/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.18.1(d7a26172c5955d29d2a8cca4377b53b28925c766)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){
var e,t=["exports","require","vs/base/common/lifecycle","vs/editor/common/core/range","vs/base/common/event","vs/base/common/strings","vs/nls","vs/nls!vs/editor/editor.main","vs/base/browser/dom","vs/css!vs/editor/editor.main","vs/base/common/errors","vs/editor/browser/editorExtensions","vs/platform/instantiation/common/instantiation","vs/editor/common/core/position","vs/platform/contextkey/common/contextkey","vs/base/common/async","vs/platform/theme/common/themeService","vs/editor/common/modes","vs/base/common/platform","vs/base/common/arrays","vs/editor/common/core/selection","vs/editor/common/editorContextKeys","vs/platform/theme/common/colorRegistry","vs/base/common/types","vs/base/common/uri","vs/base/common/color","vs/base/common/cancellation","vs/base/browser/fastDomNode","vs/base/browser/browser","vs/base/common/objects","vs/editor/common/model/textModel","vs/editor/browser/services/codeEditorService","vs/platform/commands/common/commands","vs/platform/keybinding/common/keybinding","vs/platform/notification/common/notification","vs/editor/browser/view/viewPart","vs/editor/common/controller/cursorCommon","vs/editor/common/view/editorColorRegistry","vs/base/common/keyCodes","vs/platform/configuration/common/configuration","vs/editor/common/modes/languageConfigurationRegistry","vs/base/common/map","vs/editor/common/services/modelService","vs/base/browser/ui/aria/aria","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/platform/registry/common/platform","vs/editor/common/config/editorOptions","vs/base/common/resources","vs/editor/common/model","vs/base/common/network","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/event","vs/editor/common/core/editOperation","vs/platform/contextview/browser/contextView","vs/platform/opener/common/opener","vs/editor/common/standaloneStrings","vs/base/browser/keyboardEvent","vs/base/common/actions","vs/platform/actions/common/actions","vs/editor/common/services/editorWorkerService","vs/editor/browser/core/editorState","vs/base/common/iterator","vs/editor/common/modes/nullMode","vs/base/common/filters","vs/editor/browser/config/configuration","vs/platform/accessibility/common/accessibility","vs/editor/common/viewModel/viewModel","vs/platform/storage/common/storage","vs/platform/markers/common/markers","vs/editor/common/services/modeService","vs/editor/browser/view/dynamicViewOverlay","vs/editor/common/editorCommon","vs/platform/instantiation/common/extensions","vs/base/browser/ui/actionbar/actionbar","vs/base/common/linkedList","vs/editor/common/services/resolverService","vs/editor/common/view/viewEvents","vs/base/common/htmlContent","vs/base/browser/touch","vs/editor/common/core/characterClassifier","vs/editor/common/commands/replaceCommand","vs/base/browser/globalMouseMoveMonitor","vs/base/common/path","vs/platform/keybinding/common/keybindingsRegistry","vs/editor/common/viewModel/viewEventHandler","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/lineTokens","vs/editor/common/view/renderingContext","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/styler","vs/editor/standalone/common/standaloneThemeService","vs/editor/common/modes/languageConfiguration","vs/editor/contrib/suggest/suggest","vs/editor/common/viewLayout/viewLineRenderer","vs/base/common/collections","vs/editor/contrib/referenceSearch/peekViewWidget","vs/editor/contrib/referenceSearch/referencesModel","vs/editor/browser/widget/codeEditorWidget","vs/editor/common/model/wordHelper","vs/base/browser/ui/sash/sash","vs/editor/browser/editorBrowser","vs/platform/label/common/label","vs/platform/telemetry/common/telemetry","vs/platform/instantiation/common/serviceCollection","vs/editor/common/core/uint","vs/editor/common/core/token","vs/editor/contrib/message/messageController","vs/editor/common/modes/modesRegistry","vs/base/common/severity","vs/platform/progress/common/progress","vs/editor/contrib/markdown/markdownRenderer","vs/editor/common/config/editorZoom","vs/editor/standalone/browser/simpleServices","vs/platform/log/common/log","vs/base/common/decorators","vs/base/browser/formattedTextRenderer","vs/editor/common/config/fontInfo","vs/editor/contrib/referenceSearch/referencesWidget","vs/base/parts/quickopen/browser/quickOpenModel","vs/editor/browser/controller/coreCommands","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/list/listWidget","vs/base/browser/ui/inputbox/inputBox","vs/base/common/range","vs/base/common/diff/diff","vs/platform/workspace/common/workspace","vs/base/common/stopwatch","vs/editor/contrib/snippet/snippetParser","vs/editor/contrib/folding/foldingRanges","vs/editor/contrib/codeAction/codeActionTrigger","vs/platform/list/browser/listService","vs/editor/browser/viewParts/glyphMargin/glyphMargin","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/platform/clipboard/common/clipboardService","vs/base/browser/ui/iconLabel/iconLabel","vs/editor/common/viewModel/prefixSumComputer","vs/editor/contrib/find/findModel","vs/editor/common/viewLayout/lineDecorations","vs/editor/common/view/minimapCharRenderer","vs/editor/common/services/resourceConfiguration","vs/editor/common/standalone/standaloneEnums","vs/editor/standalone/browser/quickOpen/editorQuickOpen","vs/editor/common/modes/supports/richEditBrackets","vs/editor/common/modes/supports","vs/editor/common/controller/cursorWordOperations","vs/editor/common/controller/cursorTypeOperations","vs/editor/common/model/textModelSearch","vs/editor/contrib/referenceSearch/referencesController","vs/base/common/idGenerator","vs/editor/common/config/commonEditorConfig","vs/editor/contrib/parameterHints/provideSignatureHelp","vs/base/browser/ui/list/listView","vs/editor/browser/widget/embeddedCodeEditorWidget","vs/base/browser/dnd","vs/editor/browser/view/viewLayer","vs/editor/common/core/stringBuilder","vs/base/browser/ui/highlightedlabel/highlightedLabel","vs/base/parts/tree/browser/treeDefaults","vs/base/common/numbers","vs/base/common/assert","vs/editor/contrib/snippet/snippetController2","vs/editor/browser/editorDom","vs/editor/browser/services/bulkEditService","vs/base/browser/ui/checkbox/checkbox","vs/base/browser/iframe","vs/editor/browser/widget/diffNavigator","vs/editor/browser/controller/textAreaInput","vs/editor/common/editorAction","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/standalone/standaloneBase","vs/editor/common/view/overviewZoneManager","vs/css!vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/editor/browser/viewParts/margin/margin","vs/editor/contrib/comment/blockCommentCommand","vs/editor/contrib/folding/syntaxRangeProvider","vs/editor/contrib/format/formattingEdit","vs/editor/contrib/goToDefinition/clickLinkGesture","vs/editor/contrib/hover/hoverOperation","vs/editor/contrib/hover/hoverWidgets","vs/editor/contrib/smartSelect/bracketSelections","vs/editor/standalone/common/monarch/monarchCommon","vs/base/browser/ui/findinput/findInputCheckboxes","vs/base/browser/ui/tree/objectTree","vs/base/common/keybindingLabels","vs/platform/files/common/files","vs/platform/instantiation/common/descriptors","vs/editor/common/services/markersDecorationService","vs/editor/common/model/tokensStore","vs/editor/common/commands/shiftCommand","vs/editor/common/controller/cursorMoveOperations","vs/editor/common/controller/cursorDeleteOperations","vs/editor/common/controller/cursorMoveCommands","vs/editor/common/modes/textToHtmlTokenizer","vs/editor/common/viewModel/splitLinesCollection","vs/editor/standalone/common/monarch/monarchLexer","vs/css!vs/base/browser/ui/findinput/findInput","vs/editor/browser/controller/textAreaState","vs/platform/keybinding/common/keybindingResolver","vs/platform/layout/browser/layoutService","vs/editor/common/services/editorWorkerServiceImpl","vs/base/common/worker/simpleWorker","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/labels","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/common/marshalling","vs/editor/contrib/codeAction/codeAction","vs/editor/contrib/codelens/codelens","vs/editor/contrib/colorPicker/color","vs/editor/contrib/colorPicker/colorDetector","vs/editor/contrib/goToDefinition/goToDefinition","vs/base/common/glob","vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode","vs/editor/contrib/wordOperations/wordOperations","vs/base/common/extpath","vs/base/common/scrollable","vs/editor/browser/viewParts/lines/viewLine","vs/editor/browser/controller/mouseTarget","vs/editor/browser/viewParts/lineNumbers/lineNumbers","vs/editor/browser/widget/diffEditorWidget","vs/base/browser/ui/tree/objectTreeModel","vs/editor/contrib/find/findController","vs/base/browser/ui/tree/indexTreeModel","vs/editor/contrib/codeAction/codeActionCommands","vs/base/common/functional","vs/base/browser/ui/scrollbar/scrollbarState","vs/editor/contrib/goToDefinition/goToDefinitionCommands","vs/editor/contrib/gotoError/gotoError","vs/editor/standalone/browser/standaloneServices","vs/editor/common/modes/languageFeatureRegistry","vs/css!vs/editor/contrib/clipboard/clipboard","vs/editor/browser/viewParts/contentWidgets/contentWidgets","vs/editor/browser/viewParts/decorations/decorations","vs/css!vs/editor/contrib/bracketMatching/bracketMatching","vs/editor/browser/viewParts/linesDecorations/linesDecorations","vs/editor/browser/services/abstractCodeEditorService","vs/editor/browser/viewParts/marginDecorations/marginDecorations","vs/editor/browser/viewParts/overlayWidgets/overlayWidgets","vs/editor/browser/viewParts/overviewRuler/overviewRuler","vs/editor/browser/viewParts/viewZones/viewZones","vs/css!vs/editor/browser/widget/media/tokens","vs/editor/common/viewLayout/viewLayout","vs/editor/common/viewModel/viewModelDecorations","vs/editor/contrib/caretOperations/moveCaretCommand","vs/css!vs/editor/browser/widget/media/editor","vs/editor/contrib/codeAction/codeActionWidget","vs/editor/contrib/colorPicker/colorPickerModel","vs/css!vs/editor/standalone/browser/quickOpen/quickOutline","vs/editor/contrib/comment/lineCommentCommand","vs/editor/contrib/dnd/dragAndDropCommand","vs/editor/contrib/find/findState","vs/editor/contrib/find/replaceAllCommand","vs/editor/contrib/find/replacePattern","vs/css!vs/editor/browser/widget/media/diffReview","vs/editor/contrib/folding/foldingModel","vs/editor/contrib/folding/hiddenRangeModel","vs/editor/common/commands/surroundSelectionCommand","vs/editor/contrib/folding/intializingRangeProvider","vs/css!vs/editor/standalone/browser/quickOpen/gotoLine","vs/css!vs/editor/standalone/browser/quickOpen/editorQuickOpen","vs/css!vs/editor/standalone/browser/inspectTokens/inspectTokens","vs/css!vs/editor/standalone/browser/iPadShowKeyboard/iPadShowKeyboard","vs/editor/contrib/inPlaceReplace/inPlaceReplaceCommand","vs/editor/contrib/indentation/indentUtils","vs/editor/contrib/linesOperations/copyLinesCommand","vs/editor/contrib/linesOperations/sortLinesCommand","vs/css!vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp","vs/editor/contrib/smartSelect/wordSelections","vs/css!vs/editor/browser/widget/media/diffEditor","vs/editor/contrib/suggest/suggestCommitCharacters","vs/editor/contrib/suggest/wordDistance","vs/css!vs/editor/contrib/zoneWidget/zoneWidget","vs/editor/standalone/common/monarch/monarchCompile","vs/nls!vs/base/browser/ui/actionbar/actionbar","vs/css!vs/editor/browser/viewParts/viewCursors/viewCursors","vs/css!vs/editor/browser/viewParts/selections/selections","vs/css!vs/editor/browser/viewParts/scrollDecoration/scrollDecoration","vs/nls!vs/base/browser/ui/aria/aria","vs/css!vs/editor/browser/viewParts/rulers/rulers","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputCheckboxes","vs/editor/common/diff/diffComputer","vs/nls!vs/base/browser/ui/findinput/replaceInput","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/editor/browser/viewParts/overlayWidgets/overlayWidgets","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/findinput/replaceInput","vs/nls!vs/base/browser/ui/keybindingLabel/keybindingLabel","vs/nls!vs/base/browser/ui/list/listWidget","vs/css!vs/editor/browser/viewParts/minimap/minimap","vs/nls!vs/base/browser/ui/menu/menu","vs/base/browser/ui/menu/menu","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/css!vs/editor/browser/viewParts/marginDecorations/marginDecorations","vs/base/browser/ui/tree/dataTree","vs/editor/browser/config/charWidthReader","vs/base/browser/ui/tree/asyncDataTree","vs/nls!vs/base/common/keybindingLabels","vs/css!vs/editor/contrib/suggest/media/suggest","vs/base/browser/ui/keybindingLabel/keybindingLabel","vs/nls!vs/base/common/severity","vs/css!vs/editor/browser/viewParts/linesDecorations/linesDecorations","vs/nls!vs/base/parts/quickopen/browser/quickOpenModel","vs/css!vs/editor/browser/viewParts/lines/viewLines","vs/nls!vs/base/parts/quickopen/browser/quickOpenWidget","vs/base/parts/quickopen/browser/quickOpenWidget","vs/nls!vs/editor/browser/controller/coreCommands","vs/nls!vs/editor/browser/widget/codeEditorWidget","vs/nls!vs/editor/browser/widget/diffEditorWidget","vs/nls!vs/editor/browser/widget/diffReview","vs/nls!vs/editor/browser/widget/inlineDiffMargin","vs/editor/browser/widget/inlineDiffMargin","vs/nls!vs/editor/common/config/commonEditorConfig","vs/nls!vs/editor/common/config/editorOptions","vs/css!vs/editor/browser/viewParts/lineNumbers/lineNumbers","vs/css!vs/editor/browser/viewParts/indentGuides/indentGuides","vs/editor/contrib/suggest/completionModel","vs/nls!vs/editor/common/modes/modesRegistry","vs/nls!vs/editor/common/standaloneStrings","vs/css!vs/editor/browser/viewParts/glyphMargin/glyphMargin","vs/nls!vs/editor/common/view/editorColorRegistry","vs/nls!vs/editor/contrib/bracketMatching/bracketMatching","vs/nls!vs/editor/contrib/caretOperations/caretOperations","vs/nls!vs/editor/contrib/caretOperations/transpose","vs/nls!vs/editor/contrib/clipboard/clipboard","vs/nls!vs/editor/contrib/codeAction/codeActionCommands","vs/nls!vs/editor/contrib/codeAction/lightBulbWidget","vs/nls!vs/editor/contrib/comment/comment","vs/nls!vs/editor/contrib/contextmenu/contextmenu","vs/nls!vs/editor/contrib/cursorUndo/cursorUndo","vs/nls!vs/editor/contrib/find/findController","vs/nls!vs/editor/contrib/find/findWidget","vs/nls!vs/editor/contrib/folding/folding","vs/nls!vs/editor/contrib/fontZoom/fontZoom","vs/nls!vs/editor/contrib/format/format","vs/nls!vs/editor/contrib/format/formatActions","vs/nls!vs/editor/contrib/goToDefinition/goToDefinitionCommands","vs/nls!vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/nls!vs/editor/contrib/goToDefinition/goToDefinitionResultsNavigation","vs/nls!vs/editor/contrib/gotoError/gotoError","vs/nls!vs/editor/contrib/gotoError/gotoErrorWidget","vs/nls!vs/editor/contrib/hover/hover","vs/nls!vs/editor/contrib/hover/modesContentHover","vs/nls!vs/editor/contrib/inPlaceReplace/inPlaceReplace","vs/nls!vs/editor/contrib/linesOperations/linesOperations","vs/nls!vs/editor/contrib/links/links","vs/nls!vs/editor/contrib/message/messageController","vs/nls!vs/editor/contrib/multicursor/multicursor","vs/nls!vs/editor/contrib/parameterHints/parameterHints","vs/nls!vs/editor/contrib/parameterHints/parameterHintsWidget","vs/nls!vs/editor/contrib/referenceSearch/peekViewWidget","vs/nls!vs/editor/contrib/referenceSearch/referenceSearch","vs/nls!vs/editor/contrib/referenceSearch/referencesController","vs/nls!vs/editor/contrib/referenceSearch/referencesModel","vs/css!vs/editor/browser/viewParts/decorations/decorations","vs/nls!vs/editor/contrib/referenceSearch/referencesTree","vs/nls!vs/editor/contrib/referenceSearch/referencesWidget","vs/nls!vs/editor/contrib/rename/rename","vs/nls!vs/editor/contrib/rename/renameInputField","vs/nls!vs/editor/contrib/smartSelect/smartSelect","vs/nls!vs/editor/contrib/snippet/snippetVariables","vs/nls!vs/editor/contrib/suggest/suggestController","vs/nls!vs/editor/contrib/suggest/suggestWidget","vs/nls!vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode","vs/nls!vs/editor/contrib/tokenization/tokenization","vs/nls!vs/editor/contrib/wordHighlighter/wordHighlighter","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/keybinding/common/abstractKeybindingService","vs/nls!vs/platform/list/browser/listService","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/colorRegistry","vs/platform/extensions/common/extensions","vs/css!vs/editor/contrib/snippet/snippetSession","vs/css!vs/editor/contrib/rename/renameInputField","vs/css!vs/editor/browser/viewParts/currentLineMarginHighlight/currentLineMarginHighlight","vs/platform/instantiation/common/graph","vs/css!vs/editor/browser/viewParts/currentLineHighlight/currentLineHighlight","vs/css!vs/editor/browser/controller/textAreaHandler","vs/base/parts/tree/browser/treeImpl","vs/css!vs/base/parts/tree/browser/tree","vs/editor/common/model/editStack","vs/css!vs/base/parts/quickopen/browser/quickopen","vs/css!vs/base/browser/ui/tree/media/tree","vs/editor/browser/config/elementSizeObserver","vs/base/browser/ui/splitview/splitview","vs/css!vs/base/browser/ui/splitview/splitview","vs/editor/common/model/indentationGuesser","vs/base/parts/tree/browser/treeView","vs/editor/common/model/textModelTokens","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/sash/sash","vs/editor/common/model/intervalTree","vs/editor/common/controller/cursorColumnSelection","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/textModelEvents","vs/base/browser/ui/progressbar/progressbar","vs/css!vs/base/browser/ui/progressbar/progressbar","vs/css!vs/editor/contrib/referenceSearch/media/referencesWidget","vs/editor/common/controller/oneCursor","vs/editor/common/controller/cursorCollection","vs/editor/common/controller/cursor","vs/css!vs/platform/contextview/browser/contextMenuHandler","vs/css!vs/base/browser/ui/menu/menu","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/keybindingLabel/keybindingLabel","vs/editor/common/view/runtimeMinimapCharRenderer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/viewModel/characterHardWrappingLineMapper","vs/editor/common/viewModel/viewModelImpl","vs/editor/contrib/documentSymbols/outlineModel","vs/editor/contrib/folding/foldingDecorations","vs/editor/contrib/folding/indentRangeProvider","vs/editor/contrib/linesOperations/moveLinesCommand","vs/editor/contrib/zoneWidget/zoneWidget","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/standalone/browser/colorizer","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/iconLabel/iconlabel","vs/css!vs/base/browser/ui/findinput/findInputCheckboxes","vs/editor/browser/services/openerService","vs/editor/contrib/links/getLinks","vs/css!vs/editor/contrib/referenceSearch/media/peekViewWidget","vs/base/browser/ui/countBadge/countBadge","vs/editor/contrib/suggest/suggestAlternatives","vs/editor/contrib/suggest/wordContextKey","vs/css!vs/base/browser/ui/countBadge/countBadge","vs/base/browser/ui/contextview/contextview","vs/platform/actions/common/menuService","vs/css!vs/base/browser/ui/contextview/contextview","vs/platform/dialogs/common/dialogs","vs/editor/common/modes/abstractMode","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/abstractKeybindingService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/css!vs/base/browser/ui/checkbox/checkbox","vs/editor/contrib/codeAction/lightBulbWidget","vs/css!vs/editor/contrib/parameterHints/parameterHints","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/css!vs/base/browser/ui/aria/aria","vs/editor/common/modes/languageSelector","vs/platform/contextview/browser/contextViewService","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/editor/common/modes/linkComputer","vs/editor/common/services/webWorker","vs/base/worker/defaultWorkerFactory","vs/platform/markers/common/markerService","vs/base/parts/tree/browser/treeViewModel","vs/base/parts/tree/browser/treeModel","vs/base/parts/tree/browser/treeDnd","vs/editor/contrib/hover/modesGlyphHover","vs/base/parts/tree/browser/tree","vs/base/parts/quickopen/browser/quickOpenViewer","vs/css!vs/editor/contrib/message/messageController","vs/editor/common/services/getIconClasses","vs/editor/common/modes/supports/characterPair","vs/base/common/mime","vs/editor/common/modes/supports/indentRules","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/editor/browser/view/viewOverlays","vs/editor/browser/viewParts/viewCursors/viewCursor","vs/editor/common/services/languagesRegistry","vs/editor/common/services/modeServiceImpl","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/editor/common/services/modelServiceImpl","vs/platform/accessibility/common/abstractAccessibilityService","vs/platform/accessibility/common/accessibilityService","vs/platform/configuration/common/configurationModels","vs/platform/contextkey/browser/contextKeyService","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/platform/browser/contextScopedHistoryWidget","vs/base/browser/ui/list/rowCache","vs/editor/contrib/suggest/suggestMemory","vs/editor/contrib/suggest/suggestController","vs/editor/contrib/suggest/suggestModel","vs/base/browser/markdownRenderer","vs/editor/browser/core/keybindingCancellation","vs/editor/common/modes/supports/onEnter","vs/editor/browser/view/viewController","vs/editor/contrib/caretOperations/caretOperations","vs/editor/contrib/caretOperations/transpose","vs/editor/contrib/clipboard/clipboard","vs/css!vs/editor/contrib/links/links","vs/editor/contrib/codeAction/codeActionModel","vs/editor/common/modes/supports/electricCharacter","vs/editor/contrib/codelens/codeLensCache","vs/css!vs/editor/contrib/hover/hover","vs/editor/common/modes/supports/tokenization","vs/editor/contrib/comment/comment","vs/editor/contrib/contextmenu/contextmenu","vs/editor/contrib/cursorUndo/cursorUndo","vs/editor/contrib/dnd/dnd","vs/editor/contrib/folding/folding","vs/editor/contrib/fontZoom/fontZoom","vs/editor/contrib/format/format","vs/editor/contrib/format/formatActions","vs/editor/common/modes/tokenizationRegistry","vs/editor/contrib/goToDefinition/goToDefinitionResultsNavigation","vs/editor/contrib/hover/getHover","vs/editor/contrib/linesOperations/linesOperations","vs/base/common/search","vs/editor/contrib/parameterHints/parameterHintsModel","vs/editor/contrib/quickOpen/quickOpen","vs/editor/contrib/smartSelect/smartSelect","vs/css!vs/editor/contrib/gotoError/media/gotoErrorWidget","vs/editor/common/commands/trimTrailingWhitespaceCommand","vs/editor/contrib/tokenization/tokenization","vs/editor/editor.all","vs/editor/contrib/wordPartOperations/wordPartOperations","vs/editor/standalone/browser/iPadShowKeyboard/iPadShowKeyboard","vs/editor/standalone/browser/toggleHighContrast/toggleHighContrast","vs/editor/common/core/rgba","vs/editor/contrib/rename/renameInputField","vs/base/browser/ui/octiconLabel/octiconLabel","vs/editor/standalone/browser/quickOpen/quickOpenEditorWidget","vs/platform/contextview/browser/contextMenuHandler","vs/css!vs/editor/standalone/browser/standalone-tokens","vs/editor/browser/services/codeEditorServiceImpl","vs/editor/browser/viewParts/editorScrollbar/editorScrollbar","vs/editor/browser/viewParts/lines/rangeUtil","vs/editor/common/view/viewContext","vs/editor/browser/controller/mouseHandler","vs/editor/browser/controller/pointerHandler","vs/editor/browser/view/viewOutgoingEvents","vs/editor/browser/viewParts/lines/viewLines","vs/editor/browser/viewParts/minimap/minimap","vs/editor/browser/viewParts/scrollDecoration/scrollDecoration","vs/editor/browser/viewParts/selections/selections","vs/base/browser/ui/list/rangeMap","vs/editor/browser/viewParts/currentLineHighlight/currentLineHighlight","vs/editor/browser/viewParts/currentLineMarginHighlight/currentLineMarginHighlight","vs/editor/browser/viewParts/indentGuides/indentGuides","vs/editor/common/view/viewEventDispatcher","vs/editor/browser/controller/textAreaHandler","vs/editor/browser/viewParts/overviewRuler/decorationsOverviewRuler","vs/editor/browser/viewParts/rulers/rulers","vs/editor/browser/viewParts/viewCursors/viewCursors","vs/editor/browser/view/viewImpl","vs/base/common/process","vs/editor/browser/widget/diffReview","vs/css!vs/editor/contrib/folding/folding","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/editor/common/services/markerDecorationsServiceImpl","vs/editor/contrib/bracketMatching/bracketMatching","vs/editor/contrib/codelens/codelensWidget","vs/editor/contrib/codelens/codelensController","vs/editor/contrib/colorPicker/colorPickerWidget","vs/editor/contrib/find/findDecorations","vs/css!vs/editor/contrib/find/findWidget","vs/editor/contrib/find/findOptionsWidget","vs/editor/contrib/find/findWidget","vs/css!vs/editor/contrib/dnd/dnd","vs/editor/contrib/inPlaceReplace/inPlaceReplace","vs/editor/contrib/links/links","vs/editor/common/viewLayout/viewLinesViewportData","vs/editor/contrib/codeAction/codeActionUi","vs/editor/common/viewLayout/whitespaceComputer","vs/editor/contrib/codeAction/codeActionContributions","vs/editor/contrib/multicursor/multicursor","vs/editor/contrib/parameterHints/parameterHintsWidget","vs/editor/contrib/parameterHints/parameterHints","vs/base/common/history","vs/editor/contrib/referenceSearch/referencesTree","vs/editor/contrib/rename/rename","vs/editor/contrib/suggest/suggestWidget","vs/editor/contrib/wordHighlighter/wordHighlighter","vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp","vs/editor/standalone/browser/inspectTokens/inspectTokens","vs/base/common/hash","vs/editor/standalone/browser/quickOpen/gotoLine","vs/editor/standalone/browser/quickOpen/quickCommand","vs/editor/standalone/browser/quickOpen/quickOutline","vs/editor/standalone/browser/standaloneCodeServiceImpl","vs/editor/standalone/common/themes","vs/editor/standalone/browser/standaloneThemeServiceImpl","vs/platform/contextview/browser/contextMenuService","vs/editor/common/viewLayout/linesLayout","vs/base/common/diff/diffChange","vs/css!vs/editor/contrib/colorPicker/colorPicker","vs/editor/common/model/mirrorTextModel","vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/editor/contrib/referenceSearch/referenceSearch","vs/editor/standalone/browser/referenceSearch/standaloneReferenceSearch","vs/platform/severityIcon/common/severityIcon","vs/editor/contrib/gotoError/gotoErrorWidget","vs/editor/common/services/editorSimpleWorker","vs/editor/contrib/hover/modesContentHover","vs/editor/contrib/hover/hover","vs/base/browser/ui/list/splice","vs/base/browser/ui/list/list","vs/editor/standalone/browser/standaloneCodeEditor","vs/css!vs/editor/contrib/codelens/codelensWidget","vs/editor/standalone/browser/standaloneEditor","vs/editor/standalone/browser/standaloneLanguages","vs/editor/editor.api","vs/platform/workspaces/common/workspaces","vs/editor/contrib/snippet/snippetVariables","vs/editor/contrib/snippet/snippetSession","vs/css!vs/editor/contrib/codeAction/lightBulbWidget","vs/base/common/marked/marked","vs/base/common/insane/insane","vs/editor/common/standalone/promise-polyfill/polyfill","vs/editor/edcore.main"],i=function(e){
for(var i=[],n=0,o=e.length;n<o;n++)i[n]=t[e[n]];return i};!function(e){var t=function(){function e(){this._pendingLoads=0}return e.prototype.attachListeners=function(e,t,i,n){var o=function(){t.removeEventListener("load",r),t.removeEventListener("error",s)},r=function(e){o(),i()},s=function(e){o(),n(e)};t.addEventListener("load",r),t.addEventListener("error",s)},e.prototype._onLoad=function(e,t){this._pendingLoads--,t()},e.prototype._onLoadError=function(e,t,i){this._pendingLoads--,t(i)},e.prototype._insertLinkNode=function(e){this._pendingLoads++;var t=document.head||document.getElementsByTagName("head")[0],i=t.getElementsByTagName("link")||document.head.getElementsByTagName("script");i.length>0?t.insertBefore(e,i[i.length-1]):t.appendChild(e)},e.prototype.createLinkTag=function(e,t,i,n){var o=this,r=document.createElement("link");r.setAttribute("rel","stylesheet"),r.setAttribute("type","text/css"),r.setAttribute("data-name",e);return this.attachListeners(e,r,function(){return o._onLoad(e,i)},function(t){
return o._onLoadError(e,n,t)}),r.setAttribute("href",t),r},e.prototype._linkTagExists=function(e,t){var i,n,o,r,s=document.getElementsByTagName("link");for(i=0,n=s.length;i<n;i++)if(o=s[i].getAttribute("data-name"),r=s[i].getAttribute("href"),o===e||r===t)return!0;return!1},e.prototype.load=function(e,t,i,n){if(this._linkTagExists(e,t))i();else{var o=this.createLinkTag(e,t,i,n);this._insertLinkNode(o)}},e}(),i=function(){function e(){this._cssLoader=new t}return e.prototype.load=function(e,t,i){var n=t.toUrl(e+".css");this._cssLoader.load(e,n,function(e){i({})},function(e){"function"==typeof i.error&&i.error("Could not find "+n+" or it was empty")})},e}();e.CSSPlugin=i,define("vs/css",new i)}(e||(e={}));var n;!function(e){function t(e,t,i){var n;return n=0===t.length?e:e.replace(/\{(\d+)\}/g,function(e,i){var n=i[0],o=t[n],r=e;return"string"==typeof o?r=o:"number"!=typeof o&&"boolean"!=typeof o&&void 0!==o&&null!==o||(r=String(o)),r}),i.isPseudo&&(n="［"+n.replace(/[aouei]/g,"$&$&")+"］"),n}function i(e,i){
return function(n,o){var r=Array.prototype.slice.call(arguments,2);return t(e[n],r,i)}}var n=function(){function e(){this._detected=!1,this._isPseudo=!1}return Object.defineProperty(e.prototype,"isPseudo",{get:function(){return this._detect(),this._isPseudo},enumerable:!0,configurable:!0}),e.prototype._detect=function(){this._detected||(this._detected=!0,this._isPseudo="undefined"!=typeof document&&document.location&&document.location.hash.indexOf("pseudo=true")>=0)},e}(),o=function(){function e(e){var i=this;this._env=e,this.localize=function(e,n){for(var o=[],r=2;r<arguments.length;r++)o[r-2]=arguments[r];return function(e,i,n){for(var o=[],r=3;r<arguments.length;r++)o[r-3]=arguments[r];return t(n,o,e)}.apply(void 0,[i._env,e,n].concat(o))}}return e.prototype.setPseudoTranslation=function(e){this._env._isPseudo=e},e.prototype.create=function(e,t){return{localize:i(t[e],this._env)}},e.prototype.load=function(t,n,o,r){var s=this;if(r=r||{},t&&0!==t.length){
var a=r["vs/nls"]||{},l=a.availableLanguages?function(e,t){var i=e[t];return i||(i=e["*"])||null}(a.availableLanguages,t):null,u=".nls";null!==l&&l!==e.DEFAULT_TAG&&(u=u+"."+l);var d=function(e){Array.isArray(e)?e.localize=i(e,s._env):e.localize=i(e[t],s._env),o(e)};"function"==typeof a.loadBundle?a.loadBundle(t,l,function(e,i){e?n([t+".nls"],d):d(i)}):n([t+u],d)}else o({localize:this.localize})},e.DEFAULT_TAG="i-default",e}();e.NLSPlugin=o,define("vs/nls",new o(new n))}(n||(n={})),define(t[154],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:"text/plain"};var i=function(){function e(e){this.data=e}return e.prototype.update=function(){},e.prototype.getData=function(){return this.data},e}();t.DragAndDropData=i,t.StaticDND={CurrentDragAndDropData:void 0}}),define(t[165],i([1,0]),function(e,t){"use strict";function i(e){if(!e.parent||e.parent===e)return null;try{
var t=e.location,i=e.parent.location;if(t.protocol!==i.protocol||t.hostname!==i.hostname||t.port!==i.port)return o=!0,null}catch(e){return o=!0,null}return e.parent}function n(e,t){for(var i,n=e.document.getElementsByTagName("iframe"),o=0,r=n.length;o<r;o++)if((i=n[o]).contentWindow===t)return i;return null}Object.defineProperty(t,"__esModule",{value:!0});var o=!1,r=null,s=function(){function e(){}return e.getSameOriginWindowChain=function(){if(!r){r=[];var e,t=window;do{(e=i(t))?r.push({window:t,iframeElement:n(e,t)}):r.push({window:t,iframeElement:null}),t=e}while(t)}return r.slice(0)},e.hasDifferentOriginAncestor=function(){return r||this.getSameOriginWindowChain(),o},e.getPositionOfChildWindowRelativeToAncestorWindow=function(e,t){if(!t||e===t)return{top:0,left:0};for(var i=0,n=0,o=0,r=this.getSameOriginWindowChain();o<r.length;o++){var s=r[o];if(s.window===t)break;if(!s.iframeElement)break;var a=s.iframeElement.getBoundingClientRect();i+=a.top,n+=a.left}return{top:i,left:n}},e}();t.IframeUtils=s}),
define(t[589],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e.TREE="tree",e.FORM="form"}(t.ListAriaRootRole||(t.ListAriaRootRole={}))}),define(t[588],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.spliceables=e}return e.prototype.splice=function(e,t,i){this.spliceables.forEach(function(n){return n.splice(e,t,i)})},e}();t.CombinedSpliceable=i}),define(t[225],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i){this._scrollbarSize=Math.round(t),this._oppositeScrollbarSize=Math.round(i),this._arrowSize=Math.round(e),this._visibleSize=0,this._scrollSize=0,this._scrollPosition=0,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}return e.prototype.clone=function(){
var t=new e(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize);return t.setVisibleSize(this._visibleSize),t.setScrollSize(this._scrollSize),t.setScrollPosition(this._scrollPosition),t},e.prototype.setVisibleSize=function(e){var t=Math.round(e);return this._visibleSize!==t&&(this._visibleSize=t,this._refreshComputedValues(),!0)},e.prototype.setScrollSize=function(e){var t=Math.round(e);return this._scrollSize!==t&&(this._scrollSize=t,this._refreshComputedValues(),!0)},e.prototype.setScrollPosition=function(e){var t=Math.round(e);return this._scrollPosition!==t&&(this._scrollPosition=t,this._refreshComputedValues(),!0)},e._computeValues=function(e,t,i,n,o){var r=Math.max(0,i-e),s=Math.max(0,r-2*t),a=n>0&&n>i;if(!a)return{computedAvailableSize:Math.round(r),computedIsNeeded:a,computedSliderSize:Math.round(s),computedSliderRatio:0,computedSliderPosition:0};var l=Math.round(Math.max(20,Math.floor(i*s/n))),u=(s-l)/(n-i),d=o*u;return{computedAvailableSize:Math.round(r),computedIsNeeded:a,
computedSliderSize:Math.round(l),computedSliderRatio:u,computedSliderPosition:Math.round(d)}},e.prototype._refreshComputedValues=function(){var t=e._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=t.computedAvailableSize,this._computedIsNeeded=t.computedIsNeeded,this._computedSliderSize=t.computedSliderSize,this._computedSliderRatio=t.computedSliderRatio,this._computedSliderPosition=t.computedSliderPosition},e.prototype.getArrowSize=function(){return this._arrowSize},e.prototype.getScrollPosition=function(){return this._scrollPosition},e.prototype.getRectangleLargeSize=function(){return this._computedAvailableSize},e.prototype.getRectangleSmallSize=function(){return this._scrollbarSize},e.prototype.isNeeded=function(){return this._computedIsNeeded},e.prototype.getSliderSize=function(){return this._computedSliderSize},e.prototype.getSliderPosition=function(){return this._computedSliderPosition},
e.prototype.getDesiredScrollPositionFromOffset=function(e){if(!this._computedIsNeeded)return 0;var t=e-this._arrowSize-this._computedSliderSize/2;return Math.round(t/this._computedSliderRatio)},e.prototype.getDesiredScrollPositionFromDelta=function(e){if(!this._computedIsNeeded)return 0;var t=this._computedSliderPosition+e;return Math.round(t/this._computedSliderRatio)},e}();t.ScrollbarState=i}),define(t[19],i([1,0]),function(e,t){"use strict";function i(e,t){return n(e,t,0,e.length-1,[]),e}function n(e,t,i,o,r){if(!(o<=i)){var s=i+(o-i)/2|0;n(e,t,i,s,r),n(e,t,s+1,o,r),t(e[s],e[s+1])<=0||function(e,t,i,n,o,r){for(var s=i,a=n+1,l=i;l<=o;l++)r[l]=e[l];for(l=i;l<=o;l++)s>n?e[l]=r[a++]:a>o?e[l]=r[s++]:t(r[a],r[s])<0?e[l]=r[a++]:e[l]=r[s++]}(e,t,i,s,o,r)}}function o(e,t){for(var i=0;i<e.length;i++){if(t(e[i]))return i}return-1}Object.defineProperty(t,"__esModule",{value:!0}),t.tail=function(e,t){return void 0===t&&(t=0),e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call")
;return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,i){if(void 0===i&&(i=function(e,t){return e===t}),e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(var n=0,o=e.length;n<o;n++)if(!i(e[n],t[n]))return!1;return!0},t.binarySearch=function(e,t,i){for(var n=0,o=e.length-1;n<=o;){var r=(n+o)/2|0,s=i(e[r],t);if(s<0)n=r+1;else{if(!(s>0))return r;o=r-1}}return-(n+1)},t.findFirstInSorted=function(e,t){var i=0,n=e.length;if(0===n)return 0;for(;i<n;){var o=Math.floor((i+n)/2);t(e[o])?n=o:i=o+1}return i},t.mergeSort=i,t.groupBy=function(e,t){for(var n=[],o=void 0,r=0,s=i(e.slice(0),t);r<s.length;r++){var a=s[r];o&&0===t(o[0],a)?o.push(a):(o=[a],n.push(o))}return n},t.coalesce=function(e){return e.filter(function(e){return!!e})},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter(function(t,i){return e.indexOf(t)===i});var i=Object.create(null)
;return e.filter(function(e){var n=t(e);return!i[n]&&(i[n]=!0,!0)})},t.distinctES6=function(e){var t=new Set;return e.filter(function(e){return!t.has(e)&&(t.add(e),!0)})},t.firstIndex=o,t.first=function(e,t,i){void 0===i&&(i=void 0);var n=o(e,t);return n<0?i:e[n]},t.flatten=function(e){var t;return(t=[]).concat.apply(t,e)},t.range=function(e,t){var i="number"==typeof t?e:0;"number"==typeof t?i=e:(i=0,t=e);var n=[];if(i<=t)for(o=i;o<t;o++)n.push(o);else for(var o=i;o>t;o--)n.push(o);return n},t.arrayInsert=function(e,t,i){var n=e.slice(0,t),o=e.slice(t);return n.concat(i,o)},t.pushToStart=function(e,t){var i=e.indexOf(t);i>-1&&(e.splice(i,1),e.unshift(t))},t.pushToEnd=function(e,t){var i=e.indexOf(t);i>-1&&(e.splice(i,1),e.push(t))},t.asArray=function(e){return Array.isArray(e)?e:[e]}}),define(t[160],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=function(e,t){if(!e)throw new Error(t?"Assertion failed ("+t+")":"Assertion Failed")}}),
define(t[95],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=Object.prototype.hasOwnProperty;t.values=function(e){var t=[];for(var n in e)i.call(e,n)&&t.push(e[n]);return t},t.first=function(e){for(var t in e)if(i.call(e,t))return e[t]},t.forEach=function(e,t){var n=function(n){if(i.call(e,n)&&!1===t({key:n,value:e[n]},function(){delete e[n]}))return{value:void 0}};for(var o in e){var r=n(o);if("object"==typeof r)return r.value}};var n=function(){function e(){this.map=new Map}return e.prototype.add=function(e,t){var i=this.map.get(e);i||(i=new Set,this.map.set(e,i)),i.add(t)},e.prototype.delete=function(e,t){var i=this.map.get(e);i&&(i.delete(t),0===i.size&&this.map.delete(e))},e.prototype.forEach=function(e,t){var i=this.map.get(e);i&&i.forEach(t)},e}();t.SetMap=n}),define(t[25],i([1,0]),function(e,t){"use strict";function i(e,t){var i=Math.pow(10,t);return Math.round(e*i)/i}Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,n,o){
void 0===o&&(o=1),this.r=0|Math.min(255,Math.max(0,e)),this.g=0|Math.min(255,Math.max(0,t)),this.b=0|Math.min(255,Math.max(0,n)),this.a=i(Math.max(Math.min(1,o),0),3)}return e.equals=function(e,t){return e.r===t.r&&e.g===t.g&&e.b===t.b&&e.a===t.a},e}();t.RGBA=n;var o=function(){function e(e,t,n,o){this.h=0|Math.max(Math.min(360,e),0),this.s=i(Math.max(Math.min(1,t),0),3),this.l=i(Math.max(Math.min(1,n),0),3),this.a=i(Math.max(Math.min(1,o),0),3)}return e.equals=function(e,t){return e.h===t.h&&e.s===t.s&&e.l===t.l&&e.a===t.a},e.fromRGBA=function(t){var i=t.r/255,n=t.g/255,o=t.b/255,r=t.a,s=Math.max(i,n,o),a=Math.min(i,n,o),l=0,u=0,d=(a+s)/2,c=s-a;if(c>0){switch(u=Math.min(d<=.5?c/(2*d):c/(2-2*d),1),s){case i:l=(n-o)/c+(n<o?6:0);break;case n:l=(o-i)/c+2;break;case o:l=(i-n)/c+4}l*=60,l=Math.round(l)}return new e(l,u,d,r)},e._hue2rgb=function(e,t,i){return i<0&&(i+=1),i>1&&(i-=1),i<1/6?e+6*(t-e)*i:i<.5?t:i<2/3?e+(t-e)*(2/3-i)*6:e},e.toRGBA=function(t){var i,o,r,s=t.h/360,a=t.s,l=t.l,u=t.a;if(0===a)i=o=r=l;else{
var d=l<.5?l*(1+a):l+a-l*a,c=2*l-d;i=e._hue2rgb(c,d,s+1/3),o=e._hue2rgb(c,d,s),r=e._hue2rgb(c,d,s-1/3)}return new n(Math.round(255*i),Math.round(255*o),Math.round(255*r),u)},e}();t.HSLA=o;var r=function(){function e(e,t,n,o){this.h=0|Math.max(Math.min(360,e),0),this.s=i(Math.max(Math.min(1,t),0),3),this.v=i(Math.max(Math.min(1,n),0),3),this.a=i(Math.max(Math.min(1,o),0),3)}return e.equals=function(e,t){return e.h===t.h&&e.s===t.s&&e.v===t.v&&e.a===t.a},e.fromRGBA=function(t){var i,n=t.r/255,o=t.g/255,r=t.b/255,s=Math.max(n,o,r),a=s-Math.min(n,o,r),l=0===s?0:a/s;return i=0===a?0:s===n?((o-r)/a%6+6)%6:s===o?(r-n)/a+2:(n-o)/a+4,new e(Math.round(60*i),l,s,t.a)},e.toRGBA=function(e){var t=e.h,i=e.s,o=e.v,r=e.a,s=o*i,a=s*(1-Math.abs(t/60%2-1)),l=o-s,u=[0,0,0],d=u[0],c=u[1],h=u[2];return t<60?(d=s,c=a):t<120?(d=a,c=s):t<180?(c=s,h=a):t<240?(c=a,h=s):t<300?(d=a,h=s):t<360&&(d=s,h=a),d=Math.round(255*(d+l)),c=Math.round(255*(c+l)),h=Math.round(255*(h+l)),new n(d,c,h,r)},e}();t.HSVA=r;var s=function(){function e(e){
if(!e)throw new Error("Color needs a value");if(e instanceof n)this.rgba=e;else if(e instanceof o)this._hsla=e,this.rgba=o.toRGBA(e);else{if(!(e instanceof r))throw new Error("Invalid color ctor argument");this._hsva=e,this.rgba=r.toRGBA(e)}}return e.fromHex=function(t){return e.Format.CSS.parseHex(t)||e.red},Object.defineProperty(e.prototype,"hsla",{get:function(){return this._hsla?this._hsla:o.fromRGBA(this.rgba)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hsva",{get:function(){return this._hsva?this._hsva:r.fromRGBA(this.rgba)},enumerable:!0,configurable:!0}),e.prototype.equals=function(e){return!!e&&n.equals(this.rgba,e.rgba)&&o.equals(this.hsla,e.hsla)&&r.equals(this.hsva,e.hsva)},e.prototype.getRelativeLuminance=function(){return i(.2126*e._relativeLuminanceForComponent(this.rgba.r)+.7152*e._relativeLuminanceForComponent(this.rgba.g)+.0722*e._relativeLuminanceForComponent(this.rgba.b),4)},e._relativeLuminanceForComponent=function(e){var t=e/255
;return t<=.03928?t/12.92:Math.pow((t+.055)/1.055,2.4)},e.prototype.isLighter=function(){return(299*this.rgba.r+587*this.rgba.g+114*this.rgba.b)/1e3>=128},e.prototype.isLighterThan=function(e){return this.getRelativeLuminance()>e.getRelativeLuminance()},e.prototype.isDarkerThan=function(e){return this.getRelativeLuminance()<e.getRelativeLuminance()},e.prototype.lighten=function(t){return new e(new o(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*t,this.hsla.a))},e.prototype.darken=function(t){return new e(new o(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*t,this.hsla.a))},e.prototype.transparent=function(t){var i=this.rgba,o=i.r,r=i.g,s=i.b,a=i.a;return new e(new n(o,r,s,a*t))},e.prototype.isTransparent=function(){return 0===this.rgba.a},e.prototype.isOpaque=function(){return 1===this.rgba.a},e.prototype.opposite=function(){return new e(new n(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))},e.prototype.toString=function(){return""+e.Format.CSS.format(this)},e.getLighterColor=function(e,t,i){
if(e.isLighterThan(t))return e;i=i||.5;var n=e.getRelativeLuminance(),o=t.getRelativeLuminance();return i=i*(o-n)/o,e.lighten(i)},e.getDarkerColor=function(e,t,i){if(e.isDarkerThan(t))return e;i=i||.5;var n=e.getRelativeLuminance();return i=i*(n-t.getRelativeLuminance())/n,e.darken(i)},e.white=new e(new n(255,255,255,1)),e.black=new e(new n(0,0,0,1)),e.red=new e(new n(255,0,0,1)),e.blue=new e(new n(0,0,255,1)),e.cyan=new e(new n(0,255,255,1)),e.lightgrey=new e(new n(211,211,211,1)),e.transparent=new e(new n(0,0,0,0)),e}();t.Color=s,function(e){!function(t){!function(t){function i(e){var t=e.toString(16);return 2!==t.length?"0"+t:t}function o(e){switch(e){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:case 65:return 10;case 98:case 66:return 11;case 99:case 67:return 12;case 100:case 68:return 13;case 101:case 69:return 14;case 102:case 70:return 15}return 0}
t.formatRGB=function(t){return 1===t.rgba.a?"rgb("+t.rgba.r+", "+t.rgba.g+", "+t.rgba.b+")":e.Format.CSS.formatRGBA(t)},t.formatRGBA=function(e){return"rgba("+e.rgba.r+", "+e.rgba.g+", "+e.rgba.b+", "+ +e.rgba.a.toFixed(2)+")"},t.formatHSL=function(t){return 1===t.hsla.a?"hsl("+t.hsla.h+", "+(100*t.hsla.s).toFixed(2)+"%, "+(100*t.hsla.l).toFixed(2)+"%)":e.Format.CSS.formatHSLA(t)},t.formatHSLA=function(e){return"hsla("+e.hsla.h+", "+(100*e.hsla.s).toFixed(2)+"%, "+(100*e.hsla.l).toFixed(2)+"%, "+e.hsla.a.toFixed(2)+")"},t.formatHex=function(e){return"#"+i(e.rgba.r)+i(e.rgba.g)+i(e.rgba.b)},t.formatHexA=function(t,n){return void 0===n&&(n=!1),n&&1===t.rgba.a?e.Format.CSS.formatHex(t):"#"+i(t.rgba.r)+i(t.rgba.g)+i(t.rgba.b)+i(Math.round(255*t.rgba.a))},t.format=function(t){return t?t.isOpaque()?e.Format.CSS.formatHex(t):e.Format.CSS.formatRGBA(t):null},t.parseHex=function(t){if(!t)return null;var i=t.length;if(0===i)return null;if(35!==t.charCodeAt(0))return null;if(7===i){
var r=16*o(t.charCodeAt(1))+o(t.charCodeAt(2)),s=16*o(t.charCodeAt(3))+o(t.charCodeAt(4)),a=16*o(t.charCodeAt(5))+o(t.charCodeAt(6));return new e(new n(r,s,a,1))}if(9===i){var r=16*o(t.charCodeAt(1))+o(t.charCodeAt(2)),s=16*o(t.charCodeAt(3))+o(t.charCodeAt(4)),a=16*o(t.charCodeAt(5))+o(t.charCodeAt(6)),l=16*o(t.charCodeAt(7))+o(t.charCodeAt(8));return new e(new n(r,s,a,l/255))}if(4===i){var r=o(t.charCodeAt(1)),s=o(t.charCodeAt(2)),a=o(t.charCodeAt(3));return new e(new n(16*r+r,16*s+s,16*a+a))}if(5===i){var r=o(t.charCodeAt(1)),s=o(t.charCodeAt(2)),a=o(t.charCodeAt(3)),l=o(t.charCodeAt(4));return new e(new n(16*r+r,16*s+s,16*a+a,(16*l+l)/255))}return null}}(t.CSS||(t.CSS={}))}(e.Format||(e.Format={}))}(s=t.Color||(t.Color={})),t.Color=s}),define(t[115],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=function(e,t,i){var n=null,o=null;if("function"==typeof i.value?(n="value",
0!==(o=i.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof i.get&&(n="get",o=i.get),!o)throw new Error("not supported");var r="$memoize$"+t;i[n]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return this.hasOwnProperty(r)||Object.defineProperty(this,r,{configurable:!1,enumerable:!1,writable:!1,value:o.apply(this,e)}),this[r]}}}),define(t[577],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i,n){this.originalStart=e,this.originalLength=t,this.modifiedStart=i,this.modifiedLength=n}return e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=i}),define(t[125],i([1,0,577]),function(e,t,i){"use strict";function n(e){return{getLength:function(){return e.length},getElementAtIndex:function(t){return e.charCodeAt(t)}}}
Object.defineProperty(t,"__esModule",{value:!0}),t.stringDiff=function(e,t,i){return new a(n(e),n(t)).ComputeDiff(i)};var o=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=o;var r=function(){function e(){}return e.Copy=function(e,t,i,n,o){for(var r=0;r<o;r++)i[n+r]=e[t+r]},e}();t.MyArray=r;var s=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++
},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),a=function(){function e(e,t,i){void 0===i&&(i=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}return e.prototype.ElementsAreEqual=function(e,t){return this.OriginalSequence.getElementAtIndex(e)===this.ModifiedSequence.getElementAtIndex(t)},e.prototype.OriginalElementsAreEqual=function(e,t){return this.OriginalSequence.getElementAtIndex(e)===this.OriginalSequence.getElementAtIndex(t)},e.prototype.ModifiedElementsAreEqual=function(e,t){
return this.ModifiedSequence.getElementAtIndex(e)===this.ModifiedSequence.getElementAtIndex(t)},e.prototype.ComputeDiff=function(e){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,e)},e.prototype._ComputeDiff=function(e,t,i,n,o){var r=this.ComputeDiffRecursive(e,t,i,n,[!1]);return o?this.PrettifyChanges(r):r},e.prototype.ComputeDiffRecursive=function(e,t,n,r,s){for(s[0]=!1;e<=t&&n<=r&&this.ElementsAreEqual(e,n);)e++,n++;for(;t>=e&&r>=n&&this.ElementsAreEqual(t,r);)t--,r--;if(e>t||n>r){var a=void 0;return n<=r?(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),a=[new i.DiffChange(e,0,n,r-n+1)]):e<=t?(o.Assert(n===r+1,"modifiedStart should only be one more than modifiedEnd"),a=[new i.DiffChange(e,t-e+1,n,0)]):(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),o.Assert(n===r+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}
var l=[0],u=[0],d=this.ComputeRecursionPoint(e,t,n,r,l,u,s),c=l[0],h=u[0];if(null!==d)return d;if(!s[0]){var p=this.ComputeDiffRecursive(e,c,n,h,s),f=[];return f=s[0]?[new i.DiffChange(c+1,t-(c+1)+1,h+1,r-(h+1)+1)]:this.ComputeDiffRecursive(c+1,t,h+1,r,s),this.ConcatenateChanges(p,f)}return[new i.DiffChange(e,t-e+1,n,r-n+1)]},e.prototype.WALKTRACE=function(e,t,n,o,r,a,l,u,d,c,h,p,f,g,m,v,_,y){var b,C=null,S=null,w=new s,E=t,L=n,x=f[0]-v[0]-o,D=Number.MIN_VALUE,I=this.m_forwardHistory.length-1;do{(b=x+e)===E||b<L&&d[b-1]<d[b+1]?(g=(h=d[b+1])-x-o,h<D&&w.MarkNextChange(),D=h,w.AddModifiedElement(h+1,g),x=b+1-e):(g=(h=d[b-1]+1)-x-o,h<D&&w.MarkNextChange(),D=h-1,w.AddOriginalElement(h,g+1),x=b-1-e),I>=0&&(e=(d=this.m_forwardHistory[I])[0],E=1,L=d.length-1)}while(--I>=-1);if(C=w.getReverseChanges(),y[0]){var N=f[0]+1,M=v[0]+1;if(null!==C&&C.length>0){var k=C[C.length-1];N=Math.max(N,k.getOriginalEnd()),M=Math.max(M,k.getModifiedEnd())}S=[new i.DiffChange(N,p-N+1,M,m-M+1)]}else{w=new s,E=a,L=l,x=f[0]-v[0]-u,
D=Number.MAX_VALUE,I=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{(b=x+r)===E||b<L&&c[b-1]>=c[b+1]?(g=(h=c[b+1]-1)-x-u,h>D&&w.MarkNextChange(),D=h+1,w.AddOriginalElement(h+1,g+1),x=b+1-r):(g=(h=c[b-1])-x-u,h>D&&w.MarkNextChange(),D=h,w.AddModifiedElement(h+1,g+1),x=b-1-r),I>=0&&(r=(c=this.m_reverseHistory[I])[0],E=1,L=c.length-1)}while(--I>=-1);S=w.getChanges()}return this.ConcatenateChanges(C,S)},e.prototype.ComputeRecursionPoint=function(e,t,n,o,s,a,l){var u,d=0,c=0,h=0,p=0,f=0,g=0;e--,n--,s[0]=0,a[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var m=t-e+(o-n),v=m+1,_=new Array(v),y=new Array(v),b=o-n,C=t-e,S=e-n,w=t-o,E=(C-b)%2==0;_[b]=e,y[C]=t,l[0]=!1;var L,x;for(u=1;u<=m/2+1;u++){var D=0,I=0;for(h=this.ClipDiagonalBound(b-u,u,b,v),p=this.ClipDiagonalBound(b+u,u,b,v),L=h;L<=p;L+=2){for(c=(d=L===h||L<p&&_[L-1]<_[L+1]?_[L+1]:_[L-1]+1)-(L-b)-S,x=d;d<t&&c<o&&this.ElementsAreEqual(d+1,c+1);)d++,c++;if(_[L]=d,d+c>D+I&&(D=d,I=c),!E&&Math.abs(L-C)<=u-1&&d>=y[L])return s[0]=d,a[0]=c,
x<=y[L]&&u<=1448?this.WALKTRACE(b,h,p,S,C,f,g,w,_,y,d,t,s,c,o,a,E,l):null}var N=(D-e+(I-n)-u)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(D,this.OriginalSequence,N))return l[0]=!0,s[0]=D,a[0]=I,N>0&&u<=1448?this.WALKTRACE(b,h,p,S,C,f,g,w,_,y,d,t,s,c,o,a,E,l):(e++,n++,[new i.DiffChange(e,t-e+1,n,o-n+1)]);for(f=this.ClipDiagonalBound(C-u,u,C,v),g=this.ClipDiagonalBound(C+u,u,C,v),L=f;L<=g;L+=2){for(c=(d=L===f||L<g&&y[L-1]>=y[L+1]?y[L+1]-1:y[L-1])-(L-C)-w,x=d;d>e&&c>n&&this.ElementsAreEqual(d,c);)d--,c--;if(y[L]=d,E&&Math.abs(L-b)<=u&&d<=_[L])return s[0]=d,a[0]=c,x>=_[L]&&u<=1448?this.WALKTRACE(b,h,p,S,C,f,g,w,_,y,d,t,s,c,o,a,E,l):null}if(u<=1447){var M=new Array(p-h+2);M[0]=b-h+1,r.Copy(_,h,M,1,p-h+1),this.m_forwardHistory.push(M),(M=new Array(g-f+2))[0]=C-f+1,r.Copy(y,f,M,1,g-f+1),this.m_reverseHistory.push(M)}}return this.WALKTRACE(b,h,p,S,C,f,g,w,_,y,d,t,s,c,o,a,E,l)},e.prototype.PrettifyChanges=function(e){for(a=0;a<e.length;a++){
for(var t=e[a],i=a<e.length-1?e[a+1].originalStart:this.OriginalSequence.getLength(),n=a<e.length-1?e[a+1].modifiedStart:this.ModifiedSequence.getLength(),o=t.originalLength>0,r=t.modifiedLength>0;t.originalStart+t.originalLength<i&&t.modifiedStart+t.modifiedLength<n&&(!o||this.OriginalElementsAreEqual(t.originalStart,t.originalStart+t.originalLength))&&(!r||this.ModifiedElementsAreEqual(t.modifiedStart,t.modifiedStart+t.modifiedLength));)t.originalStart++,t.modifiedStart++;var s=[null];a<e.length-1&&this.ChangesOverlap(e[a],e[a+1],s)&&(e[a]=s[0],e.splice(a+1,1),a--)}for(var a=e.length-1;a>=0;a--){var t=e[a],i=0,n=0;if(a>0){var l=e[a-1];l.originalLength>0&&(i=l.originalStart+l.originalLength),l.modifiedLength>0&&(n=l.modifiedStart+l.modifiedLength)}for(var o=t.originalLength>0,r=t.modifiedLength>0,u=0,d=this._boundaryScore(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength),c=1;;c++){var h=t.originalStart-c,p=t.modifiedStart-c;if(h<i||p<n)break
;if(o&&!this.OriginalElementsAreEqual(h,h+t.originalLength))break;if(r&&!this.ModifiedElementsAreEqual(p,p+t.modifiedLength))break;var f=this._boundaryScore(h,t.originalLength,p,t.modifiedLength);f>d&&(d=f,u=c)}t.originalStart-=u,t.modifiedStart-=u}return e},e.prototype._OriginalIsBoundary=function(e){if(e<=0||e>=this.OriginalSequence.getLength()-1)return!0;var t=this.OriginalSequence.getElementAtIndex(e);return"string"==typeof t&&/^\s*$/.test(t)},e.prototype._OriginalRegionIsBoundary=function(e,t){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(t>0){var i=e+t;if(this._OriginalIsBoundary(i-1)||this._OriginalIsBoundary(i))return!0}return!1},e.prototype._ModifiedIsBoundary=function(e){if(e<=0||e>=this.ModifiedSequence.getLength()-1)return!0;var t=this.ModifiedSequence.getElementAtIndex(e);return"string"==typeof t&&/^\s*$/.test(t)},e.prototype._ModifiedRegionIsBoundary=function(e,t){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(t>0){var i=e+t
;if(this._ModifiedIsBoundary(i-1)||this._ModifiedIsBoundary(i))return!0}return!1},e.prototype._boundaryScore=function(e,t,i,n){return(this._OriginalRegionIsBoundary(e,t)?1:0)+(this._ModifiedRegionIsBoundary(i,n)?1:0)},e.prototype.ConcatenateChanges=function(e,t){var i=[];if(0===e.length||0===t.length)return t.length>0?t:e;if(this.ChangesOverlap(e[e.length-1],t[0],i)){n=new Array(e.length+t.length-1);return r.Copy(e,0,n,0,e.length-1),n[e.length-1]=i[0],r.Copy(t,1,n,e.length,t.length-1),n}var n=new Array(e.length+t.length);return r.Copy(e,0,n,0,e.length),r.Copy(t,0,n,e.length,t.length),n},e.prototype.ChangesOverlap=function(e,t,n){if(o.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),o.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var r=e.originalStart,s=e.originalLength,a=e.modifiedStart,l=e.modifiedLength
;return e.originalStart+e.originalLength>=t.originalStart&&(s=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(l=t.modifiedStart+t.modifiedLength-e.modifiedStart),n[0]=new i.DiffChange(r,s,a,l),!0}return n[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,i,n){if(e>=0&&e<n)return e;var o=n-i-1,r=t%2==0;if(e<0){return r===(i%2==0)?0:1}return r===(o%2==0)?n-1:n-2},e}();t.LcsDiff=a}),define(t[10],i([1,0]),function(e,t){"use strict";function i(e){return e instanceof Error&&e.name===o&&e.message===o}Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(function(){if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}return e.prototype.emit=function(e){this.listeners.forEach(function(t){t(e)})},e.prototype.onUnexpectedError=function(e){this.unexpectedErrorHandler(e),this.emit(e)},e.prototype.onUnexpectedExternalError=function(e){
this.unexpectedErrorHandler(e)},e}();t.ErrorHandler=n,t.errorHandler=new n,t.onUnexpectedError=function(e){i(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){i(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error)return{$isError:!0,name:e.name,message:e.message,stack:e.stacktrace||e.stack};return e};var o="Canceled";t.isPromiseCanceledError=i,t.canceled=function(){var e=new Error(o);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error("Illegal argument: "+e):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error("Illegal state: "+e):new Error("Illegal state")}}),define(t[224],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=function(e){var t,i=this,n=!1;return function(){return n?t:(n=!0,t=e.apply(i,arguments))}}}),define(t[568],i([1,0]),function(e,t){"use strict";function i(e,t){switch(void 0===t&&(t=0),typeof e){case"object":
return null===e?n(349,t):Array.isArray(e)?function(e,t){return t=n(104579,t),e.reduce(function(e,t){return i(t,e)},t)}(e,t):function(e,t){return t=n(181387,t),Object.keys(e).sort().reduce(function(t,n){return t=o(n,t),i(e[n],t)},t)}(e,t);case"string":return o(e,t);case"boolean":return function(e,t){return n(e?433:863,t)}(e,t);case"number":return n(e,t);case"undefined":return n(0,937);default:return n(0,617)}}function n(e,t){return(t<<5)-t+e|0}function o(e,t){t=n(149417,t);for(var i=0,o=e.length;i<o;i++)t=n(e.charCodeAt(i),t);return t}Object.defineProperty(t,"__esModule",{value:!0}),t.hash=i}),define(t[78],i([1,0,19]),function(e,t,i){"use strict";function n(e){return o(e)?!e.value:!Array.isArray(e)||e.every(n)}function o(e){return e instanceof s||!(!e||"object"!=typeof e)&&("string"==typeof e.value&&("boolean"==typeof e.isTrusted||void 0===e.isTrusted))}function r(e,t){return e===t||!(!e||!t)&&(e.value===t.value&&e.isTrusted===t.isTrusted)}Object.defineProperty(t,"__esModule",{value:!0});var s=function(){
function e(e){void 0===e&&(e=""),this.value=e}return e.prototype.appendText=function(e){return this.value+=e.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&"),this},e.prototype.appendMarkdown=function(e){return this.value+=e,this},e.prototype.appendCodeblock=function(e,t){return this.value+="\n```",this.value+=e,this.value+="\n",this.value+=t,this.value+="\n```\n",this},e}();t.MarkdownString=s,t.isEmptyMarkdownString=n,t.isMarkdownString=o,t.markedStringsEquals=function(e,t){return!e&&!t||!(!e||!t)&&(Array.isArray(e)&&Array.isArray(t)?i.equals(e,t,r):!(!o(e)||!o(t))&&r(e,t))},t.removeMarkdownEscapes=function(e){return e?e.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1"):e},t.parseHrefAndDimensions=function(e){var t=[],i=e.split("|").map(function(e){return e.trim()});e=i[0];var n=i[1];if(n){var o=/height=(\d+)/.exec(n),r=/width=(\d+)/.exec(n),s=o?o[1]:"",a=r?r[1]:"",l=isFinite(parseInt(a)),u=isFinite(parseInt(s));l&&t.push('width="'+a+'"'),u&&t.push('height="'+s+'"')}return{href:e,dimensions:t}}}),
define(t[149],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this._prefix=e,this._lastId=0}return e.prototype.nextId=function(){return this._prefix+ ++this._lastId},e}();t.IdGenerator=i,t.defaultGenerator=new i("id#")});/*
The MIT License (MIT)

Copyright © 2015 Nicolas Bevacqua

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
let o;!function(){function e(t,i,n){function o(s,a){if(!i[s]){if(!t[s]){var l="function"==typeof require&&require;if(!a&&l)return l(s,!0);if(r)return r(s,!0);var u=new Error("Cannot find module '"+s+"'");throw u.code="MODULE_NOT_FOUND",u}var d=i[s]={exports:{}};t[s][0].call(d.exports,function(e){return o(t[s][1][e]||e)},d,d.exports,e,t,i,n)}return i[s].exports}for(var r="function"==typeof require&&require,s=0;s<n.length;s++)o(n[s]);return o}return e}()({1:[function(e,t,i){"use strict";var n=e("./toMap");t.exports={uris:n(["background","base","cite","href","longdesc","src","usemap"])}},{"./toMap":10}],2:[function(e,t,i){"use strict";t.exports={allowedAttributes:{"*":["title","accesskey"],a:["href","name","target","aria-label"],iframe:["allowfullscreen","frameborder","src"],img:["src","alt","title","aria-label"]},allowedClasses:{},allowedSchemes:["http","https","mailto"],
allowedTags:["a","abbr","article","b","blockquote","br","caption","code","del","details","div","em","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","li","main","mark","ol","p","pre","section","span","strike","strong","sub","summary","sup","table","tbody","td","th","thead","tr","u","ul"],filter:null}},{}],3:[function(e,t,i){"use strict";var n=e("./toMap");t.exports={voids:n(["area","br","col","hr","img","wbr","input","base","basefont","link","meta"])}},{"./toMap":10}],4:[function(e,t,i){"use strict";function n(e,t,i){var n=[],o=!0===i?t:r({},l,t),u=a(n,o);return s(e,u),n.join("")}e("he");var r=e("assignment"),s=e("./parser"),a=e("./sanitizer"),l=e("./defaults");n.defaults=l,t.exports=n,o=n},{"./defaults":2,"./parser":7,"./sanitizer":8,assignment:6,he:9}],5:[function(e,t,i){"use strict";t.exports=function(e){return"string"==typeof e?e.toLowerCase():e}},{}],6:[function(e,t,i){"use strict";function n(e){for(var t,i,o=Array.prototype.slice.call(arguments,1);o.length;){t=o.shift()
;for(i in t)t.hasOwnProperty(i)&&("[object Object]"===Object.prototype.toString.call(e[i])?e[i]=n(e[i],t[i]):e[i]=t[i])}return e}t.exports=n},{}],7:[function(e,t,i){"use strict";function n(e,t){function i(){f=!0,function(){"\x3c!--"===e.substr(0,4)?function(){var i=e.indexOf("--\x3e");i>=0&&(t.comment&&t.comment(e.substring(4,i)),e=e.substring(i+3),f=!1)}():c.test(e)?n(l,p):d.test(e)&&n(a,h);!function(){if(!f)return;var i,n=e.indexOf("<");n>=0?(i=e.substring(0,n),e=e.substring(n)):(i=e,e="");t.chars&&t.chars(i)}()}();var i=e===m;m=e,i&&(e="")}function n(t,i){var n=e.match(t);n&&(e=e.substring(n[0].length),n[0].replace(t,i),f=!1)}function h(e,i,n,a){var l={},d=r(i),c=s.voids[d]||!!a;n.replace(u,function(e,t,i,n,r){l[t]=void 0===i&&void 0===n&&void 0===r?void 0:o.decode(i||n||r||"")}),c||g.push(d),t.start&&t.start(d,l,c)}function p(e,i){var n,o=0,s=r(i);if(s)for(o=g.length-1;o>=0&&g[o]!==s;o--);if(o>=0){for(n=g.length-1;n>=o;n--)t.end&&t.end(g[n]);g.length=o}}for(var f,g=function(){var e=[]
;return e.lastItem=function(){return e[e.length-1]},e}(),m=e;e;)i();p()}var o=e("he"),r=e("./lowercase"),s=(e("./attributes"),e("./elements")),a=/^<\s*([\w:-]+)((?:\s+[\w:-]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)\s*>/,l=/^<\s*\/\s*([\w:-]+)[^>]*>/,u=/([\w:-]+)(?:\s*=\s*(?:(?:"((?:[^"])*)")|(?:'((?:[^'])*)')|([^>\s]+)))?/g,d=/^</,c=/^<\s*\//;t.exports=n},{"./attributes":1,"./elements":3,"./lowercase":5,he:9}],8:[function(e,t,i){"use strict";function n(e,t){function i(t){e.push(t)}function n(e,t,n){function a(e){function n(e){return l&&-1!==l.indexOf(e)}var a=t[e],l=(h.allowedClasses||{})[u]||[],d=(h.allowedAttributes||{})[u]||[];d=d.concat((h.allowedAttributes||{})["*"]||[]);var c=r(e);("class"===c&&-1===d.indexOf(c)?(a=a.split(" ").filter(n).join(" ").trim()).length:-1!==d.indexOf(c)&&(!0!==s.uris[c]||function(e){var t=e[0];if("#"===t||"/"===t)return!0;var i=e.indexOf(":");if(-1===i)return!0;var n=e.indexOf("?");if(-1!==n&&i>n)return!0;var o=e.indexOf("#");if(-1!==o&&i>o)return!0
;return h.allowedSchemes.some(function(t){return 0===e.indexOf(t+":")})}(a)))&&(i(" "),i(e),"string"==typeof a&&(i('="'),i(o.encode(a)),i('"')))}var u=r(e);c.ignoring?l(u):-1!==(h.allowedTags||[]).indexOf(u)&&(!h.filter||h.filter({tag:u,attrs:t}))?(i("<"),i(u),Object.keys(t).forEach(a),i(n?"/>":">")):l(u)}function l(e){a.voids[e]||(!1===c.ignoring?c={ignoring:e,depth:1}:c.ignoring===e&&c.depth++)}function u(e){c.ignoring===e&&--c.depth<=0&&d()}function d(){c={ignoring:!1,depth:0}}var c,h=t||{};return d(),{start:n,end:function(e){var t=r(e);-1!==(h.allowedTags||[]).indexOf(t)&&!1===c.ignoring?(i("</"),i(t),i(">")):u(t)},chars:function(e){!1===c.ignoring&&i(h.transformText?h.transformText(e):e)}}}var o=e("he"),r=e("./lowercase"),s=e("./attributes"),a=e("./elements");t.exports=n},{"./attributes":1,"./elements":3,"./lowercase":5,he:9}],9:[function(e,t,i){"use strict";function n(e){return a[e]}function o(e){return l[e]}function r(e){return null==e?"":String(e).replace(d,n)}function s(e){
return null==e?"":String(e).replace(u,o)}var a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l={"&amp;":"&","&lt;":"<","&gt;":">","&quot;":'"',"&#39;":"'"},u=/(&amp;|&lt;|&gt;|&quot;|&#39;)/g,d=/[&<>"']/g;r.options=s.options={},t.exports={encode:r,escape:r,decode:s,unescape:s,version:"1.0.0-browser"}},{}],10:[function(e,t,i){"use strict";function n(e,t){return e[t]=!0,e}t.exports=function(e){return e.reduce(n,{})}},{}]},{},[4]),define("vs/base/common/insane/insane",function(){return{insane:o}});var r=this&&this.__extends||function(){var e=function(t,i){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i])})(t,i)};return function(t,i){function n(){this.constructor=t}e(t,i),t.prototype=null===i?Object.create(i):(n.prototype=i.prototype,new n)}}();define(t[62],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FIN={done:!0,value:void 0};var i;!function(e){
var i={next:function(){return t.FIN}};e.empty=function(){return i},e.single=function(e){var i=!1;return{next:function(){return i?t.FIN:(i=!0,{done:!1,value:e})}}},e.fromArray=function(e,i,n){return void 0===i&&(i=0),void 0===n&&(n=e.length),{next:function(){return i>=n?t.FIN:{done:!1,value:e[i++]}}}},e.from=function(t){return t?Array.isArray(t)?e.fromArray(t):t:e.empty()},e.map=function(e,i){return{next:function(){var n=e.next();return n.done?t.FIN:{done:!1,value:i(n.value)}}}},e.filter=function(e,i){return{next:function(){for(;;){var n=e.next();if(n.done)return t.FIN;if(i(n.value))return{done:!1,value:n.value}}}}},e.forEach=function(e,t){for(var i=e.next();!i.done;i=e.next())t(i.value)},e.collect=function(e,t){void 0===t&&(t=Number.POSITIVE_INFINITY);var i=[];if(0===t)return i;for(var n=0,o=e.next();!(o.done||(i.push(o.value),++n>=t));o=e.next());return i},e.concat=function(){for(var e=[],i=0;i<arguments.length;i++)e[i]=arguments[i];var n=0;return{next:function(){if(n>=e.length)return t.FIN;var i=e[n].next()
;return i.done?(n++,this.next()):i}}}}(i=t.Iterator||(t.Iterator={})),t.getSequenceIterator=function(e){return Array.isArray(e)?i.fromArray(e):e};var n=function(){function e(e,t,i,n){void 0===t&&(t=0),void 0===i&&(i=e.length),void 0===n&&(n=t-1),this.items=e,this.start=t,this.end=i,this.index=n}return e.prototype.first=function(){return this.index=this.start,this.current()},e.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},e.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},e}();t.ArrayIterator=n;var o=function(e){function t(t,i,n,o){return void 0===i&&(i=0),void 0===n&&(n=t.length),void 0===o&&(o=i-1),e.call(this,t,i,n,o)||this}return r(t,e),t.prototype.current=function(){return e.prototype.current.call(this)},t.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},t.prototype.first=function(){return this.index=this.start,this.current()},
t.prototype.last=function(){return this.index=this.end-1,this.current()},t.prototype.parent=function(){return null},t}(n);t.ArrayNavigator=o;var s=function(){function e(e,t){this.iterator=e,this.fn=t}return e.prototype.next=function(){return this.fn(this.iterator.next())},e}();t.MappedIterator=s}),define(t[561],i([1,0,62]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){void 0===e&&(e=[]),void 0===t&&(t=10),this._initialize(e),this._limit=t,this._onChange()}return e.prototype.add=function(e){this._history.delete(e),this._history.add(e),this._onChange()},e.prototype.next=function(){return this._navigator.next()},e.prototype.previous=function(){return this._navigator.previous()},e.prototype.current=function(){return this._navigator.current()},e.prototype.parent=function(){return null},e.prototype.first=function(){return this._navigator.first()},e.prototype.last=function(){return this._navigator.last()},e.prototype.has=function(e){
return this._history.has(e)},e.prototype._onChange=function(){this._reduceToLimit(),this._navigator=new i.ArrayNavigator(this._elements,0,this._elements.length,this._elements.length)},e.prototype._reduceToLimit=function(){var e=this._elements;e.length>this._limit&&this._initialize(e.slice(e.length-this._limit))},e.prototype._initialize=function(e){this._history=new Set;for(var t=0,i=e;t<i.length;t++){var n=i[t];this._history.add(n)}},Object.defineProperty(e.prototype,"_elements",{get:function(){var e=[];return this._history.forEach(function(t){return e.push(t)}),e},enumerable:!0,configurable:!0}),e}();t.HistoryNavigator=n}),define(t[38],i([1,0,10]),function(e,t,i){"use strict";function n(e,t){var i=!!(2048&e),n=!!(256&e);return new l(2===t?n:i,!!(1024&e),!!(512&e),2===t?i:n,255&e)}Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(e,t){this._keyCodeToStr[e]=t,
this._strToKeyCode[t.toLowerCase()]=e},e.prototype.keyCodeToStr=function(e){return this._keyCodeToStr[e]},e.prototype.strToKeyCode=function(e){return this._strToKeyCode[e.toLowerCase()]||0},e}(),r=new o,s=new o,a=new o;!function(){function e(e,t,i,n){void 0===i&&(i=t),void 0===n&&(n=i),r.define(e,t),s.define(e,i),a.define(e,n)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),
e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}();!function(e){e.toString=function(e){return r.keyCodeToStr(e)},e.fromString=function(e){
return r.strToKeyCode(e)},e.toUserSettingsUS=function(e){return s.keyCodeToStr(e)},e.toUserSettingsGeneral=function(e){return a.keyCodeToStr(e)},e.fromUserSettings=function(e){return s.strToKeyCode(e)||a.strToKeyCode(e)}}(t.KeyCodeUtils||(t.KeyCodeUtils={})),t.KeyChord=function(e,t){return(e|(65535&t)<<16>>>0)>>>0},t.createKeybinding=function(e,t){if(0===e)return null;var i=(65535&e)>>>0,o=(4294901760&e)>>>16;return new u(0!==o?[n(i,t),n(o,t)]:[n(i,t)])},t.createSimpleKeybinding=n;var l=function(){function e(e,t,i,n,o){this.ctrlKey=e,this.shiftKey=t,this.altKey=i,this.metaKey=n,this.keyCode=o}return e.prototype.equals=function(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.toChord=function(){return new u([this])},e.prototype.isDuplicateModifierCase=function(){
return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();t.SimpleKeybinding=l;var u=function(){function e(e){if(0===e.length)throw i.illegalArgument("parts");this.parts=e}return e.prototype.equals=function(e){if(null===e)return!1;if(this.parts.length!==e.parts.length)return!1;for(var t=0;t<this.parts.length;t++)if(!this.parts[t].equals(e.parts[t]))return!1;return!0},e}();t.ChordKeybinding=u;var d=function(){return function(e,t,i,n,o,r){this.ctrlKey=e,this.shiftKey=t,this.altKey=i,this.metaKey=n,this.keyLabel=o,this.keyAriaLabel=r}}();t.ResolvedKeybindingPart=d;var c=function(){return function(){}}();t.ResolvedKeybinding=c}),define(t[2],i([1,0]),function(e,t){"use strict";function i(e){if(r&&e&&e!==l.None)try{e[s]=!0}catch(e){}}function n(e){if(!r)return e;var t=new Error("Potentially leaked disposable").stack;return setTimeout(function(){e[s]||console.log(t)},3e3),e}function o(e){return Array.isArray(e)?(e.forEach(function(e){
e&&(i(e),e.dispose())}),[]):e?(i(e),e.dispose(),e):void 0}Object.defineProperty(t,"__esModule",{value:!0});var r=!1,s="__is_disposable_tracked__";t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=o,t.combinedDisposable=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return e.forEach(i),n({dispose:function(){return o(e)}})},t.toDisposable=function(e){var t=n({dispose:function(){i(t),e()}});return t};var a=function(){function e(){this._toDispose=new Set,this._isDisposed=!1}return e.prototype.dispose=function(){this._isDisposed||(i(this),this._isDisposed=!0,this.clear())},e.prototype.clear=function(){this._toDispose.forEach(function(e){return e.dispose()}),this._toDispose.clear()},e.prototype.add=function(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return i(e),
this._isDisposed?console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e},e}();t.DisposableStore=a;var l=function(){function e(){this._store=new a,n(this)}return e.prototype.dispose=function(){i(this),this._store.dispose()},e.prototype._register=function(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)},e.None=Object.freeze({dispose:function(){}}),e}();t.Disposable=l;var u=function(){function e(){this._isDisposed=!1,n(this)}return Object.defineProperty(e.prototype,"value",{get:function(){return this._isDisposed?void 0:this._value},set:function(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&i(e),this._value=e)},enumerable:!0,configurable:!0}),e.prototype.clear=function(){this.value=void 0},e.prototype.dispose=function(){this._isDisposed=!0,i(this),this._value&&this._value.dispose(),this._value=void 0},e}()
;t.MutableDisposable=u;var d=function(){function e(e){this.object=e}return e.prototype.dispose=function(){},e}();t.ImmortalReference=d}),define(t[75],i([1,0,62]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),o=function(){function e(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===n.Undefined},e.prototype.clear=function(){this._first=n.Undefined,this._last=n.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var i=this,o=new n(e);if(this._first===n.Undefined)this._first=o,this._last=o;else if(t){var r=this._last;this._last=o,o.prev=r,r.next=o}else{
var s=this._first;this._first=o,o.next=s,s.prev=o}this._size+=1;var a=!1;return function(){a||(a=!0,i._remove(o))}},e.prototype.shift=function(){if(this._first!==n.Undefined){var e=this._first.element;return this._remove(this._first),e}},e.prototype.pop=function(){if(this._last!==n.Undefined){var e=this._last.element;return this._remove(this._last),e}},e.prototype._remove=function(e){if(e.prev!==n.Undefined&&e.next!==n.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===n.Undefined&&e.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):e.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):e.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===n.Undefined?i.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==n.Undefined;t=t.next)e.push(t.element);return e
},e}();t.LinkedList=o}),define(t[4],i([1,0,10,224,2,75]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){function t(e){return function(t,i,n){void 0===i&&(i=null);var o,r=!1;return o=e(function(e){if(!r)return o?o.dispose():r=!0,t.call(i,e)},null,n),r&&o.dispose(),o}}function i(e,t){return a(function(i,n,o){return void 0===n&&(n=null),e(function(e){return i.call(n,t(e))},null,o)})}function n(e,t){return a(function(i,n,o){return void 0===n&&(n=null),e(function(e){t(e),i.call(n,e)},null,o)})}function r(e,t){return a(function(i,n,o){return void 0===n&&(n=null),e(function(e){return t(e)&&i.call(n,e)},null,o)})}function s(e,t,n){var o=n;return i(e,function(e){return o=t(o,e)})}function a(e){var t,i=new d({onFirstListenerAdd:function(){t=e(i.fire,i)},onLastListenerRemove:function(){t.dispose()}});return i.event}function l(e){var t,i=!0;return r(e,function(e){var n=i||e!==t;return i=!1,t=e,n})}e.None=function(){return o.Disposable.None},e.once=t,e.map=i,
e.forEach=n,e.filter=r,e.signal=function(e){return e},e.any=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return function(t,i,n){return void 0===i&&(i=null),o.combinedDisposable.apply(void 0,e.map(function(e){return e(function(e){return t.call(i,e)},null,n)}))}},e.reduce=s,e.snapshot=a,e.debounce=function(e,t,i,n,o){void 0===i&&(i=100),void 0===n&&(n=!1);var r,s=void 0,a=void 0,l=0,u=new d({leakWarningThreshold:o,onFirstListenerAdd:function(){r=e(function(e){l++,s=t(s,e),n&&!a&&u.fire(s),clearTimeout(a),a=setTimeout(function(){var e=s;s=void 0,a=void 0,(!n||l>1)&&u.fire(e),l=0},i)})},onLastListenerRemove:function(){r.dispose()}});return u.event},e.stopwatch=function(e){var n=(new Date).getTime();return i(t(e),function(e){return(new Date).getTime()-n})},e.latch=l,e.buffer=function(e,t,i){void 0===t&&(t=!1),void 0===i&&(i=[]);var n=i.slice(),o=e(function(e){n?n.push(e):s.fire(e)}),r=function(){n&&n.forEach(function(e){return s.fire(e)}),n=null},s=new d({onFirstListenerAdd:function(){
o||(o=e(function(e){return s.fire(e)}))},onFirstListenerDidAdd:function(){n&&(t?setTimeout(r):r())},onLastListenerRemove:function(){o&&o.dispose(),o=null}});return s.event};var u=function(){function e(e){this.event=e}return e.prototype.map=function(t){return new e(i(this.event,t))},e.prototype.forEach=function(t){return new e(n(this.event,t))},e.prototype.filter=function(t){return new e(r(this.event,t))},e.prototype.reduce=function(t,i){return new e(s(this.event,t,i))},e.prototype.latch=function(){return new e(l(this.event))},e.prototype.on=function(e,t,i){return this.event(e,t,i)},e.prototype.once=function(e,i,n){return t(this.event)(e,i,n)},e}();e.chain=function(e){return new u(e)},e.fromNodeEventEmitter=function(e,t,i){void 0===i&&(i=function(e){return e});var n=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return o.fire(i.apply(void 0,e))},o=new d({onFirstListenerAdd:function(){return e.on(t,n)},onLastListenerRemove:function(){return e.removeListener(t,n)}});return o.event},
e.fromDOMEventEmitter=function(e,t,i){void 0===i&&(i=function(e){return e});var n=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return o.fire(i.apply(void 0,e))},o=new d({onFirstListenerAdd:function(){return e.addEventListener(t,n)},onLastListenerRemove:function(){return e.removeEventListener(t,n)}});return o.event},e.fromPromise=function(e){var t=new d,i=!1;return e.then(void 0,function(){return null}).then(function(){i?t.fire(void 0):setTimeout(function(){return t.fire(void 0)},0)}),i=!0,t.event},e.toPromise=function(e){return new Promise(function(i){return t(e)(i)})}}(a=t.Event||(t.Event={}));var l=-1,u=function(){function e(e,t){void 0===t&&(t=Math.random().toString(18).slice(2,5)),this.customThreshold=e,this.name=t,this._warnCountdown=0}return e.prototype.dispose=function(){this._stacks&&this._stacks.clear()},e.prototype.check=function(e){var t=this,i=l;if("number"==typeof this.customThreshold&&(i=this.customThreshold),!(i<=0||e<i)){this._stacks||(this._stacks=new Map)
;var n=(new Error).stack.split("\n").slice(3).join("\n"),o=this._stacks.get(n)||0;if(this._stacks.set(n,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*i;var r,s=0;this._stacks.forEach(function(e,t){(!r||s<e)&&(r=t,s=e)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+e+" listeners already. MOST frequent listener ("+s+"):"),console.warn(r)}return function(){var e=t._stacks.get(n)||0;t._stacks.set(n,e-1)}}},e}(),d=function(){function e(e){this._disposed=!1,this._options=e,this._leakageMon=l>0?new u(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(e.prototype,"event",{get:function(){var t=this;return this._event||(this._event=function(i,n,r){t._listeners||(t._listeners=new s.LinkedList);var a=t._listeners.isEmpty();a&&t._options&&t._options.onFirstListenerAdd&&t._options.onFirstListenerAdd(t);var l=t._listeners.push(n?[i,n]:i);a&&t._options&&t._options.onFirstListenerDidAdd&&t._options.onFirstListenerDidAdd(t),
t._options&&t._options.onListenerDidAdd&&t._options.onListenerDidAdd(t,i,n);var u;t._leakageMon&&(u=t._leakageMon.check(t._listeners.size));var d;return d={dispose:function(){if(u&&u(),d.dispose=e._noop,!t._disposed&&(l(),t._options&&t._options.onLastListenerRemove)){t._listeners&&!t._listeners.isEmpty()||t._options.onLastListenerRemove(t)}}},r instanceof o.DisposableStore?r.add(d):Array.isArray(r)&&r.push(d),d}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var t=this._listeners.iterator(),n=t.next();!n.done;n=t.next())this._deliveryQueue.push([n.value,e]);for(;this._deliveryQueue.size>0;){var o=this._deliveryQueue.shift(),r=o[0],a=o[1];try{"function"==typeof r?r.call(void 0,a):r[0].call(r[1],a)}catch(n){i.onUnexpectedError(n)}}}},e.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),
this._disposed=!0},e._noop=function(){},e}();t.Emitter=d;var c=function(e){function t(t){var i=e.call(this,t)||this;return i._isPaused=0,i._eventQueue=new s.LinkedList,i._mergeFn=t&&t.merge,i}return r(t,e),t.prototype.pause=function(){this._isPaused++},t.prototype.resume=function(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){var t=this._eventQueue.toArray();this._eventQueue.clear(),e.prototype.fire.call(this,this._mergeFn(t))}else for(;!this._isPaused&&0!==this._eventQueue.size;)e.prototype.fire.call(this,this._eventQueue.shift())},t.prototype.fire=function(t){this._listeners&&(0!==this._isPaused?this._eventQueue.push(t):e.prototype.fire.call(this,t))},t}(d);t.PauseableEmitter=c;var h=function(){function e(){var e=this;this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:function(){return e.onFirstListenerAdd()},onLastListenerRemove:function(){return e.onLastListenerRemove()}})}return Object.defineProperty(e.prototype,"event",{get:function(){return this.emitter.event},
enumerable:!0,configurable:!0}),e.prototype.add=function(e){var t=this,i={event:e,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);return o.toDisposable(n.once(function(){t.hasListeners&&t.unhook(i);var e=t.events.indexOf(i);t.events.splice(e,1)}))},e.prototype.onFirstListenerAdd=function(){var e=this;this.hasListeners=!0,this.events.forEach(function(t){return e.hook(t)})},e.prototype.onLastListenerRemove=function(){var e=this;this.hasListeners=!1,this.events.forEach(function(t){return e.unhook(t)})},e.prototype.hook=function(e){var t=this;e.listener=e.event(function(e){return t.emitter.fire(e)})},e.prototype.unhook=function(e){e.listener&&e.listener.dispose(),e.listener=null},e.prototype.dispose=function(){this.emitter.dispose()},e}();t.EventMultiplexer=h;var p=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(e){var t=this;return function(i,n,o){return e(function(e){var o=t.buffers[t.buffers.length-1];o?o.push(function(){return i.call(n,e)}):i.call(n,e)
},void 0,o)}},e.prototype.bufferEvents=function(e){var t=[];this.buffers.push(t);var i=e();return this.buffers.pop(),t.forEach(function(e){return e()}),i},e}();t.EventBufferer=p;var f=function(){function e(){var e=this;this.listening=!1,this.inputEvent=a.None,this.inputEventListener=o.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:function(){e.listening=!0,e.inputEventListener=e.inputEvent(e.emitter.fire,e.emitter)},onLastListenerRemove:function(){e.listening=!1,e.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(e.prototype,"input",{set:function(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},e}();t.Relay=f}),define(t[28],i([1,0,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(){
this._zoomLevel=0,this._lastZoomLevelChangeTime=0,this._onDidChangeZoomLevel=new i.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event}return e.prototype.getZoomLevel=function(){return this._zoomLevel},e.prototype.getTimeSinceLastZoomLevelChanged=function(){return Date.now()-this._lastZoomLevelChangeTime},e.prototype.getPixelRatio=function(){var e=document.createElement("canvas").getContext("2d");return(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)},e.INSTANCE=new e,e}();t.getZoomLevel=function(){return n.INSTANCE.getZoomLevel()},t.getTimeSinceLastZoomLevelChanged=function(){return n.INSTANCE.getTimeSinceLastZoomLevelChanged()},t.onDidChangeZoomLevel=function(e){return n.INSTANCE.onDidChangeZoomLevel(e)},t.getPixelRatio=function(){return n.INSTANCE.getPixelRatio()};var o=navigator.userAgent;t.isIE=o.indexOf("Trident")>=0,t.isEdge=o.indexOf("Edge/")>=0,
t.isEdgeOrIE=t.isIE||t.isEdge,t.isFirefox=o.indexOf("Firefox")>=0,t.isWebKit=o.indexOf("AppleWebKit")>=0,t.isChrome=o.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&o.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isIPad=o.indexOf("iPad")>=0,t.isEdgeWebView=t.isEdge&&o.indexOf("WebView/")>=0,t.hasClipboardSupport=function(){if(t.isIE)return!1;if(t.isEdge){var e=o.indexOf("Edge/"),i=parseInt(o.substring(e+5,o.indexOf(".",e)),10);if(!i||i>=12&&i<=16)return!1}return!0}}),define(t[52],i([1,0,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.domEvent=function(e,t,n){var o=function(e){return r.fire(e)},r=new i.Emitter({onFirstListenerAdd:function(){e.addEventListener(t,o,n)},onLastListenerRemove:function(){e.removeEventListener(t,o,n)}});return r.event},t.stop=function(e){return i.Event.map(e,function(e){return e.preventDefault(),e.stopPropagation(),e})}}),define(t[222],i([1,0,19,4,62]),function(e,t,i,n,o){"use strict";function r(e){
return"object"==typeof e&&"visibility"in e&&"data"in e}function s(e){switch(e){case!0:return 1;case!1:return 0;default:return e}}function a(e){var t=e.element,i=e.collapsed;return{element:t,children:o.Iterator.map(o.Iterator.fromArray(e.children),a),collapsed:i}}Object.defineProperty(t,"__esModule",{value:!0}),t.isFilterResult=r,t.getVisibleState=s;var l=function(){function e(e,t,i){void 0===i&&(i={}),this.list=e,this.rootRef=[],this.eventBufferer=new n.EventBufferer,this._onDidChangeCollapseState=new n.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new n.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new n.Emitter,this.onDidSplice=this._onDidSplice.event,this.collapseByDefault=void 0!==i.collapseByDefault&&i.collapseByDefault,this.filter=i.filter,this.autoExpandSingleChildren=void 0!==i.autoExpandSingleChildren&&i.autoExpandSingleChildren,
this.root={parent:void 0,element:t,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visible:!0,filterData:void 0}}return e.prototype.splice=function(e,t,i,n,r){var s,l=this;if(0===e.length)throw new Error("Invalid tree location");for(var u=this.getParentNodeWithListIndex(e),d=u.parentNode,c=u.listIndex,h=u.revealed,p=u.visible,f=[],g=o.Iterator.map(o.Iterator.from(i),function(e){return l.createTreeNode(e,d,d.visible?1:0,h,f,n)}),m=e[e.length-1],v=0,_=m;_>=0&&_<d.children.length;_--){if((x=d.children[_]).visible){v=x.visibleChildIndex;break}}var y=[],b=0,C=0;o.Iterator.forEach(g,function(e){y.push(e),C+=e.renderNodeCount,e.visible&&(e.visibleChildIndex=v+b++)});for(var S=(s=d.children).splice.apply(s,[m,t].concat(y)),w=0,E=0,L=S;E<L.length;E++){(x=L[E]).visible&&w++}if(0!==w)for(_=m+y.length;_<d.children.length;_++){var x=d.children[_];x.visible&&(x.visibleChildIndex-=w)}if(d.visibleChildrenCount+=b-w,h&&p){var D=S.reduce(function(e,t){
return e+t.renderNodeCount},0);this._updateAncestorsRenderNodeCount(d,C-D),this.list.splice(c,D,f)}if(S.length>0&&r){var I=function(e){r(e),e.children.forEach(I)};S.forEach(I)}var N=o.Iterator.map(o.Iterator.fromArray(S),a);return this._onDidSplice.fire({insertedNodes:y,deletedNodes:S}),N},e.prototype.rerender=function(e){if(0===e.length)throw new Error("Invalid tree location");var t=this.getTreeNodeWithListIndex(e),i=t.node,n=t.listIndex;t.revealed&&this.list.splice(n,1,[i])},e.prototype.getListIndex=function(e){var t=this.getTreeNodeWithListIndex(e),i=t.listIndex,n=t.visible,o=t.revealed;return n&&o?i:-1},e.prototype.getListRenderCount=function(e){return this.getTreeNode(e).renderNodeCount},e.prototype.isCollapsed=function(e){return this.getTreeNode(e).collapsed},e.prototype.setCollapsed=function(e,t,i){var n=this,o=this.getTreeNode(e);return void 0===t&&(t=!o.collapsed),this.eventBufferer.bufferEvents(function(){return n._setCollapsed(e,t,i)})},e.prototype._setCollapsed=function(e,t,i){
var n=this.getTreeNodeWithListIndex(e),o=n.node,r=n.listIndex,s=n.revealed,a=this._setListNodeCollapsed(o,r,s,t,i||!1);if(o!==this.root&&this.autoExpandSingleChildren&&!t&&!i){for(var l=-1,u=0;u<o.children.length;u++){if(o.children[u].visible){if(l>-1){l=-1;break}l=u}}l>-1&&this._setCollapsed(e.concat([l]),!1,!1)}return a},e.prototype._setListNodeCollapsed=function(e,t,i,n,o){var r=this._setNodeCollapsed(e,n,o,!1);if(!i||!e.visible)return r;var s=e.renderNodeCount,a=this.updateNodeAfterCollapseChange(e),l=s-(-1===t?0:1);return this.list.splice(t+1,l,a.slice(1)),r},e.prototype._setNodeCollapsed=function(e,t,i,n){var o=e.collapsible&&e.collapsed!==t;if(e.collapsible&&(e.collapsed=t,o&&this._onDidChangeCollapseState.fire({node:e,deep:n})),i)for(var r=0,s=e.children;r<s.length;r++){var a=s[r];o=this._setNodeCollapsed(a,t,!0,!0)||o}return o},e.prototype.expandTo=function(e){var t=this;this.eventBufferer.bufferEvents(function(){for(var i=t.getTreeNode(e);i.parent;)i=i.parent,e=e.slice(0,e.length-1),
i.collapsed&&t._setCollapsed(e,!1)})},e.prototype.refilter=function(){var e=this.root.renderNodeCount,t=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,t)},e.prototype.createTreeNode=function(e,t,i,n,r,s){var a=this,l={parent:t,element:e.element,children:[],depth:t.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:"boolean"==typeof e.collapsible?e.collapsible:void 0!==e.collapsed,collapsed:void 0===e.collapsed?this.collapseByDefault:e.collapsed,renderNodeCount:1,visible:!0,filterData:void 0},u=this._filterNode(l,i);n&&r.push(l);var d=o.Iterator.from(e.children),c=n&&0!==u&&!l.collapsed,h=o.Iterator.map(d,function(e){return a.createTreeNode(e,l,u,c,r,s)}),p=0,f=1;return o.Iterator.forEach(h,function(e){l.children.push(e),f+=e.renderNodeCount,e.visible&&(e.visibleChildIndex=p++)}),l.collapsible=l.collapsible||l.children.length>0,l.visibleChildrenCount=p,l.visible=2===u?p>0:1===u,l.visible?l.collapsed||(l.renderNodeCount=f):(l.renderNodeCount=0,n&&r.pop()),s&&s(l),l},
e.prototype.updateNodeAfterCollapseChange=function(e){var t=e.renderNodeCount,i=[];return this._updateNodeAfterCollapseChange(e,i),this._updateAncestorsRenderNodeCount(e.parent,i.length-t),i},e.prototype._updateNodeAfterCollapseChange=function(e,t){if(!1===e.visible)return 0;if(t.push(e),e.renderNodeCount=1,!e.collapsed)for(var i=0,n=e.children;i<n.length;i++){var o=n[i];e.renderNodeCount+=this._updateNodeAfterCollapseChange(o,t)}return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount},e.prototype.updateNodeAfterFilterChange=function(e){var t=e.renderNodeCount,i=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,i),this._updateAncestorsRenderNodeCount(e.parent,i.length-t),i},e.prototype._updateNodeAfterFilterChange=function(e,t,i,n){void 0===n&&(n=!0);var o;if(e!==this.root){if(0===(o=this._filterNode(e,t)))return e.visible=!1,!1;n&&i.push(e)}var r=i.length;e.renderNodeCount=e===this.root?0:1;var s=!1;if(e.collapsed&&0===o)e.visibleChildrenCount=0;else{
for(var a=0,l=0,u=e.children;l<u.length;l++){var d=u[l];s=this._updateNodeAfterFilterChange(d,o,i,n&&!e.collapsed)||s,d.visible&&(d.visibleChildIndex=a++)}e.visibleChildrenCount=a}return e!==this.root&&(e.visible=2===o?s:1===o),e.visible?e.collapsed||(e.renderNodeCount+=i.length-r):(e.renderNodeCount=0,n&&i.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible},e.prototype._updateAncestorsRenderNodeCount=function(e,t){if(0!==t)for(;e;)e.renderNodeCount+=t,this._onDidChangeRenderNodeCount.fire(e),e=e.parent},e.prototype._filterNode=function(e,t){var i=this.filter?this.filter.filter(e.element,t):1;return"boolean"==typeof i?(e.filterData=void 0,i?1:0):r(i)?(e.filterData=i.data,s(i.visibility)):(e.filterData=void 0,s(i))},e.prototype.getTreeNode=function(e,t){if(void 0===t&&(t=this.root),!e||0===e.length)return t;var i=e[0],n=e.slice(1);if(i<0||i>t.children.length)throw new Error("Invalid tree location");return this.getTreeNode(n,t.children[i])},e.prototype.getTreeNodeWithListIndex=function(e){
if(0===e.length)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};var t=this.getParentNodeWithListIndex(e),i=t.parentNode,n=t.listIndex,o=t.revealed,r=t.visible,s=e[e.length-1];if(s<0||s>i.children.length)throw new Error("Invalid tree location");var a=i.children[s];return{node:a,listIndex:n,revealed:o,visible:r&&a.visible}},e.prototype.getParentNodeWithListIndex=function(e,t,i,n,o){void 0===t&&(t=this.root),void 0===i&&(i=0),void 0===n&&(n=!0),void 0===o&&(o=!0);var r=e[0],s=e.slice(1);if(r<0||r>t.children.length)throw new Error("Invalid tree location");for(var a=0;a<r;a++)i+=t.children[a].renderNodeCount;return n=n&&!t.collapsed,o=o&&t.visible,0===s.length?{parentNode:t,listIndex:i,revealed:n,visible:o}:this.getParentNodeWithListIndex(s,t.children[r],i+1,n,o)},e.prototype.getNode=function(e){return void 0===e&&(e=[]),this.getTreeNode(e)},e.prototype.getNodeLocation=function(e){for(var t=[];e.parent;)t.push(e.parent.children.indexOf(e)),e=e.parent;return t.reverse()},
e.prototype.getParentNodeLocation=function(e){return e.length<=1?[]:i.tail2(e)[0]},e}();t.IndexTreeModel=l});var s=this&&this.__assign||function(){return(s=Object.assign||function(e){for(var t,i=1,n=arguments.length;i<n;i++){t=arguments[i];for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o])}return e}).apply(this,arguments)};define(t[220],i([1,0,62,222]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t){void 0===t&&(t={}),this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new n.IndexTreeModel(e,null,t),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,t.sorter&&(this.sorter={compare:function(e,i){return t.sorter.compare(e.element,i.element)}}),this.identityProvider=t.identityProvider}return e.prototype.setChildren=function(e,t,i,n){var o=this.getElementLocation(e)
;return this._setChildren(o,this.preserveCollapseState(t),i,n)},e.prototype._setChildren=function(e,t,i,n){var o=this,r=new Set,s=new Set;return this.model.splice(e.concat([0]),Number.MAX_VALUE,t,function(e){if(r.add(e.element),o.nodes.set(e.element,e),o.identityProvider){var t=o.identityProvider.getId(e.element).toString();s.add(t),o.nodesByIdentity.set(t,e)}i&&i(e)},function(e){if(r.has(e.element)||o.nodes.delete(e.element),o.identityProvider){var t=o.identityProvider.getId(e.element).toString();s.has(t)||o.nodesByIdentity.delete(t)}n&&n(e)})},e.prototype.preserveCollapseState=function(e){var t=this,n=e?i.getSequenceIterator(e):i.Iterator.empty();return this.sorter&&(n=i.Iterator.fromArray(i.Iterator.collect(n).sort(this.sorter.compare.bind(this.sorter)))),i.Iterator.map(n,function(e){var i=t.nodes.get(e.element);if(!i&&t.identityProvider){var n=t.identityProvider.getId(e.element).toString();i=t.nodesByIdentity.get(n)}if(!i)return s({},e,{children:t.preserveCollapseState(e.children)})
;var o="boolean"==typeof e.collapsible?e.collapsible:i.collapsible,r=void 0!==e.collapsed?e.collapsed:i.collapsed;return s({},e,{collapsible:o,collapsed:r,children:t.preserveCollapseState(e.children)})})},e.prototype.rerender=function(e){var t=this.getElementLocation(e);this.model.rerender(t)},e.prototype.getListIndex=function(e){var t=this.getElementLocation(e);return this.model.getListIndex(t)},e.prototype.getListRenderCount=function(e){var t=this.getElementLocation(e);return this.model.getListRenderCount(t)},e.prototype.isCollapsed=function(e){var t=this.getElementLocation(e);return this.model.isCollapsed(t)},e.prototype.setCollapsed=function(e,t,i){var n=this.getElementLocation(e);return this.model.setCollapsed(n,t,i)},e.prototype.expandTo=function(e){var t=this.getElementLocation(e);this.model.expandTo(t)},e.prototype.refilter=function(){this.model.refilter()},e.prototype.getNode=function(e){if(void 0===e&&(e=null),null===e)return this.model.getNode(this.model.rootRef);var t=this.nodes.get(e)
;if(!t)throw new Error("Tree element not found: "+e);return t},e.prototype.getNodeLocation=function(e){return e.element},e.prototype.getParentNodeLocation=function(e){if(null===e)throw new Error("Invalid getParentNodeLocation call");var t=this.nodes.get(e);if(!t)throw new Error("Tree element not found: "+e);return t.parent.element},e.prototype.getElementLocation=function(e){if(null===e)return[];var t=this.nodes.get(e);if(!t)throw new Error("Tree element not found: "+e);return this.model.getNodeLocation(t)},e}();t.ObjectTreeModel=o});var a=this&&this.__awaiter||function(e,t,i,n){return new(i||(i=Promise))(function(o,r){function s(e){try{l(n.next(e))}catch(e){r(e)}}function a(e){try{l(n.throw(e))}catch(e){r(e)}}function l(e){e.done?o(e.value):new i(function(t){t(e.value)}).then(s,a)}l((n=n.apply(e,t||[])).next())})},l=this&&this.__generator||function(e,t){function i(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,
o&&(r=2&i[0]?o.return:i[0]?o.throw||((r=o.return)&&r.call(o),0):o.next)&&!(r=r.call(o,i[1])).done)return r;switch(o=0,r&&(i=[2&i[0],r.value]),i[0]){case 0:case 1:r=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,o=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(r=a.trys,!(r=r.length>0&&r[r.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!r||i[1]>r[0]&&i[1]<r[3])){a.label=i[1];break}if(6===i[0]&&a.label<r[1]){a.label=r[1],r=i;break}if(r&&a.label<r[2]){a.label=r[2],a.ops.push(i);break}r[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],o=0}finally{n=r=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}var n,o,r,s,a={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return s={next:i(0),throw:i(1),return:i(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};define(t[58],i([1,0,2,4]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var o=function(e){function t(t,i,o,r,s){void 0===i&&(i=""),void 0===o&&(o=""),void 0===r&&(r=!0);var a=e.call(this)||this;return a._onDidChange=a._register(new n.Emitter),a.onDidChange=a._onDidChange.event,a._enabled=!0,a._checked=!1,a._radio=!1,a._id=t,a._label=i,a._cssClass=o,a._enabled=r,a._actionCallback=s,a}return r(t,e),Object.defineProperty(t.prototype,"id",{get:function(){return this._id},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"label",{get:function(){return this._label},set:function(e){this._setLabel(e)},enumerable:!0,configurable:!0}),t.prototype._setLabel=function(e){this._label!==e&&(this._label=e,this._onDidChange.fire({label:e}))},Object.defineProperty(t.prototype,"tooltip",{get:function(){return this._tooltip||""},set:function(e){this._setTooltip(e)},enumerable:!0,configurable:!0}),t.prototype._setTooltip=function(e){this._tooltip!==e&&(this._tooltip=e,this._onDidChange.fire({tooltip:e}))},Object.defineProperty(t.prototype,"class",{get:function(){return this._cssClass
},set:function(e){this._setClass(e)},enumerable:!0,configurable:!0}),t.prototype._setClass=function(e){this._cssClass!==e&&(this._cssClass=e,this._onDidChange.fire({class:e}))},Object.defineProperty(t.prototype,"enabled",{get:function(){return this._enabled},set:function(e){this._setEnabled(e)},enumerable:!0,configurable:!0}),t.prototype._setEnabled=function(e){this._enabled!==e&&(this._enabled=e,this._onDidChange.fire({enabled:e}))},Object.defineProperty(t.prototype,"checked",{get:function(){return this._checked},set:function(e){this._setChecked(e)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"radio",{get:function(){return this._radio},set:function(e){this._setRadio(e)},enumerable:!0,configurable:!0}),t.prototype._setChecked=function(e){this._checked!==e&&(this._checked=e,this._onDidChange.fire({checked:e}))},t.prototype._setRadio=function(e){this._radio!==e&&(this._radio=e,this._onDidChange.fire({radio:e}))},t.prototype.run=function(e,t){
return this._actionCallback?this._actionCallback(e):Promise.resolve(!0)},t}(i.Disposable);t.Action=o;var s=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._onDidBeforeRun=t._register(new n.Emitter),t.onDidBeforeRun=t._onDidBeforeRun.event,t._onDidRun=t._register(new n.Emitter),t.onDidRun=t._onDidRun.event,t}return r(t,e),t.prototype.run=function(e,t){return a(this,void 0,void 0,function(){var i,n;return l(this,function(o){switch(o.label){case 0:if(!e.enabled)return[2,Promise.resolve(null)];this._onDidBeforeRun.fire({action:e}),o.label=1;case 1:return o.trys.push([1,3,,4]),[4,this.runAction(e,t)];case 2:return i=o.sent(),this._onDidRun.fire({action:e,result:i}),[3,4];case 3:return n=o.sent(),this._onDidRun.fire({action:e,error:n}),[3,4];case 4:return[2]}})})},t.prototype.runAction=function(e,t){var i=t?e.run(t):e.run();return Promise.resolve(i)},t}(i.Disposable);t.ActionRunner=s}),define(t[26],i([1,0,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0
});var n,o=Object.freeze(function(e,t){var i=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(i)}}});!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||t instanceof r||!(!t||"object"!=typeof t)&&"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})}(n=t.CancellationToken||(t.CancellationToken={}));var r=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){
return this._isCancelled?o:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),s=function(){function e(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new r),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof r&&this._token.cancel():this._token=n.Cancelled},e.prototype.dispose=function(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof r&&this._token.dispose():this._token=n.None},e}();t.CancellationTokenSource=s}),define(t[15],i([1,0,26,10,2]),function(e,t,i,n,o){"use strict";function r(e){var t=new i.CancellationTokenSource,o=e(t.token),r=new Promise(function(e,i){
t.token.onCancellationRequested(function(){i(n.canceled())}),Promise.resolve(o).then(function(i){t.dispose(),e(i)},function(e){t.dispose(),i(e)})});return new(function(){function e(){}return e.prototype.cancel=function(){t.cancel()},e.prototype.then=function(e,t){return r.then(e,t)},e.prototype.catch=function(e){return this.then(void 0,e)},e.prototype.finally=function(e){return r.finally(e)},e}())}function s(e,t){return t?new Promise(function(i,o){var r=setTimeout(i,e);t.onCancellationRequested(function(){clearTimeout(r),o(n.canceled())})}):r(function(t){return s(e,t)})}Object.defineProperty(t,"__esModule",{value:!0}),t.isThenable=function(e){return e&&"function"==typeof e.then},t.createCancelablePromise=r,t.raceCancellation=function(e,t,i){return Promise.race([e,new Promise(function(e){return t.onCancellationRequested(function(){return e(i)})})])};var a=function(){function e(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}
return e.prototype.trigger=function(e,t){var i=this;return void 0===t&&(t=this.defaultDelay),this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(function(e,t){i.doResolve=e,i.doReject=t}).then(function(){i.completionPromise=null,i.doResolve=null;var e=i.task;return i.task=null,e()})),this.timeout=setTimeout(function(){i.timeout=null,i.doResolve(null)},t),this.completionPromise},e.prototype.isTriggered=function(){return null!==this.timeout},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.doReject(n.canceled()),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e.prototype.dispose=function(){this.cancelTimeout()},e}();t.Delayer=a,t.timeout=s,t.disposableTimeout=function(e,t){void 0===t&&(t=0);var i=setTimeout(e,t);return o.toDisposable(function(){return clearTimeout(i)})},t.first=function(e,t,i){void 0===t&&(t=function(e){return!!e}),void 0===i&&(i=null)
;var n=0,o=e.length,r=function(){if(n>=o)return Promise.resolve(i);var s=e[n++];return Promise.resolve(s()).then(function(e){return t(e)?Promise.resolve(e):r()})};return r()};var l=function(){function e(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}return e.prototype.dispose=function(){this.cancel()},e.prototype.cancel=function(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)},e.prototype.cancelAndSet=function(e,t){var i=this;this.cancel(),this._token=setTimeout(function(){i._token=-1,e()},t)},e.prototype.setIfNotSet=function(e,t){var i=this;-1===this._token&&(this._token=setTimeout(function(){i._token=-1,e()},t))},e}();t.TimeoutTimer=l;var u=function(){function e(){this._token=-1}return e.prototype.dispose=function(){this.cancel()},e.prototype.cancel=function(){-1!==this._token&&(clearInterval(this._token),this._token=-1)},e.prototype.cancelAndSet=function(e,t){this.cancel(),this._token=setInterval(function(){e()},t)},e}();t.IntervalTimer=u
;var d=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.schedule=function(e){void 0===e&&(e=this.timeout),this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)},e.prototype.isScheduled=function(){return-1!==this.timeoutToken},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.doRun()},e.prototype.doRun=function(){this.runner&&this.runner()},e}();t.RunOnceScheduler=d,function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){var e=Object.freeze({didTimeout:!0,timeRemaining:function(){return 15}});t.runWhenIdle=function(t){var i=setTimeout(function(){return t(e)}),n=!1;return{dispose:function(){n||(n=!0,clearTimeout(i))}}}}else t.runWhenIdle=function(e,t){
var i=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0),n=!1;return{dispose:function(){n||(n=!0,cancelIdleCallback(i))}}}}();var c=function(){function e(e){var i=this;this._didRun=!1,this._executor=function(){try{i._value=e()}catch(e){i._error=e}finally{i._didRun=!0}},this._handle=t.runWhenIdle(function(){return i._executor()})}return e.prototype.dispose=function(){this._handle.dispose()},e.prototype.getValue=function(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value},e}();t.IdleValue=c}),define(t[541],i([1,0,15,2]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t,n,o){var r=e.call(this)||this;return r._visibility=t,r._visibleClassName=n,r._invisibleClassName=o,r._domNode=null,r._isVisible=!1,r._isNeeded=!1,r._shouldBeVisible=!1,r._revealTimer=r._register(new i.TimeoutTimer),r}return r(t,e),t.prototype.applyVisibilitySetting=function(e){
return 2!==this._visibility&&(3===this._visibility||e)},t.prototype.setShouldBeVisible=function(e){var t=this.applyVisibilitySetting(e);this._shouldBeVisible!==t&&(this._shouldBeVisible=t,this.ensureVisibility())},t.prototype.setIsNeeded=function(e){this._isNeeded!==e&&(this._isNeeded=e,this.ensureVisibility())},t.prototype.setDomNode=function(e){this._domNode=e,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)},t.prototype.ensureVisibility=function(){this._isNeeded?this._shouldBeVisible?this._reveal():this._hide(!0):this._hide(!1)},t.prototype._reveal=function(){var e=this;this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(function(){e._domNode&&e._domNode.setClassName(e._visibleClassName)},0))},t.prototype._hide=function(e){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode&&this._domNode.setClassName(this._invisibleClassName+(e?" fade":"")))},t}(n.Disposable);t.ScrollbarVisibilityController=o}),define(t[41],i([1,0]),function(e,t){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.values=function(e){var t=[];return e.forEach(function(e){return t.push(e)}),t},t.keys=function(e){var t=[];return e.forEach(function(e,i){return t.push(i)}),t};var i=function(){function e(){this._value="",this._pos=0}return e.prototype.reset=function(e){return this._value=e,this._pos=0,this},e.prototype.next=function(){return this._pos+=1,this},e.prototype.hasNext=function(){return this._pos<this._value.length-1},e.prototype.cmp=function(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)},e.prototype.value=function(){return this._value[this._pos]},e}();t.StringIterator=i;var n=function(){function e(){}return e.prototype.reset=function(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()},e.prototype.hasNext=function(){return this._to<this._value.length},e.prototype.next=function(){this._from=this._to;for(var e=!0;this._to<this._value.length;this._to++){var t=this._value.charCodeAt(this._to)
;if(47===t||92===t){if(!e)break;this._from++}else e=!1}return this},e.prototype.cmp=function(e){for(var t=0,i=e.length,n=this._from;t<i&&n<this._to;){var o=e.charCodeAt(t)-this._value.charCodeAt(n);if(0!==o)return o;t+=1,n+=1}return i===this._to-this._from?0:t<i?-1:1},e.prototype.value=function(){return this._value.substring(this._from,this._to)},e}();t.PathIterator=n;var o=function(){return function(){}}(),s=function(){function e(e){this._iter=e}return e.forPaths=function(){return new e(new n)},e.forStrings=function(){return new e(new i)},e.prototype.clear=function(){this._root=void 0},e.prototype.set=function(e,t){var i,n=this._iter.reset(e);for(this._root||(this._root=new o,this._root.segment=n.value()),i=this._root;;){var r=n.cmp(i.segment);if(r>0)i.left||(i.left=new o,i.left.segment=n.value()),i=i.left;else if(r<0)i.right||(i.right=new o,i.right.segment=n.value()),i=i.right;else{if(!n.hasNext())break;n.next(),i.mid||(i.mid=new o,i.mid.segment=n.value()),i=i.mid}}var s=i.value;return i.value=t,i.key=e,s},
e.prototype.get=function(e){for(var t=this._iter.reset(e),i=this._root;i;){var n=t.cmp(i.segment);if(n>0)i=i.left;else if(n<0)i=i.right;else{if(!t.hasNext())break;t.next(),i=i.mid}}return i?i.value:void 0},e.prototype.findSubstr=function(e){for(var t=this._iter.reset(e),i=this._root,n=void 0;i;){var o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else{if(!t.hasNext())break;t.next(),n=i.value||n,i=i.mid}}return i&&i.value||n},e.prototype.forEach=function(e){this._forEach(this._root,e)},e.prototype._forEach=function(e,t){e&&(this._forEach(e.left,t),e.value&&t(e.value,e.key),this._forEach(e.mid,t),this._forEach(e.right,t))},e}();t.TernarySearchTree=s;var a=function(){function e(){this.map=new Map,this.ignoreCase=!1}return e.prototype.set=function(e,t){this.map.set(this.toKey(e),t)},e.prototype.get=function(e){return this.map.get(this.toKey(e))},e.prototype.toKey=function(e){var t=e.toString();return this.ignoreCase&&(t=t.toLowerCase()),t},e}();t.ResourceMap=a;var l=function(){function e(){
this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0}return e.prototype.clear=function(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0},Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.get=function(e,t){void 0===t&&(t=0);var i=this._map.get(e);if(i)return 0!==t&&this.touch(i,t),i.value},e.prototype.set=function(e,t,i){void 0===i&&(i=0);var n=this._map.get(e);if(n)n.value=t,0!==i&&this.touch(n,i);else{switch(n={key:e,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:default:this.addItemLast(n)}this._map.set(e,n),this._size++}},e.prototype.delete=function(e){return!!this.remove(e)},e.prototype.remove=function(e){var t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value},e.prototype.forEach=function(e,t){for(var i=this._head;i;)t?e.bind(t)(i.value,i.key,this):e(i.value,i.key,this),i=i.next},
e.prototype.trimOld=function(e){if(!(e>=this.size))if(0!==e){for(var t=this._head,i=this.size;t&&i>e;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0)}else this.clear()},e.prototype.addItemFirst=function(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e},e.prototype.addItemLast=function(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e},e.prototype.removeItem=function(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{var t=e.next,i=e.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}e.next=void 0,
e.previous=void 0},e.prototype.touch=function(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;var i=e.next,n=e.previous;e===this._tail?(n.next=void 0,this._tail=n):(i.previous=n,n.next=i),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e}else if(2===t){if(e===this._tail)return;var i=e.next,n=e.previous;e===this._head?(i.previous=void 0,this._head=i):(i.previous=n,n.next=i),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e}},e.prototype.toJSON=function(){var e=[];return this.forEach(function(t,i){e.push([i,t])}),e},e}();t.LinkedMap=l;var u=function(e){function t(t,i){void 0===i&&(i=1);var n=e.call(this)||this;return n._limit=t,n._ratio=Math.min(Math.max(0,i),1),n}return r(t,e),t.prototype.get=function(t){return e.prototype.get.call(this,t,2)},t.prototype.peek=function(t){return e.prototype.get.call(this,t,0)},t.prototype.set=function(t,i){e.prototype.set.call(this,t,i,2),this.checkTrim()},
t.prototype.checkTrim=function(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))},t}(l);t.LRUCache=u});/**
 * marked - a markdown parser
 * Copyright (c) 2011-2014, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/markedjs/marked
 */
var u;(function(e){"use strict";function t(e){this.tokens=[],this.tokens.links=Object.create(null),this.options=e||m.defaults,this.rules=v.normal,this.options.pedantic?this.rules=v.pedantic:this.options.gfm&&(this.options.tables?this.rules=v.tables:this.rules=v.gfm)}function i(e,t){if(this.options=t||m.defaults,this.links=e,this.rules=_.normal,this.renderer=this.options.renderer||new n,this.renderer.options=this.options,!this.links)throw new Error("Tokens array requires a `links` property.");this.options.pedantic?this.rules=_.pedantic:this.options.gfm&&(this.options.breaks?this.rules=_.breaks:this.rules=_.gfm)}function n(e){this.options=e||m.defaults}function o(){}function r(e){this.tokens=[],this.token=null,this.options=e||m.defaults,this.options.renderer=this.options.renderer||new n,this.renderer=this.options.renderer,this.renderer.options=this.options,this.slugger=new s}function s(){this.seen={}}function a(e,t){if(t){if(a.escapeTest.test(e))return e.replace(a.escapeReplace,function(e){
return a.replacements[e]})}else if(a.escapeTestNoEncode.test(e))return e.replace(a.escapeReplaceNoEncode,function(e){return a.replacements[e]});return e}function l(e){return e.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/gi,function(e,t){return"colon"===(t=t.toLowerCase())?":":"#"===t.charAt(0)?"x"===t.charAt(1)?String.fromCharCode(parseInt(t.substring(2),16)):String.fromCharCode(+t.substring(1)):""})}function d(e,t){return e=e.source||e,t=t||"",{replace:function(t,i){return i=i.source||i,i=i.replace(/(^|[^\[])\^/g,"$1"),e=e.replace(t,i),this},getRegex:function(){return new RegExp(e,t)}}}function c(e,t,i){if(e){try{var n=decodeURIComponent(l(i)).replace(/[^\w:]/g,"").toLowerCase()}catch(e){return null}if(0===n.indexOf("javascript:")||0===n.indexOf("vbscript:")||0===n.indexOf("data:"))return null}t&&!b.test(i)&&(i=function(e,t){y[" "+e]||(/^[^:]+:\/*[^/]*$/.test(e)?y[" "+e]=e+"/":y[" "+e]=g(e,"/",!0));return e=y[" "+e],
"//"===t.slice(0,2)?e.replace(/:[\s\S]*/,":")+t:"/"===t.charAt(0)?e.replace(/(:\/*[^/]*)[\s\S]*/,"$1")+t:e+t}(t,i));try{i=encodeURI(i).replace(/%25/g,"%")}catch(e){return null}return i}function h(){}function p(e){for(var t,i,n=1;n<arguments.length;n++){t=arguments[n];for(i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i])}return e}function f(e,t){var i=e.replace(/\|/g,function(e,t,i){for(var n=!1,o=t;--o>=0&&"\\"===i[o];)n=!n;return n?"|":" |"}).split(/ \|/),n=0;if(i.length>t)i.splice(t);else for(;i.length<t;)i.push("");for(;n<i.length;n++)i[n]=i[n].trim().replace(/\\\|/g,"|");return i}function g(e,t,i){if(0===e.length)return"";for(var n=0;n<e.length;){var o=e.charAt(e.length-n-1);if(o!==t||i){if(o===t||!i)break;n++}else n++}return e.substr(0,e.length-n)}function m(e,i,n){if(void 0===e||null===e)throw new Error("marked(): input parameter is undefined or null");if("string"!=typeof e)throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(e)+", string expected")
;if(n||"function"==typeof i){n||(n=i,i=null);var o,s,l=(i=p({},m.defaults,i||{})).highlight,u=0;try{o=t.lex(e,i)}catch(e){return n(e)}s=o.length;var d=function(e){if(e)return i.highlight=l,n(e);var t;try{t=r.parse(o,i)}catch(t){e=t}return i.highlight=l,e?n(e):n(null,t)};if(!l||l.length<3)return d();if(delete i.highlight,!s)return d();for(;u<o.length;u++)!function(e){"code"!==e.type?--s||d():l(e.text,e.lang,function(t,i){return t?d(t):null==i||i===e.text?--s||d():(e.text=i,e.escaped=!0,void(--s||d()))})}(o[u])}else try{return i&&(i=p({},m.defaults,i)),r.parse(t.lex(e,i),i)}catch(e){if(e.message+="\nPlease report this to https://github.com/markedjs/marked.",(i||m.defaults).silent)return"<p>An error occurred:</p><pre>"+a(e.message+"",!0)+"</pre>";throw e}}var v={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:h,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,nptable:h,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,
list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?\\?>\\n*|<![A-Z][\\s\\S]*?>\\n*|<!\\[CDATA\\[[\\s\\S]*?\\]\\]>\\n*|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading| {0,3}>|<\/?(?:tag)(?: +|\n|\/?>)|<(?:script|pre|style|!--))[^\n]+)*)/,text:/^[^\n]+/};v._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,v._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,v.def=d(v.def).replace("label",v._label).replace("title",v._title).getRegex(),v.bullet=/(?:[*+-]|\d{1,9}\.)/,
v.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,v.item=d(v.item,"gm").replace(/bull/g,v.bullet).getRegex(),v.list=d(v.list).replace(/bull/g,v.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+v.def.source+")").getRegex(),v._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",v._comment=/<!--(?!-?>)[\s\S]*?-->/,v.html=d(v.html,"i").replace("comment",v._comment).replace("tag",v._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),v.paragraph=d(v.paragraph).replace("hr",v.hr).replace("heading",v.heading).replace("lheading",v.lheading).replace("tag",v._tag).getRegex(),
v.blockquote=d(v.blockquote).replace("paragraph",v.paragraph).getRegex(),v.normal=p({},v),v.gfm=p({},v.normal,{fences:/^ {0,3}(`{3,}|~{3,})([^`\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/}),v.gfm.paragraph=d(v.paragraph).replace("(?!","(?!"+v.gfm.fences.source.replace("\\1","\\2")+"|"+v.list.source.replace("\\1","\\3")+"|").getRegex(),v.tables=p({},v.gfm,{nptable:/^ *([^|\n ].*\|.*)\n *([-:]+ *\|[-| :]*)(?:\n((?:.*[^>\n ].*(?:\n|$))*)\n*|$)/,table:/^ *\|(.+)\n *\|?( *[-:]+[-| :]*)(?:\n((?: *[^>\n ].*(?:\n|$))*)\n*|$)/}),v.pedantic=p({},v.normal,{html:d("^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:\"[^\"]*\"|'[^']*'|\\s[^'\"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))").replace("comment",v._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),
def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/}),t.rules=v,t.lex=function(e,i){return new t(i).lex(e)},t.prototype.lex=function(e){return e=e.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n"),this.token(e,!0)},t.prototype.token=function(e,t){e=e.replace(/^ +$/gm,"");for(var i,n,o,r,s,a,l,u,d,c,h,p,m,_,y,b;e;)if((o=this.rules.newline.exec(e))&&(e=e.substring(o[0].length),o[0].length>1&&this.tokens.push({type:"space"})),o=this.rules.code.exec(e))e=e.substring(o[0].length),o=o[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?o:g(o,"\n")});else if(o=this.rules.fences.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"code",lang:o[2]?o[2].trim():o[2],text:o[3]||""});else if(o=this.rules.heading.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"heading",depth:o[1].length,text:o[2]});else if((o=this.rules.nptable.exec(e))&&(a={type:"table",header:f(o[1].replace(/^ *| *\| *$/g,"")),
align:o[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:o[3]?o[3].replace(/\n$/,"").split("\n"):[]}).header.length===a.align.length){for(e=e.substring(o[0].length),h=0;h<a.align.length;h++)/^ *-+: *$/.test(a.align[h])?a.align[h]="right":/^ *:-+: *$/.test(a.align[h])?a.align[h]="center":/^ *:-+ *$/.test(a.align[h])?a.align[h]="left":a.align[h]=null;for(h=0;h<a.cells.length;h++)a.cells[h]=f(a.cells[h],a.header.length);this.tokens.push(a)}else if(o=this.rules.hr.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"hr"});else if(o=this.rules.blockquote.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"blockquote_start"}),o=o[0].replace(/^ *> ?/gm,""),this.token(o,t),this.tokens.push({type:"blockquote_end"});else if(o=this.rules.list.exec(e)){for(e=e.substring(o[0].length),l={type:"list_start",ordered:_=(r=o[2]).length>1,start:_?+r:"",loose:!1},this.tokens.push(l),u=[],i=!1,m=(o=o[0].match(this.rules.item)).length,h=0;h<m;h++)c=(a=o[h]).length,
~(a=a.replace(/^ *([*+-]|\d+\.) */,"")).indexOf("\n ")&&(c-=a.length,a=this.options.pedantic?a.replace(/^ {1,4}/gm,""):a.replace(new RegExp("^ {1,"+c+"}","gm"),"")),h!==m-1&&(s=v.bullet.exec(o[h+1])[0],(r.length>1?1===s.length:s.length>1||this.options.smartLists&&s!==r)&&(e=o.slice(h+1).join("\n")+e,h=m-1)),n=i||/\n\n(?!\s*$)/.test(a),h!==m-1&&(i="\n"===a.charAt(a.length-1),n||(n=i)),n&&(l.loose=!0),b=void 0,(y=/^\[[ xX]\] /.test(a))&&(b=" "!==a[1],a=a.replace(/^\[[ xX]\] +/,"")),d={type:"list_item_start",task:y,checked:b,loose:n},u.push(d),this.tokens.push(d),this.token(a,!1),this.tokens.push({type:"list_item_end"});if(l.loose)for(m=u.length,h=0;h<m;h++)u[h].loose=!0;this.tokens.push({type:"list_end"})}else if(o=this.rules.html.exec(e))e=e.substring(o[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&("pre"===o[1]||"script"===o[1]||"style"===o[1]),text:o[0]});else if(t&&(o=this.rules.def.exec(e)))e=e.substring(o[0].length),
o[3]&&(o[3]=o[3].substring(1,o[3].length-1)),p=o[1].toLowerCase().replace(/\s+/g," "),this.tokens.links[p]||(this.tokens.links[p]={href:o[2],title:o[3]});else if((o=this.rules.table.exec(e))&&(a={type:"table",header:f(o[1].replace(/^ *| *\| *$/g,"")),align:o[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:o[3]?o[3].replace(/\n$/,"").split("\n"):[]}).header.length===a.align.length){for(e=e.substring(o[0].length),h=0;h<a.align.length;h++)/^ *-+: *$/.test(a.align[h])?a.align[h]="right":/^ *:-+: *$/.test(a.align[h])?a.align[h]="center":/^ *:-+ *$/.test(a.align[h])?a.align[h]="left":a.align[h]=null;for(h=0;h<a.cells.length;h++)a.cells[h]=f(a.cells[h].replace(/^ *\| *| *\| *$/g,""),a.header.length);this.tokens.push(a)}else if(o=this.rules.lheading.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"heading",depth:"="===o[2]?1:2,text:o[1]});else if(t&&(o=this.rules.paragraph.exec(e)))e=e.substring(o[0].length),this.tokens.push({type:"paragraph",text:"\n"===o[1].charAt(o[1].length-1)?o[1].slice(0,-1):o[1]
});else if(o=this.rules.text.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"text",text:o[0]});else if(e)throw new Error("Infinite loop on byte: "+e.charCodeAt(0));return this.tokens};var _={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(href(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,strong:/^__([^\s_])__(?!_)|^\*\*([^\s*])\*\*(?!\*)|^__([^\s][\s\S]*?[^\s])__(?!_)|^\*\*([^\s][\s\S]*?[^\s])\*\*(?!\*)/,em:/^_([^\s_])_(?!_)|^\*([^\s*"<\[])\*(?!\*)|^_([^\s][\s\S]*?[^\s_])_(?!_|[^\spunctuation])|^_([^\s_][\s\S]*?[^\s])_(?!_|[^\spunctuation])|^\*([^\s"<\[][\s\S]*?[^\s*])\*(?!\*)|^\*([^\s*"<\[][\s\S]*?[^\s])\*(?!\*)/,
code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n))|(?= {2,}\n))/};_._punctuation="!\"#$%&'()*+,\\-./:;<=>?@\\[^_{|}~",_.em=d(_.em).replace(/punctuation/g,_._punctuation).getRegex(),_._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,_._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,_._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,_.autolink=d(_.autolink).replace("scheme",_._scheme).replace("email",_._email).getRegex(),_._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,_.tag=d(_.tag).replace("comment",v._comment).replace("attribute",_._attribute).getRegex(),_._label=/(?:\[[^\[\]]*\]|\\[\[\]]?|`[^`]*`|`(?!`)|[^\[\]\\`])*?/,_._href=/\s*(<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*)/,_._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,
_.link=d(_.link).replace("label",_._label).replace("href",_._href).replace("title",_._title).getRegex(),_.reflink=d(_.reflink).replace("label",_._label).getRegex(),_.normal=p({},_),_.pedantic=p({},_.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/,link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",_._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",_._label).getRegex()}),_.gfm=p({},_.normal,{escape:d(_.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,
text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?= {2,}\n|[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),_.gfm.url=d(_.gfm.url,"i").replace("email",_.gfm._extended_email).getRegex(),_.breaks=p({},_.gfm,{br:d(_.br).replace("{2,}","*").getRegex(),text:d(_.gfm.text).replace(/\{2,\}/g,"*").getRegex()}),i.rules=_,i.output=function(e,t,n){return new i(t,n).output(e)},i.prototype.output=function(e){for(var t,n,o,r,s,l,u="";e;)if(s=this.rules.escape.exec(e))e=e.substring(s[0].length),u+=a(s[1]);else if(s=this.rules.tag.exec(e))!this.inLink&&/^<a /i.test(s[0])?this.inLink=!0:this.inLink&&/^<\/a>/i.test(s[0])&&(this.inLink=!1),!this.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(s[0])?this.inRawBlock=!0:this.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(s[0])&&(this.inRawBlock=!1),e=e.substring(s[0].length),
u+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(s[0]):a(s[0]):s[0];else if(s=this.rules.link.exec(e)){var d=function(e,t){if(-1===e.indexOf(t[1]))return-1;for(var i=0,n=0;n<e.length;n++)if("\\"===e[n])n++;else if(e[n]===t[0])i++;else if(e[n]===t[1]&&--i<0)return n;return-1}(s[2],"()");if(d>-1){var c=s[0].length-(s[2].length-d)-(s[3]||"").length;s[2]=s[2].substring(0,d),s[0]=s[0].substring(0,c).trim(),s[3]=""}e=e.substring(s[0].length),this.inLink=!0,o=s[2],this.options.pedantic?(t=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(o))?(o=t[1],r=t[3]):r="":r=s[3]?s[3].slice(1,-1):"",o=o.trim().replace(/^<([\s\S]*)>$/,"$1"),u+=this.outputLink(s,{href:i.escapes(o),title:i.escapes(r)}),this.inLink=!1}else if((s=this.rules.reflink.exec(e))||(s=this.rules.nolink.exec(e))){if(e=e.substring(s[0].length),t=(s[2]||s[1]).replace(/\s+/g," "),!(t=this.links[t.toLowerCase()])||!t.href){u+=s[0].charAt(0),e=s[0].substring(1)+e;continue}this.inLink=!0,u+=this.outputLink(s,t),this.inLink=!1
}else if(s=this.rules.strong.exec(e))e=e.substring(s[0].length),u+=this.renderer.strong(this.output(s[4]||s[3]||s[2]||s[1]));else if(s=this.rules.em.exec(e))e=e.substring(s[0].length),u+=this.renderer.em(this.output(s[6]||s[5]||s[4]||s[3]||s[2]||s[1]));else if(s=this.rules.code.exec(e))e=e.substring(s[0].length),u+=this.renderer.codespan(a(s[2].trim(),!0));else if(s=this.rules.br.exec(e))e=e.substring(s[0].length),u+=this.renderer.br();else if(s=this.rules.del.exec(e))e=e.substring(s[0].length),u+=this.renderer.del(this.output(s[1]));else if(s=this.rules.autolink.exec(e))e=e.substring(s[0].length),o="@"===s[2]?"mailto:"+(n=a(this.mangle(s[1]))):n=a(s[1]),u+=this.renderer.link(o,null,n);else if(this.inLink||!(s=this.rules.url.exec(e))){if(s=this.rules.text.exec(e))e=e.substring(s[0].length),this.inRawBlock?u+=this.renderer.text(s[0]):u+=this.renderer.text(a(this.smartypants(s[0])));else if(e)throw new Error("Infinite loop on byte: "+e.charCodeAt(0))}else{if("@"===s[2])o="mailto:"+(n=a(s[0]));else{do{l=s[0],
s[0]=this.rules._backpedal.exec(s[0])[0]}while(l!==s[0]);n=a(s[0]),o="www."===s[1]?"http://"+n:n}e=e.substring(s[0].length),u+=this.renderer.link(o,null,n)}return u},i.escapes=function(e){return e?e.replace(i.rules._escapes,"$1"):e},i.prototype.outputLink=function(e,t){var i=t.href,n=t.title?a(t.title):null;return"!"!==e[0].charAt(0)?this.renderer.link(i,n,this.output(e[1])):this.renderer.image(i,n,a(e[1]))},i.prototype.smartypants=function(e){return this.options.smartypants?e.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…"):e},i.prototype.mangle=function(e){if(!this.options.mangle)return e;for(var t,i="",n=e.length,o=0;o<n;o++)t=e.charCodeAt(o),Math.random()>.5&&(t="x"+t.toString(16)),i+="&#"+t+";";return i},n.prototype.code=function(e,t,i){var n=(t||"").match(/\S*/)[0];if(this.options.highlight){var o=this.options.highlight(e,n);null!=o&&o!==e&&(i=!0,e=o)}
return n?'<pre><code class="'+this.options.langPrefix+a(n,!0)+'">'+(i?e:a(e,!0))+"</code></pre>\n":"<pre><code>"+(i?e:a(e,!0))+"</code></pre>"},n.prototype.blockquote=function(e){return"<blockquote>\n"+e+"</blockquote>\n"},n.prototype.html=function(e){return e},n.prototype.heading=function(e,t,i,n){return this.options.headerIds?"<h"+t+' id="'+this.options.headerPrefix+n.slug(i)+'">'+e+"</h"+t+">\n":"<h"+t+">"+e+"</h"+t+">\n"},n.prototype.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"},n.prototype.list=function(e,t,i){var n=t?"ol":"ul";return"<"+n+(t&&1!==i?' start="'+i+'"':"")+">\n"+e+"</"+n+">\n"},n.prototype.listitem=function(e){return"<li>"+e+"</li>\n"},n.prototype.checkbox=function(e){return"<input "+(e?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},n.prototype.paragraph=function(e){return"<p>"+e+"</p>\n"},n.prototype.table=function(e,t){return t&&(t="<tbody>"+t+"</tbody>"),"<table>\n<thead>\n"+e+"</thead>\n"+t+"</table>\n"},n.prototype.tablerow=function(e){
return"<tr>\n"+e+"</tr>\n"},n.prototype.tablecell=function(e,t){var i=t.header?"th":"td";return(t.align?"<"+i+' align="'+t.align+'">':"<"+i+">")+e+"</"+i+">\n"},n.prototype.strong=function(e){return"<strong>"+e+"</strong>"},n.prototype.em=function(e){return"<em>"+e+"</em>"},n.prototype.codespan=function(e){return"<code>"+e+"</code>"},n.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"},n.prototype.del=function(e){return"<del>"+e+"</del>"},n.prototype.link=function(e,t,i){if(null===(e=c(this.options.sanitize,this.options.baseUrl,e)))return i;var n='<a href="'+a(e)+'"';return t&&(n+=' title="'+t+'"'),n+=">"+i+"</a>"},n.prototype.image=function(e,t,i){if(null===(e=c(this.options.sanitize,this.options.baseUrl,e)))return i;var n='<img src="'+e+'" alt="'+i+'"';return t&&(n+=' title="'+t+'"'),n+=this.options.xhtml?"/>":">"},n.prototype.text=function(e){return e},o.prototype.strong=o.prototype.em=o.prototype.codespan=o.prototype.del=o.prototype.text=function(e){return e},
o.prototype.link=o.prototype.image=function(e,t,i){return""+i},o.prototype.br=function(){return""},r.parse=function(e,t){return new r(t).parse(e)},r.prototype.parse=function(e){this.inline=new i(e.links,this.options),this.inlineText=new i(e.links,p({},this.options,{renderer:new o})),this.tokens=e.reverse();for(var t="";this.next();)t+=this.tok();return t},r.prototype.next=function(){return this.token=this.tokens.pop()},r.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0},r.prototype.parseText=function(){for(var e=this.token.text;"text"===this.peek().type;)e+="\n"+this.next().text;return this.inline.output(e)},r.prototype.tok=function(){switch(this.token.type){case"space":return"";case"hr":return this.renderer.hr();case"heading":return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,l(this.inlineText.output(this.token.text)),this.slugger);case"code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case"table":var e,t,i,n,o="",r=""
;for(i="",e=0;e<this.token.header.length;e++)i+=this.renderer.tablecell(this.inline.output(this.token.header[e]),{header:!0,align:this.token.align[e]});for(o+=this.renderer.tablerow(i),e=0;e<this.token.cells.length;e++){for(t=this.token.cells[e],i="",n=0;n<t.length;n++)i+=this.renderer.tablecell(this.inline.output(t[n]),{header:!1,align:this.token.align[n]});r+=this.renderer.tablerow(i)}return this.renderer.table(o,r);case"blockquote_start":for(r="";"blockquote_end"!==this.next().type;)r+=this.tok();return this.renderer.blockquote(r);case"list_start":r="";for(var s=this.token.ordered,a=this.token.start;"list_end"!==this.next().type;)r+=this.tok();return this.renderer.list(r,s,a);case"list_item_start":r="";var u=this.token.loose,d=this.token.checked,c=this.token.task;for(this.token.task&&(r+=this.renderer.checkbox(d));"list_item_end"!==this.next().type;)r+=u||"text"!==this.token.type?this.tok():this.parseText();return this.renderer.listitem(r,c,d);case"html":return this.renderer.html(this.token.text)
;case"paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case"text":return this.renderer.paragraph(this.parseText());default:var h='Token with "'+this.token.type+'" type was not found.';if(!this.options.silent)throw new Error(h);console.log(h)}},s.prototype.slug=function(e){var t=e.toLowerCase().trim().replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-");if(this.seen.hasOwnProperty(t)){var i=t;do{this.seen[i]++,t=i+"-"+this.seen[i]}while(this.seen.hasOwnProperty(t))}return this.seen[t]=0,t},a.escapeTest=/[&<>"']/,a.escapeReplace=/[&<>"']/g,a.replacements={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a.escapeTestNoEncode=/[<>"']|&(?!#?\w+;)/,a.escapeReplaceNoEncode=/[<>"']|&(?!#?\w+;)/g;var y={},b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;h.exec=h,m.options=m.setOptions=function(e){return p(m.defaults,e),m},m.getDefaults=function(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",
mangle:!0,pedantic:!1,renderer:new n,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tables:!0,xhtml:!1}},m.defaults=m.getDefaults(),m.Parser=r,m.parser=r.parse,m.Renderer=n,m.TextRenderer=o,m.Lexer=t,m.lexer=t.lex,m.InlineLexer=i,m.inlineLexer=i.output,m.Slugger=s,m.parse=m,u=m}).call(this),define("vs/base/common/marked/marked",function(){return u}),define(t[159],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.clamp=function(e,t,i){return Math.min(Math.max(e,t),i)}}),define(t[18],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=!1,n=!1,o=!1,r=!1,s=!1,a=void 0,l="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||l){if("object"==typeof process){i="win32"===process.platform,n="darwin"===process.platform,o="linux"===process.platform,"en","en";var u=process.env.VSCODE_NLS_CONFIG;if(u)try{
var d=JSON.parse(u),c=d.availableLanguages["*"];d.locale,c||"en",d._translationsConfigFile}catch(e){}r=!0}}else i=(a=navigator.userAgent).indexOf("Windows")>=0,n=a.indexOf("Macintosh")>=0,o=a.indexOf("Linux")>=0,s=!0,navigator.language;t.isWindows=i,t.isMacintosh=n,t.isLinux=o,t.isNative=r,t.isWeb=s;var h="object"==typeof self?self:"object"==typeof global?global:{};t.globals=h;var p=null;t.setImmediate=function(e){return null===p&&(p=t.globals.setImmediate?t.globals.setImmediate.bind(t.globals):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):t.globals.setTimeout.bind(t.globals)),p(e)},t.OS=n?2:i?1:3}),define(t[57],i([1,0,28,38,18]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=new Array(230),s=new Array(112);!function(){function e(e,t){r[e]=t,s[t]=e}for(var t=0;t<s.length;t++)s[t]=-1;e(3,7),e(8,1),e(9,2),e(13,3),e(16,4),e(17,5),e(18,6),e(19,7),e(20,8),e(27,9),e(32,10),e(33,11),e(34,12),e(35,13),e(36,14),e(37,15),
e(38,16),e(39,17),e(40,18),e(45,19),e(46,20),e(48,21),e(49,22),e(50,23),e(51,24),e(52,25),e(53,26),e(54,27),e(55,28),e(56,29),e(57,30),e(65,31),e(66,32),e(67,33),e(68,34),e(69,35),e(70,36),e(71,37),e(72,38),e(73,39),e(74,40),e(75,41),e(76,42),e(77,43),e(78,44),e(79,45),e(80,46),e(81,47),e(82,48),e(83,49),e(84,50),e(85,51),e(86,52),e(87,53),e(88,54),e(89,55),e(90,56),e(93,58),e(96,93),e(97,94),e(98,95),e(99,96),e(100,97),e(101,98),e(102,99),e(103,100),e(104,101),e(105,102),e(106,103),e(107,104),e(108,105),e(109,106),e(110,107),e(111,108),e(112,59),e(113,60),e(114,61),e(115,62),e(116,63),e(117,64),e(118,65),e(119,66),e(120,67),e(121,68),e(122,69),e(123,70),e(124,71),e(125,72),e(126,73),e(127,74),e(128,75),e(129,76),e(130,77),e(144,78),e(145,79),e(186,80),e(187,81),e(188,82),e(189,83),e(190,84),e(191,85),e(192,86),e(193,110),e(194,111),e(219,87),e(220,88),e(221,89),e(222,90),e(223,91),e(226,92),e(229,109),i.isIE?e(91,57):i.isFirefox?(e(59,80),e(107,81),e(109,83),o.isMacintosh&&e(224,57)):i.isWebKit&&(e(91,57),
o.isMacintosh?e(93,57):e(92,57))}();var a=o.isMacintosh?256:2048,l=o.isMacintosh?2048:256,u=function(){function e(e){this._standardKeyboardEventBrand=!0;var t=e;this.browserEvent=t,this.target=t.target,this.ctrlKey=t.ctrlKey,this.shiftKey=t.shiftKey,this.altKey=t.altKey,this.metaKey=t.metaKey,this.keyCode=function(e){if(e.charCode){var t=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(t)}return r[e.keyCode]||0}(t),this.code=t.code,this.ctrlKey=this.ctrlKey||5===this.keyCode,this.altKey=this.altKey||6===this.keyCode,this.shiftKey=this.shiftKey||4===this.keyCode,this.metaKey=this.metaKey||57===this.keyCode,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}return e.prototype.preventDefault=function(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},
e.prototype.toKeybinding=function(){return this._asRuntimeKeybinding},e.prototype.equals=function(e){return this._asKeybinding===e},e.prototype._computeKeybinding=function(){var e=0;5!==this.keyCode&&4!==this.keyCode&&6!==this.keyCode&&57!==this.keyCode&&(e=this.keyCode);var t=0;return this.ctrlKey&&(t|=a),this.altKey&&(t|=512),this.shiftKey&&(t|=1024),this.metaKey&&(t|=l),t|=e},e.prototype._computeRuntimeKeybinding=function(){var e=0;return 5!==this.keyCode&&4!==this.keyCode&&6!==this.keyCode&&57!==this.keyCode&&(e=this.keyCode),new n.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,e)},e}();t.StandardKeyboardEvent=u}),define(t[44],i([1,0,28,165,18]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e){this.timestamp=Date.now(),this.browserEvent=e,this.leftButton=0===e.button,this.middleButton=1===e.button,this.rightButton=2===e.button,this.target=e.target,this.detail=e.detail||1,"dblclick"===e.type&&(this.detail=2),
this.ctrlKey=e.ctrlKey,this.shiftKey=e.shiftKey,this.altKey=e.altKey,this.metaKey=e.metaKey,"number"==typeof e.pageX?(this.posx=e.pageX,this.posy=e.pageY):(this.posx=e.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=e.clientY+document.body.scrollTop+document.documentElement.scrollTop);var t=n.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,e.view);this.posx-=t.left,this.posy-=t.top}return e.prototype.preventDefault=function(){this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},e}();t.StandardMouseEvent=s;var a=function(e){function t(t){var i=e.call(this,t)||this;return i.dataTransfer=t.dataTransfer,i}return r(t,e),t}(s);t.DragMouseEvent=a;var l=function(){function e(e,t,n){if(void 0===t&&(t=0),void 0===n&&(n=0),this.browserEvent=e||null,this.target=e?e.target||e.targetNode||e.srcElement:null,this.deltaY=n,this.deltaX=t,
e)if("wheel"===e.type){var r=e;r.deltaMode===r.DOM_DELTA_LINE?(this.deltaY=-e.deltaY,this.deltaX=-e.deltaX):(this.deltaY=-e.deltaY/40,this.deltaX=-e.deltaX/40)}else{var s=e,a=e;void 0!==s.wheelDeltaY?this.deltaY=s.wheelDeltaY/120:void 0!==a.VERTICAL_AXIS&&a.axis===a.VERTICAL_AXIS&&(this.deltaY=-a.detail/3),void 0!==s.wheelDeltaX?i.isSafari&&o.isWindows?this.deltaX=-s.wheelDeltaX/120:this.deltaX=s.wheelDeltaX/120:void 0!==a.HORIZONTAL_AXIS&&a.axis===a.HORIZONTAL_AXIS&&(this.deltaX=-e.detail/3),0===this.deltaY&&0===this.deltaX&&e.wheelDelta&&(this.deltaY=e.wheelDelta/120)}}return e.prototype.preventDefault=function(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},e}();t.StandardWheelEvent=l}),define(t[538],i([1,0,18]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n="undefined"==typeof process?{
cwd:function(){return"/"},env:Object.create(null),get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},nextTick:function(e){return i.setImmediate(e)}}:process;t.cwd=n.cwd,t.env=n.env,t.platform=n.platform}),define(t[83],i([1,0,538]),function(e,t,i){"use strict";function n(e,t){if("string"!=typeof e)throw new v(t,"string",e)}function o(e){return e===g||e===m}function s(e){return e===g}function a(e){return e>=d&&e<=h||e>=c&&e<=p}function l(e,t,i,n){for(var o,r="",s=0,a=-1,l=0,u=0;u<=e.length;++u){if(u<e.length)o=e.charCodeAt(u);else{if(n(o))break;o=g}if(n(o)){if(a===u-1||1===l);else if(a!==u-1&&2===l){if(r.length<2||2!==s||r.charCodeAt(r.length-1)!==f||r.charCodeAt(r.length-2)!==f){if(r.length>2){var d=r.lastIndexOf(i);-1===d?(r="",s=0):s=(r=r.slice(0,d)).length-1-r.lastIndexOf(i),a=u,l=0;continue}if(2===r.length||1===r.length){r="",s=0,a=u,l=0;continue}}t&&(r.length>0?r+=i+"..":r="..",s=2)}else r.length>0?r+=i+e.slice(a+1,u):r=e.slice(a+1,u),s=u-a-1;a=u,l=0}else o===f&&-1!==l?++l:l=-1}
return r}function u(e,t){var i=t.dir||t.root,n=t.base||(t.name||"")+(t.ext||"");return i?i===t.root?i+n:i+e+n:n}Object.defineProperty(t,"__esModule",{value:!0});var d=65,c=97,h=90,p=122,f=46,g=47,m=92,v=function(e){function t(t,i,n){var o,r=this;"string"==typeof i&&0===i.indexOf("not ")?(o="must not be",i=i.replace(/^not /,"")):o="must be";var s='The "'+t+'" '+(-1!==t.indexOf(".")?"property":"argument")+" "+o+" of type "+i;return s+=". Received type "+typeof n,r=e.call(this,s)||this,r.code="ERR_INVALID_ARG_TYPE",r}return r(t,e),t}(Error);t.win32={resolve:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var r="",s="",u=!1,d=e.length-1;d>=-1;d--){var c=void 0;if(d>=0?c=e[d]:r?void 0!==(c=i.env["="+r]||i.cwd())&&c.slice(0,3).toLowerCase()===r.toLowerCase()+"\\"||(c=r+"\\"):c=i.cwd(),n(c,"path"),0!==c.length){var h=c.length,p=0,f="",g=!1,m=c.charCodeAt(0);if(h>1)if(o(m))if(g=!0,o(c.charCodeAt(1))){for(var v=2,_=v;v<h&&!o(c.charCodeAt(v));++v);if(v<h&&v!==_){var y=c.slice(_,v)
;for(_=v;v<h&&o(c.charCodeAt(v));++v);if(v<h&&v!==_){for(_=v;v<h&&!o(c.charCodeAt(v));++v);v===h?(f="\\\\"+y+"\\"+c.slice(_),p=v):v!==_&&(f="\\\\"+y+"\\"+c.slice(_,v),p=v)}}}else p=1;else a(m)&&58===c.charCodeAt(1)&&(f=c.slice(0,2),p=2,h>2&&o(c.charCodeAt(2))&&(g=!0,p=3));else o(m)&&(p=1,g=!0);if(!(f.length>0&&r.length>0&&f.toLowerCase()!==r.toLowerCase())&&(0===r.length&&f.length>0&&(r=f),u||(s=c.slice(p)+"\\"+s,u=g),r.length>0&&u))break}}return s=l(s,!u,"\\",o),r+(u?"\\":"")+s||"."},normalize:function(e){n(e,"path");var t=e.length;if(0===t)return".";var i,r=0,s=!1,u=e.charCodeAt(0);if(t>1)if(o(u))if(s=!0,o(e.charCodeAt(1))){for(var d=2,c=d;d<t&&!o(e.charCodeAt(d));++d);if(d<t&&d!==c){var h=e.slice(c,d);for(c=d;d<t&&o(e.charCodeAt(d));++d);if(d<t&&d!==c){for(c=d;d<t&&!o(e.charCodeAt(d));++d);if(d===t)return"\\\\"+h+"\\"+e.slice(c)+"\\";d!==c&&(i="\\\\"+h+"\\"+e.slice(c,d),r=d)}}}else r=1;else a(u)&&58===e.charCodeAt(1)&&(i=e.slice(0,2),r=2,t>2&&o(e.charCodeAt(2))&&(s=!0,r=3));else if(o(u))return"\\";var p
;return 0!==(p=r<t?l(e.slice(r),!s,"\\",o):"").length||s||(p="."),p.length>0&&o(e.charCodeAt(t-1))&&(p+="\\"),void 0===i?s?p.length>0?"\\"+p:"\\":p.length>0?p:"":s?p.length>0?i+"\\"+p:i+"\\":p.length>0?i+p:i},isAbsolute:function(e){n(e,"path");var t=e.length;if(0===t)return!1;var i=e.charCodeAt(0);return!!o(i)||!!(a(i)&&t>2&&58===e.charCodeAt(1)&&o(e.charCodeAt(2)))},join:function(){for(var e=[],i=0;i<arguments.length;i++)e[i]=arguments[i];if(0===e.length)return".";for(var r,s,a=0;a<e.length;++a){var l=e[a];n(l,"path"),l.length>0&&(void 0===r?r=s=l:r+="\\"+l)}if(void 0===r)return".";var u=!0,d=0;if("string"==typeof s&&o(s.charCodeAt(0))){++d;var c=s.length;c>1&&o(s.charCodeAt(1))&&(++d,c>2&&(o(s.charCodeAt(2))?++d:u=!1))}if(u){for(;d<r.length&&o(r.charCodeAt(d));++d);d>=2&&(r="\\"+r.slice(d))}return t.win32.normalize(r)},relative:function(e,i){if(n(e,"from"),n(i,"to"),e===i)return"";var o=t.win32.resolve(e),r=t.win32.resolve(i);if(o===r)return"";if(e=o.toLowerCase(),i=r.toLowerCase(),e===i)return""
;for(var s=0;s<e.length&&e.charCodeAt(s)===m;++s);for(var a=e.length;a-1>s&&e.charCodeAt(a-1)===m;--a);for(var l=a-s,u=0;u<i.length&&i.charCodeAt(u)===m;++u);for(var d=i.length;d-1>u&&i.charCodeAt(d-1)===m;--d);for(var c=d-u,h=l<c?l:c,p=-1,f=0;f<=h;++f){if(f===h){if(c>h){if(i.charCodeAt(u+f)===m)return r.slice(u+f+1);if(2===f)return r.slice(u+f)}l>h&&(e.charCodeAt(s+f)===m?p=f:2===f&&(p=3));break}var g=e.charCodeAt(s+f);if(g!==i.charCodeAt(u+f))break;g===m&&(p=f)}if(f!==h&&-1===p)return r;var v="";for(-1===p&&(p=0),f=s+p+1;f<=a;++f)f!==a&&e.charCodeAt(f)!==m||(0===v.length?v+="..":v+="\\..");return v.length>0?v+r.slice(u+p,d):(u+=p,r.charCodeAt(u)===m&&++u,r.slice(u,d))},toNamespacedPath:function(e){if("string"!=typeof e)return e;if(0===e.length)return"";var i=t.win32.resolve(e);if(i.length>=3)if(i.charCodeAt(0)===m){if(i.charCodeAt(1)===m){var n=i.charCodeAt(2);if(63!==n&&n!==f)return"\\\\?\\UNC\\"+i.slice(2)}}else if(a(i.charCodeAt(0))&&58===i.charCodeAt(1)&&i.charCodeAt(2)===m)return"\\\\?\\"+i;return e},
dirname:function(e){n(e,"path");var t=e.length;if(0===t)return".";var i=-1,r=-1,s=!0,l=0,u=e.charCodeAt(0);if(t>1)if(o(u)){if(i=l=1,o(e.charCodeAt(1))){for(var d=2,c=d;d<t&&!o(e.charCodeAt(d));++d);if(d<t&&d!==c){for(c=d;d<t&&o(e.charCodeAt(d));++d);if(d<t&&d!==c){for(c=d;d<t&&!o(e.charCodeAt(d));++d);if(d===t)return e;d!==c&&(i=l=d+1)}}}}else a(u)&&58===e.charCodeAt(1)&&(i=l=2,t>2&&o(e.charCodeAt(2))&&(i=l=3));else if(o(u))return e;for(var h=t-1;h>=l;--h)if(o(e.charCodeAt(h))){if(!s){r=h;break}}else s=!1;if(-1===r){if(-1===i)return".";r=i}return e.slice(0,r)},basename:function(e,t){void 0!==t&&n(t,"ext"),n(e,"path");var i,r=0,s=-1,l=!0;if(e.length>=2){a(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(r=2)}if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";var u=t.length-1,d=-1;for(i=e.length-1;i>=r;--i){var c=e.charCodeAt(i);if(o(c)){if(!l){r=i+1;break}}else-1===d&&(l=!1,d=i+1),u>=0&&(c===t.charCodeAt(u)?-1==--u&&(s=i):(u=-1,s=d))}return r===s?s=d:-1===s&&(s=e.length),e.slice(r,s)
}for(i=e.length-1;i>=r;--i)if(o(e.charCodeAt(i))){if(!l){r=i+1;break}}else-1===s&&(l=!1,s=i+1);return-1===s?"":e.slice(r,s)},extname:function(e){n(e,"path");var t=0,i=-1,r=0,s=-1,l=!0,u=0;e.length>=2&&58===e.charCodeAt(1)&&a(e.charCodeAt(0))&&(t=r=2);for(var d=e.length-1;d>=t;--d){var c=e.charCodeAt(d);if(o(c)){if(!l){r=d+1;break}}else-1===s&&(l=!1,s=d+1),c===f?-1===i?i=d:1!==u&&(u=1):-1!==i&&(u=-1)}return-1===i||-1===s||0===u||1===u&&i===s-1&&i===r+1?"":e.slice(i,s)},format:function(e){if(null===e||"object"!=typeof e)throw new v("pathObject","Object",e);return u("\\",e)},parse:function(e){n(e,"path");var t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;var i=e.length,r=0,s=e.charCodeAt(0);if(i>1){if(o(s)){if(r=1,o(e.charCodeAt(1))){for(var l=2,u=l;l<i&&!o(e.charCodeAt(l));++l);if(l<i&&l!==u){for(u=l;l<i&&o(e.charCodeAt(l));++l);if(l<i&&l!==u){for(u=l;l<i&&!o(e.charCodeAt(l));++l);l===i?r=l:l!==u&&(r=l+1)}}}}else if(a(s)&&58===e.charCodeAt(1)){if(r=2,!(i>2))return t.root=t.dir=e,t
;if(o(e.charCodeAt(2))){if(3===i)return t.root=t.dir=e,t;r=3}}}else if(o(s))return t.root=t.dir=e,t;r>0&&(t.root=e.slice(0,r));for(var d=-1,c=r,h=-1,p=!0,g=e.length-1,m=0;g>=r;--g)if(s=e.charCodeAt(g),o(s)){if(!p){c=g+1;break}}else-1===h&&(p=!1,h=g+1),s===f?-1===d?d=g:1!==m&&(m=1):-1!==d&&(m=-1);return-1===d||-1===h||0===m||1===m&&d===h-1&&d===c+1?-1!==h&&(t.base=t.name=e.slice(c,h)):(t.name=e.slice(c,d),t.base=e.slice(c,h),t.ext=e.slice(d,h)),t.dir=c>0&&c!==r?e.slice(0,c-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var o="",r=!1,a=e.length-1;a>=-1&&!r;a--){var u=void 0;n(u=a>=0?e[a]:i.cwd(),"path"),0!==u.length&&(o=u+"/"+o,r=u.charCodeAt(0)===g)}return o=l(o,!r,"/",s),r?o.length>0?"/"+o:"/":o.length>0?o:"."},normalize:function(e){if(n(e,"path"),0===e.length)return".";var t=e.charCodeAt(0)===g,i=e.charCodeAt(e.length-1)===g;return 0!==(e=l(e,!t,"/",s)).length||t||(e="."),e.length>0&&i&&(e+="/"),t?"/"+e:e},
isAbsolute:function(e){return n(e,"path"),e.length>0&&e.charCodeAt(0)===g},join:function(){for(var e=[],i=0;i<arguments.length;i++)e[i]=arguments[i];if(0===e.length)return".";for(var o,r=0;r<e.length;++r){var s=arguments[r];n(s,"path"),s.length>0&&(void 0===o?o=s:o+="/"+s)}return void 0===o?".":t.posix.normalize(o)},relative:function(e,i){if(n(e,"from"),n(i,"to"),e===i)return"";if(e=t.posix.resolve(e),i=t.posix.resolve(i),e===i)return"";for(var o=1;o<e.length&&e.charCodeAt(o)===g;++o);for(var r=e.length,s=r-o,a=1;a<i.length&&i.charCodeAt(a)===g;++a);for(var l=i.length-a,u=s<l?s:l,d=-1,c=0;c<=u;++c){if(c===u){if(l>u){if(i.charCodeAt(a+c)===g)return i.slice(a+c+1);if(0===c)return i.slice(a+c)}else s>u&&(e.charCodeAt(o+c)===g?d=c:0===c&&(d=0));break}var h=e.charCodeAt(o+c);if(h!==i.charCodeAt(a+c))break;h===g&&(d=c)}var p="";for(c=o+d+1;c<=r;++c)c!==r&&e.charCodeAt(c)!==g||(0===p.length?p+="..":p+="/..");return p.length>0?p+i.slice(a+d):(a+=d,i.charCodeAt(a)===g&&++a,i.slice(a))},toNamespacedPath:function(e){
return e},dirname:function(e){if(n(e,"path"),0===e.length)return".";for(var t=e.charCodeAt(0)===g,i=-1,o=!0,r=e.length-1;r>=1;--r)if(e.charCodeAt(r)===g){if(!o){i=r;break}}else o=!1;return-1===i?t?"/":".":t&&1===i?"//":e.slice(0,i)},basename:function(e,t){void 0!==t&&n(t,"ext"),n(e,"path");var i,o=0,r=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";var a=t.length-1,l=-1;for(i=e.length-1;i>=0;--i){var u=e.charCodeAt(i);if(u===g){if(!s){o=i+1;break}}else-1===l&&(s=!1,l=i+1),a>=0&&(u===t.charCodeAt(a)?-1==--a&&(r=i):(a=-1,r=l))}return o===r?r=l:-1===r&&(r=e.length),e.slice(o,r)}for(i=e.length-1;i>=0;--i)if(e.charCodeAt(i)===g){if(!s){o=i+1;break}}else-1===r&&(s=!1,r=i+1);return-1===r?"":e.slice(o,r)},extname:function(e){n(e,"path");for(var t=-1,i=0,o=-1,r=!0,s=0,a=e.length-1;a>=0;--a){var l=e.charCodeAt(a);if(l!==g)-1===o&&(r=!1,o=a+1),l===f?-1===t?t=a:1!==s&&(s=1):-1!==t&&(s=-1);else if(!r){i=a+1;break}}
return-1===t||-1===o||0===s||1===s&&t===o-1&&t===i+1?"":e.slice(t,o)},format:function(e){if(null===e||"object"!=typeof e)throw new v("pathObject","Object",e);return u("/",e)},parse:function(e){n(e,"path");var t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;var i,o=e.charCodeAt(0)===g;o?(t.root="/",i=1):i=0;for(var r=-1,s=0,a=-1,l=!0,u=e.length-1,d=0;u>=i;--u){var c=e.charCodeAt(u);if(c!==g)-1===a&&(l=!1,a=u+1),c===f?-1===r?r=u:1!==d&&(d=1):-1!==r&&(d=-1);else if(!l){s=u+1;break}}return-1===r||-1===a||0===d||1===d&&r===a-1&&r===s+1?-1!==a&&(t.base=t.name=0===s&&o?e.slice(1,a):e.slice(s,a)):(0===s&&o?(t.name=e.slice(1,r),t.base=e.slice(1,a)):(t.name=e.slice(s,r),t.base=e.slice(s,a)),t.ext=e.slice(r,a)),s>0?t.dir=e.slice(0,s-1):o&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===i.platform?t.win32.normalize:t.posix.normalize,t.join="win32"===i.platform?t.win32.join:t.posix.join,
t.relative="win32"===i.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===i.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===i.platform?t.win32.basename:t.posix.basename,t.extname="win32"===i.platform?t.win32.extname:t.posix.extname,t.sep="win32"===i.platform?t.win32.sep:t.posix.sep}),define(t[124],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){function t(e,t){if(e.start>=t.end||t.start>=e.end)return{start:0,end:0};var i=Math.max(e.start,t.start),n=Math.min(e.end,t.end);return n-i<=0?{start:0,end:0}:{start:i,end:n}}function i(e){return e.end-e.start<=0}e.intersect=t,e.isEmpty=i,e.intersects=function(e,n){return!i(t(e,n))},e.relativeComplement=function(e,t){var n=[],o={start:e.start,end:Math.min(t.start,e.end)},r={start:Math.max(t.end,e.start),end:e.end};return i(o)||n.push(o),i(r)||n.push(r),n}}(t.Range||(t.Range={}))}),define(t[528],i([1,0,124]),function(e,t,i){"use strict";function n(e,t){for(var n=[],o=0,r=t;o<r.length;o++){
var s=r[o];if(!(e.start>=s.range.end)){if(e.end<s.range.start)break;var a=i.Range.intersect(e,s.range);i.Range.isEmpty(a)||n.push({range:a,size:s.size})}}return n}function o(e,t){return{start:e.start+t,end:e.end+t}}function r(e){for(var t=[],i=null,n=0,o=e;n<o.length;n++){var r=o[n],s=r.range.start,a=r.range.end,l=r.size;i&&l===i.size?i.range.end=a:(i={range:{start:s,end:a},size:l},t.push(i))}return t}Object.defineProperty(t,"__esModule",{value:!0}),t.groupIntersect=n,t.shift=o,t.consolidate=r;var s=function(){function e(){this.groups=[],this._size=0}return e.prototype.splice=function(e,t,i){void 0===i&&(i=[]);var s=i.length-t,a=n({start:0,end:e},this.groups),l=n({start:e+t,end:Number.POSITIVE_INFINITY},this.groups).map(function(e){return{range:o(e.range,s),size:e.size}}),u=i.map(function(t,i){return{range:{start:e+i,end:e+i+1},size:t.size}});this.groups=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return r(e.reduce(function(e,t){return e.concat(t)},[]))}(a,u,l),
this._size=this.groups.reduce(function(e,t){return e+t.size*(t.range.end-t.range.start)},0)},Object.defineProperty(e.prototype,"count",{get:function(){var e=this.groups.length;return e?this.groups[e-1].range.end:0},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.indexAt=function(e){if(e<0)return-1;for(var t=0,i=0,n=0,o=this.groups;n<o.length;n++){var r=o[n],s=r.range.end-r.range.start,a=i+s*r.size;if(e<a)return t+Math.floor((e-i)/r.size);t+=s,i=a}return t},e.prototype.indexAfter=function(e){return Math.min(this.indexAt(e)+1,this.count)},e.prototype.positionAt=function(e){if(e<0)return-1;for(var t=0,i=0,n=0,o=this.groups;n<o.length;n++){var r=o[n],s=r.range.end-r.range.start,a=i+s;if(e<a)return t+(e-i)*r.size;t+=s*r.size,i=a}return-1},e.prototype.dispose=function(){this.groups=null},e}();t.RangeMap=s}),define(t[215],i([1,0,4,2]),function(e,t,i,n){"use strict";function o(e,t){var i=t-e;return function(t){
return e+i*function(e){return 1-function(e){return Math.pow(e,3)}(1-e)}(t)}}Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e,t,i,n,o,r){t|=0,i|=0,n|=0,o|=0,r|=0,(e|=0)<0&&(e=0),i+e>t&&(i=t-e),i<0&&(i=0),n<0&&(n=0),r+n>o&&(r=o-n),r<0&&(r=0),this.width=e,this.scrollWidth=t,this.scrollLeft=i,this.height=n,this.scrollHeight=o,this.scrollTop=r}return e.prototype.equals=function(e){return this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop},e.prototype.withScrollDimensions=function(t){return new e(void 0!==t.width?t.width:this.width,void 0!==t.scrollWidth?t.scrollWidth:this.scrollWidth,this.scrollLeft,void 0!==t.height?t.height:this.height,void 0!==t.scrollHeight?t.scrollHeight:this.scrollHeight,this.scrollTop)},e.prototype.withScrollPosition=function(t){
return new e(this.width,this.scrollWidth,void 0!==t.scrollLeft?t.scrollLeft:this.scrollLeft,this.height,this.scrollHeight,void 0!==t.scrollTop?t.scrollTop:this.scrollTop)},e.prototype.createScrollEvent=function(e){var t=this.width!==e.width,i=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,o=this.height!==e.height,r=this.scrollHeight!==e.scrollHeight,s=this.scrollTop!==e.scrollTop;return{width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:t,scrollWidthChanged:i,scrollLeftChanged:n,heightChanged:o,scrollHeightChanged:r,scrollTopChanged:s}},e}();t.ScrollState=s;var a=function(e){function t(t,n){var o=e.call(this)||this;return o._onScroll=o._register(new i.Emitter),o.onScroll=o._onScroll.event,o._smoothScrollDuration=t,o._scheduleAtNextAnimationFrame=n,o._state=new s(0,0,0,0,0,0),o._smoothScrolling=null,o}return r(t,e),t.prototype.dispose=function(){
this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),e.prototype.dispose.call(this)},t.prototype.setSmoothScrollDuration=function(e){this._smoothScrollDuration=e},t.prototype.validateScrollPosition=function(e){return this._state.withScrollPosition(e)},t.prototype.getScrollDimensions=function(){return this._state},t.prototype.setScrollDimensions=function(e){var t=this._state.withScrollDimensions(e);this._setState(t),this._smoothScrolling&&this._smoothScrolling.acceptScrollDimensions(this._state)},t.prototype.getFutureScrollPosition=function(){return this._smoothScrolling?this._smoothScrolling.to:this._state},t.prototype.getCurrentScrollPosition=function(){return this._state},t.prototype.setScrollPositionNow=function(e){var t=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(t)},t.prototype.setScrollPositionSmooth=function(e){var t=this
;if(0===this._smoothScrollDuration)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:void 0===e.scrollLeft?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:void 0===e.scrollTop?this._smoothScrolling.to.scrollTop:e.scrollTop};n=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===n.scrollLeft&&this._smoothScrolling.to.scrollTop===n.scrollTop)return;var i=this._smoothScrolling.combine(this._state,n,this._smoothScrollDuration);this._smoothScrolling.dispose(),this._smoothScrolling=i}else{var n=this._state.withScrollPosition(e);this._smoothScrolling=u.start(this._state,n,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(function(){t._smoothScrolling&&(t._smoothScrolling.animationFrameDisposable=null,t._performSmoothScrolling())})},t.prototype._performSmoothScrolling=function(){var e=this;if(this._smoothScrolling){var t=this._smoothScrolling.tick(),i=this._state.withScrollPosition(t)
;if(this._setState(i),t.isDone)return this._smoothScrolling.dispose(),void(this._smoothScrolling=null);this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(function(){e._smoothScrolling&&(e._smoothScrolling.animationFrameDisposable=null,e._performSmoothScrolling())})}},t.prototype._setState=function(e){var t=this._state;t.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(t)))},t}(n.Disposable);t.Scrollable=a;var l=function(){return function(e,t,i){this.scrollLeft=e,this.scrollTop=t,this.isDone=i}}();t.SmoothScrollingUpdate=l;var u=function(){function e(e,t,i,n){this.from=e,this.to=t,this.duration=n,this._startTime=i,this.animationFrameDisposable=null,this._initAnimations()}return e.prototype._initAnimations=function(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)},e.prototype._initAnimation=function(e,t,i){
if(Math.abs(e-t)>2.5*i){var n=void 0,r=void 0;return e<t?(n=e+.75*i,r=t-.75*i):(n=e-.75*i,r=t+.75*i),function(e,t,i){return function(n){return n<i?e(n/i):t((n-i)/(1-i))}}(o(e,n),o(r,t),.33)}return o(e,t)},e.prototype.dispose=function(){null!==this.animationFrameDisposable&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)},e.prototype.acceptScrollDimensions=function(e){this.to=e.withScrollPosition(this.to),this._initAnimations()},e.prototype.tick=function(){return this._tick(Date.now())},e.prototype._tick=function(e){var t=(e-this._startTime)/this.duration;if(t<1){var i=this.scrollLeft(t),n=this.scrollTop(t);return new l(i,n,!1)}return new l(this.to.scrollLeft,this.to.scrollTop,!0)},e.prototype.combine=function(t,i,n){return e.start(t,i,n)},e.start=function(t,i,n){n+=10;return new e(t,i,Date.now()-10,n)},e}();t.SmoothScrollingOperation=u}),define(t[127],i([1,0,18]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var n=i.globals.performance&&"function"==typeof i.globals.performance.now,o=function(){function e(e){this._highResolution=n&&e,this._startTime=this._now(),this._stopTime=-1}return e.create=function(t){return void 0===t&&(t=!0),new e(t)},e.prototype.stop=function(){this._stopTime=this._now()},e.prototype.elapsed=function(){return-1!==this._stopTime?this._stopTime-this._startTime:this._now()-this._startTime},e.prototype._now=function(){return this._highResolution?i.globals.performance.now():(new Date).getTime()},e}();t.StopWatch=o}),define(t[5],i([1,0]),function(e,t){"use strict";function i(e){return e.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function n(e,t){if(!e||!t)return e;var i=t.length;if(0===i||0===e.length)return e;for(var n=0;e.indexOf(t,n)===n;)n+=i;return e.substring(n)}function o(e,t){if(!e||!t)return e;var i=t.length,n=e.length;if(0===i||0===n)return e;for(var o=n,r=-1;;){if(-1===(r=e.lastIndexOf(t,o-1))||r+i!==o)break;if(0===r)return"";o=r}return e.substring(0,o)}function r(e,t){
return e<t?-1:e>t?1:0}function s(e){return e>=97&&e<=122}function a(e){return e>=65&&e<=90}function l(e){return s(e)||a(e)}function u(e,t,i){if(void 0===i&&(i=e.length),"string"!=typeof e||"string"!=typeof t)return!1;for(var n=0;n<i;n++){var o=e.charCodeAt(n),r=t.charCodeAt(n);if(o!==r)if(l(o)&&l(r)){var s=Math.abs(o-r);if(0!==s&&32!==s)return!1}else if(String.fromCharCode(o).toLowerCase()!==String.fromCharCode(r).toLowerCase())return!1}return!0}function d(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}Object.defineProperty(t,"__esModule",{value:!0}),t.empty="",t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,i){void 0===i&&(i="0");for(var n=""+e,o=[n],r=n.length;r<t;r++)o.push(i);return o.reverse().join("")};var c=/{(\d+)}/g;t.format=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];return 0===t.length?e:e.replace(c,function(e,i){var n=parseInt(i,10);return isNaN(n)||n<0||n>=t.length?e:t[n]})},
t.escape=function(e){return e.replace(/[<>&]/g,function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}})},t.escapeRegExpCharacters=i,t.trim=function(e,t){return void 0===t&&(t=" "),o(n(e,t),t)},t.ltrim=n,t.rtrim=o,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(var i=0;i<t.length;i++)if(e[i]!==t[i])return!1;return!0},t.endsWith=function(e,t){var i=e.length-t.length;return i>0?e.indexOf(t,i)===i:0===i&&e===t},t.createRegExp=function(e,t,n){if(void 0===n&&(n={}),!e)throw new Error("Cannot create regex from empty string");t||(e=i(e)),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));var o="";return n.global&&(o+="g"),n.matchCase||(o+="i"),n.multiline&&(o+="m"),n.unicode&&(o+="u"),new RegExp(e,o)},t.regExpLeadsToEndlessLoop=function(e){
return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(var t=0,i=e.length;t<i;t++){var n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t,i){void 0===t&&(t=0),void 0===i&&(i=e.length);for(var n=t;n<i;n++){var o=e.charCodeAt(n);if(32!==o&&9!==o)return e.substring(t,n)}return e.substring(t,i)},t.lastNonWhitespaceIndex=function(e,t){void 0===t&&(t=e.length-1);for(var i=t;i>=0;i--){var n=e.charCodeAt(i);if(32!==n&&9!==n)return i}return-1},t.compare=r,t.compareIgnoreCase=function(e,t){for(var i=Math.min(e.length,t.length),n=0;n<i;n++){var o=e.charCodeAt(n),l=t.charCodeAt(n);if(o!==l){a(o)&&(o+=32),a(l)&&(l+=32);var u=o-l;if(0!==u)return s(o)&&s(l)?u:r(e.toLowerCase(),t.toLowerCase())}}return e.length<t.length?-1:e.length>t.length?1:0},t.isLowerAsciiLetter=s,
t.isUpperAsciiLetter=a,t.equalsIgnoreCase=function(e,t){return(e?e.length:0)===(t?t.length:0)&&u(e,t)},t.startsWithIgnoreCase=function(e,t){var i=t.length;return!(t.length>e.length)&&u(e,t,i)},t.commonPrefixLength=function(e,t){var i,n=Math.min(e.length,t.length);for(i=0;i<n;i++)if(e.charCodeAt(i)!==t.charCodeAt(i))return i;return n},t.commonSuffixLength=function(e,t){var i,n=Math.min(e.length,t.length),o=e.length-1,r=t.length-1;for(i=0;i<n;i++)if(e.charCodeAt(o-i)!==t.charCodeAt(r-i))return i;return n},t.isHighSurrogate=function(e){return 55296<=e&&e<=56319},t.isLowSurrogate=function(e){return 56320<=e&&e<=57343}
;var h=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=function(e){return h.test(e)};var p=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;t.containsEmoji=function(e){return p.test(e)};var f=/^[\t\n\r\x20-\x7E]*$/;t.isBasicASCII=function(e){return f.test(e)},t.containsFullWidthCharacter=function(e){for(var t=0,i=e.length;t<i;t++)if(d(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=d,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),
t.startsWithUTF8BOM=function(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))},t.safeBtoa=function(e){return btoa(encodeURIComponent(e))},t.repeat=function(e,t){for(var i="",n=0;n<t;n++)i+=e;return i},t.containsUppercaseCharacter=function(e,t){return void 0===t&&(t=!1),!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)}}),define(t[513],i([1,0,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderOcticons=function(e){return i.escape(e)}}),define(t[214],i([1,0,5,83]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toSlashes=function(e){return e.replace(/[\\/]/g,n.posix.sep)},t.isEqualOrParent=function(e,t,o,r){if(void 0===r&&(r=n.sep),e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(o){if(!i.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;var s=t.length;return t.charAt(t.length-1)===r&&s--,
e.charAt(s)===r}return t.charAt(t.length-1)!==r&&(t+=r),0===e.indexOf(t)},t.isWindowsDriveLetter=function(e){return e>=65&&e<=90||e>=97&&e<=122}}),define(t[64],i([1,0,41,5]),function(e,t,i,n){"use strict";function o(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return function(t,i){for(var n=0,o=e.length;n<o;n++){var r=e[n](t,i);if(r)return r}return null}}function r(e,t){var i=t.toLowerCase().indexOf(e.toLowerCase());return-1===i?null:[{start:i,end:i+e.length}]}function s(e,t){return a(e.toLowerCase(),t.toLowerCase(),0,0)}function a(e,t,i,n){if(i===e.length)return[];if(n===t.length)return null;if(e[i]===t[n]){var o=null;return(o=a(e,t,i+1,n+1))?p({start:n,end:n+1},o):null}return a(e,t,i,n+1)}function l(e){return 97<=e&&e<=122}function u(e){return 65<=e&&e<=90}function d(e){return 48<=e&&e<=57}function c(e){return 32===e||9===e||10===e||13===e}function h(e){return l(e)||u(e)||d(e)}function p(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function f(e,t){
for(var i=t;i<e.length;i++){var n=e.charCodeAt(i);if(u(n)||d(n)||i>0&&!h(e.charCodeAt(i-1)))return i}return e.length}function g(e,t,i,n){if(i===e.length)return[];if(n===t.length)return null;if(e[i]!==t[n].toLowerCase())return null;var o=null,r=n+1;for(o=g(e,t,i+1,n+1);!o&&(r=f(t,r))<t.length;)o=g(e,t,i+1,r),r++;return null===o?null:p({start:n,end:n+1},o)}function m(e,t){if(!t)return null;if(0===(t=t.trim()).length)return null;if(!function(e){for(var t=0,i=0,n=0,o=0,r=0;r<e.length;r++)u(n=e.charCodeAt(r))&&t++,l(n)&&i++,c(n)&&o++;return 0!==t&&0!==i||0!==o?t<=5:e.length<=30}(e))return null;if(t.length>60)return null;var i=function(e){for(var t=0,i=0,n=0,o=0,r=0,s=0;s<e.length;s++)u(r=e.charCodeAt(s))&&t++,l(r)&&i++,h(r)&&n++,d(r)&&o++;return{upperPercent:t/e.length,lowerPercent:i/e.length,alphaPercent:n/e.length,numericPercent:o/e.length}}(t);if(!function(e){var t=e.upperPercent,i=e.lowerPercent,n=e.alphaPercent,o=e.numericPercent;return i>.2&&t<.8&&n>.6&&o<.2}(i)){if(!function(e){var t=e.upperPercent
;return 0===e.lowerPercent&&t>.6}(i))return null;t=t.toLowerCase()}var n=null,o=0;for(e=e.toLowerCase();o<t.length&&null===(n=g(e,t,0,o));)o=f(t,o+1);return n}function v(){for(var e=[],t=[0],i=1;i<=N;i++)t.push(-i);for(i=0;i<=N;i++){var n=t.slice(0);n[0]=-i,e.push(n)}return e}function _(e,t,i,n,o){function r(e,t,i){for(void 0===i&&(i=" ");e.length<t;)e=i+e;return e}for(var s=" |   |"+n.split("").map(function(e){return r(e,3)}).join("|")+"\n",a=0;a<=i;a++)s+=0===a?" |":t[a-1]+"|",s+=e[a].slice(0,o+1).map(function(e){return r(e.toString(),3)}).join("|")+"\n";return s}function y(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:return!0;default:return!1}}function b(e,t,i){return t[e]!==i[e]}function C(e,t,i,n,o,r){for(;t<i&&o<r;)e[t]===n[o]&&(t+=1),o+=1;return t===i}function S(e,t,i,n,o,r,s){var a=e.length>N?N:e.length,l=n.length>N?N:n.length;if(!(i>=a||r>=l||a>l)&&C(t,i,a,o,r,l)){var u=1,d=1,c=i,h=r;for(u=1,c=i;c<a;u++,
c++)for(d=1,h=r;h<l;d++,h++){var p=function(e,t,i,n,o,r,s){if(t[i]!==r[s])return-1;return s===i-n?e[i]===o[s]?7:5:!b(s,o,r)||0!==s&&b(s-1,o,r)?!y(r,s)||0!==s&&y(r,s-1)?y(r,s-1)||function(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 32:case 9:return!0;default:return!1}}(r,s-1)?5:1:5:e[i]===o[s]?7:5}(e,t,c,i,n,o,h);k[u][d]=p;var f=M[u-1][d-1]+(p>1?1:p),g=M[u-1][d]+-1,m=M[u][d-1]+-1;m>=g?m>f?(M[u][d]=m,T[u][d]=4):m===f?(M[u][d]=m,T[u][d]=6):(M[u][d]=f,T[u][d]=2):g>f?(M[u][d]=g,T[u][d]=1):g===f?(M[u][d]=g,T[u][d]=3):(M[u][d]=f,T[u][d]=2)}if(R&&function(e,t,i,n){e=e.substr(t),i=i.substr(n),console.log(_(M,e,e.length,i,i.length)),console.log(_(T,e,e.length,i,i.length)),console.log(_(k,e,e.length,i,i.length))}(e,i,n,r),O=0,A=-100,F=r,W=s,w(u-1,d-1,a===l?1:0,0,!1),0!==O)return[A,P,r]}}function w(e,t,i,n,o){if(!(O>=10||i<-25)){for(var r=0;e>0&&t>0;){var s=k[e][t],a=T[e][t];if(4===a)t-=1,o?i-=5:0!==n&&(i-=1),o=!1,r=0;else{if(!(2&a))return;if(4&a&&w(e,t-1,0!==n?i-1:i,n,o),i+=s,e-=1,t-=1,o=!0,
n+=Math.pow(2,t+F),1===s){if(r+=1,0===e&&!W)return}else i+=1+r*(s-1),r=0}}O+=1,(i-=t>=3?9:3*t)>A&&(A=i,P=n)}}function E(e,t,i,n,o,r,s){return function(e,t,i,n,o,r,s,a){var l=S(e,t,i,n,o,r,a);if(l&&!s)return l;if(e.length>=3)for(var u=Math.min(7,e.length-1),d=i+1;d<u;d++){var c=function(e,t){if(t+1>=e.length)return;var i=e[t],n=e[t+1];if(i===n)return;return e.slice(0,t)+n+i+e.slice(t+2)}(e,d);if(c){var h=S(c,c.toLowerCase(),i,n,o,r,a);h&&(h[0]-=3,(!l||h[0]>l[0])&&(l=h))}}return l}(e,t,i,n,o,r,!0,s)}Object.defineProperty(t,"__esModule",{value:!0}),t.or=o,t.matchesPrefix=function(e,t,i){return!i||i.length<t.length?null:(e?n.startsWithIgnoreCase(i,t):0===i.indexOf(t))?t.length>0?[{start:0,end:t.length}]:[]:null}.bind(void 0,!0),t.matchesContiguousSubString=r,t.matchesSubString=s,t.isUpper=u;var L=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(function(e){return L.add(e.charCodeAt(0))}),t.matchesCamelCase=m;var x=o(t.matchesPrefix,m,r),D=o(t.matchesPrefix,m,s),I=new i.LRUCache(1e4)
;t.matchesFuzzy=function(e,t,i){if(void 0===i&&(i=!1),"string"!=typeof e||"string"!=typeof t)return null;var o=I.get(e);o||(o=new RegExp(n.convertSimple2RegExpPattern(e),"i"),I.set(e,o));var r=o.exec(t);return r?[{start:r.index,end:r.index+r[0].length}]:i?D(e,t):x(e,t)},t.anyScore=function(e,t,i,n,o,r){var s=S(e,t,0,n,o,0,!0);if(s)return s;for(var a=0,l=0,u=r,d=0;d<t.length&&d<N;++d){var c=o.indexOf(t.charAt(d),u);if(c>=0)l+=1,a+=Math.pow(2,c),u=c+1;else if(0!==a)break}return[l,a,r]},t.createMatches=function(e){if(void 0===e)return[];for(var t=e[1].toString(2),i=[],n=e[2];n<N;n++)if("1"===t[t.length-(n+1)]){var o=i[i.length-1];o&&o.end===n?o.end=n+1:i.push({start:n,end:n+1})}return i};var N=128,M=v(),k=v(),T=v(),R=!1;t.isPatternInWord=C;!function(e){e.Default=Object.freeze([-100,0,0]),e.isDefault=function(e){return!e||-100===e[0]&&0===e[1]&&0===e[2]}}(t.FuzzyScore||(t.FuzzyScore={})),t.fuzzyScore=S;var O=0,P=0,A=0,F=0,W=!1;t.fuzzyScoreGracefulAggressive=E}),
define(t[211],i([1,0,19,5,214,83,41,15]),function(e,t,i,n,o,r,s,a){"use strict";function l(e){switch(e){case 0:return"";case 1:return C+"*?";default:return"(?:"+b+"|"+C+"+"+b+"|"+b+C+"+)*?"}}function u(e,t){if(!e)return[];for(var i=[],n=!1,o=!1,r="",s=0,a=e;s<a.length;s++){var l=a[s];switch(l){case t:if(!n&&!o){i.push(r),r="";continue}break;case"{":n=!0;break;case"}":n=!1;break;case"[":o=!0;break;case"]":o=!1}r+=l}return r&&i.push(r),i}function d(e){if(!e)return"";var t="",i=u(e,y);if(i.every(function(e){return e===_}))t=".*";else{var o=!1;i.forEach(function(e,r){if(e!==_){for(var s=!1,a="",c=!1,h="",p=0,f=e;p<f.length;p++){var g=f[p];if("}"!==g&&s)a+=g;else if(!c||"]"===g&&h)switch(g){case"{":s=!0;continue;case"[":c=!0;continue;case"}":var m="(?:"+u(a,",").map(function(e){return d(e)}).join("|")+")";t+=m,s=!1,a="";break;case"]":t+="["+h+"]",c=!1,h="";break;case"?":t+=C;continue;case"*":t+=l(1);continue;default:t+=n.escapeRegExpCharacters(g)}else{
h+="-"===g?g:"^"!==g&&"!"!==g||h?g===y?"":n.escapeRegExpCharacters(g):"^"}}r<i.length-1&&(i[r+1]!==_||r+2<i.length)&&(t+=b),o=!1}else o||(t+=l(2),o=!0)})}return t}function c(e,t){if(!e)return k;var o;o="string"!=typeof e?e.pattern:e;var r=(o=o.trim())+"_"+!!t.trimForExclusions,s=N.get(r);if(s)return h(s,e);var a;if(w.test(o)){var l=o.substr(4);s=function(e,t){return"string"==typeof e&&n.endsWith(e,l)?o:null}}else s=(a=E.exec(p(o,t)))?function(e,t){var i="/"+e,o="\\"+e,r=function(r,s){return"string"!=typeof r?null:s?s===e?t:null:r===e||n.endsWith(r,i)||n.endsWith(r,o)?t:null},s=[e];return r.basenames=s,r.patterns=[t],r.allBasenames=s,r}(a[1],o):(t.trimForExclusions?x:L).test(o)?function(e,t){var n=v(e.slice(1,-1).split(",").map(function(e){return c(e,t)}).filter(function(e){return e!==k}),e),o=n.length;if(!o)return k;if(1===o)return n[0];var r=function(t,i){for(var o=0,r=n.length;o<r;o++)if(n[o](t,i))return e;return null},s=i.first(n,function(e){return!!e.allBasenames});s&&(r.allBasenames=s.allBasenames)
;var a=n.reduce(function(e,t){return t.allPaths?e.concat(t.allPaths):e},[]);a.length&&(r.allPaths=a);return r}(o,t):(a=D.exec(p(o,t)))?f(a[1].substr(1),o,!0):(a=I.exec(p(o,t)))?f(a[1],o,!1):function(e){try{var t=new RegExp("^"+d(e)+"$");return function(i,n){return t.lastIndex=0,"string"==typeof i&&t.test(i)?e:null}}catch(e){return k}}(o);return N.set(r,s),h(s,e)}function h(e,t){return"string"==typeof t?e:function(i,n){return o.isEqualOrParent(i,t.base)?e(r.relative(t.base,i),n):null}}function p(e,t){return t.trimForExclusions&&n.endsWith(e,"/**")?e.substr(0,e.length-2):e}function f(e,t,i){var o=r.sep!==r.posix.sep?e.replace(S,r.sep):e,s=r.sep+o,a=i?function(e,i){return"string"!=typeof e||e!==o&&!n.endsWith(e,s)?null:t}:function(e,i){return"string"==typeof e&&e===o?t:null};return a.allPaths=[(i?"*/":"./")+e],a}function g(e,t){if(void 0===t&&(t={}),!e)return M;if("string"==typeof e||m(e)){var n=c(e,t);if(n===k)return M;var o=function(e,t){return!!n(e,t)};return n.allBasenames&&(o.allBasenames=n.allBasenames),
n.allPaths&&(o.allPaths=n.allPaths),o}return function(e,t){var n=v(Object.getOwnPropertyNames(e).map(function(i){return function(e,t,i){if(!1===t)return k;var n=c(e,i);if(n===k)return k;if("boolean"==typeof t)return n;if(t){var o=t.when;if("string"==typeof o){var r=function(t,i,r,s){if(!s||!n(t,i))return null;var l=o.replace("$(basename)",r),u=s(l);return a.isThenable(u)?u.then(function(t){return t?e:null}):u?e:null};return r.requiresSiblings=!0,r}}return n}(i,e[i],t)}).filter(function(e){return e!==k})),o=n.length;if(!o)return k;if(!n.some(function(e){return!!e.requiresSiblings})){if(1===o)return n[0];var s=function(e,t){for(var i=0,o=n.length;i<o;i++){var r=n[i](e,t);if(r)return r}return null},l=i.first(n,function(e){return!!e.allBasenames});l&&(s.allBasenames=l.allBasenames);var u=n.reduce(function(e,t){return t.allPaths?e.concat(t.allPaths):e},[]);return u.length&&(s.allPaths=u),s}var d=function(e,t,i){for(var o=void 0,s=0,a=n.length;s<a;s++){var l=n[s];l.requiresSiblings&&i&&(t||(t=r.basename(e)),
o||(o=t.substr(0,t.length-r.extname(e).length)));var u=l(e,t,o,i);if(u)return u}return null},h=i.first(n,function(e){return!!e.allBasenames});h&&(d.allBasenames=h.allBasenames);var p=n.reduce(function(e,t){return t.allPaths?e.concat(t.allPaths):e},[]);p.length&&(d.allPaths=p);return d}(e,t)}function m(e){var t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function v(e,t){var i=e.filter(function(e){return!!e.basenames});if(i.length<2)return e;var n,o=i.reduce(function(e,t){var i=t.basenames;return i?e.concat(i):e},[]);if(t){n=[];for(var r=0,s=o.length;r<s;r++)n.push(t)}else n=i.reduce(function(e,t){var i=t.patterns;return i?e.concat(i):e},[]);var a=function(e,t){if("string"!=typeof e)return null;if(!t){var i=void 0;for(i=e.length;i>0;i--){var r=e.charCodeAt(i-1);if(47===r||92===r)break}t=e.substr(i)}var s=o.indexOf(t);return-1!==s?n[s]:null};a.basenames=o,a.patterns=n,a.allBasenames=o;var l=e.filter(function(e){return!e.basenames});return l.push(a),l}Object.defineProperty(t,"__esModule",{
value:!0});var _="**",y="/",b="[/\\\\]",C="[^/\\\\]",S=/\//g;t.splitGlobAware=u;var w=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,L=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,x=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,N=new s.LRUCache(1e4),M=function(){return!1},k=function(){return null};t.match=function(e,t,i){return!(!e||"string"!=typeof t)&&g(e)(t,void 0,i)},t.parse=g,t.isRelativePattern=m}),define(t[500],i([1,0,5]),function(e,t,i){"use strict";function n(e,t){return e&&""!==e[0]?e[0].toUpperCase()===e[0]?t.toUpperCase():e[0].toLowerCase()===e[0]?t.toLowerCase():i.containsUppercaseCharacter(e[0][0])?function(e,t,i){return-1!==e[0].indexOf(i)&&-1!==t.indexOf(i)&&e[0].split(i).length===t.split(i).length}(e,t,"-")?function(e,t,i){var o=t.split(i),r=e[0].split(i),s="";return o.forEach(function(e,t){s+=n([r[t]],e)+i}),s.slice(0,-1)}(e,t,"-"):t[0].toUpperCase()+t.substr(1):t:t}
Object.defineProperty(t,"__esModule",{value:!0}),t.buildReplaceStringWithCasePreserved=n}),define(t[23],i([1,0]),function(e,t){"use strict";function i(e){return typeof e===u.string||e instanceof String}function n(e){return!(typeof e!==u.object||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function o(e){return typeof e===u.undefined}function r(e){return o(e)||null===e}function s(e){return typeof e===u.function}function a(e,t){if(i(t)){if(typeof e!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(s(t)){try{if(e instanceof t)return}catch(e){}if(!r(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){for(var t=[],i=Object.getPrototypeOf(e);Object.prototype!==i;)t=t.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return t}
Object.defineProperty(t,"__esModule",{value:!0});var u={number:"number",string:"string",undefined:"undefined",object:"object",function:"function"};t.isArray=function(e){return Array.isArray?Array.isArray(e):!(!e||typeof e.length!==u.number||e.constructor!==Array)},t.isString=i,t.isObject=n,t.isNumber=function(e){return(typeof e===u.number||e instanceof Number)&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=o,t.isUndefinedOrNull=r;var d=Object.prototype.hasOwnProperty;t.isEmptyObject=function(e){if(!n(e))return!1;for(var t in e)if(d.call(e,t))return!1;return!0},t.isFunction=s,t.validateConstraints=function(e,t){for(var i=Math.min(e.length,t.length),n=0;n<i;n++)a(e[n],t[n])},t.validateConstraint=a,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){for(var t=[],i=0,n=l(e);i<n.length;i++){var o=n[i];"function"==typeof e[o]&&t.push(o)}return t},t.createProxyObject=function(e,t){for(var i=function(e){return function(){var i=Array.prototype.slice.call(arguments,0);return t(e,i)}
},n={},o=0,r=e;o<r.length;o++){var s=r[o];n[s]=i(s)}return n},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e}}),define(t[29],i([1,0,23]),function(e,t,i){"use strict";function n(e){if(!e||"object"!=typeof e)return e;if(e instanceof RegExp)return e;var t=Array.isArray(e)?[]:{};return Object.keys(e).forEach(function(i){e[i]&&"object"==typeof e[i]?t[i]=n(e[i]):t[i]=e[i]}),t}function o(e,t,n){if(i.isUndefinedOrNull(e))return e;var r=t(e);if(void 0!==r)return r;if(i.isArray(e)){for(var s=[],l=0,u=e;l<u.length;l++){var d=u[l];s.push(o(d,t,n))}return s}if(i.isObject(e)){if(n.has(e))throw new Error("Cannot clone recursive data-structure");n.add(e);var c={};for(var h in e)a.call(e,h)&&(c[h]=o(e[h],t,n));return n.delete(e),c}return e}function r(e,t,n){return void 0===n&&(n=!0),i.isObject(e)?(i.isObject(t)&&Object.keys(t).forEach(function(o){o in e?n&&(i.isObject(e[o])&&i.isObject(t[o])?r(e[o],t[o],n):e[o]=t[o]):e[o]=t[o]}),e):t}function s(e,t){
if(e===t)return!0;if(null===e||void 0===e||null===t||void 0===t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;var i,n;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(i=0;i<e.length;i++)if(!s(e[i],t[i]))return!1}else{var o=[];for(n in e)o.push(n);o.sort();var r=[];for(n in t)r.push(n);if(r.sort(),!s(o,r))return!1;for(i=0;i<o.length;i++)if(!s(e[o[i]],t[o[i]]))return!1}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=n,t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;for(var t=[e];t.length>0;){var i=t.shift();Object.freeze(i);for(var n in i)if(a.call(i,n)){var o=i[n];"object"!=typeof o||Object.isFrozen(o)||t.push(o)}}return e};var a=Object.prototype.hasOwnProperty;t.cloneAndChange=function(e,t){return o(e,t,new Set)},t.mixin=r,t.assign=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];return t.forEach(function(t){return Object.keys(t).forEach(function(i){return e[i]=t[i]})}),e},
t.equals=s,t.getOrDefault=function(e,t,i){var n=t(e);return void 0===n?i:n}}),define(t[157],i([1,0,29,513,5]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,t){this.supportOcticons=t,this.domNode=document.createElement("span"),this.domNode.className="monaco-highlighted-label",this.didEverRender=!1,e.appendChild(this.domNode)}return Object.defineProperty(e.prototype,"element",{get:function(){return this.domNode},enumerable:!0,configurable:!0}),e.prototype.set=function(t,n,o,r){void 0===n&&(n=[]),void 0===o&&(o=""),t||(t=""),r&&(t=e.escapeNewLines(t,n)),this.didEverRender&&this.text===t&&this.title===o&&i.equals(this.highlights,n)||(Array.isArray(n)||(n=[]),this.text=t,this.title=o,this.highlights=n,this.render())},e.prototype.render=function(){for(var e="",t=0,i=0,r=this.highlights;i<r.length;i++){var s=r[i];if(s.end!==s.start){if(t<s.start){e+="<span>";var a=this.text.substring(t,s.start);e+=this.supportOcticons?n.renderOcticons(a):o.escape(a),
e+="</span>",t=s.end}e+='<span class="highlight">';l=this.text.substring(s.start,s.end);e+=this.supportOcticons?n.renderOcticons(l):o.escape(l),e+="</span>",t=s.end}}if(t<this.text.length){e+="<span>";var l=this.text.substring(t);e+=this.supportOcticons?n.renderOcticons(l):o.escape(l),e+="</span>"}this.domNode.innerHTML=e,this.domNode.title=this.title,this.didEverRender=!0},e.escapeNewLines=function(e,t){var i=0,n=0;return e.replace(/\r\n|\r|\n/g,function(e,o){n="\r\n"===e?-1:0,o+=i;for(var r=0,s=t;r<s.length;r++){var a=s[r];a.end<=o||(a.start>=o&&(a.start+=n),a.end>=o&&(a.end+=n))}return i+=n,"⏎"})},e}();t.HighlightedLabel=r}),define(t[24],i([1,0,18]),function(e,t,i){"use strict";function n(e,t){for(var i=void 0,n=-1,o=0;o<e.length;o++){var r=e.charCodeAt(o);if(r>=97&&r<=122||r>=65&&r<=90||r>=48&&r<=57||45===r||46===r||95===r||126===r||t&&47===r)-1!==n&&(i+=encodeURIComponent(e.substring(n,o)),n=-1),void 0!==i&&(i+=e.charAt(o));else{void 0===i&&(i=e.substr(0,o));var s=_[r]
;void 0!==s?(-1!==n&&(i+=encodeURIComponent(e.substring(n,o)),n=-1),i+=s):-1===n&&(n=o)}}return-1!==n&&(i+=encodeURIComponent(e.substring(n))),void 0!==i?i:e}function o(e){var t;return t=e.authority&&e.path.length>1&&"file"===e.scheme?"//"+e.authority+e.path:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?e.path[1].toLowerCase()+e.path.substr(2):e.path,i.isWindows&&(t=t.replace(/\//g,"\\")),t}function s(e,t){var i=t?function(e){for(var t=void 0,i=0;i<e.length;i++){var n=e.charCodeAt(i);35===n||63===n?(void 0===t&&(t=e.substr(0,i)),t+=_[n]):void 0!==t&&(t+=e[i])}return void 0!==t?t:e}:n,o="",r=e.scheme,s=e.authority,a=e.path,l=e.query,u=e.fragment;if(r&&(o+=r,o+=":"),(s||"file"===r)&&(o+=p,o+=p),s){var d=s.indexOf("@");if(-1!==d){var c=s.substr(0,d);s=s.substr(d+1),-1===(d=c.indexOf(":"))?o+=i(c,!1):(o+=i(c.substr(0,d),!1),o+=":",o+=i(c.substr(d+1),!1)),o+="@"}
-1===(d=(s=s.toLowerCase()).indexOf(":"))?o+=i(s,!1):(o+=i(s.substr(0,d),!1),o+=s.substr(d))}if(a){if(a.length>=3&&47===a.charCodeAt(0)&&58===a.charCodeAt(2)){(h=a.charCodeAt(1))>=65&&h<=90&&(a="/"+String.fromCharCode(h+32)+":"+a.substr(3))}else if(a.length>=2&&58===a.charCodeAt(1)){var h=a.charCodeAt(0);h>=65&&h<=90&&(a=String.fromCharCode(h+32)+":"+a.substr(2))}o+=i(a,!0)}return l&&(o+="?",o+=i(l,!1)),u&&(o+="#",o+=t?u:n(u,!1)),o}var a;Object.defineProperty(t,"__esModule",{value:!0});var l=/^\w[\w\d+.-]*$/,u=/^\//,d=/^\/\//,c=!0,h="",p="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,g=function(){function e(e,t,i,n,o,r){void 0===r&&(r=!1),"object"==typeof e?(this.scheme=e.scheme||h,this.authority=e.authority||h,this.path=e.path||h,this.query=e.query||h,this.fragment=e.fragment||h):(this.scheme=function(e,t){return t||c?e||h:(e||(console.trace("BAD uri lacks scheme, falling back to file-scheme."),e="file"),e)}(e,r),this.authority=t||h,this.path=function(e,t){switch(e){case"https":
case"http":case"file":t?t[0]!==p&&(t=p+t):t=p}return t}(this.scheme,i||h),this.query=n||h,this.fragment=o||h,function(e,t){if(!e.scheme){if(t||c)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+e.authority+'", path: "'+e.path+'", query: "'+e.query+'", fragment: "'+e.fragment+'"}');console.warn('[UriError]: Scheme is missing: {scheme: "", authority: "'+e.authority+'", path: "'+e.path+'", query: "'+e.query+'", fragment: "'+e.fragment+'"}')}if(e.scheme&&!l.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!u.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,r))}return e.isUri=function(t){
return t instanceof e||!!t&&("string"==typeof t.authority&&"string"==typeof t.fragment&&"string"==typeof t.path&&"string"==typeof t.query&&"string"==typeof t.scheme&&"function"==typeof t.fsPath&&"function"==typeof t.with&&"function"==typeof t.toString)},Object.defineProperty(e.prototype,"fsPath",{get:function(){return o(this)},enumerable:!0,configurable:!0}),e.prototype.with=function(e){if(!e)return this;var t=e.scheme,i=e.authority,n=e.path,o=e.query,r=e.fragment;return void 0===t?t=this.scheme:null===t&&(t=h),void 0===i?i=this.authority:null===i&&(i=h),void 0===n?n=this.path:null===n&&(n=h),void 0===o?o=this.query:null===o&&(o=h),void 0===r?r=this.fragment:null===r&&(r=h),t===this.scheme&&i===this.authority&&n===this.path&&o===this.query&&r===this.fragment?this:new v(t,i,n,o,r)},e.parse=function(e,t){void 0===t&&(t=!1);var i=f.exec(e);return i?new v(i[2]||h,decodeURIComponent(i[4]||h),decodeURIComponent(i[5]||h),decodeURIComponent(i[7]||h),decodeURIComponent(i[9]||h),t):new v(h,h,h,h,h)},e.file=function(e){
var t=h;if(i.isWindows&&(e=e.replace(/\\/g,p)),e[0]===p&&e[1]===p){var n=e.indexOf(p,2);-1===n?(t=e.substring(2),e=p):(t=e.substring(2,n),e=e.substring(n)||p)}return new v("file",t,e,h,h)},e.from=function(e){return new v(e.scheme,e.authority,e.path,e.query,e.fragment)},e.prototype.toString=function(e){return void 0===e&&(e=!1),s(this,e)},e.prototype.toJSON=function(){return this},e.revive=function(t){if(t){if(t instanceof e)return t;var i=new v(t);return i._formatted=t.external,i._fsPath=t._sep===m?t.fsPath:null,i}return t},e}();t.URI=g;var m=i.isWindows?1:void 0,v=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._formatted=null,t._fsPath=null,t}return r(t,e),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=o(this)),this._fsPath},enumerable:!0,configurable:!0}),t.prototype.toString=function(e){return void 0===e&&(e=!1),e?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)},t.prototype.toJSON=function(){var e={
$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=m),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e},t}(g),_=(a={},a[58]="%3A",a[47]="%2F",a[63]="%3F",a[35]="%23",a[91]="%5B",a[93]="%5D",a[64]="%40",a[33]="%21",a[36]="%24",a[38]="%26",a[39]="%27",a[40]="%28",a[41]="%29",a[42]="%2A",a[43]="%2B",a[44]="%2C",a[59]="%3B",a[61]="%3D",a[32]="%20",a)}),define(t[205],i([1,0,24]),function(e,t,i){"use strict";function n(e,t){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return i.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}for(var o in e)Object.hasOwnProperty.call(e,o)&&(e[o]=n(e[o],t+1))}return e}Object.defineProperty(t,"__esModule",{value:!0}),t.parse=function(e){var t=JSON.parse(e);return t=n(t,0)},t.revive=n}),define(t[50],i([1,0,24,18]),function(e,t,i,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var o;!function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata"}(o=t.Schemas||(t.Schemas={}));var r=function(){function e(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http"}return e.prototype.setPreferredWebSchema=function(e){this._preferredWebSchema=e},e.prototype.rewrite=function(e,t){var r=this._hosts[e],s=this._ports[e],a=this._connectionTokens[e];return i.URI.from({scheme:n.isWeb?this._preferredWebSchema:o.vscodeRemoteResource,authority:r+":"+s,path:"/vscode-remote-resource",query:"path="+encodeURIComponent(t)+"&tkn="+encodeURIComponent(a)})},e}()
;t.RemoteAuthorities=new r}),define(t[8],i([1,0,28,52,57,44,15,10,4,2,18,19,50]),function(e,t,i,n,o,a,l,u,d,c,h,p,f){"use strict";function g(e,t,i,n){return new I(e,t,i,n)}function m(e){if(!N){N=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||function(e){return setTimeout(function(){return e((new Date).getTime())},0)}}return N.call(self,e)}function v(e){return document.defaultView.getComputedStyle(e,null)}function _(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1}function y(e){void 0===e&&(e=document.getElementsByTagName("head")[0]);var t=document.createElement("style");return t.type="text/css",t.media="screen",e.appendChild(t),t}function b(){return A||(A=y()),A}function C(e,t,i){for(var n=[],o=3;o<arguments.length;o++)n[o-3]=arguments[o];var r=V.exec(t);if(!r)throw new Error("Bad use of emmet");i=s({},i||{});var a,l=r[1]||"div"
;return a=e!==W.HTML?document.createElementNS(e,l):document.createElement(l),r[3]&&(a.id=r[3]),r[4]&&(a.className=r[4].replace(/\./g," ").trim()),Object.keys(i).forEach(function(e){var t=i[e];/^on\w+$/.test(e)?a[e]=t:"selected"===e?t&&a.setAttribute(e,"true"):a.setAttribute(e,t)}),p.coalesce(n).forEach(function(e){e instanceof Node?a.appendChild(e):a.appendChild(document.createTextNode(e))}),a}function S(e,t){for(var i=[],n=2;n<arguments.length;n++)i[n-2]=arguments[n];return C.apply(void 0,[W.HTML,e,t].concat(i))}function w(e){if(e&&e.hasAttribute("tabIndex")){if(document.activeElement===e){var t=function(e,t){for(;e;){if(e instanceof HTMLElement&&e.hasAttribute(t))return e;e=e.parentNode}return null}(e.parentElement,"tabIndex");t&&t.focus()}e.removeAttribute("tabindex")}}function E(e){return e&&f.Schemas.vscodeRemote===e.scheme?f.RemoteAuthorities.rewrite(e.authority,e.path):e}Object.defineProperty(t,"__esModule",{value:!0}),t.clearNode=function(e){for(;e.firstChild;)e.removeChild(e.firstChild)},
t.removeNode=function(e){e.parentNode&&e.parentNode.removeChild(e)},t.isInDOM=function(e){for(;e;){if(e===document.body)return!0;e=e.parentNode||e.host}return!1};var L=new(function(){function e(){this._lastStart=-1,this._lastEnd=-1}return e.prototype._findClassName=function(e,t){var i=e.className;if(i){t=t.trim();var n=i.length,o=t.length;if(0!==o)if(n<o)this._lastStart=-1;else{if(i===t)return this._lastStart=0,void(this._lastEnd=n);for(var r,s=-1;(s=i.indexOf(t,s+1))>=0;){if(r=s+o,(0===s||32===i.charCodeAt(s-1))&&32===i.charCodeAt(r))return this._lastStart=s,void(this._lastEnd=r+1);if(s>0&&32===i.charCodeAt(s-1)&&r===n)return this._lastStart=s-1,void(this._lastEnd=r);if(0===s&&r===n)return this._lastStart=0,void(this._lastEnd=r)}this._lastStart=-1}else this._lastStart=-1}else this._lastStart=-1},e.prototype.hasClass=function(e,t){return this._findClassName(e,t),-1!==this._lastStart},e.prototype.addClasses=function(e){for(var t=this,i=[],n=1;n<arguments.length;n++)i[n-1]=arguments[n];i.forEach(function(i){
return i.split(" ").forEach(function(i){return t.addClass(e,i)})})},e.prototype.addClass=function(e,t){e.className?(this._findClassName(e,t),-1===this._lastStart&&(e.className=e.className+" "+t)):e.className=t},e.prototype.removeClass=function(e,t){this._findClassName(e,t),-1!==this._lastStart&&(e.className=e.className.substring(0,this._lastStart)+e.className.substring(this._lastEnd))},e.prototype.removeClasses=function(e){for(var t=this,i=[],n=1;n<arguments.length;n++)i[n-1]=arguments[n];i.forEach(function(i){return i.split(" ").forEach(function(i){return t.removeClass(e,i)})})},e.prototype.toggleClass=function(e,t,i){this._findClassName(e,t),-1===this._lastStart||void 0!==i&&i||this.removeClass(e,t),-1!==this._lastStart||void 0!==i&&!i||this.addClass(e,t)},e}()),x=new(function(){function e(){}return e.prototype.hasClass=function(e,t){return Boolean(t)&&e.classList&&e.classList.contains(t)},e.prototype.addClasses=function(e){for(var t=this,i=[],n=1;n<arguments.length;n++)i[n-1]=arguments[n]
;i.forEach(function(i){return i.split(" ").forEach(function(i){return t.addClass(e,i)})})},e.prototype.addClass=function(e,t){t&&e.classList&&e.classList.add(t)},e.prototype.removeClass=function(e,t){t&&e.classList&&e.classList.remove(t)},e.prototype.removeClasses=function(e){for(var t=this,i=[],n=1;n<arguments.length;n++)i[n-1]=arguments[n];i.forEach(function(i){return i.split(" ").forEach(function(i){return t.removeClass(e,i)})})},e.prototype.toggleClass=function(e,t,i){e.classList&&e.classList.toggle(t,i)},e}()),D=i.isIE?L:x;t.hasClass=D.hasClass.bind(D),t.addClass=D.addClass.bind(D),t.addClasses=D.addClasses.bind(D),t.removeClass=D.removeClass.bind(D),t.removeClasses=D.removeClasses.bind(D),t.toggleClass=D.toggleClass.bind(D);var I=function(){function e(e,t,i,n){this._node=e,this._type=t,this._handler=i,this._useCapture=n||!1,this._node.addEventListener(this._type,this._handler,this._useCapture)}return e.prototype.dispose=function(){
this._handler&&(this._node.removeEventListener(this._type,this._handler,this._useCapture),this._node=null,this._handler=null)},e}();t.addDisposableListener=g,t.addStandardDisposableListener=function(e,t,i,n){var r=i;return"click"===t||"mousedown"===t?r=function(e){return function(t){return e(new a.StandardMouseEvent(t))}}(i):"keydown"!==t&&"keypress"!==t&&"keyup"!==t||(r=function(e){return function(t){return e(new o.StandardKeyboardEvent(t))}}(i)),g(e,t,r,n)},t.addDisposableNonBubblingMouseOutListener=function(e,t){return g(e,"mouseout",function(i){for(var n=i.relatedTarget||i.target;n&&n!==e;)n=n.parentNode;n!==e&&t(i)})};var N=null,M=function(){function e(e,t){void 0===t&&(t=0),this._runner=e,this.priority=t,this._canceled=!1}return e.prototype.dispose=function(){this._canceled=!0},e.prototype.execute=function(){if(!this._canceled)try{this._runner()}catch(e){u.onUnexpectedError(e)}},e.sort=function(e,t){return t.priority-e.priority},e}();!function(){var e=[],i=null,n=!1,o=!1,r=function(){for(n=!1,i=e,e=[],
o=!0;i.length>0;){i.sort(M.sort);i.shift().execute()}o=!1};t.scheduleAtNextAnimationFrame=function(t,i){void 0===i&&(i=0);var o=new M(t,i);return e.push(o),n||(n=!0,m(r)),o},t.runAtThisOrScheduleAtNextAnimationFrame=function(e,n){if(o){var r=new M(e,n);return i.push(r),r}return t.scheduleAtNextAnimationFrame(e,n)}}();var k=16,T=function(e,t){return t},R=function(e){function t(t,i,n,o,r){void 0===o&&(o=T),void 0===r&&(r=k);var s=e.call(this)||this,a=null,u=0,d=s._register(new l.TimeoutTimer),c=function(){u=(new Date).getTime(),n(a),a=null};return s._register(g(t,i,function(e){a=o(a,e);var t=(new Date).getTime()-u;t>=r?(d.cancel(),c()):d.setIfNotSet(c,r-t)})),s}return r(t,e),t}(c.Disposable);t.addDisposableThrottledListener=function(e,t,i,n,o){return new R(e,t,i,n,o)},t.getComputedStyle=v;var O=function(){function e(){}return e.convertToPixels=function(e,t){return parseFloat(t)||0},e.getDimension=function(t,i,n){var o=v(t),r="0";return o&&(r=o.getPropertyValue?o.getPropertyValue(i):o.getAttribute(n)),
e.convertToPixels(t,r)},e.getBorderLeftWidth=function(t){return e.getDimension(t,"border-left-width","borderLeftWidth")},e.getBorderRightWidth=function(t){return e.getDimension(t,"border-right-width","borderRightWidth")},e.getBorderTopWidth=function(t){return e.getDimension(t,"border-top-width","borderTopWidth")},e.getBorderBottomWidth=function(t){return e.getDimension(t,"border-bottom-width","borderBottomWidth")},e.getPaddingLeft=function(t){return e.getDimension(t,"padding-left","paddingLeft")},e.getPaddingRight=function(t){return e.getDimension(t,"padding-right","paddingRight")},e.getPaddingTop=function(t){return e.getDimension(t,"padding-top","paddingTop")},e.getPaddingBottom=function(t){return e.getDimension(t,"padding-bottom","paddingBottom")},e.getMarginLeft=function(t){return e.getDimension(t,"margin-left","marginLeft")},e.getMarginTop=function(t){return e.getDimension(t,"margin-top","marginTop")},e.getMarginRight=function(t){return e.getDimension(t,"margin-right","marginRight")},
e.getMarginBottom=function(t){return e.getDimension(t,"margin-bottom","marginBottom")},e}(),P=function(){return function(e,t){this.width=e,this.height=t}}();t.Dimension=P,t.getTopLeftOffset=function(e){for(var t=e.offsetParent,i=e.offsetTop,n=e.offsetLeft;null!==(e=e.parentNode)&&e!==document.body&&e!==document.documentElement;){i-=e.scrollTop;var o=v(e);o&&(n-="rtl"!==o.direction?e.scrollLeft:-e.scrollLeft),e===t&&(n+=O.getBorderLeftWidth(e),i+=O.getBorderTopWidth(e),i+=e.offsetTop,n+=e.offsetLeft,t=e.offsetParent)}return{left:n,top:i}},t.getDomNodePagePosition=function(e){var i=e.getBoundingClientRect();return{left:i.left+t.StandardWindow.scrollX,top:i.top+t.StandardWindow.scrollY,width:i.width,height:i.height}},t.StandardWindow=new(function(){function e(){}return Object.defineProperty(e.prototype,"scrollX",{get:function(){return"number"==typeof window.scrollX?window.scrollX:document.body.scrollLeft+document.documentElement.scrollLeft},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"scrollY",{get:function(){return"number"==typeof window.scrollY?window.scrollY:document.body.scrollTop+document.documentElement.scrollTop},enumerable:!0,configurable:!0}),e}()),t.getTotalWidth=function(e){var t=O.getMarginLeft(e)+O.getMarginRight(e);return e.offsetWidth+t},t.getContentWidth=function(e){var t=O.getBorderLeftWidth(e)+O.getBorderRightWidth(e),i=O.getPaddingLeft(e)+O.getPaddingRight(e);return e.offsetWidth-t-i},t.getContentHeight=function(e){var t=O.getBorderTopWidth(e)+O.getBorderBottomWidth(e),i=O.getPaddingTop(e)+O.getPaddingBottom(e);return e.offsetHeight-t-i},t.getTotalHeight=function(e){var t=O.getMarginTop(e)+O.getMarginBottom(e);return e.offsetHeight+t},t.isAncestor=_,t.findParentWithClass=function(e,i,n){for(;e;){if(t.hasClass(e,i))return e;if(n)if("string"==typeof n){if(t.hasClass(e,n))return null}else if(e===n)return null;e=e.parentNode}return null},t.createStyleSheet=y;var A=null;t.createCSSRule=function(e,t,i){void 0===i&&(i=b()),
i&&t&&i.sheet.insertRule(e+"{"+t+"}",0)},t.removeCSSRulesContainingSelector=function(e,t){if(void 0===t&&(t=b()),t){for(var i=function(e){return e&&e.sheet&&e.sheet.rules?e.sheet.rules:e&&e.sheet&&e.sheet.cssRules?e.sheet.cssRules:[]}(t),n=[],o=0;o<i.length;o++)-1!==i[o].selectorText.indexOf(e)&&n.push(o);for(o=n.length-1;o>=0;o--)t.sheet.deleteRule(n[o])}},t.isHTMLElement=function(e){return"object"==typeof HTMLElement?e instanceof HTMLElement:e&&"object"==typeof e&&1===e.nodeType&&"string"==typeof e.nodeName},t.EventType={CLICK:"click",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",
SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:i.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:function(e,t){e.preventDefault?e.preventDefault():e.returnValue=!1,t&&(e.stopPropagation?e.stopPropagation():e.cancelBubble=!0)}},t.saveParentsScrollTop=function(e){for(var t=[],i=0;e&&e.nodeType===e.ELEMENT_NODE;i++)t[i]=e.scrollTop,e=e.parentNode;return t},t.restoreParentsScrollTop=function(e,t){for(var i=0;e&&e.nodeType===e.ELEMENT_NODE;i++)e.scrollTop!==t[i]&&(e.scrollTop=t[i]),e=e.parentNode};var F=function(e){function i(i){var o=e.call(this)||this;o._onDidFocus=o._register(new d.Emitter),
o.onDidFocus=o._onDidFocus.event,o._onDidBlur=o._register(new d.Emitter),o.onDidBlur=o._onDidBlur.event;var r=_(document.activeElement,i),s=!1;return o._register(n.domEvent(i,t.EventType.FOCUS,!0)(function(){s=!1,r||(r=!0,o._onDidFocus.fire())})),o._register(n.domEvent(i,t.EventType.BLUR,!0)(function(){r&&(s=!0,window.setTimeout(function(){s&&(s=!1,r=!1,o._onDidBlur.fire())},0))})),o}return r(i,e),i}(c.Disposable);t.trackFocus=function(e){return new F(e)},t.append=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];return t.forEach(function(t){return e.appendChild(t)}),t[t.length-1]};var W,V=/([\w\-]+)?(#([\w\-]+))?((.([\w\-]+))*)/;!function(e){e.HTML="http://www.w3.org/1999/xhtml",e.SVG="http://www.w3.org/2000/svg"}(W=t.Namespace||(t.Namespace={})),t.$=S,S.SVG=function(e,t){for(var i=[],n=2;n<arguments.length;n++)i[n-2]=arguments[n];return C.apply(void 0,[W.SVG,e,t].concat(i))},t.show=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var i=0,n=e;i<n.length;i++){
var o=n[i];o.style.display="",o.removeAttribute("aria-hidden")}},t.hide=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var i=0,n=e;i<n.length;i++){var o=n[i];o.style.display="none",o.setAttribute("aria-hidden","true")}},t.removeTabIndexAndUpdateFocus=w,t.getElementsByTagName=function(e){return Array.prototype.slice.call(document.getElementsByTagName(e),0)},t.computeScreenAwareSize=function(e){var t=window.devicePixelRatio*e;return Math.max(1,Math.floor(t))/window.devicePixelRatio},t.windowOpenNoOpener=function(e){if(h.isNative||i.isEdgeWebView)window.open(e);else{var t=window.open();t&&(t.opener=null,t.location.href=e)}},t.animate=function(e){var i=function(){e(),n=t.scheduleAtNextAnimationFrame(i)},n=t.scheduleAtNextAnimationFrame(i);return c.toDisposable(function(){return n.dispose()})},f.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http"),t.asDomUri=E,t.asCSSUrl=function(e){
return e?"url('"+E(e).toString(!0).replace(/'/g,"%27")+"')":"url('')"}}),define(t[27],i([1,0,8]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.domNode=e,this._maxWidth=-1,this._width=-1,this._height=-1,this._top=-1,this._left=-1,this._bottom=-1,this._right=-1,this._fontFamily="",this._fontWeight="",this._fontSize=-1,this._lineHeight=-1,this._letterSpacing=-100,this._className="",this._display="",this._position="",this._visibility="",this._layerHint=!1}return e.prototype.setMaxWidth=function(e){this._maxWidth!==e&&(this._maxWidth=e,this.domNode.style.maxWidth=this._maxWidth+"px")},e.prototype.setWidth=function(e){this._width!==e&&(this._width=e,this.domNode.style.width=this._width+"px")},e.prototype.setHeight=function(e){this._height!==e&&(this._height=e,this.domNode.style.height=this._height+"px")},e.prototype.setTop=function(e){this._top!==e&&(this._top=e,this.domNode.style.top=this._top+"px")},e.prototype.unsetTop=function(){
-1!==this._top&&(this._top=-1,this.domNode.style.top="")},e.prototype.setLeft=function(e){this._left!==e&&(this._left=e,this.domNode.style.left=this._left+"px")},e.prototype.setBottom=function(e){this._bottom!==e&&(this._bottom=e,this.domNode.style.bottom=this._bottom+"px")},e.prototype.setRight=function(e){this._right!==e&&(this._right=e,this.domNode.style.right=this._right+"px")},e.prototype.setFontFamily=function(e){this._fontFamily!==e&&(this._fontFamily=e,this.domNode.style.fontFamily=this._fontFamily)},e.prototype.setFontWeight=function(e){this._fontWeight!==e&&(this._fontWeight=e,this.domNode.style.fontWeight=this._fontWeight)},e.prototype.setFontSize=function(e){this._fontSize!==e&&(this._fontSize=e,this.domNode.style.fontSize=this._fontSize+"px")},e.prototype.setLineHeight=function(e){this._lineHeight!==e&&(this._lineHeight=e,this.domNode.style.lineHeight=this._lineHeight+"px")},e.prototype.setLetterSpacing=function(e){this._letterSpacing!==e&&(this._letterSpacing=e,
this.domNode.style.letterSpacing=this._letterSpacing+"px")},e.prototype.setClassName=function(e){this._className!==e&&(this._className=e,this.domNode.className=this._className)},e.prototype.toggleClassName=function(e,t){i.toggleClass(this.domNode,e,t),this._className=this.domNode.className},e.prototype.setDisplay=function(e){this._display!==e&&(this._display=e,this.domNode.style.display=this._display)},e.prototype.setPosition=function(e){this._position!==e&&(this._position=e,this.domNode.style.position=this._position)},e.prototype.setVisibility=function(e){this._visibility!==e&&(this._visibility=e,this.domNode.style.visibility=this._visibility)},e.prototype.setLayerHinting=function(e){this._layerHint!==e&&(this._layerHint=e,this.domNode.style.willChange=this._layerHint?"transform":"auto")},e.prototype.setAttribute=function(e,t){this.domNode.setAttribute(e,t)},e.prototype.removeAttribute=function(e){this.domNode.removeAttribute(e)},e.prototype.appendChild=function(e){this.domNode.appendChild(e.domNode)},
e.prototype.removeChild=function(e){this.domNode.removeChild(e.domNode)},e}();t.FastDomNode=n,t.createFastDomNode=function(e){return new n(e)}}),define(t[116],i([1,0,8]),function(e,t,i){"use strict";function n(e,t){void 0===t&&(t={});var i=o(t);return r(i,function(e){var t={type:1,children:[]},i=0,n=t,o=[],r=new a(e);for(;!r.eos();){var l=r.next(),u="\\"===l&&0!==s(r.peek());if(u&&(l=r.next()),!u&&function(e){return 0!==s(e)}(l)&&l===r.peek()){r.advance(),2===n.type&&(n=o.pop());var d=s(l);if(n.type===d||5===n.type&&6===d)n=o.pop();else{var c={type:d,children:[]};5===d&&(c.index=i,i++),n.children.push(c),o.push(n),n=c}}else if("\n"===l)2===n.type&&(n=o.pop()),n.children.push({type:7});else if(2!==n.type){var h={type:2,content:l};n.children.push(h),o.push(n),n=h}else n.content+=l}2===n.type&&(n=o.pop());o.length;return t}(e),t.actionHandler),i}function o(e){var t=e.inline?"span":"div",i=document.createElement(t);return e.className&&(i.className=e.className),i}function r(e,t,n){var o
;if(2===t.type)o=document.createTextNode(t.content||"");else if(3===t.type)o=document.createElement("b");else if(4===t.type)o=document.createElement("i");else if(5===t.type&&n){var s=document.createElement("a");s.href="#",n.disposeables.add(i.addStandardDisposableListener(s,"click",function(e){n.callback(String(t.index),e)})),o=s}else 7===t.type?o=document.createElement("br"):1===t.type&&(o=e);o&&e!==o&&e.appendChild(o),o&&Array.isArray(t.children)&&t.children.forEach(function(e){r(o,e,n)})}function s(e){switch(e){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;default:return 0}}Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=function(e,t){void 0===t&&(t={});var i=o(t);return i.textContent=e,i},t.renderFormattedText=n,t.createElement=o;var a=function(){function e(e){this.source=e,this.index=0}return e.prototype.eos=function(){return this.index>=this.source.length},e.prototype.next=function(){var e=this.peek();return this.advance(),e},e.prototype.peek=function(){
return this.source[this.index]},e.prototype.advance=function(){this.index++},e}()}),define(t[82],i([1,0,8,165,44,2]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.standardMouseMoveMerger=function(e,t){var i=new o.StandardMouseEvent(t);return i.preventDefault(),{leftButton:i.leftButton,posx:i.posx,posy:i.posy}};var s=function(){function e(){this.hooks=new r.DisposableStore,this.mouseMoveEventMerger=null,this.mouseMoveCallback=null,this.onStopCallback=null}return e.prototype.dispose=function(){this.stopMonitoring(!1),this.hooks.dispose()},e.prototype.stopMonitoring=function(e){if(this.isMonitoring()){this.hooks.clear(),this.mouseMoveEventMerger=null,this.mouseMoveCallback=null;var t=this.onStopCallback;this.onStopCallback=null,e&&t&&t()}},e.prototype.isMonitoring=function(){return!!this.mouseMoveEventMerger},e.prototype.startMonitoring=function(e,t,r){var s=this;if(!this.isMonitoring()){this.mouseMoveEventMerger=e,this.mouseMoveCallback=t,this.onStopCallback=r
;for(var a=n.IframeUtils.getSameOriginWindowChain(),l=0,u=a;l<u.length;l++){var d=u[l];this.hooks.add(i.addDisposableThrottledListener(d.window.document,"mousemove",function(e){return s.mouseMoveCallback(e)},function(e,t){return s.mouseMoveEventMerger(e,t)})),this.hooks.add(i.addDisposableListener(d.window.document,"mouseup",function(e){return s.stopMonitoring(!0)}))}if(n.IframeUtils.hasDifferentOriginAncestor()){var c=a[a.length-1];this.hooks.add(i.addDisposableListener(c.window.document,"mouseout",function(e){"html"===new o.StandardMouseEvent(e).target.tagName.toLowerCase()&&s.stopMonitoring(!0)})),this.hooks.add(i.addDisposableListener(c.window.document,"mouseover",function(e){"html"===new o.StandardMouseEvent(e).target.tagName.toLowerCase()&&s.stopMonitoring(!0)})),this.hooks.add(i.addDisposableListener(c.window.document.body,"mouseleave",function(e){s.stopMonitoring(!0)}))}}},e}();t.GlobalMouseMoveMonitor=s}),define(t[475],i([1,0,8,116,10,78,149,599,600,205,29,5,24]),function(e,t,i,n,o,r,s,a,l,u,d,c,h){
"use strict";function p(e,t){void 0===t&&(t={});var p,f=n.createElement(t),g=function(t,n){var o=e.uris&&e.uris[t];if(!o)return t;var r=h.URI.revive(o);return n&&(r=i.asDomUri(r)),r.query&&(r=r.with({query:function(t){var i;try{i=u.parse(decodeURIComponent(t))}catch(e){}return i?(i=d.cloneAndChange(i,function(t){return e.uris&&e.uris[t]?h.URI.revive(e.uris[t]):void 0}),encodeURIComponent(JSON.stringify(i))):t}(r.query)})),o&&(t=r.toString(!0)),t},m=new Promise(function(e){return p=e}),v=new a.Renderer;v.image=function(e,t,i){var n,o=[],s=[];return e&&(e=(n=r.parseHrefAndDimensions(e)).href,o=n.dimensions,e=g(e,!0),s.push('src="'+e+'"')),i&&s.push('alt="'+i+'"'),t&&s.push('title="'+t+'"'),o.length&&(s=s.concat(o)),"<img "+s.join(" ")+">"},v.link=function(t,i,n){return t===n&&(n=r.removeMarkdownEscapes(n)),t=g(t,!1),i=r.removeMarkdownEscapes(i),
!(t=r.removeMarkdownEscapes(t))||t.match(/^data:|javascript:/i)||t.match(/^command:/i)&&!e.isTrusted||t.match(/^command:(\/\/\/)?_workbench\.downloadResource/i)?n:'<a href="#" data-href="'+(t=t.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"))+'" title="'+(i||t)+'">'+n+"</a>"},v.paragraph=function(e){return"<p>"+e+"</p>"},t.codeBlockRenderer&&(v.code=function(e,i){var n=t.codeBlockRenderer(i,e),o=s.defaultGenerator.nextId(),r=Promise.all([n,m]).then(function(e){var t=e[0],i=f.querySelector('div[data-code="'+o+'"]');i&&(i.innerHTML=t)}).catch(function(e){});return t.codeBlockRenderCallback&&r.then(t.codeBlockRenderCallback),'<div class="code" data-code="'+o+'">'+c.escape(e)+"</div>"});var _=t.actionHandler;_&&_.disposeables.add(i.addStandardDisposableListener(f,"click",function(e){var t=e.target;if("A"===t.tagName||(t=t.parentElement)&&"A"===t.tagName)try{var i=t.dataset.href;i&&_.callback(i,e)}catch(e){o.onUnexpectedError(e)}finally{
e.preventDefault()}}));var y={sanitize:!0,renderer:v},b=["http","https","mailto","data"];e.isTrusted&&b.push("command");var C=a.parse(e.value,y);return f.innerHTML=l.insane(C,{allowedSchemes:b,allowedAttributes:{a:["href","name","target","data-href"],iframe:["allowfullscreen","frameborder","src"],img:["src","title","alt","width","height"],div:["class","data-code"]}}),p(),f}Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdown=p});var d=this&&this.__decorate||function(e,t,i,n){var o,r=arguments.length,s=r<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(r<3?o(s):r>3?o(t,i,s):o(t,i))||s);return r>3&&s&&Object.defineProperty(t,i,s),s};define(t[79],i([1,0,19,2,8,115]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){e.Tap="-monaco-gesturetap",e.Change="-monaco-gesturechange",
e.Start="-monaco-gesturestart",e.End="-monaco-gesturesend",e.Contextmenu="-monaco-gesturecontextmenu"}(a=t.EventType||(t.EventType={}));var l=function(e){function t(){var t=e.call(this)||this;return t.dispatched=!1,t.activeTouches={},t.handle=null,t.targets=[],t._register(o.addDisposableListener(document,"touchstart",function(e){return t.onTouchStart(e)})),t._register(o.addDisposableListener(document,"touchend",function(e){return t.onTouchEnd(e)})),t._register(o.addDisposableListener(document,"touchmove",function(e){return t.onTouchMove(e)})),t}return r(t,e),t.addTarget=function(e){t.isTouchDevice()&&(t.INSTANCE||(t.INSTANCE=new t),t.INSTANCE.targets.push(e))},t.isTouchDevice=function(){return"ontouchstart"in window||navigator.maxTouchPoints>0||window.navigator.msMaxTouchPoints>0},t.prototype.dispose=function(){this.handle&&(this.handle.dispose(),this.handle=null),e.prototype.dispose.call(this)},t.prototype.onTouchStart=function(e){var t=Date.now();this.handle&&(this.handle.dispose(),this.handle=null)
;for(var i=0,n=e.targetTouches.length;i<n;i++){var o=e.targetTouches.item(i);this.activeTouches[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:t,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[t],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};var r=this.newGestureEvent(a.Start,o.target);r.pageX=o.pageX,r.pageY=o.pageY,this.dispatchEvent(r)}this.dispatched&&(e.preventDefault(),e.stopPropagation(),this.dispatched=!1)},t.prototype.onTouchEnd=function(e){for(var n=Date.now(),o=Object.keys(this.activeTouches).length,r=function(r,l){var u=e.changedTouches.item(r);if(!s.activeTouches.hasOwnProperty(String(u.identifier)))return console.warn("move of an UNKNOWN touch",u),"continue";var d=s.activeTouches[u.identifier],c=Date.now()-d.initialTimeStamp;if(c<t.HOLD_DELAY&&Math.abs(d.initialPageX-i.tail(d.rollingPageX))<30&&Math.abs(d.initialPageY-i.tail(d.rollingPageY))<30){(h=s.newGestureEvent(a.Tap,d.initialTarget)).pageX=i.tail(d.rollingPageX),h.pageY=i.tail(d.rollingPageY),
s.dispatchEvent(h)}else if(c>=t.HOLD_DELAY&&Math.abs(d.initialPageX-i.tail(d.rollingPageX))<30&&Math.abs(d.initialPageY-i.tail(d.rollingPageY))<30){var h=s.newGestureEvent(a.Contextmenu,d.initialTarget);h.pageX=i.tail(d.rollingPageX),h.pageY=i.tail(d.rollingPageY),s.dispatchEvent(h)}else if(1===o){var p=i.tail(d.rollingPageX),f=i.tail(d.rollingPageY),g=i.tail(d.rollingTimestamps)-d.rollingTimestamps[0],m=p-d.rollingPageX[0],v=f-d.rollingPageY[0],_=s.targets.filter(function(e){return d.initialTarget instanceof Node&&e.contains(d.initialTarget)});s.inertia(_,n,Math.abs(m)/g,m>0?1:-1,p,Math.abs(v)/g,v>0?1:-1,f)}s.dispatchEvent(s.newGestureEvent(a.End,d.initialTarget)),delete s.activeTouches[u.identifier]},s=this,l=0,u=e.changedTouches.length;l<u;l++)r(l);this.dispatched&&(e.preventDefault(),e.stopPropagation(),this.dispatched=!1)},t.prototype.newGestureEvent=function(e,t){var i=document.createEvent("CustomEvent");return i.initEvent(e,!1,!0),i.initialTarget=t,i},t.prototype.dispatchEvent=function(e){var t=this
;this.targets.forEach(function(i){e.initialTarget instanceof Node&&i.contains(e.initialTarget)&&(i.dispatchEvent(e),t.dispatched=!0)})},t.prototype.inertia=function(e,i,n,r,s,l,u,d){var c=this;this.handle=o.scheduleAtNextAnimationFrame(function(){var o=Date.now(),h=o-i,p=0,f=0,g=!0;l+=t.SCROLL_FRICTION*h,(n+=t.SCROLL_FRICTION*h)>0&&(g=!1,p=r*n*h),l>0&&(g=!1,f=u*l*h);var m=c.newGestureEvent(a.Change);m.translationX=p,m.translationY=f,e.forEach(function(e){return e.dispatchEvent(m)}),g||c.inertia(e,o,n,r,s+p,l,u,d+f)})},t.prototype.onTouchMove=function(e){for(var t=Date.now(),n=0,o=e.changedTouches.length;n<o;n++){var r=e.changedTouches.item(n);if(this.activeTouches.hasOwnProperty(String(r.identifier))){var s=this.activeTouches[r.identifier],l=this.newGestureEvent(a.Change,s.initialTarget);l.translationX=r.pageX-i.tail(s.rollingPageX),l.translationY=r.pageY-i.tail(s.rollingPageY),l.pageX=r.pageX,l.pageY=r.pageY,this.dispatchEvent(l),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),
s.rollingTimestamps.shift()),s.rollingPageX.push(r.pageX),s.rollingPageY.push(r.pageY),s.rollingTimestamps.push(t)}else console.warn("end of an UNKNOWN touch",r)}this.dispatched&&(e.preventDefault(),e.stopPropagation(),this.dispatched=!1)},t.SCROLL_FRICTION=-.005,t.HOLD_DELAY=700,d([s.memoize],t,"isTouchDevice",null),t}(n.Disposable);t.Gesture=l}),define(t[471],i([1,0,8]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.renderers=e,this.cache=new Map}return e.prototype.alloc=function(e){var t=this.getTemplateCache(e).pop();if(!t){var n=i.$(".monaco-list-row");t={domNode:n,templateId:e,templateData:this.getRenderer(e).renderTemplate(n)}}return t},e.prototype.release=function(e){e&&this.releaseRow(e)},e.prototype.releaseRow=function(e){var t=e.domNode,n=e.templateId;t&&(i.removeClass(t,"scrolling"),function(e){try{e.parentElement&&e.parentElement.removeChild(e)}catch(e){}}(t));this.getTemplateCache(n).push(e)},
e.prototype.getTemplateCache=function(e){var t=this.cache.get(e);return t||(t=[],this.cache.set(e,t)),t},e.prototype.garbageCollect=function(){var e=this;this.renderers&&(this.cache.forEach(function(t,i){for(var n=0,o=t;n<o.length;n++){var r=o[n];e.getRenderer(i).disposeTemplate(r.templateData),r.domNode=null,r.templateData=null}}),this.cache.clear())},e.prototype.dispose=function(){this.garbageCollect(),this.cache.clear(),this.renderers=null},e.prototype.getRenderer=function(e){var t=this.renderers.get(e);if(!t)throw new Error("No renderer found for "+e);return t},e}();t.RowCache=n}),define(t[45],i([1,0,8,57,44,2]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.onclick=function(e,t){this._register(i.addDisposableListener(e,i.EventType.CLICK,function(e){return t(new o.StandardMouseEvent(e))}))},t.prototype.onmousedown=function(e,t){
this._register(i.addDisposableListener(e,i.EventType.MOUSE_DOWN,function(e){return t(new o.StandardMouseEvent(e))}))},t.prototype.onmouseover=function(e,t){this._register(i.addDisposableListener(e,i.EventType.MOUSE_OVER,function(e){return t(new o.StandardMouseEvent(e))}))},t.prototype.onnonbubblingmouseout=function(e,t){this._register(i.addDisposableNonBubblingMouseOutListener(e,function(e){return t(new o.StandardMouseEvent(e))}))},t.prototype.onkeydown=function(e,t){this._register(i.addDisposableListener(e,i.EventType.KEY_DOWN,function(e){return t(new n.StandardKeyboardEvent(e))}))},t.prototype.onkeyup=function(e,t){this._register(i.addDisposableListener(e,i.EventType.KEY_UP,function(e){return t(new n.StandardKeyboardEvent(e))}))},t.prototype.oninput=function(e,t){this._register(i.addDisposableListener(e,i.EventType.INPUT,t))},t.prototype.onblur=function(e,t){this._register(i.addDisposableListener(e,i.EventType.BLUR,t))},t.prototype.onfocus=function(e,t){
this._register(i.addDisposableListener(e,i.EventType.FOCUS,t))},t.prototype.onchange=function(e,t){this._register(i.addDisposableListener(e,i.EventType.CHANGE,t))},t}(s.Disposable);t.Widget=a}),define(t[133],i([1,0,82,45,15]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ARROW_IMG_SIZE=11;var s=function(e){function n(n){var r=e.call(this)||this;return r._onActivate=n.onActivate,r.bgDomNode=document.createElement("div"),r.bgDomNode.className="arrow-background",r.bgDomNode.style.position="absolute",r.bgDomNode.style.width=n.bgWidth+"px",r.bgDomNode.style.height=n.bgHeight+"px",void 0!==n.top&&(r.bgDomNode.style.top="0px"),void 0!==n.left&&(r.bgDomNode.style.left="0px"),void 0!==n.bottom&&(r.bgDomNode.style.bottom="0px"),void 0!==n.right&&(r.bgDomNode.style.right="0px"),r.domNode=document.createElement("div"),r.domNode.className=n.className,r.domNode.style.position="absolute",r.domNode.style.width=t.ARROW_IMG_SIZE+"px",r.domNode.style.height=t.ARROW_IMG_SIZE+"px",
void 0!==n.top&&(r.domNode.style.top=n.top+"px"),void 0!==n.left&&(r.domNode.style.left=n.left+"px"),void 0!==n.bottom&&(r.domNode.style.bottom=n.bottom+"px"),void 0!==n.right&&(r.domNode.style.right=n.right+"px"),r._mouseMoveMonitor=r._register(new i.GlobalMouseMoveMonitor),r.onmousedown(r.bgDomNode,function(e){return r._arrowMouseDown(e)}),r.onmousedown(r.domNode,function(e){return r._arrowMouseDown(e)}),r._mousedownRepeatTimer=r._register(new o.IntervalTimer),r._mousedownScheduleRepeatTimer=r._register(new o.TimeoutTimer),r}return r(n,e),n.prototype._arrowMouseDown=function(e){var t=this;this._onActivate(),this._mousedownRepeatTimer.cancel(),this._mousedownScheduleRepeatTimer.cancelAndSet(function(){t._mousedownRepeatTimer.cancelAndSet(function(){return t._onActivate()},1e3/24)},200),this._mouseMoveMonitor.startMonitoring(i.standardMouseMoveMerger,function(e){},function(){t._mousedownRepeatTimer.cancel(),t._mousedownScheduleRepeatTimer.cancel()}),e.preventDefault()},n}(n.Widget);t.ScrollbarArrow=s}),
define(t[204],i([1,0,8,27,82,133,541,45,18]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(t){var i=e.call(this)||this;return i._lazyRender=t.lazyRender,i._host=t.host,i._scrollable=t.scrollable,i._scrollbarState=t.scrollbarState,i._visibilityController=i._register(new a.ScrollbarVisibilityController(t.visibility,"visible scrollbar "+t.extraScrollbarClassName,"invisible scrollbar "+t.extraScrollbarClassName)),i._mouseMoveMonitor=i._register(new o.GlobalMouseMoveMonitor),i._shouldRender=!0,i.domNode=n.createFastDomNode(document.createElement("div")),i.domNode.setAttribute("role","presentation"),i.domNode.setAttribute("aria-hidden","true"),i._visibilityController.setDomNode(i.domNode),i.domNode.setPosition("absolute"),i.onmousedown(i.domNode.domNode,function(e){return i._domNodeMouseDown(e)}),i}return r(t,e),t.prototype._createArrow=function(e){var t=this._register(new s.ScrollbarArrow(e));this.domNode.domNode.appendChild(t.bgDomNode),
this.domNode.domNode.appendChild(t.domNode)},t.prototype._createSlider=function(e,t,i,o){var r=this;this.slider=n.createFastDomNode(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(e),this.slider.setLeft(t),"number"==typeof i&&this.slider.setWidth(i),"number"==typeof o&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.domNode.domNode.appendChild(this.slider.domNode),this.onmousedown(this.slider.domNode,function(e){e.leftButton&&(e.preventDefault(),r._sliderMouseDown(e,function(){}))}),this.onclick(this.slider.domNode,function(e){e.leftButton&&e.stopPropagation()})},t.prototype._onElementSize=function(e){return this._scrollbarState.setVisibleSize(e)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype._onElementScrollSize=function(e){
return this._scrollbarState.setScrollSize(e)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype._onElementScrollPosition=function(e){return this._scrollbarState.setScrollPosition(e)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype.beginReveal=function(){this._visibilityController.setShouldBeVisible(!0)},t.prototype.beginHide=function(){this._visibilityController.setShouldBeVisible(!1)},t.prototype.render=function(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))},t.prototype._domNodeMouseDown=function(e){
e.target===this.domNode.domNode&&this._onMouseDown(e)},t.prototype.delegateMouseDown=function(e){var t=this.domNode.domNode.getClientRects()[0].top,i=t+this._scrollbarState.getSliderPosition(),n=t+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),o=this._sliderMousePosition(e);i<=o&&o<=n?e.leftButton&&(e.preventDefault(),this._sliderMouseDown(e,function(){})):this._onMouseDown(e)},t.prototype._onMouseDown=function(e){var t,n;if(e.target===this.domNode.domNode&&"number"==typeof e.browserEvent.offsetX&&"number"==typeof e.browserEvent.offsetY)t=e.browserEvent.offsetX,n=e.browserEvent.offsetY;else{var o=i.getDomNodePagePosition(this.domNode.domNode);t=e.posx-o.left,n=e.posy-o.top}this._setDesiredScrollPositionNow(this._scrollbarState.getDesiredScrollPositionFromOffset(this._mouseDownRelativePosition(t,n))),e.leftButton&&(e.preventDefault(),this._sliderMouseDown(e,function(){}))},t.prototype._sliderMouseDown=function(e,t){
var i=this,n=this._sliderMousePosition(e),r=this._sliderOrthogonalMousePosition(e),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._mouseMoveMonitor.startMonitoring(o.standardMouseMoveMerger,function(e){var t=i._sliderOrthogonalMousePosition(e),o=Math.abs(t-r);if(u.isWindows&&o>140)i._setDesiredScrollPositionNow(s.getScrollPosition());else{var a=i._sliderMousePosition(e)-n;i._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(a))}},function(){i.slider.toggleClassName("active",!1),i._host.onDragEnd(),t()}),this._host.onDragStart()},t.prototype._setDesiredScrollPositionNow=function(e){var t={};this.writeScrollPosition(t,e),this._scrollable.setScrollPositionNow(t)},t}(l.Widget);t.AbstractScrollbar=d}),define(t[463],i([1,0,44,204,133,225]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t,n,r){var a=e.call(this,{lazyRender:n.lazyRender,host:r,
scrollbarState:new s.ScrollbarState(n.horizontalHasArrows?n.arrowSize:0,2===n.horizontal?0:n.horizontalScrollbarSize,2===n.vertical?0:n.verticalScrollbarSize),visibility:n.horizontal,extraScrollbarClassName:"horizontal",scrollable:t})||this;if(n.horizontalHasArrows){var l=(n.arrowSize-o.ARROW_IMG_SIZE)/2,u=(n.horizontalScrollbarSize-o.ARROW_IMG_SIZE)/2;a._createArrow({className:"left-arrow",top:u,left:l,bottom:void 0,right:void 0,bgWidth:n.arrowSize,bgHeight:n.horizontalScrollbarSize,onActivate:function(){return a._host.onMouseWheel(new i.StandardWheelEvent(null,1,0))}}),a._createArrow({className:"right-arrow",top:u,left:void 0,bottom:void 0,right:l,bgWidth:n.arrowSize,bgHeight:n.horizontalScrollbarSize,onActivate:function(){return a._host.onMouseWheel(new i.StandardWheelEvent(null,-1,0))}})}return a._createSlider(Math.floor((n.horizontalScrollbarSize-n.horizontalSliderSize)/2),0,void 0,n.horizontalSliderSize),a}return r(t,e),t.prototype._updateSlider=function(e,t){this.slider.setWidth(e),
this.slider.setLeft(t)},t.prototype._renderDomNode=function(e,t){this.domNode.setWidth(e),this.domNode.setHeight(t),this.domNode.setLeft(0),this.domNode.setBottom(0)},t.prototype.onDidScroll=function(e){return this._shouldRender=this._onElementScrollSize(e.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(e.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(e.width)||this._shouldRender,this._shouldRender},t.prototype._mouseDownRelativePosition=function(e,t){return e},t.prototype._sliderMousePosition=function(e){return e.posx},t.prototype._sliderOrthogonalMousePosition=function(e){return e.posy},t.prototype.writeScrollPosition=function(e,t){e.scrollLeft=t},t}(n.AbstractScrollbar);t.HorizontalScrollbar=a}),define(t[458],i([1,0,44,204,133,225]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t,n,r){var a=e.call(this,{lazyRender:n.lazyRender,host:r,
scrollbarState:new s.ScrollbarState(n.verticalHasArrows?n.arrowSize:0,2===n.vertical?0:n.verticalScrollbarSize,0),visibility:n.vertical,extraScrollbarClassName:"vertical",scrollable:t})||this;if(n.verticalHasArrows){var l=(n.arrowSize-o.ARROW_IMG_SIZE)/2,u=(n.verticalScrollbarSize-o.ARROW_IMG_SIZE)/2;a._createArrow({className:"up-arrow",top:l,left:u,bottom:void 0,right:void 0,bgWidth:n.verticalScrollbarSize,bgHeight:n.arrowSize,onActivate:function(){return a._host.onMouseWheel(new i.StandardWheelEvent(null,0,1))}}),a._createArrow({className:"down-arrow",top:void 0,left:u,bottom:l,right:void 0,bgWidth:n.verticalScrollbarSize,bgHeight:n.arrowSize,onActivate:function(){return a._host.onMouseWheel(new i.StandardWheelEvent(null,0,-1))}})}return a._createSlider(0,Math.floor((n.verticalScrollbarSize-n.verticalSliderSize)/2),n.verticalSliderSize,void 0),a}return r(t,e),t.prototype._updateSlider=function(e,t){this.slider.setHeight(e),this.slider.setTop(t)},t.prototype._renderDomNode=function(e,t){
this.domNode.setWidth(t),this.domNode.setHeight(e),this.domNode.setRight(0),this.domNode.setTop(0)},t.prototype.onDidScroll=function(e){return this._shouldRender=this._onElementScrollSize(e.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(e.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(e.height)||this._shouldRender,this._shouldRender},t.prototype._mouseDownRelativePosition=function(e,t){return t},t.prototype._sliderMousePosition=function(e){return e.posy},t.prototype._sliderOrthogonalMousePosition=function(e){return e.posx},t.prototype.writeScrollPosition=function(e,t){e.scrollTop=t},t}(n.AbstractScrollbar);t.VerticalScrollbar=a}),define(t[48],i([1,0,214,83,24,5,50,18]),function(e,t,i,n,o,r,s,a){"use strict";function l(e){return!e||e.scheme!==s.Schemas.file||!a.isLinux}function u(e,t){return e===t||r.equalsIgnoreCase(e,t)}function d(e){return n.posix.basename(e.path)}function c(e){var t,n=e.path
;return t=e.authority&&n.length>1&&e.scheme===s.Schemas.file?"//"+e.authority+n:a.isWindows&&47===n.charCodeAt(0)&&i.isWindowsDriveLetter(n.charCodeAt(1))&&58===n.charCodeAt(2)?n.substr(1):n,a.isWindows&&(t=t.replace(/\//g,"\\")),t}Object.defineProperty(t,"__esModule",{value:!0}),t.hasToIgnoreCase=l,t.basenameOrAuthority=function(e){return d(e)||e.authority},t.isEqualAuthority=u,t.isEqual=function(e,t,i){if(void 0===i&&(i=l(e)),e===t)return!0;if(!e||!t)return!1;if(e.scheme!==t.scheme||!u(e.authority,t.authority))return!1;var n=e.path||"/",o=t.path||"/";return n===o||i&&r.equalsIgnoreCase(n||"/",o||"/")},t.basename=d,t.dirname=function(e){if(0===e.path.length)return e;if(e.scheme===s.Schemas.file)return o.URI.file(n.dirname(c(e)));var t=n.posix.dirname(e.path);return e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error('dirname("'+e.toString+")) resulted in a relative path"),t="/"),e.with({path:t})},t.joinPath=function(e){for(var t,i=[],r=1;r<arguments.length;r++)i[r-1]=arguments[r];var a
;return a=e.scheme===s.Schemas.file?o.URI.file(n.join.apply(n,[c(e)].concat(i))).path:(t=n.posix).join.apply(t,[e.path||"/"].concat(i)),e.with({path:a})},t.normalizePath=function(e){if(!e.path.length)return e;var t;return t=e.scheme===s.Schemas.file?o.URI.file(n.normalize(c(e))).path:n.posix.normalize(e.path),e.with({path:t})},t.originalFSPath=c,t.relativePath=function(e,t,o){if(void 0===o&&(o=l(e)),e.scheme===t.scheme&&u(e.authority,t.authority)){if(e.scheme===s.Schemas.file){var r=n.relative(e.path,t.path);return a.isWindows?i.toSlashes(r):r}var d=e.path||"/",c=t.path||"/";if(o){for(var h=0,p=Math.min(d.length,c.length);h<p&&(d.charCodeAt(h)===c.charCodeAt(h)||d.charAt(h).toLowerCase()===c.charAt(h).toLowerCase());h++);d=c.substr(0,h)+d.substr(h)}return n.posix.relative(d,c)}};!function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){var i=new Map
;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(function(e){var t=e.split(":"),n=t[0],o=t[1];n&&o&&i.set(n,o)});var n=t.path.substring(0,t.path.indexOf(";"));return n&&i.set(e.META_DATA_MIME,n),i}}(t.DataUri||(t.DataUri={}))}),define(t[203],i([1,0,24,83,5,50,18,48]),function(e,t,i,n,o,r,s,a){"use strict";function l(e){return!(!s.isWindows||!e||":"!==e[1])}function u(e){return l(e)?e.charAt(0).toUpperCase()+e.slice(1):e}function d(e,t){if(s.isWindows||!e||!t)return e;var i=c.original===t?c.normalized:void 0;return i||(i=""+o.rtrim(t,n.posix.sep)+n.posix.sep,c={original:t,normalized:i}),(s.isLinux?o.startsWith(e,i):o.startsWithIgnoreCase(e,i))&&(e="~/"+e.substr(i.length)),e}Object.defineProperty(t,"__esModule",{value:!0}),t.getPathLabel=function(e,t,o){if("string"==typeof e&&(e=i.URI.file(e)),o){var c=o.getWorkspaceFolder(e);if(c){var h=o.getWorkspace().folders.length>1,p=void 0;if(p=a.isEqual(c.uri,e)?"":a.relativePath(c.uri,e),h){var f=c&&c.name?c.name:a.basename(c.uri)
;p=p?f+" • "+p:f}return p}}if(e.scheme!==r.Schemas.file&&e.scheme!==r.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(l(e.fsPath))return n.normalize(u(e.fsPath));var g=n.normalize(e.fsPath);return!s.isWindows&&t&&(g=d(g,t.userHome)),g},t.getBaseLabel=function(e){if(e){"string"==typeof e&&(e=i.URI.file(e));var t=a.basename(e)||(e.scheme===r.Schemas.file?e.fsPath:e.path);return l(t)?u(t):t}},t.normalizeDriveLetter=u;var c=Object.create(null);t.tildify=d}),define(t[456],i([1,0,83,5,211,50,48]),function(e,t,i,n,o,r,s){"use strict";function a(e,t){void 0===t&&(t=!1);var n=function(e){return{id:e.id,mime:e.mime,filename:e.filename,extension:e.extension,filepattern:e.filepattern,firstline:e.firstline,userConfigured:e.userConfigured,filenameLowercase:e.filename?e.filename.toLowerCase():void 0,extensionLowercase:e.extension?e.extension.toLowerCase():void 0,filepatternLowercase:e.filepattern?e.filepattern.toLowerCase():void 0,
filepatternOnPath:!!e.filepattern&&e.filepattern.indexOf(i.posix.sep)>=0}}(e);d.push(n),n.userConfigured?h.push(n):c.push(n),t&&!n.userConfigured&&d.forEach(function(e){e.mime===n.mime||e.userConfigured||(n.extension&&e.extension===n.extension&&console.warn("Overwriting extension <<"+n.extension+">> to now point to mime <<"+n.mime+">>"),n.filename&&e.filename===n.filename&&console.warn("Overwriting filename <<"+n.filename+">> to now point to mime <<"+n.mime+">>"),n.filepattern&&e.filepattern===n.filepattern&&console.warn("Overwriting filepattern <<"+n.filepattern+">> to now point to mime <<"+n.mime+">>"),n.firstline&&e.firstline===n.firstline&&console.warn("Overwriting firstline <<"+n.firstline+">> to now point to mime <<"+n.mime+">>"))})}function l(e,o){var a;if(e)switch(e.scheme){case r.Schemas.file:a=e.fsPath;break;case r.Schemas.data:a=s.DataUri.parseMetaData(e).get(s.DataUri.META_DATA_LABEL);break;default:a=e.path}if(!a)return[t.MIME_UNKNOWN];a=a.toLowerCase();var l=i.basename(a),p=u(a,l,h)
;if(p)return[p,t.MIME_TEXT];var f=u(a,l,c);if(f)return[f,t.MIME_TEXT];if(o){var g=function(e){n.startsWithUTF8BOM(e)&&(e=e.substr(1));if(e.length>0)for(var t=d.length-1;t>=0;t--){var i=d[t];if(i.firstline){var o=e.match(i.firstline);if(o&&o.length>0)return i.mime}}return null}(o);if(g)return[g,t.MIME_TEXT]}return[t.MIME_UNKNOWN]}function u(e,t,i){for(var r=null,s=null,a=null,l=i.length-1;l>=0;l--){var u=i[l];if(t===u.filenameLowercase){r=u;break}if(u.filepattern&&(!s||u.filepattern.length>s.filepattern.length)){var d=u.filepatternOnPath?e:t;o.match(u.filepatternLowercase,d)&&(s=u)}u.extension&&(!a||u.extension.length>a.extension.length)&&n.endsWith(t,u.extensionLowercase)&&(a=u)}return r?r.mime:s?s.mime:a?a.mime:null}Object.defineProperty(t,"__esModule",{value:!0}),t.MIME_TEXT="text/plain",t.MIME_UNKNOWN="application/unknown";var d=[],c=[],h=[];t.registerTextMime=a,t.guessMimeTypes=l}),define(t[201],i([1,0,10,2,18,23]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var a="$initialize",l=!1;t.logOnceWebWorkerWarning=function(e){o.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(e.message))};var u=function(){function e(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(e){this._workerId=e},e.prototype.sendMessage=function(e,t){var i=this,n=String(++this._lastSentReq);return new Promise(function(o,r){i._pendingReplies[n]={resolve:o,reject:r},i._send({vsWorker:i._workerId,req:n,method:e,args:t})})},e.prototype.handleMessage=function(e){e&&e.vsWorker&&(-1!==this._workerId&&e.vsWorker!==this._workerId||this._handleMessage(e))},e.prototype._handleMessage=function(e){var t=this;if(e.seq){var n=e;if(!this._pendingReplies[n.seq])return void console.warn("Got reply to unknown seq");var o=this._pendingReplies[n.seq]
;if(delete this._pendingReplies[n.seq],n.err){var r=n.err;return n.err.$isError&&((r=new Error).name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),void o.reject(r)}o.resolve(n.res)}else{var s=e,a=s.req;this._handler.handleMessage(s.method,s.args).then(function(e){t._send({vsWorker:t._workerId,seq:a,res:e,err:void 0})},function(e){e.detail instanceof Error&&(e.detail=i.transformErrorForSerialization(e.detail)),t._send({vsWorker:t._workerId,seq:a,res:void 0,err:i.transformErrorForSerialization(e)})})}},e.prototype._send=function(e){var t=[];if(e.req)for(var i=e,n=0;n<i.args.length;n++)i.args[n]instanceof ArrayBuffer&&t.push(i.args[n]);else{(i=e).res instanceof ArrayBuffer&&t.push(i.res)}this._handler.sendMessage(e,t)},e}(),d=function(e){function t(t,i,n){var o=e.call(this)||this,r=null;o._worker=o._register(t.create("vs/base/common/worker/simpleWorker",function(e){o._protocol.handleMessage(e)},function(e){r&&r(e)})),o._protocol=new u({sendMessage:function(e,t){o._worker.postMessage(e,t)},
handleMessage:function(e,t){if("function"!=typeof n[e])return Promise.reject(new Error("Missing method "+e+" on main thread host."));try{return Promise.resolve(n[e].apply(n,t))}catch(e){return Promise.reject(e)}}}),o._protocol.setWorkerId(o._worker.getId());var l=null;void 0!==self.require&&"function"==typeof self.require.getConfig?l=self.require.getConfig():void 0!==self.requirejs&&(l=self.requirejs.s.contexts._.config);var d=s.getAllMethodNames(n);o._onModuleLoaded=o._protocol.sendMessage(a,[o._worker.getId(),JSON.parse(JSON.stringify(l)),i,d]);var c=function(e,t){return o._request(e,t)};return o._lazyProxy=new Promise(function(e,t){r=t,o._onModuleLoaded.then(function(t){e(s.createProxyObject(t,c))},function(e){t(e),o._onError("Worker failed to load "+i,e)})}),o}return r(t,e),t.prototype.getProxyObject=function(){return this._lazyProxy},t.prototype._request=function(e,t){var i=this;return new Promise(function(n,o){i._onModuleLoaded.then(function(){i._protocol.sendMessage(e,t).then(n,o)},o)})},
t.prototype._onError=function(e,t){console.error(e),console.info(t)},t}(n.Disposable);t.SimpleWorkerClient=d;var c=function(){function e(e,t){var i=this;this._requestHandlerFactory=t,this._requestHandler=null,this._protocol=new u({sendMessage:function(t,i){e(t,i)},handleMessage:function(e,t){return i._handleMessage(e,t)}})}return e.prototype.onmessage=function(e){this._protocol.handleMessage(e)},e.prototype._handleMessage=function(e,t){if(e===a)return this.initialize(t[0],t[1],t[2],t[3]);if(!this._requestHandler||"function"!=typeof this._requestHandler[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._requestHandler[e].apply(this._requestHandler,t))}catch(e){return Promise.reject(e)}},e.prototype.initialize=function(e,t,i,n){var o=this;this._protocol.setWorkerId(e);var r=s.createProxyObject(n,function(e,t){return o._protocol.sendMessage(e,t)});return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(r),
Promise.resolve(s.getAllMethodNames(this._requestHandler))):(t&&(void 0!==t.baseUrl&&delete t.baseUrl,void 0!==t.paths&&void 0!==t.paths.vs&&delete t.paths.vs,t.catchError=!0,self.require.config(t)),new Promise(function(e,t){self.require([i],function(i){o._requestHandler=i.create(r),o._requestHandler?e(s.getAllMethodNames(o._requestHandler)):t(new Error("No RequestHandler!"))},t)}))},e}();t.SimpleWorkerServer=c,t.create=function(e){return new c(e,null)}}),define(t[452],i([1,0,23]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.modelProvider=i.isFunction(e.getModel)?e:{getModel:function(){return e}}}return e.prototype.getId=function(e,t){if(!t)return null;var i=this.modelProvider.getModel();return i===t?"__root__":i.dataSource.getId(t)},e.prototype.hasChildren=function(e,t){var i=this.modelProvider.getModel();return!!(i&&i===t&&i.entries.length>0)},e.prototype.getChildren=function(e,t){var i=this.modelProvider.getModel()
;return Promise.resolve(i===t?i.entries:[])},e.prototype.getParent=function(e,t){return Promise.resolve(null)},e}();t.DataSource=n;var o=function(){function e(e){this.modelProvider=e}return e.prototype.getAriaLabel=function(e,t){var i=this.modelProvider.getModel();return i.accessibilityProvider?i.accessibilityProvider.getAriaLabel(t):null},e.prototype.getPosInSet=function(e,t){var i=this.modelProvider.getModel(),n=0;if(i.filter)for(var o=0,r=i.entries;o<r.length;o++){var s=r[o];if(i.filter.isVisible(s)&&n++,s===t)break}else n=i.entries.indexOf(t)+1;return String(n)},e.prototype.getSetSize=function(){var e=this.modelProvider.getModel(),t=0;if(e.filter)for(var i=0,n=e.entries;i<n.length;i++){var o=n[i];e.filter.isVisible(o)&&t++}else t=e.entries.length;return String(t)},e}();t.AccessibilityProvider=o;var r=function(){function e(e){this.modelProvider=e}return e.prototype.isVisible=function(e,t){var i=this.modelProvider.getModel();return!i.filter||i.filter.isVisible(t)},e}();t.Filter=r;var s=function(){
function e(e,t){this.modelProvider=e,this.styles=t}return e.prototype.updateStyles=function(e){this.styles=e},e.prototype.getHeight=function(e,t){return this.modelProvider.getModel().renderer.getHeight(t)},e.prototype.getTemplateId=function(e,t){return this.modelProvider.getModel().renderer.getTemplateId(t)},e.prototype.renderTemplate=function(e,t,i){return this.modelProvider.getModel().renderer.renderTemplate(t,i,this.styles)},e.prototype.renderElement=function(e,t,i,n){this.modelProvider.getModel().renderer.renderElement(t,i,n,this.styles)},e.prototype.disposeTemplate=function(e,t,i){this.modelProvider.getModel().renderer.disposeTemplate(t,i)},e}();t.Renderer=s}),define(t[451],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i){this._posx=e,this._posy=t,this._target=i}return e.prototype.preventDefault=function(){},e.prototype.stopPropagation=function(){},Object.defineProperty(e.prototype,"target",{get:function(){return this._target},
enumerable:!0,configurable:!0}),e}();t.ContextMenuEvent=i;var n=function(e){function t(t){var i=e.call(this,t.posx,t.posy,t.target)||this;return i.originalEvent=t,i}return r(t,e),t.prototype.preventDefault=function(){this.originalEvent.preventDefault()},t.prototype.stopPropagation=function(){this.originalEvent.stopPropagation()},t}(i);t.MouseContextMenuEvent=n;var o=function(e){function t(t,i,n){var o=e.call(this,t,i,n.target)||this;return o.originalEvent=n,o}return r(t,e),t.prototype.preventDefault=function(){this.originalEvent.preventDefault()},t.prototype.stopPropagation=function(){this.originalEvent.stopPropagation()},t}(i);t.KeyboardContextMenuEvent=o}),define(t[158],i([1,0,18,10,8,38]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(){this._arr=[]}return e.prototype.set=function(e,t){this._arr.push({keybinding:r.createKeybinding(e,i.OS),callback:t})},e.prototype.dispatch=function(e){for(var t=this._arr.length-1;t>=0;t--){var i=this._arr[t]
;if(e.toChord().equals(i.keybinding))return i.callback}return null},e}();t.KeybindingDispatcher=s;var a=function(){function e(e){var t=this;void 0===e&&(e={clickBehavior:0,keyboardSupport:!0,openMode:0}),this.options=e,this.downKeyBindingDispatcher=new s,this.upKeyBindingDispatcher=new s,("boolean"!=typeof e.keyboardSupport||e.keyboardSupport)&&(this.downKeyBindingDispatcher.set(16,function(e,i){return t.onUp(e,i)}),this.downKeyBindingDispatcher.set(18,function(e,i){return t.onDown(e,i)}),this.downKeyBindingDispatcher.set(15,function(e,i){return t.onLeft(e,i)}),this.downKeyBindingDispatcher.set(17,function(e,i){return t.onRight(e,i)}),i.isMacintosh&&(this.downKeyBindingDispatcher.set(2064,function(e,i){return t.onLeft(e,i)}),this.downKeyBindingDispatcher.set(300,function(e,i){return t.onDown(e,i)}),this.downKeyBindingDispatcher.set(302,function(e,i){return t.onUp(e,i)})),this.downKeyBindingDispatcher.set(11,function(e,i){return t.onPageUp(e,i)}),this.downKeyBindingDispatcher.set(12,function(e,i){
return t.onPageDown(e,i)}),this.downKeyBindingDispatcher.set(14,function(e,i){return t.onHome(e,i)}),this.downKeyBindingDispatcher.set(13,function(e,i){return t.onEnd(e,i)}),this.downKeyBindingDispatcher.set(10,function(e,i){return t.onSpace(e,i)}),this.downKeyBindingDispatcher.set(9,function(e,i){return t.onEscape(e,i)}),this.upKeyBindingDispatcher.set(3,this.onEnter.bind(this)),this.upKeyBindingDispatcher.set(2051,this.onEnter.bind(this)))}return e.prototype.onMouseDown=function(e,t,i,n){if(void 0===n&&(n="mouse"),0===this.options.clickBehavior&&(i.leftButton||i.middleButton)){if(i.target){if(i.target.tagName&&"input"===i.target.tagName.toLowerCase())return!1;if(o.findParentWithClass(i.target,"scrollbar","monaco-tree"))return!1;if(o.findParentWithClass(i.target,"monaco-action-bar","row"))return!1}return this.onLeftClick(e,t,i,n)}return!1},e.prototype.onClick=function(e,t,n){return i.isMacintosh&&n.ctrlKey?(n.preventDefault(),n.stopPropagation(),
!1):(!n.target||!n.target.tagName||"input"!==n.target.tagName.toLowerCase())&&((0!==this.options.clickBehavior||!n.leftButton&&!n.middleButton)&&this.onLeftClick(e,t,n))},e.prototype.onLeftClick=function(e,t,i,o){void 0===o&&(o="mouse");var r=i,s={origin:o,originalEvent:i,didClickOnTwistie:this.isClickOnTwistie(r)};if(e.getInput()===t)e.clearFocus(s),e.clearSelection(s);else{i&&r.browserEvent&&"mousedown"===r.browserEvent.type&&1===r.browserEvent.detail||i.preventDefault(),i.stopPropagation(),e.domFocus(),e.setSelection([t],s),e.setFocus(t,s),this.shouldToggleExpansion(t,r,o)&&(e.isExpanded(t)?e.collapse(t).then(void 0,n.onUnexpectedError):e.expand(t).then(void 0,n.onUnexpectedError))}return!0},e.prototype.shouldToggleExpansion=function(e,t,i){var n="mouse"===i&&2===t.detail;return this.openOnSingleClick||n||this.isClickOnTwistie(t)},Object.defineProperty(e.prototype,"openOnSingleClick",{get:function(){return 0===this.options.openMode},enumerable:!0,configurable:!0}),e.prototype.isClickOnTwistie=function(e){
var t=e.target;if(!o.hasClass(t,"content"))return!1;var i=window.getComputedStyle(t,":before");if("none"===i.backgroundImage||"none"===i.display)return!1;var n=parseInt(i.width)+parseInt(i.paddingRight);return e.browserEvent.offsetX<=n},e.prototype.onContextMenu=function(e,t,i){return(!i.target||!i.target.tagName||"input"!==i.target.tagName.toLowerCase())&&(i&&(i.preventDefault(),i.stopPropagation()),!1)},e.prototype.onTap=function(e,t,i){var n=i.initialTarget;return(!n||!n.tagName||"input"!==n.tagName.toLowerCase())&&this.onLeftClick(e,t,i,"touch")},e.prototype.onKeyDown=function(e,t){return this.onKey(this.downKeyBindingDispatcher,e,t)},e.prototype.onKeyUp=function(e,t){return this.onKey(this.upKeyBindingDispatcher,e,t)},e.prototype.onKey=function(e,t,i){var n=e.dispatch(i.toKeybinding());return!(!n||!n(t,i))&&(i.preventDefault(),i.stopPropagation(),!0)},e.prototype.onUp=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusPrevious(1,i),
e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onPageUp=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusPreviousPage(i),e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onDown=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusNext(1,i),e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onPageDown=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusNextPage(i),e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onHome=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusFirst(i),e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onEnd=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?e.clearHighlight(i):(e.focusLast(i),
e.reveal(e.getFocus()).then(void 0,n.onUnexpectedError)),!0},e.prototype.onLeft=function(e,t){var i={origin:"keyboard",originalEvent:t};if(e.getHighlight())e.clearHighlight(i);else{var o=e.getFocus();e.collapse(o).then(function(t){if(o&&!t)return e.focusParent(i),e.reveal(e.getFocus())}).then(void 0,n.onUnexpectedError)}return!0},e.prototype.onRight=function(e,t){var i={origin:"keyboard",originalEvent:t};if(e.getHighlight())e.clearHighlight(i);else{var o=e.getFocus();e.expand(o).then(function(t){if(o&&!t)return e.focusFirstChild(i),e.reveal(e.getFocus())}).then(void 0,n.onUnexpectedError)}return!0},e.prototype.onEnter=function(e,t){var i={origin:"keyboard",originalEvent:t};if(e.getHighlight())return!1;var n=e.getFocus();return n&&e.setSelection([n],i),!0},e.prototype.onSpace=function(e,t){if(e.getHighlight())return!1;var i=e.getFocus();return i&&e.toggleExpansion(i),!0},e.prototype.onEscape=function(e,t){var i={origin:"keyboard",originalEvent:t};return e.getHighlight()?(e.clearHighlight(i),
!0):e.getSelection().length?(e.clearSelection(i),!0):!!e.getFocus()&&(e.clearFocus(i),!0)},e}();t.DefaultController=a;var l=function(){function e(){}return e.prototype.getDragURI=function(e,t){return null},e.prototype.onDragStart=function(e,t,i){},e.prototype.onDragOver=function(e,t,i,n){return null},e.prototype.drop=function(e,t,i,n){},e}();t.DefaultDragAndDrop=l;var u=function(){function e(){}return e.prototype.isVisible=function(e,t){return!0},e}();t.DefaultFilter=u;var d=function(){function e(){}return e.prototype.getAriaLabel=function(e,t){return null},e}();t.DefaultAccessibilityProvider=d;var c=function(){function e(e,t){this.styleElement=e,this.selectorSuffix=t}return e.prototype.style=function(e){var t=this.selectorSuffix?"."+this.selectorSuffix:"",i=[];e.listFocusBackground&&i.push(".monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) { background-color: "+e.listFocusBackground+"; }"),
e.listFocusForeground&&i.push(".monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) { color: "+e.listFocusForeground+"; }"),e.listActiveSelectionBackground&&i.push(".monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { background-color: "+e.listActiveSelectionBackground+"; }"),e.listActiveSelectionForeground&&i.push(".monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { color: "+e.listActiveSelectionForeground+"; }"),e.listFocusAndSelectionBackground&&i.push("\n\t\t\t\t.monaco-tree-drag-image,\n\t\t\t\t.monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.focused.selected:not(.highlighted) { background-color: "+e.listFocusAndSelectionBackground+"; }\n\t\t\t"),
e.listFocusAndSelectionForeground&&i.push("\n\t\t\t\t.monaco-tree-drag-image,\n\t\t\t\t.monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.focused.selected:not(.highlighted) { color: "+e.listFocusAndSelectionForeground+"; }\n\t\t\t"),e.listInactiveSelectionBackground&&i.push(".monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { background-color: "+e.listInactiveSelectionBackground+"; }"),e.listInactiveSelectionForeground&&i.push(".monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { color: "+e.listInactiveSelectionForeground+"; }"),e.listHoverBackground&&i.push(".monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused) { background-color: "+e.listHoverBackground+"; }"),e.listHoverForeground&&i.push(".monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused) { color: "+e.listHoverForeground+"; }"),
e.listDropBackground&&i.push("\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-wrapper.drop-target,\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row.drop-target { background-color: "+e.listDropBackground+" !important; color: inherit !important; }\n\t\t\t"),
e.listFocusOutline&&i.push("\n\t\t\t\t.monaco-tree-drag-image\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px solid "+e.listFocusOutline+"; background: #000; }\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row \t\t\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px solid transparent; }\n\t\t\t\t.monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) \t\t\t\t\t\t{ border: 1px dotted "+e.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+t+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) \t\t\t\t\t\t{ border: 1px solid "+e.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted)  \t\t\t\t\t\t\t{ border: 1px solid "+e.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused)  \t{ border: 1px dashed "+e.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-wrapper.drop-target,\n\t\t\t\t.monaco-tree"+t+" .monaco-tree-rows > .monaco-tree-row.drop-target\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px dashed "+e.listFocusOutline+"; }\n\t\t\t")
;var n=i.join("\n");n!==this.styleElement.innerHTML&&(this.styleElement.innerHTML=n)},e}();t.DefaultTreestyler=c}),define(t[449],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.elements=e}return e.prototype.update=function(e){},e.prototype.getData=function(){return this.elements},e}();t.ElementsDragAndDropData=i;var n=function(){function e(e){this.elements=e}return e.prototype.update=function(e){},e.prototype.getData=function(){return this.elements},e}();t.ExternalElementsDragAndDropData=n;var o=function(){function e(){this.types=[],this.files=[]}return e.prototype.update=function(e){e.types&&(this.types=[],Array.prototype.push.apply(this.types,e.types)),e.files&&(this.files=[],Array.prototype.push.apply(this.files,e.files),this.files=this.files.filter(function(e){return e.size||e.type}))},e.prototype.getData=function(){return{types:this.types,files:this.files}},e}();t.DesktopDragAndDropData=o}),
define(t[448],i([1,0,160,10,2,4]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(e){this._onDispose=new s.Emitter,this.onDispose=this._onDispose.event,this._item=e}return Object.defineProperty(e.prototype,"item",{get:function(){return this._item},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._onDispose&&(this._onDispose.fire(),this._onDispose.dispose(),this._onDispose=void 0)},e}();t.LockData=a;var l=function(){function e(){this.locks=Object.create({})}return e.prototype.isLocked=function(e){return!!this.locks[e.id]},e.prototype.run=function(e,t){var i=this,n=this.getLock(e);if(n)return new Promise(function(o,r){s.Event.once(n.onDispose)(function(){return i.run(e,t).then(o,r)})});var o;return new Promise(function(n,r){if(e.isDisposed())return r(new Error("Item is disposed."));var s=i.locks[e.id]=new a(e);return o=t().then(function(t){return delete i.locks[e.id],s.dispose(),t}).then(n,r)})},e.prototype.getLock=function(e){
var t;for(t in this.locks){var i=this.locks[t];if(e.intersects(i.item))return i}return null},e}();t.Lock=l;var u=function(){function e(){this._isDisposed=!1,this._onDidRevealItem=new s.EventMultiplexer,this.onDidRevealItem=this._onDidRevealItem.event,this._onExpandItem=new s.EventMultiplexer,this.onExpandItem=this._onExpandItem.event,this._onDidExpandItem=new s.EventMultiplexer,this.onDidExpandItem=this._onDidExpandItem.event,this._onCollapseItem=new s.EventMultiplexer,this.onCollapseItem=this._onCollapseItem.event,this._onDidCollapseItem=new s.EventMultiplexer,this.onDidCollapseItem=this._onDidCollapseItem.event,this._onDidAddTraitItem=new s.EventMultiplexer,this.onDidAddTraitItem=this._onDidAddTraitItem.event,this._onDidRemoveTraitItem=new s.EventMultiplexer,this.onDidRemoveTraitItem=this._onDidRemoveTraitItem.event,this._onDidRefreshItem=new s.EventMultiplexer,this.onDidRefreshItem=this._onDidRefreshItem.event,this._onRefreshItemChildren=new s.EventMultiplexer,
this.onRefreshItemChildren=this._onRefreshItemChildren.event,this._onDidRefreshItemChildren=new s.EventMultiplexer,this.onDidRefreshItemChildren=this._onDidRefreshItemChildren.event,this._onDidDisposeItem=new s.EventMultiplexer,this.onDidDisposeItem=this._onDidDisposeItem.event,this.items={}}return e.prototype.register=function(e){i.ok(!this.isRegistered(e.id),"item already registered: "+e.id);var t=o.combinedDisposable(this._onDidRevealItem.add(e.onDidReveal),this._onExpandItem.add(e.onExpand),this._onDidExpandItem.add(e.onDidExpand),this._onCollapseItem.add(e.onCollapse),this._onDidCollapseItem.add(e.onDidCollapse),this._onDidAddTraitItem.add(e.onDidAddTrait),this._onDidRemoveTraitItem.add(e.onDidRemoveTrait),this._onDidRefreshItem.add(e.onDidRefresh),this._onRefreshItemChildren.add(e.onRefreshChildren),this._onDidRefreshItemChildren.add(e.onDidRefreshChildren),this._onDidDisposeItem.add(e.onDidDispose));this.items[e.id]={item:e,disposable:t}},e.prototype.deregister=function(e){
i.ok(this.isRegistered(e.id),"item not registered: "+e.id),this.items[e.id].disposable.dispose(),delete this.items[e.id]},e.prototype.isRegistered=function(e){return this.items.hasOwnProperty(e)},e.prototype.getItem=function(e){var t=this.items[e];return t?t.item:null},e.prototype.dispose=function(){this.items=null,this._onDidRevealItem.dispose(),this._onExpandItem.dispose(),this._onDidExpandItem.dispose(),this._onCollapseItem.dispose(),this._onDidCollapseItem.dispose(),this._onDidAddTraitItem.dispose(),this._onDidRemoveTraitItem.dispose(),this._onDidRefreshItem.dispose(),this._onRefreshItemChildren.dispose(),this._onDidRefreshItemChildren.dispose(),this._isDisposed=!0},e.prototype.isDisposed=function(){return this._isDisposed},e}();t.ItemRegistry=u;var d=function(){function e(e,t,i,n,o){this._onDidCreate=new s.Emitter,this._onDidReveal=new s.Emitter,this.onDidReveal=this._onDidReveal.event,this._onExpand=new s.Emitter,this.onExpand=this._onExpand.event,this._onDidExpand=new s.Emitter,
this.onDidExpand=this._onDidExpand.event,this._onCollapse=new s.Emitter,this.onCollapse=this._onCollapse.event,this._onDidCollapse=new s.Emitter,this.onDidCollapse=this._onDidCollapse.event,this._onDidAddTrait=new s.Emitter,this.onDidAddTrait=this._onDidAddTrait.event,this._onDidRemoveTrait=new s.Emitter,this.onDidRemoveTrait=this._onDidRemoveTrait.event,this._onDidRefresh=new s.Emitter,this.onDidRefresh=this._onDidRefresh.event,this._onRefreshChildren=new s.Emitter,this.onRefreshChildren=this._onRefreshChildren.event,this._onDidRefreshChildren=new s.Emitter,this.onDidRefreshChildren=this._onDidRefreshChildren.event,this._onDidDispose=new s.Emitter,this.onDidDispose=this._onDidDispose.event,this.registry=t,this.context=i,this.lock=n,this.element=o,this.id=e,this.registry.register(this),this.doesHaveChildren=this.context.dataSource.hasChildren(this.context.tree,this.element),this.needsChildrenRefresh=!0,this.parent=null,this.previous=null,this.next=null,this.firstChild=null,this.lastChild=null,this.traits={},
this.depth=0,this.expanded=!(!this.context.dataSource.shouldAutoexpand||!this.context.dataSource.shouldAutoexpand(this.context.tree,o)),this._onDidCreate.fire(this),this.visible=this._isVisible(),this.height=this._getHeight(),this._isDisposed=!1}return e.prototype.getElement=function(){return this.element},e.prototype.hasChildren=function(){return this.doesHaveChildren},e.prototype.getDepth=function(){return this.depth},e.prototype.isVisible=function(){return this.visible},e.prototype.setVisible=function(e){this.visible=e},e.prototype.isExpanded=function(){return this.expanded},e.prototype._setExpanded=function(e){this.expanded=e},e.prototype.reveal=function(e){void 0===e&&(e=null);var t={item:this,relativeTop:e};this._onDidReveal.fire(t)},e.prototype.expand=function(){var e=this;if(this.isExpanded()||!this.doesHaveChildren||this.lock.isLocked(this))return Promise.resolve(!1);return this.lock.run(this,function(){if(e.isExpanded()||!e.doesHaveChildren)return Promise.resolve(!1);var t={item:e}
;return e._onExpand.fire(t),(e.needsChildrenRefresh?e.refreshChildren(!1,!0,!0):Promise.resolve(null)).then(function(){return e._setExpanded(!0),e._onDidExpand.fire(t),!0})}).then(function(t){return!e.isDisposed()&&(e.context.options.autoExpandSingleChildren&&t&&null!==e.firstChild&&e.firstChild===e.lastChild&&e.firstChild.isVisible()?e.firstChild.expand().then(function(){return!0}):t)})},e.prototype.collapse=function(e){var t=this;if(void 0===e&&(e=!1),e){var i=Promise.resolve(null);return this.forEachChild(function(e){i=i.then(function(){return e.collapse(!0)})}),i.then(function(){return t.collapse(!1)})}return!this.isExpanded()||this.lock.isLocked(this)?Promise.resolve(!1):this.lock.run(this,function(){var e={item:t};return t._onCollapse.fire(e),t._setExpanded(!1),t._onDidCollapse.fire(e),Promise.resolve(!0)})},e.prototype.addTrait=function(e){var t={item:this,trait:e};this.traits[e]=!0,this._onDidAddTrait.fire(t)},e.prototype.removeTrait=function(e){var t={item:this,trait:e};delete this.traits[e],
this._onDidRemoveTrait.fire(t)},e.prototype.hasTrait=function(e){return this.traits[e]||!1},e.prototype.getAllTraits=function(){var e,t=[];for(e in this.traits)this.traits.hasOwnProperty(e)&&this.traits[e]&&t.push(e);return t},e.prototype.getHeight=function(){return this.height},e.prototype.refreshChildren=function(t,i,o){var r=this;if(void 0===i&&(i=!1),void 0===o&&(o=!1),!o&&!this.isExpanded()){var s=function(e){e.needsChildrenRefresh=!0,e.forEachChild(s)};return s(this),Promise.resolve(this)}this.needsChildrenRefresh=!1;var a=function(){var o={item:r,isNested:i};r._onRefreshChildren.fire(o);return(r.doesHaveChildren?r.context.dataSource.getChildren(r.context.tree,r.element):Promise.resolve([])).then(function(i){if(r.isDisposed()||r.registry.isDisposed())return Promise.resolve(null);if(!Array.isArray(i))return Promise.reject(new Error("Please return an array of children."));i=i?i.slice(0):[],i=r.sort(i);for(var n={};null!==r.firstChild;)n[r.firstChild.id]=r.firstChild,r.removeChild(r.firstChild)
;for(var o=0,s=i.length;o<s;o++){var a=i[o],l=r.context.dataSource.getId(r.context.tree,a),u=n[l]||new e(l,r.registry,r.context,r.lock,a);u.element=a,t&&(u.needsChildrenRefresh=t),delete n[l],r.addChild(u)}for(var d in n)n.hasOwnProperty(d)&&n[d].dispose();return t?Promise.all(r.mapEachChild(function(e){return e.doRefresh(t,!0)})):Promise.all(r.mapEachChild(function(e){return e.isExpanded()&&e.needsChildrenRefresh?e.doRefresh(t,!0):(e.updateVisibility(),Promise.resolve(null))}))}).then(void 0,n.onUnexpectedError).then(function(){return r._onDidRefreshChildren.fire(o)})};return i?a():this.lock.run(this,a)},e.prototype.doRefresh=function(e,t){return void 0===t&&(t=!1),this.doesHaveChildren=this.context.dataSource.hasChildren(this.context.tree,this.element),this.height=this._getHeight(),this.updateVisibility(),this._onDidRefresh.fire(this),this.refreshChildren(e,t)},e.prototype.updateVisibility=function(){this.setVisible(this._isVisible())},e.prototype.refresh=function(e){return this.doRefresh(e)},
e.prototype.getNavigator=function(){return new h(this)},e.prototype.intersects=function(e){return this.isAncestorOf(e)||e.isAncestorOf(this)},e.prototype.isAncestorOf=function(e){for(var t=e;t;){if(t.id===this.id)return!0;t=t.parent}return!1},e.prototype.addChild=function(e,t){void 0===t&&(t=this.lastChild);var i=null===this.firstChild,n=null===t,o=t===this.lastChild;if(i)this.firstChild=this.lastChild=e,e.next=e.previous=null;else if(n){if(!this.firstChild)throw new Error("Invalid tree state");this.firstChild.previous=e,e.next=this.firstChild,e.previous=null,this.firstChild=e}else if(o){if(!this.lastChild)throw new Error("Invalid tree state");this.lastChild.next=e,e.next=null,e.previous=this.lastChild,this.lastChild=e}else{if(e.previous=t,!t)throw new Error("Invalid tree state");if(e.next=t.next,!t.next)throw new Error("Invalid tree state");t.next.previous=e,t.next=e}e.parent=this,e.depth=this.depth+1},e.prototype.removeChild=function(e){var t=this.firstChild===e,i=this.lastChild===e
;if(t&&i)this.firstChild=this.lastChild=null;else if(t){if(!e.next)throw new Error("Invalid tree state");e.next.previous=null,this.firstChild=e.next}else if(i){if(!e.previous)throw new Error("Invalid tree state");e.previous.next=null,this.lastChild=e.previous}else{if(!e.next)throw new Error("Invalid tree state");if(e.next.previous=e.previous,!e.previous)throw new Error("Invalid tree state");e.previous.next=e.next}e.parent=null,e.depth=NaN},e.prototype.forEachChild=function(e){for(var t,i=this.firstChild;i;)t=i.next,e(i),i=t},e.prototype.mapEachChild=function(e){var t=[];return this.forEachChild(function(i){t.push(e(i))}),t},e.prototype.sort=function(e){var t=this,i=this.context.sorter;return i?e.sort(function(e,n){return i.compare(t.context.tree,e,n)}):e},e.prototype._getHeight=function(){return this.context.renderer?this.context.renderer.getHeight(this.context.tree,this.element):0},e.prototype._isVisible=function(){return!!this.context.filter&&this.context.filter.isVisible(this.context.tree,this.element)},
e.prototype.isDisposed=function(){return this._isDisposed},e.prototype.dispose=function(){this.forEachChild(function(e){return e.dispose()}),this.parent=null,this.previous=null,this.next=null,this.firstChild=null,this.lastChild=null,this._onDidDispose.fire(this),this.registry.deregister(this),this._onDidCreate.dispose(),this._onDidReveal.dispose(),this._onExpand.dispose(),this._onDidExpand.dispose(),this._onCollapse.dispose(),this._onDidCollapse.dispose(),this._onDidAddTrait.dispose(),this._onDidRemoveTrait.dispose(),this._onDidRefresh.dispose(),this._onRefreshChildren.dispose(),this._onDidRefreshChildren.dispose(),this._onDidDispose.dispose(),this._isDisposed=!0},e}();t.Item=d;var c=function(e){function t(t,i,n,o,r){return e.call(this,t,i,n,o,r)||this}return r(t,e),t.prototype.isVisible=function(){return!1},t.prototype.setVisible=function(e){},t.prototype.isExpanded=function(){return!0},t.prototype._setExpanded=function(e){},t.prototype._getHeight=function(){return 0},t.prototype._isVisible=function(){
return!1},t}(d),h=function(){function e(e,t){void 0===t&&(t=!0),this.item=e,this.start=t?e:null}return e.lastDescendantOf=function(t){return t?t instanceof c?e.lastDescendantOf(t.lastChild):t.isVisible()?t.isExpanded()&&null!==t.lastChild?e.lastDescendantOf(t.lastChild):t:e.lastDescendantOf(t.previous):null},e.prototype.current=function(){return this.item||null},e.prototype.next=function(){if(this.item)do{if((this.item instanceof c||this.item.isVisible()&&this.item.isExpanded())&&this.item.firstChild)this.item=this.item.firstChild;else if(this.item===this.start)this.item=null;else{for(;this.item&&this.item!==this.start&&!this.item.next;)this.item=this.item.parent;this.item===this.start&&(this.item=null),this.item=this.item?this.item.next:null}}while(this.item&&!this.item.isVisible());return this.item||null},e.prototype.previous=function(){if(this.item)do{var t=e.lastDescendantOf(this.item.previous)
;t?this.item=t:this.item.parent&&this.item.parent!==this.start&&this.item.parent.isVisible()?this.item=this.item.parent:this.item=null}while(this.item&&!this.item.isVisible());return this.item||null},e.prototype.parent=function(){if(this.item){var e=this.item.parent;e&&e!==this.start&&e.isVisible()?this.item=e:this.item=null}return this.item||null},e.prototype.first=function(){return this.item=this.start,this.next(),this.item||null},e.prototype.last=function(){return e.lastDescendantOf(this.start)},e}();t.TreeNavigator=h;var p=function(){function e(e){this._onSetInput=new s.Emitter,this.onSetInput=this._onSetInput.event,this._onDidSetInput=new s.Emitter,this.onDidSetInput=this._onDidSetInput.event,this._onRefresh=new s.Emitter,this.onRefresh=this._onRefresh.event,this._onDidRefresh=new s.Emitter,this.onDidRefresh=this._onDidRefresh.event,this._onDidHighlight=new s.Emitter,this.onDidHighlight=this._onDidHighlight.event,this._onDidSelect=new s.Emitter,this.onDidSelect=this._onDidSelect.event,
this._onDidFocus=new s.Emitter,this.onDidFocus=this._onDidFocus.event,this._onDidRevealItem=new s.Relay,this.onDidRevealItem=this._onDidRevealItem.event,this._onExpandItem=new s.Relay,this.onExpandItem=this._onExpandItem.event,this._onDidExpandItem=new s.Relay,this.onDidExpandItem=this._onDidExpandItem.event,this._onCollapseItem=new s.Relay,this.onCollapseItem=this._onCollapseItem.event,this._onDidCollapseItem=new s.Relay,this.onDidCollapseItem=this._onDidCollapseItem.event,this._onDidAddTraitItem=new s.Relay,this.onDidAddTraitItem=this._onDidAddTraitItem.event,this._onDidRemoveTraitItem=new s.Relay,this.onDidRemoveTraitItem=this._onDidRemoveTraitItem.event,this._onDidRefreshItem=new s.Relay,this.onDidRefreshItem=this._onDidRefreshItem.event,this._onRefreshItemChildren=new s.Relay,this.onRefreshItemChildren=this._onRefreshItemChildren.event,this._onDidRefreshItemChildren=new s.Relay,this.onDidRefreshItemChildren=this._onDidRefreshItemChildren.event,this._onDidDisposeItem=new s.Relay,this.context=e,
this.input=null,this.traitsToItems={}}return e.prototype.setInput=function(e){var t=this,i={item:this.input};this._onSetInput.fire(i),this.setSelection([]),this.setFocus(),this.setHighlight(),this.lock=new l,this.input&&this.input.dispose(),this.registry&&(this.registry.dispose(),this.registryDisposable.dispose()),this.registry=new u,this._onDidRevealItem.input=this.registry.onDidRevealItem,this._onExpandItem.input=this.registry.onExpandItem,this._onDidExpandItem.input=this.registry.onDidExpandItem,this._onCollapseItem.input=this.registry.onCollapseItem,this._onDidCollapseItem.input=this.registry.onDidCollapseItem,this._onDidAddTraitItem.input=this.registry.onDidAddTraitItem,this._onDidRemoveTraitItem.input=this.registry.onDidRemoveTraitItem,this._onDidRefreshItem.input=this.registry.onDidRefreshItem,this._onRefreshItemChildren.input=this.registry.onRefreshItemChildren,this._onDidRefreshItemChildren.input=this.registry.onDidRefreshItemChildren,this._onDidDisposeItem.input=this.registry.onDidDisposeItem,
this.registryDisposable=this.registry.onDidDisposeItem(function(e){return e.getAllTraits().forEach(function(i){return delete t.traitsToItems[i][e.id]})});var n=this.context.dataSource.getId(this.context.tree,e);return this.input=new c(n,this.registry,this.context,this.lock,e),i={item:this.input},this._onDidSetInput.fire(i),this.refresh(this.input)},e.prototype.getInput=function(){return this.input?this.input.getElement():null},e.prototype.refresh=function(e,t){var i=this;void 0===e&&(e=null),void 0===t&&(t=!0);var n=this.getItem(e);if(!n)return Promise.resolve(null);var o={item:n,recursive:t};return this._onRefresh.fire(o),n.refresh(t).then(function(){i._onDidRefresh.fire(o)})},e.prototype.expand=function(e){var t=this.getItem(e);return t?t.expand():Promise.resolve(!1)},e.prototype.collapse=function(e,t){void 0===t&&(t=!1);var i=this.getItem(e);return i?i.collapse(t):Promise.resolve(!1)},e.prototype.toggleExpansion=function(e,t){return void 0===t&&(t=!1),this.isExpanded(e)?this.collapse(e,t):this.expand(e)},
e.prototype.isExpanded=function(e){var t=this.getItem(e);return!!t&&t.isExpanded()},e.prototype.reveal=function(e,t){var i=this;return void 0===t&&(t=null),this.resolveUnknownParentChain(e).then(function(e){var t=Promise.resolve(null);return e.forEach(function(e){t=t.then(function(){return i.expand(e)})}),t}).then(function(){var n=i.getItem(e);if(n)return n.reveal(t)})},e.prototype.resolveUnknownParentChain=function(e){var t=this;return this.context.dataSource.getParent(this.context.tree,e).then(function(e){return e?t.resolveUnknownParentChain(e).then(function(t){return t.push(e),t}):Promise.resolve([])})},e.prototype.setHighlight=function(e,t){this.setTraits("highlighted",e?[e]:[]);var i={highlight:this.getHighlight(),payload:t};this._onDidHighlight.fire(i)},e.prototype.getHighlight=function(e){void 0===e&&(e=!1);var t=this.getElementsWithTrait("highlighted",e);return 0===t.length?null:t[0]},e.prototype.setSelection=function(e,t){this.setTraits("selected",e);var i={selection:this.getSelection(),payload:t}
;this._onDidSelect.fire(i)},e.prototype.getSelection=function(e){return void 0===e&&(e=!1),this.getElementsWithTrait("selected",e)},e.prototype.setFocus=function(e,t){this.setTraits("focused",e?[e]:[]);var i={focus:this.getFocus(),payload:t};this._onDidFocus.fire(i)},e.prototype.getFocus=function(e){void 0===e&&(e=!1);var t=this.getElementsWithTrait("focused",e);return 0===t.length?null:t[0]},e.prototype.focusNext=function(e,t){void 0===e&&(e=1);for(var i,n=this.getFocus()||this.input,o=this.getNavigator(n,!1),r=0;r<e&&(i=o.next());r++)n=i;this.setFocus(n,t)},e.prototype.focusPrevious=function(e,t){void 0===e&&(e=1);for(var i,n=this.getFocus()||this.input,o=this.getNavigator(n,!1),r=0;r<e&&(i=o.previous());r++)n=i;this.setFocus(n,t)},e.prototype.focusParent=function(e){var t=this.getFocus()||this.input,i=this.getNavigator(t,!1).parent();i&&this.setFocus(i,e)},e.prototype.focusFirstChild=function(e){var t=this.getItem(this.getFocus()||this.input),i=this.getNavigator(t,!1),n=i.next()
;i.parent()===t&&this.setFocus(n,e)},e.prototype.focusFirst=function(e,t){this.focusNth(0,e,t)},e.prototype.focusNth=function(e,t,i){for(var n=this.getParent(i),o=this.getNavigator(n),r=o.first(),s=0;s<e;s++)r=o.next();r&&this.setFocus(r,t)},e.prototype.focusLast=function(e,t){var i,n=this.getParent(t);if(t&&n)i=n.lastChild;else{i=this.getNavigator(n).last()}i&&this.setFocus(i,e)},e.prototype.getParent=function(e){if(e){var t=this.getItem(e);if(t&&t.parent)return t.parent}return this.getItem(this.input)},e.prototype.getNavigator=function(e,t){return void 0===e&&(e=null),void 0===t&&(t=!0),new h(this.getItem(e),t)},e.prototype.getItem=function(e){return void 0===e&&(e=null),null===e?this.input:e instanceof d?e:"string"==typeof e?this.registry.getItem(e):this.registry.getItem(this.context.dataSource.getId(this.context.tree,e))},e.prototype.removeTraits=function(e,t){var i,n,o=this.traitsToItems[e]||{};if(0===t.length){for(n in o)o.hasOwnProperty(n)&&(i=o[n]).removeTrait(e);delete this.traitsToItems[e]
}else for(var r=0,s=t.length;r<s;r++)(i=this.getItem(t[r]))&&(i.removeTrait(e),delete o[i.id])},e.prototype.setTraits=function(e,t){if(0===t.length)this.removeTraits(e,t);else{for(var i={},n=void 0,o=0,r=t.length;o<r;o++)(n=this.getItem(t[o]))&&(i[n.id]=n);var s=this.traitsToItems[e]||{},a=[],l=void 0;for(l in s)s.hasOwnProperty(l)&&(i.hasOwnProperty(l)?delete i[l]:a.push(s[l]));for(var o=0,r=a.length;o<r;o++)(n=a[o]).removeTrait(e),delete s[n.id];for(l in i)i.hasOwnProperty(l)&&((n=i[l]).addTrait(e),s[l]=n);this.traitsToItems[e]=s}},e.prototype.getElementsWithTrait=function(e,t){var i,n=[],o=this.traitsToItems[e]||{};for(i in o)o.hasOwnProperty(i)&&(o[i].isVisible()||t)&&n.push(o[i].getElement());return n},e.prototype.dispose=function(){this.registry&&(this.registry.dispose(),this.registry=null),this._onSetInput.dispose(),this._onDidSetInput.dispose(),this._onRefresh.dispose(),this._onDidRefresh.dispose(),this._onDidHighlight.dispose(),this._onDidSelect.dispose(),this._onDidFocus.dispose(),
this._onDidRevealItem.dispose(),this._onExpandItem.dispose(),this._onDidExpandItem.dispose(),this._onCollapseItem.dispose(),this._onDidCollapseItem.dispose(),this._onDidAddTraitItem.dispose(),this._onDidRemoveTraitItem.dispose(),this._onDidRefreshItem.dispose(),this._onRefreshItemChildren.dispose(),this._onDidRefreshItemChildren.dispose(),this._onDidDisposeItem.dispose()},e}();t.TreeModel=p}),define(t[447],i([1,0,62]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(){this.heightMap=[],this.indexes={}}return e.prototype.getContentHeight=function(){var e=this.heightMap[this.heightMap.length-1];return e?e.top+e.height:0},e.prototype.onInsertItems=function(e,t){void 0===t&&(t=null);var i,n,o,r,s=null,a=0;if(null===t)n=0,r=0;else{if(n=this.indexes[t]+1,!(i=this.heightMap[n-1]))return void console.error("view item doesnt exist");r=i.top+i.height}for(var l=this.heightMap.splice.bind(this.heightMap,n,0),u=[];s=e.next();)(i=this.createViewItem(s)).top=r+a,
this.indexes[s.id]=n++,u.push(i),a+=i.height;for(l.apply(this.heightMap,u),o=n;o<this.heightMap.length;o++)(i=this.heightMap[o]).top+=a,this.indexes[i.model.id]=o;for(o=u.length-1;o>=0;o--)this.onInsertItem(u[o]);for(o=this.heightMap.length-1;o>=n;o--)this.onRefreshItem(this.heightMap[o]);return a},e.prototype.onInsertItem=function(e){},e.prototype.onRemoveItems=function(e){for(var t,i=null,n=null,o=0,r=0;i=e.next();){if(o=this.indexes[i],!(t=this.heightMap[o]))return void console.error("view item doesnt exist");r-=t.height,delete this.indexes[i],this.onRemoveItem(t),null===n&&(n=o)}if(0!==r&&null!==n)for(this.heightMap.splice(n,o-n+1),o=n;o<this.heightMap.length;o++)(t=this.heightMap[o]).top+=r,this.indexes[t.model.id]=o,this.onRefreshItem(t)},e.prototype.onRemoveItem=function(e){},e.prototype.onRefreshItemSet=function(e){var t=this,n=e.sort(function(e,i){return t.indexes[e.id]-t.indexes[i.id]});this.onRefreshItems(new i.ArrayIterator(n))},e.prototype.onRefreshItems=function(e){
for(var t,i,n,o=null,r=null,s=0;o=e.next();){for(n=this.indexes[o.id];0!==s&&null!==r&&r<n;r++)(t=this.heightMap[r]).top+=s,this.onRefreshItem(t);t=this.heightMap[n],i=o.getHeight(),t.top+=s,s+=i-t.height,t.height=i,this.onRefreshItem(t,!0),r=n+1}if(0!==s&&null!==r)for(;r<this.heightMap.length;r++)(t=this.heightMap[r]).top+=s,this.onRefreshItem(t)},e.prototype.onRefreshItem=function(e,t){void 0===t&&(t=!1)},e.prototype.indexAt=function(e){for(var t,i,n=0,o=this.heightMap.length;n<o;)if(t=Math.floor((n+o)/2),i=this.heightMap[t],e<i.top)o=t;else{if(!(e>=i.top+i.height))return t;if(n===t)break;n=t}return this.heightMap.length},e.prototype.indexAfter=function(e){return Math.min(this.indexAt(e)+1,this.heightMap.length)},e.prototype.itemAtIndex=function(e){return this.heightMap[e]},e.prototype.itemAfter=function(e){return this.heightMap[this.indexes[e.model.id]+1]||null},e.prototype.createViewItem=function(e){throw new Error("not implemented")},e.prototype.dispose=function(){this.heightMap=[],this.indexes={}},e}()
;t.HeightMap=n}),define(t[445],i([1,0,18,201]),function(e,t,i,n){"use strict";function o(t,i){if(/^(http:)|(https:)|(file:)/.test(t)){var n=String(window.location),o=n.substr(0,n.length-window.location.hash.length-window.location.search.length-window.location.pathname.length);if(t.substring(0,o.length)!==o){var r="vs/base/worker/defaultWorkerFactory.js",s="/*"+i+"*/self.MonacoEnvironment={baseUrl: '"+e.toUrl(r).slice(0,-r.length)+"'};importScripts('"+t+"');/*"+i+"*/";return"data:text/javascript;charset=utf-8,"+encodeURIComponent(s)}}return t+"#"+i}Object.defineProperty(t,"__esModule",{value:!0}),t.getWorkerBootstrapUrl=o;var r=function(){function t(t,n,r,s,a){this.id=n;var l=function(t,n){if(i.globals.MonacoEnvironment){if("function"==typeof i.globals.MonacoEnvironment.getWorker)return i.globals.MonacoEnvironment.getWorker(t,n);if("function"==typeof i.globals.MonacoEnvironment.getWorkerUrl)return new Worker(i.globals.MonacoEnvironment.getWorkerUrl(t,n))}if("function"==typeof e){var r=o(e.toUrl("./"+t),n)
;return new Worker(r,{name:n})}throw new Error("You must define a function MonacoEnvironment.getWorkerUrl or MonacoEnvironment.getWorker")}("workerMain.js",r);!function(e){return"function"==typeof e.then}(l)?this.worker=Promise.resolve(l):this.worker=l,this.postMessage(t,[]),this.worker.then(function(e){e.onmessage=function(e){s(e.data)},e.onmessageerror=a,"function"==typeof e.addEventListener&&e.addEventListener("error",a)})}return t.prototype.getId=function(){return this.id},t.prototype.postMessage=function(e,t){this.worker&&this.worker.then(function(i){return i.postMessage(e,t)})},t.prototype.dispose=function(){this.worker&&this.worker.then(function(e){return e.terminate()}),this.worker=null},t}(),s=function(){function e(e){this._label=e,this._webWorkerFailedBeforeError=!1}return e.prototype.create=function(t,i,o){var s=this,a=++e.LAST_WORKER_ID;if(this._webWorkerFailedBeforeError)throw this._webWorkerFailedBeforeError;return new r(t,a,this._label||"anonymous"+a,i,function(e){n.logOnceWebWorkerWarning(e),
s._webWorkerFailedBeforeError=e,o(e)})},e.LAST_WORKER_ID=0,e}();t.DefaultWorkerFactory=s}),define(t[442],i([9]),{}),define(t[439],i([9]),{}),define(t[434],i([9]),{}),define(t[164],i([1,0,8,45,25,4,29,434]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l={inputActiveOptionBorder:o.Color.fromHex("#007ACC00"),inputActiveOptionBackground:o.Color.fromHex("#0E639C50")},u=function(e){function t(t){var i=e.call(this)||this;return i._onChange=i._register(new s.Emitter),i.onChange=i._onChange.event,i._onKeyDown=i._register(new s.Emitter),i.onKeyDown=i._onKeyDown.event,i._opts=a.deepClone(t),a.mixin(i._opts,l,!1),i._checked=i._opts.isChecked,i.domNode=document.createElement("div"),i.domNode.title=i._opts.title,i.domNode.className="monaco-custom-checkbox "+(i._opts.actionClassName||"")+" "+(i._checked?"checked":"unchecked"),i.domNode.tabIndex=0,i.domNode.setAttribute("role","checkbox"),i.domNode.setAttribute("aria-checked",String(i._checked)),
i.domNode.setAttribute("aria-label",i._opts.title),i.applyStyles(),i.onclick(i.domNode,function(e){i.checked=!i._checked,i._onChange.fire(!1),e.preventDefault()}),i.onkeydown(i.domNode,function(e){if(10===e.keyCode||3===e.keyCode)return i.checked=!i._checked,i._onChange.fire(!0),void e.preventDefault();i._onKeyDown.fire(e)}),i}return r(t,e),t.prototype.focus=function(){this.domNode.focus()},Object.defineProperty(t.prototype,"checked",{get:function(){return this._checked},set:function(e){this._checked=e,this.domNode.setAttribute("aria-checked",String(this._checked)),this._checked?this.domNode.classList.add("checked"):this.domNode.classList.remove("checked"),this.applyStyles()},enumerable:!0,configurable:!0}),t.prototype.width=function(){return 22},t.prototype.style=function(e){e.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=e.inputActiveOptionBorder),e.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=e.inputActiveOptionBackground),this.applyStyles()},
t.prototype.applyStyles=function(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"transparent",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"transparent")},t.prototype.enable=function(){this.domNode.tabIndex=0,this.domNode.setAttribute("aria-disabled",String(!1))},t.prototype.disable=function(){i.removeTabIndexAndUpdateFocus(this.domNode),this.domNode.setAttribute("aria-disabled",String(!0))},t}(n.Widget);t.Checkbox=u}),define(t[428],i([9]),{}),define(t[426],i([1,0,8,2,124,428]),function(e,t,i,n,o){"use strict";function s(e,t,i){var n=i.offset+i.size;return 0===i.position?t<=e-n?n:t<=i.offset?i.offset-t:Math.max(e-t,0):t<=i.offset?i.offset-t:t<=e-n?n:0}Object.defineProperty(t,"__esModule",{value:!0}),t.layout=s;var a=function(e){function t(t){var o=e.call(this)||this;return o.container=null,o.delegate=null,
o.toDisposeOnClean=n.Disposable.None,o.toDisposeOnSetContainer=n.Disposable.None,o.view=i.$(".context-view"),i.hide(o.view),o.setContainer(t),o._register(n.toDisposable(function(){return o.setContainer(null)})),o}return r(t,e),t.prototype.setContainer=function(e){var o=this;if(this.container&&(this.toDisposeOnSetContainer.dispose(),this.container.removeChild(this.view),this.container=null),e){this.container=e,this.container.appendChild(this.view);var r=new n.DisposableStore;t.BUBBLE_UP_EVENTS.forEach(function(e){r.add(i.addStandardDisposableListener(o.container,e,function(e){o.onDOMEvent(e,!1)}))}),t.BUBBLE_DOWN_EVENTS.forEach(function(e){r.add(i.addStandardDisposableListener(o.container,e,function(e){o.onDOMEvent(e,!0)},!0))}),this.toDisposeOnSetContainer=r}},t.prototype.show=function(e){this.isVisible()&&this.hide(),i.clearNode(this.view),this.view.className="context-view",this.view.style.top="0px",this.view.style.left="0px",i.show(this.view),this.toDisposeOnClean=e.render(this.view)||n.Disposable.None,
this.delegate=e,this.doLayout(),this.delegate.focus&&this.delegate.focus()},t.prototype.layout=function(){this.isVisible()&&(!1!==this.delegate.canRelayout?(this.delegate.layout&&this.delegate.layout(),this.doLayout()):this.hide())},t.prototype.doLayout=function(){if(this.isVisible()){var e,t=this.delegate.getAnchor();if(i.isHTMLElement(t)){var n=i.getDomNodePagePosition(t);e={top:n.top,left:n.left,width:n.width,height:n.height}}else e={top:t.y,left:t.x,width:t.width||1,height:t.height||2};var r,a=i.getTotalWidth(this.view),l=i.getTotalHeight(this.view),u=this.delegate.anchorPosition||0,d=this.delegate.anchorAlignment||0,c={offset:e.top-window.pageYOffset,size:e.height,position:0===u?0:1};r=0===d?{offset:e.left,size:0,position:0}:{offset:e.left+e.width,size:0,position:1};var h=s(window.innerHeight,l,c)+window.pageYOffset;o.Range.intersects({start:h,end:h+l},{start:c.offset,end:c.offset+c.size})&&(r.size=e.width,1===d&&(r.offset=e.left));var p=s(window.innerWidth,a,r)
;i.removeClasses(this.view,"top","bottom","left","right"),i.addClass(this.view,0===u?"bottom":"top"),i.addClass(this.view,0===d?"left":"right");var f=i.getDomNodePagePosition(this.container);this.view.style.top=h-f.top+"px",this.view.style.left=p-f.left+"px",this.view.style.width="initial"}},t.prototype.hide=function(e){var t=this.delegate;this.delegate=null,t&&t.onHide&&t.onHide(e),this.toDisposeOnClean.dispose(),i.hide(this.view)},t.prototype.isVisible=function(){return!!this.delegate},t.prototype.onDOMEvent=function(e,t){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(e,document.activeElement):t&&!i.isAncestor(e.target,this.container)&&this.hide())},t.prototype.dispose=function(){this.hide(),e.prototype.dispose.call(this)},t.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"],t.BUBBLE_DOWN_EVENTS=["click"],t}(n.Disposable);t.ContextView=a}),define(t[425],i([9]),{}),define(t[422],i([1,0,8,5,25,29,425]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var s={badgeBackground:o.Color.fromHex("#4D4D4D"),badgeForeground:o.Color.fromHex("#FFFFFF")},a=function(){function e(e,t){this.count=0,this.options=t||Object.create(null),r.mixin(this.options,s,!1),this.badgeBackground=this.options.badgeBackground,this.badgeForeground=this.options.badgeForeground,this.badgeBorder=this.options.badgeBorder,this.element=i.append(e,i.$(".monaco-count-badge")),this.countFormat=this.options.countFormat||"{0}",this.titleFormat=this.options.titleFormat||"",this.setCount(this.options.count||0)}return e.prototype.setCount=function(e){this.count=e,this.render()},e.prototype.setTitleFormat=function(e){this.titleFormat=e,this.render()},e.prototype.render=function(){this.element.textContent=n.format(this.countFormat,this.count),this.element.title=n.format(this.titleFormat,this.count),this.applyStyles()},e.prototype.style=function(e){this.badgeBackground=e.badgeBackground,this.badgeForeground=e.badgeForeground,this.badgeBorder=e.badgeBorder,this.applyStyles()},
e.prototype.applyStyles=function(){if(this.element){var e=this.badgeBackground?this.badgeBackground.toString():null,t=this.badgeForeground?this.badgeForeground.toString():null,i=this.badgeBorder?this.badgeBorder.toString():null;this.element.style.backgroundColor=e,this.element.style.color=t,this.element.style.borderWidth=i?"1px":null,this.element.style.borderStyle=i?"solid":null,this.element.style.borderColor=i}},e}();t.CountBadge=a}),define(t[196],i([9]),{}),define(t[418],i([9]),{}),define(t[417],i([9]),{}),define(t[135],i([1,0,8,157,2,417]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e){this._element=e}return Object.defineProperty(e.prototype,"element",{get:function(){return this._element},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"textContent",{set:function(e){this.disposed||e===this._textContent||(this._textContent=e,this._element.textContent=e)},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"className",{set:function(e){this.disposed||e===this._className||(this._className=e,this._element.className=e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"title",{set:function(e){this.disposed||e===this._title||(this._title=e,this._title?this._element.title=e:this._element.removeAttribute("title"))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"empty",{set:function(e){this.disposed||e===this._empty||(this._empty=e,this._element.style.marginLeft=e?"0":null)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.disposed=!0},e}(),a=function(e){function t(t,o){var r=e.call(this)||this;return r.domNode=r._register(new s(i.append(t,i.$(".monaco-icon-label")))),r.labelDescriptionContainer=r._register(new s(i.append(r.domNode.element,i.$(".monaco-icon-label-description-container")))),
o&&o.supportHighlights?r.labelNode=new n.HighlightedLabel(i.append(r.labelDescriptionContainer.element,i.$("a.label-name")),!!o.supportOcticons):r.labelNode=r._register(new s(i.append(r.labelDescriptionContainer.element,i.$("a.label-name")))),o&&o.supportDescriptionHighlights?r.descriptionNodeFactory=function(){return new n.HighlightedLabel(i.append(r.labelDescriptionContainer.element,i.$("span.label-description")),!!o.supportOcticons)}:r.descriptionNodeFactory=function(){return r._register(new s(i.append(r.labelDescriptionContainer.element,i.$("span.label-description"))))},r}return r(t,e),t.prototype.setLabel=function(e,t,i){var o=["monaco-icon-label"];i&&(i.extraClasses&&o.push.apply(o,i.extraClasses),i.italic&&o.push("italic")),this.domNode.className=o.join(" "),this.domNode.title=i&&i.title?i.title:"",this.labelNode instanceof n.HighlightedLabel?this.labelNode.set(e||"",i?i.matches:void 0,i&&i.title?i.title:void 0,i&&i.labelEscapeNewLines):this.labelNode.textContent=e||"",
(t||this.descriptionNode)&&(this.descriptionNode||(this.descriptionNode=this.descriptionNodeFactory()),this.descriptionNode instanceof n.HighlightedLabel?(this.descriptionNode.set(t||"",i?i.descriptionMatches:void 0),i&&i.descriptionTitle?this.descriptionNode.element.title=i.descriptionTitle:this.descriptionNode.element.removeAttribute("title")):(this.descriptionNode.textContent=t||"",this.descriptionNode.title=i&&i.descriptionTitle?i.descriptionTitle:"",this.descriptionNode.empty=!t))},t}(o.Disposable);t.IconLabel=a}),define(t[416],i([9]),{}),define(t[404],i([9]),{}),define(t[403],i([9]),{}),define(t[402],i([9]),{}),define(t[396],i([9]),{}),define(t[395],i([1,0,2,25,29,8,15,396]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l={progressBarBackground:n.Color.fromHex("#0E70C0")},u=function(e){function t(t,i){var n=e.call(this)||this;return n.options=i||Object.create(null),o.mixin(n.options,l,!1),n.workedVal=0,n.progressBarBackground=n.options.progressBarBackground,
n._register(n.showDelayedScheduler=new a.RunOnceScheduler(function(){return s.show(n.element)},0)),n.create(t),n}return r(t,e),t.prototype.create=function(e){this.element=document.createElement("div"),s.addClass(this.element,"monaco-progress-container"),e.appendChild(this.element),this.bit=document.createElement("div"),s.addClass(this.bit,"progress-bit"),this.element.appendChild(this.bit),this.applyStyles()},t.prototype.off=function(){this.bit.style.width="inherit",this.bit.style.opacity="1",s.removeClasses(this.element,"active","infinite","discrete"),this.workedVal=0,this.totalWork=void 0},t.prototype.stop=function(){return this.doDone(!1)},t.prototype.doDone=function(e){var t=this;return s.addClass(this.element,"done"),s.hasClass(this.element,"infinite")?(this.bit.style.opacity="0",e?setTimeout(function(){return t.off()},200):this.off()):(this.bit.style.width="inherit",e?setTimeout(function(){return t.off()},200):this.off()),this},t.prototype.hide=function(){s.hide(this.element),
this.showDelayedScheduler.cancel()},t.prototype.style=function(e){this.progressBarBackground=e.progressBarBackground,this.applyStyles()},t.prototype.applyStyles=function(){if(this.bit){var e=this.progressBarBackground?this.progressBarBackground.toString():null;this.bit.style.backgroundColor=e}},t}(i.Disposable);t.ProgressBar=u}),define(t[390],i([9]),{}),define(t[100],i([1,0,2,28,18,23,79,44,4,8,52,390]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h=!1,p=function(e){function t(t,r,s){void 0===s&&(s={});var l=e.call(this)||this;return l._state=3,l._onDidEnablementChange=l._register(new u.Emitter),l.onDidEnablementChange=l._onDidEnablementChange.event,l._onDidStart=l._register(new u.Emitter),l.onDidStart=l._onDidStart.event,l._onDidChange=l._register(new u.Emitter),l.onDidChange=l._onDidChange.event,l._onDidReset=l._register(new u.Emitter),l.onDidReset=l._onDidReset.event,l._onDidEnd=l._register(new u.Emitter),l.onDidEnd=l._onDidEnd.event,l.linkedSash=void 0,
l.orthogonalStartSashDisposables=l._register(new i.DisposableStore),l.orthogonalEndSashDisposables=l._register(new i.DisposableStore),l.el=d.append(t,d.$(".monaco-sash")),o.isMacintosh&&d.addClass(l.el,"mac"),l._register(c.domEvent(l.el,"mousedown")(l.onMouseDown,l)),l._register(c.domEvent(l.el,"dblclick")(l.onMouseDoubleClick,l)),a.Gesture.addTarget(l.el),l._register(c.domEvent(l.el,a.EventType.Start)(l.onTouchStart,l)),n.isIPad&&d.addClass(l.el,"touch"),l.setOrientation(s.orientation||0),l.hidden=!1,l.layoutProvider=r,l.orthogonalStartSash=s.orthogonalStartSash,l.orthogonalEndSash=s.orthogonalEndSash,d.toggleClass(l.el,"debug",h),l}return r(t,e),Object.defineProperty(t.prototype,"state",{get:function(){return this._state},set:function(e){this._state!==e&&(d.toggleClass(this.el,"disabled",0===e),d.toggleClass(this.el,"minimum",1===e),d.toggleClass(this.el,"maximum",2===e),this._state=e,this._onDidEnablementChange.fire(e))},enumerable:!0,configurable:!0}),
Object.defineProperty(t.prototype,"orthogonalStartSash",{get:function(){return this._orthogonalStartSash},set:function(e){this.orthogonalStartSashDisposables.clear(),e?(this.orthogonalStartSashDisposables.add(e.onDidEnablementChange(this.onOrthogonalStartSashEnablementChange,this)),this.onOrthogonalStartSashEnablementChange(e.state)):this.onOrthogonalStartSashEnablementChange(0),this._orthogonalStartSash=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"orthogonalEndSash",{get:function(){return this._orthogonalEndSash},set:function(e){this.orthogonalEndSashDisposables.clear(),e?(this.orthogonalEndSashDisposables.add(e.onDidEnablementChange(this.onOrthogonalEndSashEnablementChange,this)),this.onOrthogonalEndSashEnablementChange(e.state)):this.onOrthogonalEndSashEnablementChange(0),this._orthogonalEndSash=e},enumerable:!0,configurable:!0}),t.prototype.setOrientation=function(e){this.orientation=e,1===this.orientation?(d.addClass(this.el,"horizontal"),
d.removeClass(this.el,"vertical")):(d.removeClass(this.el,"horizontal"),d.addClass(this.el,"vertical")),this.layoutProvider&&this.layout()},t.prototype.onMouseDown=function(e){var t=this;d.EventHelper.stop(e,!1);var n=!1;if(!e.__orthogonalSashEvent){var r=this.getOrthogonalSash(e);r&&(n=!0,e.__orthogonalSashEvent=!0,r.onMouseDown(e))}if(this.linkedSash&&!e.__linkedSashEvent&&(e.__linkedSashEvent=!0,this.linkedSash.onMouseDown(e)),this.state){for(var s=d.getElementsByTagName("iframe").concat(d.getElementsByTagName("webview")),a=0,u=s;a<u.length;a++){u[a].style.pointerEvents="none"}var h=new l.StandardMouseEvent(e),p=h.posx,f=h.posy,g=h.altKey,m={startX:p,currentX:p,startY:f,currentY:f,altKey:g};d.addClass(this.el,"active"),this._onDidStart.fire(m);var v=d.createStyleSheet(this.el),_=function(){var e="";e=n?"all-scroll":1===t.orientation?1===t.state?"s-resize":2===t.state?"n-resize":o.isMacintosh?"row-resize":"ns-resize":1===t.state?"e-resize":2===t.state?"w-resize":o.isMacintosh?"col-resize":"ew-resize",
v.innerHTML="* { cursor: "+e+" !important; }"},y=new i.DisposableStore;_(),n||this.onDidEnablementChange(_,null,y);c.domEvent(window,"mousemove")(function(e){d.EventHelper.stop(e,!1);var i=new l.StandardMouseEvent(e),n={startX:p,currentX:i.posx,startY:f,currentY:i.posy,altKey:g};t._onDidChange.fire(n)},null,y),c.domEvent(window,"mouseup")(function(e){d.EventHelper.stop(e,!1),t.el.removeChild(v),d.removeClass(t.el,"active"),t._onDidEnd.fire(),y.dispose();for(var i=0,n=s;i<n.length;i++)n[i].style.pointerEvents="auto"},null,y)}},t.prototype.onMouseDoubleClick=function(e){var t=this.getOrthogonalSash(e);t&&t._onDidReset.fire(),this.linkedSash&&this.linkedSash._onDidReset.fire(),this._onDidReset.fire()},t.prototype.onTouchStart=function(e){var t=this;d.EventHelper.stop(e);var n=[],o=e.pageX,r=e.pageY,l=e.altKey;this._onDidStart.fire({startX:o,currentX:o,startY:r,currentY:r,altKey:l}),n.push(d.addDisposableListener(this.el,a.EventType.Change,function(e){
s.isNumber(e.pageX)&&s.isNumber(e.pageY)&&t._onDidChange.fire({startX:o,currentX:e.pageX,startY:r,currentY:e.pageY,altKey:l})})),n.push(d.addDisposableListener(this.el,a.EventType.End,function(e){t._onDidEnd.fire(),i.dispose(n)}))},t.prototype.layout=function(){var e=n.isIPad?20:4;if(0===this.orientation){var t=this.layoutProvider;this.el.style.left=t.getVerticalSashLeft(this)-e/2+"px",t.getVerticalSashTop&&(this.el.style.top=t.getVerticalSashTop(this)+"px"),t.getVerticalSashHeight&&(this.el.style.height=t.getVerticalSashHeight(this)+"px")}else{var i=this.layoutProvider;this.el.style.top=i.getHorizontalSashTop(this)-e/2+"px",i.getHorizontalSashLeft&&(this.el.style.left=i.getHorizontalSashLeft(this)+"px"),i.getHorizontalSashWidth&&(this.el.style.width=i.getHorizontalSashWidth(this)+"px")}},t.prototype.hide=function(){this.hidden=!0,this.el.style.display="none",this.el.setAttribute("aria-hidden","true")},t.prototype.onOrthogonalStartSashEnablementChange=function(e){
d.toggleClass(this.el,"orthogonal-start",0!==e)},t.prototype.onOrthogonalEndSashEnablementChange=function(e){d.toggleClass(this.el,"orthogonal-end",0!==e)},t.prototype.getOrthogonalSash=function(e){if(0===this.orientation){if(e.offsetY<=4)return this.orthogonalStartSash;if(e.offsetY>=this.el.clientHeight-4)return this.orthogonalEndSash}else{if(e.offsetX<=4)return this.orthogonalStartSash;if(e.offsetX>=this.el.clientWidth-4)return this.orthogonalEndSash}},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.el&&this.el.parentElement&&this.el.parentElement.removeChild(this.el),this.el=null},t}(i.Disposable);t.Sash=p}),define(t[389],i([9]),{}),define(t[51],i([1,0,28,8,27,44,463,458,45,15,4,2,18,215,389]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f){"use strict";function g(e){var t={lazyRender:void 0!==e.lazyRender&&e.lazyRender,className:void 0!==e.className?e.className:"",useShadows:void 0===e.useShadows||e.useShadows,handleMouseWheel:void 0===e.handleMouseWheel||e.handleMouseWheel,
flipAxes:void 0!==e.flipAxes&&e.flipAxes,alwaysConsumeMouseWheel:void 0!==e.alwaysConsumeMouseWheel&&e.alwaysConsumeMouseWheel,scrollYToX:void 0!==e.scrollYToX&&e.scrollYToX,mouseWheelScrollSensitivity:void 0!==e.mouseWheelScrollSensitivity?e.mouseWheelScrollSensitivity:1,fastScrollSensitivity:void 0!==e.fastScrollSensitivity?e.fastScrollSensitivity:5,mouseWheelSmoothScroll:void 0===e.mouseWheelSmoothScroll||e.mouseWheelSmoothScroll,arrowSize:void 0!==e.arrowSize?e.arrowSize:11,listenOnDomNode:void 0!==e.listenOnDomNode?e.listenOnDomNode:null,horizontal:void 0!==e.horizontal?e.horizontal:1,horizontalScrollbarSize:void 0!==e.horizontalScrollbarSize?e.horizontalScrollbarSize:10,horizontalSliderSize:void 0!==e.horizontalSliderSize?e.horizontalSliderSize:0,horizontalHasArrows:void 0!==e.horizontalHasArrows&&e.horizontalHasArrows,vertical:void 0!==e.vertical?e.vertical:1,verticalScrollbarSize:void 0!==e.verticalScrollbarSize?e.verticalScrollbarSize:10,
verticalHasArrows:void 0!==e.verticalHasArrows&&e.verticalHasArrows,verticalSliderSize:void 0!==e.verticalSliderSize?e.verticalSliderSize:0};return t.horizontalSliderSize=void 0!==e.horizontalSliderSize?e.horizontalSliderSize:t.horizontalScrollbarSize,t.verticalSliderSize=void 0!==e.verticalSliderSize?e.verticalSliderSize:t.verticalScrollbarSize,p.isMacintosh&&(t.className+=" mac"),t}Object.defineProperty(t,"__esModule",{value:!0});var m=function(){return function(e,t,i){this.timestamp=e,this.deltaX=t,this.deltaY=i,this.score=0}}(),v=function(){function e(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}return e.prototype.isPhysicalMouseWheel=function(){if(-1===this._front&&-1===this._rear)return!1;for(var e=1,t=0,i=1,n=this._rear;;){var o=n===this._front?e:Math.pow(2,-i);if(e-=o,t+=this._memory[n].score*o,n===this._front)break;n=(this._capacity+n-1)%this._capacity,i++}return t<=.5},e.prototype.accept=function(e,t,i){var n=new m(e,t,i);n.score=this._computeScore(n),
-1===this._front&&-1===this._rear?(this._memory[0]=n,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=n)},e.prototype._computeScore=function(e){if(Math.abs(e.deltaX)>0&&Math.abs(e.deltaY)>0)return 1;var t=.5;-1===this._front&&-1===this._rear||this._memory[this._rear];return(Math.abs(e.deltaX-Math.round(e.deltaX))>0||Math.abs(e.deltaY-Math.round(e.deltaY))>0)&&(t+=.25),Math.min(Math.max(t,0),1)},e.INSTANCE=new e,e}();t.MouseWheelClassifier=v;var _=function(e){function t(t,i,n){var r=e.call(this)||this;r._onScroll=r._register(new c.Emitter),r.onScroll=r._onScroll.event,t.style.overflow="hidden",r._options=g(i),r._scrollable=n,r._register(r._scrollable.onScroll(function(e){r._onDidScroll(e),r._onScroll.fire(e)}));var s={onMouseWheel:function(e){return r._onMouseWheel(e)},onDragStart:function(){return r._onDragStart()},onDragEnd:function(){return r._onDragEnd()}}
;return r._verticalScrollbar=r._register(new l.VerticalScrollbar(r._scrollable,r._options,s)),r._horizontalScrollbar=r._register(new a.HorizontalScrollbar(r._scrollable,r._options,s)),r._domNode=document.createElement("div"),r._domNode.className="monaco-scrollable-element "+r._options.className,r._domNode.setAttribute("role","presentation"),r._domNode.style.position="relative",r._domNode.style.overflow="hidden",r._domNode.appendChild(t),r._domNode.appendChild(r._horizontalScrollbar.domNode.domNode),r._domNode.appendChild(r._verticalScrollbar.domNode.domNode),r._options.useShadows?(r._leftShadowDomNode=o.createFastDomNode(document.createElement("div")),r._leftShadowDomNode.setClassName("shadow"),r._domNode.appendChild(r._leftShadowDomNode.domNode),r._topShadowDomNode=o.createFastDomNode(document.createElement("div")),r._topShadowDomNode.setClassName("shadow"),r._domNode.appendChild(r._topShadowDomNode.domNode),r._topLeftShadowDomNode=o.createFastDomNode(document.createElement("div")),
r._topLeftShadowDomNode.setClassName("shadow top-left-corner"),r._domNode.appendChild(r._topLeftShadowDomNode.domNode)):(r._leftShadowDomNode=null,r._topShadowDomNode=null,r._topLeftShadowDomNode=null),r._listenOnDomNode=r._options.listenOnDomNode||r._domNode,r._mouseWheelToDispose=[],r._setListeningToMouseWheel(r._options.handleMouseWheel),r.onmouseover(r._listenOnDomNode,function(e){return r._onMouseOver(e)}),r.onnonbubblingmouseout(r._listenOnDomNode,function(e){return r._onMouseOut(e)}),r._hideTimeout=r._register(new d.TimeoutTimer),r._isDragging=!1,r._mouseIsOver=!1,r._shouldRender=!0,r._revealOnScroll=!0,r}return r(t,e),t.prototype.dispose=function(){this._mouseWheelToDispose=h.dispose(this._mouseWheelToDispose),e.prototype.dispose.call(this)},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getOverviewRulerLayoutInfo=function(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}},t.prototype.delegateVerticalScrollbarMouseDown=function(e){
this._verticalScrollbar.delegateMouseDown(e)},t.prototype.getScrollDimensions=function(){return this._scrollable.getScrollDimensions()},t.prototype.setScrollDimensions=function(e){this._scrollable.setScrollDimensions(e)},t.prototype.updateClassName=function(e){this._options.className=e,p.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className},t.prototype.updateOptions=function(e){var t=g(e);this._options.handleMouseWheel=t.handleMouseWheel,this._options.mouseWheelScrollSensitivity=t.mouseWheelScrollSensitivity,this._options.fastScrollSensitivity=t.fastScrollSensitivity,this._setListeningToMouseWheel(this._options.handleMouseWheel),this._options.lazyRender||this._render()},t.prototype._setListeningToMouseWheel=function(e){var t=this;if(this._mouseWheelToDispose.length>0!==e&&(this._mouseWheelToDispose=h.dispose(this._mouseWheelToDispose),e)){var o=function(e){t._onMouseWheel(new s.StandardWheelEvent(e))}
;this._mouseWheelToDispose.push(n.addDisposableListener(this._listenOnDomNode,i.isEdgeOrIE?"mousewheel":"wheel",o))}},t.prototype._onMouseWheel=function(e){var t,i=v.INSTANCE;if(i.accept(Date.now(),e.deltaX,e.deltaY),e.deltaY||e.deltaX){var n=e.deltaY*this._options.mouseWheelScrollSensitivity,o=e.deltaX*this._options.mouseWheelScrollSensitivity;this._options.flipAxes&&(n=(t=[o,n])[0],o=t[1]);var r=!p.isMacintosh&&e.browserEvent&&e.browserEvent.shiftKey;!this._options.scrollYToX&&!r||o||(o=n,n=0),e.browserEvent&&e.browserEvent.altKey&&(o*=this._options.fastScrollSensitivity,n*=this._options.fastScrollSensitivity);var s=this._scrollable.getFutureScrollPosition(),a={};if(n){var l=s.scrollTop-50*n;this._verticalScrollbar.writeScrollPosition(a,l)}if(o){var u=s.scrollLeft-50*o;this._horizontalScrollbar.writeScrollPosition(a,u)}if(a=this._scrollable.validateScrollPosition(a),s.scrollLeft!==a.scrollLeft||s.scrollTop!==a.scrollTop){
this._options.mouseWheelSmoothScroll&&i.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(a):this._scrollable.setScrollPositionNow(a),this._shouldRender=!0}}(this._options.alwaysConsumeMouseWheel||this._shouldRender)&&(e.preventDefault(),e.stopPropagation())},t.prototype._onDidScroll=function(e){this._shouldRender=this._horizontalScrollbar.onDidScroll(e)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(e)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()},t.prototype.renderNow=function(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()},t.prototype._render=function(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){var e=this._scrollable.getCurrentScrollPosition(),t=e.scrollTop>0,i=e.scrollLeft>0
;this._leftShadowDomNode.setClassName("shadow"+(i?" left":"")),this._topShadowDomNode.setClassName("shadow"+(t?" top":"")),this._topLeftShadowDomNode.setClassName("shadow top-left-corner"+(t?" top":"")+(i?" left":""))}},t.prototype._onDragStart=function(){this._isDragging=!0,this._reveal()},t.prototype._onDragEnd=function(){this._isDragging=!1,this._hide()},t.prototype._onMouseOut=function(e){this._mouseIsOver=!1,this._hide()},t.prototype._onMouseOver=function(e){this._mouseIsOver=!0,this._reveal()},t.prototype._reveal=function(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()},t.prototype._hide=function(){this._mouseIsOver||this._isDragging||(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())},t.prototype._scheduleHide=function(){var e=this;this._mouseIsOver||this._isDragging||this._hideTimeout.cancelAndSet(function(){return e._hide()},500)},t}(u.Widget);t.AbstractScrollableElement=_;var y=function(e){function t(t,i){var o=this
;(i=i||{}).mouseWheelSmoothScroll=!1;var r=new f.Scrollable(0,function(e){return n.scheduleAtNextAnimationFrame(e)});return(o=e.call(this,t,i,r)||this)._register(r),o}return r(t,e),t.prototype.setScrollPosition=function(e){this._scrollable.setScrollPositionNow(e)},t.prototype.getScrollPosition=function(){return this._scrollable.getCurrentScrollPosition()},t}(_);t.ScrollableElement=y;var b=function(e){function t(t,i,n){return e.call(this,t,i,n)||this}return r(t,e),t}(_);t.SmoothScrollableElement=b;var C=function(e){function t(t,i){var n=e.call(this,t,i)||this;return n._element=t,n.onScroll(function(e){e.scrollTopChanged&&(n._element.scrollTop=e.scrollTop),e.scrollLeftChanged&&(n._element.scrollLeft=e.scrollLeft)}),n.scanDomNode(),n}return r(t,e),t.prototype.scanDomNode=function(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,
scrollTop:this._element.scrollTop})},t}(y);t.DomScrollableElement=C}),define(t[152],i([1,0,29,2,79,8,4,52,51,528,471,18,28,115,124,19,154,15]),function(e,t,i,n,o,r,s,a,l,u,c,h,p,f,g,m,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var y={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements:function(e){return[e]},getDragURI:function(){return null},onDragStart:function(){},onDragOver:function(){return!1},drop:function(){}},horizontalScrolling:!1},b=function(){function e(e){this.elements=e}return e.prototype.update=function(){},e.prototype.getData=function(){return this.elements},e}();t.ElementsDragAndDropData=b;var C=function(){function e(e){this.elements=e}return e.prototype.update=function(){},e.prototype.getData=function(){return this.elements},e}();t.ExternalElementsDragAndDropData=C;var S=function(){function e(){this.types=[],this.files=[]}return e.prototype.update=function(e){var t
;if(e.types&&(t=this.types).splice.apply(t,[0,this.types.length].concat(e.types)),e.files){this.files.splice(0,this.files.length);for(var i=0;i<e.files.length;i++){var n=e.files.item(i);n&&(n.size||n.type)&&this.files.push(n)}}},e.prototype.getData=function(){return{types:this.types,files:this.files}},e}();t.DesktopDragAndDropData=S;var w=function(){function e(t,d,h,p){var f=this;if(void 0===p&&(p=y),this.virtualDelegate=d,this.domId="list_id_"+ ++e.InstanceCount,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new _.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=n.Disposable.None,this.dragOverMouseY=0,this.canUseTranslate3d=void 0,this.canDrop=!1,this.currentDragFeedbackDisposable=n.Disposable.None,this.onDragLeaveTimeout=n.Disposable.None,this._onDidChangeContentHeight=new s.Emitter,
p.horizontalScrolling&&p.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new u.RangeMap;for(var g=0,m=h;g<m.length;g++){var v=m[g];this.renderers.set(v.templateId,v)}this.cache=new c.RowCache(this.renderers),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",r.addClass(this.domNode,this.domId),this.domNode.tabIndex=0,r.toggleClass(this.domNode,"mouse-support","boolean"!=typeof p.mouseSupport||p.mouseSupport),this.horizontalScrolling=i.getOrDefault(p,function(e){return e.horizontalScrolling},y.horizontalScrolling),r.toggleClass(this.domNode,"horizontal-scrolling",this.horizontalScrolling),this.additionalScrollHeight=void 0===p.additionalScrollHeight?0:p.additionalScrollHeight,this.ariaProvider=p.ariaProvider||{getSetSize:function(e,t,i){return i},getPosInSet:function(e,t){return t+1}},this.rowsContainer=document.createElement("div"),
this.rowsContainer.className="monaco-list-rows",o.Gesture.addTarget(this.rowsContainer),this.scrollableElement=new l.ScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:!0,horizontal:this.horizontalScrolling?1:2,vertical:i.getOrDefault(p,function(e){return e.verticalScrollMode},y.verticalScrollMode),useShadows:i.getOrDefault(p,function(e){return e.useShadows},y.useShadows)}),this.domNode.appendChild(this.scrollableElement.getDomNode()),t.appendChild(this.domNode),this.disposables=[this.rangeMap,this.scrollableElement,this.cache],this.scrollableElement.onScroll(this.onScroll,this,this.disposables),a.domEvent(this.rowsContainer,o.EventType.Change)(this.onTouchChange,this,this.disposables),a.domEvent(this.scrollableElement.getDomNode(),"scroll")(function(e){return e.target.scrollTop=0},null,this.disposables),s.Event.map(a.domEvent(this.domNode,"dragover"),function(e){return f.toDragEvent(e)})(this.onDragOver,this,this.disposables),s.Event.map(a.domEvent(this.domNode,"drop"),function(e){
return f.toDragEvent(e)})(this.onDrop,this,this.disposables),a.domEvent(this.domNode,"dragleave")(this.onDragLeave,this,this.disposables),a.domEvent(window,"dragend")(this.onDragEnd,this,this.disposables),this.setRowLineHeight=i.getOrDefault(p,function(e){return e.setRowLineHeight},y.setRowLineHeight),this.supportDynamicHeights=i.getOrDefault(p,function(e){return e.supportDynamicHeights},y.supportDynamicHeights),this.dnd=i.getOrDefault(p,function(e){return e.dnd},y.dnd),this.layout()}return Object.defineProperty(e.prototype,"contentHeight",{get:function(){return this.rangeMap.size},enumerable:!0,configurable:!0}),e.prototype.splice=function(e,t,i){if(void 0===i&&(i=[]),this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(e,t,i)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}},e.prototype._splice=function(e,t,i){var o,r=this;void 0===i&&(i=[]);for(var s=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),a={start:e,
end:e+t},l=g.Range.intersect(s,a),d=l.start;d<l.end;d++)this.removeItemFromDOM(d);var c,h={start:e+t,end:this.items.length},p=g.Range.intersect(h,s),f=g.Range.relativeComplement(h,s),m=i.map(function(e){return{id:String(r.itemId++),element:e,templateId:r.virtualDelegate.getTemplateId(e),size:r.virtualDelegate.getHeight(e),width:void 0,hasDynamicHeight:!!r.virtualDelegate.hasDynamicHeight&&r.virtualDelegate.hasDynamicHeight(e),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:n.Disposable.None}});0===e&&t>=this.items.length?(this.rangeMap=new u.RangeMap,this.rangeMap.splice(0,0,m),this.items=m,c=[]):(this.rangeMap.splice(e,t,m),c=(o=this.items).splice.apply(o,[e,t].concat(m)));for(var v=i.length-t,_=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),y=u.shift(p,v),b=g.Range.intersect(_,y),d=b.start;d<b.end;d++)this.updateItemInDOM(this.items[d],d);for(var C=0,S=g.Range.relativeComplement(y,_);C<S.length;C++)for(d=(I=S[C]).start;d<I.end;d++)this.removeItemFromDOM(d)
;for(var w=f.map(function(e){return u.shift(e,v)}),E=[{start:e,end:e+i.length}].concat(w).map(function(e){return g.Range.intersect(_,e)}),L=this.getNextToLastElement(E),x=0,D=E;x<D.length;x++)for(var I=D[x],d=I.start;d<I.end;d++)this.insertItemInDOM(d,L);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),c.map(function(e){return e.element})},e.prototype.eventuallyUpdateScrollDimensions=function(){var e=this;this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=this._scrollHeight+"px",this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=r.scheduleAtNextAnimationFrame(function(){e.scrollableElement.setScrollDimensions({scrollHeight:e.scrollHeight}),e.updateScrollWidth(),e.scrollableElementUpdateDisposable=null}))},e.prototype.eventuallyUpdateScrollWidth=function(){var e=this;this.horizontalScrolling&&this.scrollableElementWidthDelayer.trigger(function(){return e.updateScrollWidth()})},
e.prototype.updateScrollWidth=function(){if(this.horizontalScrolling){0===this.items.length&&this.scrollableElement.setScrollDimensions({scrollWidth:0});for(var e=0,t=0,i=this.items;t<i.length;t++){var n=i[t];void 0!==n.width&&(e=Math.max(e,n.width))}this.scrollWidth=e,this.scrollableElement.setScrollDimensions({scrollWidth:e+10})}},e.prototype.rerender=function(){if(this.supportDynamicHeights){for(var e=0,t=this.items;e<t.length;e++){t[e].lastDynamicHeightWidth=void 0}this._rerender(this.lastRenderTop,this.lastRenderHeight)}},Object.defineProperty(e.prototype,"length",{get:function(){return this.items.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderHeight",{get:function(){return this.scrollableElement.getScrollDimensions().height},enumerable:!0,configurable:!0}),e.prototype.element=function(e){return this.items[e].element},e.prototype.domElement=function(e){var t=this.items[e].row;return t&&t.domNode},e.prototype.elementHeight=function(e){return this.items[e].size},
e.prototype.elementTop=function(e){return this.rangeMap.positionAt(e)},e.prototype.indexAt=function(e){return this.rangeMap.indexAt(e)},e.prototype.indexAfter=function(e){return this.rangeMap.indexAfter(e)},e.prototype.layout=function(e,t){var i={height:"number"==typeof e?e:r.getContentHeight(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,i.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(i),void 0!==t&&(this.renderWidth=t,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:"number"==typeof t?t:r.getContentWidth(this.domNode)}))},e.prototype.render=function(e,t,i,n){
for(var o=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),r=this.getRenderRange(e,t),s=g.Range.relativeComplement(r,o),a=g.Range.relativeComplement(o,r),l=this.getNextToLastElement(s),u=0,d=s;u<d.length;u++)for(v=(m=d[u]).start;v<m.end;v++)this.insertItemInDOM(v,l);for(var c=0,f=a;c<f.length;c++)for(var m=f[c],v=m.start;v<m.end;v++)this.removeItemFromDOM(v);var _=!h.isWindows&&!p.isFirefox&&0===p.getZoomLevel();if(_){var y="translate3d(-"+i+"px, -"+e+"px, 0px)";this.rowsContainer.style.transform=y,this.rowsContainer.style.webkitTransform=y,_!==this.canUseTranslate3d&&(this.rowsContainer.style.left="0",this.rowsContainer.style.top="0")}else this.rowsContainer.style.left="-"+i+"px",this.rowsContainer.style.top="-"+e+"px",_!==this.canUseTranslate3d&&(this.rowsContainer.style.transform="",this.rowsContainer.style.webkitTransform="");this.horizontalScrolling&&(this.rowsContainer.style.width=Math.max(n,this.renderWidth)+"px"),this.canUseTranslate3d=_,this.lastRenderTop=e,this.lastRenderHeight=t},
e.prototype.insertItemInDOM=function(e,t){var i=this,n=this.items[e];if(!n.row){n.row=this.cache.alloc(n.templateId);var o=this.ariaProvider.getRole?this.ariaProvider.getRole(n.element):"treeitem";n.row.domNode.setAttribute("role",o);var r=this.ariaProvider.isChecked?this.ariaProvider.isChecked(n.element):void 0;void 0!==r&&n.row.domNode.setAttribute("aria-checked",String(r))}n.row.domNode.parentElement||(t?this.rowsContainer.insertBefore(n.row.domNode,t):this.rowsContainer.appendChild(n.row.domNode)),this.updateItemInDOM(n,e);var s=this.renderers.get(n.templateId);if(!s)throw new Error("No renderer found for template id "+n.templateId);s&&s.renderElement(n.element,e,n.row.templateData,n.size);var l=this.dnd.getDragURI(n.element);if(n.dragStartDisposable.dispose(),n.row.domNode.draggable=!!l,l){var u=a.domEvent(n.row.domNode,"dragstart");n.dragStartDisposable=u(function(e){return i.onDragStart(n.element,l,e)})}this.horizontalScrolling&&(this.measureItemWidth(n),this.eventuallyUpdateScrollWidth())},
e.prototype.measureItemWidth=function(e){if(e.row&&e.row.domNode){e.row.domNode.style.width="fit-content",e.width=r.getContentWidth(e.row.domNode);var t=window.getComputedStyle(e.row.domNode);t.paddingLeft&&(e.width+=parseFloat(t.paddingLeft)),t.paddingRight&&(e.width+=parseFloat(t.paddingRight)),e.row.domNode.style.width=""}},e.prototype.updateItemInDOM=function(e,t){e.row.domNode.style.top=this.elementTop(t)+"px",e.row.domNode.style.height=e.size+"px",this.setRowLineHeight&&(e.row.domNode.style.lineHeight=e.size+"px"),e.row.domNode.setAttribute("data-index",""+t),e.row.domNode.setAttribute("data-last-element",t===this.length-1?"true":"false"),e.row.domNode.setAttribute("aria-setsize",String(this.ariaProvider.getSetSize(e.element,t,this.length))),e.row.domNode.setAttribute("aria-posinset",String(this.ariaProvider.getPosInSet(e.element,t))),e.row.domNode.setAttribute("id",this.getElementDomId(t)),r.toggleClass(e.row.domNode,"drop-target",e.dropTarget)},e.prototype.removeItemFromDOM=function(e){
var t=this.items[e];t.dragStartDisposable.dispose();var i=this.renderers.get(t.templateId);i&&i.disposeElement&&i.disposeElement(t.element,e,t.row.templateData,t.size),this.cache.release(t.row),t.row=null,this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()},e.prototype.getScrollTop=function(){return this.scrollableElement.getScrollPosition().scrollTop},e.prototype.setScrollTop=function(e){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:e})},Object.defineProperty(e.prototype,"scrollTop",{get:function(){return this.getScrollTop()},set:function(e){this.setScrollTop(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"scrollHeight",{get:function(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"onMouseClick",{get:function(){var e=this;return s.Event.map(a.domEvent(this.domNode,"click"),function(t){return e.toMouseEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDblClick",{get:function(){var e=this;return s.Event.map(a.domEvent(this.domNode,"dblclick"),function(t){return e.toMouseEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseMiddleClick",{get:function(){var e=this;return s.Event.filter(s.Event.map(a.domEvent(this.domNode,"auxclick"),function(t){return e.toMouseEvent(t)}),function(e){return 1===e.browserEvent.button})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDown",{get:function(){var e=this;return s.Event.map(a.domEvent(this.domNode,"mousedown"),function(t){return e.toMouseEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onContextMenu",{get:function(){var e=this
;return s.Event.map(a.domEvent(this.domNode,"contextmenu"),function(t){return e.toMouseEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onTouchStart",{get:function(){var e=this;return s.Event.map(a.domEvent(this.domNode,"touchstart"),function(t){return e.toTouchEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onTap",{get:function(){var e=this;return s.Event.map(a.domEvent(this.rowsContainer,o.EventType.Tap),function(t){return e.toGestureEvent(t)})},enumerable:!0,configurable:!0}),e.prototype.toMouseEvent=function(e){var t=this.getItemIndexFromEventTarget(e.target||null),i=void 0===t?void 0:this.items[t];return{browserEvent:e,index:t,element:i&&i.element}},e.prototype.toTouchEvent=function(e){var t=this.getItemIndexFromEventTarget(e.target||null),i=void 0===t?void 0:this.items[t];return{browserEvent:e,index:t,element:i&&i.element}},e.prototype.toGestureEvent=function(e){
var t=this.getItemIndexFromEventTarget(e.initialTarget||null),i=void 0===t?void 0:this.items[t];return{browserEvent:e,index:t,element:i&&i.element}},e.prototype.toDragEvent=function(e){var t=this.getItemIndexFromEventTarget(e.target||null),i=void 0===t?void 0:this.items[t];return{browserEvent:e,index:t,element:i&&i.element}},e.prototype.onScroll=function(e){try{this.render(e.scrollTop,e.height,e.scrollLeft,e.scrollWidth),this.supportDynamicHeights&&this._rerender(e.scrollTop,e.height)}catch(t){throw console.error("Got bad scroll event:",e),t}},e.prototype.onTouchChange=function(e){e.preventDefault(),e.stopPropagation(),this.scrollTop-=e.translationY},e.prototype.onDragStart=function(e,t,i){if(i.dataTransfer){var n=this.dnd.getDragElements(e);if(i.dataTransfer.effectAllowed="copyMove",i.dataTransfer.setData(v.DataTransfers.RESOURCES,JSON.stringify([t])),i.dataTransfer.setDragImage){var o=void 0;this.dnd.getDragLabel&&(o=this.dnd.getDragLabel(n)),void 0===o&&(o=String(n.length));var s=r.$(".monaco-drag-image")
;s.textContent=o,document.body.appendChild(s),i.dataTransfer.setDragImage(s,-10,-10),setTimeout(function(){return document.body.removeChild(s)},0)}this.currentDragData=new b(n),v.StaticDND.CurrentDragAndDropData=new C(n),this.dnd.onDragStart&&this.dnd.onDragStart(this.currentDragData,i)}},e.prototype.onDragOver=function(e){var t=this;if(e.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),v.StaticDND.CurrentDragAndDropData&&"vscode-ui"===v.StaticDND.CurrentDragAndDropData.getData())return!1;if(this.setupDragAndDropScrollTopAnimation(e.browserEvent),!e.browserEvent.dataTransfer)return!1;if(!this.currentDragData)if(v.StaticDND.CurrentDragAndDropData)this.currentDragData=v.StaticDND.CurrentDragAndDropData;else{if(!e.browserEvent.dataTransfer.types)return!1;this.currentDragData=new S}var i=this.dnd.onDragOver(this.currentDragData,e.element,e.index,e.browserEvent);if(this.canDrop="boolean"==typeof i?i:i.accept,!this.canDrop)return this.currentDragFeedback=void 0,
this.currentDragFeedbackDisposable.dispose(),!1;e.browserEvent.dataTransfer.dropEffect="boolean"!=typeof i&&0===i.effect?"copy":"move";var o;if(o="boolean"!=typeof i&&i.feedback?i.feedback:void 0===e.index?[-1]:[e.index],o=m.distinct(o).filter(function(e){return e>=-1&&e<t.length}).sort(),0===(o=-1===o[0]?[-1]:o).length)throw new Error("Invalid empty feedback list");if(function(e,t){return Array.isArray(e)&&Array.isArray(t)?m.equals(e,t):e===t}(this.currentDragFeedback,o))return!0;if(this.currentDragFeedback=o,this.currentDragFeedbackDisposable.dispose(),-1===o[0])r.addClass(this.domNode,"drop-target"),this.currentDragFeedbackDisposable=n.toDisposable(function(){return r.removeClass(t.domNode,"drop-target")});else{for(var s=0,a=o;s<a.length;s++){var l=a[s],u=this.items[l];u.dropTarget=!0,u.row&&u.row.domNode&&r.addClass(u.row.domNode,"drop-target")}this.currentDragFeedbackDisposable=n.toDisposable(function(){for(var e=0,i=o;e<i.length;e++){var n=i[e],s=t.items[n];s.dropTarget=!1,
s.row&&s.row.domNode&&r.removeClass(s.row.domNode,"drop-target")}})}return!0},e.prototype.onDragLeave=function(){var e=this;this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=_.disposableTimeout(function(){return e.clearDragOverFeedback()},100)},e.prototype.onDrop=function(e){if(this.canDrop){var t=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.StaticDND.CurrentDragAndDropData=void 0,t&&e.browserEvent.dataTransfer&&(e.browserEvent.preventDefault(),t.update(e.browserEvent.dataTransfer),this.dnd.drop(t,e.element,e.index,e.browserEvent))}},e.prototype.onDragEnd=function(){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,v.StaticDND.CurrentDragAndDropData=void 0},e.prototype.clearDragOverFeedback=function(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=n.Disposable.None},
e.prototype.setupDragAndDropScrollTopAnimation=function(e){var t=this;if(!this.dragOverAnimationDisposable){var i=r.getTopLeftOffset(this.domNode).top;this.dragOverAnimationDisposable=r.animate(this.animateDragAndDropScrollTop.bind(this,i))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=_.disposableTimeout(function(){t.dragOverAnimationDisposable&&(t.dragOverAnimationDisposable.dispose(),t.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=e.pageY},e.prototype.animateDragAndDropScrollTop=function(e){if(void 0!==this.dragOverMouseY){var t=this.dragOverMouseY-e,i=this.renderHeight-35;t<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(t-35))):t>i&&(this.scrollTop+=Math.min(14,Math.floor(.3*(t-i))))}},e.prototype.teardownDragAndDropScrollTopAnimation=function(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},
e.prototype.getItemIndexFromEventTarget=function(e){for(var t=e;t instanceof HTMLElement&&t!==this.rowsContainer;){var i=t.getAttribute("data-index");if(i){var n=Number(i);if(!isNaN(n))return n}t=t.parentElement}},e.prototype.getRenderRange=function(e,t){return{start:this.rangeMap.indexAt(e),end:this.rangeMap.indexAfter(e+t-1)}},e.prototype._rerender=function(e,t){var i,n,o=this.getRenderRange(e,t);e===this.elementTop(o.start)?(i=o.start,n=0):o.end-o.start>1&&(i=o.start+1,n=this.elementTop(i)-e);for(var r=0;;){for(var s=this.getRenderRange(e,t),a=!1,l=s.start;l<s.end;l++){var u=this.probeDynamicHeight(l);0!==u&&this.rangeMap.splice(l,1,[this.items[l]]),r+=u,a=a||0!==u}if(!a){0!==r&&this.eventuallyUpdateScrollDimensions();for(var d=0,c=g.Range.relativeComplement(o,s);d<c.length;d++)for(l=(f=c[d]).start;l<f.end;l++)this.items[l].row&&this.removeItemFromDOM(l);for(var h=0,p=g.Range.relativeComplement(s,o);h<p.length;h++)for(var f=p[h],l=f.start;l<f.end;l++){
var m=l+1,v=m<this.items.length?this.items[m].row:null,_=v?v.domNode:null;this.insertItemInDOM(l,_)}for(l=s.start;l<s.end;l++)this.items[l].row&&this.updateItemInDOM(this.items[l],l);return"number"==typeof i&&(this.scrollTop=this.elementTop(i)-n),void this._onDidChangeContentHeight.fire(this.contentHeight)}}},e.prototype.probeDynamicHeight=function(e){var t=this.items[e];if(!t.hasDynamicHeight||t.lastDynamicHeightWidth===this.renderWidth)return 0;var i=t.size,n=this.cache.alloc(t.templateId);n.domNode.style.height="",this.rowsContainer.appendChild(n.domNode);var o=this.renderers.get(t.templateId);return o&&(o.renderElement(t.element,e,n.templateData,void 0),o.disposeElement&&o.disposeElement(t.element,e,n.templateData,void 0)),t.size=n.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight&&this.virtualDelegate.setDynamicHeight(t.element,t.size),t.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(n.domNode),this.cache.release(n),t.size-i},e.prototype.getNextToLastElement=function(e){
var t=e[e.length-1];if(!t)return null;var i=this.items[t.end];return i&&i.row?i.row.domNode:null},e.prototype.getElementDomId=function(e){return this.domId+"_"+e},e.prototype.dispose=function(){if(this.items){for(var e=0,t=this.items;e<t.length;e++){var i=t[e];if(i.row){var o=this.renderers.get(i.row.templateId);o&&o.disposeTemplate(i.row.templateData)}}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.disposables=n.dispose(this.disposables)},e.InstanceCount=0,d([f.memoize],e.prototype,"onMouseClick",null),d([f.memoize],e.prototype,"onMouseDblClick",null),d([f.memoize],e.prototype,"onMouseMiddleClick",null),d([f.memoize],e.prototype,"onMouseDown",null),d([f.memoize],e.prototype,"onContextMenu",null),d([f.memoize],e.prototype,"onTouchStart",null),d([f.memoize],e.prototype,"onTap",null),e}();t.ListView=w}),define(t[387],i([1,0,18,28,2,8,125,79,5,44,57,449,62,51,447,451,4,154,158,15]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var C=function(){function e(e){this.context=e,this._cache={"":[]}}return e.prototype.alloc=function(e){var t=this.cache(e).pop();if(!t){var i=document.createElement("div");i.className="content";var n=document.createElement("div");n.appendChild(i);var o=null;try{o=this.context.renderer.renderTemplate(this.context.tree,e,i)}catch(e){console.error("Tree usage error: exception while rendering template"),console.error(e)}t={element:n,templateId:e,templateData:o}}return t},e.prototype.release=function(e,t){!function(e){try{e.parentElement.removeChild(e)}catch(e){}}(t.element),this.cache(e).push(t)},e.prototype.cache=function(e){return this._cache[e]||(this._cache[e]=[])},e.prototype.garbageCollect=function(){var e=this;this._cache&&Object.keys(this._cache).forEach(function(t){e._cache[t].forEach(function(i){e.context.renderer.disposeTemplate(e.context.tree,t,i.templateData),i.element=null,i.templateData=null}),delete e._cache[t]})},e.prototype.dispose=function(){
this.garbageCollect(),this._cache=null},e}();t.RowCache=C;var S=function(){function e(e,t){var i=this;this.width=0,this.needsRender=!1,this.uri=null,this.unbindDragStart=o.Disposable.None,this._draggable=!1,this.context=e,this.model=t,this.id=this.model.id,this.row=null,this.top=0,this.height=t.getHeight(),this._styles={},t.getAllTraits().forEach(function(e){return i._styles[e]=!0}),t.isExpanded()&&this.addClass("expanded")}return Object.defineProperty(e.prototype,"expanded",{set:function(e){e?this.addClass("expanded"):this.removeClass("expanded")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"loading",{set:function(e){e?this.addClass("loading"):this.removeClass("loading")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"draggable",{get:function(){return this._draggable},set:function(e){this._draggable=e,this.render(!0)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"dropTarget",{set:function(e){
e?this.addClass("drop-target"):this.removeClass("drop-target")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"element",{get:function(){return this.row&&this.row.element},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"templateId",{get:function(){return this._templateId||(this._templateId=this.context.renderer.getTemplateId&&this.context.renderer.getTemplateId(this.context.tree,this.model.getElement()))},enumerable:!0,configurable:!0}),e.prototype.addClass=function(e){this._styles[e]=!0,this.render(!0)},e.prototype.removeClass=function(e){delete this._styles[e],this.render(!0)},e.prototype.render=function(e){var t=this;if(void 0===e&&(e=!1),this.model&&this.element){var i=["monaco-tree-row"];i.push.apply(i,Object.keys(this._styles)),this.model.hasChildren()&&i.push("has-children"),this.element.className=i.join(" "),this.element.draggable=this.draggable,this.element.style.height=this.height+"px",this.element.setAttribute("role","treeitem")
;var n=this.context.accessibilityProvider,o=n.getAriaLabel(this.context.tree,this.model.getElement());if(o&&this.element.setAttribute("aria-label",o),n.getPosInSet&&n.getSetSize&&(this.element.setAttribute("aria-setsize",n.getSetSize()),this.element.setAttribute("aria-posinset",n.getPosInSet(this.context.tree,this.model.getElement()))),this.model.hasTrait("focused")){var r=u.safeBtoa(this.model.id);this.element.setAttribute("aria-selected","true"),this.element.setAttribute("id",r)}else this.element.setAttribute("aria-selected","false"),this.element.removeAttribute("id");this.model.hasChildren()?this.element.setAttribute("aria-expanded",String(!!this._styles.expanded)):this.element.removeAttribute("aria-expanded"),this.element.setAttribute("aria-level",String(this.model.getDepth())),
this.context.options.paddingOnRow?this.element.style.paddingLeft=this.context.options.twistiePixels+(this.model.getDepth()-1)*this.context.options.indentPixels+"px":(this.element.style.paddingLeft=(this.model.getDepth()-1)*this.context.options.indentPixels+"px",this.row.element.firstElementChild.style.paddingLeft=this.context.options.twistiePixels+"px");var a=this.context.dnd.getDragURI(this.context.tree,this.model.getElement());if(a!==this.uri&&(this.unbindDragStart&&this.unbindDragStart.dispose(),a?(this.uri=a,this.draggable=!0,this.unbindDragStart=s.addDisposableListener(this.element,"dragstart",function(e){t.onDragStart(e)})):this.uri=null),!e&&this.element){var l=0;if(this.context.horizontalScrolling){var d=window.getComputedStyle(this.element);l=parseFloat(d.paddingLeft)}this.context.horizontalScrolling&&(this.element.style.width="fit-content");try{this.context.renderer.renderElement(this.context.tree,this.model.getElement(),this.templateId,this.row.templateData)}catch(e){
console.error("Tree usage error: exception while rendering element"),console.error(e)}this.context.horizontalScrolling&&(this.width=s.getContentWidth(this.element)+l,this.element.style.width="")}}},e.prototype.insertInDOM=function(e,t){if(this.row||(this.row=this.context.cache.alloc(this.templateId),this.element[E.BINDING]=this),!this.element.parentElement){if(null===t)e.appendChild(this.element);else try{e.insertBefore(this.element,t)}catch(t){console.warn("Failed to locate previous tree element"),e.appendChild(this.element)}this.render()}},e.prototype.removeFromDOM=function(){this.row&&(this.unbindDragStart.dispose(),this.uri=null,this.element[E.BINDING]=null,this.context.cache.release(this.templateId,this.row),this.row=null)},e.prototype.dispose=function(){this.row=null},e}();t.ViewItem=S;var w=function(e){function t(t,i,n){var o=e.call(this,t,i)||this;return o.row={element:n,templateData:null,templateId:null},o}return r(t,e),t.prototype.render=function(){if(this.model&&this.element){
var e=["monaco-tree-wrapper"];e.push.apply(e,Object.keys(this._styles)),this.model.hasChildren()&&e.push("has-children"),this.element.className=e.join(" ")}},t.prototype.insertInDOM=function(e,t){},t.prototype.removeFromDOM=function(){},t}(S),E=function(e){function t(i,r){var a=e.call(this)||this;a.model=null,a.lastPointerType="",a.lastClickTimeStamp=0,a.contentWidthUpdateDelayer=new b.Delayer(50),a.isRefreshing=!1,a.refreshingPreviousChildrenIds={},a.currentDragAndDropData=null,a.currentDropTarget=null,a.currentDropTargets=null,a.currentDropDisposable=o.Disposable.None,a.dragAndDropScrollInterval=null,a.dragAndDropScrollTimeout=null,a.dragAndDropMouseY=null,a.highlightedItemWasDraggable=!1,a.onHiddenScrollTop=null,a._onDOMFocus=new v.Emitter,a.onDOMFocus=a._onDOMFocus.event,a._onDOMBlur=new v.Emitter,a._onDidScroll=new v.Emitter,t.counter++,a.instance=t.counter;var u=void 0===i.options.horizontalScrollMode?2:i.options.horizontalScrollMode;a.horizontalScrolling=2!==u,a.context={dataSource:i.dataSource,
renderer:i.renderer,controller:i.controller,dnd:i.dnd,filter:i.filter,sorter:i.sorter,tree:i.tree,accessibilityProvider:i.accessibilityProvider,options:i.options,cache:new C(i),horizontalScrolling:a.horizontalScrolling},a.modelListeners=[],a.viewListeners=[],a.items={},a.domNode=document.createElement("div"),a.domNode.className="monaco-tree no-focused-item monaco-tree-instance-"+a.instance,a.domNode.tabIndex=i.options.preventRootFocus?-1:0,a.styleElement=s.createStyleSheet(a.domNode),a.treeStyler=i.styler||new y.DefaultTreestyler(a.styleElement,"monaco-tree-instance-"+a.instance),a.domNode.setAttribute("role","tree"),a.context.options.ariaLabel&&a.domNode.setAttribute("aria-label",a.context.options.ariaLabel),a.context.options.alwaysFocused&&s.addClass(a.domNode,"focused"),a.context.options.paddingOnRow||s.addClass(a.domNode,"no-row-padding"),a.wrapper=document.createElement("div"),a.wrapper.className="monaco-tree-wrapper",a.scrollableElement=new f.ScrollableElement(a.wrapper,{alwaysConsumeMouseWheel:!0,
horizontal:u,vertical:void 0!==i.options.verticalScrollMode?i.options.verticalScrollMode:1,useShadows:i.options.useShadows}),a.scrollableElement.onScroll(function(e){a.render(e.scrollTop,e.height,e.scrollLeft,e.width,e.scrollWidth),a._onDidScroll.fire()}),n.isIE?(a.wrapper.style.msTouchAction="none",a.wrapper.style.msContentZooming="none"):l.Gesture.addTarget(a.wrapper),a.rowsContainer=document.createElement("div"),a.rowsContainer.className="monaco-tree-rows",i.options.showTwistie&&(a.rowsContainer.className+=" show-twisties");var d=s.trackFocus(a.domNode);return a.viewListeners.push(d.onDidFocus(function(){return a.onFocus()})),a.viewListeners.push(d.onDidBlur(function(){return a.onBlur()})),a.viewListeners.push(d),a.viewListeners.push(s.addDisposableListener(a.domNode,"keydown",function(e){return a.onKeyDown(e)})),a.viewListeners.push(s.addDisposableListener(a.domNode,"keyup",function(e){return a.onKeyUp(e)})),a.viewListeners.push(s.addDisposableListener(a.domNode,"mousedown",function(e){
return a.onMouseDown(e)})),a.viewListeners.push(s.addDisposableListener(a.domNode,"mouseup",function(e){return a.onMouseUp(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,"auxclick",function(e){e&&1===e.button&&a.onMouseMiddleClick(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,"click",function(e){return a.onClick(e)})),a.viewListeners.push(s.addDisposableListener(a.domNode,"contextmenu",function(e){return a.onContextMenu(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,l.EventType.Tap,function(e){return a.onTap(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,l.EventType.Change,function(e){return a.onTouchChange(e)})),n.isIE&&(a.viewListeners.push(s.addDisposableListener(a.wrapper,"MSPointerDown",function(e){return a.onMsPointerDown(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,"MSGestureTap",function(e){return a.onMsGestureTap(e)})),a.viewListeners.push(s.addDisposableThrottledListener(a.wrapper,"MSGestureChange",function(e){
return a.onThrottledMsGestureChange(e)},function(e,t){t.stopPropagation(),t.preventDefault();var i={translationY:t.translationY,translationX:t.translationX};return e&&(i.translationY+=e.translationY,i.translationX+=e.translationX),i}))),a.viewListeners.push(s.addDisposableListener(window,"dragover",function(e){return a.onDragOver(e)})),a.viewListeners.push(s.addDisposableListener(a.wrapper,"drop",function(e){return a.onDrop(e)})),a.viewListeners.push(s.addDisposableListener(window,"dragend",function(e){return a.onDragEnd(e)})),a.viewListeners.push(s.addDisposableListener(window,"dragleave",function(e){return a.onDragOver(e)})),a.wrapper.appendChild(a.rowsContainer),a.domNode.appendChild(a.scrollableElement.getDomNode()),r.appendChild(a.domNode),a.lastRenderTop=0,a.lastRenderHeight=0,a.didJustPressContextMenuKey=!1,a.currentDropTarget=null,a.currentDropTargets=[],a.shouldInvalidateDropReaction=!1,a.dragAndDropScrollInterval=null,a.dragAndDropScrollTimeout=null,a.onRowsChanged(),a.layout(),a.setupMSGesture(),
a.applyStyles(i.options),a}return r(t,e),t.prototype.applyStyles=function(e){this.treeStyler.style(e)},t.prototype.createViewItem=function(e){return new S(this.context,e)},t.prototype.getHTMLElement=function(){return this.domNode},t.prototype.focus=function(){this.domNode.focus()},t.prototype.isFocused=function(){return document.activeElement===this.domNode},t.prototype.blur=function(){this.domNode.blur()},t.prototype.setupMSGesture=function(){var e=this;window.MSGesture&&(this.msGesture=new MSGesture,setTimeout(function(){return e.msGesture.target=e.wrapper},100))},t.prototype.isTreeVisible=function(){return null===this.onHiddenScrollTop},t.prototype.layout=function(e,t){this.isTreeVisible()&&(this.viewHeight=e||s.getContentHeight(this.wrapper),this.scrollHeight=this.getContentHeight(),this.horizontalScrolling&&(this.viewWidth=t||s.getContentWidth(this.wrapper)))},t.prototype.render=function(e,t,i,n,o){var r,s,a=e,l=e+t,u=this.lastRenderTop+this.lastRenderHeight;for(r=this.indexAfter(l)-1,
s=this.indexAt(Math.max(u,a));r>=s;r--)this.insertItemInDOM(this.itemAtIndex(r));for(r=Math.min(this.indexAt(this.lastRenderTop),this.indexAfter(l))-1,s=this.indexAt(a);r>=s;r--)this.insertItemInDOM(this.itemAtIndex(r));for(r=this.indexAt(this.lastRenderTop),s=Math.min(this.indexAt(a),this.indexAfter(u));r<s;r++)this.removeItemFromDOM(this.itemAtIndex(r));for(r=Math.max(this.indexAfter(l),this.indexAt(this.lastRenderTop)),s=this.indexAfter(u);r<s;r++)this.removeItemFromDOM(this.itemAtIndex(r));var d=this.itemAtIndex(this.indexAt(a));d&&(this.rowsContainer.style.top=d.top-a+"px"),this.horizontalScrolling&&(this.rowsContainer.style.left=-i+"px",this.rowsContainer.style.width=Math.max(o,n)+"px"),this.lastRenderTop=a,this.lastRenderHeight=l-a},t.prototype.setModel=function(e){this.releaseModel(),this.model=e,this.model.onRefresh(this.onRefreshing,this,this.modelListeners),this.model.onDidRefresh(this.onRefreshed,this,this.modelListeners),this.model.onSetInput(this.onClearingInput,this,this.modelListeners),
this.model.onDidSetInput(this.onSetInput,this,this.modelListeners),this.model.onDidFocus(this.onModelFocusChange,this,this.modelListeners),this.model.onRefreshItemChildren(this.onItemChildrenRefreshing,this,this.modelListeners),this.model.onDidRefreshItemChildren(this.onItemChildrenRefreshed,this,this.modelListeners),this.model.onDidRefreshItem(this.onItemRefresh,this,this.modelListeners),this.model.onExpandItem(this.onItemExpanding,this,this.modelListeners),this.model.onDidExpandItem(this.onItemExpanded,this,this.modelListeners),this.model.onCollapseItem(this.onItemCollapsing,this,this.modelListeners),this.model.onDidRevealItem(this.onItemReveal,this,this.modelListeners),this.model.onDidAddTraitItem(this.onItemAddTrait,this,this.modelListeners),this.model.onDidRemoveTraitItem(this.onItemRemoveTrait,this,this.modelListeners)},t.prototype.onRefreshing=function(){this.isRefreshing=!0},t.prototype.onRefreshed=function(){this.isRefreshing=!1,this.onRowsChanged()},t.prototype.onRowsChanged=function(e){
void 0===e&&(e=this.scrollTop),this.isRefreshing||(this.scrollTop=e,this.updateScrollWidth())},t.prototype.updateScrollWidth=function(){var e=this;this.horizontalScrolling&&this.contentWidthUpdateDelayer.trigger(function(){for(var t=0,i=0,n=Object.keys(e.items);i<n.length;i++){var o=n[i];t=Math.max(t,e.items[o].width)}e.scrollWidth=t+10})},t.prototype.focusNextPage=function(e){var t=this,i=this.indexAt(this.scrollTop+this.viewHeight);i=0===i?0:i-1;var n=this.itemAtIndex(i).model.getElement();if(this.model.getFocus()!==n)this.model.setFocus(n,e);else{var o=this.scrollTop;this.scrollTop+=this.viewHeight,this.scrollTop!==o&&setTimeout(function(){t.focusNextPage(e)},0)}},t.prototype.focusPreviousPage=function(e){var t,i=this;t=0===this.scrollTop?this.indexAt(this.scrollTop):this.indexAfter(this.scrollTop-1);var n=this.itemAtIndex(t).model.getElement();if(this.model.getFocus()!==n)this.model.setFocus(n,e);else{var o=this.scrollTop;this.scrollTop-=this.viewHeight,this.scrollTop!==o&&setTimeout(function(){
i.focusPreviousPage(e)},0)}},Object.defineProperty(t.prototype,"viewHeight",{get:function(){return this.scrollableElement.getScrollDimensions().height},set:function(e){this.scrollableElement.setScrollDimensions({height:e})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollHeight",{set:function(e){e+=this.horizontalScrolling?10:0,this.scrollableElement.setScrollDimensions({scrollHeight:e})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"viewWidth",{get:function(){return this.scrollableElement.getScrollDimensions().width},set:function(e){this.scrollableElement.setScrollDimensions({width:e})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollWidth",{set:function(e){this.scrollableElement.setScrollDimensions({scrollWidth:e})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollTop",{get:function(){return this.scrollableElement.getScrollPosition().scrollTop},set:function(e){
var t=this.getContentHeight()+(this.horizontalScrolling?10:0);this.scrollableElement.setScrollDimensions({scrollHeight:t}),this.scrollableElement.setScrollPosition({scrollTop:e})},enumerable:!0,configurable:!0}),t.prototype.onClearingInput=function(e){var t=e.item;t&&(this.onRemoveItems(new p.MappedIterator(t.getNavigator(),function(e){return e&&e.id})),this.onRowsChanged())},t.prototype.onSetInput=function(e){this.context.cache.garbageCollect(),this.inputItem=new w(this.context,e.item,this.wrapper)},t.prototype.onItemChildrenRefreshing=function(e){var i=e.item,n=this.items[i.id];if(n&&this.context.options.showLoading&&(n.loadingTimer=setTimeout(function(){n.loadingTimer=0,n.loading=!0},t.LOADING_DECORATION_DELAY)),!e.isNested){for(var o=[],r=i.getNavigator(),s=void 0;s=r.next();)o.push(s.id);this.refreshingPreviousChildrenIds[i.id]=o}},t.prototype.onItemChildrenRefreshed=function(e){var t=this,i=e.item,n=this.items[i.id];if(n&&(n.loadingTimer&&(clearTimeout(n.loadingTimer),n.loadingTimer=0),n.loading=!1),
!e.isNested){for(var o=this.refreshingPreviousChildrenIds[i.id],r=[],s=i.getNavigator(),l=void 0;l=s.next();)r.push(l);var u=Math.abs(o.length-r.length)>1e3,d=[],c=!1;if(!u){c=(d=new a.LcsDiff({getLength:function(){return o.length},getElementAtIndex:function(e){return o[e]}},{getLength:function(){return r.length},getElementAtIndex:function(e){return r[e].id}},null).ComputeDiff(!1)).some(function(e){if(e.modifiedLength>0)for(var i=e.modifiedStart,n=e.modifiedStart+e.modifiedLength;i<n;i++)if(t.items.hasOwnProperty(r[i].id))return!0;return!1})}if(!u&&!c&&d.length<50)for(var h=0,f=d;h<f.length;h++){var g=f[h];if(g.originalLength>0&&this.onRemoveItems(new p.ArrayIterator(o,g.originalStart,g.originalStart+g.originalLength)),g.modifiedLength>0){var m=r[g.modifiedStart-1]||i;m=m.getDepth()>0?m:null,this.onInsertItems(new p.ArrayIterator(r,g.modifiedStart,g.modifiedStart+g.modifiedLength),m?m.id:null)}}else(u||d.length)&&(this.onRemoveItems(new p.ArrayIterator(o)),
this.onInsertItems(new p.ArrayIterator(r),i.getDepth()>0?i.id:null));(u||d.length)&&this.onRowsChanged()}},t.prototype.onItemRefresh=function(e){this.onItemsRefresh([e])},t.prototype.onItemsRefresh=function(e){var t=this;this.onRefreshItemSet(e.filter(function(e){return t.items.hasOwnProperty(e.id)})),this.onRowsChanged()},t.prototype.onItemExpanding=function(e){var t=this.items[e.item.id];t&&(t.expanded=!0)},t.prototype.onItemExpanded=function(e){var t=e.item,i=this.items[t.id];if(i){i.expanded=!0;var n=this.onInsertItems(t.getNavigator(),t.id)||0,o=this.scrollTop;i.top+i.height<=this.scrollTop&&(o+=n),this.onRowsChanged(o)}},t.prototype.onItemCollapsing=function(e){var t=e.item,i=this.items[t.id];i&&(i.expanded=!1,this.onRemoveItems(new p.MappedIterator(t.getNavigator(),function(e){return e&&e.id})),this.onRowsChanged())},t.prototype.onItemReveal=function(e){var t=e.item,i=e.relativeTop,n=this.items[t.id];if(n)if(null!==i){i=(i=i<0?0:i)>1?1:i;var o=n.height-this.viewHeight;this.scrollTop=o*i+n.top}else{
var r=n.top+n.height,s=this.scrollTop+this.viewHeight;n.top<this.scrollTop?this.scrollTop=n.top:r>=s&&(this.scrollTop=r-this.viewHeight)}},t.prototype.onItemAddTrait=function(e){var t=e.item,i=e.trait,n=this.items[t.id];n&&n.addClass(i),"highlighted"===i&&(s.addClass(this.domNode,i),n&&(this.highlightedItemWasDraggable=!!n.draggable,n.draggable&&(n.draggable=!1)))},t.prototype.onItemRemoveTrait=function(e){var t=e.item,i=e.trait,n=this.items[t.id];n&&n.removeClass(i),"highlighted"===i&&(s.removeClass(this.domNode,i),this.highlightedItemWasDraggable&&(n.draggable=!0),this.highlightedItemWasDraggable=!1)},t.prototype.onModelFocusChange=function(){var e=this.model&&this.model.getFocus();s.toggleClass(this.domNode,"no-focused-item",!e),e?this.domNode.setAttribute("aria-activedescendant",u.safeBtoa(this.context.dataSource.getId(this.context.tree,e))):this.domNode.removeAttribute("aria-activedescendant")},t.prototype.onInsertItem=function(e){var t=this;e.onDragStart=function(i){t.onDragStart(e,i)},e.needsRender=!0,
this.refreshViewItem(e),this.items[e.id]=e},t.prototype.onRefreshItem=function(e,t){void 0===t&&(t=!1),e.needsRender=e.needsRender||t,this.refreshViewItem(e)},t.prototype.onRemoveItem=function(e){this.removeItemFromDOM(e),e.dispose(),delete this.items[e.id]},t.prototype.refreshViewItem=function(e){e.render(),this.shouldBeRendered(e)?this.insertItemInDOM(e):this.removeItemFromDOM(e)},t.prototype.onClick=function(e){if(!this.lastPointerType||"mouse"===this.lastPointerType){var t=new d.StandardMouseEvent(e),i=this.getItemAround(t.target);i&&(n.isIE&&Date.now()-this.lastClickTimeStamp<300&&(t.detail=2),this.lastClickTimeStamp=Date.now(),this.context.controller.onClick(this.context.tree,i.model.getElement(),t))}},t.prototype.onMouseMiddleClick=function(e){if(this.context.controller.onMouseMiddleClick){var t=new d.StandardMouseEvent(e),i=this.getItemAround(t.target);i&&this.context.controller.onMouseMiddleClick(this.context.tree,i.model.getElement(),t)}},t.prototype.onMouseDown=function(e){
if(this.didJustPressContextMenuKey=!1,this.context.controller.onMouseDown&&(!this.lastPointerType||"mouse"===this.lastPointerType)){var t=new d.StandardMouseEvent(e);if(!(t.ctrlKey&&i.isNative&&i.isMacintosh)){var n=this.getItemAround(t.target);n&&this.context.controller.onMouseDown(this.context.tree,n.model.getElement(),t)}}},t.prototype.onMouseUp=function(e){if(this.context.controller.onMouseUp&&(!this.lastPointerType||"mouse"===this.lastPointerType)){var t=new d.StandardMouseEvent(e);if(!(t.ctrlKey&&i.isNative&&i.isMacintosh)){var n=this.getItemAround(t.target);n&&this.context.controller.onMouseUp(this.context.tree,n.model.getElement(),t)}}},t.prototype.onTap=function(e){var t=this.getItemAround(e.initialTarget);t&&this.context.controller.onTap(this.context.tree,t.model.getElement(),e)},t.prototype.onTouchChange=function(e){e.preventDefault(),e.stopPropagation(),this.scrollTop-=e.translationY},t.prototype.onContextMenu=function(e){var t,i;if(e instanceof KeyboardEvent||this.didJustPressContextMenuKey){
this.didJustPressContextMenuKey=!1;var n=new c.StandardKeyboardEvent(e),o=void 0;if(i=this.model.getFocus()){var r=this.context.dataSource.getId(this.context.tree,i),a=this.items[r];o=s.getDomNodePagePosition(a.element)}else i=this.model.getInput(),o=s.getDomNodePagePosition(this.inputItem.element);t=new m.KeyboardContextMenuEvent(o.left+o.width,o.top,n)}else{var l=new d.StandardMouseEvent(e),u=this.getItemAround(l.target);if(!u)return;i=u.model.getElement(),t=new m.MouseContextMenuEvent(l)}this.context.controller.onContextMenu(this.context.tree,i,t)},t.prototype.onKeyDown=function(e){var t=new c.StandardKeyboardEvent(e);this.didJustPressContextMenuKey=58===t.keyCode||t.shiftKey&&68===t.keyCode,t.target&&t.target.tagName&&"input"===t.target.tagName.toLowerCase()||(this.didJustPressContextMenuKey&&(t.preventDefault(),t.stopPropagation()),this.context.controller.onKeyDown(this.context.tree,t))},t.prototype.onKeyUp=function(e){this.didJustPressContextMenuKey&&this.onContextMenu(e),
this.didJustPressContextMenuKey=!1,this.context.controller.onKeyUp(this.context.tree,new c.StandardKeyboardEvent(e))},t.prototype.onDragStart=function(e,t){if(!this.model.getHighlight()){var i,n=e.model.getElement(),o=this.model.getSelection();if(i=o.indexOf(n)>-1?o:[n],t.dataTransfer.effectAllowed="copyMove",t.dataTransfer.setData(_.DataTransfers.RESOURCES,JSON.stringify([e.uri])),t.dataTransfer.setDragImage){var r=void 0;r=this.context.dnd.getDragLabel?this.context.dnd.getDragLabel(this.context.tree,i):String(i.length);var s=document.createElement("div");s.className="monaco-tree-drag-image",s.textContent=r,document.body.appendChild(s),t.dataTransfer.setDragImage(s,-10,-10),setTimeout(function(){return document.body.removeChild(s)},0)}this.currentDragAndDropData=new h.ElementsDragAndDropData(i),_.StaticDND.CurrentDragAndDropData=new h.ExternalElementsDragAndDropData(i),this.context.dnd.onDragStart(this.context.tree,this.currentDragAndDropData,new d.DragMouseEvent(t))}},
t.prototype.setupDragAndDropScrollInterval=function(){var e=this,t=s.getTopLeftOffset(this.wrapper).top;this.dragAndDropScrollInterval||(this.dragAndDropScrollInterval=window.setInterval(function(){if(null!==e.dragAndDropMouseY){var i=e.dragAndDropMouseY-t,n=0,o=e.viewHeight-35;i<35?n=Math.max(-14,.2*(i-35)):i>o&&(n=Math.min(14,.2*(i-o))),e.scrollTop+=n}},10),this.cancelDragAndDropScrollTimeout(),this.dragAndDropScrollTimeout=window.setTimeout(function(){e.cancelDragAndDropScrollInterval(),e.dragAndDropScrollTimeout=null},1e3))},t.prototype.cancelDragAndDropScrollInterval=function(){this.dragAndDropScrollInterval&&(window.clearInterval(this.dragAndDropScrollInterval),this.dragAndDropScrollInterval=null),this.cancelDragAndDropScrollTimeout()},t.prototype.cancelDragAndDropScrollTimeout=function(){this.dragAndDropScrollTimeout&&(window.clearTimeout(this.dragAndDropScrollTimeout),this.dragAndDropScrollTimeout=null)},t.prototype.onDragOver=function(e){var t=this;e.preventDefault()
;var i=new d.DragMouseEvent(e),n=this.getItemAround(i.target);if(!n||0===i.posx&&0===i.posy&&i.browserEvent.type===s.EventType.DRAG_LEAVE)return this.currentDropTarget&&(this.currentDropTargets.forEach(function(e){return e.dropTarget=!1}),this.currentDropTargets=[],this.currentDropDisposable.dispose()),this.cancelDragAndDropScrollInterval(),this.currentDropTarget=null,this.currentDropElement=null,this.dragAndDropMouseY=null,!1;if(this.setupDragAndDropScrollInterval(),this.dragAndDropMouseY=i.posy,!this.currentDragAndDropData)if(_.StaticDND.CurrentDragAndDropData)this.currentDragAndDropData=_.StaticDND.CurrentDragAndDropData;else{if(!i.dataTransfer.types)return!1;this.currentDragAndDropData=new h.DesktopDragAndDropData}this.currentDragAndDropData.update(i.browserEvent.dataTransfer);var r,a,l=n.model;do{if(r=l?l.getElement():this.model.getInput(),!(a=this.context.dnd.onDragOver(this.context.tree,this.currentDragAndDropData,r,i))||1!==a.bubble)break;l=l&&l.parent}while(l)
;if(!l)return this.currentDropElement=null,!1;var u=a&&a.accept;u?(this.currentDropElement=l.getElement(),i.preventDefault(),i.dataTransfer.dropEffect=0===a.effect?"copy":"move"):this.currentDropElement=null;var c=l.id===this.inputItem.id?this.inputItem:this.items[l.id];if((this.shouldInvalidateDropReaction||this.currentDropTarget!==c||!function(e,t){return!e&&!t||!(!e||!t)&&e.accept===t.accept&&e.bubble===t.bubble&&e.effect===t.effect}(this.currentDropElementReaction,a))&&(this.shouldInvalidateDropReaction=!1,this.currentDropTarget&&(this.currentDropTargets.forEach(function(e){return e.dropTarget=!1}),this.currentDropTargets=[],this.currentDropDisposable.dispose()),this.currentDropTarget=c,this.currentDropElementReaction=a,u)){if(this.currentDropTarget&&(this.currentDropTarget.dropTarget=!0,this.currentDropTargets.push(this.currentDropTarget)),0===a.bubble)for(var p=l.getNavigator(),f=void 0;f=p.next();)(n=this.items[f.id])&&(n.dropTarget=!0,this.currentDropTargets.push(n));if(a.autoExpand){
var g=b.timeout(500);this.currentDropDisposable=o.toDisposable(function(){return g.cancel()}),g.then(function(){return t.context.tree.expand(t.currentDropElement)}).then(function(){return t.shouldInvalidateDropReaction=!0})}}return!0},t.prototype.onDrop=function(e){if(this.currentDropElement){var t=new d.DragMouseEvent(e);t.preventDefault(),this.currentDragAndDropData.update(t.browserEvent.dataTransfer),this.context.dnd.drop(this.context.tree,this.currentDragAndDropData,this.currentDropElement,t),this.onDragEnd(e)}this.cancelDragAndDropScrollInterval()},t.prototype.onDragEnd=function(e){this.currentDropTarget&&(this.currentDropTargets.forEach(function(e){return e.dropTarget=!1}),this.currentDropTargets=[]),this.currentDropDisposable.dispose(),this.cancelDragAndDropScrollInterval(),this.currentDragAndDropData=null,_.StaticDND.CurrentDragAndDropData=void 0,this.currentDropElement=null,this.currentDropTarget=null,this.dragAndDropMouseY=null},t.prototype.onFocus=function(){
this.context.options.alwaysFocused||s.addClass(this.domNode,"focused"),this._onDOMFocus.fire()},t.prototype.onBlur=function(){this.context.options.alwaysFocused||s.removeClass(this.domNode,"focused"),this.domNode.removeAttribute("aria-activedescendant"),this._onDOMBlur.fire()},t.prototype.onMsPointerDown=function(e){if(this.msGesture){var t=e.pointerType;t!==(e.MSPOINTER_TYPE_MOUSE||"mouse")?t===(e.MSPOINTER_TYPE_TOUCH||"touch")&&(this.lastPointerType="touch",e.stopPropagation(),e.preventDefault(),this.msGesture.addPointer(e.pointerId)):this.lastPointerType="mouse"}},t.prototype.onThrottledMsGestureChange=function(e){this.scrollTop-=e.translationY},t.prototype.onMsGestureTap=function(e){e.initialTarget=document.elementFromPoint(e.clientX,e.clientY),this.onTap(e)},t.prototype.insertItemInDOM=function(e){var t=null,i=this.itemAfter(e);i&&i.element&&(t=i.element),e.insertInDOM(this.rowsContainer,t)},t.prototype.removeItemFromDOM=function(e){e&&e.removeFromDOM()},t.prototype.shouldBeRendered=function(e){
return e.top<this.lastRenderTop+this.lastRenderHeight&&e.top+e.height>this.lastRenderTop},t.prototype.getItemAround=function(e){var i=this.inputItem,n=e;do{if(n[t.BINDING]&&(i=n[t.BINDING]),n===this.wrapper||n===this.domNode)return i;if(n===this.scrollableElement.getDomNode()||n===document.body)return}while(n=n.parentElement)},t.prototype.releaseModel=function(){this.model&&(this.modelListeners=o.dispose(this.modelListeners),this.model=null)},t.prototype.dispose=function(){var t=this;this.scrollableElement.dispose(),this.releaseModel(),this.viewListeners=o.dispose(this.viewListeners),this._onDOMFocus.dispose(),this._onDOMBlur.dispose(),this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.items&&Object.keys(this.items).forEach(function(e){return t.items[e].removeFromDOM()}),this.context.cache&&this.context.cache.dispose(),e.prototype.dispose.call(this)},t.BINDING="monaco-tree-row",t.LOADING_DECORATION_DELAY=800,t.counter=0,t}(g.HeightMap);t.TreeView=E}),define(t[385],i([9]),{}),
define(t[384],i([1,0,2,4,23,8,159,19,100,25,52,385]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h,p={separatorBorder:d.Color.transparent},f=function(){function e(e,t,i,n){this.container=e,this.view=t,this.disposable=n,this._cachedVisibleSize=void 0,"number"==typeof i?(this._size=i,this._cachedVisibleSize=void 0,s.addClass(e,"visible")):(this._size=0,this._cachedVisibleSize=i.cachedVisibleSize)}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},set:function(e){this._size=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"visible",{get:function(){return void 0===this._cachedVisibleSize},enumerable:!0,configurable:!0}),e.prototype.setVisible=function(e,t){e!==this.visible&&(e?(this.size=a.clamp(this._cachedVisibleSize,this.viewMinimumSize,this.viewMaximumSize),this._cachedVisibleSize=void 0):(this._cachedVisibleSize="number"==typeof t?t:this.size,this.size=0),s.toggleClass(this.container,"visible",e),
this.view.setVisible&&this.view.setVisible(e))},Object.defineProperty(e.prototype,"minimumSize",{get:function(){return this.visible?this.view.minimumSize:0},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"viewMinimumSize",{get:function(){return this.view.minimumSize},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"maximumSize",{get:function(){return this.visible?this.view.maximumSize:0},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"viewMaximumSize",{get:function(){return this.view.maximumSize},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"priority",{get:function(){return this.view.priority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"snap",{get:function(){return!!this.view.snap},enumerable:!0,configurable:!0}),e.prototype.layout=function(e){this.view.layout(this.size,e)},e.prototype.dispose=function(){return this.disposable.dispose(),this.view},e}(),g=function(e){function t(){
return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.layout=function(t){e.prototype.layout.call(this,t),this.container.style.height=this.size+"px"},t}(f),m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.layout=function(t){e.prototype.layout.call(this,t),this.container.style.width=this.size+"px"},t}(f);!function(e){e[e.Idle=0]="Idle",e[e.Busy=1]="Busy"}(h||(h={}));!function(e){e.Distribute={type:"distribute"},e.Split=function(e){return{type:"split",index:e}},e.Invisible=function(e){return{type:"invisible",cachedVisibleSize:e}}}(t.Sizing||(t.Sizing={}));var v=function(e){function t(t,i){void 0===i&&(i={});var r=e.call(this)||this;return r.size=0,r.contentSize=0,r.proportions=void 0,r.viewItems=[],r.sashItems=[],r.state=h.Idle,r._onDidSashChange=r._register(new n.Emitter),r.onDidSashChange=r._onDidSashChange.event,r._onDidSashReset=r._register(new n.Emitter),r.orientation=o.isUndefined(i.orientation)?0:i.orientation,
r.inverseAltBehavior=!!i.inverseAltBehavior,r.proportionalLayout=!!o.isUndefined(i.proportionalLayout)||!!i.proportionalLayout,r.el=document.createElement("div"),s.addClass(r.el,"monaco-split-view2"),s.addClass(r.el,0===r.orientation?"vertical":"horizontal"),t.appendChild(r.el),r.sashContainer=s.append(r.el,s.$(".sash-container")),r.viewContainer=s.append(r.el,s.$(".split-view-container")),r.style(i.styles||p),i.descriptor&&(r.size=i.descriptor.size,i.descriptor.views.forEach(function(e,t){var i=o.isUndefined(e.visible)||e.visible?e.size:{type:"invisible",cachedVisibleSize:e.size},n=e.view;r.doAddView(n,i,t,!0)}),r.contentSize=r.viewItems.reduce(function(e,t){return e+t.size},0),r.saveProportions()),r}return r(t,e),Object.defineProperty(t.prototype,"orthogonalStartSash",{get:function(){return this._orthogonalStartSash},set:function(e){for(var t=0,i=this.sashItems;t<i.length;t++){i[t].sash.orthogonalStartSash=e}this._orthogonalStartSash=e},enumerable:!0,configurable:!0}),
Object.defineProperty(t.prototype,"orthogonalEndSash",{get:function(){return this._orthogonalEndSash},set:function(e){for(var t=0,i=this.sashItems;t<i.length;t++){i[t].sash.orthogonalEndSash=e}this._orthogonalEndSash=e},enumerable:!0,configurable:!0}),t.prototype.style=function(e){e.separatorBorder.isTransparent()?(s.removeClass(this.el,"separator-border"),this.el.style.removeProperty("--separator-border")):(s.addClass(this.el,"separator-border"),this.el.style.setProperty("--separator-border",e.separatorBorder.toString()))},t.prototype.addView=function(e,t,i){void 0===i&&(i=this.viewItems.length),this.doAddView(e,t,i,!1)},t.prototype.layout=function(e,t){var i=this,n=Math.max(this.size,this.contentSize);if(this.size=e,this.orthogonalSize=t,this.proportions)for(var o=0;o<this.viewItems.length;o++){var r=this.viewItems[o];r.size=a.clamp(Math.round(this.proportions[o]*e),r.minimumSize,r.maximumSize)}else{var s=l.range(this.viewItems.length),u=s.filter(function(e){return 1===i.viewItems[e].priority
}),d=s.filter(function(e){return 2===i.viewItems[e].priority});this.resize(this.viewItems.length-1,e-n,void 0,u,d)}this.distributeEmptySpace(),this.layoutViews()},t.prototype.saveProportions=function(){var e=this;this.proportionalLayout&&this.contentSize>0&&(this.proportions=this.viewItems.map(function(t){return t.size/e.contentSize}))},t.prototype.onSashStart=function(e){var t=this,n=e.sash,o=e.start,r=e.alt,s=l.firstIndex(this.sashItems,function(e){return e.sash===n}),a=i.combinedDisposable(c.domEvent(document.body,"keydown")(function(e){return u(t.sashDragState.current,e.altKey)}),c.domEvent(document.body,"keyup")(function(){return u(t.sashDragState.current,!1)})),u=function(e,i){var n=t.viewItems.map(function(e){return e.size}),o=Number.NEGATIVE_INFINITY,r=Number.POSITIVE_INFINITY;if(t.inverseAltBehavior&&(i=!i),i){if(s===t.sashItems.length-1){o=((C=t.viewItems[s]).minimumSize-C.size)/2,r=(C.maximumSize-C.size)/2}else{o=((C=t.viewItems[s+1]).size-C.maximumSize)/2,r=(C.size-C.minimumSize)/2}}var u,d
;if(!i){var c=l.range(s,-1),h=l.range(s+1,t.viewItems.length),p=c.reduce(function(e,i){return e+(t.viewItems[i].minimumSize-n[i])},0),f=c.reduce(function(e,i){return e+(t.viewItems[i].viewMaximumSize-n[i])},0),g=0===h.length?Number.POSITIVE_INFINITY:h.reduce(function(e,i){return e+(n[i]-t.viewItems[i].minimumSize)},0),m=0===h.length?Number.NEGATIVE_INFINITY:h.reduce(function(e,i){return e+(n[i]-t.viewItems[i].viewMaximumSize)},0),v=Math.max(p,m),_=Math.min(g,f),y=t.findFirstSnapIndex(c),b=t.findFirstSnapIndex(h);if("number"==typeof y){var C=t.viewItems[y],S=Math.floor(C.viewMinimumSize/2);u={index:y,limitDelta:C.visible?v-S:v+S,size:C.size}}if("number"==typeof b){var C=t.viewItems[b],S=Math.floor(C.viewMinimumSize/2);d={index:b,limitDelta:C.visible?_+S:_-S,size:C.size}}}t.sashDragState={start:e,current:e,index:s,sizes:n,minDelta:o,maxDelta:r,alt:i,snapBefore:u,snapAfter:d,disposable:a}};u(o,r)},t.prototype.onSashChange=function(e){
var t=e.current,i=this.sashDragState,n=i.index,o=i.start,r=i.sizes,s=i.alt,a=i.minDelta,l=i.maxDelta,u=i.snapBefore,d=i.snapAfter;this.sashDragState.current=t;var c=t-o,h=this.resize(n,c,r,void 0,void 0,a,l,u,d);if(s){var p=n===this.sashItems.length-1,f=this.viewItems.map(function(e){return e.size}),g=p?n:n+1,m=this.viewItems[g],v=m.size-m.maximumSize,_=m.size-m.minimumSize,y=p?n-1:n+1;this.resize(y,-h,f,void 0,void 0,v,_)}this.distributeEmptySpace(),this.layoutViews()},t.prototype.onSashEnd=function(e){this._onDidSashChange.fire(e),this.sashDragState.disposable.dispose(),this.saveProportions()},t.prototype.onViewChange=function(e,t){var i=this.viewItems.indexOf(e);i<0||i>=this.viewItems.length||(t="number"==typeof t?t:e.size,t=a.clamp(t,e.minimumSize,e.maximumSize),this.inverseAltBehavior&&i>0?(this.resize(i-1,Math.floor((e.size-t)/2)),this.distributeEmptySpace(),this.layoutViews()):(e.size=t,this.relayout([i],void 0)))},t.prototype.resizeView=function(e,t){var i=this
;if(this.state!==h.Idle)throw new Error("Cant modify splitview");if(this.state=h.Busy,!(e<0||e>=this.viewItems.length)){var n=l.range(this.viewItems.length).filter(function(t){return t!==e}),o=n.filter(function(e){return 1===i.viewItems[e].priority}).concat([e]),r=n.filter(function(e){return 2===i.viewItems[e].priority}),s=this.viewItems[e];t=Math.round(t),t=a.clamp(t,s.minimumSize,Math.min(s.maximumSize,this.size)),s.size=t,this.relayout(o,r),this.state=h.Idle}},t.prototype.distributeViewSizes=function(){for(var e=this,t=[],i=0,n=0,o=this.viewItems;n<o.length;n++){(d=o[n]).maximumSize-d.minimumSize>0&&(t.push(d),i+=d.size)}for(var r=Math.floor(i/t.length),s=0,u=t;s<u.length;s++){var d=u[s];d.size=a.clamp(r,d.minimumSize,d.maximumSize)}var c=l.range(this.viewItems.length),h=c.filter(function(t){return 1===e.viewItems[t].priority}),p=c.filter(function(t){return 2===e.viewItems[t].priority});this.relayout(h,p)},t.prototype.getViewSize=function(e){return e<0||e>=this.viewItems.length?-1:this.viewItems[e].size},
t.prototype.doAddView=function(e,t,o,r){var a=this;if(void 0===o&&(o=this.viewItems.length),this.state!==h.Idle)throw new Error("Cant modify splitview");this.state=h.Busy;var d=s.$(".split-view-view");o===this.viewItems.length?this.viewContainer.appendChild(d):this.viewContainer.insertBefore(d,this.viewContainer.children.item(o));var c,p=e.onDidChange(function(e){return a.onViewChange(_,e)}),f=i.toDisposable(function(){return a.viewContainer.removeChild(d)}),v=i.combinedDisposable(p,f);c="number"==typeof t?t:"split"===t.type?this.getViewSize(t.index)/2:"invisible"===t.type?{cachedVisibleSize:t.cachedVisibleSize}:e.minimumSize;var _=0===this.orientation?new g(d,e,c,v):new m(d,e,c,v);if(this.viewItems.splice(o,0,_),this.viewItems.length>1){var y=0===this.orientation?1:0,b=0===this.orientation?{getHorizontalSashTop:function(e){return a.getSashPosition(e)}}:{getVerticalSashLeft:function(e){return a.getSashPosition(e)}},C=new u.Sash(this.sashContainer,b,{orientation:y,orthogonalStartSash:this.orthogonalStartSash,
orthogonalEndSash:this.orthogonalEndSash}),S=0===this.orientation?function(e){return{sash:C,start:e.startY,current:e.currentY,alt:e.altKey}}:function(e){return{sash:C,start:e.startX,current:e.currentX,alt:e.altKey}},w=n.Event.map(C.onDidStart,S)(this.onSashStart,this),E=n.Event.map(C.onDidChange,S)(this.onSashChange,this),L=n.Event.map(C.onDidEnd,function(){return l.firstIndex(a.sashItems,function(e){return e.sash===C})})(this.onSashEnd,this),x=C.onDidReset(function(){var e=l.firstIndex(a.sashItems,function(e){return e.sash===C}),t=l.range(e,-1),i=l.range(e+1,a.viewItems.length),n=a.findFirstSnapIndex(t),o=a.findFirstSnapIndex(i);("number"!=typeof n||a.viewItems[n].visible)&&("number"!=typeof o||a.viewItems[o].visible)&&a._onDidSashReset.fire(e)}),D=i.combinedDisposable(w,E,L,x,C),I={sash:C,disposable:D};this.sashItems.splice(o-1,0,I)}d.appendChild(e.element);var N;"number"!=typeof t&&"split"===t.type&&(N=[t.index]),r||this.relayout([o],N),this.state=h.Idle,
r||"number"==typeof t||"distribute"!==t.type||this.distributeViewSizes()},t.prototype.relayout=function(e,t){var i=this.viewItems.reduce(function(e,t){return e+t.size},0);this.resize(this.viewItems.length-1,this.size-i,void 0,e,t),this.distributeEmptySpace(),this.layoutViews(),this.saveProportions()},t.prototype.resize=function(e,t,i,n,o,r,s,u,d){var c=this;if(void 0===i&&(i=this.viewItems.map(function(e){return e.size})),void 0===r&&(r=Number.NEGATIVE_INFINITY),void 0===s&&(s=Number.POSITIVE_INFINITY),e<0||e>=this.viewItems.length)return 0;var h=l.range(e,-1),p=l.range(e+1,this.viewItems.length);if(o)for(var f=0,g=o;f<g.length;f++){var m=g[f];l.pushToStart(h,m),l.pushToStart(p,m)}if(n)for(var v=0,_=n;v<_.length;v++){var y=_[v];l.pushToEnd(h,y),l.pushToEnd(p,y)}var b=h.map(function(e){return c.viewItems[e]}),C=h.map(function(e){return i[e]}),S=p.map(function(e){return c.viewItems[e]}),w=p.map(function(e){return i[e]}),E=h.reduce(function(e,t){return e+(c.viewItems[t].minimumSize-i[t])
},0),L=h.reduce(function(e,t){return e+(c.viewItems[t].maximumSize-i[t])},0),x=0===p.length?Number.POSITIVE_INFINITY:p.reduce(function(e,t){return e+(i[t]-c.viewItems[t].minimumSize)},0),D=0===p.length?Number.NEGATIVE_INFINITY:p.reduce(function(e,t){return e+(i[t]-c.viewItems[t].maximumSize)},0),I=Math.max(E,D,r),N=Math.min(x,L,s),M=!1;if(u){k=this.viewItems[u.index];M=(T=t>=u.limitDelta)!==k.visible,k.setVisible(T,u.size)}if(!M&&d){var k=this.viewItems[d.index],T=t<d.limitDelta;M=T!==k.visible,k.setVisible(T,d.size)}if(M)return this.resize(e,t,i,n,o,r,s);for(var R=0,O=t=a.clamp(t,I,N);R<b.length;R++){A=b[R];O-=W=(F=a.clamp(C[R]+O,A.minimumSize,A.maximumSize))-C[R],A.size=F}for(var R=0,P=t;R<S.length;R++){var A=S[R],F=a.clamp(w[R]-P,A.minimumSize,A.maximumSize),W=F-w[R];P+=W,A.size=F}return t},t.prototype.distributeEmptySpace=function(e){for(var t=this,i=this.viewItems.reduce(function(e,t){return e+t.size},0),n=this.size-i,o=l.range(this.viewItems.length-1,-1),r=o.filter(function(e){
return 1===t.viewItems[e].priority}),s=0,u=o.filter(function(e){return 2===t.viewItems[e].priority});s<u.length;s++){h=u[s];l.pushToStart(o,h)}for(var d=0,c=r;d<c.length;d++){var h=c[d];l.pushToEnd(o,h)}"number"==typeof e&&l.pushToEnd(o,e);for(var p=0;0!==n&&p<o.length;p++){var f=this.viewItems[o[p]],g=a.clamp(f.size+n,f.minimumSize,f.maximumSize);n-=g-f.size,f.size=g}},t.prototype.layoutViews=function(){var e=this;this.contentSize=this.viewItems.reduce(function(e,t){return e+t.size},0),this.viewItems.forEach(function(t){return t.layout(e.orthogonalSize)}),this.sashItems.forEach(function(e){return e.sash.layout()});var t=!1,i=this.viewItems.map(function(e){return t=e.size-e.minimumSize>0||t});t=!1;var n=this.viewItems.map(function(e){return t=e.maximumSize-e.size>0||t}),o=this.viewItems.slice().reverse();t=!1;var r=o.map(function(e){return t=e.size-e.minimumSize>0||t}).reverse();t=!1;var s=o.map(function(e){return t=e.maximumSize-e.size>0||t}).reverse();this.sashItems.forEach(function(t,o){
var a=t.sash,u=!(i[o]&&s[o+1]),d=!(n[o]&&r[o+1]);if(u&&d){var c=l.range(o,-1),h=l.range(o+1,e.viewItems.length),p=e.findFirstSnapIndex(c),f=e.findFirstSnapIndex(h),g="number"==typeof p&&!e.viewItems[p].visible,m="number"==typeof f&&!e.viewItems[f].visible;g&&r[o]?a.state=1:m&&i[o]?a.state=2:a.state=0}else a.state=u&&!d?1:!u&&d?2:3})},t.prototype.getSashPosition=function(e){for(var t=0,i=0;i<this.sashItems.length;i++)if(t+=this.viewItems[i].size,this.sashItems[i].sash===e)return t;return 0},t.prototype.findFirstSnapIndex=function(e){for(var t=0,i=e;t<i.length;t++){r=i[t];if((s=this.viewItems[r]).visible&&s.snap)return r}for(var n=0,o=e;n<o.length;n++){var r=o[n],s=this.viewItems[r];if(s.visible&&s.maximumSize-s.minimumSize>0)return;if(!s.visible&&s.snap)return r}},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.viewItems.forEach(function(e){return e.dispose()}),this.viewItems=[],this.sashItems.forEach(function(e){return e.disposable.dispose()}),this.sashItems=[]},t}(i.Disposable)
;t.SplitView=v}),define(t[382],i([9]),{}),define(t[381],i([9]),{}),define(t[379],i([9]),{}),define(t[378],i([1,0,158,448,387,4,25,29,379]),function(e,t,i,n,o,r,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(){return function(e,t,n){if(void 0===n&&(n={}),this.tree=e,this.configuration=t,this.options=n,!t.dataSource)throw new Error("You must provide a Data Source to the tree.");this.dataSource=t.dataSource,this.renderer=t.renderer,this.controller=t.controller||new i.DefaultController({clickBehavior:1,keyboardSupport:"boolean"!=typeof n.keyboardSupport||n.keyboardSupport}),this.dnd=t.dnd||new i.DefaultDragAndDrop,this.filter=t.filter||new i.DefaultFilter,this.sorter=t.sorter,this.accessibilityProvider=t.accessibilityProvider||new i.DefaultAccessibilityProvider,this.styler=t.styler}}();t.TreeContext=l;var u={listFocusBackground:s.Color.fromHex("#073655"),listActiveSelectionBackground:s.Color.fromHex("#0E639C"),listActiveSelectionForeground:s.Color.fromHex("#FFFFFF"),
listFocusAndSelectionBackground:s.Color.fromHex("#094771"),listFocusAndSelectionForeground:s.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:s.Color.fromHex("#3F3F46"),listHoverBackground:s.Color.fromHex("#2A2D2E"),listDropBackground:s.Color.fromHex("#383B3D")},d=function(){function e(e,t,i){void 0===i&&(i={}),this._onDidChangeFocus=new r.Relay,this.onDidChangeFocus=this._onDidChangeFocus.event,this._onDidChangeSelection=new r.Relay,this.onDidChangeSelection=this._onDidChangeSelection.event,this._onHighlightChange=new r.Relay,this._onDidExpandItem=new r.Relay,this._onDidCollapseItem=new r.Relay,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event,this.container=e,a.mixin(i,u,!1),i.twistiePixels="number"==typeof i.twistiePixels?i.twistiePixels:32,i.showTwistie=!1!==i.showTwistie,i.indentPixels="number"==typeof i.indentPixels?i.indentPixels:12,i.alwaysFocused=!0===i.alwaysFocused,i.useShadows=!1!==i.useShadows,i.paddingOnRow=!1!==i.paddingOnRow,i.showLoading=!1!==i.showLoading,
this.context=new l(this,t,i),this.model=new n.TreeModel(this.context),this.view=new o.TreeView(this.context,this.container),this.view.setModel(this.model),this._onDidChangeFocus.input=this.model.onDidFocus,this._onDidChangeSelection.input=this.model.onDidSelect,this._onHighlightChange.input=this.model.onDidHighlight,this._onDidExpandItem.input=this.model.onDidExpandItem,this._onDidCollapseItem.input=this.model.onDidCollapseItem}return e.prototype.style=function(e){this.view.applyStyles(e)},Object.defineProperty(e.prototype,"onDidFocus",{get:function(){return this.view&&this.view.onDOMFocus},enumerable:!0,configurable:!0}),e.prototype.getHTMLElement=function(){return this.view.getHTMLElement()},e.prototype.layout=function(e,t){this.view.layout(e,t)},e.prototype.domFocus=function(){this.view.focus()},e.prototype.isDOMFocused=function(){return this.view.isFocused()},e.prototype.domBlur=function(){this.view.blur()},e.prototype.setInput=function(e){return this.model.setInput(e)},e.prototype.getInput=function(){
return this.model.getInput()},e.prototype.expand=function(e){return this.model.expand(e)},e.prototype.collapse=function(e,t){return void 0===t&&(t=!1),this.model.collapse(e,t)},e.prototype.toggleExpansion=function(e,t){return void 0===t&&(t=!1),this.model.toggleExpansion(e,t)},e.prototype.isExpanded=function(e){return this.model.isExpanded(e)},e.prototype.reveal=function(e,t){return void 0===t&&(t=null),this.model.reveal(e,t)},e.prototype.getHighlight=function(){return this.model.getHighlight()},e.prototype.clearHighlight=function(e){this.model.setHighlight(null,e)},e.prototype.setSelection=function(e,t){this.model.setSelection(e,t)},e.prototype.getSelection=function(){return this.model.getSelection()},e.prototype.clearSelection=function(e){this.model.setSelection([],e)},e.prototype.setFocus=function(e,t){this.model.setFocus(e,t)},e.prototype.getFocus=function(){return this.model.getFocus()},e.prototype.focusNext=function(e,t){this.model.focusNext(e,t)},e.prototype.focusPrevious=function(e,t){
this.model.focusPrevious(e,t)},e.prototype.focusParent=function(e){this.model.focusParent(e)},e.prototype.focusFirstChild=function(e){this.model.focusFirstChild(e)},e.prototype.focusFirst=function(e,t){this.model.focusFirst(e,t)},e.prototype.focusNth=function(e,t){this.model.focusNth(e,t)},e.prototype.focusLast=function(e,t){this.model.focusLast(e,t)},e.prototype.focusNextPage=function(e){this.view.focusNextPage(e)},e.prototype.focusPreviousPage=function(e){this.view.focusPreviousPage(e)},e.prototype.clearFocus=function(e){this.model.setFocus(null,e)},e.prototype.dispose=function(){this._onDispose.fire(),null!==this.model&&(this.model.dispose(),this.model=null),null!==this.view&&(this.view.dispose(),this.view=null),this._onDidChangeFocus.dispose(),this._onDidChangeSelection.dispose(),this._onHighlightChange.dispose(),this._onDidExpandItem.dispose(),this._onDidCollapseItem.dispose(),this._onDispose.dispose()},e}();t.Tree=d}),define(t[377],i([9]),{}),define(t[376],i([9]),{}),define(t[374],i([9]),{}),
define(t[354],i([9]),{}),define(t[319],i([9]),{}),define(t[315],i([9]),{}),define(t[314],i([9]),{}),define(t[303],i([9]),{}),define(t[301],i([9]),{}),define(t[293],i([9]),{}),define(t[289],i([9]),{}),define(t[284],i([9]),{}),define(t[278],i([9]),{}),define(t[276],i([9]),{}),define(t[275],i([9]),{}),define(t[274],i([9]),{}),define(t[268],i([9]),{}),define(t[253],i([9]),{}),define(t[244],i([9]),{}),define(t[240],i([9]),{}),define(t[233],i([9]),{}),define(t[230],i([9]),{}),define(t[598],i([9]),{}),define(t[591],i([9]),{}),define(t[578],i([9]),{}),define(t[551],i([9]),{}),define(t[548],i([9]),{}),define(t[540],i([9]),{}),define(t[172],i([9]),{}),define(t[504],i([9]),{}),define(t[486],i([9]),{}),define(t[482],i([9]),{}),define(t[453],i([9]),{}),define(t[436],i([9]),{}),define(t[421],i([9]),{}),define(t[397],i([9]),{}),define(t[373],i([9]),{}),define(t[372],i([9]),{}),define(t[298],i([9]),{}),define(t[271],i([9]),{}),define(t[266],i([9]),{}),define(t[261],i([9]),{}),define(t[260],i([9]),{}),
define(t[259],i([9]),{}),define(t[258],i([9]),{}),define(t[247],i([9]),{}),define(t[516],i([9]),{}),define(t[401],i([9]),{}),define(t[295],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t){this.chr=e,this.type=t,this.width=0}return e.prototype.fulfill=function(e){this.width=e},e}();t.CharWidthRequest=i;var n=function(){function e(e,t){this._bareFontInfo=e,this._requests=t,this._container=null,this._testElements=null}return e.prototype.read=function(){this._createDomElements(),document.body.appendChild(this._container),this._readFromDomElements(),document.body.removeChild(this._container),this._container=null,this._testElements=null},e.prototype._createDomElements=function(){var t=document.createElement("div");t.style.position="absolute",t.style.top="-50000px",t.style.width="50000px";var i=document.createElement("div");i.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),i.style.fontWeight=this._bareFontInfo.fontWeight,
i.style.fontSize=this._bareFontInfo.fontSize+"px",i.style.lineHeight=this._bareFontInfo.lineHeight+"px",i.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",t.appendChild(i);var n=document.createElement("div");n.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),n.style.fontWeight="bold",n.style.fontSize=this._bareFontInfo.fontSize+"px",n.style.lineHeight=this._bareFontInfo.lineHeight+"px",n.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",t.appendChild(n);var o=document.createElement("div");o.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),o.style.fontWeight=this._bareFontInfo.fontWeight,o.style.fontSize=this._bareFontInfo.fontSize+"px",o.style.lineHeight=this._bareFontInfo.lineHeight+"px",o.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",o.style.fontStyle="italic",t.appendChild(o);for(var r=[],s=0,a=this._requests.length;s<a;s++){var l=this._requests[s],u=void 0;0===l.type&&(u=i),2===l.type&&(u=n),1===l.type&&(u=o),u.appendChild(document.createElement("br"))
;var d=document.createElement("span");e._render(d,l),u.appendChild(d),r[s]=d}this._container=t,this._testElements=r},e._render=function(e,t){if(" "===t.chr){for(var i="&nbsp;",n=0;n<8;n++)i+=i;e.innerHTML=i}else{for(var o=t.chr,n=0;n<8;n++)o+=o;e.textContent=o}},e.prototype._readFromDomElements=function(){for(var e=0,t=this._requests.length;e<t;e++){var i=this._requests[e],n=this._testElements[e];i.fulfill(n.offsetWidth/256)}},e}();t.readCharWidths=function(e,t){new n(e,t).read()}}),define(t[383],i([1,0,2]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(t,i){var n=e.call(this)||this;return n.referenceDomElement=t,n.changeCallback=i,n.measureReferenceDomElementToken=-1,n.width=-1,n.height=-1,n.measureReferenceDomElement(!1),n}return r(t,e),t.prototype.dispose=function(){this.stopObserving(),e.prototype.dispose.call(this)},t.prototype.getWidth=function(){return this.width},t.prototype.getHeight=function(){return this.height},
t.prototype.startObserving=function(){var e=this;-1===this.measureReferenceDomElementToken&&(this.measureReferenceDomElementToken=setInterval(function(){return e.measureReferenceDomElement(!0)},100))},t.prototype.stopObserving=function(){-1!==this.measureReferenceDomElementToken&&(clearInterval(this.measureReferenceDomElementToken),this.measureReferenceDomElementToken=-1)},t.prototype.observe=function(e){this.measureReferenceDomElement(!0,e)},t.prototype.measureReferenceDomElement=function(e,t){var i=0,n=0;t?(i=t.width,n=t.height):this.referenceDomElement&&(i=this.referenceDomElement.clientWidth,n=this.referenceDomElement.clientHeight),i=Math.max(5,i),n=Math.max(5,n),this.width===i&&this.height===n||(this.width=i,this.height=n,e&&this.changeCallback())},t}(i.Disposable);t.ElementSizeObserver=n}),define(t[162],i([1,0,8,82,44,2]),function(e,t,i,n,o,s){"use strict";function a(e){var t=i.getDomNodePagePosition(e);return new d(t.left,t.top,t.width,t.height)}Object.defineProperty(t,"__esModule",{value:!0})
;var l=function(){function e(e,t){this.x=e,this.y=t}return e.prototype.toClientCoordinates=function(){return new u(this.x-i.StandardWindow.scrollX,this.y-i.StandardWindow.scrollY)},e}();t.PageCoordinates=l;var u=function(){function e(e,t){this.clientX=e,this.clientY=t}return e.prototype.toPageCoordinates=function(){return new l(this.clientX+i.StandardWindow.scrollX,this.clientY+i.StandardWindow.scrollY)},e}();t.ClientCoordinates=u;var d=function(){return function(e,t,i,n){this.x=e,this.y=t,this.width=i,this.height=n}}();t.EditorPagePosition=d,t.createEditorPagePosition=a;var c=function(e){function t(t,i){var n=e.call(this,t)||this;return n.pos=new l(n.posx,n.posy),n.editorPos=a(i),n}return r(t,e),t}(o.StandardMouseEvent);t.EditorMouseEvent=c;var h=function(){function e(e){this._editorViewDomNode=e}return e.prototype._create=function(e){return new c(e,this._editorViewDomNode)},e.prototype.onContextMenu=function(e,t){var n=this;return i.addDisposableListener(e,"contextmenu",function(e){t(n._create(e))})},
e.prototype.onMouseUp=function(e,t){var n=this;return i.addDisposableListener(e,"mouseup",function(e){t(n._create(e))})},e.prototype.onMouseDown=function(e,t){var n=this;return i.addDisposableListener(e,"mousedown",function(e){t(n._create(e))})},e.prototype.onMouseLeave=function(e,t){var n=this;return i.addDisposableNonBubblingMouseOutListener(e,function(e){t(n._create(e))})},e.prototype.onMouseMoveThrottled=function(e,t,n,o){var r=this;return i.addDisposableThrottledListener(e,"mousemove",t,function(e,t){return n(e,r._create(t))},o)},e}();t.EditorMouseEventFactory=h;var p=function(e){function t(t){var i=e.call(this)||this;return i._editorViewDomNode=t,i._globalMouseMoveMonitor=i._register(new n.GlobalMouseMoveMonitor),i._keydownListener=null,i}return r(t,e),t.prototype.startMonitoring=function(e,t,n){var o=this;this._keydownListener=i.addStandardDisposableListener(document,"keydown",function(e){e.toKeybinding().isModifierKey()||o._globalMouseMoveMonitor.stopMonitoring(!0)},!0)
;this._globalMouseMoveMonitor.startMonitoring(function(t,i){return e(t,new c(i,o._editorViewDomNode))},t,function(){o._keydownListener.dispose(),n()})},t}(s.Disposable);t.GlobalEditorMouseMoveMonitor=p}),define(t[235],i([1,0,4,2]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(){var t=e.call(this)||this;return t._onCodeEditorAdd=t._register(new i.Emitter),t.onCodeEditorAdd=t._onCodeEditorAdd.event,t._onCodeEditorRemove=t._register(new i.Emitter),t.onCodeEditorRemove=t._onCodeEditorRemove.event,t._onDiffEditorAdd=t._register(new i.Emitter),t._onDiffEditorRemove=t._register(new i.Emitter),t._codeEditors=Object.create(null),t._diffEditors=Object.create(null),t}return r(t,e),t.prototype.addCodeEditor=function(e){this._codeEditors[e.getId()]=e,this._onCodeEditorAdd.fire(e)},t.prototype.removeCodeEditor=function(e){delete this._codeEditors[e.getId()]&&this._onCodeEditorRemove.fire(e)},t.prototype.listCodeEditors=function(){var e=this
;return Object.keys(this._codeEditors).map(function(t){return e._codeEditors[t]})},t.prototype.addDiffEditor=function(e){this._diffEditors[e.getId()]=e,this._onDiffEditorAdd.fire(e)},t.prototype.removeDiffEditor=function(e){delete this._diffEditors[e.getId()]&&this._onDiffEditorRemove.fire(e)},t.prototype.listDiffEditors=function(){var e=this;return Object.keys(this._diffEditors).map(function(t){return e._diffEditors[t]})},t.prototype.getFocusedCodeEditor=function(){for(var e=null,t=0,i=this.listCodeEditors();t<i.length;t++){var n=i[t];if(n.hasTextFocus())return n;n.hasWidgetFocus()&&(e=n)}return e},t}(n.Disposable);t.AbstractCodeEditorService=o}),define(t[112],i([1,0,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorZoom=new(function(){function e(){this._zoomLevel=0,this._onDidChangeZoomLevel=new i.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event}return e.prototype.getZoomLevel=function(){return this._zoomLevel},e.prototype.setZoomLevel=function(e){
e=Math.min(Math.max(-5,e),20),this._zoomLevel!==e&&(this._zoomLevel=e,this._onDidChangeZoomLevel.fire(this._zoomLevel))},e}())}),define(t[13],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t){this.lineNumber=e,this.column=t}return e.prototype.with=function(t,i){return void 0===t&&(t=this.lineNumber),void 0===i&&(i=this.column),t===this.lineNumber&&i===this.column?this:new e(t,i)},e.prototype.delta=function(e,t){return void 0===e&&(e=0),void 0===t&&(t=0),this.with(this.lineNumber+e,this.column+t)},e.prototype.equals=function(t){return e.equals(this,t)},e.equals=function(e,t){return!e&&!t||!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column},e.prototype.isBefore=function(t){return e.isBefore(this,t)},e.isBefore=function(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<t.column},e.prototype.isBeforeOrEqual=function(t){return e.isBeforeOrEqual(this,t)},e.isBeforeOrEqual=function(e,t){
return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<=t.column},e.compare=function(e,t){var i=0|e.lineNumber,n=0|t.lineNumber;if(i===n){return(0|e.column)-(0|t.column)}return i-n},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e}();t.Position=i}),define(t[3],i([1,0,13]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i,n){e>i||e===i&&t>n?(this.startLineNumber=i,this.startColumn=n,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=i,this.endColumn=n)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},
e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.containsPosition=function(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber)&&(!(t.lineNumber===e.startLineNumber&&t.column<e.startColumn)&&!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn))},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.containsRange=function(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)))},e.prototype.strictContainsRange=function(t){return e.strictContainsRange(this,t)},e.strictContainsRange=function(e,t){
return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<=e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>=e.endColumn)))},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.plusRange=function(t,i){var n,o,r,s;return i.startLineNumber<t.startLineNumber?(n=i.startLineNumber,o=i.startColumn):i.startLineNumber===t.startLineNumber?(n=i.startLineNumber,o=Math.min(i.startColumn,t.startColumn)):(n=t.startLineNumber,o=t.startColumn),i.endLineNumber>t.endLineNumber?(r=i.endLineNumber,s=i.endColumn):i.endLineNumber===t.endLineNumber?(r=i.endLineNumber,s=Math.max(i.endColumn,t.endColumn)):(r=t.endLineNumber,s=t.endColumn),new e(n,o,r,s)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.intersectRanges=function(t,i){
var n=t.startLineNumber,o=t.startColumn,r=t.endLineNumber,s=t.endColumn,a=i.startLineNumber,l=i.startColumn,u=i.endLineNumber,d=i.endColumn;return n<a?(n=a,o=l):n===a&&(o=Math.max(o,l)),r>u?(r=u,s=d):r===u&&(s=Math.min(s,d)),n>r?null:n===r&&o>s?null:new e(n,o,r,s)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.prototype.getEndPosition=function(){return new i.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new i.Position(this.startLineNumber,this.startColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,i){return new e(this.startLineNumber,this.startColumn,t,i)},e.prototype.setStartPosition=function(t,i){
return new e(t,i,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return e.collapseToStart(this)},e.collapseToStart=function(t){return new e(t.startLineNumber,t.startColumn,t.startLineNumber,t.startColumn)},e.fromPositions=function(t,i){return void 0===i&&(i=t),new e(t.lineNumber,t.column,i.lineNumber,i.column)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.areIntersectingOrTouching=function(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)},e.areIntersecting=function(e,t){
return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<=t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<=e.startColumn)},e.compareRangesUsingStarts=function(e,t){if(e&&t){var i=0|e.startLineNumber,n=0|t.startLineNumber;if(i===n){var o=0|e.startColumn,r=0|t.startColumn;if(o===r){var s=0|e.endLineNumber,a=0|t.endLineNumber;if(s===a){return(0|e.endColumn)-(0|t.endColumn)}return s-a}return o-r}return i-n}return(e?1:0)-(t?1:0)},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e}();t.Range=n}),define(t[197],i([1,0,5,13,3]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){
function e(e,t,i,n,o){this.value=e,this.selectionStart=t,this.selectionEnd=i,this.selectionStartPosition=n,this.selectionEndPosition=o}return e.prototype.toString=function(){return"[ <"+this.value+">, selectionStart: "+this.selectionStart+", selectionEnd: "+this.selectionEnd+"]"},e.readFromTextArea=function(t){return new e(t.getValue(),t.getSelectionStart(),t.getSelectionEnd(),null,null)},e.prototype.collapseSelection=function(){return new e(this.value,this.value.length,this.value.length,null,null)},e.prototype.writeToTextArea=function(e,t,i){t.setValue(e,this.value),i&&t.setSelectionRange(e,this.selectionStart,this.selectionEnd)},e.prototype.deduceEditorPosition=function(e){if(e<=this.selectionStart){t=this.value.substring(e,this.selectionStart);return this._finishDeduceEditorPosition(this.selectionStartPosition,t,-1)}if(e>=this.selectionEnd){var t=this.value.substring(this.selectionEnd,e);return this._finishDeduceEditorPosition(this.selectionEndPosition,t,1)}var i=this.value.substring(this.selectionStart,e)
;if(-1===i.indexOf(String.fromCharCode(8230)))return this._finishDeduceEditorPosition(this.selectionStartPosition,i,1);var n=this.value.substring(e,this.selectionEnd);return this._finishDeduceEditorPosition(this.selectionEndPosition,n,-1)},e.prototype._finishDeduceEditorPosition=function(e,t,i){for(var n=0,o=-1;-1!==(o=t.indexOf("\n",o+1));)n++;return[e,i*t.length,n]},e.selectedText=function(t){return new e(t,0,t.length,null,null)},e.deduceInput=function(e,t,n,o){if(!e)return{text:"",replaceCharCnt:0};var r=e.value,s=e.selectionStart,a=e.selectionEnd,l=t.value,u=t.selectionStart,d=t.selectionEnd;o&&r.length>0&&s===a&&u===d&&!i.startsWith(l,r)&&i.endsWith(l,r)&&(s=0,a=0);var c=r.substring(a),h=l.substring(d),p=i.commonSuffixLength(c,h);l=l.substring(0,l.length-p);var f=(r=r.substring(0,r.length-p)).substring(0,s),g=l.substring(0,u),m=i.commonPrefixLength(f,g);if(l=l.substring(m),r=r.substring(m),u-=m,s-=m,d-=m,a-=m,n&&u===d&&r.length>0){var v=null
;if(u===l.length?i.startsWith(l,r)&&(v=l.substring(r.length)):i.endsWith(l,r)&&(v=l.substring(0,l.length-r.length)),null!==v&&v.length>0&&(/\uFE0F/.test(v)||i.containsEmoji(v)))return{text:v,replaceCharCnt:0}}if(u===d){if(r===l&&0===s&&a===r.length&&u===l.length&&-1===l.indexOf("\n")&&i.containsFullWidthCharacter(l))return{text:"",replaceCharCnt:0};return{text:l,replaceCharCnt:f.length-m}}return{text:l,replaceCharCnt:a-s}},e.EMPTY=new e("",0,0,null,null),e}();t.TextAreaState=r;var s=function(){function e(){}return e._getPageOfLine=function(t){return Math.floor((t-1)/e._LINES_PER_PAGE)},e._getRangeForPage=function(t){var i=t*e._LINES_PER_PAGE,n=i+1,r=i+e._LINES_PER_PAGE;return new o.Range(n,1,r+1,1)},e.fromEditorSelection=function(t,i,s,a){
var l,u=e._getPageOfLine(s.startLineNumber),d=e._getRangeForPage(u),c=e._getPageOfLine(s.endLineNumber),h=e._getRangeForPage(c),p=d.intersectRanges(new o.Range(1,1,s.startLineNumber,s.startColumn)),f=i.getValueInRange(p,1),g=i.getLineCount(),m=i.getLineMaxColumn(g),v=h.intersectRanges(new o.Range(s.endLineNumber,s.endColumn,g,m)),_=i.getValueInRange(v,1);if(u===c||u+1===c)l=i.getValueInRange(s,1);else{var y=d.intersectRanges(s),b=h.intersectRanges(s);l=i.getValueInRange(y,1)+String.fromCharCode(8230)+i.getValueInRange(b,1)}if(a){f.length>500&&(f=f.substring(f.length-500,f.length)),_.length>500&&(_=_.substring(0,500)),l.length>1e3&&(l=l.substring(0,500)+String.fromCharCode(8230)+l.substring(l.length-500,l.length))}return new r(f+l+_,f.length,f.length+l.length,new n.Position(s.startLineNumber,s.startColumn),new n.Position(s.endLineNumber,s.endColumn))},e._LINES_PER_PAGE=10,e}();t.PagedScreenReaderStrategy=s}),define(t[166],i([1,0,160,4,2,29,3]),function(e,t,i,n,o,s,a){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var l={followsCaret:!0,ignoreCharChanges:!0,alwaysRevealFirst:!0},u=function(e){function t(t,i){void 0===i&&(i={});var o=e.call(this)||this;return o._onDidUpdate=o._register(new n.Emitter),o._editor=t,o._options=s.mixin(i,l,!1),o.disposed=!1,o.nextIdx=-1,o.ranges=[],o.ignoreSelectionChange=!1,o.revealFirst=Boolean(o._options.alwaysRevealFirst),o._register(o._editor.onDidDispose(function(){return o.dispose()})),o._register(o._editor.onDidUpdateDiff(function(){return o._onDiffUpdated()})),o._options.followsCaret&&o._register(o._editor.getModifiedEditor().onDidChangeCursorPosition(function(e){o.ignoreSelectionChange||(o.nextIdx=-1)})),o._options.alwaysRevealFirst&&o._register(o._editor.getModifiedEditor().onDidChangeModel(function(e){o.revealFirst=!0})),o._init(),o}return r(t,e),t.prototype._init=function(){this._editor.getLineChanges()},t.prototype._onDiffUpdated=function(){this._init(),this._compute(this._editor.getLineChanges()),
this.revealFirst&&null!==this._editor.getLineChanges()&&(this.revealFirst=!1,this.nextIdx=-1,this.next(1))},t.prototype._compute=function(e){var t=this;this.ranges=[],e&&e.forEach(function(e){!t._options.ignoreCharChanges&&e.charChanges?e.charChanges.forEach(function(e){t.ranges.push({rhs:!0,range:new a.Range(e.modifiedStartLineNumber,e.modifiedStartColumn,e.modifiedEndLineNumber,e.modifiedEndColumn)})}):t.ranges.push({rhs:!0,range:new a.Range(e.modifiedStartLineNumber,1,e.modifiedStartLineNumber,1)})}),this.ranges.sort(function(e,t){return e.range.getStartPosition().isBeforeOrEqual(t.range.getStartPosition())?-1:t.range.getStartPosition().isBeforeOrEqual(e.range.getStartPosition())?1:0}),this._onDidUpdate.fire(this)},t.prototype._initIdx=function(e){var t=!1,i=this._editor.getPosition();if(i){for(var n=0,o=this.ranges.length;n<o&&!t;n++){var r=this.ranges[n].range;i.isBeforeOrEqual(r.getStartPosition())&&(this.nextIdx=n+(e?0:-1),t=!0)}t||(this.nextIdx=e?0:this.ranges.length-1),
this.nextIdx<0&&(this.nextIdx=this.ranges.length-1)}else this.nextIdx=0},t.prototype._move=function(e,t){if(i.ok(!this.disposed,"Illegal State - diff navigator has been disposed"),this.canNavigate()){-1===this.nextIdx?this._initIdx(e):e?(this.nextIdx+=1,this.nextIdx>=this.ranges.length&&(this.nextIdx=0)):(this.nextIdx-=1,this.nextIdx<0&&(this.nextIdx=this.ranges.length-1));var n=this.ranges[this.nextIdx];this.ignoreSelectionChange=!0;try{var o=n.range.getStartPosition();this._editor.setPosition(o),this._editor.revealPositionInCenter(o,t)}finally{this.ignoreSelectionChange=!1}}},t.prototype.canNavigate=function(){return this.ranges&&this.ranges.length>0},t.prototype.next=function(e){void 0===e&&(e=0),this._move(!0,e)},t.prototype.previous=function(e){void 0===e&&(e=0),this._move(!1,e)},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.ranges=[],this.disposed=!0},t}(o.Disposable);t.DiffNavigator=u}),define(t[53],i([1,0,3]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{
value:!0});var n=function(){function e(){}return e.insert=function(e,t){return{range:new i.Range(e.lineNumber,e.column,e.lineNumber,e.column),text:t,forceMoveMarkers:!0}},e.delete=function(e){return{range:e,text:null}},e.replace=function(e,t){return{range:e,text:t}},e.replaceMove=function(e,t){return{range:e,text:t,forceMoveMarkers:!0}},e}();t.EditOperation=n}),define(t[505],i([1,0,5,53,3]),function(e,t,i,n,o){"use strict";function r(e,t){t.sort(function(e,t){return e.lineNumber===t.lineNumber?e.column-t.column:e.lineNumber-t.lineNumber});for(var r=t.length-2;r>=0;r--)t[r].lineNumber===t[r+1].lineNumber&&t.splice(r,1);for(var s=[],a=0,l=0,u=t.length,d=1,c=e.getLineCount();d<=c;d++){var h=e.getLineContent(d),p=h.length+1,f=0;if(!(l<u&&t[l].lineNumber===d&&(f=t[l].column,l++,f===p))&&0!==h.length){var g=i.lastNonWhitespaceIndex(h),m=0;if(-1===g)m=1;else{if(g===h.length-1)continue;m=g+2}m=Math.max(f,m),s[a++]=n.EditOperation.delete(new o.Range(d,m,d,p))}}return s}Object.defineProperty(t,"__esModule",{value:!0})
;var s=function(){function e(e,t){this._selection=e,this._cursors=t,this._selectionId=null}return e.prototype.getEditOperations=function(e,t){for(var i=r(e,this._cursors),n=0,o=i.length;n<o;n++){var s=i[n];t.addEditOperation(s.range,s.text)}this._selectionId=t.trackSelection(this._selection)},e.prototype.computeCursorState=function(e,t){return t.getTrackedSelection(this._selectionId)},e}();t.TrimTrailingWhitespaceCommand=s,t.trimTrailingWhitespace=r}),define(t[511],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(t,i,n,o){this.r=e._clamp(t),this.g=e._clamp(i),this.b=e._clamp(n),this.a=e._clamp(o)}return e._clamp=function(e){return e<0?0:e>255?255:0|e},e.Empty=new e(0,0,0,0),e}();t.RGBA8=i}),define(t[20],i([1,0,13,3]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t,i,n,o){var r=e.call(this,t,i,n,o)||this;return r.selectionStartLineNumber=t,r.selectionStartColumn=i,
r.positionLineNumber=n,r.positionColumn=o,r}return r(t,e),t.prototype.clone=function(){return new t(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},t.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},t.prototype.equalsSelection=function(e){return t.selectionsEqual(this,e)},t.selectionsEqual=function(e,t){return e.selectionStartLineNumber===t.selectionStartLineNumber&&e.selectionStartColumn===t.selectionStartColumn&&e.positionLineNumber===t.positionLineNumber&&e.positionColumn===t.positionColumn},t.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},t.prototype.setEndPosition=function(e,i){return 0===this.getDirection()?new t(this.startLineNumber,this.startColumn,e,i):new t(e,i,this.startLineNumber,this.startColumn)},t.prototype.getPosition=function(){
return new i.Position(this.positionLineNumber,this.positionColumn)},t.prototype.setStartPosition=function(e,i){return 0===this.getDirection()?new t(e,i,this.endLineNumber,this.endColumn):new t(this.endLineNumber,this.endColumn,e,i)},t.fromPositions=function(e,i){return void 0===i&&(i=e),new t(e.lineNumber,e.column,i.lineNumber,i.column)},t.liftSelection=function(e){return new t(e.selectionStartLineNumber,e.selectionStartColumn,e.positionLineNumber,e.positionColumn)},t.selectionsArrEqual=function(e,t){if(e&&!t||!e&&t)return!1;if(!e&&!t)return!0;if(e.length!==t.length)return!1;for(var i=0,n=e.length;i<n;i++)if(!this.selectionsEqual(e[i],t[i]))return!1;return!0},t.isISelection=function(e){return e&&"number"==typeof e.selectionStartLineNumber&&"number"==typeof e.selectionStartColumn&&"number"==typeof e.positionLineNumber&&"number"==typeof e.positionColumn},t.createWithDirection=function(e,i,n,o,r){return 0===r?new t(e,i,n,o):new t(n,o,e,i)},t}(n.Range);t.Selection=o}),
define(t[167],i([1,0,28,8,15,4,2,18,5,197,20]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CopyOptions={forceCopyWithSyntaxHighlighting:!1};var h=function(e){function a(t,r){var a=e.call(this)||this;a._onFocus=a._register(new s.Emitter),a.onFocus=a._onFocus.event,a._onBlur=a._register(new s.Emitter),a.onBlur=a._onBlur.event,a._onKeyDown=a._register(new s.Emitter),a.onKeyDown=a._onKeyDown.event,a._onKeyUp=a._register(new s.Emitter),a.onKeyUp=a._onKeyUp.event,a._onCut=a._register(new s.Emitter),a.onCut=a._onCut.event,a._onPaste=a._register(new s.Emitter),a.onPaste=a._onPaste.event,a._onType=a._register(new s.Emitter),a.onType=a._onType.event,a._onCompositionStart=a._register(new s.Emitter),a.onCompositionStart=a._onCompositionStart.event,a._onCompositionUpdate=a._register(new s.Emitter),a.onCompositionUpdate=a._onCompositionUpdate.event,a._onCompositionEnd=a._register(new s.Emitter),a.onCompositionEnd=a._onCompositionEnd.event,
a._onSelectionChangeRequest=a._register(new s.Emitter),a.onSelectionChangeRequest=a._onSelectionChangeRequest.event,a._host=t,a._textArea=a._register(new f(r)),a._lastTextAreaEvent=0,a._asyncTriggerCut=a._register(new o.RunOnceScheduler(function(){return a._onCut.fire()},0)),a._textAreaState=d.TextAreaState.EMPTY,a._selectionChangeListener=null,a.writeScreenReaderContent("ctor"),a._hasFocus=!1,a._isDoingComposition=!1,a._nextCommand=0,a._register(n.addStandardDisposableListener(r.domNode,"keydown",function(e){!a._isDoingComposition||109!==e.keyCode&&1!==e.keyCode||e.stopPropagation(),e.equals(9)&&e.preventDefault(),a._onKeyDown.fire(e)})),a._register(n.addStandardDisposableListener(r.domNode,"keyup",function(e){a._onKeyUp.fire(e)})),a._register(n.addDisposableListener(r.domNode,"compositionstart",function(e){a._lastTextAreaEvent=1,a._isDoingComposition||(a._isDoingComposition=!0,i.isEdgeOrIE||a._setAndWriteTextAreaState("compositionstart",d.TextAreaState.EMPTY),a._onCompositionStart.fire())}))
;var c=function(e,t){var i=a._textAreaState,n=d.TextAreaState.readFromTextArea(a._textArea);return[n,d.TextAreaState.deduceInput(i,n,e,t)]},h=function(e){var t=a._textAreaState,i=d.TextAreaState.selectedText(e);return[i,{text:i.value,replaceCharCnt:t.selectionEnd-t.selectionStart}]},g=function(e){return!(!i.isEdgeOrIE||"ja"!==e)||!(!i.isIE||0!==e.indexOf("zh-Han"))};return a._register(n.addDisposableListener(r.domNode,"compositionupdate",function(e){if(a._lastTextAreaEvent=2,g(e.locale)){var t=c(!1,!1),i=t[0],n=t[1];return a._textAreaState=i,a._onType.fire(n),void a._onCompositionUpdate.fire(e)}var o=h(e.data),r=o[0],s=o[1];a._textAreaState=r,a._onType.fire(s),a._onCompositionUpdate.fire(e)})),a._register(n.addDisposableListener(r.domNode,"compositionend",function(e){if(a._lastTextAreaEvent=3,g(e.locale)){var t=c(!1,!1),n=t[0],o=t[1];a._textAreaState=n,a._onType.fire(o)}else{var r=h(e.data),n=r[0],o=r[1];a._textAreaState=n,a._onType.fire(o)}
(i.isEdgeOrIE||i.isChrome)&&(a._textAreaState=d.TextAreaState.readFromTextArea(a._textArea)),a._isDoingComposition&&(a._isDoingComposition=!1,a._onCompositionEnd.fire())})),a._register(n.addDisposableListener(r.domNode,"input",function(){var e=8===a._lastTextAreaEvent;if(a._lastTextAreaEvent=4,a._textArea.setIgnoreSelectionChangeTime("received input event"),!a._isDoingComposition){var t=c(l.isMacintosh,e&&l.isMacintosh),i=t[0],n=t[1];0===n.replaceCharCnt&&1===n.text.length&&u.isHighSurrogate(n.text.charCodeAt(0))||(a._textAreaState=i,0===a._nextCommand?""!==n.text&&a._onType.fire(n):(""!==n.text&&a._onPaste.fire({text:n.text}),a._nextCommand=0))}})),a._register(n.addDisposableListener(r.domNode,"cut",function(e){a._lastTextAreaEvent=5,a._textArea.setIgnoreSelectionChangeTime("received cut event"),a._ensureClipboardGetsEditorSelection(e),a._asyncTriggerCut.schedule()})),a._register(n.addDisposableListener(r.domNode,"copy",function(e){a._lastTextAreaEvent=6,a._ensureClipboardGetsEditorSelection(e)})),
a._register(n.addDisposableListener(r.domNode,"paste",function(e){if(a._lastTextAreaEvent=7,a._textArea.setIgnoreSelectionChangeTime("received paste event"),p.canUseTextData(e)){var t=p.getTextData(e);""!==t&&a._onPaste.fire({text:t})}else a._textArea.getSelectionStart()!==a._textArea.getSelectionEnd()&&a._setAndWriteTextAreaState("paste",d.TextAreaState.EMPTY),a._nextCommand=1})),a._register(n.addDisposableListener(r.domNode,"focus",function(){a._lastTextAreaEvent=8,a._setHasFocus(!0)})),a._register(n.addDisposableListener(r.domNode,"blur",function(){a._lastTextAreaEvent=9,a._setHasFocus(!1)})),a}return r(a,e),a.prototype._installSelectionChangeListener=function(){var e=this,t=0;return n.addDisposableListener(document,"selectionchange",function(n){if(e._hasFocus&&!e._isDoingComposition&&i.isChrome&&l.isWindows){var o=Date.now(),r=o-t;if(t=o,!(r<5)){var s=o-e._textArea.getIgnoreSelectionChangeTime();if(e._textArea.resetSelectionChangeTime(),
!(s<100)&&e._textAreaState.selectionStartPosition&&e._textAreaState.selectionEndPosition){var a=e._textArea.getValue();if(e._textAreaState.value===a){var u=e._textArea.getSelectionStart(),d=e._textArea.getSelectionEnd();if(e._textAreaState.selectionStart!==u||e._textAreaState.selectionEnd!==d){var h=e._textAreaState.deduceEditorPosition(u),p=e._host.deduceModelPosition(h[0],h[1],h[2]),f=e._textAreaState.deduceEditorPosition(d),g=e._host.deduceModelPosition(f[0],f[1],f[2]),m=new c.Selection(p.lineNumber,p.column,g.lineNumber,g.column);e._onSelectionChangeRequest.fire(m)}}}}}})},a.prototype.dispose=function(){e.prototype.dispose.call(this),this._selectionChangeListener&&(this._selectionChangeListener.dispose(),this._selectionChangeListener=null)},a.prototype.focusTextArea=function(){this._setHasFocus(!0)},a.prototype.isFocused=function(){return this._hasFocus},a.prototype._setHasFocus=function(e){this._hasFocus!==e&&(this._hasFocus=e,this._selectionChangeListener&&(this._selectionChangeListener.dispose(),
this._selectionChangeListener=null),this._hasFocus&&(this._selectionChangeListener=this._installSelectionChangeListener()),this._hasFocus&&(i.isEdge?this._setAndWriteTextAreaState("focusgain",d.TextAreaState.EMPTY):this.writeScreenReaderContent("focusgain")),this._hasFocus?this._onFocus.fire():this._onBlur.fire())},a.prototype._setAndWriteTextAreaState=function(e,t){this._hasFocus||(t=t.collapseSelection()),t.writeToTextArea(e,this._textArea,this._hasFocus),this._textAreaState=t},a.prototype.writeScreenReaderContent=function(e){this._isDoingComposition||this._setAndWriteTextAreaState(e,this._host.getScreenReaderContent(this._textAreaState))},a.prototype._ensureClipboardGetsEditorSelection=function(e){var n=this._host.getPlainTextToCopy();if(p.canUseTextData(e)){var o=null;i.hasClipboardSupport()&&(n.length<65536||t.CopyOptions.forceCopyWithSyntaxHighlighting)&&(o=this._host.getHTMLToCopy()),p.setTextData(e,n,o)}else this._setAndWriteTextAreaState("copy or cut",d.TextAreaState.selectedText(n))},a
}(a.Disposable);t.TextAreaInput=h;var p=function(){function e(){}return e.canUseTextData=function(e){return!!e.clipboardData||!!window.clipboardData},e.getTextData=function(e){if(e.clipboardData)return e.preventDefault(),e.clipboardData.getData("text/plain");if(window.clipboardData)return e.preventDefault(),window.clipboardData.getData("Text");throw new Error("ClipboardEventUtils.getTextData: Cannot use text data!")},e.setTextData=function(e,t,i){if(e.clipboardData)return e.clipboardData.setData("text/plain",t),null!==i&&e.clipboardData.setData("text/html",i),void e.preventDefault();if(window.clipboardData)return window.clipboardData.setData("Text",t),void e.preventDefault();throw new Error("ClipboardEventUtils.setTextData: Cannot use text data!")},e}(),f=function(e){function t(t){var i=e.call(this)||this;return i._actual=t,i._ignoreSelectionChangeTime=0,i}return r(t,e),t.prototype.setIgnoreSelectionChangeTime=function(e){this._ignoreSelectionChangeTime=Date.now()},
t.prototype.getIgnoreSelectionChangeTime=function(){return this._ignoreSelectionChangeTime},t.prototype.resetSelectionChangeTime=function(){this._ignoreSelectionChangeTime=0},t.prototype.getValue=function(){return this._actual.domNode.value},t.prototype.setValue=function(e,t){var i=this._actual.domNode;i.value!==t&&(this.setIgnoreSelectionChangeTime("setValue"),i.value=t)},t.prototype.getSelectionStart=function(){return this._actual.domNode.selectionStart},t.prototype.getSelectionEnd=function(){return this._actual.domNode.selectionEnd},t.prototype.setSelectionRange=function(e,t,o){var r=this._actual.domNode,s=document.activeElement===r,a=r.selectionStart,l=r.selectionEnd;if(s&&a===t&&l===o)i.isFirefox&&window.parent!==window&&r.focus();else{if(s)return this.setIgnoreSelectionChangeTime("setSelectionRange"),r.setSelectionRange(t,o),void(i.isFirefox&&window.parent!==window&&r.focus());try{var u=n.saveParentsScrollTop(r);this.setIgnoreSelectionChangeTime("setSelectionRange"),r.focus(),r.setSelectionRange(t,o),
n.restoreParentsScrollTop(r,u)}catch(e){}}},t}(a.Disposable)}),define(t[81],i([1,0,20]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i){void 0===i&&(i=!1),this._range=e,this._text=t,this.insertsAutoWhitespace=i}return e.prototype.getEditOperations=function(e,t){t.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(e,t){var n=t.getInverseEditOperations()[0].range;return new i.Selection(n.endLineNumber,n.endColumn,n.endLineNumber,n.endColumn)},e}();t.ReplaceCommand=n;var o=function(){function e(e,t,i){void 0===i&&(i=!1),this._range=e,this._text=t,this.insertsAutoWhitespace=i}return e.prototype.getEditOperations=function(e,t){t.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(e,t){var n=t.getInverseEditOperations()[0].range;return new i.Selection(n.startLineNumber,n.startColumn,n.startLineNumber,n.startColumn)},e}();t.ReplaceCommandWithoutChangingPosition=o
;var r=function(){function e(e,t,i,n,o){void 0===o&&(o=!1),this._range=e,this._text=t,this._columnDeltaOffset=n,this._lineNumberDeltaOffset=i,this.insertsAutoWhitespace=o}return e.prototype.getEditOperations=function(e,t){t.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(e,t){var n=t.getInverseEditOperations()[0].range;return new i.Selection(n.endLineNumber+this._lineNumberDeltaOffset,n.endColumn+this._columnDeltaOffset,n.endLineNumber+this._lineNumberDeltaOffset,n.endColumn+this._columnDeltaOffset)},e}();t.ReplaceCommandWithOffsetCursorState=r;var s=function(){function e(e,t,i){this._range=e,this._text=t,this._initialSelection=i,this._selectionId=null}return e.prototype.getEditOperations=function(e,t){t.addEditOperation(this._range,this._text),this._selectionId=t.trackSelection(this._initialSelection)},e.prototype.computeCursorState=function(e,t){return t.getTrackedSelection(this._selectionId)},e}();t.ReplaceCommandThatPreservesSelection=s}),
define(t[256],i([1,0,3,20]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t,i){this._range=e,this._charBeforeSelection=t,this._charAfterSelection=i}return e.prototype.getEditOperations=function(e,t){t.addTrackedEditOperation(new i.Range(this._range.startLineNumber,this._range.startColumn,this._range.startLineNumber,this._range.startColumn),this._charBeforeSelection),t.addTrackedEditOperation(new i.Range(this._range.endLineNumber,this._range.endColumn,this._range.endLineNumber,this._range.endColumn),this._charAfterSelection)},e.prototype.computeCursorState=function(e,t){var i=t.getInverseEditOperations(),o=i[0].range,r=i[1].range;return new n.Selection(o.endLineNumber,o.endColumn,r.endLineNumber,r.endColumn-this._charAfterSelection.length)},e}();t.SurroundSelectionCommand=o}),define(t[156],i([1,0,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),"undefined"!=typeof TextDecoder?t.createStringBuilder=function(e){
return new n(e)}:t.createStringBuilder=function(e){return new o};var n=function(){function e(e){this._decoder=new TextDecoder("UTF-16LE"),this._capacity=0|e,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}return e.prototype.reset=function(){this._completedStrings=null,this._bufferLength=0},e.prototype.build=function(){return null!==this._completedStrings?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()},e.prototype._buildBuffer=function(){if(0===this._bufferLength)return"";var e=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return this._decoder.decode(e)},e.prototype._flushBuffer=function(){var e=this._buildBuffer();this._bufferLength=0,null===this._completedStrings?this._completedStrings=[e]:this._completedStrings[this._completedStrings.length]=e},e.prototype.write1=function(e){var t=this._capacity-this._bufferLength;t<=1&&(0===t||i.isHighSurrogate(e))&&this._flushBuffer(),this._buffer[this._bufferLength++]=e},
e.prototype.appendASCII=function(e){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=e},e.prototype.appendASCIIString=function(e){var t=e.length;if(this._bufferLength+t>=this._capacity)return this._flushBuffer(),void(this._completedStrings[this._completedStrings.length]=e);for(var i=0;i<t;i++)this._buffer[this._bufferLength++]=e.charCodeAt(i)},e}(),o=function(){function e(){this._pieces=[],this._piecesLen=0}return e.prototype.reset=function(){this._pieces=[],this._piecesLen=0},e.prototype.build=function(){return this._pieces.join("")},e.prototype.write1=function(e){this._pieces[this._piecesLen++]=String.fromCharCode(e)},e.prototype.appendASCII=function(e){this._pieces[this._piecesLen++]=String.fromCharCode(e)},e.prototype.appendASCIIString=function(e){this._pieces[this._piecesLen++]=e},e}()}),define(t[155],i([1,0,27,156]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e){this._createLine=e,this._set(1,[])}
return e.prototype.flush=function(){this._set(1,[])},e.prototype._set=function(e,t){this._lines=t,this._rendLineNumberStart=e},e.prototype._get=function(){return{rendLineNumberStart:this._rendLineNumberStart,lines:this._lines}},e.prototype.getStartLineNumber=function(){return this._rendLineNumberStart},e.prototype.getEndLineNumber=function(){return this._rendLineNumberStart+this._lines.length-1},e.prototype.getCount=function(){return this._lines.length},e.prototype.getLine=function(e){var t=e-this._rendLineNumberStart;if(t<0||t>=this._lines.length)throw new Error("Illegal value for lineNumber");return this._lines[t]},e.prototype.onLinesDeleted=function(e,t){if(0===this.getCount())return null;var i=this.getStartLineNumber(),n=this.getEndLineNumber();if(t<i){var o=t-e+1;return this._rendLineNumberStart-=o,null}if(e>n)return null;for(var r=0,s=0,a=i;a<=n;a++){var l=a-this._rendLineNumberStart;e<=a&&a<=t&&(0===s?(r=l,s=1):s++)}if(e<i){var u=0;u=t<i?t-e+1:i-e,this._rendLineNumberStart-=u}
return this._lines.splice(r,s)},e.prototype.onLinesChanged=function(e,t){if(0===this.getCount())return!1;for(var i=this.getStartLineNumber(),n=this.getEndLineNumber(),o=!1,r=e;r<=t;r++)r>=i&&r<=n&&(this._lines[r-this._rendLineNumberStart].onContentChanged(),o=!0);return o},e.prototype.onLinesInserted=function(e,t){if(0===this.getCount())return null;var i=t-e+1,n=this.getStartLineNumber(),o=this.getEndLineNumber();if(e<=n)return this._rendLineNumberStart+=i,null;if(e>o)return null;if(i+e>o){return this._lines.splice(e-this._rendLineNumberStart,o-e+1)}for(var r=[],s=0;s<i;s++)r[s]=this._createLine();var a=e-this._rendLineNumberStart,l=this._lines.slice(0,a),u=this._lines.slice(a,this._lines.length-i),d=this._lines.slice(this._lines.length-i,this._lines.length);return this._lines=l.concat(r).concat(u),d},e.prototype.onTokensChanged=function(e){if(0===this.getCount())return!1;for(var t=this.getStartLineNumber(),i=this.getEndLineNumber(),n=!1,o=0,r=e.length;o<r;o++){var s=e[o]
;if(!(s.toLineNumber<t||s.fromLineNumber>i))for(var a=Math.max(t,s.fromLineNumber),l=Math.min(i,s.toLineNumber),u=a;u<=l;u++){var d=u-this._rendLineNumberStart;this._lines[d].onTokensChanged(),n=!0}}return n},e}();t.RenderedLinesCollection=o;var r=function(){function e(e){var t=this;this._host=e,this.domNode=this._createDomNode(),this._linesCollection=new o(function(){return t._host.createVisibleLine()})}return e.prototype._createDomNode=function(){var e=i.createFastDomNode(document.createElement("div"));return e.setClassName("view-layer"),e.setPosition("absolute"),e.domNode.setAttribute("role","presentation"),e.domNode.setAttribute("aria-hidden","true"),e},e.prototype.onConfigurationChanged=function(e){return e.layoutInfo},e.prototype.onFlushed=function(e){return this._linesCollection.flush(),!0},e.prototype.onLinesChanged=function(e){return this._linesCollection.onLinesChanged(e.fromLineNumber,e.toLineNumber)},e.prototype.onLinesDeleted=function(e){
var t=this._linesCollection.onLinesDeleted(e.fromLineNumber,e.toLineNumber);if(t)for(var i=0,n=t.length;i<n;i++){var o=t[i].getDomNode();o&&this.domNode.domNode.removeChild(o)}return!0},e.prototype.onLinesInserted=function(e){var t=this._linesCollection.onLinesInserted(e.fromLineNumber,e.toLineNumber);if(t)for(var i=0,n=t.length;i<n;i++){var o=t[i].getDomNode();o&&this.domNode.domNode.removeChild(o)}return!0},e.prototype.onScrollChanged=function(e){return e.scrollTopChanged},e.prototype.onTokensChanged=function(e){return this._linesCollection.onTokensChanged(e.ranges)},e.prototype.onZonesChanged=function(e){return!0},e.prototype.getStartLineNumber=function(){return this._linesCollection.getStartLineNumber()},e.prototype.getEndLineNumber=function(){return this._linesCollection.getEndLineNumber()},e.prototype.getVisibleLine=function(e){return this._linesCollection.getLine(e)},e.prototype.renderLines=function(e){var t=this._linesCollection._get(),i=new s(this.domNode.domNode,this._host,e),n={
rendLineNumberStart:t.rendLineNumberStart,lines:t.lines,linesLength:t.lines.length},o=i.render(n,e.startLineNumber,e.endLineNumber,e.relativeVerticalOffset);this._linesCollection._set(o.rendLineNumberStart,o.lines)},e}();t.VisibleLinesCollection=r;var s=function(){function e(e,t,i){this.domNode=e,this.host=t,this.viewportData=i}return e.prototype.render=function(e,t,i,n){var o={rendLineNumberStart:e.rendLineNumberStart,lines:e.lines.slice(0),linesLength:e.linesLength};if(o.rendLineNumberStart+o.linesLength-1<t||i<o.rendLineNumberStart){o.rendLineNumberStart=t,o.linesLength=i-t+1,o.lines=[];for(var r=t;r<=i;r++)o.lines[r-t]=this.host.createVisibleLine();return this._finishRendering(o,!0,n),o}if(this._renderUntouchedLines(o,Math.max(t-o.rendLineNumberStart,0),Math.min(i-o.rendLineNumberStart,o.linesLength-1),n,t),o.rendLineNumberStart>t){(s=t)<=(a=Math.min(i,o.rendLineNumberStart-1))&&(this._insertLinesBefore(o,s,a,n,t),o.linesLength+=a-s+1)}else if(o.rendLineNumberStart<t){
(l=Math.min(o.linesLength,t-o.rendLineNumberStart))>0&&(this._removeLinesBefore(o,l),o.linesLength-=l)}if(o.rendLineNumberStart=t,o.rendLineNumberStart+o.linesLength-1<i){(s=o.rendLineNumberStart+o.linesLength)<=(a=i)&&(this._insertLinesAfter(o,s,a,n,t),o.linesLength+=a-s+1)}else if(o.rendLineNumberStart+o.linesLength-1>i){var s=Math.max(0,i-o.rendLineNumberStart+1),a=o.linesLength-1,l=a-s+1;l>0&&(this._removeLinesAfter(o,l),o.linesLength-=l)}return this._finishRendering(o,!1,n),o},e.prototype._renderUntouchedLines=function(e,t,i,n,o){for(var r=e.rendLineNumberStart,s=e.lines,a=t;a<=i;a++){var l=r+a;s[a].layoutLine(l,n[l-o])}},e.prototype._insertLinesBefore=function(e,t,i,n,o){for(var r=[],s=0,a=t;a<=i;a++)r[s++]=this.host.createVisibleLine();e.lines=r.concat(e.lines)},e.prototype._removeLinesBefore=function(e,t){for(var i=0;i<t;i++){var n=e.lines[i].getDomNode();n&&this.domNode.removeChild(n)}e.lines.splice(0,t)},e.prototype._insertLinesAfter=function(e,t,i,n,o){
for(var r=[],s=0,a=t;a<=i;a++)r[s++]=this.host.createVisibleLine();e.lines=e.lines.concat(r)},e.prototype._removeLinesAfter=function(e,t){for(var i=e.linesLength-t,n=0;n<t;n++){var o=e.lines[i+n].getDomNode();o&&this.domNode.removeChild(o)}e.lines.splice(i,t)},e.prototype._finishRenderingNewLines=function(e,t,i,n){var o=this.domNode.lastChild;t||!o?this.domNode.innerHTML=i:o.insertAdjacentHTML("afterend",i);for(var r=this.domNode.lastChild,s=e.linesLength-1;s>=0;s--){var a=e.lines[s];n[s]&&(a.setDomNode(r),r=r.previousSibling)}},e.prototype._finishRenderingInvalidLines=function(e,t,i){var n=document.createElement("div");n.innerHTML=t;for(var o=0;o<e.linesLength;o++){var r=e.lines[o];if(i[o]){var s=n.firstChild,a=r.getDomNode();a.parentNode.replaceChild(s,a),r.setDomNode(s)}}},e.prototype._finishRendering=function(t,i,n){var o=e._sb,r=t.linesLength,s=t.lines,a=t.rendLineNumberStart,l=[];o.reset();for(var u=!1,d=0;d<r;d++){p=s[d];l[d]=!1;if(!p.getDomNode()){
(f=p.renderLine(d+a,n[d],this.viewportData,o))&&(l[d]=!0,u=!0)}}u&&this._finishRenderingNewLines(t,i,o.build(),l),o.reset();for(var c=!1,h=[],d=0;d<r;d++){var p=s[d];if(h[d]=!1,!l[d]){var f=p.renderLine(d+a,n[d],this.viewportData,o);f&&(h[d]=!0,c=!0)}}c&&this._finishRenderingInvalidLines(t,o.build(),h)},e._sb=n.createStringBuilder(1e5),e}()}),define(t[106],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i){this.offset=0|e,this.type=t,this.language=i}return e.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},e}();t.Token=i;var n=function(){return function(e,t){this.tokens=e,this.endState=t}}();t.TokenizationResult=n;var o=function(){return function(e,t){this.tokens=e,this.endState=t}}();t.TokenizationResult2=o}),define(t[105],i([1,0]),function(e,t){"use strict";function i(e){return e<0?0:e>4294967295?4294967295:0|e}Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i){
for(var n=new Uint8Array(e*t),o=0,r=e*t;o<r;o++)n[o]=i;this._data=n,this.rows=e,this.cols=t}return e.prototype.get=function(e,t){return this._data[e*this.cols+t]},e.prototype.set=function(e,t,i){this._data[e*this.cols+t]=i},e}();t.Uint8Matrix=n,t.toUint8=function(e){return e<0?0:e>255?255:0|e},t.toUint32=i,t.toUint32Array=function(e){for(var t=e.length,n=new Uint32Array(t),o=0;o<t;o++)n[o]=i(e[o]);return n}}),define(t[80],i([1,0,105]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(t){var n=i.toUint8(t);this._defaultValue=n,this._asciiMap=e._createAsciiMap(n),this._map=new Map}return e._createAsciiMap=function(e){for(var t=new Uint8Array(256),i=0;i<256;i++)t[i]=e;return t},e.prototype.set=function(e,t){var n=i.toUint8(t);e>=0&&e<256?this._asciiMap[e]=n:this._map.set(e,n)},e.prototype.get=function(e){return e>=0&&e<256?this._asciiMap[e]:this._map.get(e)||this._defaultValue},e}();t.CharacterClassifier=n;var o=function(){function e(){this._actual=new n(0)
}return e.prototype.add=function(e){this._actual.set(e,1)},e.prototype.has=function(e){return 1===this._actual.get(e)},e}();t.CharacterSet=o}),define(t[86],i([1,0,80]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(t){for(var i=e.call(this,0)||this,n=0,o=t.length;n<o;n++)i.set(t.charCodeAt(n),2);return i.set(32,1),i.set(9,1),i}return r(t,e),t}(i.CharacterClassifier);t.WordCharacterClassifier=n,t.getMapForWordSeparators=function(e){var t={};return function(i){return t.hasOwnProperty(i)||(t[i]=e(i)),t[i]}}(function(e){return new n(e)})}),define(t[281],i([1,0,125,5]),function(e,t,i,n){"use strict";function o(e,t,n,o){return new i.LcsDiff(e,t,n).ComputeDiff(o)}Object.defineProperty(t,"__esModule",{value:!0});var r=5e3,s=3,a=function(){function e(t){for(var i=[],n=[],o=0,r=t.length;o<r;o++)i[o]=e._getFirstNonBlankColumn(t[o],1),n[o]=e._getLastNonBlankColumn(t[o],1);this._lines=t,this._startColumns=i,this._endColumns=n}
return e.prototype.getLength=function(){return this._lines.length},e.prototype.getElementAtIndex=function(e){return this._lines[e].substring(this._startColumns[e]-1,this._endColumns[e]-1)},e.prototype.getStartLineNumber=function(e){return e+1},e.prototype.getEndLineNumber=function(e){return e+1},e._getFirstNonBlankColumn=function(e,t){var i=n.firstNonWhitespaceIndex(e);return-1===i?t:i+1},e._getLastNonBlankColumn=function(e,t){var i=n.lastNonWhitespaceIndex(e);return-1===i?t:i+2},e.prototype.getCharSequence=function(e,t,i){for(var n=[],o=[],r=[],s=0,a=t;a<=i;a++)for(var u=this._lines[a],d=e?this._startColumns[a]:1,c=e?this._endColumns[a]:u.length+1,h=d;h<c;h++)n[s]=u.charCodeAt(h-1),o[s]=a+1,r[s]=h,s++;return new l(n,o,r)},e}(),l=function(){function e(e,t,i){this._charCodes=e,this._lineNumbers=t,this._columns=i}return e.prototype.getLength=function(){return this._charCodes.length},e.prototype.getElementAtIndex=function(e){return this._charCodes[e]},e.prototype.getStartLineNumber=function(e){
return this._lineNumbers[e]},e.prototype.getStartColumn=function(e){return this._columns[e]},e.prototype.getEndLineNumber=function(e){return this._lineNumbers[e]},e.prototype.getEndColumn=function(e){return this._columns[e]+1},e}(),u=function(){function e(e,t,i,n,o,r,s,a){this.originalStartLineNumber=e,this.originalStartColumn=t,this.originalEndLineNumber=i,this.originalEndColumn=n,this.modifiedStartLineNumber=o,this.modifiedStartColumn=r,this.modifiedEndLineNumber=s,this.modifiedEndColumn=a}return e.createFromDiffChange=function(t,i,n){var o,r,s,a,l,u,d,c;return 0===t.originalLength?(o=0,r=0,s=0,a=0):(o=i.getStartLineNumber(t.originalStart),r=i.getStartColumn(t.originalStart),s=i.getEndLineNumber(t.originalStart+t.originalLength-1),a=i.getEndColumn(t.originalStart+t.originalLength-1)),0===t.modifiedLength?(l=0,u=0,d=0,c=0):(l=n.getStartLineNumber(t.modifiedStart),u=n.getStartColumn(t.modifiedStart),d=n.getEndLineNumber(t.modifiedStart+t.modifiedLength-1),c=n.getEndColumn(t.modifiedStart+t.modifiedLength-1)),
new e(o,r,s,a,l,u,d,c)},e}(),d=function(){function e(e,t,i,n,o){this.originalStartLineNumber=e,this.originalEndLineNumber=t,this.modifiedStartLineNumber=i,this.modifiedEndLineNumber=n,this.charChanges=o}return e.createFromDiffResult=function(t,i,n,r,a,l,d){var c,h,p,f,g=void 0;if(0===i.originalLength?(c=n.getStartLineNumber(i.originalStart)-1,h=0):(c=n.getStartLineNumber(i.originalStart),h=n.getEndLineNumber(i.originalStart+i.originalLength-1)),0===i.modifiedLength?(p=r.getStartLineNumber(i.modifiedStart)-1,f=0):(p=r.getStartLineNumber(i.modifiedStart),f=r.getEndLineNumber(i.modifiedStart+i.modifiedLength-1)),l&&0!==i.originalLength&&0!==i.modifiedLength&&a()){var m=n.getCharSequence(t,i.originalStart,i.originalStart+i.originalLength-1),v=r.getCharSequence(t,i.modifiedStart,i.modifiedStart+i.modifiedLength-1),_=o(m,v,a,!0);d&&(_=function(e){if(e.length<=1)return e;for(var t=[e[0]],i=t[0],n=1,o=e.length;n<o;n++){
var r=e[n],a=r.originalStart-(i.originalStart+i.originalLength),l=r.modifiedStart-(i.modifiedStart+i.modifiedLength);Math.min(a,l)<s?(i.originalLength=r.originalStart+r.originalLength-i.originalStart,i.modifiedLength=r.modifiedStart+r.modifiedLength-i.modifiedStart):(t.push(r),i=r)}return t}(_)),g=[];for(var y=0,b=_.length;y<b;y++)g.push(u.createFromDiffChange(_[y],m,v))}return new e(c,h,p,f,g)},e}(),c=function(){function e(e,t,i){this.shouldComputeCharChanges=i.shouldComputeCharChanges,this.shouldPostProcessCharChanges=i.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=i.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=i.shouldMakePrettyDiff,this.maximumRunTimeMs=r,this.originalLines=e,this.modifiedLines=t,this.original=new a(e),this.modified=new a(t),this.computationStartTime=(new Date).getTime()}return e.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,
modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var e=o(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){
for(var t=[],i=0,n=e.length;i<n;i++)t.push(d.createFromDiffResult(this.shouldIgnoreTrimWhitespace,e[i],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return t}for(var r=[],s=0,l=0,i=-1,u=e.length;i<u;i++){for(var c=i+1<u?e[i+1]:null,h=c?c.originalStart:this.originalLines.length,p=c?c.modifiedStart:this.modifiedLines.length;s<h&&l<p;){var f=this.originalLines[s],g=this.modifiedLines[l];if(f!==g){for(var m=a._getFirstNonBlankColumn(f,1),v=a._getFirstNonBlankColumn(g,1);m>1&&v>1;){if((S=f.charCodeAt(m-2))!==(w=g.charCodeAt(v-2)))break;m--,v--}(m>1||v>1)&&this._pushTrimWhitespaceCharChange(r,s+1,1,m,l+1,1,v);for(var _=a._getLastNonBlankColumn(f,1),y=a._getLastNonBlankColumn(g,1),b=f.length+1,C=g.length+1;_<b&&y<C;){var S=f.charCodeAt(_-1),w=f.charCodeAt(y-1);if(S!==w)break;_++,y++}(_<b||y<C)&&this._pushTrimWhitespaceCharChange(r,s+1,_,b,l+1,y,C)}s++,l++}
c&&(r.push(d.createFromDiffResult(this.shouldIgnoreTrimWhitespace,c,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),s+=c.originalLength,l+=c.modifiedLength)}return r},e.prototype._pushTrimWhitespaceCharChange=function(e,t,i,n,o,r,s){if(!this._mergeTrimWhitespaceCharChange(e,t,i,n,o,r,s)){var a=void 0;this.shouldComputeCharChanges&&(a=[new u(t,i,t,n,o,r,o,s)]),e.push(new d(t,t,o,o,a))}},e.prototype._mergeTrimWhitespaceCharChange=function(e,t,i,n,o,r,s){var a=e.length;if(0===a)return!1;var l=e[a-1];return 0!==l.originalEndLineNumber&&0!==l.modifiedEndLineNumber&&(l.originalEndLineNumber+1===t&&l.modifiedEndLineNumber+1===o&&(l.originalEndLineNumber=t,l.modifiedEndLineNumber=o,this.shouldComputeCharChanges&&l.charChanges.push(new u(t,i,t,n,o,r,o,s)),!0))},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;return(new Date).getTime()-this.computationStartTime<this.maximumRunTimeMs},e}()
;t.DiffComputer=c}),define(t[168],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i,n,o,r){this.id=e,this.label=t,this.alias=i,this._precondition=n,this._run=o,this._contextKeyService=r}return e.prototype.isSupported=function(){return this._contextKeyService.contextMatchesRules(this._precondition)},e.prototype.run=function(){if(!this.isSupported())return Promise.resolve(void 0);var e=this._run();return e||Promise.resolve(void 0)},e}();t.InternalEditorAction=i}),define(t[72],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isThemeColor=function(e){return e&&"string"==typeof e.id},t.EditorType={ICodeEditor:"vs.editor.ICodeEditor",IDiffEditor:"vs.editor.IDiffEditor"},t.Handler={ExecuteCommand:"executeCommand",ExecuteCommands:"executeCommands",Type:"type",ReplacePreviousChar:"replacePreviousChar",CompositionStart:"compositionStart",CompositionEnd:"compositionEnd",Paste:"paste",Cut:"cut",Undo:"undo",
Redo:"redo"}}),define(t[101],i([1,0,72]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isCodeEditor=function(e){return!(!e||"function"!=typeof e.getEditorType)&&e.getEditorType()===i.EditorType.ICodeEditor}}),define(t[49],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(t.OverviewRulerLane||(t.OverviewRulerLane={}));!function(e){e[e.Inline=1]="Inline"}(t.MinimapPosition||(t.MinimapPosition={}));var i=function(){function e(e){this.tabSize=0|e.tabSize,this.indentSize=0|e.tabSize,this.insertSpaces=Boolean(e.insertSpaces),this.defaultEOL=0|e.defaultEOL,this.trimAutoWhitespace=Boolean(e.trimAutoWhitespace)}return e.prototype.equals=function(e){return this.tabSize===e.tabSize&&this.indentSize===e.indentSize&&this.insertSpaces===e.insertSpaces&&this.defaultEOL===e.defaultEOL&&this.trimAutoWhitespace===e.trimAutoWhitespace},
e.prototype.createChangeEvent=function(e){return{tabSize:this.tabSize!==e.tabSize,indentSize:this.indentSize!==e.indentSize,insertSpaces:this.insertSpaces!==e.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==e.trimAutoWhitespace}},e}();t.TextModelResolvedOptions=i;var n=function(){return function(e,t){this.range=e,this.matches=t}}();t.FindMatch=n;var o=function(){return function(e,t,i){this.reverseEdits=e,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}();t.ApplyEditsResult=o}),define(t[380],i([1,0,10]),function(e,t,i){"use strict";function n(e){return"\n"===e.getEOL()?0:1}Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t){this.beforeVersionId=e,this.beforeCursorState=t,this.afterCursorState=null,this.afterVersionId=-1,this.editOperations=[]}return e.prototype.undo=function(e){for(var t=this.editOperations.length-1;t>=0;t--)this.editOperations[t]={operations:e.applyEdits(this.editOperations[t].operations)}},e.prototype.redo=function(e){
for(var t=0;t<this.editOperations.length;t++)this.editOperations[t]={operations:e.applyEdits(this.editOperations[t].operations)}},e}(),r=function(){function e(e,t){this.beforeVersionId=e,this.beforeCursorState=null,this.afterCursorState=null,this.afterVersionId=-1,this.eol=t}return e.prototype.undo=function(e){var t=n(e);e.setEOL(this.eol),this.eol=t},e.prototype.redo=function(e){var t=n(e);e.setEOL(this.eol),this.eol=t},e}(),s=function(){function e(e){this.model=e,this.currentOpenStackElement=null,this.past=[],this.future=[]}return e.prototype.pushStackElement=function(){null!==this.currentOpenStackElement&&(this.past.push(this.currentOpenStackElement),this.currentOpenStackElement=null)},e.prototype.clear=function(){this.currentOpenStackElement=null,this.past=[],this.future=[]},e.prototype.pushEOL=function(e){this.future=[],this.currentOpenStackElement&&this.pushStackElement();var t=n(this.model),i=new r(this.model.getAlternativeVersionId(),t);this.model.setEOL(e),i.afterVersionId=this.model.getVersionId(),
this.currentOpenStackElement=i,this.pushStackElement()},e.prototype.pushEditOperation=function(t,i,n){this.future=[];var r=null;this.currentOpenStackElement&&(this.currentOpenStackElement instanceof o?r=this.currentOpenStackElement:this.pushStackElement()),this.currentOpenStackElement||(r=new o(this.model.getAlternativeVersionId(),t),this.currentOpenStackElement=r);var s={operations:this.model.applyEdits(i)};return r.editOperations.push(s),r.afterCursorState=e._computeCursorState(n,s.operations),r.afterVersionId=this.model.getVersionId(),r.afterCursorState},e._computeCursorState=function(e,t){try{return e?e(t):null}catch(e){return i.onUnexpectedError(e),null}},e.prototype.undo=function(){if(this.pushStackElement(),this.past.length>0){var e=this.past.pop();try{e.undo(this.model)}catch(e){return i.onUnexpectedError(e),this.clear(),null}return this.future.push(e),{selections:e.beforeCursorState,recordedVersionId:e.beforeVersionId}}return null},e.prototype.canUndo=function(){
return this.past.length>0||null!==this.currentOpenStackElement},e.prototype.redo=function(){if(this.future.length>0){var e=this.future.pop();try{e.redo(this.model)}catch(e){return i.onUnexpectedError(e),this.clear(),null}return this.past.push(e),{selections:e.afterCursorState,recordedVersionId:e.afterVersionId}}return null},e.prototype.canRedo=function(){return this.future.length>0},e}();t.EditStack=s}),define(t[386],i([1,0]),function(e,t){"use strict";function i(e,t,i,n,o){o.spacesDiff=0,o.looksLikeAlignment=!1;var r;for(r=0;r<t&&r<n;r++){if((u=e.charCodeAt(r))!==(h=i.charCodeAt(r)))break}for(var s=0,a=0,l=r;l<t;l++){var u=e.charCodeAt(l);32===u?s++:a++}for(var d=0,c=0,l=r;l<n;l++){var h=i.charCodeAt(l);32===h?d++:c++}if(!(s>0&&a>0||d>0&&c>0)){var p=Math.abs(a-c),f=Math.abs(s-d);if(0===p)return o.spacesDiff=f,void(f>0&&0<=d-1&&d-1<e.length&&d<i.length&&32!==i.charCodeAt(d)&&32===e.charCodeAt(d-1)&&(o.looksLikeAlignment=!0));f%p!=0||(o.spacesDiff=f/p)}}Object.defineProperty(t,"__esModule",{value:!0})
;var n=function(){return function(){this.spacesDiff=0,this.looksLikeAlignment=!1}}();t.guessIndentation=function(e,t,o){for(var r=Math.min(e.getLineCount(),1e4),s=0,a=0,l="",u=0,d=[2,4,6,8,3,5,7],c=[0,0,0,0,0,0,0,0,0],h=new n,p=1;p<=r;p++){for(var f=e.getLineLength(p),g=e.getLineContent(p),m=f<=65536,v=!1,_=0,y=0,b=0,C=0,S=f;C<S;C++){var w=m?g.charCodeAt(C):e.getLineCharCode(p,C);if(9===w)b++;else{if(32!==w){v=!0,_=C;break}y++}}if(v&&(b>0?s++:y>1&&a++,i(l,u,g,_,h),!h.looksLikeAlignment||o&&t===h.spacesDiff)){var E=h.spacesDiff;E<=8&&c[E]++,l=g,u=_}}var L=o;s!==a&&(L=s<a);var x=t;if(L){var D=L?0:.1*r;d.forEach(function(e){var t=c[e];t>D&&(D=t,x=e)}),4===x&&c[4]>0&&c[2]>0&&c[2]>=c[4]/2&&(x=2)}return{insertSpaces:L,tabSize:x}}}),define(t[391],i([1,0]),function(e,t){"use strict";function i(e){return(1&e.metadata)>>>0}function n(e,t){e.metadata=254&e.metadata|t<<0}function o(e){return(2&e.metadata)>>>1==1}function r(e,t){e.metadata=253&e.metadata|(t?1:0)<<1}function s(e){return(4&e.metadata)>>>2==1}
function a(e,t){e.metadata=251&e.metadata|(t?1:0)<<2}function l(e,t){e.metadata=247&e.metadata|(t?1:0)<<3}function u(e,t){e.metadata=207&e.metadata|t<<4}function d(e,t){e.metadata=191&e.metadata|(t?1:0)<<6}function c(e,t,i,n){return e<i||!(e>i)&&(1!==n&&(2===n||t))}function h(e,t,i,n,o){var r=function(e){return(48&e.metadata)>>>4}(e),s=0===r||2===r,a=1===r||2===r,l=i-t,u=n,d=Math.min(l,u),h=e.start,p=!1,f=e.end,g=!1;t<=h&&f<=i&&function(e){return(64&e.metadata)>>>6==1}(e)&&(e.start=t,p=!0,e.end=t,g=!0);m=o?1:l>0?2:0;if(!p&&c(h,s,t,m)&&(p=!0),!g&&c(f,a,t,m)&&(g=!0),d>0&&!o){m=l>u?2:0;!p&&c(h,s,t+d,m)&&(p=!0),!g&&c(f,a,t+d,m)&&(g=!0)}var m=o?1:0;!p&&c(h,s,i,m)&&(e.start=t+u,p=!0),!g&&c(f,a,i,m)&&(e.end=t+u,g=!0);var v=u-l;p||(e.start=Math.max(0,h+v)),g||(e.end=Math.max(0,f+v)),e.start>e.end&&(e.end=e.start)}function p(e,o){if(e.root===t.SENTINEL)return o.parent=t.SENTINEL,o.left=t.SENTINEL,o.right=t.SENTINEL,n(o,0),e.root=o,e.root;!function(e,i){var o=0,r=e.root,s=i.start,a=i.end;for(;;){
if(C(s,a,r.start+o,r.end+o)<0){if(r.left===t.SENTINEL){i.start-=o,i.end-=o,i.maxEnd-=o,r.left=i;break}r=r.left}else{if(r.right===t.SENTINEL){i.start-=o+r.delta,i.end-=o+r.delta,i.maxEnd-=o+r.delta,r.right=i;break}o+=r.delta,r=r.right}}i.parent=r,i.left=t.SENTINEL,i.right=t.SENTINEL,n(i,1)}(e,o),b(o.parent);for(var r=o;r!==e.root&&1===i(r.parent);)if(r.parent===r.parent.parent.left){1===i(s=r.parent.parent.right)?(n(r.parent,0),n(s,0),n(r.parent.parent,1),r=r.parent.parent):(r===r.parent.right&&m(e,r=r.parent),n(r.parent,0),n(r.parent.parent,1),v(e,r.parent.parent))}else{var s=r.parent.parent.left;1===i(s)?(n(r.parent,0),n(s,0),n(r.parent.parent,1),r=r.parent.parent):(r===r.parent.left&&v(e,r=r.parent),n(r.parent,0),n(r.parent.parent,1),m(e,r.parent.parent))}return n(e.root,0),o}function f(e,o){var r,s;if(o.left===t.SENTINEL?(s=o,(r=o.right).delta+=o.delta,(r.delta<-1073741824||r.delta>1073741824)&&(e.requestNormalizeDelta=!0),r.start+=o.delta,r.end+=o.delta):o.right===t.SENTINEL?(r=o.left,
s=o):((r=(s=function(e){for(;e.left!==t.SENTINEL;)e=e.left;return e}(o.right)).right).start+=s.delta,r.end+=s.delta,r.delta+=s.delta,(r.delta<-1073741824||r.delta>1073741824)&&(e.requestNormalizeDelta=!0),s.start+=o.delta,s.end+=o.delta,s.delta=o.delta,(s.delta<-1073741824||s.delta>1073741824)&&(e.requestNormalizeDelta=!0)),s===e.root)return e.root=r,n(r,0),o.detach(),g(),y(r),void(e.root.parent=t.SENTINEL);var a=1===i(s);if(s===s.parent.left?s.parent.left=r:s.parent.right=r,s===o?r.parent=s.parent:(s.parent===o?r.parent=s:r.parent=s.parent,s.left=o.left,s.right=o.right,s.parent=o.parent,n(s,i(o)),o===e.root?e.root=s:o===o.parent.left?o.parent.left=s:o.parent.right=s,s.left!==t.SENTINEL&&(s.left.parent=s),s.right!==t.SENTINEL&&(s.right.parent=s)),o.detach(),a)return b(r.parent),s!==o&&(b(s),b(s.parent)),void g();b(r),b(r.parent),s!==o&&(b(s),b(s.parent));for(var l;r!==e.root&&0===i(r);)r===r.parent.left?(1===i(l=r.parent.right)&&(n(l,0),n(r.parent,1),m(e,r.parent),l=r.parent.right),
0===i(l.left)&&0===i(l.right)?(n(l,1),r=r.parent):(0===i(l.right)&&(n(l.left,0),n(l,1),v(e,l),l=r.parent.right),n(l,i(r.parent)),n(r.parent,0),n(l.right,0),m(e,r.parent),r=e.root)):(1===i(l=r.parent.left)&&(n(l,0),n(r.parent,1),v(e,r.parent),l=r.parent.left),0===i(l.left)&&0===i(l.right)?(n(l,1),r=r.parent):(0===i(l.left)&&(n(l.right,0),n(l,1),m(e,l),l=r.parent.left),n(l,i(r.parent)),n(r.parent,0),n(l.left,0),v(e,r.parent),r=e.root));n(r,0),g()}function g(){t.SENTINEL.parent=t.SENTINEL,t.SENTINEL.delta=0,t.SENTINEL.start=0,t.SENTINEL.end=0}function m(e,i){var n=i.right;n.delta+=i.delta,(n.delta<-1073741824||n.delta>1073741824)&&(e.requestNormalizeDelta=!0),n.start+=i.delta,n.end+=i.delta,i.right=n.left,n.left!==t.SENTINEL&&(n.left.parent=i),n.parent=i.parent,i.parent===t.SENTINEL?e.root=n:i===i.parent.left?i.parent.left=n:i.parent.right=n,n.left=i,i.parent=n,y(i),y(n)}function v(e,i){var n=i.left;i.delta-=n.delta,(i.delta<-1073741824||i.delta>1073741824)&&(e.requestNormalizeDelta=!0),i.start-=n.delta,
i.end-=n.delta,i.left=n.right,n.right!==t.SENTINEL&&(n.right.parent=i),n.parent=i.parent,i.parent===t.SENTINEL?e.root=n:i===i.parent.right?i.parent.right=n:i.parent.left=n,n.right=i,i.parent=n,y(i),y(n)}function _(e){var i=e.end;if(e.left!==t.SENTINEL){var n=e.left.maxEnd;n>i&&(i=n)}if(e.right!==t.SENTINEL){var o=e.right.maxEnd+e.delta;o>i&&(i=o)}return i}function y(e){e.maxEnd=_(e)}function b(e){for(;e!==t.SENTINEL;){var i=_(e);if(e.maxEnd===i)return;e.maxEnd=i,e=e.parent}}function C(e,t,i,n){return e===i?t-n:e-i}Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeColor=i,t.getNodeIsInOverviewRuler=function(e){return(8&e.metadata)>>>3==1};var S=function(){function e(e,t,i){this.metadata=0,this.parent=this,this.left=this,this.right=this,n(this,1),this.start=t,this.end=i,this.delta=0,this.maxEnd=i,this.id=e,this.ownerId=0,this.options=null,a(this,!1),u(this,1),l(this,!1),d(this,!1),this.cachedVersionId=0,this.cachedAbsoluteStart=t,this.cachedAbsoluteEnd=i,this.range=null,r(this,!1)}
return e.prototype.reset=function(e,t,i,n){this.start=t,this.end=i,this.maxEnd=i,this.cachedVersionId=e,this.cachedAbsoluteStart=t,this.cachedAbsoluteEnd=i,this.range=n},e.prototype.setOptions=function(e){this.options=e;var t=this.options.className;a(this,"squiggly-error"===t||"squiggly-warning"===t||"squiggly-info"===t),u(this,this.options.stickiness),l(this,!(!this.options.overviewRuler||!this.options.overviewRuler.color)),d(this,this.options.collapseOnReplaceEdit)},e.prototype.setCachedOffsets=function(e,t,i){this.cachedVersionId!==i&&(this.range=null),this.cachedVersionId=i,this.cachedAbsoluteStart=e,this.cachedAbsoluteEnd=t},e.prototype.detach=function(){this.parent=null,this.left=null,this.right=null},e}();t.IntervalNode=S,t.SENTINEL=new S(null,0,0),t.SENTINEL.parent=t.SENTINEL,t.SENTINEL.left=t.SENTINEL,t.SENTINEL.right=t.SENTINEL,n(t.SENTINEL,0);var w=function(){function e(){this.root=t.SENTINEL,this.requestNormalizeDelta=!1}return e.prototype.intervalSearch=function(e,i,n,a,l){
return this.root===t.SENTINEL?[]:function(e,i,n,a,l,u){for(var d=e.root,c=0,h=0,p=0,f=[],g=0;d!==t.SENTINEL;)if(o(d))r(d.left,!1),r(d.right,!1),d===d.parent.right&&(c-=d.parent.delta),d=d.parent;else{if(!o(d.left)){if(c+d.maxEnd<i){r(d,!0);continue}if(d.left!==t.SENTINEL){d=d.left;continue}}if((h=c+d.start)>n)r(d,!0);else{if((p=c+d.end)>=i){d.setCachedOffsets(h,p,u);var m=!0;a&&d.ownerId&&d.ownerId!==a&&(m=!1),l&&s(d)&&(m=!1),m&&(f[g++]=d)}r(d,!0),d.right===t.SENTINEL||o(d.right)||(c+=d.delta,d=d.right)}}return r(e.root,!1),f}(this,e,i,n,a,l)},e.prototype.search=function(e,i,n){return this.root===t.SENTINEL?[]:function(e,i,n,a){for(var l=e.root,u=0,d=0,c=0,h=[],p=0;l!==t.SENTINEL;)if(o(l))r(l.left,!1),r(l.right,!1),l===l.parent.right&&(u-=l.parent.delta),l=l.parent;else if(l.left===t.SENTINEL||o(l.left)){d=u+l.start,c=u+l.end,l.setCachedOffsets(d,c,a);var f=!0;i&&l.ownerId&&l.ownerId!==i&&(f=!1),n&&s(l)&&(f=!1),f&&(h[p++]=l),r(l,!0),l.right===t.SENTINEL||o(l.right)||(u+=l.delta,l=l.right)}else l=l.left
;return r(e.root,!1),h}(this,e,i,n)},e.prototype.collectNodesFromOwner=function(e){return function(e,i){for(var n=e.root,s=[],a=0;n!==t.SENTINEL;)o(n)?(r(n.left,!1),r(n.right,!1),n=n.parent):n.left===t.SENTINEL||o(n.left)?(n.ownerId===i&&(s[a++]=n),r(n,!0),n.right===t.SENTINEL||o(n.right)||(n=n.right)):n=n.left;return r(e.root,!1),s}(this,e)},e.prototype.collectNodesPostOrder=function(){return function(e){for(var i=e.root,n=[],s=0;i!==t.SENTINEL;)o(i)?(r(i.left,!1),r(i.right,!1),i=i.parent):i.left===t.SENTINEL||o(i.left)?i.right===t.SENTINEL||o(i.right)?(n[s++]=i,r(i,!0)):i=i.right:i=i.left;return r(e.root,!1),n}(this)},e.prototype.insert=function(e){p(this,e),this._normalizeDeltaIfNecessary()},e.prototype.delete=function(e){f(this,e),this._normalizeDeltaIfNecessary()},e.prototype.resolveNode=function(e,t){for(var i=e,n=0;e!==this.root;)e===e.parent.right&&(n+=e.parent.delta),e=e.parent;var o=i.start+n,r=i.end+n;i.setCachedOffsets(o,r,t)},e.prototype.acceptReplace=function(e,i,n,s){for(var a=function(e,i,n){
for(var s=e.root,a=0,l=0,u=0,d=[],c=0;s!==t.SENTINEL;)if(o(s))r(s.left,!1),r(s.right,!1),s===s.parent.right&&(a-=s.parent.delta),s=s.parent;else{if(!o(s.left)){if(a+s.maxEnd<i){r(s,!0);continue}if(s.left!==t.SENTINEL){s=s.left;continue}}(l=a+s.start)>n?r(s,!0):((u=a+s.end)>=i&&(s.setCachedOffsets(l,u,0),d[c++]=s),r(s,!0),s.right===t.SENTINEL||o(s.right)||(a+=s.delta,s=s.right))}return r(e.root,!1),d}(this,e,e+i),l=0,u=a.length;l<u;l++){f(this,d=a[l])}this._normalizeDeltaIfNecessary(),function(e,i,n,s){for(var a=e.root,l=0,u=s-(n-i);a!==t.SENTINEL;)if(o(a))r(a.left,!1),r(a.right,!1),a===a.parent.right&&(l-=a.parent.delta),y(a),a=a.parent;else{if(!o(a.left)){if(l+a.maxEnd<i){r(a,!0);continue}if(a.left!==t.SENTINEL){a=a.left;continue}}l+a.start>n?(a.start+=u,a.end+=u,a.delta+=u,(a.delta<-1073741824||a.delta>1073741824)&&(e.requestNormalizeDelta=!0),r(a,!0)):(r(a,!0),a.right===t.SENTINEL||o(a.right)||(l+=a.delta,a=a.right))}r(e.root,!1)}(this,e,e+i,n),this._normalizeDeltaIfNecessary()
;for(var l=0,u=a.length;l<u;l++){var d=a[l];d.start=d.cachedAbsoluteStart,d.end=d.cachedAbsoluteEnd,h(d,e,e+i,n,s),d.maxEnd=d.end,p(this,d)}this._normalizeDeltaIfNecessary()},e.prototype._normalizeDeltaIfNecessary=function(){this.requestNormalizeDelta&&(this.requestNormalizeDelta=!1,function(e){for(var i=e.root,n=0;i!==t.SENTINEL;)i.left===t.SENTINEL||o(i.left)?i.right===t.SENTINEL||o(i.right)?(i.start=n+i.start,i.end=n+i.end,i.delta=0,y(i),r(i,!0),r(i.left,!1),r(i.right,!1),i===i.parent.right&&(n-=i.parent.delta),i=i.parent):(n+=i.delta,i=i.right):i=i.left;r(e.root,!1)}(this))},e}();t.IntervalTree=w,t.nodeAcceptEdit=h,t.recomputeMaxEnd=y,t.intervalCompare=C}),define(t[393],i([1,0]),function(e,t){"use strict";function i(e){for(;e.left!==t.SENTINEL;)e=e.left;return e}function n(e){for(;e.right!==t.SENTINEL;)e=e.right;return e}function o(e){return e===t.SENTINEL?0:e.size_left+e.piece.length+o(e.right)}function r(e){return e===t.SENTINEL?0:e.lf_left+e.piece.lineFeedCnt+r(e.right)}function s(){
t.SENTINEL.parent=t.SENTINEL}function a(e,i){var n=i.right;n.size_left+=i.size_left+(i.piece?i.piece.length:0),n.lf_left+=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),i.right=n.left,n.left!==t.SENTINEL&&(n.left.parent=i),n.parent=i.parent,i.parent===t.SENTINEL?e.root=n:i.parent.left===i?i.parent.left=n:i.parent.right=n,n.left=i,i.parent=n}function l(e,i){var n=i.left;i.left=n.right,n.right!==t.SENTINEL&&(n.right.parent=i),n.parent=i.parent,i.size_left-=n.size_left+(n.piece?n.piece.length:0),i.lf_left-=n.lf_left+(n.piece?n.piece.lineFeedCnt:0),i.parent===t.SENTINEL?e.root=n:i===i.parent.right?i.parent.right=n:i.parent.left=n,n.right=i,i.parent=n}function u(e,i,n,o){for(;i!==e.root&&i!==t.SENTINEL;)i.parent.left===i&&(i.parent.size_left+=n,i.parent.lf_left+=o),i=i.parent}function d(e,t){var i=0,n=0;if(t!==e.root){if(0===i){for(;t!==e.root&&t===t.parent.right;)t=t.parent;if(t===e.root)return;i=o((t=t.parent).left)-t.size_left,n=r(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=n}
for(;t!==e.root&&(0!==i||0!==n);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}}Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(e,t){this.piece=e,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}return e.prototype.next=function(){if(this.right!==t.SENTINEL)return i(this.right);for(var e=this;e.parent!==t.SENTINEL&&e.parent.left!==e;)e=e.parent;return e.parent===t.SENTINEL?t.SENTINEL:e.parent},e.prototype.prev=function(){if(this.left!==t.SENTINEL)return n(this.left);for(var e=this;e.parent!==t.SENTINEL&&e.parent.right!==e;)e=e.parent;return e.parent===t.SENTINEL?t.SENTINEL:e.parent},e.prototype.detach=function(){this.parent=null,this.left=null,this.right=null},e}();t.TreeNode=c,t.SENTINEL=new c(null,0),t.SENTINEL.parent=t.SENTINEL,t.SENTINEL.left=t.SENTINEL,t.SENTINEL.right=t.SENTINEL,t.SENTINEL.color=0,t.leftest=i,t.righttest=n,t.calculateSize=o,t.calculateLF=r,t.resetSentinel=s,t.leftRotate=a,t.rightRotate=l,
t.rbDelete=function(e,n){var c,h;if(c=n.left===t.SENTINEL?(h=n).right:n.right===t.SENTINEL?(h=n).left:(h=i(n.right)).right,h===e.root)return e.root=c,c.color=0,n.detach(),s(),void(e.root.parent=t.SENTINEL);var p=1===h.color;if(h===h.parent.left?h.parent.left=c:h.parent.right=c,h===n?(c.parent=h.parent,d(e,c)):(h.parent===n?c.parent=h:c.parent=h.parent,d(e,c),h.left=n.left,h.right=n.right,h.parent=n.parent,h.color=n.color,n===e.root?e.root=h:n===n.parent.left?n.parent.left=h:n.parent.right=h,h.left!==t.SENTINEL&&(h.left.parent=h),h.right!==t.SENTINEL&&(h.right.parent=h),h.size_left=n.size_left,h.lf_left=n.lf_left,d(e,h)),n.detach(),c.parent.left===c){var f=o(c),g=r(c);if(f!==c.parent.size_left||g!==c.parent.lf_left){var m=f-c.parent.size_left,v=g-c.parent.lf_left;c.parent.size_left=f,c.parent.lf_left=g,u(e,c.parent,m,v)}}if(d(e,c.parent),p)s();else{for(var _;c!==e.root&&0===c.color;)c===c.parent.left?(1===(_=c.parent.right).color&&(_.color=0,c.parent.color=1,a(e,c.parent),_=c.parent.right),
0===_.left.color&&0===_.right.color?(_.color=1,c=c.parent):(0===_.right.color&&(_.left.color=0,_.color=1,l(e,_),_=c.parent.right),_.color=c.parent.color,c.parent.color=0,_.right.color=0,a(e,c.parent),c=e.root)):(1===(_=c.parent.left).color&&(_.color=0,c.parent.color=1,l(e,c.parent),_=c.parent.left),0===_.left.color&&0===_.right.color?(_.color=1,c=c.parent):(0===_.left.color&&(_.right.color=0,_.color=1,a(e,_),_=c.parent.left),_.color=c.parent.color,c.parent.color=0,_.left.color=0,l(e,c.parent),c=e.root));c.color=0,s()}},t.fixInsert=function(e,t){for(d(e,t);t!==e.root&&1===t.parent.color;)if(t.parent===t.parent.parent.left)1===(i=t.parent.parent.right).color?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&a(e,t=t.parent),t.parent.color=0,t.parent.parent.color=1,l(e,t.parent.parent));else{var i=t.parent.parent.left;1===i.color?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&l(e,t=t.parent),t.parent.color=0,
t.parent.parent.color=1,a(e,t.parent.parent))}e.root.color=0},t.updateTreeMetadata=u,t.recomputeTreeMetadata=d}),define(t[394],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){return function(){this.changeType=1}}();t.ModelRawFlush=i;var n=function(){return function(e,t){this.changeType=2,this.lineNumber=e,this.detail=t}}();t.ModelRawLineChanged=n;var o=function(){return function(e,t){this.changeType=3,this.fromLineNumber=e,this.toLineNumber=t}}();t.ModelRawLinesDeleted=o;var r=function(){return function(e,t,i){this.changeType=4,this.fromLineNumber=e,this.toLineNumber=t,this.detail=i}}();t.ModelRawLinesInserted=r;var s=function(){return function(){this.changeType=5}}();t.ModelRawEOLChanged=s;var a=function(){function e(e,t,i,n){this.changes=e,this.versionId=t,this.isUndoing=i,this.isRedoing=n}return e.prototype.containsEvent=function(e){for(var t=0,i=this.changes.length;t<i;t++){if(this.changes[t].changeType===e)return!0}return!1},e.merge=function(t,i){
return new e([].concat(t.changes).concat(i.changes),i.versionId,t.isUndoing||i.isUndoing,t.isRedoing||i.isRedoing)},e}();t.ModelRawContentChangedEvent=a;var l=function(){function e(e,t){this.rawContentChangedEvent=e,this.contentChangedEvent=t}return e.prototype.merge=function(t){return new e(a.merge(this.rawContentChangedEvent,t.rawContentChangedEvent),e._mergeChangeEvents(this.contentChangedEvent,t.contentChangedEvent))},e._mergeChangeEvents=function(e,t){return{changes:[].concat(e.changes).concat(t.changes),eol:t.eol,versionId:t.versionId,isUndoing:e.isUndoing||t.isUndoing,isRedoing:e.isRedoing||t.isRedoing,isFlush:e.isFlush||t.isFlush}},e}();t.InternalModelContentChangeEvent=l}),define(t[147],i([1,0,5,86,13,3,49]),function(e,t,i,n,o,r,s){"use strict";function a(e){if(!e||0===e.length)return!1;for(var t=0,i=e.length;t<i;t++){if(92===e.charCodeAt(t)){if(++t>=i)break;var n=e.charCodeAt(t);if(110===n||114===n||87===n)return!0}}return!1}function l(e,t,i){if(!i)return new s.FindMatch(e,null)
;for(var n=[],o=0,r=t.length;o<r;o++)n[o]=t[o];return new s.FindMatch(e,n)}function u(e,t,i,n,o){return function(e,t,i,n,o){if(0===n)return!0;var r=t.charCodeAt(n-1);if(0!==e.get(r))return!0;if(13===r||10===r)return!0;if(o>0){var s=t.charCodeAt(n);if(0!==e.get(s))return!0}return!1}(e,t,0,n,o)&&function(e,t,i,n,o){if(n+o===i)return!0;var r=t.charCodeAt(n+o);if(0!==e.get(r))return!0;if(13===r||10===r)return!0;if(o>0){var s=t.charCodeAt(n+o-1);if(0!==e.get(s))return!0}return!1}(e,t,i,n,o)}Object.defineProperty(t,"__esModule",{value:!0});var d=function(){function e(e,t,i,n){this.searchString=e,this.isRegex=t,this.matchCase=i,this.wordSeparators=n}return e.prototype.parseSearchRequest=function(){if(""===this.searchString)return null;var e;e=this.isRegex?a(this.searchString):this.searchString.indexOf("\n")>=0;var t=null;try{t=i.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:e,global:!0})}catch(e){return null}if(!t)return null;var o=!this.isRegex&&!e
;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new c(t,this.wordSeparators?n.getMapForWordSeparators(this.wordSeparators):null,o?this.searchString:null)},e}();t.SearchParams=d,t.isMultilineRegexSource=a;var c=function(){return function(e,t,i){this.regex=e,this.wordSeparators=t,this.simpleSearch=i}}();t.SearchData=c,t.createFindMatch=l;var h=function(){function e(e){for(var t=[],i=0,n=0,o=e.length;n<o;n++)10===e.charCodeAt(n)&&(t[i++]=n);this._lineFeedsOffsets=t}return e.prototype.findLineFeedCountBeforeOffset=function(e){var t=this._lineFeedsOffsets,i=0,n=t.length-1;if(-1===n)return 0;if(e<=t[0])return 0;for(;i<n;){var o=i+((n-i)/2>>0);t[o]>=e?n=o-1:t[o+1]>=e?(i=o,n=o):i=o+1}return i+1},e}(),p=function(){function e(){}return e.findMatches=function(e,t,i,n,o){var r=t.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(e,i,new f(r.wordSeparators,r.regex),n,o):this._doFindMatchesLineByLine(e,i,r,n,o):[]},
e._getMultilineMatchRange=function(e,t,i,n,o,s){var a,l=0;a=n?t+o+(l=n.findLineFeedCountBeforeOffset(o)):t+o;var u;if(n){var d=n.findLineFeedCountBeforeOffset(o+s.length)-l;u=a+s.length+d}else u=a+s.length;var c=e.getPositionAt(a),h=e.getPositionAt(u);return new r.Range(c.lineNumber,c.column,h.lineNumber,h.column)},e._doFindMatchesMultiline=function(e,t,i,n,o){var r,s=e.getOffsetAt(t.getStartPosition()),a=e.getValueInRange(t,1),u="\r\n"===e.getEOL()?new h(a):null,d=[],c=0;for(i.reset(0);r=i.next(a);)if(d[c++]=l(this._getMultilineMatchRange(e,s,a,u,r.index,r[0]),r,n),c>=o)return d;return d},e._doFindMatchesLineByLine=function(e,t,i,n,o){var r=[],s=0;if(t.startLineNumber===t.endLineNumber){var a=e.getLineContent(t.startLineNumber).substring(t.startColumn-1,t.endColumn-1);return s=this._findMatchesInLine(i,a,t.startLineNumber,t.startColumn-1,s,r,n,o),r}var l=e.getLineContent(t.startLineNumber).substring(t.startColumn-1);s=this._findMatchesInLine(i,l,t.startLineNumber,t.startColumn-1,s,r,n,o)
;for(var u=t.startLineNumber+1;u<t.endLineNumber&&s<o;u++)s=this._findMatchesInLine(i,e.getLineContent(u),u,0,s,r,n,o);if(s<o){var d=e.getLineContent(t.endLineNumber).substring(0,t.endColumn-1);s=this._findMatchesInLine(i,d,t.endLineNumber,0,s,r,n,o)}return r},e._findMatchesInLine=function(e,t,i,n,o,a,d,c){var h=e.wordSeparators;if(!d&&e.simpleSearch){for(var p=e.simpleSearch,g=p.length,m=t.length,v=-g;-1!==(v=t.indexOf(p,v+g));)if((!h||u(h,t,m,v,g))&&(a[o++]=new s.FindMatch(new r.Range(i,v+1+n,i,v+1+g+n),null),o>=c))return o;return o}var _,y=new f(e.wordSeparators,e.regex);y.reset(0);do{if((_=y.next(t))&&(a[o++]=l(new r.Range(i,_.index+1+n,i,_.index+1+_[0].length+n),_,d),o>=c))return o}while(_);return o},e.findNextMatch=function(e,t,i,n){var o=t.parseSearchRequest();if(!o)return null;var r=new f(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(e,i,r,n):this._doFindNextMatchLineByLine(e,i,r,n)},e._doFindNextMatchMultiline=function(e,t,i,n){
var s=new o.Position(t.lineNumber,1),a=e.getOffsetAt(s),u=e.getLineCount(),d=e.getValueInRange(new r.Range(s.lineNumber,s.column,u,e.getLineMaxColumn(u)),1),c="\r\n"===e.getEOL()?new h(d):null;i.reset(t.column-1);var p=i.next(d);return p?l(this._getMultilineMatchRange(e,a,d,c,p.index,p[0]),p,n):1!==t.lineNumber||1!==t.column?this._doFindNextMatchMultiline(e,new o.Position(1,1),i,n):null},e._doFindNextMatchLineByLine=function(e,t,i,n){var o=e.getLineCount(),r=t.lineNumber,s=e.getLineContent(r),a=this._findFirstMatchInLine(i,s,r,t.column,n);if(a)return a;for(var l=1;l<=o;l++){var u=(r+l-1)%o,d=e.getLineContent(u+1),c=this._findFirstMatchInLine(i,d,u+1,1,n);if(c)return c}return null},e._findFirstMatchInLine=function(e,t,i,n,o){e.reset(n-1);var s=e.next(t);return s?l(new r.Range(i,s.index+1,i,s.index+1+s[0].length),s,o):null},e.findPreviousMatch=function(e,t,i,n){var o=t.parseSearchRequest();if(!o)return null;var r=new f(o.wordSeparators,o.regex)
;return o.regex.multiline?this._doFindPreviousMatchMultiline(e,i,r,n):this._doFindPreviousMatchLineByLine(e,i,r,n)},e._doFindPreviousMatchMultiline=function(e,t,i,n){var s=this._doFindMatchesMultiline(e,new r.Range(1,1,t.lineNumber,t.column),i,n,9990);if(s.length>0)return s[s.length-1];var a=e.getLineCount();return t.lineNumber!==a||t.column!==e.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(e,new o.Position(a,e.getLineMaxColumn(a)),i,n):null},e._doFindPreviousMatchLineByLine=function(e,t,i,n){var o=e.getLineCount(),r=t.lineNumber,s=e.getLineContent(r).substring(0,t.column-1),a=this._findLastMatchInLine(i,s,r,n);if(a)return a;for(var l=1;l<=o;l++){var u=(o+r-l-1)%o,d=e.getLineContent(u+1),c=this._findLastMatchInLine(i,d,u+1,n);if(c)return c}return null},e._findLastMatchInLine=function(e,t,i,n){var o,s=null;for(e.reset(0);o=e.next(t);)s=l(new r.Range(i,o.index+1,i,o.index+1+o[0].length),o,n);return s},e}();t.TextModelSearch=p,t.isValidMatch=u;var f=function(){function e(e,t){this._wordSeparators=e,
this._searchRegex=t,this._prevMatchStartIndex=-1,this._prevMatchLength=0}return e.prototype.reset=function(e){this._searchRegex.lastIndex=e,this._prevMatchStartIndex=-1,this._prevMatchLength=0},e.prototype.next=function(e){var t,i=e.length;do{if(this._prevMatchStartIndex+this._prevMatchLength===i)return null;if(!(t=this._searchRegex.exec(e)))return null;var n=t.index,o=t[0].length;if(n===this._prevMatchStartIndex&&o===this._prevMatchLength){if(0===o){this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=o,!this._wordSeparators||u(this._wordSeparators,e,i,n,o))return t}while(t);return null},e}();t.Searcher=f}),define(t[169],i([1,0,13,3,49,393,147]),function(e,t,i,n,o,r,s){"use strict";function a(e){var t;return(t=e[e.length-1]<65536?new Uint16Array(e.length):new Uint32Array(e.length)).set(e,0),t}function l(e,t){void 0===t&&(t=!0);for(var i=[0],n=1,o=0,r=e.length;o<r;o++){var s=e.charCodeAt(o);13===s?o+1<r&&10===e.charCodeAt(o+1)?(i[n++]=o+2,
o++):i[n++]=o+1:10===s&&(i[n++]=o+1)}return t?a(i):i}Object.defineProperty(t,"__esModule",{value:!0}),t.AverageBufferSize=65535,t.createUintArray=a;var u=function(){return function(e,t,i,n,o){this.lineStarts=e,this.cr=t,this.lf=i,this.crlf=n,this.isBasicASCII=o}}();t.LineStarts=u,t.createLineStartsFast=l,t.createLineStarts=function(e,t){e.length=0,e[0]=0;for(var i=1,n=0,o=0,r=0,s=!0,l=0,d=t.length;l<d;l++){var c=t.charCodeAt(l);13===c?l+1<d&&10===t.charCodeAt(l+1)?(r++,e[i++]=l+2,l++):(n++,e[i++]=l+1):10===c?(o++,e[i++]=l+1):s&&9!==c&&(c<32||c>126)&&(s=!1)}var h=new u(a(e),n,o,r,s);return e.length=0,h};var d=function(){return function(e,t,i,n,o){this.bufferIndex=e,this.start=t,this.end=i,this.lineFeedCnt=n,this.length=o}}();t.Piece=d;var c=function(){return function(e,t){this.buffer=e,this.lineStarts=t}}();t.StringBuffer=c;var h=function(){function e(e){this._limit=e,this._cache=[]}return e.prototype.get=function(e){for(var t=this._cache.length-1;t>=0;t--){var i=this._cache[t]
;if(i.nodeStartOffset<=e&&i.nodeStartOffset+i.node.piece.length>=e)return i}return null},e.prototype.get2=function(e){for(var t=this._cache.length-1;t>=0;t--){var i=this._cache[t];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<e&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=e)return i}return null},e.prototype.set=function(e){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(e)},e.prototype.valdiate=function(e){for(var t=!1,i=this._cache,n=0;n<i.length;n++){var o=i[n];(null===o.node.parent||o.nodeStartOffset>=e)&&(i[n]=null,t=!0)}if(t){for(var r=[],s=0,a=i;s<a.length;s++){var l=a[s];null!==l&&r.push(l)}this._cache=r}},e}(),p=function(){function e(e,t,i){this.create(e,t,i)}return e.prototype.create=function(e,t,i){this._buffers=[new c("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=r.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=t,this._EOLLength=t.length,this._EOLNormalized=i;for(var n=null,o=0,s=e.length;o<s;o++)if(e[o].buffer.length>0){
e[o].lineStarts||(e[o].lineStarts=l(e[o].buffer));var a=new d(o+1,{line:0,column:0},{line:e[o].lineStarts.length-1,column:e[o].buffer.length-e[o].lineStarts[e[o].lineStarts.length-1]},e[o].lineStarts.length-1,e[o].buffer.length);this._buffers.push(e[o]),n=this.rbInsertRight(n,a)}this._searchCache=new h(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()},e.prototype.normalizeEOL=function(e){var i=this,n=t.AverageBufferSize,o=n-Math.floor(n/3),r=2*o,s="",a=0,u=[];if(this.iterate(this.root,function(t){var n=i.getNodeContent(t),d=n.length;if(a<=o||a+d<r)return s+=n,a+=d,!0;var h=s.replace(/\r\n|\r|\n/g,e);return u.push(new c(h,l(h))),s=n,a=d,!0}),a>0){var d=s.replace(/\r\n|\r|\n/g,e);u.push(new c(d,l(d)))}this.create(u,e,!0)},e.prototype.getEOL=function(){return this._EOL},e.prototype.setEOL=function(e){this._EOL=e,this._EOLLength=this._EOL.length,this.normalizeEOL(e)},e.prototype.getOffsetAt=function(e,t){
for(var i=0,n=this.root;n!==r.SENTINEL;)if(n.left!==r.SENTINEL&&n.lf_left+1>=e)n=n.left;else{if(n.lf_left+n.piece.lineFeedCnt+1>=e){i+=n.size_left;return i+=this.getAccumulatedValue(n,e-n.lf_left-2)+t-1}e-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right}return i},e.prototype.getPositionAt=function(e){e=Math.floor(e),e=Math.max(0,e);for(var t=this.root,n=0,o=e;t!==r.SENTINEL;)if(0!==t.size_left&&t.size_left>=e)t=t.left;else{if(t.size_left+t.piece.length>=e){var s=this.getIndexOf(t,e-t.size_left);if(n+=t.lf_left+s.index,0===s.index){l=o-(a=this.getOffsetAt(n+1,1));return new i.Position(n+1,l+1)}return new i.Position(n+1,s.remainder+1)}if(e-=t.size_left+t.piece.length,n+=t.lf_left+t.piece.lineFeedCnt,t.right===r.SENTINEL){var a=this.getOffsetAt(n+1,1),l=o-e-a;return new i.Position(n+1,l+1)}t=t.right}return new i.Position(1,1)},e.prototype.getValueInRange=function(e,t){if(e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn)return""
;var i=this.nodeAt2(e.startLineNumber,e.startColumn),n=this.nodeAt2(e.endLineNumber,e.endColumn),o=this.getValueInRange2(i,n);return t?t===this._EOL&&this._EOLNormalized&&t===this.getEOL()&&this._EOLNormalized?o:o.replace(/\r\n|\r|\n/g,t):o},e.prototype.getValueInRange2=function(e,t){if(e.node===t.node){var i=e.node,n=this._buffers[i.piece.bufferIndex].buffer,o=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return n.substring(o+e.remainder,o+t.remainder)}var s=e.node,a=this._buffers[s.piece.bufferIndex].buffer,l=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start),u=a.substring(l+e.remainder,l+s.piece.length);for(s=s.next();s!==r.SENTINEL;){var d=this._buffers[s.piece.bufferIndex].buffer,c=this.offsetInBuffer(s.piece.bufferIndex,s.piece.start);if(s===t.node){u+=d.substring(c,c+t.remainder);break}u+=d.substr(c,s.piece.length),s=s.next()}return u},e.prototype.getLinesContent=function(){return this.getContentOfSubTree(this.root).split(/\r\n|\r|\n/)},e.prototype.getLength=function(){return this._length
},e.prototype.getLineCount=function(){return this._lineCnt},e.prototype.getLineContent=function(e){return this._lastVisitedLine.lineNumber===e?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=e,e===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(e):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(e,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(e).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)},e.prototype.getLineCharCode=function(e,t){var i=this.nodeAt2(e,t+1);if(i.remainder===i.node.piece.length){var n=i.node.next();if(!n)return 0;var o=this._buffers[n.piece.bufferIndex],r=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(r)}var o=this._buffers[i.node.piece.bufferIndex],s=(r=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start))+i.remainder;return o.buffer.charCodeAt(s)},e.prototype.getLineLength=function(e){if(e===this.getLineCount()){var t=this.getOffsetAt(e,1)
;return this.getLength()-t}return this.getOffsetAt(e+1,1)-this.getOffsetAt(e,1)-this._EOLLength},e.prototype.findMatchesInNode=function(e,t,i,o,r,a,l,u,d,c,h){var p,f=this._buffers[e.piece.bufferIndex],g=this.offsetInBuffer(e.piece.bufferIndex,e.piece.start),m=this.offsetInBuffer(e.piece.bufferIndex,r),v=this.offsetInBuffer(e.piece.bufferIndex,a);t.reset(m);var _={line:0,column:0};do{if(p=t.next(f.buffer)){if(p.index>=v)return c;this.positionInBuffer(e,p.index-g,_);var y=this.getLineFeedCnt(e.piece.bufferIndex,r,_),b=_.line===r.line?_.column-r.column+o:_.column+1,C=b+p[0].length;if(h[c++]=s.createFindMatch(new n.Range(i+y,b,i+y,C),p,u),p.index+p[0].length>=v)return c;if(c>=d)return c}}while(p);return c},e.prototype.findMatchesLineByLine=function(e,t,i,n){var o=[],r=0,a=new s.Searcher(t.wordSeparators,t.regex),l=this.nodeAt2(e.startLineNumber,e.startColumn);if(null===l)return[];var u=this.nodeAt2(e.endLineNumber,e.endColumn);if(null===u)return[]
;var d=this.positionInBuffer(l.node,l.remainder),c=this.positionInBuffer(u.node,u.remainder);if(l.node===u.node)return this.findMatchesInNode(l.node,a,e.startLineNumber,e.startColumn,d,c,t,i,n,r,o),o;for(var h=e.startLineNumber,p=l.node;p!==u.node;){var f=this.getLineFeedCnt(p.piece.bufferIndex,d,p.piece.end);if(f>=1){var g=this._buffers[p.piece.bufferIndex].lineStarts,m=this.offsetInBuffer(p.piece.bufferIndex,p.piece.start),v=g[d.line+f],_=h===e.startLineNumber?e.startColumn:1;if((r=this.findMatchesInNode(p,a,h,_,d,this.positionInBuffer(p,v-m),t,i,n,r,o))>=n)return o;h+=f}var y=h===e.startLineNumber?e.startColumn-1:0;if(h===e.endLineNumber){C=this.getLineContent(h).substring(y,e.endColumn-1);return r=this._findMatchesInLine(t,a,C,e.endLineNumber,y,r,o,i,n),o}if((r=this._findMatchesInLine(t,a,this.getLineContent(h).substr(y),h,y,r,o,i,n))>=n)return o;h++,p=(l=this.nodeAt2(h,1)).node,d=this.positionInBuffer(l.node,l.remainder)}if(h===e.endLineNumber){
var b=h===e.startLineNumber?e.startColumn-1:0,C=this.getLineContent(h).substring(b,e.endColumn-1);return r=this._findMatchesInLine(t,a,C,e.endLineNumber,b,r,o,i,n),o}var S=h===e.startLineNumber?e.startColumn:1;return r=this.findMatchesInNode(u.node,a,h,S,d,c,t,i,n,r,o),o},e.prototype._findMatchesInLine=function(e,t,i,r,a,l,u,d,c){var h=e.wordSeparators;if(!d&&e.simpleSearch){for(var p=e.simpleSearch,f=p.length,g=i.length,m=-f;-1!==(m=i.indexOf(p,m+f));)if((!h||s.isValidMatch(h,i,g,m,f))&&(u[l++]=new o.FindMatch(new n.Range(r,m+1+a,r,m+1+f+a),null),l>=c))return l;return l}var v;t.reset(0);do{if((v=t.next(i))&&(u[l++]=s.createFindMatch(new n.Range(r,v.index+1+a,r,v.index+1+v[0].length+a),v,d),l>=c))return l}while(v);return l},e.prototype.insert=function(e,i,n){if(void 0===n&&(n=!1),this._EOLNormalized=this._EOLNormalized&&n,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==r.SENTINEL){
var o=this.nodeAt(e),s=o.node,a=o.remainder,l=o.nodeStartOffset,u=s.piece,c=u.bufferIndex,h=this.positionInBuffer(s,a);if(0===s.piece.bufferIndex&&u.end.line===this._lastChangeBufferPos.line&&u.end.column===this._lastChangeBufferPos.column&&l+u.length===e&&i.length<t.AverageBufferSize)return this.appendToNode(s,i),void this.computeBufferMetadata();if(l===e)this.insertContentToNodeLeft(i,s),this._searchCache.valdiate(e);else if(l+s.piece.length>e){var p=[],f=new d(u.bufferIndex,h,u.end,this.getLineFeedCnt(u.bufferIndex,h,u.end),this.offsetInBuffer(c,u.end)-this.offsetInBuffer(c,h));if(this.shouldCheckCRLF()&&this.endWithCR(i)){if(10===this.nodeCharCodeAt(s,a)){var g={line:f.start.line+1,column:0};f=new d(f.bufferIndex,g,f.end,this.getLineFeedCnt(f.bufferIndex,g,f.end),f.length-1),i+="\n"}}if(this.shouldCheckCRLF()&&this.startWithLF(i)){if(13===this.nodeCharCodeAt(s,a-1)){var m=this.positionInBuffer(s,a-1);this.deleteNodeTail(s,m),i="\r"+i,0===s.piece.length&&p.push(s)}else this.deleteNodeTail(s,h)
}else this.deleteNodeTail(s,h);var v=this.createNewPieces(i);f.length>0&&this.rbInsertRight(s,f);for(var _=s,y=0;y<v.length;y++)_=this.rbInsertRight(_,v[y]);this.deleteNodes(p)}else this.insertContentToNodeRight(i,s)}else for(var b=this.createNewPieces(i),s=this.rbInsertLeft(null,b[0]),y=1;y<b.length;y++)s=this.rbInsertRight(s,b[y]);this.computeBufferMetadata()},e.prototype.delete=function(e,t){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",!(t<=0||this.root===r.SENTINEL)){var i=this.nodeAt(e),n=this.nodeAt(e+t),o=i.node,s=n.node;if(o===s){var a=this.positionInBuffer(o,i.remainder),l=this.positionInBuffer(o,n.remainder);if(i.nodeStartOffset===e){if(t===o.piece.length){var u=o.next();return r.rbDelete(this,o),this.validateCRLFWithPrevNode(u),void this.computeBufferMetadata()}return this.deleteNodeHead(o,l),this._searchCache.valdiate(e),this.validateCRLFWithPrevNode(o),void this.computeBufferMetadata()}return i.nodeStartOffset+o.piece.length===e+t?(this.deleteNodeTail(o,a),
this.validateCRLFWithNextNode(o),void this.computeBufferMetadata()):(this.shrinkNode(o,a,l),void this.computeBufferMetadata())}var d=[],c=this.positionInBuffer(o,i.remainder);this.deleteNodeTail(o,c),this._searchCache.valdiate(e),0===o.piece.length&&d.push(o);var h=this.positionInBuffer(s,n.remainder);this.deleteNodeHead(s,h),0===s.piece.length&&d.push(s);for(var p=o.next();p!==r.SENTINEL&&p!==s;p=p.next())d.push(p);var f=0===o.piece.length?o.prev():o;this.deleteNodes(d),this.validateCRLFWithNextNode(f),this.computeBufferMetadata()}},e.prototype.insertContentToNodeLeft=function(e,t){var i=[];if(this.shouldCheckCRLF()&&this.endWithCR(e)&&this.startWithLF(t)){var n=t.piece,o={line:n.start.line+1,column:0},s=new d(n.bufferIndex,o,n.end,this.getLineFeedCnt(n.bufferIndex,o,n.end),n.length-1);t.piece=s,e+="\n",r.updateTreeMetadata(this,t,-1,-1),0===t.piece.length&&i.push(t)}for(var a=this.createNewPieces(e),l=this.rbInsertLeft(t,a[a.length-1]),u=a.length-2;u>=0;u--)l=this.rbInsertLeft(l,a[u])
;this.validateCRLFWithPrevNode(l),this.deleteNodes(i)},e.prototype.insertContentToNodeRight=function(e,t){this.adjustCarriageReturnFromNext(e,t)&&(e+="\n");for(var i=this.createNewPieces(e),n=this.rbInsertRight(t,i[0]),o=n,r=1;r<i.length;r++)o=this.rbInsertRight(o,i[r]);this.validateCRLFWithPrevNode(n)},e.prototype.positionInBuffer=function(e,t,i){for(var n=e.piece,o=e.piece.bufferIndex,r=this._buffers[o].lineStarts,s=r[n.start.line]+n.start.column+t,a=n.start.line,l=n.end.line,u=0,d=0,c=0;a<=l&&(u=a+(l-a)/2|0,c=r[u],u!==l);)if(d=r[u+1],s<c)l=u-1;else{if(!(s>=d))break;a=u+1}return i?(i.line=u,i.column=s-c,null):{line:u,column:s-c}},e.prototype.getLineFeedCnt=function(e,t,i){if(0===i.column)return i.line-t.line;var n=this._buffers[e].lineStarts;if(i.line===n.length-1)return i.line-t.line;var o=n[i.line+1],r=n[i.line]+i.column;if(o>r+1)return i.line-t.line;var s=r-1;return 13===this._buffers[e].buffer.charCodeAt(s)?i.line-t.line+1:i.line-t.line},e.prototype.offsetInBuffer=function(e,t){
return this._buffers[e].lineStarts[t.line]+t.column},e.prototype.deleteNodes=function(e){for(var t=0;t<e.length;t++)r.rbDelete(this,e[t])},e.prototype.createNewPieces=function(e){if(e.length>t.AverageBufferSize){for(var i=[];e.length>t.AverageBufferSize;){var n=e.charCodeAt(t.AverageBufferSize-1),o=void 0;13===n||n>=55296&&n<=56319?(o=e.substring(0,t.AverageBufferSize-1),e=e.substring(t.AverageBufferSize-1)):(o=e.substring(0,t.AverageBufferSize),e=e.substring(t.AverageBufferSize));var r=l(o);i.push(new d(this._buffers.length,{line:0,column:0},{line:r.length-1,column:o.length-r[r.length-1]},r.length-1,o.length)),this._buffers.push(new c(o,r))}var s=l(e);return i.push(new d(this._buffers.length,{line:0,column:0},{line:s.length-1,column:e.length-s[s.length-1]},s.length-1,e.length)),this._buffers.push(new c(e,s)),i}var a=this._buffers[0].buffer.length,u=l(e,!1),h=this._lastChangeBufferPos
;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===a&&0!==a&&this.startWithLF(e)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},h=this._lastChangeBufferPos;for(p=0;p<u.length;p++)u[p]+=a+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(u.slice(1)),this._buffers[0].buffer+="_"+e,a+=1}else{if(0!==a)for(var p=0;p<u.length;p++)u[p]+=a;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(u.slice(1)),this._buffers[0].buffer+=e}var f=this._buffers[0].buffer.length,g=this._buffers[0].lineStarts.length-1,m={line:g,column:f-this._buffers[0].lineStarts[g]},v=new d(0,h,m,this.getLineFeedCnt(0,h,m),f-a);return this._lastChangeBufferPos=m,[v]},e.prototype.getLineRawContent=function(e,t){void 0===t&&(t=0);var i=this.root,n="",o=this._searchCache.get2(e);if(o){i=o.node
;var s=this.getAccumulatedValue(i,e-o.nodeStartLineNumber-1),a=this._buffers[i.piece.bufferIndex].buffer,l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);if(o.nodeStartLineNumber+i.piece.lineFeedCnt!==e){c=this.getAccumulatedValue(i,e-o.nodeStartLineNumber);return a.substring(l+s,l+c-t)}n=a.substring(l+s,l+i.piece.length)}else for(var u=0,d=e;i!==r.SENTINEL;)if(i.left!==r.SENTINEL&&i.lf_left>=e-1)i=i.left;else{if(i.lf_left+i.piece.lineFeedCnt>e-1){var s=this.getAccumulatedValue(i,e-i.lf_left-2),c=this.getAccumulatedValue(i,e-i.lf_left-1),a=this._buffers[i.piece.bufferIndex].buffer,l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return u+=i.size_left,this._searchCache.set({node:i,nodeStartOffset:u,nodeStartLineNumber:d-(e-1-i.lf_left)}),a.substring(l+s,l+c-t)}if(i.lf_left+i.piece.lineFeedCnt===e-1){var s=this.getAccumulatedValue(i,e-i.lf_left-2),a=this._buffers[i.piece.bufferIndex].buffer,l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);n=a.substring(l+s,l+i.piece.length);break}
e-=i.lf_left+i.piece.lineFeedCnt,u+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==r.SENTINEL;){a=this._buffers[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){var c=this.getAccumulatedValue(i,0),l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return n+=a.substring(l,l+c-t)}l=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);n+=a.substr(l,i.piece.length),i=i.next()}return n},e.prototype.computeBufferMetadata=function(){for(var e=this.root,t=1,i=0;e!==r.SENTINEL;)t+=e.lf_left+e.piece.lineFeedCnt,i+=e.size_left+e.piece.length,e=e.right;this._lineCnt=t,this._length=i,this._searchCache.valdiate(this._length)},e.prototype.getIndexOf=function(e,t){var i=e.piece,n=this.positionInBuffer(e,t),o=n.line-i.start.line;if(this.offsetInBuffer(i.bufferIndex,i.end)-this.offsetInBuffer(i.bufferIndex,i.start)===t){var r=this.getLineFeedCnt(e.piece.bufferIndex,i.start,n);if(r!==o)return{index:r,remainder:0}}return{index:o,remainder:n.column}},e.prototype.getAccumulatedValue=function(e,t){
if(t<0)return 0;var i=e.piece,n=this._buffers[i.bufferIndex].lineStarts,o=i.start.line+t+1;return o>i.end.line?n[i.end.line]+i.end.column-n[i.start.line]-i.start.column:n[o]-n[i.start.line]-i.start.column},e.prototype.deleteNodeTail=function(e,t){var i=e.piece,n=i.lineFeedCnt,o=this.offsetInBuffer(i.bufferIndex,i.end),s=t,a=this.offsetInBuffer(i.bufferIndex,s),l=this.getLineFeedCnt(i.bufferIndex,i.start,s),u=l-n,c=a-o,h=i.length+c;e.piece=new d(i.bufferIndex,i.start,s,l,h),r.updateTreeMetadata(this,e,c,u)},e.prototype.deleteNodeHead=function(e,t){var i=e.piece,n=i.lineFeedCnt,o=this.offsetInBuffer(i.bufferIndex,i.start),s=t,a=this.getLineFeedCnt(i.bufferIndex,s,i.end),l=a-n,u=o-this.offsetInBuffer(i.bufferIndex,s),c=i.length+u;e.piece=new d(i.bufferIndex,s,i.end,a,c),r.updateTreeMetadata(this,e,u,l)},e.prototype.shrinkNode=function(e,t,i){
var n=e.piece,o=n.start,s=n.end,a=n.length,l=n.lineFeedCnt,u=t,c=this.getLineFeedCnt(n.bufferIndex,n.start,u),h=this.offsetInBuffer(n.bufferIndex,t)-this.offsetInBuffer(n.bufferIndex,o);e.piece=new d(n.bufferIndex,n.start,u,c,h),r.updateTreeMetadata(this,e,h-a,c-l);var p=new d(n.bufferIndex,i,s,this.getLineFeedCnt(n.bufferIndex,i,s),this.offsetInBuffer(n.bufferIndex,s)-this.offsetInBuffer(n.bufferIndex,i)),f=this.rbInsertRight(e,p);this.validateCRLFWithPrevNode(f)},e.prototype.appendToNode=function(e,t){this.adjustCarriageReturnFromNext(t,e)&&(t+="\n");var i=this.shouldCheckCRLF()&&this.startWithLF(t)&&this.endWithCR(e),n=this._buffers[0].buffer.length;this._buffers[0].buffer+=t;for(var o=l(t,!1),s=0;s<o.length;s++)o[s]+=n;if(i){var a=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:n-a}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(o.slice(1))
;var u=this._buffers[0].lineStarts.length-1,c={line:u,column:this._buffers[0].buffer.length-this._buffers[0].lineStarts[u]},h=e.piece.length+t.length,p=e.piece.lineFeedCnt,f=this.getLineFeedCnt(0,e.piece.start,c),g=f-p;e.piece=new d(e.piece.bufferIndex,e.piece.start,c,f,h),this._lastChangeBufferPos=c,r.updateTreeMetadata(this,e,t.length,g)},e.prototype.nodeAt=function(e){var t=this.root,i=this._searchCache.get(e);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:e-i.nodeStartOffset};for(var n=0;t!==r.SENTINEL;)if(t.size_left>e)t=t.left;else{if(t.size_left+t.piece.length>=e){n+=t.size_left;var o={node:t,remainder:e-t.size_left,nodeStartOffset:n};return this._searchCache.set(o),o}e-=t.size_left+t.piece.length,n+=t.size_left+t.piece.length,t=t.right}return null},e.prototype.nodeAt2=function(e,t){for(var i=this.root,n=0;i!==r.SENTINEL;)if(i.left!==r.SENTINEL&&i.lf_left>=e-1)i=i.left;else{if(i.lf_left+i.piece.lineFeedCnt>e-1){
var o=this.getAccumulatedValue(i,e-i.lf_left-2),s=this.getAccumulatedValue(i,e-i.lf_left-1);return n+=i.size_left,{node:i,remainder:Math.min(o+t-1,s),nodeStartOffset:n}}if(i.lf_left+i.piece.lineFeedCnt===e-1){if((o=this.getAccumulatedValue(i,e-i.lf_left-2))+t-1<=i.piece.length)return{node:i,remainder:o+t-1,nodeStartOffset:n};t-=i.piece.length-o;break}e-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==r.SENTINEL;){if(i.piece.lineFeedCnt>0){var s=this.getAccumulatedValue(i,0),a=this.offsetOfNode(i);return{node:i,remainder:Math.min(t-1,s),nodeStartOffset:a}}if(i.piece.length>=t-1){return{node:i,remainder:t-1,nodeStartOffset:this.offsetOfNode(i)}}t-=i.piece.length,i=i.next()}return null},e.prototype.nodeCharCodeAt=function(e,t){if(e.piece.lineFeedCnt<1)return-1;var i=this._buffers[e.piece.bufferIndex],n=this.offsetInBuffer(e.piece.bufferIndex,e.piece.start)+t;return i.buffer.charCodeAt(n)},e.prototype.offsetOfNode=function(e){if(!e)return 0
;for(var t=e.size_left;e!==this.root;)e.parent.right===e&&(t+=e.parent.size_left+e.parent.piece.length),e=e.parent;return t},e.prototype.shouldCheckCRLF=function(){return!(this._EOLNormalized&&"\n"===this._EOL)},e.prototype.startWithLF=function(e){if("string"==typeof e)return 10===e.charCodeAt(0);if(e===r.SENTINEL||0===e.piece.lineFeedCnt)return!1;var t=e.piece,i=this._buffers[t.bufferIndex].lineStarts,n=t.start.line,o=i[n]+t.start.column;if(n===i.length-1)return!1;return!(i[n+1]>o+1)&&10===this._buffers[t.bufferIndex].buffer.charCodeAt(o)},e.prototype.endWithCR=function(e){return"string"==typeof e?13===e.charCodeAt(e.length-1):e!==r.SENTINEL&&0!==e.piece.lineFeedCnt&&13===this.nodeCharCodeAt(e,e.piece.length-1)},e.prototype.validateCRLFWithPrevNode=function(e){if(this.shouldCheckCRLF()&&this.startWithLF(e)){var t=e.prev();this.endWithCR(t)&&this.fixCRLF(t,e)}},e.prototype.validateCRLFWithNextNode=function(e){if(this.shouldCheckCRLF()&&this.endWithCR(e)){var t=e.next();this.startWithLF(t)&&this.fixCRLF(e,t)}
},e.prototype.fixCRLF=function(e,t){var i,n=[],o=this._buffers[e.piece.bufferIndex].lineStarts;i=0===e.piece.end.column?{line:e.piece.end.line-1,column:o[e.piece.end.line]-o[e.piece.end.line-1]-1}:{line:e.piece.end.line,column:e.piece.end.column-1};var s=e.piece.length-1,a=e.piece.lineFeedCnt-1;e.piece=new d(e.piece.bufferIndex,e.piece.start,i,a,s),r.updateTreeMetadata(this,e,-1,-1),0===e.piece.length&&n.push(e);var l={line:t.piece.start.line+1,column:0},u=t.piece.length-1,c=this.getLineFeedCnt(t.piece.bufferIndex,l,t.piece.end);t.piece=new d(t.piece.bufferIndex,l,t.piece.end,c,u),r.updateTreeMetadata(this,t,-1,-1),0===t.piece.length&&n.push(t);var h=this.createNewPieces("\r\n");this.rbInsertRight(e,h[0]);for(var p=0;p<n.length;p++)r.rbDelete(this,n[p])},e.prototype.adjustCarriageReturnFromNext=function(e,t){if(this.shouldCheckCRLF()&&this.endWithCR(e)){var i=t.next();if(this.startWithLF(i)){if(e+="\n",1===i.piece.length)r.rbDelete(this,i);else{var n=i.piece,o={line:n.start.line+1,column:0
},s=n.length-1,a=this.getLineFeedCnt(n.bufferIndex,o,n.end);i.piece=new d(n.bufferIndex,o,n.end,a,s),r.updateTreeMetadata(this,i,-1,-1)}return!0}}return!1},e.prototype.iterate=function(e,t){if(e===r.SENTINEL)return t(r.SENTINEL);var i=this.iterate(e.left,t);return i?t(e)&&this.iterate(e.right,t):i},e.prototype.getNodeContent=function(e){if(e===r.SENTINEL)return"";var t=this._buffers[e.piece.bufferIndex],i=e.piece,n=this.offsetInBuffer(i.bufferIndex,i.start),o=this.offsetInBuffer(i.bufferIndex,i.end);return t.buffer.substring(n,o)},e.prototype.rbInsertRight=function(e,t){var i=new r.TreeNode(t,1);i.left=r.SENTINEL,i.right=r.SENTINEL,i.parent=r.SENTINEL,i.size_left=0,i.lf_left=0;if(this.root===r.SENTINEL)this.root=i,i.color=0;else if(e.right===r.SENTINEL)e.right=i,i.parent=e;else{var n=r.leftest(e.right);n.left=i,i.parent=n}return r.fixInsert(this,i),i},e.prototype.rbInsertLeft=function(e,t){var i=new r.TreeNode(t,1);if(i.left=r.SENTINEL,i.right=r.SENTINEL,i.parent=r.SENTINEL,i.size_left=0,i.lf_left=0,
this.root===r.SENTINEL)this.root=i,i.color=0;else if(e.left===r.SENTINEL)e.left=i,i.parent=e;else{var n=r.righttest(e.left);n.right=i,i.parent=n}return r.fixInsert(this,i),i},e.prototype.getContentOfSubTree=function(e){var t=this,i="";return this.iterate(e,function(e){return i+=t.getNodeContent(e),!0}),i},e}();t.PieceTreeBase=p}),define(t[406],i([1,0,5,3,49,169]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e,t,i,n,o,s){this._BOM=t,this._mightContainNonBasicASCII=!o,this._mightContainRTL=n,this._pieceTree=new r.PieceTreeBase(e,i,s)}return e.prototype.mightContainRTL=function(){return this._mightContainRTL},e.prototype.mightContainNonBasicASCII=function(){return this._mightContainNonBasicASCII},e.prototype.getBOM=function(){return this._BOM},e.prototype.getEOL=function(){return this._pieceTree.getEOL()},e.prototype.getOffsetAt=function(e,t){return this._pieceTree.getOffsetAt(e,t)},e.prototype.getPositionAt=function(e){
return this._pieceTree.getPositionAt(e)},e.prototype.getRangeAt=function(e,t){var i=e+t,o=this.getPositionAt(e),r=this.getPositionAt(i);return new n.Range(o.lineNumber,o.column,r.lineNumber,r.column)},e.prototype.getValueInRange=function(e,t){if(void 0===t&&(t=0),e.isEmpty())return"";var i=this._getEndOfLine(t);return this._pieceTree.getValueInRange(e,i)},e.prototype.getValueLengthInRange=function(e,t){if(void 0===t&&(t=0),e.isEmpty())return 0;if(e.startLineNumber===e.endLineNumber)return e.endColumn-e.startColumn;var i=this.getOffsetAt(e.startLineNumber,e.startColumn);return this.getOffsetAt(e.endLineNumber,e.endColumn)-i},e.prototype.getLength=function(){return this._pieceTree.getLength()},e.prototype.getLineCount=function(){return this._pieceTree.getLineCount()},e.prototype.getLinesContent=function(){return this._pieceTree.getLinesContent()},e.prototype.getLineContent=function(e){return this._pieceTree.getLineContent(e)},e.prototype.getLineCharCode=function(e,t){return this._pieceTree.getLineCharCode(e,t)
},e.prototype.getLineLength=function(e){return this._pieceTree.getLineLength(e)},e.prototype.getLineFirstNonWhitespaceColumn=function(e){var t=i.firstNonWhitespaceIndex(this.getLineContent(e));return-1===t?0:t+1},e.prototype.getLineLastNonWhitespaceColumn=function(e){var t=i.lastNonWhitespaceIndex(this.getLineContent(e));return-1===t?0:t+2},e.prototype._getEndOfLine=function(e){switch(e){case 1:return"\n";case 2:return"\r\n";case 0:return this.getEOL()}throw new Error("Unknown EOL preference")},e.prototype.setEOL=function(e){this._pieceTree.setEOL(e)},e.prototype.applyEdits=function(t,n){for(var r=this._mightContainRTL,s=this._mightContainNonBasicASCII,a=!0,l=[],u=0;u<t.length;u++){v=t[u];a&&v._isTracked&&(a=!1);var d=v.range;!r&&v.text&&(r=i.containsRTL(v.text)),!s&&v.text&&(s=!i.isBasicASCII(v.text)),l[u]={sortIndex:u,identifier:v.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),lines:v.text?v.text.split(/\r\n|\r|\n/):null,
forceMoveMarkers:Boolean(v.forceMoveMarkers),isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}l.sort(e._sortOpsAscending);for(var c=!1,u=0,h=l.length-1;u<h;u++){var p=l[u].range.getEndPosition(),f=l[u+1].range.getStartPosition();if(f.isBeforeOrEqual(p)){if(f.isBefore(p))throw new Error("Overlapping ranges are not allowed!");c=!0}}a&&(l=this._reduceOperations(l));for(var g=e._getInverseEditRanges(l),m=[],u=0;u<l.length;u++){var v=l[u],_=g[u];if(n&&v.isAutoWhitespaceEdit&&v.range.isEmpty())for(E=_.startLineNumber;E<=_.endLineNumber;E++){var y="";E===_.startLineNumber&&(y=this.getLineContent(v.range.startLineNumber),-1!==i.firstNonWhitespaceIndex(y))||m.push({lineNumber:E,oldContent:y})}}for(var b=[],u=0;u<l.length;u++){var v=l[u],_=g[u];b[u]={sortIndex:v.sortIndex,identifier:v.identifier,range:_,text:this.getValueInRange(v.range),forceMoveMarkers:v.forceMoveMarkers}}c||b.sort(function(e,t){return e.sortIndex-t.sortIndex}),this._mightContainRTL=r,this._mightContainNonBasicASCII=s
;var C=this._doApplyEdits(l),S=null;if(n&&m.length>0){m.sort(function(e,t){return t.lineNumber-e.lineNumber}),S=[];for(var u=0,w=m.length;u<w;u++){var E=m[u].lineNumber;if(!(u>0&&m[u-1].lineNumber===E)){var L=m[u].oldContent,x=this.getLineContent(E);0!==x.length&&x!==L&&-1===i.firstNonWhitespaceIndex(x)&&S.push(E)}}}return new o.ApplyEditsResult(b,C,S)},e.prototype._reduceOperations=function(e){return e.length<1e3?e:[this._toSingleEditOperation(e)]},e.prototype._toSingleEditOperation=function(e){for(var t=!1,i=e[0].range,o=e[e.length-1].range,r=new n.Range(i.startLineNumber,i.startColumn,o.endLineNumber,o.endColumn),s=i.startLineNumber,a=i.startColumn,l=[],u=0,d=e.length;u<d;u++){var c=e[u],h=c.range;t=t||c.forceMoveMarkers;for(var p=s;p<h.startLineNumber;p++)p===s?l.push(this.getLineContent(p).substring(a-1)):(l.push("\n"),l.push(this.getLineContent(p)));if(h.startLineNumber===s?l.push(this.getLineContent(h.startLineNumber).substring(a-1,h.startColumn-1)):(l.push("\n"),
l.push(this.getLineContent(h.startLineNumber).substring(0,h.startColumn-1))),c.lines)for(var f=0,g=c.lines.length;f<g;f++)0!==f&&l.push("\n"),l.push(c.lines[f]);s=c.range.endLineNumber,a=c.range.endColumn}return{sortIndex:0,identifier:e[0].identifier,range:r,rangeOffset:this.getOffsetAt(r.startLineNumber,r.startColumn),rangeLength:this.getValueLengthInRange(r,0),lines:l.join("").split("\n"),forceMoveMarkers:t,isAutoWhitespaceEdit:!1}},e.prototype._doApplyEdits=function(t){t.sort(e._sortOpsDescending);for(var i=[],o=0;o<t.length;o++){var r=t[o],s=r.range.startLineNumber,a=r.range.startColumn,l=r.range.endLineNumber,u=r.range.endColumn;if(s!==l||a!==u||r.lines&&0!==r.lines.length){var d=l-s,c=r.lines?r.lines.length-1:0,h=Math.min(d,c),p=r.lines?r.lines.join(this.getEOL()):"";if(p?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,p,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength),h<c){for(var f=[],g=h+1;g<=c;g++)f.push(r.lines[g])
;f[f.length-1]=this.getLineContent(s+c-1)}var m=new n.Range(s,a,l,u);i.push({range:m,rangeLength:r.rangeLength,text:p,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}}return i},e.prototype.findMatchesLineByLine=function(e,t,i,n){return this._pieceTree.findMatchesLineByLine(e,t,i,n)},e._getInverseEditRanges=function(e){for(var t=[],i=0,o=0,r=null,s=0,a=e.length;s<a;s++){var l=e[s],u=void 0,d=void 0;r?r.range.endLineNumber===l.range.startLineNumber?(u=i,d=o+(l.range.startColumn-r.range.endColumn)):(u=i+(l.range.startLineNumber-r.range.endLineNumber),d=l.range.startColumn):(u=l.range.startLineNumber,d=l.range.startColumn);var c=void 0;if(l.lines&&l.lines.length>0){var h=l.lines.length,p=l.lines[0],f=l.lines[h-1];c=1===h?new n.Range(u,d,u,d+p.length):new n.Range(u,d,u+h-1,f.length+1)}else c=new n.Range(u,d,u,d);i=c.endLineNumber,o=c.endColumn,t.push(c),r=l}return t},e._sortOpsAscending=function(e,t){var i=n.Range.compareRangesUsingEnds(e.range,t.range);return 0===i?e.sortIndex-t.sortIndex:i},
e._sortOpsDescending=function(e,t){var i=n.Range.compareRangesUsingEnds(e.range,t.range);return 0===i?t.sortIndex-e.sortIndex:-i},e}();t.PieceTreeTextBuffer=s}),define(t[414],i([1,0,5,169,406]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,t,i,n,o,r,s,a){this._chunks=e,this._bom=t,this._cr=i,this._lf=n,this._crlf=o,this._containsRTL=r,this._isBasicASCII=s,this._normalizeEOL=a}return e.prototype._getEOL=function(e){var t=this._cr+this._lf+this._crlf,i=this._cr+this._crlf;return 0===t?1===e?"\n":"\r\n":i>t/2?"\r\n":"\n"},e.prototype.create=function(e){var t=this._getEOL(e),i=this._chunks;if(this._normalizeEOL&&("\r\n"===t&&(this._cr>0||this._lf>0)||"\n"===t&&(this._cr>0||this._crlf>0)))for(var r=0,s=i.length;r<s;r++){var a=i[r].buffer.replace(/\r\n|\r|\n/g,t),l=n.createLineStartsFast(a);i[r]=new n.StringBuffer(a,l)}return new o.PieceTreeTextBuffer(i,this._bom,t,this._containsRTL,this._isBasicASCII,this._normalizeEOL)},e}()
;t.PieceTreeTextBufferFactory=r;var s=function(){function e(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.isBasicASCII=!0}return e.prototype.acceptChunk=function(e){if(0!==e.length){0===this.chunks.length&&i.startsWithUTF8BOM(e)&&(this.BOM=i.UTF8_BOM_CHARACTER,e=e.substr(1));var t=e.charCodeAt(e.length-1);13===t||t>=55296&&t<=56319?(this._acceptChunk1(e.substr(0,e.length-1),!1),this._hasPreviousChar=!0,this._previousChar=t):(this._acceptChunk1(e,!1),this._hasPreviousChar=!1,this._previousChar=t)}},e.prototype._acceptChunk1=function(e,t){(t||0!==e.length)&&(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+e):this._acceptChunk2(e))},e.prototype._acceptChunk2=function(e){var t=n.createLineStarts(this._tmpLineStarts,e);this.chunks.push(new n.StringBuffer(e,t.lineStarts)),this.cr+=t.cr,this.lf+=t.lf,this.crlf+=t.crlf,this.isBasicASCII&&(this.isBasicASCII=t.isBasicASCII),
this.isBasicASCII||this.containsRTL||(this.containsRTL=i.containsRTL(e))},e.prototype.finish=function(e){return void 0===e&&(e=!0),this._finish(),new r(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.isBasicASCII,e)},e.prototype._finish=function(){if(0===this.chunks.length&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;var e=this.chunks[this.chunks.length-1];e.buffer+=String.fromCharCode(this._previousChar);var t=n.createLineStartsFast(e.buffer);e.lineStarts=t,13===this._previousChar&&this.cr++}},e}();t.PieceTreeTextBufferBuilder=s}),define(t[99],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.DEFAULT_WORD_REGEXP=function(e){void 0===e&&(e="");for(var i="(-?\\d*\\.\\d\\w*)|([^",n=0,o=t.USUAL_WORD_SEPARATORS;n<o.length;n++){var r=o[n];e.indexOf(r)>=0||(i+="\\"+r)}return i+="\\s]+)",new RegExp(i,"g")}(),t.ensureValidWordDefinition=function(e){
var i=t.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)i=e;else{var n="g";e.ignoreCase&&(n+="i"),e.multiline&&(n+="m"),e.unicode&&(n+="u"),i=new RegExp(e.source,n)}return i.lastIndex=0,i},t.getWordAtText=function(e,t,i,n){t.lastIndex=0;var o=t.exec(i);if(!o)return null;var r=o[0].indexOf(" ")>=0?function(e,t,i,n){var o=e-1-n;t.lastIndex=0;for(var r;r=t.exec(i);){var s=r.index||0;if(s>o)return null;if(t.lastIndex>=o)return{word:r[0],startColumn:n+1+s,endColumn:n+1+t.lastIndex}}return null}(e,t,i,n):function(e,t,i,n){var o=e-1-n,r=i.lastIndexOf(" ",o-1)+1;t.lastIndex=r;for(var s;s=t.exec(i);){var a=s.index||0;if(a<=o&&t.lastIndex>=o)return{word:s[0],startColumn:n+1+a,endColumn:n+1+t.lastIndex}}return null}(e,t,i,n);return t.lastIndex=0,r}}),define(t[430],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this._languageIdentifier=e}return e.prototype.getId=function(){return this._languageIdentifier.language},e}();t.FrankensteinMode=i}),
define(t[92],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={}));var i=function(){function e(e){if(this.open=e.open,this.close=e.close,this._standardTokenMask=0,Array.isArray(e.notIn))for(var t=0,i=e.notIn.length;t<i;t++){switch(e.notIn[t]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4}}}return e.prototype.isOK=function(e){return 0==(this._standardTokenMask&e)},e}();t.StandardAutoClosingPairConditional=i}),define(t[440],i([1,0,211]),function(e,t,i){"use strict";function n(e,t,o,r){if(Array.isArray(e)){for(var s=0,a=0,l=e;a<l.length;a++){var u=n(l[a],t,o,r);if(10===u)return u;u>s&&(s=u)}return s}if("string"==typeof e)return r?"*"===e?5:e===o?10:0:0;if(e){var d=e.language,c=e.pattern,h=e.scheme,p=e.hasAccessToAllModels;if(!r&&!p)return 0;s=0
;if(h)if(h===t.scheme)s=10;else{if("*"!==h)return 0;s=5}if(d)if(d===o)s=10;else{if("*"!==d)return 0;s=Math.max(s,5)}if(c){if(c!==t.fsPath&&!i.match(c,t.fsPath))return 0;s=10}return s}return 0}Object.defineProperty(t,"__esModule",{value:!0}),t.score=n}),define(t[443],i([1,0,80,105]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e){for(var t=0,i=0,o=0,r=e.length;o<r;o++){var s=e[o],a=s[0],l=s[1],u=s[2];l>t&&(t=l),a>i&&(i=a),u>i&&(i=u)}t++,i++;for(var d=new n.Uint8Matrix(i,t,0),o=0,r=e.length;o<r;o++){var c=e[o],a=c[0],l=c[1],u=c[2];d.set(a,l,u)}this._states=d,this._maxCharCode=t}return e.prototype.nextState=function(e,t){return t<0||t>=this._maxCharCode?0:this._states.get(e,t)},e}();t.StateMachine=o;var r=null,s=null,a=function(){function e(){}return e._createLink=function(e,t,i,n,o){var r=o-1;do{var s=t.charCodeAt(r);if(2!==e.get(s))break;r--}while(r>n);if(n>0){var a=t.charCodeAt(n-1),l=t.charCodeAt(r)
;(40===a&&41===l||91===a&&93===l||123===a&&125===l)&&r--}return{range:{startLineNumber:i,startColumn:n+1,endLineNumber:i,endColumn:r+2},url:t.substring(n,r+1)}},e.computeLinks=function(t,n){void 0===n&&(null===r&&(r=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),n=r);for(var a=function(){if(null===s){for(s=new i.CharacterClassifier(0),e=0;e<" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".length;e++)s.set(" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".charCodeAt(e),1);for(var e=0;e<".,;".length;e++)s.set(".,;".charCodeAt(e),2)}return s}(),l=[],u=1,d=t.getLineCount();u<=d;u++){for(var c=t.getLineContent(u),h=c.length,p=0,f=0,g=0,m=1,v=!1,_=!1,y=!1;p<h;){var b=!1,C=c.charCodeAt(p);if(13===m){S=void 0;switch(C){case 40:v=!0,S=0;break;case 41:S=v?0:1;break;case 91:_=!0,S=0;break;case 93:S=_?0:1;break;case 123:y=!0,S=0;break
;case 125:S=y?0:1;break;case 39:S=34===g||96===g?0:1;break;case 34:S=39===g||96===g?0:1;break;case 96:S=39===g||34===g?0:1;break;default:S=a.get(C)}1===S&&(l.push(e._createLink(a,c,u,f,p)),b=!0)}else if(12===m){var S=void 0;91===C?(_=!0,S=0):S=a.get(C),1===S?b=!0:m=13}else 0===(m=n.nextState(m,C))&&(b=!0);b&&(m=1,v=!1,_=!1,y=!1,f=p+1,g=C),p++}13===m&&l.push(e._createLink(a,c,u,f,h))}return l},e}();t.LinkComputer=a,t.computeLinks=function(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?a.computeLinks(e):[]}}),define(t[144],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createScopedLineTokens=function(e,t){for(var n=e.getCount(),o=e.findTokenIndexAtOffset(t),r=e.getLanguageId(o),s=o;s+1<n&&e.getLanguageId(s+1)===r;)s++;for(var a=o;a>0&&e.getLanguageId(a-1)===r;)a--;return new i(e,r,a,s+1,e.getStartOffset(a),e.getEndOffset(s))};var i=function(){function e(e,t,i,n,o,r){this._actual=e,this.languageId=t,this._firstTokenIndex=i,
this._lastTokenIndex=n,this.firstCharOffset=o,this._lastCharOffset=r}return e.prototype.getLineContent=function(){return this._actual.getLineContent().substring(this.firstCharOffset,this._lastCharOffset)},e.prototype.getTokenCount=function(){return this._lastTokenIndex-this._firstTokenIndex},e.prototype.findTokenIndexAtOffset=function(e){return this._actual.findTokenIndexAtOffset(e+this.firstCharOffset)-this._firstTokenIndex},e.prototype.getStandardTokenType=function(e){return this._actual.getStandardTokenType(e+this._firstTokenIndex)},e}();t.ScopedLineTokens=i,t.ignoreBracketsInToken=function(e){return 0!=(7&e)}}),define(t[455],i([1,0,92]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(t){if(t.autoClosingPairs?this._autoClosingPairs=t.autoClosingPairs.map(function(e){return new i.StandardAutoClosingPairConditional(e)}):t.brackets?this._autoClosingPairs=t.brackets.map(function(e){return new i.StandardAutoClosingPairConditional({open:e[0],close:e[1]})
}):this._autoClosingPairs=[],t.__electricCharacterSupport&&t.__electricCharacterSupport.docComment){var n=t.__electricCharacterSupport.docComment;this._autoClosingPairs.push(new i.StandardAutoClosingPairConditional({open:n.open,close:n.close||""}))}this._autoCloseBefore="string"==typeof t.autoCloseBefore?t.autoCloseBefore:e.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED,this._surroundingPairs=t.surroundingPairs||this._autoClosingPairs}return e.prototype.getAutoClosingPairs=function(){return this._autoClosingPairs},e.prototype.getAutoCloseBeforeSet=function(){return this._autoCloseBefore},e.shouldAutoClosePair=function(e,t,i){if(0===t.getTokenCount())return!0;var n=t.findTokenIndexAtOffset(i-2),o=t.getStandardTokenType(n);return e.isOK(o)},e.prototype.getSurroundingPairs=function(){return this._surroundingPairs},e.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED=";:.,=}])> \n\t",e}();t.CharacterPairSupport=n}),define(t[457],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var i=function(){function e(e){this._indentationRules=e}return e.prototype.shouldIncrease=function(e){return!!(this._indentationRules&&this._indentationRules.increaseIndentPattern&&this._indentationRules.increaseIndentPattern.test(e))},e.prototype.shouldDecrease=function(e){return!!(this._indentationRules&&this._indentationRules.decreaseIndentPattern&&this._indentationRules.decreaseIndentPattern.test(e))},e.prototype.shouldIndentNextLine=function(e){return!!(this._indentationRules&&this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(e))},e.prototype.shouldIgnore=function(e){return!!(this._indentationRules&&this._indentationRules.unIndentedLinePattern&&this._indentationRules.unIndentedLinePattern.test(e))},e.prototype.getIndentMetadata=function(e){var t=0;return this.shouldIncrease(e)&&(t+=1),this.shouldDecrease(e)&&(t+=2),this.shouldIndentNextLine(e)&&(t+=4),this.shouldIgnore(e)&&(t+=8),t},e}();t.IndentRulesSupport=i}),define(t[469],i([1,0]),function(e,t){
"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,i,n,o){if(e&&t){if(r=this.doNavigateValueSet(t,o))return{range:e,value:r}}if(i&&n){var r=this.doNavigateValueSet(n,o);if(r)return{range:i,value:r}}return null},e.prototype.doNavigateValueSet=function(e,t){var i=this.numberReplace(e,t);return null!==i?i:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var i=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),n=Number(e),o=parseFloat(e);return isNaN(n)||isNaN(o)||n!==o?null:0!==n||t?(n=Math.floor(n*i),n+=t?i:-i,String(n/i)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,i){for(var n=null,o=0,r=e.length;null===n&&o<r;o++)n=this.valueSetReplace(e[o],t,i)
;return n},e.prototype.valueSetReplace=function(e,t,i){var n=e.indexOf(t);return n>=0?((n+=i?1:-1)<0?n=e.length-1:n%=e.length,e[n]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=i}),define(t[477],i([1,0,10,5,92]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(t){var i=this;(t=t||{}).brackets=t.brackets||[["(",")"],["{","}"],["[","]"]],this._brackets=[],t.brackets.forEach(function(t){var n=e._createOpenBracketRegExp(t[0]),o=e._createCloseBracketRegExp(t[1]);n&&o&&i._brackets.push({open:t[0],openRegExp:n,close:t[1],closeRegExp:o})}),this._regExpRules=t.regExpRules||[]}return e.prototype.onEnter=function(e,t,i){for(var n=0,r=this._regExpRules.length;n<r;n++){var s=this._regExpRules[n];if([{reg:s.beforeText,text:t},{reg:s.afterText,text:i},{reg:s.oneLineAboveText,text:e}].every(function(e){return!e.reg||e.reg.test(e.text)}))return s.action}if(t.length>0&&i.length>0)for(var n=0,r=this._brackets.length;n<r;n++){
if((a=this._brackets[n]).openRegExp.test(t)&&a.closeRegExp.test(i))return{indentAction:o.IndentAction.IndentOutdent}}if(t.length>0)for(var n=0,r=this._brackets.length;n<r;n++){var a=this._brackets[n];if(a.openRegExp.test(t))return{indentAction:o.IndentAction.Indent}}return null},e._createOpenBracketRegExp=function(t){var i=n.escapeRegExpCharacters(t);return/\B/.test(i.charAt(0))||(i="\\b"+i),i+="\\s*$",e._safeRegExp(i)},e._createCloseBracketRegExp=function(t){var i=n.escapeRegExpCharacters(t);return/\B/.test(i.charAt(i.length-1))||(i+="\\b"),i="^\\s*"+i,e._safeRegExp(i)},e._safeRegExp=function(e){try{return new RegExp(e)}catch(e){return i.onUnexpectedError(e),null}},e}();t.OnEnterSupport=r}),define(t[143],i([1,0,5,3]),function(e,t,i,n){"use strict";function o(e,t){var i={};return function(n){var o=e(n);return i.hasOwnProperty(o)||(i[o]=t(n)),i[o]}}function r(e){var t=/^[\w]+$/.test(e);return e=i.escapeRegExpCharacters(e),t?"\\b"+e+"\\b":e}function s(e){var t="("+e.map(r).join(")|(")+")"
;return i.createRegExp(t,!0)}Object.defineProperty(t,"__esModule",{value:!0});var a=function(){return function(e,t,i,n,o){this.languageIdentifier=e,this.open=t,this.close=i,this.forwardRegex=n,this.reversedRegex=o}}();t.RichEditBracket=a;var l=function(){return function(e,t){var i=this;this.brackets=t.map(function(t){return new a(e,t[0],t[1],u({open:t[0],close:t[1]}),d({open:t[0],close:t[1]}))}),this.forwardRegex=c(this.brackets),this.reversedRegex=h(this.brackets),this.textIsBracket={},this.textIsOpenBracket={};var n=0;this.brackets.forEach(function(e){i.textIsBracket[e.open.toLowerCase()]=e,i.textIsBracket[e.close.toLowerCase()]=e,i.textIsOpenBracket[e.open.toLowerCase()]=!0,i.textIsOpenBracket[e.close.toLowerCase()]=!1,n=Math.max(n,e.open.length),n=Math.max(n,e.close.length)}),this.maxBracketLength=n}}();t.RichEditBrackets=l;var u=o(function(e){return e.open+";"+e.close},function(e){return s([e.open,e.close])}),d=o(function(e){return e.open+";"+e.close},function(e){return s([p(e.open),p(e.close)])
}),c=o(function(e){return e.map(function(e){return e.open+";"+e.close}).join(";")},function(e){var t=[];return e.forEach(function(e){t.push(e.open),t.push(e.close)}),s(t)}),h=o(function(e){return e.map(function(e){return e.open+";"+e.close}).join(";")},function(e){var t=[];return e.forEach(function(e){t.push(p(e.open)),t.push(p(e.close))}),s(t)}),p=function(){var e=null,t=null;return function(i){return e!==i&&(t=function(e){for(var t="",i=e.length-1;i>=0;i--)t+=e.charAt(i);return t}(e=i)),t}}(),f=function(){function e(){}return e._findPrevBracketInText=function(e,t,i,o){var r=i.match(e);if(!r)return null;var s=i.length-(r.index||0),a=r[0].length,l=o+s;return new n.Range(t,l-a+1,t,l+1)},e.findPrevBracketInToken=function(e,t,i,n,o){var r=p(i).substring(i.length-o,i.length-n);return this._findPrevBracketInText(e,t,r,n)},e.findNextBracketInText=function(e,t,i,o){var r=i.match(e);if(!r)return null;var s=r.index||0,a=r[0].length;if(0===a)return null;var l=o+s;return new n.Range(t,l+1,t,l+1+a)},
e.findNextBracketInToken=function(e,t,i,n,o){var r=i.substring(n,o);return this.findNextBracketInText(e,t,r,n)},e}();t.BracketsUtils=f}),define(t[484],i([1,0,144,143]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e){this._richEditBrackets=e}return e.prototype.getElectricCharacters=function(){var e=[];if(this._richEditBrackets)for(var t=0,i=this._richEditBrackets.brackets.length;t<i;t++){var n=this._richEditBrackets.brackets[t],o=n.close.charAt(n.close.length-1);e.push(o)}return e=e.filter(function(e,t,i){return i.indexOf(e)===t})},e.prototype.onElectricCharacter=function(e,t,o){if(!this._richEditBrackets||0===this._richEditBrackets.brackets.length)return null;var r=t.findTokenIndexAtOffset(o-1);if(i.ignoreBracketsInToken(t.getStandardTokenType(r)))return null;var s=this._richEditBrackets.reversedRegex,a=t.getLineContent().substring(0,o-1)+e,l=n.BracketsUtils.findPrevBracketInToken(s,1,a,0,a.length);if(!l)return null
;var u=a.substring(l.startColumn-1,l.endColumn-1);u=u.toLowerCase();if(this._richEditBrackets.textIsOpenBracket[u])return null;var d=a.substring(0,l.startColumn-1);return/^\s*$/.test(d)?{matchOpenBracket:u}:null},e}();t.BracketElectricCharacterSupport=o}),define(t[40],i([1,0,10,4,2,5,3,99,92,144,455,484,457,477,143]),function(e,t,i,n,o,r,s,a,l,u,d,c,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(){function e(t,i,n){this._languageIdentifier=t,this._brackets=null,this._electricCharacter=null;var o=null;i&&(o=i._conf),this._conf=e._mergeConf(o,n),this.onEnter=e._handleOnEnter(this._conf),this.comments=e._handleComments(this._conf),this.characterPair=new d.CharacterPairSupport(this._conf),this.wordDefinition=this._conf.wordPattern||a.DEFAULT_WORD_REGEXP,this.indentationRules=this._conf.indentationRules,this._conf.indentationRules?this.indentRulesSupport=new h.IndentRulesSupport(this._conf.indentationRules):this.indentRulesSupport=null,this.foldingRules=this._conf.folding||{}}
return Object.defineProperty(e.prototype,"brackets",{get:function(){return!this._brackets&&this._conf.brackets&&(this._brackets=new f.RichEditBrackets(this._languageIdentifier,this._conf.brackets)),this._brackets},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"electricCharacter",{get:function(){return this._electricCharacter||(this._electricCharacter=new c.BracketElectricCharacterSupport(this.brackets)),this._electricCharacter},enumerable:!0,configurable:!0}),e._mergeConf=function(e,t){return{comments:e?t.comments||e.comments:t.comments,brackets:e?t.brackets||e.brackets:t.brackets,wordPattern:e?t.wordPattern||e.wordPattern:t.wordPattern,indentationRules:e?t.indentationRules||e.indentationRules:t.indentationRules,onEnterRules:e?t.onEnterRules||e.onEnterRules:t.onEnterRules,autoClosingPairs:e?t.autoClosingPairs||e.autoClosingPairs:t.autoClosingPairs,surroundingPairs:e?t.surroundingPairs||e.surroundingPairs:t.surroundingPairs,
autoCloseBefore:e?t.autoCloseBefore||e.autoCloseBefore:t.autoCloseBefore,folding:e?t.folding||e.folding:t.folding,__electricCharacterSupport:e?t.__electricCharacterSupport||e.__electricCharacterSupport:t.__electricCharacterSupport}},e._handleOnEnter=function(e){var t={},i=!0;return e.brackets&&(i=!1,t.brackets=e.brackets),e.indentationRules&&(i=!1),e.onEnterRules&&(i=!1,t.regExpRules=e.onEnterRules),i?null:new p.OnEnterSupport(t)},e._handleComments=function(e){var t=e.comments;if(!t)return null;var i={};if(t.lineComment&&(i.lineCommentToken=t.lineComment),t.blockComment){var n=t.blockComment,o=n[0],r=n[1];i.blockCommentStartToken=o,i.blockCommentEndToken=r}return i},e}();t.RichEditSupport=g;var m=function(){return function(e){this.languageIdentifier=e}}();t.LanguageConfigurationChangeEvent=m;var v=function(){function e(){this._entries=new Map,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event}return e.prototype.register=function(e,t){
var i=this,n=this._getRichEditSupport(e.id),r=new g(e,n,t);return this._entries.set(e.id,r),this._onDidChange.fire(new m(e)),o.toDisposable(function(){i._entries.get(e.id)===r&&(i._entries.set(e.id,n),i._onDidChange.fire(new m(e)))})},e.prototype._getRichEditSupport=function(e){return this._entries.get(e)},e.prototype._getElectricCharacterSupport=function(e){var t=this._getRichEditSupport(e);return t?t.electricCharacter||null:null},e.prototype.getElectricCharacters=function(e){var t=this._getElectricCharacterSupport(e);return t?t.getElectricCharacters():[]},e.prototype.onElectricCharacter=function(e,t,i){var n=u.createScopedLineTokens(t,i-1),o=this._getElectricCharacterSupport(n.languageId);return o?o.onElectricCharacter(e,n,i-n.firstCharOffset):null},e.prototype.getComments=function(e){var t=this._getRichEditSupport(e);return t?t.comments||null:null},e.prototype._getCharacterPairSupport=function(e){var t=this._getRichEditSupport(e);return t?t.characterPair||null:null},
e.prototype.getAutoClosingPairs=function(e){var t=this._getCharacterPairSupport(e);return t?t.getAutoClosingPairs():[]},e.prototype.getAutoCloseBeforeSet=function(e){var t=this._getCharacterPairSupport(e);return t?t.getAutoCloseBeforeSet():d.CharacterPairSupport.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED},e.prototype.getSurroundingPairs=function(e){var t=this._getCharacterPairSupport(e);return t?t.getSurroundingPairs():[]},e.prototype.shouldAutoClosePair=function(e,t,i){var n=u.createScopedLineTokens(t,i-1);return d.CharacterPairSupport.shouldAutoClosePair(e,n,i-n.firstCharOffset)},e.prototype.getWordDefinition=function(e){var t=this._getRichEditSupport(e);return t?a.ensureValidWordDefinition(t.wordDefinition||null):a.ensureValidWordDefinition(null)},e.prototype.getFoldingRules=function(e){var t=this._getRichEditSupport(e);return t?t.foldingRules:{}},e.prototype.getIndentRulesSupport=function(e){var t=this._getRichEditSupport(e);return t?t.indentRulesSupport||null:null},
e.prototype.getPrecedingValidLine=function(e,t,i){var n=e.getLanguageIdAtPosition(t,0);if(t>1){var o=void 0,r=-1;for(o=t-1;o>=1;o--){if(e.getLanguageIdAtPosition(o,0)!==n)return r;var s=e.getLineContent(o);if(!i.shouldIgnore(s)&&!/^\s+$/.test(s)&&""!==s)return o;r=o}}return-1},e.prototype.getInheritIndentForLine=function(e,t,i){void 0===i&&(i=!0);var n=this.getIndentRulesSupport(e.getLanguageIdentifier().id);if(!n)return null;if(t<=1)return{indentation:"",action:null};var o=this.getPrecedingValidLine(e,t,n);if(o<0)return null;if(o<1)return{indentation:"",action:null};var s=e.getLineContent(o);if(n.shouldIncrease(s)||n.shouldIndentNextLine(s))return{indentation:r.getLeadingWhitespace(s),action:l.IndentAction.Indent,line:o};if(n.shouldDecrease(s))return{indentation:r.getLeadingWhitespace(s),action:null,line:o};if(1===o)return{indentation:r.getLeadingWhitespace(e.getLineContent(o)),action:null,line:o};var a=o-1,u=n.getIndentMetadata(e.getLineContent(a));if(!(3&u)&&4&u){
for(var d=0,c=a-1;c>0;c--)if(!n.shouldIndentNextLine(e.getLineContent(c))){d=c;break}return{indentation:r.getLeadingWhitespace(e.getLineContent(d+1)),action:null,line:d+1}}if(i)return{indentation:r.getLeadingWhitespace(e.getLineContent(o)),action:null,line:o};for(c=o;c>0;c--){var h=e.getLineContent(c);if(n.shouldIncrease(h))return{indentation:r.getLeadingWhitespace(h),action:l.IndentAction.Indent,line:c};if(n.shouldIndentNextLine(h)){for(var d=0,p=c-1;p>0;p--)if(!n.shouldIndentNextLine(e.getLineContent(c))){d=p;break}return{indentation:r.getLeadingWhitespace(e.getLineContent(d+1)),action:null,line:d+1}}if(n.shouldDecrease(h))return{indentation:r.getLeadingWhitespace(h),action:null,line:c}}return{indentation:r.getLeadingWhitespace(e.getLineContent(1)),action:null,line:1}},e.prototype.getGoodIndentForLine=function(e,t,n,o){var s=this.getIndentRulesSupport(t);if(!s)return null;var a=this.getInheritIndentForLine(e,n),u=e.getLineContent(n);if(a){var d=a.line;if(void 0!==d){var c=this._getOnEnterSupport(t),h=null
;try{c&&(h=c.onEnter("",e.getLineContent(d),""))}catch(e){i.onUnexpectedError(e)}if(h){var p=r.getLeadingWhitespace(e.getLineContent(d));return h.removeText&&(p=p.substring(0,p.length-h.removeText)),h.indentAction===l.IndentAction.Indent||h.indentAction===l.IndentAction.IndentOutdent?p=o.shiftIndent(p):h.indentAction===l.IndentAction.Outdent&&(p=o.unshiftIndent(p)),s.shouldDecrease(u)&&(p=o.unshiftIndent(p)),h.appendText&&(p+=h.appendText),r.getLeadingWhitespace(p)}}return s.shouldDecrease(u)?a.action===l.IndentAction.Indent?a.indentation:o.unshiftIndent(a.indentation):a.action===l.IndentAction.Indent?o.shiftIndent(a.indentation):a.indentation}return null},e.prototype.getIndentForEnter=function(e,t,i,n){e.forceTokenization(t.startLineNumber);var o,s,a=e.getLineTokens(t.startLineNumber),d=u.createScopedLineTokens(a,t.startColumn-1),c=d.getLineContent(),h=!1;if(d.firstCharOffset>0&&a.getLanguageId(0)!==d.languageId?(h=!0,
o=c.substr(0,t.startColumn-1-d.firstCharOffset)):o=a.getLineContent().substring(0,t.startColumn-1),t.isEmpty())s=c.substr(t.startColumn-1-d.firstCharOffset);else{s=this.getScopedLineTokens(e,t.endLineNumber,t.endColumn).getLineContent().substr(t.endColumn-1-d.firstCharOffset)}var p=this.getIndentRulesSupport(d.languageId);if(!p)return null;var f=o,g=r.getLeadingWhitespace(o);if(!n&&!h){var m=this.getInheritIndentForLine(e,t.startLineNumber);p.shouldDecrease(o)&&m&&(g=m.indentation,m.action!==l.IndentAction.Indent&&(g=i.unshiftIndent(g))),f=g+r.ltrim(r.ltrim(o," "),"\t")}var v={getLineTokens:function(t){return e.getLineTokens(t)},getLanguageIdentifier:function(){return e.getLanguageIdentifier()},getLanguageIdAtPosition:function(t,i){return e.getLanguageIdAtPosition(t,i)},getLineContent:function(i){return i===t.startLineNumber?f:e.getLineContent(i)}},_=r.getLeadingWhitespace(a.getLineContent()),y=this.getInheritIndentForLine(v,t.startLineNumber+1);if(!y){var b=h?_:g;return{beforeEnter:b,afterEnter:b}}
var C=h?_:y.indentation;return y.action===l.IndentAction.Indent&&(C=i.shiftIndent(C)),p.shouldDecrease(s)&&(C=i.unshiftIndent(C)),{beforeEnter:h?_:g,afterEnter:C}},e.prototype.getIndentActionForType=function(e,t,i,n){var o=this.getScopedLineTokens(e,t.startLineNumber,t.startColumn),r=this.getIndentRulesSupport(o.languageId);if(!r)return null;var s,a=o.getLineContent(),u=a.substr(0,t.startColumn-1-o.firstCharOffset);if(t.isEmpty())s=a.substr(t.startColumn-1-o.firstCharOffset);else{s=this.getScopedLineTokens(e,t.endLineNumber,t.endColumn).getLineContent().substr(t.endColumn-1-o.firstCharOffset)}if(!r.shouldDecrease(u+s)&&r.shouldDecrease(u+i+s)){var d=this.getInheritIndentForLine(e,t.startLineNumber,!1);if(!d)return null;var c=d.indentation;return d.action!==l.IndentAction.Indent&&(c=n.unshiftIndent(c)),c}return null},e.prototype.getIndentMetadata=function(e,t){var i=this.getIndentRulesSupport(e.getLanguageIdentifier().id);return i?t<1||t>e.getLineCount()?null:i.getIndentMetadata(e.getLineContent(t)):null},
e.prototype._getOnEnterSupport=function(e){var t=this._getRichEditSupport(e);return t?t.onEnter||null:null},e.prototype.getRawEnterActionAtPosition=function(e,t,i){var n=this.getEnterAction(e,new s.Range(t,i,t,i));return n?n.enterAction:null},e.prototype.getEnterAction=function(e,t){var n=this.getIndentationAtPosition(e,t.startLineNumber,t.startColumn),o=this.getScopedLineTokens(e,t.startLineNumber,t.startColumn),r=this._getOnEnterSupport(o.languageId);if(!r)return null;var s,a=o.getLineContent(),u=a.substr(0,t.startColumn-1-o.firstCharOffset);if(t.isEmpty())s=a.substr(t.startColumn-1-o.firstCharOffset);else{s=this.getScopedLineTokens(e,t.endLineNumber,t.endColumn).getLineContent().substr(t.endColumn-1-o.firstCharOffset)}var d=t.startLineNumber,c="";if(d>1&&0===o.firstCharOffset){var h=this.getScopedLineTokens(e,d-1);h.languageId===o.languageId&&(c=h.getLineContent())}var p=null;try{p=r.onEnter(c,u,s)}catch(e){i.onUnexpectedError(e)}
return p?(p.appendText||(p.indentAction===l.IndentAction.Indent||p.indentAction===l.IndentAction.IndentOutdent?p.appendText="\t":p.appendText=""),p.removeText&&(n=n.substring(0,n.length-p.removeText)),{enterAction:p,indentation:n}):null},e.prototype.getIndentationAtPosition=function(e,t,i){var n=e.getLineContent(t),o=r.getLeadingWhitespace(n);return o.length>i-1&&(o=o.substring(0,i-1)),o},e.prototype.getScopedLineTokens=function(e,t,i){e.forceTokenization(t);var n=e.getLineTokens(t),o=void 0===i?e.getLineMaxColumn(t)-1:i-1;return u.createScopedLineTokens(n,o)},e.prototype.getBracketsSupport=function(e){var t=this._getRichEditSupport(e);return t?t.brackets||null:null},e}();t.LanguageConfigurationRegistryImpl=v,t.LanguageConfigurationRegistry=new v}),define(t[487],i([1,0,25]),function(e,t,i){"use strict";function n(e){if(!e||!Array.isArray(e))return[];for(var t=[],i=0,n=0,o=e.length;n<o;n++){var r=e[n],s=-1;if("string"==typeof r.fontStyle){s=0;for(var l=r.fontStyle.split(" "),u=0,d=l.length;u<d;u++){
switch(l[u]){case"italic":s|=1;break;case"bold":s|=2;break;case"underline":s|=4}}}var c=null;"string"==typeof r.foreground&&(c=r.foreground);var h=null;"string"==typeof r.background&&(h=r.background),t[i++]=new a(r.token||"",n,s,c,h)}return t}function o(e,t){e.sort(function(e,t){var i=s(e.token,t.token);return 0!==i?i:e.index-t.index});for(var i=0,n="000000",o="ffffff";e.length>=1&&""===e[0].token;){var r=e.shift();-1!==r.fontStyle&&(i=r.fontStyle),null!==r.foreground&&(n=r.foreground),null!==r.background&&(o=r.background)}for(var a=new u,l=0,c=t;l<c.length;l++){var f=c[l];a.getId(f)}for(var g=a.getId(n),m=a.getId(o),v=new h(i,g,m),_=new p(v),y=0,b=e.length;y<b;y++){var C=e[y];_.insert(C.token,C.fontStyle,a.getId(C.foreground),a.getId(C.background))}return new d(a,_)}function r(e){var t=e.match(c);if(!t)return 0;switch(t[1]){case"comment":return 1;case"string":return 2;case"regex":case"regexp":return 4}throw new Error("Unexpected match for standard token type!")}function s(e,t){return e<t?-1:e>t?1:0}
Object.defineProperty(t,"__esModule",{value:!0});var a=function(){return function(e,t,i,n,o){this.token=e,this.index=t,this.fontStyle=i,this.foreground=n,this.background=o}}();t.ParsedTokenThemeRule=a,t.parseTokenTheme=n;var l=/^#?([0-9A-Fa-f]{6})([0-9A-Fa-f]{2})?$/,u=function(){function e(){this._lastColorId=0,this._id2color=[],this._color2id=new Map}return e.prototype.getId=function(e){if(null===e)return 0;var t=e.match(l);if(!t)throw new Error("Illegal value for token color: "+e);e=t[1].toUpperCase();var n=this._color2id.get(e);return n||(n=++this._lastColorId,this._color2id.set(e,n),this._id2color[n]=i.Color.fromHex("#"+e),n)},e.prototype.getColorMap=function(){return this._id2color.slice(0)},e}();t.ColorMap=u;var d=function(){function e(e,t){this._colorMap=e,this._root=t,this._cache=new Map}return e.createFromRawTokenTheme=function(e,t){return this.createFromParsedTokenTheme(n(e),t)},e.createFromParsedTokenTheme=function(e,t){return o(e,t)},e.prototype.getColorMap=function(){
return this._colorMap.getColorMap()},e.prototype._match=function(e){return this._root.match(e)},e.prototype.match=function(e,t){var i=this._cache.get(t);if(void 0===i){var n=this._match(t),o=r(t);i=(n.metadata|o<<8)>>>0,this._cache.set(t,i)}return(i|e<<0)>>>0},e}();t.TokenTheme=d;var c=/\b(comment|string|regex|regexp)\b/;t.toStandardTokenType=r,t.strcmp=s;var h=function(){function e(e,t,i){this._fontStyle=e,this._foreground=t,this._background=i,this.metadata=(this._fontStyle<<11|this._foreground<<14|this._background<<23)>>>0}return e.prototype.clone=function(){return new e(this._fontStyle,this._foreground,this._background)},e.prototype.acceptOverwrite=function(e,t,i){-1!==e&&(this._fontStyle=e),0!==t&&(this._foreground=t),0!==i&&(this._background=i),this.metadata=(this._fontStyle<<11|this._foreground<<14|this._background<<23)>>>0},e}();t.ThemeTrieElementRule=h;var p=function(){function e(e){this._mainRule=e,this._children=new Map}return e.prototype.match=function(e){if(""===e)return this._mainRule
;var t,i,n=e.indexOf(".");-1===n?(t=e,i=""):(t=e.substring(0,n),i=e.substring(n+1));var o=this._children.get(t);return void 0!==o?o.match(i):this._mainRule},e.prototype.insert=function(t,i,n,o){if(""!==t){var r,s,a=t.indexOf(".");-1===a?(r=t,s=""):(r=t.substring(0,a),s=t.substring(a+1));var l=this._children.get(r);void 0===l&&(l=new e(this._mainRule.clone()),this._children.set(r,l)),l.insert(s,i,n,o)}else this._mainRule.acceptOverwrite(i,n,o)},e}();t.ThemeTrieElement=p,t.generateTokensCSSForColorMap=function(e){for(var t=[],i=1,n=e.length;i<n;i++){var o=e[i];t[i]=".mtk"+i+" { color: "+o+"; }"}return t.push(".mtki { font-style: italic; }"),t.push(".mtkb { font-weight: bold; }"),t.push(".mtku { text-decoration: underline; text-underline-position: under; }"),t.join("\n")}}),define(t[496],i([1,0,4,2,23,41]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(){this._map=new Map,this._promises=new Map,this._onDidChange=new i.Emitter,
this.onDidChange=this._onDidChange.event,this._colorMap=null}return e.prototype.fire=function(e){this._onDidChange.fire({changedLanguages:e,changedColorMap:!1})},e.prototype.register=function(e,t){var i=this;return this._map.set(e,t),this.fire([e]),n.toDisposable(function(){i._map.get(e)===t&&(i._map.delete(e),i.fire([e]))})},e.prototype.registerPromise=function(e,t){var i=this,o=null,r=!1;return this._promises.set(e,t.then(function(t){i._promises.delete(e),!r&&t&&(o=i.register(e,t))})),n.toDisposable(function(){r=!0,o&&o.dispose()})},e.prototype.getPromise=function(e){var t=this,i=this.get(e);if(i)return Promise.resolve(i);var n=this._promises.get(e);return n?n.then(function(i){return t.get(e)}):null},e.prototype.get=function(e){return o.withUndefinedAsNull(this._map.get(e))},e.prototype.setColorMap=function(e){this._colorMap=e,this._onDidChange.fire({changedLanguages:r.keys(this._map),changedColorMap:!0})},e.prototype.getColorMap=function(){return this._colorMap},e.prototype.getDefaultBackground=function(){
return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null},e}();t.TokenizationRegistryImpl=s}),/*!
Copyright (c) 2014 Taylor Hakes
Copyright (c) 2014 Forbes Lindesay
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t():"function"==typeof define&&define.amd?define("vs/editor/common/standalone/promise-polyfill/polyfill",t):t()}(0,function(){"use strict";function e(e){var t=this.constructor;return this.then(function(i){return t.resolve(e()).then(function(){return i})},function(i){return t.resolve(e()).then(function(){return t.reject(i)})})}function t(){}function i(e){if(!(this instanceof i))throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],a(e,this)}function n(e,t){for(;3===e._state;)e=e._value;0!==e._state?(e._handled=!0,i._immediateFn(function(){var i=1===e._state?t.onFulfilled:t.onRejected;if(null!==i){var n;try{n=i(e._value)}catch(e){return void r(t.promise,e)}o(t.promise,n)}else(1===e._state?o:r)(t.promise,e._value)})):e._deferreds.push(t)}function o(e,t){try{
if(t===e)throw new TypeError("A promise cannot be resolved with itself.");if(t&&("object"==typeof t||"function"==typeof t)){var n=t.then;if(t instanceof i)return e._state=3,e._value=t,void s(e);if("function"==typeof n)return void a(function(e,t){return function(){e.apply(t,arguments)}}(n,t),e)}e._state=1,e._value=t,s(e)}catch(t){r(e,t)}}function r(e,t){e._state=2,e._value=t,s(e)}function s(e){2===e._state&&0===e._deferreds.length&&i._immediateFn(function(){e._handled||i._unhandledRejectionFn(e._value)});for(var t=0,o=e._deferreds.length;t<o;t++)n(e,e._deferreds[t]);e._deferreds=null}function a(e,t){var i=!1;try{e(function(e){i||(i=!0,o(t,e))},function(e){i||(i=!0,r(t,e))})}catch(e){if(i)return;i=!0,r(t,e)}}var l=setTimeout;i.prototype.catch=function(e){return this.then(null,e)},i.prototype.then=function(e,i){var o=new this.constructor(t);return n(this,new function(e,t,i){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof t?t:null,this.promise=i}(e,i,o)),o},i.prototype.finally=e,
i.all=function(e){return new i(function(t,i){function n(e,s){try{if(s&&("object"==typeof s||"function"==typeof s)){var a=s.then;if("function"==typeof a)return void a.call(s,function(t){n(e,t)},i)}o[e]=s,0==--r&&t(o)}catch(e){i(e)}}if(!e||void 0===e.length)throw new TypeError("Promise.all accepts an array");var o=Array.prototype.slice.call(e);if(0===o.length)return t([]);for(var r=o.length,s=0;s<o.length;s++)n(s,o[s])})},i.resolve=function(e){return e&&"object"==typeof e&&e.constructor===i?e:new i(function(t){t(e)})},i.reject=function(e){return new i(function(t,i){i(e)})},i.race=function(e){return new i(function(t,i){for(var n=0,o=e.length;n<o;n++)e[n].then(t,i)})},i._immediateFn="function"==typeof setImmediate&&function(e){setImmediate(e)}||function(e){l(e,0)},i._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)};var u=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window
;if("undefined"!=typeof global)return global;throw new Error("unable to locate global object")}();"Promise"in u?u.Promise.prototype.finally||(u.Promise.prototype.finally=e):u.Promise=i}),define(t[141],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.MarkerTag||(t.MarkerTag={}));!function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"}(t.MarkerSeverity||(t.MarkerSeverity={}));!function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",
e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",
e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",
e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"}(t.KeyCode||(t.KeyCode={}));!function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={}));!function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"}(t.ScrollbarVisibility||(t.ScrollbarVisibility={}));!function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(t.OverviewRulerLane||(t.OverviewRulerLane={}));!function(e){e[e.Inline=1]="Inline"}(t.MinimapPosition||(t.MinimapPosition={}));!function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLinePreference||(t.EndOfLinePreference={}));!function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"
}(t.DefaultEndOfLine||(t.DefaultEndOfLine={}));!function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(t.EndOfLineSequence||(t.EndOfLineSequence={}));!function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));!function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"}(t.ScrollType||(t.ScrollType={}));!function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"}(t.CursorChangeReason||(t.CursorChangeReason={}));!function(e){e[e.None=0]="None",e[e.Small=1]="Small",e[e.Large=2]="Large",e[e.SmallBlocks=3]="SmallBlocks",e[e.LargeBlocks=4]="LargeBlocks"}(t.RenderMinimap||(t.RenderMinimap={}));!function(e){
e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(t.WrappingIndent||(t.WrappingIndent={}));!function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));!function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));!function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"}(t.RenderLineNumbersType||(t.RenderLineNumbersType={}));!function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));!function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",
e[e.TOP_CENTER=2]="TOP_CENTER"}(t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));!function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(t.MouseTargetType||(t.MouseTargetType={}));!function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={}));!function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",
e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.Snippet=25]="Snippet"}(t.CompletionItemKind||(t.CompletionItemKind={}));!function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={}));!function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));!function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"
}(t.CompletionTriggerKind||(t.CompletionTriggerKind={}));!function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));!function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={}));!function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",
e[e.TypeParameter=25]="TypeParameter"}(t.SymbolKind||(t.SymbolKind={}));!function(e){e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={}))}),define(t[170],i([1,0,26,4,38,24,13,3,20,106,141,601]),function(e,t,i,n,o,r,s,a,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(){}return e.chord=function(e,t){return o.KeyChord(e,t)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();t.KeyMod=c,t.createMonacoBaseAPI=function(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.CancellationTokenSource,Emitter:n.Emitter,KeyCode:d.KeyCode,KeyMod:c,Position:s.Position,Range:a.Range,Selection:l.Selection,SelectionDirection:d.SelectionDirection,MarkerSeverity:d.MarkerSeverity,MarkerTag:d.MarkerTag,Uri:r.URI,Token:u.Token}}}),define(t[171],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i){this.from=0|e,this.to=0|t,this.colorId=0|i}return e.compare=function(e,t){
return e.colorId===t.colorId?e.from===t.from?e.to-t.to:e.from-t.from:e.colorId-t.colorId},e}();t.ColorZone=i;var n=function(){function e(e,t,i){this.startLineNumber=e,this.endLineNumber=t,this.color=i,this._colorZone=null}return e.compare=function(e,t){return e.color===t.color?e.startLineNumber===t.startLineNumber?e.endLineNumber-t.endLineNumber:e.startLineNumber-t.startLineNumber:e.color<t.color?-1:1},e.prototype.setColorZone=function(e){this._colorZone=e},e.prototype.getColorZones=function(){return this._colorZone},e}();t.OverviewRulerZone=n;var o=function(){function e(e){this._getVerticalOffsetForLine=e,this._zones=[],this._colorZonesInvalid=!1,this._lineHeight=0,this._domWidth=0,this._domHeight=0,this._outerHeight=0,this._pixelRatio=1,this._lastAssignedId=0,this._color2Id=Object.create(null),this._id2Color=[]}return e.prototype.getId2Color=function(){return this._id2Color},e.prototype.setZones=function(e){this._zones=e,this._zones.sort(n.compare)},e.prototype.setLineHeight=function(e){
return this._lineHeight!==e&&(this._lineHeight=e,this._colorZonesInvalid=!0,!0)},e.prototype.setPixelRatio=function(e){this._pixelRatio=e,this._colorZonesInvalid=!0},e.prototype.getDOMWidth=function(){return this._domWidth},e.prototype.getCanvasWidth=function(){return this._domWidth*this._pixelRatio},e.prototype.setDOMWidth=function(e){return this._domWidth!==e&&(this._domWidth=e,this._colorZonesInvalid=!0,!0)},e.prototype.getDOMHeight=function(){return this._domHeight},e.prototype.getCanvasHeight=function(){return this._domHeight*this._pixelRatio},e.prototype.setDOMHeight=function(e){return this._domHeight!==e&&(this._domHeight=e,this._colorZonesInvalid=!0,!0)},e.prototype.getOuterHeight=function(){return this._outerHeight},e.prototype.setOuterHeight=function(e){return this._outerHeight!==e&&(this._outerHeight=e,this._colorZonesInvalid=!0,!0)},e.prototype.resolveColorZones=function(){
for(var e=this._colorZonesInvalid,t=Math.floor(this._lineHeight),n=Math.floor(this.getCanvasHeight()),o=n/Math.floor(this._outerHeight),r=Math.floor(4*this._pixelRatio/2),s=[],a=0,l=this._zones.length;a<l;a++){var u=this._zones[a];if(!e){var d=u.getColorZones();if(d){s.push(d);continue}}var c=Math.floor(o*this._getVerticalOffsetForLine(u.startLineNumber)),h=Math.floor(o*(this._getVerticalOffsetForLine(u.endLineNumber)+t)),p=Math.floor((c+h)/2),f=h-p;f<r&&(f=r),p-f<0&&(p=f),p+f>n&&(p=n-f);var g=u.color,m=this._color2Id[g];m||(m=++this._lastAssignedId,this._color2Id[g]=m,this._id2Color[m]=g);var v=new i(p-f,p+f,m);u.setColorZone(v),s.push(v)}return this._colorZonesInvalid=!1,s.sort(i.compare),s},e}();t.OverviewZoneManager=o}),define(t[88],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t){this._viewLayout=e,this.viewportData=t,this.scrollWidth=this._viewLayout.getScrollWidth(),this.scrollHeight=this._viewLayout.getScrollHeight(),
this.visibleRange=this.viewportData.visibleRange,this.bigNumbersDelta=this.viewportData.bigNumbersDelta;var i=this._viewLayout.getCurrentViewport();this.scrollTop=i.top,this.scrollLeft=i.left,this.viewportWidth=i.width,this.viewportHeight=i.height}return e.prototype.getScrolledTopFromAbsoluteTop=function(e){return e-this.scrollTop},e.prototype.getVerticalOffsetForLineNumber=function(e){return this._viewLayout.getVerticalOffsetForLineNumber(e)},e.prototype.getDecorationsInViewport=function(){return this.viewportData.getDecorationsInViewport()},e}();t.RestrictedRenderingContext=i;var n=function(e){function t(t,i,n){var o=e.call(this,t,i)||this;return o._viewLines=n,o}return r(t,e),t.prototype.linesVisibleRangesForRange=function(e,t){return this._viewLines.linesVisibleRangesForRange(e,t)},t.prototype.visibleRangeForPosition=function(e){return this._viewLines.visibleRangeForPosition(e)},t}(i);t.RenderingContext=n;var o=function(){return function(e,t){this.lineNumber=e,this.ranges=t}}();t.LineVisibleRanges=o
;var s=function(){function e(e,t){this.left=Math.round(e),this.width=Math.round(t)}return e.prototype.toString=function(){return"["+this.left+","+this.width+"]"},e}();t.HorizontalRange=s}),define(t[519],i([1,0,88]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this.left=e,this.width=t}return e.prototype.toString=function(){return"["+this.left+","+this.width+"]"},e.compare=function(e,t){return e.left-t.left},e}(),o=function(){function e(){}return e._createRange=function(){return this._handyReadyRange||(this._handyReadyRange=document.createRange()),this._handyReadyRange},e._detachRange=function(e,t){e.selectNodeContents(t)},e._readClientRects=function(e,t,i,n,o){var r=this._createRange();try{return r.setStart(e,t),r.setEnd(i,n),r.getClientRects()}catch(e){return null}finally{this._detachRange(r,o)}},e._mergeAdjacentRanges=function(e){if(1===e.length)return[new i.HorizontalRange(e[0].left,e[0].width)];e.sort(n.compare)
;for(var t=[],o=0,r=e[0].left,s=e[0].width,a=1,l=e.length;a<l;a++){var u=e[a],d=u.left,c=u.width;r+s+.9>=d?s=Math.max(s,d+c-r):(t[o++]=new i.HorizontalRange(r,s),r=d,s=c)}return t[o++]=new i.HorizontalRange(r,s),t},e._createHorizontalRangesFromClientRects=function(e,t){if(!e||0===e.length)return null;for(var i=[],o=0,r=e.length;o<r;o++){var s=e[o];i[o]=new n(Math.max(0,s.left-t),s.width)}return this._mergeAdjacentRanges(i)},e.readHorizontalRanges=function(e,t,i,n,o,r,s){var a=e.children.length-1;if(0>a)return null;(t=Math.min(a,Math.max(0,t)))!==(n=Math.min(a,Math.max(0,n)))&&n>0&&0===o&&(n--,o=1073741824);var l=e.children[t].firstChild,u=e.children[n].firstChild;if(l&&u||(!l&&0===i&&t>0&&(l=e.children[t-1].firstChild,i=1073741824),!u&&0===o&&n>0&&(u=e.children[n-1].firstChild,o=1073741824)),!l||!u)return null;i=Math.min(l.textContent.length,Math.max(0,i)),o=Math.min(u.textContent.length,Math.max(0,o));var d=this._readClientRects(l,i,u,o,s);return this._createHorizontalRangesFromClientRects(d,r)},e}()
;t.RangeUtil=o}),define(t[520],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e,t,i,n){this.configuration=e,this.theme=t,this.model=i,this.viewLayout=i.viewLayout,this.privateViewEventBus=n}return e.prototype.addEventHandler=function(e){this.privateViewEventBus.addEventHandler(e)},e.prototype.removeEventHandler=function(e){this.privateViewEventBus.removeEventHandler(e)},e}();t.ViewContext=i}),define(t[532],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this._eventHandlerGateKeeper=e,this._eventHandlers=[],this._eventQueue=null,this._isConsumingQueue=!1}return e.prototype.addEventHandler=function(e){for(var t=0,i=this._eventHandlers.length;t<i;t++)this._eventHandlers[t]===e&&console.warn("Detected duplicate listener in ViewEventDispatcher",e);this._eventHandlers.push(e)},e.prototype.removeEventHandler=function(e){
for(var t=0;t<this._eventHandlers.length;t++)if(this._eventHandlers[t]===e){this._eventHandlers.splice(t,1);break}},e.prototype.emit=function(e){this._eventQueue?this._eventQueue.push(e):this._eventQueue=[e],this._isConsumingQueue||this.consumeQueue()},e.prototype.emitMany=function(e){this._eventQueue?this._eventQueue=this._eventQueue.concat(e):this._eventQueue=e,this._isConsumingQueue||this.consumeQueue()},e.prototype.consumeQueue=function(){var e=this;this._eventHandlerGateKeeper(function(){try{e._isConsumingQueue=!0,e._doConsumeQueue()}finally{e._isConsumingQueue=!1}})},e.prototype._doConsumeQueue=function(){for(;this._eventQueue;){var e=this._eventQueue;this._eventQueue=null;for(var t=this._eventHandlers.slice(0),i=0,n=t.length;i<n;i++)t[i].handleEvents(e)}},e}();t.ViewEventDispatcher=i}),define(t[77],i([1,0,10,2]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){return function(e){this.type=1,this.canUseLayerHinting=e.canUseLayerHinting,
this.pixelRatio=e.pixelRatio,this.editorClassName=e.editorClassName,this.lineHeight=e.lineHeight,this.readOnly=e.readOnly,this.accessibilitySupport=e.accessibilitySupport,this.emptySelectionClipboard=e.emptySelectionClipboard,this.copyWithSyntaxHighlighting=e.copyWithSyntaxHighlighting,this.layoutInfo=e.layoutInfo,this.fontInfo=e.fontInfo,this.viewInfo=e.viewInfo,this.wrappingInfo=e.wrappingInfo}}();t.ViewConfigurationChangedEvent=o;var s=function(){return function(e){this.type=2,this.selections=e}}();t.ViewCursorStateChangedEvent=s;var a=function(){return function(){this.type=3}}();t.ViewDecorationsChangedEvent=a;var l=function(){return function(){this.type=4}}();t.ViewFlushedEvent=l;var u=function(){return function(e){this.type=5,this.isFocused=e}}();t.ViewFocusChangedEvent=u;var d=function(){return function(){this.type=6}}();t.ViewLineMappingChangedEvent=d;var c=function(){return function(e,t){this.type=7,this.fromLineNumber=e,this.toLineNumber=t}}();t.ViewLinesChangedEvent=c;var h=function(){
return function(e,t){this.type=8,this.fromLineNumber=e,this.toLineNumber=t}}();t.ViewLinesDeletedEvent=h;var p=function(){return function(e,t){this.type=9,this.fromLineNumber=e,this.toLineNumber=t}}();t.ViewLinesInsertedEvent=p;var f=function(){return function(e,t,i,n){this.type=10,this.range=e,this.verticalType=t,this.revealHorizontal=i,this.scrollType=n}}();t.ViewRevealRangeRequestEvent=f;var g=function(){return function(e){this.type=11,this.scrollWidth=e.scrollWidth,this.scrollLeft=e.scrollLeft,this.scrollHeight=e.scrollHeight,this.scrollTop=e.scrollTop,this.scrollWidthChanged=e.scrollWidthChanged,this.scrollLeftChanged=e.scrollLeftChanged,this.scrollHeightChanged=e.scrollHeightChanged,this.scrollTopChanged=e.scrollTopChanged}}();t.ViewScrollChangedEvent=g;var m=function(){return function(e){this.type=12,this.ranges=e}}();t.ViewTokensChangedEvent=m;var v=function(){return function(){this.type=15}}();t.ViewThemeChangedEvent=v;var _=function(){return function(){this.type=13}}()
;t.ViewTokensColorsChangedEvent=_;var y=function(){return function(){this.type=14}}();t.ViewZonesChangedEvent=y;var b=function(){return function(){this.type=16}}();t.ViewLanguageConfigurationEvent=b;var C=function(e){function t(){var t=e.call(this)||this;return t._listeners=[],t._collector=null,t._collectorCnt=0,t}return r(t,e),t.prototype.dispose=function(){this._listeners=[],e.prototype.dispose.call(this)},t.prototype._beginEmit=function(){return this._collectorCnt++,1===this._collectorCnt&&(this._collector=new S),this._collector},t.prototype._endEmit=function(){if(this._collectorCnt--,0===this._collectorCnt){var e=this._collector.finalize();this._collector=null,e.length>0&&this._emit(e)}},t.prototype._emit=function(e){for(var t=this._listeners.slice(0),n=0,o=t.length;n<o;n++)!function(e,t){try{e(t)}catch(e){i.onUnexpectedError(e)}}(t[n],e)},t.prototype.addEventListener=function(e){var t=this;return this._listeners.push(e),n.toDisposable(function(){for(var i=t._listeners,n=0,o=i.length;n<o;n++)if(i[n]===e){
i.splice(n,1);break}})},t}(n.Disposable);t.ViewEventEmitter=C;var S=function(){function e(){this._eventsLen=0,this._events=[],this._eventsLen=0}return e.prototype.emit=function(e){this._events[this._eventsLen++]=e},e.prototype.finalize=function(){var e=this._events;return this._events=[],e},e}();t.ViewEventsCollector=S}),define(t[138],i([1,0,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i,n){this.startColumn=e,this.endColumn=t,this.className=i,this.type=n}return e._equals=function(e,t){return e.startColumn===t.startColumn&&e.endColumn===t.endColumn&&e.className===t.className&&e.type===t.type},e.equalsArr=function(t,i){var n=t.length;if(n!==i.length)return!1;for(var o=0;o<n;o++)if(!e._equals(t[o],i[o]))return!1;return!0},e.filter=function(t,i,n,o){if(0===t.length)return[];for(var r=[],s=0,a=0,l=t.length;a<l;a++){var u=t[a],d=u.range;if(!(d.endLineNumber<i||d.startLineNumber>i)&&(!d.isEmpty()||0!==u.type&&3!==u.type)){
var c=d.startLineNumber===i?d.startColumn:n,h=d.endLineNumber===i?d.endColumn:o;r[s++]=new e(c,h,u.inlineClassName,u.type)}}return r},e.compare=function(e,t){return e.startColumn===t.startColumn?e.endColumn===t.endColumn?e.className<t.className?-1:e.className>t.className?1:0:e.endColumn-t.endColumn:e.startColumn-t.startColumn},e}();t.LineDecoration=n;var o=function(){return function(e,t,i){this.startOffset=e,this.endOffset=t,this.className=i}}();t.DecorationSegment=o;var r=function(){function e(){this.stopOffsets=[],this.classNames=[],this.count=0}return e.prototype.consumeLowerThan=function(e,t,i){for(;this.count>0&&this.stopOffsets[0]<e;){for(var n=0;n+1<this.count&&this.stopOffsets[n]===this.stopOffsets[n+1];)n++;i.push(new o(t,this.stopOffsets[n],this.classNames.join(" "))),t=this.stopOffsets[n]+1,this.stopOffsets.splice(0,n+1),this.classNames.splice(0,n+1),this.count-=n+1}return this.count>0&&t<e&&(i.push(new o(t,e-1,this.classNames.join(" "))),t=e),t},e.prototype.insert=function(e,t){
if(0===this.count||this.stopOffsets[this.count-1]<=e)this.stopOffsets.push(e),this.classNames.push(t);else for(var i=0;i<this.count;i++)if(this.stopOffsets[i]>=e){this.stopOffsets.splice(i,0,e),this.classNames.splice(i,0,t);break}this.count++},e}(),s=function(){function e(){}return e.normalize=function(e,t){if(0===t.length)return[];for(var n=[],o=new r,s=0,a=0,l=t.length;a<l;a++){var u=t[a],d=u.startColumn,c=u.endColumn,h=u.className;if(d>1){p=e.charCodeAt(d-2);i.isHighSurrogate(p)&&d--}if(c>1){var p=e.charCodeAt(c-2);i.isHighSurrogate(p)&&c--}var f=d-1,g=c-2;s=o.consumeLowerThan(f,s,n),0===o.count&&(s=f),o.insert(g,h)}return o.consumeLowerThan(1073741824,s,n),n},e}();t.LineDecorationsNormalizer=s}),define(t[94],i([1,0,5,156,138]),function(e,t,i,n,o){"use strict";function r(e,t){if(0===e.lineContent.length){var n=0,r="<span><span> </span></span>";if(e.lineDecorations.length>0){for(var a=[],l=0,c=e.lineDecorations.length;l<c;l++){var p=e.lineDecorations[l];1===p.type&&(a.push(e.lineDecorations[l].className),
n|=1),2===p.type&&(a.push(e.lineDecorations[l].className),n|=2)}0!==n&&(r='<span><span class="'+a.join(" ")+'"></span></span>')}return t.appendASCIIString(r),new d(new u(0,0),!1,n)}return function(e,t){var n=e.fontIsMonospace,o=e.canUseHalfwidthRightwardsArrow,r=e.containsForeignElements,s=e.lineContent,a=e.len,l=e.isOverflowing,c=e.parts,h=e.tabSize,p=e.containsRTL,f=e.spaceWidth,g=e.renderWhitespace,m=e.renderControlCharacters,v=new u(a+1,c.length),_=0,y=0,b=0,C=0,S=0;t.appendASCIIString("<span>");for(var w=0,E=c.length;w<E;w++){S+=C;var L=c[w],x=L.endIndex,D=L.type,I=0!==g&&D.indexOf("vs-whitespace")>=0;if(b=0,t.appendASCIIString('<span class="'),t.appendASCIIString(D),t.appendASCII(34),I){for(var N=0,M=_,k=y;M<x;M++){if(9===(T=s.charCodeAt(M))){k+=(R=h-(M+k)%h)-1,N+=R}else N++}if(!n){!("vs-whitespace"===D)&&r||(t.appendASCIIString(' style="width:'),t.appendASCIIString(String(f*N)),t.appendASCIIString('px"'))}for(t.appendASCII(62);_<x;_++){v.setPartData(_,w,b,S);if(9===(T=s.charCodeAt(_))){
for(y+=(R=h-(_+y)%h)-1,b+=R-1,R>0&&(!o||R>1?t.write1(8594):t.write1(65515),R--);R>0;)t.write1(160),R--}else t.write1(183);b++}C=N}else{N=0;for(p&&t.appendASCIIString(' dir="ltr"'),t.appendASCII(62);_<x;_++){v.setPartData(_,w,b,S);var T=s.charCodeAt(_);switch(T){case 9:var R=h-(_+y)%h;for(y+=R-1,b+=R-1;R>0;)t.write1(160),N++,R--;break;case 32:t.write1(160),N++;break;case 60:t.appendASCIIString("&lt;"),N++;break;case 62:t.appendASCIIString("&gt;"),N++;break;case 38:t.appendASCIIString("&amp;"),N++;break;case 0:t.appendASCIIString("&#00;"),N++;break;case 65279:case 8232:t.write1(65533),N++;break;default:i.isFullWidthCharacter(T)&&y++,m&&T<32?(t.write1(9216+T),N++):(t.write1(T),N++)}b++}C=N}t.appendASCIIString("</span>")}v.setPartData(a,c.length-1,b,S),l&&t.appendASCIIString("<span>&hellip;</span>");return t.appendASCIIString("</span>"),new d(v,p,r)}(function(e){var t,n,r=e.useMonospaceOptimizations,a=e.lineContent;-1!==e.stopRenderingLineAfter&&e.stopRenderingLineAfter<a.length?(t=!0,
n=e.stopRenderingLineAfter):(t=!1,n=a.length);var l=function(e,t,i){var n=[],o=0;t>0&&(n[o++]=new s(t,""));for(var r=0,a=e.getCount();r<a;r++){var l=e.getEndOffset(r);if(!(l<=t)){var u=e.getClassName(r);if(l>=i){n[o++]=new s(i,u);break}n[o++]=new s(l,u)}}return n}(e.lineTokens,e.fauxIndentLength,n);(3===e.renderWhitespace||1===e.renderWhitespace||2===e.renderWhitespace&&e.selectionsOnLine)&&(l=function(e,t,n,o,r,a,l,u,d){var c,h=[],p=0,f=0,g=o[f].type,m=o[f].endIndex,v=o.length,_=i.firstNonWhitespaceIndex(e);-1===_?(_=t,c=t):c=i.lastNonWhitespaceIndex(e);for(var y=0,b=0;b<r;b++){9===(E=e.charCodeAt(b))?y=a:i.isFullWidthCharacter(E)?y+=2:y++}y%=a;for(var C=!1,S=0,w=u&&u[S],b=r;b<t;b++){var E=e.charCodeAt(b);w&&b>=w.endOffset&&(S++,w=u&&u[S]);var L=void 0;if(b<_||b>c)L=!0;else if(9===E)L=!0;else if(32===E)if(d)if(C)L=!0;else{var x=b+1<t?e.charCodeAt(b+1):0;L=32===x||9===x}else L=!0;else L=!1;L&&u&&(L=!!w&&w.startOffset<=b&&w.endOffset>b),C?(!L||!l&&y>=a)&&(h[p++]=new s(b,"vs-whitespace"),
y%=a):(b===m||L&&b>r)&&(h[p++]=new s(b,g),y%=a),9===E?y=a:i.isFullWidthCharacter(E)?y+=2:y++,C=L,b===m&&++f<v&&(g=o[f].type,m=o[f].endIndex)}var D=!1;if(C)if(n&&d){var I=t>0?e.charCodeAt(t-1):0,N=t>1?e.charCodeAt(t-2):0;32===I&&32!==N&&9!==N||(D=!0)}else D=!0;return h[p++]=new s(t,D?"vs-whitespace":g),h}(a,n,e.continuesWithWrappedLine,l,e.fauxIndentLength,e.tabSize,r,e.selectionsOnLine,1===e.renderWhitespace));var u=0;if(e.lineDecorations.length>0){for(var d=0,c=e.lineDecorations.length;d<c;d++){var p=e.lineDecorations[d];3===p.type?u|=1:1===p.type?u|=1:2===p.type&&(u|=2)}l=function(e,t,i,n){n.sort(o.LineDecoration.compare);for(var r=o.LineDecorationsNormalizer.normalize(e,n),a=r.length,l=0,u=[],d=0,c=0,h=0,p=i.length;h<p;h++){for(var f=i[h],g=f.endIndex,m=f.type;l<a&&r[l].startOffset<g;){var v=r[l];if(v.startOffset>c&&(c=v.startOffset,u[d++]=new s(c,m)),!(v.endOffset+1<=g)){c=g,u[d++]=new s(c,m+" "+v.className);break}c=v.endOffset+1,u[d++]=new s(c,m+" "+v.className),l++}g>c&&(c=g,u[d++]=new s(c,m))}
var _=i[i.length-1].endIndex;if(l<a&&r[l].startOffset===_){for(var y=[];l<a&&r[l].startOffset===_;)y.push(r[l].className),l++;u[d++]=new s(c,y.join(" "))}return u}(a,0,l,e.lineDecorations)}e.containsRTL||(l=function(e,t,i){var n=0,o=[],r=0;if(i)for(var a=0,l=t.length;a<l;a++){p=(f=t[a]).endIndex;if(n+50<p){for(var u=f.type,d=-1,c=n,h=n;h<p;h++)32===e.charCodeAt(h)&&(d=h),-1!==d&&h-c>=50&&(o[r++]=new s(d+1,u),c=d+1,d=-1);c!==p&&(o[r++]=new s(p,u))}else o[r++]=f;n=p}else for(var a=0,l=t.length;a<l;a++){var p,f=t[a],g=(p=f.endIndex)-n;if(g>50){for(var u=f.type,m=Math.ceil(g/50),h=1;h<m;h++){var v=n+50*h;o[r++]=new s(v,u)}o[r++]=new s(p,u)}else o[r++]=f;n=p}return o}(a,l,!e.isBasicASCII||e.fontLigatures));return new h(r,e.canUseHalfwidthRightwardsArrow,a,n,t,l,u,e.tabSize,e.containsRTL,e.spaceWidth,e.renderWhitespace,e.renderControlCharacters)}(e),t)}Object.defineProperty(t,"__esModule",{value:!0});var s=function(){return function(e,t){this.endIndex=e,this.type=t}}(),a=function(){function e(e,t){
this.startOffset=e,this.endOffset=t}return e.prototype.equals=function(e){return this.startOffset===e.startOffset&&this.endOffset===e.endOffset},e}();t.LineRange=a;var l=function(){function e(e,t,i,n,o,r,s,a,l,u,d,c,h,p,f,g){this.useMonospaceOptimizations=e,this.canUseHalfwidthRightwardsArrow=t,this.lineContent=i,this.continuesWithWrappedLine=n,this.isBasicASCII=o,this.containsRTL=r,this.fauxIndentLength=s,this.lineTokens=a,this.lineDecorations=l,this.tabSize=u,this.spaceWidth=d,this.stopRenderingLineAfter=c,this.renderWhitespace="all"===h?3:"boundary"===h?1:"selection"===h?2:0,this.renderControlCharacters=p,this.fontLigatures=f,this.selectionsOnLine=g&&g.sort(function(e,t){return e.startOffset<t.startOffset?-1:1})}return e.prototype.sameSelection=function(e){if(null===this.selectionsOnLine)return null===e;if(null===e)return!1;if(e.length!==this.selectionsOnLine.length)return!1;for(var t=0;t<this.selectionsOnLine.length;t++)if(!this.selectionsOnLine[t].equals(e[t]))return!1;return!0},
e.prototype.equals=function(e){return this.useMonospaceOptimizations===e.useMonospaceOptimizations&&this.canUseHalfwidthRightwardsArrow===e.canUseHalfwidthRightwardsArrow&&this.lineContent===e.lineContent&&this.continuesWithWrappedLine===e.continuesWithWrappedLine&&this.isBasicASCII===e.isBasicASCII&&this.containsRTL===e.containsRTL&&this.fauxIndentLength===e.fauxIndentLength&&this.tabSize===e.tabSize&&this.spaceWidth===e.spaceWidth&&this.stopRenderingLineAfter===e.stopRenderingLineAfter&&this.renderWhitespace===e.renderWhitespace&&this.renderControlCharacters===e.renderControlCharacters&&this.fontLigatures===e.fontLigatures&&o.LineDecoration.equalsArr(this.lineDecorations,e.lineDecorations)&&this.lineTokens.equals(e.lineTokens)&&this.sameSelection(e.selectionsOnLine)},e}();t.RenderLineInput=l;var u=function(){function e(e,t){this.length=e,this._data=new Uint32Array(this.length),this._absoluteOffsets=new Uint32Array(this.length)}return e.getPartIndex=function(e){return(4294901760&e)>>>16},
e.getCharIndex=function(e){return(65535&e)>>>0},e.prototype.setPartData=function(e,t,i,n){var o=(t<<16|i<<0)>>>0;this._data[e]=o,this._absoluteOffsets[e]=n+i},e.prototype.getAbsoluteOffsets=function(){return this._absoluteOffsets},e.prototype.charOffsetToPartData=function(e){return 0===this.length?0:e<0?this._data[0]:e>=this.length?this._data[this.length-1]:this._data[e]},e.prototype.partDataToCharOffset=function(t,i,n){if(0===this.length)return 0;for(var o=(t<<16|n<<0)>>>0,r=0,s=this.length-1;r+1<s;){var a=r+s>>>1,l=this._data[a];if(l===o)return a;l>o?s=a:r=a}if(r===s)return r;var u=this._data[r],d=this._data[s];if(u===o)return r;if(d===o)return s;var c=e.getPartIndex(u);return n-e.getCharIndex(u)<=(c!==e.getPartIndex(d)?i:e.getCharIndex(d))-n?r:s},e}();t.CharacterMapping=u;var d=function(){return function(e,t,i){this.characterMapping=e,this.containsRTL=t,this.containsForeignElements=i}}();t.RenderLineOutput=d,t.renderViewLine=r;var c=function(){return function(e,t,i,n){this.characterMapping=e,this.html=t,
this.containsRTL=i,this.containsForeignElements=n}}();t.RenderLineOutput2=c,t.renderViewLine2=function(e){var t=n.createStringBuilder(1e4),i=r(e,t);return new c(i.characterMapping,t.build(),i.containsRTL,i.containsForeignElements)};var h=function(){return function(e,t,i,n,o,r,s,a,l,u,d,c){this.fontIsMonospace=e,this.canUseHalfwidthRightwardsArrow=t,this.lineContent=i,this.len=n,this.isOverflowing=o,this.parts=r,this.containsForeignElements=s,this.tabSize=a,this.containsRTL=l,this.spaceWidth=u,this.renderWhitespace=d,this.renderControlCharacters=c}}()}),define(t[554],i([1,0,3]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,n,o){this.selections=e,this.startLineNumber=0|t.startLineNumber,this.endLineNumber=0|t.endLineNumber,this.relativeVerticalOffset=t.relativeVerticalOffset,this.bigNumbersDelta=0|t.bigNumbersDelta,this.whitespaceViewportData=n,this._model=o,
this.visibleRange=new i.Range(t.startLineNumber,this._model.getLineMinColumn(t.startLineNumber),t.endLineNumber,this._model.getLineMaxColumn(t.endLineNumber))}return e.prototype.getViewLineRenderingData=function(e){return this._model.getViewLineRenderingData(this.visibleRange,e)},e.prototype.getDecorationsInViewport=function(){return this._model.getDecorationsInViewport(this.visibleRange)},e}();t.ViewportData=n}),define(t[556],i([1,0,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(){this._instanceId=i.singleLetterHash(++e.INSTANCE_COUNT),this._heights=[],this._minWidths=[],this._ids=[],this._afterLineNumbers=[],this._ordinals=[],this._prefixSum=[],this._prefixSumValidIndex=-1,this._whitespaceId2Index={},this._lastWhitespaceId=0,this._minWidth=-1}return e.findInsertionIndex=function(e,t,i,n){for(var o=0,r=e.length;o<r;){var s=o+r>>>1;t===e[s]?n<i[s]?r=s:o=s+1:t<e[s]?r=s:o=s+1}return o},e.prototype.insertWhitespace=function(t,i,n,o){t|=0,i|=0,n|=0,
o|=0;var r=this._instanceId+ ++this._lastWhitespaceId,s=e.findInsertionIndex(this._afterLineNumbers,t,this._ordinals,i);return this._insertWhitespaceAtIndex(r,s,t,i,n,o),this._minWidth=-1,r},e.prototype._insertWhitespaceAtIndex=function(e,t,i,n,o,r){t|=0,i|=0,n|=0,o|=0,r|=0,this._heights.splice(t,0,o),this._minWidths.splice(t,0,r),this._ids.splice(t,0,e),this._afterLineNumbers.splice(t,0,i),this._ordinals.splice(t,0,n),this._prefixSum.splice(t,0,0);for(var s=Object.keys(this._whitespaceId2Index),a=0,l=s.length;a<l;a++){var u=s[a],d=this._whitespaceId2Index[u];d>=t&&(this._whitespaceId2Index[u]=d+1)}this._whitespaceId2Index[e]=t,this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,t-1)},e.prototype.changeWhitespace=function(e,t,i){t|=0,i|=0;var n=!1;return n=this.changeWhitespaceHeight(e,i)||n,n=this.changeWhitespaceAfterLineNumber(e,t)||n},e.prototype.changeWhitespaceHeight=function(e,t){if(t|=0,this._whitespaceId2Index.hasOwnProperty(e)){var i=this._whitespaceId2Index[e]
;if(this._heights[i]!==t)return this._heights[i]=t,this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,i-1),!0}return!1},e.prototype.changeWhitespaceAfterLineNumber=function(t,i){if(i|=0,this._whitespaceId2Index.hasOwnProperty(t)){var n=this._whitespaceId2Index[t];if(this._afterLineNumbers[n]!==i){var o=this._ordinals[n],r=this._heights[n],s=this._minWidths[n];this.removeWhitespace(t);var a=e.findInsertionIndex(this._afterLineNumbers,i,this._ordinals,o);return this._insertWhitespaceAtIndex(t,a,i,o,r,s),!0}}return!1},e.prototype.removeWhitespace=function(e){if(this._whitespaceId2Index.hasOwnProperty(e)){var t=this._whitespaceId2Index[e];return delete this._whitespaceId2Index[e],this._removeWhitespaceAtIndex(t),this._minWidth=-1,!0}return!1},e.prototype._removeWhitespaceAtIndex=function(e){e|=0,this._heights.splice(e,1),this._minWidths.splice(e,1),this._ids.splice(e,1),this._afterLineNumbers.splice(e,1),this._ordinals.splice(e,1),this._prefixSum.splice(e,1),
this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,e-1);for(var t=Object.keys(this._whitespaceId2Index),i=0,n=t.length;i<n;i++){var o=t[i],r=this._whitespaceId2Index[o];r>=e&&(this._whitespaceId2Index[o]=r-1)}},e.prototype.onLinesDeleted=function(e,t){e|=0,t|=0;for(var i=0,n=this._afterLineNumbers.length;i<n;i++){var o=this._afterLineNumbers[i];e<=o&&o<=t?this._afterLineNumbers[i]=e-1:o>t&&(this._afterLineNumbers[i]-=t-e+1)}},e.prototype.onLinesInserted=function(e,t){e|=0,t|=0;for(var i=0,n=this._afterLineNumbers.length;i<n;i++){e<=this._afterLineNumbers[i]&&(this._afterLineNumbers[i]+=t-e+1)}},e.prototype.getTotalHeight=function(){return 0===this._heights.length?0:this.getAccumulatedHeight(this._heights.length-1)},e.prototype.getAccumulatedHeight=function(e){e|=0;var t=Math.max(0,this._prefixSumValidIndex+1);0===t&&(this._prefixSum[0]=this._heights[0],t++);for(var i=t;i<=e;i++)this._prefixSum[i]=this._prefixSum[i-1]+this._heights[i]
;return this._prefixSumValidIndex=Math.max(this._prefixSumValidIndex,e),this._prefixSum[e]},e.prototype.getAccumulatedHeightBeforeLineNumber=function(e){e|=0;var t=this._findLastWhitespaceBeforeLineNumber(e);return-1===t?0:this.getAccumulatedHeight(t)},e.prototype._findLastWhitespaceBeforeLineNumber=function(e){e|=0;for(var t=this._afterLineNumbers,i=0,n=t.length-1;i<=n;){var o=i+((n-i|0)/2|0)|0;if(t[o]<e){if(o+1>=t.length||t[o+1]>=e)return o;i=o+1|0}else n=o-1|0}return-1},e.prototype._findFirstWhitespaceAfterLineNumber=function(e){e|=0;var t=this._findLastWhitespaceBeforeLineNumber(e)+1;return t<this._heights.length?t:-1},e.prototype.getFirstWhitespaceIndexAfterLineNumber=function(e){return e|=0,this._findFirstWhitespaceAfterLineNumber(e)},e.prototype.getCount=function(){return this._heights.length},e.prototype.getMinWidth=function(){if(-1===this._minWidth){for(var e=0,t=0,i=this._minWidths.length;t<i;t++)e=Math.max(e,this._minWidths[t]);this._minWidth=e}return this._minWidth},
e.prototype.getAfterLineNumberForWhitespaceIndex=function(e){return e|=0,this._afterLineNumbers[e]},e.prototype.getIdForWhitespaceIndex=function(e){return e|=0,this._ids[e]},e.prototype.getHeightForWhitespaceIndex=function(e){return e|=0,this._heights[e]},e.prototype.getWhitespaces=function(e){e|=0;for(var t=[],i=0;i<this._heights.length;i++)t.push({id:this._ids[i],afterLineNumber:this._afterLineNumbers[i],heightInLines:this._heights[i]/e});return t},e.INSTANCE_COUNT=0,e}();t.WhitespaceComputer=n}),define(t[576],i([1,0,556]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this._lineCount=e,this._lineHeight=t,this._whitespaces=new i.WhitespaceComputer}return e.prototype.setLineHeight=function(e){this._lineHeight=e},e.prototype.onFlushed=function(e){this._lineCount=e},e.prototype.insertWhitespace=function(e,t,i,n){return this._whitespaces.insertWhitespace(e,t,i,n)},e.prototype.changeWhitespace=function(e,t,i){
return this._whitespaces.changeWhitespace(e,t,i)},e.prototype.removeWhitespace=function(e){return this._whitespaces.removeWhitespace(e)},e.prototype.onLinesDeleted=function(e,t){this._lineCount-=t-e+1,this._whitespaces.onLinesDeleted(e,t)},e.prototype.onLinesInserted=function(e,t){this._lineCount+=t-e+1,this._whitespaces.onLinesInserted(e,t)},e.prototype.getLinesTotalHeight=function(){return this._lineHeight*this._lineCount+this._whitespaces.getTotalHeight()},e.prototype.getVerticalOffsetForLineNumber=function(e){return((e|=0)>1?this._lineHeight*(e-1):0)+this._whitespaces.getAccumulatedHeightBeforeLineNumber(e)},e.prototype.getWhitespaceAccumulatedHeightBeforeLineNumber=function(e){return this._whitespaces.getAccumulatedHeightBeforeLineNumber(e)},e.prototype.getWhitespaceMinWidth=function(){return this._whitespaces.getMinWidth()},e.prototype.isAfterLines=function(e){return e>this.getLinesTotalHeight()},e.prototype.getLineNumberAtOrAfterVerticalOffset=function(e){if((e|=0)<0)return 1
;for(var t=0|this._lineCount,i=this._lineHeight,n=1,o=t;n<o;){var r=(n+o)/2|0,s=0|this.getVerticalOffsetForLineNumber(r);if(e>=s+i)n=r+1;else{if(e>=s)return r;o=r}}return n>t?t:n},e.prototype.getLinesViewportData=function(e,t){e|=0,t|=0;var i,n,o=this._lineHeight,r=0|this.getLineNumberAtOrAfterVerticalOffset(e),s=0|this.getVerticalOffsetForLineNumber(r),a=0|this._lineCount,l=0|this._whitespaces.getFirstWhitespaceIndexAfterLineNumber(r),u=0|this._whitespaces.getCount();-1===l?(l=u,n=a+1,i=0):(n=0|this._whitespaces.getAfterLineNumberForWhitespaceIndex(l),i=0|this._whitespaces.getHeightForWhitespaceIndex(l));var d=s,c=d,h=0;s>=5e5&&(h=5e5*Math.floor(s/5e5),c-=h=Math.floor(h/o)*o);for(var p=[],f=e+(t-e)/2,g=-1,m=r;m<=a;m++){if(-1===g){var v=d;(v<=f&&f<d+o||v>f)&&(g=m)}for(d+=o,p[m-r]=c,c+=o;n===m;)c+=i,d+=i,++l>=u?n=a+1:(n=0|this._whitespaces.getAfterLineNumberForWhitespaceIndex(l),i=0|this._whitespaces.getHeightForWhitespaceIndex(l));if(d>=t){a=m;break}}-1===g&&(g=a)
;var _=0|this.getVerticalOffsetForLineNumber(a),y=r,b=a;return y<b&&s<e&&y++,y<b&&_+o>t&&b--,{bigNumbersDelta:h,startLineNumber:r,endLineNumber:a,relativeVerticalOffset:p,centeredLineNumber:g,completelyVisibleStartLineNumber:y,completelyVisibleEndLineNumber:b}},e.prototype.getVerticalOffsetForWhitespaceIndex=function(e){e|=0;var t,i=this._whitespaces.getAfterLineNumberForWhitespaceIndex(e);t=i>=1?this._lineHeight*i:0;var n;return n=e>0?this._whitespaces.getAccumulatedHeight(e-1):0,t+n},e.prototype.getWhitespaceIndexAtOrAfterVerticallOffset=function(e){e|=0;var t,i,n,o=0,r=this._whitespaces.getCount()-1;if(r<0)return-1;if(e>=this.getVerticalOffsetForWhitespaceIndex(r)+this._whitespaces.getHeightForWhitespaceIndex(r))return-1;for(;o<r;)if(t=Math.floor((o+r)/2),i=this.getVerticalOffsetForWhitespaceIndex(t),n=this._whitespaces.getHeightForWhitespaceIndex(t),e>=i+n)o=t+1;else{if(e>=i)return t;r=t}return o},e.prototype.getWhitespaceAtVerticalOffset=function(e){e|=0
;var t=this.getWhitespaceIndexAtOrAfterVerticallOffset(e);if(t<0)return null;if(t>=this._whitespaces.getCount())return null;var i=this.getVerticalOffsetForWhitespaceIndex(t);if(i>e)return null;var n=this._whitespaces.getHeightForWhitespaceIndex(t);return{id:this._whitespaces.getIdForWhitespaceIndex(t),afterLineNumber:this._whitespaces.getAfterLineNumberForWhitespaceIndex(t),verticalOffset:i,height:n}},e.prototype.getWhitespaceViewportData=function(e,t){e|=0,t|=0;var i=this.getWhitespaceIndexAtOrAfterVerticallOffset(e),n=this._whitespaces.getCount()-1;if(i<0)return[];for(var o=[],r=i;r<=n;r++){var s=this.getVerticalOffsetForWhitespaceIndex(r),a=this._whitespaces.getHeightForWhitespaceIndex(r);if(s>=t)break;o.push({id:this._whitespaces.getIdForWhitespaceIndex(r),afterLineNumber:this._whitespaces.getAfterLineNumberForWhitespaceIndex(r),verticalOffset:s,height:a})}return o},e.prototype.getWhitespaces=function(){return this._whitespaces.getWhitespaces(this._lineHeight)},e}();t.LinesLayout=n}),
define(t[136],i([1,0,105]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){return function(e,t){this.index=e,this.remainder=t}}();t.PrefixSumIndexOfResult=n;var o=function(){function e(e){this.values=e,this.prefixSum=new Uint32Array(e.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValues=function(e,t){e=i.toUint32(e);var n=this.values,o=this.prefixSum,r=t.length;return 0!==r&&(this.values=new Uint32Array(n.length+r),this.values.set(n.subarray(0,e),0),this.values.set(n.subarray(e),e+r),this.values.set(t,e),e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.changeValue=function(e,t){return e=i.toUint32(e),t=i.toUint32(t),this.values[e]!==t&&(this.values[e]=t,
e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),!0)},e.prototype.removeValues=function(e,t){e=i.toUint32(e),t=i.toUint32(t);var n=this.values,o=this.prefixSum;if(e>=n.length)return!1;var r=n.length-e;return t>=r&&(t=r),0!==t&&(this.values=new Uint32Array(n.length-t),this.values.set(n.subarray(0,e),0),this.values.set(n.subarray(e+t),e),this.prefixSum=new Uint32Array(this.values.length),e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(o.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){return e<0?0:(e=i.toUint32(e),this._getAccumulatedValue(e))},e.prototype._getAccumulatedValue=function(e){if(e<=this.prefixSumValidIndex[0])return this.prefixSum[e];var t=this.prefixSumValidIndex[0]+1;0===t&&(this.prefixSum[0]=this.values[0],t++),
e>=this.values.length&&(e=this.values.length-1);for(var i=t;i<=e;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],e),this.prefixSum[e]},e.prototype.getIndexOf=function(e){e=Math.floor(e),this.getTotalValue();for(var t=0,i=this.values.length-1,o=0,r=0,s=0;t<=i;)if(o=t+(i-t)/2|0,r=this.prefixSum[o],s=r-this.values[o],e<s)i=o-1;else{if(!(e>=r))break;t=o+1}return new n(o,e-s)},e}();t.PrefixSumComputer=o;var r=function(){function e(e){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new o(e),this._bustCache()}return e.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},e.prototype.insertValues=function(e,t){this._actual.insertValues(e,t)&&this._bustCache()},e.prototype.changeValue=function(e,t){this._actual.changeValue(e,t)&&this._bustCache()},e.prototype.removeValues=function(e,t){this._actual.removeValues(e,t)&&this._bustCache()},e.prototype.getTotalValue=function(){
return this._actual.getTotalValue()},e.prototype.getAccumulatedValue=function(e){return this._actual.getAccumulatedValue(e)},e.prototype.getIndexOf=function(e){if(e=Math.floor(e),null!==this._cache){var t=e-this._cacheAccumulatedValueStart;if(t>=0&&t<this._cache.length)return this._cache[t]}return this._actual.getIndexOf(e)},e.prototype.warmUpCache=function(e,t){for(var i=[],n=e;n<=t;n++)i[n-e]=this.getIndexOf(n);this._cache=i,this._cacheAccumulatedValueStart=e},e}();t.PrefixSumComputerWithCache=r}),define(t[579],i([1,0,13,136]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t,i,n){this._uri=e,this._lines=t,this._eol=i,this._versionId=n,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){e.eol&&e.eol!==this._eol&&(this._eol=e.eol,this._lineStarts=null);for(var t=0,n=e.changes;t<n.length;t++){var o=n[t]
;this._acceptDeleteRange(o.range),this._acceptInsertText(new i.Position(o.range.startLineNumber,o.range.startColumn),o.text)}this._versionId=e.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=this._eol.length,t=this._lines.length,i=new Uint32Array(t),o=0;o<t;o++)i[o]=this._lines[o].length+e;this._lineStarts=new n.PrefixSumComputer(i)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber!==e.endLineNumber)this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber);else{if(e.startColumn===e.endColumn)return
;this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var i=t.split(/\r\n|\r|\n/);if(1!==i.length){i[i.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+i[0]);for(var n=new Uint32Array(i.length-1),o=1;o<i.length;o++)this._lines.splice(e.lineNumber+o-1,0,i[o]),n[o-1]=i[o].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,n)}else this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+i[0]+this._lines[e.lineNumber-1].substring(e.column-1))}},e}();t.MirrorTextModel=o}),define(t[585],i([1,0,19,125,62,18,24,13,3,281,579,99,443,469,170,23]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var v=function(e){function t(){
return null!==e&&e.apply(this,arguments)||this}return r(t,e),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var i=h.getWordAtText(e.column,h.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return i?new u.Range(e.lineNumber,i.startColumn,e.lineNumber,i.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var i=this.getWordAtPosition(e,t);return i?{word:this._lines[e.lineNumber-1].substring(i.startColumn-1,e.column-1),
startColumn:i.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.createWordIterator=function(e){var t,i,n=this,r=0,s=0,a=[],l=function(){if(s<a.length){var u=i.substring(a[s].start,a[s].end);return s+=1,t?t.value=u:t={done:!1,value:u},t}return r>=n._lines.length?o.FIN:(i=n._lines[r],a=n._wordenize(i,e),s=0,r+=1,l())};return{next:l}},t.prototype.getLineWords=function(e,t){for(var i=this._lines[e-1],n=[],o=0,r=this._wordenize(i,t);o<r.length;o++){var s=r[o];n.push({word:i.substring(s.start,s.end),startColumn:s.start+1,endColumn:s.end+1})}return n},t.prototype._wordenize=function(e,t){var i,n=[];for(t.lastIndex=0;(i=t.exec(e))&&0!==i[0].length;)n.push({start:i.index,end:i.index+i[0].length});return n},t.prototype.getValueInRange=function(e){if((e=this._validateRange(e)).startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,i=e.startLineNumber-1,n=e.endLineNumber-1,o=[]
;o.push(this._lines[i].substring(e.startColumn-1));for(var r=i+1;r<n;r++)o.push(this._lines[r]);return o.push(this._lines[n].substring(0,e.endColumn-1)),o.join(t)},t.prototype.offsetAt=function(e){return e=this._validatePosition(e),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(e.lineNumber-2)+(e.column-1)},t.prototype.positionAt=function(e){e=Math.floor(e),e=Math.max(0,e),this._ensureLineStarts();var t=this._lineStarts.getIndexOf(e),i=this._lines[t.index].length;return{lineNumber:1+t.index,column:1+Math.min(t.remainder,i)}},t.prototype._validateRange=function(e){var t=this._validatePosition({lineNumber:e.startLineNumber,column:e.startColumn}),i=this._validatePosition({lineNumber:e.endLineNumber,column:e.endColumn});return t.lineNumber!==e.startLineNumber||t.column!==e.startColumn||i.lineNumber!==e.endLineNumber||i.column!==e.endColumn?{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:i.lineNumber,endColumn:i.column}:e},t.prototype._validatePosition=function(e){
if(!l.Position.isIPosition(e))throw new Error("bad position");var t=e.lineNumber,i=e.column,n=!1;if(t<1)t=1,i=1,n=!0;else if(t>this._lines.length)t=this._lines.length,i=this._lines[t-1].length+1,n=!0;else{var o=this._lines[t-1].length+1;i<1?(i=1,n=!0):i>o&&(i=o,n=!0)}return n?{lineNumber:t,column:i}:e},t}(c.MirrorTextModel),_=function(){function t(e,t){this._host=e,this._models=Object.create(null),this._foreignModuleFactory=t,this._foreignModule=null}return t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(e){return this._models[e]},t.prototype._getModels=function(){var e=this,t=[];return Object.keys(this._models).forEach(function(i){return t.push(e._models[i])}),t},t.prototype.acceptNewModel=function(e){this._models[e.url]=new v(a.URI.parse(e.url),e.lines,e.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){this._models[e].onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},
t.prototype.computeDiff=function(e,t,i){var n=this._getModel(e),o=this._getModel(t);if(!n||!o)return Promise.resolve(null);var r=n.getLinesContent(),s=o.getLinesContent(),a=new d.DiffComputer(r,s,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:i,shouldMakePrettyDiff:!0}).computeDiff(),l=!(a.length>0)&&this._modelsAreIdentical(n,o);return Promise.resolve({identical:l,changes:a})},t.prototype._modelsAreIdentical=function(e,t){var i=e.getLineCount();if(i!==t.getLineCount())return!1;for(var n=1;n<=i;n++){if(e.getLineContent(n)!==t.getLineContent(n))return!1}return!0},t.prototype.computeMoreMinimalEdits=function(e,o){var r=this._getModel(e);if(!r)return Promise.resolve(o);for(var s=[],a=void 0,l=0,d=o=i.mergeSort(o,function(e,t){if(e.range&&t.range)return u.Range.compareRangesUsingStarts(e.range,t.range);return(e.range?0:1)-(t.range?0:1)});l<d.length;l++){var c=d[l],h=c.range,p=c.text,f=c.eol;if("number"==typeof f&&(a=f),!u.Range.isEmpty(h)||p){var g=r.getValueInRange(h)
;if(p=p.replace(/\r\n|\n|\r/g,r.eol),g!==p)if(Math.max(p.length,g.length)>t._diffLimit)s.push({range:h,text:p});else for(var m=n.stringDiff(g,p,!1),v=r.offsetAt(u.Range.lift(h).getStartPosition()),_=0,y=m;_<y.length;_++){var b=y[_],C=r.positionAt(v+b.originalStart),S=r.positionAt(v+b.originalStart+b.originalLength),w={text:p.substr(b.modifiedStart,b.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:S.lineNumber,endColumn:S.column}};r.getValueInRange(w.range)!==w.text&&s.push(w)}}}return"number"==typeof a&&s.push({eol:a,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),Promise.resolve(s)},t.prototype.computeLinks=function(e){var t=this._getModel(e);return t?Promise.resolve(p.computeLinks(t)):Promise.resolve(null)},t.prototype.textualSuggest=function(e,i,n,o){var r=this._getModel(e);if(!r)return Promise.resolve(null);var s=Object.create(null),a=[],l=new RegExp(n,o),u=r.getWordUntilPosition(i,l),d=r.getWordAtPosition(i,l)
;d&&(s[r.getValueInRange(d)]=!0);for(var c=r.createWordIterator(l),h=c.next();!h.done&&a.length<=t._suggestionsLimit;h=c.next()){var p=h.value;s[p]||(s[p]=!0,isNaN(Number(p))&&a.push({kind:18,label:p,insertText:p,range:{startLineNumber:i.lineNumber,startColumn:u.startColumn,endLineNumber:i.lineNumber,endColumn:u.endColumn}}))}return Promise.resolve({suggestions:a})},t.prototype.computeWordRanges=function(e,t,i,n){var o=this._getModel(e);if(!o)return Promise.resolve(Object.create(null));for(var r=new RegExp(i,n),s=Object.create(null),a=t.startLineNumber;a<t.endLineNumber;a++)for(var l=0,u=o.getLineWords(a,r);l<u.length;l++){var d=u[l];if(isNaN(Number(d.word))){var c=s[d.word];c||(c=[],s[d.word]=c),c.push({startLineNumber:a,startColumn:d.startColumn,endLineNumber:a,endColumn:d.endColumn})}}return Promise.resolve(s)},t.prototype.navigateValueSet=function(e,t,i,n,o){var r=this._getModel(e);if(!r)return Promise.resolve(null);var s=new RegExp(n,o);t.startColumn===t.endColumn&&(t={startLineNumber:t.startLineNumber,
startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn+1});var a=r.getValueInRange(t),l=r.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},s);if(!l)return Promise.resolve(null);var u=r.getValueInRange(l),d=f.BasicInplaceReplace.INSTANCE.navigateValueSet(t,a,l,u,i);return Promise.resolve(d)},t.prototype.loadForeignModule=function(t,i,n){var o=this,r={host:m.createProxyObject(n,function(e,t){return o._host.fhr(e,t)}),getMirrorModels:function(){return o._getModels()}};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(r,i),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise(function(n,s){e([t],function(e){o._foreignModule=e.create(r,i),n(m.getAllMethodNames(o._foreignModule))},s)})},t.prototype.fmr=function(e,t){if(!this._foreignModule||"function"!=typeof this._foreignModule[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{
return Promise.resolve(this._foreignModule[e].apply(this._foreignModule,t))}catch(e){return Promise.reject(e)}},t._diffLimit=1e5,t._suggestionsLimit=1e4,t}();t.EditorSimpleWorker=_,t.create=function(e){return new _(e,null)},"function"==typeof importScripts&&(s.globals.monaco=g.createMonacoBaseAPI())}),define(t[85],i([1,0,2]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(){var t=e.call(this)||this;return t._shouldRender=!0,t}return r(t,e),t.prototype.shouldRender=function(){return this._shouldRender},t.prototype.forceShouldRender=function(){this._shouldRender=!0},t.prototype.setShouldRender=function(){this._shouldRender=!0},t.prototype.onDidRender=function(){this._shouldRender=!1},t.prototype.onConfigurationChanged=function(e){return!1},t.prototype.onCursorStateChanged=function(e){return!1},t.prototype.onDecorationsChanged=function(e){return!1},t.prototype.onFlushed=function(e){return!1},t.prototype.onFocusChanged=function(e){return!1},
t.prototype.onLanguageConfigurationChanged=function(e){return!1},t.prototype.onLineMappingChanged=function(e){return!1},t.prototype.onLinesChanged=function(e){return!1},t.prototype.onLinesDeleted=function(e){return!1},t.prototype.onLinesInserted=function(e){return!1},t.prototype.onRevealRangeRequest=function(e){return!1},t.prototype.onScrollChanged=function(e){return!1},t.prototype.onTokensChanged=function(e){return!1},t.prototype.onTokensColorsChanged=function(e){return!1},t.prototype.onZonesChanged=function(e){return!1},t.prototype.onThemeChanged=function(e){return!1},t.prototype.handleEvents=function(e){for(var t=!1,i=0,n=e.length;i<n;i++){var o=e[i];switch(o.type){case 1:this.onConfigurationChanged(o)&&(t=!0);break;case 2:this.onCursorStateChanged(o)&&(t=!0);break;case 3:this.onDecorationsChanged(o)&&(t=!0);break;case 4:this.onFlushed(o)&&(t=!0);break;case 5:this.onFocusChanged(o)&&(t=!0);break;case 16:this.onLanguageConfigurationChanged(o)&&(t=!0);break;case 6:this.onLineMappingChanged(o)&&(t=!0);break
;case 7:this.onLinesChanged(o)&&(t=!0);break;case 8:this.onLinesDeleted(o)&&(t=!0);break;case 9:this.onLinesInserted(o)&&(t=!0);break;case 10:this.onRevealRangeRequest(o)&&(t=!0);break;case 11:this.onScrollChanged(o)&&(t=!0);break;case 12:this.onTokensChanged(o)&&(t=!0);break;case 13:this.onTokensColorsChanged(o)&&(t=!0);break;case 14:this.onZonesChanged(o)&&(t=!0);break;case 15:this.onThemeChanged(o)&&(t=!0);break;default:console.info("View received unknown event: "),console.info(o)}}t&&(this._shouldRender=!0)},t}(i.Disposable);t.ViewEventHandler=n}),define(t[71],i([1,0,85]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t}(i.ViewEventHandler);t.DynamicViewOverlay=n}),define(t[35],i([1,0,27,85]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._context.addEventHandler(i),i}
return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),e.prototype.dispose.call(this)},t}(n.ViewEventHandler);t.ViewPart=o;var s=function(){function e(){}return e.write=function(e,t){i.FastDomNode,e.setAttribute("data-mprt",String(t))},e.read=function(e){var t=e.getAttribute("data-mprt");return null===t?0:parseInt(t,10)},e.collect=function(e,t){for(var i=[],n=0;e&&e!==document.body&&e!==t;)e.nodeType===e.ELEMENT_NODE&&(i[n++]=this.read(e)),e=e.parentElement;for(var o=new Uint8Array(n),r=0;r<n;r++)o[r]=i[n-r-1];return o},e}();t.PartFingerprints=s}),define(t[231],i([1,0,8,27,35]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){return function(e,t){this.top=e,this.left=t}}(),a=function(e){function t(t,i){var r=e.call(this,t)||this;return r._viewDomNode=i,r._widgets={},r.domNode=n.createFastDomNode(document.createElement("div")),o.PartFingerprints.write(r.domNode,1),r.domNode.setClassName("contentWidgets"),
r.domNode.setPosition("absolute"),r.domNode.setTop(0),r.overflowingContentWidgetsDomNode=n.createFastDomNode(document.createElement("div")),o.PartFingerprints.write(r.overflowingContentWidgetsDomNode,2),r.overflowingContentWidgetsDomNode.setClassName("overflowingContentWidgets"),r}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._widgets={}},t.prototype.onConfigurationChanged=function(e){for(var t=0,i=Object.keys(this._widgets);t<i.length;t++){var n=i[t];this._widgets[n].onConfigurationChanged(e)}return!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLineMappingChanged=function(e){for(var t=0,i=Object.keys(this._widgets);t<i.length;t++){var n=i[t];this._widgets[n].onLineMappingChanged(e)}return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return!0},
t.prototype.onZonesChanged=function(e){return!0},t.prototype.addWidget=function(e){var t=new l(this._context,this._viewDomNode,e);this._widgets[t.id]=t,t.allowEditorOverflow?this.overflowingContentWidgetsDomNode.appendChild(t.domNode):this.domNode.appendChild(t.domNode),this.setShouldRender()},t.prototype.setWidgetPosition=function(e,t,i,n){this._widgets[e.getId()].setPosition(t,i,n),this.setShouldRender()},t.prototype.removeWidget=function(e){var t=e.getId();if(this._widgets.hasOwnProperty(t)){var i=this._widgets[t];delete this._widgets[t];var n=i.domNode.domNode;n.parentNode.removeChild(n),n.removeAttribute("monaco-visible-content-widget"),this.setShouldRender()}},t.prototype.shouldSuppressMouseDownOnWidget=function(e){return!!this._widgets.hasOwnProperty(e)&&this._widgets[e].suppressMouseDown},t.prototype.onBeforeRender=function(e){for(var t=0,i=Object.keys(this._widgets);t<i.length;t++){var n=i[t];this._widgets[n].onBeforeRender(e)}},t.prototype.prepareRender=function(e){
for(var t=0,i=Object.keys(this._widgets);t<i.length;t++){var n=i[t];this._widgets[n].prepareRender(e)}},t.prototype.render=function(e){for(var t=0,i=Object.keys(this._widgets);t<i.length;t++){var n=i[t];this._widgets[n].render(e)}},t}(o.ViewPart);t.ViewContentWidgets=a;var l=function(){function e(e,t,i){this._context=e,this._viewDomNode=t,this._actual=i,this.domNode=n.createFastDomNode(this._actual.getDomNode()),this.id=this._actual.getId(),this.allowEditorOverflow=this._actual.allowEditorOverflow||!1,this.suppressMouseDown=this._actual.suppressMouseDown||!1,this._fixedOverflowWidgets=this._context.configuration.editor.viewInfo.fixedOverflowWidgets,this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._lineHeight=this._context.configuration.editor.lineHeight,this._position=null,this._range=null,this._viewPosition=null,this._viewRange=null,this._preference=[],this._cachedDomNodeClientWidth=-1,
this._cachedDomNodeClientHeight=-1,this._maxWidth=this._getMaxWidth(),this._isVisible=!1,this._renderData=null,this.domNode.setPosition(this._fixedOverflowWidgets&&this.allowEditorOverflow?"fixed":"absolute"),this.domNode.setVisibility("hidden"),this.domNode.setAttribute("widgetId",this.id),this.domNode.setMaxWidth(this._maxWidth)}return e.prototype.onConfigurationChanged=function(e){e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._maxWidth=this._getMaxWidth())},e.prototype.onLineMappingChanged=function(e){this._setPosition(this._position,this._range)},e.prototype._setPosition=function(e,t){if(this._position=e,this._range=t,this._viewPosition=null,this._viewRange=null,this._position){var i=this._context.model.validateModelPosition(this._position)
;this._context.model.coordinatesConverter.modelPositionIsVisible(i)&&(this._viewPosition=this._context.model.coordinatesConverter.convertModelPositionToViewPosition(i))}if(this._range){var n=this._context.model.validateModelRange(this._range);this._viewRange=this._context.model.coordinatesConverter.convertModelRangeToViewRange(n)}},e.prototype._getMaxWidth=function(){return this.allowEditorOverflow?window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth:this._contentWidth},e.prototype.setPosition=function(e,t,i){this._setPosition(e,t),this._preference=i,this._cachedDomNodeClientWidth=-1,this._cachedDomNodeClientHeight=-1},e.prototype._layoutBoxInViewport=function(e,t,i,n,o){var r=e.top,s=r,a=t.top+this._lineHeight,l=r-n,u=s>=n,d=a,c=o.viewportHeight-a>=n,h=e.left,p=t.left;return h+i>o.scrollLeft+o.viewportWidth&&(h=o.scrollLeft+o.viewportWidth-i),p+i>o.scrollLeft+o.viewportWidth&&(p=o.scrollLeft+o.viewportWidth-i),h<o.scrollLeft&&(h=o.scrollLeft),p<o.scrollLeft&&(p=o.scrollLeft),{
fitsAbove:u,aboveTop:l,aboveLeft:h,fitsBelow:c,belowTop:d,belowLeft:p}},e.prototype._layoutBoxInPage=function(e,t,n,o,r){var s=e.left-r.scrollLeft,a=t.left-r.scrollLeft,l=e.top-o,u=t.top+this._lineHeight,d=s+this._contentLeft,c=a+this._contentLeft,h=i.getDomNodePagePosition(this._viewDomNode.domNode),p=h.top+l-i.StandardWindow.scrollY,f=h.top+u-i.StandardWindow.scrollY,g=h.left+d-i.StandardWindow.scrollX,m=h.left+c-i.StandardWindow.scrollX,v=window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,_=p>=22,y=f+o<=(window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight)-22;if(g+n+20>v){g-=b=g-(v-n-20),d-=b}if(m+n+20>v){m-=b=m-(v-n-20),c-=b}if(g<0){g-=b=g,d-=b}if(m<0){var b=m;m-=b,c-=b}return this._fixedOverflowWidgets&&(l=p,u=f,d=g,c=m),{fitsAbove:_,aboveTop:l,aboveLeft:d,fitsBelow:y,belowTop:u,belowLeft:c}},e.prototype._prepareRenderWidgetAtExactPositionOverflowing=function(e){return new s(e.top,e.left+this._contentLeft)},
e.prototype._getTopAndBottomLeft=function(e){if(!this._viewPosition)return[null,null];var t=e.visibleRangeForPosition(this._viewPosition);if(!t)return[null,null];var i=e.getVerticalOffsetForLineNumber(this._viewPosition.lineNumber)-e.scrollTop,n=new s(i,t.left),o=this._viewPosition.lineNumber,r=t.left;if(this._viewRange){var a=e.linesVisibleRangesForRange(this._viewRange,!1);if(a&&a.length>0)for(var l=a.length-1;l>=0;l--){var u=a[l];if(u.lineNumber>=o){u.lineNumber>o&&(o=u.lineNumber,r=1073741824);for(var d=0,c=u.ranges.length;d<c;d++){var h=u.ranges[d];h.left<r&&(r=h.left)}}}}var p=e.getVerticalOffsetForLineNumber(o)-e.scrollTop;return[n,new s(p,r)]},e.prototype._prepareRenderWidget=function(e){var t=this._getTopAndBottomLeft(e),i=t[0],n=t[1];if(!i||!n)return null;if(-1===this._cachedDomNodeClientWidth||-1===this._cachedDomNodeClientHeight){var o=this.domNode.domNode;this._cachedDomNodeClientWidth=o.clientWidth,this._cachedDomNodeClientHeight=o.clientHeight}var r
;if(r=this.allowEditorOverflow?this._layoutBoxInPage(i,n,this._cachedDomNodeClientWidth,this._cachedDomNodeClientHeight,e):this._layoutBoxInViewport(i,n,this._cachedDomNodeClientWidth,this._cachedDomNodeClientHeight,e),this._preference)for(var a=1;a<=2;a++)for(var l=0,u=this._preference;l<u.length;l++){var d=u[l];if(1===d){if(!r)return null;if(2===a||r.fitsAbove)return new s(r.aboveTop,r.aboveLeft)}else{if(2!==d)return this.allowEditorOverflow?this._prepareRenderWidgetAtExactPositionOverflowing(i):i;if(!r)return null;if(2===a||r.fitsBelow)return new s(r.belowTop,r.belowLeft)}}return null},e.prototype.onBeforeRender=function(e){this._viewPosition&&this._preference&&(this._viewPosition.lineNumber<e.startLineNumber||this._viewPosition.lineNumber>e.endLineNumber||this.domNode.setMaxWidth(this._maxWidth))},e.prototype.prepareRender=function(e){this._renderData=this._prepareRenderWidget(e)},e.prototype.render=function(e){this._renderData?(this.allowEditorOverflow?(this.domNode.setTop(this._renderData.top),
this.domNode.setLeft(this._renderData.left)):(this.domNode.setTop(this._renderData.top+e.scrollTop-e.bigNumbersDelta),this.domNode.setLeft(this._renderData.left)),this._isVisible||(this.domNode.setVisibility("inherit"),this.domNode.setAttribute("monaco-visible-content-widget","true"),this._isVisible=!0)):this._isVisible&&(this.domNode.removeAttribute("monaco-visible-content-widget"),this._isVisible=!1,this.domNode.setVisibility("hidden"))},e}()}),define(t[232],i([1,0,71,3,88,354]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._lineHeight=i._context.configuration.editor.lineHeight,i._typicalHalfwidthCharacterWidth=i._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},
t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.fontInfo&&(this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged||e.scrollWidthChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype.prepareRender=function(e){for(var t=e.getDecorationsInViewport(),i=[],o=0,r=0,s=t.length;r<s;r++){var a=t[r];a.options.className&&(i[o++]=a)}i=i.sort(function(e,t){if(e.options.zIndex<t.options.zIndex)return-1;if(e.options.zIndex>t.options.zIndex)return 1;var i=e.options.className,o=t.options.className
;return i<o?-1:i>o?1:n.Range.compareRangesUsingStarts(e.range,t.range)});for(var l=e.visibleRange.startLineNumber,u=e.visibleRange.endLineNumber,d=[],c=l;c<=u;c++){d[c-l]=""}this._renderWholeLineDecorations(e,i,d),this._renderNormalDecorations(e,i,d),this._renderResult=d},t.prototype._renderWholeLineDecorations=function(e,t,i){for(var n=String(this._lineHeight),o=e.visibleRange.startLineNumber,r=e.visibleRange.endLineNumber,s=0,a=t.length;s<a;s++){var l=t[s];if(l.options.isWholeLine)for(var u='<div class="cdr '+l.options.className+'" style="left:0;width:100%;height:'+n+'px;"></div>',d=Math.max(l.range.startLineNumber,o),c=Math.min(l.range.endLineNumber,r),h=d;h<=c;h++){i[h-o]+=u}}},t.prototype._renderNormalDecorations=function(e,t,i){for(var o=String(this._lineHeight),r=e.visibleRange.startLineNumber,s=null,a=!1,l=null,u=0,d=t.length;u<d;u++){var c=t[u];if(!c.options.isWholeLine){var h=c.options.className,p=Boolean(c.options.showIfCollapsed),f=c.range
;p&&1===f.endColumn&&f.endLineNumber!==f.startLineNumber&&(f=new n.Range(f.startLineNumber,f.startColumn,f.endLineNumber-1,this._context.model.getLineMaxColumn(f.endLineNumber-1))),s===h&&a===p&&n.Range.areIntersectingOrTouching(l,f)?l=n.Range.plusRange(l,f):(null!==s&&this._renderNormalDecoration(e,l,s,a,o,r,i),s=h,a=p,l=f)}}null!==s&&this._renderNormalDecoration(e,l,s,a,o,r,i)},t.prototype._renderNormalDecoration=function(e,t,i,n,r,s,a){var l=e.linesVisibleRangesForRange(t,"findMatch"===i);if(l)for(var u=0,d=l.length;u<d;u++){var c=l[u],h=c.lineNumber-s;if(n&&1===c.ranges.length){var p=c.ranges[0];0===p.width&&(c.ranges[0]=new o.HorizontalRange(p.left,this._typicalHalfwidthCharacterWidth))}for(var f=0,g=c.ranges.length;f<g;f++){var m=c.ranges[f],v='<div class="cdr '+i+'" style="left:'+String(m.left)+"px;width:"+String(m.width)+"px;height:"+r+'px;"></div>';a[h]+=v}}},t.prototype.render=function(e,t){if(!this._renderResult)return"";var i=t-e;return i<0||i>=this._renderResult.length?"":this._renderResult[i]},t
}(i.DynamicViewOverlay);t.DecorationsOverlay=s}),define(t[132],i([1,0,71,319]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){return function(e,t,i){this.startLineNumber=+e,this.endLineNumber=+t,this.className=String(i)}}();t.DecorationToRender=n;var o=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._render=function(e,t,i){for(var n=[],o=e;o<=t;o++){n[o-e]=[]}if(0===i.length)return n;i.sort(function(e,t){return e.className===t.className?e.startLineNumber===t.startLineNumber?e.endLineNumber-t.endLineNumber:e.startLineNumber-t.startLineNumber:e.className<t.className?-1:1});for(var r=null,s=0,a=0,l=i.length;a<l;a++){var u=i[a],d=u.className,c=Math.max(u.startLineNumber,e)-e,h=Math.min(u.endLineNumber,t)-e;r===d?(c=Math.max(s+1,c),s=Math.max(s,h)):(r=d,s=h);for(var p=c;p<=s;p++)n[p].push(r)}return n},t}(i.DynamicViewOverlay);t.DedupOverlay=o;var s=function(e){function t(t){var i=e.call(this)||this
;return i._context=t,i._lineHeight=i._context.configuration.editor.lineHeight,i._glyphMargin=i._context.configuration.editor.viewInfo.glyphMargin,i._glyphMarginLeft=i._context.configuration.editor.layoutInfo.glyphMarginLeft,i._glyphMarginWidth=i._context.configuration.editor.layoutInfo.glyphMarginWidth,i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.viewInfo&&(this._glyphMargin=this._context.configuration.editor.viewInfo.glyphMargin),e.layoutInfo&&(this._glyphMarginLeft=this._context.configuration.editor.layoutInfo.glyphMarginLeft,this._glyphMarginWidth=this._context.configuration.editor.layoutInfo.glyphMarginWidth),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},
t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype._getDecorations=function(e){for(var t=e.getDecorationsInViewport(),i=[],o=0,r=0,s=t.length;r<s;r++){var a=t[r],l=a.options.glyphMarginClassName;l&&(i[o++]=new n(a.range.startLineNumber,a.range.endLineNumber,l))}return i},t.prototype.prepareRender=function(e){if(this._glyphMargin){for(var t=e.visibleRange.startLineNumber,i=e.visibleRange.endLineNumber,n=this._render(t,i,this._getDecorations(e)),o=this._lineHeight.toString(),r='" style="left:'+this._glyphMarginLeft.toString()+"px;width:"+this._glyphMarginWidth.toString()+"px;height:"+o+'px;"></div>',s=[],a=t;a<=i;a++){var l=a-t,u=n[l];0===u.length?s[l]="":s[l]='<div class="cgmr '+u.join(" ")+r}this._renderResult=s}else this._renderResult=null},t.prototype.render=function(e,t){
if(!this._renderResult)return"";var i=t-e;return i<0||i>=this._renderResult.length?"":this._renderResult[i]},t}(o);t.GlyphMarginOverlay=s}),define(t[234],i([1,0,132,301]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._decorationsLeft=i._context.configuration.editor.layoutInfo.decorationsLeft,i._decorationsWidth=i._context.configuration.editor.layoutInfo.decorationsWidth,i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.layoutInfo&&(this._decorationsLeft=this._context.configuration.editor.layoutInfo.decorationsLeft,this._decorationsWidth=this._context.configuration.editor.layoutInfo.decorationsWidth),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},
t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype._getDecorations=function(e){for(var t=e.getDecorationsInViewport(),n=[],o=0,r=0,s=t.length;r<s;r++){var a=t[r],l=a.options.linesDecorationsClassName;l&&(n[o++]=new i.DecorationToRender(a.range.startLineNumber,a.range.endLineNumber,l))}return n},t.prototype.prepareRender=function(e){for(var t=e.visibleRange.startLineNumber,i=e.visibleRange.endLineNumber,n=this._render(t,i,this._getDecorations(e)),o='" style="left:'+this._decorationsLeft.toString()+"px;width:"+this._decorationsWidth.toString()+'px;"></div>',r=[],s=t;s<=i;s++){for(var a=s-t,l=n[a],u="",d=0,c=l.length;d<c;d++)u+='<div class="cldr '+l[d]+o;r[a]=u}this._renderResult=r},t.prototype.render=function(e,t){return this._renderResult?this._renderResult[t-e]:""},t}(i.DedupOverlay)
;t.LinesDecorationsOverlay=n}),define(t[173],i([1,0,27,35]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(n){var o=e.call(this,n)||this;return o._canUseLayerHinting=o._context.configuration.editor.canUseLayerHinting,o._contentLeft=o._context.configuration.editor.layoutInfo.contentLeft,o._glyphMarginLeft=o._context.configuration.editor.layoutInfo.glyphMarginLeft,o._glyphMarginWidth=o._context.configuration.editor.layoutInfo.glyphMarginWidth,o._domNode=i.createFastDomNode(document.createElement("div")),o._domNode.setClassName(t.OUTER_CLASS_NAME),o._domNode.setPosition("absolute"),o._domNode.setAttribute("role","presentation"),o._domNode.setAttribute("aria-hidden","true"),o._glyphMarginBackgroundDomNode=i.createFastDomNode(document.createElement("div")),o._glyphMarginBackgroundDomNode.setClassName(t.CLASS_NAME),o._domNode.appendChild(o._glyphMarginBackgroundDomNode),o}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},
t.prototype.getDomNode=function(){return this._domNode},t.prototype.onConfigurationChanged=function(e){return e.canUseLayerHinting&&(this._canUseLayerHinting=this._context.configuration.editor.canUseLayerHinting),e.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._glyphMarginLeft=this._context.configuration.editor.layoutInfo.glyphMarginLeft,this._glyphMarginWidth=this._context.configuration.editor.layoutInfo.glyphMarginWidth),!0},t.prototype.onScrollChanged=function(t){return e.prototype.onScrollChanged.call(this,t)||t.scrollTopChanged},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){this._domNode.setLayerHinting(this._canUseLayerHinting);var t=e.scrollTop-e.bigNumbersDelta;this._domNode.setTop(-t);var i=Math.min(e.scrollHeight,1e6);this._domNode.setHeight(i),this._domNode.setWidth(this._contentLeft),this._glyphMarginBackgroundDomNode.setLeft(this._glyphMarginLeft),this._glyphMarginBackgroundDomNode.setWidth(this._glyphMarginWidth),
this._glyphMarginBackgroundDomNode.setHeight(i)},t.CLASS_NAME="glyph-margin",t.OUTER_CLASS_NAME="margin",t}(n.ViewPart);t.Margin=o}),define(t[236],i([1,0,132,293]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype._getDecorations=function(e){
for(var t=e.getDecorationsInViewport(),n=[],o=0,r=0,s=t.length;r<s;r++){var a=t[r],l=a.options.marginClassName;l&&(n[o++]=new i.DecorationToRender(a.range.startLineNumber,a.range.endLineNumber,l))}return n},t.prototype.prepareRender=function(e){for(var t=e.visibleRange.startLineNumber,i=e.visibleRange.endLineNumber,n=this._render(t,i,this._getDecorations(e)),o=[],r=t;r<=i;r++){for(var s=r-t,a=n[s],l="",u=0,d=a.length;u<d;u++)l+='<div class="cmdr '+a[u]+'" style=""></div>';o[s]=l}this._renderResult=o},t.prototype.render=function(e,t){return this._renderResult?this._renderResult[t-e]:""},t}(i.DedupOverlay);t.MarginViewLineDecorationsOverlay=n}),define(t[237],i([1,0,27,35,284]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t){var o=e.call(this,t)||this;return o._widgets={},o._verticalScrollbarWidth=o._context.configuration.editor.layoutInfo.verticalScrollbarWidth,o._minimapWidth=o._context.configuration.editor.layoutInfo.minimapWidth,
o._horizontalScrollbarHeight=o._context.configuration.editor.layoutInfo.horizontalScrollbarHeight,o._editorHeight=o._context.configuration.editor.layoutInfo.height,o._editorWidth=o._context.configuration.editor.layoutInfo.width,o._domNode=i.createFastDomNode(document.createElement("div")),n.PartFingerprints.write(o._domNode,4),o._domNode.setClassName("overlayWidgets"),o}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._widgets={}},t.prototype.getDomNode=function(){return this._domNode},t.prototype.onConfigurationChanged=function(e){return!!e.layoutInfo&&(this._verticalScrollbarWidth=this._context.configuration.editor.layoutInfo.verticalScrollbarWidth,this._minimapWidth=this._context.configuration.editor.layoutInfo.minimapWidth,this._horizontalScrollbarHeight=this._context.configuration.editor.layoutInfo.horizontalScrollbarHeight,this._editorHeight=this._context.configuration.editor.layoutInfo.height,this._editorWidth=this._context.configuration.editor.layoutInfo.width,!0)},
t.prototype.addWidget=function(e){var t=i.createFastDomNode(e.getDomNode());this._widgets[e.getId()]={widget:e,preference:null,domNode:t},t.setPosition("absolute"),t.setAttribute("widgetId",e.getId()),this._domNode.appendChild(t),this.setShouldRender()},t.prototype.setWidgetPosition=function(e,t){var i=this._widgets[e.getId()];return i.preference!==t&&(i.preference=t,this.setShouldRender(),!0)},t.prototype.removeWidget=function(e){var t=e.getId();if(this._widgets.hasOwnProperty(t)){var i=this._widgets[t].domNode.domNode;delete this._widgets[t],i.parentNode.removeChild(i),this.setShouldRender()}},t.prototype._renderWidget=function(e){var t=e.domNode;if(null!==e.preference)if(0===e.preference)t.setTop(0),t.setRight(2*this._verticalScrollbarWidth+this._minimapWidth);else if(1===e.preference){var i=t.domNode.clientHeight;t.setTop(this._editorHeight-i-2*this._horizontalScrollbarHeight),t.setRight(2*this._verticalScrollbarWidth+this._minimapWidth)}else 2===e.preference&&(t.setTop(0),
t.domNode.style.right="50%");else t.unsetTop()},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){this._domNode.setWidth(this._editorWidth);for(var t=Object.keys(this._widgets),i=0,n=t.length;i<n;i++){var o=t[i];this._renderWidget(this._widgets[o])}},t}(n.ViewPart);t.ViewOverlayWidgets=o}),define(t[238],i([1,0,27,171,85]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t,o){var r=e.call(this)||this;return r._context=t,r._domNode=i.createFastDomNode(document.createElement("canvas")),r._domNode.setClassName(o),r._domNode.setPosition("absolute"),r._domNode.setLayerHinting(!0),r._zoneManager=new n.OverviewZoneManager(function(e){return r._context.viewLayout.getVerticalOffsetForLineNumber(e)}),r._zoneManager.setDOMWidth(0),r._zoneManager.setDOMHeight(0),r._zoneManager.setOuterHeight(r._context.viewLayout.getScrollHeight()),r._zoneManager.setLineHeight(r._context.configuration.editor.lineHeight),
r._zoneManager.setPixelRatio(r._context.configuration.editor.pixelRatio),r._context.addEventHandler(r),r}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._zoneManager.setLineHeight(this._context.configuration.editor.lineHeight),this._render()),e.pixelRatio&&(this._zoneManager.setPixelRatio(this._context.configuration.editor.pixelRatio),this._domNode.setWidth(this._zoneManager.getDOMWidth()),this._domNode.setHeight(this._zoneManager.getDOMHeight()),this._domNode.domNode.width=this._zoneManager.getCanvasWidth(),this._domNode.domNode.height=this._zoneManager.getCanvasHeight(),this._render()),!0},t.prototype.onFlushed=function(e){return this._render(),!0},t.prototype.onScrollChanged=function(e){return e.scrollHeightChanged&&(this._zoneManager.setOuterHeight(e.scrollHeight),this._render()),!0},t.prototype.onZonesChanged=function(e){return this._render(),!0},
t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.setLayout=function(e){this._domNode.setTop(e.top),this._domNode.setRight(e.right);var t=!1;t=this._zoneManager.setDOMWidth(e.width)||t,(t=this._zoneManager.setDOMHeight(e.height)||t)&&(this._domNode.setWidth(this._zoneManager.getDOMWidth()),this._domNode.setHeight(this._zoneManager.getDOMHeight()),this._domNode.domNode.width=this._zoneManager.getCanvasWidth(),this._domNode.domNode.height=this._zoneManager.getCanvasHeight(),this._render())},t.prototype.setZones=function(e){this._zoneManager.setZones(e),this._render()},t.prototype._render=function(){if(0===this._zoneManager.getOuterHeight())return!1;var e=this._zoneManager.getCanvasWidth(),t=this._zoneManager.getCanvasHeight(),i=this._zoneManager.resolveColorZones(),n=this._zoneManager.getId2Color(),o=this._domNode.domNode.getContext("2d");return o.clearRect(0,0,e,t),i.length>0&&this._renderOneLane(o,i,n,e),!0},t.prototype._renderOneLane=function(e,t,i,n){
for(var o=0,r=0,s=0,a=0,l=t;a<l.length;a++){var u=l[a],d=u.colorId,c=u.from,h=u.to;d!==o?(e.fillRect(0,r,n,s-r),o=d,e.fillStyle=i[o],r=c,s=h):s>=c?s=Math.max(s,h):(e.fillRect(0,r,n,s-r),r=c,s=h)}e.fillRect(0,r,n,s-r)},t}(o.ViewEventHandler);t.OverviewRuler=s}),define(t[239],i([1,0,27,10,35,13]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var n=e.call(this,t)||this;return n._lineHeight=n._context.configuration.editor.lineHeight,n._contentWidth=n._context.configuration.editor.layoutInfo.contentWidth,n._contentLeft=n._context.configuration.editor.layoutInfo.contentLeft,n.domNode=i.createFastDomNode(document.createElement("div")),n.domNode.setClassName("view-zones"),n.domNode.setPosition("absolute"),n.domNode.setAttribute("role","presentation"),n.domNode.setAttribute("aria-hidden","true"),n.marginDomNode=i.createFastDomNode(document.createElement("div")),n.marginDomNode.setClassName("margin-view-zones"),
n.marginDomNode.setPosition("absolute"),n.marginDomNode.setAttribute("role","presentation"),n.marginDomNode.setAttribute("aria-hidden","true"),n._zones={},n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._zones={}},t.prototype._recomputeWhitespacesProps=function(){for(var e=!1,t=Object.keys(this._zones),i=0,n=t.length;i<n;i++){var o=t[i],r=this._zones[o],s=this._computeWhitespaceProps(r.delegate);this._context.viewLayout.changeWhitespace(o,s.afterViewLineNumber,s.heightInPx)&&(this._safeCallOnComputedHeight(r.delegate,s.heightInPx),e=!0)}return e},t.prototype.onConfigurationChanged=function(e){return e.lineHeight?(this._lineHeight=this._context.configuration.editor.lineHeight,this._recomputeWhitespacesProps()):(e.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft),!0)},t.prototype.onLineMappingChanged=function(e){var t=this._recomputeWhitespacesProps()
;return t&&this._context.viewLayout.onHeightMaybeChanged(),t},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged||e.scrollWidthChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype._getZoneOrdinal=function(e){return void 0!==e.afterColumn?e.afterColumn:1e4},t.prototype._computeWhitespaceProps=function(e){if(0===e.afterLineNumber)return{afterViewLineNumber:0,heightInPx:this._heightInPixels(e),minWidthInPx:this._minWidthInPixels(e)};var t;if(void 0!==e.afterColumn)t=this._context.model.validateModelPosition({lineNumber:e.afterLineNumber,column:e.afterColumn});else{var i=this._context.model.validateModelPosition({lineNumber:e.afterLineNumber,column:1}).lineNumber;t=new s.Position(i,this._context.model.getModelLineMaxColumn(i))}var n;n=t.column===this._context.model.getModelLineMaxColumn(t.lineNumber)?this._context.model.validateModelPosition({lineNumber:t.lineNumber+1,column:1
}):this._context.model.validateModelPosition({lineNumber:t.lineNumber,column:t.column+1});var o=this._context.model.coordinatesConverter.convertModelPositionToViewPosition(t),r=this._context.model.coordinatesConverter.modelPositionIsVisible(n);return{afterViewLineNumber:o.lineNumber,heightInPx:r?this._heightInPixels(e):0,minWidthInPx:this._minWidthInPixels(e)}},t.prototype.addZone=function(e){var t=this._computeWhitespaceProps(e),n={whitespaceId:this._context.viewLayout.addWhitespace(t.afterViewLineNumber,this._getZoneOrdinal(e),t.heightInPx,t.minWidthInPx),delegate:e,isVisible:!1,domNode:i.createFastDomNode(e.domNode),marginDomNode:e.marginDomNode?i.createFastDomNode(e.marginDomNode):null};return this._safeCallOnComputedHeight(n.delegate,t.heightInPx),n.domNode.setPosition("absolute"),n.domNode.domNode.style.width="100%",n.domNode.setDisplay("none"),n.domNode.setAttribute("monaco-view-zone",n.whitespaceId),this.domNode.appendChild(n.domNode),n.marginDomNode&&(n.marginDomNode.setPosition("absolute"),
n.marginDomNode.domNode.style.width="100%",n.marginDomNode.setDisplay("none"),n.marginDomNode.setAttribute("monaco-view-zone",n.whitespaceId),this.marginDomNode.appendChild(n.marginDomNode)),this._zones[n.whitespaceId]=n,this.setShouldRender(),n.whitespaceId},t.prototype.removeZone=function(e){if(this._zones.hasOwnProperty(e)){var t=this._zones[e];return delete this._zones[e],this._context.viewLayout.removeWhitespace(t.whitespaceId),t.domNode.removeAttribute("monaco-visible-view-zone"),t.domNode.removeAttribute("monaco-view-zone"),t.domNode.domNode.parentNode.removeChild(t.domNode.domNode),t.marginDomNode&&(t.marginDomNode.removeAttribute("monaco-visible-view-zone"),t.marginDomNode.removeAttribute("monaco-view-zone"),t.marginDomNode.domNode.parentNode.removeChild(t.marginDomNode.domNode)),this.setShouldRender(),!0}return!1},t.prototype.layoutZone=function(e){var t=!1;if(this._zones.hasOwnProperty(e)){var i=this._zones[e],n=this._computeWhitespaceProps(i.delegate)
;(t=this._context.viewLayout.changeWhitespace(i.whitespaceId,n.afterViewLineNumber,n.heightInPx)||t)&&(this._safeCallOnComputedHeight(i.delegate,n.heightInPx),this.setShouldRender())}return t},t.prototype.shouldSuppressMouseDownOnViewZone=function(e){if(this._zones.hasOwnProperty(e)){var t=this._zones[e];return Boolean(t.delegate.suppressMouseDown)}return!1},t.prototype._heightInPixels=function(e){return"number"==typeof e.heightInPx?e.heightInPx:"number"==typeof e.heightInLines?this._lineHeight*e.heightInLines:this._lineHeight},t.prototype._minWidthInPixels=function(e){return"number"==typeof e.minWidthInPx?e.minWidthInPx:0},t.prototype._safeCallOnComputedHeight=function(e,t){if("function"==typeof e.onComputedHeight)try{e.onComputedHeight(t)}catch(e){n.onUnexpectedError(e)}},t.prototype._safeCallOnDomNodeTop=function(e,t){if("function"==typeof e.onDomNodeTop)try{e.onDomNodeTop(t)}catch(e){n.onUnexpectedError(e)}},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){
for(var t=e.viewportData.whitespaceViewportData,i={},n=!1,o=0,r=t.length;o<r;o++)i[t[o].id]=t[o],n=!0;for(var s=Object.keys(this._zones),o=0,r=s.length;o<r;o++){var a=s[o],l=this._zones[a],u=0,d=0,c="none";i.hasOwnProperty(a)?(u=i[a].verticalOffset-e.bigNumbersDelta,d=i[a].height,c="block",l.isVisible||(l.domNode.setAttribute("monaco-visible-view-zone","true"),l.isVisible=!0),this._safeCallOnDomNodeTop(l.delegate,e.getScrolledTopFromAbsoluteTop(i[a].verticalOffset))):(l.isVisible&&(l.domNode.removeAttribute("monaco-visible-view-zone"),l.isVisible=!1),this._safeCallOnDomNodeTop(l.delegate,e.getScrolledTopFromAbsoluteTop(-1e6))),l.domNode.setTop(u),l.domNode.setHeight(d),l.domNode.setDisplay(c),l.marginDomNode&&(l.marginDomNode.setTop(u),l.marginDomNode.setHeight(d),l.marginDomNode.setDisplay(c))}n&&(this.domNode.setWidth(Math.max(e.scrollWidth,this._contentWidth)),this.marginDomNode.setWidth(this._contentLeft))},t}(o.ViewPart);t.ViewZones=a}),define(t[67],i([1,0,5]),function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var n=function(){return function(e,t,i,n){this.top=0|e,this.left=0|t,this.width=0|i,this.height=0|n}}();t.Viewport=n;var o=function(){return function(e,t){this.tabSize=e,this.data=t}}();t.MinimapLinesRenderingData=o;var r=function(){return function(e,t,i,n,o){this.content=e,this.continuesWithWrappedLine=t,this.minColumn=i,this.maxColumn=n,this.tokens=o}}();t.ViewLineData=r;var s=function(){function e(t,i,n,o,r,s,a,l,u){this.minColumn=t,this.maxColumn=i,this.content=n,this.continuesWithWrappedLine=o,this.isBasicASCII=e.isBasicASCII(n,s),this.containsRTL=e.containsRTL(n,this.isBasicASCII,r),this.tokens=a,this.inlineDecorations=l,this.tabSize=u}return e.isBasicASCII=function(e,t){return!t||i.isBasicASCII(e)},e.containsRTL=function(e,t,n){return!(t||!n)&&i.containsRTL(e)},e}();t.ViewLineRenderingData=s;var a=function(){return function(e,t,i){this.range=e,this.inlineClassName=t,this.type=i}}();t.InlineDecoration=a;var l=function(){return function(e,t){this.range=e,
this.options=t}}();t.ViewModelDecoration=l}),define(t[241],i([1,0,2,215,576,67]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t,i,r){var s=e.call(this)||this;return s._configuration=t,s._linesLayout=new o.LinesLayout(i,s._configuration.editor.lineHeight),s.scrollable=s._register(new n.Scrollable(0,r)),s._configureSmoothScrollDuration(),s.scrollable.setScrollDimensions({width:t.editor.layoutInfo.contentWidth,height:t.editor.layoutInfo.contentHeight}),s.onDidScroll=s.scrollable.onScroll,s._updateHeight(),s}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.onHeightMaybeChanged=function(){this._updateHeight()},t.prototype._configureSmoothScrollDuration=function(){this.scrollable.setSmoothScrollDuration(this._configuration.editor.viewInfo.smoothScrolling?125:0)},t.prototype.onConfigurationChanged=function(e){e.lineHeight&&this._linesLayout.setLineHeight(this._configuration.editor.lineHeight),
e.layoutInfo&&this.scrollable.setScrollDimensions({width:this._configuration.editor.layoutInfo.contentWidth,height:this._configuration.editor.layoutInfo.contentHeight}),e.viewInfo&&this._configureSmoothScrollDuration(),this._updateHeight()},t.prototype.onFlushed=function(e){this._linesLayout.onFlushed(e)},t.prototype.onLinesDeleted=function(e,t){this._linesLayout.onLinesDeleted(e,t)},t.prototype.onLinesInserted=function(e,t){this._linesLayout.onLinesInserted(e,t)},t.prototype._getHorizontalScrollbarHeight=function(e){return 2===this._configuration.editor.viewInfo.scrollbar.horizontal?0:e.width>=e.scrollWidth?0:this._configuration.editor.viewInfo.scrollbar.horizontalScrollbarSize},t.prototype._getTotalHeight=function(){var e=this.scrollable.getScrollDimensions(),t=this._linesLayout.getLinesTotalHeight();return this._configuration.editor.viewInfo.scrollBeyondLastLine?t+=e.height-this._configuration.editor.lineHeight:t+=this._getHorizontalScrollbarHeight(e),Math.max(e.height,t)},
t.prototype._updateHeight=function(){this.scrollable.setScrollDimensions({scrollHeight:this._getTotalHeight()})},t.prototype.getCurrentViewport=function(){var e=this.scrollable.getScrollDimensions(),t=this.scrollable.getCurrentScrollPosition();return new s.Viewport(t.scrollTop,t.scrollLeft,e.width,e.height)},t.prototype.getFutureViewport=function(){var e=this.scrollable.getScrollDimensions(),t=this.scrollable.getFutureScrollPosition();return new s.Viewport(t.scrollTop,t.scrollLeft,e.width,e.height)},t.prototype._computeScrollWidth=function(e,t){if(!this._configuration.editor.wrappingInfo.isViewportWrapping){var i=this._configuration.editor.viewInfo.scrollBeyondLastColumn*this._configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,n=this._linesLayout.getWhitespaceMinWidth();return Math.max(e+i,t,n)}return Math.max(e,t)},t.prototype.onMaxLineWidthChanged=function(e){var t=this._computeScrollWidth(e,this.getCurrentViewport().width);this.scrollable.setScrollDimensions({scrollWidth:t}),this._updateHeight()
},t.prototype.saveState=function(){var e=this.scrollable.getFutureScrollPosition(),t=e.scrollTop,i=this._linesLayout.getLineNumberAtOrAfterVerticalOffset(t);return{scrollTop:t,scrollTopWithoutViewZones:t-this._linesLayout.getWhitespaceAccumulatedHeightBeforeLineNumber(i),scrollLeft:e.scrollLeft}},t.prototype.addWhitespace=function(e,t,i,n){return this._linesLayout.insertWhitespace(e,t,i,n)},t.prototype.changeWhitespace=function(e,t,i){return this._linesLayout.changeWhitespace(e,t,i)},t.prototype.removeWhitespace=function(e){return this._linesLayout.removeWhitespace(e)},t.prototype.getVerticalOffsetForLineNumber=function(e){return this._linesLayout.getVerticalOffsetForLineNumber(e)},t.prototype.isAfterLines=function(e){return this._linesLayout.isAfterLines(e)},t.prototype.getLineNumberAtVerticalOffset=function(e){return this._linesLayout.getLineNumberAtOrAfterVerticalOffset(e)},t.prototype.getWhitespaceAtVerticalOffset=function(e){return this._linesLayout.getWhitespaceAtVerticalOffset(e)},
t.prototype.getLinesViewportData=function(){var e=this.getCurrentViewport();return this._linesLayout.getLinesViewportData(e.top,e.top+e.height)},t.prototype.getLinesViewportDataAtScrollTop=function(e){var t=this.scrollable.getScrollDimensions();return e+t.height>t.scrollHeight&&(e=t.scrollHeight-t.height),e<0&&(e=0),this._linesLayout.getLinesViewportData(e,e+t.height)},t.prototype.getWhitespaceViewportData=function(){var e=this.getCurrentViewport();return this._linesLayout.getWhitespaceViewportData(e.top,e.top+e.height)},t.prototype.getWhitespaces=function(){return this._linesLayout.getWhitespaces()},t.prototype.getScrollWidth=function(){return this.scrollable.getScrollDimensions().scrollWidth},t.prototype.getScrollHeight=function(){return this.scrollable.getScrollDimensions().scrollHeight},t.prototype.getCurrentScrollLeft=function(){return this.scrollable.getCurrentScrollPosition().scrollLeft},t.prototype.getCurrentScrollTop=function(){return this.scrollable.getCurrentScrollPosition().scrollTop},
t.prototype.validateScrollPosition=function(e){return this.scrollable.validateScrollPosition(e)},t.prototype.setScrollPositionNow=function(e){this.scrollable.setScrollPositionNow(e)},t.prototype.setScrollPositionSmooth=function(e){this.scrollable.setScrollPositionSmooth(e)},t.prototype.deltaScrollNow=function(e,t){var i=this.scrollable.getCurrentScrollPosition();this.scrollable.setScrollPositionNow({scrollLeft:i.scrollLeft+e,scrollTop:i.scrollTop+t})},t}(i.Disposable);t.ViewLayout=a}),define(t[242],i([1,0,13,3,67]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,t,i,n,o){this.editorId=e,this.model=t,this.configuration=i,this._linesCollection=n,this._coordinatesConverter=o,this._decorationsCache=Object.create(null),this._cachedModelDecorationsResolver=null,this._cachedModelDecorationsResolverViewRange=null}return e.prototype._clearCachedModelDecorationsResolver=function(){this._cachedModelDecorationsResolver=null,
this._cachedModelDecorationsResolverViewRange=null},e.prototype.dispose=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.reset=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.onModelDecorationsChanged=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.onLineMappingChanged=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype._getOrCreateViewModelDecoration=function(e){var t=e.id,r=this._decorationsCache[t];if(!r){var s=e.range,a=e.options,l=void 0;if(a.isWholeLine){var u=this._coordinatesConverter.convertModelPositionToViewPosition(new i.Position(s.startLineNumber,1)),d=this._coordinatesConverter.convertModelPositionToViewPosition(new i.Position(s.endLineNumber,this.model.getLineMaxColumn(s.endLineNumber)));l=new n.Range(u.lineNumber,u.column,d.lineNumber,d.column)
}else l=this._coordinatesConverter.convertModelRangeToViewRange(s);r=new o.ViewModelDecoration(l,a),this._decorationsCache[t]=r}return r},e.prototype.getDecorationsViewportData=function(e){var t=null!==this._cachedModelDecorationsResolver;return(t=t&&e.equalsRange(this._cachedModelDecorationsResolverViewRange))||(this._cachedModelDecorationsResolver=this._getDecorationsViewportData(e),this._cachedModelDecorationsResolverViewRange=e),this._cachedModelDecorationsResolver},e.prototype._getDecorationsViewportData=function(e){for(var t=this._linesCollection.getDecorationsInRange(e,this.editorId,this.configuration.editor.readOnly),i=e.startLineNumber,r=e.endLineNumber,s=[],a=0,l=[],u=i;u<=r;u++)l[u-i]=[];for(var d=0,c=t.length;d<c;d++){var h=t[d],p=h.options,f=this._getOrCreateViewModelDecoration(h),g=f.range;if(s[a++]=f,
p.inlineClassName)for(var m=new o.InlineDecoration(g,p.inlineClassName,p.inlineClassNameAffectsLetterSpacing?3:0),v=Math.max(i,g.startLineNumber),_=Math.min(r,g.endLineNumber),u=v;u<=_;u++)l[u-i].push(m);if(p.beforeContentClassName&&i<=g.startLineNumber&&g.startLineNumber<=r){m=new o.InlineDecoration(new n.Range(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn),p.beforeContentClassName,1);l[g.startLineNumber-i].push(m)}if(p.afterContentClassName&&i<=g.endLineNumber&&g.endLineNumber<=r){m=new o.InlineDecoration(new n.Range(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn),p.afterContentClassName,2);l[g.endLineNumber-i].push(m)}}return{decorations:s,inlineDecorations:l}},e}();t.ViewModelDecorations=r}),define(t[243],i([1,0,3]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this._selection=e,this._isMovingLeft=t,this._cutStartIndex=-1,this._cutEndIndex=-1,this._moved=!1,this._selectionId=null}
return e.prototype.getEditOperations=function(e,t){var n=this._selection;if(this._selectionId=t.trackSelection(n),n.startLineNumber===n.endLineNumber&&(!this._isMovingLeft||0!==n.startColumn)&&(this._isMovingLeft||n.endColumn!==e.getLineMaxColumn(n.startLineNumber))){var o,r,s,a=n.selectionStartLineNumber,l=e.getLineContent(a);this._isMovingLeft?(o=l.substring(0,n.startColumn-2),r=l.substring(n.startColumn-1,n.endColumn-1),s=l.substring(n.startColumn-2,n.startColumn-1)+l.substring(n.endColumn-1)):(o=l.substring(0,n.startColumn-1)+l.substring(n.endColumn-1,n.endColumn),r=l.substring(n.startColumn-1,n.endColumn-1),s=l.substring(n.endColumn));var u=o+r+s;t.addEditOperation(new i.Range(a,1,a,e.getLineMaxColumn(a)),null),t.addEditOperation(new i.Range(a,1,a,1),u),this._cutStartIndex=n.startColumn+(this._isMovingLeft?-1:1),this._cutEndIndex=this._cutStartIndex+n.endColumn-n.startColumn,this._moved=!0}},e.prototype.computeCursorState=function(e,t){var i=t.getTrackedSelection(this._selectionId)
;return this._moved&&(i=(i=i.setStartPosition(i.startLineNumber,this._cutStartIndex)).setEndPosition(i.startLineNumber,this._cutEndIndex)),i},e}();t.MoveCaretCommand=n}),define(t[130],i([1,0,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.value=e}return e.prototype.equals=function(e){return this.value===e.value},e.prototype.contains=function(t){return this.equals(t)||i.startsWith(t.value,this.value+e.sep)},e.prototype.intersects=function(e){return this.contains(e)||e.contains(this)},e.sep=".",e.Empty=new e(""),e.QuickFix=new e("quickfix"),e.Refactor=new e("refactor"),e.Source=new e("source"),e.SourceOrganizeImports=new e("source.organizeImports"),e.SourceFixAll=new e("source.fixAll"),e}();t.CodeActionKind=n,t.mayIncludeActionsOfKind=function(e,t){return!(e.kind&&!e.kind.intersects(t)||n.Source.contains(t)&&!e.includeSourceActions)},t.filtersAction=function(e,t){var i=t.kind?new n(t.kind):void 0
;return!(!(!e.kind||i&&e.kind.contains(i))||!e.includeSourceActions&&i&&n.Source.contains(i)||e.onlyIncludePreferredActions&&!t.isPreferred)}}),define(t[245],i([1,0,8,58,10,13,2]),function(e,t,i,n,o,s,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(t,i,n){var o=e.call(this)||this;return o._editor=t,o._contextMenuService=i,o._delegate=n,o._showingActions=o._register(new u.MutableDisposable),o._visible=!1,o}return r(t,e),t.prototype.show=function(e,t){return a(this,void 0,void 0,function(){var i,n=this;return l(this,function(r){return e.actions.length?this._editor.getDomNode()?(this._visible=!0,i=e.actions.map(function(e){return n.codeActionToAction(e)}),this._showingActions.value=e,this._contextMenuService.showContextMenu({getAnchor:function(){return s.Position.isIPosition(t)&&(t=n._toCoords(t)),t||{x:0,y:0}},getActions:function(){return i},onHide:function(){n._visible=!1,n._editor.focus()},autoSelectFirstItem:!0}),[2]):(this._visible=!1,
[2,Promise.reject(o.canceled())]):(this._visible=!1,[2])})})},t.prototype.codeActionToAction=function(e){var t=this,i=e.command?e.command.id:e.title,o=e.title;return new n.Action(i,o,void 0,!0,function(){return t._delegate.onSelectCodeAction(e)})},Object.defineProperty(t.prototype,"isVisible",{get:function(){return this._visible},enumerable:!0,configurable:!0}),t.prototype._toCoords=function(e){if(!this._editor.hasModel())return{x:0,y:0};this._editor.revealPosition(e,1),this._editor.render();var t=this._editor.getScrolledVisiblePosition(e),n=i.getDomNodePagePosition(this._editor.getDomNode());return{x:n.left+t.left,y:n.top+t.top+t.height}},t}(u.Disposable);t.CodeActionWidget=d}),define(t[246],i([1,0,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,n){this.presentationIndex=n,this._onColorFlushed=new i.Emitter,this.onColorFlushed=this._onColorFlushed.event,this._onDidChangeColor=new i.Emitter,this.onDidChangeColor=this._onDidChangeColor.event,
this._onDidChangePresentation=new i.Emitter,this.onDidChangePresentation=this._onDidChangePresentation.event,this.originalColor=e,this._color=e,this._colorPresentations=t}return Object.defineProperty(e.prototype,"color",{get:function(){return this._color},set:function(e){this._color.equals(e)||(this._color=e,this._onDidChangeColor.fire(e))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"presentation",{get:function(){return this.colorPresentations[this.presentationIndex]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"colorPresentations",{get:function(){return this._colorPresentations},set:function(e){this._colorPresentations=e,this.presentationIndex>e.length-1&&(this.presentationIndex=0),this._onDidChangePresentation.fire(this.presentation)},enumerable:!0,configurable:!0}),e.prototype.selectNextColorPresentation=function(){this.presentationIndex=(this.presentationIndex+1)%this.colorPresentations.length,this.flushColor(),
this._onDidChangePresentation.fire(this.presentation)},e.prototype.guessColorPresentation=function(e,t){for(var i=0;i<this.colorPresentations.length;i++)if(t===this.colorPresentations[i].label){this.presentationIndex=i,this._onDidChangePresentation.fire(this.presentation);break}},e.prototype.flushColor=function(){this._onColorFlushed.fire(this._color)},e}();t.ColorPickerModel=n}),define(t[174],i([1,0,53,13,3,20,40]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(e){this._selection=e,this._usedEndToken=null}return e._haystackHasNeedleAtOffset=function(e,t,i){if(i<0)return!1;var n=t.length;if(i+n>e.length)return!1;for(var o=0;o<n;o++){var r=e.charCodeAt(i+o),s=t.charCodeAt(o);if(r!==s&&!(r>=65&&r<=90&&r+32===s||s>=65&&s<=90&&s+32===r))return!1}return!0},e.prototype._createOperationsForBlockComment=function(t,i,n,r,s){
var a=t.startLineNumber,l=t.startColumn,u=t.endLineNumber,d=t.endColumn,c=r.getLineContent(a),h=r.getLineContent(u),p=c.lastIndexOf(i,l-1+i.length),f=h.indexOf(n,d-1-n.length);if(-1!==p&&-1!==f)if(a===u){c.substring(p+i.length,f).indexOf(n)>=0&&(p=-1,f=-1)}else{var g=c.substring(p+i.length),m=h.substring(0,f);(g.indexOf(n)>=0||m.indexOf(n)>=0)&&(p=-1,f=-1)}var v;-1!==p&&-1!==f?(p+i.length<c.length&&32===c.charCodeAt(p+i.length)&&(i+=" "),f>0&&32===h.charCodeAt(f-1)&&(n=" "+n,f-=1),v=e._createRemoveBlockCommentOperations(new o.Range(a,p+i.length+1,u,f+1),i,n)):(v=e._createAddBlockCommentOperations(t,i,n),this._usedEndToken=1===v.length?n:null);for(var _=0,y=v;_<y.length;_++){var b=y[_];s.addTrackedEditOperation(b.range,b.text)}},e._createRemoveBlockCommentOperations=function(e,t,n){var r=[]
;return o.Range.isEmpty(e)?r.push(i.EditOperation.delete(new o.Range(e.startLineNumber,e.startColumn-t.length,e.endLineNumber,e.endColumn+n.length))):(r.push(i.EditOperation.delete(new o.Range(e.startLineNumber,e.startColumn-t.length,e.startLineNumber,e.startColumn))),r.push(i.EditOperation.delete(new o.Range(e.endLineNumber,e.endColumn,e.endLineNumber,e.endColumn+n.length)))),r},e._createAddBlockCommentOperations=function(e,t,r){var s=[];return o.Range.isEmpty(e)?s.push(i.EditOperation.replace(new o.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn),t+"  "+r)):(s.push(i.EditOperation.insert(new n.Position(e.startLineNumber,e.startColumn),t+" ")),s.push(i.EditOperation.insert(new n.Position(e.endLineNumber,e.endColumn)," "+r))),s},e.prototype.getEditOperations=function(e,t){var i=this._selection.startLineNumber,n=this._selection.startColumn;e.tokenizeIfCheap(i);var o=e.getLanguageIdAtPosition(i,n),r=s.LanguageConfigurationRegistry.getComments(o)
;r&&r.blockCommentStartToken&&r.blockCommentEndToken&&this._createOperationsForBlockComment(this._selection,r.blockCommentStartToken,r.blockCommentEndToken,e,t)},e.prototype.computeCursorState=function(e,t){var i=t.getInverseEditOperations();if(2===i.length){var n=i[0],o=i[1];return new r.Selection(n.range.endLineNumber,n.range.endColumn,o.range.startLineNumber,o.range.startColumn)}var s=i[0].range,a=this._usedEndToken?-this._usedEndToken.length-1:0;return new r.Selection(s.endLineNumber,s.endColumn+a,s.endLineNumber,s.endColumn+a)},e}();t.BlockCommentCommand=a}),define(t[248],i([1,0,5,53,13,3,20,40,174]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t,i){this._selection=e,this._selectionId=null,this._tabSize=t,this._type=i,this._deltaColumn=0,this._moveEndPositionDown=!1}return e._gatherPreflightCommentStrings=function(e,t,i){e.tokenizeIfCheap(t)
;var n=e.getLanguageIdAtPosition(t,1),o=a.LanguageConfigurationRegistry.getComments(n),r=o?o.lineCommentToken:null;if(!r)return null;for(var s=[],l=0,u=i-t+1;l<u;l++)s[l]={ignore:!1,commentStr:r,commentStrOffset:0,commentStrLength:r.length};return s},e._analyzeLines=function(e,t,n,o){var r,s=!0;r=0===e||1!==e;for(var a=0,u=n.length;a<u;a++){var d=n[a],c=o+a,h=t.getLineContent(c),p=i.firstNonWhitespaceIndex(h);if(-1!==p){if(s=!1,d.ignore=!1,d.commentStrOffset=p,r&&!l.BlockCommentCommand._haystackHasNeedleAtOffset(h,d.commentStr,p)&&(0===e?r=!1:1===e||(d.ignore=!0)),r){var f=p+d.commentStrLength;f<h.length&&32===h.charCodeAt(f)&&(d.commentStrLength+=1)}}else d.ignore=!0,d.commentStrOffset=h.length}if(0===e&&s){r=!1;for(var a=0,u=n.length;a<u;a++)n[a].ignore=!1}return{supported:!0,shouldRemoveComments:r,lines:n}},e._gatherPreflightData=function(t,i,n,o){var r=e._gatherPreflightCommentStrings(i,n,o);return null===r?{supported:!1}:e._analyzeLines(t,i,r,n)},e.prototype._executeLineComments=function(t,i,n,r){var s
;n.shouldRemoveComments?s=e._createRemoveLineCommentsOperations(n.lines,r.startLineNumber):(e._normalizeInsertionPoint(t,n.lines,r.startLineNumber,this._tabSize),s=e._createAddLineCommentsOperations(n.lines,r.startLineNumber));for(var a=new o.Position(r.positionLineNumber,r.positionColumn),l=0,u=s.length;l<u;l++)if(i.addEditOperation(s[l].range,s[l].text),s[l].range.isEmpty()&&s[l].range.getStartPosition().equals(a)){t.getLineContent(a.lineNumber).length+1===a.column&&(this._deltaColumn=(s[l].text||"").length)}this._selectionId=i.trackSelection(r)},e.prototype._attemptRemoveBlockComment=function(e,t,i,n){var o=t.startLineNumber,s=t.endLineNumber,a=n.length+Math.max(e.getLineFirstNonWhitespaceColumn(t.startLineNumber),t.startColumn),u=e.getLineContent(o).lastIndexOf(i,a-1),d=e.getLineContent(s).indexOf(n,t.endColumn-1-i.length);return-1!==u&&-1===d&&(d=e.getLineContent(o).indexOf(n,u+i.length),s=o),-1===u&&-1!==d&&(u=e.getLineContent(s).lastIndexOf(i,d),o=s),
!t.isEmpty()||-1!==u&&-1!==d||-1!==(u=e.getLineContent(o).indexOf(i))&&(d=e.getLineContent(o).indexOf(n,u+i.length)),-1!==u&&32===e.getLineContent(o).charCodeAt(u+i.length)&&(i+=" "),-1!==d&&32===e.getLineContent(s).charCodeAt(d-1)&&(n=" "+n,d-=1),-1!==u&&-1!==d?l.BlockCommentCommand._createRemoveBlockCommentOperations(new r.Range(o,u+i.length+1,s,d+1),i,n):null},e.prototype._executeBlockComment=function(e,t,n){e.tokenizeIfCheap(n.startLineNumber);var o=e.getLanguageIdAtPosition(n.startLineNumber,1),s=a.LanguageConfigurationRegistry.getComments(o);if(s&&s.blockCommentStartToken&&s.blockCommentEndToken){var u=s.blockCommentStartToken,d=s.blockCommentEndToken,c=this._attemptRemoveBlockComment(e,n,u,d);if(!c){if(n.isEmpty()){var h=e.getLineContent(n.startLineNumber),p=i.firstNonWhitespaceIndex(h);-1===p&&(p=h.length),c=l.BlockCommentCommand._createAddBlockCommentOperations(new r.Range(n.startLineNumber,p+1,n.startLineNumber,h.length+1),u,d)
}else c=l.BlockCommentCommand._createAddBlockCommentOperations(new r.Range(n.startLineNumber,e.getLineFirstNonWhitespaceColumn(n.startLineNumber),n.endLineNumber,e.getLineMaxColumn(n.endLineNumber)),u,d);1===c.length&&(this._deltaColumn=u.length+1)}this._selectionId=t.trackSelection(n);for(var f=0,g=c;f<g.length;f++){var m=g[f];t.addEditOperation(m.range,m.text)}}},e.prototype.getEditOperations=function(t,i){var n=this._selection;this._moveEndPositionDown=!1,n.startLineNumber<n.endLineNumber&&1===n.endColumn&&(this._moveEndPositionDown=!0,n=n.setEndPosition(n.endLineNumber-1,t.getLineMaxColumn(n.endLineNumber-1)));var o=e._gatherPreflightData(this._type,t,n.startLineNumber,n.endLineNumber);return o.supported?this._executeLineComments(t,i,o,n):this._executeBlockComment(t,i,n)},e.prototype.computeCursorState=function(e,t){var i=t.getTrackedSelection(this._selectionId);return this._moveEndPositionDown&&(i=i.setEndPosition(i.endLineNumber+1,1)),
new s.Selection(i.selectionStartLineNumber,i.selectionStartColumn+this._deltaColumn,i.positionLineNumber,i.positionColumn+this._deltaColumn)},e._createRemoveLineCommentsOperations=function(e,t){for(var i=[],o=0,s=e.length;o<s;o++){var a=e[o];a.ignore||i.push(n.EditOperation.delete(new r.Range(t+o,a.commentStrOffset+1,t+o,a.commentStrOffset+a.commentStrLength+1)))}return i},e._createAddLineCommentsOperations=function(e,t){for(var i=[],r=0,s=e.length;r<s;r++){var a=e[r];a.ignore||i.push(n.EditOperation.insert(new o.Position(t+r,a.commentStrOffset+1),a.commentStr+" "))}return i},e.nextVisibleColumn=function(e,t,i,n){return i?e+(t-e%t):e+n},e._normalizeInsertionPoint=function(t,i,n,o){for(var r,s,a=Number.MAX_VALUE,l=0,u=i.length;l<u;l++)if(!i[l].ignore){for(var d=t.getLineContent(n+l),c=0,h=0,p=i[l].commentStrOffset;c<a&&h<p;h++)c=e.nextVisibleColumn(c,o,9===d.charCodeAt(h),1);c<a&&(a=c)}a=Math.floor(a/o)*o;for(var l=0,u=i.length;l<u;l++)if(!i[l].ignore){var d=t.getLineContent(n+l),c=0;for(r=0,
s=i[l].commentStrOffset;c<a&&r<s;r++)c=e.nextVisibleColumn(c,o,9===d.charCodeAt(r),1);i[l].commentStrOffset=c>a?r-1:r}},e}();t.LineCommentCommand=u}),define(t[249],i([1,0,20,3]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t,i){this.selection=e,this.targetPosition=t,this.copy=i,this.targetSelection=null}return e.prototype.getEditOperations=function(e,t){var o=e.getValueInRange(this.selection);this.copy||t.addEditOperation(this.selection,null),t.addEditOperation(new n.Range(this.targetPosition.lineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.targetPosition.column),o),
!this.selection.containsPosition(this.targetPosition)||this.copy&&(this.selection.getEndPosition().equals(this.targetPosition)||this.selection.getStartPosition().equals(this.targetPosition))?this.copy?this.targetSelection=new i.Selection(this.targetPosition.lineNumber,this.targetPosition.column,this.selection.endLineNumber-this.selection.startLineNumber+this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.targetPosition.lineNumber>this.selection.endLineNumber?this.targetSelection=new i.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.targetPosition.lineNumber<this.selection.endLineNumber?this.targetSelection=new i.Selection(this.targetPosition.lineNumber,this.targetPosition.column,this.targetPosition.lineNumber+this.selection.endLineNumber-this.selection.startLineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.selection.endColumn<=this.targetPosition.column?this.targetSelection=new i.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,(this.selection.startLineNumber,
this.selection.endLineNumber,this.targetPosition.column-this.selection.endColumn+this.selection.startColumn),this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column:this.selection.endColumn):this.targetSelection=new i.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.targetPosition.column+this.selection.endColumn-this.selection.startColumn):this.targetSelection=this.selection},e.prototype.computeCursorState=function(e,t){return this.targetSelection},e}();t.DragAndDropCommand=o}),define(t[250],i([1,0,4,3]),function(e,t,i,n){"use strict";function o(e,t){return 1===e||2!==e&&t}Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){this._onFindReplaceStateChange=new i.Emitter,this.onFindReplaceStateChange=this._onFindReplaceStateChange.event,this._searchString="",this._replaceString="",this._isRevealed=!1,
this._isReplaceRevealed=!1,this._isRegex=!1,this._isRegexOverride=0,this._wholeWord=!1,this._wholeWordOverride=0,this._matchCase=!1,this._matchCaseOverride=0,this._preserveCase=!1,this._preserveCaseOverride=0,this._searchScope=null,this._matchesPosition=0,this._matchesCount=0,this._currentMatch=null}return Object.defineProperty(e.prototype,"searchString",{get:function(){return this._searchString},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"replaceString",{get:function(){return this._replaceString},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRevealed",{get:function(){return this._isRevealed},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isReplaceRevealed",{get:function(){return this._isReplaceRevealed},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRegex",{get:function(){return o(this._isRegexOverride,this._isRegex)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"wholeWord",{get:function(){
return o(this._wholeWordOverride,this._wholeWord)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchCase",{get:function(){return o(this._matchCaseOverride,this._matchCase)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"preserveCase",{get:function(){return o(this._preserveCaseOverride,this._preserveCase)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualIsRegex",{get:function(){return this._isRegex},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualWholeWord",{get:function(){return this._wholeWord},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualMatchCase",{get:function(){return this._matchCase},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualPreserveCase",{get:function(){return this._preserveCase},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"searchScope",{get:function(){return this._searchScope},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"matchesPosition",{get:function(){return this._matchesPosition},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchesCount",{get:function(){return this._matchesCount},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"currentMatch",{get:function(){return this._currentMatch},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){},e.prototype.changeMatchInfo=function(e,t,i){var o={moveCursor:!1,updateHistory:!1,searchString:!1,replaceString:!1,isRevealed:!1,isReplaceRevealed:!1,isRegex:!1,wholeWord:!1,matchCase:!1,preserveCase:!1,searchScope:!1,matchesPosition:!1,matchesCount:!1,currentMatch:!1},r=!1;0===t&&(e=0),e>t&&(e=t),this._matchesPosition!==e&&(this._matchesPosition=e,o.matchesPosition=!0,r=!0),this._matchesCount!==t&&(this._matchesCount=t,o.matchesCount=!0,r=!0),void 0!==i&&(n.Range.equalsRange(this._currentMatch,i)||(this._currentMatch=i,o.currentMatch=!0,r=!0)),r&&this._onFindReplaceStateChange.fire(o)},
e.prototype.change=function(e,t,i){void 0===i&&(i=!0);var o={moveCursor:t,updateHistory:i,searchString:!1,replaceString:!1,isRevealed:!1,isReplaceRevealed:!1,isRegex:!1,wholeWord:!1,matchCase:!1,preserveCase:!1,searchScope:!1,matchesPosition:!1,matchesCount:!1,currentMatch:!1},r=!1,s=this.isRegex,a=this.wholeWord,l=this.matchCase,u=this.preserveCase;void 0!==e.searchString&&this._searchString!==e.searchString&&(this._searchString=e.searchString,o.searchString=!0,r=!0),void 0!==e.replaceString&&this._replaceString!==e.replaceString&&(this._replaceString=e.replaceString,o.replaceString=!0,r=!0),void 0!==e.isRevealed&&this._isRevealed!==e.isRevealed&&(this._isRevealed=e.isRevealed,o.isRevealed=!0,r=!0),void 0!==e.isReplaceRevealed&&this._isReplaceRevealed!==e.isReplaceRevealed&&(this._isReplaceRevealed=e.isReplaceRevealed,o.isReplaceRevealed=!0,r=!0),void 0!==e.isRegex&&(this._isRegex=e.isRegex),void 0!==e.wholeWord&&(this._wholeWord=e.wholeWord),void 0!==e.matchCase&&(this._matchCase=e.matchCase),
void 0!==e.preserveCase&&(this._preserveCase=e.preserveCase),void 0!==e.searchScope&&(n.Range.equalsRange(this._searchScope,e.searchScope)||(this._searchScope=e.searchScope,o.searchScope=!0,r=!0)),this._isRegexOverride=void 0!==e.isRegexOverride?e.isRegexOverride:0,this._wholeWordOverride=void 0!==e.wholeWordOverride?e.wholeWordOverride:0,this._matchCaseOverride=void 0!==e.matchCaseOverride?e.matchCaseOverride:0,this._preserveCaseOverride=void 0!==e.preserveCaseOverride?e.preserveCaseOverride:0,s!==this.isRegex&&(r=!0,o.isRegex=!0),a!==this.wholeWord&&(r=!0,o.wholeWord=!0),l!==this.matchCase&&(r=!0,o.matchCase=!0),u!==this.preserveCase&&(r=!0,o.preserveCase=!0),r&&this._onFindReplaceStateChange.fire(o)},e}();t.FindReplaceState=r}),define(t[251],i([1,0,3]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i){this._editorSelection=e,this._ranges=t,this._replaceStrings=i,this._trackedEditorSelectionId=null}
return e.prototype.getEditOperations=function(e,t){if(this._ranges.length>0){for(var n=[],o=0;o<this._ranges.length;o++)n.push({range:this._ranges[o],text:this._replaceStrings[o]});n.sort(function(e,t){return i.Range.compareRangesUsingStarts(e.range,t.range)});for(var r=[],s=n[0],o=1;o<n.length;o++)s.range.endLineNumber===n[o].range.startLineNumber&&s.range.endColumn===n[o].range.startColumn?(s.range=s.range.plusRange(n[o].range),s.text=s.text+n[o].text):(r.push(s),s=n[o]);r.push(s);for(var a=0,l=r;a<l.length;a++){var u=l[a];t.addEditOperation(u.range,u.text)}}this._trackedEditorSelectionId=t.trackSelection(this._editorSelection)},e.prototype.computeCursorState=function(e,t){return t.getTrackedSelection(this._trackedEditorSelectionId)},e}();t.ReplaceAllCommand=n}),define(t[252],i([1,0,500]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){return function(e){this.staticValue=e,this.kind=0}}(),o=function(){return function(e){this.pieces=e,this.kind=1}
}(),r=function(){function e(e){e&&0!==e.length?1===e.length&&null!==e[0].staticValue?this._state=new n(e[0].staticValue):this._state=new o(e):this._state=new n("")}return e.fromStaticValue=function(t){return new e([s.staticValue(t)])},Object.defineProperty(e.prototype,"hasReplacementPatterns",{get:function(){return 1===this._state.kind},enumerable:!0,configurable:!0}),e.prototype.buildReplaceString=function(t,n){if(0===this._state.kind)return n?i.buildReplaceStringWithCasePreserved(t,this._state.staticValue):this._state.staticValue;for(var o="",r=0,s=this._state.pieces.length;r<s;r++){var a=this._state.pieces[r];null===a.staticValue?o+=e._substitute(a.matchIndex,t):o+=a.staticValue}return o},e._substitute=function(e,t){if(null===t)return"";if(0===e)return t[0];for(var i="";e>0;){if(e<t.length){return(t[e]||"")+i}i=String(e%10)+i,e=Math.floor(e/10)}return"$"+i},e}();t.ReplacePattern=r;var s=function(){function e(e,t){this.staticValue=e,this.matchIndex=t}return e.staticValue=function(t){return new e(t,-1)},
e.matchIndex=function(t){return new e(null,t)},e}();t.ReplacePiece=s;var a=function(){function e(e){this._source=e,this._lastCharIndex=0,this._result=[],this._resultLen=0,this._currentStaticPiece=""}return e.prototype.emitUnchanged=function(e){this._emitStatic(this._source.substring(this._lastCharIndex,e)),this._lastCharIndex=e},e.prototype.emitStatic=function(e,t){this._emitStatic(e),this._lastCharIndex=t},e.prototype._emitStatic=function(e){0!==e.length&&(this._currentStaticPiece+=e)},e.prototype.emitMatchIndex=function(e,t){0!==this._currentStaticPiece.length&&(this._result[this._resultLen++]=s.staticValue(this._currentStaticPiece),this._currentStaticPiece=""),this._result[this._resultLen++]=s.matchIndex(e),this._lastCharIndex=t},e.prototype.finalize=function(){return this.emitUnchanged(this._source.length),0!==this._currentStaticPiece.length&&(this._result[this._resultLen++]=s.staticValue(this._currentStaticPiece),this._currentStaticPiece=""),new r(this._result)},e}();t.parseReplaceString=function(e){
if(!e||0===e.length)return new r(null);for(var t=new a(e),i=0,n=e.length;i<n;i++){var o=e.charCodeAt(i);if(92!==o){if(36===o){if(++i>=n)break;if(36===(u=e.charCodeAt(i))){t.emitUnchanged(i-1),t.emitStatic("$",i+1);continue}if(48===u||38===u){t.emitUnchanged(i-1),t.emitMatchIndex(0,i+1);continue}if(49<=u&&u<=57){var s=u-48;if(i+1<n){var l=e.charCodeAt(i+1);if(48<=l&&l<=57){i++,s=10*s+(l-48),t.emitUnchanged(i-2),t.emitMatchIndex(s,i+1);continue}}t.emitUnchanged(i-1),t.emitMatchIndex(s,i+1);continue}}}else{if(++i>=n)break;var u;switch(u=e.charCodeAt(i)){case 92:t.emitUnchanged(i-1),t.emitStatic("\\",i+1);break;case 110:t.emitUnchanged(i-1),t.emitStatic("\n",i+1);break;case 116:t.emitUnchanged(i-1),t.emitStatic("\t",i+1)}}}return t.finalize()}}),define(t[129],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MAX_FOLDING_REGIONS=65535,t.MAX_LINE_NUMBER=16777215;var i=function(){function e(e,i,n){
if(e.length!==i.length||e.length>t.MAX_FOLDING_REGIONS)throw new Error("invalid startIndexes or endIndexes size");this._startIndexes=e,this._endIndexes=i,this._collapseStates=new Uint32Array(Math.ceil(e.length/32)),this._types=n,this._parentsComputed=!1}return e.prototype.ensureParentIndices=function(){var e=this;if(!this._parentsComputed){this._parentsComputed=!0;for(var i=[],n=function(t,n){var o=i[i.length-1];return e.getStartLineNumber(o)<=t&&e.getEndLineNumber(o)>=n},o=0,r=this._startIndexes.length;o<r;o++){var s=this._startIndexes[o],a=this._endIndexes[o];if(s>t.MAX_LINE_NUMBER||a>t.MAX_LINE_NUMBER)throw new Error("startLineNumber or endLineNumber must not exceed "+t.MAX_LINE_NUMBER);for(;i.length>0&&!n(s,a);)i.pop();var l=i.length>0?i[i.length-1]:-1;i.push(o),this._startIndexes[o]=s+((255&l)<<24),this._endIndexes[o]=a+((65280&l)<<16)}}},Object.defineProperty(e.prototype,"length",{get:function(){return this._startIndexes.length},enumerable:!0,configurable:!0}),e.prototype.getStartLineNumber=function(e){
return this._startIndexes[e]&t.MAX_LINE_NUMBER},e.prototype.getEndLineNumber=function(e){return this._endIndexes[e]&t.MAX_LINE_NUMBER},e.prototype.getType=function(e){return this._types?this._types[e]:void 0},e.prototype.hasTypes=function(){return!!this._types},e.prototype.isCollapsed=function(e){var t=e/32|0,i=e%32;return 0!=(this._collapseStates[t]&1<<i)},e.prototype.setCollapsed=function(e,t){var i=e/32|0,n=e%32,o=this._collapseStates[i];this._collapseStates[i]=t?o|1<<n:o&~(1<<n)},e.prototype.toRegion=function(e){return new n(this,e)},e.prototype.getParentIndex=function(e){this.ensureParentIndices();var i=((4278190080&this._startIndexes[e])>>>24)+((4278190080&this._endIndexes[e])>>>16);return i===t.MAX_FOLDING_REGIONS?-1:i},e.prototype.contains=function(e,t){return this.getStartLineNumber(e)<=t&&this.getEndLineNumber(e)>=t},e.prototype.findIndex=function(e){var t=0,i=this._startIndexes.length;if(0===i)return-1;for(;t<i;){var n=Math.floor((t+i)/2);e<this.getStartLineNumber(n)?i=n:t=n+1}return t-1},
e.prototype.findRange=function(e){var t=this.findIndex(e);if(t>=0){if(this.getEndLineNumber(t)>=e)return t;for(t=this.getParentIndex(t);-1!==t;){if(this.contains(t,e))return t;t=this.getParentIndex(t)}}return-1},e.prototype.toString=function(){for(var e=[],t=0;t<this.length;t++)e[t]="["+(this.isCollapsed(t)?"+":"-")+"] "+this.getStartLineNumber(t)+"/"+this.getEndLineNumber(t);return e.join(", ")},e}();t.FoldingRegions=i;var n=function(){function e(e,t){this.ranges=e,this.index=t}return Object.defineProperty(e.prototype,"startLineNumber",{get:function(){return this.ranges.getStartLineNumber(this.index)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"endLineNumber",{get:function(){return this.ranges.getEndLineNumber(this.index)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"regionIndex",{get:function(){return this.index},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parentIndex",{get:function(){return this.ranges.getParentIndex(this.index)},
enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isCollapsed",{get:function(){return this.ranges.isCollapsed(this.index)},enumerable:!0,configurable:!0}),e.prototype.containedBy=function(e){return e.startLineNumber<=this.startLineNumber&&e.endLineNumber>=this.endLineNumber},e.prototype.containsLine=function(e){return this.startLineNumber<=e&&e<=this.endLineNumber},e}();t.FoldingRegion=n}),define(t[254],i([1,0,4,129]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t){this._updateEventEmitter=new i.Emitter,this.onDidChange=this._updateEventEmitter.event,this._textModel=e,this._decorationProvider=t,this._regions=new n.FoldingRegions(new Uint32Array(0),new Uint32Array(0)),this._editorDecorationIds=[],this._isInitialized=!1}return Object.defineProperty(e.prototype,"regions",{get:function(){return this._regions},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"textModel",{get:function(){return this._textModel},
enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isInitialized",{get:function(){return this._isInitialized},enumerable:!0,configurable:!0}),e.prototype.toggleCollapseState=function(e){var t=this;if(e.length){var i={};this._decorationProvider.changeDecorations(function(n){for(var o=0,r=e;o<r.length;o++){var s=r[o].regionIndex,a=t._editorDecorationIds[s];if(a&&!i[a]){i[a]=!0;var l=!t._regions.isCollapsed(s);t._regions.setCollapsed(s,l),n.changeDecorationOptions(a,t._decorationProvider.getDecorationOption(l))}}}),this._updateEventEmitter.fire({model:this,collapseStateChanged:e})}},e.prototype.update=function(e,t){var i=this;void 0===t&&(t=[]);for(var n=[],o=function(o,r){var s=e.getStartLineNumber(o);r&&function(e,i){for(var n=0,o=t;n<o.length;n++){var r=o[n];if(e<r&&r<=i)return!0}return!1}(s,e.getEndLineNumber(o))&&(r=!1),e.setCollapsed(o,r);var a=i._textModel.getLineMaxColumn(s),l={startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a};n.push({range:l,
options:i._decorationProvider.getDecorationOption(r)})},r=0,s=function(){for(;r<i._regions.length;){var e=i._regions.isCollapsed(r);if(r++,e)return r-1}return-1},a=0,l=s();-1!==l&&a<e.length;){var u=this._textModel.getDecorationRange(this._editorDecorationIds[l]);if(u){var d=u.startLineNumber;if(this._textModel.getLineMaxColumn(d)===u.startColumn)for(;a<e.length;){var c=e.getStartLineNumber(a);if(!(d>=c))break;o(a,d===c),a++}}l=s()}for(;a<e.length;)o(a,!1),a++;this._editorDecorationIds=this._decorationProvider.deltaDecorations(this._editorDecorationIds,n),this._regions=e,this._isInitialized=!0,this._updateEventEmitter.fire({model:this})},e.prototype.getMemento=function(){for(var e=[],t=0;t<this._regions.length;t++)if(this._regions.isCollapsed(t)){var i=this._textModel.getDecorationRange(this._editorDecorationIds[t]);if(i){var n=i.startLineNumber,o=i.endLineNumber+this._regions.getEndLineNumber(t)-this._regions.getStartLineNumber(t);e.push({startLineNumber:n,endLineNumber:o})}}if(e.length>0)return e},
e.prototype.applyMemento=function(e){if(Array.isArray(e)){for(var t=[],i=0,n=e;i<n.length;i++){var o=n[i],r=this.getRegionAtLine(o.startLineNumber);r&&!r.isCollapsed&&t.push(r)}this.toggleCollapseState(t)}},e.prototype.dispose=function(){this._decorationProvider.deltaDecorations(this._editorDecorationIds,[])},e.prototype.getAllRegionsAtLine=function(e,t){var i=[];if(this._regions)for(var n=this._regions.findRange(e),o=1;n>=0;){var r=this._regions.toRegion(n);t&&!t(r,o)||i.push(r),o++,n=r.parentIndex}return i},e.prototype.getRegionAtLine=function(e){if(this._regions){var t=this._regions.findRange(e);if(t>=0)return this._regions.toRegion(t)}return null},e.prototype.getRegionsInside=function(e,t){var i=[],n=e?e.regionIndex+1:0,o=e?e.endLineNumber:Number.MAX_VALUE;if(t&&2===t.length)for(var r=[],s=n,a=this._regions.length;s<a;s++){l=this._regions.toRegion(s);if(!(this._regions.getStartLineNumber(s)<o))break;for(;r.length>0&&!l.containedBy(r[r.length-1]);)r.pop();r.push(l),t(l,r.length)&&i.push(l)
}else for(var s=n,a=this._regions.length;s<a;s++){var l=this._regions.toRegion(s);if(!(this._regions.getStartLineNumber(s)<o))break;t&&!t(l)||i.push(l)}return i},e}();t.FoldingModel=o,t.setCollapseStateLevelsDown=function(e,t,i,n){void 0===i&&(i=Number.MAX_VALUE);var o=[];if(n&&n.length>0)for(var r=0,s=n;r<s.length;r++){var a=s[r],l=e.getRegionAtLine(a);l&&(l.isCollapsed!==t&&o.push(l),i>1)&&(u=e.getRegionsInside(l,function(e,n){return e.isCollapsed!==t&&n<i}),o.push.apply(o,u))}else{var u=e.getRegionsInside(null,function(e,n){return e.isCollapsed!==t&&n<i});o.push.apply(o,u)}e.toggleCollapseState(o)},t.setCollapseStateLevelsUp=function(e,t,i,n){for(var o=[],r=0,s=n;r<s.length;r++){var a=s[r],l=e.getAllRegionsAtLine(a,function(e,n){return e.isCollapsed!==t&&n<=i});o.push.apply(o,l)}e.toggleCollapseState(o)},t.setCollapseStateAtLevel=function(e,t,i,n){var o=e.getRegionsInside(null,function(e,o){return o===t&&e.isCollapsed!==i&&!n.some(function(t){return e.containsLine(t)})});e.toggleCollapseState(o)},
t.setCollapseStateForMatchingLines=function(e,t,i){for(var n=e.textModel,o=e.regions,r=[],s=o.length-1;s>=0;s--)if(i!==o.isCollapsed(s)){var a=o.getStartLineNumber(s);t.test(n.getLineContent(a))&&r.push(o.toRegion(s))}e.toggleCollapseState(r)},t.setCollapseStateForType=function(e,t,i){for(var n=e.regions,o=[],r=n.length-1;r>=0;r--)i!==n.isCollapsed(r)&&t===n.getType(r)&&o.push(n.toRegion(r));e.toggleCollapseState(o)}}),define(t[255],i([1,0,4,3,19]),function(e,t,i,n,o){"use strict";function r(e,t){var i=o.findFirstInSorted(e,function(e){return t<e.startLineNumber})-1;return i>=0&&e[i].endLineNumber>=t?e[i]:null}Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e){var t=this;this._updateEventEmitter=new i.Emitter,this._foldingModel=e,this._foldingModelListener=e.onDidChange(function(e){return t.updateHiddenRanges()}),this._hiddenRanges=[],e.regions.length&&this.updateHiddenRanges()}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){
return this._updateEventEmitter.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hiddenRanges",{get:function(){return this._hiddenRanges},enumerable:!0,configurable:!0}),e.prototype.updateHiddenRanges=function(){for(var e=!1,t=[],i=0,o=0,r=Number.MAX_VALUE,s=-1,a=this._foldingModel.regions;i<a.length;i++)if(a.isCollapsed(i)){var l=a.getStartLineNumber(i)+1,u=a.getEndLineNumber(i);r<=l&&u<=s||(!e&&o<this._hiddenRanges.length&&this._hiddenRanges[o].startLineNumber===l&&this._hiddenRanges[o].endLineNumber===u?(t.push(this._hiddenRanges[o]),o++):(e=!0,t.push(new n.Range(l,1,u,1))),r=l,s=u)}(e||o<this._hiddenRanges.length)&&this.applyHiddenRanges(t)},e.prototype.applyMemento=function(e){if(!Array.isArray(e)||0===e.length)return!1;for(var t=[],i=0,o=e;i<o.length;i++){var r=o[i];if(!r.startLineNumber||!r.endLineNumber)return!1;t.push(new n.Range(r.startLineNumber+1,1,r.endLineNumber,1))}return this.applyHiddenRanges(t),!0},e.prototype.getMemento=function(){
return this._hiddenRanges.map(function(e){return{startLineNumber:e.startLineNumber-1,endLineNumber:e.endLineNumber}})},e.prototype.applyHiddenRanges=function(e){this._hiddenRanges=e,this._updateEventEmitter.fire(e)},e.prototype.hasRanges=function(){return this._hiddenRanges.length>0},e.prototype.isHidden=function(e){return null!==r(this._hiddenRanges,e)},e.prototype.adjustSelections=function(e){for(var t=this,i=!1,n=this._foldingModel.textModel,o=null,s=function(e){return o&&function(e,t){return e>=t.startLineNumber&&e<=t.endLineNumber}(e,o)||(o=r(t._hiddenRanges,e)),o?o.startLineNumber-1:null},a=0,l=e.length;a<l;a++){var u=e[a],d=s(u.startLineNumber);d&&(u=u.setStartPosition(d,n.getLineMaxColumn(d)),i=!0);var c=s(u.endLineNumber);c&&(u=u.setEndPosition(c,n.getLineMaxColumn(c)),i=!0),e[a]=u}return i},e.prototype.dispose=function(){this.hiddenRanges.length>0&&(this._hiddenRanges=[],this._updateEventEmitter.fire(this._hiddenRanges)),this._foldingModelListener&&(this._foldingModelListener.dispose(),
this._foldingModelListener=null)},e}();t.HiddenRangeModel=s}),define(t[175],i([1,0,10,129]),function(e,t,i,n){"use strict";function o(e,t){for(var i=e.sort(function(e,t){var i=e.start-t.start;return 0===i&&(i=e.rank-t.rank),i}),n=new l(t),o=void 0,r=[],s=0,a=i;s<a.length;s++){var u=a[s];if(o){if(u.start>o.start)if(u.end<=o.end)r.push(o),o=u,n.add(u.start,u.end,u.kind&&u.kind.value,r.length);else{if(u.start>o.end){do{o=r.pop()}while(o&&u.start>o.end);o&&r.push(o),o=u}n.add(u.start,u.end,u.kind&&u.kind.value,r.length)}}else o=u,n.add(u.start,u.end,u.kind&&u.kind.value,r.length)}return n.toIndentRanges()}Object.defineProperty(t,"__esModule",{value:!0});var r=5e3,s={};t.ID_SYNTAX_PROVIDER="syntax";var a=function(){function e(e,i,n){void 0===n&&(n=r),this.editorModel=e,this.providers=i,this.limit=n,this.id=t.ID_SYNTAX_PROVIDER}return e.prototype.compute=function(e){var t=this;return function(e,t,n){var o=null,r=e.map(function(e,r){return Promise.resolve(e.provideFoldingRanges(t,s,n)).then(function(e){
if(!n.isCancellationRequested&&Array.isArray(e)){Array.isArray(o)||(o=[]);for(var i=t.getLineCount(),s=0,a=e;s<a.length;s++){var l=a[s];l.start>0&&l.end>l.start&&l.end<=i&&o.push({start:l.start,end:l.end,rank:r,kind:l.kind})}}},i.onUnexpectedExternalError)});return Promise.all(r).then(function(e){return o})}(this.providers,this.editorModel,e).then(function(e){if(e){return o(e,t.limit)}return null})},e.prototype.dispose=function(){},e}();t.SyntaxRangeProvider=a;var l=function(){function e(e){this._startIndexes=[],this._endIndexes=[],this._nestingLevels=[],this._nestingLevelCounts=[],this._types=[],this._length=0,this._foldingRangesLimit=e}return e.prototype.add=function(e,t,i,o){if(!(e>n.MAX_LINE_NUMBER||t>n.MAX_LINE_NUMBER)){var r=this._length;this._startIndexes[r]=e,this._endIndexes[r]=t,this._nestingLevels[r]=o,this._types[r]=i,this._length++,o<30&&(this._nestingLevelCounts[o]=(this._nestingLevelCounts[o]||0)+1)}},e.prototype.toIndentRanges=function(){if(this._length<=this._foldingRangesLimit){
for(var e=new Uint32Array(this._length),t=new Uint32Array(this._length),i=0;i<this._length;i++)e[i]=this._startIndexes[i],t[i]=this._endIndexes[i];return new n.FoldingRegions(e,t,this._types)}for(var o=0,r=this._nestingLevelCounts.length,i=0;i<this._nestingLevelCounts.length;i++){var s=this._nestingLevelCounts[i];if(s){if(s+o>this._foldingRangesLimit){r=i;break}o+=s}}for(var e=new Uint32Array(this._foldingRangesLimit),t=new Uint32Array(this._foldingRangesLimit),a=[],i=0,l=0;i<this._length;i++){var u=this._nestingLevels[i];(u<r||u===r&&o++<this._foldingRangesLimit)&&(e[l]=this._startIndexes[i],t[l]=this._endIndexes[i],a[l]=this._types[i],l++)}return new n.FoldingRegions(e,t,a)},e}();t.RangesCollector=l,t.sanitizeRanges=o}),define(t[257],i([1,0,175]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ID_INIT_PROVIDER="init";var n=function(){function e(e,i,n,o){if(this.editorModel=e,this.id=t.ID_INIT_PROVIDER,i.length){var r=function(t){return{range:{
startLineNumber:t.startLineNumber,startColumn:0,endLineNumber:t.endLineNumber,endColumn:e.getLineLength(t.endLineNumber)},options:{stickiness:1}}};this.decorationIds=e.deltaDecorations([],i.map(r)),this.timeout=setTimeout(n,o)}}return e.prototype.dispose=function(){this.decorationIds&&(this.editorModel.deltaDecorations(this.decorationIds,[]),this.decorationIds=void 0),"number"==typeof this.timeout&&(clearTimeout(this.timeout),this.timeout=void 0)},e.prototype.compute=function(e){var t=[];if(this.decorationIds)for(var n=0,o=this.decorationIds;n<o.length;n++){var r=o[n],s=this.editorModel.getDecorationRange(r);s&&t.push({start:s.startLineNumber,end:s.endLineNumber,rank:1})}return Promise.resolve(i.sanitizeRanges(t,Number.MAX_VALUE))},e}();t.InitializingRangeProvider=n}),define(t[176],i([1,0,53,3]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){}return e._handleEolEdits=function(e,t){for(var i=void 0,n=[],o=0,r=t;o<r.length;o++){var s=r[o]
;"number"==typeof s.eol&&(i=s.eol),s.range&&"string"==typeof s.text&&n.push(s)}return"number"==typeof i&&e.hasModel()&&e.getModel().pushEOL(i),n},e._isFullModelReplaceEdit=function(e,t){if(!e.hasModel())return!1;var i=e.getModel(),n=i.validateRange(t.range);return i.getFullModelRange().equalsRange(n)},e.execute=function(t,o){t.pushUndoStop();var r=e._handleEolEdits(t,o);1===r.length&&e._isFullModelReplaceEdit(t,r[0])?t.executeEdits("formatEditsCommand",r.map(function(e){return i.EditOperation.replace(n.Range.lift(e.range),e.text)})):t.executeEdits("formatEditsCommand",r.map(function(e){return i.EditOperation.replaceMove(n.Range.lift(e.range),e.text)})),t.pushUndoStop()},e}();t.FormattingEdit=o}),define(t[177],i([1,0,28,2,4,18,172]),function(e,t,i,n,o,s){"use strict";function a(e,t){return!!e[t]}function l(e){return"altKey"===e?s.isMacintosh?new c(57,"metaKey",6,"altKey"):new c(5,"ctrlKey",6,"altKey"):s.isMacintosh?new c(6,"altKey",57,"metaKey"):new c(6,"altKey",5,"ctrlKey")}
Object.defineProperty(t,"__esModule",{value:!0});var u=function(){return function(e,t){this.target=e.target,this.hasTriggerModifier=a(e.event,t.triggerModifier),this.hasSideBySideModifier=a(e.event,t.triggerSideBySideModifier),this.isNoneOrSingleMouseDown=i.isIE||e.event.detail<=1}}();t.ClickLinkMouseEvent=u;var d=function(){return function(e,t){this.keyCodeIsTriggerKey=e.keyCode===t.triggerKey,this.keyCodeIsSideBySideKey=e.keyCode===t.triggerSideBySideKey,this.hasTriggerModifier=a(e,t.triggerModifier)}}();t.ClickLinkKeyboardEvent=d;var c=function(){function e(e,t,i,n){this.triggerKey=e,this.triggerModifier=t,this.triggerSideBySideKey=i,this.triggerSideBySideModifier=n}return e.prototype.equals=function(e){return this.triggerKey===e.triggerKey&&this.triggerModifier===e.triggerModifier&&this.triggerSideBySideKey===e.triggerSideBySideKey&&this.triggerSideBySideModifier===e.triggerSideBySideModifier},e}();t.ClickLinkOptions=c;var h=function(e){function t(t){var i=e.call(this)||this
;return i._onMouseMoveOrRelevantKeyDown=i._register(new o.Emitter),i.onMouseMoveOrRelevantKeyDown=i._onMouseMoveOrRelevantKeyDown.event,i._onExecute=i._register(new o.Emitter),i.onExecute=i._onExecute.event,i._onCancel=i._register(new o.Emitter),i.onCancel=i._onCancel.event,i._editor=t,i._opts=l(i._editor.getConfiguration().multiCursorModifier),i.lastMouseMoveEvent=null,i.hasTriggerKeyOnMouseDown=!1,i._register(i._editor.onDidChangeConfiguration(function(e){if(e.multiCursorModifier){var t=l(i._editor.getConfiguration().multiCursorModifier);if(i._opts.equals(t))return;i._opts=t,i.lastMouseMoveEvent=null,i.hasTriggerKeyOnMouseDown=!1,i._onCancel.fire()}})),i._register(i._editor.onMouseMove(function(e){return i.onEditorMouseMove(new u(e,i._opts))})),i._register(i._editor.onMouseDown(function(e){return i.onEditorMouseDown(new u(e,i._opts))})),i._register(i._editor.onMouseUp(function(e){return i.onEditorMouseUp(new u(e,i._opts))})),i._register(i._editor.onKeyDown(function(e){
return i.onEditorKeyDown(new d(e,i._opts))})),i._register(i._editor.onKeyUp(function(e){return i.onEditorKeyUp(new d(e,i._opts))})),i._register(i._editor.onMouseDrag(function(){return i.resetHandler()})),i._register(i._editor.onDidChangeCursorSelection(function(e){return i.onDidChangeCursorSelection(e)})),i._register(i._editor.onDidChangeModel(function(e){return i.resetHandler()})),i._register(i._editor.onDidChangeModelContent(function(){return i.resetHandler()})),i._register(i._editor.onDidScrollChange(function(e){(e.scrollTopChanged||e.scrollLeftChanged)&&i.resetHandler()})),i}return r(t,e),t.prototype.onDidChangeCursorSelection=function(e){e.selection&&e.selection.startColumn!==e.selection.endColumn&&this.resetHandler()},t.prototype.onEditorMouseMove=function(e){this.lastMouseMoveEvent=e,this._onMouseMoveOrRelevantKeyDown.fire([e,null])},t.prototype.onEditorMouseDown=function(e){this.hasTriggerKeyOnMouseDown=e.hasTriggerModifier},t.prototype.onEditorMouseUp=function(e){
this.hasTriggerKeyOnMouseDown&&this._onExecute.fire(e)},t.prototype.onEditorKeyDown=function(e){this.lastMouseMoveEvent&&(e.keyCodeIsTriggerKey||e.keyCodeIsSideBySideKey&&e.hasTriggerModifier)?this._onMouseMoveOrRelevantKeyDown.fire([this.lastMouseMoveEvent,e]):e.hasTriggerModifier&&this._onCancel.fire()},t.prototype.onEditorKeyUp=function(e){e.keyCodeIsTriggerKey&&this._onCancel.fire()},t.prototype.resetHandler=function(){this.lastMouseMoveEvent=null,this.hasTriggerKeyOnMouseDown=!1,this._onCancel.fire()},t}(n.Disposable);t.ClickLinkGesture=h}),define(t[178],i([1,0,15,10]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t,n,o,r){var s=this;this._computer=e,this._state=0,this._hoverTime=r,this._firstWaitScheduler=new i.RunOnceScheduler(function(){return s._triggerAsyncComputation()},0),this._secondWaitScheduler=new i.RunOnceScheduler(function(){return s._triggerSyncComputation()},0),this._loadingMessageScheduler=new i.RunOnceScheduler(function(){
return s._showLoadingMessage()},0),this._asyncComputationPromise=null,this._asyncComputationPromiseDone=!1,this._completeCallback=t,this._errorCallback=n,this._progressCallback=o}return e.prototype.setHoverTime=function(e){this._hoverTime=e},e.prototype._firstWaitTime=function(){return this._hoverTime/2},e.prototype._secondWaitTime=function(){return this._hoverTime/2},e.prototype._loadingMessageTime=function(){return 3*this._hoverTime},e.prototype._triggerAsyncComputation=function(){var e=this;this._state=2,this._secondWaitScheduler.schedule(this._secondWaitTime()),this._computer.computeAsync?(this._asyncComputationPromiseDone=!1,this._asyncComputationPromise=i.createCancelablePromise(function(t){return e._computer.computeAsync(t)}),this._asyncComputationPromise.then(function(t){e._asyncComputationPromiseDone=!0,e._withAsyncResult(t)},function(t){return e._onError(t)})):this._asyncComputationPromiseDone=!0},e.prototype._triggerSyncComputation=function(){
this._computer.computeSync&&this._computer.onResult(this._computer.computeSync(),!0),this._asyncComputationPromiseDone?(this._state=0,this._onComplete(this._computer.getResult())):(this._state=3,this._onProgress(this._computer.getResult()))},e.prototype._showLoadingMessage=function(){3===this._state&&this._onProgress(this._computer.getResultWithLoadingMessage())},e.prototype._withAsyncResult=function(e){e&&this._computer.onResult(e,!1),3===this._state&&(this._state=0,this._onComplete(this._computer.getResult()))},e.prototype._onComplete=function(e){this._completeCallback&&this._completeCallback(e)},e.prototype._onError=function(e){this._errorCallback?this._errorCallback(e):n.onUnexpectedError(e)},e.prototype._onProgress=function(e){this._progressCallback&&this._progressCallback(e)},e.prototype.start=function(e){if(0===e)0===this._state&&(this._state=1,this._firstWaitScheduler.schedule(this._firstWaitTime()),this._loadingMessageScheduler.schedule(this._loadingMessageTime()));else switch(this._state){case 0:
this._triggerAsyncComputation(),this._secondWaitScheduler.cancel(),this._triggerSyncComputation();break;case 2:this._secondWaitScheduler.cancel(),this._triggerSyncComputation()}},e.prototype.cancel=function(){this._loadingMessageScheduler.cancel(),1===this._state&&this._firstWaitScheduler.cancel(),2===this._state&&(this._secondWaitScheduler.cancel(),this._asyncComputationPromise&&(this._asyncComputationPromise.cancel(),this._asyncComputationPromise=null)),3===this._state&&this._asyncComputationPromise&&(this._asyncComputationPromise.cancel(),this._asyncComputationPromise=null),this._state=0},e}();t.HoverOperation=o}),define(t[179],i([1,0,8,51,45]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t,i){var o=e.call(this)||this;return o.allowEditorOverflow=!0,o._id=t,o._editor=i,o._isVisible=!1,o._stoleFocus=!1,o._containerDomNode=document.createElement("div"),o._containerDomNode.className="monaco-editor-hover hidden",o._containerDomNode.tabIndex=0,
o._domNode=document.createElement("div"),o._domNode.className="monaco-editor-hover-content",o.scrollbar=new n.DomScrollableElement(o._domNode,{}),o._register(o.scrollbar),o._containerDomNode.appendChild(o.scrollbar.getDomNode()),o.onkeydown(o._containerDomNode,function(e){e.equals(9)&&o.hide()}),o._register(o._editor.onDidChangeConfiguration(function(e){e.fontInfo&&o.updateFont()})),o._editor.onDidLayoutChange(function(e){return o.layout()}),o.layout(),o._editor.addContentWidget(o),o._showAtPosition=null,o._showAtRange=null,o._stoleFocus=!1,o}return r(t,e),Object.defineProperty(t.prototype,"isVisible",{get:function(){return this._isVisible},set:function(e){this._isVisible=e,i.toggleClass(this._containerDomNode,"hidden",!this._isVisible)},enumerable:!0,configurable:!0}),t.prototype.getId=function(){return this._id},t.prototype.getDomNode=function(){return this._containerDomNode},t.prototype.showAt=function(e,t,i){this._showAtPosition=e,this._showAtRange=t,this.isVisible=!0,
this._editor.layoutContentWidget(this),this._editor.render(),this._stoleFocus=i,i&&this._containerDomNode.focus()},t.prototype.hide=function(){this.isVisible&&(this.isVisible=!1,this._editor.layoutContentWidget(this),this._stoleFocus&&this._editor.focus())},t.prototype.getPosition=function(){return this.isVisible?{position:this._showAtPosition,range:this._showAtRange,preference:[1,2]}:null},t.prototype.dispose=function(){this._editor.removeContentWidget(this),e.prototype.dispose.call(this)},t.prototype.updateFont=function(){var e=this;Array.prototype.slice.call(this._domNode.getElementsByClassName("code")).forEach(function(t){return e._editor.applyFontInfo(t)})},t.prototype.updateContents=function(e){this._domNode.textContent="",this._domNode.appendChild(e),this.updateFont(),this._editor.layoutContentWidget(this),this.onContentsChange()},t.prototype.onContentsChange=function(){this.scrollbar.scanDomNode()},t.prototype.layout=function(){
var e=Math.max(this._editor.getLayoutInfo().height/4,250),t=this._editor.getConfiguration().fontInfo,i=t.fontSize,n=t.lineHeight;this._domNode.style.fontSize=i+"px",this._domNode.style.lineHeight=n+"px",this._domNode.style.maxHeight=e+"px",this._domNode.style.maxWidth=Math.max(.66*this._editor.getLayoutInfo().width,500)+"px"},t}(o.Widget);t.ContentHoverWidget=s;var a=function(e){function t(t,i){var n=e.call(this)||this;return n._id=t,n._editor=i,n._isVisible=!1,n._domNode=document.createElement("div"),n._domNode.className="monaco-editor-hover hidden",n._domNode.setAttribute("aria-hidden","true"),n._domNode.setAttribute("role","presentation"),n._showAtLineNumber=-1,n._register(n._editor.onDidChangeConfiguration(function(e){e.fontInfo&&n.updateFont()})),n._editor.addOverlayWidget(n),n}return r(t,e),Object.defineProperty(t.prototype,"isVisible",{get:function(){return this._isVisible},set:function(e){this._isVisible=e,i.toggleClass(this._domNode,"hidden",!this._isVisible)},enumerable:!0,configurable:!0}),
t.prototype.getId=function(){return this._id},t.prototype.getDomNode=function(){return this._domNode},t.prototype.showAt=function(e){this._showAtLineNumber=e,this.isVisible||(this.isVisible=!0);var t=this._editor.getLayoutInfo(),i=this._editor.getTopForLineNumber(this._showAtLineNumber),n=this._editor.getScrollTop(),o=this._editor.getConfiguration().lineHeight,r=i-n-(this._domNode.clientHeight-o)/2;this._domNode.style.left=t.glyphMarginLeft+t.glyphMarginWidth+"px",this._domNode.style.top=Math.max(Math.round(r),0)+"px"},t.prototype.hide=function(){this.isVisible&&(this.isVisible=!1)},t.prototype.getPosition=function(){return null},t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),e.prototype.dispose.call(this)},t.prototype.updateFont=function(){var e=this,t=Array.prototype.slice.call(this._domNode.getElementsByTagName("code")),i=Array.prototype.slice.call(this._domNode.getElementsByClassName("code"));t.concat(i).forEach(function(t){return e._editor.applyFontInfo(t)})},
t.prototype.updateContents=function(e){this._domNode.textContent="",this._domNode.appendChild(e),this.updateFont()},t}(o.Widget);t.GlyphHoverWidget=a}),define(t[262],i([1,0,20]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i){this._editRange=e,this._originalSelection=t,this._text=i}return e.prototype.getEditOperations=function(e,t){t.addTrackedEditOperation(this._editRange,this._text)},e.prototype.computeCursorState=function(e,t){var n=t.getInverseEditOperations()[0].range;return this._originalSelection.isEmpty()?new i.Selection(n.endLineNumber,Math.min(this._originalSelection.positionColumn,n.endColumn),n.endLineNumber,Math.min(this._originalSelection.positionColumn,n.endColumn)):new i.Selection(n.endLineNumber,n.endColumn-this._text.length,n.endLineNumber,n.endColumn)},e}();t.InPlaceReplaceCommand=n}),define(t[263],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSpaceCnt=function(e,t){
for(var i=0,n=0;n<e.length;n++)"\t"===e.charAt(n)?i+=t:i++;return i},t.generateIndent=function(e,t,i){e=e<0?0:e;var n="";if(!i){var o=Math.floor(e/t);for(e%=t,r=0;r<o;r++)n+="\t"}for(var r=0;r<e;r++)n+=" ";return n}}),define(t[264],i([1,0,3,20]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t){this._selection=e,this._isCopyingDown=t,this._selectionDirection=0,this._selectionId=null,this._startLineNumberDelta=0,this._endLineNumberDelta=0}return e.prototype.getEditOperations=function(e,t){var n=this._selection;this._startLineNumberDelta=0,this._endLineNumberDelta=0,n.startLineNumber<n.endLineNumber&&1===n.endColumn&&(this._endLineNumberDelta=1,n=n.setEndPosition(n.endLineNumber-1,e.getLineMaxColumn(n.endLineNumber-1)));for(var o=[],r=n.startLineNumber;r<=n.endLineNumber;r++)o.push(e.getLineContent(r));var s=o.join("\n");""===s&&this._isCopyingDown&&(this._startLineNumberDelta++,this._endLineNumberDelta++),
this._isCopyingDown?t.addEditOperation(new i.Range(n.startLineNumber,1,n.startLineNumber,1),s+"\n"):t.addEditOperation(new i.Range(n.endLineNumber,e.getLineMaxColumn(n.endLineNumber),n.endLineNumber,e.getLineMaxColumn(n.endLineNumber)),"\n"+s),this._selectionId=t.trackSelection(n),this._selectionDirection=this._selection.getDirection()},e.prototype.computeCursorState=function(e,t){var i=t.getTrackedSelection(this._selectionId);if(0!==this._startLineNumberDelta||0!==this._endLineNumberDelta){var o=i.startLineNumber,r=i.startColumn,s=i.endLineNumber,a=i.endColumn;0!==this._startLineNumberDelta&&(o+=this._startLineNumberDelta,r=1),0!==this._endLineNumberDelta&&(s+=this._endLineNumberDelta,a=1),i=n.Selection.createWithDirection(o,r,s,a,this._selectionDirection)}return i},e}();t.CopyLinesCommand=o}),define(t[265],i([1,0,53,3]),function(e,t,i,n){"use strict";function o(e,t,i){var n=t.startLineNumber,o=t.endLineNumber;if(1===t.endColumn&&o--,n>=o)return null;for(var r=[],s=n;s<=o;s++)r.push(e.getLineContent(s))
;var a=r.slice(0);return a.sort(function(e,t){return e.toLowerCase().localeCompare(t.toLowerCase())}),!0===i&&(a=a.reverse()),{startLineNumber:n,endLineNumber:o,before:r,after:a}}Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,t){this.selection=e,this.descending=t,this.selectionId=null}return e.prototype.getEditOperations=function(e,t){var r=function(e,t,r){var s=o(e,t,r);return s?i.EditOperation.replace(new n.Range(s.startLineNumber,1,s.endLineNumber,e.getLineMaxColumn(s.endLineNumber)),s.after.join("\n")):null}(e,this.selection,this.descending);r&&t.addEditOperation(r.range,r.text),this.selectionId=t.trackSelection(this.selection)},e.prototype.computeCursorState=function(e,t){return t.getTrackedSelection(this.selectionId)},e.canRun=function(e,t,i){if(null===e)return!1;var n=o(e,t,i);if(!n)return!1;for(var r=0,s=n.before.length;r<s;r++)if(n.before[r]!==n.after[r])return!0;return!1},e}();t.SortLinesCommand=r}),define(t[180],i([1,0,13,3,75]),function(e,t,i,n,o){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){}return e.prototype.provideSelectionRanges=function(t,i){return a(this,void 0,void 0,function(){var n,o,r,s,a;return l(this,function(u){switch(u.label){case 0:n=[],o=function(i){var o,r;return l(this,function(s){switch(s.label){case 0:return o=[],n.push(o),r=new Map,[4,new Promise(function(n){return e._bracketsRightYield(n,0,t,i,r)})];case 1:return s.sent(),[4,new Promise(function(n){return e._bracketsLeftYield(n,0,t,i,r,o)})];case 2:return s.sent(),[2]}})},r=0,s=i,u.label=1;case 1:return r<s.length?(a=s[r],[5,o(a)]):[3,4];case 2:u.sent(),u.label=3;case 3:return r++,[3,1];case 4:return[2,n]}})})},e._bracketsRightYield=function(t,i,n,r,s){for(var a=new Map,l=Date.now();;){if(i>=e._maxRounds){t();break}if(!r){t();break}var u=n.findNextBracket(r);if(!u){t();break}if(Date.now()-l>e._maxDuration){setTimeout(function(){return e._bracketsRightYield(t,i+1,n,r,s)});break}var d=u.close;if(u.isOpen){c=a.has(d)?a.get(d):0;a.set(d,c+1)}else{
var c=a.has(d)?a.get(d):0;if(c-=1,a.set(d,Math.max(0,c)),c<0){var h=s.get(d);h||(h=new o.LinkedList,s.set(d,h)),h.push(u.range)}}r=u.range.getEndPosition()}},e._bracketsLeftYield=function(t,i,o,r,s,a){for(var l=new Map,u=Date.now();;){if(i>=e._maxRounds&&0===s.size){t();break}if(!r){t();break}var d=o.findPrevBracket(r);if(!d){t();break}if(Date.now()-u>e._maxDuration){setTimeout(function(){return e._bracketsLeftYield(t,i+1,o,r,s,a)});break}var c=d.close;if(d.isOpen){m=l.has(c)?l.get(c):0;if(m-=1,l.set(c,Math.max(0,m)),m<0){var h=s.get(c);if(h){var p=h.shift();0===h.size&&s.delete(c);var f=n.Range.fromPositions(d.range.getEndPosition(),p.getStartPosition()),g=n.Range.fromPositions(d.range.getStartPosition(),p.getEndPosition());a.push({range:f}),a.push({range:g}),e._addBracketLeading(o,g,a)}}}else{var m=l.has(c)?l.get(c):0;l.set(c,m+1)}r=d.range.getStartPosition()}},e._addBracketLeading=function(e,t,o){if(t.startLineNumber!==t.endLineNumber){var r=t.startLineNumber,s=e.getLineFirstNonWhitespaceColumn(r)
;0!==s&&s!==t.startColumn&&(o.push({range:n.Range.fromPositions(new i.Position(r,s),t.getEndPosition())}),o.push({range:n.Range.fromPositions(new i.Position(r,1),t.getEndPosition())}));var a=r-1;if(a>0){var l=e.getLineFirstNonWhitespaceColumn(a);l===t.startColumn&&l!==e.getLineLastNonWhitespaceColumn(a)&&(o.push({range:n.Range.fromPositions(new i.Position(a,l),t.getEndPosition())}),o.push({range:n.Range.fromPositions(new i.Position(a,1),t.getEndPosition())}))}}},e._maxDuration=30,e._maxRounds=2,e}();t.BracketSelectionRangeProvider=r}),define(t[267],i([1,0,3,5]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){}return e.prototype.provideSelectionRanges=function(e,t){for(var i=[],n=0,o=t;n<o.length;n++){var r=o[n],s=[];i.push(s),this._addInWordRanges(s,e,r),this._addWordRanges(s,e,r),this._addWhitespaceLine(s,e,r),s.push({range:e.getFullModelRange()})}return i},e.prototype._addInWordRanges=function(e,t,o){var r=t.getWordAtPosition(o);if(r){
for(var s=r.word,a=r.startColumn,l=o.column-a,u=l,d=l,c=0;u>=0;u--){if(95===(h=s.charCodeAt(u))||45===h)break;if(n.isLowerAsciiLetter(h)&&n.isUpperAsciiLetter(c))break;c=h}for(u+=1;d<s.length;d++){var h=s.charCodeAt(d);if(n.isUpperAsciiLetter(h)&&n.isLowerAsciiLetter(c))break;if(95===h||45===h)break;c=h}u<d&&e.push({range:new i.Range(o.lineNumber,a+u,o.lineNumber,a+d)})}},e.prototype._addWordRanges=function(e,t,n){var o=t.getWordAtPosition(n);o&&e.push({range:new i.Range(n.lineNumber,o.startColumn,n.lineNumber,o.endColumn)})},e.prototype._addWhitespaceLine=function(e,t,n){t.getLineLength(n.lineNumber)>0&&0===t.getLineFirstNonWhitespaceColumn(n.lineNumber)&&0===t.getLineLastNonWhitespaceColumn(n.lineNumber)&&e.push({range:new i.Range(n.lineNumber,1,n.lineNumber,t.getLineMaxColumn(n.lineNumber))})},e}();t.WordSelectionRangeProvider=o}),define(t[128],i([1,0]),function(e,t){"use strict";function i(e,t){for(var i=e.slice();i.length>0;){var n=i.shift();if(!t(n))break;i.unshift.apply(i,n.children)}}var n
;Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){this.value="",this.pos=0}return e.isDigitCharacter=function(e){return e>=48&&e<=57},e.isVariableCharacter=function(e){return 95===e||e>=97&&e<=122||e>=65&&e<=90},e.prototype.text=function(e){this.value=e,this.pos=0},e.prototype.tokenText=function(e){return this.value.substr(e.pos,e.len)},e.prototype.next=function(){if(this.pos>=this.value.length)return{type:14,pos:this.pos,len:0};var t,i=this.pos,n=0,o=this.value.charCodeAt(i);if("number"==typeof(t=e._table[o]))return this.pos+=1,{type:t,pos:i,len:1};if(e.isDigitCharacter(o)){t=8;do{n+=1,o=this.value.charCodeAt(i+n)}while(e.isDigitCharacter(o));return this.pos+=n,{type:t,pos:i,len:n}}if(e.isVariableCharacter(o)){t=9;do{o=this.value.charCodeAt(i+ ++n)}while(e.isVariableCharacter(o)||e.isDigitCharacter(o));return this.pos+=n,{type:t,pos:i,len:n}}t=10;do{n+=1,o=this.value.charCodeAt(i+n)}while(!isNaN(o)&&void 0===e._table[o]&&!e.isDigitCharacter(o)&&!e.isVariableCharacter(o))
;return this.pos+=n,{type:t,pos:i,len:n}},e._table=(n={},n[36]=0,n[58]=1,n[44]=2,n[123]=3,n[125]=4,n[92]=5,n[47]=6,n[124]=7,n[43]=11,n[45]=12,n[63]=13,n),e}();t.Scanner=o;var s=function(){function e(){this._children=[]}return e.prototype.appendChild=function(e){return e instanceof a&&this._children[this._children.length-1]instanceof a?this._children[this._children.length-1].value+=e.value:(e.parent=this,this._children.push(e)),this},e.prototype.replace=function(e,t){var i=e.parent,n=i.children.indexOf(e),o=i.children.slice(0);o.splice.apply(o,[n,1].concat(t)),i._children=o,function e(t,i){for(var n=0,o=t;n<o.length;n++){var r=o[n];r.parent=i,e(r.children,r)}}(t,i)},Object.defineProperty(e.prototype,"children",{get:function(){return this._children},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"snippet",{get:function(){for(var e=this;;){if(!e)return;if(e instanceof f)return e;e=e.parent}},enumerable:!0,configurable:!0}),e.prototype.toString=function(){
return this.children.reduce(function(e,t){return e+t.toString()},"")},e.prototype.len=function(){return 0},e}();t.Marker=s;var a=function(e){function t(t){var i=e.call(this)||this;return i.value=t,i}return r(t,e),t.prototype.toString=function(){return this.value},t.prototype.len=function(){return this.value.length},t.prototype.clone=function(){return new t(this.value)},t}(s);t.Text=a;var l=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t}(s);t.TransformableMarker=l;var u=function(e){function t(t){var i=e.call(this)||this;return i.index=t,i}return r(t,e),t.compareByIndex=function(e,t){return e.index===t.index?0:e.isFinalTabstop?1:t.isFinalTabstop?-1:e.index<t.index?-1:e.index>t.index?1:0},Object.defineProperty(t.prototype,"isFinalTabstop",{get:function(){return 0===this.index},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"choice",{get:function(){return 1===this._children.length&&this._children[0]instanceof d?this._children[0]:void 0},enumerable:!0,
configurable:!0}),t.prototype.clone=function(){var e=new t(this.index);return this.transform&&(e.transform=this.transform.clone()),e._children=this.children.map(function(e){return e.clone()}),e},t}(l);t.Placeholder=u;var d=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.options=[],t}return r(t,e),t.prototype.appendChild=function(e){return e instanceof a&&(e.parent=this,this.options.push(e)),this},t.prototype.toString=function(){return this.options[0].value},t.prototype.len=function(){return this.options[0].len()},t.prototype.clone=function(){var e=new t;return this.options.forEach(e.appendChild,e),e},t}(s);t.Choice=d;var c=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t.regexp=new RegExp(""),t}return r(t,e),t.prototype.resolve=function(e){var t=this,i=!1,n=e.replace(this.regexp,function(){return i=!0,t._replace(Array.prototype.slice.call(arguments,0,-2))});return!i&&this._children.some(function(e){return e instanceof h&&Boolean(e.elseValue)
})&&(n=this._replace([])),n},t.prototype._replace=function(e){for(var t="",i=0,n=this._children;i<n.length;i++){var o=n[i];if(o instanceof h){var r=e[o.index]||"";t+=r=o.resolve(r)}else t+=o.toString()}return t},t.prototype.toString=function(){return""},t.prototype.clone=function(){var e=new t;return e.regexp=new RegExp(this.regexp.source,(this.regexp.ignoreCase?"i":"")+(this.regexp.global?"g":"")),e._children=this.children.map(function(e){return e.clone()}),e},t}(s);t.Transform=c;var h=function(e){function t(t,i,n,o){var r=e.call(this)||this;return r.index=t,r.shorthandName=i,r.ifValue=n,r.elseValue=o,r}return r(t,e),t.prototype.resolve=function(e){
return"upcase"===this.shorthandName?e?e.toLocaleUpperCase():"":"downcase"===this.shorthandName?e?e.toLocaleLowerCase():"":"capitalize"===this.shorthandName?e?e[0].toLocaleUpperCase()+e.substr(1):"":"pascalcase"===this.shorthandName?e?this._toPascalCase(e):"":Boolean(e)&&"string"==typeof this.ifValue?this.ifValue:Boolean(e)||"string"!=typeof this.elseValue?e||"":this.elseValue},t.prototype._toPascalCase=function(e){var t=e.match(/[a-z]+/gi);return t?t.map(function(e){return e.charAt(0).toUpperCase()+e.substr(1).toLowerCase()}).join(""):e},t.prototype.clone=function(){return new t(this.index,this.shorthandName,this.ifValue,this.elseValue)},t}(s);t.FormatString=h;var p=function(e){function t(t){var i=e.call(this)||this;return i.name=t,i}return r(t,e),t.prototype.resolve=function(e){var t=e.resolve(this);return this.transform&&(t=this.transform.resolve(t||"")),void 0!==t&&(this._children=[new a(t)],!0)},t.prototype.clone=function(){var e=new t(this.name)
;return this.transform&&(e.transform=this.transform.clone()),e._children=this.children.map(function(e){return e.clone()}),e},t}(l);t.Variable=p;var f=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),Object.defineProperty(t.prototype,"placeholderInfo",{get:function(){if(!this._placeholders){var e,t=[];this.walk(function(i){return i instanceof u&&(t.push(i),e=!e||e.index<i.index?i:e),!0}),this._placeholders={all:t,last:e}}return this._placeholders},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"placeholders",{get:function(){return this.placeholderInfo.all},enumerable:!0,configurable:!0}),t.prototype.offset=function(e){var t=0,i=!1;return this.walk(function(n){return n===e?(i=!0,!1):(t+=n.len(),!0)}),i?t:-1},t.prototype.fullLen=function(e){var t=0;return i([e],function(e){return t+=e.len(),!0}),t},t.prototype.enclosingPlaceholders=function(e){for(var t=[],i=e.parent;i;)i instanceof u&&t.push(i),i=i.parent;return t},t.prototype.resolveVariables=function(e){
var t=this;return this.walk(function(i){return i instanceof p&&i.resolve(e)&&(t._placeholders=void 0),!0}),this},t.prototype.appendChild=function(t){return this._placeholders=void 0,e.prototype.appendChild.call(this,t)},t.prototype.replace=function(t,i){return this._placeholders=void 0,e.prototype.replace.call(this,t,i)},t.prototype.clone=function(){var e=new t;return this._children=this.children.map(function(e){return e.clone()}),e},t.prototype.walk=function(e){i(this.children,e)},t}(s);t.TextmateSnippet=f;var g=function(){function e(){this._scanner=new o,this._token={type:14,pos:0,len:0}}return e.escape=function(e){return e.replace(/\$|}|\\/g,"\\$&")},e.prototype.parse=function(e,t,i){this._scanner.text(e),this._token=this._scanner.next();for(var n=new f;this._parse(n););var o=new Map,r=[],s=0;n.walk(function(e){return e instanceof u&&(s+=1,e.isFinalTabstop?o.set(0,void 0):!o.has(e.index)&&e.children.length>0?o.set(e.index,e.children):r.push(e)),!0});for(var a=0,l=r;a<l.length;a++){
var d=l[a],c=o.get(d.index);if(c){var h=new u(d.index);h.transform=d.transform;for(var p=0,g=c;p<g.length;p++){var m=g[p];h.appendChild(m.clone())}n.replace(d,[h])}}return i||(i=s>0&&t),!o.has(0)&&i&&n.appendChild(new u(0)),n},e.prototype._accept=function(e,t){if(void 0===e||this._token.type===e){var i=!t||this._scanner.tokenText(this._token);return this._token=this._scanner.next(),i}return!1},e.prototype._backTo=function(e){return this._scanner.pos=e.pos+e.len,this._token=e,!1},e.prototype._until=function(e){if(14===this._token.type)return!1;for(var t="",i=this._token.pos,n={type:14,pos:0,len:0};this._token.type!==e||5===n.type;)if(this._token.type===e&&(t+=this._scanner.value.substring(i,n.pos),i=this._token.pos),n=this._token,this._token=this._scanner.next(),14===this._token.type)return!1;return t+=this._scanner.value.substring(i,this._token.pos),this._token=this._scanner.next(),t},e.prototype._parse=function(e){
return this._parseEscaped(e)||this._parseTabstopOrVariableName(e)||this._parseComplexPlaceholder(e)||this._parseComplexVariable(e)||this._parseAnything(e)},e.prototype._parseEscaped=function(e){var t;return!!(t=this._accept(5,!0))&&(t=this._accept(0,!0)||this._accept(4,!0)||this._accept(5,!0)||t,e.appendChild(new a(t)),!0)},e.prototype._parseTabstopOrVariableName=function(e){var t,i=this._token;return this._accept(0)&&(t=this._accept(9,!0)||this._accept(8,!0))?(e.appendChild(/^\d+$/.test(t)?new u(Number(t)):new p(t)),!0):this._backTo(i)},e.prototype._parseComplexPlaceholder=function(e){var t,i=this._token;if(!(this._accept(0)&&this._accept(3)&&(t=this._accept(8,!0))))return this._backTo(i);var n=new u(Number(t));if(this._accept(1))for(;;){if(this._accept(4))return e.appendChild(n),!0;if(!this._parse(n))return e.appendChild(new a("${"+t+":")),n.children.forEach(e.appendChild,e),!0}else{if(!(n.index>0&&this._accept(7)))return this._accept(6)?this._parseTransform(n)?(e.appendChild(n),!0):(this._backTo(i),
!1):this._accept(4)?(e.appendChild(n),!0):this._backTo(i);for(var o=new d;;){if(this._parseChoiceElement(o)){if(this._accept(2))continue;if(this._accept(7)&&(n.appendChild(o),this._accept(4)))return e.appendChild(n),!0}return this._backTo(i),!1}}},e.prototype._parseChoiceElement=function(e){for(var t=this._token,i=[];;){if(2===this._token.type||7===this._token.type)break;var n=void 0;if(!(n=(n=this._accept(5,!0))?this._accept(2,!0)||this._accept(7,!0)||this._accept(5,!0)||n:this._accept(void 0,!0)))return this._backTo(t),!1;i.push(n)}return 0===i.length?(this._backTo(t),!1):(e.appendChild(new a(i.join(""))),!0)},e.prototype._parseComplexVariable=function(e){var t,i=this._token;if(!(this._accept(0)&&this._accept(3)&&(t=this._accept(9,!0))))return this._backTo(i);var n=new p(t);if(!this._accept(1))return this._accept(6)?this._parseTransform(n)?(e.appendChild(n),!0):(this._backTo(i),!1):this._accept(4)?(e.appendChild(n),!0):this._backTo(i);for(;;){if(this._accept(4))return e.appendChild(n),!0
;if(!this._parse(n))return e.appendChild(new a("${"+t+":")),n.children.forEach(e.appendChild,e),!0}},e.prototype._parseTransform=function(e){for(var t=new c,i="",n="";;){if(this._accept(6))break;o=void 0;if(o=this._accept(5,!0))i+=o=this._accept(6,!0)||o;else{if(14===this._token.type)return!1;i+=this._accept(void 0,!0)}}for(;;){if(this._accept(6))break;var o=void 0;if(o=this._accept(5,!0))o=this._accept(5,!0)||this._accept(6,!0)||o,t.appendChild(new a(o));else if(!this._parseFormatString(t)&&!this._parseAnything(t))return!1}for(;;){if(this._accept(4))break;if(14===this._token.type)return!1;n+=this._accept(void 0,!0)}try{t.regexp=new RegExp(i,n)}catch(e){return!1}return e.transform=t,!0},e.prototype._parseFormatString=function(e){var t=this._token;if(!this._accept(0))return!1;var i=!1;this._accept(3)&&(i=!0);var n=this._accept(8,!0);if(!n)return this._backTo(t),!1;if(!i)return e.appendChild(new h(Number(n))),!0;if(this._accept(4))return e.appendChild(new h(Number(n))),!0
;if(!this._accept(1))return this._backTo(t),!1;if(this._accept(6)){var o=this._accept(9,!0);return o&&this._accept(4)?(e.appendChild(new h(Number(n),o)),!0):(this._backTo(t),!1)}if(this._accept(11)){if(r=this._until(4))return e.appendChild(new h(Number(n),void 0,r,void 0)),!0}else if(this._accept(12)){if(s=this._until(4))return e.appendChild(new h(Number(n),void 0,void 0,s)),!0}else if(this._accept(13)){var r=this._until(1);if(r){if(s=this._until(4))return e.appendChild(new h(Number(n),void 0,r,s)),!0}}else{var s=this._until(4);if(s)return e.appendChild(new h(Number(n),void 0,void 0,s)),!0}return this._backTo(t),!1},e.prototype._parseAnything=function(e){return 14!==this._token.type&&(e.appendChild(new a(this._scanner.tokenText(this._token))),this._accept(void 0),!0)},e}();t.SnippetParser=g}),define(t[269],i([1,0,19,2,80]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e,t,i){var o=this;this._disposables=new n.DisposableStore,
this._disposables.add(t.onDidShow(function(){return o._onItem(t.getFocusedItem())})),this._disposables.add(t.onDidFocus(this._onItem,this)),this._disposables.add(t.onDidHide(this.reset,this)),this._disposables.add(e.onWillType(function(t){if(o._active){var n=t.charCodeAt(t.length-1);o._active.acceptCharacters.has(n)&&e.getConfiguration().contribInfo.acceptSuggestionOnCommitCharacter&&i(o._active.item)}}))}return e.prototype._onItem=function(e){if(e&&i.isNonEmptyArray(e.item.completion.commitCharacters)){if(!this._active||this._active.item.item!==e.item){for(var t=new o.CharacterSet,n=0,r=e.item.completion.commitCharacters;n<r.length;n++){var s=r[n];s.length>0&&t.add(s.charCodeAt(0))}this._active={acceptCharacters:t,item:e}}}else this.reset()},e.prototype.reset=function(){this._active=void 0},e.prototype.dispose=function(){this._disposables.dispose()},e}();t.CommitCharacterController=r}),define(t[270],i([1,0,19,3,180]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var s=function(){function e(){}return e.create=function(t,s){if(!s.getConfiguration().contribInfo.suggest.localityBonus)return Promise.resolve(e.None);if(!s.hasModel())return Promise.resolve(e.None);var a=s.getModel(),l=s.getPosition();return t.canComputeWordRanges(a.uri)?(new o.BracketSelectionRangeProvider).provideSelectionRanges(a,[l]).then(function(o){return o&&0!==o.length&&0!==o[0].length?t.computeWordRanges(a.uri,o[0][0].range).then(function(t){return new(function(e){function a(){return null!==e&&e.apply(this,arguments)||this}return r(a,e),a.prototype.distance=function(e,r){if(!t||!l.equals(s.getPosition()))return 0;if(17===r.kind)return 2<<20;var a=r.label,u=t[a];if(i.isFalsyOrEmpty(u))return 2<<20;for(var d=i.binarySearch(u,n.Range.fromPositions(e),n.Range.compareRangesUsingStarts),c=d>=0?u[d]:u[Math.max(0,~d-1)],h=o.length,p=0,f=o[0];p<f.length;p++){var g=f[p];if(!n.Range.containsRange(g.range,c))break;h-=1}return h},a}(e))}):e.None}):Promise.resolve(e.None)},e.None=new(function(e){function t(){
return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.distance=function(){return 0},t}(e)),e}();t.WordDistance=s}),define(t[181],i([1,0]),function(e,t){"use strict";function i(e){return Array.isArray(e)}function n(e){return"string"==typeof e}function o(e){return!e}function r(e,t){return e.ignoreCase&&t?t.toLowerCase():t}Object.defineProperty(t,"__esModule",{value:!0}),t.isFuzzyActionArr=i,t.isFuzzyAction=function(e){return!i(e)},t.isString=n,t.isIAction=function(e){return!n(e)},t.empty=o,t.fixCase=r,t.sanitize=function(e){return e.replace(/[&<>'"_]/g,"-")},t.log=function(e,t){console.log(e.languageId+": "+t)},t.createError=function(e,t){return new Error(e.languageId+": "+t)},t.substituteMatches=function(e,t,i,n,s){var a=null;return t.replace(/\$((\$)|(#)|(\d\d?)|[sS](\d\d?)|@(\w+))/g,function(t,l,u,d,c,h,p,f,g){return o(u)?o(d)?!o(c)&&c<n.length?r(e,n[c]):!o(p)&&e&&"string"==typeof e[p]?e[p]:(null===a&&(a=s.split(".")).unshift(s),!o(h)&&h<a.length?r(e,a[h]):""):r(e,i):"$"})},
t.findRules=function(e,t){for(var i=t;i&&i.length>0;){var n=e.tokenizer[i];if(n)return n;var o=i.lastIndexOf(".");i=o<0?null:i.substr(0,o)}return null},t.stateExists=function(e,t){for(var i=t;i&&i.length>0;){if(e.stateNames[i])return!0;var n=i.lastIndexOf(".");i=n<0?null:i.substr(0,n)}return!1}}),define(t[272],i([1,0,181]),function(e,t,i){"use strict";function n(e,t){return"boolean"==typeof e?e:t}function o(e,t){return"string"==typeof e?e:t}function r(e,t){void 0===t&&(t=!1),t&&(e=e.map(function(e){return e.toLowerCase()}));var i=function(e){for(var t={},i=0,n=e;i<n.length;i++)t[n[i]]=!0;return t}(e);return t?function(e){return void 0!==i[e.toLowerCase()]&&i.hasOwnProperty(e.toLowerCase())}:function(e){return void 0!==i[e]&&i.hasOwnProperty(e)}}function s(e,t){for(var n=0;t.indexOf("@")>=0&&n<5;)n++,t=t.replace(/@(\w+)/g,function(n,o){var r="";if("string"==typeof e[o])r=e[o];else{
if(!(e[o]&&e[o]instanceof RegExp))throw void 0===e[o]?i.createError(e,"language definition does not contain attribute '"+o+"', used at: "+t):i.createError(e,"attribute reference '"+o+"' must be a string, used at: "+t);r=e[o].source}return i.empty(r)?"":"(?:"+r+")"});return new RegExp(t,e.ignoreCase?"i":"")}function a(e,t,n,o){var a=-1,l=n,u=n.match(/^\$(([sS]?)(\d\d?)|#)(.*)$/);u&&(u[3]&&(a=parseInt(u[3]),u[2]&&(a+=100)),l=u[4]);var d="~",c=l;l&&0!==l.length?/^\w*$/.test(c)?d="==":(u=l.match(/^(@|!@|~|!~|==|!=)(.*)$/))&&(d=u[1],c=u[2]):(d="!=",c="");var h;if("~"!==d&&"!~"!==d||!/^(\w|\|)*$/.test(c))if("@"===d||"!@"===d){var p=e[c];if(!p)throw i.createError(e,"the @ match target '"+c+"' is not defined, in rule: "+t);if(!function(e,t){if(!t)return!1;if(!Array.isArray(t))return!1;for(var i=0,n=t;i<n.length;i++)if(!e(n[i]))return!1;return!0}(function(e){return"string"==typeof e},p))throw i.createError(e,"the @ match target '"+c+"' must be an array of strings, in rule: "+t);var f=r(p,e.ignoreCase);h=function(e){
return"@"===d?f(e):!f(e)}}else if("~"===d||"!~"===d)if(c.indexOf("$")<0){var g=s(e,"^"+c+"$");h=function(e){return"~"===d?g.test(e):!g.test(e)}}else h=function(t,n,o,r){return s(e,"^"+i.substituteMatches(e,c,n,o,r)+"$").test(t)};else if(c.indexOf("$")<0){var m=i.fixCase(e,c);h=function(e){return"=="===d?e===m:e!==m}}else{var v=i.fixCase(e,c);h=function(t,n,o,r,s){var a=i.substituteMatches(e,v,n,o,r);return"=="===d?t===a:t!==a}}else{var _=r(c.split("|"),e.ignoreCase);h=function(e){return"~"===d?_(e):!_(e)}}return-1===a?{name:n,value:o,test:function(e,t,i,n){return h(e,e,t,i,n)}}:{name:n,value:o,test:function(e,t,i,n){var o=function(e,t,i,n){if(n<0)return e;if(n<t.length)return t[n];if(n>=100){n-=100;var o=i.split(".");if(o.unshift(i),n<o.length)return o[n]}return null}(e,t,i,a);return h(o||"",e,t,i,n)}}}function l(e,t,n){if(n){if("string"==typeof n)return n;if(n.token||""===n.token){if("string"!=typeof n.token)throw i.createError(e,"a 'token' attribute must be of type string, in rule: "+t);var o={token:n.token
};if(n.token.indexOf("$")>=0&&(o.tokenSubst=!0),"string"==typeof n.bracket)if("@open"===n.bracket)o.bracket=1;else{if("@close"!==n.bracket)throw i.createError(e,"a 'bracket' attribute must be either '@open' or '@close', in rule: "+t);o.bracket=-1}if(n.next){if("string"!=typeof n.next)throw i.createError(e,"the next state must be a string value in rule: "+t);var r=n.next;if(!/^(@pop|@push|@popall)$/.test(r)&&("@"===r[0]&&(r=r.substr(1)),r.indexOf("$")<0&&!i.stateExists(e,i.substituteMatches(e,r,"",[],""))))throw i.createError(e,"the next state '"+n.next+"' is not defined in rule: "+t);o.next=r}return"number"==typeof n.goBack&&(o.goBack=n.goBack),"string"==typeof n.switchTo&&(o.switchTo=n.switchTo),"string"==typeof n.log&&(o.log=n.log),"string"==typeof n.nextEmbedded&&(o.nextEmbedded=n.nextEmbedded,e.usesEmbedded=!0),o}if(Array.isArray(n)){for(var s=[],u=0,d=n.length;u<d;u++)s[u]=l(e,t,n[u]);return{group:s}}if(n.cases){var c=[];for(var h in n.cases)if(n.cases.hasOwnProperty(h)){var p=l(e,t,n.cases[h])
;"@default"===h||"@"===h||""===h?c.push({test:void 0,value:p,name:h}):"@eos"===h?c.push({test:function(e,t,i,n){return n},value:p,name:h}):c.push(a(e,t,h,p))}var f=e.defaultToken;return{test:function(e,t,i,n){for(var o=0,r=c;o<r.length;o++){var s=r[o];if(!s.test||s.test(e,t,i,n))return s.value}return f}}}throw i.createError(e,"an action must be a string, an object with a 'token' or 'cases' attribute, or an array of actions; in rule: "+t)}return{token:""}}Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e){this.regex=new RegExp(""),this.action={token:""},this.matchOnlyAtLineStart=!1,this.name="",this.name=e}return e.prototype.setRegex=function(e,t){var n;if("string"==typeof t)n=t;else{if(!(t instanceof RegExp))throw i.createError(e,"rules must start with a match string or regular expression: "+this.name);n=t.source}this.matchOnlyAtLineStart=n.length>0&&"^"===n[0],this.name=this.name+": "+n,this.regex=s(e,"^(?:"+(this.matchOnlyAtLineStart?n.substr(1):n)+")")},
e.prototype.setAction=function(e,t){this.action=l(e,this.name,t)},e}();t.compile=function(e,t){function r(e,o,l){for(var d=0,c=l;d<c.length;d++){var h=c[d],p=h.include;if(p){if("string"!=typeof p)throw i.createError(s,"an 'include' attribute must be a string at: "+e);if("@"===p[0]&&(p=p.substr(1)),!t.tokenizer[p])throw i.createError(s,"include target '"+p+"' is not defined at: "+e);r(e+"."+p,o,t.tokenizer[p])}else{var f=new u(e);if(Array.isArray(h)&&h.length>=1&&h.length<=3)if(f.setRegex(a,h[0]),h.length>=3)if("string"==typeof h[1])f.setAction(a,{token:h[1],next:h[2]});else{if("object"!=typeof h[1])throw i.createError(s,"a next state as the last element of a rule can only be given if the action is either an object or a string, at: "+e);var g=h[1];g.next=h[2],f.setAction(a,g)}else f.setAction(a,h[1]);else{if(!h.regex)throw i.createError(s,"a rule must either be an array, or an object with a 'regex' or 'include' field at: "+e);h.name&&"string"==typeof h.name&&(f.name=h.name),
h.matchOnlyAtStart&&(f.matchOnlyAtLineStart=n(h.matchOnlyAtLineStart,!1)),f.setRegex(a,h.regex),f.setAction(a,h.action)}o.push(f)}}}if(!t||"object"!=typeof t)throw new Error("Monarch: expecting a language definition object");var s={};s.languageId=e,s.noThrow=!1,s.maxStack=100,s.start="string"==typeof t.start?t.start:null,s.ignoreCase=n(t.ignoreCase,!1),s.tokenPostfix=o(t.tokenPostfix,"."+s.languageId),s.defaultToken=o(t.defaultToken,"source"),s.usesEmbedded=!1;var a=t;if(a.languageId=e,a.ignoreCase=s.ignoreCase,a.noThrow=s.noThrow,a.usesEmbedded=s.usesEmbedded,a.stateNames=t.tokenizer,a.defaultToken=s.defaultToken,!t.tokenizer||"object"!=typeof t.tokenizer)throw i.createError(s,"a language definition must define the 'tokenizer' attribute as an object");s.tokenizer=[];for(var l in t.tokenizer)if(t.tokenizer.hasOwnProperty(l)){s.start||(s.start=l);var d=t.tokenizer[l];s.tokenizer[l]=new Array,r("tokenizer."+l,s.tokenizer[l],d)}if(s.usesEmbedded=a.usesEmbedded,t.brackets){
if(!Array.isArray(t.brackets))throw i.createError(s,"the 'brackets' attribute must be defined as an array")}else t.brackets=[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}];for(var c=[],h=0,p=t.brackets;h<p.length;h++){var f=p[h];if(f&&Array.isArray(f)&&3===f.length&&(f={token:f[2],open:f[0],close:f[1]}),f.open===f.close)throw i.createError(s,"open and close brackets in a 'brackets' attribute must be different: "+f.open+"\n hint: use the 'bracket' attribute if matching on equal brackets is required.");if("string"!=typeof f.open||"string"!=typeof f.token||"string"!=typeof f.close)throw i.createError(s,"every element in the 'brackets' array must be a '{open,close,token}' object or array");c.push({token:f.token+s.tokenPostfix,open:i.fixCase(s,f.open),close:i.fixCase(s,f.close)})}return s.brackets=c,s.noThrow=!0,s}}),define(t[273],i([6,7]),function(e,t){
return e.create("vs/base/browser/ui/actionbar/actionbar",t)}),define(t[74],i([1,0,18,273,2,58,8,23,79,57,4,442]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h=function(e){function t(t,i,n){var o=e.call(this)||this;return o.options=n,o._context=t||o,o._action=i,i instanceof s.Action&&o._register(i.onDidChange(function(e){o.element&&o.handleActionChangeEvent(e)})),o}return r(t,e),t.prototype.handleActionChangeEvent=function(e){void 0!==e.enabled&&this.updateEnabled(),void 0!==e.checked&&this.updateChecked(),void 0!==e.class&&this.updateClass(),void 0!==e.label&&(this.updateLabel(),this.updateTooltip()),void 0!==e.tooltip&&this.updateTooltip()},Object.defineProperty(t.prototype,"actionRunner",{get:function(){return this._actionRunner},set:function(e){this._actionRunner=e},enumerable:!0,configurable:!0}),t.prototype.getAction=function(){return this._action},t.prototype.isEnabled=function(){return this._action.enabled},t.prototype.setActionContext=function(e){
this._context=e},t.prototype.render=function(e){var t=this;this.element=e,u.Gesture.addTarget(e);var n=this.options&&this.options.draggable;n&&(e.draggable=!0),this._register(a.addDisposableListener(this.element,u.EventType.Tap,function(e){return t.onClick(e)})),this._register(a.addDisposableListener(this.element,a.EventType.MOUSE_DOWN,function(e){n||a.EventHelper.stop(e,!0),t._action.enabled&&0===e.button&&t.element&&a.addClass(t.element,"active")})),this._register(a.addDisposableListener(this.element,a.EventType.CLICK,function(e){a.EventHelper.stop(e,!0),t.options&&t.options.isMenu?t.onClick(e):i.setImmediate(function(){return t.onClick(e)})})),this._register(a.addDisposableListener(this.element,a.EventType.DBLCLICK,function(e){a.EventHelper.stop(e,!0)})),[a.EventType.MOUSE_UP,a.EventType.MOUSE_OUT].forEach(function(e){t._register(a.addDisposableListener(t.element,e,function(e){a.EventHelper.stop(e),a.removeClass(t.element,"active")}))})},t.prototype.onClick=function(e){a.EventHelper.stop(e,!0);var t
;l.isUndefinedOrNull(this._context)?t=e:(t=this._context,l.isObject(t)&&(t.event=e)),this._actionRunner.run(this._action,t)},t.prototype.focus=function(){this.element&&(this.element.focus(),a.addClass(this.element,"focused"))},t.prototype.blur=function(){this.element&&(this.element.blur(),a.removeClass(this.element,"focused"))},t.prototype.updateEnabled=function(){},t.prototype.updateLabel=function(){},t.prototype.updateTooltip=function(){},t.prototype.updateClass=function(){},t.prototype.updateChecked=function(){},t.prototype.dispose=function(){this.element&&(a.removeNode(this.element),this.element=void 0),e.prototype.dispose.call(this)},t}(o.Disposable);t.BaseActionViewItem=h;var p=function(e){function t(i){var n=e.call(this,t.ID,i,i?"separator text":"separator")||this;return n.checked=!1,n.radio=!1,n.enabled=!1,n}return r(t,e),t.ID="vs.actions.separator",t}(s.Action);t.Separator=p;var f=function(e){function t(t,i,n){void 0===n&&(n={});var o=e.call(this,t,i,n)||this;return o.options=n,
o.options.icon=void 0!==n.icon&&n.icon,o.options.label=void 0===n.label||n.label,o.cssClass="",o}return r(t,e),t.prototype.render=function(t){e.prototype.render.call(this,t),this.element&&(this.label=a.append(this.element,a.$("a.action-label"))),this._action.id===p.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button"),this.options.label&&this.options.keybinding&&this.element&&(a.append(this.element,a.$("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()},t.prototype.focus=function(){e.prototype.focus.call(this),this.label.focus()},t.prototype.updateLabel=function(){this.options.label&&(this.label.textContent=this.getAction().label)},t.prototype.updateTooltip=function(){var e=null
;this.getAction().tooltip?e=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(e=this.getAction().label,this.options.keybinding&&(e=n.localize(0,null,e,this.options.keybinding))),e&&(this.label.title=e)},t.prototype.updateClass=function(){this.cssClass&&a.removeClasses(this.label,this.cssClass),this.options.icon?(this.cssClass=this.getAction().class,a.addClass(this.label,"icon"),this.cssClass&&a.addClasses(this.label,this.cssClass),this.updateEnabled()):a.removeClass(this.label,"icon")},t.prototype.updateEnabled=function(){this.getAction().enabled?(this.label.removeAttribute("aria-disabled"),this.element&&a.removeClass(this.element,"disabled"),a.removeClass(this.label,"disabled"),this.label.tabIndex=0):(this.label.setAttribute("aria-disabled","true"),this.element&&a.addClass(this.element,"disabled"),a.addClass(this.label,"disabled"),a.removeTabIndexAndUpdateFocus(this.label))},t.prototype.updateChecked=function(){
this.getAction().checked?a.addClass(this.label,"checked"):a.removeClass(this.label,"checked")},t}(h);t.ActionViewItem=f;var g={orientation:0,context:null,triggerKeys:{keys:[3,10],keyDown:!1}},m=function(e){function t(t,i){void 0===i&&(i=g);var n=e.call(this)||this;n._onDidBlur=n._register(new c.Emitter),n.onDidBlur=n._onDidBlur.event,n._onDidCancel=n._register(new c.Emitter),n.onDidCancel=n._onDidCancel.event,n._onDidRun=n._register(new c.Emitter),n.onDidRun=n._onDidRun.event,n._onDidBeforeRun=n._register(new c.Emitter),n.onDidBeforeRun=n._onDidBeforeRun.event,n.options=i,n._context=i.context,n.options.triggerKeys||(n.options.triggerKeys=g.triggerKeys),n.options.actionRunner?n._actionRunner=n.options.actionRunner:(n._actionRunner=new s.ActionRunner,n._register(n._actionRunner)),n._register(n._actionRunner.onDidRun(function(e){return n._onDidRun.fire(e)})),n._register(n._actionRunner.onDidBeforeRun(function(e){return n._onDidBeforeRun.fire(e)})),n.viewItems=[],n.focusedItem=void 0,
n.domNode=document.createElement("div"),n.domNode.className="monaco-action-bar",!1!==i.animated&&a.addClass(n.domNode,"animated");var o,r;switch(n.options.orientation){case 0:o=15,r=17;break;case 1:o=17,r=15,n.domNode.className+=" reverse";break;case 2:o=16,r=18,n.domNode.className+=" vertical";break;case 3:o=18,r=16,n.domNode.className+=" vertical reverse"}return n._register(a.addDisposableListener(n.domNode,a.EventType.KEY_DOWN,function(e){var t=new d.StandardKeyboardEvent(e),i=!0;t.equals(o)?n.focusPrevious():t.equals(r)?n.focusNext():t.equals(9)?n.cancel():n.isTriggerKeyEvent(t)?n.options.triggerKeys&&n.options.triggerKeys.keyDown&&n.doTrigger(t):i=!1,i&&(t.preventDefault(),t.stopPropagation())})),n._register(a.addDisposableListener(n.domNode,a.EventType.KEY_UP,function(e){var t=new d.StandardKeyboardEvent(e);n.isTriggerKeyEvent(t)?(n.options.triggerKeys&&!n.options.triggerKeys.keyDown&&n.doTrigger(t),t.preventDefault(),t.stopPropagation()):(t.equals(2)||t.equals(1026))&&n.updateFocusedItem()})),
n.focusTracker=n._register(a.trackFocus(n.domNode)),n._register(n.focusTracker.onDidBlur(function(){document.activeElement!==n.domNode&&a.isAncestor(document.activeElement,n.domNode)||(n._onDidBlur.fire(),n.focusedItem=void 0)})),n._register(n.focusTracker.onDidFocus(function(){return n.updateFocusedItem()})),n.actionsList=document.createElement("ul"),n.actionsList.className="actions-container",n.actionsList.setAttribute("role","toolbar"),n.options.ariaLabel&&n.actionsList.setAttribute("aria-label",n.options.ariaLabel),n.domNode.appendChild(n.actionsList),t.appendChild(n.domNode),n}return r(t,e),t.prototype.isTriggerKeyEvent=function(e){var t=!1;return this.options.triggerKeys&&this.options.triggerKeys.keys.forEach(function(i){t=t||e.equals(i)}),t},t.prototype.updateFocusedItem=function(){for(var e=0;e<this.actionsList.children.length;e++){var t=this.actionsList.children[e];if(a.isAncestor(document.activeElement,t)){this.focusedItem=e;break}}},Object.defineProperty(t.prototype,"context",{get:function(){
return this._context},set:function(e){this._context=e,this.viewItems.forEach(function(t){return t.setActionContext(e)})},enumerable:!0,configurable:!0}),t.prototype.getContainer=function(){return this.domNode},t.prototype.push=function(e,t){var i=this;void 0===t&&(t={});var n=Array.isArray(e)?e:[e],o=l.isNumber(t.index)?t.index:null;n.forEach(function(e){var n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation"),i._register(a.addDisposableListener(n,a.EventType.CONTEXT_MENU,function(e){e.preventDefault(),e.stopPropagation()}));var r;i.options.actionViewItemProvider&&(r=i.options.actionViewItemProvider(e)),r||(r=new f(i.context,e,t)),r.actionRunner=i._actionRunner,r.setActionContext(i.context),r.render(n),null===o||o<0||o>=i.actionsList.children.length?(i.actionsList.appendChild(n),i.viewItems.push(r)):(i.actionsList.insertBefore(n,i.actionsList.children[o]),i.viewItems.splice(o,0,r),o++)})},t.prototype.clear=function(){this.viewItems=o.dispose(this.viewItems),
a.clearNode(this.actionsList)},t.prototype.isEmpty=function(){return 0===this.viewItems.length},t.prototype.focus=function(e){var t=!1,i=void 0;void 0===e?t=!0:"number"==typeof e?i=e:"boolean"==typeof e&&(t=e),t&&void 0===this.focusedItem?(this.focusedItem=this.viewItems.length-1,this.focusNext()):(void 0!==i&&(this.focusedItem=i),this.updateFocus())},t.prototype.focusNext=function(){void 0===this.focusedItem&&(this.focusedItem=this.viewItems.length-1);var e,t=this.focusedItem;do{this.focusedItem=(this.focusedItem+1)%this.viewItems.length,e=this.viewItems[this.focusedItem]}while(this.focusedItem!==t&&!e.isEnabled());this.focusedItem!==t||e.isEnabled()||(this.focusedItem=void 0),this.updateFocus()},t.prototype.focusPrevious=function(){void 0===this.focusedItem&&(this.focusedItem=0);var e,t=this.focusedItem;do{this.focusedItem=this.focusedItem-1,this.focusedItem<0&&(this.focusedItem=this.viewItems.length-1),e=this.viewItems[this.focusedItem]}while(this.focusedItem!==t&&!e.isEnabled())
;this.focusedItem!==t||e.isEnabled()||(this.focusedItem=void 0),this.updateFocus(!0)},t.prototype.updateFocus=function(e){void 0===this.focusedItem&&this.actionsList.focus();for(var t=0;t<this.viewItems.length;t++){var i=this.viewItems[t];t===this.focusedItem?l.isFunction(i.isEnabled)&&(i.isEnabled()&&l.isFunction(i.focus)?i.focus(e):this.actionsList.focus()):l.isFunction(i.blur)&&i.blur()}},t.prototype.doTrigger=function(e){if(void 0!==this.focusedItem){var t=this.viewItems[this.focusedItem];if(t instanceof h){var i=null===t._context||void 0===t._context?e:t._context;this.run(t._action,i)}}},t.prototype.cancel=function(){document.activeElement instanceof HTMLElement&&document.activeElement.blur(),this._onDidCancel.fire()},t.prototype.run=function(e,t){return this._actionRunner.run(e,t)},t.prototype.dispose=function(){o.dispose(this.viewItems),this.viewItems=[],a.removeNode(this.getContainer()),e.prototype.dispose.call(this)},t}(o.Disposable);t.ActionBar=m}),define(t[277],i([6,7]),function(e,t){
return e.create("vs/base/browser/ui/aria/aria",t)}),define(t[43],i([1,0,277,18,8,439]),function(e,t,i,n,o){"use strict";function r(e,t){s(l,e,t)}function s(e,t,n){if(a){if(!n)switch(c===t?d++:(c=t,d=0),d){case 0:break;case 1:t=i.localize(0,null,t);break;default:t=i.localize(1,null,t,d)}o.clearNode(e),e.textContent=t,e.style.visibility="hidden",e.style.visibility="visible"}}Object.defineProperty(t,"__esModule",{value:!0});var a,l,u;t.setARIAContainer=function(e){(a=document.createElement("div")).className="monaco-aria-container",(l=document.createElement("div")).className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),a.appendChild(l),(u=document.createElement("div")).className="monaco-status",u.setAttribute("role","status"),u.setAttribute("aria-atomic","true"),a.appendChild(u),e.appendChild(a)},t.alert=r,t.status=function(e,t){n.isMacintosh?r(e,t):s(u,e,t)};var d=0,c=void 0}),define(t[279],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/findinput/findInput",t)}),
define(t[280],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/findinput/findInputCheckboxes",t)}),define(t[182],i([1,0,164,280,418]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=n.localize(0,null),s=n.localize(1,null),a=n.localize(2,null),l=function(e){function t(t){return e.call(this,{actionClassName:"monaco-case-sensitive",title:o+t.appendTitle,isChecked:t.isChecked,inputActiveOptionBorder:t.inputActiveOptionBorder,inputActiveOptionBackground:t.inputActiveOptionBackground})||this}return r(t,e),t}(i.Checkbox);t.CaseSensitiveCheckbox=l;var u=function(e){function t(t){return e.call(this,{actionClassName:"monaco-whole-word",title:s+t.appendTitle,isChecked:t.isChecked,inputActiveOptionBorder:t.inputActiveOptionBorder,inputActiveOptionBackground:t.inputActiveOptionBackground})||this}return r(t,e),t}(i.Checkbox);t.WholeWordsCheckbox=u;var d=function(e){function t(t){return e.call(this,{actionClassName:"monaco-regex",title:a+t.appendTitle,isChecked:t.isChecked,
inputActiveOptionBorder:t.inputActiveOptionBorder,inputActiveOptionBackground:t.inputActiveOptionBackground})||this}return r(t,e),t}(i.Checkbox);t.RegexCheckbox=d}),define(t[282],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/findinput/replaceInput",t)}),define(t[283],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(t[123],i([1,0,283,28,8,116,43,74,4,45,25,29,561,51,52,416]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var m=o.$,v={inputBackground:c.Color.fromHex("#3C3C3C"),inputForeground:c.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:c.Color.fromHex("#55AAFF"),inputValidationInfoBackground:c.Color.fromHex("#063B49"),inputValidationWarningBorder:c.Color.fromHex("#B89500"),inputValidationWarningBackground:c.Color.fromHex("#352A05"),inputValidationErrorBorder:c.Color.fromHex("#BE1100"),inputValidationErrorBackground:c.Color.fromHex("#5A1D1D")},_=function(e){function t(t,i,r){
var s=e.call(this)||this;s.state="idle",s.maxHeight=Number.POSITIVE_INFINITY,s._onDidChange=s._register(new u.Emitter),s.onDidChange=s._onDidChange.event,s._onDidHeightChange=s._register(new u.Emitter),s.onDidHeightChange=s._onDidHeightChange.event,s.contextViewProvider=i,s.options=r||Object.create(null),h.mixin(s.options,v,!1),s.message=null,s.placeholder=s.options.placeholder||"",s.ariaLabel=s.options.ariaLabel||"",s.inputBackground=s.options.inputBackground,s.inputForeground=s.options.inputForeground,s.inputBorder=s.options.inputBorder,s.inputValidationInfoBorder=s.options.inputValidationInfoBorder,s.inputValidationInfoBackground=s.options.inputValidationInfoBackground,s.inputValidationInfoForeground=s.options.inputValidationInfoForeground,s.inputValidationWarningBorder=s.options.inputValidationWarningBorder,s.inputValidationWarningBackground=s.options.inputValidationWarningBackground,s.inputValidationWarningForeground=s.options.inputValidationWarningForeground,
s.inputValidationErrorBorder=s.options.inputValidationErrorBorder,s.inputValidationErrorBackground=s.options.inputValidationErrorBackground,s.inputValidationErrorForeground=s.options.inputValidationErrorForeground,s.options.validationOptions&&(s.validation=s.options.validationOptions.validation),s.element=o.append(t,m(".monaco-inputbox.idle"));var a=s.options.flexibleHeight?"textarea":"input",d=o.append(s.element,m(".wrapper"));if(s.input=o.append(d,m(a+".input")),s.input.setAttribute("autocorrect","off"),s.input.setAttribute("autocapitalize","off"),s.input.setAttribute("spellcheck","false"),s.onfocus(s.input,function(){return o.addClass(s.element,"synthetic-focus")}),s.onblur(s.input,function(){return o.removeClass(s.element,"synthetic-focus")}),s.options.flexibleHeight){s.maxHeight="number"==typeof s.options.flexibleMaxHeight?s.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,s.mirror=o.append(d,m("div.mirror")),s.mirror.innerHTML="&nbsp;",s.scrollableElement=new f.ScrollableElement(s.element,{vertical:1
}),s.options.flexibleWidth&&(s.input.setAttribute("wrap","off"),s.mirror.style.whiteSpace="pre",s.mirror.style.wordWrap="initial"),o.append(t,s.scrollableElement.getDomNode()),s._register(s.scrollableElement),s._register(s.scrollableElement.onScroll(function(e){return s.input.scrollTop=e.scrollTop}));var c=u.Event.filter(g.domEvent(document,"selectionchange"),function(){var e=document.getSelection();return!!e&&e.anchorNode===d});s._register(c(s.updateScrollDimensions,s)),s._register(s.onDidHeightChange(s.updateScrollDimensions,s))}else s.input.type=s.options.type||"text",s.input.setAttribute("wrap","off");return s.ariaLabel&&s.input.setAttribute("aria-label",s.ariaLabel),s.placeholder&&s.setPlaceHolder(s.placeholder),s.oninput(s.input,function(){return s.onValueChange()}),s.onblur(s.input,function(){return s.onBlur()}),s.onfocus(s.input,function(){return s.onFocus()}),s.placeholder&&n.isIE&&s.onclick(s.input,function(e){o.EventHelper.stop(e,!0),s.input.focus()}),setTimeout(function(){s.input&&s.updateMirror()
},0),s.options.actions&&(s.actionbar=s._register(new l.ActionBar(s.element)),s.actionbar.push(s.options.actions,{icon:!0,label:!1})),s.applyStyles(),s}return r(t,e),t.prototype.onBlur=function(){this._hideMessage()},t.prototype.onFocus=function(){this._showMessage()},t.prototype.setPlaceHolder=function(e){this.input&&(this.input.setAttribute("placeholder",e),this.input.title=e)},t.prototype.setAriaLabel=function(e){this.ariaLabel=e,this.input&&(e?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label"))},Object.defineProperty(t.prototype,"inputElement",{get:function(){return this.input},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return this.input.value},set:function(e){this.input.value!==e&&(this.input.value=e,this.onValueChange())},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"height",{get:function(){return"number"==typeof this.cachedHeight?this.cachedHeight:o.getTotalHeight(this.element)},enumerable:!0,
configurable:!0}),t.prototype.focus=function(){this.input.focus()},t.prototype.blur=function(){this.input.blur()},t.prototype.hasFocus=function(){return document.activeElement===this.input},t.prototype.select=function(e){void 0===e&&(e=null),this.input.select(),e&&this.input.setSelectionRange(e.start,e.end)},t.prototype.enable=function(){this.input.removeAttribute("disabled")},t.prototype.disable=function(){this.input.disabled=!0,this._hideMessage()},Object.defineProperty(t.prototype,"width",{get:function(){return o.getTotalWidth(this.input)},set:function(e){if(this.options.flexibleHeight&&this.options.flexibleWidth){var t=0;if(this.mirror){t=(parseFloat(this.mirror.style.paddingLeft||"")||0)+(parseFloat(this.mirror.style.paddingRight||"")||0)}this.input.style.width=e-t+"px"}else this.input.style.width=e+"px";this.mirror&&(this.mirror.style.width=e+"px")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"paddingRight",{set:function(e){
this.options.flexibleHeight&&this.options.flexibleWidth?this.input.style.width="calc(100% - "+e+"px)":this.input.style.paddingRight=e+"px",this.mirror&&(this.mirror.style.paddingRight=e+"px")},enumerable:!0,configurable:!0}),t.prototype.updateScrollDimensions=function(){if("number"==typeof this.cachedContentHeight&&"number"==typeof this.cachedHeight){var e=this.cachedContentHeight,t=this.cachedHeight,i=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:e,height:t}),this.scrollableElement.setScrollPosition({scrollTop:i})}},t.prototype.showMessage=function(e,t){this.message=e,o.removeClass(this.element,"idle"),o.removeClass(this.element,"info"),o.removeClass(this.element,"warning"),o.removeClass(this.element,"error"),o.addClass(this.element,this.classForType(e.type));var n=this.stylesForType(this.message.type);this.element.style.border=n.border?"1px solid "+n.border:null;var r
;r=3===e.type?i.localize(0,null,e.content):2===e.type?i.localize(1,null,e.content):i.localize(2,null,e.content),a.alert(r),(this.hasFocus()||t)&&this._showMessage()},t.prototype.hideMessage=function(){this.message=null,o.removeClass(this.element,"info"),o.removeClass(this.element,"warning"),o.removeClass(this.element,"error"),o.addClass(this.element,"idle"),this._hideMessage(),this.applyStyles()},t.prototype.validate=function(){var e=null;return this.validation&&((e=this.validation(this.value))?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(e)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),!e},t.prototype.stylesForType=function(e){switch(e){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,
foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}},t.prototype.classForType=function(e){switch(e){case 1:return"info";case 2:return"warning";default:return"error"}},t.prototype._showMessage=function(){var e=this;if(this.contextViewProvider&&this.message){var t,i=function(){return t.style.width=o.getTotalWidth(e.element)+"px"};this.contextViewProvider.showContextView({getAnchor:function(){return e.element},anchorAlignment:1,render:function(n){if(!e.message)return null;t=o.append(n,m(".monaco-inputbox-container")),i();var r={inline:!0,className:"monaco-inputbox-message"},a=e.message.formatContent?s.renderFormattedText(e.message.content,r):s.renderText(e.message.content,r);o.addClass(a,e.classForType(e.message.type));var l=e.stylesForType(e.message.type);return a.style.backgroundColor=l.background?l.background.toString():null,
a.style.color=l.foreground?l.foreground.toString():null,a.style.border=l.border?"1px solid "+l.border:null,o.append(t,a),null},onHide:function(){e.state="closed"},layout:i}),this.state="open"}},t.prototype._hideMessage=function(){this.contextViewProvider&&("open"===this.state&&this.contextViewProvider.hideContextView(),this.state="idle")},t.prototype.onValueChange=function(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),"open"===this.state&&this.contextViewProvider&&this.contextViewProvider.layout()},t.prototype.updateMirror=function(){if(this.mirror){var e=this.value||this.placeholder,t=10===e.charCodeAt(e.length-1)?" ":"";e+t?this.mirror.textContent=e+t:this.mirror.innerHTML="&nbsp;",this.layout()}},t.prototype.style=function(e){this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,
this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.applyStyles()},t.prototype.applyStyles=function(){if(this.element){var e=this.inputBackground?this.inputBackground.toString():null,t=this.inputForeground?this.inputForeground.toString():null,i=this.inputBorder?this.inputBorder.toString():null;this.element.style.backgroundColor=e,this.element.style.color=t,this.input.style.backgroundColor=e,this.input.style.color=t,this.element.style.borderWidth=i?"1px":null,this.element.style.borderStyle=i?"solid":null,this.element.style.borderColor=i}},t.prototype.layout=function(){if(this.mirror){
var e=this.cachedContentHeight;this.cachedContentHeight=o.getTotalHeight(this.mirror),e!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}},t.prototype.dispose=function(){this._hideMessage(),this.element=null,this.input=null,this.contextViewProvider=void 0,this.message=null,this.validation=void 0,this.state=null,this.actionbar=void 0,e.prototype.dispose.call(this)},t}(d.Widget);t.InputBox=_;var y=function(e){function t(t,i,n){var o=e.call(this,t,i,n)||this;return o.history=new p.HistoryNavigator(n.history,100),o}return r(t,e),t.prototype.addToHistory=function(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)},t.prototype.showNextValue=function(){this.history.has(this.value)||this.addToHistory();var e=this.getNextValue();e&&(e=e===this.value?this.getNextValue():e),e&&(this.value=e,a.status(this.value))},
t.prototype.showPreviousValue=function(){this.history.has(this.value)||this.addToHistory();var e=this.getPreviousValue();e&&(e=e===this.value?this.getPreviousValue():e),e&&(this.value=e,a.status(this.value))},t.prototype.getCurrentValue=function(){var e=this.history.current();return e||(e=this.history.last(),this.history.next()),e},t.prototype.getPreviousValue=function(){return this.history.previous()||this.history.first()},t.prototype.getNextValue=function(){return this.history.next()||this.history.last()},t}(_);t.HistoryInputBox=y}),define(t[285],i([1,0,279,8,123,45,4,182,196]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=i.localize(0,null),d=function(e){function t(t,i,r,s){var d=e.call(this)||this;d._showOptionButtons=r,d.fixFocusOnOptionClickEnabled=!0,d._onDidOptionChange=d._register(new a.Emitter),d.onDidOptionChange=d._onDidOptionChange.event,d._onKeyDown=d._register(new a.Emitter),d.onKeyDown=d._onKeyDown.event,d._onMouseDown=d._register(new a.Emitter),
d.onMouseDown=d._onMouseDown.event,d._onInput=d._register(new a.Emitter),d._onKeyUp=d._register(new a.Emitter),d._onCaseSensitiveKeyDown=d._register(new a.Emitter),d.onCaseSensitiveKeyDown=d._onCaseSensitiveKeyDown.event,d._onRegexKeyDown=d._register(new a.Emitter),d.onRegexKeyDown=d._onRegexKeyDown.event,d._lastHighlightFindOptions=0,d.contextViewProvider=i,d.placeholder=s.placeholder||"",d.validation=s.validation,d.label=s.label||u,d.inputActiveOptionBorder=s.inputActiveOptionBorder,d.inputActiveOptionBackground=s.inputActiveOptionBackground,d.inputBackground=s.inputBackground,d.inputForeground=s.inputForeground,d.inputBorder=s.inputBorder,d.inputValidationInfoBorder=s.inputValidationInfoBorder,d.inputValidationInfoBackground=s.inputValidationInfoBackground,d.inputValidationInfoForeground=s.inputValidationInfoForeground,d.inputValidationWarningBorder=s.inputValidationWarningBorder,d.inputValidationWarningBackground=s.inputValidationWarningBackground,
d.inputValidationWarningForeground=s.inputValidationWarningForeground,d.inputValidationErrorBorder=s.inputValidationErrorBorder,d.inputValidationErrorBackground=s.inputValidationErrorBackground,d.inputValidationErrorForeground=s.inputValidationErrorForeground;var c=s.appendCaseSensitiveLabel||"",h=s.appendWholeWordsLabel||"",p=s.appendRegexLabel||"",f=s.history||[],g=!!s.flexibleHeight,m=!!s.flexibleWidth,v=s.flexibleMaxHeight;d.domNode=document.createElement("div"),n.addClass(d.domNode,"monaco-findInput"),d.inputBox=d._register(new o.HistoryInputBox(d.domNode,d.contextViewProvider,{placeholder:d.placeholder||"",ariaLabel:d.label||"",validationOptions:{validation:d.validation},inputBackground:d.inputBackground,inputForeground:d.inputForeground,inputBorder:d.inputBorder,inputValidationInfoBackground:d.inputValidationInfoBackground,inputValidationInfoForeground:d.inputValidationInfoForeground,inputValidationInfoBorder:d.inputValidationInfoBorder,
inputValidationWarningBackground:d.inputValidationWarningBackground,inputValidationWarningForeground:d.inputValidationWarningForeground,inputValidationWarningBorder:d.inputValidationWarningBorder,inputValidationErrorBackground:d.inputValidationErrorBackground,inputValidationErrorForeground:d.inputValidationErrorForeground,inputValidationErrorBorder:d.inputValidationErrorBorder,history:f,flexibleHeight:g,flexibleWidth:m,flexibleMaxHeight:v})),d.regex=d._register(new l.RegexCheckbox({appendTitle:p,isChecked:!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionBackground:d.inputActiveOptionBackground})),d._register(d.regex.onChange(function(e){d._onDidOptionChange.fire(e),!e&&d.fixFocusOnOptionClickEnabled&&d.inputBox.focus(),d.validate()})),d._register(d.regex.onKeyDown(function(e){d._onRegexKeyDown.fire(e)})),d.wholeWords=d._register(new l.WholeWordsCheckbox({appendTitle:h,isChecked:!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionBackground:d.inputActiveOptionBackground
})),d._register(d.wholeWords.onChange(function(e){d._onDidOptionChange.fire(e),!e&&d.fixFocusOnOptionClickEnabled&&d.inputBox.focus(),d.validate()})),d.caseSensitive=d._register(new l.CaseSensitiveCheckbox({appendTitle:c,isChecked:!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionBackground:d.inputActiveOptionBackground})),d._register(d.caseSensitive.onChange(function(e){d._onDidOptionChange.fire(e),!e&&d.fixFocusOnOptionClickEnabled&&d.inputBox.focus(),d.validate()})),d._register(d.caseSensitive.onKeyDown(function(e){d._onCaseSensitiveKeyDown.fire(e)})),d._showOptionButtons&&(d.inputBox.paddingRight=d.caseSensitive.width()+d.wholeWords.width()+d.regex.width());var _=[d.caseSensitive.domNode,d.wholeWords.domNode,d.regex.domNode];d.onkeydown(d.domNode,function(e){if(e.equals(15)||e.equals(17)||e.equals(9)){var t=_.indexOf(document.activeElement);if(t>=0){var i=-1;e.equals(17)?i=(t+1)%_.length:e.equals(15)&&(i=0===t?_.length-1:t-1),e.equals(9)?_[t].blur():i>=0&&_[i].focus(),
n.EventHelper.stop(e,!0)}}});var y=document.createElement("div");return y.className="controls",y.style.display=d._showOptionButtons?"block":"none",y.appendChild(d.caseSensitive.domNode),y.appendChild(d.wholeWords.domNode),y.appendChild(d.regex.domNode),d.domNode.appendChild(y),t&&t.appendChild(d.domNode),d.onkeydown(d.inputBox.inputElement,function(e){return d._onKeyDown.fire(e)}),d.onkeyup(d.inputBox.inputElement,function(e){return d._onKeyUp.fire(e)}),d.oninput(d.inputBox.inputElement,function(e){return d._onInput.fire()}),d.onmousedown(d.inputBox.inputElement,function(e){return d._onMouseDown.fire(e)}),d}return r(t,e),t.prototype.enable=function(){n.removeClass(this.domNode,"disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable()},t.prototype.disable=function(){n.addClass(this.domNode,"disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable()},t.prototype.setFocusInputOnOptionClick=function(e){
this.fixFocusOnOptionClickEnabled=e},t.prototype.setEnabled=function(e){e?this.enable():this.disable()},t.prototype.getValue=function(){return this.inputBox.value},t.prototype.setValue=function(e){this.inputBox.value!==e&&(this.inputBox.value=e)},t.prototype.style=function(e){this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,
this.inputValidationErrorForeground=e.inputValidationErrorForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.applyStyles()},t.prototype.applyStyles=function(){if(this.domNode){var e={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(e),this.wholeWords.style(e),this.caseSensitive.style(e);var t={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,
inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(t)}},t.prototype.select=function(){this.inputBox.select()},t.prototype.focus=function(){this.inputBox.focus()},t.prototype.getCaseSensitive=function(){return this.caseSensitive.checked},t.prototype.setCaseSensitive=function(e){this.caseSensitive.checked=e},t.prototype.getWholeWords=function(){return this.wholeWords.checked},t.prototype.setWholeWords=function(e){this.wholeWords.checked=e},t.prototype.getRegex=function(){return this.regex.checked},t.prototype.setRegex=function(e){this.regex.checked=e,this.validate()},t.prototype.focusOnCaseSensitive=function(){this.caseSensitive.focus()},t.prototype.highlightFindOptions=function(){n.removeClass(this.domNode,"highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,n.addClass(this.domNode,"highlight-"+this._lastHighlightFindOptions)},t.prototype.validate=function(){
this.inputBox&&this.inputBox.validate()},t.prototype.clearMessage=function(){this.inputBox&&this.inputBox.hideMessage()},t.prototype.dispose=function(){e.prototype.dispose.call(this)},t}(s.Widget);t.FindInput=d}),define(t[286],i([1,0,282,8,123,45,4,164,196]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=i.localize(0,null),d=i.localize(1,null),c=function(e){function t(t){return e.call(this,{actionClassName:"monaco-case-sensitive",title:d+t.appendTitle,isChecked:t.isChecked,inputActiveOptionBorder:t.inputActiveOptionBorder})||this}return r(t,e),t}(l.Checkbox);t.PreserveCaseCheckbox=c;var h=function(e){function t(t,i,n,o){var r=e.call(this)||this;r._showOptionButtons=n,r.fixFocusOnOptionClickEnabled=!0,r.cachedOptionsWidth=0,r._onDidOptionChange=r._register(new a.Emitter),r.onDidOptionChange=r._onDidOptionChange.event,r._onKeyDown=r._register(new a.Emitter),r.onKeyDown=r._onKeyDown.event,r._onMouseDown=r._register(new a.Emitter),
r._onInput=r._register(new a.Emitter),r._onKeyUp=r._register(new a.Emitter),r._onPreserveCaseKeyDown=r._register(new a.Emitter),r.onPreserveCaseKeyDown=r._onPreserveCaseKeyDown.event,r.contextViewProvider=i,r.placeholder=o.placeholder||"",r.validation=o.validation,r.label=o.label||u,r.inputActiveOptionBorder=o.inputActiveOptionBorder,r.inputBackground=o.inputBackground,r.inputForeground=o.inputForeground,r.inputBorder=o.inputBorder,r.inputValidationInfoBorder=o.inputValidationInfoBorder,r.inputValidationInfoBackground=o.inputValidationInfoBackground,r.inputValidationInfoForeground=o.inputValidationInfoForeground,r.inputValidationWarningBorder=o.inputValidationWarningBorder,r.inputValidationWarningBackground=o.inputValidationWarningBackground,r.inputValidationWarningForeground=o.inputValidationWarningForeground,r.inputValidationErrorBorder=o.inputValidationErrorBorder,r.inputValidationErrorBackground=o.inputValidationErrorBackground,r.inputValidationErrorForeground=o.inputValidationErrorForeground
;var s=!!o.flexibleHeight,l=!!o.flexibleWidth,d=o.flexibleMaxHeight;return r.buildDomNode(o.history||[],s,l,d),t&&t.appendChild(r.domNode),r.onkeydown(r.inputBox.inputElement,function(e){return r._onKeyDown.fire(e)}),r.onkeyup(r.inputBox.inputElement,function(e){return r._onKeyUp.fire(e)}),r.oninput(r.inputBox.inputElement,function(e){return r._onInput.fire()}),r.onmousedown(r.inputBox.inputElement,function(e){return r._onMouseDown.fire(e)}),r}return r(t,e),t.prototype.enable=function(){n.removeClass(this.domNode,"disabled"),this.inputBox.enable(),this.preserveCase.enable()},t.prototype.disable=function(){n.addClass(this.domNode,"disabled"),this.inputBox.disable(),this.preserveCase.disable()},t.prototype.setEnabled=function(e){e?this.enable():this.disable()},t.prototype.style=function(e){this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,
this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.applyStyles()},t.prototype.applyStyles=function(){if(this.domNode){var e={inputActiveOptionBorder:this.inputActiveOptionBorder};this.preserveCase.style(e);var t={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,
inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(t)}},t.prototype.select=function(){this.inputBox.select()},t.prototype.focus=function(){this.inputBox.focus()},t.prototype.getPreserveCase=function(){return this.preserveCase.checked},t.prototype.setPreserveCase=function(e){this.preserveCase.checked=e},t.prototype.focusOnPreserve=function(){this.preserveCase.focus()},t.prototype.buildDomNode=function(e,t,i,r){var s=this;this.domNode=document.createElement("div"),n.addClass(this.domNode,"monaco-findInput"),
this.inputBox=this._register(new o.HistoryInputBox(this.domNode,this.contextViewProvider,{ariaLabel:this.label||"",placeholder:this.placeholder||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:e,flexibleHeight:t,flexibleWidth:i,flexibleMaxHeight:r})),this.preserveCase=this._register(new c({appendTitle:"",isChecked:!1,
inputActiveOptionBorder:this.inputActiveOptionBorder})),this._register(this.preserveCase.onChange(function(e){s._onDidOptionChange.fire(e),!e&&s.fixFocusOnOptionClickEnabled&&s.inputBox.focus(),s.validate()})),this._register(this.preserveCase.onKeyDown(function(e){s._onPreserveCaseKeyDown.fire(e)})),this._showOptionButtons?this.cachedOptionsWidth=this.preserveCase.width():this.cachedOptionsWidth=0;var a=[this.preserveCase.domNode];this.onkeydown(this.domNode,function(e){if(e.equals(15)||e.equals(17)||e.equals(9)){var t=a.indexOf(document.activeElement);if(t>=0){var i=-1;e.equals(17)?i=(t+1)%a.length:e.equals(15)&&(i=0===t?a.length-1:t-1),e.equals(9)?a[t].blur():i>=0&&a[i].focus(),n.EventHelper.stop(e,!0)}}});var l=document.createElement("div");l.className="controls",l.style.display=this._showOptionButtons?"block":"none",l.appendChild(this.preserveCase.domNode),this.domNode.appendChild(l)},t.prototype.validate=function(){this.inputBox&&this.inputBox.validate()},Object.defineProperty(t.prototype,"width",{
set:function(e){this.inputBox.paddingRight=this.cachedOptionsWidth,this.inputBox.width=e,this.domNode.style.width=e+"px"},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t}(s.Widget);t.ReplaceInput=h}),define(t[287],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/keybindingLabel/keybindingLabel",t)}),define(t[288],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/list/listWidget",t)}),define(t[122],i([1,0,288,2,23,19,115,8,18,79,57,4,52,589,152,25,29,588,159,64,403]),function(e,t,i,n,o,a,l,u,c,h,p,f,g,m,v,_,y,b,C,S){"use strict";function w(e){return"INPUT"===e.tagName||"TEXTAREA"===e.tagName}function E(e){return!(e.ctrlKey||e.metaKey||e.altKey)&&(e.keyCode>=31&&e.keyCode<=56||e.keyCode>=21&&e.keyCode<=30||e.keyCode>=93&&e.keyCode<=102||e.keyCode>=80&&e.keyCode<=90)}function L(e){return c.isMacintosh?e.browserEvent.metaKey:e.browserEvent.ctrlKey}function x(e){return e.browserEvent.shiftKey}function D(e){
return e instanceof MouseEvent&&2===e.button}function I(e,t){for(var i=[],n=0,o=0;n<e.length||o<t.length;)if(n>=e.length)i.push(t[o++]);else if(o>=t.length)i.push(e[n++]);else{if(e[n]===t[o]){i.push(e[n]),n++,o++;continue}e[n]<t[o]?i.push(e[n++]):i.push(t[o++])}return i}Object.defineProperty(t,"__esModule",{value:!0});var N,M=function(){function e(e){this.trait=e,this.renderedElements=[]}return Object.defineProperty(e.prototype,"templateId",{get:function(){return"template:"+this.trait.trait},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(e){return e},e.prototype.renderElement=function(e,t,i){var n=a.firstIndex(this.renderedElements,function(e){return e.templateData===i});if(n>=0){o=this.renderedElements[n];this.trait.unrender(i),o.index=t}else{var o={index:t,templateData:i};this.renderedElements.push(o)}this.trait.renderIndex(t,i)},e.prototype.splice=function(e,t,i){for(var n=[],o=0,r=this.renderedElements;o<r.length;o++){var s=r[o];s.index<e?n.push(s):s.index>=e+t&&n.push({
index:s.index+i-t,templateData:s.templateData})}this.renderedElements=n},e.prototype.renderIndexes=function(e){for(var t=0,i=this.renderedElements;t<i.length;t++){var n=i[t],o=n.index,r=n.templateData;e.indexOf(o)>-1&&this.trait.renderIndex(o,r)}},e.prototype.disposeTemplate=function(e){var t=a.firstIndex(this.renderedElements,function(t){return t.templateData===e});t<0||this.renderedElements.splice(t,1)},e}(),k=function(){function e(e){this._trait=e,this.indexes=[],this.sortedIndexes=[],this._onChange=new f.Emitter,this.onChange=this._onChange.event}return Object.defineProperty(e.prototype,"trait",{get:function(){return this._trait},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderer",{get:function(){return new M(this)},enumerable:!0,configurable:!0}),e.prototype.splice=function(e,t,i){var n=i.length-t,o=e+t,r=this.sortedIndexes.filter(function(t){return t<e}).concat(i.map(function(t,i){return t?i+e:-1}).filter(function(e){return-1!==e}),this.sortedIndexes.filter(function(e){
return e>=o}).map(function(e){return e+n}));this.renderer.splice(e,t,i.length),this._set(r,r)},e.prototype.renderIndex=function(e,t){u.toggleClass(t,this._trait,this.contains(e))},e.prototype.unrender=function(e){u.removeClass(e,this._trait)},e.prototype.set=function(e,t){return this._set(e,e.slice().sort(K),t)},e.prototype._set=function(e,t,i){var n=this.indexes,o=this.sortedIndexes;this.indexes=e,this.sortedIndexes=t;var r=I(o,e);return this.renderer.renderIndexes(r),this._onChange.fire({indexes:e,browserEvent:i}),n},e.prototype.get=function(){return this.indexes},e.prototype.contains=function(e){return a.binarySearch(this.sortedIndexes,e,K)>=0},e.prototype.dispose=function(){this._onChange=n.dispose(this._onChange)},d([l.memoize],e.prototype,"renderer",null),e}(),T=function(e){function t(){return e.call(this,"focused")||this}return r(t,e),t.prototype.renderIndex=function(t,i){e.prototype.renderIndex.call(this,t,i),this.contains(t)?i.setAttribute("aria-selected","true"):i.removeAttribute("aria-selected")},t
}(k),R=function(){function e(e,t,i){this.trait=e,this.view=t,this.identityProvider=i}return e.prototype.splice=function(e,t,i){var n=this;if(!this.identityProvider)return this.trait.splice(e,t,i.map(function(){return!1}));var o=this.trait.get().map(function(e){return n.identityProvider.getId(n.view.element(e)).toString()}),r=i.map(function(e){return o.indexOf(n.identityProvider.getId(e).toString())>-1});this.trait.splice(e,t,r)},e}(),O=function(){function e(e,t,i){this.list=e,this.view=t,this.disposables=new n.DisposableStore;var o=!1!==i.multipleSelectionSupport;this.openController=i.openController||W;var r=f.Event.chain(g.domEvent(t.domNode,"keydown")).filter(function(e){return!w(e.target)}).map(function(e){return new p.StandardKeyboardEvent(e)});r.filter(function(e){return 3===e.keyCode}).on(this.onEnter,this,this.disposables),r.filter(function(e){return 16===e.keyCode}).on(this.onUpArrow,this,this.disposables),r.filter(function(e){return 18===e.keyCode}).on(this.onDownArrow,this,this.disposables),
r.filter(function(e){return 11===e.keyCode}).on(this.onPageUpArrow,this,this.disposables),r.filter(function(e){return 12===e.keyCode}).on(this.onPageDownArrow,this,this.disposables),r.filter(function(e){return 9===e.keyCode}).on(this.onEscape,this,this.disposables),o&&r.filter(function(e){return(c.isMacintosh?e.metaKey:e.ctrlKey)&&31===e.keyCode}).on(this.onCtrlA,this,this.disposables)}return e.prototype.onEnter=function(e){e.preventDefault(),e.stopPropagation(),this.list.setSelection(this.list.getFocus(),e.browserEvent),this.openController.shouldOpen(e.browserEvent)&&this.list.open(this.list.getFocus(),e.browserEvent)},e.prototype.onUpArrow=function(e){e.preventDefault(),e.stopPropagation(),this.list.focusPrevious(1,!1,e.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onDownArrow=function(e){e.preventDefault(),e.stopPropagation(),this.list.focusNext(1,!1,e.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},
e.prototype.onPageUpArrow=function(e){e.preventDefault(),e.stopPropagation(),this.list.focusPreviousPage(e.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onPageDownArrow=function(e){e.preventDefault(),e.stopPropagation(),this.list.focusNextPage(e.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onCtrlA=function(e){e.preventDefault(),e.stopPropagation(),this.list.setSelection(a.range(this.list.length),e.browserEvent),this.view.domNode.focus()},e.prototype.onEscape=function(e){e.preventDefault(),e.stopPropagation(),this.list.setSelection([],e.browserEvent),this.view.domNode.focus()},e.prototype.dispose=function(){this.disposables.dispose()},e}();!function(e){e[e.Idle=0]="Idle",e[e.Typing=1]="Typing"}(N||(N={})),t.mightProducePrintableCharacter=E;var P=function(){function e(e,t,i){this.list=e,this.view=t,this.keyboardNavigationLabelProvider=i,this.enabled=!1,this.state=N.Idle,this.automaticKeyboardNavigation=!0,
this.triggered=!1,this.enabledDisposables=new n.DisposableStore,this.disposables=new n.DisposableStore,this.updateOptions(e.options)}return e.prototype.updateOptions=function(e){void 0===e.enableKeyboardNavigation||!!e.enableKeyboardNavigation?this.enable():this.disable(),void 0!==e.automaticKeyboardNavigation&&(this.automaticKeyboardNavigation=e.automaticKeyboardNavigation)},e.prototype.enable=function(){var e=this;if(!this.enabled){var t=f.Event.chain(g.domEvent(this.view.domNode,"keydown")).filter(function(e){return!w(e.target)}).filter(function(){return e.automaticKeyboardNavigation||e.triggered}).map(function(e){return new p.StandardKeyboardEvent(e)}).filter(this.keyboardNavigationLabelProvider.mightProducePrintableCharacter?function(t){return e.keyboardNavigationLabelProvider.mightProducePrintableCharacter(t)}:function(e){return E(e)}).forEach(function(e){e.stopPropagation(),e.preventDefault()}).map(function(e){return e.browserEvent.key}).event,i=f.Event.debounce(t,function(){return null},800)
;f.Event.reduce(f.Event.any(t,i),function(e,t){return null===t?null:(e||"")+t})(this.onInput,this,this.enabledDisposables),this.enabled=!0,this.triggered=!1}},e.prototype.disable=function(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)},e.prototype.onInput=function(e){if(!e)return this.state=N.Idle,void(this.triggered=!1);var t=this.list.getFocus(),i=t.length>0?t[0]:0,n=this.state===N.Idle?1:0;this.state=N.Typing;for(var o=0;o<this.list.length;o++){var r=(i+o+n)%this.list.length,s=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(r)),a=s&&s.toString();if(void 0===a||S.matchesPrefix(e,a))return this.list.setFocus([r]),void this.list.reveal(r)}},e.prototype.dispose=function(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()},e}(),A=function(){function e(e,t){this.list=e,this.view=t,this.disposables=new n.DisposableStore;f.Event.chain(g.domEvent(t.domNode,"keydown")).filter(function(e){return!w(e.target)
}).map(function(e){return new p.StandardKeyboardEvent(e)}).filter(function(e){return!(2!==e.keyCode||e.ctrlKey||e.metaKey||e.shiftKey||e.altKey)}).on(this.onTab,this,this.disposables)}return e.prototype.onTab=function(e){if(e.target===this.view.domNode){var t=this.list.getFocus();if(0!==t.length){var i=this.view.domElement(t[0]);if(i){var n=i.querySelector("[tabIndex]");if(n&&n instanceof HTMLElement&&-1!==n.tabIndex){var o=window.getComputedStyle(n);"hidden"!==o.visibility&&"none"!==o.display&&(e.preventDefault(),e.stopPropagation(),n.focus())}}}}},e.prototype.dispose=function(){this.disposables.dispose()},e}();t.isSelectionSingleChangeEvent=L,t.isSelectionRangeChangeEvent=x;var F={isSelectionSingleChangeEvent:L,isSelectionRangeChangeEvent:x},W={shouldOpen:function(e){return!(e instanceof MouseEvent)||!D(e)}},V=function(){function e(e){this.list=e,this.disposables=new n.DisposableStore,this.multipleSelectionSupport=!(!1===e.options.multipleSelectionSupport),
this.multipleSelectionSupport&&(this.multipleSelectionController=e.options.multipleSelectionController||F),this.openController=e.options.openController||W,this.mouseSupport=void 0===e.options.mouseSupport||!!e.options.mouseSupport,this.mouseSupport&&(e.onMouseDown(this.onMouseDown,this,this.disposables),e.onContextMenu(this.onContextMenu,this,this.disposables),e.onMouseDblClick(this.onDoubleClick,this,this.disposables),e.onTouchStart(this.onMouseDown,this,this.disposables),h.Gesture.addTarget(e.getHTMLElement())),e.onMouseClick(this.onPointer,this,this.disposables),e.onMouseMiddleClick(this.onPointer,this,this.disposables),e.onTap(this.onPointer,this,this.disposables)}return e.prototype.isSelectionSingleChangeEvent=function(e){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(e):c.isMacintosh?e.browserEvent.metaKey:e.browserEvent.ctrlKey},e.prototype.isSelectionRangeChangeEvent=function(e){
return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(e):e.browserEvent.shiftKey},e.prototype.isSelectionChangeEvent=function(e){return this.isSelectionSingleChangeEvent(e)||this.isSelectionRangeChangeEvent(e)},e.prototype.onMouseDown=function(e){document.activeElement!==e.browserEvent.target&&this.list.domFocus()},e.prototype.onContextMenu=function(e){var t=void 0===e.index?[]:[e.index];this.list.setFocus(t,e.browserEvent)},e.prototype.onPointer=function(e){if(this.mouseSupport&&!w(e.browserEvent.target)){var t=this.list.getFocus()[0],i=this.list.getSelection();t=void 0===t?i[0]:t;var n=e.index;if(void 0===n)return this.list.setFocus([],e.browserEvent),void this.list.setSelection([],e.browserEvent);if(this.multipleSelectionSupport&&this.isSelectionRangeChangeEvent(e))return this.changeSelection(e,t);if(this.multipleSelectionSupport&&this.isSelectionChangeEvent(e))return this.changeSelection(e,t);this.list.setFocus([n],e.browserEvent),
D(e.browserEvent)||(this.list.setSelection([n],e.browserEvent),this.openController.shouldOpen(e.browserEvent)&&this.list.open([n],e.browserEvent))}},e.prototype.onDoubleClick=function(e){if(!(w(e.browserEvent.target)||this.multipleSelectionSupport&&this.isSelectionChangeEvent(e))){var t=this.list.getFocus();this.list.setSelection(t,e.browserEvent),this.list.pin(t)}},e.prototype.changeSelection=function(e,t){var i=e.index;if(this.isSelectionRangeChangeEvent(e)&&void 0!==t){var n=Math.min(t,i),o=Math.max(t,i),r=a.range(n,o+1),s=function(e,t){var i=e.indexOf(t);if(-1===i)return[];for(var n=[],o=i-1;o>=0&&e[o]===t-(i-o);)n.push(e[o--]);for(n.reverse(),o=i;o<e.length&&e[o]===t+(o-i);)n.push(e[o++]);return n}(I(l=this.list.getSelection(),[t]),t);if(0===s.length)return;u=I(r,function(e,t){for(var i=[],n=0,o=0;n<e.length||o<t.length;)if(n>=e.length)i.push(t[o++]);else if(o>=t.length)i.push(e[n++]);else{if(e[n]===t[o]){n++,o++;continue}e[n]<t[o]?i.push(e[n++]):o++}return i}(l,s))
;this.list.setSelection(u,e.browserEvent)}else if(this.isSelectionSingleChangeEvent(e)){var l=this.list.getSelection(),u=l.filter(function(e){return e!==i});this.list.setFocus([i]),l.length===u.length?this.list.setSelection(u.concat([i]),e.browserEvent):this.list.setSelection(u,e.browserEvent)}},e.prototype.dispose=function(){this.disposables.dispose()},e}();t.MouseController=V;var B=function(){function e(e,t){this.styleElement=e,this.selectorSuffix=t}return e.prototype.style=function(e){var t=this.selectorSuffix?"."+this.selectorSuffix:"",i=[];e.listFocusBackground&&(i.push(".monaco-list"+t+":focus .monaco-list-row.focused { background-color: "+e.listFocusBackground+"; }"),i.push(".monaco-list"+t+":focus .monaco-list-row.focused:hover { background-color: "+e.listFocusBackground+"; }")),e.listFocusForeground&&i.push(".monaco-list"+t+":focus .monaco-list-row.focused { color: "+e.listFocusForeground+"; }"),
e.listActiveSelectionBackground&&(i.push(".monaco-list"+t+":focus .monaco-list-row.selected { background-color: "+e.listActiveSelectionBackground+"; }"),i.push(".monaco-list"+t+":focus .monaco-list-row.selected:hover { background-color: "+e.listActiveSelectionBackground+"; }")),e.listActiveSelectionForeground&&i.push(".monaco-list"+t+":focus .monaco-list-row.selected { color: "+e.listActiveSelectionForeground+"; }"),e.listFocusAndSelectionBackground&&i.push("\n\t\t\t\t.monaco-drag-image,\n\t\t\t\t.monaco-list"+t+":focus .monaco-list-row.selected.focused { background-color: "+e.listFocusAndSelectionBackground+"; }\n\t\t\t"),e.listFocusAndSelectionForeground&&i.push("\n\t\t\t\t.monaco-drag-image,\n\t\t\t\t.monaco-list"+t+":focus .monaco-list-row.selected.focused { color: "+e.listFocusAndSelectionForeground+"; }\n\t\t\t"),e.listInactiveFocusBackground&&(i.push(".monaco-list"+t+" .monaco-list-row.focused { background-color:  "+e.listInactiveFocusBackground+"; }"),
i.push(".monaco-list"+t+" .monaco-list-row.focused:hover { background-color:  "+e.listInactiveFocusBackground+"; }")),e.listInactiveSelectionBackground&&(i.push(".monaco-list"+t+" .monaco-list-row.selected { background-color:  "+e.listInactiveSelectionBackground+"; }"),i.push(".monaco-list"+t+" .monaco-list-row.selected:hover { background-color:  "+e.listInactiveSelectionBackground+"; }")),e.listInactiveSelectionForeground&&i.push(".monaco-list"+t+" .monaco-list-row.selected { color: "+e.listInactiveSelectionForeground+"; }"),e.listHoverBackground&&i.push(".monaco-list"+t+":not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color:  "+e.listHoverBackground+"; }"),e.listHoverForeground&&i.push(".monaco-list"+t+" .monaco-list-row:hover:not(.selected):not(.focused) { color:  "+e.listHoverForeground+"; }"),e.listSelectionOutline&&i.push(".monaco-list"+t+" .monaco-list-row.selected { outline: 1px dotted "+e.listSelectionOutline+"; outline-offset: -1px; }"),
e.listFocusOutline&&i.push("\n\t\t\t\t.monaco-drag-image,\n\t\t\t\t.monaco-list"+t+":focus .monaco-list-row.focused { outline: 1px solid "+e.listFocusOutline+"; outline-offset: -1px; }\n\t\t\t"),e.listInactiveFocusOutline&&i.push(".monaco-list"+t+" .monaco-list-row.focused { outline: 1px dotted "+e.listInactiveFocusOutline+"; outline-offset: -1px; }"),e.listHoverOutline&&i.push(".monaco-list"+t+" .monaco-list-row:hover { outline: 1px dashed "+e.listHoverOutline+"; outline-offset: -1px; }"),e.listDropBackground&&i.push("\n\t\t\t\t.monaco-list"+t+".drop-target,\n\t\t\t\t.monaco-list"+t+" .monaco-list-row.drop-target { background-color: "+e.listDropBackground+" !important; color: inherit !important; }\n\t\t\t"),e.listFilterWidgetBackground&&i.push(".monaco-list-type-filter { background-color: "+e.listFilterWidgetBackground+" }"),e.listFilterWidgetOutline&&i.push(".monaco-list-type-filter { border: 1px solid "+e.listFilterWidgetOutline+"; }"),
e.listFilterWidgetNoMatchesOutline&&i.push(".monaco-list-type-filter.no-matches { border: 1px solid "+e.listFilterWidgetNoMatchesOutline+"; }"),e.listMatchesShadow&&i.push(".monaco-list-type-filter { box-shadow: 1px 1px 1px "+e.listMatchesShadow+"; }");var n=i.join("\n");n!==this.styleElement.innerHTML&&(this.styleElement.innerHTML=n)},e}();t.DefaultStyleController=B;var H={listFocusBackground:_.Color.fromHex("#073655"),listActiveSelectionBackground:_.Color.fromHex("#0E639C"),listActiveSelectionForeground:_.Color.fromHex("#FFFFFF"),listFocusAndSelectionBackground:_.Color.fromHex("#094771"),listFocusAndSelectionForeground:_.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:_.Color.fromHex("#3F3F46"),listHoverBackground:_.Color.fromHex("#2A2D2E"),listDropBackground:_.Color.fromHex("#383B3D"),treeIndentGuidesStroke:_.Color.fromHex("#a9a9a9")},z={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI:function(){return null},onDragStart:function(){},onDragOver:function(){return!1},
drop:function(){}},ariaRootRole:m.ListAriaRootRole.TREE},K=function(e,t){return e-t},U=function(){function e(e,t){this._templateId=e,this.renderers=t}return Object.defineProperty(e.prototype,"templateId",{get:function(){return this._templateId},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(e){return this.renderers.map(function(t){return t.renderTemplate(e)})},e.prototype.renderElement=function(e,t,i,n){for(var o=0,r=0,s=this.renderers;r<s.length;r++){s[r].renderElement(e,t,i[o++],n)}},e.prototype.disposeElement=function(e,t,i,n){for(var o=0,r=0,s=this.renderers;r<s.length;r++){var a=s[r];a.disposeElement&&a.disposeElement(e,t,i[o],n),o+=1}},e.prototype.disposeTemplate=function(e){for(var t=0,i=0,n=this.renderers;i<n.length;i++){n[i].disposeTemplate(e[t++])}},e}(),j=function(){function e(e){this.accessibilityProvider=e,this.templateId="a18n"}return e.prototype.renderTemplate=function(e){return e},e.prototype.renderElement=function(e,t,i){var n=this.accessibilityProvider.getAriaLabel(e)
;n?i.setAttribute("aria-label",n):i.removeAttribute("aria-label");var o=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(e);"number"==typeof o?i.setAttribute("aria-level",""+o):i.removeAttribute("aria-level")},e.prototype.disposeTemplate=function(e){},e}(),q=function(){function e(e,t){this.list=e,this.dnd=t}return e.prototype.getDragElements=function(e){var t=this.list.getSelectedElements();return t.indexOf(e)>-1?t:[e]},e.prototype.getDragURI=function(e){return this.dnd.getDragURI(e)},e.prototype.getDragLabel=function(e){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(e)},e.prototype.onDragStart=function(e,t){this.dnd.onDragStart&&this.dnd.onDragStart(e,t)},e.prototype.onDragOver=function(e,t,i,n){return this.dnd.onDragOver(e,t,i,n)},e.prototype.drop=function(e,t,i,n){this.dnd.drop(e,t,i,n)},e}(),G=function(){function e(e,t,o,r){void 0===r&&(r=z),this._options=r,this.eventBufferer=new f.EventBufferer,this.disposables=new n.DisposableStore,this._onDidOpen=new f.Emitter,
this.onDidOpen=this._onDidOpen.event,this._onPin=new f.Emitter,this.didJustPressContextMenuKey=!1,this._onDidDispose=new f.Emitter,this.onDidDispose=this._onDidDispose.event,this.focus=new T,this.selection=new k("selected"),y.mixin(r,H,!1);var a=[this.focus.renderer,this.selection.renderer];r.accessibilityProvider&&a.push(new j(r.accessibilityProvider)),o=o.map(function(e){return new U(e.templateId,a.concat([e]))});var l=s({},r,{dnd:r.dnd&&new q(this,r.dnd)});if(this.view=new v.ListView(e,t,o,l),"string"!=typeof r.ariaRole?this.view.domNode.setAttribute("role",m.ListAriaRootRole.TREE):this.view.domNode.setAttribute("role",r.ariaRole),this.styleElement=u.createStyleSheet(this.view.domNode),this.styleController=r.styleController||new B(this.styleElement,this.view.domId),this.spliceable=new b.CombinedSpliceable([new R(this.focus,this.view,r.identityProvider),new R(this.selection,this.view,r.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),
this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.onDidFocus=f.Event.map(g.domEvent(this.view.domNode,"focus",!0),function(){return null}),this.onDidBlur=f.Event.map(g.domEvent(this.view.domNode,"blur",!0),function(){return null}),this.disposables.add(new A(this,this.view)),"boolean"!=typeof r.keyboardSupport||r.keyboardSupport){var d=new O(this,this.view,r);this.disposables.add(d)}r.keyboardNavigationLabelProvider&&(this.typeLabelController=new P(this,this.view,r.keyboardNavigationLabelProvider),this.disposables.add(this.typeLabelController)),this.disposables.add(this.createMouseController(r)),this.onFocusChange(this._onFocusChange,this,this.disposables),this.onSelectionChange(this._onSelectionChange,this,this.disposables),r.ariaLabel&&this.view.domNode.setAttribute("aria-label",i.localize(0,null,r.ariaLabel)),this.style(r)}return Object.defineProperty(e.prototype,"onFocusChange",{get:function(){var e=this
;return f.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),function(t){return e.toListEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onSelectionChange",{get:function(){var e=this;return f.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),function(t){return e.toListEvent(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"domId",{get:function(){return this.view.domId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseClick",{get:function(){return this.view.onMouseClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDblClick",{get:function(){return this.view.onMouseDblClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseMiddleClick",{get:function(){return this.view.onMouseMiddleClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDown",{get:function(){return this.view.onMouseDown},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"onTouchStart",{get:function(){return this.view.onTouchStart},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onTap",{get:function(){return this.view.onTap},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onContextMenu",{get:function(){var e=this,t=f.Event.chain(g.domEvent(this.view.domNode,"keydown")).map(function(e){return new p.StandardKeyboardEvent(e)}).filter(function(t){return e.didJustPressContextMenuKey=58===t.keyCode||t.shiftKey&&68===t.keyCode}).filter(function(e){return e.preventDefault(),e.stopPropagation(),!1}).event,i=f.Event.chain(g.domEvent(this.view.domNode,"keyup")).filter(function(){var t=e.didJustPressContextMenuKey;return e.didJustPressContextMenuKey=!1,t}).filter(function(){return e.getFocus().length>0&&!!e.view.domElement(e.getFocus()[0])}).map(function(t){var i=e.getFocus()[0];return{index:i,element:e.view.element(i),anchor:e.view.domElement(i),browserEvent:t}
}).event,n=f.Event.chain(this.view.onContextMenu).filter(function(){return!e.didJustPressContextMenuKey}).map(function(e){var t=e.element,i=e.index,n=e.browserEvent;return{element:t,index:i,anchor:{x:n.clientX+1,y:n.clientY},browserEvent:n}}).event;return f.Event.any(t,i,n)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onKeyDown",{get:function(){return g.domEvent(this.view.domNode,"keydown")},enumerable:!0,configurable:!0}),e.prototype.createMouseController=function(e){return new V(this)},e.prototype.updateOptions=function(e){void 0===e&&(e={}),this._options=s({},this._options,e),this.typeLabelController&&this.typeLabelController.updateOptions(this._options)},Object.defineProperty(e.prototype,"options",{get:function(){return this._options},enumerable:!0,configurable:!0}),e.prototype.splice=function(e,t,i){var n=this;if(void 0===i&&(i=[]),e<0||e>this.view.length)throw new Error("Invalid start index: "+e);if(t<0)throw new Error("Invalid delete count: "+t)
;0===t&&0===i.length||this.eventBufferer.bufferEvents(function(){return n.spliceable.splice(e,t,i)})},e.prototype.rerender=function(){this.view.rerender()},e.prototype.element=function(e){return this.view.element(e)},Object.defineProperty(e.prototype,"length",{get:function(){return this.view.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentHeight",{get:function(){return this.view.contentHeight},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"scrollTop",{get:function(){return this.view.getScrollTop()},set:function(e){this.view.setScrollTop(e)},enumerable:!0,configurable:!0}),e.prototype.domFocus=function(){this.view.domNode.focus()},e.prototype.layout=function(e,t){this.view.layout(e,t)},e.prototype.setSelection=function(e,t){for(var i=0,n=e;i<n.length;i++){var o=n[i];if(o<0||o>=this.length)throw new Error("Invalid index "+o)}this.selection.set(e,t)},e.prototype.getSelection=function(){return this.selection.get()},e.prototype.getSelectedElements=function(){
var e=this;return this.getSelection().map(function(t){return e.view.element(t)})},e.prototype.setFocus=function(e,t){for(var i=0,n=e;i<n.length;i++){var o=n[i];if(o<0||o>=this.length)throw new Error("Invalid index "+o)}this.focus.set(e,t)},e.prototype.focusNext=function(e,t,i,n){if(void 0===e&&(e=1),void 0===t&&(t=!1),0!==this.length){var o=this.focus.get(),r=this.findNextIndex(o.length>0?o[0]+e:0,t,n);r>-1&&this.setFocus([r],i)}},e.prototype.focusPrevious=function(e,t,i,n){if(void 0===e&&(e=1),void 0===t&&(t=!1),0!==this.length){var o=this.focus.get(),r=this.findPreviousIndex(o.length>0?o[0]-e:0,t,n);r>-1&&this.setFocus([r],i)}},e.prototype.focusNextPage=function(e,t){var i=this,n=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);n=0===n?0:n-1;var o=this.view.element(n),r=this.getFocusedElements()[0];if(r!==o){var s=this.findPreviousIndex(n,!1,t);s>-1&&r!==this.view.element(s)?this.setFocus([s],e):this.setFocus([n],e)}else{var a=this.view.getScrollTop()
;this.view.setScrollTop(a+this.view.renderHeight-this.view.elementHeight(n)),this.view.getScrollTop()!==a&&setTimeout(function(){return i.focusNextPage(e,t)},0)}},e.prototype.focusPreviousPage=function(e,t){var i,n=this,o=this.view.getScrollTop();i=0===o?this.view.indexAt(o):this.view.indexAfter(o-1);var r=this.view.element(i),s=this.getFocusedElements()[0];if(s!==r){var a=this.findNextIndex(i,!1,t);a>-1&&s!==this.view.element(a)?this.setFocus([a],e):this.setFocus([i],e)}else{var l=o;this.view.setScrollTop(o-this.view.renderHeight),this.view.getScrollTop()!==l&&setTimeout(function(){return n.focusPreviousPage(e,t)},0)}},e.prototype.focusLast=function(e,t){if(0!==this.length){var i=this.findPreviousIndex(this.length-1,!1,t);i>-1&&this.setFocus([i],e)}},e.prototype.focusFirst=function(e,t){if(0!==this.length){var i=this.findNextIndex(0,!1,t);i>-1&&this.setFocus([i],e)}},e.prototype.findNextIndex=function(e,t,i){void 0===t&&(t=!1);for(var n=0;n<this.length;n++){if(e>=this.length&&!t)return-1;if(e%=this.length,
!i||i(this.element(e)))return e;e++}return-1},e.prototype.findPreviousIndex=function(e,t,i){void 0===t&&(t=!1);for(var n=0;n<this.length;n++){if(e<0&&!t)return-1;if(e=(this.length+e%this.length)%this.length,!i||i(this.element(e)))return e;e--}return-1},e.prototype.getFocus=function(){return this.focus.get()},e.prototype.getFocusedElements=function(){var e=this;return this.getFocus().map(function(t){return e.view.element(t)})},e.prototype.reveal=function(e,t){if(e<0||e>=this.length)throw new Error("Invalid index "+e);var i=this.view.getScrollTop(),n=this.view.elementTop(e),r=this.view.elementHeight(e);if(o.isNumber(t)){var s=r-this.view.renderHeight;this.view.setScrollTop(s*C.clamp(t,0,1)+n)}else{var a=n+r,l=i+this.view.renderHeight;n<i?this.view.setScrollTop(n):a>=l&&this.view.setScrollTop(a-this.view.renderHeight)}},e.prototype.getRelativeTop=function(e){if(e<0||e>=this.length)throw new Error("Invalid index "+e);var t=this.view.getScrollTop(),i=this.view.elementTop(e),n=this.view.elementHeight(e)
;if(i<t||i+n>t+this.view.renderHeight)return null;var o=n-this.view.renderHeight;return Math.abs((t-i)/o)},e.prototype.getHTMLElement=function(){return this.view.domNode},e.prototype.open=function(e,t){for(var i=this,n=0,o=e;n<o.length;n++){var r=o[n];if(r<0||r>=this.length)throw new Error("Invalid index "+r)}this._onDidOpen.fire({indexes:e,elements:e.map(function(e){return i.view.element(e)}),browserEvent:t})},e.prototype.pin=function(e){for(var t=0,i=e;t<i.length;t++){var n=i[t];if(n<0||n>=this.length)throw new Error("Invalid index "+n)}this._onPin.fire(e)},e.prototype.style=function(e){this.styleController.style(e)},e.prototype.toListEvent=function(e){var t=this,i=e.indexes,n=e.browserEvent;return{indexes:i,elements:i.map(function(e){return t.view.element(e)}),browserEvent:n}},e.prototype._onFocusChange=function(){var e=this.focus.get();e.length>0?this.view.domNode.setAttribute("aria-activedescendant",this.view.getElementDomId(e[0])):this.view.domNode.removeAttribute("aria-activedescendant"),
this.view.domNode.setAttribute("role","tree"),u.toggleClass(this.view.domNode,"element-focused",e.length>0)},e.prototype._onSelectionChange=function(){var e=this.selection.get();u.toggleClass(this.view.domNode,"selection-none",0===e.length),u.toggleClass(this.view.domNode,"selection-single",1===e.length),u.toggleClass(this.view.domNode,"selection-multiple",e.length>1)},e.prototype.dispose=function(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidOpen.dispose(),this._onPin.dispose(),this._onDidDispose.dispose()},d([l.memoize],e.prototype,"onFocusChange",null),d([l.memoize],e.prototype,"onSelectionChange",null),d([l.memoize],e.prototype,"onContextMenu",null),e}();t.List=G}),define(t[290],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/menu/menu",t)}),define(t[291],i([1,0,290,5,58,74,8,57,15,2,51,4,18,402]),function(e,t,i,n,o,s,a,l,u,d,c,h,p){"use strict";function f(e){var i=t.MENU_MNEMONIC_REGEX,n=i.exec(e);if(!n)return e;var o=!n[1];return e.replace(i,o?"$2$3":"").trim()}
Object.defineProperty(t,"__esModule",{value:!0}),t.MENU_MNEMONIC_REGEX=/\(&([^\s&])\)|(^|[^&])&([^\s&])/,t.MENU_ESCAPED_MNEMONIC_REGEX=/(&amp;)?(&amp;)([^\s&])/g;var g=function(e){function t(t,i,n){var o=e.call(this,n||"submenu",t,"",!0)||this;return o.entries=i,o}return r(t,e),t}(o.Action);t.SubmenuAction=g;var m=function(e){function t(t,i,n){void 0===n&&(n={});var o=this;a.addClass(t,"monaco-menu-container"),t.setAttribute("role","presentation");var r=document.createElement("div");a.addClass(r,"monaco-menu"),r.setAttribute("role","presentation"),(o=e.call(this,r,{orientation:2,actionViewItemProvider:function(e){return o.doGetActionViewItem(e,n,s)},context:n.context,actionRunner:n.actionRunner,ariaLabel:n.ariaLabel,triggerKeys:{keys:[3].concat(p.isMacintosh?[10]:[]),keyDown:!0}})||this).menuElement=r,o._onScroll=o._register(new h.Emitter),o.actionsList.setAttribute("role","menu"),o.actionsList.tabIndex=0,o.menuDisposables=o._register(new d.DisposableStore),
a.addDisposableListener(r,a.EventType.KEY_DOWN,function(e){new l.StandardKeyboardEvent(e).equals(2)&&e.preventDefault()}),n.enableMnemonics&&o.menuDisposables.add(a.addDisposableListener(r,a.EventType.KEY_DOWN,function(e){var t=e.key.toLocaleLowerCase();if(o.mnemonics.has(t)){a.EventHelper.stop(e,!0);var i=o.mnemonics.get(t);if(1===i.length&&(i[0]instanceof _&&o.focusItemByElement(i[0].container),i[0].onClick(e)),i.length>1){var n=i.shift();n&&(o.focusItemByElement(n.container),i.push(n)),o.mnemonics.set(t,i)}}})),p.isLinux&&o._register(a.addDisposableListener(r,a.EventType.KEY_DOWN,function(e){var t=new l.StandardKeyboardEvent(e);t.equals(14)||t.equals(11)?(o.focusedItem=o.viewItems.length-1,o.focusNext(),a.EventHelper.stop(e,!0)):(t.equals(13)||t.equals(12))&&(o.focusedItem=0,o.focusPrevious(),a.EventHelper.stop(e,!0))})),o._register(a.addDisposableListener(o.domNode,a.EventType.MOUSE_OUT,function(e){var t=e.relatedTarget;a.isAncestor(t,o.domNode)||(o.focusedItem=void 0,
o.scrollTopHold=o.menuElement.scrollTop,o.updateFocus(),e.stopPropagation())})),o._register(a.addDisposableListener(o.domNode,a.EventType.MOUSE_UP,function(e){a.EventHelper.stop(e,!0)})),o._register(a.addDisposableListener(o.actionsList,a.EventType.MOUSE_OVER,function(e){var t=e.target;if(t&&a.isAncestor(t,o.actionsList)&&t!==o.actionsList){for(;t.parentElement!==o.actionsList&&null!==t.parentElement;)t=t.parentElement;if(a.hasClass(t,"action-item")){var i=o.focusedItem;o.scrollTopHold=o.menuElement.scrollTop,o.setFocusedItem(t),i!==o.focusedItem&&o.updateFocus()}}}));var s={parent:o};o.mnemonics=new Map,o.push(i,{icon:!0,label:!0,isMenu:!0}),o.scrollableElement=o._register(new c.DomScrollableElement(r,{alwaysConsumeMouseWheel:!0,horizontal:2,vertical:3,verticalScrollbarSize:7,handleMouseWheel:!0,useShadows:!0}));return o.scrollableElement.getDomNode().style.position=null,r.style.maxHeight=Math.max(10,window.innerHeight-t.getBoundingClientRect().top-30)+"px",
o.menuDisposables.add(o.scrollableElement.onScroll(function(){o._onScroll.fire()},o)),o._register(a.addDisposableListener(o.menuElement,a.EventType.SCROLL,function(e){void 0!==o.scrollTopHold&&(o.menuElement.scrollTop=o.scrollTopHold,o.scrollTopHold=void 0),o.scrollableElement.scanDomNode()})),t.appendChild(o.scrollableElement.getDomNode()),o.scrollableElement.scanDomNode(),o.viewItems.filter(function(e){return!(e instanceof y)}).forEach(function(e,t,i){e.updatePositionInSet(t+1,i.length)}),o}return r(t,e),t.prototype.style=function(e){var t=this.getContainer(),i=e.foregroundColor?""+e.foregroundColor:null,n=e.backgroundColor?""+e.backgroundColor:null,o=e.borderColor?"2px solid "+e.borderColor:null,r=e.shadowColor?"0 2px 4px "+e.shadowColor:null;t.style.border=o,this.domNode.style.color=i,this.domNode.style.backgroundColor=n,t.style.boxShadow=r,this.viewItems&&this.viewItems.forEach(function(t){(t instanceof v||t instanceof y)&&t.style(e)})},t.prototype.getContainer=function(){
return this.scrollableElement.getDomNode()},Object.defineProperty(t.prototype,"onScroll",{get:function(){return this._onScroll.event},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollOffset",{get:function(){return this.menuElement.scrollTop},enumerable:!0,configurable:!0}),t.prototype.focusItemByElement=function(e){var t=this.focusedItem;this.setFocusedItem(e),t!==this.focusedItem&&this.updateFocus()},t.prototype.setFocusedItem=function(e){for(var t=0;t<this.actionsList.children.length;t++){if(e===this.actionsList.children[t]){this.focusedItem=t;break}}},t.prototype.doGetActionViewItem=function(e,t,i){if(e instanceof s.Separator)return new y(t.context,e,{icon:!0});if(e instanceof g){a=new _(e,e.entries,i,t);if(t.enableMnemonics){if((l=a.getMnemonic())&&a.isEnabled()){u=[];this.mnemonics.has(l)&&(u=this.mnemonics.get(l)),u.push(a),this.mnemonics.set(l,u)}}return a}var n={enableMnemonics:t.enableMnemonics};if(t.getKeyBinding){var o=t.getKeyBinding(e);if(o){var r=o.getLabel()
;r&&(n.keybinding=r)}}var a=new v(t.context,e,n);if(t.enableMnemonics){var l=a.getMnemonic();if(l&&a.isEnabled()){var u=[];this.mnemonics.has(l)&&(u=this.mnemonics.get(l)),u.push(a),this.mnemonics.set(l,u)}}return a},t}(s.ActionBar);t.Menu=m;var v=function(e){function o(i,n,o){void 0===o&&(o={});var r=this;if(o.isMenu=!0,r=e.call(this,n,n,o)||this,r.options=o,r.options.icon=void 0!==o.icon&&o.icon,r.options.label=void 0===o.label||o.label,r.cssClass="",r.options.label&&o.enableMnemonics){var s=r.getAction().label;if(s){var l=t.MENU_MNEMONIC_REGEX.exec(s);l&&(r.mnemonic=(l[1]?l[1]:l[3]).toLocaleLowerCase())}}return r.runOnceToEnableMouseUp=new u.RunOnceScheduler(function(){r.element&&r._register(a.addDisposableListener(r.element,a.EventType.MOUSE_UP,function(e){a.EventHelper.stop(e,!0),r.onClick(e)}))},50),r._register(r.runOnceToEnableMouseUp),r}return r(o,e),o.prototype.render=function(t){e.prototype.render.call(this,t),this.element&&(this.container=t,
this.item=a.append(this.element,a.$("a.action-menu-item")),this._action.id===s.Separator.ID?this.item.setAttribute("role","presentation"):(this.item.setAttribute("role","menuitem"),this.mnemonic&&this.item.setAttribute("aria-keyshortcuts",""+this.mnemonic)),this.check=a.append(this.item,a.$("span.menu-item-check")),this.check.setAttribute("role","none"),this.label=a.append(this.item,a.$("span.action-label")),this.options.label&&this.options.keybinding&&(a.append(this.item,a.$("span.keybinding")).textContent=this.options.keybinding),this.runOnceToEnableMouseUp.schedule(),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked())},o.prototype.blur=function(){e.prototype.blur.call(this),this.applyStyle()},o.prototype.focus=function(){e.prototype.focus.call(this),this.item.focus(),this.applyStyle()},o.prototype.updatePositionInSet=function(e,t){this.item.setAttribute("aria-posinset",""+e),this.item.setAttribute("aria-setsize",""+t)},o.prototype.updateLabel=function(){
if(this.options.label){var e=this.getAction().label;if(e){var i=f(e);this.options.enableMnemonics||(e=i),this.label.setAttribute("aria-label",i.replace(/&&/g,"&"));var o=t.MENU_MNEMONIC_REGEX.exec(e);if(o){e=n.escape(e),t.MENU_ESCAPED_MNEMONIC_REGEX.lastIndex=0;for(var r=t.MENU_ESCAPED_MNEMONIC_REGEX.exec(e);r&&r[1];)r=t.MENU_ESCAPED_MNEMONIC_REGEX.exec(e);r&&(e=e.substr(0,r.index)+'<u aria-hidden="true">'+r[3]+"</u>"+e.substr(r.index+r[0].length)),e=e.replace(/&amp;&amp;/g,"&amp;"),this.item.setAttribute("aria-keyshortcuts",(o[1]?o[1]:o[3]).toLocaleLowerCase())}else e=e.replace(/&&/g,"&")}this.label.innerHTML=e.trim()}},o.prototype.updateTooltip=function(){var e=null;this.getAction().tooltip?e=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(e=this.getAction().label,this.options.keybinding&&(e=i.localize(0,null,e,this.options.keybinding))),e&&(this.item.title=e)},o.prototype.updateClass=function(){this.cssClass&&a.removeClasses(this.item,this.cssClass),
this.options.icon?(this.cssClass=this.getAction().class||"",a.addClass(this.label,"icon"),this.cssClass&&a.addClasses(this.label,this.cssClass),this.updateEnabled()):a.removeClass(this.label,"icon")},o.prototype.updateEnabled=function(){this.getAction().enabled?(this.element&&a.removeClass(this.element,"disabled"),a.removeClass(this.item,"disabled"),this.item.tabIndex=0):(this.element&&a.addClass(this.element,"disabled"),a.addClass(this.item,"disabled"),a.removeTabIndexAndUpdateFocus(this.item))},o.prototype.updateChecked=function(){this.getAction().checked?(a.addClass(this.item,"checked"),this.item.setAttribute("role","menuitemcheckbox"),this.item.setAttribute("aria-checked","true")):(a.removeClass(this.item,"checked"),this.item.setAttribute("role","menuitem"),this.item.setAttribute("aria-checked","false"))},o.prototype.getMnemonic=function(){return this.mnemonic},o.prototype.applyStyle=function(){if(this.menuStyle){
var e=this.element&&a.hasClass(this.element,"focused"),t=e&&this.menuStyle.selectionForegroundColor?this.menuStyle.selectionForegroundColor:this.menuStyle.foregroundColor,i=e&&this.menuStyle.selectionBackgroundColor?this.menuStyle.selectionBackgroundColor:this.menuStyle.backgroundColor,n=e&&this.menuStyle.selectionBorderColor?"thin solid "+this.menuStyle.selectionBorderColor:null;this.item.style.color=t?""+t:null,this.check.style.backgroundColor=t?""+t:null,this.item.style.backgroundColor=i?""+i:null,this.container.style.border=n}},o.prototype.style=function(e){this.menuStyle=e,this.applyStyle()},o}(s.BaseActionViewItem),_=function(e){function t(t,i,n,o){var r=e.call(this,t,t,o)||this;return r.submenuActions=i,r.parentData=n,r.submenuOptions=o,r.submenuDisposables=r._register(new d.DisposableStore),r.showScheduler=new u.RunOnceScheduler(function(){r.mouseOver&&(r.cleanupExistingSubmenu(!1),r.createSubmenu(!1))},250),r.hideScheduler=new u.RunOnceScheduler(function(){
r.element&&!a.isAncestor(document.activeElement,r.element)&&r.parentData.submenu===r.mysubmenu&&(r.parentData.parent.focus(!1),r.cleanupExistingSubmenu(!0))},750),r}return r(t,e),t.prototype.render=function(t){var i=this;e.prototype.render.call(this,t),this.element&&(a.addClass(this.item,"monaco-submenu-item"),this.item.setAttribute("aria-haspopup","true"),this.submenuIndicator=a.append(this.item,a.$("span.submenu-indicator")),this.submenuIndicator.setAttribute("aria-hidden","true"),this._register(a.addDisposableListener(this.element,a.EventType.KEY_UP,function(e){var t=new l.StandardKeyboardEvent(e);(t.equals(17)||t.equals(3))&&(a.EventHelper.stop(e,!0),i.createSubmenu(!0))})),this._register(a.addDisposableListener(this.element,a.EventType.KEY_DOWN,function(e){var t=new l.StandardKeyboardEvent(e);document.activeElement===i.item&&(t.equals(17)||t.equals(3))&&a.EventHelper.stop(e,!0)})),this._register(a.addDisposableListener(this.element,a.EventType.MOUSE_OVER,function(e){i.mouseOver||(i.mouseOver=!0,
i.showScheduler.schedule())})),this._register(a.addDisposableListener(this.element,a.EventType.MOUSE_LEAVE,function(e){i.mouseOver=!1})),this._register(a.addDisposableListener(this.element,a.EventType.FOCUS_OUT,function(e){i.element&&!a.isAncestor(document.activeElement,i.element)&&i.hideScheduler.schedule()})),this._register(this.parentData.parent.onScroll(function(){i.parentData.parent.focus(!1),i.cleanupExistingSubmenu(!1)})))},t.prototype.onClick=function(e){a.EventHelper.stop(e,!0),this.cleanupExistingSubmenu(!1),this.createSubmenu(!1)},t.prototype.cleanupExistingSubmenu=function(e){this.parentData.submenu&&(e||this.parentData.submenu!==this.mysubmenu)&&(this.parentData.submenu.dispose(),this.parentData.submenu=void 0,this.submenuContainer&&(this.submenuDisposables.clear(),this.submenuContainer=void 0))},t.prototype.createSubmenu=function(e){var t=this;if(void 0===e&&(e=!0),this.element)if(this.parentData.submenu)this.parentData.submenu.focus(!1);else{
this.submenuContainer=a.append(this.element,a.$("div.monaco-submenu")),a.addClasses(this.submenuContainer,"menubar-menu-items-holder","context-view"),this.parentData.submenu=new m(this.submenuContainer,this.submenuActions,this.submenuOptions),this.menuStyle&&this.parentData.submenu.style(this.menuStyle);var i=this.element.getBoundingClientRect(),n=this.submenuContainer.getBoundingClientRect(),o=getComputedStyle(this.parentData.parent.domNode),r=parseFloat(o.paddingTop||"0")||0;window.innerWidth<=i.right+n.width?(this.submenuContainer.style.left="10px",this.submenuContainer.style.top=this.element.offsetTop-this.parentData.parent.scrollOffset+i.height+"px"):(this.submenuContainer.style.left=this.element.offsetWidth+"px",this.submenuContainer.style.top=this.element.offsetTop-this.parentData.parent.scrollOffset-r+"px"),this.submenuDisposables.add(a.addDisposableListener(this.submenuContainer,a.EventType.KEY_UP,function(e){new l.StandardKeyboardEvent(e).equals(15)&&(a.EventHelper.stop(e,!0),
t.parentData.parent.focus(),t.parentData.submenu&&(t.parentData.submenu.dispose(),t.parentData.submenu=void 0),t.submenuDisposables.clear(),t.submenuContainer=void 0)})),this.submenuDisposables.add(a.addDisposableListener(this.submenuContainer,a.EventType.KEY_DOWN,function(e){new l.StandardKeyboardEvent(e).equals(15)&&a.EventHelper.stop(e,!0)})),this.submenuDisposables.add(this.parentData.submenu.onDidCancel(function(){t.parentData.parent.focus(),t.parentData.submenu&&(t.parentData.submenu.dispose(),t.parentData.submenu=void 0),t.submenuDisposables.clear(),t.submenuContainer=void 0})),this.parentData.submenu.focus(e),this.mysubmenu=this.parentData.submenu}},t.prototype.applyStyle=function(){if(e.prototype.applyStyle.call(this),this.menuStyle){var t=this.element&&a.hasClass(this.element,"focused")&&this.menuStyle.selectionForegroundColor?this.menuStyle.selectionForegroundColor:this.menuStyle.foregroundColor;this.submenuIndicator.style.backgroundColor=t?""+t:null,
this.parentData.submenu&&this.parentData.submenu.style(this.menuStyle)}},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.hideScheduler.dispose(),this.mysubmenu&&(this.mysubmenu.dispose(),this.mysubmenu=null),this.submenuContainer&&(this.submenuContainer=void 0)},t}(v),y=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.style=function(e){this.label.style.borderBottomColor=e.separatorColor?""+e.separatorColor:null},t}(s.ActionViewItem);t.cleanMnemonic=f}),define(t[292],i([6,7]),function(e,t){return e.create("vs/base/browser/ui/tree/abstractTree",t)}),define(t[121],i([1,0,2,122,8,4,57,154,19,152,52,64,222,292,15,18,41,159,95,382]),function(e,t,i,n,o,a,l,u,d,c,h,p,f,g,m,v,_,y,b){"use strict";function C(e){if(e instanceof c.ElementsDragAndDropData){var t=e.elements;return new c.ElementsDragAndDropData(t.map(function(e){return e.element}))}return e}function S(e){return"INPUT"===e.tagName||"TEXTAREA"===e.tagName}function w(e){return{
elements:e.elements.map(function(e){return e.element}),browserEvent:e.browserEvent}}function E(e,t){t(e),e.children.forEach(function(e){return E(e,t)})}Object.defineProperty(t,"__esModule",{value:!0});var L=function(){function e(e,t){this.modelProvider=e,this.dnd=t,this.autoExpandDisposable=i.Disposable.None}return e.prototype.getDragURI=function(e){return this.dnd.getDragURI(e.element)},e.prototype.getDragLabel=function(e){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(e.map(function(e){return e.element}))},e.prototype.onDragStart=function(e,t){this.dnd.onDragStart&&this.dnd.onDragStart(C(e),t)},e.prototype.onDragOver=function(e,t,i,n,o){var r=this;void 0===o&&(o=!0);var a=this.dnd.onDragOver(C(e),t&&t.element,i,n),l=this.autoExpandNode!==t;if(l&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=t),void 0===t)return a;if(l&&"boolean"!=typeof a&&a.autoExpand&&(this.autoExpandDisposable=m.disposableTimeout(function(){var e=r.modelProvider(),i=e.getNodeLocation(t)
;e.isCollapsed(i)&&e.setCollapsed(i,!1),r.autoExpandNode=void 0},500)),"boolean"==typeof a||!a.accept||void 0===a.bubble){if(!o){return{accept:"boolean"==typeof a?a:a.accept,effect:"boolean"==typeof a?void 0:a.effect,feedback:[i]}}return a}if(1===a.bubble){var u=t.parent,c=this.modelProvider(),h=u&&c.getListIndex(c.getNodeLocation(u));return this.onDragOver(e,u,h,n,!1)}var p=this.modelProvider(),f=p.getNodeLocation(t),g=p.getListIndex(f),v=p.getListRenderCount(f);return s({},a,{feedback:d.range(g,g+v)})},e.prototype.drop=function(e,t,i,n){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(C(e),t&&t.element,i,n)},e}(),x=function(){function e(e){this.delegate=e}return e.prototype.getHeight=function(e){return this.delegate.getHeight(e.element)},e.prototype.getTemplateId=function(e){return this.delegate.getTemplateId(e.element)},e.prototype.hasDynamicHeight=function(e){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(e.element)},
e.prototype.setDynamicHeight=function(e,t){this.delegate.setDynamicHeight&&this.delegate.setDynamicHeight(e.element,t)},e}();t.ComposedTreeDelegate=x;var D;!function(e){e.None="none",e.OnHover="onHover",e.Always="always"}(D=t.RenderIndentGuides||(t.RenderIndentGuides={}));var I=function(){function e(e,t){var n=this;void 0===t&&(t=[]),this.onDidChange=e,this._elements=t,this.disposables=new i.DisposableStore,e(function(e){return n._elements=e},null,this.disposables)}return Object.defineProperty(e.prototype,"elements",{get:function(){return this._elements},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.disposables.dispose()},e}(),N=function(){function e(t,n,o,r){void 0===r&&(r={}),this.renderer=t,this.activeNodes=o,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=e.DefaultIndent,this._renderIndentGuides=D.None,this.renderedIndentGuides=new b.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=i.Disposable.None,this.disposables=[],
this.templateId=t.templateId,this.updateOptions(r),a.Event.map(n,function(e){return e.node})(this.onDidChangeNodeTwistieState,this,this.disposables),t.onDidChangeTwistieState&&t.onDidChangeTwistieState(this.onDidChangeTwistieState,this,this.disposables)}return e.prototype.updateOptions=function(e){if(void 0===e&&(e={}),void 0!==e.indent&&(this.indent=y.clamp(e.indent,0,40)),void 0!==e.renderIndentGuides){var t=e.renderIndentGuides;if(t!==this._renderIndentGuides)if(this._renderIndentGuides=t,t){var n=new i.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,n),this.indentGuidesDisposable=n,this._onDidChangeActiveNodes(this.activeNodes.elements)}else this.indentGuidesDisposable.dispose()}},e.prototype.renderTemplate=function(e){var t=o.append(e,o.$(".monaco-tl-row")),n=o.append(t,o.$(".monaco-tl-indent")),r=o.append(t,o.$(".monaco-tl-twistie")),s=o.append(t,o.$(".monaco-tl-contents")),a=this.renderer.renderTemplate(s);return{container:e,indent:n,twistie:r,
indentGuidesDisposable:i.Disposable.None,templateData:a}},e.prototype.renderElement=function(t,i,n,o){"number"==typeof o&&(this.renderedNodes.set(t,{templateData:n,height:o}),this.renderedElements.set(t.element,t));var r=e.DefaultIndent+(t.depth-1)*this.indent;n.twistie.style.marginLeft=r+"px",n.indent.style.width=r+this.indent-16+"px",this.renderTwistie(t,n),"number"==typeof o&&this.renderIndentGuides(t,n),this.renderer.renderElement(t,i,n.templateData,o)},e.prototype.disposeElement=function(e,t,i,n){i.indentGuidesDisposable.dispose(),this.renderer.disposeElement&&this.renderer.disposeElement(e,t,i.templateData,n),"number"==typeof n&&(this.renderedNodes.delete(e),this.renderedElements.delete(e.element))},e.prototype.disposeTemplate=function(e){this.renderer.disposeTemplate(e.templateData)},e.prototype.onDidChangeTwistieState=function(e){var t=this.renderedElements.get(e);t&&this.onDidChangeNodeTwistieState(t)},e.prototype.onDidChangeNodeTwistieState=function(e){var t=this.renderedNodes.get(e)
;t&&(this.renderTwistie(e,t.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(e,t.templateData))},e.prototype.renderTwistie=function(e,t){this.renderer.renderTwistie&&this.renderer.renderTwistie(e.element,t.twistie),o.toggleClass(t.twistie,"collapsible",e.collapsible),o.toggleClass(t.twistie,"collapsed",e.collapsible&&e.collapsed),e.collapsible?t.container.setAttribute("aria-expanded",String(!e.collapsed)):t.container.removeAttribute("aria-expanded")},e.prototype.renderIndentGuides=function(e,t){var n=this;if(o.clearNode(t.indent),t.indentGuidesDisposable.dispose(),this._renderIndentGuides!==D.None){for(var r=new i.DisposableStore,s=e,a=function(){var e=s.parent,a=o.$(".indent-guide",{style:"width: "+l.indent+"px"});l.activeIndentNodes.has(e)&&o.addClass(a,"active"),0===t.indent.childElementCount?t.indent.appendChild(a):t.indent.insertBefore(a,t.indent.firstElementChild),l.renderedIndentGuides.add(e,a),r.add(i.toDisposable(function(){
return n.renderedIndentGuides.delete(e,a)})),s=e},l=this;s.parent&&s.parent.parent;)a();t.indentGuidesDisposable=r}},e.prototype._onDidChangeActiveNodes=function(e){var t=this;if(this._renderIndentGuides!==D.None){var i=new Set;e.forEach(function(e){e.collapsible&&e.children.length>0&&!e.collapsed?i.add(e):e.parent&&i.add(e.parent)}),this.activeIndentNodes.forEach(function(e){i.has(e)||t.renderedIndentGuides.forEach(e,function(e){return o.removeClass(e,"active")})}),i.forEach(function(e){t.activeIndentNodes.has(e)||t.renderedIndentGuides.forEach(e,function(e){return o.addClass(e,"active")})}),this.activeIndentNodes=i}},e.prototype.dispose=function(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),this.disposables=i.dispose(this.disposables)},e.DefaultIndent=8,e}(),M=function(){function e(e,t,i){this.tree=e,this.keyboardNavigationLabelProvider=t,this._filter=i,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=[],
e.onWillRefilter(this.reset,this,this.disposables)}return Object.defineProperty(e.prototype,"totalCount",{get:function(){return this._totalCount},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchCount",{get:function(){return this._matchCount},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"pattern",{set:function(e){this._pattern=e,this._lowercasePattern=e.toLowerCase()},enumerable:!0,configurable:!0}),e.prototype.filter=function(e,t){if(this._filter){var i=this._filter.filter(e,t);if(this.tree.options.simpleKeyboardNavigation)return i;if(0===("boolean"==typeof i?i?1:0:f.isFilterResult(i)?f.getVisibleState(i.visibility):i))return!1}if(this._totalCount++,this.tree.options.simpleKeyboardNavigation||!this._pattern)return this._matchCount++,{data:p.FuzzyScore.Default,visibility:!0};var n=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(e),o=n&&n.toString();if(void 0===o)return{data:p.FuzzyScore.Default,visibility:!0}
;var r=p.fuzzyScore(this._pattern,this._lowercasePattern,0,o,o.toLowerCase(),0,!0);return r?(this._matchCount++,{data:r,visibility:!0}):this.tree.options.filterOnType?2:{data:p.FuzzyScore.Default,visibility:!0}},e.prototype.reset=function(){this._totalCount=0,this._matchCount=0},e.prototype.dispose=function(){this.disposables=i.dispose(this.disposables)},e}(),k=function(){function e(e,t,i,n,r){this.tree=e,this.view=i,this.filter=n,this.keyboardNavigationLabelProvider=r,this._enabled=!1,this._pattern="",this._empty=!1,this._onDidChangeEmptyState=new a.Emitter,this.positionClassName="ne",this.automaticKeyboardNavigation=!0,this.triggered=!1,this._onDidChangePattern=new a.Emitter,this.enabledDisposables=[],this.disposables=[],this.domNode=o.$(".monaco-list-type-filter."+this.positionClassName),this.domNode.draggable=!0,h.domEvent(this.domNode,"dragstart")(this.onDragStart,this,this.disposables),this.messageDomNode=o.append(i.getHTMLElement(),o.$(".monaco-list-type-filter-message")),
this.labelDomNode=o.append(this.domNode,o.$("span.label"));var s=o.append(this.domNode,o.$(".controls"));this._filterOnType=!!e.options.filterOnType,this.filterOnTypeDomNode=o.append(s,o.$("input.filter")),this.filterOnTypeDomNode.type="checkbox",this.filterOnTypeDomNode.checked=this._filterOnType,this.filterOnTypeDomNode.tabIndex=-1,this.updateFilterOnTypeTitle(),h.domEvent(this.filterOnTypeDomNode,"input")(this.onDidChangeFilterOnType,this,this.disposables),this.clearDomNode=o.append(s,o.$("button.clear")),this.clearDomNode.tabIndex=-1,this.clearDomNode.title=g.localize(0,null),this.keyboardNavigationEventFilter=e.options.keyboardNavigationEventFilter,t.onDidSplice(this.onDidSpliceModel,this,this.disposables),this.updateOptions(e.options)}return Object.defineProperty(e.prototype,"enabled",{get:function(){return this._enabled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"pattern",{get:function(){return this._pattern},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"filterOnType",{get:function(){return this._filterOnType},enumerable:!0,configurable:!0}),e.prototype.updateOptions=function(e){e.simpleKeyboardNavigation?this.disable():this.enable(),void 0!==e.filterOnType&&(this._filterOnType=!!e.filterOnType,this.filterOnTypeDomNode.checked=this._filterOnType),void 0!==e.automaticKeyboardNavigation&&(this.automaticKeyboardNavigation=e.automaticKeyboardNavigation),this.tree.refilter(),this.render(),this.automaticKeyboardNavigation||this.onEventOrInput("")},e.prototype.enable=function(){var e=this;if(!this._enabled){var t=this.keyboardNavigationLabelProvider.mightProducePrintableCharacter?function(t){return e.keyboardNavigationLabelProvider.mightProducePrintableCharacter(t)}:function(e){return n.mightProducePrintableCharacter(e)},i=a.Event.chain(h.domEvent(this.view.getHTMLElement(),"keydown")).filter(function(t){return!S(t.target)||t.target===e.filterOnTypeDomNode}).map(function(e){return new l.StandardKeyboardEvent(e)
}).filter(this.keyboardNavigationEventFilter||function(){return!0}).filter(function(){return e.automaticKeyboardNavigation||e.triggered}).filter(function(i){return t(i)||(e.pattern.length>0||e.triggered)&&(9===i.keyCode||1===i.keyCode)&&!i.altKey&&!i.ctrlKey&&!i.metaKey||1===i.keyCode&&(v.isMacintosh?i.altKey&&!i.metaKey:i.ctrlKey)&&!i.shiftKey}).forEach(function(e){e.stopPropagation(),e.preventDefault()}).event,o=h.domEvent(this.clearDomNode,"click");a.Event.chain(a.Event.any(i,o)).event(this.onEventOrInput,this,this.enabledDisposables),this.filter.pattern="",this.tree.refilter(),this.render(),this._enabled=!0,this.triggered=!1}},e.prototype.disable=function(){this._enabled&&(this.domNode.remove(),this.enabledDisposables=i.dispose(this.enabledDisposables),this.tree.refilter(),this.render(),this._enabled=!1,this.triggered=!1)},e.prototype.onEventOrInput=function(e){
"string"==typeof e?this.onInput(e):e instanceof MouseEvent||9===e.keyCode||1===e.keyCode&&(v.isMacintosh?e.altKey:e.ctrlKey)?this.onInput(""):1===e.keyCode?this.onInput(0===this.pattern.length?"":this.pattern.substr(0,this.pattern.length-1)):this.onInput(this.pattern+e.browserEvent.key)},e.prototype.onInput=function(e){var t=this.view.getHTMLElement();e&&!this.domNode.parentElement?t.append(this.domNode):!e&&this.domNode.parentElement&&(this.domNode.remove(),this.tree.domFocus()),this._pattern=e,this._onDidChangePattern.fire(e),this.filter.pattern=e,this.tree.refilter(),e&&this.tree.focusNext(0,!0,void 0,function(e){return!p.FuzzyScore.isDefault(e.filterData)});var i=this.tree.getFocus();if(i.length>0){var n=i[0];null===this.tree.getRelativeTop(n)&&this.tree.reveal(n,.5)}this.render(),e||(this.triggered=!1)},e.prototype.onDragStart=function(){var e=this,t=this.view.getHTMLElement(),n=o.getDomNodePagePosition(t).left,r=t.clientWidth,s=r/2,a=this.domNode.clientWidth,l=[],d=this.positionClassName,c=function(){
switch(d){case"nw":e.domNode.style.top="4px",e.domNode.style.left="4px";break;case"ne":e.domNode.style.top="4px",e.domNode.style.left=r-a-6+"px"}};c(),o.removeClass(this.domNode,d),o.addClass(this.domNode,"dragging"),l.push(i.toDisposable(function(){return o.removeClass(e.domNode,"dragging")})),h.domEvent(document,"dragover")(function(e){e.preventDefault();var t=e.screenX-n;e.dataTransfer&&(e.dataTransfer.dropEffect="none"),d=t<s?"nw":"ne",c()},null,l),h.domEvent(this.domNode,"dragend")(function(){e.positionClassName=d,e.domNode.className="monaco-list-type-filter "+e.positionClassName,e.domNode.style.top=null,e.domNode.style.left=null,i.dispose(l)},null,l),u.StaticDND.CurrentDragAndDropData=new u.DragAndDropData("vscode-ui"),l.push(i.toDisposable(function(){return u.StaticDND.CurrentDragAndDropData=void 0}))},e.prototype.onDidSpliceModel=function(){this._enabled&&0!==this.pattern.length&&(this.tree.refilter(),this.render())},e.prototype.onDidChangeFilterOnType=function(){this.tree.updateOptions({
filterOnType:this.filterOnTypeDomNode.checked}),this.tree.refilter(),this.tree.domFocus(),this.render(),this.updateFilterOnTypeTitle()},e.prototype.updateFilterOnTypeTitle=function(){this.filterOnType?this.filterOnTypeDomNode.title=g.localize(1,null):this.filterOnTypeDomNode.title=g.localize(2,null)},e.prototype.render=function(){var e=this.filter.totalCount>0&&0===this.filter.matchCount;this.pattern&&this.tree.options.filterOnType&&e?(this.messageDomNode.textContent=g.localize(3,null),this._empty=!0):(this.messageDomNode.innerHTML="",this._empty=!1),o.toggleClass(this.domNode,"no-matches",e),this.domNode.title=g.localize(4,null,this.filter.matchCount,this.filter.totalCount),this.labelDomNode.textContent=this.pattern.length>16?"…"+this.pattern.substr(this.pattern.length-16):this.pattern,this._onDidChangeEmptyState.fire(this._empty)},e.prototype.shouldAllowFocus=function(e){
return!(this.enabled&&this.pattern&&!this.filterOnType)||(this.filter.totalCount>0&&this.filter.matchCount<=1||!p.FuzzyScore.isDefault(e.filterData))},e.prototype.dispose=function(){this.disable(),this._onDidChangePattern.dispose(),this.disposables=i.dispose(this.disposables)},e}(),T=function(){function e(e){this.identityProvider=e,this.nodes=[],this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event}return Object.defineProperty(e.prototype,"nodeSet",{get:function(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet},enumerable:!0,configurable:!0}),e.prototype.set=function(e,t){d.equals(this.nodes,e)||this._set(e,!1,t)},e.prototype._set=function(e,t,i){if(this.nodes=e.slice(),this.elements=void 0,this._nodeSet=void 0,!t){var n=this;this._onDidChange.fire({get elements(){return n.get()},browserEvent:i})}},e.prototype.get=function(){return this.elements||(this.elements=this.nodes.map(function(e){return e.element})),this.elements.slice()},e.prototype.getNodes=function(){
return this.nodes},e.prototype.has=function(e){return this.nodeSet.has(e)},e.prototype.onDidModelSplice=function(e){var t=this,i=e.insertedNodes,n=e.deletedNodes;if(!this.identityProvider){var o=this.createNodeSet(),r=function(e){return o.delete(e)};return n.forEach(function(e){return E(e,r)}),void this.set(_.values(o))}var s=new Set,a=function(e){return s.add(t.identityProvider.getId(e.element).toString())};n.forEach(function(e){return E(e,a)});var l=new Map,u=function(e){return l.set(t.identityProvider.getId(e.element).toString(),e)};i.forEach(function(e){return E(e,u)});for(var d=[],c=!0,h=0,p=this.nodes;h<p.length;h++){var f=p[h],g=this.identityProvider.getId(f.element).toString();if(s.has(g)){var m=l.get(g);m?d.push(m):c=!1}else d.push(f)}this._set(d,c)},e.prototype.createNodeSet=function(){for(var e=new Set,t=0,i=this.nodes;t<i.length;t++){var n=i[t];e.add(n)}return e},e}(),R=function(e){function t(t,i){var n=e.call(this,t)||this;return n.tree=i,n}return r(t,e),t.prototype.onPointer=function(t){
if(!S(t.browserEvent.target)){var i=t.element;if(!i)return e.prototype.onPointer.call(this,t);if(this.isSelectionRangeChangeEvent(t)||this.isSelectionSingleChangeEvent(t))return e.prototype.onPointer.call(this,t);var n=o.hasClass(t.browserEvent.target,"monaco-tl-twistie");if(!this.tree.openOnSingleClick&&2!==t.browserEvent.detail&&!n)return e.prototype.onPointer.call(this,t);var r=!1;if((r="function"==typeof this.tree.expandOnlyOnTwistieClick?this.tree.expandOnlyOnTwistieClick(i.element):!!this.tree.expandOnlyOnTwistieClick)&&!n)return e.prototype.onPointer.call(this,t);var s=this.tree.model,a=s.getNodeLocation(i),l=t.browserEvent.altKey;s.setCollapsed(a,void 0,l),r&&n||e.prototype.onPointer.call(this,t)}},t.prototype.onDoubleClick=function(t){o.hasClass(t.browserEvent.target,"monaco-tl-twistie")||e.prototype.onDoubleClick.call(this,t)},t}(n.MouseController),O=function(e){function t(t,i,n,o,r,s){var a=e.call(this,t,i,n,s)||this;return a.focusTrait=o,a.selectionTrait=r,a}return r(t,e),
t.prototype.createMouseController=function(e){return new R(this,e.tree)},t.prototype.splice=function(t,i,n){var o=this;if(void 0===n&&(n=[]),e.prototype.splice.call(this,t,i,n),0!==n.length){var r=[],s=[];n.forEach(function(e,i){o.focusTrait.has(e)&&r.push(t+i),o.selectionTrait.has(e)&&s.push(t+i)}),r.length>0&&e.prototype.setFocus.call(this,d.distinctES6(e.prototype.getFocus.call(this).concat(r))),s.length>0&&e.prototype.setSelection.call(this,d.distinctES6(e.prototype.getSelection.call(this).concat(s)))}},t.prototype.setFocus=function(t,i,n){var o=this;void 0===n&&(n=!1),e.prototype.setFocus.call(this,t,i),n||this.focusTrait.set(t.map(function(e){return o.element(e)}),i)},t.prototype.setSelection=function(t,i,n){var o=this;void 0===n&&(n=!1),e.prototype.setSelection.call(this,t,i),n||this.selectionTrait.set(t.map(function(e){return o.element(e)}),i)},t}(n.List),P=function(){function e(e,t,i,n){var r,u=this;void 0===n&&(n={}),this._options=n,this.eventBufferer=new a.EventBufferer,this.disposables=[],
this._onWillRefilter=new a.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new a.Emitter;var d=new x(t),c=new a.Relay,h=new a.Relay,p=new I(h.event);this.disposables.push(p),this.renderers=i.map(function(e){return new N(e,c.event,p,n)}),(r=this.disposables).push.apply(r,this.renderers);var f;if(n.keyboardNavigationLabelProvider&&(f=new M(this,n.keyboardNavigationLabelProvider,n.filter),n=s({},n,{filter:f}),this.disposables.push(f)),this.focus=new T(n.identityProvider),this.selection=new T(n.identityProvider),this.view=new O(e,d,this.renderers,this.focus,this.selection,s({},function(e,t){return t&&s({},t,{identityProvider:t.identityProvider&&{getId:function(e){return t.identityProvider.getId(e.element)}},dnd:t.dnd&&new L(e,t.dnd),multipleSelectionController:t.multipleSelectionController&&{isSelectionSingleChangeEvent:function(e){return t.multipleSelectionController.isSelectionSingleChangeEvent(s({},e,{element:e.element}))},isSelectionRangeChangeEvent:function(e){
return t.multipleSelectionController.isSelectionRangeChangeEvent(s({},e,{element:e.element}))}},accessibilityProvider:t.accessibilityProvider&&{getAriaLabel:function(e){return t.accessibilityProvider.getAriaLabel(e.element)},getAriaLevel:function(e){return e.depth}},keyboardNavigationLabelProvider:t.keyboardNavigationLabelProvider&&s({},t.keyboardNavigationLabelProvider,{getKeyboardNavigationLabel:function(e){return t.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(e.element)}}),enableKeyboardNavigation:t.simpleKeyboardNavigation,ariaProvider:{getSetSize:function(e){return e.parent.visibleChildrenCount},getPosInSet:function(e){return e.visibleChildIndex+1}}})}(function(){return u.model},n),{tree:this})),this.model=this.createModel(this.view,n),c.input=this.model.onDidChangeCollapseState,this.model.onDidSplice(function(e){u.focus.onDidModelSplice(e),u.selection.onDidModelSplice(e)},null,this.disposables),
h.input=a.Event.map(a.Event.any(this.focus.onDidChange,this.selection.onDidChange,this.model.onDidSplice),function(){return u.focus.getNodes().concat(u.selection.getNodes())}),!1!==n.keyboardSupport){var g=a.Event.chain(this.view.onKeyDown).filter(function(e){return!S(e.target)}).map(function(e){return new l.StandardKeyboardEvent(e)});g.filter(function(e){return 15===e.keyCode}).on(this.onLeftArrow,this,this.disposables),g.filter(function(e){return 17===e.keyCode}).on(this.onRightArrow,this,this.disposables),g.filter(function(e){return 10===e.keyCode}).on(this.onSpace,this,this.disposables)}n.keyboardNavigationLabelProvider&&(this.typeFilterController=new k(this,this.model,this.view,f,n.keyboardNavigationLabelProvider),this.focusNavigationFilter=function(e){return u.typeFilterController.shouldAllowFocus(e)},this.disposables.push(this.typeFilterController)),this.styleElement=o.createStyleSheet(this.view.getHTMLElement()),o.toggleClass(this.getHTMLElement(),"always",this._options.renderIndentGuides===D.Always)}
return Object.defineProperty(e.prototype,"onDidChangeFocus",{get:function(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidChangeSelection",{get:function(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidOpen",{get:function(){return a.Event.map(this.view.onDidOpen,w)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidFocus",{get:function(){return this.view.onDidFocus},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidChangeCollapseState",{get:function(){return this.model.onDidChangeCollapseState},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"openOnSingleClick",{get:function(){return void 0===this._options.openOnSingleClick||this._options.openOnSingleClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"expandOnlyOnTwistieClick",{get:function(){
return void 0!==this._options.expandOnlyOnTwistieClick&&this._options.expandOnlyOnTwistieClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidDispose",{get:function(){return this.view.onDidDispose},enumerable:!0,configurable:!0}),e.prototype.updateOptions=function(e){void 0===e&&(e={}),this._options=s({},this._options,e);for(var t=0,i=this.renderers;t<i.length;t++){i[t].updateOptions(e)}this.view.updateOptions({enableKeyboardNavigation:this._options.simpleKeyboardNavigation,automaticKeyboardNavigation:this._options.automaticKeyboardNavigation}),this.typeFilterController&&this.typeFilterController.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),o.toggleClass(this.getHTMLElement(),"always",this._options.renderIndentGuides===D.Always)},Object.defineProperty(e.prototype,"options",{get:function(){return this._options},enumerable:!0,configurable:!0}),e.prototype.getHTMLElement=function(){return this.view.getHTMLElement()},
Object.defineProperty(e.prototype,"scrollTop",{get:function(){return this.view.scrollTop},set:function(e){this.view.scrollTop=e},enumerable:!0,configurable:!0}),e.prototype.domFocus=function(){this.view.domFocus()},e.prototype.layout=function(e,t){this.view.layout(e,t)},e.prototype.style=function(e){var t="."+this.view.domId,i=[];e.treeIndentGuidesStroke&&(i.push(".monaco-list"+t+":hover .monaco-tl-indent > .indent-guide, .monaco-list"+t+".always .monaco-tl-indent > .indent-guide  { border-color: "+e.treeIndentGuidesStroke.transparent(.4)+"; }"),i.push(".monaco-list"+t+" .monaco-tl-indent > .indent-guide.active { border-color: "+e.treeIndentGuidesStroke+"; }"));var n=i.join("\n");n!==this.styleElement.innerHTML&&(this.styleElement.innerHTML=n),this.view.style(e)},e.prototype.getNode=function(e){return this.model.getNode(e)},e.prototype.collapse=function(e,t){return void 0===t&&(t=!1),this.model.setCollapsed(e,!0,t)},e.prototype.expand=function(e,t){return void 0===t&&(t=!1),this.model.setCollapsed(e,!1,t)},
e.prototype.isCollapsed=function(e){return this.model.isCollapsed(e)},e.prototype.refilter=function(){this._onWillRefilter.fire(void 0),this.model.refilter()},e.prototype.setSelection=function(e,t){var i=this,n=e.map(function(e){return i.model.getNode(e)});this.selection.set(n,t);var o=e.map(function(e){return i.model.getListIndex(e)}).filter(function(e){return e>-1});this.view.setSelection(o,t,!0)},e.prototype.getSelection=function(){return this.selection.get()},e.prototype.setFocus=function(e,t){var i=this,n=e.map(function(e){return i.model.getNode(e)});this.focus.set(n,t);var o=e.map(function(e){return i.model.getListIndex(e)}).filter(function(e){return e>-1});this.view.setFocus(o,t,!0)},e.prototype.focusNext=function(e,t,i,n){void 0===e&&(e=1),void 0===t&&(t=!1),void 0===n&&(n=this.focusNavigationFilter),this.view.focusNext(e,t,i,n)},e.prototype.getFocus=function(){return this.focus.get()},e.prototype.reveal=function(e,t){this.model.expandTo(e);var i=this.model.getListIndex(e)
;-1!==i&&this.view.reveal(i,t)},e.prototype.getRelativeTop=function(e){var t=this.model.getListIndex(e);return-1===t?null:this.view.getRelativeTop(t)},e.prototype.onLeftArrow=function(e){e.preventDefault(),e.stopPropagation();var t=this.view.getFocusedElements();if(0!==t.length){var i=t[0],n=this.model.getNodeLocation(i);if(!this.model.setCollapsed(n,!0)){var o=this.model.getParentNodeLocation(n);if(null===o)return;var r=this.model.getListIndex(o);this.view.reveal(r),this.view.setFocus([r])}}},e.prototype.onRightArrow=function(e){e.preventDefault(),e.stopPropagation();var t=this.view.getFocusedElements();if(0!==t.length){var i=t[0],n=this.model.getNodeLocation(i);if(!this.model.setCollapsed(n,!1)){if(!i.children.some(function(e){return e.visible}))return;var o=this.view.getFocus()[0]+1;this.view.reveal(o),this.view.setFocus([o])}}},e.prototype.onSpace=function(e){e.preventDefault(),e.stopPropagation();var t=this.view.getFocusedElements();if(0!==t.length){
var i=t[0],n=this.model.getNodeLocation(i),o=e.browserEvent.altKey;this.model.setCollapsed(n,void 0,o)}},e.prototype.dispose=function(){this.disposables=i.dispose(this.disposables),this.view.dispose()},e}();t.AbstractTree=P}),define(t[294],i([1,0,121,220]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t,i,n,o,r){void 0===r&&(r={});var s=e.call(this,t,i,n,r)||this;return s.dataSource=o,s.identityProvider=r.identityProvider,s}return r(t,e),t.prototype.createModel=function(e,t){return new n.ObjectTreeModel(e,t)},t}(i.AbstractTree);t.DataTree=o}),define(t[183],i([1,0,121,220]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t,i,n,o){return void 0===o&&(o={}),e.call(this,t,i,n,o)||this}return r(t,e),Object.defineProperty(t.prototype,"onDidChangeCollapseState",{get:function(){return this.model.onDidChangeCollapseState},enumerable:!0,configurable:!0}),t.prototype.setChildren=function(e,t){
return this.model.setChildren(e,t)},t.prototype.rerender=function(e){void 0!==e?this.model.rerender(e):this.view.rerender()},t.prototype.createModel=function(e,t){return new n.ObjectTreeModel(e,t)},t}(i.AbstractTree);t.ObjectTree=o}),define(t[296],i([1,0,121,183,2,4,15,62,152,10,8,41]),function(e,t,i,n,o,r,u,d,c,h,p,f){"use strict";function g(e){return s({},e,{children:[],loading:!1,stale:!0,slow:!1,collapsedByDefault:void 0})}function m(e,t){return!!t.parent&&(t.parent===e||m(e,t.parent))}function v(e){return{browserEvent:e.browserEvent,elements:e.elements.map(function(e){return e.element})}}function _(e){if(e instanceof c.ElementsDragAndDropData){var t=e.elements;return new c.ElementsDragAndDropData(t.map(function(e){return e.element}))}return e}function y(e,t){var i;return i=!(t&&t.viewState.expanded&&e.id&&t.viewState.expanded.indexOf(e.id)>-1)&&e.collapsedByDefault,e.collapsedByDefault=void 0,{element:e,children:e.hasChildren?d.Iterator.map(d.Iterator.fromArray(e.children),function(e){return y(e,t)}):[],
collapsible:e.hasChildren,collapsed:i}}function b(e,t){t(e),e.children.forEach(function(e){return b(e,t)})}Object.defineProperty(t,"__esModule",{value:!0});var C,S=function(){function e(e){this.node=e}return Object.defineProperty(e.prototype,"element",{get:function(){return this.node.element.element},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parent",{get:function(){return this.node.parent&&new e(this.node.parent)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"children",{get:function(){return this.node.children.map(function(t){return new e(t)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"depth",{get:function(){return this.node.depth},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"visibleChildrenCount",{get:function(){return this.node.visibleChildrenCount},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"visibleChildIndex",{get:function(){return this.node.visibleChildIndex},enumerable:!0,configurable:!0
}),Object.defineProperty(e.prototype,"collapsible",{get:function(){return this.node.collapsible},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"collapsed",{get:function(){return this.node.collapsed},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"visible",{get:function(){return this.node.visible},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filterData",{get:function(){return this.node.filterData},enumerable:!0,configurable:!0}),e}(),w=function(){function e(e,t){this.renderer=e,this.onDidChangeTwistieState=t,this.renderedNodes=new Map,this.disposables=[],this.templateId=e.templateId}return e.prototype.renderTemplate=function(e){return{templateData:this.renderer.renderTemplate(e)}},e.prototype.renderElement=function(e,t,i,n){this.renderer.renderElement(new S(e),t,i.templateData,n)},e.prototype.renderTwistie=function(e,t){return p.toggleClass(t,"loading",e.slow),!1},e.prototype.disposeElement=function(e,t,i,n){
this.renderer.disposeElement&&this.renderer.disposeElement(new S(e),t,i.templateData,n)},e.prototype.disposeTemplate=function(e){this.renderer.disposeTemplate(e.templateData)},e.prototype.dispose=function(){this.renderedNodes.clear(),this.disposables=o.dispose(this.disposables)},e}();!function(e){e[e.Refresh=0]="Refresh",e[e.Expand=1]="Expand"}(C=t.ChildrenResolutionReason||(t.ChildrenResolutionReason={}));var E=function(){function e(e){this.dnd=e}return e.prototype.getDragURI=function(e){return this.dnd.getDragURI(e.element)},e.prototype.getDragLabel=function(e){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(e.map(function(e){return e.element}))},e.prototype.onDragStart=function(e,t){this.dnd.onDragStart&&this.dnd.onDragStart(_(e),t)},e.prototype.onDragOver=function(e,t,i,n,o){return void 0===o&&(o=!0),this.dnd.onDragOver(_(e),t&&t.element,i,n)},e.prototype.drop=function(e,t,i,n){this.dnd.drop(_(e),t&&t.element,i,n)},e}(),L=function(){function e(e,t,o,a,l){var u=this;void 0===l&&(l={}),
this.dataSource=a,this.nodes=new Map,this.subTreeRefreshPromises=new Map,this.refreshPromises=new Map,this._onDidRender=new r.Emitter,this._onDidChangeNodeSlowState=new r.Emitter,this.disposables=[],this.identityProvider=l.identityProvider,this.autoExpandSingleChildren=void 0!==l.autoExpandSingleChildren&&l.autoExpandSingleChildren,this.sorter=l.sorter,this.collapseByDefault=l.collapseByDefault;var d=new i.ComposedTreeDelegate(t),c=o.map(function(e){return new w(e,u._onDidChangeNodeSlowState.event)}),h=function(e){return e&&s({},e,{collapseByDefault:!0,identityProvider:e.identityProvider&&{getId:function(t){return e.identityProvider.getId(t.element)}},dnd:e.dnd&&new E(e.dnd),multipleSelectionController:e.multipleSelectionController&&{isSelectionSingleChangeEvent:function(t){return e.multipleSelectionController.isSelectionSingleChangeEvent(s({},t,{element:t.element}))},isSelectionRangeChangeEvent:function(t){return e.multipleSelectionController.isSelectionRangeChangeEvent(s({},t,{element:t.element}))}},
accessibilityProvider:e.accessibilityProvider&&{getAriaLabel:function(t){return e.accessibilityProvider.getAriaLabel(t.element)}},filter:e.filter&&{filter:function(t,i){return e.filter.filter(t.element,i)}},keyboardNavigationLabelProvider:e.keyboardNavigationLabelProvider&&s({},e.keyboardNavigationLabelProvider,{getKeyboardNavigationLabel:function(t){return e.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(t.element)}}),sorter:void 0,expandOnlyOnTwistieClick:void 0===e.expandOnlyOnTwistieClick?void 0:"function"!=typeof e.expandOnlyOnTwistieClick?e.expandOnlyOnTwistieClick:function(t){return e.expandOnlyOnTwistieClick(t.element)},ariaProvider:void 0,additionalScrollHeight:e.additionalScrollHeight})}(l)||{};this.tree=new n.ObjectTree(e,d,c,h),this.root=g({element:void 0,parent:null,hasChildren:!0}),this.identityProvider&&(this.root=s({},this.root,{id:null})),this.nodes.set(null,this.root),this.tree.onDidChangeCollapseState(this._onDidChangeCollapseState,this,this.disposables)}
return Object.defineProperty(e.prototype,"onDidChangeFocus",{get:function(){return r.Event.map(this.tree.onDidChangeFocus,v)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidChangeSelection",{get:function(){return r.Event.map(this.tree.onDidChangeSelection,v)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidOpen",{get:function(){return r.Event.map(this.tree.onDidOpen,v)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidFocus",{get:function(){return this.tree.onDidFocus},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidDispose",{get:function(){return this.tree.onDidDispose},enumerable:!0,configurable:!0}),e.prototype.updateOptions=function(e){void 0===e&&(e={}),this.tree.updateOptions(e)},e.prototype.getHTMLElement=function(){return this.tree.getHTMLElement()},Object.defineProperty(e.prototype,"scrollTop",{get:function(){return this.tree.scrollTop},set:function(e){this.tree.scrollTop=e},enumerable:!0,configurable:!0
}),e.prototype.domFocus=function(){this.tree.domFocus()},e.prototype.layout=function(e,t){this.tree.layout(e,t)},e.prototype.style=function(e){this.tree.style(e)},e.prototype.getInput=function(){return this.root.element},e.prototype.setInput=function(e,t){return a(this,void 0,void 0,function(){var i;return l(this,function(n){switch(n.label){case 0:return this.refreshPromises.forEach(function(e){return e.cancel()}),this.refreshPromises.clear(),this.root.element=e,i=t&&{viewState:t,focus:[],selection:[]},[4,this.updateChildren(e,!0,i)];case 1:return n.sent(),i&&(this.tree.setFocus(i.focus),this.tree.setSelection(i.selection)),t&&"number"==typeof t.scrollTop&&(this.scrollTop=t.scrollTop),[2]}})})},e.prototype.updateChildren=function(e,t,i){return void 0===e&&(e=this.root.element),void 0===t&&(t=!0),a(this,void 0,void 0,function(){return l(this,function(n){switch(n.label){case 0:if(void 0===this.root.element)throw new Error("Tree input not set")
;return this.root.loading?[4,this.subTreeRefreshPromises.get(this.root)]:[3,3];case 1:return n.sent(),[4,r.Event.toPromise(this._onDidRender.event)];case 2:n.sent(),n.label=3;case 3:return[4,this.refreshAndRenderNode(this.getDataNode(e),t,C.Refresh,i)];case 4:return n.sent(),[2]}})})},e.prototype.rerender=function(e){if(void 0!==e&&e!==this.root.element){var t=this.getDataNode(e);this.tree.rerender(t)}else this.tree.rerender()},e.prototype.collapse=function(e,t){void 0===t&&(t=!1);var i=this.getDataNode(e);return this.tree.collapse(i===this.root?null:i,t)},e.prototype.expand=function(e,t){return void 0===t&&(t=!1),a(this,void 0,void 0,function(){var i,n;return l(this,function(o){switch(o.label){case 0:if(void 0===this.root.element)throw new Error("Tree input not set");return this.root.loading?[4,this.subTreeRefreshPromises.get(this.root)]:[3,3];case 1:return o.sent(),[4,r.Event.toPromise(this._onDidRender.event)];case 2:o.sent(),o.label=3;case 3:
return(i=this.getDataNode(e))===this.root||i.loading||this.tree.isCollapsed(i)?(n=this.tree.expand(i===this.root?null:i,t),i.loading?[4,this.subTreeRefreshPromises.get(i)]:[3,6]):[2,!1];case 4:return o.sent(),[4,r.Event.toPromise(this._onDidRender.event)];case 5:o.sent(),o.label=6;case 6:return[2,n]}})})},e.prototype.setSelection=function(e,t){var i=this,n=e.map(function(e){return i.getDataNode(e)});this.tree.setSelection(n,t)},e.prototype.getSelection=function(){return this.tree.getSelection().map(function(e){return e.element})},e.prototype.setFocus=function(e,t){var i=this,n=e.map(function(e){return i.getDataNode(e)});this.tree.setFocus(n,t)},e.prototype.getFocus=function(){return this.tree.getFocus().map(function(e){return e.element})},e.prototype.reveal=function(e,t){this.tree.reveal(this.getDataNode(e),t)},e.prototype.getDataNode=function(e){var t=this.nodes.get(e===this.root.element?null:e);if(!t)throw new Error("Data tree node not found: "+e);return t},
e.prototype.refreshAndRenderNode=function(e,t,i,n){return a(this,void 0,void 0,function(){var o,r;return l(this,function(s){switch(s.label){case 0:return[4,this.refreshNode(e,t,n)];case 1:return s.sent(),this.render(e,n),e!==this.root&&this.autoExpandSingleChildren&&i===C.Expand?(o=this.tree.getNode(e),1!==(r=o.children.filter(function(e){return e.visible})).length?[3,3]:[4,this.tree.expand(r[0].element,!1)]):[3,3];case 2:s.sent(),s.label=3;case 3:return[2]}})})},e.prototype.refreshNode=function(e,t,i){return a(this,void 0,void 0,function(){var n,o=this;return l(this,function(r){switch(r.label){case 0:if(this.subTreeRefreshPromises.forEach(function(r,s){!n&&function(e,t){return e===t||m(e,t)||m(t,e)}(s,e)&&(n=r.then(function(){return o.refreshNode(e,t,i)}))}),n)return[2,n];n=this.doRefreshSubTree(e,t,i),this.subTreeRefreshPromises.set(e,n),r.label=1;case 1:return r.trys.push([1,,3,4]),[4,n];case 2:return r.sent(),[3,4];case 3:return this.subTreeRefreshPromises.delete(e),[7];case 4:return[2]}})})},
e.prototype.doRefreshSubTree=function(e,t,i){return a(this,void 0,void 0,function(){var n,o=this;return l(this,function(r){switch(r.label){case 0:e.loading=!0,r.label=1;case 1:return r.trys.push([1,,4,5]),[4,this.doRefreshNode(e,t,i)];case 2:return n=r.sent(),e.stale=!1,[4,Promise.all(n.map(function(e){return o.doRefreshSubTree(e,t,i)}))];case 3:return r.sent(),[3,5];case 4:return e.loading=!1,[7];case 5:return[2]}})})},e.prototype.doRefreshNode=function(e,t,i){return a(this,void 0,void 0,function(){var n,o,r,s,a=this;return l(this,function(l){switch(l.label){case 0:e.hasChildren=!!this.dataSource.hasChildren(e.element),e.hasChildren?((o=u.timeout(800)).then(function(){e.slow=!0,a._onDidChangeNodeSlowState.fire(e)},function(e){return null}),n=this.doGetChildren(e).finally(function(){return o.cancel()})):n=Promise.resolve([]),l.label=1;case 1:return l.trys.push([1,3,4,5]),[4,n];case 2:return r=l.sent(),[2,this.setChildren(e,r,t,i)];case 3:if(s=l.sent(),e!==this.root&&this.tree.collapse(e===this.root?null:e),
h.isPromiseCanceledError(s))return[2,[]];throw s;case 4:return e.slow&&(e.slow=!1,this._onDidChangeNodeSlowState.fire(e)),[7];case 5:return[2]}})})},e.prototype.doGetChildren=function(e){var t=this,i=this.refreshPromises.get(e);return i||(i=u.createCancelablePromise(function(){return a(t,void 0,void 0,function(){var t;return l(this,function(i){switch(i.label){case 0:return[4,this.dataSource.getChildren(e.element)];case 1:return t=i.sent(),this.sorter&&t.sort(this.sorter.compare.bind(this.sorter)),[2,t]}})})}),this.refreshPromises.set(e,i),i.finally(function(){return t.refreshPromises.delete(e)}))},e.prototype._onDidChangeCollapseState=function(e){var t=e.node,i=e.deep;!t.collapsed&&t.element.stale&&(i?this.collapse(t.element.element):this.refreshAndRenderNode(t.element,!1,C.Expand).catch(h.onUnexpectedError))},e.prototype.setChildren=function(e,t,i,n){var o,r=this;if(0===e.children.length&&0===t.length)return[];for(var s=new Map,a=new Map,l=0,u=e.children;l<u.length;l++){_=u[l];s.set(_.element,_),
this.identityProvider&&a.set(_.id,this.tree.getNode(_))}for(var d=[],c=t.map(function(t){var o=!!r.dataSource.hasChildren(t);if(!r.identityProvider){c=g({element:t,parent:e,hasChildren:o});return o&&r.collapseByDefault&&!r.collapseByDefault(t)&&(c.collapsedByDefault=!1,d.push(c)),c}var l=r.identityProvider.getId(t).toString(),u=a.get(l);if(u){var c=u.element;return s.delete(c.element),r.nodes.delete(c.element),r.nodes.set(t,c),c.element=t,c.hasChildren=o,i?u.collapsed?b(c,function(e){return e.stale=!0}):d.push(c):o&&r.collapseByDefault&&!r.collapseByDefault(t)&&(c.collapsedByDefault=!1,d.push(c)),c}var h=g({element:t,parent:e,id:l,hasChildren:o});return n&&n.viewState.focus&&n.viewState.focus.indexOf(l)>-1&&n.focus.push(h),n&&n.viewState.selection&&n.viewState.selection.indexOf(l)>-1&&n.selection.push(h),n&&n.viewState.expanded&&n.viewState.expanded.indexOf(l)>-1?d.push(h):o&&r.collapseByDefault&&!r.collapseByDefault(t)&&(h.collapsedByDefault=!1,d.push(h)),h}),h=0,p=f.values(s);h<p.length;h++){
b(p[h],function(e){return r.nodes.delete(e.element)})}for(var m=0,v=c;m<v.length;m++){var _=v[m];this.nodes.set(_.element,_)}return(o=e.children).splice.apply(o,[0,e.children.length].concat(c)),d},e.prototype.render=function(e,t){var i=e.children.map(function(e){return y(e,t)});this.tree.setChildren(e===this.root?null:e,i),this._onDidRender.fire()},e.prototype.dispose=function(){o.dispose(this.disposables)},e}();t.AsyncDataTree=L}),define(t[297],i([6,7]),function(e,t){return e.create("vs/base/common/keybindingLabels",t)}),define(t[184],i([1,0,297]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t,i){void 0===i&&(i=t),this.modifierLabels=[null],this.modifierLabels[2]=e,this.modifierLabels[1]=t,this.modifierLabels[3]=i}return e.prototype.toLabel=function(e,t,i){if(0===t.length)return null;for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=i(s);if(null===a)return null;n[o]=function(e,t,i){if(null===t)return"";var n=[]
;return e.ctrlKey&&n.push(i.ctrlKey),e.shiftKey&&n.push(i.shiftKey),e.altKey&&n.push(i.altKey),e.metaKey&&n.push(i.metaKey),n.push(t),n.join(i.separator)}(s,a,this.modifierLabels[e])}return n.join(" ")},e}();t.ModifierLabelProvider=n,t.UILabelProvider=new n({ctrlKey:"⌃",shiftKey:"⇧",altKey:"⌥",metaKey:"⌘",separator:""},{ctrlKey:i.localize(0,null),shiftKey:i.localize(1,null),altKey:i.localize(2,null),metaKey:i.localize(3,null),separator:"+"},{ctrlKey:i.localize(4,null),shiftKey:i.localize(5,null),altKey:i.localize(6,null),metaKey:i.localize(7,null),separator:"+"}),t.AriaLabelProvider=new n({ctrlKey:i.localize(8,null),shiftKey:i.localize(9,null),altKey:i.localize(10,null),metaKey:i.localize(11,null),separator:"+"},{ctrlKey:i.localize(12,null),shiftKey:i.localize(13,null),altKey:i.localize(14,null),metaKey:i.localize(15,null),separator:"+"},{ctrlKey:i.localize(16,null),shiftKey:i.localize(17,null),altKey:i.localize(18,null),metaKey:i.localize(19,null),separator:"+"})}),
define(t[299],i([1,0,29,184,8,287,404]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=o.$,a=function(){function e(e,t,i){this.os=t,this.options=i,this.domNode=o.append(e,s(".monaco-keybinding")),this.didEverRender=!1,e.appendChild(this.domNode)}return e.prototype.set=function(t,i){this.didEverRender&&this.keybinding===t&&e.areSame(this.matches,i)||(this.keybinding=t,this.matches=i,this.render())},e.prototype.render=function(){if(o.clearNode(this.domNode),this.keybinding){var e=this.keybinding.getParts(),t=e[0],i=e[1];t&&this.renderPart(this.domNode,t,this.matches?this.matches.firstPart:null),i&&(o.append(this.domNode,s("span.monaco-keybinding-key-chord-separator",void 0," ")),this.renderPart(this.domNode,i,this.matches?this.matches.chordPart:null)),this.domNode.title=this.keybinding.getAriaLabel()||""}else this.options&&this.options.renderUnboundKeybindings&&this.renderUnbound(this.domNode);this.didEverRender=!0},e.prototype.renderPart=function(e,t,i){
var o=n.UILabelProvider.modifierLabels[this.os];t.ctrlKey&&this.renderKey(e,o.ctrlKey,Boolean(i&&i.ctrlKey),o.separator),t.shiftKey&&this.renderKey(e,o.shiftKey,Boolean(i&&i.shiftKey),o.separator),t.altKey&&this.renderKey(e,o.altKey,Boolean(i&&i.altKey),o.separator),t.metaKey&&this.renderKey(e,o.metaKey,Boolean(i&&i.metaKey),o.separator);var r=t.keyLabel;r&&this.renderKey(e,r,Boolean(i&&i.keyCode),"")},e.prototype.renderKey=function(e,t,i,n){o.append(e,s("span.monaco-keybinding-key"+(i?".highlight":""),void 0,t)),n&&o.append(e,s("span.monaco-keybinding-key-separator",void 0,n))},e.prototype.renderUnbound=function(e){o.append(e,s("span.monaco-keybinding-key",void 0,r.localize(0,null)))},e.areSame=function(e,t){return e===t||!e&&!t||!!e&&!!t&&i.equals(e.firstPart,t.firstPart)&&i.equals(e.chordPart,t.chordPart)},e}();t.KeybindingLabel=a}),define(t[300],i([6,7]),function(e,t){return e.create("vs/base/common/severity",t)}),define(t[109],i([1,0,300,5]),function(e,t,i,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var o;!function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(o||(o={})),function(e){var t="error",o="warning",r="warn",s="info",a=Object.create(null);a[e.Error]=i.localize(0,null),a[e.Warning]=i.localize(1,null),a[e.Info]=i.localize(2,null),e.fromValue=function(i){return i?n.equalsIgnoreCase(t,i)?e.Error:n.equalsIgnoreCase(o,i)||n.equalsIgnoreCase(r,i)?e.Warning:n.equalsIgnoreCase(s,i)?e.Info:e.Ignore:e.Ignore}}(o||(o={})),t.default=o}),define(t[302],i([6,7]),function(e,t){return e.create("vs/base/parts/quickopen/browser/quickOpenModel",t)}),define(t[119],i([1,0,302,23,135,74,157,8,299,18,19]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h=0,p=function(){function e(e){void 0===e&&(e=[]),this.id=(h++).toString(),this.labelHighlights=e,this.descriptionHighlights=[]}return e.prototype.getId=function(){return this.id},e.prototype.getLabel=function(){},
e.prototype.getLabelOptions=function(){},e.prototype.getAriaLabel=function(){return c.coalesce([this.getLabel(),this.getDescription(),this.getDetail()]).join(", ")},e.prototype.getDetail=function(){},e.prototype.getIcon=function(){},e.prototype.getDescription=function(){},e.prototype.getTooltip=function(){},e.prototype.getDescriptionTooltip=function(){},e.prototype.getKeybinding=function(){},e.prototype.isHidden=function(){return!!this.hidden},e.prototype.setHighlights=function(e,t,i){this.labelHighlights=e,this.descriptionHighlights=t,this.detailHighlights=i},e.prototype.getHighlights=function(){return[this.labelHighlights,this.descriptionHighlights,this.detailHighlights]},e.prototype.run=function(e,t){return!1},e}();t.QuickOpenEntry=p;var f=function(e){function t(t,i,n){var o=e.call(this)||this;return o.entry=t,o.groupLabel=i,o.withBorder=n,o}return r(t,e),t.prototype.getGroupLabel=function(){return this.groupLabel},t.prototype.setGroupLabel=function(e){this.groupLabel=e},t.prototype.showBorder=function(){
return!!this.withBorder},t.prototype.setShowBorder=function(e){this.withBorder=e},t.prototype.getLabel=function(){return this.entry?this.entry.getLabel():e.prototype.getLabel.call(this)},t.prototype.getLabelOptions=function(){return this.entry?this.entry.getLabelOptions():e.prototype.getLabelOptions.call(this)},t.prototype.getAriaLabel=function(){return this.entry?this.entry.getAriaLabel():e.prototype.getAriaLabel.call(this)},t.prototype.getDetail=function(){return this.entry?this.entry.getDetail():e.prototype.getDetail.call(this)},t.prototype.getIcon=function(){return this.entry?this.entry.getIcon():e.prototype.getIcon.call(this)},t.prototype.getDescription=function(){return this.entry?this.entry.getDescription():e.prototype.getDescription.call(this)},t.prototype.getHighlights=function(){return this.entry?this.entry.getHighlights():e.prototype.getHighlights.call(this)},t.prototype.isHidden=function(){return this.entry?this.entry.isHidden():e.prototype.isHidden.call(this)},
t.prototype.setHighlights=function(t,i,n){this.entry?this.entry.setHighlights(t,i,n):e.prototype.setHighlights.call(this,t,i,n)},t.prototype.run=function(t,i){return this.entry?this.entry.run(t,i):e.prototype.run.call(this,t,i)},t}(p);t.QuickOpenEntryGroup=f;var g=function(){function e(){}return e.prototype.hasActions=function(e,t){return!1},e.prototype.getActions=function(e,t){return null},e}(),m=function(){function e(e,t){void 0===e&&(e=new g),this.actionProvider=e,this.actionRunner=t}return e.prototype.getHeight=function(e){return e.getDetail()?44:22},e.prototype.getTemplateId=function(e){return e instanceof f?"quickOpenEntryGroup":"quickOpenEntry"},e.prototype.renderTemplate=function(e,t,i){var n=document.createElement("div");l.addClass(n,"sub-content"),t.appendChild(n);var r=l.$(".quick-open-row"),c=l.$(".quick-open-row"),h=l.$(".quick-open-entry",void 0,r,c);n.appendChild(h);var p=document.createElement("span");r.appendChild(p);var f=new o.IconLabel(r,{supportHighlights:!0,
supportDescriptionHighlights:!0,supportOcticons:!0}),g=document.createElement("span");r.appendChild(g),l.addClass(g,"quick-open-entry-keybinding");var m=new u.KeybindingLabel(g,d.OS),v=document.createElement("div");c.appendChild(v),l.addClass(v,"quick-open-entry-meta");var _,y=new a.HighlightedLabel(v,!0);"quickOpenEntryGroup"===e&&(_=document.createElement("div"),l.addClass(_,"results-group"),t.appendChild(_)),l.addClass(t,"actions");var b=document.createElement("div");l.addClass(b,"primary-action-bar"),t.appendChild(b);return{container:t,entry:h,icon:p,label:f,detail:y,keybinding:m,group:_,actionBar:new s.ActionBar(b,{actionRunner:this.actionRunner})}},e.prototype.renderElement=function(e,t,i,o){this.actionProvider.hasActions(null,e)?l.addClass(i.container,"has-actions"):l.removeClass(i.container,"has-actions"),i.actionBar.context=e;var r=this.actionProvider.getActions(null,e);if(i.actionBar.isEmpty()&&r&&r.length>0?i.actionBar.push(r,{icon:!0,label:!1
}):i.actionBar.isEmpty()||r&&0!==r.length||i.actionBar.clear(),e instanceof f&&e.getGroupLabel()?l.addClass(i.container,"has-group-label"):l.removeClass(i.container,"has-group-label"),e instanceof f){var s=e,a=i;s.showBorder()?(l.addClass(a.container,"results-group-separator"),o.pickerGroupBorder&&(a.container.style.borderTopColor=o.pickerGroupBorder.toString())):(l.removeClass(a.container,"results-group-separator"),a.container.style.borderTopColor=null);var u=s.getGroupLabel()||"";a.group&&(a.group.textContent=u,o.pickerGroupForeground&&(a.group.style.color=o.pickerGroupForeground.toString()))}if(e instanceof p){var d=e.getHighlights(),c=d[0],h=d[1],g=d[2],m=e.getIcon()?"quick-open-entry-icon "+e.getIcon():"";i.icon.className=m;var v=e.getLabelOptions()||Object.create(null);v.matches=c||[],v.title=e.getTooltip(),v.descriptionTitle=e.getDescriptionTooltip()||e.getDescription(),v.descriptionMatches=h||[],i.label.setLabel(n.withNullAsUndefined(e.getLabel()),e.getDescription(),v),i.detail.set(e.getDetail(),g),
i.keybinding.set(e.getKeybinding())}},e.prototype.disposeTemplate=function(e,t){t.actionBar.dispose(),t.actionBar=null,t.container=null,t.entry=null,t.keybinding=null,t.detail=null,t.group=null,t.icon=null,t.label.dispose(),t.label=null},e}(),v=function(){function e(e,t){void 0===e&&(e=[]),void 0===t&&(t=new g),this._entries=e,this._dataSource=this,this._renderer=new m(t),this._filter=this,this._runner=this,this._accessibilityProvider=this}return Object.defineProperty(e.prototype,"entries",{get:function(){return this._entries},set:function(e){this._entries=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"dataSource",{get:function(){return this._dataSource},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderer",{get:function(){return this._renderer},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filter",{get:function(){return this._filter},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"runner",{get:function(){return this._runner
},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"accessibilityProvider",{get:function(){return this._accessibilityProvider},enumerable:!0,configurable:!0}),e.prototype.getId=function(e){return e.getId()},e.prototype.getLabel=function(e){return n.withUndefinedAsNull(e.getLabel())},e.prototype.getAriaLabel=function(e){return e.getAriaLabel()?i.localize(0,null,e.getAriaLabel()):i.localize(1,null)},e.prototype.isVisible=function(e){return!e.isHidden()},e.prototype.run=function(e,t,i){return e.run(t,i)},e}();t.QuickOpenModel=v}),define(t[304],i([6,7]),function(e,t){return e.create("vs/base/parts/quickopen/browser/quickOpenWidget",t)}),define(t[305],i([1,0,304,18,23,452,123,378,395,57,158,8,2,25,29,44,381]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.onContextMenu=function(t,i,o){
return n.isMacintosh?this.onLeftClick(t,i,o):e.prototype.onContextMenu.call(this,t,i,o)},t}(c.DefaultController);t.QuickOpenController=v;var _={background:f.Color.fromHex("#1E1E1E"),foreground:f.Color.fromHex("#CCCCCC"),pickerGroupForeground:f.Color.fromHex("#0097FB"),pickerGroupBorder:f.Color.fromHex("#3F3F46"),widgetShadow:f.Color.fromHex("#000000"),progressBarBackground:f.Color.fromHex("#0E70C0")},y=i.localize(0,null),b=function(e){function t(t,i,n){var o=e.call(this)||this;return o.isDisposed=!1,o.container=t,o.callbacks=i,o.options=n,o.styles=n||Object.create(null),g.mixin(o.styles,_,!1),o.model=null,o}return r(t,e),t.prototype.getModel=function(){return this.model},t.prototype.create=function(){var e=this;this.element=document.createElement("div"),h.addClass(this.element,"monaco-quick-open-widget"),this.container.appendChild(this.element),this._register(h.addDisposableListener(this.element,h.EventType.CONTEXT_MENU,function(e){return h.EventHelper.stop(e,!0)})),
this._register(h.addDisposableListener(this.element,h.EventType.FOCUS,function(t){return e.gainingFocus()},!0)),this._register(h.addDisposableListener(this.element,h.EventType.BLUR,function(t){return e.loosingFocus(t)},!0)),this._register(h.addDisposableListener(this.element,h.EventType.KEY_DOWN,function(t){var i=new d.StandardKeyboardEvent(t);if(9===i.keyCode)h.EventHelper.stop(t,!0),e.hide(2);else if(2===i.keyCode&&!i.altKey&&!i.ctrlKey&&!i.metaKey){var n=t.currentTarget.querySelectorAll("input, .monaco-tree, .monaco-tree-row.focused .action-label.icon");i.shiftKey&&i.target===n[0]?(h.EventHelper.stop(t,!0),n[n.length-1].focus()):i.shiftKey||i.target!==n[n.length-1]||(h.EventHelper.stop(t,!0),n[0].focus())}})),this.progressBar=this._register(new u.ProgressBar(this.element,{progressBarBackground:this.styles.progressBarBackground})),this.progressBar.hide(),this.inputContainer=document.createElement("div"),h.addClass(this.inputContainer,"quick-open-input"),this.element.appendChild(this.inputContainer),
this.inputBox=this._register(new a.InputBox(this.inputContainer,void 0,{placeholder:this.options.inputPlaceHolder||"",ariaLabel:y,inputBackground:this.styles.inputBackground,inputForeground:this.styles.inputForeground,inputBorder:this.styles.inputBorder,inputValidationInfoBackground:this.styles.inputValidationInfoBackground,inputValidationInfoForeground:this.styles.inputValidationInfoForeground,inputValidationInfoBorder:this.styles.inputValidationInfoBorder,inputValidationWarningBackground:this.styles.inputValidationWarningBackground,inputValidationWarningForeground:this.styles.inputValidationWarningForeground,inputValidationWarningBorder:this.styles.inputValidationWarningBorder,inputValidationErrorBackground:this.styles.inputValidationErrorBackground,inputValidationErrorForeground:this.styles.inputValidationErrorForeground,inputValidationErrorBorder:this.styles.inputValidationErrorBorder})),this.inputElement=this.inputBox.inputElement,this.inputElement.setAttribute("role","combobox"),
this.inputElement.setAttribute("aria-haspopup","false"),this.inputElement.setAttribute("aria-autocomplete","list"),this._register(h.addDisposableListener(this.inputBox.inputElement,h.EventType.INPUT,function(t){return e.onType()})),this._register(h.addDisposableListener(this.inputBox.inputElement,h.EventType.KEY_DOWN,function(t){var i=new d.StandardKeyboardEvent(t),n=e.shouldOpenInBackground(i);if(2!==i.keyCode)if(18===i.keyCode||16===i.keyCode||12===i.keyCode||11===i.keyCode)h.EventHelper.stop(t,!0),e.navigateInTree(i.keyCode,i.shiftKey),e.inputBox.inputElement.selectionStart===e.inputBox.inputElement.selectionEnd&&(e.inputBox.inputElement.selectionStart=e.inputBox.value.length);else if(3===i.keyCode||n){h.EventHelper.stop(t,!0);var o=e.tree.getFocus();o&&e.elementSelected(o,t,n?2:1)}})),this.resultCount=document.createElement("div"),h.addClass(this.resultCount,"quick-open-result-count"),this.resultCount.setAttribute("aria-live","polite"),this.resultCount.setAttribute("aria-atomic","true"),
this.element.appendChild(this.resultCount),this.treeContainer=document.createElement("div"),h.addClass(this.treeContainer,"quick-open-tree"),this.element.appendChild(this.treeContainer);var t=this.options.treeCreator||function(e,t,i){return new l.Tree(e,t,i)};return this.tree=this._register(t(this.treeContainer,{dataSource:new s.DataSource(this),controller:new v({clickBehavior:1,keyboardSupport:this.options.keyboardSupport}),renderer:this.renderer=new s.Renderer(this,this.styles),filter:new s.Filter(this),accessibilityProvider:new s.AccessibilityProvider(this)},{twistiePixels:11,indentPixels:0,alwaysFocused:!0,verticalScrollMode:3,horizontalScrollMode:2,ariaLabel:i.localize(1,null),keyboardSupport:this.options.keyboardSupport,preventRootFocus:!1})),this.treeElement=this.tree.getHTMLElement(),this._register(this.tree.onDidChangeFocus(function(t){e.elementFocused(t.focus,t)})),this._register(this.tree.onDidChangeSelection(function(t){if(t.selection&&t.selection.length>0){
var i=t.payload&&t.payload.originalEvent instanceof m.StandardMouseEvent?t.payload.originalEvent:void 0,n=!!i&&e.shouldOpenInBackground(i);e.elementSelected(t.selection[0],t,n?2:1)}})),this._register(h.addDisposableListener(this.treeContainer,h.EventType.KEY_DOWN,function(t){var i=new d.StandardKeyboardEvent(t);e.quickNavigateConfiguration&&(18!==i.keyCode&&16!==i.keyCode&&12!==i.keyCode&&11!==i.keyCode||(h.EventHelper.stop(t,!0),e.navigateInTree(i.keyCode)))})),this._register(h.addDisposableListener(this.treeContainer,h.EventType.KEY_UP,function(t){var i=new d.StandardKeyboardEvent(t),n=i.keyCode;if(e.quickNavigateConfiguration){var o=e.quickNavigateConfiguration.keybindings;if(3===n||o.some(function(e){var t=e.getParts(),o=t[0];return!t[1]&&(o.shiftKey&&4===n?!(i.ctrlKey||i.altKey||i.metaKey):!(!o.altKey||6!==n)||(!(!o.ctrlKey||5!==n)||!(!o.metaKey||57!==n)))})){var r=e.tree.getFocus();r&&e.elementSelected(r,t)}}})),this.layoutDimensions&&this.layout(this.layoutDimensions),this.applyStyles(),
this._register(h.addDisposableListener(this.treeContainer,h.EventType.KEY_DOWN,function(t){var i=new d.StandardKeyboardEvent(t);e.quickNavigateConfiguration||18!==i.keyCode&&16!==i.keyCode&&12!==i.keyCode&&11!==i.keyCode||(h.EventHelper.stop(t,!0),e.navigateInTree(i.keyCode,i.shiftKey),e.treeElement.focus())})),this.element},t.prototype.style=function(e){this.styles=e,this.applyStyles()},t.prototype.applyStyles=function(){if(this.element){var e=this.styles.foreground?this.styles.foreground.toString():null,t=this.styles.background?this.styles.background.toString():null,i=this.styles.borderColor?this.styles.borderColor.toString():null,n=this.styles.widgetShadow?this.styles.widgetShadow.toString():null;this.element.style.color=e,this.element.style.backgroundColor=t,this.element.style.borderColor=i,this.element.style.borderWidth=i?"1px":null,this.element.style.borderStyle=i?"solid":null,this.element.style.boxShadow=n?"0 5px 8px "+n:null}this.progressBar&&this.progressBar.style({
progressBarBackground:this.styles.progressBarBackground}),this.inputBox&&this.inputBox.style({inputBackground:this.styles.inputBackground,inputForeground:this.styles.inputForeground,inputBorder:this.styles.inputBorder,inputValidationInfoBackground:this.styles.inputValidationInfoBackground,inputValidationInfoForeground:this.styles.inputValidationInfoForeground,inputValidationInfoBorder:this.styles.inputValidationInfoBorder,inputValidationWarningBackground:this.styles.inputValidationWarningBackground,inputValidationWarningForeground:this.styles.inputValidationWarningForeground,inputValidationWarningBorder:this.styles.inputValidationWarningBorder,inputValidationErrorBackground:this.styles.inputValidationErrorBackground,inputValidationErrorForeground:this.styles.inputValidationErrorForeground,inputValidationErrorBorder:this.styles.inputValidationErrorBorder}),this.tree&&!this.options.treeCreator&&this.tree.style(this.styles),this.renderer&&this.renderer.updateStyles(this.styles)},
t.prototype.shouldOpenInBackground=function(e){if(e instanceof d.StandardKeyboardEvent){if(17!==e.keyCode)return!1;if(e.metaKey||e.ctrlKey||e.shiftKey||e.altKey)return!1;var t=this.inputBox.inputElement;return t.selectionEnd===this.inputBox.value.length&&t.selectionStart===t.selectionEnd}return e.middleButton},t.prototype.onType=function(){var e=this.inputBox.value;this.helpText&&(e?h.hide(this.helpText):h.show(this.helpText)),this.callbacks.onType(e)},t.prototype.navigateInTree=function(e,t){var i=this.tree.getInput(),n=i?i.entries:[],o=this.tree.getFocus();switch(e){case 18:this.tree.focusNext();break;case 16:this.tree.focusPrevious();break;case 12:this.tree.focusNextPage();break;case 11:this.tree.focusPreviousPage();break;case 2:t?this.tree.focusPrevious():this.tree.focusNext()}var r=this.tree.getFocus();n.length>1&&o===r&&(16===e||2===e&&t?this.tree.focusLast():(18===e||2===e&&!t)&&this.tree.focusFirst()),(r=this.tree.getFocus())&&this.tree.reveal(r)},t.prototype.elementFocused=function(e,t){
if(e&&this.isVisible()){var i=this.treeElement.getAttribute("aria-activedescendant");i?this.inputElement.setAttribute("aria-activedescendant",i):this.inputElement.removeAttribute("aria-activedescendant");var n={event:t,keymods:this.extractKeyMods(t),quickNavigateConfiguration:this.quickNavigateConfiguration};this.model.runner.run(e,0,n)}},t.prototype.elementSelected=function(e,t,i){var n=!0;if(this.isVisible()){var o=i||1,r={event:t,keymods:this.extractKeyMods(t),quickNavigateConfiguration:this.quickNavigateConfiguration};n=this.model.runner.run(e,o,r)}n&&this.hide(0)},t.prototype.extractKeyMods=function(e){return{ctrlCmd:e&&(e.ctrlKey||e.metaKey||e.payload&&e.payload.originalEvent&&(e.payload.originalEvent.ctrlKey||e.payload.originalEvent.metaKey)),alt:e&&(e.altKey||e.payload&&e.payload.originalEvent&&e.payload.originalEvent.altKey)}},t.prototype.show=function(e,t){this.visible=!0,this.isLoosingFocus=!1,this.quickNavigateConfiguration=t?t.quickNavigateConfiguration:void 0,
this.quickNavigateConfiguration?(h.hide(this.inputContainer),h.show(this.element),this.tree.domFocus()):(h.show(this.inputContainer),h.show(this.element),this.inputBox.focus()),this.helpText&&(this.quickNavigateConfiguration||o.isString(e)?h.hide(this.helpText):h.show(this.helpText)),o.isString(e)?this.doShowWithPrefix(e):(t&&t.value&&this.restoreLastInput(t.value),this.doShowWithInput(e,t&&t.autoFocus?t.autoFocus:{})),t&&t.inputSelection&&!this.quickNavigateConfiguration&&this.inputBox.select(t.inputSelection),this.callbacks.onShow&&this.callbacks.onShow()},t.prototype.restoreLastInput=function(e){this.inputBox.value=e,this.inputBox.select(),this.callbacks.onType(e)},t.prototype.doShowWithPrefix=function(e){this.inputBox.value=e,this.callbacks.onType(e)},t.prototype.doShowWithInput=function(e,t){this.setInput(e,t)},t.prototype.setInputAndLayout=function(e,t){var i=this;this.treeContainer.style.height=this.getHeight(e)+"px",this.tree.setInput(null).then(function(){return i.model=e,
i.inputElement.setAttribute("aria-haspopup",String(e&&e.entries&&e.entries.length>0)),i.tree.setInput(e)}).then(function(){i.tree.layout();var n=e?e.entries.filter(function(t){return i.isElementVisible(e,t)}):[];i.updateResultCount(n.length),n.length&&i.autoFocus(e,n,t)})},t.prototype.isElementVisible=function(e,t){return!e.filter||e.filter.isVisible(t)},t.prototype.autoFocus=function(e,t,i){if(void 0===i&&(i={}),i.autoFocusPrefixMatch){for(var n=void 0,o=void 0,r=i.autoFocusPrefixMatch,s=r.toLowerCase(),a=0,l=t;a<l.length;a++){var u=l[a],d=e.dataSource.getLabel(u)||"";if(n||0!==d.indexOf(r)?o||0!==d.toLowerCase().indexOf(s)||(o=u):n=u,n&&o)break}var c=n||o;if(c)return this.tree.setFocus(c),void this.tree.reveal(c,.5)}i.autoFocusFirstEntry?(this.tree.focusFirst(),this.tree.reveal(this.tree.getFocus())):"number"==typeof i.autoFocusIndex?t.length>i.autoFocusIndex&&(this.tree.focusNth(i.autoFocusIndex),
this.tree.reveal(this.tree.getFocus())):i.autoFocusSecondEntry?t.length>1&&this.tree.focusNth(1):i.autoFocusLastEntry&&t.length>1&&this.tree.focusLast()},t.prototype.getHeight=function(e){var i=this,n=e.renderer;if(!e){var o=n.getHeight(null);return this.options.minItemsToShow?this.options.minItemsToShow*o:0}var r,s=0;this.layoutDimensions&&this.layoutDimensions.height&&(r=.4*(this.layoutDimensions.height-50)),(!r||r>t.MAX_ITEMS_HEIGHT)&&(r=t.MAX_ITEMS_HEIGHT);for(var a=e.entries.filter(function(t){return i.isElementVisible(e,t)}),l=this.options.maxItemsToShow||a.length,u=0;u<l&&u<a.length;u++){var d=n.getHeight(a[u]);if(!(s+d<=r))break;s+=d}return s},t.prototype.updateResultCount=function(e){this.resultCount.textContent=i.localize(2,null,e)},t.prototype.hide=function(e){this.isVisible()&&(this.visible=!1,h.hide(this.element),this.element.blur(),this.inputBox.value="",this.tree.setInput(null),this.inputElement.setAttribute("aria-haspopup","false"),
this.treeContainer.style.height=(this.options.minItemsToShow?22*this.options.minItemsToShow:0)+"px",this.progressBar.stop().hide(),this.tree.isDOMFocused()?this.tree.domBlur():this.inputBox.hasFocus()&&this.inputBox.blur(),0===e?this.callbacks.onOk():this.callbacks.onCancel(),this.callbacks.onHide&&this.callbacks.onHide(e))},t.prototype.setInput=function(e,t,i){this.isVisible()&&(this.getInput()&&this.onInputChanging(),this.setInputAndLayout(e,t),this.inputBox&&this.inputBox.setAriaLabel(i||y))},t.prototype.onInputChanging=function(){var e=this;this.inputChangingTimeoutHandle&&(clearTimeout(this.inputChangingTimeoutHandle),this.inputChangingTimeoutHandle=null),h.addClass(this.element,"content-changing"),this.inputChangingTimeoutHandle=setTimeout(function(){h.removeClass(e.element,"content-changing")},500)},t.prototype.getInput=function(){return this.tree.getInput()},t.prototype.isVisible=function(){return this.visible},t.prototype.layout=function(e){this.layoutDimensions=e
;var i=Math.min(.62*this.layoutDimensions.width,t.MAX_WIDTH);this.element&&(this.element.style.width=i+"px",this.element.style.marginLeft="-"+i/2+"px",this.inputContainer.style.width=i-12+"px")},t.prototype.gainingFocus=function(){this.isLoosingFocus=!1},t.prototype.loosingFocus=function(e){var t=this;if(this.isVisible()){var i=e.relatedTarget;!this.quickNavigateConfiguration&&h.isAncestor(i,this.element)||(this.isLoosingFocus=!0,setTimeout(function(){if(t.isLoosingFocus&&!t.isDisposed){t.callbacks.onFocusLost&&t.callbacks.onFocusLost()||t.hide(1)}},0))}},t.prototype.dispose=function(){e.prototype.dispose.call(this),this.isDisposed=!0},t.MAX_WIDTH=600,t.MAX_ITEMS_HEIGHT=440,t}(p.Disposable);t.QuickOpenWidget=b}),define(t[306],i([6,7]),function(e,t){return e.create("vs/editor/browser/controller/coreCommands",t)}),define(t[307],i([6,7]),function(e,t){return e.create("vs/editor/browser/widget/codeEditorWidget",t)}),define(t[308],i([6,7]),function(e,t){
return e.create("vs/editor/browser/widget/diffEditorWidget",t)}),define(t[309],i([6,7]),function(e,t){return e.create("vs/editor/browser/widget/diffReview",t)}),define(t[310],i([6,7]),function(e,t){return e.create("vs/editor/browser/widget/inlineDiffMargin",t)}),define(t[311],i([1,0,310,8,58,2,3]),function(e,t,i,n,o,s,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(t,r,s,d,c,h){var p=e.call(this)||this;p._viewZoneId=t,p._marginDomNode=r,p.editor=s,p.diff=d,p._contextMenuService=c,p._clipboardService=h,p._visibility=!1,p._marginDomNode.style.zIndex="10",p._diffActions=document.createElement("div"),p._diffActions.className="lightbulb-glyph",p._diffActions.style.position="absolute";var f=s.getConfiguration().lineHeight,g=s.getModel().getEOL();p._diffActions.style.right="0px",p._diffActions.style.visibility="hidden",p._diffActions.style.height=f+"px",p._diffActions.style.lineHeight=f+"px",p._marginDomNode.appendChild(p._diffActions);var m=[]
;m.push(new o.Action("diff.clipboard.copyDeletedContent",d.originalEndLineNumber>d.modifiedStartLineNumber?i.localize(0,null):i.localize(1,null),void 0,!0,function(){return a(p,void 0,void 0,function(){return l(this,function(e){switch(e.label){case 0:return[4,this._clipboardService.writeText(d.originalContent.join(g)+g)];case 1:return e.sent(),[2]}})})}));var v=0,_=void 0;d.originalEndLineNumber>d.modifiedStartLineNumber&&(_=new o.Action("diff.clipboard.copyDeletedLineContent",i.localize(2,null,d.originalStartLineNumber),void 0,!0,function(){return a(p,void 0,void 0,function(){return l(this,function(e){switch(e.label){case 0:return[4,this._clipboardService.writeText(d.originalContent[v])];case 1:return e.sent(),[2]}})})}),m.push(_));return s.getConfiguration().readOnly||m.push(new o.Action("diff.inline.revertChange",i.localize(3,null),void 0,!0,function(){return a(p,void 0,void 0,function(){var e;return l(this,function(t){
return 0===d.modifiedEndLineNumber?(e=s.getModel().getLineMaxColumn(d.modifiedStartLineNumber),s.executeEdits("diffEditor",[{range:new u.Range(d.modifiedStartLineNumber,e,d.modifiedStartLineNumber,e),text:g+d.originalContent.join(g)}])):(e=s.getModel().getLineMaxColumn(d.modifiedEndLineNumber),s.executeEdits("diffEditor",[{range:new u.Range(d.modifiedStartLineNumber,1,d.modifiedEndLineNumber,e),text:d.originalContent.join(g)}])),[2]})})})),p._register(n.addStandardDisposableListener(p._diffActions,"mousedown",function(e){var t=n.getDomNodePagePosition(p._diffActions),o=t.top,r=t.height,s=Math.floor(f/3);e.preventDefault(),p._contextMenuService.showContextMenu({getAnchor:function(){return{x:e.posx,y:o+r+s}},getActions:function(){return _&&(_.label=i.localize(4,null,d.originalStartLineNumber+v)),m},autoSelectFirstItem:!0})})),p._register(s.onMouseMove(function(e){if(8===e.target.type||5===e.target.type){e.target.detail.viewZoneId===p._viewZoneId?(p.visibility=!0,
v=p._updateLightBulbPosition(p._marginDomNode,e.event.browserEvent.y,f)):p.visibility=!1}else p.visibility=!1})),p}return r(t,e),Object.defineProperty(t.prototype,"visibility",{get:function(){return this._visibility},set:function(e){this._visibility!==e&&(this._visibility=e,this._diffActions.style.visibility=e?"visible":"hidden")},enumerable:!0,configurable:!0}),t.prototype._updateLightBulbPosition=function(e,t,i){var o=t-n.getDomNodePagePosition(e).top,r=Math.floor(o/i),s=r*i;return this._diffActions.style.top=s+"px",r},t}(s.Disposable);t.InlineDiffMargin=d}),define(t[312],i([6,7]),function(e,t){return e.create("vs/editor/common/config/commonEditorConfig",t)}),define(t[313],i([6,7]),function(e,t){return e.create("vs/editor/common/config/editorOptions",t)}),define(t[47],i([1,0,313,19,29,18,99,23]),function(e,t,i,n,o,r,a,l){"use strict";function u(e,t){return void 0===e?t:"false"!==e&&Boolean(e)}function d(e,t){return"string"!=typeof e?t:e}function c(e,t,i){return"string"!=typeof e?t:-1===i.indexOf(e)?t:e}
function h(e,t,i,n){var o;return void 0===e?o=t:(o=parseInt(e,10),isNaN(o)&&(o=t)),o=Math.max(i,o),0|(o=Math.min(n,o))}function p(e,t){var i=parseFloat(e);return isNaN(i)&&(i=t),i}function f(e,t){if("string"!=typeof e)return t;switch(e){case"hidden":return 2;case"visible":return 3;default:return 1}}Object.defineProperty(t,"__esModule",{value:!0}),t.blinkingStyleToString=function(e){if(1===e)return"blink";if(4===e)return"expand";if(3===e)return"phase";if(2===e)return"smooth";if(5===e)return"solid";throw new Error("blinkingStyleToString: Unknown blinkingStyle")};var g;!function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(g=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={})),t.cursorStyleToString=function(e){if(e===g.Line)return"line";if(e===g.Block)return"block";if(e===g.Underline)return"underline";if(e===g.LineThin)return"line-thin";if(e===g.BlockOutline)return"block-outline"
;if(e===g.UnderlineThin)return"underline-thin";throw new Error("cursorStyleToString: Unknown cursorStyle")};var m=function(){function e(e){this.canUseLayerHinting=e.canUseLayerHinting,this.pixelRatio=e.pixelRatio,this.editorClassName=e.editorClassName,this.lineHeight=0|e.lineHeight,this.readOnly=e.readOnly,this.accessibilitySupport=e.accessibilitySupport,this.multiCursorModifier=e.multiCursorModifier,this.multiCursorMergeOverlapping=e.multiCursorMergeOverlapping,this.wordSeparators=e.wordSeparators,this.autoClosingBrackets=e.autoClosingBrackets,this.autoClosingQuotes=e.autoClosingQuotes,this.autoClosingOvertype=e.autoClosingOvertype,this.autoSurround=e.autoSurround,this.autoIndent=e.autoIndent,this.useTabStops=e.useTabStops,this.tabFocusMode=e.tabFocusMode,this.dragAndDrop=e.dragAndDrop,this.emptySelectionClipboard=e.emptySelectionClipboard,this.copyWithSyntaxHighlighting=e.copyWithSyntaxHighlighting,this.layoutInfo=e.layoutInfo,this.fontInfo=e.fontInfo,this.viewInfo=e.viewInfo,
this.wrappingInfo=e.wrappingInfo,this.contribInfo=e.contribInfo,this.showUnused=e.showUnused}return e.prototype.equals=function(t){
return this.canUseLayerHinting===t.canUseLayerHinting&&this.pixelRatio===t.pixelRatio&&this.editorClassName===t.editorClassName&&this.lineHeight===t.lineHeight&&this.readOnly===t.readOnly&&this.accessibilitySupport===t.accessibilitySupport&&this.multiCursorModifier===t.multiCursorModifier&&this.multiCursorMergeOverlapping===t.multiCursorMergeOverlapping&&this.wordSeparators===t.wordSeparators&&this.autoClosingBrackets===t.autoClosingBrackets&&this.autoClosingQuotes===t.autoClosingQuotes&&this.autoClosingOvertype===t.autoClosingOvertype&&this.autoSurround===t.autoSurround&&this.autoIndent===t.autoIndent&&this.useTabStops===t.useTabStops&&this.tabFocusMode===t.tabFocusMode&&this.dragAndDrop===t.dragAndDrop&&this.showUnused===t.showUnused&&this.emptySelectionClipboard===t.emptySelectionClipboard&&this.copyWithSyntaxHighlighting===t.copyWithSyntaxHighlighting&&e._equalsLayoutInfo(this.layoutInfo,t.layoutInfo)&&this.fontInfo.equals(t.fontInfo)&&e._equalsViewOptions(this.viewInfo,t.viewInfo)&&e._equalsWrappingInfo(this.wrappingInfo,t.wrappingInfo)&&e._equalsContribOptions(this.contribInfo,t.contribInfo)
},e.prototype.createChangeEvent=function(t){return{canUseLayerHinting:this.canUseLayerHinting!==t.canUseLayerHinting,pixelRatio:this.pixelRatio!==t.pixelRatio,editorClassName:this.editorClassName!==t.editorClassName,lineHeight:this.lineHeight!==t.lineHeight,readOnly:this.readOnly!==t.readOnly,accessibilitySupport:this.accessibilitySupport!==t.accessibilitySupport,multiCursorModifier:this.multiCursorModifier!==t.multiCursorModifier,multiCursorMergeOverlapping:this.multiCursorMergeOverlapping!==t.multiCursorMergeOverlapping,wordSeparators:this.wordSeparators!==t.wordSeparators,autoClosingBrackets:this.autoClosingBrackets!==t.autoClosingBrackets,autoClosingQuotes:this.autoClosingQuotes!==t.autoClosingQuotes,autoClosingOvertype:this.autoClosingOvertype!==t.autoClosingOvertype,autoSurround:this.autoSurround!==t.autoSurround,autoIndent:this.autoIndent!==t.autoIndent,useTabStops:this.useTabStops!==t.useTabStops,tabFocusMode:this.tabFocusMode!==t.tabFocusMode,dragAndDrop:this.dragAndDrop!==t.dragAndDrop,
emptySelectionClipboard:this.emptySelectionClipboard!==t.emptySelectionClipboard,copyWithSyntaxHighlighting:this.copyWithSyntaxHighlighting!==t.copyWithSyntaxHighlighting,layoutInfo:!e._equalsLayoutInfo(this.layoutInfo,t.layoutInfo),fontInfo:!this.fontInfo.equals(t.fontInfo),viewInfo:!e._equalsViewOptions(this.viewInfo,t.viewInfo),wrappingInfo:!e._equalsWrappingInfo(this.wrappingInfo,t.wrappingInfo),contribInfo:!e._equalsContribOptions(this.contribInfo,t.contribInfo)}},e._equalsLayoutInfo=function(e,t){
return e.width===t.width&&e.height===t.height&&e.glyphMarginLeft===t.glyphMarginLeft&&e.glyphMarginWidth===t.glyphMarginWidth&&e.glyphMarginHeight===t.glyphMarginHeight&&e.lineNumbersLeft===t.lineNumbersLeft&&e.lineNumbersWidth===t.lineNumbersWidth&&e.lineNumbersHeight===t.lineNumbersHeight&&e.decorationsLeft===t.decorationsLeft&&e.decorationsWidth===t.decorationsWidth&&e.decorationsHeight===t.decorationsHeight&&e.contentLeft===t.contentLeft&&e.contentWidth===t.contentWidth&&e.contentHeight===t.contentHeight&&e.renderMinimap===t.renderMinimap&&e.minimapLeft===t.minimapLeft&&e.minimapWidth===t.minimapWidth&&e.viewportColumn===t.viewportColumn&&e.verticalScrollbarWidth===t.verticalScrollbarWidth&&e.horizontalScrollbarHeight===t.horizontalScrollbarHeight&&this._equalsOverviewRuler(e.overviewRuler,t.overviewRuler)},e._equalsOverviewRuler=function(e,t){return e.width===t.width&&e.height===t.height&&e.top===t.top&&e.right===t.right},e._equalsViewOptions=function(e,t){
return e.extraEditorClassName===t.extraEditorClassName&&e.disableMonospaceOptimizations===t.disableMonospaceOptimizations&&n.equals(e.rulers,t.rulers)&&e.ariaLabel===t.ariaLabel&&e.renderLineNumbers===t.renderLineNumbers&&e.renderCustomLineNumbers===t.renderCustomLineNumbers&&e.cursorSurroundingLines===t.cursorSurroundingLines&&e.renderFinalNewline===t.renderFinalNewline&&e.selectOnLineNumbers===t.selectOnLineNumbers&&e.glyphMargin===t.glyphMargin&&e.revealHorizontalRightPadding===t.revealHorizontalRightPadding&&e.roundedSelection===t.roundedSelection&&e.overviewRulerLanes===t.overviewRulerLanes&&e.overviewRulerBorder===t.overviewRulerBorder&&e.cursorBlinking===t.cursorBlinking&&e.mouseWheelZoom===t.mouseWheelZoom&&e.cursorSmoothCaretAnimation===t.cursorSmoothCaretAnimation&&e.cursorStyle===t.cursorStyle&&e.cursorWidth===t.cursorWidth&&e.hideCursorInOverviewRuler===t.hideCursorInOverviewRuler&&e.scrollBeyondLastLine===t.scrollBeyondLastLine&&e.scrollBeyondLastColumn===t.scrollBeyondLastColumn&&e.smoothScrolling===t.smoothScrolling&&e.stopRenderingLineAfter===t.stopRenderingLineAfter&&e.renderWhitespace===t.renderWhitespace&&e.renderControlCharacters===t.renderControlCharacters&&e.fontLigatures===t.fontLigatures&&e.renderIndentGuides===t.renderIndentGuides&&e.highlightActiveIndentGuide===t.highlightActiveIndentGuide&&e.renderLineHighlight===t.renderLineHighlight&&this._equalsScrollbarOptions(e.scrollbar,t.scrollbar)&&this._equalsMinimapOptions(e.minimap,t.minimap)&&e.fixedOverflowWidgets===t.fixedOverflowWidgets
},e._equalsScrollbarOptions=function(e,t){return e.arrowSize===t.arrowSize&&e.vertical===t.vertical&&e.horizontal===t.horizontal&&e.useShadows===t.useShadows&&e.verticalHasArrows===t.verticalHasArrows&&e.horizontalHasArrows===t.horizontalHasArrows&&e.handleMouseWheel===t.handleMouseWheel&&e.horizontalScrollbarSize===t.horizontalScrollbarSize&&e.horizontalSliderSize===t.horizontalSliderSize&&e.verticalScrollbarSize===t.verticalScrollbarSize&&e.verticalSliderSize===t.verticalSliderSize&&e.mouseWheelScrollSensitivity===t.mouseWheelScrollSensitivity&&e.fastScrollSensitivity===t.fastScrollSensitivity},e._equalsMinimapOptions=function(e,t){return e.enabled===t.enabled&&e.side===t.side&&e.showSlider===t.showSlider&&e.renderCharacters===t.renderCharacters&&e.maxColumn===t.maxColumn},e._equalFindOptions=function(e,t){
return e.seedSearchStringFromSelection===t.seedSearchStringFromSelection&&e.autoFindInSelection===t.autoFindInSelection&&e.globalFindClipboard===t.globalFindClipboard&&e.addExtraSpaceOnTop===t.addExtraSpaceOnTop},e._equalsParameterHintOptions=function(e,t){return e.enabled===t.enabled&&e.cycle===t.cycle},e._equalsHoverOptions=function(e,t){return e.enabled===t.enabled&&e.delay===t.delay&&e.sticky===t.sticky},e._equalsSuggestOptions=function(e,t){return e===t||!(!e||!t)&&(e.filterGraceful===t.filterGraceful&&e.snippets===t.snippets&&e.snippetsPreventQuickSuggestions===t.snippetsPreventQuickSuggestions&&e.localityBonus===t.localityBonus&&e.shareSuggestSelections===t.shareSuggestSelections&&e.showIcons===t.showIcons&&e.maxVisibleSuggestions===t.maxVisibleSuggestions&&o.equals(e.filteredTypes,t.filteredTypes))},e._equalsGotoLocationOptions=function(e,t){return e===t||!(!e||!t)&&e.multiple===t.multiple},e._equalsWrappingInfo=function(e,t){
return e.inDiffEditor===t.inDiffEditor&&e.isDominatedByLongLines===t.isDominatedByLongLines&&e.isWordWrapMinified===t.isWordWrapMinified&&e.isViewportWrapping===t.isViewportWrapping&&e.wrappingColumn===t.wrappingColumn&&e.wrappingIndent===t.wrappingIndent&&e.wordWrapBreakBeforeCharacters===t.wordWrapBreakBeforeCharacters&&e.wordWrapBreakAfterCharacters===t.wordWrapBreakAfterCharacters&&e.wordWrapBreakObtrusiveCharacters===t.wordWrapBreakObtrusiveCharacters},e._equalsContribOptions=function(t,i){
return t.selectionClipboard===i.selectionClipboard&&this._equalsHoverOptions(t.hover,i.hover)&&t.links===i.links&&t.contextmenu===i.contextmenu&&e._equalsQuickSuggestions(t.quickSuggestions,i.quickSuggestions)&&t.quickSuggestionsDelay===i.quickSuggestionsDelay&&this._equalsParameterHintOptions(t.parameterHints,i.parameterHints)&&t.formatOnType===i.formatOnType&&t.formatOnPaste===i.formatOnPaste&&t.suggestOnTriggerCharacters===i.suggestOnTriggerCharacters&&t.acceptSuggestionOnEnter===i.acceptSuggestionOnEnter&&t.acceptSuggestionOnCommitCharacter===i.acceptSuggestionOnCommitCharacter&&t.wordBasedSuggestions===i.wordBasedSuggestions&&t.suggestSelection===i.suggestSelection&&t.suggestFontSize===i.suggestFontSize&&t.suggestLineHeight===i.suggestLineHeight&&t.tabCompletion===i.tabCompletion&&this._equalsSuggestOptions(t.suggest,i.suggest)&&e._equalsGotoLocationOptions(t.gotoLocation,i.gotoLocation)&&t.selectionHighlight===i.selectionHighlight&&t.occurrencesHighlight===i.occurrencesHighlight&&t.codeLens===i.codeLens&&t.folding===i.folding&&t.foldingStrategy===i.foldingStrategy&&t.showFoldingControls===i.showFoldingControls&&t.matchBrackets===i.matchBrackets&&this._equalFindOptions(t.find,i.find)&&t.colorDecorators===i.colorDecorators&&o.equals(t.codeActionsOnSave,i.codeActionsOnSave)&&t.codeActionsOnSaveTimeout===i.codeActionsOnSaveTimeout&&t.lightbulbEnabled===i.lightbulbEnabled
},e._equalsQuickSuggestions=function(e,t){return"boolean"==typeof e?"boolean"==typeof t&&e===t:"boolean"!=typeof t&&(e.comments===t.comments&&e.other===t.other&&e.strings===t.strings)},e}();t.InternalEditorOptions=m;var v=function(){function e(){}return e.validate=function(e,t){var i=e.wordWrap;!0===i?i="on":!1===i&&(i="off"),i=c(i,t.wordWrap,["off","on","wordWrapColumn","bounded"]);var n=this._sanitizeViewInfo(e,t.viewInfo),o=this._sanitizeContribInfo(e,t.contribInfo),s=void 0;"string"==typeof e.multiCursorModifier&&(s="ctrlCmd"===e.multiCursorModifier?r.isMacintosh?"metaKey":"ctrlKey":"altKey");var a,l,p,f=c(s,t.multiCursorModifier,["altKey","metaKey","ctrlKey"]);return"boolean"==typeof e.autoClosingBrackets&&!1===e.autoClosingBrackets?(a="never",l="never",p="never"):(a=c(e.autoClosingBrackets,t.autoClosingBrackets,["always","languageDefined","beforeWhitespace","never"]),l=c(e.autoClosingQuotes,t.autoClosingQuotes,["always","languageDefined","beforeWhitespace","never"]),
p=c(e.autoSurround,t.autoSurround,["languageDefined","brackets","quotes","never"])),{inDiffEditor:u(e.inDiffEditor,t.inDiffEditor),wordSeparators:d(e.wordSeparators,t.wordSeparators),lineNumbersMinChars:h(e.lineNumbersMinChars,t.lineNumbersMinChars,1,10),lineDecorationsWidth:void 0===e.lineDecorationsWidth?t.lineDecorationsWidth:e.lineDecorationsWidth,readOnly:u(e.readOnly,t.readOnly),mouseStyle:c(e.mouseStyle,t.mouseStyle,["text","default","copy"]),disableLayerHinting:u(e.disableLayerHinting,t.disableLayerHinting),automaticLayout:u(e.automaticLayout,t.automaticLayout),wordWrap:i,wordWrapColumn:h(e.wordWrapColumn,t.wordWrapColumn,1,1073741824),wordWrapMinified:u(e.wordWrapMinified,t.wordWrapMinified),wrappingIndent:function(e,t){return"string"!=typeof e?t:"same"===e?1:"indent"===e?2:"deepIndent"===e?3:0}(e.wrappingIndent,t.wrappingIndent),wordWrapBreakBeforeCharacters:d(e.wordWrapBreakBeforeCharacters,t.wordWrapBreakBeforeCharacters),
wordWrapBreakAfterCharacters:d(e.wordWrapBreakAfterCharacters,t.wordWrapBreakAfterCharacters),wordWrapBreakObtrusiveCharacters:d(e.wordWrapBreakObtrusiveCharacters,t.wordWrapBreakObtrusiveCharacters),autoClosingBrackets:a,autoClosingQuotes:l,autoClosingOvertype:c(e.autoClosingOvertype,t.autoClosingOvertype,["always","auto","never"]),autoSurround:p,autoIndent:u(e.autoIndent,t.autoIndent),dragAndDrop:u(e.dragAndDrop,t.dragAndDrop),emptySelectionClipboard:u(e.emptySelectionClipboard,t.emptySelectionClipboard),copyWithSyntaxHighlighting:u(e.copyWithSyntaxHighlighting,t.copyWithSyntaxHighlighting),useTabStops:u(e.useTabStops,t.useTabStops),multiCursorModifier:f,multiCursorMergeOverlapping:u(e.multiCursorMergeOverlapping,t.multiCursorMergeOverlapping),accessibilitySupport:c(e.accessibilitySupport,t.accessibilitySupport,["auto","on","off"]),showUnused:u(e.showUnused,t.showUnused),viewInfo:n,contribInfo:o}},e._sanitizeScrollbarOpts=function(e,t,i,n){if("object"!=typeof e)return t
;var o=h(e.horizontalScrollbarSize,t.horizontalScrollbarSize,0,1e3),r=h(e.verticalScrollbarSize,t.verticalScrollbarSize,0,1e3);return{vertical:f(e.vertical,t.vertical),horizontal:f(e.horizontal,t.horizontal),arrowSize:h(e.arrowSize,t.arrowSize,0,1e3),useShadows:u(e.useShadows,t.useShadows),verticalHasArrows:u(e.verticalHasArrows,t.verticalHasArrows),horizontalHasArrows:u(e.horizontalHasArrows,t.horizontalHasArrows),horizontalScrollbarSize:o,horizontalSliderSize:h(e.horizontalSliderSize,o,0,1e3),verticalScrollbarSize:r,verticalSliderSize:h(e.verticalSliderSize,r,0,1e3),handleMouseWheel:u(e.handleMouseWheel,t.handleMouseWheel),mouseWheelScrollSensitivity:i,fastScrollSensitivity:n}},e._sanitizeMinimapOpts=function(e,t){return"object"!=typeof e?t:{enabled:u(e.enabled,t.enabled),side:c(e.side,t.side,["right","left"]),showSlider:c(e.showSlider,t.showSlider,["always","mouseover"]),renderCharacters:u(e.renderCharacters,t.renderCharacters),maxColumn:h(e.maxColumn,t.maxColumn,1,1e4)}},e._sanitizeFindOpts=function(e,t){
return"object"!=typeof e?t:{seedSearchStringFromSelection:u(e.seedSearchStringFromSelection,t.seedSearchStringFromSelection),autoFindInSelection:u(e.autoFindInSelection,t.autoFindInSelection),globalFindClipboard:u(e.globalFindClipboard,t.globalFindClipboard),addExtraSpaceOnTop:u(e.addExtraSpaceOnTop,t.addExtraSpaceOnTop)}},e._sanitizeParameterHintOpts=function(e,t){return"object"!=typeof e?t:{enabled:u(e.enabled,t.enabled),cycle:u(e.cycle,t.cycle)}},e._sanitizeHoverOpts=function(e,t){var i;if("boolean"==typeof e)i={enabled:e};else{if("object"!=typeof e)return t;i=e}return{enabled:u(i.enabled,t.enabled),delay:h(i.delay,t.delay,0,1e4),sticky:u(i.sticky,t.sticky)}},e._sanitizeSuggestOpts=function(e,t){var i=e.suggest||{};return{filterGraceful:u(i.filterGraceful,t.filterGraceful),snippets:c(e.snippetSuggestions,t.snippets,["top","bottom","inline","none"]),snippetsPreventQuickSuggestions:u(i.snippetsPreventQuickSuggestions,t.filterGraceful),localityBonus:u(i.localityBonus,t.localityBonus),
shareSuggestSelections:u(i.shareSuggestSelections,t.shareSuggestSelections),showIcons:u(i.showIcons,t.showIcons),maxVisibleSuggestions:h(i.maxVisibleSuggestions,t.maxVisibleSuggestions,1,15),filteredTypes:l.isObject(i.filteredTypes)?i.filteredTypes:Object.create(null)}},e._sanitizeGotoLocationOpts=function(e,t){return{multiple:c((e.gotoLocation||{}).multiple,t.multiple,["peek","gotoAndPeek","goto"])}},e._sanitizeTabCompletionOpts=function(e,t){return!1===e?"off":!0===e?"onlySnippets":c(e,t,["on","off","onlySnippets"])},e._sanitizeViewInfo=function(e,t){var i=[];if(Array.isArray(e.rulers)){for(var n=0,o=e.rulers.length;n<o;n++)i.push(h(e.rulers[n],0,0,1e4));i.sort()}var r=t.renderLineNumbers,s=t.renderCustomLineNumbers;if(void 0!==e.lineNumbers){var a=e.lineNumbers;!0===a?a="on":!1===a&&(a="off"),"function"==typeof a?(r=4,s=a):r="interval"===a?3:"relative"===a?2:"on"===a?1:0}var l=u(e.fontLigatures,t.fontLigatures),f=u(e.disableMonospaceOptimizations,t.disableMonospaceOptimizations)||l,m=e.renderWhitespace
;!0===m?m="boundary":!1===m&&(m="none"),m=c(m,t.renderWhitespace,["none","boundary","selection","all"]);var v=e.renderLineHighlight;!0===v?v="line":!1===v&&(v="none"),v=c(v,t.renderLineHighlight,["none","gutter","line","all"]);var _=p(e.mouseWheelScrollSensitivity,t.scrollbar.mouseWheelScrollSensitivity);0===_&&(_=1);var y=p(e.fastScrollSensitivity,t.scrollbar.fastScrollSensitivity);y<=0&&(y=t.scrollbar.fastScrollSensitivity);var b=this._sanitizeScrollbarOpts(e.scrollbar,t.scrollbar,_,y),C=this._sanitizeMinimapOpts(e.minimap,t.minimap);return{extraEditorClassName:d(e.extraEditorClassName,t.extraEditorClassName),disableMonospaceOptimizations:f,rulers:i,ariaLabel:d(e.ariaLabel,t.ariaLabel),cursorSurroundingLines:h(e.cursorSurroundingLines,t.cursorWidth,0,Number.MAX_VALUE),renderLineNumbers:r,renderCustomLineNumbers:s,renderFinalNewline:u(e.renderFinalNewline,t.renderFinalNewline),selectOnLineNumbers:u(e.selectOnLineNumbers,t.selectOnLineNumbers),glyphMargin:u(e.glyphMargin,t.glyphMargin),
revealHorizontalRightPadding:h(e.revealHorizontalRightPadding,t.revealHorizontalRightPadding,0,1e3),roundedSelection:u(e.roundedSelection,t.roundedSelection),overviewRulerLanes:h(e.overviewRulerLanes,t.overviewRulerLanes,0,3),overviewRulerBorder:u(e.overviewRulerBorder,t.overviewRulerBorder),cursorBlinking:function(e,t){if("string"!=typeof e)return t;switch(e){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"visible":case"solid":return 5}return 1}(e.cursorBlinking,t.cursorBlinking),mouseWheelZoom:u(e.mouseWheelZoom,t.mouseWheelZoom),cursorSmoothCaretAnimation:u(e.cursorSmoothCaretAnimation,t.cursorSmoothCaretAnimation),cursorStyle:function(e,t){return"string"!=typeof e?t:"line"===e?g.Line:"block"===e?g.Block:"underline"===e?g.Underline:"line-thin"===e?g.LineThin:"block-outline"===e?g.BlockOutline:"underline-thin"===e?g.UnderlineThin:g.Line}(e.cursorStyle,t.cursorStyle),cursorWidth:h(e.cursorWidth,t.cursorWidth,0,Number.MAX_VALUE),
hideCursorInOverviewRuler:u(e.hideCursorInOverviewRuler,t.hideCursorInOverviewRuler),scrollBeyondLastLine:u(e.scrollBeyondLastLine,t.scrollBeyondLastLine),scrollBeyondLastColumn:h(e.scrollBeyondLastColumn,t.scrollBeyondLastColumn,0,1073741824),smoothScrolling:u(e.smoothScrolling,t.smoothScrolling),stopRenderingLineAfter:h(e.stopRenderingLineAfter,t.stopRenderingLineAfter,-1,1073741824),renderWhitespace:m,renderControlCharacters:u(e.renderControlCharacters,t.renderControlCharacters),fontLigatures:l,renderIndentGuides:u(e.renderIndentGuides,t.renderIndentGuides),highlightActiveIndentGuide:u(e.highlightActiveIndentGuide,t.highlightActiveIndentGuide),renderLineHighlight:v,scrollbar:b,minimap:C,fixedOverflowWidgets:u(e.fixedOverflowWidgets,t.fixedOverflowWidgets)}},e._sanitizeContribInfo=function(e,t){var i;i="object"==typeof e.quickSuggestions?s({other:!0},e.quickSuggestions):u(e.quickSuggestions,t.quickSuggestions),
"boolean"==typeof e.acceptSuggestionOnEnter&&(e.acceptSuggestionOnEnter=e.acceptSuggestionOnEnter?"on":"off");var n=this._sanitizeFindOpts(e.find,t.find);return{selectionClipboard:u(e.selectionClipboard,t.selectionClipboard),hover:this._sanitizeHoverOpts(e.hover,t.hover),links:u(e.links,t.links),contextmenu:u(e.contextmenu,t.contextmenu),quickSuggestions:i,quickSuggestionsDelay:h(e.quickSuggestionsDelay,t.quickSuggestionsDelay,-1073741824,1073741824),parameterHints:this._sanitizeParameterHintOpts(e.parameterHints,t.parameterHints),formatOnType:u(e.formatOnType,t.formatOnType),formatOnPaste:u(e.formatOnPaste,t.formatOnPaste),suggestOnTriggerCharacters:u(e.suggestOnTriggerCharacters,t.suggestOnTriggerCharacters),acceptSuggestionOnEnter:c(e.acceptSuggestionOnEnter,t.acceptSuggestionOnEnter,["on","smart","off"]),acceptSuggestionOnCommitCharacter:u(e.acceptSuggestionOnCommitCharacter,t.acceptSuggestionOnCommitCharacter),wordBasedSuggestions:u(e.wordBasedSuggestions,t.wordBasedSuggestions),
suggestSelection:c(e.suggestSelection,t.suggestSelection,["first","recentlyUsed","recentlyUsedByPrefix"]),suggestFontSize:h(e.suggestFontSize,t.suggestFontSize,0,1e3),suggestLineHeight:h(e.suggestLineHeight,t.suggestLineHeight,0,1e3),tabCompletion:this._sanitizeTabCompletionOpts(e.tabCompletion,t.tabCompletion),suggest:this._sanitizeSuggestOpts(e,t.suggest),gotoLocation:this._sanitizeGotoLocationOpts(e,t.gotoLocation),selectionHighlight:u(e.selectionHighlight,t.selectionHighlight),occurrencesHighlight:u(e.occurrencesHighlight,t.occurrencesHighlight),codeLens:u(e.codeLens,t.codeLens),folding:u(e.folding,t.folding),foldingStrategy:c(e.foldingStrategy,t.foldingStrategy,["auto","indentation"]),showFoldingControls:c(e.showFoldingControls,t.showFoldingControls,["always","mouseover"]),matchBrackets:u(e.matchBrackets,t.matchBrackets),find:n,colorDecorators:u(e.colorDecorators,t.colorDecorators),lightbulbEnabled:u(!!e.lightbulb&&e.lightbulb.enabled,t.lightbulbEnabled),codeActionsOnSave:function(e,t){if(!e)return t
;for(var i=Object.create(null),n=0,o=Object.keys(e);n<o.length;n++){var r=o[n],s=e[r];"boolean"==typeof s&&(i[r]=s)}return i}(e.codeActionsOnSave,{}),codeActionsOnSaveTimeout:h(e.codeActionsOnSaveTimeout,t.codeActionsOnSaveTimeout,1,1e4)}},e}();t.EditorOptionsValidator=v;var _=function(){function e(){}return e._tweakValidatedOptions=function(e,t){var n=1===t;return{inDiffEditor:e.inDiffEditor,wordSeparators:e.wordSeparators,lineNumbersMinChars:e.lineNumbersMinChars,lineDecorationsWidth:e.lineDecorationsWidth,readOnly:e.readOnly,mouseStyle:e.mouseStyle,disableLayerHinting:e.disableLayerHinting,automaticLayout:e.automaticLayout,wordWrap:e.wordWrap,wordWrapColumn:e.wordWrapColumn,wordWrapMinified:e.wordWrapMinified,wrappingIndent:e.wrappingIndent,wordWrapBreakBeforeCharacters:e.wordWrapBreakBeforeCharacters,wordWrapBreakAfterCharacters:e.wordWrapBreakAfterCharacters,wordWrapBreakObtrusiveCharacters:e.wordWrapBreakObtrusiveCharacters,autoClosingBrackets:e.autoClosingBrackets,autoClosingQuotes:e.autoClosingQuotes,
autoClosingOvertype:e.autoClosingOvertype,autoSurround:e.autoSurround,autoIndent:e.autoIndent,dragAndDrop:e.dragAndDrop,emptySelectionClipboard:e.emptySelectionClipboard,copyWithSyntaxHighlighting:e.copyWithSyntaxHighlighting,useTabStops:e.useTabStops,multiCursorModifier:e.multiCursorModifier,multiCursorMergeOverlapping:e.multiCursorMergeOverlapping,accessibilitySupport:e.accessibilitySupport,showUnused:e.showUnused,viewInfo:{extraEditorClassName:e.viewInfo.extraEditorClassName,disableMonospaceOptimizations:e.viewInfo.disableMonospaceOptimizations,rulers:e.viewInfo.rulers,ariaLabel:n?i.localize(0,null):e.viewInfo.ariaLabel,renderLineNumbers:e.viewInfo.renderLineNumbers,renderCustomLineNumbers:e.viewInfo.renderCustomLineNumbers,cursorSurroundingLines:e.viewInfo.cursorSurroundingLines,renderFinalNewline:e.viewInfo.renderFinalNewline,selectOnLineNumbers:e.viewInfo.selectOnLineNumbers,glyphMargin:e.viewInfo.glyphMargin,revealHorizontalRightPadding:e.viewInfo.revealHorizontalRightPadding,
roundedSelection:e.viewInfo.roundedSelection,overviewRulerLanes:e.viewInfo.overviewRulerLanes,overviewRulerBorder:e.viewInfo.overviewRulerBorder,cursorBlinking:e.viewInfo.cursorBlinking,mouseWheelZoom:e.viewInfo.mouseWheelZoom,cursorSmoothCaretAnimation:e.viewInfo.cursorSmoothCaretAnimation,cursorStyle:e.viewInfo.cursorStyle,cursorWidth:e.viewInfo.cursorWidth,hideCursorInOverviewRuler:e.viewInfo.hideCursorInOverviewRuler,scrollBeyondLastLine:e.viewInfo.scrollBeyondLastLine,scrollBeyondLastColumn:e.viewInfo.scrollBeyondLastColumn,smoothScrolling:e.viewInfo.smoothScrolling,stopRenderingLineAfter:e.viewInfo.stopRenderingLineAfter,renderWhitespace:e.viewInfo.renderWhitespace,renderControlCharacters:e.viewInfo.renderControlCharacters,fontLigatures:e.viewInfo.fontLigatures,renderIndentGuides:e.viewInfo.renderIndentGuides,highlightActiveIndentGuide:e.viewInfo.highlightActiveIndentGuide,renderLineHighlight:e.viewInfo.renderLineHighlight,scrollbar:e.viewInfo.scrollbar,minimap:{enabled:e.viewInfo.minimap.enabled,
side:e.viewInfo.minimap.side,renderCharacters:e.viewInfo.minimap.renderCharacters,showSlider:e.viewInfo.minimap.showSlider,maxColumn:e.viewInfo.minimap.maxColumn},fixedOverflowWidgets:e.viewInfo.fixedOverflowWidgets},contribInfo:{selectionClipboard:e.contribInfo.selectionClipboard,hover:e.contribInfo.hover,links:e.contribInfo.links,contextmenu:e.contribInfo.contextmenu,quickSuggestions:e.contribInfo.quickSuggestions,quickSuggestionsDelay:e.contribInfo.quickSuggestionsDelay,parameterHints:e.contribInfo.parameterHints,formatOnType:e.contribInfo.formatOnType,formatOnPaste:e.contribInfo.formatOnPaste,suggestOnTriggerCharacters:e.contribInfo.suggestOnTriggerCharacters,acceptSuggestionOnEnter:e.contribInfo.acceptSuggestionOnEnter,acceptSuggestionOnCommitCharacter:e.contribInfo.acceptSuggestionOnCommitCharacter,wordBasedSuggestions:e.contribInfo.wordBasedSuggestions,suggestSelection:e.contribInfo.suggestSelection,suggestFontSize:e.contribInfo.suggestFontSize,suggestLineHeight:e.contribInfo.suggestLineHeight,
tabCompletion:e.contribInfo.tabCompletion,suggest:e.contribInfo.suggest,gotoLocation:e.contribInfo.gotoLocation,selectionHighlight:e.contribInfo.selectionHighlight,occurrencesHighlight:e.contribInfo.occurrencesHighlight,codeLens:e.contribInfo.codeLens,folding:e.contribInfo.folding,foldingStrategy:e.contribInfo.foldingStrategy,showFoldingControls:e.contribInfo.showFoldingControls,matchBrackets:e.contribInfo.matchBrackets,find:e.contribInfo.find,colorDecorators:e.contribInfo.colorDecorators,lightbulbEnabled:e.contribInfo.lightbulbEnabled,codeActionsOnSave:e.contribInfo.codeActionsOnSave,codeActionsOnSaveTimeout:e.contribInfo.codeActionsOnSaveTimeout}}},e.createInternalEditorOptions=function(e,t){var i;i="auto"===t.accessibilitySupport?e.accessibilitySupport:"on"===t.accessibilitySupport?2:1;var n,o=this._tweakValidatedOptions(t,i);if("string"==typeof o.lineDecorationsWidth&&/^\d+(\.\d+)?ch$/.test(o.lineDecorationsWidth)){
n=parseFloat(o.lineDecorationsWidth.substr(0,o.lineDecorationsWidth.length-2))*e.fontInfo.typicalHalfwidthCharacterWidth}else n=h(o.lineDecorationsWidth,0,0,1e3);o.contribInfo.folding&&(n+=16);var r=y.compute({outerWidth:e.outerWidth,outerHeight:e.outerHeight,showGlyphMargin:o.viewInfo.glyphMargin,lineHeight:e.fontInfo.lineHeight,showLineNumbers:0!==o.viewInfo.renderLineNumbers,lineNumbersMinChars:o.lineNumbersMinChars,lineNumbersDigitCount:e.lineNumbersDigitCount,lineDecorationsWidth:n,typicalHalfwidthCharacterWidth:e.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:e.fontInfo.maxDigitWidth,verticalScrollbarWidth:o.viewInfo.scrollbar.verticalScrollbarSize,horizontalScrollbarHeight:o.viewInfo.scrollbar.horizontalScrollbarSize,scrollbarArrowSize:o.viewInfo.scrollbar.arrowSize,verticalScrollbarHasArrows:o.viewInfo.scrollbar.verticalHasArrows,minimap:o.viewInfo.minimap.enabled,minimapSide:o.viewInfo.minimap.side,minimapRenderCharacters:o.viewInfo.minimap.renderCharacters,
minimapMaxColumn:o.viewInfo.minimap.maxColumn,pixelRatio:e.pixelRatio}),s=null,a=o.wordWrap,l=o.wordWrapColumn,u=o.wordWrapMinified;s=2===i?{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:-1}:u&&e.isDominatedByLongLines?{isWordWrapMinified:!0,isViewportWrapping:!0,wrappingColumn:Math.max(1,r.viewportColumn)}:"on"===a?{isWordWrapMinified:!1,isViewportWrapping:!0,wrappingColumn:Math.max(1,r.viewportColumn)}:"bounded"===a?{isWordWrapMinified:!1,isViewportWrapping:!0,wrappingColumn:Math.min(Math.max(1,r.viewportColumn),l)}:"wordWrapColumn"===a?{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:l}:{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:-1};var d={inDiffEditor:o.inDiffEditor,isDominatedByLongLines:e.isDominatedByLongLines,isWordWrapMinified:s.isWordWrapMinified,isViewportWrapping:s.isViewportWrapping,wrappingColumn:s.wrappingColumn,wrappingIndent:o.wrappingIndent,wordWrapBreakBeforeCharacters:o.wordWrapBreakBeforeCharacters,
wordWrapBreakAfterCharacters:o.wordWrapBreakAfterCharacters,wordWrapBreakObtrusiveCharacters:o.wordWrapBreakObtrusiveCharacters},c="monaco-editor";return o.viewInfo.extraEditorClassName&&(c+=" "+o.viewInfo.extraEditorClassName),e.extraEditorClassName&&(c+=" "+e.extraEditorClassName),o.viewInfo.fontLigatures&&(c+=" enable-ligatures"),"default"===o.mouseStyle?c+=" mouse-default":"copy"===o.mouseStyle&&(c+=" mouse-copy"),new m({canUseLayerHinting:!o.disableLayerHinting,pixelRatio:e.pixelRatio,editorClassName:c,lineHeight:e.fontInfo.lineHeight,readOnly:o.readOnly,accessibilitySupport:i,multiCursorModifier:o.multiCursorModifier,multiCursorMergeOverlapping:o.multiCursorMergeOverlapping,wordSeparators:o.wordSeparators,autoClosingBrackets:o.autoClosingBrackets,autoClosingQuotes:o.autoClosingQuotes,autoClosingOvertype:o.autoClosingOvertype,autoSurround:o.autoSurround,autoIndent:o.autoIndent,useTabStops:o.useTabStops,tabFocusMode:!!o.readOnly||e.tabFocusMode,dragAndDrop:o.dragAndDrop,
emptySelectionClipboard:o.emptySelectionClipboard&&e.emptySelectionClipboard,copyWithSyntaxHighlighting:o.copyWithSyntaxHighlighting,layoutInfo:r,fontInfo:e.fontInfo,viewInfo:o.viewInfo,wrappingInfo:d,contribInfo:o.contribInfo,showUnused:o.showUnused})},e}();t.InternalEditorOptionsFactory=_;var y=function(){function e(){}return e.compute=function(e){var t=0|e.outerWidth,i=0|e.outerHeight,n=e.showGlyphMargin,o=0|e.lineHeight,r=e.showLineNumbers,s=0|e.lineNumbersMinChars,a=0|e.lineNumbersDigitCount,l=0|e.lineDecorationsWidth,u=e.typicalHalfwidthCharacterWidth,d=e.maxDigitWidth,c=0|e.verticalScrollbarWidth,h=e.verticalScrollbarHasArrows,p=0|e.scrollbarArrowSize,f=0|e.horizontalScrollbarHeight,g=e.minimap,m=e.minimapSide,v=e.minimapRenderCharacters,_=0|e.minimapMaxColumn,y=e.pixelRatio,b=0;if(r){var C=Math.max(a,s);b=Math.round(C*d)}var S=0;n&&(S=o);var w,E,L,x,D=0,I=D+S,N=I+b,M=N+l,k=t-S-b-l;if(g){var T=void 0;y>=2?(w=v?2:4,T=2/y):(w=v?1:3,T=1/y)
;(L=Math.max(0,Math.floor((k-c-2)*T/(u+T))))/T>_&&(L=Math.floor(_*T)),x=k-L,"left"===m?(E=0,D+=L,I+=L,N+=L,M+=L):E=t-L-c}else E=0,L=0,w=0,x=k;var R=Math.max(1,Math.floor((x-c-2)/u)),O=h?p:0;return{width:t,height:i,glyphMarginLeft:D,glyphMarginWidth:S,glyphMarginHeight:i,lineNumbersLeft:I,lineNumbersWidth:b,lineNumbersHeight:i,decorationsLeft:N,decorationsWidth:l,decorationsHeight:i,contentLeft:M,contentWidth:x,contentHeight:i,renderMinimap:w,minimapLeft:E,minimapWidth:L,viewportColumn:R,verticalScrollbarWidth:c,horizontalScrollbarHeight:f,overviewRuler:{top:O,width:c,height:i-2*O,right:0}}},e}();t.EditorLayoutProvider=y;t.EDITOR_FONT_DEFAULTS={fontFamily:r.isMacintosh?"Menlo, Monaco, 'Courier New', monospace":r.isLinux?"'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'":"Consolas, 'Courier New', monospace",fontWeight:"normal",fontSize:r.isMacintosh?12:14,lineHeight:0,letterSpacing:0},t.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,
largeFileOptimizations:!0},t.EDITOR_DEFAULTS={inDiffEditor:!1,wordSeparators:a.USUAL_WORD_SEPARATORS,lineNumbersMinChars:5,lineDecorationsWidth:10,readOnly:!1,mouseStyle:"text",disableLayerHinting:!1,automaticLayout:!1,wordWrap:"off",wordWrapColumn:80,wordWrapMinified:!0,wrappingIndent:1,wordWrapBreakBeforeCharacters:"([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋",wordWrapBreakAfterCharacters:" \t})]?|/&,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ”〉》」』】〕）］｝｣",wordWrapBreakObtrusiveCharacters:".",autoClosingBrackets:"languageDefined",autoClosingQuotes:"languageDefined",autoClosingOvertype:"auto",autoSurround:"languageDefined",autoIndent:!0,dragAndDrop:!0,emptySelectionClipboard:!0,copyWithSyntaxHighlighting:!0,useTabStops:!0,multiCursorModifier:"altKey",multiCursorMergeOverlapping:!0,accessibilitySupport:"auto",showUnused:!0,viewInfo:{extraEditorClassName:"",disableMonospaceOptimizations:!1,rulers:[],ariaLabel:i.localize(1,null),renderLineNumbers:1,renderCustomLineNumbers:null,
cursorSurroundingLines:0,renderFinalNewline:!0,selectOnLineNumbers:!0,glyphMargin:!0,revealHorizontalRightPadding:30,roundedSelection:!0,overviewRulerLanes:2,overviewRulerBorder:!0,cursorBlinking:1,mouseWheelZoom:!1,cursorSmoothCaretAnimation:!1,cursorStyle:g.Line,cursorWidth:0,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,scrollBeyondLastColumn:5,smoothScrolling:!1,stopRenderingLineAfter:1e4,renderWhitespace:"none",renderControlCharacters:!1,fontLigatures:!1,renderIndentGuides:!0,highlightActiveIndentGuide:!0,renderLineHighlight:"line",scrollbar:{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:10,horizontalSliderSize:10,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,mouseWheelScrollSensitivity:1,fastScrollSensitivity:5},minimap:{enabled:!0,side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120},fixedOverflowWidgets:!1},contribInfo:{selectionClipboard:!0,hover:{enabled:!0,delay:300,sticky:!0},
links:!0,contextmenu:!0,quickSuggestions:{other:!0,comments:!1,strings:!1},quickSuggestionsDelay:10,parameterHints:{enabled:!0,cycle:!1},formatOnType:!1,formatOnPaste:!1,suggestOnTriggerCharacters:!0,acceptSuggestionOnEnter:"on",acceptSuggestionOnCommitCharacter:!0,wordBasedSuggestions:!0,suggestSelection:"recentlyUsed",suggestFontSize:0,suggestLineHeight:0,tabCompletion:"off",suggest:{filterGraceful:!0,snippets:"inline",snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,maxVisibleSuggestions:12,filteredTypes:Object.create(null)},gotoLocation:{multiple:"peek"},selectionHighlight:!0,occurrencesHighlight:!0,codeLens:!0,folding:!0,foldingStrategy:"auto",showFoldingControls:"mouseover",matchBrackets:!0,find:{seedSearchStringFromSelection:!0,autoFindInSelection:!1,globalFindClipboard:!1,addExtraSpaceOnTop:!0},colorDecorators:!0,lightbulbEnabled:!0,codeActionsOnSave:{},codeActionsOnSaveTimeout:750}}}),define(t[117],i([1,0,18,47,112]),function(e,t,i,n,o){"use strict"
;function s(e,t){if("number"==typeof e)return e;if(void 0===e)return t;var i=parseFloat(e);return isNaN(i)?t:i}function a(e,t,i){return e<t?t:e>i?i:e}function l(e,t){return"string"!=typeof e?t:e}Object.defineProperty(t,"__esModule",{value:!0});var u=i.isMacintosh?1.5:1.35,d=function(){function e(e){this.zoomLevel=e.zoomLevel,this.fontFamily=String(e.fontFamily),this.fontWeight=String(e.fontWeight),this.fontSize=e.fontSize,this.lineHeight=0|e.lineHeight,this.letterSpacing=e.letterSpacing}return e.createFromRawSettings=function(t,i,r){void 0===r&&(r=!1);var d=l(t.fontFamily,n.EDITOR_FONT_DEFAULTS.fontFamily),c=l(t.fontWeight,n.EDITOR_FONT_DEFAULTS.fontWeight),h=s(t.fontSize,n.EDITOR_FONT_DEFAULTS.fontSize);0===(h=a(h,0,100))?h=n.EDITOR_FONT_DEFAULTS.fontSize:h<8&&(h=8);var p=function(e,t){if("number"==typeof e)return Math.round(e);if(void 0===e)return t;var i=parseInt(e);return isNaN(i)?t:i}(t.lineHeight,0);0===(p=a(p,0,150))?p=Math.round(u*h):p<8&&(p=8);var f=s(t.letterSpacing,0);f=a(f,-5,20)
;var g=1+(r?0:.1*o.EditorZoom.getZoomLevel());return h*=g,p*=g,new e({zoomLevel:i,fontFamily:d,fontWeight:c,fontSize:h,lineHeight:p,letterSpacing:f})},e.prototype.getId=function(){return this.zoomLevel+"-"+this.fontFamily+"-"+this.fontWeight+"-"+this.fontSize+"-"+this.lineHeight+"-"+this.letterSpacing},e.prototype.getMassagedFontFamily=function(){return/[,"']/.test(this.fontFamily)?this.fontFamily:/[+ ]/.test(this.fontFamily)?'"'+this.fontFamily+'"':this.fontFamily},e}();t.BareFontInfo=d;var c=function(e){function t(t,i){var n=e.call(this,t)||this;return n.isTrusted=i,n.isMonospace=t.isMonospace,n.typicalHalfwidthCharacterWidth=t.typicalHalfwidthCharacterWidth,n.typicalFullwidthCharacterWidth=t.typicalFullwidthCharacterWidth,n.canUseHalfwidthRightwardsArrow=t.canUseHalfwidthRightwardsArrow,n.spaceWidth=t.spaceWidth,n.maxDigitWidth=t.maxDigitWidth,n}return r(t,e),t.prototype.equals=function(e){
return this.fontFamily===e.fontFamily&&this.fontWeight===e.fontWeight&&this.fontSize===e.fontSize&&this.lineHeight===e.lineHeight&&this.letterSpacing===e.letterSpacing&&this.typicalHalfwidthCharacterWidth===e.typicalHalfwidthCharacterWidth&&this.typicalFullwidthCharacterWidth===e.typicalFullwidthCharacterWidth&&this.canUseHalfwidthRightwardsArrow===e.canUseHalfwidthRightwardsArrow&&this.spaceWidth===e.spaceWidth&&this.maxDigitWidth===e.maxDigitWidth},t}(d);t.FontInfo=c}),define(t[316],i([1,0,64,47,5]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){return function(e,t){this.leadingLineContent=e,this.characterCountDelta=t}}();t.LineContext=r;var s=function(){function e(t,i,o,r,s){void 0===s&&(s=n.EDITOR_DEFAULTS.contribInfo.suggest),this._snippetCompareFn=e._compareCompletionItems,this._items=t,this._column=i,this._wordDistance=r,this._options=s,this._refilterKind=1,this._lineContext=o,
"top"===s.snippets?this._snippetCompareFn=e._compareCompletionItemsSnippetsUp:"bottom"===s.snippets&&(this._snippetCompareFn=e._compareCompletionItemsSnippetsDown)}return Object.defineProperty(e.prototype,"lineContext",{get:function(){return this._lineContext},set:function(e){this._lineContext.leadingLineContent===e.leadingLineContent&&this._lineContext.characterCountDelta===e.characterCountDelta||(this._refilterKind=this._lineContext.characterCountDelta<e.characterCountDelta&&this._filteredItems?2:1,this._lineContext=e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"items",{get:function(){return this._ensureCachedState(),this._filteredItems},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"incomplete",{get:function(){return this._ensureCachedState(),this._isIncomplete},enumerable:!0,configurable:!0}),e.prototype.adopt=function(e){for(var t=new Array,i=0;i<this._items.length;)e.has(this._items[i].provider)?i++:(t.push(this._items[i]),
this._items[i]=this._items[this._items.length-1],this._items.pop());return this._refilterKind=1,t},Object.defineProperty(e.prototype,"stats",{get:function(){return this._ensureCachedState(),this._stats},enumerable:!0,configurable:!0}),e.prototype._ensureCachedState=function(){0!==this._refilterKind&&this._createCachedState()},e.prototype._createCachedState=function(){this._isIncomplete=new Set,this._stats={suggestionCount:0,snippetCount:0,textCount:0};for(var e=this._lineContext,t=e.leadingLineContent,n=e.characterCountDelta,r="",s="",a=1===this._refilterKind?this._items:this._filteredItems,l=[],u=!this._options.filterGraceful||a.length>2e3?i.fuzzyScore:i.fuzzyScoreGracefulAggressive,d=0;d<a.length;d++){var c=a[d];c.container.incomplete&&this._isIncomplete.add(c.provider);var h=c.position.column-c.completion.range.startColumn,p=h+n-(c.position.column-this._column);if(r.length!==p&&(s=(r=0===p?"":t.slice(-p)).toLowerCase()),c.word=r,0===p)c.score=i.FuzzyScore.Default;else{for(var f=0;f<h;){
var g=r.charCodeAt(f);if(32!==g&&9!==g)break;f+=1}if(f>=p)c.score=i.FuzzyScore.Default;else if("string"==typeof c.completion.filterText){if(!(m=u(r,s,f,c.completion.filterText,c.filterTextLow,0,!1)))continue;0===o.compareIgnoreCase(c.completion.filterText,c.completion.label)?c.score=m:(c.score=i.anyScore(r,s,f,c.completion.label,c.labelLow,0),c.score[0]=m[0])}else{var m=u(r,s,f,c.completion.label,c.labelLow,0,!1);if(!m)continue;c.score=m}}switch(c.idx=d,c.distance=this._wordDistance.distance(c.position,c.completion),l.push(c),this._stats.suggestionCount++,c.completion.kind){case 25:this._stats.snippetCount++;break;case 18:this._stats.textCount++}}this._filteredItems=l.sort(this._snippetCompareFn),this._refilterKind=0},e._compareCompletionItems=function(e,t){return e.score[0]>t.score[0]?-1:e.score[0]<t.score[0]?1:e.distance<t.distance?-1:e.distance>t.distance?1:e.idx<t.idx?-1:e.idx>t.idx?1:0},e._compareCompletionItemsSnippetsDown=function(t,i){if(t.completion.kind!==i.completion.kind){
if(25===t.completion.kind)return 1;if(25===i.completion.kind)return-1}return e._compareCompletionItems(t,i)},e._compareCompletionItemsSnippetsUp=function(t,i){if(t.completion.kind!==i.completion.kind){if(25===t.completion.kind)return-1;if(25===i.completion.kind)return 1}return e._compareCompletionItems(t,i)},e}();t.CompletionModel=s}),define(t[317],i([6,7]),function(e,t){return e.create("vs/editor/common/modes/modesRegistry",t)}),define(t[318],i([6,7]),function(e,t){return e.create("vs/editor/common/standaloneStrings",t)}),define(t[56],i([1,0,318]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e.noSelection=i.localize(0,null),e.singleSelectionRange=i.localize(1,null),e.singleSelection=i.localize(2,null),e.multiSelectionRange=i.localize(3,null),e.multiSelection=i.localize(4,null),e.emergencyConfOn=i.localize(5,null),e.openingDocs=i.localize(6,null),e.readonlyDiffEditor=i.localize(7,null),e.editableDiffEditor=i.localize(8,null),e.readonlyEditor=i.localize(9,null),
e.editableEditor=i.localize(10,null),e.changeConfigToOnMac=i.localize(11,null),e.changeConfigToOnWinLinux=i.localize(12,null),e.auto_on=i.localize(13,null),e.auto_off=i.localize(14,null),e.tabFocusModeOnMsg=i.localize(15,null),e.tabFocusModeOnMsgNoKb=i.localize(16,null),e.tabFocusModeOffMsg=i.localize(17,null),e.tabFocusModeOffMsgNoKb=i.localize(18,null),e.openDocMac=i.localize(19,null),e.openDocWinLinux=i.localize(20,null),e.outroMsg=i.localize(21,null),e.showAccessibilityHelpAction=i.localize(22,null)}(t.AccessibilityHelpNLS||(t.AccessibilityHelpNLS={}));!function(e){e.inspectTokensAction=i.localize(23,null)}(t.InspectTokensNLS||(t.InspectTokensNLS={}));!function(e){e.gotoLineLabelValidLineAndColumn=i.localize(24,null),e.gotoLineLabelValidLine=i.localize(25,null),e.gotoLineLabelEmptyWithLineLimit=i.localize(26,null),e.gotoLineLabelEmptyWithLineAndColumnLimit=i.localize(27,null),e.gotoLineAriaLabel=i.localize(28,null),e.gotoLineActionInput=i.localize(29,null),e.gotoLineActionLabel=i.localize(30,null)
}(t.GoToLineNLS||(t.GoToLineNLS={}));!function(e){e.ariaLabelEntryWithKey=i.localize(31,null),e.ariaLabelEntry=i.localize(32,null),e.quickCommandActionInput=i.localize(33,null),e.quickCommandActionLabel=i.localize(34,null)}(t.QuickCommandNLS||(t.QuickCommandNLS={}));!function(e){e.entryAriaLabel=i.localize(35,null),e.quickOutlineActionInput=i.localize(36,null),e.quickOutlineActionLabel=i.localize(37,null),e._symbols_=i.localize(38,null),e._modules_=i.localize(39,null),e._class_=i.localize(40,null),e._interface_=i.localize(41,null),e._method_=i.localize(42,null),e._function_=i.localize(43,null),e._property_=i.localize(44,null),e._variable_=i.localize(45,null),e._variable2_=i.localize(46,null),e._constructor_=i.localize(47,null),e._call_=i.localize(48,null)}(t.QuickOutlineNLS||(t.QuickOutlineNLS={}));!function(e){e.editorViewAccessibleLabel=i.localize(49,null),e.accessibilityHelpMessageIE=i.localize(50,null),e.accessibilityHelpMessage=i.localize(51,null)
}(t.StandaloneCodeEditorNLS||(t.StandaloneCodeEditorNLS={}));!function(e){e.toggleHighContrast=i.localize(52,null)}(t.ToggleHighContrastNLS||(t.ToggleHighContrastNLS={}));!function(e){e.bulkEditServiceSummary=i.localize(53,null)}(t.SimpleServicesNLS||(t.SimpleServicesNLS={}))}),define(t[320],i([6,7]),function(e,t){return e.create("vs/editor/common/view/editorColorRegistry",t)}),define(t[321],i([6,7]),function(e,t){return e.create("vs/editor/contrib/bracketMatching/bracketMatching",t)}),define(t[322],i([6,7]),function(e,t){return e.create("vs/editor/contrib/caretOperations/caretOperations",t)}),define(t[323],i([6,7]),function(e,t){return e.create("vs/editor/contrib/caretOperations/transpose",t)}),define(t[324],i([6,7]),function(e,t){return e.create("vs/editor/contrib/clipboard/clipboard",t)}),define(t[325],i([6,7]),function(e,t){return e.create("vs/editor/contrib/codeAction/codeActionCommands",t)}),define(t[326],i([6,7]),function(e,t){return e.create("vs/editor/contrib/codeAction/lightBulbWidget",t)}),
define(t[327],i([6,7]),function(e,t){return e.create("vs/editor/contrib/comment/comment",t)}),define(t[328],i([6,7]),function(e,t){return e.create("vs/editor/contrib/contextmenu/contextmenu",t)}),define(t[329],i([6,7]),function(e,t){return e.create("vs/editor/contrib/cursorUndo/cursorUndo",t)}),define(t[330],i([6,7]),function(e,t){return e.create("vs/editor/contrib/find/findController",t)}),define(t[331],i([6,7]),function(e,t){return e.create("vs/editor/contrib/find/findWidget",t)}),define(t[332],i([6,7]),function(e,t){return e.create("vs/editor/contrib/folding/folding",t)}),define(t[333],i([6,7]),function(e,t){return e.create("vs/editor/contrib/fontZoom/fontZoom",t)}),define(t[334],i([6,7]),function(e,t){return e.create("vs/editor/contrib/format/format",t)}),define(t[335],i([6,7]),function(e,t){return e.create("vs/editor/contrib/format/formatActions",t)}),define(t[336],i([6,7]),function(e,t){return e.create("vs/editor/contrib/goToDefinition/goToDefinitionCommands",t)}),define(t[337],i([6,7]),function(e,t){
return e.create("vs/editor/contrib/goToDefinition/goToDefinitionMouse",t)}),define(t[338],i([6,7]),function(e,t){return e.create("vs/editor/contrib/goToDefinition/goToDefinitionResultsNavigation",t)}),define(t[339],i([6,7]),function(e,t){return e.create("vs/editor/contrib/gotoError/gotoError",t)}),define(t[340],i([6,7]),function(e,t){return e.create("vs/editor/contrib/gotoError/gotoErrorWidget",t)}),define(t[341],i([6,7]),function(e,t){return e.create("vs/editor/contrib/hover/hover",t)}),define(t[342],i([6,7]),function(e,t){return e.create("vs/editor/contrib/hover/modesContentHover",t)}),define(t[343],i([6,7]),function(e,t){return e.create("vs/editor/contrib/inPlaceReplace/inPlaceReplace",t)}),define(t[344],i([6,7]),function(e,t){return e.create("vs/editor/contrib/linesOperations/linesOperations",t)}),define(t[345],i([6,7]),function(e,t){return e.create("vs/editor/contrib/links/links",t)}),define(t[346],i([6,7]),function(e,t){return e.create("vs/editor/contrib/message/messageController",t)}),
define(t[347],i([6,7]),function(e,t){return e.create("vs/editor/contrib/multicursor/multicursor",t)}),define(t[348],i([6,7]),function(e,t){return e.create("vs/editor/contrib/parameterHints/parameterHints",t)}),define(t[349],i([6,7]),function(e,t){return e.create("vs/editor/contrib/parameterHints/parameterHintsWidget",t)}),define(t[350],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/peekViewWidget",t)}),define(t[351],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/referenceSearch",t)}),define(t[352],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/referencesController",t)}),define(t[353],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/referencesModel",t)}),define(t[97],i([1,0,353,4,48,2,5,149,3]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t,i){this.parent=e,this._range=t,this.isProviderFirst=i,this._onRefChanged=new n.Emitter,
this.onRefChanged=this._onRefChanged.event,this.id=a.defaultGenerator.nextId()}return Object.defineProperty(e.prototype,"uri",{get:function(){return this.parent.uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"range",{get:function(){return this._range},set:function(e){this._range=e,this._onRefChanged.fire(this)},enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){return i.localize(0,null,o.basename(this.uri),this.range.startLineNumber,this.range.startColumn)},e}();t.OneReference=u;var d=function(){function e(e){this._modelReference=e}return e.prototype.dispose=function(){r.dispose(this._modelReference)},e.prototype.preview=function(e,t){void 0===t&&(t=8);var i=this._modelReference.object.textEditorModel;if(i){var n=e.startLineNumber,o=e.startColumn,r=e.endLineNumber,a=e.endColumn,u=i.getWordUntilPosition({lineNumber:n,column:o-t
}),d=new l.Range(n,u.startColumn,n,o),c=new l.Range(r,a,r,Number.MAX_VALUE),h=i.getValueInRange(d).replace(/^\s+/,s.empty),p=i.getValueInRange(e);return{value:h+p+i.getValueInRange(c).replace(/\s+$/,s.empty),highlight:{start:h.length,end:h.length+p.length}}}},e}();t.FilePreview=d;var c=function(){function e(e,t){this._parent=e,this._uri=t,this._children=[]}return Object.defineProperty(e.prototype,"id",{get:function(){return this._uri.toString()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parent",{get:function(){return this._parent},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"children",{get:function(){return this._children},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"preview",{get:function(){return this._preview},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"failure",{get:function(){return this._loadFailure},
enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){var e=this.children.length;return 1===e?i.localize(1,null,o.basename(this.uri),this.uri.fsPath):i.localize(2,null,e,o.basename(this.uri),this.uri.fsPath)},e.prototype.resolve=function(e){var t=this;return this._resolved?Promise.resolve(this):Promise.resolve(e.createModelReference(this._uri).then(function(e){if(!e.object)throw e.dispose(),new Error;return t._preview=new d(e),t._resolved=!0,t},function(e){return t._children=[],t._resolved=!0,t._loadFailure=e,t}))},e.prototype.dispose=function(){this._preview&&(this._preview.dispose(),this._preview=void 0)},e}();t.FileReferences=c;var h=function(){function e(t){var i=this;this._disposables=new r.DisposableStore,this.groups=[],this.references=[],this._onDidChangeReferenceRange=new n.Emitter,this.onDidChangeReferenceRange=this._onDidChangeReferenceRange.event;var o=t[0];t.sort(e._compareReferences);for(var s,a=0,d=t;a<d.length;a++){var h=d[a]
;if(s&&s.uri.toString()===h.uri.toString()||(s=new c(this,h.uri),this.groups.push(s)),0===s.children.length||!l.Range.equalsRange(h.range,s.children[s.children.length-1].range)){var p=new u(s,h.targetSelectionRange||h.range,o===h);this._disposables.add(p.onRefChanged(function(e){return i._onDidChangeReferenceRange.fire(e)})),this.references.push(p),s.children.push(p)}}}return Object.defineProperty(e.prototype,"empty",{get:function(){return 0===this.groups.length},enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){return this.empty?i.localize(3,null):1===this.references.length?i.localize(4,null,this.references[0].uri.fsPath):1===this.groups.length?i.localize(5,null,this.references.length,this.groups[0].uri.fsPath):i.localize(6,null,this.references.length,this.groups.length)},e.prototype.nextOrPreviousReference=function(e,t){var i=e.parent,n=i.children.indexOf(e),o=i.children.length,r=i.parent.groups.length;return 1===r||t&&n+1<o||!t&&n>0?(n=t?(n+1)%o:(n+o-1)%o,
i.children[n]):(n=i.parent.groups.indexOf(i),t?(n=(n+1)%r,i.parent.groups[n].children[0]):(n=(n+r-1)%r,i.parent.groups[n].children[i.parent.groups[n].children.length-1]))},e.prototype.nearestReference=function(e,t){var i=this.references.map(function(i,n){return{idx:n,prefixLen:s.commonPrefixLength(i.uri.toString(),e.toString()),offsetDist:100*Math.abs(i.range.startLineNumber-t.lineNumber)+Math.abs(i.range.startColumn-t.column)}}).sort(function(e,t){return e.prefixLen>t.prefixLen?-1:e.prefixLen<t.prefixLen?1:e.offsetDist<t.offsetDist?-1:e.offsetDist>t.offsetDist?1:0})[0];if(i)return this.references[i.idx]},e.prototype.firstReference=function(){for(var e=0,t=this.references;e<t.length;e++){var i=t[e];if(i.isProviderFirst)return i}return this.references[0]},e.prototype.dispose=function(){r.dispose(this.groups),this._disposables.dispose(),this.groups.length=0},e._compareReferences=function(e,t){var i=e.uri.toString(),n=t.uri.toString();return i<n?-1:i>n?1:l.Range.compareRangesUsingStarts(e.range,t.range)},e}()
;t.ReferencesModel=h}),define(t[355],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/referencesTree",t)}),define(t[356],i([6,7]),function(e,t){return e.create("vs/editor/contrib/referenceSearch/referencesWidget",t)}),define(t[357],i([6,7]),function(e,t){return e.create("vs/editor/contrib/rename/rename",t)}),define(t[358],i([6,7]),function(e,t){return e.create("vs/editor/contrib/rename/renameInputField",t)}),define(t[359],i([6,7]),function(e,t){return e.create("vs/editor/contrib/smartSelect/smartSelect",t)}),define(t[360],i([6,7]),function(e,t){return e.create("vs/editor/contrib/snippet/snippetVariables",t)}),define(t[361],i([6,7]),function(e,t){return e.create("vs/editor/contrib/suggest/suggestController",t)}),define(t[362],i([6,7]),function(e,t){return e.create("vs/editor/contrib/suggest/suggestWidget",t)}),define(t[363],i([6,7]),function(e,t){return e.create("vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode",t)}),define(t[364],i([6,7]),function(e,t){
return e.create("vs/editor/contrib/tokenization/tokenization",t)}),define(t[365],i([6,7]),function(e,t){return e.create("vs/editor/contrib/wordHighlighter/wordHighlighter",t)}),define(t[366],i([6,7]),function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)}),define(t[367],i([6,7]),function(e,t){return e.create("vs/platform/keybinding/common/abstractKeybindingService",t)}),define(t[368],i([6,7]),function(e,t){return e.create("vs/platform/list/browser/listService",t)}),define(t[369],i([6,7]),function(e,t){return e.create("vs/platform/markers/common/markers",t)}),define(t[370],i([6,7]),function(e,t){return e.create("vs/platform/theme/common/colorRegistry",t)}),define(t[371],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.value=e,this._lower=e.toLowerCase()}return e.toKey=function(e){return"string"==typeof e?e.toLowerCase():e._lower},e}();t.ExtensionIdentifier=i}),define(t[185],i([1,0]),function(e,t){
"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={}))}),define(t[186],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){return function(e,t,i){void 0===t&&(t=[]),void 0===i&&(i=!1),this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=i}}();t.SyncDescriptor=i}),define(t[73],i([1,0,186]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=[];t.registerSingleton=function(e,t,o){n.push([e,new i.SyncDescriptor(t,[],o)])},t.getSingletonServiceDescriptors=function(){return n}}),define(t[375],i([1,0,23,95]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e){this._hashFn=e,this._nodes=Object.create(null)}return e.prototype.roots=function(){var e=[];return n.forEach(this._nodes,function(t){
i.isEmptyObject(t.value.outgoing)&&e.push(t.value)}),e},e.prototype.insertEdge=function(e,t){var i=this.lookupOrInsertNode(e),n=this.lookupOrInsertNode(t);i.outgoing[this._hashFn(t)]=n,n.incoming[this._hashFn(e)]=i},e.prototype.removeNode=function(e){var t=this._hashFn(e);delete this._nodes[t],n.forEach(this._nodes,function(e){delete e.value.outgoing[t],delete e.value.incoming[t]})},e.prototype.lookupOrInsertNode=function(e){var t=this._hashFn(e),i=this._nodes[t];return i||(i=function(e){return{data:e,incoming:Object.create(null),outgoing:Object.create(null)}}(e),this._nodes[t]=i),i},e.prototype.isEmpty=function(){for(var e in this._nodes)return!1;return!0},e.prototype.toString=function(){var e=[];return n.forEach(this._nodes,function(t){e.push(t.key+", (incoming)["+Object.keys(t.value.incoming).join(", ")+"], (outgoing)["+Object.keys(t.value.outgoing).join(",")+"]")}),e.join("\n")},e}();t.Graph=o}),define(t[12],i([1,0]),function(e,t){"use strict";function i(e,t,i,n){
t[o.DI_TARGET]===t?t[o.DI_DEPENDENCIES].push({id:e,index:i,optional:n}):(t[o.DI_DEPENDENCIES]=[{id:e,index:i,optional:n}],t[o.DI_TARGET]=t)}function n(e){if(o.serviceIds.has(e))return o.serviceIds.get(e);var t=function(e,n,o){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(t,e,o,!1)};return t.toString=function(){return e},o.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0});var o;!function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(o=t._util||(t._util={})),t.IInstantiationService=n("instantiationService"),t.createDecorator=n,t.optional=function(e){return function(t,n,o){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");i(e,t,o,!0)}}}),define(t[163],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.IBulkEditService=i.createDecorator("IWorkspaceEditService")}),define(t[31],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ICodeEditorService=i.createDecorator("codeEditorService")}),define(t[60],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ID_EDITOR_WORKER_SERVICE="editorWorkerService",t.IEditorWorkerService=i.createDecorator(t.ID_EDITOR_WORKER_SERVICE)}),define(t[187],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IMarkerDecorationsService=i.createDecorator("markerDecorationsService")}),define(t[70],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IModeService=i.createDecorator("modeService")}),define(t[42],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IModelService=i.createDecorator("modelService"),t.shouldSynchronizeModel=function(e){
return!e.isTooLargeForSyncing()&&!e.isForSimpleWidget}}),define(t[229],i([1,0,4,2,440,42]),function(e,t,i,n,o,r){"use strict";function s(e){return"string"!=typeof e&&(Array.isArray(e)?e.every(s):!!e.exclusive)}Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(){this._clock=0,this._entries=[],this._onDidChange=new i.Emitter}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t){var i=this,o={selector:e,provider:t,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),n.toDisposable(function(){if(o){var e=i._entries.indexOf(o);e>=0&&(i._entries.splice(e,1),i._lastCandidate=void 0,i._onDidChange.fire(i._entries.length),o=void 0)}})},e.prototype.has=function(e){return this.all(e).length>0},e.prototype.all=function(e){if(!e)return[];this._updateScores(e)
;for(var t=[],i=0,n=this._entries;i<n.length;i++){var o=n[i];o._score>0&&t.push(o.provider)}return t},e.prototype.ordered=function(e){var t=[];return this._orderedForEach(e,function(e){return t.push(e.provider)}),t},e.prototype.orderedGroups=function(e){var t,i,n=[];return this._orderedForEach(e,function(e){t&&i===e._score?t.push(e.provider):(i=e._score,t=[e.provider],n.push(t))}),n},e.prototype._orderedForEach=function(e,t){if(e){this._updateScores(e);for(var i=0,n=this._entries;i<n.length;i++){var o=n[i];o._score>0&&t(o)}}},e.prototype._updateScores=function(t){var i={uri:t.uri.toString(),language:t.getLanguageIdentifier().language};if(!this._lastCandidate||this._lastCandidate.language!==i.language||this._lastCandidate.uri!==i.uri){this._lastCandidate=i;for(var n=0,a=this._entries;n<a.length;n++){var l=a[n];if(l._score=o.score(l.selector,t.uri,t.getLanguageIdentifier().language,r.shouldSynchronizeModel(t)),s(l.selector)&&l._score>0){for(var u=0,d=this._entries;u<d.length;u++){d[u]._score=0}l._score=1e3
;break}}this._entries.sort(e._compareByScoreAndTime)}},e._compareByScoreAndTime=function(e,t){return e._score<t._score?1:e._score>t._score?-1:e._time<t._time?1:e._time>t._time?-1:0},e}();t.LanguageFeatureRegistry=a}),define(t[17],i([1,0,23,24,3,229,496]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){return function(e,t){this.language=e,this.id=t}}();t.LanguageIdentifier=a;var l=function(){function e(){}return e.getLanguageId=function(e){return(255&e)>>>0},e.getTokenType=function(e){return(1792&e)>>>8},e.getFontStyle=function(e){return(14336&e)>>>11},e.getForeground=function(e){return(8372224&e)>>>14},e.getBackground=function(e){return(4286578688&e)>>>23},e.getClassNameFromMetadata=function(e){var t="mtk"+this.getForeground(e),i=this.getFontStyle(e);return 1&i&&(t+=" mtki"),2&i&&(t+=" mtkb"),4&i&&(t+=" mtku"),t},e.getInlineStyleFromMetadata=function(e,t){var i=this.getForeground(e),n=this.getFontStyle(e),o="color: "+t[i]+";"
;return 1&n&&(o+="font-style: italic;"),2&n&&(o+="font-weight: bold;"),4&n&&(o+="text-decoration: underline;"),o},e}();t.TokenMetadata=l,t.completionKindToCssClass=function(){var e=Object.create(null);return e[0]="method",e[1]="function",e[2]="constructor",e[3]="field",e[4]="variable",e[5]="class",e[6]="struct",e[7]="interface",e[8]="module",e[9]="property",e[10]="event",e[11]="operator",e[12]="unit",e[13]="value",e[14]="constant",e[15]="enum",e[16]="enum-member",e[17]="keyword",e[25]="snippet",e[18]="text",e[19]="color",e[20]="file",e[21]="reference",e[22]="customcolor",e[23]="folder",e[24]="type-parameter",function(t){return e[t]||"property"}}(),t.completionKindFromString=function(){var e=Object.create(null);return e.method=0,e.function=1,e.constructor=2,e.field=3,e.variable=4,e.class=5,e.struct=6,e.interface=7,e.module=8,e.property=9,e.event=10,e.operator=11,e.unit=12,e.value=13,e.constant=14,e.enum=15,e["enum-member"]=16,e.enumMember=16,e.keyword=17,e.snippet=25,e.text=18,e.color=19,e.file=20,
e.reference=21,e.customcolor=22,e.folder=23,e["type-parameter"]=24,e.typeParameter=24,function(t,i){var n=e[t];return void 0!==n||i||(n=9),n}}();!function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));!function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={})),t.isLocationLink=function(e){return e&&n.URI.isUri(e.uri)&&o.Range.isIRange(e.range)&&(o.Range.isIRange(e.originSelectionRange)||o.Range.isIRange(e.targetSelectionRange))},t.symbolKindToCssClass=function(){var e=Object.create(null);return e[0]="file",e[1]="module",e[2]="namespace",e[3]="package",e[4]="class",e[5]="method",e[6]="property",e[7]="field",e[8]="constructor",e[9]="enum",e[10]="interface",e[11]="function",e[12]="variable",e[13]="constant",e[14]="string",e[15]="number",e[16]="boolean",e[17]="array",e[18]="object",e[19]="key",e[20]="null",e[21]="enum-member",
e[22]="struct",e[23]="event",e[24]="operator",e[25]="type-parameter",function(t,i){return"symbol-icon "+(i?"inline":"block")+" "+(e[t]||"property")}}();var u=function(){function e(e){this.value=e}return e.Comment=new e("comment"),e.Imports=new e("imports"),e.Region=new e("region"),e}();t.FoldingRangeKind=u,t.isResourceTextEdit=function(e){return i.isObject(e)&&e.resource&&Array.isArray(e.edits)},t.ReferenceProviderRegistry=new r.LanguageFeatureRegistry,t.RenameProviderRegistry=new r.LanguageFeatureRegistry,t.CompletionProviderRegistry=new r.LanguageFeatureRegistry,t.SignatureHelpProviderRegistry=new r.LanguageFeatureRegistry,t.HoverProviderRegistry=new r.LanguageFeatureRegistry,t.DocumentSymbolProviderRegistry=new r.LanguageFeatureRegistry,t.DocumentHighlightProviderRegistry=new r.LanguageFeatureRegistry,t.DefinitionProviderRegistry=new r.LanguageFeatureRegistry,t.DeclarationProviderRegistry=new r.LanguageFeatureRegistry,t.ImplementationProviderRegistry=new r.LanguageFeatureRegistry,
t.TypeDefinitionProviderRegistry=new r.LanguageFeatureRegistry,t.CodeLensProviderRegistry=new r.LanguageFeatureRegistry,t.CodeActionProviderRegistry=new r.LanguageFeatureRegistry,t.DocumentFormattingEditProviderRegistry=new r.LanguageFeatureRegistry,t.DocumentRangeFormattingEditProviderRegistry=new r.LanguageFeatureRegistry,t.OnTypeFormattingEditProviderRegistry=new r.LanguageFeatureRegistry,t.LinkProviderRegistry=new r.LanguageFeatureRegistry,t.ColorProviderRegistry=new r.LanguageFeatureRegistry,t.SelectionRangeRegistry=new r.LanguageFeatureRegistry,t.FoldingRangeProviderRegistry=new r.LanguageFeatureRegistry,t.TokenizationRegistry=new s.TokenizationRegistryImpl}),define(t[87],i([1,0,17]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this._tokens=e,this._tokensCount=this._tokens.length>>>1,this._text=t}return e.prototype.equals=function(t){return t instanceof e&&this.slicedEquals(t,0,this._tokensCount)},e.prototype.slicedEquals=function(e,t,i){
if(this._text!==e._text)return!1;if(this._tokensCount!==e._tokensCount)return!1;for(var n=t<<1,o=n+(i<<1),r=n;r<o;r++)if(this._tokens[r]!==e._tokens[r])return!1;return!0},e.prototype.getLineContent=function(){return this._text},e.prototype.getCount=function(){return this._tokensCount},e.prototype.getStartOffset=function(e){return e>0?this._tokens[e-1<<1]:0},e.prototype.getLanguageId=function(e){var t=this._tokens[1+(e<<1)];return i.TokenMetadata.getLanguageId(t)},e.prototype.getStandardTokenType=function(e){var t=this._tokens[1+(e<<1)];return i.TokenMetadata.getTokenType(t)},e.prototype.getForeground=function(e){var t=this._tokens[1+(e<<1)];return i.TokenMetadata.getForeground(t)},e.prototype.getClassName=function(e){var t=this._tokens[1+(e<<1)];return i.TokenMetadata.getClassNameFromMetadata(t)},e.prototype.getInlineStyle=function(e,t){var n=this._tokens[1+(e<<1)];return i.TokenMetadata.getInlineStyleFromMetadata(n,t)},e.prototype.getEndOffset=function(e){return this._tokens[e<<1]},
e.prototype.findTokenIndexAtOffset=function(t){return e.findIndexInTokensArray(this._tokens,t)},e.prototype.inflate=function(){return this},e.prototype.sliceAndInflate=function(e,t,i){return new o(this,e,t,i)},e.convertToEndOffset=function(e,t){for(var i=(e.length>>>1)-1,n=0;n<i;n++)e[n<<1]=e[n+1<<1];e[i<<1]=t},e.findIndexInTokensArray=function(e,t){if(e.length<=2)return 0;for(var i=0,n=(e.length>>>1)-1;i<n;){var o=i+Math.floor((n-i)/2),r=e[o<<1];if(r===t)return o+1;r<t?i=o+1:r>t&&(n=o)}return i},e}();t.LineTokens=n;var o=function(){function e(e,t,i,n){this._source=e,this._startOffset=t,this._endOffset=i,this._deltaOffset=n,this._firstTokenIndex=e.findTokenIndexAtOffset(t),this._tokensCount=0;for(var o=this._firstTokenIndex,r=e.getCount();o<r;o++){if(e.getStartOffset(o)>=i)break;this._tokensCount++}}return e.prototype.equals=function(t){
return t instanceof e&&(this._startOffset===t._startOffset&&this._endOffset===t._endOffset&&this._deltaOffset===t._deltaOffset&&this._source.slicedEquals(t._source,this._firstTokenIndex,this._tokensCount))},e.prototype.getCount=function(){return this._tokensCount},e.prototype.getForeground=function(e){return this._source.getForeground(this._firstTokenIndex+e)},e.prototype.getEndOffset=function(e){var t=this._source.getEndOffset(this._firstTokenIndex+e);return Math.min(this._endOffset,t)-this._startOffset+this._deltaOffset},e.prototype.getClassName=function(e){return this._source.getClassName(this._firstTokenIndex+e)},e.prototype.getInlineStyle=function(e,t){return this._source.getInlineStyle(this._firstTokenIndex+e,t)},e.prototype.findTokenIndexAtOffset=function(e){return this._source.findTokenIndexAtOffset(e+this._startOffset-this._deltaOffset)-this._firstTokenIndex},e}();t.SlicedLineTokens=o}),define(t[188],i([1,0,19,87,13,17]),function(e,t,i,n,o,r){"use strict";function s(e){return(16384|e<<0|2<<23)>>>0}
function a(e){return e instanceof Uint32Array?e:new Uint32Array(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.countEOL=function(e){for(var t=0,i=0,n=0,o=e.length;n<o;n++){var r=e.charCodeAt(n);13===r?(0===t&&(i=n),t++,n+1<o&&10===e.charCodeAt(n+1)&&n++):10===r&&(0===t&&(i=n),t++)}return 0===t&&(i=e.length),[t,i]};var l=new Uint32Array(0).buffer,u=function(){function e(){this.tokens=[]}return e.prototype.add=function(e,t){if(this.tokens.length>0){var i=this.tokens[this.tokens.length-1];if(i.startLineNumber+i.tokens.length-1+1===e)return void i.tokens.push(t)}this.tokens.push(new d(e,[t]))},e}();t.MultilineTokensBuilder=u;var d=function(){return function(e,t){this.startLineNumber=e,this.tokens=t}}();t.MultilineTokens=d;var c=function(){function e(){this._lineTokens=[],this._len=0}return e.prototype.flush=function(){this._lineTokens=[],this._len=0},e.prototype.getTokens=function(e,t,i){var o=null;if(t<this._len&&(o=this._lineTokens[t]),null!==o&&o!==l)return new n.LineTokens(a(o),i)
;var r=new Uint32Array(2);return r[0]=i.length,r[1]=s(e),new n.LineTokens(r,i)},e._massageTokens=function(e,t,i){var n=i?a(i):null;if(0===t){var o=!1;if(n&&n.length>1&&(o=r.TokenMetadata.getLanguageId(n[1])!==e),!o)return l}if(!n||0===n.length){var u=new Uint32Array(2);return u[0]=t,u[1]=s(e),u.buffer}return n[n.length-2]=t,0===n.byteOffset&&n.byteLength===n.buffer.byteLength?n.buffer:n},e.prototype._ensureLine=function(e){for(;e>=this._len;)this._lineTokens[this._len]=null,this._len++},e.prototype._deleteLines=function(e,t){0!==t&&(e+t>this._len&&(t=this._len-e),this._lineTokens.splice(e,t),this._len-=t)},e.prototype._insertLines=function(e,t){if(0!==t){for(var n=[],o=0;o<t;o++)n[o]=null;this._lineTokens=i.arrayInsert(this._lineTokens,e,n),this._len+=t}},e.prototype.setTokens=function(t,i,n,o){var r=e._massageTokens(t,n,o);this._ensureLine(i),this._lineTokens[i]=r},e.prototype.acceptEdit=function(e,t,i){this._acceptDeleteRange(e),this._acceptInsertText(new o.Position(e.startLineNumber,e.startColumn),t,i)},
e.prototype._acceptDeleteRange=function(t){var i=t.startLineNumber-1;if(!(i>=this._len))if(t.startLineNumber!==t.endLineNumber){this._lineTokens[i]=e._deleteEnding(this._lineTokens[i],t.startColumn-1);var n=t.endLineNumber-1,o=null;n<this._len&&(o=e._deleteBeginning(this._lineTokens[n],t.endColumn-1)),this._lineTokens[i]=e._append(this._lineTokens[i],o),this._deleteLines(t.startLineNumber,t.endLineNumber-t.startLineNumber)}else{if(t.startColumn===t.endColumn)return;this._lineTokens[i]=e._delete(this._lineTokens[i],t.startColumn-1,t.endColumn-1)}},e.prototype._acceptInsertText=function(t,i,n){if(0!==i||0!==n){var o=t.lineNumber-1;o>=this._len||(0!==i?(this._lineTokens[o]=e._deleteEnding(this._lineTokens[o],t.column-1),this._lineTokens[o]=e._insert(this._lineTokens[o],t.column-1,n),this._insertLines(t.lineNumber,i)):this._lineTokens[o]=e._insert(this._lineTokens[o],t.column-1,n))}},e._deleteBeginning=function(t,i){return null===t||t===l?t:e._delete(t,0,i)},e._deleteEnding=function(t,i){
if(null===t||t===l)return t;var n=a(t),o=n[n.length-2];return e._delete(t,i,o)},e._delete=function(e,t,i){if(null===e||e===l||t===i)return e;var o=a(e),r=o.length>>>1;if(0===t&&o[o.length-2]===i)return l;var s=n.LineTokens.findIndexInTokensArray(o,t),u=s>0?o[s-1<<1]:0;if(i<o[s<<1]){for(var d=i-t,c=s;c<r;c++)o[c<<1]-=d;return e}var h,p;u!==t?(o[s<<1]=t,h=s+1<<1,p=t):(h=s<<1,p=u);for(var f=i-t,g=s+1;g<r;g++){var m=o[g<<1]-f;m>p&&(o[h++]=m,o[h++]=o[1+(g<<1)],p=m)}if(h===o.length)return e;var v=new Uint32Array(h);return v.set(o.subarray(0,h),0),v.buffer},e._append=function(e,t){if(t===l)return e;if(e===l)return t;if(null===e)return e;if(null===t)return null;var i=a(e),n=a(t),o=n.length>>>1,r=new Uint32Array(i.length+n.length);r.set(i,0);for(var s=i.length,u=i[i.length-2],d=0;d<o;d++)r[s++]=n[d<<1]+u,r[s++]=n[1+(d<<1)];return r.buffer},e._insert=function(e,t,i){if(null===e||e===l)return e;var o=a(e),r=o.length>>>1,s=n.LineTokens.findIndexInTokensArray(o,t);if(s>0){o[s-1<<1]===t&&s--}for(var u=s;u<r;u++)o[u<<1]+=i
;return e},e}();t.TokensStore=c}),define(t[63],i([1,0,106,17]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){}return e.prototype.clone=function(){return this},e.prototype.equals=function(e){return this===e},e}();t.NULL_STATE=new o,t.NULL_MODE_ID="vs.editor.nullMode",t.NULL_LANGUAGE_IDENTIFIER=new n.LanguageIdentifier(t.NULL_MODE_ID,0),t.nullTokenize=function(e,t,n,o){return new i.TokenizationResult([new i.Token(o,"",e)],n)},t.nullTokenize2=function(e,n,o,r){var s=new Uint32Array(2);return s[0]=r,s[1]=(16384|e<<0|2<<23)>>>0,new i.TokenizationResult2(s,null===o?t.NULL_STATE:o)}}),define(t[388],i([1,0,19,10,87,13,17,63,2,127,188]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";function h(e,t,i,r){var s=null;if(t)try{s=t.tokenize2(i,r.clone(),0)}catch(e){n.onUnexpectedError(e)}return s||(s=l.nullTokenize2(e.id,i,r,0)),o.LineTokens.convertToEndOffset(s.tokens,i.length),s}Object.defineProperty(t,"__esModule",{value:!0});var p=function(){function e(){
this._beginState=[],this._valid=[],this._len=0,this._invalidLineStartIndex=0}return e.prototype._reset=function(e){this._beginState=[],this._valid=[],this._len=0,this._invalidLineStartIndex=0,e&&this._setBeginState(0,e)},e.prototype.flush=function(e){this._reset(e)},Object.defineProperty(e.prototype,"invalidLineStartIndex",{get:function(){return this._invalidLineStartIndex},enumerable:!0,configurable:!0}),e.prototype._invalidateLine=function(e){e<this._len&&(this._valid[e]=!1),e<this._invalidLineStartIndex&&(this._invalidLineStartIndex=e)},e.prototype._isValid=function(e){return e<this._len&&this._valid[e]},e.prototype.getBeginState=function(e){return e<this._len?this._beginState[e]:null},e.prototype._ensureLine=function(e){for(;e>=this._len;)this._beginState[this._len]=null,this._valid[this._len]=!1,this._len++},e.prototype._deleteLines=function(e,t){0!==t&&(e+t>this._len&&(t=this._len-e),this._beginState.splice(e,t),this._valid.splice(e,t),this._len-=t)},e.prototype._insertLines=function(e,t){if(0!==t){
for(var n=[],o=[],r=0;r<t;r++)n[r]=null,o[r]=!1;this._beginState=i.arrayInsert(this._beginState,e,n),this._valid=i.arrayInsert(this._valid,e,o),this._len+=t}},e.prototype._setValid=function(e,t){this._ensureLine(e),this._valid[e]=t},e.prototype._setBeginState=function(e,t){this._ensureLine(e),this._beginState[e]=t},e.prototype.setEndState=function(e,t,i){if(this._setValid(t,!0),this._invalidLineStartIndex=t+1,t!==e-1){var n=this.getBeginState(t+1);if(null===n||!i.equals(n))return this._setBeginState(t+1,i),void this._invalidateLine(t+1);for(var o=t+1;o<e&&this._isValid(o);)o++;this._invalidLineStartIndex=o}},e.prototype.setFakeTokens=function(e){this._setValid(e,!1)},e.prototype.applyEdits=function(e,t){for(var i=e.endLineNumber-e.startLineNumber,n=t,o=Math.min(i,n);o>=0;o--)this._invalidateLine(e.startLineNumber+o-1);this._acceptDeleteRange(e),this._acceptInsertText(new s.Position(e.startLineNumber,e.startColumn),t)},e.prototype._acceptDeleteRange=function(e){
e.startLineNumber-1>=this._len||this._deleteLines(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){e.lineNumber-1>=this._len||this._insertLines(e.lineNumber,t)},e}();t.TokenizationStateStore=p;var f=function(e){function t(t){var i=e.call(this)||this;return i._textModel=t,i._tokenizationStateStore=new p,i._revalidateTokensTimeout=-1,i._tokenizationSupport=null,i._register(a.TokenizationRegistry.onDidChange(function(e){var t=i._textModel.getLanguageIdentifier();-1!==e.changedLanguages.indexOf(t.language)&&(i._resetTokenizationState(),i._textModel.clearTokens())})),i._register(i._textModel.onDidChangeRawContentFast(function(e){e.containsEvent(1)&&i._resetTokenizationState()})),i._register(i._textModel.onDidChangeContentFast(function(e){for(var t=0,n=e.changes.length;t<n;t++){var o=e.changes[t],r=c.countEOL(o.text)[0];i._tokenizationStateStore.applyEdits(o.range,r)}i._beginBackgroundTokenization()})),i._register(i._textModel.onDidChangeAttached(function(){
i._beginBackgroundTokenization()})),i._register(i._textModel.onDidChangeLanguage(function(){i._resetTokenizationState(),i._textModel.clearTokens()})),i._resetTokenizationState(),i}return r(t,e),t.prototype.dispose=function(){this._clearTimers(),e.prototype.dispose.call(this)},t.prototype._clearTimers=function(){-1!==this._revalidateTokensTimeout&&(clearTimeout(this._revalidateTokensTimeout),this._revalidateTokensTimeout=-1)},t.prototype._resetTokenizationState=function(){this._clearTimers();var e=function(e){var t=e.getLanguageIdentifier(),i=e.isTooLargeForTokenization()?null:a.TokenizationRegistry.get(t.language),o=null;if(i)try{o=i.getInitialState()}catch(e){n.onUnexpectedError(e),i=null}return[i,o]}(this._textModel),t=e[0],i=e[1];this._tokenizationSupport=t,this._tokenizationStateStore.flush(i),this._beginBackgroundTokenization()},t.prototype._beginBackgroundTokenization=function(){var e=this
;this._textModel.isAttachedToEditor()&&this._hasLinesToTokenize()&&-1===this._revalidateTokensTimeout&&(this._revalidateTokensTimeout=setTimeout(function(){e._revalidateTokensTimeout=-1,e._revalidateTokensNow()},0))},t.prototype._revalidateTokensNow=function(e){void 0===e&&(e=this._textModel.getLineCount());for(var t=new c.MultilineTokensBuilder,i=d.StopWatch.create(!1);this._hasLinesToTokenize()&&!(i.elapsed()>20);){if(this._tokenizeOneInvalidLine(t)>=e)break}this._beginBackgroundTokenization(),this._textModel.setTokens(t.tokens)},t.prototype.tokenizeViewport=function(e,t){var i=new c.MultilineTokensBuilder;this._tokenizeViewport(i,e,t),this._textModel.setTokens(i.tokens)},t.prototype.reset=function(){this._resetTokenizationState(),this._textModel.clearTokens()},t.prototype.forceTokenization=function(e){var t=new c.MultilineTokensBuilder;this._updateTokensUntilLine(t,e),this._textModel.setTokens(t.tokens)},t.prototype.isCheapToTokenize=function(e){if(!this._tokenizationSupport)return!0
;var t=this._tokenizationStateStore.invalidLineStartIndex+1;return!(e>t)&&(e<t||this._textModel.getLineLength(e)<2048)},t.prototype._hasLinesToTokenize=function(){return!!this._tokenizationSupport&&this._tokenizationStateStore.invalidLineStartIndex<this._textModel.getLineCount()},t.prototype._tokenizeOneInvalidLine=function(e){if(!this._hasLinesToTokenize())return this._textModel.getLineCount()+1;var t=this._tokenizationStateStore.invalidLineStartIndex+1;return this._updateTokensUntilLine(e,t),t},t.prototype._updateTokensUntilLine=function(e,t){if(this._tokenizationSupport)for(var i=this._textModel.getLanguageIdentifier(),n=this._textModel.getLineCount(),o=t-1,r=this._tokenizationStateStore.invalidLineStartIndex;r<=o;r++){var s=this._textModel.getLineContent(r+1),a=this._tokenizationStateStore.getBeginState(r),l=h(i,this._tokenizationSupport,s,a);e.add(r+1,l.tokens),this._tokenizationStateStore.setEndState(n,r,l.endState),r=this._tokenizationStateStore.invalidLineStartIndex-1}},
t.prototype._tokenizeViewport=function(e,t,i){if(this._tokenizationSupport&&!(i<=this._tokenizationStateStore.invalidLineStartIndex))if(t<=this._tokenizationStateStore.invalidLineStartIndex)this._updateTokensUntilLine(e,i);else{for(var n=this._textModel.getLineFirstNonWhitespaceColumn(t),o=[],r=null,s=t-1;n>0&&s>=1;s--){var a=this._textModel.getLineFirstNonWhitespaceColumn(s);if(0!==a&&a<n){if(r=this._tokenizationStateStore.getBeginState(s-1))break;o.push(this._textModel.getLineContent(s)),n=a}}r||(r=this._tokenizationSupport.getInitialState());for(var l=this._textModel.getLanguageIdentifier(),u=r,s=o.length-1;s>=0;s--){u=(p=h(l,this._tokenizationSupport,o[s],u)).endState}for(var d=t;d<=i;d++){var c=this._textModel.getLineContent(d),p=h(l,this._tokenizationSupport,c,u);e.add(d,p.tokens),this._tokenizationStateStore.setFakeTokens(d-1),u=p.endState}}},t}(u.Disposable);t.TextModelTokenization=f}),
define(t[30],i([1,0,10,4,2,5,24,47,13,3,20,49,380,386,391,414,394,147,388,99,40,63,144,143,23,188,25]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D){"use strict";function I(e){var t=new m.PieceTreeTextBufferBuilder;return t.acceptChunk(e),t.finish()}function N(e,t){return("string"==typeof e?I(e):e).create(t)}function M(e){return e.replace(/[^a-z0-9\-_]/gi," ")}function k(e){return e instanceof V?e:V.createDynamic(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.createTextBufferFactory=I,t.createTextBuffer=N;var T=0;t.LONG_LINE_BOUNDARY=1e4;var R=function(){throw new Error("Invalid change accessor")},O=function(e){function o(t,i,r,l){void 0===l&&(l=null);var u=e.call(this)||this;u._onWillDispose=u._register(new n.Emitter),u.onWillDispose=u._onWillDispose.event,u._onDidChangeDecorations=u._register(new H),u.onDidChangeDecorations=u._onDidChangeDecorations.event,u._onDidChangeLanguage=u._register(new n.Emitter),u.onDidChangeLanguage=u._onDidChangeLanguage.event,
u._onDidChangeLanguageConfiguration=u._register(new n.Emitter),u.onDidChangeLanguageConfiguration=u._onDidChangeLanguageConfiguration.event,u._onDidChangeTokens=u._register(new n.Emitter),u.onDidChangeTokens=u._onDidChangeTokens.event,u._onDidChangeOptions=u._register(new n.Emitter),u.onDidChangeOptions=u._onDidChangeOptions.event,u._onDidChangeAttached=u._register(new n.Emitter),u.onDidChangeAttached=u._onDidChangeAttached.event,u._eventEmitter=u._register(new z),T++,u.id="$model"+T,u.isForSimpleWidget=i.isForSimpleWidget,u._associatedResource=void 0===l||null===l?a.URI.parse("inmemory://model/"+T):l,u._attachedEditorCount=0,u._buffer=N(t,i.defaultEOL),u._options=o.resolveOptions(u._buffer,i);var c=u._buffer.getLineCount(),h=u._buffer.getValueLengthInRange(new d.Range(1,1,c,u._buffer.getLineLength(c)+1),0);return i.largeFileOptimizations?u._isTooLargeForTokenization=h>o.LARGE_FILE_SIZE_THRESHOLD||c>o.LARGE_FILE_LINE_COUNT_THRESHOLD:u._isTooLargeForTokenization=!1,u._isTooLargeForSyncing=h>o.MODEL_SYNC_LIMIT,
u._versionId=1,u._alternativeVersionId=1,u._isDisposed=!1,u._isDisposing=!1,u._languageIdentifier=r||S.NULL_LANGUAGE_IDENTIFIER,u._languageRegistryListener=C.LanguageConfigurationRegistry.onDidChange(function(e){e.languageIdentifier.id===u._languageIdentifier.id&&u._onDidChangeLanguageConfiguration.fire({})}),u._instanceId=s.singleLetterHash(T),u._lastDecorationId=0,u._decorations=Object.create(null),u._decorationsTree=new P,u._commandManager=new p.EditStack(u),u._isUndoing=!1,u._isRedoing=!1,u._trimAutoWhitespaceLines=null,u._tokens=new x.TokensStore,u._tokenization=new y.TextModelTokenization(u),u}return r(o,e),o.createFromString=function(e,t,i,n){return void 0===t&&(t=o.DEFAULT_CREATION_OPTIONS),void 0===i&&(i=null),void 0===n&&(n=null),new o(e,t,i,n)},o.resolveOptions=function(e,t){if(t.detectIndentation){var i=f.guessIndentation(e,t.tabSize,t.insertSpaces);return new h.TextModelResolvedOptions({tabSize:i.tabSize,indentSize:i.tabSize,insertSpaces:i.insertSpaces,trimAutoWhitespace:t.trimAutoWhitespace,
defaultEOL:t.defaultEOL})}return new h.TextModelResolvedOptions({tabSize:t.tabSize,indentSize:t.indentSize,insertSpaces:t.insertSpaces,trimAutoWhitespace:t.trimAutoWhitespace,defaultEOL:t.defaultEOL})},o.prototype.onDidChangeRawContentFast=function(e){return this._eventEmitter.fastEvent(function(t){return e(t.rawContentChangedEvent)})},o.prototype.onDidChangeRawContent=function(e){return this._eventEmitter.slowEvent(function(t){return e(t.rawContentChangedEvent)})},o.prototype.onDidChangeContentFast=function(e){return this._eventEmitter.fastEvent(function(t){return e(t.contentChangedEvent)})},o.prototype.onDidChangeContent=function(e){return this._eventEmitter.slowEvent(function(t){return e(t.contentChangedEvent)})},o.prototype.dispose=function(){this._isDisposing=!0,this._onWillDispose.fire(),this._languageRegistryListener.dispose(),this._tokenization.dispose(),this._isDisposed=!0,e.prototype.dispose.call(this),this._isDisposing=!1},o.prototype._assertNotDisposed=function(){
if(this._isDisposed)throw new Error("Model is disposed!")},o.prototype._emitContentChangedEvent=function(e,t){this._isDisposing||this._eventEmitter.fire(new v.InternalModelContentChangeEvent(e,t))},o.prototype.setValue=function(e){if(this._assertNotDisposed(),null!==e){var t=N(e,this._options.defaultEOL);this.setValueFromTextBuffer(t)}},o.prototype._createContentChanged2=function(e,t,i,n,o,r,s){return{changes:[{range:e,rangeOffset:t,rangeLength:i,text:n}],eol:this._buffer.getEOL(),versionId:this.getVersionId(),isUndoing:o,isRedoing:r,isFlush:s}},o.prototype.setValueFromTextBuffer=function(e){if(this._assertNotDisposed(),null!==e){var t=this.getFullModelRange(),i=this.getValueLengthInRange(t),n=this.getLineCount(),o=this.getLineMaxColumn(n);this._buffer=e,this._increaseVersionId(),this._tokens.flush(),this._decorations=Object.create(null),this._decorationsTree=new P,this._commandManager=new p.EditStack(this),this._trimAutoWhitespaceLines=null,
this._emitContentChangedEvent(new v.ModelRawContentChangedEvent([new v.ModelRawFlush],this._versionId,!1,!1),this._createContentChanged2(new d.Range(1,1,n,o),0,i,this.getValue(),!1,!1,!0))}},o.prototype.setEOL=function(e){this._assertNotDisposed();var t=1===e?"\r\n":"\n";if(this._buffer.getEOL()!==t){var i=this.getFullModelRange(),n=this.getValueLengthInRange(i),o=this.getLineCount(),r=this.getLineMaxColumn(o);this._onBeforeEOLChange(),this._buffer.setEOL(t),this._increaseVersionId(),this._onAfterEOLChange(),this._emitContentChangedEvent(new v.ModelRawContentChangedEvent([new v.ModelRawEOLChanged],this._versionId,!1,!1),this._createContentChanged2(new d.Range(1,1,o,r),0,n,this.getValue(),!1,!1,!1))}},o.prototype._onBeforeEOLChange=function(){var e=this.getVersionId(),t=this._decorationsTree.search(0,!1,!1,e);this._ensureNodesHaveRanges(t)},o.prototype._onAfterEOLChange=function(){for(var e=this.getVersionId(),t=this._decorationsTree.collectNodesPostOrder(),i=0,n=t.length;i<n;i++){
var o=t[i],r=o.cachedAbsoluteStart-o.start,s=this._buffer.getOffsetAt(o.range.startLineNumber,o.range.startColumn),a=this._buffer.getOffsetAt(o.range.endLineNumber,o.range.endColumn);o.cachedAbsoluteStart=s,o.cachedAbsoluteEnd=a,o.cachedVersionId=e,o.start=s-r,o.end=a-r,g.recomputeMaxEnd(o)}},o.prototype.onBeforeAttached=function(){this._attachedEditorCount++,1===this._attachedEditorCount&&this._onDidChangeAttached.fire(void 0)},o.prototype.onBeforeDetached=function(){this._attachedEditorCount--,0===this._attachedEditorCount&&this._onDidChangeAttached.fire(void 0)},o.prototype.isAttachedToEditor=function(){return this._attachedEditorCount>0},o.prototype.getAttachedEditorCount=function(){return this._attachedEditorCount},o.prototype.isTooLargeForSyncing=function(){return this._isTooLargeForSyncing},o.prototype.isTooLargeForTokenization=function(){return this._isTooLargeForTokenization},o.prototype.isDisposed=function(){return this._isDisposed},o.prototype.isDominatedByLongLines=function(){
if(this._assertNotDisposed(),this.isTooLargeForTokenization())return!1;for(var e=0,i=0,n=this._buffer.getLineCount(),o=1;o<=n;o++){var r=this._buffer.getLineLength(o);r>=t.LONG_LINE_BOUNDARY?i+=r:e+=r}return i>e},Object.defineProperty(o.prototype,"uri",{get:function(){return this._associatedResource},enumerable:!0,configurable:!0}),o.prototype.getOptions=function(){return this._assertNotDisposed(),this._options},o.prototype.getFormattingOptions=function(){return{tabSize:this._options.indentSize,insertSpaces:this._options.insertSpaces}},o.prototype.updateOptions=function(e){this._assertNotDisposed();var t=void 0!==e.tabSize?e.tabSize:this._options.tabSize,i=void 0!==e.indentSize?e.indentSize:this._options.indentSize,n=void 0!==e.insertSpaces?e.insertSpaces:this._options.insertSpaces,o=void 0!==e.trimAutoWhitespace?e.trimAutoWhitespace:this._options.trimAutoWhitespace,r=new h.TextModelResolvedOptions({tabSize:t,indentSize:i,insertSpaces:n,defaultEOL:this._options.defaultEOL,trimAutoWhitespace:o})
;if(!this._options.equals(r)){var s=this._options.createChangeEvent(r);this._options=r,this._onDidChangeOptions.fire(s)}},o.prototype.detectIndentation=function(e,t){this._assertNotDisposed();var i=f.guessIndentation(this._buffer,t,e);this.updateOptions({insertSpaces:i.insertSpaces,tabSize:i.tabSize,indentSize:i.tabSize})},o._normalizeIndentationFromWhitespace=function(e,t,i){for(var n=0,o=0;o<e.length;o++)"\t"===e.charAt(o)?n+=t:n++;var r="";if(!i){var s=Math.floor(n/t);n%=t;for(o=0;o<s;o++)r+="\t"}for(o=0;o<n;o++)r+=" ";return r},o.normalizeIndentation=function(e,t,i){var n=s.firstNonWhitespaceIndex(e);return-1===n&&(n=e.length),o._normalizeIndentationFromWhitespace(e.substring(0,n),t,i)+e.substring(n)},o.prototype.normalizeIndentation=function(e){return this._assertNotDisposed(),o.normalizeIndentation(e,this._options.indentSize,this._options.insertSpaces)},o.prototype.getVersionId=function(){return this._assertNotDisposed(),this._versionId},o.prototype.mightContainRTL=function(){
return this._buffer.mightContainRTL()},o.prototype.mightContainNonBasicASCII=function(){return this._buffer.mightContainNonBasicASCII()},o.prototype.getAlternativeVersionId=function(){return this._assertNotDisposed(),this._alternativeVersionId},o.prototype.getOffsetAt=function(e){this._assertNotDisposed();var t=this._validatePosition(e.lineNumber,e.column,!1);return this._buffer.getOffsetAt(t.lineNumber,t.column)},o.prototype.getPositionAt=function(e){this._assertNotDisposed();var t=Math.min(this._buffer.getLength(),Math.max(0,e));return this._buffer.getPositionAt(t)},o.prototype._increaseVersionId=function(){this._versionId=this._versionId+1,this._alternativeVersionId=this._versionId},o.prototype._overwriteAlternativeVersionId=function(e){this._alternativeVersionId=e},o.prototype.getValue=function(e,t){void 0===t&&(t=!1),this._assertNotDisposed();var i=this.getFullModelRange(),n=this.getValueInRange(i,e);return t?this._buffer.getBOM()+n:n},o.prototype.getValueLength=function(e,t){void 0===t&&(t=!1),
this._assertNotDisposed();var i=this.getFullModelRange(),n=this.getValueLengthInRange(i,e);return t?this._buffer.getBOM().length+n:n},o.prototype.getValueInRange=function(e,t){return void 0===t&&(t=0),this._assertNotDisposed(),this._buffer.getValueInRange(this.validateRange(e),t)},o.prototype.getValueLengthInRange=function(e,t){return void 0===t&&(t=0),this._assertNotDisposed(),this._buffer.getValueLengthInRange(this.validateRange(e),t)},o.prototype.getLineCount=function(){return this._assertNotDisposed(),this._buffer.getLineCount()},o.prototype.getLineContent=function(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineContent(e)},o.prototype.getLineLength=function(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLength(e)},o.prototype.getLinesContent=function(){return this._assertNotDisposed(),this._buffer.getLinesContent()},
o.prototype.getEOL=function(){return this._assertNotDisposed(),this._buffer.getEOL()},o.prototype.getLineMinColumn=function(e){return this._assertNotDisposed(),1},o.prototype.getLineMaxColumn=function(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLength(e)+1},o.prototype.getLineFirstNonWhitespaceColumn=function(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineFirstNonWhitespaceColumn(e)},o.prototype.getLineLastNonWhitespaceColumn=function(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLastNonWhitespaceColumn(e)},o.prototype._validateRangeRelaxedNoAllocations=function(e){var t,i,n=this._buffer.getLineCount(),o=e.startLineNumber,r=e.startColumn;if(o<1)t=1,i=1;else if(o>n)t=n,i=this.getLineMaxColumn(t);else if(t=0|o,r<=1)i=1;else{
i=r>=(h=this.getLineMaxColumn(t))?h:0|r}var s,a,l=e.endLineNumber,u=e.endColumn;if(l<1)s=1,a=1;else if(l>n)s=n,a=this.getLineMaxColumn(s);else if(s=0|l,u<=1)a=1;else{var h=this.getLineMaxColumn(s);a=u>=h?h:0|u}return o===t&&r===i&&l===s&&u===a&&e instanceof d.Range&&!(e instanceof c.Selection)?e:new d.Range(t,i,s,a)},o.prototype._isValidPosition=function(e,t,i){if("number"!=typeof e||"number"!=typeof t)return!1;if(isNaN(e)||isNaN(t))return!1;if(e<1||t<1)return!1;if((0|e)!==e||(0|t)!==t)return!1;if(e>this._buffer.getLineCount())return!1;if(t>this.getLineMaxColumn(e))return!1;if(i&&t>1){var n=this._buffer.getLineCharCode(e,t-2);if(s.isHighSurrogate(n))return!1}return!0},o.prototype._validatePosition=function(e,t,i){var n=Math.floor("number"!=typeof e||isNaN(e)?1:e),o=Math.floor("number"!=typeof t||isNaN(t)?1:t),r=this._buffer.getLineCount();if(n<1)return new u.Position(1,1);if(n>r)return new u.Position(r,this.getLineMaxColumn(r));if(o<=1)return new u.Position(n,1);var a=this.getLineMaxColumn(n)
;if(o>=a)return new u.Position(n,a);if(i){var l=this._buffer.getLineCharCode(n,o-2);if(s.isHighSurrogate(l))return new u.Position(n,o-1)}return new u.Position(n,o)},o.prototype.validatePosition=function(e){return this._assertNotDisposed(),e instanceof u.Position&&this._isValidPosition(e.lineNumber,e.column,!0)?e:this._validatePosition(e.lineNumber,e.column,!0)},o.prototype._isValidRange=function(e,t){var i=e.startLineNumber,n=e.startColumn,o=e.endLineNumber,r=e.endColumn;if(!this._isValidPosition(i,n,!1))return!1;if(!this._isValidPosition(o,r,!1))return!1;if(t){var a=n>1?this._buffer.getLineCharCode(i,n-2):0,l=r>1&&r<=this._buffer.getLineLength(o)?this._buffer.getLineCharCode(o,r-2):0,u=s.isHighSurrogate(a),d=s.isHighSurrogate(l);return!u&&!d}return!0},o.prototype.validateRange=function(e){if(this._assertNotDisposed(),e instanceof d.Range&&!(e instanceof c.Selection)&&this._isValidRange(e,!0))return e
;var t=this._validatePosition(e.startLineNumber,e.startColumn,!1),i=this._validatePosition(e.endLineNumber,e.endColumn,!1),n=t.lineNumber,o=t.column,r=i.lineNumber,a=i.column,l=o>1?this._buffer.getLineCharCode(n,o-2):0,u=a>1&&a<=this._buffer.getLineLength(r)?this._buffer.getLineCharCode(r,a-2):0,h=s.isHighSurrogate(l),p=s.isHighSurrogate(u);return h||p?n===r&&o===a?new d.Range(n,o-1,r,a-1):h&&p?new d.Range(n,o-1,r,a+1):h?new d.Range(n,o-1,r,a):new d.Range(n,o,r,a+1):new d.Range(n,o,r,a)},o.prototype.modifyPosition=function(e,t){this._assertNotDisposed();var i=this.getOffsetAt(e)+t;return this.getPositionAt(Math.min(this._buffer.getLength(),Math.max(0,i)))},o.prototype.getFullModelRange=function(){this._assertNotDisposed();var e=this.getLineCount();return new d.Range(1,1,e,this.getLineMaxColumn(e))},o.prototype.findMatchesLineByLine=function(e,t,i,n){return this._buffer.findMatchesLineByLine(e,t,i,n)},o.prototype.findMatches=function(e,t,i,n,o,r,s){void 0===s&&(s=999),this._assertNotDisposed();var a
;if(a=d.Range.isIRange(t)?this.validateRange(t):this.getFullModelRange(),!i&&e.indexOf("\n")<0){var l=new _.SearchParams(e,i,n,o).parseSearchRequest();return l?this.findMatchesLineByLine(a,l,r,s):[]}return _.TextModelSearch.findMatches(this,new _.SearchParams(e,i,n,o),a,r,s)},o.prototype.findNextMatch=function(e,t,i,n,o,r){this._assertNotDisposed();var s=this.validatePosition(t);if(!i&&e.indexOf("\n")<0){var a=new _.SearchParams(e,i,n,o).parseSearchRequest();if(!a)return null;var l=this.getLineCount(),u=new d.Range(s.lineNumber,s.column,l,this.getLineMaxColumn(l)),c=this.findMatchesLineByLine(u,a,r,1);return _.TextModelSearch.findNextMatch(this,new _.SearchParams(e,i,n,o),s,r),c.length>0?c[0]:(u=new d.Range(1,1,s.lineNumber,this.getLineMaxColumn(s.lineNumber)),(c=this.findMatchesLineByLine(u,a,r,1)).length>0?c[0]:null)}return _.TextModelSearch.findNextMatch(this,new _.SearchParams(e,i,n,o),s,r)},o.prototype.findPreviousMatch=function(e,t,i,n,o,r){this._assertNotDisposed();var s=this.validatePosition(t)
;return _.TextModelSearch.findPreviousMatch(this,new _.SearchParams(e,i,n,o),s,r)},o.prototype.pushStackElement=function(){this._commandManager.pushStackElement()},o.prototype.pushEOL=function(e){if(("\n"===this.getEOL()?0:1)!==e)try{this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._commandManager.pushEOL(e)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},o.prototype.pushEditOperations=function(e,t,i){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._pushEditOperations(e,t,i)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},o.prototype._pushEditOperations=function(e,t,i){var n=this;if(this._options.trimAutoWhitespace&&this._trimAutoWhitespaceLines){for(var o=t.map(function(e){return{range:n.validateRange(e.range),text:e.text}}),r=!0,s=0,a=e.length;s<a;s++){for(var l=e[s],u=!1,c=0,h=o.length;c<h;c++){
var p=(_=o[c].range).startLineNumber>l.endLineNumber,f=l.startLineNumber>_.endLineNumber;if(!p&&!f){u=!0;break}}if(!u){r=!1;break}}if(r)for(var s=0,a=this._trimAutoWhitespaceLines.length;s<a;s++){for(var g=this._trimAutoWhitespaceLines[s],m=this.getLineMaxColumn(g),v=!0,c=0,h=o.length;c<h;c++){var _=o[c].range,y=o[c].text;if(!(g<_.startLineNumber||g>_.endLineNumber)&&!(g===_.startLineNumber&&_.startColumn===m&&_.isEmpty()&&y&&y.length>0&&"\n"===y.charAt(0)||g===_.startLineNumber&&1===_.startColumn&&_.isEmpty()&&y&&y.length>0&&"\n"===y.charAt(y.length-1))){v=!1;break}}v&&t.push({range:new d.Range(g,1,g,m),text:null})}this._trimAutoWhitespaceLines=null}return this._commandManager.pushEditOperation(e,t,i)},o.prototype.applyEdits=function(e){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._applyEdits(e)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},o.prototype._applyEdits=function(e){
for(var t=0,i=e.length;t<i;t++)e[t].range=this.validateRange(e[t].range);var n=this._buffer.getLineCount(),o=this._buffer.applyEdits(e,this._options.trimAutoWhitespace),r=this._buffer.getLineCount(),s=o.changes;if(this._trimAutoWhitespaceLines=o.trimAutoWhitespaceLineNumbers,0!==s.length){for(var a=[],l=n,t=0,i=s.length;t<i;t++){var u=s[t],d=x.countEOL(u.text),c=d[0],h=d[1];this._tokens.acceptEdit(u.range,c,h),this._onDidChangeDecorations.fire(),this._decorationsTree.acceptReplace(u.rangeOffset,u.rangeLength,u.text.length,u.forceMoveMarkers);for(var p=u.range.startLineNumber,f=u.range.endLineNumber,g=f-p,m=c,_=Math.min(g,m),y=m-g,b=_;b>=0;b--){var C=p+b,S=r-l-y+C;a.push(new v.ModelRawLineChanged(C,this.getLineContent(S)))}if(_<g){var w=p+_;a.push(new v.ModelRawLinesDeleted(w+1,f))}if(_<m){for(var E=p+_,L=m-_,D=r-l-L+E+1,I=[],N=0;N<L;N++){var M=D+N;I[M-D]=this.getLineContent(M)}a.push(new v.ModelRawLinesInserted(E+1,p+m,I))}l+=y}this._increaseVersionId(),
this._emitContentChangedEvent(new v.ModelRawContentChangedEvent(a,this.getVersionId(),this._isUndoing,this._isRedoing),{changes:s,eol:this._buffer.getEOL(),versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing,isFlush:!1})}return o.reverseEdits},o.prototype._undo=function(){this._isUndoing=!0;var e=this._commandManager.undo();return this._isUndoing=!1,e?(this._overwriteAlternativeVersionId(e.recordedVersionId),e.selections):null},o.prototype.undo=function(){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._undo()}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},o.prototype.canUndo=function(){return this._commandManager.canUndo()},o.prototype._redo=function(){this._isRedoing=!0;var e=this._commandManager.redo();return this._isRedoing=!1,e?(this._overwriteAlternativeVersionId(e.recordedVersionId),e.selections):null},o.prototype.redo=function(){try{
return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._redo()}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},o.prototype.canRedo=function(){return this._commandManager.canRedo()},o.prototype.changeDecorations=function(e,t){void 0===t&&(t=0),this._assertNotDisposed();try{return this._onDidChangeDecorations.beginDeferredEmit(),this._changeDecorations(t,e)}finally{this._onDidChangeDecorations.endDeferredEmit()}},o.prototype._changeDecorations=function(e,t){var n=this,o={addDecoration:function(t,i){return n._onDidChangeDecorations.fire(),n._deltaDecorationsImpl(e,[],[{range:t,options:i}])[0]},changeDecoration:function(e,t){n._onDidChangeDecorations.fire(),n._changeDecorationImpl(e,t)},changeDecorationOptions:function(e,t){n._onDidChangeDecorations.fire(),n._changeDecorationOptionsImpl(e,k(t))},removeDecoration:function(t){n._onDidChangeDecorations.fire(),n._deltaDecorationsImpl(e,[t],[])},deltaDecorations:function(t,i){
return 0===t.length&&0===i.length?[]:(n._onDidChangeDecorations.fire(),n._deltaDecorationsImpl(e,t,i))}},r=null;try{r=t(o)}catch(e){i.onUnexpectedError(e)}return o.addDecoration=R,o.changeDecoration=R,o.changeDecorationOptions=R,o.removeDecoration=R,o.deltaDecorations=R,r},o.prototype.deltaDecorations=function(e,t,i){if(void 0===i&&(i=0),this._assertNotDisposed(),e||(e=[]),0===e.length&&0===t.length)return[];try{return this._onDidChangeDecorations.beginDeferredEmit(),this._onDidChangeDecorations.fire(),this._deltaDecorationsImpl(i,e,t)}finally{this._onDidChangeDecorations.endDeferredEmit()}},o.prototype._getTrackedRange=function(e){return this.getDecorationRange(e)},o.prototype._setTrackedRange=function(e,t,i){var n=e?this._decorations[e]:null;if(!n)return t?this._deltaDecorationsImpl(0,[],[{range:t,options:B[i]}])[0]:null;if(!t)return this._decorationsTree.delete(n),delete this._decorations[n.id],null
;var o=this._validateRangeRelaxedNoAllocations(t),r=this._buffer.getOffsetAt(o.startLineNumber,o.startColumn),s=this._buffer.getOffsetAt(o.endLineNumber,o.endColumn);return this._decorationsTree.delete(n),n.reset(this.getVersionId(),r,s,o),n.setOptions(B[i]),this._decorationsTree.insert(n),n.id},o.prototype.removeAllDecorationsWithOwnerId=function(e){if(!this._isDisposed)for(var t=this._decorationsTree.collectNodesFromOwner(e),i=0,n=t.length;i<n;i++){var o=t[i];this._decorationsTree.delete(o),delete this._decorations[o.id]}},o.prototype.getDecorationOptions=function(e){var t=this._decorations[e];return t?t.options:null},o.prototype.getDecorationRange=function(e){var t=this._decorations[e];if(!t)return null;var i=this.getVersionId();return t.cachedVersionId!==i&&this._decorationsTree.resolveNode(t,i),null===t.range&&(t.range=this._getRangeAt(t.cachedAbsoluteStart,t.cachedAbsoluteEnd)),t.range},o.prototype.getLineDecorations=function(e,t,i){return void 0===t&&(t=0),void 0===i&&(i=!1),
e<1||e>this.getLineCount()?[]:this.getLinesDecorations(e,e,t,i)},o.prototype.getLinesDecorations=function(e,t,i,n){void 0===i&&(i=0),void 0===n&&(n=!1);var o=this.getLineCount(),r=Math.min(o,Math.max(1,e)),s=Math.min(o,Math.max(1,t)),a=this.getLineMaxColumn(s);return this._getDecorationsInRange(new d.Range(r,1,s,a),i,n)},o.prototype.getDecorationsInRange=function(e,t,i){void 0===t&&(t=0),void 0===i&&(i=!1);var n=this.validateRange(e);return this._getDecorationsInRange(n,t,i)},o.prototype.getOverviewRulerDecorations=function(e,t){void 0===e&&(e=0),void 0===t&&(t=!1);var i=this.getVersionId(),n=this._decorationsTree.search(e,t,!0,i);return this._ensureNodesHaveRanges(n)},o.prototype.getAllDecorations=function(e,t){void 0===e&&(e=0),void 0===t&&(t=!1);var i=this.getVersionId(),n=this._decorationsTree.search(e,t,!1,i);return this._ensureNodesHaveRanges(n)},o.prototype._getDecorationsInRange=function(e,t,i){
var n=this._buffer.getOffsetAt(e.startLineNumber,e.startColumn),o=this._buffer.getOffsetAt(e.endLineNumber,e.endColumn),r=this.getVersionId(),s=this._decorationsTree.intervalSearch(n,o,t,i,r);return this._ensureNodesHaveRanges(s)},o.prototype._ensureNodesHaveRanges=function(e){for(var t=0,i=e.length;t<i;t++){var n=e[t];null===n.range&&(n.range=this._getRangeAt(n.cachedAbsoluteStart,n.cachedAbsoluteEnd))}return e},o.prototype._getRangeAt=function(e,t){return this._buffer.getRangeAt(e,t-e)},o.prototype._changeDecorationImpl=function(e,t){var i=this._decorations[e];if(i){var n=this._validateRangeRelaxedNoAllocations(t),o=this._buffer.getOffsetAt(n.startLineNumber,n.startColumn),r=this._buffer.getOffsetAt(n.endLineNumber,n.endColumn);this._decorationsTree.delete(i),i.reset(this.getVersionId(),o,r,n),this._decorationsTree.insert(i)}},o.prototype._changeDecorationOptionsImpl=function(e,t){var i=this._decorations[e];if(i){
!(!i.options.overviewRuler||!i.options.overviewRuler.color)!==!(!t.overviewRuler||!t.overviewRuler.color)?(this._decorationsTree.delete(i),i.setOptions(t),this._decorationsTree.insert(i)):i.setOptions(t)}},o.prototype._deltaDecorationsImpl=function(e,t,i){for(var n=this.getVersionId(),o=t.length,r=0,s=i.length,a=0,l=new Array(s);r<o||a<s;){var u=null;if(r<o){do{u=this._decorations[t[r++]]}while(!u&&r<o);u&&this._decorationsTree.delete(u)}if(a<s){if(!u){var d=++this._lastDecorationId,c=this._instanceId+";"+d;u=new g.IntervalNode(c,0,0),this._decorations[c]=u}var h=i[a],p=this._validateRangeRelaxedNoAllocations(h.range),f=k(h.options),m=this._buffer.getOffsetAt(p.startLineNumber,p.startColumn),v=this._buffer.getOffsetAt(p.endLineNumber,p.endColumn);u.ownerId=e,u.reset(n,m,v,p),u.setOptions(f),this._decorationsTree.insert(u),l[a]=u.id,a++}else u&&delete this._decorations[u.id]}return l},o.prototype.setLineTokens=function(e,t){if(e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber")
;this._tokens.setTokens(this._languageIdentifier.id,e-1,this._buffer.getLineLength(e),t)},o.prototype.setTokens=function(e){if(0!==e.length){for(var t=[],i=0,n=e.length;i<n;i++){var o=e[i];t.push({fromLineNumber:o.startLineNumber,toLineNumber:o.startLineNumber+o.tokens.length-1});for(var r=0,s=o.tokens.length;r<s;r++)this.setLineTokens(o.startLineNumber+r,o.tokens[r])}this._emitModelTokensChangedEvent({tokenizationSupportChanged:!1,ranges:t})}},o.prototype.tokenizeViewport=function(e,t){e=Math.max(1,e),t=Math.min(this._buffer.getLineCount(),t),this._tokenization.tokenizeViewport(e,t)},o.prototype.clearTokens=function(){this._tokens.flush(),this._emitModelTokensChangedEvent({tokenizationSupportChanged:!0,ranges:[{fromLineNumber:1,toLineNumber:this._buffer.getLineCount()}]})},o.prototype._emitModelTokensChangedEvent=function(e){this._isDisposing||this._onDidChangeTokens.fire(e)},o.prototype.resetTokenization=function(){this._tokenization.reset()},o.prototype.forceTokenization=function(e){
if(e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");this._tokenization.forceTokenization(e)},o.prototype.isCheapToTokenize=function(e){return this._tokenization.isCheapToTokenize(e)},o.prototype.tokenizeIfCheap=function(e){this.isCheapToTokenize(e)&&this.forceTokenization(e)},o.prototype.getLineTokens=function(e){if(e<1||e>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._getLineTokens(e)},o.prototype._getLineTokens=function(e){var t=this.getLineContent(e);return this._tokens.getTokens(this._languageIdentifier.id,e-1,t)},o.prototype.getLanguageIdentifier=function(){return this._languageIdentifier},o.prototype.getModeId=function(){return this._languageIdentifier.language},o.prototype.setMode=function(e){if(this._languageIdentifier.id!==e.id){var t={oldLanguage:this._languageIdentifier.language,newLanguage:e.language};this._languageIdentifier=e,this._onDidChangeLanguage.fire(t),this._onDidChangeLanguageConfiguration.fire({})}},
o.prototype.getLanguageIdAtPosition=function(e,t){var i=this.validatePosition(new u.Position(e,t)),n=this.getLineTokens(i.lineNumber);return n.getLanguageId(n.findTokenIndexAtOffset(i.column-1))},o.prototype.getWordAtPosition=function(e){this._assertNotDisposed();var t=this.validatePosition(e),i=this.getLineContent(t.lineNumber),n=this._getLineTokens(t.lineNumber),r=n.findTokenIndexAtOffset(t.column-1),s=o._findLanguageBoundaries(n,r),a=s[0],l=s[1],u=b.getWordAtText(t.column,C.LanguageConfigurationRegistry.getWordDefinition(n.getLanguageId(r)),i.substring(a,l),a);if(u&&u.startColumn<=e.column&&e.column<=u.endColumn)return u;if(r>0&&a===t.column-1){var d=o._findLanguageBoundaries(n,r-1),c=d[0],h=d[1],p=b.getWordAtText(t.column,C.LanguageConfigurationRegistry.getWordDefinition(n.getLanguageId(r-1)),i.substring(c,h),c);if(p&&p.startColumn<=e.column&&e.column<=p.endColumn)return p}return null},o._findLanguageBoundaries=function(e,t){
for(var i=e.getLanguageId(t),n=0,o=t;o>=0&&e.getLanguageId(o)===i;o--)n=e.getStartOffset(o);for(var r=e.getLineContent().length,o=t,s=e.getCount();o<s&&e.getLanguageId(o)===i;o++)r=e.getEndOffset(o);return[n,r]},o.prototype.getWordUntilPosition=function(e){var t=this.getWordAtPosition(e);return t?{word:t.word.substr(0,e.column-t.startColumn),startColumn:t.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},o.prototype.findMatchingBracketUp=function(e,t){var i=e.toLowerCase(),n=this.validatePosition(t),o=this._getLineTokens(n.lineNumber),r=o.getLanguageId(o.findTokenIndexAtOffset(n.column-1)),s=C.LanguageConfigurationRegistry.getBracketsSupport(r);if(!s)return null;var a=s.textIsBracket[i];return a?this._findMatchingBracketUp(a,n):null},o.prototype.matchBracket=function(e){return this._matchBracket(this.validatePosition(e))},o.prototype._matchBracket=function(e){var t=e.lineNumber,i=this._getLineTokens(t),n=this._buffer.getLineContent(t),o=i.findTokenIndexAtOffset(e.column-1)
;if(o<0)return null;var r=C.LanguageConfigurationRegistry.getBracketsSupport(i.getLanguageId(o));if(r&&!w.ignoreBracketsInToken(i.getStandardTokenType(o))){for(var s=Math.max(i.getStartOffset(o),e.column-1-r.maxBracketLength),a=Math.min(i.getEndOffset(o),e.column-1+r.maxBracketLength),l=null;;){if(!(d=E.BracketsUtils.findNextBracketInToken(r.forwardRegex,t,n,s,a)))break;if(d.startColumn<=e.column&&e.column<=d.endColumn){c=(c=n.substring(d.startColumn-1,d.endColumn-1)).toLowerCase();(h=this._matchFoundBracket(d,r.textIsBracket[c],r.textIsOpenBracket[c]))&&(l=h)}s=d.endColumn-1}if(l)return l}if(o>0&&i.getStartOffset(o)===e.column-1){a=i.getStartOffset(o);o--;var u=C.LanguageConfigurationRegistry.getBracketsSupport(i.getLanguageId(o));if(u&&!w.ignoreBracketsInToken(i.getStandardTokenType(o))){var s=Math.max(i.getStartOffset(o),e.column-1-u.maxBracketLength),d=E.BracketsUtils.findPrevBracketInToken(u.reversedRegex,t,n,s,a);if(d&&d.startColumn<=e.column&&e.column<=d.endColumn){
var c=n.substring(d.startColumn-1,d.endColumn-1);c=c.toLowerCase();var h=this._matchFoundBracket(d,u.textIsBracket[c],u.textIsOpenBracket[c]);if(h)return h}}}return null},o.prototype._matchFoundBracket=function(e,t,i){if(!t)return null;if(i){if(n=this._findMatchingBracketDown(t,e.getEndPosition()))return[e,n]}else{var n=this._findMatchingBracketUp(t,e.getStartPosition());if(n)return[e,n]}return null},o.prototype._findMatchingBracketUp=function(e,t){for(var i=e.languageIdentifier.id,n=e.reversedRegex,o=-1,r=t.lineNumber;r>=1;r--){var s=this._getLineTokens(r),a=s.getCount(),l=this._buffer.getLineContent(r),u=a-1,d=-1;for(r===t.lineNumber&&(u=s.findTokenIndexAtOffset(t.column-1),d=t.column-1);u>=0;u--){var c=s.getLanguageId(u),h=s.getStandardTokenType(u),p=s.getStartOffset(u),f=s.getEndOffset(u);if(-1===d&&(d=f),c===i&&!w.ignoreBracketsInToken(h))for(;;){var g=E.BracketsUtils.findPrevBracketInToken(n,r,l,p,d);if(!g)break;var m=l.substring(g.startColumn-1,g.endColumn-1)
;if((m=m.toLowerCase())===e.open?o++:m===e.close&&o--,0===o)return g;d=g.startColumn-1}d=-1}}return null},o.prototype._findMatchingBracketDown=function(e,t){for(var i=e.languageIdentifier.id,n=e.forwardRegex,o=1,r=t.lineNumber,s=this.getLineCount();r<=s;r++){var a=this._getLineTokens(r),l=a.getCount(),u=this._buffer.getLineContent(r),d=0,c=0;for(r===t.lineNumber&&(d=a.findTokenIndexAtOffset(t.column-1),c=t.column-1);d<l;d++){var h=a.getLanguageId(d),p=a.getStandardTokenType(d),f=a.getStartOffset(d),g=a.getEndOffset(d);if(0===c&&(c=f),h===i&&!w.ignoreBracketsInToken(p))for(;;){var m=E.BracketsUtils.findNextBracketInToken(n,r,u,c,g);if(!m)break;var v=u.substring(m.startColumn-1,m.endColumn-1);if((v=v.toLowerCase())===e.open?o++:v===e.close&&o--,0===o)return m;c=m.endColumn-1}c=0}}return null},o.prototype.findPrevBracket=function(e){for(var t=this.validatePosition(e),i=-1,n=null,o=t.lineNumber;o>=1;o--){var r=this._getLineTokens(o),s=r.getCount(),a=this._buffer.getLineContent(o),l=s-1,u=-1
;for(o===t.lineNumber&&(l=r.findTokenIndexAtOffset(t.column-1),u=t.column-1);l>=0;l--){var d=r.getLanguageId(l),c=r.getStandardTokenType(l),h=r.getStartOffset(l),p=r.getEndOffset(l);if(-1===u&&(u=p),i!==d&&(i=d,n=C.LanguageConfigurationRegistry.getBracketsSupport(i)),n&&!w.ignoreBracketsInToken(c)){var f=E.BracketsUtils.findPrevBracketInToken(n.reversedRegex,o,a,h,u);if(f)return this._toFoundBracket(n,f)}u=-1}}return null},o.prototype.findNextBracket=function(e){for(var t=this.validatePosition(e),i=-1,n=null,o=t.lineNumber,r=this.getLineCount();o<=r;o++){var s=this._getLineTokens(o),a=s.getCount(),l=this._buffer.getLineContent(o),u=0,d=0;for(o===t.lineNumber&&(u=s.findTokenIndexAtOffset(t.column-1),d=t.column-1);u<a;u++){var c=s.getLanguageId(u),h=s.getStandardTokenType(u),p=s.getStartOffset(u),f=s.getEndOffset(u);if(0===d&&(d=p),i!==c&&(i=c,n=C.LanguageConfigurationRegistry.getBracketsSupport(i)),n&&!w.ignoreBracketsInToken(h)){var g=E.BracketsUtils.findNextBracketInToken(n.forwardRegex,o,l,d,f)
;if(g)return this._toFoundBracket(n,g)}d=0}}return null},o.prototype._toFoundBracket=function(e,t){if(!t)return null;var i=this.getValueInRange(t);i=i.toLowerCase();var n=e.textIsBracket[i];return n?{range:t,open:n.open,close:n.close,isOpen:e.textIsOpenBracket[i]}:null},o.computeIndentLevel=function(e,t){for(var i=0,n=0,o=e.length;n<o;){var r=e.charCodeAt(n);if(32===r)i++;else{if(9!==r)break;i=i-i%t+t}n++}return n===o?-1:i},o.prototype._computeIndentLevel=function(e){return o.computeIndentLevel(this._buffer.getLineContent(e+1),this._options.tabSize)},o.prototype.getActiveIndentGuide=function(e,t,i){var n=this;this._assertNotDisposed();var o=this.getLineCount();if(e<1||e>o)throw new Error("Illegal value for lineNumber");for(var r=C.LanguageConfigurationRegistry.getFoldingRules(this._languageIdentifier.id),s=Boolean(r&&r.offSide),a=-2,l=-1,u=-2,d=-1,c=function(e){if(-1!==a&&(-2===a||a>e-1)){a=-1,l=-1;for(i=e-2;i>=0;i--){var t=n._computeIndentLevel(i);if(t>=0){a=i,l=t;break}}}if(-2===u){u=-1,d=-1
;for(var i=e;i<o;i++){var r=n._computeIndentLevel(i);if(r>=0){u=i,d=r;break}}}},h=-2,p=-1,f=-2,g=-1,m=function(e){if(-2===h){h=-1,p=-1;for(i=e-2;i>=0;i--){var t=n._computeIndentLevel(i);if(t>=0){h=i,p=t;break}}}if(-1!==f&&(-2===f||f<e-1)){f=-1,g=-1;for(var i=e;i<o;i++){var r=n._computeIndentLevel(i);if(r>=0){f=i,g=r;break}}}},v=0,_=!0,y=0,b=!0,S=0,w=0;_||b;w++){var E=e-w,L=e+w;if(0!==w&&(E<1||E<t)&&(_=!1),0!==w&&(L>o||L>i)&&(b=!1),w>5e4&&(_=!1,b=!1),_){var x=void 0;if((I=this._computeIndentLevel(E-1))>=0?(u=E-1,d=I,x=Math.ceil(I/this._options.indentSize)):(c(E),x=this._getIndentLevelForWhitespaceLine(s,l,d)),0===w){if(v=E,y=L,0===(S=x))return{startLineNumber:v,endLineNumber:y,indent:S};continue}x>=S?v=E:_=!1}if(b){var D=void 0,I=this._computeIndentLevel(L-1);I>=0?(h=L-1,p=I,D=Math.ceil(I/this._options.indentSize)):(m(L),D=this._getIndentLevelForWhitespaceLine(s,p,g)),D>=S?y=L:b=!1}}return{startLineNumber:v,endLineNumber:y,indent:S}},o.prototype.getLinesIndentGuides=function(e,t){this._assertNotDisposed()
;var i=this.getLineCount();if(e<1||e>i)throw new Error("Illegal value for startLineNumber");if(t<1||t>i)throw new Error("Illegal value for endLineNumber");for(var n=C.LanguageConfigurationRegistry.getFoldingRules(this._languageIdentifier.id),o=Boolean(n&&n.offSide),r=new Array(t-e+1),s=-2,a=-1,l=-2,u=-1,d=e;d<=t;d++){var c=d-e,h=this._computeIndentLevel(d-1);if(h>=0)s=d-1,a=h,r[c]=Math.ceil(h/this._options.indentSize);else{if(-2===s){s=-1,a=-1;for(p=d-2;p>=0;p--){if((f=this._computeIndentLevel(p))>=0){s=p,a=f;break}}}if(-1!==l&&(-2===l||l<d-1)){l=-1,u=-1;for(var p=d;p<i;p++){var f=this._computeIndentLevel(p);if(f>=0){l=p,u=f;break}}}r[c]=this._getIndentLevelForWhitespaceLine(o,a,u)}}return r},o.prototype._getIndentLevelForWhitespaceLine=function(e,t,i){return-1===t||-1===i?0:t<i?1+Math.floor(t/this._options.indentSize):t===i?Math.ceil(i/this._options.indentSize):e?Math.ceil(i/this._options.indentSize):1+Math.floor(i/this._options.indentSize)},o.MODEL_SYNC_LIMIT=52428800,o.LARGE_FILE_SIZE_THRESHOLD=20971520,
o.LARGE_FILE_LINE_COUNT_THRESHOLD=3e5,o.DEFAULT_CREATION_OPTIONS={isForSimpleWidget:!1,tabSize:l.EDITOR_MODEL_DEFAULTS.tabSize,indentSize:l.EDITOR_MODEL_DEFAULTS.indentSize,insertSpaces:l.EDITOR_MODEL_DEFAULTS.insertSpaces,detectIndentation:!1,defaultEOL:1,trimAutoWhitespace:l.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace,largeFileOptimizations:l.EDITOR_MODEL_DEFAULTS.largeFileOptimizations},o}(o.Disposable);t.TextModel=O;var P=function(){function e(){this._decorationsTree0=new g.IntervalTree,this._decorationsTree1=new g.IntervalTree}return e.prototype.intervalSearch=function(e,t,i,n,o){var r=this._decorationsTree0.intervalSearch(e,t,i,n,o),s=this._decorationsTree1.intervalSearch(e,t,i,n,o);return r.concat(s)},e.prototype.search=function(e,t,i,n){if(i)return this._decorationsTree1.search(e,t,n);var o=this._decorationsTree0.search(e,t,n),r=this._decorationsTree1.search(e,t,n);return o.concat(r)},e.prototype.collectNodesFromOwner=function(e){
var t=this._decorationsTree0.collectNodesFromOwner(e),i=this._decorationsTree1.collectNodesFromOwner(e);return t.concat(i)},e.prototype.collectNodesPostOrder=function(){var e=this._decorationsTree0.collectNodesPostOrder(),t=this._decorationsTree1.collectNodesPostOrder();return e.concat(t)},e.prototype.insert=function(e){g.getNodeIsInOverviewRuler(e)?this._decorationsTree1.insert(e):this._decorationsTree0.insert(e)},e.prototype.delete=function(e){g.getNodeIsInOverviewRuler(e)?this._decorationsTree1.delete(e):this._decorationsTree0.delete(e)},e.prototype.resolveNode=function(e,t){g.getNodeIsInOverviewRuler(e)?this._decorationsTree1.resolveNode(e,t):this._decorationsTree0.resolveNode(e,t)},e.prototype.acceptReplace=function(e,t,i,n){this._decorationsTree0.acceptReplace(e,t,i,n),this._decorationsTree1.acceptReplace(e,t,i,n)},e}(),A=function(){return function(e){this.color=e.color||s.empty,this.darkColor=e.darkColor||s.empty}}(),F=function(e){function t(t){var i=e.call(this,t)||this;return i._resolvedColor=null,
i.position="number"==typeof t.position?t.position:h.OverviewRulerLane.Center,i}return r(t,e),t.prototype.getColor=function(e){return this._resolvedColor||("light"!==e.type&&this.darkColor?this._resolvedColor=this._resolveColor(this.darkColor,e):this._resolvedColor=this._resolveColor(this.color,e)),this._resolvedColor},t.prototype.invalidateCachedColor=function(){this._resolvedColor=null},t.prototype._resolveColor=function(e,t){if("string"==typeof e)return e;var i=e?t.getColor(e.id):null;return i?i.toString():s.empty},t}(A);t.ModelDecorationOverviewRulerOptions=F;var W=function(e){function t(t){var i=e.call(this,t)||this;return i.position=t.position,i}return r(t,e),t.prototype.getColor=function(e){return this._resolvedColor||("light"!==e.type&&this.darkColor?this._resolvedColor=this._resolveColor(this.darkColor,e):this._resolvedColor=this._resolveColor(this.color,e)),this._resolvedColor},t.prototype.invalidateCachedColor=function(){this._resolvedColor=void 0},t.prototype._resolveColor=function(e,t){
return"string"==typeof e?D.Color.fromHex(e):t.getColor(e.id)},t}(A);t.ModelDecorationMinimapOptions=W;var V=function(){function e(e){this.stickiness=e.stickiness||0,this.zIndex=e.zIndex||0,this.className=e.className?M(e.className):null,this.hoverMessage=L.withUndefinedAsNull(e.hoverMessage),this.glyphMarginHoverMessage=L.withUndefinedAsNull(e.glyphMarginHoverMessage),this.isWholeLine=e.isWholeLine||!1,this.showIfCollapsed=e.showIfCollapsed||!1,this.collapseOnReplaceEdit=e.collapseOnReplaceEdit||!1,this.overviewRuler=e.overviewRuler?new F(e.overviewRuler):null,this.minimap=e.minimap?new W(e.minimap):null,this.glyphMarginClassName=e.glyphMarginClassName?M(e.glyphMarginClassName):null,this.linesDecorationsClassName=e.linesDecorationsClassName?M(e.linesDecorationsClassName):null,this.marginClassName=e.marginClassName?M(e.marginClassName):null,this.inlineClassName=e.inlineClassName?M(e.inlineClassName):null,this.inlineClassNameAffectsLetterSpacing=e.inlineClassNameAffectsLetterSpacing||!1,
this.beforeContentClassName=e.beforeContentClassName?M(e.beforeContentClassName):null,this.afterContentClassName=e.afterContentClassName?M(e.afterContentClassName):null}return e.register=function(t){return new e(t)},e.createDynamic=function(t){return new e(t)},e}();t.ModelDecorationOptions=V,V.EMPTY=V.register({});var B=[V.register({stickiness:0}),V.register({stickiness:1}),V.register({stickiness:2}),V.register({stickiness:3})],H=function(e){function t(){var t=e.call(this)||this;return t._actual=t._register(new n.Emitter),t.event=t._actual.event,t._deferredCnt=0,t._shouldFire=!1,t}return r(t,e),t.prototype.beginDeferredEmit=function(){this._deferredCnt++},t.prototype.endDeferredEmit=function(){this._deferredCnt--,0===this._deferredCnt&&this._shouldFire&&(this._shouldFire=!1,this._actual.fire({}))},t.prototype.fire=function(){this._shouldFire=!0},t}(o.Disposable);t.DidChangeDecorationsEmitter=H;var z=function(e){function t(){var t=e.call(this)||this;return t._fastEmitter=t._register(new n.Emitter),
t.fastEvent=t._fastEmitter.event,t._slowEmitter=t._register(new n.Emitter),t.slowEvent=t._slowEmitter.event,t._deferredCnt=0,t._deferredEvent=null,t}return r(t,e),t.prototype.beginDeferredEmit=function(){this._deferredCnt++},t.prototype.endDeferredEmit=function(){if(this._deferredCnt--,0===this._deferredCnt&&null!==this._deferredEvent){var e=this._deferredEvent;this._deferredEvent=null,this._fastEmitter.fire(e),this._slowEmitter.fire(e)}},t.prototype.fire=function(e){this._deferredCnt>0?this._deferredEvent?this._deferredEvent=this._deferredEvent.merge(e):this._deferredEvent=e:(this._fastEmitter.fire(e),this._slowEmitter.fire(e))},t}(o.Disposable);t.DidChangeContentEmitter=z}),define(t[36],i([1,0,10,5,13,3,20,30,40]),function(e,t,i,n,o,r,s,a,l){"use strict";function u(e,t,i){e.has(t)?e.get(t).push(i):e.set(t,[i])}Object.defineProperty(t,"__esModule",{value:!0});var d=function(){return!0},c=function(){return!1},h=function(e){return" "===e||"\t"===e},p=function(){function e(t,i,n){this._languageIdentifier=t
;var o=n.editor;this.readOnly=o.readOnly,this.tabSize=i.tabSize,this.indentSize=i.indentSize,this.insertSpaces=i.insertSpaces,this.pageSize=Math.max(1,Math.floor(o.layoutInfo.height/o.fontInfo.lineHeight)-2),this.lineHeight=o.lineHeight,this.useTabStops=o.useTabStops,this.wordSeparators=o.wordSeparators,this.emptySelectionClipboard=o.emptySelectionClipboard,this.copyWithSyntaxHighlighting=o.copyWithSyntaxHighlighting,this.multiCursorMergeOverlapping=o.multiCursorMergeOverlapping,this.autoClosingBrackets=o.autoClosingBrackets,this.autoClosingQuotes=o.autoClosingQuotes,this.autoClosingOvertype=o.autoClosingOvertype,this.autoSurround=o.autoSurround,this.autoIndent=o.autoIndent,this.autoClosingPairsOpen2=new Map,this.autoClosingPairsClose2=new Map,this.surroundingPairs={},this._electricChars=null,this.shouldAutoCloseBefore={quote:e._getShouldAutoClose(t,this.autoClosingQuotes),bracket:e._getShouldAutoClose(t,this.autoClosingBrackets)};var r=e._getAutoClosingPairs(t);if(r)for(var s=0,a=r;s<a.length;s++){h=a[s]
;u(this.autoClosingPairsOpen2,h.open.charAt(h.open.length-1),h),1===h.close.length&&u(this.autoClosingPairsClose2,h.close,h)}var l=e._getSurroundingPairs(t);if(l)for(var d=0,c=l;d<c.length;d++){var h=c[d];this.surroundingPairs[h.open]=h.close}}return e.shouldRecreate=function(e){return e.layoutInfo||e.wordSeparators||e.emptySelectionClipboard||e.multiCursorMergeOverlapping||e.autoClosingBrackets||e.autoClosingQuotes||e.autoClosingOvertype||e.autoSurround||e.useTabStops||e.lineHeight||e.readOnly},Object.defineProperty(e.prototype,"electricChars",{get:function(){if(!this._electricChars){this._electricChars={};var t=e._getElectricCharacters(this._languageIdentifier);if(t)for(var i=0,n=t;i<n.length;i++){var o=n[i];this._electricChars[o]=!0}}return this._electricChars},enumerable:!0,configurable:!0}),e.prototype.normalizeIndentation=function(e){return a.TextModel.normalizeIndentation(e,this.indentSize,this.insertSpaces)},e._getElectricCharacters=function(e){try{
return l.LanguageConfigurationRegistry.getElectricCharacters(e.id)}catch(e){return i.onUnexpectedError(e),null}},e._getAutoClosingPairs=function(e){try{return l.LanguageConfigurationRegistry.getAutoClosingPairs(e.id)}catch(e){return i.onUnexpectedError(e),null}},e._getShouldAutoClose=function(t,i){switch(i){case"beforeWhitespace":return h;case"languageDefined":return e._getLanguageDefinedShouldAutoClose(t);case"always":return d;case"never":return c}},e._getLanguageDefinedShouldAutoClose=function(e){try{var t=l.LanguageConfigurationRegistry.getAutoCloseBeforeSet(e.id);return function(e){return-1!==t.indexOf(e)}}catch(e){return i.onUnexpectedError(e),c}},e._getSurroundingPairs=function(e){try{return l.LanguageConfigurationRegistry.getSurroundingPairs(e.id)}catch(e){return i.onUnexpectedError(e),null}},e}();t.CursorConfiguration=p;var f=function(){function e(t,i,n,o){this.selectionStart=t,this.selectionStartLeftoverVisibleColumns=i,this.position=n,this.leftoverVisibleColumns=o,
this.selection=e._computeSelection(this.selectionStart,this.position)}return e.prototype.equals=function(e){return this.selectionStartLeftoverVisibleColumns===e.selectionStartLeftoverVisibleColumns&&this.leftoverVisibleColumns===e.leftoverVisibleColumns&&this.position.equals(e.position)&&this.selectionStart.equalsRange(e.selectionStart)},e.prototype.hasSelection=function(){return!this.selection.isEmpty()||!this.selectionStart.isEmpty()},e.prototype.move=function(t,i,n,s){return t?new e(this.selectionStart,this.selectionStartLeftoverVisibleColumns,new o.Position(i,n),s):new e(new r.Range(i,n,i,n),s,new o.Position(i,n),s)},e._computeSelection=function(e,t){var i,n,o,r;return e.isEmpty()?(i=e.startLineNumber,n=e.startColumn,o=t.lineNumber,r=t.column):t.isBeforeOrEqual(e.getStartPosition())?(i=e.endLineNumber,n=e.endColumn,o=t.lineNumber,r=t.column):(i=e.startLineNumber,n=e.startColumn,o=t.lineNumber,r=t.column),new s.Selection(i,n,o,r)},e}();t.SingleCursorState=f;var g=function(){function e(e,t,i){this.model=t,
this.viewModel=i,this.config=new p(this.model.getLanguageIdentifier(),this.model.getOptions(),e)}return e.prototype.validateViewPosition=function(e,t){return this.viewModel.coordinatesConverter.validateViewPosition(e,t)},e.prototype.validateViewRange=function(e,t){return this.viewModel.coordinatesConverter.validateViewRange(e,t)},e.prototype.convertViewRangeToModelRange=function(e){return this.viewModel.coordinatesConverter.convertViewRangeToModelRange(e)},e.prototype.convertViewPositionToModelPosition=function(e,t){return this.viewModel.coordinatesConverter.convertViewPositionToModelPosition(new o.Position(e,t))},e.prototype.convertModelPositionToViewPosition=function(e){return this.viewModel.coordinatesConverter.convertModelPositionToViewPosition(e)},e.prototype.convertModelRangeToViewRange=function(e){return this.viewModel.coordinatesConverter.convertModelRangeToViewRange(e)},e.prototype.getCurrentScrollTop=function(){return this.viewModel.viewLayout.getCurrentScrollTop()},
e.prototype.getCompletelyVisibleViewRange=function(){return this.viewModel.getCompletelyVisibleViewRange()},e.prototype.getCompletelyVisibleModelRange=function(){var e=this.viewModel.getCompletelyVisibleViewRange();return this.viewModel.coordinatesConverter.convertViewRangeToModelRange(e)},e.prototype.getCompletelyVisibleViewRangeAtScrollTop=function(e){return this.viewModel.getCompletelyVisibleViewRangeAtScrollTop(e)},e.prototype.getVerticalOffsetForViewLine=function(e){return this.viewModel.viewLayout.getVerticalOffsetForLineNumber(e)},e}();t.CursorContext=g;var m=function(){return function(e){this.modelState=e,this.viewState=null}}();t.PartialModelCursorState=m;var v=function(){return function(e){this.modelState=null,this.viewState=e}}();t.PartialViewCursorState=v;var _=function(){function e(e,t){this.modelState=e,this.viewState=t}return e.fromModelState=function(e){return new m(e)},e.fromViewState=function(e){return new v(e)},e.fromModelSelection=function(t){
var i=t.selectionStartLineNumber,n=t.selectionStartColumn,s=t.positionLineNumber,a=t.positionColumn,l=new f(new r.Range(i,n,i,n),0,new o.Position(s,a),0);return e.fromModelState(l)},e.fromModelSelections=function(e){for(var t=[],i=0,n=e.length;i<n;i++)t[i]=this.fromModelSelection(e[i]);return t},e.prototype.equals=function(e){return this.viewState.equals(e.viewState)&&this.modelState.equals(e.modelState)},e}();t.CursorState=_;var y=function(){return function(e,t,i){this.type=e,this.commands=t,this.shouldPushStackElementBefore=i.shouldPushStackElementBefore,this.shouldPushStackElementAfter=i.shouldPushStackElementAfter}}();t.EditOperationResult=y;var b=function(){function e(){}return e.isLowSurrogate=function(e,t,i){var o=e.getLineContent(t);return!(i<0||i>=o.length)&&n.isLowSurrogate(o.charCodeAt(i))},e.isHighSurrogate=function(e,t,i){var o=e.getLineContent(t);return!(i<0||i>=o.length)&&n.isHighSurrogate(o.charCodeAt(i))},e.isInsideSurrogatePair=function(e,t,i){return this.isHighSurrogate(e,t,i-2)},
e.visibleColumnFromColumn=function(e,t,i){var o=e.length;o>t-1&&(o=t-1);for(var r=0,s=0;s<o;s++){var a=e.charCodeAt(s);9===a?r=this.nextRenderTabStop(r,i):n.isFullWidthCharacter(a)?r+=2:r+=1}return r},e.visibleColumnFromColumn2=function(e,t,i){return this.visibleColumnFromColumn(t.getLineContent(i.lineNumber),i.column,e.tabSize)},e.columnFromVisibleColumn=function(e,t,i){if(t<=0)return 1;for(var o=e.length,r=0,s=0;s<o;s++){var a=e.charCodeAt(s),l=void 0;if((l=9===a?this.nextRenderTabStop(r,i):n.isFullWidthCharacter(a)?r+2:r+1)>=t){return l-t<t-r?s+2:s+1}r=l}return o+1},e.columnFromVisibleColumn2=function(e,t,i,n){var o=this.columnFromVisibleColumn(t.getLineContent(i),n,e.tabSize),r=t.getLineMinColumn(i);if(o<r)return r;var s=t.getLineMaxColumn(i);return o>s?s:o},e.nextRenderTabStop=function(e,t){return e+t-e%t},e.nextIndentTabStop=function(e,t){return e+t-e%t},e.prevRenderTabStop=function(e,t){return e-1-(e-1)%t},e.prevIndentTabStop=function(e,t){return e-1-(e-1)%t},e}();t.CursorColumns=b,
t.isQuote=function(e){return"'"===e||'"'===e||"`"===e}}),define(t[189],i([1,0,5,36,3,20,40]),function(e,t,i,n,o,r,s){"use strict";function a(e,t){l[e]||(l[e]=["",e]);for(var i=l[e],n=i.length;n<=t;n++)i[n]=i[n-1]+e;return i[t]}Object.defineProperty(t,"__esModule",{value:!0});var l=Object.create(null);t.cachedStringRepeat=a;var u=function(){function e(e,t){this._opts=t,this._selection=e,this._selectionId=null,this._useLastEditRangeForCursorEndPosition=!1,this._selectionStartColumnStaysPut=!1}return e.unshiftIndent=function(e,t,i,o,r){var s=n.CursorColumns.visibleColumnFromColumn(e,t,i);if(r){return a(l=a(" ",o),d=(u=n.CursorColumns.prevIndentTabStop(s,o))/o)}var l="\t",u=n.CursorColumns.prevRenderTabStop(s,i),d=u/i;return a(l,d)},e.shiftIndent=function(e,t,i,o,r){var s=n.CursorColumns.visibleColumnFromColumn(e,t,i);if(r){return a(l=a(" ",o),d=(u=n.CursorColumns.nextIndentTabStop(s,o))/o)}var l="\t",u=n.CursorColumns.nextRenderTabStop(s,i),d=u/i;return a(l,d)},e.prototype._addEditOperation=function(e,t,i){
this._useLastEditRangeForCursorEndPosition?e.addTrackedEditOperation(t,i):e.addEditOperation(t,i)},e.prototype.getEditOperations=function(t,r){var l=this._selection.startLineNumber,u=this._selection.endLineNumber;1===this._selection.endColumn&&l!==u&&(u-=1);var d=this._opts,c=d.tabSize,h=d.indentSize,p=d.insertSpaces,f=l===u;if(this._selection.isEmpty()&&/^\s*$/.test(t.getLineContent(l))&&(this._useLastEditRangeForCursorEndPosition=!0),this._opts.useTabStops)for(var g=0,m=0,v=l;v<=u;v++,g=m){m=0;var _=t.getLineContent(v),y=i.firstNonWhitespaceIndex(_);if((!this._opts.isUnshift||0!==_.length&&0!==y)&&(f||this._opts.isUnshift||0!==_.length)){if(-1===y&&(y=_.length),v>1){if(n.CursorColumns.visibleColumnFromColumn(_,y+1,c)%h!=0&&t.isCheapToTokenize(v-1)){var b=s.LanguageConfigurationRegistry.getRawEnterActionAtPosition(t,v-1,t.getLineMaxColumn(v-1));if(b){if(m=g,b.appendText)for(var C=0,S=b.appendText.length;C<S&&m<h&&32===b.appendText.charCodeAt(C);C++)m++;b.removeText&&(m=Math.max(0,m-b.removeText))
;for(C=0;C<m&&(0!==y&&32===_.charCodeAt(y-1));C++)y--}}}if(!this._opts.isUnshift||0!==y){var w=void 0;w=this._opts.isUnshift?e.unshiftIndent(_,y+1,c,h,p):e.shiftIndent(_,y+1,c,h,p),this._addEditOperation(r,new o.Range(v,1,v,y+1),w),v===l&&(this._selectionStartColumnStaysPut=this._selection.startColumn<=y+1)}}}else for(var E=p?a(" ",h):"\t",v=l;v<=u;v++){var _=t.getLineContent(v),y=i.firstNonWhitespaceIndex(_);if((!this._opts.isUnshift||0!==_.length&&0!==y)&&((f||this._opts.isUnshift||0!==_.length)&&(-1===y&&(y=_.length),!this._opts.isUnshift||0!==y)))if(this._opts.isUnshift){y=Math.min(y,h);for(var L=0;L<y;L++){if(9===_.charCodeAt(L)){y=L+1;break}}this._addEditOperation(r,new o.Range(v,1,v,y+1),"")}else this._addEditOperation(r,new o.Range(v,1,v,1),E),v===l&&(this._selectionStartColumnStaysPut=1===this._selection.startColumn)}this._selectionId=r.trackSelection(this._selection)},e.prototype.computeCursorState=function(e,t){if(this._useLastEditRangeForCursorEndPosition){var i=t.getInverseEditOperations()[0]
;return new r.Selection(i.range.endLineNumber,i.range.endColumn,i.range.endLineNumber,i.range.endColumn)}var n=t.getTrackedSelection(this._selectionId);if(this._selectionStartColumnStaysPut){var o=this._selection.startColumn;return n.startColumn<=o?n:0===n.getDirection()?new r.Selection(n.startLineNumber,o,n.endLineNumber,n.endColumn):new r.Selection(n.endLineNumber,n.endColumn,n.startLineNumber,o)}return n},e}();t.ShiftCommand=u}),define(t[392],i([1,0,36,13,3]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){}return e.columnSelect=function(e,t,r,s,a,l){for(var u=Math.abs(a-r)+1,d=r>a,c=s>l,h=s<l,p=[],f=0;f<u;f++){var g=r+(d?-f:f),m=i.CursorColumns.columnFromVisibleColumn2(e,t,g,s),v=i.CursorColumns.columnFromVisibleColumn2(e,t,g,l),_=i.CursorColumns.visibleColumnFromColumn2(e,t,new n.Position(g,m)),y=i.CursorColumns.visibleColumnFromColumn2(e,t,new n.Position(g,v));if(h){if(_>l)continue;if(y<s)continue}if(c){if(y>s)continue;if(_<l)continue}
p.push(new i.SingleCursorState(new o.Range(g,m,g,m),0,new n.Position(g,v),0))}if(0===p.length)for(f=0;f<u;f++){var g=r+(d?-f:f),b=t.getLineMaxColumn(g);p.push(new i.SingleCursorState(new o.Range(g,b,g,b),0,new n.Position(g,b),0))}return{viewStates:p,reversed:d,fromLineNumber:r,fromVisualColumn:s,toLineNumber:a,toVisualColumn:l}},e.columnSelectLeft=function(t,i,n){var o=n.toViewVisualColumn;return o>1&&o--,e.columnSelect(t,i,n.fromViewLineNumber,n.fromViewVisualColumn,n.toViewLineNumber,o)},e.columnSelectRight=function(e,t,o){for(var r=0,s=Math.min(o.fromViewLineNumber,o.toViewLineNumber),a=Math.max(o.fromViewLineNumber,o.toViewLineNumber),l=s;l<=a;l++){var u=t.getLineMaxColumn(l),d=i.CursorColumns.visibleColumnFromColumn2(e,t,new n.Position(l,u));r=Math.max(r,d)}var c=o.toViewVisualColumn;return c<r&&c++,this.columnSelect(e,t,o.fromViewLineNumber,o.fromViewVisualColumn,o.toViewLineNumber,c)},e.columnSelectUp=function(e,t,i,n){var o=n?e.pageSize:1,r=Math.max(1,i.toViewLineNumber-o)
;return this.columnSelect(e,t,i.fromViewLineNumber,i.fromViewVisualColumn,r,i.toViewVisualColumn)},e.columnSelectDown=function(e,t,i,n){var o=n?e.pageSize:1,r=Math.min(t.getLineCount(),i.toViewLineNumber+o);return this.columnSelect(e,t,i.fromViewLineNumber,i.fromViewVisualColumn,r,i.toViewVisualColumn)},e}();t.ColumnSelection=r}),define(t[190],i([1,0,36,13,3]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){return function(e,t,i){this.lineNumber=e,this.column=t,this.leftoverVisibleColumns=i}}();t.CursorPosition=r;var s=function(){function e(){}return e.left=function(e,t,n,o){return o>t.getLineMinColumn(n)?i.CursorColumns.isLowSurrogate(t,n,o-2)?o-=2:o-=1:n>1&&(n-=1,o=t.getLineMaxColumn(n)),new r(n,o,0)},e.moveLeft=function(t,i,n,o,r){var s,a;if(n.hasSelection()&&!o)s=n.selection.startLineNumber,a=n.selection.startColumn;else{var l=e.left(t,i,n.position.lineNumber,n.position.column-(r-1));s=l.lineNumber,a=l.column}return n.move(o,s,a,0)},
e.right=function(e,t,n,o){return o<t.getLineMaxColumn(n)?i.CursorColumns.isHighSurrogate(t,n,o-1)?o+=2:o+=1:n<t.getLineCount()&&(n+=1,o=t.getLineMinColumn(n)),new r(n,o,0)},e.moveRight=function(t,i,n,o,r){var s,a;if(n.hasSelection()&&!o)s=n.selection.endLineNumber,a=n.selection.endColumn;else{var l=e.right(t,i,n.position.lineNumber,n.position.column+(r-1));s=l.lineNumber,a=l.column}return n.move(o,s,a,0)},e.down=function(e,t,n,o,s,a,l){var u=i.CursorColumns.visibleColumnFromColumn(t.getLineContent(n),o,e.tabSize)+s;n+=a;var d=t.getLineCount();return n>d?(n=d,l?o=t.getLineMaxColumn(n):(o=Math.min(t.getLineMaxColumn(n),o),i.CursorColumns.isInsideSurrogatePair(t,n,o)&&(o-=1))):(o=i.CursorColumns.columnFromVisibleColumn2(e,t,n,u),i.CursorColumns.isInsideSurrogatePair(t,n,o)&&(o-=1)),s=u-i.CursorColumns.visibleColumnFromColumn(t.getLineContent(n),o,e.tabSize),new r(n,o,s)},e.moveDown=function(t,i,n,o,r){var s,a;n.hasSelection()&&!o?(s=n.selection.endLineNumber,a=n.selection.endColumn):(s=n.position.lineNumber,
a=n.position.column);var l=e.down(t,i,s,a,n.leftoverVisibleColumns,r,!0);return n.move(o,l.lineNumber,l.column,l.leftoverVisibleColumns)},e.translateDown=function(t,r,s){var a=s.selection,l=e.down(t,r,a.selectionStartLineNumber,a.selectionStartColumn,s.selectionStartLeftoverVisibleColumns,1,!1),u=e.down(t,r,a.positionLineNumber,a.positionColumn,s.leftoverVisibleColumns,1,!1);return new i.SingleCursorState(new o.Range(l.lineNumber,l.column,l.lineNumber,l.column),l.leftoverVisibleColumns,new n.Position(u.lineNumber,u.column),u.leftoverVisibleColumns)},e.up=function(e,t,n,o,s,a,l){var u=i.CursorColumns.visibleColumnFromColumn(t.getLineContent(n),o,e.tabSize)+s;return(n-=a)<1?(n=1,l?o=t.getLineMinColumn(n):(o=Math.min(t.getLineMaxColumn(n),o),i.CursorColumns.isInsideSurrogatePair(t,n,o)&&(o-=1))):(o=i.CursorColumns.columnFromVisibleColumn2(e,t,n,u),i.CursorColumns.isInsideSurrogatePair(t,n,o)&&(o-=1)),s=u-i.CursorColumns.visibleColumnFromColumn(t.getLineContent(n),o,e.tabSize),new r(n,o,s)},
e.moveUp=function(t,i,n,o,r){var s,a;n.hasSelection()&&!o?(s=n.selection.startLineNumber,a=n.selection.startColumn):(s=n.position.lineNumber,a=n.position.column);var l=e.up(t,i,s,a,n.leftoverVisibleColumns,r,!0);return n.move(o,l.lineNumber,l.column,l.leftoverVisibleColumns)},e.translateUp=function(t,r,s){var a=s.selection,l=e.up(t,r,a.selectionStartLineNumber,a.selectionStartColumn,s.selectionStartLeftoverVisibleColumns,1,!1),u=e.up(t,r,a.positionLineNumber,a.positionColumn,s.leftoverVisibleColumns,1,!1);return new i.SingleCursorState(new o.Range(l.lineNumber,l.column,l.lineNumber,l.column),l.leftoverVisibleColumns,new n.Position(u.lineNumber,u.column),u.leftoverVisibleColumns)},e.moveToBeginningOfLine=function(e,t,i,n){var o,r=i.position.lineNumber,s=t.getLineMinColumn(r),a=t.getLineFirstNonWhitespaceColumn(r)||s;return o=i.position.column===a?s:a,i.move(n,r,o,0)},e.moveToEndOfLine=function(e,t,i,n){var o=i.position.lineNumber,r=t.getLineMaxColumn(o);return i.move(n,o,r,0)},
e.moveToBeginningOfBuffer=function(e,t,i,n){return i.move(n,1,1,0)},e.moveToEndOfBuffer=function(e,t,i,n){var o=t.getLineCount(),r=t.getLineMaxColumn(o);return i.move(n,o,r,0)},e}();t.MoveOperations=s}),define(t[191],i([1,0,5,81,36,190,3]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(){}return e.deleteRight=function(e,t,i,o){for(var a=[],l=3!==e,u=0,d=o.length;u<d;u++){var c=o[u],h=c;if(h.isEmpty()){var p=c.getPosition(),f=r.MoveOperations.right(t,i,p.lineNumber,p.column);h=new s.Range(f.lineNumber,f.column,p.lineNumber,p.column)}h.isEmpty()?a[u]=null:(h.startLineNumber!==h.endLineNumber&&(l=!0),a[u]=new n.ReplaceCommand(h,""))}return[l,a]},e._isAutoClosingPairDelete=function(e,t,i){if("never"===e.autoClosingBrackets&&"never"===e.autoClosingQuotes)return!1;for(var n=0,r=i.length;n<r;n++){var s=i[n],a=s.getPosition();if(!s.isEmpty())return!1;var l=t.getLineContent(a.lineNumber),u=l[a.column-2],d=e.autoClosingPairsOpen2.get(u);if(!d)return!1
;if(o.isQuote(u)){if("never"===e.autoClosingQuotes)return!1}else if("never"===e.autoClosingBrackets)return!1;for(var c=l[a.column-1],h=!1,p=0,f=d;p<f.length;p++){var g=f[p];g.open===u&&g.close===c&&(h=!0)}if(!h)return!1}return!0},e._runAutoClosingPairDelete=function(e,t,i){for(var o=[],r=0,a=i.length;r<a;r++){var l=i[r].getPosition(),u=new s.Range(l.lineNumber,l.column-1,l.lineNumber,l.column+1);o[r]=new n.ReplaceCommand(u,"")}return[!0,o]},e.deleteLeft=function(e,t,a,l){if(this._isAutoClosingPairDelete(t,a,l))return this._runAutoClosingPairDelete(t,a,l);for(var u=[],d=2!==e,c=0,h=l.length;c<h;c++){var p=l[c],f=p;if(f.isEmpty()){var g=p.getPosition();if(t.useTabStops&&g.column>1){var m=a.getLineContent(g.lineNumber),v=i.firstNonWhitespaceIndex(m),_=-1===v?m.length+1:v+1;if(g.column<=_){var y=o.CursorColumns.visibleColumnFromColumn2(t,a,g),b=o.CursorColumns.prevIndentTabStop(y,t.indentSize),C=o.CursorColumns.columnFromVisibleColumn2(t,a,g.lineNumber,b);f=new s.Range(g.lineNumber,C,g.lineNumber,g.column)
}else f=new s.Range(g.lineNumber,g.column-1,g.lineNumber,g.column)}else{var S=r.MoveOperations.left(t,a,g.lineNumber,g.column);f=new s.Range(S.lineNumber,S.column,g.lineNumber,g.column)}}f.isEmpty()?u[c]=null:(f.startLineNumber!==f.endLineNumber&&(d=!0),u[c]=new n.ReplaceCommand(f,""))}return[d,u]},e.cut=function(e,t,i){for(var r=[],a=0,l=i.length;a<l;a++){var u=i[a];if(u.isEmpty())if(e.emptySelectionClipboard){var d=u.getPosition(),c=void 0,h=void 0,p=void 0,f=void 0;d.lineNumber<t.getLineCount()?(c=d.lineNumber,h=1,p=d.lineNumber+1,f=1):d.lineNumber>1?(c=d.lineNumber-1,h=t.getLineMaxColumn(d.lineNumber-1),p=d.lineNumber,f=t.getLineMaxColumn(d.lineNumber)):(c=d.lineNumber,h=1,p=d.lineNumber,f=t.getLineMaxColumn(d.lineNumber));var g=new s.Range(c,h,p,f);g.isEmpty()?r[a]=null:r[a]=new n.ReplaceCommand(g,"")}else r[a]=null;else r[a]=new n.ReplaceCommand(u,"")}return new o.EditOperationResult(0,r,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e}();t.DeleteOperations=a}),
define(t[146],i([1,0,10,5,81,189,256,36,86,3,92,40]),function(e,t,i,n,o,s,a,l,u,d,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(){function e(){}return e.indent=function(e,t,i){if(null===t||null===i)return[];for(var n=[],o=0,r=i.length;o<r;o++)n[o]=new s.ShiftCommand(i[o],{isUnshift:!1,tabSize:e.tabSize,indentSize:e.indentSize,insertSpaces:e.insertSpaces,useTabStops:e.useTabStops});return n},e.outdent=function(e,t,i){for(var n=[],o=0,r=i.length;o<r;o++)n[o]=new s.ShiftCommand(i[o],{isUnshift:!0,tabSize:e.tabSize,indentSize:e.indentSize,insertSpaces:e.insertSpaces,useTabStops:e.useTabStops});return n},e.shiftIndent=function(e,t,i){return i=i||1,s.ShiftCommand.shiftIndent(t,t.length+i,e.tabSize,e.indentSize,e.insertSpaces)},e.unshiftIndent=function(e,t,i){return i=i||1,s.ShiftCommand.unshiftIndent(t,t.length+i,e.tabSize,e.indentSize,e.insertSpaces)},e._distributedPaste=function(e,t,i,n){for(var r=[],s=0,a=i.length;s<a;s++)r[s]=new o.ReplaceCommand(i[s],n[s])
;return new l.EditOperationResult(0,r,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._simplePaste=function(e,t,i,n,r){for(var s=[],a=0,u=i.length;a<u;a++){var c=i[a],h=c.getPosition();if(r&&n.indexOf("\n")!==n.length-1&&(r=!1),r&&c.startLineNumber!==c.endLineNumber&&(r=!1),r&&c.startColumn===t.getLineMinColumn(c.startLineNumber)&&c.endColumn===t.getLineMaxColumn(c.startLineNumber)&&(r=!1),r){var p=new d.Range(h.lineNumber,1,h.lineNumber,1);s[a]=new o.ReplaceCommand(p,n)}else s[a]=new o.ReplaceCommand(c,n)}return new l.EditOperationResult(0,s,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._distributePasteToCursors=function(e,t,i,n){if(i)return null;if(1===e.length)return null;if(n&&n.length===e.length)return n;10===t.charCodeAt(t.length-1)&&(t=t.substr(0,t.length-1));var o=t.split(/\r\n|\r|\n/);return o.length===e.length?o:null},e.paste=function(e,t,i,n,o,r){var s=this._distributePasteToCursors(i,n,o,r);return s?(i=i.sort(d.Range.compareRangesUsingStarts),
this._distributedPaste(e,t,i,s)):this._simplePaste(e,t,i,n,o)},e._goodIndentForLine=function(t,i,o){var r=null,s="",a=t.autoIndent?h.LanguageConfigurationRegistry.getInheritIndentForLine(i,o,!1):null;if(a)r=a.action,s=a.indentation;else if(o>1){var l=void 0;for(l=o-1;l>=1;l--){var u=i.getLineContent(l);if(n.lastNonWhitespaceIndex(u)>=0)break}if(l<1)return null;var p=i.getLineMaxColumn(l),f=h.LanguageConfigurationRegistry.getEnterAction(i,new d.Range(l,p,l,p));f&&(s=f.indentation,(r=f.enterAction)&&(s+=r.appendText))}return r&&(r===c.IndentAction.Indent&&(s=e.shiftIndent(t,s)),r===c.IndentAction.Outdent&&(s=e.unshiftIndent(t,s)),s=t.normalizeIndentation(s)),s||null},e._replaceJumpToNextIndent=function(e,t,i,n){var r="",s=i.getStartPosition();if(e.insertSpaces)for(var a=l.CursorColumns.visibleColumnFromColumn2(e,t,s),u=e.indentSize,d=u-a%u,c=0;c<d;c++)r+=" ";else r="\t";return new o.ReplaceCommand(i,r,n)},e.tab=function(e,t,i){for(var r=[],a=0,l=i.length;a<l;a++){var u=i[a];if(u.isEmpty()){
var c=t.getLineContent(u.startLineNumber);if(/^\s*$/.test(c)&&t.isCheapToTokenize(u.startLineNumber)){var h=this._goodIndentForLine(e,t,u.startLineNumber);h=h||"\t";var p=e.normalizeIndentation(h);if(!n.startsWith(c,p)){r[a]=new o.ReplaceCommand(new d.Range(u.startLineNumber,1,u.startLineNumber,c.length+1),p,!0);continue}}r[a]=this._replaceJumpToNextIndent(e,t,u,!0)}else{if(u.startLineNumber===u.endLineNumber){var f=t.getLineMaxColumn(u.startLineNumber);if(1!==u.startColumn||u.endColumn!==f){r[a]=this._replaceJumpToNextIndent(e,t,u,!1);continue}}r[a]=new s.ShiftCommand(u,{isUnshift:!1,tabSize:e.tabSize,indentSize:e.indentSize,insertSpaces:e.insertSpaces,useTabStops:e.useTabStops})}}return r},e.replacePreviousChar=function(e,t,i,n,r,s){for(var a=[],u=0,c=n.length;u<c;u++){var h=n[u];if(h.isEmpty()){var p=h.getPosition(),f=Math.max(1,p.column-s),g=new d.Range(p.lineNumber,f,p.lineNumber,p.column);a[u]=new o.ReplaceCommand(g,r)}else a[u]=null}return new l.EditOperationResult(1,a,{
shouldPushStackElementBefore:1!==e,shouldPushStackElementAfter:!1})},e._typeCommand=function(e,t,i){return i?new o.ReplaceCommandWithoutChangingPosition(e,t,!0):new o.ReplaceCommand(e,t,!0)},e._enter=function(t,i,r,s){if(!i.isCheapToTokenize(s.getStartPosition().lineNumber)){var a=i.getLineContent(s.startLineNumber),u=n.getLeadingWhitespace(a).substring(0,s.startColumn-1);return e._typeCommand(s,"\n"+t.normalizeIndentation(u),r)}var p=h.LanguageConfigurationRegistry.getEnterAction(i,s);if(p){var f=p.enterAction,g=p.indentation;if(f.indentAction===c.IndentAction.None)return e._typeCommand(s,"\n"+t.normalizeIndentation(g+f.appendText),r);if(f.indentAction===c.IndentAction.Indent)return e._typeCommand(s,"\n"+t.normalizeIndentation(g+f.appendText),r);if(f.indentAction===c.IndentAction.IndentOutdent){var m=t.normalizeIndentation(g),v=t.normalizeIndentation(g+f.appendText),_="\n"+v+"\n"+m
;return r?new o.ReplaceCommandWithoutChangingPosition(s,_,!0):new o.ReplaceCommandWithOffsetCursorState(s,_,-1,v.length-m.length,!0)}if(f.indentAction===c.IndentAction.Outdent){var y=e.unshiftIndent(t,g);return e._typeCommand(s,"\n"+t.normalizeIndentation(y+f.appendText),r)}}if(!t.autoIndent){var b=i.getLineContent(s.startLineNumber),C=n.getLeadingWhitespace(b).substring(0,s.startColumn-1);return e._typeCommand(s,"\n"+t.normalizeIndentation(C),r)}var S=h.LanguageConfigurationRegistry.getIndentForEnter(i,s,{unshiftIndent:function(i){return e.unshiftIndent(t,i)},shiftIndent:function(i){return e.shiftIndent(t,i)},normalizeIndentation:function(e){return t.normalizeIndentation(e)}},t.autoIndent),w=i.getLineContent(s.startLineNumber),E=n.getLeadingWhitespace(w).substring(0,s.startColumn-1);if(S){var L=l.CursorColumns.visibleColumnFromColumn2(t,i,s.getEndPosition()),x=s.endColumn,D="\n";E!==t.normalizeIndentation(S.beforeEnter)&&(D=t.normalizeIndentation(S.beforeEnter)+w.substring(E.length,s.startColumn-1)+"\n",
s=new d.Range(s.startLineNumber,1,s.endLineNumber,s.endColumn));var I=i.getLineContent(s.endLineNumber),N=n.firstNonWhitespaceIndex(I);if(s=N>=0?s.setEndPosition(s.endLineNumber,Math.max(s.endColumn,N+1)):s.setEndPosition(s.endLineNumber,i.getLineMaxColumn(s.endLineNumber)),r)return new o.ReplaceCommandWithoutChangingPosition(s,D+t.normalizeIndentation(S.afterEnter),!0);var M=0;return x<=N+1&&(t.insertSpaces||(L=Math.ceil(L/t.indentSize)),M=Math.min(L+1-t.normalizeIndentation(S.afterEnter).length-1,0)),new o.ReplaceCommandWithOffsetCursorState(s,D+t.normalizeIndentation(S.afterEnter),0,M,!0)}return e._typeCommand(s,"\n"+t.normalizeIndentation(E),r)},e._isAutoIndentType=function(e,t,i){if(!e.autoIndent)return!1;for(var n=0,o=i.length;n<o;n++)if(!t.isCheapToTokenize(i[n].getEndPosition().lineNumber))return!1;return!0},e._runAutoIndentType=function(t,i,n,o){
var r=h.LanguageConfigurationRegistry.getIndentationAtPosition(i,n.startLineNumber,n.startColumn),s=h.LanguageConfigurationRegistry.getIndentActionForType(i,n,o,{shiftIndent:function(i){return e.shiftIndent(t,i)},unshiftIndent:function(i){return e.unshiftIndent(t,i)}});if(null===s)return null;if(s!==t.normalizeIndentation(r)){var a=i.getLineFirstNonWhitespaceColumn(n.startLineNumber);return 0===a?e._typeCommand(new d.Range(n.startLineNumber,0,n.endLineNumber,n.endColumn),t.normalizeIndentation(s)+o,!1):e._typeCommand(new d.Range(n.startLineNumber,0,n.endLineNumber,n.endColumn),t.normalizeIndentation(s)+i.getLineContent(n.startLineNumber).substring(a-1,n.startColumn-1)+o,!1)}return null},e._isAutoClosingOvertype=function(e,t,i,n,o){if("never"===e.autoClosingOvertype)return!1;if(!e.autoClosingPairsClose2.has(o))return!1;for(var r=0,s=i.length;r<s;r++){var a=i[r];if(!a.isEmpty())return!1;var l=a.getPosition();if(t.getLineContent(l.lineNumber).charAt(l.column-1)!==o)return!1;if("auto"===e.autoClosingOvertype){
for(var u=!1,d=0,c=n.length;d<c;d++){var h=n[d];if(l.lineNumber===h.startLineNumber&&l.column===h.startColumn){u=!0;break}}if(!u)return!1}}return!0},e._runAutoClosingOvertype=function(e,t,i,n,r){for(var s=[],a=0,u=n.length;a<u;a++){var c=n[a].getPosition(),h=new d.Range(c.lineNumber,c.column,c.lineNumber,c.column+1);s[a]=new o.ReplaceCommand(h,r)}return new l.EditOperationResult(1,s,{shouldPushStackElementBefore:1!==e,shouldPushStackElementAfter:!1})},e._isBeforeClosingBrace=function(e,t,i){var n=e.autoClosingPairsClose2.get(i);if(!n)return!1;for(var o=t.open===t.close,r=0,s=n;r<s.length;r++){var a=s[r],l=a.open===a.close;if(o||!l)return!0}return!1},e._findAutoClosingPairOpen=function(e,t,i,n){var o=e.autoClosingPairsOpen2.get(n);if(!o)return null;for(var r=null,s=0,a=o;s<a.length;s++){var l=a[s];if(null===r||l.open.length>r.open.length){for(var u=!0,c=0,h=i;c<h.length;c++){var p=h[c];if(t.getValueInRange(new d.Range(p.lineNumber,p.column-l.open.length+1,p.lineNumber,p.column))+n!==l.open){u=!1;break}}
u&&(r=l)}}return r},e._isAutoClosingOpenCharType=function(t,n,o,r,s){var a=l.isQuote(r),d=a?t.autoClosingQuotes:t.autoClosingBrackets;if("never"===d)return null;var c=this._findAutoClosingPairOpen(t,n,o.map(function(e){return e.getPosition()}),r);if(!c)return null;for(var p=a?t.shouldAutoCloseBefore.quote:t.shouldAutoCloseBefore.bracket,f=0,g=o.length;f<g;f++){var m=o[f];if(!m.isEmpty())return null;var v=m.getPosition(),_=n.getLineContent(v.lineNumber);if(_.length>v.column-1){var y=_.charAt(v.column-1);if(!e._isBeforeClosingBrace(t,c,y)&&!p(y))return null}if(!n.isCheapToTokenize(v.lineNumber))return null;if(1===c.open.length&&a&&"always"!==d){var b=u.getMapForWordSeparators(t.wordSeparators);if(s&&v.column>1&&0===b.get(_.charCodeAt(v.column-2)))return null;if(!s&&v.column>2&&0===b.get(_.charCodeAt(v.column-3)))return null}n.forceTokenization(v.lineNumber);var C=n.getLineTokens(v.lineNumber),S=!1;try{S=h.LanguageConfigurationRegistry.shouldAutoClosePair(c,C,s?v.column:v.column-1)}catch(e){
i.onUnexpectedError(e)}if(!S)return null}return c},e._runAutoClosingOpenCharType=function(e,t,i,n,o,r,s){for(var a=[],u=0,d=n.length;u<d;u++){var c=n[u];a[u]=new f(c,o,r,s.close)}return new l.EditOperationResult(1,a,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})},e._shouldSurroundChar=function(e,t){return l.isQuote(t)?"quotes"===e.autoSurround||"languageDefined"===e.autoSurround:"brackets"===e.autoSurround||"languageDefined"===e.autoSurround},e._isSurroundSelectionType=function(t,i,n,o){if(!e._shouldSurroundChar(t,o)||!t.surroundingPairs.hasOwnProperty(o))return!1;for(var r=l.isQuote(o),s=0,a=n.length;s<a;s++){var u=n[s];if(u.isEmpty())return!1;for(var d=!0,c=u.startLineNumber;c<=u.endLineNumber;c++){var h=i.getLineContent(c),p=c===u.startLineNumber?u.startColumn-1:0,f=c===u.endLineNumber?u.endColumn-1:h.length,g=h.substring(p,f);if(/[^ \t]/.test(g)){d=!1;break}}if(d)return!1;if(r&&u.startLineNumber===u.endLineNumber&&u.startColumn+1===u.endColumn){var m=i.getValueInRange(u)
;if(l.isQuote(m))return!1}}return!0},e._runSurroundSelectionType=function(e,t,i,n,o){for(var r=[],s=0,u=n.length;s<u;s++){var d=n[s],c=t.surroundingPairs[o];r[s]=new a.SurroundSelectionCommand(d,o,c)}return new l.EditOperationResult(0,r,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._isTypeInterceptorElectricChar=function(e,t,i){return!(1!==i.length||!t.isCheapToTokenize(i[0].getEndPosition().lineNumber))},e._typeInterceptorElectricChar=function(e,t,r,s,a){if(!t.electricChars.hasOwnProperty(a)||!s.isEmpty())return null;var u=s.getPosition();r.forceTokenization(u.lineNumber);var c,p=r.getLineTokens(u.lineNumber);try{c=h.LanguageConfigurationRegistry.onElectricCharacter(a,p,u.column)}catch(e){return i.onUnexpectedError(e),null}if(!c)return null;if(c.matchOpenBracket){var f=(p.getLineContent()+a).lastIndexOf(c.matchOpenBracket)+1,g=r.findMatchingBracketUp(c.matchOpenBracket,{lineNumber:u.lineNumber,column:f});if(g){if(g.startLineNumber===u.lineNumber)return null
;var m=r.getLineContent(g.startLineNumber),v=n.getLeadingWhitespace(m),_=t.normalizeIndentation(v),y=r.getLineContent(u.lineNumber),b=r.getLineFirstNonWhitespaceColumn(u.lineNumber)||u.column,C=_+y.substring(b-1,u.column-1)+a,S=new d.Range(u.lineNumber,1,u.lineNumber,u.column),w=new o.ReplaceCommand(S,C);return new l.EditOperationResult(1,[w],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!0})}}return null},e.compositionEndWithInterceptors=function(e,t,i,n,r){for(var s=null,a=0,u=n;a<u.length;a++){var c=u[a];if(!c.isEmpty())return null;var h=c.getPosition(),p=i.getValueInRange(new d.Range(h.lineNumber,h.column-1,h.lineNumber,h.column));if(null===s)s=p;else if(s!==p)return null}if(!s)return null;if(this._isAutoClosingOvertype(t,i,n,r,s)){var f=n.map(function(e){return new o.ReplaceCommand(new d.Range(e.positionLineNumber,e.positionColumn,e.positionLineNumber,e.positionColumn+1),"",!1)});return new l.EditOperationResult(1,f,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})}
var g=this._isAutoClosingOpenCharType(t,i,n,s,!1);return g?this._runAutoClosingOpenCharType(e,t,i,n,s,!1,g):null},e.typeWithInterceptors=function(t,i,n,r,s,a){if("\n"===a){for(var u=[],d=0,c=r.length;d<c;d++)u[d]=e._enter(i,n,!1,r[d]);return new l.EditOperationResult(1,u,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})}if(this._isAutoIndentType(i,n,r)){for(var h=[],p=!1,d=0,c=r.length;d<c;d++)if(h[d]=this._runAutoIndentType(i,n,r[d],a),!h[d]){p=!0;break}if(!p)return new l.EditOperationResult(1,h,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})}if(this._isAutoClosingOvertype(i,n,r,s,a))return this._runAutoClosingOvertype(t,i,n,r,a);var f=this._isAutoClosingOpenCharType(i,n,r,a,!0);if(f)return this._runAutoClosingOpenCharType(t,i,n,r,a,!0,f);if(this._isSurroundSelectionType(i,n,r,a))return this._runSurroundSelectionType(t,i,n,r,a);if(this._isTypeInterceptorElectricChar(i,n,r)){var g=this._typeInterceptorElectricChar(t,i,n,r[0],a);if(g)return g}
for(var m=[],d=0,c=r.length;d<c;d++)m[d]=new o.ReplaceCommand(r[d],a);var v=1!==t;return" "===a&&(v=!0),new l.EditOperationResult(1,m,{shouldPushStackElementBefore:v,shouldPushStackElementAfter:!1})},e.typeWithoutInterceptors=function(e,t,i,n,r){for(var s=[],a=0,u=n.length;a<u;a++)s[a]=new o.ReplaceCommand(n[a],r);return new l.EditOperationResult(1,s,{shouldPushStackElementBefore:1!==e,shouldPushStackElementAfter:!1})},e.lineInsertBefore=function(e,t,i){if(null===t||null===i)return[];for(var n=[],r=0,s=i.length;r<s;r++){var a=i[r].positionLineNumber;if(1===a)n[r]=new o.ReplaceCommandWithoutChangingPosition(new d.Range(1,1,1,1),"\n");else{a--;var l=t.getLineMaxColumn(a);n[r]=this._enter(e,t,!1,new d.Range(a,l,a,l))}}return n},e.lineInsertAfter=function(e,t,i){if(null===t||null===i)return[];for(var n=[],o=0,r=i.length;o<r;o++){var s=i[o].positionLineNumber,a=t.getLineMaxColumn(s);n[o]=this._enter(e,t,!1,new d.Range(s,a,s,a))}return n},e.lineBreakInsert=function(e,t,i){
for(var n=[],o=0,r=i.length;o<r;o++)n[o]=this._enter(e,t,!0,i[o]);return n},e}();t.TypeOperations=p;var f=function(e){function t(t,i,n,o){var r=e.call(this,t,(n?i:"")+o,0,-o.length)||this;return r._openCharacter=i,r._closeCharacter=o,r.closeCharacterRange=null,r.enclosingRange=null,r}return r(t,e),t.prototype.computeCursorState=function(t,i){var n=i.getInverseEditOperations()[0].range;return this.closeCharacterRange=new d.Range(n.startLineNumber,n.endColumn-this._closeCharacter.length,n.endLineNumber,n.endColumn),this.enclosingRange=new d.Range(n.startLineNumber,n.endColumn-this._openCharacter.length-this._closeCharacter.length,n.endLineNumber,n.endColumn),e.prototype.computeCursorState.call(this,t,i)},t}(o.ReplaceCommandWithOffsetCursorState);t.TypeWithAutoClosingCommand=f}),define(t[145],i([1,0,5,36,86,13,3]),function(e,t,i,n,o,s,a){"use strict";function l(e){return e.filter(function(e){return Boolean(e)})}Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(){}
return e._createWord=function(e,t,i,n,o){return{start:n,end:o,wordType:t,nextCharClass:i}},e._findPreviousWordOnLine=function(e,t,i){var n=t.getLineContent(i.lineNumber);return this._doFindPreviousWordOnLine(n,e,i)},e._doFindPreviousWordOnLine=function(e,t,i){for(var n=0,o=i.column-2;o>=0;o--){var r=e.charCodeAt(o),s=t.get(r);if(0===s){if(2===n)return this._createWord(e,n,s,o+1,this._findEndOfWord(e,t,n,o+1));n=1}else if(2===s){if(1===n)return this._createWord(e,n,s,o+1,this._findEndOfWord(e,t,n,o+1));n=2}else if(1===s&&0!==n)return this._createWord(e,n,s,o+1,this._findEndOfWord(e,t,n,o+1))}return 0!==n?this._createWord(e,n,1,0,this._findEndOfWord(e,t,n,0)):null},e._findEndOfWord=function(e,t,i,n){for(var o=e.length,r=n;r<o;r++){var s=e.charCodeAt(r),a=t.get(s);if(1===a)return r;if(1===i&&2===a)return r;if(2===i&&0===a)return r}return o},e._findNextWordOnLine=function(e,t,i){var n=t.getLineContent(i.lineNumber);return this._doFindNextWordOnLine(n,e,i)},e._doFindNextWordOnLine=function(e,t,i){
for(var n=0,o=e.length,r=i.column-1;r<o;r++){var s=e.charCodeAt(r),a=t.get(s);if(0===a){if(2===n)return this._createWord(e,n,a,this._findStartOfWord(e,t,n,r-1),r);n=1}else if(2===a){if(1===n)return this._createWord(e,n,a,this._findStartOfWord(e,t,n,r-1),r);n=2}else if(1===a&&0!==n)return this._createWord(e,n,a,this._findStartOfWord(e,t,n,r-1),r)}return 0!==n?this._createWord(e,n,1,this._findStartOfWord(e,t,n,o-1),o):null},e._findStartOfWord=function(e,t,i,n){for(var o=n;o>=0;o--){var r=e.charCodeAt(o),s=t.get(r);if(1===s)return o+1;if(1===i&&2===s)return o+1;if(2===i&&0===s)return o+1}return 0},e.moveWordLeft=function(t,i,n,o){var r=n.lineNumber,a=n.column,l=!1;1===a&&r>1&&(l=!0,r-=1,a=i.getLineMaxColumn(r));var u=e._findPreviousWordOnLine(t,i,new s.Position(r,a));if(0===o){if(u&&!l){if(i.getLineLastNonWhitespaceColumn(r)<a)return new s.Position(r,u.end+1)}return new s.Position(r,u?u.start+1:1)}
if(1===o)return u&&2===u.wordType&&u.end-u.start==1&&0===u.nextCharClass&&(u=e._findPreviousWordOnLine(t,i,new s.Position(r,u.start+1))),new s.Position(r,u?u.start+1:1);if(3===o){for(;u&&2===u.wordType;)u=e._findPreviousWordOnLine(t,i,new s.Position(r,u.start+1));return new s.Position(r,u?u.start+1:1)}return u&&a<=u.end+1&&(u=e._findPreviousWordOnLine(t,i,new s.Position(r,u.start+1))),new s.Position(r,u?u.end+1:1)},e._moveWordPartLeft=function(e,t){var n=t.lineNumber,o=e.getLineMaxColumn(n);if(1===t.column)return n>1?new s.Position(n-1,e.getLineMaxColumn(n-1)):t;for(var r=e.getLineContent(n),a=t.column-1;a>1;a--){var l=r.charCodeAt(a-2),u=r.charCodeAt(a-1);if(95!==l&&95===u)return new s.Position(n,a);if(i.isLowerAsciiLetter(l)&&i.isUpperAsciiLetter(u))return new s.Position(n,a);if(i.isUpperAsciiLetter(l)&&i.isUpperAsciiLetter(u)&&a+1<o){var d=r.charCodeAt(a);if(i.isLowerAsciiLetter(d))return new s.Position(n,a)}}return new s.Position(n,1)},e.moveWordRight=function(t,i,n,o){var r=n.lineNumber,a=n.column,l=!1
;a===i.getLineMaxColumn(r)&&r<i.getLineCount()&&(l=!0,r+=1,a=1);var u=e._findNextWordOnLine(t,i,new s.Position(r,a));if(2===o)u&&2===u.wordType&&u.end-u.start==1&&0===u.nextCharClass&&(u=e._findNextWordOnLine(t,i,new s.Position(r,u.end+1))),a=u?u.end+1:i.getLineMaxColumn(r);else if(3===o){for(;u&&2===u.wordType;)u=e._findNextWordOnLine(t,i,new s.Position(r,u.end+1));a=u?u.end+1:i.getLineMaxColumn(r)}else u&&!l&&a>=u.start+1&&(u=e._findNextWordOnLine(t,i,new s.Position(r,u.end+1))),a=u?u.start+1:i.getLineMaxColumn(r);return new s.Position(r,a)},e._moveWordPartRight=function(e,t){var n=t.lineNumber,o=e.getLineMaxColumn(n);if(t.column===o)return n<e.getLineCount()?new s.Position(n+1,1):t;for(var r=e.getLineContent(n),a=t.column+1;a<o;a++){var l=r.charCodeAt(a-2),u=r.charCodeAt(a-1);if(95===l&&95!==u)return new s.Position(n,a);if(i.isLowerAsciiLetter(l)&&i.isUpperAsciiLetter(u))return new s.Position(n,a);if(i.isUpperAsciiLetter(l)&&i.isUpperAsciiLetter(u)&&a+1<o){var d=r.charCodeAt(a)
;if(i.isLowerAsciiLetter(d))return new s.Position(n,a)}}return new s.Position(n,o)},e._deleteWordLeftWhitespace=function(e,t){var n=e.getLineContent(t.lineNumber),o=t.column-2,r=i.lastNonWhitespaceIndex(n,o);return r+1<o?new a.Range(t.lineNumber,r+2,t.lineNumber,t.column):null},e.deleteWordLeft=function(t,i,n,o,r){if(!n.isEmpty())return n;var l=new s.Position(n.positionLineNumber,n.positionColumn),u=l.lineNumber,d=l.column;if(1===u&&1===d)return null;if(o){var c=this._deleteWordLeftWhitespace(i,l);if(c)return c}var h=e._findPreviousWordOnLine(t,i,l);return 0===r?h?d=h.start+1:d>1?d=1:(u--,d=i.getLineMaxColumn(u)):(h&&d<=h.end+1&&(h=e._findPreviousWordOnLine(t,i,new s.Position(u,h.start+1))),h?d=h.end+1:d>1?d=1:(u--,d=i.getLineMaxColumn(u))),new a.Range(u,d,l.lineNumber,l.column)},e._deleteWordPartLeft=function(t,i){if(!i.isEmpty())return i;var n=i.getPosition(),o=e._moveWordPartLeft(t,n);return new a.Range(n.lineNumber,n.column,o.lineNumber,o.column)},e._findFirstNonWhitespaceChar=function(e,t){
for(var i=e.length,n=t;n<i;n++){var o=e.charAt(n);if(" "!==o&&"\t"!==o)return n}return i},e._deleteWordRightWhitespace=function(e,t){var i=e.getLineContent(t.lineNumber),n=t.column-1,o=this._findFirstNonWhitespaceChar(i,n);return n+1<o?new a.Range(t.lineNumber,t.column,t.lineNumber,o+1):null},e.deleteWordRight=function(t,i,n,o,r){if(!n.isEmpty())return n;var l=new s.Position(n.positionLineNumber,n.positionColumn),u=l.lineNumber,d=l.column,c=i.getLineCount(),h=i.getLineMaxColumn(u);if(u===c&&d===h)return null;if(o){var p=this._deleteWordRightWhitespace(i,l);if(p)return p}var f=e._findNextWordOnLine(t,i,l);return 2===r?f?d=f.end+1:d<h||u===c?d=h:(u++,d=(f=e._findNextWordOnLine(t,i,new s.Position(u,1)))?f.start+1:i.getLineMaxColumn(u)):(f&&d>=f.start+1&&(f=e._findNextWordOnLine(t,i,new s.Position(u,f.end+1))),f?d=f.start+1:d<h||u===c?d=h:(u++,d=(f=e._findNextWordOnLine(t,i,new s.Position(u,1)))?f.start+1:i.getLineMaxColumn(u))),new a.Range(u,d,l.lineNumber,l.column)},e._deleteWordPartRight=function(t,i){
if(!i.isEmpty())return i;var n=i.getPosition(),o=e._moveWordPartRight(t,n);return new a.Range(n.lineNumber,n.column,o.lineNumber,o.column)},e.word=function(t,i,r,l,u){var d=o.getMapForWordSeparators(t.wordSeparators),c=e._findPreviousWordOnLine(d,i,u),h=e._findNextWordOnLine(d,i,u);if(!l){var p,f;return c&&1===c.wordType&&c.start<=u.column-1&&u.column-1<=c.end?(p=c.start+1,f=c.end+1):h&&1===h.wordType&&h.start<=u.column-1&&u.column-1<=h.end?(p=h.start+1,f=h.end+1):(p=c?c.end+1:1,f=h?h.start+1:i.getLineMaxColumn(u.lineNumber)),new n.SingleCursorState(new a.Range(u.lineNumber,p,u.lineNumber,f),0,new s.Position(u.lineNumber,f),0)}var g,m;c&&1===c.wordType&&c.start<u.column-1&&u.column-1<c.end?(g=c.start+1,m=c.end+1):h&&1===h.wordType&&h.start<u.column-1&&u.column-1<h.end?(g=h.start+1,m=h.end+1):(g=u.column,m=u.column);var v,_=u.lineNumber;if(r.selectionStart.containsPosition(u))v=r.selectionStart.endColumn;else if(u.isBeforeOrEqual(r.selectionStart.getStartPosition())){v=g;y=new s.Position(_,v)
;r.selectionStart.containsPosition(y)&&(v=r.selectionStart.endColumn)}else{v=m;var y=new s.Position(_,v);r.selectionStart.containsPosition(y)&&(v=r.selectionStart.startColumn)}return r.move(!0,_,v,0)},e}();t.WordOperations=u;var d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.deleteWordPartLeft=function(e,t,i,n){var o=l([u.deleteWordLeft(e,t,i,n,0),u.deleteWordLeft(e,t,i,n,2),u._deleteWordPartLeft(t,i)]);return o.sort(a.Range.compareRangesUsingEnds),o[2]},t.deleteWordPartRight=function(e,t,i,n){var o=l([u.deleteWordRight(e,t,i,n,0),u.deleteWordRight(e,t,i,n,2),u._deleteWordPartRight(t,i)]);return o.sort(a.Range.compareRangesUsingStarts),o[0]},t.moveWordPartLeft=function(e,t,i){var n=l([u.moveWordLeft(e,t,i,0),u.moveWordLeft(e,t,i,2),u._moveWordPartLeft(t,i)]);return n.sort(s.Position.compare),n[2]},t.moveWordPartRight=function(e,t,i){var n=l([u.moveWordRight(e,t,i,0),u.moveWordRight(e,t,i,2),u._moveWordPartRight(t,i)]);return n.sort(s.Position.compare),n[0]},t}(u)
;t.WordPartOperations=d}),define(t[192],i([1,0,23,36,190,145,13,3]),function(e,t,i,n,o,r,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(){function e(){}return e.addCursorDown=function(e,t,i){for(var r=[],s=0,a=0,l=t.length;a<l;a++){var u=t[a];r[s++]=new n.CursorState(u.modelState,u.viewState),r[s++]=i?n.CursorState.fromModelState(o.MoveOperations.translateDown(e.config,e.model,u.modelState)):n.CursorState.fromViewState(o.MoveOperations.translateDown(e.config,e.viewModel,u.viewState))}return r},e.addCursorUp=function(e,t,i){for(var r=[],s=0,a=0,l=t.length;a<l;a++){var u=t[a];r[s++]=new n.CursorState(u.modelState,u.viewState),r[s++]=i?n.CursorState.fromModelState(o.MoveOperations.translateUp(e.config,e.model,u.modelState)):n.CursorState.fromViewState(o.MoveOperations.translateUp(e.config,e.viewModel,u.viewState))}return r},e.moveToBeginningOfLine=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o];n[o]=this._moveToLineStart(e,s,i)}return n},
e._moveToLineStart=function(e,t,i){var n=t.viewState.position.column,o=n===t.modelState.position.column,r=t.viewState.position.lineNumber,s=e.viewModel.getLineFirstNonWhitespaceColumn(r);return o||n===s?this._moveToLineStartByModel(e,t,i):this._moveToLineStartByView(e,t,i)},e._moveToLineStartByView=function(e,t,i){return n.CursorState.fromViewState(o.MoveOperations.moveToBeginningOfLine(e.config,e.viewModel,t.viewState,i))},e._moveToLineStartByModel=function(e,t,i){return n.CursorState.fromModelState(o.MoveOperations.moveToBeginningOfLine(e.config,e.model,t.modelState,i))},e.moveToEndOfLine=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o];n[o]=this._moveToLineEnd(e,s,i)}return n},e._moveToLineEnd=function(e,t,i){var n=t.viewState.position,o=e.viewModel.getLineMaxColumn(n.lineNumber),r=n.column===o,s=t.modelState.position,a=e.model.getLineMaxColumn(s.lineNumber),l=o-n.column==a-s.column;return r||l?this._moveToLineEndByModel(e,t,i):this._moveToLineEndByView(e,t,i)},
e._moveToLineEndByView=function(e,t,i){return n.CursorState.fromViewState(o.MoveOperations.moveToEndOfLine(e.config,e.viewModel,t.viewState,i))},e._moveToLineEndByModel=function(e,t,i){return n.CursorState.fromModelState(o.MoveOperations.moveToEndOfLine(e.config,e.model,t.modelState,i))},e.expandLineSelection=function(e,t){for(var i=[],o=0,r=t.length;o<r;o++){var l=t[o].viewState.selection,u=l.startLineNumber,d=e.viewModel.getLineCount(),c=l.endLineNumber,h=void 0;c===d?h=e.viewModel.getLineMaxColumn(d):(c++,h=1),i[o]=n.CursorState.fromViewState(new n.SingleCursorState(new a.Range(u,1,u,1),0,new s.Position(c,h),0))}return i},e.moveToBeginningOfBuffer=function(e,t,i){for(var r=[],s=0,a=t.length;s<a;s++){var l=t[s];r[s]=n.CursorState.fromModelState(o.MoveOperations.moveToBeginningOfBuffer(e.config,e.model,l.modelState,i))}return r},e.moveToEndOfBuffer=function(e,t,i){for(var r=[],s=0,a=t.length;s<a;s++){var l=t[s]
;r[s]=n.CursorState.fromModelState(o.MoveOperations.moveToEndOfBuffer(e.config,e.model,l.modelState,i))}return r},e.selectAll=function(e,t){var i=e.model.getLineCount(),o=e.model.getLineMaxColumn(i);return n.CursorState.fromModelState(new n.SingleCursorState(new a.Range(1,1,1,1),0,new s.Position(i,o),0))},e.line=function(e,t,i,o,r){var l=e.model.validatePosition(o),u=r?e.validateViewPosition(new s.Position(r.lineNumber,r.column),l):e.convertModelPositionToViewPosition(l);if(!i||!t.modelState.hasSelection()){var d=e.model.getLineCount(),c=l.lineNumber+1,h=1;return c>d&&(c=d,h=e.model.getLineMaxColumn(c)),n.CursorState.fromModelState(new n.SingleCursorState(new a.Range(l.lineNumber,1,c,h),0,new s.Position(c,h),0))}var p=t.modelState.selectionStart.getStartPosition().lineNumber;if(l.lineNumber<p)return n.CursorState.fromViewState(t.viewState.move(t.modelState.hasSelection(),u.lineNumber,1,0));if(l.lineNumber>p){var d=e.viewModel.getLineCount(),f=u.lineNumber+1,g=1;return f>d&&(f=d,
g=e.viewModel.getLineMaxColumn(f)),n.CursorState.fromViewState(t.viewState.move(t.modelState.hasSelection(),f,g,0))}var m=t.modelState.selectionStart.getEndPosition();return n.CursorState.fromModelState(t.modelState.move(t.modelState.hasSelection(),m.lineNumber,m.column,0))},e.word=function(e,t,i,o){var s=e.model.validatePosition(o);return n.CursorState.fromModelState(r.WordOperations.word(e.config,e.model,t.modelState,i,s))},e.cancelSelection=function(e,t){if(!t.modelState.hasSelection())return new n.CursorState(t.modelState,t.viewState);var i=t.viewState.position.lineNumber,o=t.viewState.position.column;return n.CursorState.fromViewState(new n.SingleCursorState(new a.Range(i,o,i,o),0,new s.Position(i,o),0))},e.moveTo=function(e,t,i,o,r){var a=e.model.validatePosition(o),l=r?e.validateViewPosition(new s.Position(r.lineNumber,r.column),a):e.convertModelPositionToViewPosition(a);return n.CursorState.fromViewState(t.viewState.move(i,l.lineNumber,l.column,0))},e.move=function(e,t,i){var n=i.select,o=i.value
;switch(i.direction){case 0:return 4===i.unit?this._moveHalfLineLeft(e,t,n):this._moveLeft(e,t,n,o);case 1:return 4===i.unit?this._moveHalfLineRight(e,t,n):this._moveRight(e,t,n,o);case 2:return 2===i.unit?this._moveUpByViewLines(e,t,n,o):this._moveUpByModelLines(e,t,n,o);case 3:return 2===i.unit?this._moveDownByViewLines(e,t,n,o):this._moveDownByModelLines(e,t,n,o);case 4:return this._moveToViewMinColumn(e,t,n);case 5:return this._moveToViewFirstNonWhitespaceColumn(e,t,n);case 6:return this._moveToViewCenterColumn(e,t,n);case 7:return this._moveToViewMaxColumn(e,t,n);case 8:return this._moveToViewLastNonWhitespaceColumn(e,t,n);case 9:var r=t[0],s=e.getCompletelyVisibleModelRange(),a=this._firstLineNumberInRange(e.model,s,o),l=e.model.getLineFirstNonWhitespaceColumn(a);return[this._moveToModelPosition(e,r,n,a,l)];case 11:var r=t[0],s=e.getCompletelyVisibleModelRange(),a=this._lastLineNumberInRange(e.model,s,o),l=e.model.getLineFirstNonWhitespaceColumn(a);return[this._moveToModelPosition(e,r,n,a,l)];case 10:
var r=t[0],s=e.getCompletelyVisibleModelRange(),a=Math.round((s.startLineNumber+s.endLineNumber)/2),l=e.model.getLineFirstNonWhitespaceColumn(a);return[this._moveToModelPosition(e,r,n,a,l)];case 12:for(var u=e.getCompletelyVisibleViewRange(),d=[],c=0,h=t.length;c<h;c++){r=t[c];d[c]=this.findPositionInViewportIfOutside(e,r,u,n)}return d}return null},e.findPositionInViewportIfOutside=function(e,t,i,o){var r=t.viewState.position.lineNumber;if(i.startLineNumber<=r&&r<=i.endLineNumber-1)return new n.CursorState(t.modelState,t.viewState);r>i.endLineNumber-1&&(r=i.endLineNumber-1),r<i.startLineNumber&&(r=i.startLineNumber);var s=e.viewModel.getLineFirstNonWhitespaceColumn(r);return this._moveToViewPosition(e,t,o,r,s)},e._firstLineNumberInRange=function(e,t,i){var n=t.startLineNumber;return t.startColumn!==e.getLineMinColumn(n)&&n++,Math.min(t.endLineNumber,n+i-1)},e._lastLineNumberInRange=function(e,t,i){var n=t.startLineNumber;return t.startColumn!==e.getLineMinColumn(n)&&n++,Math.max(n,t.endLineNumber-i+1)},
e._moveLeft=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a],d=o.MoveOperations.moveLeft(e.config,e.viewModel,u.viewState,i,r);if(1===r&&d.position.lineNumber!==u.viewState.position.lineNumber){e.viewModel.coordinatesConverter.convertViewPositionToModelPosition(d.position).lineNumber===u.modelState.position.lineNumber&&(d=o.MoveOperations.moveLeft(e.config,e.viewModel,d,i,1))}s[a]=n.CursorState.fromViewState(d)}return s},e._moveHalfLineLeft=function(e,t,i){for(var r=[],s=0,a=t.length;s<a;s++){var l=t[s],u=l.viewState.position.lineNumber,d=Math.round(e.viewModel.getLineContent(u).length/2);r[s]=n.CursorState.fromViewState(o.MoveOperations.moveLeft(e.config,e.viewModel,l.viewState,i,d))}return r},e._moveRight=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a],d=o.MoveOperations.moveRight(e.config,e.viewModel,u.viewState,i,r);if(1===r&&d.position.lineNumber!==u.viewState.position.lineNumber){
e.viewModel.coordinatesConverter.convertViewPositionToModelPosition(d.position).lineNumber===u.modelState.position.lineNumber&&(d=o.MoveOperations.moveRight(e.config,e.viewModel,d,i,1))}s[a]=n.CursorState.fromViewState(d)}return s},e._moveHalfLineRight=function(e,t,i){for(var r=[],s=0,a=t.length;s<a;s++){var l=t[s],u=l.viewState.position.lineNumber,d=Math.round(e.viewModel.getLineContent(u).length/2);r[s]=n.CursorState.fromViewState(o.MoveOperations.moveRight(e.config,e.viewModel,l.viewState,i,d))}return r},e._moveDownByViewLines=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a];s[a]=n.CursorState.fromViewState(o.MoveOperations.moveDown(e.config,e.viewModel,u.viewState,i,r))}return s},e._moveDownByModelLines=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a];s[a]=n.CursorState.fromModelState(o.MoveOperations.moveDown(e.config,e.model,u.modelState,i,r))}return s},e._moveUpByViewLines=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a]
;s[a]=n.CursorState.fromViewState(o.MoveOperations.moveUp(e.config,e.viewModel,u.viewState,i,r))}return s},e._moveUpByModelLines=function(e,t,i,r){for(var s=[],a=0,l=t.length;a<l;a++){var u=t[a];s[a]=n.CursorState.fromModelState(o.MoveOperations.moveUp(e.config,e.model,u.modelState,i,r))}return s},e._moveToViewPosition=function(e,t,i,o,r){return n.CursorState.fromViewState(t.viewState.move(i,o,r,0))},e._moveToModelPosition=function(e,t,i,o,r){return n.CursorState.fromModelState(t.modelState.move(i,o,r,0))},e._moveToViewMinColumn=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=s.viewState.position.lineNumber,l=e.viewModel.getLineMinColumn(a);n[o]=this._moveToViewPosition(e,s,i,a,l)}return n},e._moveToViewFirstNonWhitespaceColumn=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=s.viewState.position.lineNumber,l=e.viewModel.getLineFirstNonWhitespaceColumn(a);n[o]=this._moveToViewPosition(e,s,i,a,l)}return n},e._moveToViewCenterColumn=function(e,t,i){
for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=s.viewState.position.lineNumber,l=Math.round((e.viewModel.getLineMaxColumn(a)+e.viewModel.getLineMinColumn(a))/2);n[o]=this._moveToViewPosition(e,s,i,a,l)}return n},e._moveToViewMaxColumn=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=s.viewState.position.lineNumber,l=e.viewModel.getLineMaxColumn(a);n[o]=this._moveToViewPosition(e,s,i,a,l)}return n},e._moveToViewLastNonWhitespaceColumn=function(e,t,i){for(var n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=s.viewState.position.lineNumber,l=e.viewModel.getLineLastNonWhitespaceColumn(a);n[o]=this._moveToViewPosition(e,s,i,a,l)}return n},e}();t.CursorMoveCommands=l;!function(e){e.description={description:"Move cursor to a logical position in the view",args:[{name:"Cursor move argument object",
description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'to': A mandatory logical position value providing where to move the cursor.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'left', 'right', 'up', 'down'\n\t\t\t\t\t\t'wrappedLineStart', 'wrappedLineEnd', 'wrappedLineColumnCenter'\n\t\t\t\t\t\t'wrappedLineFirstNonWhitespaceCharacter', 'wrappedLineLastNonWhitespaceCharacter'\n\t\t\t\t\t\t'viewPortTop', 'viewPortCenter', 'viewPortBottom', 'viewPortIfOutside'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'by': Unit to move. Default is computed based on 'to' value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'line', 'wrappedLine', 'character', 'halfLine'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'value': Number of units to move. Default is '1'.\n\t\t\t\t\t* 'select': If 'true' makes the selection. Default is 'false'.\n\t\t\t\t",constraint:function(e){if(!i.isObject(e))return!1;var t=e
;return!(!i.isString(t.to)||!i.isUndefined(t.select)&&!i.isBoolean(t.select)||!i.isUndefined(t.by)&&!i.isString(t.by)||!i.isUndefined(t.value)&&!i.isNumber(t.value))},schema:{type:"object",required:["to"],properties:{to:{type:"string",enum:["left","right","up","down","wrappedLineStart","wrappedLineEnd","wrappedLineColumnCenter","wrappedLineFirstNonWhitespaceCharacter","wrappedLineLastNonWhitespaceCharacter","viewPortTop","viewPortCenter","viewPortBottom","viewPortIfOutside"]},by:{type:"string",enum:["line","wrappedLine","character","halfLine"]},value:{type:"number",default:1},select:{type:"boolean",default:!1}}}}]},e.RawDirection={Left:"left",Right:"right",Up:"up",Down:"down",WrappedLineStart:"wrappedLineStart",WrappedLineFirstNonWhitespaceCharacter:"wrappedLineFirstNonWhitespaceCharacter",WrappedLineColumnCenter:"wrappedLineColumnCenter",WrappedLineEnd:"wrappedLineEnd",WrappedLineLastNonWhitespaceCharacter:"wrappedLineLastNonWhitespaceCharacter",ViewPortTop:"viewPortTop",ViewPortCenter:"viewPortCenter",
ViewPortBottom:"viewPortBottom",ViewPortIfOutside:"viewPortIfOutside"},e.RawUnit={Line:"line",WrappedLine:"wrappedLine",Character:"character",HalfLine:"halfLine"},e.parse=function(t){if(!t.to)return null;var i;switch(t.to){case e.RawDirection.Left:i=0;break;case e.RawDirection.Right:i=1;break;case e.RawDirection.Up:i=2;break;case e.RawDirection.Down:i=3;break;case e.RawDirection.WrappedLineStart:i=4;break;case e.RawDirection.WrappedLineFirstNonWhitespaceCharacter:i=5;break;case e.RawDirection.WrappedLineColumnCenter:i=6;break;case e.RawDirection.WrappedLineEnd:i=7;break;case e.RawDirection.WrappedLineLastNonWhitespaceCharacter:i=8;break;case e.RawDirection.ViewPortTop:i=9;break;case e.RawDirection.ViewPortBottom:i=11;break;case e.RawDirection.ViewPortCenter:i=10;break;case e.RawDirection.ViewPortIfOutside:i=12;break;default:return null}var n=0;switch(t.by){case e.RawUnit.Line:n=1;break;case e.RawUnit.WrappedLine:n=2;break;case e.RawUnit.Character:n=3;break;case e.RawUnit.HalfLine:n=4}return{direction:i,
unit:n,select:!!t.select,value:t.value||1}}}(t.CursorMove||(t.CursorMove={}))}),define(t[398],i([1,0,36,13,3,20]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e){this._selTrackedRange=null,this._trackSelection=!0,this._setState(e,new i.SingleCursorState(new o.Range(1,1,1,1),0,new n.Position(1,1),0),new i.SingleCursorState(new o.Range(1,1,1,1),0,new n.Position(1,1),0))}return e.prototype.dispose=function(e){this._removeTrackedRange(e)},e.prototype.startTrackingSelection=function(e){this._trackSelection=!0,this._updateTrackedRange(e)},e.prototype.stopTrackingSelection=function(e){this._trackSelection=!1,this._removeTrackedRange(e)},e.prototype._updateTrackedRange=function(e){this._trackSelection&&(this._selTrackedRange=e.model._setTrackedRange(this._selTrackedRange,this.modelState.selection,0))},e.prototype._removeTrackedRange=function(e){this._selTrackedRange=e.model._setTrackedRange(this._selTrackedRange,null,0)},
e.prototype.asCursorState=function(){return new i.CursorState(this.modelState,this.viewState)},e.prototype.readSelectionFromMarkers=function(e){var t=e.model._getTrackedRange(this._selTrackedRange);return 0===this.modelState.selection.getDirection()?new r.Selection(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):new r.Selection(t.endLineNumber,t.endColumn,t.startLineNumber,t.startColumn)},e.prototype.ensureValidState=function(e){this._setState(e,this.modelState,this.viewState)},e.prototype.setState=function(e,t,i){this._setState(e,t,i)},e.prototype._setState=function(e,t,r){if(t){var s=e.model.validateRange(t.selectionStart),a=t.selectionStart.equalsRange(s)?t.selectionStartLeftoverVisibleColumns:0,l=e.model.validatePosition(t.position),u=t.position.equals(l)?t.leftoverVisibleColumns:0;t=new i.SingleCursorState(s,a,l,u)}else{if(!r)return
;var s=e.model.validateRange(e.convertViewRangeToModelRange(r.selectionStart)),l=e.model.validatePosition(e.convertViewPositionToModelPosition(r.position.lineNumber,r.position.column));t=new i.SingleCursorState(s,r.selectionStartLeftoverVisibleColumns,l,r.leftoverVisibleColumns)}if(r){var d=e.validateViewRange(r.selectionStart,t.selectionStart),c=e.validateViewPosition(r.position,t.position);r=new i.SingleCursorState(d,t.selectionStartLeftoverVisibleColumns,c,t.leftoverVisibleColumns)}else{var h=e.convertModelPositionToViewPosition(new n.Position(t.selectionStart.startLineNumber,t.selectionStart.startColumn)),p=e.convertModelPositionToViewPosition(new n.Position(t.selectionStart.endLineNumber,t.selectionStart.endColumn)),d=new o.Range(h.lineNumber,h.column,p.lineNumber,p.column),c=e.convertModelPositionToViewPosition(t.position);r=new i.SingleCursorState(d,t.selectionStartLeftoverVisibleColumns,c,t.leftoverVisibleColumns)}this.modelState=t,this.viewState=r,this._updateTrackedRange(e)},e}();t.OneCursor=s}),
define(t[399],i([1,0,36,398,20]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e){this.context=e,this.primaryCursor=new n.OneCursor(e),this.secondaryCursors=[],this.lastAddedCursorIndex=0}return e.prototype.dispose=function(){this.primaryCursor.dispose(this.context),this.killSecondaryCursors()},e.prototype.startTrackingSelections=function(){this.primaryCursor.startTrackingSelection(this.context);for(var e=0,t=this.secondaryCursors.length;e<t;e++)this.secondaryCursors[e].startTrackingSelection(this.context)},e.prototype.stopTrackingSelections=function(){this.primaryCursor.stopTrackingSelection(this.context);for(var e=0,t=this.secondaryCursors.length;e<t;e++)this.secondaryCursors[e].stopTrackingSelection(this.context)},e.prototype.updateContext=function(e){this.context=e},e.prototype.ensureValidState=function(){this.primaryCursor.ensureValidState(this.context)
;for(var e=0,t=this.secondaryCursors.length;e<t;e++)this.secondaryCursors[e].ensureValidState(this.context)},e.prototype.readSelectionFromMarkers=function(){var e=[];e[0]=this.primaryCursor.readSelectionFromMarkers(this.context);for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t].readSelectionFromMarkers(this.context);return e},e.prototype.getAll=function(){var e=[];e[0]=this.primaryCursor.asCursorState();for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t].asCursorState();return e},e.prototype.getViewPositions=function(){var e=[];e[0]=this.primaryCursor.viewState.position;for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t].viewState.position;return e},e.prototype.getSelections=function(){var e=[];e[0]=this.primaryCursor.modelState.selection;for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t].modelState.selection;return e},e.prototype.getViewSelections=function(){var e=[]
;e[0]=this.primaryCursor.viewState.selection;for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t].viewState.selection;return e},e.prototype.setSelections=function(e){this.setStates(i.CursorState.fromModelSelections(e))},e.prototype.getPrimaryCursor=function(){return this.primaryCursor.asCursorState()},e.prototype.setStates=function(e){null!==e&&(this.primaryCursor.setState(this.context,e[0].modelState,e[0].viewState),this._setSecondaryStates(e.slice(1)))},e.prototype._setSecondaryStates=function(e){var t=this.secondaryCursors.length,i=e.length;if(t<i)for(var n=i-t,o=0;o<n;o++)this._addSecondaryCursor();else if(t>i)for(var r=t-i,o=0;o<r;o++)this._removeSecondaryCursor(this.secondaryCursors.length-1);for(o=0;o<i;o++)this.secondaryCursors[o].setState(this.context,e[o].modelState,e[o].viewState)},e.prototype.killSecondaryCursors=function(){this._setSecondaryStates([])},e.prototype._addSecondaryCursor=function(){this.secondaryCursors.push(new n.OneCursor(this.context)),
this.lastAddedCursorIndex=this.secondaryCursors.length},e.prototype.getLastAddedCursorIndex=function(){return 0===this.secondaryCursors.length||0===this.lastAddedCursorIndex?0:this.lastAddedCursorIndex},e.prototype._removeSecondaryCursor=function(e){this.lastAddedCursorIndex>=e+1&&this.lastAddedCursorIndex--,this.secondaryCursors[e].dispose(this.context),this.secondaryCursors.splice(e,1)},e.prototype._getAll=function(){var e=[];e[0]=this.primaryCursor;for(var t=0,i=this.secondaryCursors.length;t<i;t++)e[t+1]=this.secondaryCursors[t];return e},e.prototype.normalize=function(){if(0!==this.secondaryCursors.length){for(var e=this._getAll(),t=[],n=0,r=e.length;n<r;n++)t.push({index:n,selection:e[n].modelState.selection});t.sort(function(e,t){return e.selection.startLineNumber===t.selection.startLineNumber?e.selection.startColumn-t.selection.startColumn:e.selection.startLineNumber-t.selection.startLineNumber});for(var s=0;s<t.length-1;s++){var a=t[s],l=t[s+1],u=a.selection,d=l.selection
;if(this.context.config.multiCursorMergeOverlapping){if(d.isEmpty()||u.isEmpty()?d.getStartPosition().isBeforeOrEqual(u.getEndPosition()):d.getStartPosition().isBefore(u.getEndPosition())){var c=a.index<l.index?s:s+1,h=a.index<l.index?s+1:s,p=t[h].index,f=t[c].index,g=t[h].selection,m=t[c].selection;if(!g.equalsSelection(m)){var v=g.plusRange(m),_=g.selectionStartLineNumber===g.startLineNumber&&g.selectionStartColumn===g.startColumn,y=m.selectionStartLineNumber===m.startLineNumber&&m.selectionStartColumn===m.startColumn,b=void 0;p===this.lastAddedCursorIndex?(b=_,this.lastAddedCursorIndex=f):b=y;var C=void 0;C=b?new o.Selection(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new o.Selection(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn),t[c].selection=C;var S=i.CursorState.fromModelSelection(C);e[f].setState(this.context,S.modelState,S.viewState)}for(var w=0,E=t;w<E.length;w++){var L=E[w];L.index>p&&L.index--}e.splice(p,1),t.splice(h,1),this._removeSecondaryCursor(p-1),s--}}}}},e}()
;t.CursorCollection=r}),define(t[400],i([1,0,10,4,5,399,36,191,146,3,20,72,77,2]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(){return function(e,t,i){this.selections=e,this.source=t,this.reason=i}}();t.CursorStateChangedEvent=g;var m=function(){function e(e,t){this.modelVersionId=e.getVersionId(),this.cursorState=t.getAll()}return e.prototype.equals=function(e){if(!e)return!1;if(this.modelVersionId!==e.modelVersionId)return!1;if(this.cursorState.length!==e.cursorState.length)return!1;for(var t=0,i=this.cursorState.length;t<i;t++)if(!this.cursorState[t].equals(e.cursorState[t]))return!1;return!0},e}();t.CursorModelState=m;var v=function(){function e(e,t,i){this._model=e,this._autoClosedCharactersDecorations=t,this._autoClosedEnclosingDecorations=i}return e.getAllAutoClosedCharacters=function(e){for(var t=[],i=0,n=e;i<n.length;i++){var o=n[i];t=t.concat(o.getAutoClosedCharactersRanges())}return t},e.prototype.dispose=function(){
this._autoClosedCharactersDecorations=this._model.deltaDecorations(this._autoClosedCharactersDecorations,[]),this._autoClosedEnclosingDecorations=this._model.deltaDecorations(this._autoClosedEnclosingDecorations,[])},e.prototype.getAutoClosedCharactersRanges=function(){for(var e=[],t=0;t<this._autoClosedCharactersDecorations.length;t++){var i=this._model.getDecorationRange(this._autoClosedCharactersDecorations[t]);i&&e.push(i)}return e},e.prototype.isValid=function(e){for(var t=[],i=0;i<this._autoClosedEnclosingDecorations.length;i++){var n=this._model.getDecorationRange(this._autoClosedEnclosingDecorations[i]);if(n&&(t.push(n),n.startLineNumber!==n.endLineNumber))return!1}t.sort(d.Range.compareRangesUsingStarts),e.sort(d.Range.compareRangesUsingStarts);for(i=0;i<e.length;i++){if(i>=t.length)return!1;if(!t[i].strictContainsRange(e[i]))return!1}return!0},e}(),_=function(e){function t(t,i,o){var r=e.call(this)||this;r._onDidReachMaxCursorCount=r._register(new n.Emitter),
r.onDidReachMaxCursorCount=r._onDidReachMaxCursorCount.event,r._onDidAttemptReadOnlyEdit=r._register(new n.Emitter),r.onDidAttemptReadOnlyEdit=r._onDidAttemptReadOnlyEdit.event,r._onDidChange=r._register(new n.Emitter),r.onDidChange=r._onDidChange.event,r._configuration=t,r._model=i,r._knownModelVersionId=r._model.getVersionId(),r._viewModel=o,r.context=new a.CursorContext(r._configuration,r._model,r._viewModel),r._cursors=new s.CursorCollection(r.context),r._isHandling=!1,r._isDoingComposition=!1,r._columnSelectData=null,r._autoClosedActions=[],r._prevEditOperationType=0,r._register(r._model.onDidChangeRawContent(function(e){if(r._knownModelVersionId=e.versionId,!r._isHandling){var t=e.containsEvent(1);r._onModelContentChanged(t)}})),r._register(o.addEventListener(function(e){(function(e){for(var t=0,i=e.length;t<i;t++)if(6===e[t].type)return!0;return!1})(e)&&r._knownModelVersionId===r._model.getVersionId()&&r.setStates("viewModel",0,r.getAll())}));var l=function(){
r.context=new a.CursorContext(r._configuration,r._model,r._viewModel),r._cursors.updateContext(r.context)};return r._register(r._model.onDidChangeLanguage(function(e){l()})),r._register(r._model.onDidChangeLanguageConfiguration(function(){l()})),r._register(r._model.onDidChangeOptions(function(){l()})),r._register(r._configuration.onDidChange(function(e){a.CursorConfiguration.shouldRecreate(e)&&l()})),r}return r(t,e),t.prototype.dispose=function(){this._cursors.dispose(),this._autoClosedActions=f.dispose(this._autoClosedActions),e.prototype.dispose.call(this)},t.prototype._validateAutoClosedActions=function(){if(this._autoClosedActions.length>0)for(var e=this._cursors.getSelections(),t=0;t<this._autoClosedActions.length;t++){var i=this._autoClosedActions[t];i.isValid(e)||(i.dispose(),this._autoClosedActions.splice(t,1),t--)}},t.prototype.getPrimaryCursor=function(){return this._cursors.getPrimaryCursor()},t.prototype.getLastAddedCursorIndex=function(){return this._cursors.getLastAddedCursorIndex()},
t.prototype.getAll=function(){return this._cursors.getAll()},t.prototype.setStates=function(e,i,n){null!==n&&n.length>t.MAX_CURSOR_COUNT&&(n=n.slice(0,t.MAX_CURSOR_COUNT),this._onDidReachMaxCursorCount.fire(void 0));var o=new m(this._model,this);this._cursors.setStates(n),this._cursors.normalize(),this._columnSelectData=null,this._validateAutoClosedActions(),this._emitStateChangedIfNecessary(e,i,o)},t.prototype.setColumnSelectData=function(e){this._columnSelectData=e},t.prototype.reveal=function(e,t,i){this._revealRange(t,0,e,i)},t.prototype.revealRange=function(e,t,i,n){this.emitCursorRevealRange(t,i,e,n)},t.prototype.scrollTo=function(e){this._viewModel.viewLayout.setScrollPositionSmooth({scrollTop:e})},t.prototype.saveState=function(){for(var e=[],t=this._cursors.getSelections(),i=0,n=t.length;i<n;i++){var o=t[i];e.push({inSelectionMode:!o.isEmpty(),selectionStart:{lineNumber:o.selectionStartLineNumber,column:o.selectionStartColumn},position:{lineNumber:o.positionLineNumber,column:o.positionColumn}})}
return e},t.prototype.restoreState=function(e){for(var t=[],i=0,n=e.length;i<n;i++){var o=e[i],r=1,s=1;o.position&&o.position.lineNumber&&(r=o.position.lineNumber),o.position&&o.position.column&&(s=o.position.column);var l=r,u=s;o.selectionStart&&o.selectionStart.lineNumber&&(l=o.selectionStart.lineNumber),o.selectionStart&&o.selectionStart.column&&(u=o.selectionStart.column),t.push({selectionStartLineNumber:l,selectionStartColumn:u,positionLineNumber:r,positionColumn:s})}this.setStates("restoreState",0,a.CursorState.fromModelSelections(t)),this.reveal(!0,0,1)},t.prototype._onModelContentChanged=function(e){if(this._prevEditOperationType=0,e)this._cursors.dispose(),this._cursors=new s.CursorCollection(this.context),this._validateAutoClosedActions(),this._emitStateChangedIfNecessary("model",1,null);else{var t=this._cursors.readSelectionFromMarkers();this.setStates("modelChange",2,a.CursorState.fromModelSelections(t))}},t.prototype.getSelection=function(){
return this._cursors.getPrimaryCursor().modelState.selection},t.prototype.getColumnSelectData=function(){if(this._columnSelectData)return this._columnSelectData;var e=this._cursors.getPrimaryCursor().viewState.position,t=e.lineNumber,i=a.CursorColumns.visibleColumnFromColumn2(this.context.config,this.context.viewModel,e);return{isReal:!1,fromViewLineNumber:t,fromViewVisualColumn:i,toViewLineNumber:t,toViewVisualColumn:i}},t.prototype.getSelections=function(){return this._cursors.getSelections()},t.prototype.getViewSelections=function(){return this._cursors.getViewSelections()},t.prototype.getPosition=function(){return this._cursors.getPrimaryCursor().modelState.position},t.prototype.setSelections=function(e,t){this.setStates(e,0,a.CursorState.fromModelSelections(t))},t.prototype.getPrevEditOperationType=function(){return this._prevEditOperationType},t.prototype.setPrevEditOperationType=function(e){this._prevEditOperationType=e},t.prototype._pushAutoClosedAction=function(e,t){
for(var i=[],n=[],o=0,r=e.length;o<r;o++)i.push({range:e[o],options:{inlineClassName:"auto-closed-character",stickiness:1}}),n.push({range:t[o],options:{stickiness:1}});var s=this._model.deltaDecorations([],i),a=this._model.deltaDecorations([],n);this._autoClosedActions.push(new v(this._model,s,a))},t.prototype._executeEditOperation=function(e){if(e){e.shouldPushStackElementBefore&&this._model.pushStackElement();var t=y.executeCommands(this._model,this._cursors.getSelections(),e.commands);if(t){this._interpretCommandResult(t);for(var i=[],n=[],o=0;o<e.commands.length;o++){var r=e.commands[o];r instanceof u.TypeWithAutoClosingCommand&&r.enclosingRange&&r.closeCharacterRange&&(i.push(r.closeCharacterRange),n.push(r.enclosingRange))}i.length>0&&this._pushAutoClosedAction(i,n),this._prevEditOperationType=e.type}e.shouldPushStackElementAfter&&this._model.pushStackElement()}},t.prototype._interpretCommandResult=function(e){e&&0!==e.length||(e=this._cursors.readSelectionFromMarkers()),this._columnSelectData=null,
this._cursors.setSelections(e),this._cursors.normalize()},t.prototype._emitStateChangedIfNecessary=function(e,t,i){var n=new m(this._model,this);if(n.equals(i))return!1;var o=this._cursors.getSelections(),r=this._cursors.getViewSelections();try{this._beginEmit().emit(new p.ViewCursorStateChangedEvent(r))}finally{this._endEmit()}return i&&i.cursorState.length===n.cursorState.length&&!n.cursorState.some(function(e,t){return!e.modelState.equals(i.cursorState[t].modelState)})||this._onDidChange.fire(new g(o,e||"keyboard",t)),!0},t.prototype._revealRange=function(e,t,i,n){var o=this._cursors.getViewPositions(),r=o[0];if(1===e)for(s=1;s<o.length;s++)o[s].isBefore(r)&&(r=o[s]);else if(2===e)for(var s=1;s<o.length;s++)r.isBeforeOrEqual(o[s])&&(r=o[s]);else if(o.length>1)return;var a=new d.Range(r.lineNumber,r.column,r.lineNumber,r.column);this.emitCursorRevealRange(a,t,i,n)},t.prototype.emitCursorRevealRange=function(e,t,i,n){try{this._beginEmit().emit(new p.ViewRevealRangeRequestEvent(e,t,i,n))}finally{
this._endEmit()}},t.prototype._findAutoClosingPairs=function(e){if(!e.length)return null;for(var t=[],i=0,n=e.length;i<n;i++){var o=e[i];if(!o.text||o.text.indexOf("\n")>=0)return null;var r=o.text.match(/([)\]}>'"`])([^)\]}>'"`]*)$/);if(!r)return null;var s=r[1],a=this.context.config.autoClosingPairsClose2.get(s);if(!a||1!==a.length)return null;var l=a[0].open,u=o.text.length-r[2].length-1,d=o.text.lastIndexOf(l,u-1);if(-1===d)return null;t.push([d,u])}return t},t.prototype.executeEdits=function(e,t,i){var n=this,o=null;"snippet"===e&&(o=this._findAutoClosingPairs(t)),o&&(t[0]._isTracked=!0);var r=[],s=[],a=this._model.pushEditOperations(this.getSelections(),t,function(e){if(o)for(var t=0,a=o.length;t<a;t++){var l=o[t],u=l[0],c=l[1],h=e[t],p=h.range.startLineNumber,f=h.range.startColumn-1+u,g=h.range.startColumn-1+c;r.push(new d.Range(p,g+1,p,g+2)),s.push(new d.Range(p,f+1,p,g+2))}var m=i(e);return m&&(n._isHandling=!0),m});a&&(this._isHandling=!1,this.setSelections(e,a)),
r.length>0&&this._pushAutoClosedAction(r,s)},t.prototype.trigger=function(e,t,n){var o=h.Handler;if(t!==o.CompositionStart)if(t===o.CompositionEnd&&(this._isDoingComposition=!1),this._configuration.editor.readOnly)this._onDidAttemptReadOnlyEdit.fire(void 0);else{var r=new m(this._model,this),s=0;t!==o.Undo&&t!==o.Redo&&this._cursors.stopTrackingSelections(),this._cursors.ensureValidState(),this._isHandling=!0;try{switch(t){case o.Type:this._type(e,n.text);break;case o.ReplacePreviousChar:this._replacePreviousChar(n.text,n.replaceCharCnt);break;case o.Paste:s=4,this._paste(n.text,n.pasteOnNewLine,n.multicursorText);break;case o.Cut:this._cut();break;case o.Undo:s=5,this._interpretCommandResult(this._model.undo());break;case o.Redo:s=6,this._interpretCommandResult(this._model.redo());break;case o.ExecuteCommand:this._externalExecuteCommand(n);break;case o.ExecuteCommands:this._externalExecuteCommands(n);break;case o.CompositionEnd:this._interpretCompositionEnd(e)}}catch(e){i.onUnexpectedError(e)}
this._isHandling=!1,t!==o.Undo&&t!==o.Redo&&this._cursors.startTrackingSelections(),this._validateAutoClosedActions(),this._emitStateChangedIfNecessary(e,s,r)&&this._revealRange(0,0,!0,0)}else this._isDoingComposition=!0},t.prototype._interpretCompositionEnd=function(e){if(!this._isDoingComposition&&"keyboard"===e){var t=v.getAllAutoClosedCharacters(this._autoClosedActions);this._executeEditOperation(u.TypeOperations.compositionEndWithInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),t))}},t.prototype._type=function(e,t){if(this._isDoingComposition||"keyboard"!==e)this._executeEditOperation(u.TypeOperations.typeWithoutInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),t));else for(var i=0,n=t.length;i<n;i++){var r=t.charCodeAt(i),s=void 0;o.isHighSurrogate(r)&&i+1<n?(s=t.charAt(i)+t.charAt(i+1),i++):s=t.charAt(i);var a=v.getAllAutoClosedCharacters(this._autoClosedActions)
;this._executeEditOperation(u.TypeOperations.typeWithInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),a,s))}},t.prototype._replacePreviousChar=function(e,t){this._executeEditOperation(u.TypeOperations.replacePreviousChar(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),e,t))},t.prototype._paste=function(e,t,i){this._executeEditOperation(u.TypeOperations.paste(this.context.config,this.context.model,this.getSelections(),e,t,i))},t.prototype._cut=function(){this._executeEditOperation(l.DeleteOperations.cut(this.context.config,this.context.model,this.getSelections()))},t.prototype._externalExecuteCommand=function(e){this._cursors.killSecondaryCursors(),this._executeEditOperation(new a.EditOperationResult(0,[e],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!1}))},t.prototype._externalExecuteCommands=function(e){this._executeEditOperation(new a.EditOperationResult(0,e,{shouldPushStackElementBefore:!1,
shouldPushStackElementAfter:!1}))},t.MAX_CURSOR_COUNT=1e4,t}(p.ViewEventEmitter);t.Cursor=_;var y=function(){function e(){}return e.executeCommands=function(e,t,i){for(var n={model:e,selectionsBefore:t,trackedRanges:[],trackedRangesDirection:[]},o=this._innerExecuteCommands(n,i),r=0,s=n.trackedRanges.length;r<s;r++)n.model._setTrackedRange(n.trackedRanges[r],null,0);return o},e._innerExecuteCommands=function(e,t){if(this._arrayIsEmpty(t))return null;var i=this._getEditOperations(e,t);if(0===i.operations.length)return null;var n=i.operations,o=this._getLoserCursorMap(n);if(o.hasOwnProperty("0"))return console.warn("Ignoring commands"),null;for(var r=[],s=0,a=n.length;s<a;s++)o.hasOwnProperty(n[s].identifier.major.toString())||r.push(n[s]);i.hadTrackedEditOperation&&r.length>0&&(r[0]._isTracked=!0);var l=e.model.pushEditOperations(e.selectionsBefore,r,function(i){for(var n=[],o=0;o<e.selectionsBefore.length;o++)n[o]=[];for(var r=0,s=i;r<s.length;r++){var a=s[r];a.identifier&&n[a.identifier.major].push(a)}
for(var l=function(e,t){return e.identifier.minor-t.identifier.minor},u=[],d=function(i){n[i].length>0?(n[i].sort(l),u[i]=t[i].computeCursorState(e.model,{getInverseEditOperations:function(){return n[i]},getTrackedSelection:function(t){var i=parseInt(t,10),n=e.model._getTrackedRange(e.trackedRanges[i]);return 0===e.trackedRangesDirection[i]?new c.Selection(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn):new c.Selection(n.endLineNumber,n.endColumn,n.startLineNumber,n.startColumn)}})):u[i]=e.selectionsBefore[i]},o=0;o<e.selectionsBefore.length;o++)d(o);return u});l||(l=e.selectionsBefore);var u=[];for(var d in o)o.hasOwnProperty(d)&&u.push(parseInt(d,10));u.sort(function(e,t){return t-e});for(var h=0,p=u;h<p.length;h++){var f=p[h];l.splice(f,1)}return l},e._arrayIsEmpty=function(e){for(var t=0,i=e.length;t<i;t++)if(e[t])return!1;return!0},e._getEditOperations=function(e,t){for(var i=[],n=!1,o=0,r=t.length;o<r;o++){var s=t[o];if(s){var a=this._getEditOperationsFromCommand(e,o,s)
;i=i.concat(a.operations),n=n||a.hadTrackedEditOperation}}return{operations:i,hadTrackedEditOperation:n}},e._getEditOperationsFromCommand=function(e,t,n){var o=[],r=0,s=function(e,i){e.isEmpty()&&""===i||o.push({identifier:{major:t,minor:r++},range:e,text:i,forceMoveMarkers:!1,isAutoWhitespaceEdit:n.insertsAutoWhitespace})},a=!1,l={addEditOperation:s,addTrackedEditOperation:function(e,t){a=!0,s(e,t)},trackSelection:function(t,i){var n;if(t.isEmpty())if("boolean"==typeof i)n=i?2:3;else{var o=e.model.getLineMaxColumn(t.startLineNumber);n=t.startColumn===o?2:3}else n=1;var r=e.trackedRanges.length,s=e.model._setTrackedRange(null,t,n);return e.trackedRanges[r]=s,e.trackedRangesDirection[r]=t.getDirection(),r.toString()}};try{n.getEditOperations(e.model,l)}catch(e){return i.onUnexpectedError(e),{operations:[],hadTrackedEditOperation:!1}}return{operations:o,hadTrackedEditOperation:a}},e._getLoserCursorMap=function(e){(e=e.slice(0)).sort(function(e,t){return-d.Range.compareRangesUsingEnds(e.range,t.range)})
;for(var t={},i=1;i<e.length;i++){var n=e[i-1],o=e[i];if(n.range.getStartPosition().isBefore(o.range.getEndPosition())){var r=void 0;t[(r=n.identifier.major>o.identifier.major?n.identifier.major:o.identifier.major).toString()]=!0;for(var s=0;s<e.length;s++)e[s].identifier.major===r&&(e.splice(s,1),s<i&&i--,s--);i>0&&i--}}return t},e}()}),define(t[193],i([1,0,5,87,63]),function(e,t,i,n,o){"use strict";function r(e,t){return void 0===t&&(t=s),function(e,t){for(var o='<div class="monaco-tokenized-source">',r=e.split(/\r\n|\r|\n/),s=t.getInitialState(),a=0,l=r.length;a<l;a++){var u=r[a];a>0&&(o+="<br/>");var d=t.tokenize2(u,s,0);n.LineTokens.convertToEndOffset(d.tokens,u.length);for(var c=new n.LineTokens(d.tokens,u).inflate(),h=0,p=0,f=c.getCount();p<f;p++){var g=c.getClassName(p),m=c.getEndOffset(p);o+='<span class="'+g+'">'+i.escape(u.substring(h,m))+"</span>",h=m}s=d.endState}return o+="</div>"}(e,t||s)}Object.defineProperty(t,"__esModule",{value:!0});var s={getInitialState:function(){return o.NULL_STATE},
tokenize2:function(e,t,i){return o.nullTokenize2(0,e,t,i)}};t.tokenizeToString=r,t.tokenizeLineToHTML=function(e,t,i,n,o,r){for(var s="<div>",a=n,l=0,u=0,d=t.getCount();u<d;u++){var c=t.getEndOffset(u);if(!(c<=n)){for(var h="";a<c&&a<o;a++){var p=e.charCodeAt(a);switch(p){case 9:var f=r-(a+l)%r;for(l+=f-1;f>0;)h+="&nbsp;",f--;break;case 60:h+="&lt;";break;case 62:h+="&gt;";break;case 38:h+="&amp;";break;case 0:h+="&#00;";break;case 65279:case 8232:h+="�";break;case 13:h+="&#8203";break;case 32:h+="&nbsp;";break;default:h+=String.fromCharCode(p)}}if(s+='<span style="'+t.getInlineStyle(u,i)+'">'+h+"</span>",c>o||a>=o)break}}return s+="</div>"}}),define(t[76],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ITextModelService=i.createDecorator("textModelService")}),define(t[140],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ITextResourceConfigurationService=i.createDecorator("textResourceConfigurationService"),
t.ITextResourcePropertiesService=i.createDecorator("textResourcePropertiesService")}),define(t[139],i([1,0,4,511,17]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){var e=this;this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._updateColorMap(),o.TokenizationRegistry.onDidChange(function(t){t.changedColorMap&&e._updateColorMap()})}return e.getInstance=function(){return this._INSTANCE||(this._INSTANCE=new e),this._INSTANCE},e.prototype._updateColorMap=function(){var e=o.TokenizationRegistry.getColorMap();if(!e)return this._colors=[n.RGBA8.Empty],void(this._backgroundIsLight=!0);this._colors=[n.RGBA8.Empty];for(var t=1;t<e.length;t++){var i=e[t].rgba;this._colors[t]=new n.RGBA8(i.r,i.g,i.b,Math.round(255*i.a))}var r=e[2].getRelativeLuminance();this._backgroundIsLight=r>=.5,this._onDidChange.fire(void 0)},e.prototype.getColor=function(e){return(e<1||e>=this._colors.length)&&(e=2),this._colors[e]},
e.prototype.backgroundIsLight=function(){return this._backgroundIsLight},e._INSTANCE=null,e}();t.MinimapTokensColorTracker=r;var s=function(){function e(t,i){if(760!==t.length)throw new Error("Invalid x2CharData");if(190!==i.length)throw new Error("Invalid x1CharData");this.x2charData=t,this.x1charData=i,this.x2charDataLight=e.soften(t,.8),this.x1charDataLight=e.soften(i,50/60)}return e.soften=function(e,t){for(var i=new Uint8ClampedArray(e.length),n=0,o=e.length;n<o;n++)i[n]=e[n]*t;return i},e._getChIndex=function(e){return(e-=32)<0&&(e+=95),e%95},e.prototype.x2RenderChar=function(t,i,n,o,r,s,a){if(i+2>t.width||n+4>t.height)console.warn("bad render request outside image data");else{var l=a?this.x2charDataLight:this.x2charData,u=e._getChIndex(o),d=4*t.width,c=s.r,h=s.g,p=s.b,f=r.r-c,g=r.g-h,m=r.b-p,v=t.data,_=4*u*2,y=n*d+4*i,b=l[_]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b;b=l[_+1]/255;v[y+4]=c+f*b,v[y+5]=h+g*b,v[y+6]=p+m*b,y+=d;b=l[_+2]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b;b=l[_+3]/255;v[y+4]=c+f*b,
v[y+5]=h+g*b,v[y+6]=p+m*b,y+=d;b=l[_+4]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b;b=l[_+5]/255;v[y+4]=c+f*b,v[y+5]=h+g*b,v[y+6]=p+m*b,y+=d;b=l[_+6]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b;b=l[_+7]/255;v[y+4]=c+f*b,v[y+5]=h+g*b,v[y+6]=p+m*b}},e.prototype.x1RenderChar=function(t,i,n,o,r,s,a){if(i+1>t.width||n+2>t.height)console.warn("bad render request outside image data");else{var l=a?this.x1charDataLight:this.x1charData,u=e._getChIndex(o),d=4*t.width,c=s.r,h=s.g,p=s.b,f=r.r-c,g=r.g-h,m=r.b-p,v=t.data,_=2*u*1,y=n*d+4*i,b=l[_]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b,y+=d;b=l[_+1]/255;v[y+0]=c+f*b,v[y+1]=h+g*b,v[y+2]=p+m*b}},e.prototype.x2BlockRenderChar=function(e,t,i,n,o,r){if(t+2>e.width||i+4>e.height)console.warn("bad render request outside image data");else{var s=4*e.width,a=o.r,l=o.g,u=o.b,d=a+.5*(n.r-a),c=l+.5*(n.g-l),h=u+.5*(n.b-u),p=e.data,f=i*s+4*t;p[f+0]=d,p[f+1]=c,p[f+2]=h,p[f+4]=d,p[f+5]=c,p[f+6]=h,p[(f+=s)+0]=d,p[f+1]=c,p[f+2]=h,p[f+4]=d,p[f+5]=c,p[f+6]=h,p[(f+=s)+0]=d,p[f+1]=c,p[f+2]=h,
p[f+4]=d,p[f+5]=c,p[f+6]=h,p[(f+=s)+0]=d,p[f+1]=c,p[f+2]=h,p[f+4]=d,p[f+5]=c,p[f+6]=h}},e.prototype.x1BlockRenderChar=function(e,t,i,n,o,r){if(t+1>e.width||i+2>e.height)console.warn("bad render request outside image data");else{var s=4*e.width,a=o.r,l=o.g,u=o.b,d=a+.5*(n.r-a),c=l+.5*(n.g-l),h=u+.5*(n.b-u),p=e.data,f=i*s+4*t;p[f+0]=d,p[f+1]=c,p[f+2]=h,p[(f+=s)+0]=d,p[f+1]=c,p[f+2]=h}},e}();t.MinimapCharRenderer=s}),define(t[405],i([1,0,139]),function(e,t,i){"use strict";function n(e){for(var t=new Uint8ClampedArray(e.length),i=0,n=e.length;i<n;i++)t[i]=e[i];return t}Object.defineProperty(t,"__esModule",{value:!0});var o=null;t.getOrCreateMinimapCharRenderer=function(){if(!o){var e=n(s);s=null;var t=n(r);r=null,o=new i.MinimapCharRenderer(t,e)}return o}
;var r=[0,0,0,0,0,0,0,0,39,14,39,14,14,5,29,10,96,96,29,29,0,0,0,0,49,113,195,214,227,166,135,42,40,29,194,38,75,148,197,187,145,0,160,61,75,143,2,183,138,58,163,6,177,223,197,227,38,13,11,4,0,0,0,0,10,54,52,8,62,4,71,122,73,2,19,40,10,50,155,36,79,70,145,121,7,5,0,0,2,1,36,12,204,166,16,5,0,0,0,0,1,0,154,34,0,0,0,0,96,83,0,0,0,0,0,0,0,0,46,34,0,82,2,56,53,3,146,0,146,119,152,132,152,131,145,119,170,42,15,42,15,42,172,194,131,132,0,139,80,28,227,143,159,135,15,118,11,126,171,144,20,124,88,106,217,196,0,106,189,92,168,43,5,130,164,133,130,115,183,65,134,120,141,141,170,196,2,106,31,32,105,2,145,130,116,114,132,135,138,140,138,113,147,137,81,183,129,94,0,0,21,16,4,3,46,34,0,0,45,34,1,0,160,49,0,0,43,143,203,23,1,76,0,0,38,28,131,96,38,28,0,0,168,31,29,191,98,0,118,139,5,113,45,13,37,6,97,115,161,179,204,105,223,224,83,52,111,100,184,186,120,132,212,145,180,139,174,161,212,182,104,162,131,0,131,0,104,161,219,120,110,116,110,116,219,120,207,154,163,40,147,22,207,154,202,159,161,47,145,23,111,0,139,154,144,30,144,135,139,187,110,110,168,161,150,145,110,110,185,162,43,16,43,16,185,162,73,129,0,110,0,110,191,87,149,149,236,48,195,91,146,149,146,0,146,0,146,0,187,173,200,201,222,215,172,147,95,95,193,97,224,129,159,206,97,192,155,139,153,115,153,115,156,140,189,158,123,136,190,64,111,0,155,139,153,115,153,114,156,241,197,148,150,152,170,116,110,157,156,128,169,14,13,159,158,149,212,189,43,16,43,16,43,16,148,110,148,110,147,109,182,151,133,121,106,118,114,103,89,66,94,94,211,188,205,207,139,168,151,152,87,76,101,79,151,152,130,156,125,116,47,29,43,16,169,228,11,103,120,6,230,176,55,49,55,6,55,6,193,102,92,0,71,0,13,30,0,147,63,43,12,43,12,43,142,152,71,53,61,61,0,0,0,0,0,0,0,0,0,0,158,146,25,2,0,0,0,0,0,0,0,0,107,130,170,194,176,188,109,0,203,159,113,111,202,158,0,0,135,135,114,0,136,135,0,109,187,190,148,126,177,187,0,0,149,130,218,105,169,135,37,113,146,113,49,13,49,13,0,0,178,195,147,114,255,255,109,0,193,149,110,109,109,109,12,15,125,41,33,41,144,188,1,6,75,53,10,53,210,161,110,0,152,148,210,60,110,156,213,5,63,5,63,5,45,111,0,0,232,172,190,168,190,169,0,0,190,144,109,109,109,109,0,0,168,140,148,111,168,140,0,0,200,151,113,110,255,158,0,0,184,188,147,139,186,255,0,0,122,130,111,0,109,0,0,0,132,69,109,93,110,136,51,5,205,103,61,6,47,106,0,0,110,109,110,122,155,179,0,0,132,120,113,114,84,63,0,0,124,108,202,189,160,174,0,0,144,142,79,57,159,146,0,0,138,138,119,117,255,69,0,0,97,198,47,38,208,84,23,112,41,14,157,7,121,192,35,11,35,11,35,11,160,61,129,9,40,19,20,139,236,44,0,0,15,3,97,93,0,0],s=[0,0,23,12,53,0,130,127,58,149,67,77,72,198,13,0,25,51,25,49,94,2,8,64,0,24,0,21,0,9,19,27,126,126,51,80,72,105,87,98,73,93,106,85,111,123,87,30,116,126,123,110,4,16,9,28,21,53,8,62,23,52,73,21,132,183,78,142,168,175,70,70,128,128,123,110,125,43,100,139,125,119,78,78,54,77,139,139,33,87,201,117,162,149,130,130,138,60,130,172,149,127,95,98,95,25,118,135,110,85,147,175,105,110,121,30,101,113,34,68,20,26,34,68,56,0,0,44,3,0,27,175,80,133,31,66,85,147,32,150,90,25,45,230,77,101,36,83,22,84,71,118,44,44,52,172,38,101,35,130,40,197,43,197,29,26,23,103,67,44,25,129,29,85,27,177,33,97,32,145,33,77,38,96,20,55,36,95,2,22]
}),define(t[194],i([1,0,13,3,30,77,136,67]),function(e,t,i,n,o,r,s,a){"use strict";function l(e,t,i,n,o,r,s){var a=e.createLineMapping(t,i,n,o,r);return null===a?s?h.INSTANCE:p.INSTANCE:new f(a,s)}Object.defineProperty(t,"__esModule",{value:!0});var u=function(){return function(e,t){this.outputLineIndex=e,this.outputOffset=t}}();t.OutputPosition=u;var d=function(){function e(e){this._lines=e}return e.prototype.convertViewPositionToModelPosition=function(e){return this._lines.convertViewPositionToModelPosition(e.lineNumber,e.column)},e.prototype.convertViewRangeToModelRange=function(e){var t=this._lines.convertViewPositionToModelPosition(e.startLineNumber,e.startColumn),i=this._lines.convertViewPositionToModelPosition(e.endLineNumber,e.endColumn);return new n.Range(t.lineNumber,t.column,i.lineNumber,i.column)},e.prototype.validateViewPosition=function(e,t){return this._lines.validateViewPosition(e.lineNumber,e.column,t)},e.prototype.validateViewRange=function(e,t){
var i=this._lines.validateViewPosition(e.startLineNumber,e.startColumn,t.getStartPosition()),o=this._lines.validateViewPosition(e.endLineNumber,e.endColumn,t.getEndPosition());return new n.Range(i.lineNumber,i.column,o.lineNumber,o.column)},e.prototype.convertModelPositionToViewPosition=function(e){return this._lines.convertModelPositionToViewPosition(e.lineNumber,e.column)},e.prototype.convertModelRangeToViewRange=function(e){var t=this._lines.convertModelPositionToViewPosition(e.startLineNumber,e.startColumn),i=this._lines.convertModelPositionToViewPosition(e.endLineNumber,e.endColumn);return new n.Range(t.lineNumber,t.column,i.lineNumber,i.column)},e.prototype.modelPositionIsVisible=function(e){return this._lines.modelPositionIsVisible(e.lineNumber,e.column)},e}();t.CoordinatesConverter=d;var c=function(){function e(e,t,i,n,o,r){this.model=e,this._validModelVersionId=-1,this.tabSize=i,this.wrappingColumn=n,this.columnsForFullWidthChar=o,this.wrappingIndent=r,this.linePositionMapperFactory=t,
this._constructLines(!0)}return e.prototype.dispose=function(){this.hiddenAreasIds=this.model.deltaDecorations(this.hiddenAreasIds,[])},e.prototype.createCoordinatesConverter=function(){return new d(this)},e.prototype._ensureValidState=function(){if(this.model.getVersionId()!==this._validModelVersionId)throw new Error("ViewModel is out of sync with Model!");this.lines.length!==this.model.getLineCount()&&this._constructLines(!1)},e.prototype._constructLines=function(e){var t=this;this.lines=[],e&&(this.hiddenAreasIds=[]);for(var i=this.model.getLinesContent(),o=i.length,r=new Uint32Array(o),a=this.hiddenAreasIds.map(function(e){return t.model.getDecorationRange(e)}).sort(n.Range.compareRangesUsingStarts),u=1,d=0,c=-1,h=c+1<a.length?d+1:o+2,p=0;p<o;p++){var f=p+1;f===h&&(u=a[++c].startLineNumber,d=a[c].endLineNumber,h=c+1<a.length?d+1:o+2);var g=f>=u&&f<=d,m=l(this.linePositionMapperFactory,i[p],this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,!g);r[p]=m.getViewLineCount(),
this.lines[p]=m}this._validModelVersionId=this.model.getVersionId(),this.prefixSumComputer=new s.PrefixSumComputerWithCache(r)},e.prototype.getHiddenAreas=function(){var e=this;return this.hiddenAreasIds.map(function(t){return e.model.getDecorationRange(t)})},e.prototype._reduceRanges=function(e){var t=this;if(0===e.length)return[];for(var i=e.map(function(e){return t.model.validateRange(e)}).sort(n.Range.compareRangesUsingStarts),o=[],r=i[0].startLineNumber,s=i[0].endLineNumber,a=1,l=i.length;a<l;a++){var u=i[a];u.startLineNumber>s+1?(o.push(new n.Range(r,1,s,1)),r=u.startLineNumber,s=u.endLineNumber):u.endLineNumber>s&&(s=u.endLineNumber)}return o.push(new n.Range(r,1,s,1)),o},e.prototype.setHiddenAreas=function(e){var t=this,i=this._reduceRanges(e),r=this.hiddenAreasIds.map(function(e){return t.model.getDecorationRange(e)}).sort(n.Range.compareRangesUsingStarts);if(i.length===r.length){for(var s=!1,a=0;a<i.length;a++)if(!i[a].equalsRange(r[a])){s=!0;break}if(!s)return!1}
for(var l=[],u=0,d=i;u<d.length;u++){var c=d[u];l.push({range:c,options:o.ModelDecorationOptions.EMPTY})}this.hiddenAreasIds=this.model.deltaDecorations(this.hiddenAreasIds,l);for(var h=i,p=1,f=0,g=-1,m=g+1<h.length?f+1:this.lines.length+2,v=!1,a=0;a<this.lines.length;a++){var _=a+1;_===m&&(p=h[++g].startLineNumber,f=h[g].endLineNumber,m=g+1<h.length?f+1:this.lines.length+2);var y=!1;if(_>=p&&_<=f?this.lines[a].isVisible()&&(this.lines[a]=this.lines[a].setVisible(!1),y=!0):(v=!0,this.lines[a].isVisible()||(this.lines[a]=this.lines[a].setVisible(!0),y=!0)),y){var b=this.lines[a].getViewLineCount();this.prefixSumComputer.changeValue(a,b)}}return v||this.setHiddenAreas([]),!0},e.prototype.modelPositionIsVisible=function(e,t){return!(e<1||e>this.lines.length)&&this.lines[e-1].isVisible()},e.prototype.setTabSize=function(e){return this.tabSize!==e&&(this.tabSize=e,this._constructLines(!1),!0)},e.prototype.setWrappingSettings=function(e,t,i){
return(this.wrappingIndent!==e||this.wrappingColumn!==t||this.columnsForFullWidthChar!==i)&&(this.wrappingIndent=e,this.wrappingColumn=t,this.columnsForFullWidthChar=i,this._constructLines(!1),!0)},e.prototype.onModelFlushed=function(){this._constructLines(!0)},e.prototype.onModelLinesDeleted=function(e,t,i){if(e<=this._validModelVersionId)return null;var n=1===t?1:this.prefixSumComputer.getAccumulatedValue(t-2)+1,o=this.prefixSumComputer.getAccumulatedValue(i-1);return this.lines.splice(t-1,i-t+1),this.prefixSumComputer.removeValues(t-1,i-t+1),new r.ViewLinesDeletedEvent(n,o)},e.prototype.onModelLinesInserted=function(e,t,n,o){if(e<=this._validModelVersionId)return null;for(var s=this.getHiddenAreas(),a=!1,u=new i.Position(t,1),d=0,c=s;d<c.length;d++){if(c[d].containsPosition(u)){a=!0;break}}for(var h=1===t?1:this.prefixSumComputer.getAccumulatedValue(t-2)+1,p=0,f=[],g=new Uint32Array(o.length),m=0,v=o.length;m<v;m++){
var _=l(this.linePositionMapperFactory,o[m],this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,!a);f.push(_);var y=_.getViewLineCount();p+=y,g[m]=y}return this.lines=this.lines.slice(0,t-1).concat(f).concat(this.lines.slice(t-1)),this.prefixSumComputer.insertValues(t-1,g),new r.ViewLinesInsertedEvent(h,h+p-1)},e.prototype.onModelLineChanged=function(e,t,i){if(e<=this._validModelVersionId)return[!1,null,null,null];var n=t-1,o=this.lines[n].getViewLineCount(),s=this.lines[n].isVisible(),a=l(this.linePositionMapperFactory,i,this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,s);this.lines[n]=a;var u=this.lines[n].getViewLineCount(),d=!1,c=0,h=-1,p=0,f=-1,g=0,m=-1;o>u?(m=(g=(h=(c=1===t?1:this.prefixSumComputer.getAccumulatedValue(t-2)+1)+u-1)+1)+(o-u)-1,d=!0):o<u?(f=(p=(h=(c=1===t?1:this.prefixSumComputer.getAccumulatedValue(t-2)+1)+o-1)+1)+(u-o)-1,d=!0):h=(c=1===t?1:this.prefixSumComputer.getAccumulatedValue(t-2)+1)+u-1,
this.prefixSumComputer.changeValue(n,u);return[d,c<=h?new r.ViewLinesChangedEvent(c,h):null,p<=f?new r.ViewLinesInsertedEvent(p,f):null,g<=m?new r.ViewLinesDeletedEvent(g,m):null]},e.prototype.acceptVersionId=function(e){this._validModelVersionId=e,1!==this.lines.length||this.lines[0].isVisible()||this.setHiddenAreas([])},e.prototype.getViewLineCount=function(){return this._ensureValidState(),this.prefixSumComputer.getTotalValue()},e.prototype._toValidViewLineNumber=function(e){if(e<1)return 1;var t=this.getViewLineCount();return e>t?t:e},e.prototype.warmUpLookupCache=function(e,t){this.prefixSumComputer.warmUpCache(e-1,t-1)},e.prototype.getActiveIndentGuide=function(e,t,i){this._ensureValidState(),e=this._toValidViewLineNumber(e),t=this._toValidViewLineNumber(t),i=this._toValidViewLineNumber(i)
;var n=this.convertViewPositionToModelPosition(e,this.getViewLineMinColumn(e)),o=this.convertViewPositionToModelPosition(t,this.getViewLineMinColumn(t)),r=this.convertViewPositionToModelPosition(i,this.getViewLineMinColumn(i)),s=this.model.getActiveIndentGuide(n.lineNumber,o.lineNumber,r.lineNumber),a=this.convertModelPositionToViewPosition(s.startLineNumber,1),l=this.convertModelPositionToViewPosition(s.endLineNumber,this.model.getLineMaxColumn(s.endLineNumber));return{startLineNumber:a.lineNumber,endLineNumber:l.lineNumber,indent:s.indent}},e.prototype.getViewLinesIndentGuides=function(e,t){this._ensureValidState(),e=this._toValidViewLineNumber(e),t=this._toValidViewLineNumber(t);for(var n=this.convertViewPositionToModelPosition(e,this.getViewLineMinColumn(e)),o=this.convertViewPositionToModelPosition(t,this.getViewLineMaxColumn(t)),r=[],s=[],a=[],l=n.lineNumber-1,u=o.lineNumber-1,d=null,c=l;c<=u;c++){var h=this.lines[c];if(h.isVisible()){
var p=h.getViewLineNumberOfModelPosition(0,c===l?n.column:1),f=h.getViewLineNumberOfModelPosition(0,this.model.getLineMaxColumn(c+1)),g=0;(S=f-p+1)>1&&1===h.getViewLineMinColumn(this.model,c+1,f)&&(g=0===p?1:2),s.push(S),a.push(g),null===d&&(d=new i.Position(c+1,0))}else null!==d&&(r=r.concat(this.model.getLinesIndentGuides(d.lineNumber,c)),d=null)}null!==d&&(r=r.concat(this.model.getLinesIndentGuides(d.lineNumber,o.lineNumber)),d=null);for(var m=t-e+1,v=new Array(m),_=0,y=0,b=r.length;y<b;y++){var C=r[y],S=Math.min(m-_,s[y]),w=void 0;w=2===(g=a[y])?0:1===g?1:S;for(var E=0;E<S;E++)E===w&&(C=0),v[_++]=C}return v},e.prototype.getViewLineContent=function(e){this._ensureValidState(),e=this._toValidViewLineNumber(e);var t=this.prefixSumComputer.getIndexOf(e-1),i=t.index,n=t.remainder;return this.lines[i].getViewLineContent(this.model,i+1,n)},e.prototype.getViewLineLength=function(e){this._ensureValidState(),e=this._toValidViewLineNumber(e);var t=this.prefixSumComputer.getIndexOf(e-1),i=t.index,n=t.remainder
;return this.lines[i].getViewLineLength(this.model,i+1,n)},e.prototype.getViewLineMinColumn=function(e){this._ensureValidState(),e=this._toValidViewLineNumber(e);var t=this.prefixSumComputer.getIndexOf(e-1),i=t.index,n=t.remainder;return this.lines[i].getViewLineMinColumn(this.model,i+1,n)},e.prototype.getViewLineMaxColumn=function(e){this._ensureValidState(),e=this._toValidViewLineNumber(e);var t=this.prefixSumComputer.getIndexOf(e-1),i=t.index,n=t.remainder;return this.lines[i].getViewLineMaxColumn(this.model,i+1,n)},e.prototype.getViewLineData=function(e){this._ensureValidState(),e=this._toValidViewLineNumber(e);var t=this.prefixSumComputer.getIndexOf(e-1),i=t.index,n=t.remainder;return this.lines[i].getViewLineData(this.model,i+1,n)},e.prototype.getViewLinesData=function(e,t,i){this._ensureValidState(),e=this._toValidViewLineNumber(e),t=this._toValidViewLineNumber(t);for(var n=this.prefixSumComputer.getIndexOf(e-1),o=e,r=n.index,s=n.remainder,a=[],l=r,u=this.model.getLineCount();l<u;l++){
var d=this.lines[l];if(d.isVisible()){var c=l===r?s:0,h=d.getViewLineCount()-c,p=!1;o+h>t&&(p=!0,h=t-o+1);var f=c+h;if(d.getViewLinesData(this.model,l+1,c,f,o-e,i,a),o+=h,p)break}}return a},e.prototype.validateViewPosition=function(e,t,n){this._ensureValidState(),e=this._toValidViewLineNumber(e);var o=this.prefixSumComputer.getIndexOf(e-1),r=o.index,s=o.remainder,a=this.lines[r],l=a.getViewLineMinColumn(this.model,r+1,s),u=a.getViewLineMaxColumn(this.model,r+1,s);t<l&&(t=l),t>u&&(t=u);var d=a.getModelColumnOfViewPosition(s,t);return this.model.validatePosition(new i.Position(r+1,d)).equals(n)?new i.Position(e,t):this.convertModelPositionToViewPosition(n.lineNumber,n.column)},e.prototype.convertViewPositionToModelPosition=function(e,t){this._ensureValidState(),e=this._toValidViewLineNumber(e);var n=this.prefixSumComputer.getIndexOf(e-1),o=n.index,r=n.remainder,s=this.lines[o].getModelColumnOfViewPosition(r,t);return this.model.validatePosition(new i.Position(o+1,s))},
e.prototype.convertModelPositionToViewPosition=function(e,t){this._ensureValidState();for(var n=this.model.validatePosition(new i.Position(e,t)),o=n.lineNumber,r=n.column,s=o-1,a=!1;s>0&&!this.lines[s].isVisible();)s--,a=!0;if(0===s&&!this.lines[s].isVisible())return new i.Position(1,1);var l=1+(0===s?0:this.prefixSumComputer.getAccumulatedValue(s-1));return a?this.lines[s].getViewPositionOfModelPosition(l,this.model.getLineMaxColumn(s+1)):this.lines[o-1].getViewPositionOfModelPosition(l,r)},e.prototype._getViewLineNumberForModelPosition=function(e,t){var i=e-1;if(this.lines[i].isVisible()){var n=1+(0===i?0:this.prefixSumComputer.getAccumulatedValue(i-1));return this.lines[i].getViewLineNumberOfModelPosition(n,t)}for(;i>0&&!this.lines[i].isVisible();)i--;if(0===i&&!this.lines[i].isVisible())return 1;var o=1+(0===i?0:this.prefixSumComputer.getAccumulatedValue(i-1));return this.lines[i].getViewLineNumberOfModelPosition(o,this.model.getLineMaxColumn(i+1))},
e.prototype.getAllOverviewRulerDecorations=function(e,t,i){for(var n=this.model.getOverviewRulerDecorations(e,t),o=new v,r=0,s=n;r<s.length;r++){var a=s[r],l=a.options.overviewRuler,u=l?l.position:0;if(0!==u){var d=l.getColor(i),c=this._getViewLineNumberForModelPosition(a.range.startLineNumber,a.range.startColumn),h=this._getViewLineNumberForModelPosition(a.range.endLineNumber,a.range.endColumn);o.accept(d,c,h,u)}}return o.result},e.prototype.getDecorationsInRange=function(e,t,o){var r=this.convertViewPositionToModelPosition(e.startLineNumber,e.startColumn),s=this.convertViewPositionToModelPosition(e.endLineNumber,e.endColumn);if(s.lineNumber-r.lineNumber<=e.endLineNumber-e.startLineNumber)return this.model.getDecorationsInRange(new n.Range(r.lineNumber,1,s.lineNumber,s.column),t,o);for(var a=[],l=r.lineNumber-1,u=s.lineNumber-1,d=null,c=l;c<=u;c++){if(this.lines[c].isVisible())null===d&&(d=new i.Position(c+1,c===l?r.column:1));else if(null!==d){var h=this.model.getLineMaxColumn(c)
;a=a.concat(this.model.getDecorationsInRange(new n.Range(d.lineNumber,d.column,c,h),t,o)),d=null}}null!==d&&(a=a.concat(this.model.getDecorationsInRange(new n.Range(d.lineNumber,d.column,s.lineNumber,s.column),t,o)),d=null),a.sort(function(e,t){var i=n.Range.compareRangesUsingStarts(e.range,t.range);return 0===i?e.id<t.id?-1:e.id>t.id?1:0:i});for(var p=[],f=0,g=null,m=0,v=a;m<v.length;m++){var _=v[m],y=_.id;g!==y&&(g=y,p[f++]=_)}return p},e}();t.SplitLinesCollection=c;var h=function(){function e(){}return e.prototype.isVisible=function(){return!0},e.prototype.setVisible=function(e){return e?this:p.INSTANCE},e.prototype.getViewLineCount=function(){return 1},e.prototype.getViewLineContent=function(e,t,i){return e.getLineContent(t)},e.prototype.getViewLineLength=function(e,t,i){return e.getLineLength(t)},e.prototype.getViewLineMinColumn=function(e,t,i){return e.getLineMinColumn(t)},e.prototype.getViewLineMaxColumn=function(e,t,i){return e.getLineMaxColumn(t)},e.prototype.getViewLineData=function(e,t,i){
var n=e.getLineTokens(t),o=n.getLineContent();return new a.ViewLineData(o,!1,1,o.length+1,n.inflate())},e.prototype.getViewLinesData=function(e,t,i,n,o,r,s){r[o]?s[o]=this.getViewLineData(e,t,0):s[o]=null},e.prototype.getModelColumnOfViewPosition=function(e,t){return t},e.prototype.getViewPositionOfModelPosition=function(e,t){return new i.Position(e,t)},e.prototype.getViewLineNumberOfModelPosition=function(e,t){return e},e.INSTANCE=new e,e}(),p=function(){function e(){}return e.prototype.isVisible=function(){return!1},e.prototype.setVisible=function(e){return e?h.INSTANCE:this},e.prototype.getViewLineCount=function(){return 0},e.prototype.getViewLineContent=function(e,t,i){throw new Error("Not supported")},e.prototype.getViewLineLength=function(e,t,i){throw new Error("Not supported")},e.prototype.getViewLineMinColumn=function(e,t,i){throw new Error("Not supported")},e.prototype.getViewLineMaxColumn=function(e,t,i){throw new Error("Not supported")},e.prototype.getViewLineData=function(e,t,i){
throw new Error("Not supported")},e.prototype.getViewLinesData=function(e,t,i,n,o,r,s){throw new Error("Not supported")},e.prototype.getModelColumnOfViewPosition=function(e,t){throw new Error("Not supported")},e.prototype.getViewPositionOfModelPosition=function(e,t){throw new Error("Not supported")},e.prototype.getViewLineNumberOfModelPosition=function(e,t){throw new Error("Not supported")},e.INSTANCE=new e,e}(),f=function(){function e(e,t){this.positionMapper=e,this.wrappedIndent=this.positionMapper.getWrappedLinesIndent(),this.wrappedIndentLength=this.wrappedIndent.length,this.outputLineCount=this.positionMapper.getOutputLineCount(),this._isVisible=t}return e.prototype.isVisible=function(){return this._isVisible},e.prototype.setVisible=function(e){return this._isVisible=e,this},e.prototype.getViewLineCount=function(){return this._isVisible?this.outputLineCount:0},e.prototype.getInputStartOffsetOfOutputLineIndex=function(e){return this.positionMapper.getInputOffsetOfOutputPosition(e,0)},
e.prototype.getInputEndOffsetOfOutputLineIndex=function(e,t,i){return i+1===this.outputLineCount?e.getLineMaxColumn(t)-1:this.positionMapper.getInputOffsetOfOutputPosition(i+1,0)},e.prototype.getViewLineContent=function(e,t,i){if(!this._isVisible)throw new Error("Not supported");var n=this.getInputStartOffsetOfOutputLineIndex(i),o=this.getInputEndOffsetOfOutputLineIndex(e,t,i),r=e.getValueInRange({startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:o+1});return i>0&&(r=this.wrappedIndent+r),r},e.prototype.getViewLineLength=function(e,t,i){if(!this._isVisible)throw new Error("Not supported");var n=this.getInputStartOffsetOfOutputLineIndex(i),o=this.getInputEndOffsetOfOutputLineIndex(e,t,i)-n;return i>0&&(o=this.wrappedIndent.length+o),o},e.prototype.getViewLineMinColumn=function(e,t,i){if(!this._isVisible)throw new Error("Not supported");return i>0?this.wrappedIndentLength+1:1},e.prototype.getViewLineMaxColumn=function(e,t,i){if(!this._isVisible)throw new Error("Not supported")
;return this.getViewLineContent(e,t,i).length+1},e.prototype.getViewLineData=function(e,t,i){if(!this._isVisible)throw new Error("Not supported");var n=this.getInputStartOffsetOfOutputLineIndex(i),o=this.getInputEndOffsetOfOutputLineIndex(e,t,i),r=e.getValueInRange({startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:o+1});i>0&&(r=this.wrappedIndent+r);var s=i>0?this.wrappedIndentLength+1:1,l=r.length+1,u=i+1<this.getViewLineCount(),d=0;i>0&&(d=this.wrappedIndentLength);var c=e.getLineTokens(t);return new a.ViewLineData(r,u,s,l,c.sliceAndInflate(n,o,d))},e.prototype.getViewLinesData=function(e,t,i,n,o,r,s){if(!this._isVisible)throw new Error("Not supported");for(var a=i;a<n;a++){var l=o+a-i;r[l]?s[l]=this.getViewLineData(e,t,a):s[l]=null}},e.prototype.getModelColumnOfViewPosition=function(e,t){if(!this._isVisible)throw new Error("Not supported");var i=t-1;return e>0&&(i<this.wrappedIndentLength?i=0:i-=this.wrappedIndentLength),this.positionMapper.getInputOffsetOfOutputPosition(e,i)+1},
e.prototype.getViewPositionOfModelPosition=function(e,t){if(!this._isVisible)throw new Error("Not supported");var n=this.positionMapper.getOutputPositionOfInputOffset(t-1),o=n.outputLineIndex,r=n.outputOffset+1;return o>0&&(r+=this.wrappedIndentLength),new i.Position(e+o,r)},e.prototype.getViewLineNumberOfModelPosition=function(e,t){if(!this._isVisible)throw new Error("Not supported");return e+this.positionMapper.getOutputPositionOfInputOffset(t-1).outputLineIndex},e}();t.SplitLine=f;var g=function(){function e(e){this._lines=e}return e.prototype._validPosition=function(e){return this._lines.model.validatePosition(e)},e.prototype._validRange=function(e){return this._lines.model.validateRange(e)},e.prototype.convertViewPositionToModelPosition=function(e){return this._validPosition(e)},e.prototype.convertViewRangeToModelRange=function(e){return this._validRange(e)},e.prototype.validateViewPosition=function(e,t){return this._validPosition(t)},e.prototype.validateViewRange=function(e,t){return this._validRange(t)
},e.prototype.convertModelPositionToViewPosition=function(e){return this._validPosition(e)},e.prototype.convertModelRangeToViewRange=function(e){return this._validRange(e)},e.prototype.modelPositionIsVisible=function(e){var t=this._lines.model.getLineCount();return!(e.lineNumber<1||e.lineNumber>t)},e}();t.IdentityCoordinatesConverter=g;var m=function(){function e(e){this.model=e}return e.prototype.dispose=function(){},e.prototype.createCoordinatesConverter=function(){return new g(this)},e.prototype.getHiddenAreas=function(){return[]},e.prototype.setHiddenAreas=function(e){return!1},e.prototype.setTabSize=function(e){return!1},e.prototype.setWrappingSettings=function(e,t,i){return!1},e.prototype.onModelFlushed=function(){},e.prototype.onModelLinesDeleted=function(e,t,i){return new r.ViewLinesDeletedEvent(t,i)},e.prototype.onModelLinesInserted=function(e,t,i,n){return new r.ViewLinesInsertedEvent(t,i)},e.prototype.onModelLineChanged=function(e,t,i){return[!1,new r.ViewLinesChangedEvent(t,t),null,null]},
e.prototype.acceptVersionId=function(e){},e.prototype.getViewLineCount=function(){return this.model.getLineCount()},e.prototype.warmUpLookupCache=function(e,t){},e.prototype.getActiveIndentGuide=function(e,t,i){return{startLineNumber:e,endLineNumber:e,indent:0}},e.prototype.getViewLinesIndentGuides=function(e,t){for(var i=t-e+1,n=new Array(i),o=0;o<i;o++)n[o]=0;return n},e.prototype.getViewLineContent=function(e){return this.model.getLineContent(e)},e.prototype.getViewLineLength=function(e){return this.model.getLineLength(e)},e.prototype.getViewLineMinColumn=function(e){return this.model.getLineMinColumn(e)},e.prototype.getViewLineMaxColumn=function(e){return this.model.getLineMaxColumn(e)},e.prototype.getViewLineData=function(e){var t=this.model.getLineTokens(e),i=t.getLineContent();return new a.ViewLineData(i,!1,1,i.length+1,t.inflate())},e.prototype.getViewLinesData=function(e,t,i){var n=this.model.getLineCount();e=Math.min(Math.max(1,e),n),t=Math.min(Math.max(1,t),n);for(var o=[],r=e;r<=t;r++){var s=r-e
;i[s]||(o[s]=null),o[s]=this.getViewLineData(r)}return o},e.prototype.getAllOverviewRulerDecorations=function(e,t,i){for(var n=this.model.getOverviewRulerDecorations(e,t),o=new v,r=0,s=n;r<s.length;r++){var a=s[r],l=a.options.overviewRuler,u=l?l.position:0;if(0!==u){var d=l.getColor(i),c=a.range.startLineNumber,h=a.range.endLineNumber;o.accept(d,c,h,u)}}return o.result},e.prototype.getDecorationsInRange=function(e,t,i){return this.model.getDecorationsInRange(e,t,i)},e}();t.IdentityLinesCollection=m;var v=function(){function e(){this.result=Object.create(null)}return e.prototype.accept=function(e,t,i,n){var o=this.result[e];if(o){var r=o[o.length-3],s=o[o.length-1];if(r===n&&s+1>=t)return void(i>s&&(o[o.length-1]=i));o.push(n,t,i)}else this.result[e]=[n,t,i]},e}()}),define(t[407],i([1,0,5,80,105,136,194]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t,i,n){for(var o=e.call(this,0)||this,r=0;r<t.length;r++)o.set(t.charCodeAt(r),1)
;for(r=0;r<i.length;r++)o.set(i.charCodeAt(r),2);for(r=0;r<n.length;r++)o.set(n.charCodeAt(r),3);return o}return r(t,e),t.prototype.get=function(t){return t>=12352&&t<=12543||t>=13312&&t<=19903||t>=19968&&t<=40959?4:e.prototype.get.call(this,t)},t}(n.CharacterClassifier),u=function(){function e(e,t,i){this.classifier=new l(e,t,i)}return e.nextVisibleColumn=function(e,t,i,n){return e=+e,t=+t,n=+n,i?e+(t-e%t):e+n},e.prototype.createLineMapping=function(t,n,r,a,l){if(-1===r)return null;n=+n,r=+r,a=+a;var u=0,c="",h=-1;if(0!==(l=+l)&&-1!==(h=i.firstNonWhitespaceIndex(t))){c=t.substring(0,h);for(E=0;E<h;E++)u=e.nextVisibleColumn(u,n,9===t.charCodeAt(E),1);var p=0;2===l?p=1:3===l&&(p=2);for(E=0;E<p;E++)c+="\t",u=e.nextVisibleColumn(u,n,!0,1);u+a>r&&(c="",u=0)}for(var f=this.classifier,g=0,m=[],v=0,_=0,y=-1,b=0,C=-1,S=0,w=t.length,E=0;E<w;E++){var L=t.charCodeAt(E),x=9===L,D=f.get(L);if(i.isLowSurrogate(L))_+=1;else{if(1===D&&(y=E,b=u),4===D&&E>0){var I=t.charCodeAt(E-1);1!==f.get(I)&&(y=E,b=u)}var N=1
;if(i.isFullWidthCharacter(L)&&(N=a),(_=e.nextVisibleColumn(_,n,x,N))>r&&0!==E){var M=void 0,k=void 0;-1!==y&&b<=r?(M=y,k=b):-1!==C&&S<=r?(M=C,k=S):(M=E,k=u),m[v++]=M-g,g=M,_=e.nextVisibleColumn(k,n,x,N),y=-1,b=0,C=-1,S=0}if(-1!==y&&(b=e.nextVisibleColumn(b,n,x,N)),-1!==C&&(S=e.nextVisibleColumn(S,n,x,N)),2===D&&(0===l||E>=h)&&(y=E+1,b=u),4===D&&E<w-1){var T=t.charCodeAt(E+1);2!==f.get(T)&&(y=E+1,b=u)}3===D&&(C=E+1,S=u)}}return 0===v?null:(m[v++]=w-g,new d(new s.PrefixSumComputer(o.toUint32Array(m)),c))},e}();t.CharacterHardWrappingLineMapperFactory=u;var d=function(){function e(e,t){this._prefixSums=e,this._wrappedLinesIndent=t}return e.prototype.getOutputLineCount=function(){return this._prefixSums.getCount()},e.prototype.getWrappedLinesIndent=function(){return this._wrappedLinesIndent},e.prototype.getInputOffsetOfOutputPosition=function(e,t){return 0===e?t:this._prefixSums.getAccumulatedValue(e-1)+t},e.prototype.getOutputPositionOfInputOffset=function(e){var t=this._prefixSums.getIndexOf(e)
;return new a.OutputPosition(t.index,t.remainder)},e}();t.CharacterHardWrappingLineMapping=d}),define(t[408],i([1,0,25,5,47,13,3,17,193,139,77,241,407,194,67,242,15]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var _=!0,y=function(e){function t(t,i,n,o){var r=e.call(this)||this;if(r.editorId=t,r.configuration=i,r.model=n,r._tokenizeViewportSoon=r._register(new v.RunOnceScheduler(function(){return r.tokenizeViewport()},50)),r.hasFocus=!1,r.viewportStartLine=-1,r.viewportStartLineTrackedRange=null,r.viewportStartLineDelta=0,_&&r.model.isTooLargeForTokenization())r.lines=new f.IdentityLinesCollection(r.model);else{var s=r.configuration.editor,a=new p.CharacterHardWrappingLineMapperFactory(s.wrappingInfo.wordWrapBreakBeforeCharacters,s.wrappingInfo.wordWrapBreakAfterCharacters,s.wrappingInfo.wordWrapBreakObtrusiveCharacters)
;r.lines=new f.SplitLinesCollection(r.model,a,r.model.getOptions().tabSize,s.wrappingInfo.wrappingColumn,s.fontInfo.typicalFullwidthCharacterWidth/s.fontInfo.typicalHalfwidthCharacterWidth,s.wrappingInfo.wrappingIndent)}return r.coordinatesConverter=r.lines.createCoordinatesConverter(),r.viewLayout=r._register(new h.ViewLayout(r.configuration,r.getLineCount(),o)),r._register(r.viewLayout.onDidScroll(function(e){e.scrollTopChanged&&r._tokenizeViewportSoon.schedule();try{r._beginEmit().emit(new c.ViewScrollChangedEvent(e))}finally{r._endEmit()}})),r.decorations=new m.ViewModelDecorations(r.editorId,r.model,r.configuration,r.lines,r.coordinatesConverter),r._registerModelEvents(),r._register(r.configuration.onDidChange(function(e){try{var t=r._beginEmit();r._onConfigurationChanged(t,e)}finally{r._endEmit()}})),r._register(d.MinimapTokensColorTracker.getInstance().onDidChange(function(){try{r._beginEmit().emit(new c.ViewTokensColorsChangedEvent)}finally{r._endEmit()}})),r}return r(t,e),
t.prototype.dispose=function(){e.prototype.dispose.call(this),this.decorations.dispose(),this.lines.dispose(),this.viewportStartLineTrackedRange=this.model._setTrackedRange(this.viewportStartLineTrackedRange,null,1)},t.prototype.tokenizeViewport=function(){var e=this.viewLayout.getLinesViewportData(),t=this.coordinatesConverter.convertViewPositionToModelPosition(new s.Position(e.startLineNumber,1)),i=this.coordinatesConverter.convertViewPositionToModelPosition(new s.Position(e.endLineNumber,1));this.model.tokenizeViewport(t.lineNumber,i.lineNumber)},t.prototype.setHasFocus=function(e){this.hasFocus=e},t.prototype._onConfigurationChanged=function(e,t){var i=null;if(-1!==this.viewportStartLine){var n=new s.Position(this.viewportStartLine,this.getLineMinColumn(this.viewportStartLine));i=this.coordinatesConverter.convertViewPositionToModelPosition(n)}var o=!1,r=this.configuration.editor
;if(this.lines.setWrappingSettings(r.wrappingInfo.wrappingIndent,r.wrappingInfo.wrappingColumn,r.fontInfo.typicalFullwidthCharacterWidth/r.fontInfo.typicalHalfwidthCharacterWidth)&&(e.emit(new c.ViewFlushedEvent),e.emit(new c.ViewLineMappingChangedEvent),e.emit(new c.ViewDecorationsChangedEvent),this.decorations.onLineMappingChanged(),this.viewLayout.onFlushed(this.getLineCount()),0!==this.viewLayout.getCurrentScrollTop()&&(o=!0)),t.readOnly&&(this.decorations.reset(),e.emit(new c.ViewDecorationsChangedEvent)),e.emit(new c.ViewConfigurationChangedEvent(t)),this.viewLayout.onConfigurationChanged(t),o&&i){var a=this.coordinatesConverter.convertModelPositionToViewPosition(i),l=this.viewLayout.getVerticalOffsetForLineNumber(a.lineNumber);this.viewLayout.setScrollPositionNow({scrollTop:l+this.viewportStartLineDelta})}},t.prototype._registerModelEvents=function(){var e=this;this._register(this.model.onDidChangeRawContentFast(function(t){try{
for(var i=e._beginEmit(),n=!1,o=!1,r=t.changes,s=t.versionId,a=0,l=r.length;a<l;a++){var u=r[a];switch(u.changeType){case 1:e.lines.onModelFlushed(),i.emit(new c.ViewFlushedEvent),e.decorations.reset(),e.viewLayout.onFlushed(e.getLineCount()),n=!0;break;case 3:null!==(g=e.lines.onModelLinesDeleted(s,u.fromLineNumber,u.toLineNumber))&&(i.emit(g),e.viewLayout.onLinesDeleted(g.fromLineNumber,g.toLineNumber)),n=!0;break;case 4:null!==(f=e.lines.onModelLinesInserted(s,u.fromLineNumber,u.toLineNumber,u.detail))&&(i.emit(f),e.viewLayout.onLinesInserted(f.fromLineNumber,f.toLineNumber)),n=!0;break;case 2:var d=e.lines.onModelLineChanged(s,u.lineNumber,u.detail),h=d[0],p=d[1],f=d[2],g=d[3];o=h,p&&i.emit(p),f&&(i.emit(f),e.viewLayout.onLinesInserted(f.fromLineNumber,f.toLineNumber)),g&&(i.emit(g),e.viewLayout.onLinesDeleted(g.fromLineNumber,g.toLineNumber))}}e.lines.acceptVersionId(s),e.viewLayout.onHeightMaybeChanged(),!n&&o&&(i.emit(new c.ViewLineMappingChangedEvent),i.emit(new c.ViewDecorationsChangedEvent),
e.decorations.onLineMappingChanged())}finally{e._endEmit()}if(e.viewportStartLine=-1,e.configuration.setMaxLineNumber(e.model.getLineCount()),!e.hasFocus&&e.model.getAttachedEditorCount()>=2&&e.viewportStartLineTrackedRange){var m=e.model._getTrackedRange(e.viewportStartLineTrackedRange);if(m){var v=e.coordinatesConverter.convertModelPositionToViewPosition(m.getStartPosition()),_=e.viewLayout.getVerticalOffsetForLineNumber(v.lineNumber);e.viewLayout.setScrollPositionNow({scrollTop:_+e.viewportStartLineDelta})}}})),this._register(this.model.onDidChangeTokens(function(t){for(var i=[],n=0,o=t.ranges.length;n<o;n++){var r=t.ranges[n],a=e.coordinatesConverter.convertModelPositionToViewPosition(new s.Position(r.fromLineNumber,1)).lineNumber,l=e.coordinatesConverter.convertModelPositionToViewPosition(new s.Position(r.toLineNumber,e.model.getLineMaxColumn(r.toLineNumber))).lineNumber;i[n]={fromLineNumber:a,toLineNumber:l}}try{e._beginEmit().emit(new c.ViewTokensChangedEvent(i))}finally{e._endEmit()}
t.tokenizationSupportChanged&&e._tokenizeViewportSoon.schedule()})),this._register(this.model.onDidChangeLanguageConfiguration(function(t){try{e._beginEmit().emit(new c.ViewLanguageConfigurationEvent)}finally{e._endEmit()}})),this._register(this.model.onDidChangeOptions(function(t){if(e.lines.setTabSize(e.model.getOptions().tabSize)){e.decorations.onLineMappingChanged(),e.viewLayout.onFlushed(e.getLineCount());try{var i=e._beginEmit();i.emit(new c.ViewFlushedEvent),i.emit(new c.ViewLineMappingChangedEvent),i.emit(new c.ViewDecorationsChangedEvent)}finally{e._endEmit()}}})),this._register(this.model.onDidChangeDecorations(function(t){e.decorations.onModelDecorationsChanged();try{e._beginEmit().emit(new c.ViewDecorationsChangedEvent)}finally{e._endEmit()}}))},t.prototype.setHiddenAreas=function(e){try{var t=this._beginEmit();this.lines.setHiddenAreas(e)&&(t.emit(new c.ViewFlushedEvent),t.emit(new c.ViewLineMappingChangedEvent),t.emit(new c.ViewDecorationsChangedEvent),this.decorations.onLineMappingChanged(),
this.viewLayout.onFlushed(this.getLineCount()),this.viewLayout.onHeightMaybeChanged())}finally{this._endEmit()}},t.prototype.getVisibleRanges=function(){var e=this.getCompletelyVisibleViewRange(),t=this.coordinatesConverter.convertViewRangeToModelRange(e),i=this.lines.getHiddenAreas();if(0===i.length)return[t];for(var n=[],o=0,r=t.startLineNumber,s=t.startColumn,l=t.endLineNumber,u=t.endColumn,d=0,c=i.length;d<c;d++){var h=i[d].startLineNumber,p=i[d].endLineNumber;p<r||(h>l||(r<h&&(n[o++]=new a.Range(r,s,h-1,this.model.getLineMaxColumn(h-1))),r=p+1,s=1))}return(r<l||r===l&&s<u)&&(n[o++]=new a.Range(r,s,l,u)),n},t.prototype.getCompletelyVisibleViewRange=function(){var e=this.viewLayout.getLinesViewportData(),t=e.completelyVisibleStartLineNumber,i=e.completelyVisibleEndLineNumber;return new a.Range(t,this.getLineMinColumn(t),i,this.getLineMaxColumn(i))},t.prototype.getCompletelyVisibleViewRangeAtScrollTop=function(e){
var t=this.viewLayout.getLinesViewportDataAtScrollTop(e),i=t.completelyVisibleStartLineNumber,n=t.completelyVisibleEndLineNumber;return new a.Range(i,this.getLineMinColumn(i),n,this.getLineMaxColumn(n))},t.prototype.saveState=function(){var e=this.viewLayout.saveState(),t=e.scrollTop,i=this.viewLayout.getLineNumberAtVerticalOffset(t),n=this.coordinatesConverter.convertViewPositionToModelPosition(new s.Position(i,this.getLineMinColumn(i))),o=this.viewLayout.getVerticalOffsetForLineNumber(i)-t;return{scrollLeft:e.scrollLeft,firstPosition:n,firstPositionDeltaTop:o}},t.prototype.reduceRestoreState=function(e){if(void 0===e.firstPosition)return this._reduceRestoreStateCompatibility(e);var t=this.model.validatePosition(e.firstPosition),i=this.coordinatesConverter.convertModelPositionToViewPosition(t),n=this.viewLayout.getVerticalOffsetForLineNumber(i.lineNumber)-e.firstPositionDeltaTop;return{scrollLeft:e.scrollLeft,scrollTop:n}},t.prototype._reduceRestoreStateCompatibility=function(e){return{
scrollLeft:e.scrollLeft,scrollTop:e.scrollTopWithoutViewZones}},t.prototype.getTabSize=function(){return this.model.getOptions().tabSize},t.prototype.getOptions=function(){return this.model.getOptions()},t.prototype.getLineCount=function(){return this.lines.getViewLineCount()},t.prototype.setViewport=function(e,t,i){this.lines.warmUpLookupCache(e,t),this.viewportStartLine=e;var n=this.coordinatesConverter.convertViewPositionToModelPosition(new s.Position(e,this.getLineMinColumn(e)));this.viewportStartLineTrackedRange=this.model._setTrackedRange(this.viewportStartLineTrackedRange,new a.Range(n.lineNumber,n.column,n.lineNumber,n.column),1);var o=this.viewLayout.getVerticalOffsetForLineNumber(e),r=this.viewLayout.getCurrentScrollTop();this.viewportStartLineDelta=r-o},t.prototype.getActiveIndentGuide=function(e,t,i){return this.lines.getActiveIndentGuide(e,t,i)},t.prototype.getLinesIndentGuides=function(e,t){return this.lines.getViewLinesIndentGuides(e,t)},t.prototype.getLineContent=function(e){
return this.lines.getViewLineContent(e)},t.prototype.getLineLength=function(e){return this.lines.getViewLineLength(e)},t.prototype.getLineMinColumn=function(e){return this.lines.getViewLineMinColumn(e)},t.prototype.getLineMaxColumn=function(e){return this.lines.getViewLineMaxColumn(e)},t.prototype.getLineFirstNonWhitespaceColumn=function(e){var t=n.firstNonWhitespaceIndex(this.getLineContent(e));return-1===t?0:t+1},t.prototype.getLineLastNonWhitespaceColumn=function(e){var t=n.lastNonWhitespaceIndex(this.getLineContent(e));return-1===t?0:t+2},t.prototype.getDecorationsInViewport=function(e){return this.decorations.getDecorationsViewportData(e).decorations},t.prototype.getViewLineRenderingData=function(e,t){var i=this.model.mightContainRTL(),n=this.model.mightContainNonBasicASCII(),o=this.getTabSize(),r=this.lines.getViewLineData(t),s=this.decorations.getDecorationsViewportData(e).inlineDecorations[t-e.startLineNumber]
;return new g.ViewLineRenderingData(r.minColumn,r.maxColumn,r.content,r.continuesWithWrappedLine,i,n,r.tokens,s,o)},t.prototype.getViewLineData=function(e){return this.lines.getViewLineData(e)},t.prototype.getMinimapLinesRenderingData=function(e,t,i){var n=this.lines.getViewLinesData(e,t,i);return new g.MinimapLinesRenderingData(this.getTabSize(),n)},t.prototype.getAllOverviewRulerDecorations=function(e){return this.lines.getAllOverviewRulerDecorations(this.editorId,this.configuration.editor.readOnly,e)},t.prototype.invalidateOverviewRulerColorCache=function(){for(var e=0,t=this.model.getOverviewRulerDecorations();e<t.length;e++){var i=t[e].options.overviewRuler;i&&i.invalidateCachedColor()}},t.prototype.invalidateMinimapColorCache=function(){for(var e=0,t=this.model.getAllDecorations();e<t.length;e++){var i=t[e].options.minimap;i&&i.invalidateCachedColor()}},t.prototype.getValueInRange=function(e,t){var i=this.coordinatesConverter.convertViewRangeToModelRange(e);return this.model.getValueInRange(i,t)},
t.prototype.getModelLineMaxColumn=function(e){return this.model.getLineMaxColumn(e)},t.prototype.validateModelPosition=function(e){return this.model.validatePosition(e)},t.prototype.validateModelRange=function(e){return this.model.validateRange(e)},t.prototype.deduceModelPositionRelativeToViewPosition=function(e,t,i){var n=this.coordinatesConverter.convertViewPositionToModelPosition(e);2===this.model.getEOL().length&&(t<0?t-=i:t+=i);var o=this.model.getOffsetAt(n)+t;return this.model.getPositionAt(o)},t.prototype.getEOL=function(){return this.model.getEOL()},t.prototype.getPlainTextToCopy=function(e,t,i){var n=this,o=i?"\r\n":this.model.getEOL();(e=e.slice(0)).sort(a.Range.compareRangesUsingStarts);var r=e.filter(function(e){return!e.isEmpty()});if(0===r.length){if(!t)return"";for(var l=e.map(function(e){var t=new s.Position(e.startLineNumber,1);return n.coordinatesConverter.convertViewPositionToModelPosition(t).lineNumber}),u="",d=0;d<l.length;d++)d>0&&l[d-1]===l[d]||(u+=this.model.getLineContent(l[d])+o)
;return u}for(var c=[],h=0,p=r;h<p.length;h++){var f=p[h];c.push(this.getValueInRange(f,i?2:0))}return 1===c.length?c[0]:c},t.prototype.getHTMLToCopy=function(e,t){if(1===this.model.getLanguageIdentifier().id)return null;if(1!==e.length)return null;var i=this.coordinatesConverter.convertViewRangeToModelRange(e[0]);if(i.isEmpty()){if(!t)return null;var n=i.startLineNumber;i=new a.Range(n,this.model.getLineMinColumn(n),n,this.model.getLineMaxColumn(n))}var r=this.configuration.editor.fontInfo,s=this._getColorMap(),l=r.fontFamily===o.EDITOR_FONT_DEFAULTS.fontFamily?r.fontFamily:"'"+r.fontFamily+"', "+o.EDITOR_FONT_DEFAULTS.fontFamily;return'<div style="color: '+s[1]+";background-color: "+s[2]+";font-family: "+l+";font-weight: "+r.fontWeight+";font-size: "+r.fontSize+"px;line-height: "+r.lineHeight+'px;white-space: pre;">'+this._getHTMLToCopy(i,s)+"</div>"},t.prototype._getHTMLToCopy=function(e,t){for(var i=e.startLineNumber,n=e.startColumn,o=e.endLineNumber,r=e.endColumn,s=this.getTabSize(),a="",l=i;l<=o;l++){
var d=this.model.getLineTokens(l),c=d.getLineContent(),h=l===i?n-1:0,p=l===o?r-1:c.length;a+=""===c?"<br>":u.tokenizeLineToHTML(c,d.inflate(),t,h,p,s)}return a},t.prototype._getColorMap=function(){var e=l.TokenizationRegistry.getColorMap(),t=["#000000"];if(e)for(var n=1,o=e.length;n<o;n++)t[n]=i.Color.Format.CSS.formatHex(e[n]);return t},t}(c.ViewEventEmitter);t.ViewModel=y}),define(t[409],i([1,0,19,26,95,10,41,17]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(){}return e.prototype.remove=function(){this.parent&&delete this.parent.children[this.id]},e.findId=function(e,t){var i;"string"==typeof e?i=t.id+"/"+e:(i=t.id+"/"+e.name,void 0!==t.children[i]&&(i=t.id+"/"+e.name+"_"+e.range.startLineNumber+"_"+e.range.startColumn));for(var n=i,o=0;void 0!==t.children[n];o++)n=i+"_"+o;return n},e.empty=function(e){for(var t in e.children)return!1;return!0},e}();t.TreeElement=u;var d=function(e){function t(t,i,n){var o=e.call(this)||this
;return o.id=t,o.parent=i,o.symbol=n,o.children=Object.create(null),o}return r(t,e),t}(u);t.OutlineElement=d;var c=function(e){function t(t,i,n,o){var r=e.call(this)||this;return r.id=t,r.parent=i,r.provider=n,r.providerIndex=o,r.children=Object.create(null),r}return r(t,e),t}(u);t.OutlineGroup=c;var h=function(){function e(){this._n=1,this._val=0}return e.prototype.update=function(e){return this._val=this._val+(e-this._val)/this._n,this._n+=1,this},e}(),p=function(e){function t(t){var i=e.call(this)||this;return i.textModel=t,i.id="root",i.parent=void 0,i._groups=Object.create(null),i.children=Object.create(null),i.id="root",i.parent=void 0,i}return r(t,e),t.create=function(e,i){var o=this,r=this._keys.for(e,!0),s=t._requests.get(r);if(!s){var a=new n.CancellationTokenSource;s={promiseCnt:0,source:a,promise:t._create(e,a.token),model:void 0},t._requests.set(r,s);var l=Date.now();s.promise.then(function(){var t=o._keys.for(e,!1),i=o._requestDurations.get(t);i||(i=new h,o._requestDurations.set(t,i)),
i.update(Date.now()-l)})}return s.model?Promise.resolve(s.model):(s.promiseCnt+=1,i.onCancellationRequested(function(){0==--s.promiseCnt&&(s.source.cancel(),t._requests.delete(r))}),new Promise(function(e,i){s.promise.then(function(t){s.model=t,e(t)},function(e){t._requests.delete(r),i(e)})}))},t._create=function(e,o){var r=new n.CancellationTokenSource(o),a=new t(e),d=l.DocumentSymbolProviderRegistry.ordered(e),h=d.map(function(e,i){var n=u.findId("provider_"+i,a),o=new c(n,a,e,i);return Promise.resolve(e.provideDocumentSymbols(a.textModel,r.token)).then(function(e){for(var i=0,n=e||[];i<n.length;i++){t._makeOutlineElement(n[i],o)}return o},function(e){return s.onUnexpectedExternalError(e),o}).then(function(e){u.empty(e)?e.remove():a._groups[n]=e})}),p=l.DocumentSymbolProviderRegistry.onDidChange(function(){var t=l.DocumentSymbolProviderRegistry.ordered(e);i.equals(t,d)||r.cancel()});return Promise.all(h).then(function(){
return r.token.isCancellationRequested&&!o.isCancellationRequested?t._create(e,o):a._compact()}).finally(function(){p.dispose()})},t._makeOutlineElement=function(e,i){var n=u.findId(e,i),o=new d(n,i,e);if(e.children)for(var r=0,s=e.children;r<s.length;r++){var a=s[r];t._makeOutlineElement(a,o)}i.children[o.id]=o},t.prototype._compact=function(){var e=0;for(var t in this._groups){i=this._groups[t];void 0===o.first(i.children)?delete this._groups[t]:e+=1}if(1!==e)this.children=this._groups;else{var i=o.first(this._groups);for(var t in i.children){var n=i.children[t];n.parent=this,this.children[n.id]=n}}return this},t._requestDurations=new a.LRUCache(50,.7),t._requests=new a.LRUCache(9,.75),t._keys=new(function(){function e(){this._counter=1,this._data=new WeakMap}return e.prototype.for=function(e,t){return e.id+"/"+(t?e.getVersionId():"")+"/"+this._hash(l.DocumentSymbolProviderRegistry.all(e))},e.prototype._hash=function(e){for(var t="",i=0,n=e;i<n.length;i++){var o=n[i],r=this._data.get(o)
;void 0===r&&(r=this._counter++,this._data.set(o,r)),t+=r}return t},e}()),t}(u);t.OutlineModel=p}),define(t[410],i([1,0,30]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.editor=e,this.autoHideFoldingControls=!0}return e.prototype.getDecorationOption=function(t){return t?e.COLLAPSED_VISUAL_DECORATION:this.autoHideFoldingControls?e.EXPANDED_AUTO_HIDE_VISUAL_DECORATION:e.EXPANDED_VISUAL_DECORATION},e.prototype.deltaDecorations=function(e,t){return this.editor.deltaDecorations(e,t)},e.prototype.changeDecorations=function(e){return this.editor.changeDecorations(e)},e.COLLAPSED_VISUAL_DECORATION=i.ModelDecorationOptions.register({stickiness:1,afterContentClassName:"inline-folded",linesDecorationsClassName:"folding collapsed"}),e.EXPANDED_AUTO_HIDE_VISUAL_DECORATION=i.ModelDecorationOptions.register({stickiness:1,linesDecorationsClassName:"folding"}),e.EXPANDED_VISUAL_DECORATION=i.ModelDecorationOptions.register({stickiness:1,
linesDecorationsClassName:"folding alwaysShowFoldIcons"}),e}();t.FoldingDecorationProvider=n}),define(t[411],i([1,0,129,30,40]),function(e,t,i,n,o){"use strict";function r(e,t,i,o){void 0===o&&(o=s);var r=e.getOptions().tabSize,a=new l(o),u=void 0;i&&(u=new RegExp("("+i.start.source+")|(?:"+i.end.source+")"));var d=[],c=e.getLineCount()+1;d.push({indent:-1,endAbove:c,line:c});for(var h=e.getLineCount();h>0;h--){var p=e.getLineContent(h),f=n.TextModel.computeIndentLevel(p,r),g=d[d.length-1];if(-1!==f){var m=void 0;if(u&&(m=p.match(u))){if(!m[1]){d.push({indent:-2,endAbove:h,line:h});continue}for(var v=d.length-1;v>0&&-2!==d[v].indent;)v--;if(v>0){d.length=v+1,g=d[v],a.insertFirst(h,g.line,f),g.line=h,g.indent=f,g.endAbove=h;continue}}if(g.indent>f){do{d.pop(),g=d[d.length-1]}while(g.indent>f);var _=g.endAbove-1;_-h>=1&&a.insertFirst(h,_,f)}g.indent===f?g.endAbove=h:d.push({indent:f,endAbove:h,line:h})}else t&&(g.endAbove=h)}return a.toIndentRanges(e)}Object.defineProperty(t,"__esModule",{value:!0});var s=5e3
;t.ID_INDENT_PROVIDER="indent";var a=function(){function e(e){this.editorModel=e,this.id=t.ID_INDENT_PROVIDER}return e.prototype.dispose=function(){},e.prototype.compute=function(e){var t=o.LanguageConfigurationRegistry.getFoldingRules(this.editorModel.getLanguageIdentifier().id),i=t&&!!t.offSide,n=t&&t.markers;return Promise.resolve(r(this.editorModel,i,n))},e}();t.IndentRangeProvider=a;var l=function(){function e(e){this._startIndexes=[],this._endIndexes=[],this._indentOccurrences=[],this._length=0,this._foldingRangesLimit=e}return e.prototype.insertFirst=function(e,t,n){if(!(e>i.MAX_LINE_NUMBER||t>i.MAX_LINE_NUMBER)){var o=this._length;this._startIndexes[o]=e,this._endIndexes[o]=t,this._length++,n<1e3&&(this._indentOccurrences[n]=(this._indentOccurrences[n]||0)+1)}},e.prototype.toIndentRanges=function(e){if(this._length<=this._foldingRangesLimit){for(var t=new Uint32Array(this._length),o=new Uint32Array(this._length),r=this._length-1,s=0;r>=0;r--,s++)t[s]=this._startIndexes[r],o[s]=this._endIndexes[r]
;return new i.FoldingRegions(t,o)}for(var a=0,l=this._indentOccurrences.length,r=0;r<this._indentOccurrences.length;r++){var u=this._indentOccurrences[r];if(u){if(u+a>this._foldingRangesLimit){l=r;break}a+=u}}for(var d=e.getOptions().tabSize,t=new Uint32Array(this._foldingRangesLimit),o=new Uint32Array(this._foldingRangesLimit),r=this._length-1,s=0;r>=0;r--){var c=this._startIndexes[r],h=e.getLineContent(c),p=n.TextModel.computeIndentLevel(h,d);(p<l||p===l&&a++<this._foldingRangesLimit)&&(t[s]=c,o[s]=this._endIndexes[r],s++)}return new i.FoldingRegions(t,o)},e}();t.RangesCollector=l,t.computeRanges=r}),define(t[412],i([1,0,5,189,3,20,92,40,263]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t,i){this._selection=e,this._isMovingDown=t,this._autoIndent=i,this._selectionId=null,this._moveEndLineSelectionShrink=!1}return e.prototype.getEditOperations=function(e,t){var n=e.getLineCount()
;if(this._isMovingDown&&this._selection.endLineNumber===n)this._selectionId=t.trackSelection(this._selection);else if(this._isMovingDown||1!==this._selection.startLineNumber){this._moveEndPositionDown=!1;var s=this._selection;s.startLineNumber<s.endLineNumber&&1===s.endColumn&&(this._moveEndPositionDown=!0,s=s.setEndPosition(s.endLineNumber-1,e.getLineMaxColumn(s.endLineNumber-1)));var u=e.getOptions(),d=u.tabSize,c=u.indentSize,h=u.insertSpaces,p=this.buildIndentConverter(d,c,h),f={getLineTokens:function(t){return e.getLineTokens(t)},getLanguageIdentifier:function(){return e.getLanguageIdentifier()},getLanguageIdAtPosition:function(t,i){return e.getLanguageIdAtPosition(t,i)},getLineContent:null};if(s.startLineNumber===s.endLineNumber&&1===e.getLineMaxColumn(s.startLineNumber)){var g=s.startLineNumber,m=this._isMovingDown?g+1:g-1;1===e.getLineMaxColumn(m)?t.addEditOperation(new o.Range(1,1,1,1),null):(t.addEditOperation(new o.Range(g,1,g,1),e.getLineContent(m)),
t.addEditOperation(new o.Range(m,1,m,e.getLineMaxColumn(m)),null)),s=new r.Selection(m,1,m,1)}else{var v,_=void 0;if(this._isMovingDown){v=s.endLineNumber+1,_=e.getLineContent(v),t.addEditOperation(new o.Range(v-1,e.getLineMaxColumn(v-1),v,e.getLineMaxColumn(v)),null);var y=_;if(this.shouldAutoIndent(e,s)){var b=this.matchEnterRule(e,p,d,v,s.startLineNumber-1);if(null!==b){var C=i.getLeadingWhitespace(e.getLineContent(v)),S=b+l.getSpaceCnt(C,d),w=l.generateIndent(S,d,h);y=w+this.trimLeft(_)}else{f.getLineContent=function(t){return t===s.startLineNumber?e.getLineContent(v):e.getLineContent(t)};var E=a.LanguageConfigurationRegistry.getGoodIndentForLine(f,e.getLanguageIdAtPosition(v,1),s.startLineNumber,p);if(null!==E){C=i.getLeadingWhitespace(e.getLineContent(v));if((S=l.getSpaceCnt(E,d))!==(N=l.getSpaceCnt(C,d))){w=l.generateIndent(S,d,h);y=w+this.trimLeft(_)}}}t.addEditOperation(new o.Range(s.startLineNumber,1,s.startLineNumber,1),y+"\n")
;if(null!==(x=this.matchEnterRule(e,p,d,s.startLineNumber,s.startLineNumber,y)))0!==x&&this.getIndentEditsOfMovingBlock(e,t,s,d,h,x);else{f.getLineContent=function(t){return t===s.startLineNumber?y:t>=s.startLineNumber+1&&t<=s.endLineNumber+1?e.getLineContent(t-1):e.getLineContent(t)};var L=a.LanguageConfigurationRegistry.getGoodIndentForLine(f,e.getLanguageIdAtPosition(v,1),s.startLineNumber+1,p);if(null!==L){C=i.getLeadingWhitespace(e.getLineContent(s.startLineNumber));if((S=l.getSpaceCnt(L,d))!==(N=l.getSpaceCnt(C,d))){M=S-N;this.getIndentEditsOfMovingBlock(e,t,s,d,h,M)}}}}else t.addEditOperation(new o.Range(s.startLineNumber,1,s.startLineNumber,1),y+"\n")}else if(v=s.startLineNumber-1,_=e.getLineContent(v),t.addEditOperation(new o.Range(v,1,v+1,1),null),t.addEditOperation(new o.Range(s.endLineNumber,e.getLineMaxColumn(s.endLineNumber),s.endLineNumber,e.getLineMaxColumn(s.endLineNumber)),"\n"+_),this.shouldAutoIndent(e,s)){f.getLineContent=function(t){
return t===v?e.getLineContent(s.startLineNumber):e.getLineContent(t)};var x=this.matchEnterRule(e,p,d,s.startLineNumber,s.startLineNumber-2);if(null!==x)0!==x&&this.getIndentEditsOfMovingBlock(e,t,s,d,h,x);else{var D=a.LanguageConfigurationRegistry.getGoodIndentForLine(f,e.getLanguageIdAtPosition(s.startLineNumber,1),v,p);if(null!==D){var I=i.getLeadingWhitespace(e.getLineContent(s.startLineNumber)),S=l.getSpaceCnt(D,d),N=l.getSpaceCnt(I,d);if(S!==N){var M=S-N;this.getIndentEditsOfMovingBlock(e,t,s,d,h,M)}}}}}this._selectionId=t.trackSelection(s)}else this._selectionId=t.trackSelection(this._selection)},e.prototype.buildIndentConverter=function(e,t,i){return{shiftIndent:function(o){return n.ShiftCommand.shiftIndent(o,o.length+1,e,t,i)},unshiftIndent:function(o){return n.ShiftCommand.unshiftIndent(o,o.length+1,e,t,i)}}},e.prototype.matchEnterRule=function(e,t,n,r,u,d){for(var c=u;c>=1;){var h=void 0;h=c===u&&void 0!==d?d:e.getLineContent(c);if(i.lastNonWhitespaceIndex(h)>=0)break;c--}
if(c<1||r>e.getLineCount())return null;var p=e.getLineMaxColumn(c),f=a.LanguageConfigurationRegistry.getEnterAction(e,new o.Range(c,p,c,p));if(f){var g=f.indentation,m=f.enterAction;m.indentAction===s.IndentAction.None?g=f.indentation+m.appendText:m.indentAction===s.IndentAction.Indent?g=f.indentation+m.appendText:m.indentAction===s.IndentAction.IndentOutdent?g=f.indentation:m.indentAction===s.IndentAction.Outdent&&(g=t.unshiftIndent(f.indentation)+m.appendText);var v=e.getLineContent(r);if(this.trimLeft(v).indexOf(this.trimLeft(g))>=0){var _=i.getLeadingWhitespace(e.getLineContent(r)),y=i.getLeadingWhitespace(g),b=a.LanguageConfigurationRegistry.getIndentMetadata(e,r);null!==b&&2&b&&(y=t.unshiftIndent(y));return l.getSpaceCnt(y,n)-l.getSpaceCnt(_,n)}}return null},e.prototype.trimLeft=function(e){return e.replace(/^\s+/,"")},e.prototype.shouldAutoIndent=function(e,t){if(!this._autoIndent)return!1;if(!e.isCheapToTokenize(t.startLineNumber))return!1;var i=e.getLanguageIdAtPosition(t.startLineNumber,1)
;return i===e.getLanguageIdAtPosition(t.endLineNumber,1)&&null!==a.LanguageConfigurationRegistry.getIndentRulesSupport(i)},e.prototype.getIndentEditsOfMovingBlock=function(e,t,n,r,s,a){for(var u=n.startLineNumber;u<=n.endLineNumber;u++){var d=e.getLineContent(u),c=i.getLeadingWhitespace(d),h=l.getSpaceCnt(c,r)+a,p=l.generateIndent(h,r,s);p!==c&&(t.addEditOperation(new o.Range(u,1,u,c.length+1),p),u===n.endLineNumber&&n.endColumn<=c.length+1&&""===p&&(this._moveEndLineSelectionShrink=!0))}},e.prototype.computeCursorState=function(e,t){var i=t.getTrackedSelection(this._selectionId);return this._moveEndPositionDown&&(i=i.setEndPosition(i.endLineNumber+1,1)),this._moveEndLineSelectionShrink&&i.startLineNumber<i.endLineNumber&&(i=i.setEndPosition(i.endLineNumber,2)),i},e}();t.MoveLinesCommand=u}),define(t[413],i([1,0,8,100,25,149,2,29,3,30,271]),function(e,t,i,n,o,r,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=new o.Color(new o.RGBA(0,122,204)),c={showArrow:!0,showFrame:!0,
className:"",frameColor:d,arrowColor:d,keepEditorSelection:!1},h=function(){function e(e,t,i,n,o,r){this.id="",this.domNode=e,this.afterLineNumber=t,this.afterColumn=i,this.heightInLines=n,this._onDomNodeTop=o,this._onComputedHeight=r}return e.prototype.onDomNodeTop=function(e){this._onDomNodeTop(e)},e.prototype.onComputedHeight=function(e){this._onComputedHeight(e)},e}();t.ViewZoneDelegate=h;var p=function(){function e(e,t){this._id=e,this._domNode=t}return e.prototype.getId=function(){return this._id},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return null},e}();t.OverlayWidgetDelegate=p;var f=function(){function e(t){this._editor=t,this._ruleName=e._IdGenerator.nextId(),this._decorations=[],this._color=null,this._height=-1}return e.prototype.dispose=function(){this.hide(),i.removeCSSRulesContainingSelector(this._ruleName)},Object.defineProperty(e.prototype,"color",{set:function(e){this._color!==e&&(this._color=e,this._updateStyle())},enumerable:!0,
configurable:!0}),Object.defineProperty(e.prototype,"height",{set:function(e){this._height!==e&&(this._height=e,this._updateStyle())},enumerable:!0,configurable:!0}),e.prototype._updateStyle=function(){i.removeCSSRulesContainingSelector(this._ruleName),i.createCSSRule(".monaco-editor "+this._ruleName,"border-style: solid; border-color: transparent; border-bottom-color: "+this._color+"; border-width: "+this._height+"px; bottom: -"+this._height+"px; margin-left: -"+this._height+"px; ")},e.prototype.show=function(e){this._decorations=this._editor.deltaDecorations(this._decorations,[{range:l.Range.fromPositions(e),options:{className:this._ruleName,stickiness:1}}])},e.prototype.hide=function(){this._editor.deltaDecorations(this._decorations,[])},e._IdGenerator=new r.IdGenerator(".arrow-decoration-"),e}(),g=function(){function e(e,t){var i=this;void 0===t&&(t={}),this._arrow=null,this._overlayWidget=null,this._resizeSash=null,this._positionMarkerId=[],this._viewZone=null,this._disposables=new s.DisposableStore,
this.container=null,this._isShowing=!1,this.editor=e,this.options=a.deepClone(t),a.mixin(this.options,c,!1),this.domNode=document.createElement("div"),this.options.isAccessible||(this.domNode.setAttribute("aria-hidden","true"),this.domNode.setAttribute("role","presentation")),this._disposables.add(this.editor.onDidLayoutChange(function(e){var t=i._getWidth(e);i.domNode.style.width=t+"px",i.domNode.style.left=i._getLeft(e)+"px",i._onWidth(t)}))}return e.prototype.dispose=function(){var e=this;this._overlayWidget&&(this.editor.removeOverlayWidget(this._overlayWidget),this._overlayWidget=null),this._viewZone&&this.editor.changeViewZones(function(t){e._viewZone&&t.removeZone(e._viewZone.id),e._viewZone=null}),this.editor.deltaDecorations(this._positionMarkerId,[]),this._positionMarkerId=[],this._disposables.dispose()},e.prototype.create=function(){i.addClass(this.domNode,"zone-widget"),this.options.className&&i.addClass(this.domNode,this.options.className),this.container=document.createElement("div"),
i.addClass(this.container,"zone-widget-container"),this.domNode.appendChild(this.container),this.options.showArrow&&(this._arrow=new f(this.editor),this._disposables.add(this._arrow)),this._fillContainer(this.container),this._initSash(),this._applyStyles()},e.prototype.style=function(e){e.frameColor&&(this.options.frameColor=e.frameColor),e.arrowColor&&(this.options.arrowColor=e.arrowColor),this._applyStyles()},e.prototype._applyStyles=function(){if(this.container&&this.options.frameColor){var e=this.options.frameColor.toString();this.container.style.borderTopColor=e,this.container.style.borderBottomColor=e}if(this._arrow&&this.options.arrowColor){var t=this.options.arrowColor.toString();this._arrow.color=t}},e.prototype._getWidth=function(e){return e.width-e.minimapWidth-e.verticalScrollbarWidth},e.prototype._getLeft=function(e){return e.minimapWidth>0&&0===e.minimapLeft?e.minimapWidth:0},e.prototype._onViewZoneTop=function(e){this.domNode.style.top=e+"px"},e.prototype._onViewZoneHeight=function(e){
if(this.domNode.style.height=e+"px",this.container){var t=e-this._decoratingElementsHeight();this.container.style.height=t+"px";var i=this.editor.getLayoutInfo();this._doLayout(t,this._getWidth(i))}this._resizeSash&&this._resizeSash.layout()},Object.defineProperty(e.prototype,"position",{get:function(){var e=this._positionMarkerId[0];if(e){var t=this.editor.getModel();if(t){var i=t.getDecorationRange(e);if(i)return i.getStartPosition()}}},enumerable:!0,configurable:!0}),e.prototype.show=function(e,t){var i=l.Range.isIRange(e)?e:new l.Range(e.lineNumber,e.column,e.lineNumber,e.column);this._isShowing=!0,this._showImpl(i,t),this._isShowing=!1,this._positionMarkerId=this.editor.deltaDecorations(this._positionMarkerId,[{range:i,options:u.ModelDecorationOptions.EMPTY}])},e.prototype.hide=function(){var e=this;this._viewZone&&(this.editor.changeViewZones(function(t){e._viewZone&&t.removeZone(e._viewZone.id)}),this._viewZone=null),this._overlayWidget&&(this.editor.removeOverlayWidget(this._overlayWidget),
this._overlayWidget=null),this._arrow&&this._arrow.hide()},e.prototype._decoratingElementsHeight=function(){var e=this.editor.getConfiguration().lineHeight,t=0;if(this.options.showArrow){t+=2*Math.round(e/3)}if(this.options.showFrame){t+=2*Math.round(e/9)}return t},e.prototype._showImpl=function(e,t){var i=this,n={lineNumber:e.startLineNumber,column:e.startColumn},o=this.editor.getLayoutInfo(),r=this._getWidth(o);this.domNode.style.width=r+"px",this.domNode.style.left=this._getLeft(o)+"px";var s=document.createElement("div");s.style.overflow="hidden";var a=this.editor.getConfiguration().lineHeight,l=this.editor.getLayoutInfo().height/a*.8;t>=l&&(t=l);var u=0,d=0;if(this._arrow&&this.options.showArrow&&(u=Math.round(a/3),this._arrow.height=u,this._arrow.show(n)),this.options.showFrame&&(d=Math.round(a/9)),this.editor.changeViewZones(function(e){i._viewZone&&e.removeZone(i._viewZone.id),i._overlayWidget&&(i.editor.removeOverlayWidget(i._overlayWidget),i._overlayWidget=null),i.domNode.style.top="-1000px",
i._viewZone=new h(s,n.lineNumber,n.column,t,function(e){return i._onViewZoneTop(e)},function(e){return i._onViewZoneHeight(e)}),i._viewZone.id=e.addZone(i._viewZone),i._overlayWidget=new p("vs.editor.contrib.zoneWidget"+i._viewZone.id,i.domNode),i.editor.addOverlayWidget(i._overlayWidget)}),this.container&&this.options.showFrame){var c=this.options.frameWidth?this.options.frameWidth:d;this.container.style.borderTopWidth=c+"px",this.container.style.borderBottomWidth=c+"px"}var f=t*a-this._decoratingElementsHeight();this.container&&(this.container.style.top=u+"px",this.container.style.height=f+"px",this.container.style.overflow="hidden"),this._doLayout(f,r),this.options.keepEditorSelection||this.editor.setSelection(e);var g=this.editor.getModel();if(g){var m=Math.min(g.getLineCount(),Math.max(1,e.endLineNumber+1));this.revealLine(m)}},e.prototype.revealLine=function(e){this.editor.revealLine(e,0)},e.prototype.setCssClass=function(e,t){this.container&&(t&&this.container.classList.remove(t),
i.addClass(this.container,e))},e.prototype._onWidth=function(e){},e.prototype._doLayout=function(e,t){},e.prototype._relayout=function(e){var t=this;this._viewZone&&this._viewZone.heightInLines!==e&&this.editor.changeViewZones(function(i){t._viewZone&&(t._viewZone.heightInLines=e,i.layoutZone(t._viewZone.id))})},e.prototype._initSash=function(){var e=this;if(!this._resizeSash){this._resizeSash=this._disposables.add(new n.Sash(this.domNode,this,{orientation:1})),this.options.isResizeable||(this._resizeSash.hide(),this._resizeSash.state=0);var t;this._disposables.add(this._resizeSash.onDidStart(function(i){e._viewZone&&(t={startY:i.startY,heightInLines:e._viewZone.heightInLines})})),this._disposables.add(this._resizeSash.onDidEnd(function(){t=void 0})),this._disposables.add(this._resizeSash.onDidChange(function(i){if(t){var n=(i.currentY-t.startY)/e.editor.getConfiguration().lineHeight,o=n<0?Math.ceil(n):Math.floor(n),r=t.heightInLines+o;r>5&&r<35&&e._relayout(r)}}))}},
e.prototype.getHorizontalSashLeft=function(){return 0},e.prototype.getHorizontalSashTop=function(){return(null===this.domNode.style.height?0:parseInt(this.domNode.style.height))-this._decoratingElementsHeight()/2},e.prototype.getHorizontalSashWidth=function(){var e=this.editor.getLayoutInfo();return e.width-e.minimapWidth},e}();t.ZoneWidget=g}),define(t[195],i([1,0,106,17,63,181]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e){this._maxCacheDepth=e,this._entries=Object.create(null)}return e.create=function(e,t){return this._INSTANCE.create(e,t)},e.prototype.create=function(e,t){if(null!==e&&e.depth>=this._maxCacheDepth)return new a(e,t);var i=a.getStackElementId(e);i.length>0&&(i+="|"),i+=t;var n=this._entries[i];return n||(n=new a(e,t),this._entries[i]=n,n)},e._INSTANCE=new e(5),e}(),a=function(){function e(e,t){this.parent=e,this.state=t,this.depth=(this.parent?this.parent.depth:0)+1}return e.getStackElementId=function(e){
for(var t="";null!==e;)t.length>0&&(t+="|"),t+=e.state,e=e.parent;return t},e._equals=function(e,t){for(;null!==e&&null!==t;){if(e===t)return!0;if(e.state!==t.state)return!1;e=e.parent,t=t.parent}return null===e&&null===t},e.prototype.equals=function(t){return e._equals(this,t)},e.prototype.push=function(e){return s.create(this,e)},e.prototype.pop=function(){return this.parent},e.prototype.popall=function(){for(var e=this;e.parent;)e=e.parent;return e},e.prototype.switchTo=function(e){return s.create(this.parent,e)},e}(),l=function(){function e(e,t){this.modeId=e,this.state=t}return e.prototype.equals=function(e){return this.modeId===e.modeId&&this.state.equals(e.state)},e.prototype.clone=function(){return this.state.clone()===this.state?this:new e(this.modeId,this.state)},e}(),u=function(){function e(e){this._maxCacheDepth=e,this._entries=Object.create(null)}return e.create=function(e,t){return this._INSTANCE.create(e,t)},e.prototype.create=function(e,t){if(null!==t)return new d(e,t)
;if(null!==e&&e.depth>=this._maxCacheDepth)return new d(e,t);var i=a.getStackElementId(e),n=this._entries[i];return n||(n=new d(e,null),this._entries[i]=n,n)},e._INSTANCE=new e(5),e}(),d=function(){function e(e,t){this.stack=e,this.embeddedModeData=t}return e.prototype.clone=function(){return(this.embeddedModeData?this.embeddedModeData.clone():null)===this.embeddedModeData?this:u.create(this.stack,this.embeddedModeData)},e.prototype.equals=function(t){return t instanceof e&&(!!this.stack.equals(t.stack)&&(null===this.embeddedModeData&&null===t.embeddedModeData||null!==this.embeddedModeData&&null!==t.embeddedModeData&&this.embeddedModeData.equals(t.embeddedModeData)))},e}(),c=function(){function e(){this._tokens=[],this._language=null,this._lastTokenType=null,this._lastTokenLanguage=null}return e.prototype.enterMode=function(e,t){this._language=t},e.prototype.emit=function(e,t){this._lastTokenType===t&&this._lastTokenLanguage===this._language||(this._lastTokenType=t,this._lastTokenLanguage=this._language,
this._tokens.push(new i.Token(e,t,this._language)))},e.prototype.nestedModeTokenize=function(e,t,i){var o=t.modeId,r=t.state,s=n.TokenizationRegistry.get(o);if(!s)return this.enterMode(i,o),this.emit(i,""),r;var a=s.tokenize(e,r,i);return this._tokens=this._tokens.concat(a.tokens),this._lastTokenType=null,this._lastTokenLanguage=null,this._language=null,a.endState},e.prototype.finalize=function(e){return new i.TokenizationResult(this._tokens,e)},e}(),h=function(){function e(e,t){this._modeService=e,this._theme=t,this._prependTokens=null,this._tokens=[],this._currentLanguageId=0,this._lastTokenMetadata=0}return e.prototype.enterMode=function(e,t){this._currentLanguageId=this._modeService.getLanguageIdentifier(t).id},e.prototype.emit=function(e,t){var i=this._theme.match(this._currentLanguageId,t);this._lastTokenMetadata!==i&&(this._lastTokenMetadata=i,this._tokens.push(e),this._tokens.push(i))},e._merge=function(e,t,i){var n=null!==e?e.length:0,o=t.length,r=null!==i?i.length:0
;if(0===n&&0===o&&0===r)return new Uint32Array(0);if(0===n&&0===o)return i;if(0===o&&0===r)return e;var s=new Uint32Array(n+o+r);null!==e&&s.set(e);for(var a=0;a<o;a++)s[n+a]=t[a];return null!==i&&s.set(i,n+o),s},e.prototype.nestedModeTokenize=function(t,i,o){var r=i.modeId,s=i.state,a=n.TokenizationRegistry.get(r);if(!a)return this.enterMode(o,r),this.emit(o,""),s;var l=a.tokenize2(t,s,o);return this._prependTokens=e._merge(this._prependTokens,this._tokens,l.tokens),this._tokens=[],this._currentLanguageId=0,this._lastTokenMetadata=0,l.endState},e.prototype.finalize=function(t){return new i.TokenizationResult2(e._merge(this._prependTokens,this._tokens,null),t)},e}(),p=function(){function e(e,t,i,o){var r=this;this._modeService=e,this._standaloneThemeService=t,this._modeId=i,this._lexer=o,this._embeddedModes=Object.create(null),this.embeddedLoaded=Promise.resolve(void 0);var s=!1;this._tokenizationRegistryListener=n.TokenizationRegistry.onDidChange(function(e){if(!s){
for(var t=!1,i=0,o=e.changedLanguages.length;i<o;i++){var a=e.changedLanguages[i];if(r._embeddedModes[a]){t=!0;break}}t&&(s=!0,n.TokenizationRegistry.fire([r._modeId]),s=!1)}})}return e.prototype.dispose=function(){this._tokenizationRegistryListener.dispose()},e.prototype.getLoadStatus=function(){var t=[];for(var i in this._embeddedModes)if(this._embeddedModes.hasOwnProperty(i)){var o=n.TokenizationRegistry.get(i);if(o){if(o instanceof e){var r=o.getLoadStatus();!1===r.loaded&&t.push(r.promise)}continue}var s=n.TokenizationRegistry.getPromise(i);s&&t.push(s)}return 0===t.length?{loaded:!0}:{loaded:!1,promise:Promise.all(t).then(function(e){})}},e.prototype.getInitialState=function(){var e=s.create(null,this._lexer.start);return u.create(e,null)},e.prototype.tokenize=function(e,t,i){var n=new c,o=this._tokenize(e,t,i,n);return n.finalize(o)},e.prototype.tokenize2=function(e,t,i){var n=new h(this._modeService,this._standaloneThemeService.getTheme().tokenTheme),o=this._tokenize(e,t,i,n);return n.finalize(o)},
e.prototype._tokenize=function(e,t,i,n){return t.embeddedModeData?this._nestedTokenize(e,t,i,n):this._myTokenize(e,t,i,n)},e.prototype._findLeavingNestedModeOffset=function(e,t){var i=this._lexer.tokenizer[t.stack.state];if(!i&&!(i=r.findRules(this._lexer,t.stack.state)))throw r.createError(this._lexer,"tokenizer state is not defined: "+t.stack.state);for(var n=-1,o=!1,s=0,a=i;s<a.length;s++){var l=a[s];if(r.isIAction(l.action)&&"@pop"===l.action.nextEmbedded){o=!0;var u=l.regex,d=l.regex.source;"^(?:"===d.substr(0,4)&&")"===d.substr(d.length-1,1)&&(u=new RegExp(d.substr(4,d.length-5),u.ignoreCase?"i":""));var c=e.search(u);-1!==c&&(-1===n||c<n)&&(n=c)}}if(!o)throw r.createError(this._lexer,'no rule containing nextEmbedded: "@pop" in tokenizer embedded state: '+t.stack.state);return n},e.prototype._nestedTokenize=function(e,t,i,n){var o=this._findLeavingNestedModeOffset(e,t);if(-1===o){var r=n.nestedModeTokenize(e,t.embeddedModeData,i);return u.create(t.stack,new l(t.embeddedModeData.modeId,r))}
var s=e.substring(0,o);s.length>0&&n.nestedModeTokenize(s,t.embeddedModeData,i);var a=e.substring(o);return this._myTokenize(a,t,i+o,n)},e.prototype._safeRuleName=function(e){return e?e.name:"(unknown)"},e.prototype._myTokenize=function(e,t,i,n){n.enterMode(i,this._modeId);for(var o=e.length,s=t.embeddedModeData,a=t.stack,l=0,d=null,c=!0;c||l<o;){var h=l,p=a.depth,f=d?d.groups.length:0,g=a.state,m=null,v=null,_=null,y=null,b=null;if(d){m=d.matches;var C=d.groups.shift();v=C.matched,_=C.action,y=d.rule,0===d.groups.length&&(d=null)}else{if(!c&&l>=o)break;c=!1;var S=this._lexer.tokenizer[g];if(!S&&!(S=r.findRules(this._lexer,g)))throw r.createError(this._lexer,"tokenizer state is not defined: "+g);for(var w=e.substr(l),E=0,L=S;E<L.length;E++){var x=L[E];if((0===l||!x.matchOnlyAtLineStart)&&(m=w.match(x.regex))){v=m[0],_=x.action;break}}}if(m||(m=[""],v=""),_||(l<o&&(v=(m=[e.charAt(l)])[0]),_=this._lexer.defaultToken),null===v)break
;for(l+=v.length;r.isFuzzyAction(_)&&r.isIAction(_)&&_.test;)_=_.test(v,m,g,l===o);var D=null;if("string"==typeof _||Array.isArray(_))D=_;else if(_.group)D=_.group;else if(null!==_.token&&void 0!==_.token){if(D=_.tokenSubst?r.substituteMatches(this._lexer,_.token,v,m,g):_.token,_.nextEmbedded)if("@pop"===_.nextEmbedded){if(!s)throw r.createError(this._lexer,"cannot pop embedded mode if not inside one");s=null}else{if(s)throw r.createError(this._lexer,"cannot enter embedded mode from within an embedded mode");b=r.substituteMatches(this._lexer,_.nextEmbedded,v,m,g)}if(_.goBack&&(l=Math.max(0,l-_.goBack)),_.switchTo&&"string"==typeof _.switchTo){if("@"===(I=r.substituteMatches(this._lexer,_.switchTo,v,m,g))[0]&&(I=I.substr(1)),!r.findRules(this._lexer,I))throw r.createError(this._lexer,"trying to switch to a state '"+I+"' that is undefined in rule: "+this._safeRuleName(y));a=a.switchTo(I)}else{if(_.transform&&"function"==typeof _.transform)throw r.createError(this._lexer,"action.transform not supported")
;if(_.next)if("@push"===_.next){if(a.depth>=this._lexer.maxStack)throw r.createError(this._lexer,"maximum tokenizer stack size reached: ["+a.state+","+a.parent.state+",...]");a=a.push(g)}else if("@pop"===_.next){if(a.depth<=1)throw r.createError(this._lexer,"trying to pop an empty stack in rule: "+this._safeRuleName(y));a=a.pop()}else if("@popall"===_.next)a=a.popall();else{var I=r.substituteMatches(this._lexer,_.next,v,m,g);if("@"===I[0]&&(I=I.substr(1)),!r.findRules(this._lexer,I))throw r.createError(this._lexer,"trying to set a next state '"+I+"' that is undefined in rule: "+this._safeRuleName(y));a=a.push(I)}}_.log&&"string"==typeof _.log&&r.log(this._lexer,this._lexer.languageId+": "+r.substituteMatches(this._lexer,_.log,v,m,g))}if(null===D)throw r.createError(this._lexer,"lexer rule has no well-defined action in rule: "+this._safeRuleName(y));if(Array.isArray(D)){if(d&&d.groups.length>0)throw r.createError(this._lexer,"groups cannot be nested: "+this._safeRuleName(y))
;if(m.length!==D.length+1)throw r.createError(this._lexer,"matched number of groups does not match the number of actions in rule: "+this._safeRuleName(y));for(var N=0,M=1;M<m.length;M++)N+=m[M].length;if(N!==v.length)throw r.createError(this._lexer,"with groups, all characters should be matched in consecutive groups in rule: "+this._safeRuleName(y));d={rule:y,matches:m,groups:[]};for(M=0;M<D.length;M++)d.groups[M]={action:D[M],matched:m[M+1]};l-=v.length}else{if("@rematch"===D&&(l-=v.length,v="",m=null,D=""),0===v.length){if(0===o||p!==a.depth||g!==a.state||(d?d.groups.length:0)!==f)continue;throw r.createError(this._lexer,"no progress in tokenizer in rule: "+this._safeRuleName(y))}var k=null;if(r.isString(D)&&0===D.indexOf("@brackets")){var T=D.substr("@brackets".length),R=function(e,t){if(!t)return null;t=r.fixCase(e,t);for(var i=0,n=e.brackets;i<n.length;i++){var o=n[i];if(o.open===t)return{token:o.token,bracketType:1};if(o.close===t)return{token:o.token,bracketType:-1}}return null}(this._lexer,v)
;if(!R)throw r.createError(this._lexer,"@brackets token returned but no bracket defined as: "+v);k=r.sanitize(R.token+T)}else{var O=""===D?"":D+this._lexer.tokenPostfix;k=r.sanitize(O)}if(n.emit(h+i,k),null!==b){var P=this._modeService.getModeIdForLanguageName(b);P&&(b=P);var A=this._getNestedEmbeddedModeData(b);if(l<o){w=e.substr(l);return this._nestedTokenize(w,u.create(a,A),i+l,n)}return u.create(a,A)}}}return u.create(a,s)},e.prototype._getNestedEmbeddedModeData=function(e){var t=this._locateMode(e);if(t){var i=n.TokenizationRegistry.get(t);if(i)return new l(t,i.getInitialState())}return new l(t||o.NULL_MODE_ID,o.NULL_STATE)},e.prototype._locateMode=function(e){if(!e||!this._modeService.isRegisteredMode(e))return null;if(e===this._modeId)return e;var t=this._modeService.getModeId(e);return t&&(this._modeService.triggerMode(t),this._embeddedModes[t]=!0),t},e}();t.MonarchTokenizer=p,t.createTokenizationSupport=function(e,t,i,n){return new p(e,t,i,n)}}),
define(t[415],i([1,0,15,5,87,17,94,67,195]),function(e,t,i,n,o,r,s,a,l){"use strict";function u(e,t,i){return new Promise(function(n,r){var u=function(){var d=function(e,t,i){for(var n=[],r=i.getInitialState(),l=0,u=e.length;l<u;l++){var d=e[l],c=i.tokenize2(d,r,0);o.LineTokens.convertToEndOffset(c.tokens,d.length);var h=new o.LineTokens(c.tokens,d),p=a.ViewLineRenderingData.isBasicASCII(d,!0),f=a.ViewLineRenderingData.containsRTL(d,p,!0),g=s.renderViewLine2(new s.RenderLineInput(!1,!0,d,!1,p,f,0,h.inflate(),[],t,0,-1,"none",!1,!1,null));(n=n.concat(g.html)).push("<br/>"),r=c.endState}return n.join("")}(e,t,i);if(i instanceof l.MonarchTokenizer){var c=i.getLoadStatus();if(!1===c.loaded)return void c.promise.then(u,r)}n(d)};u()})}function d(e,t){var i=[],n=new Uint32Array(2);n[0]=0,n[1]=16793600;for(var r=0,l=e.length;r<l;r++){var u=e[r];n[0]=u.length
;var d=new o.LineTokens(n,u),c=a.ViewLineRenderingData.isBasicASCII(u,!0),h=a.ViewLineRenderingData.containsRTL(u,c,!0),p=s.renderViewLine2(new s.RenderLineInput(!1,!0,u,!1,c,h,0,d,[],t,0,-1,"none",!1,!1,null));(i=i.concat(p.html)).push("<br/>")}return i.join("")}Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(){}return e.colorizeElement=function(e,t,i,n){var o=(n=n||{}).theme||"vs",r=n.mimeType||i.getAttribute("lang")||i.getAttribute("data-lang");if(!r)return console.error("Mode not detected"),Promise.resolve();e.setTheme(o);var s=i.firstChild?i.firstChild.nodeValue:"";i.className+=" "+o;return this.colorize(t,s||"",r,n).then(function(e){i.innerHTML=e},function(e){return console.error(e)})},e.colorize=function(e,t,o,s){var a=4;s&&"number"==typeof s.tabSize&&(a=s.tabSize),n.startsWithUTF8BOM(t)&&(t=t.substr(1));var l=t.split(/\r\n|\r|\n/),c=e.getModeId(o);if(!c)return Promise.resolve(d(l,a));e.triggerMode(c);var h=r.TokenizationRegistry.get(c);if(h)return u(l,a,h)
;var p=r.TokenizationRegistry.getPromise(c);return p?new Promise(function(e,t){p.then(function(i){u(l,a,i).then(e,t)},t)}):new Promise(function(e,t){var n=null,o=null,s=function(){n&&(n.dispose(),n=null),o&&(o.dispose(),o=null);var i=r.TokenizationRegistry.get(c);i?u(l,a,i).then(e,t):e(d(l,a))};(o=new i.TimeoutTimer).cancelAndSet(s,500),n=r.TokenizationRegistry.onDidChange(function(e){e.changedLanguages.indexOf(c)>=0&&s()})})},e.colorizeLine=function(e,t,i,n,o){void 0===o&&(o=4);var r=a.ViewLineRenderingData.isBasicASCII(e,t),l=a.ViewLineRenderingData.containsRTL(e,r,i);return s.renderViewLine2(new s.RenderLineInput(!1,!0,e,!1,r,l,0,n,[],o,0,-1,"none",!1,!1,null)).html},e.colorizeModelLine=function(e,t,i){void 0===i&&(i=4);var n=e.getLineContent(t);e.forceTokenization(t);var o=e.getLineTokens(t).inflate();return this.colorizeLine(n,e.mightContainNonBasicASCII(),e.mightContainRTL(),o,i)},e}();t.Colorizer=c}),define(t[91],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.IStandaloneThemeService=i.createDecorator("themeService")}),define(t[134],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IClipboardService=i.createDecorator("clipboardService")}),define(t[32],i([1,0,2,23,12,4,75,41]),function(e,t,i,n,o,r,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ICommandService=o.createDecorator("commandService"),t.CommandsRegistry=new(function(){function e(){this._commands=new Map,this._onDidRegisterCommand=new r.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}return e.prototype.registerCommand=function(e,t){var o=this;if(!e)throw new Error("invalid command");if("string"==typeof e){if(!t)throw new Error("invalid command");return this.registerCommand({id:e,handler:t})}if(e.description){for(var r=[],a=0,l=e.description.args;a<l.length;a++){var u=l[a];r.push(u.constraint)}var d=e.handler;e.handler=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];return n.validateConstraints(t,r),
d.apply(void 0,[e].concat(t))}}var c=e.id,h=this._commands.get(c);h||(h=new s.LinkedList,this._commands.set(c,h));var p=h.unshift(e),f=i.toDisposable(function(){p();var e=o._commands.get(c);e&&e.isEmpty()&&o._commands.delete(c)});return this._onDidRegisterCommand.fire(c),f},e.prototype.registerCommandAlias=function(e,i){return t.CommandsRegistry.registerCommand(e,function(e){for(var n,o=[],r=1;r<arguments.length;r++)o[r-1]=arguments[r];return(n=e.get(t.ICommandService)).executeCommand.apply(n,[i].concat(o))})},e.prototype.getCommand=function(e){var t=this._commands.get(e);if(t&&!t.isEmpty())return t.iterator().next().value},e.prototype.getCommands=function(){for(var e=new Map,t=0,i=a.keys(this._commands);t<i.length;t++){var n=i[t],o=this.getCommand(n);o&&e.set(n,o)}return e},e}())});var c=this&&this.__param||function(e,t){return function(i,n){t(i,n,e)}};define(t[419],i([1,0,8,2,75,205,50,48,5,31,32]),function(e,t,i,n,o,s,u,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var m=function(e){function t(t,i){var n=e.call(this)||this;return n._editorService=t,n._commandService=i,n._openers=new o.LinkedList,n._validators=new o.LinkedList,n}return r(t,e),t.prototype.open=function(e,t){return a(this,void 0,void 0,function(){var i,n,o,r,s,a,u;return l(this,function(l){switch(l.label){case 0:if(!e.scheme)return[2,Promise.resolve(!1)];i=0,n=this._validators.toArray(),l.label=1;case 1:return i<n.length?(o=n[i],[4,o.shouldOpen(e)]):[3,4];case 2:if(!l.sent())return[2,!1];l.label=3;case 3:return i++,[3,1];case 4:r=0,s=this._openers.toArray(),l.label=5;case 5:return r<s.length?(a=s[r],[4,a.open(e,t)]):[3,8];case 6:if(u=l.sent())return[2,!0];l.label=7;case 7:return r++,[3,5];case 8:return[2,this._doOpen(e,t)]}})})},t.prototype._doOpen=function(e,t){var i,n=e.scheme,o=e.path,r=e.query,a=e.fragment;if(p.equalsIgnoreCase(n,u.Schemas.mailto)||t&&t.openExternal)return this._doOpenExternal(e)
;if(p.equalsIgnoreCase(n,u.Schemas.http)||p.equalsIgnoreCase(n,u.Schemas.https))return this._doOpenExternal(e);if(p.equalsIgnoreCase(n,u.Schemas.command)){if(!g.CommandsRegistry.getCommand(o))return Promise.reject("command '"+o+"' NOT known");var l=[];try{l=s.parse(r),Array.isArray(l)||(l=[l])}catch(e){}return(i=this._commandService).executeCommand.apply(i,[o].concat(l)).then(function(){return!0})}var d=void 0,c=/^L?(\d+)(?:,(\d+))?/.exec(a);return c&&(d={startLineNumber:parseInt(c[1]),startColumn:c[2]?parseInt(c[2]):1},e=e.with({fragment:""})),e.scheme===u.Schemas.file&&(e=h.normalizePath(e)),this._editorService.openCodeEditor({resource:e,options:{selection:d}},this._editorService.getFocusedCodeEditor(),t&&t.openToSide).then(function(){return!0})},t.prototype._doOpenExternal=function(e){return i.windowOpenNoOpener(encodeURI(e.toString(!0))),Promise.resolve(!0)},t.prototype.dispose=function(){this._validators.clear()},t=d([c(0,f.ICodeEditorService),c(1,g.ICommandService)],t)}(n.Disposable);t.OpenerService=m
}),define(t[420],i([1,0,26,10,24,3,17,42,32,2,19]),function(e,t,i,n,o,s,u,d,c,h,p){"use strict";function f(e,t){var i=[],o=u.LinkProviderRegistry.ordered(e).reverse().map(function(o,r){return Promise.resolve(o.provideLinks(e,t)).then(function(e){e&&(i[r]=[e,o])},n.onUnexpectedExternalError)});return Promise.all(o).then(function(){var e=new v(p.coalesce(i));return t.isCancellationRequested?(e.dispose(),new v([])):e})}var g=this;Object.defineProperty(t,"__esModule",{value:!0});var m=function(){function e(e,t){this._link=e,this._provider=t}return e.prototype.toJSON=function(){return{range:this.range,url:this.url,tooltip:this.tooltip}},Object.defineProperty(e.prototype,"range",{get:function(){return this._link.range},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"url",{get:function(){return this._link.url},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"tooltip",{get:function(){return this._link.tooltip},enumerable:!0,configurable:!0}),e.prototype.resolve=function(e){
var t=this;if(this._link.url)try{return"string"==typeof this._link.url?Promise.resolve(o.URI.parse(this._link.url)):Promise.resolve(this._link.url)}catch(e){return Promise.reject(new Error("invalid"))}return"function"==typeof this._provider.resolveLink?Promise.resolve(this._provider.resolveLink(this._link,e)).then(function(i){return t._link=i||t._link,t._link.url?t.resolve(e):Promise.reject(new Error("missing"))}):Promise.reject(new Error("missing"))},e}();t.Link=m;var v=function(e){function t(i){for(var n=e.call(this)||this,o=[],r=function(e,i){var n=e.links.map(function(e){return new m(e,i)});o=t._union(o,n),h.isDisposable(i)&&s._register(i)},s=this,a=0,l=i;a<l.length;a++){var u=l[a];r(u[0],u[1])}return n.links=o,n}return r(t,e),t._union=function(e,t){var i,n,o,r,a=[];for(i=0,o=0,n=e.length,r=t.length;i<n&&o<r;){var l=e[i],u=t[o];if(s.Range.areIntersectingOrTouching(l.range,u.range))i++;else{s.Range.compareRangesUsingStarts(l.range,u.range)<0?(a.push(l),i++):(a.push(u),o++)}}for(;i<n;i++)a.push(e[i])
;for(;o<r;o++)a.push(t[o]);return a},t}(h.Disposable);t.LinksList=v,t.getLinks=f,c.CommandsRegistry.registerCommand("_executeLinkProvider",function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return a(g,void 0,void 0,function(){var n,r,s,a;return l(this,function(l){switch(l.label){case 0:return(n=t[0])instanceof o.URI&&(r=e.get(d.IModelService).getModel(n))?[4,f(r,i.CancellationToken.None)]:[2,[]];case 1:return(s=l.sent())?(a=s.links.slice(0),s.dispose(),[2,a]):[2,[]]}})})})}),define(t[14],i([1,0,5,12]),function(e,t,i,n){"use strict";function o(e,t){var i=e.getType(),n=t.getType();if(i!==n)return i-n;switch(i){case 1:case 2:case 3:case 4:case 6:case 7:case 5:return e.cmp(t);default:throw new Error("Unknown ContextKeyExpr!")}}Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(){}return e.has=function(e){return a.create(e)},e.equals=function(e,t){return l.create(e,t)},e.regex=function(e,t){return c.create(e,t)},e.not=function(e){return d.create(e)},e.and=function(){
for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return p.create(e)},e.or=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return f.create(e)},e.deserialize=function(e,t){if(void 0===t&&(t=!1),e)return this._deserializeOrExpression(e,t)},e._deserializeOrExpression=function(e,t){var i=this,n=e.split("||");return f.create(n.map(function(e){return i._deserializeAndExpression(e,t)}))},e._deserializeAndExpression=function(e,t){var i=this,n=e.split("&&");return p.create(n.map(function(e){return i._deserializeOne(e,t)}))},e._deserializeOne=function(e,t){if((e=e.trim()).indexOf("!=")>=0){i=e.split("!=");return u.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("==")>=0){i=e.split("==");return l.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("=~")>=0){var i=e.split("=~");return c.create(i[0].trim(),this._deserializeRegexValue(i[1],t))}return/^\!\s*/.test(e)?d.create(e.substr(1).trim()):a.create(e)},e._deserializeValue=function(e,t){
if("true"===(e=e.trim()))return!0;if("false"===e)return!1;var i=/^'([^']*)'$/.exec(e);return i?i[1].trim():e},e._deserializeRegexValue=function(e,t){if(i.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}var n=e.indexOf("/"),o=e.lastIndexOf("/");if(n===o||n<0){if(t)throw new Error("bad regexp-value '"+e+"', missing /-enclosure");return console.warn("bad regexp-value '"+e+"', missing /-enclosure"),null}var r=e.slice(n+1,o),s="i"===e[o+1]?"i":"";try{return new RegExp(r,s)}catch(i){if(t)throw new Error("bad regexp-value '"+e+"', parse error: "+i);return console.warn("bad regexp-value '"+e+"', parse error: "+i),null}},e}();t.ContextKeyExpr=s;var a=function(){function e(e){this.key=e}return e.create=function(t){return new e(t)},e.prototype.getType=function(){return 1},e.prototype.cmp=function(e){return this.key<e.key?-1:this.key>e.key?1:0},e.prototype.equals=function(t){return t instanceof e&&this.key===t.key},
e.prototype.evaluate=function(e){return!!e.getValue(this.key)},e.prototype.keys=function(){return[this.key]},e.prototype.negate=function(){return d.create(this.key)},e}();t.ContextKeyDefinedExpr=a;var l=function(){function e(e,t){this.key=e,this.value=t}return e.create=function(t,i){return"boolean"==typeof i?i?a.create(t):d.create(t):new e(t,i)},e.prototype.getType=function(){return 3},e.prototype.cmp=function(e){return this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0},e.prototype.equals=function(t){return t instanceof e&&(this.key===t.key&&this.value===t.value)},e.prototype.evaluate=function(e){return e.getValue(this.key)==this.value},e.prototype.keys=function(){return[this.key]},e.prototype.negate=function(){return u.create(this.key,this.value)},e}();t.ContextKeyEqualsExpr=l;var u=function(){function e(e,t){this.key=e,this.value=t}return e.create=function(t,i){return"boolean"==typeof i?i?d.create(t):a.create(t):new e(t,i)},e.prototype.getType=function(){return 4},
e.prototype.cmp=function(e){return this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0},e.prototype.equals=function(t){return t instanceof e&&(this.key===t.key&&this.value===t.value)},e.prototype.evaluate=function(e){return e.getValue(this.key)!=this.value},e.prototype.keys=function(){return[this.key]},e.prototype.negate=function(){return l.create(this.key,this.value)},e}();t.ContextKeyNotEqualsExpr=u;var d=function(){function e(e){this.key=e}return e.create=function(t){return new e(t)},e.prototype.getType=function(){return 2},e.prototype.cmp=function(e){return this.key<e.key?-1:this.key>e.key?1:0},e.prototype.equals=function(t){return t instanceof e&&this.key===t.key},e.prototype.evaluate=function(e){return!e.getValue(this.key)},e.prototype.keys=function(){return[this.key]},e.prototype.negate=function(){return a.create(this.key)},e}();t.ContextKeyNotExpr=d;var c=function(){function e(e,t){this.key=e,this.regexp=t}return e.create=function(t,i){return new e(t,i)},
e.prototype.getType=function(){return 6},e.prototype.cmp=function(e){if(this.key<e.key)return-1;if(this.key>e.key)return 1;var t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return t<i?-1:t>i?1:0},e.prototype.equals=function(t){if(t instanceof e){var i=this.regexp?this.regexp.source:"",n=t.regexp?t.regexp.source:"";return this.key===t.key&&i===n}return!1},e.prototype.evaluate=function(e){var t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)},e.prototype.keys=function(){return[this.key]},e.prototype.negate=function(){return h.create(this)},e}();t.ContextKeyRegexExpr=c;var h=function(){function e(e){this._actual=e}return e.create=function(t){return new e(t)},e.prototype.getType=function(){return 7},e.prototype.cmp=function(e){return this._actual.cmp(e._actual)},e.prototype.equals=function(t){return t instanceof e&&this._actual.equals(t._actual)},e.prototype.evaluate=function(e){return!this._actual.evaluate(e)},e.prototype.keys=function(){return this._actual.keys()},
e.prototype.negate=function(){return this._actual},e}();t.ContextKeyNotRegexExpr=h;var p=function(){function e(e){this.expr=e}return e.create=function(t){var i=e._normalizeArr(t);if(0!==i.length)return 1===i.length?i[0]:new e(i)},e.prototype.getType=function(){return 5},e.prototype.cmp=function(e){if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(var t=0,i=this.expr.length;t<i;t++){var n=o(this.expr[t],e.expr[t]);if(0!==n)return n}return 0},e.prototype.equals=function(t){if(t instanceof e){if(this.expr.length!==t.expr.length)return!1;for(var i=0,n=this.expr.length;i<n;i++)if(!this.expr[i].equals(t.expr[i]))return!1;return!0}return!1},e.prototype.evaluate=function(e){for(var t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].evaluate(e))return!1;return!0},e._normalizeArr=function(t){var i=[];if(t){for(var n=0,r=t.length;n<r;n++){var s=t[n];if(s)if(s instanceof e)i=i.concat(s.expr);else{
if(s instanceof f)throw new Error("It is not allowed to have an or expression here due to lack of parens!");i.push(s)}}i.sort(o)}return i},e.prototype.keys=function(){for(var e=[],t=0,i=this.expr;t<i.length;t++){var n=i[t];e.push.apply(e,n.keys())}return e},e.prototype.negate=function(){for(var e=[],t=0,i=this.expr;t<i.length;t++){var n=i[t];e.push(n.negate())}return f.create(e)},e}();t.ContextKeyAndExpr=p;var f=function(){function e(e){this.expr=e}return e.create=function(t){var i=e._normalizeArr(t);if(0!==i.length)return 1===i.length?i[0]:new e(i)},e.prototype.getType=function(){return 8},e.prototype.equals=function(t){if(t instanceof e){if(this.expr.length!==t.expr.length)return!1;for(var i=0,n=this.expr.length;i<n;i++)if(!this.expr[i].equals(t.expr[i]))return!1;return!0}return!1},e.prototype.evaluate=function(e){for(var t=0,i=this.expr.length;t<i;t++)if(this.expr[t].evaluate(e))return!0;return!1},e._normalizeArr=function(t){var i=[];if(t){for(var n=0,r=t.length;n<r;n++){var s=t[n]
;s&&(s instanceof e?i=i.concat(s.expr):i.push(s))}i.sort(o)}return i},e.prototype.keys=function(){for(var e=[],t=0,i=this.expr;t<i.length;t++){var n=i[t];e.push.apply(e,n.keys())}return e},e.prototype.negate=function(){for(var t=[],i=0,n=this.expr;i<n.length;i++){var o=n[i];t.push(o.negate())}for(var r=function(t){return t instanceof e?t.expr:[t]};t.length>1;){for(var a=t.shift(),l=t.shift(),u=[],d=0,c=r(a);d<c.length;d++)for(var h=c[d],p=0,f=r(l);p<f.length;p++){var g=f[p];u.push(s.and(h,g))}t.unshift(s.or.apply(s,u))}return t[0]},e}();t.ContextKeyOrExpr=f;var g=function(e){function t(t,i){var n=e.call(this,t)||this;return n._defaultValue=i,n}return r(t,e),t.prototype.bindTo=function(e){return e.createKey(this.key,this._defaultValue)},t.prototype.getValue=function(e){return e.getContextKeyValue(this.key)},t.prototype.toNegated=function(){return s.not(this.key)},t}(a);t.RawContextKey=g,t.IContextKeyService=n.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"}),
define(t[21],i([1,0,14]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e.editorTextFocus=new i.RawContextKey("editorTextFocus",!1),e.focus=new i.RawContextKey("editorFocus",!1),e.textInputFocus=new i.RawContextKey("textInputFocus",!1),e.readOnly=new i.RawContextKey("editorReadonly",!1),e.writable=e.readOnly.toNegated(),e.hasNonEmptySelection=new i.RawContextKey("editorHasSelection",!1),e.hasOnlyEmptySelection=e.hasNonEmptySelection.toNegated(),e.hasMultipleSelections=new i.RawContextKey("editorHasMultipleSelections",!1),e.hasSingleSelection=e.hasMultipleSelections.toNegated(),e.tabMovesFocus=new i.RawContextKey("editorTabMovesFocus",!1),e.tabDoesNotMoveFocus=e.tabMovesFocus.toNegated(),e.isInEmbeddedEditor=new i.RawContextKey("isInEmbeddedEditor",!1),e.canUndo=new i.RawContextKey("canUndo",!1),e.canRedo=new i.RawContextKey("canRedo",!1),e.languageId=new i.RawContextKey("editorLangId",""),
e.hasCompletionItemProvider=new i.RawContextKey("editorHasCompletionItemProvider",!1),e.hasCodeActionsProvider=new i.RawContextKey("editorHasCodeActionsProvider",!1),e.hasCodeLensProvider=new i.RawContextKey("editorHasCodeLensProvider",!1),e.hasDefinitionProvider=new i.RawContextKey("editorHasDefinitionProvider",!1),e.hasDeclarationProvider=new i.RawContextKey("editorHasDeclarationProvider",!1),e.hasImplementationProvider=new i.RawContextKey("editorHasImplementationProvider",!1),e.hasTypeDefinitionProvider=new i.RawContextKey("editorHasTypeDefinitionProvider",!1),e.hasHoverProvider=new i.RawContextKey("editorHasHoverProvider",!1),e.hasDocumentHighlightProvider=new i.RawContextKey("editorHasDocumentHighlightProvider",!1),e.hasDocumentSymbolProvider=new i.RawContextKey("editorHasDocumentSymbolProvider",!1),e.hasReferenceProvider=new i.RawContextKey("editorHasReferenceProvider",!1),e.hasRenameProvider=new i.RawContextKey("editorHasRenameProvider",!1),
e.hasSignatureHelpProvider=new i.RawContextKey("editorHasSignatureHelpProvider",!1),e.hasDocumentFormattingProvider=new i.RawContextKey("editorHasDocumentFormattingProvider",!1),e.hasDocumentSelectionFormattingProvider=new i.RawContextKey("editorHasDocumentSelectionFormattingProvider",!1),e.hasMultipleDocumentFormattingProvider=new i.RawContextKey("editorHasMultipleDocumentFormattingProvider",!1),e.hasMultipleDocumentSelectionFormattingProvider=new i.RawContextKey("editorHasMultipleDocumentSelectionFormattingProvider",!1)}(t.EditorContextKeys||(t.EditorContextKeys={}))}),define(t[423],i([1,0,2,14]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(t,i){this._editor=t,this._index=0,this._ckOtherSuggestions=e.OtherSuggestions.bindTo(i)}return e.prototype.dispose=function(){this.reset()},e.prototype.reset=function(){this._ckOtherSuggestions.reset(),i.dispose(this._listener),this._model=void 0,this._acceptNext=void 0,this._ignore=!1},
e.prototype.set=function(t,i){var n=this,o=t.model,r=t.index;if(0!==o.items.length){e._moveIndex(!0,o,r)!==r?(this._acceptNext=i,this._model=o,this._index=r,this._listener=this._editor.onDidChangeCursorPosition(function(){n._ignore||n.reset()}),this._ckOtherSuggestions.set(!0)):this.reset()}else this.reset()},e._moveIndex=function(e,t,i){for(var n=i;;){if((n=(n+t.items.length+(e?1:-1))%t.items.length)===i)break;if(!t.items[n].completion.additionalTextEdits)break}return n},e.prototype.next=function(){this._move(!0)},e.prototype.prev=function(){this._move(!1)},e.prototype._move=function(t){if(this._model)try{this._ignore=!0,this._index=e._moveIndex(t,this._model,this._index),this._acceptNext({index:this._index,item:this._model.items[this._index],model:this._model})}finally{this._ignore=!1}},e.OtherSuggestions=new n.RawContextKey("hasOtherSuggestions",!1),e=d([c(1,n.IContextKeyService)],e)}();t.SuggestAlternatives=o}),define(t[424],i([1,0,14,2]),function(e,t,i,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(i,n){var o=e.call(this)||this;return o._editor=i,o._enabled=!1,o._ckAtEnd=t.AtEnd.bindTo(n),o._register(o._editor.onDidChangeConfiguration(function(e){return e.contribInfo&&o._update()})),o._update(),o}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),n.dispose(this._selectionListener),this._ckAtEnd.reset()},t.prototype._update=function(){var e=this,t="on"===this._editor.getConfiguration().contribInfo.tabCompletion;if(this._enabled!==t)if(this._enabled=t,this._enabled){var i=function(){if(e._editor.hasModel()){var t=e._editor.getModel(),i=e._editor.getSelection(),n=t.getWordAtPosition(i.getStartPosition());n?e._ckAtEnd.set(n.endColumn===i.getStartPosition().column):e._ckAtEnd.set(!1)}else e._ckAtEnd.set(!1)};this._selectionListener=this._editor.onDidChangeCursorSelection(i),i()}else this._selectionListener&&(this._ckAtEnd.reset(),this._selectionListener.dispose(),this._selectionListener=void 0)},
t.AtEnd=new i.RawContextKey("atEndOfWord",!1),t=d([c(1,i.IContextKeyService)],t)}(n.Disposable);t.WordContextKey=o}),define(t[66],i([1,0,12,14]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IAccessibilityService=i.createDecorator("accessibilityService"),t.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new n.RawContextKey("accessibilityModeEnabled",!1)}),define(t[59],i([1,0,58,12,14,32,4]),function(e,t,i,n,o,s,a){"use strict";function l(e){return void 0!==e.command}Object.defineProperty(t,"__esModule",{value:!0}),t.isIMenuItem=l,t.IMenuService=n.createDecorator("menuService"),t.MenuRegistry=new(function(){function e(){this._commands=new Map,this._menuItems=new Map,this._onDidChangeMenu=new a.Emitter,this.onDidChangeMenu=this._onDidChangeMenu.event}return e.prototype.addCommand=function(e){var t=this;return this._commands.set(e.id,e),this._onDidChangeMenu.fire(0),{dispose:function(){t._commands.delete(e.id)&&t._onDidChangeMenu.fire(0)}}},e.prototype.getCommand=function(e){
return this._commands.get(e)},e.prototype.getCommands=function(){var e=new Map;return this._commands.forEach(function(t,i){return e.set(i,t)}),e},e.prototype.appendMenuItem=function(e,t){var i=this,n=this._menuItems.get(e);return n?n.push(t):(n=[t],this._menuItems.set(e,n)),this._onDidChangeMenu.fire(e),{dispose:function(){var o=n.indexOf(t);o>=0&&(n.splice(o,1),i._onDidChangeMenu.fire(e))}}},e.prototype.getMenuItems=function(e){var t=(this._menuItems.get(e)||[]).slice(0);return 0===e&&this._appendImplicitItems(t),t},e.prototype._appendImplicitItems=function(e){for(var t=new Set,i=0,n=e.filter(function(e){return l(e)});i<n.length;i++){var o=n[i],r=o.command,s=o.alt;t.add(r.id),s&&t.add(s.id)}this._commands.forEach(function(i,n){t.has(n)||e.push({command:i})})},e}());var u=function(e){function t(t,i,n){var o=e.call(this,t,i)||this;return o._commandService=n,o}return r(t,e),t.prototype.run=function(){for(var e,t=[],i=0;i<arguments.length;i++)t[i]=arguments[i]
;return(e=this._commandService).executeCommand.apply(e,[this.id].concat(t))},t=d([c(2,s.ICommandService)],t)}(i.Action);t.ExecuteCommandAction=u;var h=function(e){function t(t){var i=this;return i="string"==typeof t.title?e.call(this,"",t.title,"submenu")||this:e.call(this,"",t.title.value,"submenu")||this,i.item=t,i}return r(t,e),t}(i.Action);t.SubmenuItemAction=h;var p=function(e){function t(i,n,o,r,s){var a=this;return a="string"==typeof i.title?e.call(this,i.id,i.title,s)||this:e.call(this,i.id,i.title.value,s)||this,a._cssClass=void 0,a._enabled=!i.precondition||r.contextMatchesRules(i.precondition),a._checked=Boolean(i.toggled&&r.contextMatchesRules(i.toggled)),a._options=o||{},a.item=i,a.alt=n?new t(n,void 0,a._options,r,s):void 0,a}return r(t,e),t.prototype.dispose=function(){this.alt&&this.alt.dispose(),e.prototype.dispose.call(this)},t.prototype.run=function(){for(var t=[],i=0;i<arguments.length;i++)t[i]=arguments[i];var n=[];return this._options.arg&&(n=n.concat([this._options.arg])),
this._options.shouldForwardArgs&&(n=n.concat(t)),e.prototype.run.apply(this,n)},t=d([c(3,o.IContextKeyService),c(4,s.ICommandService)],t)}(u);t.MenuItemAction=p}),define(t[427],i([1,0,4,2,59,32,14]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(){function e(e){this._commandService=e}return e.prototype.createMenu=function(e,t){return new u(e,this._commandService,t)},e=d([c(0,s.ICommandService)],e)}();t.MenuService=l;var u=function(e){function t(t,n,r){var s=e.call(this)||this;return s._id=t,s._commandService=n,s._contextKeyService=r,s._onDidChange=s._register(new i.Emitter),s._build(),s._register(i.Event.debounce(i.Event.filter(o.MenuRegistry.onDidChangeMenu,function(e){return e===s._id}),function(){},50)(s._build,s)),s._register(i.Event.debounce(s._contextKeyService.onDidChangeContext,function(e,t){return e||t.affectsSome(s._contextKeys)},50)(function(e){return e&&s._onDidChange.fire(void 0)},s)),s}return r(t,e),t.prototype._build=function(){
this._menuGroups=[],this._contextKeys=new Set;var e,i=o.MenuRegistry.getMenuItems(this._id);i.sort(t._compareMenuItems);for(var n=0,r=i;n<r.length;n++){var s=r[n],a=s.group||"";e&&e[0]===a||(e=[a,[]],this._menuGroups.push(e)),e[1].push(s),t._fillInKbExprKeys(s.when,this._contextKeys),o.isIMenuItem(s)&&s.command.precondition&&t._fillInKbExprKeys(s.command.precondition,this._contextKeys),o.isIMenuItem(s)&&s.command.toggled&&t._fillInKbExprKeys(s.command.toggled,this._contextKeys)}this._onDidChange.fire(this)},t.prototype.getActions=function(e){for(var t=[],i=0,n=this._menuGroups;i<n.length;i++){for(var r=n[i],s=r[0],a=[],l=0,u=r[1];l<u.length;l++){var d=u[l];if(this._contextKeyService.contextMatchesRules(d.when)){var c=o.isIMenuItem(d)?new o.MenuItemAction(d.command,d.alt,e,this._contextKeyService,this._commandService):new o.SubmenuItemAction(d);a.push(c)}}a.length>0&&t.push([s,a])}return t},t._fillInKbExprKeys=function(e,t){if(e)for(var i=0,n=e.keys();i<n.length;i++){var o=n[i];t.add(o)}},
t._compareMenuItems=function(e,t){var i=e.group,n=t.group;if(i!==n){if(!i)return 1;if(!n)return-1;if("navigation"===i)return-1;if("navigation"===n)return 1;var o=i.localeCompare(n);if(0!==o)return o}var r=e.order||0,s=t.order||0;if(r<s)return-1;if(r>s)return 1;var a="string"==typeof e.command.title?e.command.title:e.command.title.value,l="string"==typeof t.command.title?t.command.title:t.command.title.value;return a.localeCompare(l)},t=d([c(1,s.ICommandService),c(2,a.IContextKeyService)],t)}(n.Disposable)}),define(t[54],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IContextViewService=i.createDecorator("contextViewService"),t.IContextMenuService=i.createDecorator("contextMenuService")}),define(t[429],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDialogService=i.createDecorator("dialogService")}),define(t[104],i([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){
function e(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];this._entries=new Map;for(var i=0,n=e;i<n.length;i++){var o=n[i],r=o[0],s=o[1];this.set(r,s)}}return e.prototype.set=function(e,t){var i=this._entries.get(e);return this._entries.set(e,t),i},e.prototype.has=function(e){return this._entries.has(e)},e.prototype.get=function(e){return this._entries.get(e)},e}();t.ServiceCollection=i}),define(t[431],i([1,0,10,375,186,12,104,15]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u="function"==typeof Proxy,d=function(e){function t(t){var i=e.call(this,"cyclic dependency between services")||this;return i.message=t.toString(),i}return r(t,e),t}(Error),c=function(){function e(e,t,i){void 0===e&&(e=new a.ServiceCollection),void 0===t&&(t=!1),this._services=e,this._strict=t,this._parent=i,this._services.set(s.IInstantiationService,this)}return e.prototype.createChild=function(t){return new e(t,this._strict,this)},e.prototype.invokeFunction=function(e){
for(var t=this,n=[],o=1;o<arguments.length;o++)n[o-1]=arguments[o];var r=h.traceInvocation(e),a=!1;try{var l={get:function(e,n){if(a)throw i.illegalState("service accessor is only valid during the invocation of its target method");var o=t._getOrCreateServiceInstance(e,r);if(!o&&n!==s.optional)throw new Error("[invokeFunction] unknown service '"+e+"'");return o}};return e.apply(void 0,[l].concat(n))}finally{a=!0,r.stop()}},e.prototype.createInstance=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];var n,r;return e instanceof o.SyncDescriptor?(n=h.traceCreation(e.ctor),r=this._createInstance(e.ctor,e.staticArguments.concat(t),n)):(n=h.traceCreation(e),r=this._createInstance(e,t,n)),n.stop(),r},e.prototype._createInstance=function(e,t,i){void 0===t&&(t=[]);for(var n=s._util.getServiceDependencies(e).sort(function(e,t){return e.index-t.index}),o=[],r=0,a=n;r<a.length;r++){var l=a[r],u=this._getOrCreateServiceInstance(l.id,i)
;if(!u&&this._strict&&!l.optional)throw new Error("[createInstance] "+e.name+" depends on UNKNOWN service "+l.id+".");o.push(u)}var d=n.length>0?n[0].index:t.length;if(t.length!==d){console.warn("[createInstance] First service dependency of "+e.name+" at position "+(d+1)+" conflicts with "+t.length+" static arguments");var c=d-t.length;t=c>0?t.concat(new Array(c)):t.slice(0,d)}return new(e.bind.apply(e,[void 0].concat(t.concat(o))))},e.prototype._setServiceInstance=function(e,t){if(this._services.get(e)instanceof o.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}},e.prototype._getServiceInstanceOrDescriptor=function(e){var t=this._services.get(e);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t},e.prototype._getOrCreateServiceInstance=function(e,t){var i=this._getServiceInstanceOrDescriptor(e)
;return i instanceof o.SyncDescriptor?this._createAndCacheServiceInstance(e,i,t.branch(e,!0)):(t.branch(e,!1),i)},e.prototype._createAndCacheServiceInstance=function(e,t,i){for(var r=new n.Graph(function(e){return e.id.toString()}),a=0,l=[{id:e,desc:t,_trace:i}];l.length;){var u=l.pop();if(r.lookupOrInsertNode(u),a++>100)throw new d(r);for(var c=0,h=s._util.getServiceDependencies(u.desc.ctor);c<h.length;c++){var p=h[c],f=this._getServiceInstanceOrDescriptor(p.id);if(f||p.optional||console.warn("[createInstance] "+e+" depends on "+p.id+" which is NOT registered."),f instanceof o.SyncDescriptor){var g={id:p.id,desc:f,_trace:u._trace.branch(p.id,!0)};r.insertEdge(u,g),l.push(g)}}}for(;;){var m=r.roots();if(0===m.length){if(!r.isEmpty())throw new d(r);break}for(var v=0,_=m;v<_.length;v++){var y=_[v].data,b=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,b),r.removeNode(y)}}
return this._getServiceInstanceOrDescriptor(e)},e.prototype._createServiceInstanceWithOwner=function(e,t,i,n,r){if(void 0===i&&(i=[]),this._services.get(e)instanceof o.SyncDescriptor)return this._createServiceInstance(t,i,n,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,i,n,r);throw new Error("illegalState - creating UNKNOWN service instance")},e.prototype._createServiceInstance=function(e,t,i,n){var o=this;if(void 0===t&&(t=[]),i&&u){var r=new l.IdleValue(function(){return o._createInstance(e,t,n)});return new Proxy(Object.create(null),{get:function(e,t){return r.getValue()[t]},set:function(e,t,i){return r.getValue()[t]=i,!0}})}return this._createInstance(e,t,n)},e}();t.InstantiationService=c;var h=function(){function e(e,t){this.type=e,this.name=t,this._start=Date.now(),this._dep=[]}return e.traceInvocation=function(t){return e._None},e.traceCreation=function(t){return e._None},e.prototype.branch=function(t,i){var n=new e(2,t.toString());return this._dep.push([t,i,n]),n},
e.prototype.stop=function(){function t(e,i){for(var o=[],r=new Array(e+1).join("\t"),s=0,a=i._dep;s<a.length;s++){var l=a[s],u=l[0],d=l[1],c=l[2];if(d&&c){n=!0,o.push(r+"CREATES -> "+u);var h=t(e+1,c);h&&o.push(h)}else o.push(r+"uses -> "+u)}return o.join("\n")}var i=Date.now()-this._start;e._totals+=i;var n=!1,o=[(0===this.type?"CREATE":"CALL")+" "+this.name,""+t(1,this),"DONE, took "+i.toFixed(2)+"ms (grand total "+e._totals.toFixed(2)+"ms)"];(i>2||n)&&console.log(o.join("\n"))},e._None=new(function(e){function t(){return e.call(this,-1,null)||this}return r(t,e),t.prototype.stop=function(){},t.prototype.branch=function(){return this},t}(e)),e._totals=0,e}()}),define(t[432],i([1,0,367,15,4,2]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t,i,r,s){var a=e.call(this)||this;return a._contextKeyService=t,a._commandService=i,a._telemetryService=r,a._notificationService=s,a._onDidUpdateKeybindings=a._register(new o.Emitter),a._currentChord=null,
a._currentChordChecker=new n.IntervalTimer,a._currentChordStatusMessage=null,a}return r(t,e),Object.defineProperty(t.prototype,"onDidUpdateKeybindings",{get:function(){return this._onDidUpdateKeybindings?this._onDidUpdateKeybindings.event:o.Event.None},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.lookupKeybinding=function(e){var t=this._getResolver().lookupPrimaryKeybinding(e);if(t)return t.resolvedKeybinding},t.prototype.softDispatch=function(e,t){var i=this.resolveKeyboardEvent(e);if(i.isChord())return console.warn("Unexpected keyboard event mapped to a chord"),null;var n=i.getDispatchParts()[0];if(null===n)return null;var o=this._contextKeyService.getContext(t),r=this._currentChord?this._currentChord.keypress:null;return this._getResolver().resolve(o,r,n)},t.prototype._enterChordMode=function(e,t){var n=this;this._currentChord={keypress:e,label:t},this._currentChordStatusMessage=this._notificationService.status(i.localize(0,null,t))
;var o=Date.now();this._currentChordChecker.cancelAndSet(function(){n._documentHasFocus()?Date.now()-o>5e3&&n._leaveChordMode():n._leaveChordMode()},500)},t.prototype._leaveChordMode=function(){this._currentChordStatusMessage&&(this._currentChordStatusMessage.dispose(),this._currentChordStatusMessage=null),this._currentChordChecker.cancel(),this._currentChord=null},t.prototype._dispatch=function(e,t){return this._doDispatch(this.resolveKeyboardEvent(e),t)},t.prototype._doDispatch=function(e,t){var n=this,o=!1;if(e.isChord())return console.warn("Unexpected keyboard event mapped to a chord"),!1;var r=e.getDispatchParts()[0];if(null===r)return o;var s=this._contextKeyService.getContext(t),a=this._currentChord?this._currentChord.keypress:null,l=e.getLabel(),u=this._getResolver().resolve(s,a,r);return u&&u.enterChord?(o=!0,this._enterChordMode(r,l),o):(this._currentChord&&(u&&u.commandId||(this._notificationService.status(i.localize(1,null,this._currentChord.label,l),{hideAfter:1e4}),o=!0)),this._leaveChordMode(),
u&&u.commandId&&(u.bubble||(o=!0),void 0===u.commandArgs?this._commandService.executeCommand(u.commandId).then(void 0,function(e){return n._notificationService.warn(e)}):this._commandService.executeCommand(u.commandId,u.commandArgs).then(void 0,function(e){return n._notificationService.warn(e)}),this._telemetryService.publicLog2("workbenchActionExecuted",{id:u.commandId,from:"keybinding"})),o)},t.prototype.mightProducePrintableCharacter=function(e){return!e.ctrlKey&&!e.metaKey&&(e.keyCode>=31&&e.keyCode<=56||e.keyCode>=21&&e.keyCode<=30)},t}(s.Disposable);t.AbstractKeybindingService=a}),define(t[433],i([1,0,10,184,38]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t,n){var o=e.call(this)||this;if(0===n.length)throw i.illegalArgument("parts");return o._os=t,o._parts=n,o}return r(t,e),t.prototype.getLabel=function(){var e=this;return n.UILabelProvider.toLabel(this._os,this._parts,function(t){return e._getLabel(t)})},
t.prototype.getAriaLabel=function(){var e=this;return n.AriaLabelProvider.toLabel(this._os,this._parts,function(t){return e._getAriaLabel(t)})},t.prototype.isChord=function(){return this._parts.length>1},t.prototype.getParts=function(){var e=this;return this._parts.map(function(t){return e._getPart(t)})},t.prototype._getPart=function(e){return new o.ResolvedKeybindingPart(e.ctrlKey,e.shiftKey,e.altKey,e.metaKey,this._getLabel(e),this._getAriaLabel(e))},t.prototype.getDispatchParts=function(){var e=this;return this._parts.map(function(t){return e._getDispatchPart(t)})},t}(o.ResolvedKeybinding);t.BaseResolvedKeybinding=s}),define(t[33],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IKeybindingService=i.createDecorator("keybindingService")}),define(t[435],i([1,0,8,82,4,2,30,326,33,598]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h;!function(e){e.Hidden=new(function(){return function(){this.type=0}}())
;var t=function(){return function(e,t,i){this.actions=e,this.editorPosition=t,this.widgetPosition=i,this.type=1}}();e.Showing=t}(h||(h={}));var p=function(e){function t(t,r,s){var a=e.call(this)||this;return a._editor=t,a._quickFixActionId=r,a._keybindingService=s,a._onClick=a._register(new o.Emitter),a.onClick=a._onClick.event,a._state=h.Hidden,a._domNode=document.createElement("div"),a._domNode.className="lightbulb-glyph",a._editor.addContentWidget(a),a._register(a._editor.onDidChangeModelContent(function(e){var t=a._editor.getModel();(1!==a._state.type||!t||a._state.editorPosition.lineNumber>=t.getLineCount())&&a.hide()})),a._register(i.addStandardDisposableListener(a._domNode,"mousedown",function(e){if(1===a._state.type){a._editor.focus(),e.preventDefault();var t=i.getDomNodePagePosition(a._domNode),n=t.top,o=t.height,r=a._editor.getConfiguration().lineHeight,s=Math.floor(r/3);null!==a._state.widgetPosition.position&&a._state.widgetPosition.position.lineNumber<a._state.editorPosition.lineNumber&&(s+=r),
a._onClick.fire({x:e.posx,y:n+o+s,actions:a._state.actions})}})),a._register(i.addDisposableListener(a._domNode,"mouseenter",function(e){if(1==(1&e.buttons)){a.hide();var t=new n.GlobalMouseMoveMonitor;t.startMonitoring(n.standardMouseMoveMerger,function(){},function(){t.dispose()})}})),a._register(a._editor.onDidChangeConfiguration(function(e){e.contribInfo&&!a._editor.getConfiguration().contribInfo.lightbulbEnabled&&a.hide()})),a._updateLightBulbTitle(),a._register(a._keybindingService.onDidUpdateKeybindings(a._updateLightBulbTitle,a)),a}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._editor.removeContentWidget(this)},t.prototype.getId=function(){return"LightBulbWidget"},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return 1===this._state.type?this._state.widgetPosition:null},t.prototype.update=function(e,n){var o=this;if(e.actions.length<=0)return this.hide();var r=this._editor.getConfiguration()
;if(!r.contribInfo.lightbulbEnabled)return this.hide();var s=n.lineNumber,l=n.column,u=this._editor.getModel();if(!u)return this.hide();var d=u.getOptions().tabSize,c=u.getLineContent(s),p=a.TextModel.computeIndentLevel(c,d),f=function(e){return e>2&&o._editor.getTopForLineNumber(e)===o._editor.getTopForLineNumber(e-1)},g=s;if(!(r.fontInfo.spaceWidth*p>22))if(s>1&&!f(s-1))g-=1;else if(f(s+1)){if(l*r.fontInfo.spaceWidth<22)return this.hide()}else g+=1;this._state=new h.Showing(e,n,{position:{lineNumber:g,column:1},preference:t._posPref}),i.toggleClass(this._domNode,"autofixable",e.hasAutoFix),this._editor.layoutContentWidget(this)},Object.defineProperty(t.prototype,"title",{set:function(e){this._domNode.title=e},enumerable:!0,configurable:!0}),t.prototype.hide=function(){this._state=h.Hidden,this._editor.layoutContentWidget(this)},t.prototype._updateLightBulbTitle=function(){var e,t=this._keybindingService.lookupKeybinding(this._quickFixActionId);e=t?l.localize(0,null,t.getLabel()):l.localize(1,null),
this.title=e},t._posPref=[0],t=d([c(2,u.IKeybindingService)],t)}(s.Disposable);t.LightBulbWidget=p}),define(t[198],i([1,0,14]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(t,i){this._defaultKeybindings=t,this._defaultBoundCommands=new Map;for(var n=0,o=t.length;n<o;n++){var r=t[n].command;r&&this._defaultBoundCommands.set(r,!0)}this._map=new Map,this._lookupMap=new Map,this._keybindings=e.combine(t,i);for(var n=0,o=this._keybindings.length;n<o;n++){var s=this._keybindings[n];0!==s.keypressParts.length&&this._addKeyPress(s.keypressParts[0],s)}}return e._isTargetedForRemoval=function(e,t,i,n,o){if(e.command!==n)return!1;if(t&&e.keypressParts[0]!==t)return!1;if(i&&e.keypressParts[1]!==i)return!1;if(o){if(!e.when)return!1;if(!o.equals(e.when))return!1}return!0},e.combine=function(e,t){e=e.slice(0);for(var i=[],n=0,o=t;n<o.length;n++){var r=o[n]
;if(r.command&&0!==r.command.length&&"-"===r.command.charAt(0))for(var s=r.command.substr(1),a=r.keypressParts[0],l=r.keypressParts[1],u=r.when,d=e.length-1;d>=0;d--)this._isTargetedForRemoval(e[d],a,l,s,u)&&e.splice(d,1);else i.push(r)}return e.concat(i)},e.prototype._addKeyPress=function(t,i){var n=this._map.get(t);if(void 0===n)return this._map.set(t,[i]),void this._addToLookupMap(i);for(var o=n.length-1;o>=0;o--){var r=n[o];if(r.command!==i.command){var s=r.keypressParts.length>1,a=i.keypressParts.length>1;s&&a&&r.keypressParts[1]!==i.keypressParts[1]||e.whenIsEntirelyIncluded(r.when,i.when)&&this._removeFromLookupMap(r)}}n.push(i),this._addToLookupMap(i)},e.prototype._addToLookupMap=function(e){if(e.command){var t=this._lookupMap.get(e.command);void 0===t?(t=[e],this._lookupMap.set(e.command,t)):t.push(e)}},e.prototype._removeFromLookupMap=function(e){if(e.command){var t=this._lookupMap.get(e.command);if(void 0!==t)for(var i=0,n=t.length;i<n;i++)if(t[i]===e)return void t.splice(i,1)}},
e.whenIsEntirelyIncluded=function(e,t){return!t||!!e&&this._implies(e,t)},e._implies=function(e,t){for(var n=function(e){return e instanceof i.ContextKeyOrExpr?e.expr:[e]},o=n(e.negate()).concat(n(t)),r=0;r<o.length;r++)for(var s=o[r].negate(),a=r+1;a<o.length;a++){var l=o[a];if(s.equals(l))return!0}return!1},e.prototype.lookupPrimaryKeybinding=function(e){var t=this._lookupMap.get(e);return void 0===t||0===t.length?null:t[t.length-1]},e.prototype.resolve=function(e,t,i){var n=null;if(null!==t){if(void 0===(a=this._map.get(t)))return null;n=[];for(var o=0,r=a.length;o<r;o++){var s=a[o];s.keypressParts[1]===i&&n.push(s)}}else{var a=this._map.get(i);if(void 0===a)return null;n=a}var l=this._findCommand(e,n);return l?null===t&&l.keypressParts.length>1&&null!==l.keypressParts[1]?{enterChord:!0,commandId:null,commandArgs:null,bubble:!1}:{enterChord:!1,commandId:l.command,commandArgs:l.commandArgs,bubble:l.bubble}:null},e.prototype._findCommand=function(t,i){for(var n=i.length-1;n>=0;n--){var o=i[n]
;if(e.contextMatchesRules(t,o.when))return o}return null},e.contextMatchesRules=function(e,t){return!t||t.evaluate(e)},e}();t.KeybindingResolver=n}),define(t[437],i([1,0]),function(e,t){"use strict";function i(e){for(var t=[],i=0,n=e.length;i<n;i++){var o=e[i];if(!o)return t;t.push(o)}return t}Object.defineProperty(t,"__esModule",{value:!0});var n=function(){return function(e,t,n,o,r){this.resolvedKeybinding=e,this.keypressParts=e?i(e.getDispatchParts()):[],this.bubble=!!t&&94===t.charCodeAt(0),this.command=this.bubble?t.substr(1):t,this.commandArgs=n,this.when=o,this.isDefault=r}}();t.ResolvedKeybindingItem=n,t.removeElementsAfterNulls=i}),define(t[438],i([1,0,38,433]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t,i){return e.call(this,i,t.parts)||this}return r(t,e),t.prototype._keyCodeToUILabel=function(e){if(2===this._os)switch(e){case 15:return"←";case 16:return"↑";case 17:return"→";case 18:return"↓"}return i.KeyCodeUtils.toString(e)},
t.prototype._getLabel=function(e){return e.isDuplicateModifierCase()?"":this._keyCodeToUILabel(e.keyCode)},t.prototype._getAriaLabel=function(e){return e.isDuplicateModifierCase()?"":i.KeyCodeUtils.toString(e.keyCode)},t.prototype._getDispatchPart=function(e){return t.getDispatchStr(e)},t.getDispatchStr=function(e){if(e.isModifierKey())return null;var t="";return e.ctrlKey&&(t+="ctrl+"),e.shiftKey&&(t+="shift+"),e.altKey&&(t+="alt+"),e.metaKey&&(t+="meta+"),t+=i.KeyCodeUtils.toString(e.keyCode)},t}(n.BaseResolvedKeybinding);t.USLayoutResolvedKeybinding=o}),define(t[102],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ILabelService=i.createDecorator("label")}),define(t[199],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ILayoutService=i.createDecorator("layoutService")}),define(t[441],i([1,0,426,2,199]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t){
var n=e.call(this)||this;return n.layoutService=t,n.contextView=n._register(new i.ContextView(t.container)),n.layout(),n._register(t.onLayout(function(){return n.layout()})),n}return r(t,e),t.prototype.setContainer=function(e){this.contextView.setContainer(e)},t.prototype.showContextView=function(e){this.contextView.show(e)},t.prototype.layout=function(){this.contextView.layout()},t.prototype.hideContextView=function(e){this.contextView.hide(e)},t=d([c(0,o.ILayoutService)],t)}(n.Disposable);t.ContextViewService=s}),define(t[114],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ILogService=i.createDecorator("logService");var n=function(){function e(){}return e.prototype.trace=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i]},e.prototype.error=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i]},e.prototype.dispose=function(){},e}();t.NullLogService=n}),
define(t[200],i([1,0,15,2,201,445,17,40,585,42,140,5,19,114,127]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v){"use strict";function _(e,t){var i=e.getModel(t);return!!i&&!i.isTooLargeForSyncing()}Object.defineProperty(t,"__esModule",{value:!0});var y=6e4,b=3e5,C=function(e){function t(t,i,n){var o=e.call(this)||this;return o._modelService=t,o._workerManager=o._register(new w(o._modelService)),o._logService=n,o._register(a.LinkProviderRegistry.register("*",{provideLinks:function(e,t){return _(o._modelService,e.uri)?o._workerManager.withWorker().then(function(t){return t.computeLinks(e.uri)}).then(function(e){return e&&{links:e}}):Promise.resolve({links:[]})}})),o._register(a.CompletionProviderRegistry.register("*",new S(o._workerManager,i,o._modelService))),o}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.canComputeDiff=function(e,t){return _(this._modelService,e)&&_(this._modelService,t)},t.prototype.computeDiff=function(e,t,i){
return this._workerManager.withWorker().then(function(n){return n.computeDiff(e,t,i)})},t.prototype.computeMoreMinimalEdits=function(e,t){var i=this;if(g.isNonEmptyArray(t)){if(!_(this._modelService,e))return Promise.resolve(t);var n=v.StopWatch.create(!0),o=this._workerManager.withWorker().then(function(i){return i.computeMoreMinimalEdits(e,t)});return o.finally(function(){return i._logService.trace("FORMAT#computeMoreMinimalEdits",e.toString(!0),n.elapsed())}),o}return Promise.resolve(void 0)},t.prototype.canNavigateValueSet=function(e){return _(this._modelService,e)},t.prototype.navigateValueSet=function(e,t,i){return this._workerManager.withWorker().then(function(n){return n.navigateValueSet(e,t,i)})},t.prototype.canComputeWordRanges=function(e){return _(this._modelService,e)},t.prototype.computeWordRanges=function(e,t){return this._workerManager.withWorker().then(function(i){return i.computeWordRanges(e,t)})},t=d([c(0,h.IModelService),c(1,p.ITextResourceConfigurationService),c(2,m.ILogService)],t)
}(n.Disposable);t.EditorWorkerServiceImpl=C;var S=function(){function e(e,t,i){this._debugDisplayName="wordbasedCompletions",this._workerManager=e,this._configurationService=t,this._modelService=i}return e.prototype.provideCompletionItems=function(e,t){if(this._configurationService.getValue(e.uri,t,"editor").wordBasedSuggestions&&_(this._modelService,e.uri))return this._workerManager.withWorker().then(function(i){return i.textualSuggest(e.uri,t)})},e}(),w=function(e){function t(t){var n=e.call(this)||this;n._modelService=t,n._editorWorkerClient=null,n._lastWorkerUsedTime=(new Date).getTime();return n._register(new i.IntervalTimer).cancelAndSet(function(){return n._checkStopIdleWorker()},Math.round(b/2)),n._register(n._modelService.onModelRemoved(function(e){return n._checkStopEmptyWorker()})),n}return r(t,e),t.prototype.dispose=function(){this._editorWorkerClient&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null),e.prototype.dispose.call(this)},t.prototype._checkStopEmptyWorker=function(){
if(this._editorWorkerClient){0===this._modelService.getModels().length&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)}},t.prototype._checkStopIdleWorker=function(){if(this._editorWorkerClient){(new Date).getTime()-this._lastWorkerUsedTime>b&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)}},t.prototype.withWorker=function(){return this._lastWorkerUsedTime=(new Date).getTime(),this._editorWorkerClient||(this._editorWorkerClient=new D(this._modelService,"editorWorkerService")),Promise.resolve(this._editorWorkerClient)},t}(n.Disposable),E=function(e){function t(t,n,o){var r=e.call(this)||this;if(r._syncedModels=Object.create(null),r._syncedModelsLastUsedTime=Object.create(null),r._proxy=t,r._modelService=n,!o){var s=new i.IntervalTimer;s.cancelAndSet(function(){return r._checkStopModelSync()},Math.round(y/2)),r._register(s)}return r}return r(t,e),t.prototype.dispose=function(){for(var t in this._syncedModels)n.dispose(this._syncedModels[t])
;this._syncedModels=Object.create(null),this._syncedModelsLastUsedTime=Object.create(null),e.prototype.dispose.call(this)},t.prototype.ensureSyncedResources=function(e){for(var t=0,i=e;t<i.length;t++){var n=i[t],o=n.toString();this._syncedModels[o]||this._beginModelSync(n),this._syncedModels[o]&&(this._syncedModelsLastUsedTime[o]=(new Date).getTime())}},t.prototype._checkStopModelSync=function(){var e=(new Date).getTime(),t=[];for(var i in this._syncedModelsLastUsedTime){e-this._syncedModelsLastUsedTime[i]>y&&t.push(i)}for(var n=0,o=t;n<o.length;n++){var r=o[n];this._stopModelSync(r)}},t.prototype._beginModelSync=function(e){var t=this,i=this._modelService.getModel(e);if(i&&!i.isTooLargeForSyncing()){var o=e.toString();this._proxy.acceptNewModel({url:i.uri.toString(),lines:i.getLinesContent(),EOL:i.getEOL(),versionId:i.getVersionId()});var r=new n.DisposableStore;r.add(i.onDidChangeContent(function(e){t._proxy.acceptModelChanged(o.toString(),e)})),r.add(i.onWillDispose(function(){t._stopModelSync(o)})),
r.add(n.toDisposable(function(){t._proxy.acceptRemovedModel(o)})),this._syncedModels[o]=r}},t.prototype._stopModelSync=function(e){var t=this._syncedModels[e];delete this._syncedModels[e],delete this._syncedModelsLastUsedTime[e],n.dispose(t)},t}(n.Disposable),L=function(){function e(e){this._instance=e,this._proxyObj=Promise.resolve(this._instance)}return e.prototype.dispose=function(){this._instance.dispose()},e.prototype.getProxyObject=function(){return this._proxyObj},e}(),x=function(){function e(e){this._workerClient=e}return e.prototype.fhr=function(e,t){return this._workerClient.fhr(e,t)},e}();t.EditorWorkerHost=x;var D=function(e){function t(t,i){var n=e.call(this)||this;return n._modelService=t,n._workerFactory=new s.DefaultWorkerFactory(i),n._worker=null,n._modelManager=null,n}return r(t,e),t.prototype.fhr=function(e,t){throw new Error("Not implemented!")},t.prototype._getOrCreateWorker=function(){if(!this._worker)try{
this._worker=this._register(new o.SimpleWorkerClient(this._workerFactory,"vs/editor/common/services/editorSimpleWorker",new x(this)))}catch(e){o.logOnceWebWorkerWarning(e),this._worker=new L(new u.EditorSimpleWorker(new x(this),null))}return this._worker},t.prototype._getProxy=function(){var e=this;return this._getOrCreateWorker().getProxyObject().then(void 0,function(t){return o.logOnceWebWorkerWarning(t),e._worker=new L(new u.EditorSimpleWorker(new x(e),null)),e._getOrCreateWorker().getProxyObject()})},t.prototype._getOrCreateModelManager=function(e){return this._modelManager||(this._modelManager=this._register(new E(e,this._modelService,!1))),this._modelManager},t.prototype._withSyncedResources=function(e){var t=this;return this._getProxy().then(function(i){return t._getOrCreateModelManager(i).ensureSyncedResources(e),i})},t.prototype.computeDiff=function(e,t,i){return this._withSyncedResources([e,t]).then(function(n){return n.computeDiff(e.toString(),t.toString(),i)})},
t.prototype.computeMoreMinimalEdits=function(e,t){return this._withSyncedResources([e]).then(function(i){return i.computeMoreMinimalEdits(e.toString(),t)})},t.prototype.computeLinks=function(e){return this._withSyncedResources([e]).then(function(t){return t.computeLinks(e.toString())})},t.prototype.textualSuggest=function(e,t){var i=this;return this._withSyncedResources([e]).then(function(n){var o=i._modelService.getModel(e);if(!o)return null;var r=l.LanguageConfigurationRegistry.getWordDefinition(o.getLanguageIdentifier().id),s=r.source,a=f.regExpFlags(r);return n.textualSuggest(e.toString(),t,s,a)})},t.prototype.computeWordRanges=function(e,t){var i=this;return this._withSyncedResources([e]).then(function(n){var o=i._modelService.getModel(e);if(!o)return Promise.resolve(null);var r=l.LanguageConfigurationRegistry.getWordDefinition(o.getLanguageIdentifier().id),s=r.source,a=f.regExpFlags(r);return n.computeWordRanges(e.toString(),t,s,a)})},t.prototype.navigateValueSet=function(e,t,i){var n=this
;return this._withSyncedResources([e]).then(function(o){var r=n._modelService.getModel(e);if(!r)return null;var s=l.LanguageConfigurationRegistry.getWordDefinition(r.getLanguageIdentifier().id),a=s.source,u=f.regExpFlags(s);return o.navigateValueSet(e.toString(),t,i,a,u)})},t}(n.Disposable);t.EditorWorkerClient=D}),define(t[444],i([1,0,200,23]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createWebWorker=function(e,t){return new o(e,t)};var o=function(e){function t(t,i){var n=e.call(this,t,i.label)||this;return n._foreignModuleId=i.moduleId,n._foreignModuleCreateData=i.createData||null,n._foreignModuleHost=i.host||null,n._foreignProxy=null,n}return r(t,e),t.prototype.fhr=function(e,t){if(!this._foreignModuleHost||"function"!=typeof this._foreignModuleHost[e])return Promise.reject(new Error("Missing method "+e+" or missing main thread foreign host."));try{return Promise.resolve(this._foreignModuleHost[e].apply(this._foreignModuleHost,t))}catch(e){return Promise.reject(e)}},
t.prototype._getForeignProxy=function(){var e=this;return this._foreignProxy||(this._foreignProxy=this._getProxy().then(function(t){var i=e._foreignModuleHost?n.getAllMethodNames(e._foreignModuleHost):[];return t.loadForeignModule(e._foreignModuleId,e._foreignModuleCreateData,i).then(function(i){e._foreignModuleCreateData=null;for(var n=function(e,i){return t.fmr(e,i)},o=function(e,t){return function(){var i=Array.prototype.slice.call(arguments,0);return t(e,i)}},r={},s=0,a=i;s<a.length;s++){var l=a[s];r[l]=o(l,n)}return r})})),this._foreignProxy},t.prototype.getProxy=function(){return this._getForeignProxy()},t.prototype.withSyncedResources=function(e){var t=this;return this._withSyncedResources(e).then(function(e){return t.getProxy()})},t}(i.EditorWorkerClient)}),define(t[69],i([1,0,12,369,109]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r;!function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"
}(r=t.MarkerSeverity||(t.MarkerSeverity={})),function(e){e.compare=function(e,t){return t-e};var t=Object.create(null);t[e.Error]=n.localize(0,null),t[e.Warning]=n.localize(1,null),t[e.Info]=n.localize(2,null),e.toString=function(e){return t[e]||""},e.fromSeverity=function(t){switch(t){case o.default.Error:return e.Error;case o.default.Warning:return e.Warning;case o.default.Info:return e.Info;case o.default.Ignore:return e.Hint}},e.toSeverity=function(t){switch(t){case e.Error:return o.default.Error;case e.Warning:return o.default.Warning;case e.Info:return o.default.Info;case e.Hint:return o.default.Ignore}}}(r=t.MarkerSeverity||(t.MarkerSeverity={}));!function(e){function t(e,t){var n=[i];return e.source?n.push(e.source.replace("¦","¦")):n.push(i),e.code?n.push(e.code.replace("¦","¦")):n.push(i),void 0!==e.severity&&null!==e.severity?n.push(r.toString(e.severity)):n.push(i),e.message&&t?n.push(e.message.replace("¦","¦")):n.push(i),
void 0!==e.startLineNumber&&null!==e.startLineNumber?n.push(e.startLineNumber.toString()):n.push(i),void 0!==e.startColumn&&null!==e.startColumn?n.push(e.startColumn.toString()):n.push(i),void 0!==e.endLineNumber&&null!==e.endLineNumber?n.push(e.endLineNumber.toString()):n.push(i),void 0!==e.endColumn&&null!==e.endColumn?n.push(e.endColumn.toString()):n.push(i),n.push(i),n.join("¦")}var i="";e.makeKey=function(e){return t(e,!0)},e.makeKeyOptionalMessage=t}(t.IMarkerData||(t.IMarkerData={})),t.IMarkerService=i.createDecorator("markerService")}),define(t[446],i([1,0,19,50,23,4,69]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){e.get=function(e,t,i){if(e[t])return e[t][i]},e.set=function(e,t,i,n){e[t]||(e[t]=Object.create(null)),e[t][i]=n},e.remove=function(e,t,i){return!(!e[t]||!e[t][i]||(delete e[t][i],o.isEmptyObject(e[t])&&delete e[t],0))}}(a||(a={}));var l=function(){function e(e){this.errors=0,this.infos=0,this.warnings=0,this.unknowns=0,
this._data=Object.create(null),this._service=e,this._subscription=e.onMarkerChanged(this._update,this)}return e.prototype.dispose=function(){this._subscription.dispose(),this._data=void 0},e.prototype._update=function(e){if(this._data)for(var t=0,i=e;t<i.length;t++){var n=i[t],o=n.toString(),r=this._data[o];r&&this._substract(r);var s=this._resourceStats(n);this._add(s),this._data[o]=s}},e.prototype._resourceStats=function(e){var t={errors:0,warnings:0,infos:0,unknowns:0};if(e.scheme===n.Schemas.inMemory||e.scheme===n.Schemas.walkThrough||e.scheme===n.Schemas.walkThroughSnippet)return t;for(var i=0,o=this._service.read({resource:e});i<o.length;i++){var r=o[i].severity;r===s.MarkerSeverity.Error?t.errors+=1:r===s.MarkerSeverity.Warning?t.warnings+=1:r===s.MarkerSeverity.Info?t.infos+=1:t.unknowns+=1}return t},e.prototype._substract=function(e){this.errors-=e.errors,this.warnings-=e.warnings,this.infos-=e.infos,this.unknowns-=e.unknowns},e.prototype._add=function(e){this.errors+=e.errors,
this.warnings+=e.warnings,this.infos+=e.infos,this.unknowns+=e.unknowns},e}(),u=function(){function e(){this._onMarkerChanged=new r.Emitter,this._onMarkerChangedEvent=r.Event.debounce(this._onMarkerChanged.event,e._debouncer,0),this._byResource=Object.create(null),this._byOwner=Object.create(null),this._stats=new l(this)}return e.prototype.dispose=function(){this._stats.dispose()},Object.defineProperty(e.prototype,"onMarkerChanged",{get:function(){return this._onMarkerChangedEvent},enumerable:!0,configurable:!0}),e.prototype.remove=function(e,t){for(var i=0,n=t||[];i<n.length;i++){var o=n[i];this.changeOne(e,o,[])}},e.prototype.changeOne=function(t,n,o){if(i.isFalsyOrEmpty(o)){var r=a.remove(this._byResource,n.toString(),t),s=a.remove(this._byOwner,t,n.toString());if(r!==s)throw new Error("invalid marker service state");r&&s&&this._onMarkerChanged.fire([n])}else{for(var l=[],u=0,d=o;u<d.length;u++){var c=d[u],h=e._toMarker(t,n,c);h&&l.push(h)}a.set(this._byResource,n.toString(),t,l),
a.set(this._byOwner,t,n.toString(),l),this._onMarkerChanged.fire([n])}},e._toMarker=function(e,t,i){var n=i.code,o=i.severity,r=i.message,s=i.source,a=i.startLineNumber,l=i.startColumn,u=i.endLineNumber,d=i.endColumn,c=i.relatedInformation,h=i.tags;if(r)return a=a>0?a:1,l=l>0?l:1,u=u>=a?u:a,d=d>0?d:l,{resource:t,owner:e,code:n,severity:o,message:r,source:s,startLineNumber:a,startColumn:l,endLineNumber:u,endColumn:d,relatedInformation:c,tags:h}},e.prototype.read=function(t){void 0===t&&(t=Object.create(null));var i=t.owner,n=t.resource,o=t.severities,r=t.take;if((!r||r<0)&&(r=-1),i&&n){if(y=a.get(this._byResource,n.toString(),i)){for(var s=[],l=0,u=y;l<u.length;l++){var d=u[l];if(e._accept(d,o)){b=s.push(d);if(r>0&&b===r)break}}return s}return[]}if(i||n){var c=i?this._byOwner[i]:n?this._byResource[n.toString()]:void 0;if(!c)return[];s=[];for(var h in c)for(var p=0,f=c[h];p<f.length;p++){y=f[p];if(e._accept(y,o)){b=s.push(y);if(r>0&&b===r)return s}}return s}s=[]
;for(var g in this._byResource)for(var m in this._byResource[g])for(var v=0,_=this._byResource[g][m];v<_.length;v++){var y=_[v];if(e._accept(y,o)){var b=s.push(y);if(r>0&&b===r)return s}}return s},e._accept=function(e,t){return void 0===t||(t&e.severity)===e.severity},e._debouncer=function(t,i){t||(e._dedupeMap=Object.create(null),t=[]);for(var n=0,o=i;n<o.length;n++){var r=o[n];void 0===e._dedupeMap[r.toString()]&&(e._dedupeMap[r.toString()]=!0,t.push(r))}return t},e}();t.MarkerService=u}),define(t[34],i([1,0,109,12]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Severity=i.default,t.INotificationService=n.createDecorator("notificationService");var o=function(){return function(){}}();t.NoOpNotification=o}),define(t[55],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IOpenerService=i.createDecorator("openerService"),t.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener:function(){return{dispose:function(){}}},
registerValidator:function(){return{dispose:function(){}}},open:function(){return Promise.resolve(!1)}})}),define(t[111],i([1,0,475,55,70,24,10,193,12,4,2,17]),function(e,t,i,n,o,s,a,l,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(e){function t(t,i,o){void 0===o&&(o=n.NullOpenerService);var r=e.call(this)||this;return r._editor=t,r._modeService=i,r._openerService=o,r._onDidRenderCodeBlock=r._register(new h.Emitter),r.onDidRenderCodeBlock=r._onDidRenderCodeBlock.event,r}return r(t,e),t.prototype.getOptions=function(e){var t=this;return{codeBlockRenderer:function(e,i){var n=null;if(e)n=t._modeService.getModeIdForLanguageName(e);else{var o=t._editor.getModel();o&&(n=o.getLanguageIdentifier().language)}return t._modeService.triggerMode(n||""),Promise.resolve(!0).then(function(e){var t=f.TokenizationRegistry.getPromise(n||"");return t?t.then(function(e){return l.tokenizeToString(i,e)}):l.tokenizeToString(i,void 0)}).then(function(e){
return'<span style="font-family: '+t._editor.getConfiguration().fontInfo.fontFamily+'">'+e+"</span>"})},codeBlockRenderCallback:function(){return t._onDidRenderCodeBlock.fire()},actionHandler:{callback:function(e){var i;try{i=s.URI.parse(e)}catch(e){}i&&t._openerService&&t._openerService.open(i).catch(a.onUnexpectedError)},disposeables:e}}},t.prototype.render=function(e){var t,n=new p.DisposableStore;return t=e?i.renderMarkdown(e,this.getOptions(n)):document.createElement("span"),{element:t,dispose:function(){return n.dispose()}}},t=d([c(1,o.IModeService),c(2,u.optional(n.IOpenerService))],t)}(p.Disposable);t.MarkdownRenderer=g}),define(t[450],i([1,0,8,78,2,178,179,111,55,19]),function(e,t,i,n,o,s,a,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(e){this._editor=e,this._lineNumber=-1,this._result=[]}return e.prototype.setLineNumber=function(e){this._lineNumber=e,this._result=[]},e.prototype.clearResult=function(){this._result=[]},
e.prototype.computeSync=function(){var e=function(e){return{value:e}},t=this._editor.getLineDecorations(this._lineNumber),i=[];if(!t)return i;for(var o=0,r=t;o<r.length;o++){var s=r[o];if(s.options.glyphMarginClassName){var a=s.options.glyphMarginHoverMessage;a&&!n.isEmptyMarkdownString(a)&&i.push.apply(i,d.asArray(a).map(e))}}return i},e.prototype.onResult=function(e,t){this._result=this._result.concat(e)},e.prototype.getResult=function(){return this._result},e.prototype.getResultWithLoadingMessage=function(){return this.getResult()},e}(),h=function(e){function t(i,n,r){void 0===r&&(r=u.NullOpenerService);var a=e.call(this,t.ID,i)||this;return a._renderDisposeables=a._register(new o.DisposableStore),a._messages=[],a._lastLineNumber=-1,a._markdownRenderer=a._register(new l.MarkdownRenderer(a._editor,n,r)),a._computer=new c(a._editor),a._hoverOperation=new s.HoverOperation(a._computer,function(e){return a._withResult(e)},void 0,function(e){return a._withResult(e)},300),a}return r(t,e),
t.prototype.dispose=function(){this._hoverOperation.cancel(),e.prototype.dispose.call(this)},t.prototype.onModelDecorationsChanged=function(){this.isVisible&&(this._hoverOperation.cancel(),this._computer.clearResult(),this._hoverOperation.start(0))},t.prototype.startShowingAt=function(e){this._lastLineNumber!==e&&(this._hoverOperation.cancel(),this.hide(),this._lastLineNumber=e,this._computer.setLineNumber(e),this._hoverOperation.start(0))},t.prototype.hide=function(){this._lastLineNumber=-1,this._hoverOperation.cancel(),e.prototype.hide.call(this)},t.prototype._withResult=function(e){this._messages=e,this._messages.length>0?this._renderMessages(this._lastLineNumber,this._messages):this.hide()},t.prototype._renderMessages=function(e,t){this._renderDisposeables.clear();for(var n=document.createDocumentFragment(),o=0,r=t;o<r.length;o++){var s=r[o],a=this._markdownRenderer.render(s.value);this._renderDisposeables.add(a),n.appendChild(i.$("div.hover-row",void 0,a.element))}this.updateContents(n),this.showAt(e)},
t.ID="editor.contrib.modesGlyphHoverWidget",t}(a.GlyphHoverWidget);t.ModesGlyphHoverWidget=h}),define(t[110],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IEditorProgressService=i.createDecorator("editorProgressService")}),define(t[46],i([1,0,23,160]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(){this.data=new Map}return e.prototype.add=function(e,t){n.ok(i.isString(e)),n.ok(i.isObject(t)),n.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)},e.prototype.as=function(e){return this.data.get(e)||null},e}();t.Registry=new o}),define(t[108],i([1,0,317,4,17,40,46]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions={ModesRegistry:"editor.modesRegistry"};var a=function(){function e(){this._onDidChangeLanguages=new n.Emitter,this.onDidChangeLanguages=this._onDidChangeLanguages.event,this._languages=[],this._dynamicLanguages=[]
}return e.prototype.registerLanguage=function(e){this._languages.push(e),this._onDidChangeLanguages.fire(void 0)},e.prototype.getLanguages=function(){return[].concat(this._languages).concat(this._dynamicLanguages)},e}();t.EditorModesRegistry=a,t.ModesRegistry=new a,s.Registry.add(t.Extensions.ModesRegistry,t.ModesRegistry),t.PLAINTEXT_MODE_ID="plaintext",t.PLAINTEXT_LANGUAGE_IDENTIFIER=new o.LanguageIdentifier(t.PLAINTEXT_MODE_ID,1),t.ModesRegistry.registerLanguage({id:t.PLAINTEXT_MODE_ID,extensions:[".txt",".gitignore"],aliases:[i.localize(0,null),"text"],mimetypes:["text/plain"]}),r.LanguageConfigurationRegistry.register(t.PLAINTEXT_LANGUAGE_IDENTIFIER,{brackets:[["(",")"],["[","]"],["{","}"]]})}),define(t[454],i([1,0,50,48,108,185]),function(e,t,i,n,o,r){"use strict";function s(e,t,r){if(!r)return null;var s=null;if(r.scheme===i.Schemas.data){var a=n.DataUri.parseMetaData(r).get(n.DataUri.META_DATA_MIME);a&&(s=t.getModeId(a))}else{var l=e.getModel(r);l&&(s=l.getModeId())}
return s&&s!==o.PLAINTEXT_MODE_ID?s:t.getModeIdByFilepathOrFirstLine(r)}function a(e){return e.replace(/\s/g,"\\$&")}Object.defineProperty(t,"__esModule",{value:!0}),t.getIconClasses=function(e,t,o,l){var u=l===r.FileKind.ROOT_FOLDER?["rootfolder-icon"]:l===r.FileKind.FOLDER?["folder-icon"]:["file-icon"];if(o){var d;if(d=o.scheme===i.Schemas.data?n.DataUri.parseMetaData(o).get(n.DataUri.META_DATA_LABEL):a(n.basenameOrAuthority(o).toLowerCase()),l===r.FileKind.FOLDER)u.push(d+"-name-folder-icon");else{if(d){u.push(d+"-name-file-icon");for(var c=d.split("."),h=1;h<c.length;h++)u.push(c.slice(h).join(".")+"-ext-file-icon");u.push("ext-file-icon")}var p=s(e,t,o);p&&u.push(a(p)+"-lang-file-icon")}}return u},t.detectModeId=s,t.cssEscape=a}),define(t[202],i([1,0,46,4]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions={JSONContribution:"base.contributions.json"};var o=new(function(){function e(){this._onDidChangeSchema=new n.Emitter,this.schemasById={}}
return e.prototype.registerSchema=function(e,t){this.schemasById[function(e){return e.length>0&&"#"===e.charAt(e.length-1)?e.substring(0,e.length-1):e}(e)]=t,this._onDidChangeSchema.fire(e)},e.prototype.notifySchemaChanged=function(e){this._onDidChangeSchema.fire(e)},e}());i.Registry.add(t.Extensions.JSONContribution,o)}),define(t[89],i([1,0,366,4,46,23,5,202]),function(e,t,i,n,o,r,s,a){"use strict";function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}function u(e){return t.OVERRIDE_PROPERTY_PATTERN.test(e)?i.localize(2,null,e):void 0!==g.getConfigurationProperties()[e]?i.localize(3,null,e):null}Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions={Configuration:"base.contributions.configuration"},t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},
t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.editorConfigurationSchemaId="vscode://schemas/settings/editor";var d=o.Registry.as(a.Extensions.JSONContribution),c=function(){function e(){this.overrideIdentifiers=[],this._onDidSchemaChange=new n.Emitter,this._onDidUpdateConfiguration=new n.Emitter,this.defaultOverridesConfigurationNode={id:"defaultOverrides",title:i.localize(0,null),properties:{}},this.configurationContributors=[this.defaultOverridesConfigurationNode],this.editorConfigurationSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowsTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},this.computeOverridePropertyPattern(),d.registerSchema(t.editorConfigurationSchemaId,this.editorConfigurationSchema)}
return e.prototype.registerConfiguration=function(e,t){void 0===t&&(t=!0),this.registerConfigurations([e],t)},e.prototype.registerConfigurations=function(e,t){var i=this;void 0===t&&(t=!0);var n=[];e.forEach(function(e){n.push.apply(n,i.validateAndRegisterProperties(e,t)),i.configurationContributors.push(e),i.registerJSONConfiguration(e),i.updateSchemaForOverrideSettingsConfiguration(e)}),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)},e.prototype.registerOverrideIdentifiers=function(e){var t;(t=this.overrideIdentifiers).push.apply(t,e),this.updateOverridePropertyPatternKey()},e.prototype.validateAndRegisterProperties=function(e,i,n,o){void 0===i&&(i=!0),void 0===n&&(n=3),void 0===o&&(o=!1),n=r.isUndefinedOrNull(e.scope)?n:e.scope,o=e.overridable||o;var s=[],a=e.properties;if(a)for(var d in a){var c=void 0;if(i&&(c=u(d)))console.warn(c),delete a[d];else{var h=a[d],p=h.default;r.isUndefined(p)&&(h.default=l(h.type)),o&&(h.overridable=!0),
t.OVERRIDE_PROPERTY_PATTERN.test(d)?h.scope=void 0:h.scope=r.isUndefinedOrNull(h.scope)?n:h.scope,!a[d].hasOwnProperty("included")||a[d].included?(this.configurationProperties[d]=a[d],s.push(d)):(this.excludedConfigurationProperties[d]=a[d],delete a[d])}}var f=e.allOf;if(f)for(var g=0,m=f;g<m.length;g++){var v=m[g];s.push.apply(s,this.validateAndRegisterProperties(v,i,n,o))}return s},e.prototype.getConfigurationProperties=function(){return this.configurationProperties},e.prototype.registerJSONConfiguration=function(e){function i(e){var n=e.properties;if(n)for(var o in n)switch(t.allSettings.properties[o]=n[o],n[o].scope){case 1:t.applicationSettings.properties[o]=n[o];break;case 2:t.machineSettings.properties[o]=n[o];break;case 5:t.machineOverridableSettings.properties[o]=n[o];break;case 3:t.windowSettings.properties[o]=n[o];break;case 4:t.resourceSettings.properties[o]=n[o]}var r=e.allOf;r&&r.forEach(i)}i(e)},e.prototype.updateSchemaForOverrideSettingsConfiguration=function(e){e.id!==h&&(this.update(e),
d.registerSchema(t.editorConfigurationSchemaId,this.editorConfigurationSchema))},e.prototype.updateOverridePropertyPatternKey=function(){var e=t.allSettings.patternProperties[this.overridePropertyPattern];e||(e={type:"object",description:i.localize(1,null),errorMessage:"Unknown Identifier. Use language identifiers",$ref:t.editorConfigurationSchemaId}),delete t.allSettings.patternProperties[this.overridePropertyPattern],delete t.applicationSettings.patternProperties[this.overridePropertyPattern],delete t.machineSettings.patternProperties[this.overridePropertyPattern],delete t.machineOverridableSettings.patternProperties[this.overridePropertyPattern],delete t.windowSettings.patternProperties[this.overridePropertyPattern],delete t.resourceSettings.patternProperties[this.overridePropertyPattern],this.computeOverridePropertyPattern(),t.allSettings.patternProperties[this.overridePropertyPattern]=e,t.applicationSettings.patternProperties[this.overridePropertyPattern]=e,
t.machineSettings.patternProperties[this.overridePropertyPattern]=e,t.machineOverridableSettings.patternProperties[this.overridePropertyPattern]=e,t.windowSettings.patternProperties[this.overridePropertyPattern]=e,t.resourceSettings.patternProperties[this.overridePropertyPattern]=e,this._onDidSchemaChange.fire()},e.prototype.update=function(e){var t=this,i=e.properties;if(i)for(var n in i)i[n].overridable&&(this.editorConfigurationSchema.properties[n]=this.getConfigurationProperties()[n]);var o=e.allOf;o&&o.forEach(function(e){return t.update(e)})},e.prototype.computeOverridePropertyPattern=function(){this.overridePropertyPattern=this.overrideIdentifiers.length?f.replace("${0}",this.overrideIdentifiers.map(function(e){return s.createRegExp(e,!1).source}).join("|")):p},e}(),h="override",p="\\[.*\\]$",f="\\[(${0})\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p),t.getDefaultValue=l;var g=new c;o.Registry.add(t.Extensions.Configuration,g),t.validateProperty=u}),
define(t[150],i([1,0,312,4,2,29,18,47,112,117,89,46]),function(e,t,i,n,o,s,a,l,u,d,c,h){"use strict";function p(){return null===C&&(C=Object.create(null),Object.keys(b.properties).forEach(function(e){C[e]=!0})),C}Object.defineProperty(t,"__esModule",{value:!0});var f=l.EDITOR_DEFAULTS,g=l.EDITOR_FONT_DEFAULTS,m=l.EDITOR_MODEL_DEFAULTS;t.TabFocus=new(function(){function e(){this._tabFocus=!1,this._onDidChangeTabFocus=new n.Emitter,this.onDidChangeTabFocus=this._onDidChangeTabFocus.event}return e.prototype.getTabFocusMode=function(){return this._tabFocus},e.prototype.setTabFocusMode=function(e){this._tabFocus!==e&&(this._tabFocus=e,this._onDidChangeTabFocus.fire(this._tabFocus))},e}());var v=Object.hasOwnProperty,_=function(e){function i(i,o){var r=e.call(this)||this;return r._onDidChange=r._register(new n.Emitter),r.onDidChange=r._onDidChange.event,r.isSimpleWidget=i,r._rawOptions=s.mixin({},o||{}),r._rawOptions.scrollbar=s.mixin({},r._rawOptions.scrollbar||{}),
r._rawOptions.minimap=s.mixin({},r._rawOptions.minimap||{}),r._rawOptions.find=s.mixin({},r._rawOptions.find||{}),r._rawOptions.hover=s.mixin({},r._rawOptions.hover||{}),r._rawOptions.parameterHints=s.mixin({},r._rawOptions.parameterHints||{}),r._validatedOptions=l.EditorOptionsValidator.validate(r._rawOptions,f),r._isDominatedByLongLines=!1,r._lineNumbersDigitCount=1,r._register(u.EditorZoom.onDidChangeZoomLevel(function(e){return r._recomputeOptions()})),r._register(t.TabFocus.onDidChangeTabFocus(function(e){return r._recomputeOptions()})),r}return r(i,e),i.prototype.observeReferenceElement=function(e){},i.prototype.dispose=function(){e.prototype.dispose.call(this)},i.prototype._recomputeOptions=function(){var e=this.editor,t=this._computeInternalOptions();e&&e.equals(t)||(this.editor=t,e&&this._onDidChange.fire(e.createChangeEvent(t)))},i.prototype.getRawOptions=function(){return this._rawOptions},i.prototype._computeInternalOptions=function(){
var e=this._validatedOptions,i=this._getEnvConfiguration(),n=d.BareFontInfo.createFromRawSettings(this._rawOptions,i.zoomLevel,this.isSimpleWidget),o={outerWidth:i.outerWidth,outerHeight:i.outerHeight,fontInfo:this.readConfiguration(n),extraEditorClassName:i.extraEditorClassName,isDominatedByLongLines:this._isDominatedByLongLines,lineNumbersDigitCount:this._lineNumbersDigitCount,emptySelectionClipboard:i.emptySelectionClipboard,pixelRatio:i.pixelRatio,tabFocusMode:t.TabFocus.getTabFocusMode(),accessibilitySupport:i.accessibilitySupport};return l.InternalEditorOptionsFactory.createInternalEditorOptions(o,e)},i._primitiveArrayEquals=function(e,t){if(e.length!==t.length)return!1;for(var i=0;i<e.length;i++)if(e[i]!==t[i])return!1;return!0},i._subsetEquals=function(e,t){for(var i in t)if(v.call(t,i)){var n=t[i],o=e[i];if(o===n)continue;if(Array.isArray(o)&&Array.isArray(n)){if(!this._primitiveArrayEquals(o,n))return!1;continue}if("object"==typeof o&&"object"==typeof n){if(!this._subsetEquals(o,n))return!1;continue
}return!1}return!0},i.prototype.updateOptions=function(e){void 0!==e&&(i._subsetEquals(this._rawOptions,e)||(this._rawOptions=s.mixin(this._rawOptions,e||{}),this._validatedOptions=l.EditorOptionsValidator.validate(this._rawOptions,f),this._recomputeOptions()))},i.prototype.setIsDominatedByLongLines=function(e){this._isDominatedByLongLines=e,this._recomputeOptions()},i.prototype.setMaxLineNumber=function(e){var t=i._digitCount(e);this._lineNumbersDigitCount!==t&&(this._lineNumbersDigitCount=t,this._recomputeOptions())},i._digitCount=function(e){for(var t=0;e;)e=Math.floor(e/10),t++;return t||1},i}(o.Disposable);t.CommonEditorConfiguration=_;var y=h.Registry.as(c.Extensions.Configuration),b={id:"editor",order:5,type:"object",title:i.localize(0,null),overridable:!0,scope:4,properties:{"editor.fontFamily":{type:"string",default:g.fontFamily,description:i.localize(1,null)},"editor.fontWeight":{type:"string",enum:["normal","bold","100","200","300","400","500","600","700","800","900"],default:g.fontWeight,
description:i.localize(2,null)},"editor.fontSize":{type:"number",default:g.fontSize,description:i.localize(3,null)},"editor.lineHeight":{type:"number",default:g.lineHeight,description:i.localize(4,null)},"editor.letterSpacing":{type:"number",default:g.letterSpacing,description:i.localize(5,null)},"editor.lineNumbers":{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(6,null),i.localize(7,null),i.localize(8,null),i.localize(9,null)],default:"on",description:i.localize(10,null)},"editor.cursorSurroundingLines":{type:"number",default:f.viewInfo.cursorSurroundingLines,description:i.localize(11,null)},"editor.renderFinalNewline":{type:"boolean",default:f.viewInfo.renderFinalNewline,description:i.localize(12,null)},"editor.rulers":{type:"array",items:{type:"number"},default:f.viewInfo.rulers,description:i.localize(13,null)},"editor.wordSeparators":{type:"string",default:f.wordSeparators,description:i.localize(14,null)},"editor.tabSize":{type:"number",default:m.tabSize,minimum:1,
markdownDescription:i.localize(15,null)},"editor.insertSpaces":{type:"boolean",default:m.insertSpaces,markdownDescription:i.localize(16,null)},"editor.detectIndentation":{type:"boolean",default:m.detectIndentation,markdownDescription:i.localize(17,null)},"editor.roundedSelection":{type:"boolean",default:f.viewInfo.roundedSelection,description:i.localize(18,null)},"editor.scrollBeyondLastLine":{type:"boolean",default:f.viewInfo.scrollBeyondLastLine,description:i.localize(19,null)},"editor.scrollBeyondLastColumn":{type:"number",default:f.viewInfo.scrollBeyondLastColumn,description:i.localize(20,null)},"editor.smoothScrolling":{type:"boolean",default:f.viewInfo.smoothScrolling,description:i.localize(21,null)},"editor.minimap.enabled":{type:"boolean",default:f.viewInfo.minimap.enabled,description:i.localize(22,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:f.viewInfo.minimap.side,description:i.localize(23,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],
default:f.viewInfo.minimap.showSlider,description:i.localize(24,null)},"editor.minimap.renderCharacters":{type:"boolean",default:f.viewInfo.minimap.renderCharacters,description:i.localize(25,null)},"editor.minimap.maxColumn":{type:"number",default:f.viewInfo.minimap.maxColumn,description:i.localize(26,null)},"editor.hover.enabled":{type:"boolean",default:f.contribInfo.hover.enabled,description:i.localize(27,null)},"editor.hover.delay":{type:"number",default:f.contribInfo.hover.delay,description:i.localize(28,null)},"editor.hover.sticky":{type:"boolean",default:f.contribInfo.hover.sticky,description:i.localize(29,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:f.contribInfo.find.seedSearchStringFromSelection,description:i.localize(30,null)},"editor.find.autoFindInSelection":{type:"boolean",default:f.contribInfo.find.autoFindInSelection,description:i.localize(31,null)},"editor.find.globalFindClipboard":{type:"boolean",default:f.contribInfo.find.globalFindClipboard,
description:i.localize(32,null),included:a.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:!0,description:i.localize(33,null)},"editor.wordWrap":{type:"string",enum:["off","on","wordWrapColumn","bounded"],markdownEnumDescriptions:[i.localize(34,null),i.localize(35,null),i.localize(36,null),i.localize(37,null)],default:f.wordWrap,description:i.localize(38,null)},"editor.wordWrapColumn":{type:"integer",default:f.wordWrapColumn,minimum:1,markdownDescription:i.localize(39,null)},"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(40,null),i.localize(41,null),i.localize(42,null),i.localize(43,null)],default:"same",description:i.localize(44,null)},"editor.mouseWheelScrollSensitivity":{type:"number",default:f.viewInfo.scrollbar.mouseWheelScrollSensitivity,markdownDescription:i.localize(45,null)},"editor.fastScrollSensitivity":{type:"number",default:f.viewInfo.scrollbar.fastScrollSensitivity,markdownDescription:i.localize(46,null)},
"editor.multiCursorModifier":{type:"string",enum:["ctrlCmd","alt"],markdownEnumDescriptions:[i.localize(47,null),i.localize(48,null)],default:"alt",markdownDescription:i.localize(49,null)},"editor.multiCursorMergeOverlapping":{type:"boolean",default:f.multiCursorMergeOverlapping,description:i.localize(50,null)},"editor.quickSuggestions":{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:!1,description:i.localize(51,null)},comments:{type:"boolean",default:!1,description:i.localize(52,null)},other:{type:"boolean",default:!0,description:i.localize(53,null)}}}],default:f.contribInfo.quickSuggestions,description:i.localize(54,null)},"editor.quickSuggestionsDelay":{type:"integer",default:f.contribInfo.quickSuggestionsDelay,minimum:0,description:i.localize(55,null)},"editor.parameterHints.enabled":{type:"boolean",default:f.contribInfo.parameterHints.enabled,description:i.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:f.contribInfo.parameterHints.cycle,
description:i.localize(57,null)},"editor.autoClosingBrackets":{type:"string",enum:["always","languageDefined","beforeWhitespace","never"],enumDescriptions:["",i.localize(58,null),i.localize(59,null),""],default:f.autoClosingBrackets,description:i.localize(60,null)},"editor.autoClosingQuotes":{type:"string",enum:["always","languageDefined","beforeWhitespace","never"],enumDescriptions:["",i.localize(61,null),i.localize(62,null),""],default:f.autoClosingQuotes,description:i.localize(63,null)},"editor.autoClosingOvertype":{type:"string",enum:["always","auto","never"],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)],default:f.autoClosingOvertype,description:i.localize(67,null)},"editor.autoSurround":{type:"string",enum:["languageDefined","brackets","quotes","never"],enumDescriptions:[i.localize(68,null),i.localize(69,null),i.localize(70,null),""],default:f.autoSurround,description:i.localize(71,null)},"editor.formatOnType":{type:"boolean",default:f.contribInfo.formatOnType,
description:i.localize(72,null)},"editor.formatOnPaste":{type:"boolean",default:f.contribInfo.formatOnPaste,description:i.localize(73,null)},"editor.autoIndent":{type:"boolean",default:f.autoIndent,description:i.localize(74,null)},"editor.suggestOnTriggerCharacters":{type:"boolean",default:f.contribInfo.suggestOnTriggerCharacters,description:i.localize(75,null)},"editor.acceptSuggestionOnEnter":{type:"string",enum:["on","smart","off"],default:f.contribInfo.acceptSuggestionOnEnter,markdownEnumDescriptions:["",i.localize(76,null),""],markdownDescription:i.localize(77,null)},"editor.acceptSuggestionOnCommitCharacter":{type:"boolean",default:f.contribInfo.acceptSuggestionOnCommitCharacter,markdownDescription:i.localize(78,null)},"editor.snippetSuggestions":{type:"string",enum:["top","bottom","inline","none"],enumDescriptions:[i.localize(79,null),i.localize(80,null),i.localize(81,null),i.localize(82,null)],default:f.contribInfo.suggest.snippets,description:i.localize(83,null)},"editor.emptySelectionClipboard":{
type:"boolean",default:f.emptySelectionClipboard,description:i.localize(84,null)},"editor.copyWithSyntaxHighlighting":{type:"boolean",default:f.copyWithSyntaxHighlighting,description:i.localize(85,null)},"editor.wordBasedSuggestions":{type:"boolean",default:f.contribInfo.wordBasedSuggestions,description:i.localize(86,null)},"editor.suggestSelection":{type:"string",enum:["first","recentlyUsed","recentlyUsedByPrefix"],markdownEnumDescriptions:[i.localize(87,null),i.localize(88,null),i.localize(89,null)],default:"recentlyUsed",description:i.localize(90,null)},"editor.suggestFontSize":{type:"integer",default:0,minimum:0,markdownDescription:i.localize(91,null)},"editor.suggestLineHeight":{type:"integer",default:0,minimum:0,markdownDescription:i.localize(92,null)},"editor.tabCompletion":{type:"string",default:"off",enum:["on","off","onlySnippets"],enumDescriptions:[i.localize(93,null),i.localize(94,null),i.localize(95,null)],description:i.localize(96,null)},"editor.suggest.filterGraceful":{type:"boolean",
default:!0,description:i.localize(97,null)},"editor.suggest.localityBonus":{type:"boolean",default:!1,description:i.localize(98,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:!1,markdownDescription:i.localize(99,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:!0,description:i.localize(100,null)},"editor.suggest.showIcons":{type:"boolean",default:f.contribInfo.suggest.showIcons,description:i.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",default:f.contribInfo.suggest.maxVisibleSuggestions,minimum:1,maximum:15,description:i.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",default:{keyword:!0,snippet:!0},markdownDescription:i.localize(103,null),properties:{method:{type:"boolean",default:!0,markdownDescription:i.localize(104,null)},function:{type:"boolean",default:!0,markdownDescription:i.localize(105,null)},constructor:{type:"boolean",default:!0,markdownDescription:i.localize(106,null)},field:{type:"boolean",
default:!0,markdownDescription:i.localize(107,null)},variable:{type:"boolean",default:!0,markdownDescription:i.localize(108,null)},class:{type:"boolean",default:!0,markdownDescription:i.localize(109,null)},struct:{type:"boolean",default:!0,markdownDescription:i.localize(110,null)},interface:{type:"boolean",default:!0,markdownDescription:i.localize(111,null)},module:{type:"boolean",default:!0,markdownDescription:i.localize(112,null)},property:{type:"boolean",default:!0,markdownDescription:i.localize(113,null)},event:{type:"boolean",default:!0,markdownDescription:i.localize(114,null)},operator:{type:"boolean",default:!0,markdownDescription:i.localize(115,null)},unit:{type:"boolean",default:!0,markdownDescription:i.localize(116,null)},value:{type:"boolean",default:!0,markdownDescription:i.localize(117,null)},constant:{type:"boolean",default:!0,markdownDescription:i.localize(118,null)},enum:{type:"boolean",default:!0,markdownDescription:i.localize(119,null)},enumMember:{type:"boolean",default:!0,
markdownDescription:i.localize(120,null)},keyword:{type:"boolean",default:!0,markdownDescription:i.localize(121,null)},text:{type:"boolean",default:!0,markdownDescription:i.localize(122,null)},color:{type:"boolean",default:!0,markdownDescription:i.localize(123,null)},file:{type:"boolean",default:!0,markdownDescription:i.localize(124,null)},reference:{type:"boolean",default:!0,markdownDescription:i.localize(125,null)},customcolor:{type:"boolean",default:!0,markdownDescription:i.localize(126,null)},folder:{type:"boolean",default:!0,markdownDescription:i.localize(127,null)},typeParameter:{type:"boolean",default:!0,markdownDescription:i.localize(128,null)},snippet:{type:"boolean",default:!0,markdownDescription:i.localize(129,null)}}},"editor.gotoLocation.multiple":{description:i.localize(130,null),type:"string",enum:["peek","gotoAndPeek","goto"],default:f.contribInfo.gotoLocation.multiple,enumDescriptions:[i.localize(131,null),i.localize(132,null),i.localize(133,null)]},"editor.selectionHighlight":{
type:"boolean",default:f.contribInfo.selectionHighlight,description:i.localize(134,null)},"editor.occurrencesHighlight":{type:"boolean",default:f.contribInfo.occurrencesHighlight,description:i.localize(135,null)},"editor.overviewRulerLanes":{type:"integer",default:3,description:i.localize(136,null)},"editor.overviewRulerBorder":{type:"boolean",default:f.viewInfo.overviewRulerBorder,description:i.localize(137,null)},"editor.cursorBlinking":{type:"string",enum:["blink","smooth","phase","expand","solid"],default:l.blinkingStyleToString(f.viewInfo.cursorBlinking),description:i.localize(138,null)},"editor.mouseWheelZoom":{type:"boolean",default:f.viewInfo.mouseWheelZoom,markdownDescription:i.localize(139,null)},"editor.cursorSmoothCaretAnimation":{type:"boolean",default:f.viewInfo.cursorSmoothCaretAnimation,description:i.localize(140,null)},"editor.cursorStyle":{type:"string",enum:["block","block-outline","line","line-thin","underline","underline-thin"],default:l.cursorStyleToString(f.viewInfo.cursorStyle),
description:i.localize(141,null)},"editor.cursorWidth":{type:"integer",default:f.viewInfo.cursorWidth,markdownDescription:i.localize(142,null)},"editor.fontLigatures":{type:"boolean",default:f.viewInfo.fontLigatures,description:i.localize(143,null)},"editor.hideCursorInOverviewRuler":{type:"boolean",default:f.viewInfo.hideCursorInOverviewRuler,description:i.localize(144,null)},"editor.renderWhitespace":{type:"string",enum:["none","boundary","selection","all"],enumDescriptions:["",i.localize(145,null),i.localize(146,null),""],default:f.viewInfo.renderWhitespace,description:i.localize(147,null)},"editor.renderControlCharacters":{type:"boolean",default:f.viewInfo.renderControlCharacters,description:i.localize(148,null)},"editor.renderIndentGuides":{type:"boolean",default:f.viewInfo.renderIndentGuides,description:i.localize(149,null)},"editor.highlightActiveIndentGuide":{type:"boolean",default:f.viewInfo.highlightActiveIndentGuide,description:i.localize(150,null)},"editor.renderLineHighlight":{type:"string",
enum:["none","gutter","line","all"],enumDescriptions:["","","",i.localize(151,null)],default:f.viewInfo.renderLineHighlight,description:i.localize(152,null)},"editor.codeLens":{type:"boolean",default:f.contribInfo.codeLens,description:i.localize(153,null)},"editor.folding":{type:"boolean",default:f.contribInfo.folding,description:i.localize(154,null)},"editor.foldingStrategy":{type:"string",enum:["auto","indentation"],default:f.contribInfo.foldingStrategy,markdownDescription:i.localize(155,null)},"editor.showFoldingControls":{type:"string",enum:["always","mouseover"],default:f.contribInfo.showFoldingControls,description:i.localize(156,null)},"editor.matchBrackets":{type:"boolean",default:f.contribInfo.matchBrackets,description:i.localize(157,null)},"editor.glyphMargin":{type:"boolean",default:f.viewInfo.glyphMargin,description:i.localize(158,null)},"editor.useTabStops":{type:"boolean",default:f.useTabStops,description:i.localize(159,null)},"editor.trimAutoWhitespace":{type:"boolean",
default:m.trimAutoWhitespace,description:i.localize(160,null)},"editor.stablePeek":{type:"boolean",default:!1,markdownDescription:i.localize(161,null)},"editor.dragAndDrop":{type:"boolean",default:f.dragAndDrop,description:i.localize(162,null)},"editor.accessibilitySupport":{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(163,null),i.localize(164,null),i.localize(165,null)],default:f.accessibilitySupport,description:i.localize(166,null)},"editor.showUnused":{type:"boolean",default:f.showUnused,description:i.localize(167,null)},"editor.links":{type:"boolean",default:f.contribInfo.links,description:i.localize(168,null)},"editor.colorDecorators":{type:"boolean",default:f.contribInfo.colorDecorators,description:i.localize(169,null)},"editor.lightbulb.enabled":{type:"boolean",default:f.contribInfo.lightbulbEnabled,description:i.localize(170,null)},"editor.maxTokenizationLineLength":{type:"integer",default:2e4,description:i.localize(171,null)},"editor.codeActionsOnSave":{type:"object",
properties:{"source.organizeImports":{type:"boolean",description:i.localize(172,null)},"source.fixAll":{type:"boolean",description:i.localize(173,null)}},additionalProperties:{type:"boolean"},default:f.contribInfo.codeActionsOnSave,description:i.localize(174,null)},"editor.codeActionsOnSaveTimeout":{type:"number",default:f.contribInfo.codeActionsOnSaveTimeout,description:i.localize(175,null)},"editor.selectionClipboard":{type:"boolean",default:f.contribInfo.selectionClipboard,description:i.localize(176,null),included:a.isLinux},"diffEditor.renderSideBySide":{type:"boolean",default:!0,description:i.localize(177,null)},"diffEditor.ignoreTrimWhitespace":{type:"boolean",default:!0,description:i.localize(178,null)},"editor.largeFileOptimizations":{type:"boolean",default:m.largeFileOptimizations,description:i.localize(179,null)},"diffEditor.renderIndicators":{type:"boolean",default:!0,description:i.localize(180,null)}}},C=null;t.isEditorConfigurationKey=function(e){return p()["editor."+e]||!1},
t.isDiffEditorConfigurationKey=function(e){return p()["diffEditor."+e]||!1},y.registerConfiguration(b)}),define(t[65],i([1,0,28,4,2,18,295,383,150,117]),function(e,t,i,n,o,s,a,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(){this._keys=Object.create(null),this._values=Object.create(null)}return e.prototype.has=function(e){var t=e.getId();return!!this._values[t]},e.prototype.get=function(e){var t=e.getId();return this._values[t]},e.prototype.put=function(e,t){var i=e.getId();this._keys[i]=e,this._values[i]=t},e.prototype.remove=function(e){var t=e.getId();delete this._keys[t],delete this._values[t]},e.prototype.getValues=function(){var e=this;return Object.keys(this._keys).map(function(t){return e._values[t]})},e}();t.clearAllFontInfos=function(){h.INSTANCE.clearCache()};var h=function(e){function t(){var t=e.call(this)||this;return t._onDidChange=t._register(new n.Emitter),t.onDidChange=t._onDidChange.event,t._cache=new c,t._evictUntrustedReadingsTimeout=-1,t}
return r(t,e),t.prototype.dispose=function(){-1!==this._evictUntrustedReadingsTimeout&&(clearTimeout(this._evictUntrustedReadingsTimeout),this._evictUntrustedReadingsTimeout=-1),e.prototype.dispose.call(this)},t.prototype.clearCache=function(){this._cache=new c,this._onDidChange.fire()},t.prototype._writeToCache=function(e,t){var i=this;this._cache.put(e,t),t.isTrusted||-1!==this._evictUntrustedReadingsTimeout||(this._evictUntrustedReadingsTimeout=setTimeout(function(){i._evictUntrustedReadingsTimeout=-1,i._evictUntrustedReadings()},5e3))},t.prototype._evictUntrustedReadings=function(){for(var e=this._cache.getValues(),t=!1,i=0,n=e.length;i<n;i++){var o=e[i];o.isTrusted||(t=!0,this._cache.remove(o))}t&&this._onDidChange.fire()},t.prototype.readConfiguration=function(e){if(!this._cache.has(e)){var n=t._actualReadConfiguration(e);(n.typicalHalfwidthCharacterWidth<=2||n.typicalFullwidthCharacterWidth<=2||n.spaceWidth<=2||n.maxDigitWidth<=2)&&(n=new d.FontInfo({zoomLevel:i.getZoomLevel(),fontFamily:n.fontFamily,
fontWeight:n.fontWeight,fontSize:n.fontSize,lineHeight:n.lineHeight,letterSpacing:n.letterSpacing,isMonospace:n.isMonospace,typicalHalfwidthCharacterWidth:Math.max(n.typicalHalfwidthCharacterWidth,5),typicalFullwidthCharacterWidth:Math.max(n.typicalFullwidthCharacterWidth,5),canUseHalfwidthRightwardsArrow:n.canUseHalfwidthRightwardsArrow,spaceWidth:Math.max(n.spaceWidth,5),maxDigitWidth:Math.max(n.maxDigitWidth,5)},!1)),this._writeToCache(e,n)}return this._cache.get(e)},t.createRequest=function(e,t,i,n){var o=new a.CharWidthRequest(e,t);return i.push(o),n&&n.push(o),o},t._actualReadConfiguration=function(e){
var t=[],n=[],o=this.createRequest("n",0,t,n),r=this.createRequest("ｍ",0,t,null),s=this.createRequest(" ",0,t,n),l=this.createRequest("0",0,t,n),u=this.createRequest("1",0,t,n),c=this.createRequest("2",0,t,n),h=this.createRequest("3",0,t,n),p=this.createRequest("4",0,t,n),f=this.createRequest("5",0,t,n),g=this.createRequest("6",0,t,n),m=this.createRequest("7",0,t,n),v=this.createRequest("8",0,t,n),_=this.createRequest("9",0,t,n),y=this.createRequest("→",0,t,n),b=this.createRequest("￫",0,t,null);this.createRequest("·",0,t,n),this.createRequest("|",0,t,n),this.createRequest("/",0,t,n),this.createRequest("-",0,t,n),this.createRequest("_",0,t,n),this.createRequest("i",0,t,n),this.createRequest("l",0,t,n),this.createRequest("m",0,t,n),this.createRequest("|",1,t,n),this.createRequest("_",1,t,n),this.createRequest("i",1,t,n),this.createRequest("l",1,t,n),this.createRequest("m",1,t,n),this.createRequest("n",1,t,n),this.createRequest("|",2,t,n),this.createRequest("_",2,t,n),this.createRequest("i",2,t,n),
this.createRequest("l",2,t,n),this.createRequest("m",2,t,n),this.createRequest("n",2,t,n),a.readCharWidths(e,t);for(var C=Math.max(l.width,u.width,c.width,h.width,p.width,f.width,g.width,m.width,v.width,_.width),S=!0,w=n[0].width,E=1,L=n.length;E<L;E++){var x=w-n[E].width;if(x<-.001||x>.001){S=!1;break}}var D=!0;S&&b.width!==w&&(D=!1),b.width>y.width&&(D=!1);var I=i.getTimeSinceLastZoomLevelChanged()>2e3;return new d.FontInfo({zoomLevel:i.getZoomLevel(),fontFamily:e.fontFamily,fontWeight:e.fontWeight,fontSize:e.fontSize,lineHeight:e.lineHeight,letterSpacing:e.letterSpacing,isMonospace:S,typicalHalfwidthCharacterWidth:o.width,typicalFullwidthCharacterWidth:r.width,canUseHalfwidthRightwardsArrow:D,spaceWidth:s.width,maxDigitWidth:C},I)},t.INSTANCE=new t,t}(o.Disposable),p=function(e){function t(t,n,o,r){void 0===o&&(o=null);var s=e.call(this,t,n)||this;return s.accessibilityService=r,s._elementSizeObserver=s._register(new l.ElementSizeObserver(o,function(){return s._onReferenceDomElementSizeChanged()})),
s._register(h.INSTANCE.onDidChange(function(){return s._onCSSBasedConfigurationChanged()})),s._validatedOptions.automaticLayout&&s._elementSizeObserver.startObserving(),s._register(i.onDidChangeZoomLevel(function(e){return s._recomputeOptions()})),s._register(s.accessibilityService.onDidChangeAccessibilitySupport(function(){return s._recomputeOptions()})),s._recomputeOptions(),s}return r(t,e),t.applyFontInfoSlow=function(e,t){e.style.fontFamily=t.getMassagedFontFamily(),e.style.fontWeight=t.fontWeight,e.style.fontSize=t.fontSize+"px",e.style.lineHeight=t.lineHeight+"px",e.style.letterSpacing=t.letterSpacing+"px"},t.applyFontInfo=function(e,t){e.setFontFamily(t.getMassagedFontFamily()),e.setFontWeight(t.fontWeight),e.setFontSize(t.fontSize),e.setLineHeight(t.lineHeight),e.setLetterSpacing(t.letterSpacing)},t.prototype._onReferenceDomElementSizeChanged=function(){this._recomputeOptions()},t.prototype._onCSSBasedConfigurationChanged=function(){this._recomputeOptions()},
t.prototype.observeReferenceElement=function(e){this._elementSizeObserver.observe(e)},t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype._getExtraEditorClassName=function(){var e="";return i.isSafari||i.isWebkitWebView||(e+="no-user-select "),s.isMacintosh&&(e+="mac "),e},t.prototype._getEnvConfiguration=function(){return{extraEditorClassName:this._getExtraEditorClassName(),outerWidth:this._elementSizeObserver.getWidth(),outerHeight:this._elementSizeObserver.getHeight(),emptySelectionClipboard:i.isWebKit||i.isFirefox,pixelRatio:i.getPixelRatio(),zoomLevel:i.getZoomLevel(),accessibilitySupport:this.accessibilityService.getAccessibilitySupport()}},t.prototype.readConfiguration=function(e){return h.INSTANCE.readConfiguration(e)},t}(u.CommonEditorConfiguration);t.Configuration=p}),define(t[459],i([1,0,27,65,155,35]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var i=e.call(this,t)||this
;return i._visibleLines=new o.VisibleLinesCollection(i),i.domNode=i._visibleLines.domNode,i._dynamicOverlays=[],i._isFocused=!1,i.domNode.setClassName("view-overlays"),i}return r(t,e),t.prototype.shouldRender=function(){if(e.prototype.shouldRender.call(this))return!0;for(var t=0,i=this._dynamicOverlays.length;t<i;t++){if(this._dynamicOverlays[t].shouldRender())return!0}return!1},t.prototype.dispose=function(){e.prototype.dispose.call(this);for(var t=0,i=this._dynamicOverlays.length;t<i;t++){this._dynamicOverlays[t].dispose()}this._dynamicOverlays=[]},t.prototype.getDomNode=function(){return this.domNode},t.prototype.createVisibleLine=function(){return new l(this._context.configuration,this._dynamicOverlays)},t.prototype.addDynamicOverlay=function(e){this._dynamicOverlays.push(e)},t.prototype.onConfigurationChanged=function(e){this._visibleLines.onConfigurationChanged(e);for(var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber(),n=t;n<=i;n++){
this._visibleLines.getVisibleLine(n).onConfigurationChanged(e)}return!0},t.prototype.onFlushed=function(e){return this._visibleLines.onFlushed(e)},t.prototype.onFocusChanged=function(e){return this._isFocused=e.isFocused,!0},t.prototype.onLinesChanged=function(e){return this._visibleLines.onLinesChanged(e)},t.prototype.onLinesDeleted=function(e){return this._visibleLines.onLinesDeleted(e)},t.prototype.onLinesInserted=function(e){return this._visibleLines.onLinesInserted(e)},t.prototype.onScrollChanged=function(e){return this._visibleLines.onScrollChanged(e)||!0},t.prototype.onTokensChanged=function(e){return this._visibleLines.onTokensChanged(e)},t.prototype.onZonesChanged=function(e){return this._visibleLines.onZonesChanged(e)},t.prototype.prepareRender=function(e){for(var t=this._dynamicOverlays.filter(function(e){return e.shouldRender()}),i=0,n=t.length;i<n;i++){var o=t[i];o.prepareRender(e),o.onDidRender()}},t.prototype.render=function(e){this._viewOverlaysRender(e),
this.domNode.toggleClassName("focused",this._isFocused)},t.prototype._viewOverlaysRender=function(e){this._visibleLines.renderLines(e.viewportData)},t}(s.ViewPart);t.ViewOverlays=a;var l=function(){function e(e,t){this._configuration=e,this._lineHeight=this._configuration.editor.lineHeight,this._dynamicOverlays=t,this._domNode=null,this._renderedContent=null}return e.prototype.getDomNode=function(){return this._domNode?this._domNode.domNode:null},e.prototype.setDomNode=function(e){this._domNode=i.createFastDomNode(e)},e.prototype.onContentChanged=function(){},e.prototype.onTokensChanged=function(){},e.prototype.onConfigurationChanged=function(e){e.lineHeight&&(this._lineHeight=this._configuration.editor.lineHeight)},e.prototype.renderLine=function(e,t,i,n){for(var o="",r=0,s=this._dynamicOverlays.length;r<s;r++){o+=this._dynamicOverlays[r].render(i.startLineNumber,e)}return this._renderedContent!==o&&(this._renderedContent=o,n.appendASCIIString('<div style="position:absolute;top:'),
n.appendASCIIString(String(t)),n.appendASCIIString("px;width:100%;height:"),n.appendASCIIString(String(this._lineHeight)),n.appendASCIIString('px;">'),n.appendASCIIString(o),n.appendASCIIString("</div>"),!0)},e.prototype.layoutLine=function(e,t){this._domNode&&(this._domNode.setTop(t),this._domNode.setHeight(this._lineHeight))},e}();t.ViewOverlayLine=l;var u=function(e){function t(t){var i=e.call(this,t)||this;return i._contentWidth=i._context.configuration.editor.layoutInfo.contentWidth,i.domNode.setHeight(0),i}return r(t,e),t.prototype.onConfigurationChanged=function(t){return t.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth),e.prototype.onConfigurationChanged.call(this,t)},t.prototype.onScrollChanged=function(t){return e.prototype.onScrollChanged.call(this,t)||t.scrollWidthChanged},t.prototype._viewOverlaysRender=function(t){e.prototype._viewOverlaysRender.call(this,t),this.domNode.setWidth(Math.max(t.scrollWidth,this._contentWidth))},t}(a)
;t.ContentViewOverlays=u;var d=function(e){function t(t){var i=e.call(this,t)||this;return i._contentLeft=i._context.configuration.editor.layoutInfo.contentLeft,i.domNode.setClassName("margin-view-overlays"),i.domNode.setWidth(1),n.Configuration.applyFontInfo(i.domNode,i._context.configuration.editor.fontInfo),i}return r(t,e),t.prototype.onConfigurationChanged=function(t){var i=!1;return t.fontInfo&&(n.Configuration.applyFontInfo(this.domNode,this._context.configuration.editor.fontInfo),i=!0),t.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,i=!0),e.prototype.onConfigurationChanged.call(this,t)||i},t.prototype.onScrollChanged=function(t){return e.prototype.onScrollChanged.call(this,t)||t.scrollHeightChanged},t.prototype._viewOverlaysRender=function(t){e.prototype._viewOverlaysRender.call(this,t);var i=Math.min(t.scrollHeight,1e6);this.domNode.setHeight(i),this.domNode.setWidth(this._contentLeft)},t}(a);t.MarginViewOverlays=d}),
define(t[460],i([1,0,8,27,5,65,47,13,3]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){return function(e,t,i,n,o,r){this.top=e,this.left=t,this.width=i,this.height=n,this.textContent=o,this.textContentClassName=r}}(),d=function(){function e(e){this._context=e,this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle,this._lineHeight=this._context.configuration.editor.lineHeight,this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,this._lineCursorWidth=Math.min(this._context.configuration.editor.viewInfo.cursorWidth,this._typicalHalfwidthCharacterWidth),this._isVisible=!0,this._domNode=n.createFastDomNode(document.createElement("div")),this._domNode.setClassName("cursor"),this._domNode.setHeight(this._lineHeight),this._domNode.setTop(0),this._domNode.setLeft(0),r.Configuration.applyFontInfo(this._domNode,this._context.configuration.editor.fontInfo),
this._domNode.setDisplay("none"),this._position=new a.Position(1,1),this._lastRenderedContent="",this._renderData=null}return e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return this._position},e.prototype.show=function(){this._isVisible||(this._domNode.setVisibility("inherit"),this._isVisible=!0)},e.prototype.hide=function(){this._isVisible&&(this._domNode.setVisibility("hidden"),this._isVisible=!1)},e.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.fontInfo&&(r.Configuration.applyFontInfo(this._domNode,this._context.configuration.editor.fontInfo),this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),e.viewInfo&&(this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle,this._lineCursorWidth=Math.min(this._context.configuration.editor.viewInfo.cursorWidth,this._typicalHalfwidthCharacterWidth)),!0},
e.prototype.onCursorPositionChanged=function(e){return this._position=e,!0},e.prototype._prepareRender=function(e){var t="",n="";if(this._cursorStyle===s.TextEditorCursorStyle.Line||this._cursorStyle===s.TextEditorCursorStyle.LineThin){var r=e.visibleRangeForPosition(this._position);if(!r)return null;var a;if(this._cursorStyle===s.TextEditorCursorStyle.Line){if((a=i.computeScreenAwareSize(this._lineCursorWidth>0?this._lineCursorWidth:2))>2){t=this._context.model.getLineContent(this._position.lineNumber).charAt(this._position.column-1)}}else a=i.computeScreenAwareSize(1);var d=r.left;a>=2&&d>=1&&(d-=1);var c=e.getVerticalOffsetForLineNumber(this._position.lineNumber)-e.bigNumbersDelta;return new u(c,d,a,this._lineHeight,t,n)}var h=e.linesVisibleRangesForRange(new l.Range(this._position.lineNumber,this._position.column,this._position.lineNumber,this._position.column+1),!1);if(!h||0===h.length||0===h[0].ranges.length)return null;var p=h[0].ranges[0],f=p.width<1?this._typicalHalfwidthCharacterWidth:p.width
;if(this._cursorStyle===s.TextEditorCursorStyle.Block){var g=this._context.model.getViewLineData(this._position.lineNumber);t=g.content.charAt(this._position.column-1),o.isHighSurrogate(g.content.charCodeAt(this._position.column-1))&&(t+=g.content.charAt(this._position.column));var m=g.tokens.findTokenIndexAtOffset(this._position.column-1);n=g.tokens.getClassName(m)}var v=e.getVerticalOffsetForLineNumber(this._position.lineNumber)-e.bigNumbersDelta,_=this._lineHeight;return this._cursorStyle!==s.TextEditorCursorStyle.Underline&&this._cursorStyle!==s.TextEditorCursorStyle.UnderlineThin||(v+=this._lineHeight-2,_=2),new u(v,p.left,f,_,t,n)},e.prototype.prepareRender=function(e){this._renderData=this._prepareRender(e)},e.prototype.render=function(e){return this._renderData?(this._lastRenderedContent!==this._renderData.textContent&&(this._lastRenderedContent=this._renderData.textContent,this._domNode.domNode.textContent=this._lastRenderedContent),
this._domNode.setClassName("cursor "+this._renderData.textContentClassName),this._domNode.setDisplay("block"),this._domNode.setTop(this._renderData.top),this._domNode.setLeft(this._renderData.left),this._domNode.setWidth(this._renderData.width),this._domNode.setLineHeight(this._renderData.height),this._domNode.setHeight(this._renderData.height),{domNode:this._domNode.domNode,position:this._position,contentLeft:this._renderData.left,height:this._renderData.height,width:2}):(this._domNode.setDisplay("none"),null)},e}();t.ViewCursor=d}),define(t[461],i([1,0,10,4,2,456,5,17,108,63,89,46]),function(e,t,i,n,o,s,a,l,u,d,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=Object.prototype.hasOwnProperty,f=function(e){function t(t,i){void 0===t&&(t=!0),void 0===i&&(i=!1);var o=e.call(this)||this;return o._onDidChange=o._register(new n.Emitter),o.onDidChange=o._onDidChange.event,o._warnOnOverwrite=i,o._nextLanguageId2=1,o._languageIdToLanguage=[],o._languageToLanguageId=Object.create(null),
o._languages={},o._mimeTypesMap={},o._nameMap={},o._lowercaseNameMap={},t&&(o._initializeFromRegistry(),o._register(u.ModesRegistry.onDidChangeLanguages(function(e){return o._initializeFromRegistry()}))),o}return r(t,e),t.prototype._initializeFromRegistry=function(){this._languages={},this._mimeTypesMap={},this._nameMap={},this._lowercaseNameMap={};var e=u.ModesRegistry.getLanguages();this._registerLanguages(e)},t.prototype._registerLanguages=function(e){for(var t=this,i=0,n=e;i<n.length;i++){var o=n[i];this._registerLanguage(o)}this._mimeTypesMap={},this._nameMap={},this._lowercaseNameMap={},Object.keys(this._languages).forEach(function(e){var i=t._languages[e];i.name&&(t._nameMap[i.name]=i.identifier),i.aliases.forEach(function(e){t._lowercaseNameMap[e.toLowerCase()]=i.identifier}),i.mimetypes.forEach(function(e){t._mimeTypesMap[e]=i.identifier})}),h.Registry.as(c.Extensions.Configuration).registerOverrideIdentifiers(u.ModesRegistry.getLanguages().map(function(e){return e.id})),this._onDidChange.fire()},
t.prototype._getLanguageId=function(e){if(this._languageToLanguageId[e])return this._languageToLanguageId[e];var t=this._nextLanguageId2++;return this._languageIdToLanguage[t]=e,this._languageToLanguageId[e]=t,t},t.prototype._registerLanguage=function(e){var t,i=e.id;if(p.call(this._languages,i))t=this._languages[i];else{var n=this._getLanguageId(i);t={identifier:new l.LanguageIdentifier(i,n),name:null,mimetypes:[],aliases:[],extensions:[],filenames:[],configurationFiles:[]},this._languages[i]=t}this._mergeLanguage(t,e)},t.prototype._mergeLanguage=function(e,t){var n,o=t.id,r=null;if(Array.isArray(t.mimetypes)&&t.mimetypes.length>0&&((n=e.mimetypes).push.apply(n,t.mimetypes),r=t.mimetypes[0]),r||(r="text/x-"+o,e.mimetypes.push(r)),Array.isArray(t.extensions))for(var l=0,u=t.extensions;l<u.length;l++){var d=u[l];s.registerTextMime({id:o,mime:r,extension:d},this._warnOnOverwrite),e.extensions.push(d)}if(Array.isArray(t.filenames))for(var c=0,h=t.filenames;c<h.length;c++){var p=h[c];s.registerTextMime({id:o,
mime:r,filename:p},this._warnOnOverwrite),e.filenames.push(p)}if(Array.isArray(t.filenamePatterns))for(var f=0,g=t.filenamePatterns;f<g.length;f++){var m=g[f];s.registerTextMime({id:o,mime:r,filepattern:m},this._warnOnOverwrite)}if("string"==typeof t.firstLine&&t.firstLine.length>0){var v=t.firstLine;"^"!==v.charAt(0)&&(v="^"+v);try{var _=new RegExp(v);a.regExpLeadsToEndlessLoop(_)||s.registerTextMime({id:o,mime:r,firstline:_},this._warnOnOverwrite)}catch(e){i.onUnexpectedError(e)}}e.aliases.push(o);var y=null;if(void 0!==t.aliases&&Array.isArray(t.aliases)&&(y=0===t.aliases.length?[null]:t.aliases),null!==y)for(var b=0,C=y;b<C.length;b++){var S=C[b];S&&0!==S.length&&e.aliases.push(S)}var w=null!==y&&y.length>0;if(w&&null===y[0]);else{var E=(w?y[0]:null)||o;!w&&e.name||(e.name=E)}t.configuration&&e.configurationFiles.push(t.configuration)},t.prototype.isRegisteredMode=function(e){return!!p.call(this._mimeTypesMap,e)||p.call(this._languages,e)},t.prototype.getModeIdForLanguageNameLowercase=function(e){
return p.call(this._lowercaseNameMap,e)?this._lowercaseNameMap[e].language:null},t.prototype.extractModeIds=function(e){var t=this;return e?e.split(",").map(function(e){return e.trim()}).map(function(e){return p.call(t._mimeTypesMap,e)?t._mimeTypesMap[e].language:e}).filter(function(e){return p.call(t._languages,e)}):[]},t.prototype.getLanguageIdentifier=function(e){if(e===d.NULL_MODE_ID||0===e)return d.NULL_LANGUAGE_IDENTIFIER;var t;if("string"==typeof e)t=e;else if(!(t=this._languageIdToLanguage[e]))return null;return p.call(this._languages,t)?this._languages[t].identifier:null},t.prototype.getModeIdsFromFilepathOrFirstLine=function(e,t){if(!e&&!t)return[];var i=s.guessMimeTypes(e,t);return this.extractModeIds(i.join(","))},t}(o.Disposable);t.LanguagesRegistry=f}),define(t[462],i([1,0,4,2,430,63,461]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t,n){var o=e.call(this)||this;return o._onDidChange=o._register(new i.Emitter),
o.onDidChange=o._onDidChange.event,o._selector=n,o.languageIdentifier=o._selector(),o._register(t(function(){return o._evaluate()})),o}return r(t,e),t.prototype._evaluate=function(){var e=this._selector();e.id!==this.languageIdentifier.id&&(this.languageIdentifier=e,this._onDidChange.fire(this.languageIdentifier))},t}(n.Disposable),u=function(){function e(e){var t=this;void 0===e&&(e=!1),this._onDidCreateMode=new i.Emitter,this.onDidCreateMode=this._onDidCreateMode.event,this._onLanguagesMaybeChanged=new i.Emitter,this.onLanguagesMaybeChanged=this._onLanguagesMaybeChanged.event,this._instantiatedModes={},this._registry=new a.LanguagesRegistry(!0,e),this._registry.onDidChange(function(){return t._onLanguagesMaybeChanged.fire()})}return e.prototype.isRegisteredMode=function(e){return this._registry.isRegisteredMode(e)},e.prototype.getModeIdForLanguageName=function(e){return this._registry.getModeIdForLanguageNameLowercase(e)},e.prototype.getModeIdByFilepathOrFirstLine=function(e,t){
var i=this._registry.getModeIdsFromFilepathOrFirstLine(e,t);return i.length>0?i[0]:null},e.prototype.getModeId=function(e){var t=this._registry.extractModeIds(e);return t.length>0?t[0]:null},e.prototype.getLanguageIdentifier=function(e){return this._registry.getLanguageIdentifier(e)},e.prototype.create=function(e){var t=this;return new l(this.onLanguagesMaybeChanged,function(){var i=t.getModeId(e);return t._createModeAndGetLanguageIdentifier(i)})},e.prototype.createByFilepathOrFirstLine=function(e,t){var i=this;return new l(this.onLanguagesMaybeChanged,function(){var n=i.getModeIdByFilepathOrFirstLine(e,t);return i._createModeAndGetLanguageIdentifier(n)})},e.prototype._createModeAndGetLanguageIdentifier=function(e){var t=this.getLanguageIdentifier(e||"plaintext")||s.NULL_LANGUAGE_IDENTIFIER;return this._getOrCreateMode(t.language),t},e.prototype.triggerMode=function(e){var t=this.getModeId(e);this._getOrCreateMode(t||"plaintext")},e.prototype._getOrCreateMode=function(e){
if(!this._instantiatedModes.hasOwnProperty(e)){var t=this.getLanguageIdentifier(e)||s.NULL_LANGUAGE_IDENTIFIER;this._instantiatedModes[e]=new o.FrankensteinMode(t),this._onDidCreateMode.fire(this._instantiatedModes[e])}return this._instantiatedModes[e]},e}();t.ModeServiceImpl=u}),define(t[39],i([1,0,46,12,89]),function(e,t,i,n,o){"use strict";function r(e,t,i,n){for(var o=t.split("."),r=o.pop(),s=e,a=0;a<o.length;a++){var l=o[a],u=s[l];switch(typeof u){case"undefined":u=s[l]=Object.create(null);break;case"object":break;default:return void n("Ignoring "+t+" as "+o.slice(0,a+1).join(".")+" is "+JSON.stringify(u))}s=u}"object"==typeof s?s[r]=i:n("Ignoring "+t+" as "+o.join(".")+" is "+JSON.stringify(s))}function s(e,t){var i=t.shift();if(0!==t.length){if(-1!==Object.keys(e).indexOf(i)){var n=e[i];"object"!=typeof n||Array.isArray(n)||(s(n,t),0===Object.keys(n).length&&delete e[i])}}else delete e[i]}Object.defineProperty(t,"__esModule",{value:!0}),t.IConfigurationService=n.createDecorator("configurationService"),
t.toValuesTree=function(e,t){var i=Object.create(null);for(var n in e)r(i,n,e[n],t);return i},t.addToValueTree=r,t.removeFromValueTree=function(e,t){s(e,t.split("."))},t.getConfigurationValue=function(e,t,i){var n=function(e,t){for(var i=e,n=0,o=t;n<o.length;n++){var r=o[n];if("object"!=typeof i||null===i)return;i=i[r]}return i}(e,t.split("."));return void 0===n?i:n},t.getConfigurationKeys=function(){var e=i.Registry.as(o.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){var e=Object.create(null),t=i.Registry.as(o.Extensions.Configuration).getConfigurationProperties();for(var n in t)r(e,n,t[n].default,function(e){return console.error("Conflict in default settings: "+e)});return e},t.overrideIdentifierFromKey=function(e){return e.substring(1,e.length-1)},t.getMigratedSettingValue=function(e,t,i){var n=e.inspect(t),o=e.inspect(i)
;return void 0!==n.user||void 0!==n.workspace||void 0!==n.workspaceFolder?n.value:void 0!==o.user||void 0!==o.workspace||void 0!==o.workspaceFolder?o.value:n.default}}),define(t[464],i([1,0,4,2,18,47,30,108,140,39]),function(e,t,i,n,o,s,a,l,u,h){"use strict";function p(e){return e.toString()}Object.defineProperty(t,"__esModule",{value:!0});var f=function(){function e(e,t,i){this._modelEventListeners=new n.DisposableStore,this.model=e,this._languageSelection=null,this._languageSelectionListener=null,this._modelEventListeners.add(e.onWillDispose(function(){return t(e)})),this._modelEventListeners.add(e.onDidChangeLanguage(function(t){return i(e,t)}))}return e.prototype._disposeLanguageSelection=function(){this._languageSelectionListener&&(this._languageSelectionListener.dispose(),this._languageSelectionListener=null),this._languageSelection&&(this._languageSelection.dispose(),this._languageSelection=null)},e.prototype.dispose=function(){this._modelEventListeners.dispose(),this._disposeLanguageSelection()},
e.prototype.setLanguage=function(e){var t=this;this._disposeLanguageSelection(),this._languageSelection=e,this._languageSelectionListener=this._languageSelection.onDidChange(function(){return t.model.setMode(e.languageIdentifier)}),this.model.setMode(e.languageIdentifier)},e}(),g=o.isLinux||o.isMacintosh?1:2,m=function(e){function t(t,n){var o=e.call(this)||this;return o._onModelAdded=o._register(new i.Emitter),o.onModelAdded=o._onModelAdded.event,o._onModelRemoved=o._register(new i.Emitter),o.onModelRemoved=o._onModelRemoved.event,o._onModelModeChanged=o._register(new i.Emitter),o.onModelModeChanged=o._onModelModeChanged.event,o._configurationService=t,o._resourcePropertiesService=n,o._models={},o._modelCreationOptionsByLanguageAndResource=Object.create(null),o._configurationServiceSubscription=o._configurationService.onDidChangeConfiguration(function(e){return o._updateModelOptions()}),o._updateModelOptions(),o}return r(t,e),t._readModelOptions=function(e,t){var i=s.EDITOR_MODEL_DEFAULTS.tabSize
;if(e.editor&&void 0!==e.editor.tabSize){var n=parseInt(e.editor.tabSize,10);isNaN(n)||(i=n),i<1&&(i=1)}var o=i;if(e.editor&&void 0!==e.editor.indentSize&&"tabSize"!==e.editor.indentSize){var r=parseInt(e.editor.indentSize,10);isNaN(r)||(o=r),o<1&&(o=1)}var a=s.EDITOR_MODEL_DEFAULTS.insertSpaces;e.editor&&void 0!==e.editor.insertSpaces&&(a="false"!==e.editor.insertSpaces&&Boolean(e.editor.insertSpaces));var l=g,u=e.eol;"\r\n"===u?l=2:"\n"===u&&(l=1);var d=s.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace;e.editor&&void 0!==e.editor.trimAutoWhitespace&&(d="false"!==e.editor.trimAutoWhitespace&&Boolean(e.editor.trimAutoWhitespace));var c=s.EDITOR_MODEL_DEFAULTS.detectIndentation;e.editor&&void 0!==e.editor.detectIndentation&&(c="false"!==e.editor.detectIndentation&&Boolean(e.editor.detectIndentation));var h=s.EDITOR_MODEL_DEFAULTS.largeFileOptimizations;return e.editor&&void 0!==e.editor.largeFileOptimizations&&(h="false"!==e.editor.largeFileOptimizations&&Boolean(e.editor.largeFileOptimizations)),{
isForSimpleWidget:t,tabSize:i,indentSize:o,insertSpaces:a,detectIndentation:c,defaultEOL:l,trimAutoWhitespace:d,largeFileOptimizations:h}},t.prototype.getCreationOptions=function(e,i,n){var o=this._modelCreationOptionsByLanguageAndResource[e+i];if(!o){var r=this._configurationService.getValue("editor",{overrideIdentifier:e,resource:i}),s=this._resourcePropertiesService.getEOL(i,e);o=t._readModelOptions({editor:r,eol:s},n),this._modelCreationOptionsByLanguageAndResource[e+i]=o}return o},t.prototype._updateModelOptions=function(){var e=this._modelCreationOptionsByLanguageAndResource;this._modelCreationOptionsByLanguageAndResource=Object.create(null);for(var i=Object.keys(this._models),n=0,o=i.length;n<o;n++){var r=i[n],s=this._models[r],a=s.model.getLanguageIdentifier().language,l=s.model.uri,u=e[a+l],d=this.getCreationOptions(a,l,s.model.isForSimpleWidget);t._setModelOptionsForModel(s.model,d,u)}},t._setModelOptionsForModel=function(e,t,i){
i&&i.detectIndentation===t.detectIndentation&&i.insertSpaces===t.insertSpaces&&i.tabSize===t.tabSize&&i.indentSize===t.indentSize&&i.trimAutoWhitespace===t.trimAutoWhitespace||(t.detectIndentation?(e.detectIndentation(t.insertSpaces,t.tabSize),e.updateOptions({trimAutoWhitespace:t.trimAutoWhitespace})):e.updateOptions({insertSpaces:t.insertSpaces,tabSize:t.tabSize,indentSize:t.indentSize,trimAutoWhitespace:t.trimAutoWhitespace}))},t.prototype.dispose=function(){this._configurationServiceSubscription.dispose(),e.prototype.dispose.call(this)},t.prototype._createModelData=function(e,t,i,n){var o=this,r=this.getCreationOptions(t.language,i,n),s=new a.TextModel(e,r,t,i),l=p(s.uri);if(this._models[l])throw new Error("ModelService: Cannot add model because it already exists!");var u=new f(s,function(e){return o._onWillDispose(e)},function(e,t){return o._onDidChangeLanguage(e,t)});return this._models[l]=u,u},t.prototype.createModel=function(e,t,i,n){void 0===n&&(n=!1);var o
;return t?(o=this._createModelData(e,t.languageIdentifier,i,n),this.setMode(o.model,t)):o=this._createModelData(e,l.PLAINTEXT_LANGUAGE_IDENTIFIER,i,n),this._onModelAdded.fire(o.model),o.model},t.prototype.setMode=function(e,t){if(t){var i=this._models[p(e.uri)];i&&i.setLanguage(t)}},t.prototype.getModels=function(){for(var e=[],t=Object.keys(this._models),i=0,n=t.length;i<n;i++){var o=t[i];e.push(this._models[o].model)}return e},t.prototype.getModel=function(e){var t=p(e),i=this._models[t];return i?i.model:null},t.prototype._onWillDispose=function(e){var t=p(e.uri),i=this._models[t];delete this._models[t],i.dispose(),delete this._modelCreationOptionsByLanguageAndResource[e.getLanguageIdentifier().language+e.uri],this._onModelRemoved.fire(e)},t.prototype._onDidChangeLanguage=function(e,i){var n=i.oldLanguage,o=e.getLanguageIdentifier().language,r=this.getCreationOptions(n,e.uri,e.isForSimpleWidget),s=this.getCreationOptions(o,e.uri,e.isForSimpleWidget);t._setModelOptionsForModel(e,s,r),
this._onModelModeChanged.fire({model:e,oldModeId:n})},t=d([c(0,h.IConfigurationService),c(1,u.ITextResourcePropertiesService)],t)}(n.Disposable);t.ModelServiceImpl=m}),define(t[465],i([1,0,2,66,4,14,39]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t,i){var r=e.call(this)||this;return r._contextKeyService=t,r._configurationService=i,r._onDidChangeAccessibilitySupport=new o.Emitter,r.onDidChangeAccessibilitySupport=r._onDidChangeAccessibilitySupport.event,r._accessibilityModeEnabledContext=n.CONTEXT_ACCESSIBILITY_MODE_ENABLED.bindTo(r._contextKeyService),r._register(r._configurationService.onDidChangeConfiguration(function(e){e.affectsConfiguration("editor.accessibilitySupport")&&r._updateContextKey()})),r._updateContextKey(),r.onDidChangeAccessibilitySupport(function(){return r._updateContextKey()}),r}return r(t,e),t.prototype._updateContextKey=function(){
var e=2===this.getAccessibilitySupport(),t=this._configurationService.getValue("editor.accessibilitySupport");this._accessibilityModeEnabledContext.set("on"===t||"auto"===t&&e)},t=d([c(0,s.IContextKeyService),c(1,a.IConfigurationService)],t)}(i.Disposable);t.AbstractAccessibilityService=l}),define(t[466],i([1,0,14,39,465]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t,i){var n=e.call(this,t,i)||this;return n.contextKeyService=t,n.configurationService=i,n._accessibilitySupport=0,n}return r(t,e),t.prototype.getAccessibilitySupport=function(){return this._accessibilitySupport},t=d([c(0,i.IContextKeyService),c(1,n.IConfigurationService)],t)}(o.AbstractAccessibilityService);t.BrowserAccessibilityService=s}),define(t[467],i([1,0,41,19,23,29,89,39]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t,i){void 0===e&&(e={}),void 0===t&&(t=[]),void 0===i&&(i=[]),this._contents=e,
this._keys=t,this._overrides=i,this.isFrozen=!1}return Object.defineProperty(e.prototype,"contents",{get:function(){return this.checkAndFreeze(this._contents)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"overrides",{get:function(){return this.checkAndFreeze(this._overrides)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"keys",{get:function(){return this.checkAndFreeze(this._keys)},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length},e.prototype.getValue=function(e){return e?l.getConfigurationValue(this.contents,e):this.contents},e.prototype.override=function(t){var i=this.getContentsForOverrideIdentifer(t);if(!i||"object"!=typeof i||!Object.keys(i).length)return this;for(var o={},r=0,a=n.distinct(Object.keys(this.contents).concat(Object.keys(i)));r<a.length;r++){var l=a[r],u=this.contents[l],d=i[l];d&&("object"==typeof u&&"object"==typeof d?(u=s.deepClone(u),
this.mergeContents(u,d)):u=d),o[l]=u}return new e(o)},e.prototype.merge=function(){for(var t=[],i=0;i<arguments.length;i++)t[i]=arguments[i];for(var o=s.deepClone(this.contents),r=s.deepClone(this.overrides),a=this.keys.slice(),l=0,u=t;l<u.length;l++){var d=u[l];this.mergeContents(o,d.contents);for(var c=function(e){var t=r.filter(function(t){return n.equals(t.identifiers,e.identifiers)})[0];t?h.mergeContents(t.contents,e.contents):r.push(s.deepClone(e))},h=this,p=0,f=d.overrides;p<f.length;p++){c(f[p])}for(var g=0,m=d.keys;g<m.length;g++){var v=m[g];-1===a.indexOf(v)&&a.push(v)}}return new e(o,a,r)},e.prototype.freeze=function(){return this.isFrozen=!0,this},e.prototype.mergeContents=function(e,t){for(var i=0,n=Object.keys(t);i<n.length;i++){var r=n[i];r in e&&o.isObject(e[r])&&o.isObject(t[r])?this.mergeContents(e[r],t[r]):e[r]=s.deepClone(t[r])}},e.prototype.checkAndFreeze=function(e){return this.isFrozen&&!Object.isFrozen(e)?s.deepFreeze(e):e},e.prototype.getContentsForOverrideIdentifer=function(e){
for(var t=0,i=this.overrides;t<i.length;t++){var n=i[t];if(-1!==n.identifiers.indexOf(e))return n.contents}return null},e.prototype.toJSON=function(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}},e.prototype.setValue=function(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,function(e){throw new Error(e)})},e.prototype.removeValue=function(e){this.removeKey(e)&&l.removeFromValueTree(this.contents,e)},e.prototype.addKey=function(e){for(var t=this.keys.length,i=0;i<t;i++)0===e.indexOf(this.keys[i])&&(t=i);this.keys.splice(t,1,e)},e.prototype.removeKey=function(e){var t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)},e}();t.ConfigurationModel=u;var d=function(e){function t(){for(var t=l.getDefaultValues(),i=l.getConfigurationKeys(),n=[],o=0,r=Object.keys(t);o<r.length;o++){var s=r[o];a.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[l.overrideIdentifierFromKey(s).trim()],contents:l.toValuesTree(t[s],function(e){
return console.error("Conflict in default settings file: "+e)})})}return e.call(this,t,i,n)||this}return r(t,e),t}(u);t.DefaultConfigurationModel=d;var c=function(){function e(e,t,n,o,r,s,a,l){void 0===n&&(n=new u),void 0===o&&(o=new u),void 0===r&&(r=new i.ResourceMap),void 0===s&&(s=new u),void 0===a&&(a=new i.ResourceMap),void 0===l&&(l=!0),this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=r,this._memoryConfiguration=s,this._memoryConfigurationByResource=a,this._freeze=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap}return e.prototype.getValue=function(e,t,i){return this.getConsolidateConfigurationModel(t,i).getValue(e)},e.prototype.updateValue=function(e,t,i){void 0===i&&(i={});var n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource))||(n=new u,this._memoryConfigurationByResource.set(i.resource,n)):n=this._memoryConfiguration,
void 0===t?n.removeValue(e):n.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)},e.prototype.inspect=function(e,t,i){var n=this.getConsolidateConfigurationModel(t,i),o=this.getFolderConfigurationModelForResource(t.resource,i),r=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return{default:t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),user:t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),userLocal:t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),userRemote:t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),
workspace:i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,workspaceFolder:o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,memory:t.overrideIdentifier?r.override(t.overrideIdentifier).getValue(e):r.getValue(e),value:n.getValue(e)}},Object.defineProperty(e.prototype,"userConfiguration",{get:function(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"localUserConfiguration",{get:function(){return this._localUserConfiguration},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"remoteUserConfiguration",{get:function(){
return this._remoteUserConfiguration},enumerable:!0,configurable:!0}),e.prototype.getConsolidateConfigurationModel=function(e,t){var i=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?i.override(e.overrideIdentifier):i},e.prototype.getConsolidatedConfigurationModelForResource=function(e,t){var i=e.resource,n=this.getWorkspaceConsolidatedConfiguration();if(t&&i){var o=t.getFolder(i);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);var r=this._memoryConfigurationByResource.get(i);r&&(n=n.merge(r))}return n},e.prototype.getWorkspaceConsolidatedConfiguration=function(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration},e.prototype.getFolderConsolidatedConfiguration=function(e){
var t=this._foldersConsolidatedConfigurations.get(e);if(!t){var i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(t=i.merge(n),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t},e.prototype.getFolderConfigurationModelForResource=function(e,t){if(t&&e){var i=t.getFolder(e);if(i)return o.withUndefinedAsNull(this._folderConfigurations.get(i.uri))}return null},e}();t.Configuration=c}),define(t[468],i([1,0,4,2,41,32,39,14,198]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h="data-keybinding-context",p=function(){function e(e,t){this._id=e,this._parent=t,this._value=Object.create(null),this._value._contextId=e}return e.prototype.setValue=function(e,t){return this._value[e]!==t&&(this._value[e]=t,!0)},e.prototype.removeValue=function(e){return e in this._value&&(delete this._value[e],!0)},e.prototype.getValue=function(e){var t=this._value[e]
;return void 0===t&&this._parent?this._parent.getValue(e):t},e}();t.Context=p;var f=function(e){function t(){return e.call(this,-1,null)||this}return r(t,e),t.prototype.setValue=function(e,t){return!1},t.prototype.removeValue=function(e){return!1},t.prototype.getValue=function(e){},t.INSTANCE=new t,t}(p),g=function(e){function t(t,i,n){var r=e.call(this,t,null)||this;return r._configurationService=i,r._values=new Map,r._listener=r._configurationService.onDidChangeConfiguration(function(e){if(6===e.source){var t=o.keys(r._values);r._values.clear(),n.fire(new _(t))}else{for(var i=[],s=0,a=e.affectedKeys;s<a.length;s++){var l="config."+a[s];r._values.has(l)&&(r._values.delete(l),i.push(l))}n.fire(new _(i))}}),r}return r(t,e),t.prototype.dispose=function(){this._listener.dispose()},t.prototype.getValue=function(i){if(0!==i.indexOf(t._keyPrefix))return e.prototype.getValue.call(this,i);if(this._values.has(i))return this._values.get(i)
;var n=i.substr(t._keyPrefix.length),o=this._configurationService.getValue(n),r=void 0;switch(typeof o){case"number":case"boolean":case"string":r=o}return this._values.set(i,r),r},t.prototype.setValue=function(t,i){return e.prototype.setValue.call(this,t,i)},t.prototype.removeValue=function(t){return e.prototype.removeValue.call(this,t)},t._keyPrefix="config.",t}(p),m=function(){function e(e,t,i){this._service=e,this._key=t,this._defaultValue=i,this.reset()}return e.prototype.set=function(e){this._service.setContext(this._key,e)},e.prototype.reset=function(){void 0===this._defaultValue?this._service.removeContext(this._key):this._service.setContext(this._key,this._defaultValue)},e.prototype.get=function(){return this._service.getContextKeyValue(this._key)},e}(),v=function(){function e(e){this.key=e}return e.prototype.affectsSome=function(e){return e.has(this.key)},e}(),_=function(){function e(e){this.keys=e}return e.prototype.affectsSome=function(e){for(var t=0,i=this.keys;t<i.length;t++){var n=i[t]
;if(e.has(n))return!0}return!1},e}(),y=function(){function e(e){this.events=e}return e.prototype.affectsSome=function(e){for(var t=0,i=this.events;t<i.length;t++){if(i[t].affectsSome(e))return!0}return!1},e}(),b=function(){function e(e){this._onDidChangeContext=new i.PauseableEmitter({merge:function(e){return new y(e)}}),this._isDisposed=!1,this._myContextId=e}return e.prototype.createKey=function(e,t){if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");return new m(this,e,t)},Object.defineProperty(e.prototype,"onDidChangeContext",{get:function(){return this._onDidChangeContext.event},enumerable:!0,configurable:!0}),e.prototype.bufferChangeEvents=function(e){this._onDidChangeContext.pause();try{e()}finally{this._onDidChangeContext.resume()}},e.prototype.createScoped=function(e){if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");return new S(this,e)},e.prototype.contextMatchesRules=function(e){
if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");var t=this.getContextValuesContainer(this._myContextId);return u.KeybindingResolver.contextMatchesRules(t,e)},e.prototype.getContextKeyValue=function(e){if(!this._isDisposed)return this.getContextValuesContainer(this._myContextId).getValue(e)},e.prototype.setContext=function(e,t){if(!this._isDisposed){var i=this.getContextValuesContainer(this._myContextId);i&&i.setValue(e,t)&&this._onDidChangeContext.fire(new v(e))}},e.prototype.removeContext=function(e){this._isDisposed||this.getContextValuesContainer(this._myContextId).removeValue(e)&&this._onDidChangeContext.fire(new v(e))},e.prototype.getContext=function(e){return this._isDisposed?f.INSTANCE:this.getContextValuesContainer(function(e){for(;e;){if(e.hasAttribute(h)){var t=e.getAttribute(h);return t?parseInt(t,10):NaN}e=e.parentElement}return 0}(e))},e}();t.AbstractContextKeyService=b;var C=function(e){function t(t){var i=e.call(this,0)||this;i._contexts=new Map,
i._toDispose=new n.DisposableStore,i._lastContextId=0;var o=new g(i._myContextId,t,i._onDidChangeContext);return i._contexts.set(i._myContextId,o),i._toDispose.add(o),i}return r(t,e),t.prototype.dispose=function(){this._isDisposed=!0,this._toDispose.dispose()},t.prototype.getContextValuesContainer=function(e){return this._isDisposed?f.INSTANCE:this._contexts.get(e)||f.INSTANCE},t.prototype.createChildContext=function(e){if(void 0===e&&(e=this._myContextId),this._isDisposed)throw new Error("ContextKeyService has been disposed");var t=++this._lastContextId;return this._contexts.set(t,new p(t,this.getContextValuesContainer(e))),t},t.prototype.disposeContext=function(e){this._isDisposed||this._contexts.delete(e)},t=d([c(0,a.IConfigurationService)],t)}(b);t.ContextKeyService=C;var S=function(e){function t(t,i){var n=e.call(this,t.createChildContext())||this;return n._parent=t,i&&(n._domNode=i,n._domNode.setAttribute(h,String(n._myContextId))),n}return r(t,e),t.prototype.dispose=function(){this._isDisposed=!0,
this._parent.disposeContext(this._myContextId),this._domNode&&(this._domNode.removeAttribute(h),this._domNode=void 0)},Object.defineProperty(t.prototype,"onDidChangeContext",{get:function(){return i.Event.any(this._parent.onDidChangeContext,this._onDidChangeContext.event)},enumerable:!0,configurable:!0}),t.prototype.getContextValuesContainer=function(e){return this._isDisposed?f.INSTANCE:this._parent.getContextValuesContainer(e)},t.prototype.createChildContext=function(e){if(void 0===e&&(e=this._myContextId),this._isDisposed)throw new Error("ScopedContextKeyService has been disposed");return this._parent.createChildContext(e)},t.prototype.disposeContext=function(e){this._isDisposed||this._parent.disposeContext(e)},t}(b);s.CommandsRegistry.registerCommand(l.SET_CONTEXT_COMMAND_ID,function(e,t,i){e.get(l.IContextKeyService).createKey(String(t),i)})}),define(t[84],i([1,0,38,18,32,46]),function(e,t,i,n,o,r){"use strict";function s(e,t){
return e.weight1!==t.weight1?e.weight1-t.weight1:e.command<t.command?-1:e.command>t.command?1:e.weight2-t.weight2}Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(){this._coreKeybindings=[],this._extensionKeybindings=[],this._cachedMergedKeybindings=null}return e.bindToCurrentPlatform=function(e){if(1===n.OS){if(e&&e.win)return e.win}else if(2===n.OS){if(e&&e.mac)return e.mac}else if(e&&e.linux)return e.linux;return e},e.prototype.registerKeybindingRule=function(t){var o=e.bindToCurrentPlatform(t);if(o&&o.primary){(l=i.createKeybinding(o.primary,n.OS))&&this._registerDefaultKeybinding(l,t.id,void 0,t.weight,0,t.when)}if(o&&Array.isArray(o.secondary))for(var r=0,s=o.secondary.length;r<s;r++){var a=o.secondary[r],l=i.createKeybinding(a,n.OS);l&&this._registerDefaultKeybinding(l,t.id,void 0,t.weight,-r-1,t.when)}},e.prototype.registerCommandAndKeybindingRule=function(e){this.registerKeybindingRule(e),o.CommandsRegistry.registerCommand(e)},e._mightProduceChar=function(e){
return e>=21&&e<=30||(e>=31&&e<=56||(80===e||81===e||82===e||83===e||84===e||85===e||86===e||110===e||111===e||87===e||88===e||89===e||90===e||91===e||92===e))},e.prototype._assertNoCtrlAlt=function(t,i){t.ctrlKey&&t.altKey&&!t.metaKey&&e._mightProduceChar(t.keyCode)&&console.warn("Ctrl+Alt+ keybindings should not be used by default under Windows. Offender: ",t," for ",i)},e.prototype._registerDefaultKeybinding=function(e,t,i,o,r,s){1===n.OS&&this._assertNoCtrlAlt(e.parts[0],t),this._coreKeybindings.push({keybinding:e,command:t,commandArgs:i,when:s,weight1:o,weight2:r}),this._cachedMergedKeybindings=null},e.prototype.getDefaultKeybindings=function(){return this._cachedMergedKeybindings||(this._cachedMergedKeybindings=[].concat(this._coreKeybindings).concat(this._extensionKeybindings),this._cachedMergedKeybindings.sort(s)),this._cachedMergedKeybindings.slice(0)},e}();t.KeybindingsRegistry=new a,t.Extensions={EditorModes:"platform.keybindingsRegistry"},
r.Registry.add(t.Extensions.EditorModes,t.KeybindingsRegistry)}),define(t[470],i([1,0,14,285,84,286]),function(e,t,i,n,o,s){"use strict";function a(e,t){return e.getContext(document.activeElement).getValue(t)}function l(e,n){var o=function(e,t){return e.createScoped(t.target)}(e,n);!function(e,t,n){new i.RawContextKey(n,t).bindTo(e)}(o,n,t.HistoryNavigationWidgetContext);return{scopedContextKeyService:o,historyNavigationEnablement:new i.RawContextKey(t.HistoryNavigationEnablementContext,!0).bindTo(o)}}Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigationWidgetContext="historyNavigationWidget",t.HistoryNavigationEnablementContext="historyNavigationEnabled",t.createAndBindHistoryNavigationWidgetScopedContextKeyService=l;var u=function(e){function t(t,i,n,o,r){void 0===r&&(r=!1);var s=e.call(this,t,i,r,n)||this;return s._register(l(o,{target:s.inputBox.element,historyNavigator:s.inputBox}).scopedContextKeyService),s}return r(t,e),t=d([c(3,i.IContextKeyService)],t)}(n.FindInput)
;t.ContextScopedFindInput=u;var h=function(e){function t(t,i,n,o,r){void 0===r&&(r=!1);var s=e.call(this,t,i,r,n)||this;return s._register(l(o,{target:s.inputBox.element,historyNavigator:s.inputBox}).scopedContextKeyService),s}return r(t,e),t=d([c(3,i.IContextKeyService)],t)}(s.ReplaceInput);t.ContextScopedReplaceInput=h,o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"history.showPrevious",weight:200,when:i.ContextKeyExpr.and(i.ContextKeyExpr.has(t.HistoryNavigationWidgetContext),i.ContextKeyExpr.equals(t.HistoryNavigationEnablementContext,!0)),primary:16,secondary:[528],handler:function(e,n){var o=a(e.get(i.IContextKeyService),t.HistoryNavigationWidgetContext);if(o){o.historyNavigator.showPreviousValue()}}}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"history.showNext",weight:200,when:i.ContextKeyExpr.and(i.ContextKeyExpr.has(t.HistoryNavigationWidgetContext),i.ContextKeyExpr.equals(t.HistoryNavigationEnablementContext,!0)),primary:18,secondary:[530],handler:function(e,n){
var o=a(e.get(i.IContextKeyService),t.HistoryNavigationWidgetContext);if(o){o.historyNavigator.showNextValue()}}})}),define(t[68],i([1,0,12,4,2,23]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStorageService=i.createDecorator("storageService");!function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"}(t.WillSaveStateReason||(t.WillSaveStateReason={}));var a=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._serviceBrand=null,t._onDidChangeStorage=t._register(new n.Emitter),t.onDidChangeStorage=t._onDidChangeStorage.event,t.onWillSaveState=n.Event.None,t.globalCache=new Map,t.workspaceCache=new Map,t}return r(t,e),t.prototype.getCache=function(e){return 0===e?this.globalCache:this.workspaceCache},t.prototype.get=function(e,t,i){var n=this.getCache(t).get(e);return s.isUndefinedOrNull(n)?i:n},t.prototype.getBoolean=function(e,t,i){var n=this.getCache(t).get(e);return s.isUndefinedOrNull(n)?i:"true"===n},t.prototype.store=function(e,t,i){
if(s.isUndefinedOrNull(t))return this.remove(e,i);var n=String(t);return this.getCache(i).get(e)===n?Promise.resolve():(this.getCache(i).set(e,n),this._onDidChangeStorage.fire({scope:i,key:e}),Promise.resolve())},t.prototype.remove=function(e,t){return this.getCache(t).delete(e)?(this._onDidChangeStorage.fire({scope:t,key:e}),Promise.resolve()):Promise.resolve()},t}(o.Disposable);t.InMemoryStorageService=a}),define(t[472],i([1,0,41,68,17,2,15,12,39,73]),function(e,t,i,n,o,s,a,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(){function e(){}return e.prototype.select=function(e,t,i){if(0===i.length)return 0;for(var n=i[0].score[0],o=1;o<i.length;o++){var r=i[o],s=r.score,a=r.completion;if(s[0]!==n)break;if(a.preselect)return o}return 0},e}();t.Memory=p;var f=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.memorize=function(e,t,i){},t.prototype.toJSON=function(){},t.prototype.fromJSON=function(){},t}(p);t.NoMemory=f
;var g=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._cache=new i.LRUCache(300,.66),t._seq=0,t}return r(t,e),t.prototype.memorize=function(e,t,i){var n=i.completion.label,o=e.getLanguageIdentifier().language+"/"+n;this._cache.set(o,{touch:this._seq++,type:i.completion.kind,insertText:i.completion.insertText})},t.prototype.select=function(t,i,n){if(0===n.length)return 0;var o=t.getLineContent(i.lineNumber).substr(i.column-10,i.column-1);if(/\s$/.test(o))return e.prototype.select.call(this,t,i,n);for(var r=n[0].score[0],s=-1,a=-1,l=-1,u=0;u<n.length&&n[u].score[0]===r;u++){var d=t.getLanguageIdentifier().language+"/"+n[u].completion.label,c=this._cache.peek(d);if(c&&c.touch>l&&c.type===n[u].completion.kind&&c.insertText===n[u].completion.insertText&&(l=c.touch,a=u),n[u].completion.preselect&&-1===s)return s=u}return-1!==a?a:-1!==s?s:0},t.prototype.toJSON=function(){var e=[];return this._cache.forEach(function(t,i){e.push([i,t])}),e},t.prototype.fromJSON=function(e){
this._cache.clear();for(var t=0,i=e;t<i.length;t++){var n=i[t],r=n[0],s=n[1];s.touch=0,s.type="number"==typeof s.type?s.type:o.completionKindFromString(s.type),this._cache.set(r,s)}this._seq=this._cache.size},t}(p);t.LRUMemory=g;var m=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._trie=i.TernarySearchTree.forStrings(),t._seq=0,t}return r(t,e),t.prototype.memorize=function(e,t,i){var n=e.getWordUntilPosition(t).word,o=e.getLanguageIdentifier().language+"/"+n;this._trie.set(o,{type:i.completion.kind,insertText:i.completion.insertText,touch:this._seq++})},t.prototype.select=function(t,i,n){var o=t.getWordUntilPosition(i).word;if(!o)return e.prototype.select.call(this,t,i,n);var r=t.getLanguageIdentifier().language+"/"+o,s=this._trie.get(r);if(s||(s=this._trie.findSubstr(r)),s)for(var a=0;a<n.length;a++){var l=n[a].completion,u=l.kind,d=l.insertText;if(u===s.type&&d===s.insertText)return a}return e.prototype.select.call(this,t,i,n)},t.prototype.toJSON=function(){var e=[]
;return this._trie.forEach(function(t,i){return e.push([i,t])}),e.sort(function(e,t){return-(e[1].touch-t[1].touch)}).forEach(function(e,t){return e[1].touch=t}),e.slice(0,200)},t.prototype.fromJSON=function(e){if(this._trie.clear(),e.length>0){this._seq=e[0][1].touch+1;for(var t=0,i=e;t<i.length;t++){var n=i[t],r=n[0],s=n[1];s.type="number"==typeof s.type?s.type:o.completionKindFromString(s.type),this._trie.set(r,s)}}},t}(p);t.PrefixMemory=m;var v=function(e){function t(t,i){var o=e.call(this)||this;o._storageService=t,o._configService=i,o._storagePrefix="suggest/memories";var r=function(){var e=o._configService.getValue("editor.suggestSelection"),t=o._configService.getValue("editor.suggest.shareSuggestSelections");o._update(e,t,!1)};return o._persistSoon=o._register(new a.RunOnceScheduler(function(){return o._saveState()},500)),o._register(t.onWillSaveState(function(e){e.reason===n.WillSaveStateReason.SHUTDOWN&&o._saveState()})),o._register(o._configService.onDidChangeConfiguration(function(e){
(e.affectsConfiguration("editor.suggestSelection")||e.affectsConfiguration("editor.suggest.shareSuggestSelections"))&&r()})),o._register(o._storageService.onDidChangeStorage(function(e){0===e.scope&&0===e.key.indexOf(o._storagePrefix)&&(document.hasFocus()||o._update(o._mode,o._shareMem,!0))})),r(),o}return r(t,e),t.prototype._update=function(e,t,i){if(i||this._mode!==e||this._shareMem!==t){this._shareMem=t,this._mode=e,this._strategy="recentlyUsedByPrefix"===e?new m:"recentlyUsed"===e?new g:new f;try{var n=t?0:1,o=this._storageService.get(this._storagePrefix+"/"+this._mode,n);o&&this._strategy.fromJSON(JSON.parse(o))}catch(e){}}},t.prototype.memorize=function(e,t,i){this._strategy.memorize(e,t,i),this._persistSoon.schedule()},t.prototype.select=function(e,t,i){return this._strategy.select(e,t,i)},t.prototype._saveState=function(){var e=JSON.stringify(this._strategy),t=this._shareMem?0:1;this._storageService.store(this._storagePrefix+"/"+this._mode,e,t)},
t=d([c(0,n.IStorageService),c(1,u.IConfigurationService)],t)}(s.Disposable);t.SuggestMemoryService=v,t.ISuggestMemoryService=l.createDecorator("ISuggestMemories"),h.registerSingleton(t.ISuggestMemoryService,v,!0)}),define(t[103],i([1,0,12]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ITelemetryService=i.createDecorator("telemetryService")}),define(t[11],i([1,0,10,24,31,13,42,76,59,32,14,84,46,103,23]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g){"use strict";function m(e,t){d.CommandsRegistry.registerCommand(e,function(e,i){return t(e,i||{})})}Object.defineProperty(t,"__esModule",{value:!0});var v=function(){function e(e){this.id=e.id,this.precondition=e.precondition,this._kbOpts=e.kbOpts,this._menubarOpts=e.menubarOpts,this._description=e.description}return e.prototype.register=function(){var e=this;if(this._menubarOpts&&u.MenuRegistry.appendMenuItem(this._menubarOpts.menuId,{group:this._menubarOpts.group,command:{id:this.id,title:this._menubarOpts.title},
when:this._menubarOpts.when,order:this._menubarOpts.order}),this._kbOpts){var t=this._kbOpts.kbExpr;this.precondition&&(t=t?c.ContextKeyExpr.and(t,this.precondition):this.precondition),h.KeybindingsRegistry.registerCommandAndKeybindingRule({id:this.id,handler:function(t,i){return e.runCommand(t,i)},weight:this._kbOpts.weight,when:t,primary:this._kbOpts.primary,secondary:this._kbOpts.secondary,win:this._kbOpts.win,linux:this._kbOpts.linux,mac:this._kbOpts.mac,description:this._description})}else d.CommandsRegistry.registerCommand({id:this.id,handler:function(t,i){return e.runCommand(t,i)},description:this._description})},e}();t.Command=v;var _=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.bindToContribution=function(e){return function(t){function i(e){var i=t.call(this,e)||this;return i._callback=e.handler,i}return r(i,t),i.prototype.runEditorCommand=function(t,i,n){e(i)&&this._callback(e(i),n)},i}(t)},t.prototype.runCommand=function(e,t){
var i=this,n=e.get(o.ICodeEditorService),r=n.getFocusedCodeEditor()||n.getActiveCodeEditor();if(r)return r.invokeWithinContext(function(e){if(e.get(c.IContextKeyService).contextMatchesRules(g.withNullAsUndefined(i.precondition)))return i.runEditorCommand(e,r,t)})},t}(v);t.EditorCommand=_;var y=function(e){function t(t){var i=e.call(this,t)||this;return i.label=t.label,i.alias=t.alias,i.menuOpts=t.menuOpts,i}return r(t,e),t.prototype.register=function(){this.menuOpts&&u.MenuRegistry.appendMenuItem(7,{command:{id:this.id,title:this.label},when:c.ContextKeyExpr.and(this.precondition,this.menuOpts.when),group:this.menuOpts.group,order:this.menuOpts.order}),e.prototype.register.call(this)},t.prototype.runEditorCommand=function(e,t,i){return this.reportTelemetry(e,t),this.run(e,t,i||{})},t.prototype.reportTelemetry=function(e,t){e.get(f.ITelemetryService).publicLog2("editorActionInvoked",{name:this.label,id:this.id})},t}(_);t.EditorAction=y,t.registerLanguageCommand=m,t.registerDefaultLanguageCommand=function(e,t){
m(e,function(e,o){var r=o.resource,u=o.position;if(!(r instanceof n.URI))throw i.illegalArgument("resource");if(!s.Position.isIPosition(u))throw i.illegalArgument("position");var d=e.get(a.IModelService).getModel(r);if(d){var c=s.Position.lift(u);return t(d,c,o)}return e.get(l.ITextModelService).createModelReference(r).then(function(e){return new Promise(function(i,n){try{i(t(e.object.textEditorModel,s.Position.lift(u),o))}catch(e){n(e)}}).finally(function(){e.dispose()})})})},t.registerEditorCommand=function(e){return b.INSTANCE.registerEditorCommand(e),e},t.registerEditorAction=function(e){b.INSTANCE.registerEditorAction(new e)},t.registerInstantiatedEditorAction=function(e){b.INSTANCE.registerEditorAction(e)},t.registerEditorContribution=function(e){b.INSTANCE.registerEditorContribution(e)};!function(e){e.getEditorCommand=function(e){return b.INSTANCE.getEditorCommand(e)},e.getEditorActions=function(){return b.INSTANCE.getEditorActions()},e.getEditorContributions=function(){
return b.INSTANCE.getEditorContributions()}}(t.EditorExtensionsRegistry||(t.EditorExtensionsRegistry={}));var b=function(){function e(){this.editorContributions=[],this.editorActions=[],this.editorCommands=Object.create(null)}return e.prototype.registerEditorContribution=function(e){this.editorContributions.push(e)},e.prototype.registerEditorAction=function(e){e.register(),this.editorActions.push(e)},e.prototype.getEditorContributions=function(){return this.editorContributions.slice(0)},e.prototype.getEditorActions=function(){return this.editorActions.slice(0)},e.prototype.registerEditorCommand=function(e){e.register(),this.editorCommands[e.id]=e},e.prototype.getEditorCommand=function(e){return this.editorCommands[e]||null},e.INSTANCE=new e,e}();p.Registry.add("editor.contributions",b.INSTANCE)}),define(t[120],i([1,0,306,23,11,31,392,36,191,192,146,13,3,72,21,14]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m){"use strict";function v(e){e.register()}function _(e,t){v(new L("default:"+e,e)),v(new L(e,e,t))}
Object.defineProperty(t,"__esModule",{value:!0});var y=0,b=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var n=t._getCursors();n&&this.runCoreEditorCommand(n,i||{})},t}(o.EditorCommand);t.CoreEditorCommand=b;var C;!function(e){e.description={description:"Scroll editor in the given direction",args:[{name:"Editor scroll argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'to': A mandatory direction value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'up', 'down'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'by': Unit to move. Default is computed based on 'to' value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'line', 'wrappedLine', 'page', 'halfPage'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'value': Number of units to move. Default is '1'.\n\t\t\t\t\t* 'revealCursor': If 'true' reveals the cursor if it is outside view port.\n\t\t\t\t",constraint:function(e){if(!n.isObject(e))return!1;var t=e
;return!(!n.isString(t.to)||!n.isUndefined(t.by)&&!n.isString(t.by)||!n.isUndefined(t.value)&&!n.isNumber(t.value)||!n.isUndefined(t.revealCursor)&&!n.isBoolean(t.revealCursor))},schema:{type:"object",required:["to"],properties:{to:{type:"string",enum:["up","down"]},by:{type:"string",enum:["line","wrappedLine","page","halfPage"]},value:{type:"number",default:1},revealCursor:{type:"boolean"}}}}]},e.RawDirection={Up:"up",Down:"down"},e.RawUnit={Line:"line",WrappedLine:"wrappedLine",Page:"page",HalfPage:"halfPage"},e.parse=function(t){var i;switch(t.to){case e.RawDirection.Up:i=1;break;case e.RawDirection.Down:i=2;break;default:return null}var n;switch(t.by){case e.RawUnit.Line:n=1;break;case e.RawUnit.WrappedLine:n=2;break;case e.RawUnit.Page:n=3;break;case e.RawUnit.HalfPage:n=4;break;default:n=2}return{direction:i,unit:n,value:Math.floor(t.value||1),revealCursor:!!t.revealCursor,select:!!t.select}}}(C=t.EditorScroll_||(t.EditorScroll_={}));var S;!function(e){e.description={
description:"Reveal the given line at the given logical position",args:[{name:"Reveal line argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'lineNumber': A mandatory line number value.\n\t\t\t\t\t* 'at': Logical position at which line has to be revealed .\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'top', 'center', 'bottom'\n\t\t\t\t\t\t```\n\t\t\t\t",constraint:function(e){if(!n.isObject(e))return!1;var t=e;return!(!n.isNumber(t.lineNumber)||!n.isUndefined(t.at)&&!n.isString(t.at))},schema:{type:"object",required:["lineNumber"],properties:{lineNumber:{type:"number"},at:{type:"string",enum:["top","center","bottom"]}}}}]},e.RawAtArgument={Top:"top",Center:"center",Bottom:"bottom"}}(S=t.RevealLine_||(t.RevealLine_={}));var w;!function(e){var t=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),
e.setStates(t.source,3,[d.CursorMoveCommands.moveTo(e.context,e.getPrimaryCursor(),this._inSelectionMode,t.position,t.viewPosition)]),e.reveal(!0,0,0)},t}(b);e.MoveTo=o.registerEditorCommand(new t({id:"_moveTo",inSelectionMode:!1,precondition:void 0})),e.MoveToSelect=o.registerEditorCommand(new t({id:"_moveToSelect",inSelectionMode:!0,precondition:void 0}));var i=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement();var i=this._getColumnSelectResult(e.context,e.getPrimaryCursor(),e.getColumnSelectData(),t);e.setStates(t.source,3,i.viewStates.map(function(e){return l.CursorState.fromViewState(e)})),e.setColumnSelectData({isReal:!0,fromViewLineNumber:i.fromLineNumber,fromViewVisualColumn:i.fromVisualColumn,toViewLineNumber:i.toLineNumber,toViewVisualColumn:i.toVisualColumn}),e.reveal(!0,i.reversed?1:2,0)},t}(b);e.ColumnSelect=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{
id:"columnSelect",precondition:void 0})||this}return r(t,e),t.prototype._getColumnSelectResult=function(e,t,i,n){var o=e.model.validatePosition(n.position),r=e.validateViewPosition(new h.Position(n.viewPosition.lineNumber,n.viewPosition.column),o),s=i.fromViewLineNumber,l=i.fromViewVisualColumn;return!i.isReal&&n.setAnchorIfNotSet&&(s=r.lineNumber,l=n.mouseColumn-1),a.ColumnSelection.columnSelect(e.config,e.viewModel,s,l,r.lineNumber,n.mouseColumn-1)},t}(i))),e.CursorColumnSelectLeft=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"cursorColumnSelectLeft",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3599,linux:{primary:0}}})||this}return r(t,e),t.prototype._getColumnSelectResult=function(e,t,i,n){return a.ColumnSelection.columnSelectLeft(e.config,e.viewModel,i)},t}(i))),e.CursorColumnSelectRight=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"cursorColumnSelectRight",precondition:void 0,kbOpts:{weight:y,
kbExpr:g.EditorContextKeys.textInputFocus,primary:3601,linux:{primary:0}}})||this}return r(t,e),t.prototype._getColumnSelectResult=function(e,t,i,n){return a.ColumnSelection.columnSelectRight(e.config,e.viewModel,i)},t}(i)));var n=function(e){function t(t){var i=e.call(this,t)||this;return i._isPaged=t.isPaged,i}return r(t,e),t.prototype._getColumnSelectResult=function(e,t,i,n){return a.ColumnSelection.columnSelectUp(e.config,e.viewModel,i,this._isPaged)},t}(i);e.CursorColumnSelectUp=o.registerEditorCommand(new n({isPaged:!1,id:"cursorColumnSelectUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3600,linux:{primary:0}}})),e.CursorColumnSelectPageUp=o.registerEditorCommand(new n({isPaged:!0,id:"cursorColumnSelectPageUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3595,linux:{primary:0}}}));var s=function(e){function t(t){var i=e.call(this,t)||this;return i._isPaged=t.isPaged,i}return r(t,e),
t.prototype._getColumnSelectResult=function(e,t,i,n){return a.ColumnSelection.columnSelectDown(e.config,e.viewModel,i,this._isPaged)},t}(i);e.CursorColumnSelectDown=o.registerEditorCommand(new s({isPaged:!1,id:"cursorColumnSelectDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3602,linux:{primary:0}}})),e.CursorColumnSelectPageDown=o.registerEditorCommand(new s({isPaged:!0,id:"cursorColumnSelectPageDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3596,linux:{primary:0}}}));var u=function(e){function t(){return e.call(this,{id:"cursorMove",precondition:void 0,description:d.CursorMove.description})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){var i=d.CursorMove.parse(t);i&&this._runCursorMove(e,t.source,i)},t.prototype._runCursorMove=function(e,t,i){e.context.model.pushStackElement(),e.setStates(t,3,d.CursorMoveCommands.move(e.context,e.getAll(),i)),e.reveal(!0,0,0)},t}(b);e.CursorMoveImpl=u,
e.CursorMove=o.registerEditorCommand(new u);var c=function(t){function i(e){var i=t.call(this,e)||this;return i._staticArgs=e.args,i}return r(i,t),i.prototype.runCoreEditorCommand=function(t,i){var n=this._staticArgs;-1===this._staticArgs.value&&(n={direction:this._staticArgs.direction,unit:this._staticArgs.unit,select:this._staticArgs.select,value:t.context.config.pageSize}),e.CursorMove._runCursorMove(t,i.source,n)},i}(b);e.CursorLeft=o.registerEditorCommand(new c({args:{direction:0,unit:0,select:!1,value:1},id:"cursorLeft",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:15,mac:{primary:15,secondary:[288]}}})),e.CursorLeftSelect=o.registerEditorCommand(new c({args:{direction:0,unit:0,select:!0,value:1},id:"cursorLeftSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1039}})),e.CursorRight=o.registerEditorCommand(new c({args:{direction:1,unit:0,select:!1,value:1},id:"cursorRight",precondition:void 0,kbOpts:{weight:y,
kbExpr:g.EditorContextKeys.textInputFocus,primary:17,mac:{primary:17,secondary:[292]}}})),e.CursorRightSelect=o.registerEditorCommand(new c({args:{direction:1,unit:0,select:!0,value:1},id:"cursorRightSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1041}})),e.CursorUp=o.registerEditorCommand(new c({args:{direction:2,unit:2,select:!1,value:1},id:"cursorUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:16,mac:{primary:16,secondary:[302]}}})),e.CursorUpSelect=o.registerEditorCommand(new c({args:{direction:2,unit:2,select:!0,value:1},id:"cursorUpSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1040,secondary:[3088],mac:{primary:1040},linux:{primary:1040}}})),e.CursorPageUp=o.registerEditorCommand(new c({args:{direction:2,unit:2,select:!1,value:-1},id:"cursorPageUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:11}})),
e.CursorPageUpSelect=o.registerEditorCommand(new c({args:{direction:2,unit:2,select:!0,value:-1},id:"cursorPageUpSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1035}})),e.CursorDown=o.registerEditorCommand(new c({args:{direction:3,unit:2,select:!1,value:1},id:"cursorDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:18,mac:{primary:18,secondary:[300]}}})),e.CursorDownSelect=o.registerEditorCommand(new c({args:{direction:3,unit:2,select:!0,value:1},id:"cursorDownSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1042,secondary:[3090],mac:{primary:1042},linux:{primary:1042}}})),e.CursorPageDown=o.registerEditorCommand(new c({args:{direction:3,unit:2,select:!1,value:-1},id:"cursorPageDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:12}})),e.CursorPageDownSelect=o.registerEditorCommand(new c({args:{direction:3,unit:2,select:!0,value:-1},
id:"cursorPageDownSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1036}})),e.CreateCursor=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"createCursor",precondition:void 0})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){var i,n=e.context;i=t.wholeLine?d.CursorMoveCommands.line(n,e.getPrimaryCursor(),!1,t.position,t.viewPosition):d.CursorMoveCommands.moveTo(n,e.getPrimaryCursor(),!1,t.position,t.viewPosition);var o=e.getAll();if(o.length>1)for(var r=i.modelState?i.modelState.position:null,s=i.viewState?i.viewState.position:null,a=0,l=o.length;a<l;a++){var u=o[a];if((!r||u.modelState.selection.containsPosition(r))&&(!s||u.viewState.selection.containsPosition(s)))return o.splice(a,1),e.context.model.pushStackElement(),void e.setStates(t.source,3,o)}o.push(i),e.context.model.pushStackElement(),e.setStates(t.source,3,o)},t}(b))),e.LastCursorMoveToSelect=o.registerEditorCommand(new(function(e){function t(){
return e.call(this,{id:"_lastCursorMoveToSelect",precondition:void 0})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){var i=e.context,n=e.getLastAddedCursorIndex(),o=e.getAll(),r=o.slice(0);r[n]=d.CursorMoveCommands.moveTo(i,o[n],!0,t.position,t.viewPosition),e.context.model.pushStackElement(),e.setStates(t.source,3,r)},t}(b)));var f=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,d.CursorMoveCommands.moveToBeginningOfLine(e.context,e.getAll(),this._inSelectionMode)),e.reveal(!0,0,0)},t}(b);e.CursorHome=o.registerEditorCommand(new f({inSelectionMode:!1,id:"cursorHome",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:14,mac:{primary:14,secondary:[2063]}}})),e.CursorHomeSelect=o.registerEditorCommand(new f({inSelectionMode:!0,id:"cursorHomeSelect",precondition:void 0,kbOpts:{weight:y,
kbExpr:g.EditorContextKeys.textInputFocus,primary:1038,mac:{primary:1038,secondary:[3087]}}})),e.CursorLineStart=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"cursorLineStart",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:0,mac:{primary:287}}})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,this._exec(e.context,e.getAll())),e.reveal(!0,0,0)},t.prototype._exec=function(e,t){for(var i=[],n=0,o=t.length;n<o;n++){var r=t[n],s=r.modelState.position.lineNumber;i[n]=l.CursorState.fromModelState(r.modelState.move(!1,s,1,0))}return i},t}(b)));var m=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,d.CursorMoveCommands.moveToEndOfLine(e.context,e.getAll(),this._inSelectionMode)),e.reveal(!0,0,0)},t}(b)
;e.CursorEnd=o.registerEditorCommand(new m({inSelectionMode:!1,id:"cursorEnd",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:13,mac:{primary:13,secondary:[2065]}}})),e.CursorEndSelect=o.registerEditorCommand(new m({inSelectionMode:!0,id:"cursorEndSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1037,mac:{primary:1037,secondary:[3089]}}})),e.CursorLineEnd=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"cursorLineEnd",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:0,mac:{primary:291}}})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,this._exec(e.context,e.getAll())),e.reveal(!0,0,0)},t.prototype._exec=function(e,t){for(var i=[],n=0,o=t.length;n<o;n++){var r=t[n],s=r.modelState.position.lineNumber,a=e.model.getLineMaxColumn(s)
;i[n]=l.CursorState.fromModelState(r.modelState.move(!1,s,a,0))}return i},t}(b)));var v=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,d.CursorMoveCommands.moveToBeginningOfBuffer(e.context,e.getAll(),this._inSelectionMode)),e.reveal(!0,0,0)},t}(b);e.CursorTop=o.registerEditorCommand(new v({inSelectionMode:!1,id:"cursorTop",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2062,mac:{primary:2064}}})),e.CursorTopSelect=o.registerEditorCommand(new v({inSelectionMode:!0,id:"cursorTopSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3086,mac:{primary:3088}}}));var _=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),
e.setStates(t.source,3,d.CursorMoveCommands.moveToEndOfBuffer(e.context,e.getAll(),this._inSelectionMode)),e.reveal(!0,0,0)},t}(b);e.CursorBottom=o.registerEditorCommand(new _({inSelectionMode:!1,id:"cursorBottom",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2061,mac:{primary:2066}}})),e.CursorBottomSelect=o.registerEditorCommand(new _({inSelectionMode:!0,id:"cursorBottomSelect",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:3085,mac:{primary:3090}}}));var w=function(e){function t(){return e.call(this,{id:"editorScroll",precondition:void 0,description:C.description})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){var i=C.parse(t);i&&this._runEditorScroll(e,t.source,i)},t.prototype._runEditorScroll=function(e,t,i){var n=this._computeDesiredScrollTop(e.context,i);if(i.revealCursor){var o=e.context.getCompletelyVisibleViewRangeAtScrollTop(n)
;e.setStates(t,3,[d.CursorMoveCommands.findPositionInViewportIfOutside(e.context,e.getPrimaryCursor(),o,i.select)])}e.scrollTo(n)},t.prototype._computeDesiredScrollTop=function(e,t){if(1===t.unit){var i=e.getCompletelyVisibleModelRange(),n=void 0;n=1===t.direction?Math.max(1,i.startLineNumber-t.value):Math.min(e.model.getLineCount(),i.startLineNumber+t.value);var o=e.convertModelPositionToViewPosition(new h.Position(n,1));return e.getVerticalOffsetForViewLine(o.lineNumber)}var r;r=3===t.unit?e.config.pageSize*t.value:4===t.unit?Math.round(e.config.pageSize/2)*t.value:t.value;var s=(1===t.direction?-1:1)*r;return e.getCurrentScrollTop()+s*e.config.lineHeight},t}(b);e.EditorScrollImpl=w,e.EditorScroll=o.registerEditorCommand(new w),e.ScrollLineUp=o.registerEditorCommand(new(function(t){function i(){return t.call(this,{id:"scrollLineUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2064,mac:{primary:267}}})||this}return r(i,t),
i.prototype.runCoreEditorCommand=function(t,i){e.EditorScroll._runEditorScroll(t,i.source,{direction:1,unit:2,value:1,revealCursor:!1,select:!1})},i}(b))),e.ScrollPageUp=o.registerEditorCommand(new(function(t){function i(){return t.call(this,{id:"scrollPageUp",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2059,win:{primary:523},linux:{primary:523}}})||this}return r(i,t),i.prototype.runCoreEditorCommand=function(t,i){e.EditorScroll._runEditorScroll(t,i.source,{direction:1,unit:3,value:1,revealCursor:!1,select:!1})},i}(b))),e.ScrollLineDown=o.registerEditorCommand(new(function(t){function i(){return t.call(this,{id:"scrollLineDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2066,mac:{primary:268}}})||this}return r(i,t),i.prototype.runCoreEditorCommand=function(t,i){e.EditorScroll._runEditorScroll(t,i.source,{direction:2,unit:2,value:1,revealCursor:!1,select:!1})},i}(b))),e.ScrollPageDown=o.registerEditorCommand(new(function(t){
function i(){return t.call(this,{id:"scrollPageDown",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2060,win:{primary:524},linux:{primary:524}}})||this}return r(i,t),i.prototype.runCoreEditorCommand=function(t,i){e.EditorScroll._runEditorScroll(t,i.source,{direction:2,unit:3,value:1,revealCursor:!1,select:!1})},i}(b)));var E=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,[d.CursorMoveCommands.word(e.context,e.getPrimaryCursor(),this._inSelectionMode,t.position)]),e.reveal(!0,0,0)},t}(b);e.WordSelect=o.registerEditorCommand(new E({inSelectionMode:!1,id:"_wordSelect",precondition:void 0})),e.WordSelectDrag=o.registerEditorCommand(new E({inSelectionMode:!0,id:"_wordSelectDrag",precondition:void 0})),e.LastCursorWordSelect=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{
id:"lastCursorWordSelect",precondition:void 0})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){var i=e.context,n=e.getLastAddedCursorIndex(),o=e.getAll(),r=o.slice(0),s=o[n];r[n]=d.CursorMoveCommands.word(i,s,s.modelState.hasSelection(),t.position),i.model.pushStackElement(),e.setStates(t.source,3,r)},t}(b)));var L=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,[d.CursorMoveCommands.line(e.context,e.getPrimaryCursor(),this._inSelectionMode,t.position,t.viewPosition)]),e.reveal(!1,0,0)},t}(b);e.LineSelect=o.registerEditorCommand(new L({inSelectionMode:!1,id:"_lineSelect",precondition:void 0})),e.LineSelectDrag=o.registerEditorCommand(new L({inSelectionMode:!0,id:"_lineSelectDrag",precondition:void 0}));var x=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i}return r(t,e),
t.prototype.runCoreEditorCommand=function(e,t){var i=e.getLastAddedCursorIndex(),n=e.getAll(),o=n.slice(0);o[i]=d.CursorMoveCommands.line(e.context,n[i],this._inSelectionMode,t.position,t.viewPosition),e.context.model.pushStackElement(),e.setStates(t.source,3,o)},t}(b);e.LastCursorLineSelect=o.registerEditorCommand(new x({inSelectionMode:!1,id:"lastCursorLineSelect",precondition:void 0})),e.LastCursorLineSelectDrag=o.registerEditorCommand(new x({inSelectionMode:!0,id:"lastCursorLineSelectDrag",precondition:void 0})),e.ExpandLineSelection=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"expandLineSelection",precondition:void 0,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2090}})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,d.CursorMoveCommands.expandLineSelection(e.context,e.getAll())),e.reveal(!0,0,0)},t}(b))),e.CancelSelection=o.registerEditorCommand(new(function(e){function t(){
return e.call(this,{id:"cancelSelection",precondition:g.EditorContextKeys.hasNonEmptySelection,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,[d.CursorMoveCommands.cancelSelection(e.context,e.getPrimaryCursor())]),e.reveal(!0,0,0)},t}(b))),e.RemoveSecondaryCursors=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"removeSecondaryCursors",precondition:g.EditorContextKeys.hasMultipleSelections,kbOpts:{weight:y+1,kbExpr:g.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,[e.getPrimaryCursor()]),e.reveal(!0,0,0)},t}(b))),e.RevealLine=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"revealLine",precondition:void 0,description:S.description})||this}return r(t,e),
t.prototype.runCoreEditorCommand=function(e,t){var i=t,n=(i.lineNumber||0)+1;n<1&&(n=1);var o=e.context.model.getLineCount();n>o&&(n=o);var r=new p.Range(n,1,n,e.context.model.getLineMaxColumn(n)),s=0;if(i.at)switch(i.at){case S.RawAtArgument.Top:s=3;break;case S.RawAtArgument.Center:s=1;break;case S.RawAtArgument.Bottom:s=4}var a=e.context.convertModelRangeToViewRange(r);e.revealRange(!1,a,s,0)},t}(b))),e.SelectAll=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"selectAll",precondition:void 0})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),e.setStates(t.source,3,[d.CursorMoveCommands.selectAll(e.context,e.getPrimaryCursor())])},t}(b))),e.SetSelection=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"setSelection",precondition:void 0})||this}return r(t,e),t.prototype.runCoreEditorCommand=function(e,t){e.context.model.pushStackElement(),
e.setStates(t.source,3,[l.CursorState.fromModelSelection(t.selection)])},t}(b)))}(w=t.CoreNavigationCommands||(t.CoreNavigationCommands={}));!function(e){var t=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var n=t._getCursors();n&&this.runCoreEditingCommand(t,n,i||{})},t}(o.EditorCommand);e.CoreEditingCommand=t,e.LineBreakInsert=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"lineBreakInsert",precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:0,mac:{primary:301}}})||this}return r(t,e),t.prototype.runCoreEditingCommand=function(e,t,i){e.pushUndoStop(),e.executeCommands(this.id,c.TypeOperations.lineBreakInsert(t.context.config,t.context.model,t.getAll().map(function(e){return e.modelState.selection})))},t}(t))),e.Outdent=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"outdent",
precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:m.ContextKeyExpr.and(g.EditorContextKeys.editorTextFocus,g.EditorContextKeys.tabDoesNotMoveFocus),primary:1026}})||this}return r(t,e),t.prototype.runCoreEditingCommand=function(e,t,i){e.pushUndoStop(),e.executeCommands(this.id,c.TypeOperations.outdent(t.context.config,t.context.model,t.getAll().map(function(e){return e.modelState.selection}))),e.pushUndoStop()},t}(t))),e.Tab=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"tab",precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:m.ContextKeyExpr.and(g.EditorContextKeys.editorTextFocus,g.EditorContextKeys.tabDoesNotMoveFocus),primary:2}})||this}return r(t,e),t.prototype.runCoreEditingCommand=function(e,t,i){e.pushUndoStop(),e.executeCommands(this.id,c.TypeOperations.tab(t.context.config,t.context.model,t.getAll().map(function(e){return e.modelState.selection}))),e.pushUndoStop()},t}(t))),e.DeleteLeft=o.registerEditorCommand(new(function(e){function t(){
return e.call(this,{id:"deleteLeft",precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:1,secondary:[1025],mac:{primary:1,secondary:[1025,294,257]}}})||this}return r(t,e),t.prototype.runCoreEditingCommand=function(e,t,i){var n=u.DeleteOperations.deleteLeft(t.getPrevEditOperationType(),t.context.config,t.context.model,t.getAll().map(function(e){return e.modelState.selection})),o=n[0],r=n[1];o&&e.pushUndoStop(),e.executeCommands(this.id,r),t.setPrevEditOperationType(2)},t}(t))),e.DeleteRight=o.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"deleteRight",precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:20,mac:{primary:20,secondary:[290,276]}}})||this}return r(t,e),t.prototype.runCoreEditingCommand=function(e,t,i){var n=u.DeleteOperations.deleteRight(t.getPrevEditOperationType(),t.context.config,t.context.model,t.getAll().map(function(e){return e.modelState.selection
})),o=n[0],r=n[1];o&&e.pushUndoStop(),e.executeCommands(this.id,r),t.setPrevEditOperationType(3)},t}(t)))}(t.CoreEditingCommands||(t.CoreEditingCommands={}));var E=function(e){function t(t){var i=e.call(this,t)||this;return i._editorHandler=t.editorHandler,i._inputHandler=t.inputHandler,i}return r(t,e),t.prototype.runCommand=function(e,t){var i=e.get(s.ICodeEditorService).getFocusedCodeEditor();if(i&&i.hasTextFocus())return this._runEditorHandler(e,i,t);var n=document.activeElement;if(!(n&&["input","textarea"].indexOf(n.tagName.toLowerCase())>=0)){var o=e.get(s.ICodeEditorService).getActiveCodeEditor();return o?(o.focus(),this._runEditorHandler(e,o,t)):void 0}document.execCommand(this._inputHandler)},t.prototype._runEditorHandler=function(e,t,i){var n=this._editorHandler;"string"==typeof n?t.trigger("keyboard",n,i):((i=i||{}).source="keyboard",n.runEditorCommand(e,t,i))},t}(o.Command),L=function(e){function t(t,i,n){var o=e.call(this,{id:t,precondition:void 0,description:n})||this;return o._handlerId=i,o}
return r(t,e),t.prototype.runCommand=function(e,t){var i=e.get(s.ICodeEditorService).getFocusedCodeEditor();i&&i.trigger("keyboard",this._handlerId,t)},t}(o.Command);v(new E({editorHandler:w.SelectAll,inputHandler:"selectAll",id:"editor.action.selectAll",precondition:g.EditorContextKeys.textInputFocus,kbOpts:{weight:y,kbExpr:null,primary:2079},menubarOpts:{menuId:22,group:"1_basic",title:i.localize(0,null),order:1}})),v(new E({editorHandler:f.Handler.Undo,inputHandler:"undo",id:f.Handler.Undo,precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2104},menubarOpts:{menuId:14,group:"1_do",title:i.localize(1,null),order:1}})),v(new L("default:"+f.Handler.Undo,f.Handler.Undo)),v(new E({editorHandler:f.Handler.Redo,inputHandler:"redo",id:f.Handler.Redo,precondition:g.EditorContextKeys.writable,kbOpts:{weight:y,kbExpr:g.EditorContextKeys.textInputFocus,primary:2103,secondary:[3128],mac:{primary:3128}},menubarOpts:{menuId:14,group:"1_do",
title:i.localize(2,null),order:2}})),v(new L("default:"+f.Handler.Redo,f.Handler.Redo)),_(f.Handler.Type,{description:"Type",args:[{name:"args",schema:{type:"object",required:["text"],properties:{text:{type:"string"}}}}]}),_(f.Handler.ReplacePreviousChar),_(f.Handler.CompositionStart),_(f.Handler.CompositionEnd),_(f.Handler.Paste),_(f.Handler.Cut)}),define(t[476],i([1,0,11,14,26,75,12,73]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=a.createDecorator("IEditorCancelService"),d=new n.RawContextKey("cancellableOperation",!1);l.registerSingleton(u,function(){function e(){this._tokens=new WeakMap}return e.prototype.add=function(e,t){var i=this._tokens.get(e);i||(i=e.invokeWithinContext(function(e){return{key:d.bindTo(e.get(n.IContextKeyService)),tokens:new s.LinkedList}}),this._tokens.set(e,i));var o;return i.key.set(!0),o=i.tokens.push(t),function(){o&&(o(),i.key.set(!i.tokens.isEmpty()),o=void 0)}},e.prototype.cancel=function(e){var t=this._tokens.get(e);if(t){
var i=t.tokens.pop();i&&(i.cancel(),t.key.set(!t.tokens.isEmpty()))}},e}(),!0);var c=function(e){function t(t,i){var n=e.call(this,i)||this;return n.editor=t,n._unregister=t.invokeWithinContext(function(e){return e.get(u).add(t,n)}),n}return r(t,e),t.prototype.dispose=function(){this._unregister(),e.prototype.dispose.call(this)},t}(o.CancellationTokenSource);t.EditorKeybindingCancellationTokenSource=c,i.registerEditorCommand(new(function(e){function t(){return e.call(this,{id:"editor.cancelOperation",kbOpts:{weight:100,primary:9},precondition:d})||this}return r(t,e),t.prototype.runEditorCommand=function(e,t){e.get(u).cancel(t)},t}(i.EditorCommand)))}),define(t[61],i([1,0,5,26,2,476]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(e,t){if(this.flags=t,0!=(1&this.flags)){var n=e.getModel();this.modelVersionId=n?i.format("{0}#{1}",n.uri.toString(),n.getVersionId()):null}else this.modelVersionId=null
;0!=(4&this.flags)?this.position=e.getPosition():this.position=null,0!=(2&this.flags)?this.selection=e.getSelection():this.selection=null,0!=(8&this.flags)?(this.scrollLeft=e.getScrollLeft(),this.scrollTop=e.getScrollTop()):(this.scrollLeft=-1,this.scrollTop=-1)}return e.prototype._equals=function(t){if(!(t instanceof e))return!1;var i=t;return this.modelVersionId===i.modelVersionId&&(this.scrollLeft===i.scrollLeft&&this.scrollTop===i.scrollTop&&(!(!this.position&&i.position||this.position&&!i.position||this.position&&i.position&&!this.position.equals(i.position))&&!(!this.selection&&i.selection||this.selection&&!i.selection||this.selection&&i.selection&&!this.selection.equalsRange(i.selection))))},e.prototype.validate=function(t){return this._equals(new e(t,this.flags))},e}();t.EditorState=a;var l=function(e){function t(t,i,n){var r=e.call(this,t,n)||this;return r.editor=t,r._listener=new o.DisposableStore,4&i&&r._listener.add(t.onDidChangeCursorPosition(function(e){return r.cancel()})),
2&i&&r._listener.add(t.onDidChangeCursorSelection(function(e){return r.cancel()})),8&i&&r._listener.add(t.onDidScrollChange(function(e){return r.cancel()})),1&i&&(r._listener.add(t.onDidChangeModel(function(e){return r.cancel()})),r._listener.add(t.onDidChangeModelContent(function(e){return r.cancel()}))),r}return r(t,e),t.prototype.dispose=function(){this._listener.dispose(),e.prototype.dispose.call(this)},t}(s.EditorKeybindingCancellationTokenSource);t.EditorStateCancellationTokenSource=l;var u=function(e){function t(t,i){var n=e.call(this,i)||this;return n._listener=t.onDidChangeContent(function(){return n.cancel()}),n}return r(t,e),t.prototype.dispose=function(){this._listener.dispose(),e.prototype.dispose.call(this)},t}(n.CancellationTokenSource);t.TextModelCancellationTokenSource=u;var d=function(){function e(e,t){this._visiblePosition=e,this._visiblePositionScrollDelta=t}return e.capture=function(t){var i=null,n=0;if(0!==t.getScrollTop()){var o=t.getVisibleRanges();if(o.length>0){
i=o[0].getStartPosition();var r=t.getTopForPosition(i.lineNumber,i.column);n=t.getScrollTop()-r}}return new e(i,n)},e.prototype.restore=function(e){if(this._visiblePosition){var t=e.getTopForPosition(this._visiblePosition.lineNumber,this._visiblePosition.column);e.setScrollTop(t+this._visiblePositionScrollDelta)}},e}();t.StableEditorScrollState=d}),define(t[478],i([1,0,120,13]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(){function e(e,t,i,n){this.configuration=e,this.viewModel=t,this.outgoingEvents=i,this.commandDelegate=n}return e.prototype._execMouseCommand=function(e,t){t.source="mouse",this.commandDelegate.executeEditorCommand(e,t)},e.prototype.paste=function(e,t,i,n){this.commandDelegate.paste(e,t,i,n)},e.prototype.type=function(e,t){this.commandDelegate.type(e,t)},e.prototype.replacePreviousChar=function(e,t,i){this.commandDelegate.replacePreviousChar(e,t,i)},e.prototype.compositionStart=function(e){this.commandDelegate.compositionStart(e)},
e.prototype.compositionEnd=function(e){this.commandDelegate.compositionEnd(e)},e.prototype.cut=function(e){this.commandDelegate.cut(e)},e.prototype.setSelection=function(e,t){this.commandDelegate.executeEditorCommand(i.CoreNavigationCommands.SetSelection,{source:e,selection:t})},e.prototype._validateViewColumn=function(e){var t=this.viewModel.getLineMinColumn(e.lineNumber);return e.column<t?new n.Position(e.lineNumber,t):e},e.prototype._hasMulticursorModifier=function(e){switch(this.configuration.editor.multiCursorModifier){case"altKey":return e.altKey;case"ctrlKey":return e.ctrlKey;case"metaKey":return e.metaKey}return!1},e.prototype._hasNonMulticursorModifier=function(e){switch(this.configuration.editor.multiCursorModifier){case"altKey":return e.ctrlKey||e.metaKey;case"ctrlKey":return e.altKey||e.metaKey;case"metaKey":return e.ctrlKey||e.altKey}return!1},e.prototype.dispatchMouse=function(e){
e.middleButton?e.inSelectionMode?this._columnSelect(e.position,e.mouseColumn,!0):this.moveTo(e.position):e.startedOnLineNumbers?this._hasMulticursorModifier(e)?e.inSelectionMode?this._lastCursorLineSelect(e.position):this._createCursor(e.position,!0):e.inSelectionMode?this._lineSelectDrag(e.position):this._lineSelect(e.position):e.mouseDownCount>=4?this._selectAll():3===e.mouseDownCount?this._hasMulticursorModifier(e)?e.inSelectionMode?this._lastCursorLineSelectDrag(e.position):this._lastCursorLineSelect(e.position):e.inSelectionMode?this._lineSelectDrag(e.position):this._lineSelect(e.position):2===e.mouseDownCount?this._hasMulticursorModifier(e)?this._lastCursorWordSelect(e.position):e.inSelectionMode?this._wordSelectDrag(e.position):this._wordSelect(e.position):this._hasMulticursorModifier(e)?this._hasNonMulticursorModifier(e)||(e.shiftKey?this._columnSelect(e.position,e.mouseColumn,!1):e.inSelectionMode?this._lastCursorMoveToSelect(e.position):this._createCursor(e.position,!1)):e.inSelectionMode?e.altKey?this._columnSelect(e.position,e.mouseColumn,!0):this._moveToSelect(e.position):this.moveTo(e.position)
},e.prototype._usualArgs=function(e){return e=this._validateViewColumn(e),{position:this._convertViewToModelPosition(e),viewPosition:e}},e.prototype.moveTo=function(e){this._execMouseCommand(i.CoreNavigationCommands.MoveTo,this._usualArgs(e))},e.prototype._moveToSelect=function(e){this._execMouseCommand(i.CoreNavigationCommands.MoveToSelect,this._usualArgs(e))},e.prototype._columnSelect=function(e,t,n){e=this._validateViewColumn(e),this._execMouseCommand(i.CoreNavigationCommands.ColumnSelect,{position:this._convertViewToModelPosition(e),viewPosition:e,mouseColumn:t,setAnchorIfNotSet:n})},e.prototype._createCursor=function(e,t){e=this._validateViewColumn(e),this._execMouseCommand(i.CoreNavigationCommands.CreateCursor,{position:this._convertViewToModelPosition(e),viewPosition:e,wholeLine:t})},e.prototype._lastCursorMoveToSelect=function(e){this._execMouseCommand(i.CoreNavigationCommands.LastCursorMoveToSelect,this._usualArgs(e))},e.prototype._wordSelect=function(e){
this._execMouseCommand(i.CoreNavigationCommands.WordSelect,this._usualArgs(e))},e.prototype._wordSelectDrag=function(e){this._execMouseCommand(i.CoreNavigationCommands.WordSelectDrag,this._usualArgs(e))},e.prototype._lastCursorWordSelect=function(e){this._execMouseCommand(i.CoreNavigationCommands.LastCursorWordSelect,this._usualArgs(e))},e.prototype._lineSelect=function(e){this._execMouseCommand(i.CoreNavigationCommands.LineSelect,this._usualArgs(e))},e.prototype._lineSelectDrag=function(e){this._execMouseCommand(i.CoreNavigationCommands.LineSelectDrag,this._usualArgs(e))},e.prototype._lastCursorLineSelect=function(e){this._execMouseCommand(i.CoreNavigationCommands.LastCursorLineSelect,this._usualArgs(e))},e.prototype._lastCursorLineSelectDrag=function(e){this._execMouseCommand(i.CoreNavigationCommands.LastCursorLineSelectDrag,this._usualArgs(e))},e.prototype._selectAll=function(){this._execMouseCommand(i.CoreNavigationCommands.SelectAll,{})},e.prototype._convertViewToModelPosition=function(e){
return this.viewModel.coordinatesConverter.convertViewPositionToModelPosition(e)},e.prototype.emitKeyDown=function(e){this.outgoingEvents.emitKeyDown(e)},e.prototype.emitKeyUp=function(e){this.outgoingEvents.emitKeyUp(e)},e.prototype.emitContextMenu=function(e){this.outgoingEvents.emitContextMenu(e)},e.prototype.emitMouseMove=function(e){this.outgoingEvents.emitMouseMove(e)},e.prototype.emitMouseLeave=function(e){this.outgoingEvents.emitMouseLeave(e)},e.prototype.emitMouseUp=function(e){this.outgoingEvents.emitMouseUp(e)},e.prototype.emitMouseDown=function(e){this.outgoingEvents.emitMouseDown(e)},e.prototype.emitMouseDrag=function(e){this.outgoingEvents.emitMouseDrag(e)},e.prototype.emitMouseDrop=function(e){this.outgoingEvents.emitMouseDrop(e)},e.prototype.emitMouseWheel=function(e){this.outgoingEvents.emitMouseWheel(e)},e}();t.ViewController=o}),define(t[479],i([1,0,322,11,21,243]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t,i){
var n=e.call(this,i)||this;return n.left=t,n}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){for(var i=[],n=0,o=t.getSelections();n<o.length;n++){var r=o[n];i.push(new s.MoveCaretCommand(r,this.left))}t.pushUndoStop(),t.executeCommands(this.id,i),t.pushUndoStop()}},t}(n.EditorAction),l=function(e){function t(){return e.call(this,!0,{id:"editor.action.moveCarretLeftAction",label:i.localize(0,null),alias:"Move Caret Left",precondition:o.EditorContextKeys.writable})||this}return r(t,e),t}(a),u=function(e){function t(){return e.call(this,!1,{id:"editor.action.moveCarretRightAction",label:i.localize(1,null),alias:"Move Caret Right",precondition:o.EditorContextKeys.writable})||this}return r(t,e),t}(a);n.registerEditorAction(l),n.registerEditorAction(u)}),define(t[480],i([1,0,323,5,11,81,13,3,21]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(){return e.call(this,{id:"editor.action.transposeLetters",label:i.localize(0,null),
alias:"Transpose Letters",precondition:u.EditorContextKeys.writable,kbOpts:{kbExpr:u.EditorContextKeys.textInputFocus,primary:0,mac:{primary:306},weight:100}})||this}return r(t,e),t.prototype.positionLeftOf=function(e,t){var i=e.column,o=e.lineNumber;return i>t.getLineMinColumn(o)?n.isLowSurrogate(t.getLineContent(o).charCodeAt(i-2))?i-=2:i-=1:o>1&&(o-=1,i=t.getLineMaxColumn(o)),new a.Position(o,i)},t.prototype.positionRightOf=function(e,t){var i=e.column,o=e.lineNumber;return i<t.getLineMaxColumn(o)?n.isHighSurrogate(t.getLineContent(o).charCodeAt(i-1))?i+=2:i+=1:o<t.getLineCount()&&(o+=1,i=0),new a.Position(o,i)},t.prototype.run=function(e,t){if(t.hasModel()){for(var i=t.getModel(),n=[],o=0,r=t.getSelections();o<r.length;o++){var a=r[o];if(a.isEmpty()){var u=a.startLineNumber,d=a.startColumn,c=i.getLineMaxColumn(u);if(1!==u||1!==d&&(2!==d||2!==c)){
var h=d===c?a.getPosition():this.positionRightOf(a.getPosition(),i),p=this.positionLeftOf(h,i),f=this.positionLeftOf(p,i),g=i.getValueInRange(l.Range.fromPositions(f,p)),m=i.getValueInRange(l.Range.fromPositions(p,h)),v=l.Range.fromPositions(f,h);n.push(new s.ReplaceCommand(v,m+g))}}}n.length>0&&(t.pushUndoStop(),t.executeCommands(this.id,n),t.pushUndoStop())}},t}(o.EditorAction);o.registerEditorAction(d)}),define(t[481],i([1,0,324,28,18,167,11,31,21,230]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d="9_cutcopypaste",c=o.isNative||document.queryCommandSupported("cut"),h=o.isNative||document.queryCommandSupported("copy"),p=h&&!n.isEdgeOrIE,f=o.isNative||!n.isChrome&&document.queryCommandSupported("paste"),g=function(e){function t(t,i){var n=e.call(this,i)||this;return n.browserCommand=t,n}return r(t,e),t.prototype.runCommand=function(e,t){var i=e.get(l.ICodeEditorService).getFocusedCodeEditor()
;i&&i.hasTextFocus()?i.trigger("keyboard",this.id,t):document.execCommand(this.browserCommand)},t.prototype.run=function(e,t){t.focus(),document.execCommand(this.browserCommand)},t}(a.EditorAction),m=function(e){function t(){var t={kbExpr:u.EditorContextKeys.textInputFocus,primary:2102,win:{primary:2102,secondary:[1044]},weight:100};return o.isNative||(t=void 0),e.call(this,"cut",{id:"editor.action.clipboardCutAction",label:i.localize(0,null),alias:"Cut",precondition:u.EditorContextKeys.writable,kbOpts:t,menuOpts:{group:d,order:1},menubarOpts:{menuId:14,group:"2_ccp",title:i.localize(1,null),order:1}})||this}return r(t,e),t.prototype.run=function(t,i){if(i.hasModel()){!i.getConfiguration().emptySelectionClipboard&&i.getSelection().isEmpty()||e.prototype.run.call(this,t,i)}},t}(g),v=function(e){function t(){var t={kbExpr:u.EditorContextKeys.textInputFocus,primary:2081,win:{primary:2081,secondary:[2067]},weight:100};return o.isNative||(t=void 0),e.call(this,"copy",{id:"editor.action.clipboardCopyAction",
label:i.localize(2,null),alias:"Copy",precondition:void 0,kbOpts:t,menuOpts:{group:d,order:2},menubarOpts:{menuId:14,group:"2_ccp",title:i.localize(3,null),order:2}})||this}return r(t,e),t.prototype.run=function(t,i){if(i.hasModel()){!i.getConfiguration().emptySelectionClipboard&&i.getSelection().isEmpty()||e.prototype.run.call(this,t,i)}},t}(g),_=function(e){function t(){var t={kbExpr:u.EditorContextKeys.textInputFocus,primary:2100,win:{primary:2100,secondary:[1043]},weight:100};return o.isNative||(t=void 0),e.call(this,"paste",{id:"editor.action.clipboardPasteAction",label:i.localize(4,null),alias:"Paste",precondition:u.EditorContextKeys.writable,kbOpts:t,menuOpts:{group:d,order:3},menubarOpts:{menuId:14,group:"2_ccp",title:i.localize(5,null),order:3}})||this}return r(t,e),t}(g),y=function(e){function t(){return e.call(this,"copy",{id:"editor.action.clipboardCopyWithSyntaxHighlightingAction",label:i.localize(6,null),alias:"Copy With Syntax Highlighting",precondition:void 0,kbOpts:{
kbExpr:u.EditorContextKeys.textInputFocus,primary:0,weight:100}})||this}return r(t,e),t.prototype.run=function(t,i){if(i.hasModel()){!i.getConfiguration().emptySelectionClipboard&&i.getSelection().isEmpty()||(s.CopyOptions.forceCopyWithSyntaxHighlighting=!0,e.prototype.run.call(this,t,i),s.CopyOptions.forceCopyWithSyntaxHighlighting=!1)}},t}(g);c&&a.registerEditorAction(m),h&&a.registerEditorAction(v),f&&a.registerEditorAction(_),p&&a.registerEditorAction(y)}),define(t[206],i([1,0,19,26,10,24,11,3,20,17,42,130,61,2]),function(e,t,i,n,o,s,u,d,c,h,p,f,g,m){"use strict";function v(e,t,n,r){var s=n.filter||{},a={only:s.kind?s.kind.value:void 0,trigger:"manual"===n.type?2:1},l=new g.TextModelCancellationTokenSource(e,r),u=function(e,t){return h.CodeActionProviderRegistry.all(e).filter(function(e){return!e.providedCodeActionKinds||e.providedCodeActionKinds.some(function(e){return f.mayIncludeActionsOfKind(t,new f.CodeActionKind(e))})})}(e,s),d=new m.DisposableStore,c=u.map(function(i){
return Promise.resolve(i.provideCodeActions(e,t,a,l.token)).then(function(e){return l.token.isCancellationRequested||!e?[]:(d.add(e),e.actions.filter(function(e){return e&&f.filtersAction(s,e)}))},function(e){if(o.isPromiseCanceledError(e))throw e;return o.onUnexpectedExternalError(e),[]})}),p=h.CodeActionProviderRegistry.onDidChange(function(){var t=h.CodeActionProviderRegistry.all(e);i.equals(t,u)||l.cancel()});return Promise.all(c).then(i.flatten).then(function(e){return new _(e,d)}).finally(function(){p.dispose(),l.dispose()})}Object.defineProperty(t,"__esModule",{value:!0});var _=function(e){function t(n,o){var r=e.call(this)||this;return r._register(o),r.actions=i.mergeSort(n.slice(),t.codeActionsComparator),r}return r(t,e),t.codeActionsComparator=function(e,t){return i.isNonEmptyArray(e.diagnostics)?i.isNonEmptyArray(t.diagnostics)?e.diagnostics[0].message.localeCompare(t.diagnostics[0].message):-1:i.isNonEmptyArray(t.diagnostics)?1:0},Object.defineProperty(t.prototype,"hasAutoFix",{get:function(){
return this.actions.some(function(e){return!!e.kind&&f.CodeActionKind.QuickFix.contains(new f.CodeActionKind(e.kind))&&!!e.isPreferred})},enumerable:!0,configurable:!0}),t}(m.Disposable);t.getCodeActions=v,u.registerLanguageCommand("_executeCodeActionProvider",function(e,t){return a(this,void 0,void 0,function(){var i,r,a,u,h,g;return l(this,function(l){switch(l.label){case 0:if(i=t.resource,r=t.rangeOrSelection,a=t.kind,!(i instanceof s.URI))throw o.illegalArgument();if(!(u=e.get(p.IModelService).getModel(i)))throw o.illegalArgument();if(!(h=c.Selection.isISelection(r)?c.Selection.liftSelection(r):d.Range.isIRange(r)?u.validateRange(r):void 0))throw o.illegalArgument();return[4,v(u,h,{type:"manual",filter:{includeSourceActions:!0,kind:a&&a.value?new f.CodeActionKind(a.value):void 0}},n.CancellationToken.None)];case 1:return g=l.sent(),setTimeout(function(){return g.dispose()},100),[2,g.actions]}})})})}),define(t[483],i([1,0,15,4,2,3,17,14,206]),function(e,t,i,n,o,s,a,l,u){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.SUPPORTED_CODE_ACTIONS=new l.RawContextKey("supportedCodeAction","");var d,c=function(e){function t(t,n,o,r){void 0===r&&(r=250);var s=e.call(this)||this;return s._editor=t,s._markerService=n,s._signalChange=o,s._delay=r,s._autoTriggerTimer=s._register(new i.TimeoutTimer),s._register(s._markerService.onMarkerChanged(function(e){return s._onMarkerChanges(e)})),s._register(s._editor.onDidChangeCursorPosition(function(){return s._onCursorChange()})),s}return r(t,e),t.prototype.trigger=function(e){var t=this._getRangeOfSelectionUnlessWhitespaceEnclosed(e);return this._createEventAndSignalChange(e,t)},t.prototype._onMarkerChanges=function(e){var t=this,i=this._editor.getModel();i&&e.some(function(e){return e.toString()===i.uri.toString()})&&this._autoTriggerTimer.cancelAndSet(function(){t.trigger({type:"auto"})},this._delay)},t.prototype._onCursorChange=function(){var e=this;this._autoTriggerTimer.cancelAndSet(function(){e.trigger({type:"auto"})},this._delay)},
t.prototype._getRangeOfMarker=function(e){var t=this._editor.getModel();if(t)for(var i=0,n=this._markerService.read({resource:t.uri});i<n.length;i++){var o=n[i];if(s.Range.intersectRanges(o,e))return s.Range.lift(o)}},t.prototype._getRangeOfSelectionUnlessWhitespaceEnclosed=function(e){if(this._editor.hasModel()){var t=this._editor.getModel(),i=this._editor.getSelection();if(i.isEmpty()&&"auto"===e.type){var n=i.getPosition(),o=n.lineNumber,r=n.column,s=t.getLineContent(o);if(0===s.length)return;if(1===r){if(/\s/.test(s[0]))return}else if(r===t.getLineMaxColumn(o)){if(/\s/.test(s[s.length-1]))return}else if(/\s/.test(s[r-2])&&/\s/.test(s[r-1]))return}return i}},t.prototype._createEventAndSignalChange=function(e,t){var i=this._editor.getModel();if(t&&i){var n=this._getRangeOfMarker(t),o={trigger:e,selection:t,position:n?n.getStartPosition():t.getStartPosition()};return this._signalChange(o),o}this._signalChange(void 0)},t}(o.Disposable);!function(e){e.Empty=new(function(){return function(){this.type=0}}())
;var t=function(){return function(e,t,i,n){this.trigger=e,this.rangeOrSelection=t,this.position=i,this.actions=n,this.type=1}}();e.Triggered=t}(d=t.CodeActionsState||(t.CodeActionsState={}));var h=function(e){function s(i,r,s,l){var u=e.call(this)||this;return u._editor=i,u._markerService=r,u._progressService=l,u._codeActionOracle=u._register(new o.MutableDisposable),u._state=d.Empty,u._onDidChangeState=u._register(new n.Emitter),u.onDidChangeState=u._onDidChangeState.event,u._supportedCodeActions=t.SUPPORTED_CODE_ACTIONS.bindTo(s),u._register(u._editor.onDidChangeModel(function(){return u._update()})),u._register(u._editor.onDidChangeModelLanguage(function(){return u._update()})),u._register(a.CodeActionProviderRegistry.onDidChange(function(){return u._update()})),u._update(),u}return r(s,e),s.prototype.dispose=function(){e.prototype.dispose.call(this),this.setState(d.Empty,!0)},s.prototype._update=function(){var e=this;this._codeActionOracle.value=void 0,this.setState(d.Empty);var t=this._editor.getModel()
;if(t&&a.CodeActionProviderRegistry.has(t)&&!this._editor.getConfiguration().readOnly){for(var n=[],o=0,r=a.CodeActionProviderRegistry.all(t);o<r.length;o++){var s=r[o];Array.isArray(s.providedCodeActionKinds)&&n.push.apply(n,s.providedCodeActionKinds)}this._supportedCodeActions.set(n.join(" ")),this._codeActionOracle.value=new c(this._editor,this._markerService,function(n){if(n){var o=i.createCancelablePromise(function(e){return u.getCodeActions(t,n.selection,n.trigger,e)});e._progressService&&"manual"===n.trigger.type&&e._progressService.showWhile(o,250),e.setState(new d.Triggered(n.trigger,n.selection,n.position,o))}else e.setState(d.Empty)},void 0),this._codeActionOracle.value.trigger({type:"auto"})}else this._supportedCodeActions.reset()},s.prototype.trigger=function(e){this._codeActionOracle.value&&this._codeActionOracle.value.trigger(e)},s.prototype.setState=function(e,t){e!==this._state&&(1===this._state.type&&this._state.actions.cancel(),this._state=e,t||this._onDidChangeState.fire(e))},s
}(o.Disposable);t.CodeActionModel=h}),define(t[207],i([1,0,19,26,10,24,11,17,42,2]),function(e,t,i,n,o,r,s,a,l,u){"use strict";function d(e,t){var n=a.CodeLensProviderRegistry.ordered(e),r=new Map,s=new c,l=n.map(function(i,n){return r.set(i,n),Promise.resolve(i.provideCodeLenses(e,t)).then(function(e){return e&&s.add(e,i)}).catch(o.onUnexpectedExternalError)});return Promise.all(l).then(function(){return s.lenses=i.mergeSort(s.lenses,function(e,t){return e.symbol.range.startLineNumber<t.symbol.range.startLineNumber?-1:e.symbol.range.startLineNumber>t.symbol.range.startLineNumber?1:r.get(e.provider)<r.get(t.provider)?-1:r.get(e.provider)>r.get(t.provider)?1:e.symbol.range.startColumn<t.symbol.range.startColumn?-1:e.symbol.range.startColumn>t.symbol.range.startColumn?1:0}),s})}Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(){this.lenses=[],this._dispoables=new u.DisposableStore}return e.prototype.dispose=function(){this._dispoables.dispose()},e.prototype.add=function(e,t){
this._dispoables.add(e);for(var i=0,n=e.lenses;i<n.length;i++){var o=n[i];this.lenses.push({symbol:o,provider:t})}},e}();t.CodeLensModel=c,t.getCodeLensData=d,s.registerLanguageCommand("_executeCodeLensProvider",function(e,t){var i=t.resource,s=t.itemResolveCount;if(!(i instanceof r.URI))throw o.illegalArgument();var a=e.get(l.IModelService).getModel(i);if(!a)throw o.illegalArgument();var c=[],h=new u.DisposableStore;return d(a,n.CancellationToken.None).then(function(e){h.add(e);for(var t=[],i=function(e){void 0===s||Boolean(e.symbol.command)?c.push(e.symbol):s-- >0&&e.provider.resolveCodeLens&&t.push(Promise.resolve(e.provider.resolveCodeLens(a,e.symbol,n.CancellationToken.None)).then(function(t){return c.push(t||e.symbol)}))},o=0,r=e.lenses;o<r.length;o++){i(r[o])}return Promise.all(t)}).then(function(){return c}).finally(function(){setTimeout(function(){return h.dispose()},100)})})}),define(t[485],i([1,0,12,73,207,41,68,3,15,224]),function(e,t,i,n,o,r,s,a,l,u){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.ICodeLensCache=i.createDecorator("ICodeLensCache");var h=function(){return function(e,t){this.lineCount=e,this.data=t}}(),p=function(){function e(e){var t=this;this._fakeProvider=new(function(){function e(){}return e.prototype.provideCodeLenses=function(){throw new Error("not supported")},e}()),this._cache=new r.LRUCache(20,.75);l.runWhenIdle(function(){return e.remove("codelens/cache",1)});var i="codelens/cache2",n=e.get(i,1,"{}");this._deserialize(n),u.once(e.onWillSaveState)(function(n){n.reason===s.WillSaveStateReason.SHUTDOWN&&e.store(i,t._serialize(),1)})}return e.prototype.put=function(e,t){var i=new o.CodeLensModel;i.add({lenses:t.lenses.map(function(e){return e.symbol}),dispose:function(){}},this._fakeProvider);var n=new h(e.getLineCount(),i);this._cache.set(e.uri.toString(),n)},e.prototype.get=function(e){var t=this._cache.get(e.uri.toString());return t&&t.lineCount===e.getLineCount()?t.data:void 0},e.prototype.delete=function(e){
this._cache.delete(e.uri.toString())},e.prototype._serialize=function(){var e=Object.create(null);return this._cache.forEach(function(t,i){for(var n=new Set,o=0,s=t.data.lenses;o<s.length;o++){var a=s[o];n.add(a.symbol.range.startLineNumber)}e[i]={lineCount:t.lineCount,lines:r.values(n)}}),JSON.stringify(e)},e.prototype._deserialize=function(e){try{var t=JSON.parse(e);for(var i in t){for(var n=t[i],r=[],s=0,l=n.lines;s<l.length;s++){var u=l[s];r.push({range:new a.Range(u,1,u,11)})}var d=new o.CodeLensModel;d.add({lenses:r,dispose:function(){}},this._fakeProvider),this._cache.set(i,new h(n.lineCount,d))}}catch(e){}},e=d([c(0,s.IStorageService)],e)}();t.CodeLensCache=p,n.registerSingleton(t.ICodeLensCache,p)}),define(t[208],i([1,0,26,10,24,11,3,17,42]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getColors=function(e,t){var i=[],n=a.ColorProviderRegistry.ordered(e).reverse().map(function(n){return Promise.resolve(n.provideDocumentColors(e,t)).then(function(e){
if(Array.isArray(e))for(var t=0,o=e;t<o.length;t++){var r=o[t];i.push({colorInfo:r,provider:n})}})});return Promise.all(n).then(function(){return i})},t.getColorPresentations=function(e,t,i,n){return Promise.resolve(i.provideColorPresentations(e,t,n))},r.registerLanguageCommand("_executeDocumentColorProvider",function(e,t){var r=t.resource;if(!(r instanceof o.URI))throw n.illegalArgument();var s=e.get(l.IModelService).getModel(r);if(!s)throw n.illegalArgument();var u=[],d=a.ColorProviderRegistry.ordered(s).reverse().map(function(e){return Promise.resolve(e.provideDocumentColors(s,i.CancellationToken.None)).then(function(e){if(Array.isArray(e))for(var t=0,i=e;t<i.length;t++){var n=i[t];u.push({range:n.range,color:[n.color.red,n.color.green,n.color.blue,n.color.alpha]})}})});return Promise.all(d).then(function(){return u})}),r.registerLanguageCommand("_executeColorPresentationProvider",function(e,t){var r=t.resource,u=t.color,d=t.range
;if(!(r instanceof o.URI&&Array.isArray(u)&&4===u.length&&s.Range.isIRange(d)))throw n.illegalArgument();var c=u[0],h=u[1],p=u[2],f=u[3],g=e.get(l.IModelService).getModel(r);if(!g)throw n.illegalArgument();var m={range:d,color:{red:c,green:h,blue:p,alpha:f}},v=[],_=a.ColorProviderRegistry.ordered(g).reverse().map(function(e){return Promise.resolve(e.provideColorPresentations(g,m,i.CancellationToken.None)).then(function(e){Array.isArray(e)&&v.push.apply(v,e)})});return Promise.all(_).then(function(){return v})})}),define(t[209],i([1,0,15,25,10,568,2,11,31,3,30,17,208,39]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var v=function(e){function t(t,i,n){var o=e.call(this)||this;return o._editor=t,o._codeEditorService=i,o._configurationService=n,o._localToDispose=o._register(new a.DisposableStore),o._decorationsIds=[],o._colorDatas=new Map,o._colorDecoratorIds=[],o._decorationsTypes=new Set,o._register(t.onDidChangeModel(function(e){
o._isEnabled=o.isEnabled(),o.onModelChanged()})),o._register(t.onDidChangeModelLanguage(function(e){return o.onModelChanged()})),o._register(f.ColorProviderRegistry.onDidChange(function(e){return o.onModelChanged()})),o._register(t.onDidChangeConfiguration(function(e){var t=o._isEnabled;o._isEnabled=o.isEnabled(),t!==o._isEnabled&&(o._isEnabled?o.onModelChanged():o.removeAllDecorations())})),o._timeoutTimer=null,o._computePromise=null,o._isEnabled=o.isEnabled(),o.onModelChanged(),o}return r(t,e),t.prototype.isEnabled=function(){var e=this._editor.getModel();if(!e)return!1;var t=e.getLanguageIdentifier(),i=this._configurationService.getValue(t.language);if(i){var n=i.colorDecorators;if(n&&void 0!==n.enable&&!n.enable)return n.enable}return this._editor.getConfiguration().contribInfo.colorDecorators},t.prototype.getId=function(){return t.ID},t.get=function(e){return e.getContribution(this.ID)},t.prototype.dispose=function(){this.stop(),this.removeAllDecorations(),e.prototype.dispose.call(this)},
t.prototype.onModelChanged=function(){var e=this;if(this.stop(),this._isEnabled){var n=this._editor.getModel();n&&f.ColorProviderRegistry.has(n)&&(this._localToDispose.add(this._editor.onDidChangeModelContent(function(n){e._timeoutTimer||(e._timeoutTimer=new i.TimeoutTimer,e._timeoutTimer.cancelAndSet(function(){e._timeoutTimer=null,e.beginCompute()},t.RECOMPUTE_TIME))})),this.beginCompute())}},t.prototype.beginCompute=function(){var e=this;this._computePromise=i.createCancelablePromise(function(t){var i=e._editor.getModel();return i?g.getColors(i,t):Promise.resolve([])}),this._computePromise.then(function(t){e.updateDecorations(t),e.updateColorDecorators(t),e._computePromise=null},o.onUnexpectedError)},t.prototype.stop=function(){this._timeoutTimer&&(this._timeoutTimer.cancel(),this._timeoutTimer=null),this._computePromise&&(this._computePromise.cancel(),this._computePromise=null),this._localToDispose.clear()},t.prototype.updateDecorations=function(e){var t=this,i=e.map(function(e){return{range:{
startLineNumber:e.colorInfo.range.startLineNumber,startColumn:e.colorInfo.range.startColumn,endLineNumber:e.colorInfo.range.endLineNumber,endColumn:e.colorInfo.range.endColumn},options:p.ModelDecorationOptions.EMPTY}});this._decorationsIds=this._editor.deltaDecorations(this._decorationsIds,i),this._colorDatas=new Map,this._decorationsIds.forEach(function(i,n){return t._colorDatas.set(i,e[n])})},t.prototype.updateColorDecorators=function(e){for(var t=this,i=[],o={},r=0;r<e.length&&i.length<500;r++){var a=e[r].colorInfo.color,l=a.red,u=a.green,d=a.blue,c=a.alpha,h=new n.RGBA(Math.round(255*l),Math.round(255*u),Math.round(255*d),c),p=s.hash(h).toString(16),f="rgba("+h.r+", "+h.g+", "+h.b+", "+h.a+")",g="colorBox-"+p;this._decorationsTypes.has(g)||o[g]||this._codeEditorService.registerDecorationType(g,{before:{contentText:" ",border:"solid 0.1em #000",margin:"0.1em 0.2em 0 0.2em",width:"0.8em",height:"0.8em",backgroundColor:f},dark:{before:{border:"solid 0.1em #eee"}}}),o[g]=!0,i.push({range:{
startLineNumber:e[r].colorInfo.range.startLineNumber,startColumn:e[r].colorInfo.range.startColumn,endLineNumber:e[r].colorInfo.range.endLineNumber,endColumn:e[r].colorInfo.range.endColumn},options:this._codeEditorService.resolveDecorationOptions(g,!0)})}this._decorationsTypes.forEach(function(e){o[e]||t._codeEditorService.removeDecorationType(e)}),this._colorDecoratorIds=this._editor.deltaDecorations(this._colorDecoratorIds,i)},t.prototype.removeAllDecorations=function(){var e=this;this._decorationsIds=this._editor.deltaDecorations(this._decorationsIds,[]),this._colorDecoratorIds=this._editor.deltaDecorations(this._colorDecoratorIds,[]),this._decorationsTypes.forEach(function(t){e._codeEditorService.removeDecorationType(t)})},t.prototype.getColorData=function(e){var t=this,i=this._editor.getModel();if(!i)return null;var n=i.getDecorationsInRange(h.Range.fromPositions(e,e)).filter(function(e){return t._colorDatas.has(e.id)});return 0===n.length?null:this._colorDatas.get(n[0].id)},
t.ID="editor.contrib.colorDetector",t.RECOMPUTE_TIME=1e3,t=d([c(1,u.ICodeEditorService),c(2,m.IConfigurationService)],t)}(a.Disposable);t.ColorDetector=v,l.registerEditorContribution(v)}),define(t[488],i([1,0,327,38,11,21,174,248]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(e){function t(t,i){var n=e.call(this,i)||this;return n._type=t,n}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){for(var i=t.getModel(),n=[],o=t.getSelections(),r=i.getOptions(),s=0,a=o;s<a.length;s++){var u=a[s];n.push(new l.LineCommentCommand(u,r.tabSize,this._type))}t.pushUndoStop(),t.executeCommands(this.id,n),t.pushUndoStop()}},t}(o.EditorAction),d=function(e){function t(){return e.call(this,0,{id:"editor.action.commentLine",label:i.localize(0,null),alias:"Toggle Line Comment",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:2133,weight:100},menubarOpts:{menuId:14,group:"5_insert",title:i.localize(1,null),
order:1}})||this}return r(t,e),t}(u),c=function(e){function t(){return e.call(this,1,{id:"editor.action.addCommentLine",label:i.localize(2,null),alias:"Add Line Comment",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:n.KeyChord(2089,2081),weight:100}})||this}return r(t,e),t}(u),h=function(e){function t(){return e.call(this,2,{id:"editor.action.removeCommentLine",label:i.localize(3,null),alias:"Remove Line Comment",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:n.KeyChord(2089,2099),weight:100}})||this}return r(t,e),t}(u),p=function(e){function t(){return e.call(this,{id:"editor.action.blockComment",label:i.localize(4,null),alias:"Toggle Block Comment",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:1567,linux:{primary:3103},weight:100},menubarOpts:{menuId:14,group:"5_insert",title:i.localize(5,null),order:2}})||this}return r(t,e),
t.prototype.run=function(e,t){if(t.hasModel()){for(var i=[],n=0,o=t.getSelections();n<o.length;n++){var r=o[n];i.push(new a.BlockCommentCommand(r))}t.pushUndoStop(),t.executeCommands(this.id,i),t.pushUndoStop()}},t}(o.EditorAction);o.registerEditorAction(d),o.registerEditorAction(c),o.registerEditorAction(h),o.registerEditorAction(p)}),define(t[489],i([1,0,328,8,74,2,11,21,59,14,54,33]),function(e,t,i,n,o,s,a,l,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(){function e(e,t,i,n,o,r){var a=this;this._contextMenuService=t,this._contextViewService=i,this._contextKeyService=n,this._keybindingService=o,this._menuService=r,this._toDispose=new s.DisposableStore,this._contextMenuIsBeingShownCount=0,this._editor=e,this._toDispose.add(this._editor.onContextMenu(function(e){return a._onContextMenu(e)})),this._toDispose.add(this._editor.onMouseWheel(function(e){a._contextMenuIsBeingShownCount>0&&a._contextViewService.hideContextView()})),
this._toDispose.add(this._editor.onKeyDown(function(e){58===e.keyCode&&(e.preventDefault(),e.stopPropagation(),a.showContextMenu())}))}return e.get=function(t){return t.getContribution(e.ID)},e.prototype._onContextMenu=function(e){if(this._editor.hasModel()){if(!this._editor.getConfiguration().contribInfo.contextmenu)return this._editor.focus(),void(e.target.position&&!this._editor.getSelection().containsPosition(e.target.position)&&this._editor.setPosition(e.target.position));if(12!==e.target.type&&(e.event.preventDefault(),6===e.target.type||7===e.target.type||1===e.target.type)){this._editor.focus(),e.target.position&&!this._editor.getSelection().containsPosition(e.target.position)&&this._editor.setPosition(e.target.position);var t=null;1!==e.target.type&&(t={x:e.event.posx-1,width:2,y:e.event.posy-1,height:2}),this.showContextMenu(t)}}},e.prototype.showContextMenu=function(e){if(this._editor.getConfiguration().contribInfo.contextmenu&&this._editor.hasModel())if(this._contextMenuService){
var t=this._getMenuActions(this._editor.getModel());t.length>0&&this._doShowContextMenu(t,e)}else this._editor.focus()},e.prototype._getMenuActions=function(e){var t=[],i=this._menuService.createMenu(7,this._contextKeyService),n=i.getActions({arg:e.uri});i.dispose();for(var r=0,s=n;r<s.length;r++){var a=s[r][1];t.push.apply(t,a),t.push(new o.Separator)}return t.pop(),t},e.prototype._doShowContextMenu=function(e,t){var i=this;if(void 0===t&&(t=null),this._editor.hasModel()){var r=this._editor.getConfiguration().contribInfo.hover;if(this._editor.updateOptions({hover:{enabled:!1}}),!t){this._editor.revealPosition(this._editor.getPosition(),1),this._editor.render();var s=this._editor.getScrolledVisiblePosition(this._editor.getPosition()),a=n.getDomNodePagePosition(this._editor.getDomNode()),l=a.left+s.left,u=a.top+s.top+s.height;t={x:l,y:u}}this._contextMenuIsBeingShownCount++,this._contextMenuService.showContextMenu({getAnchor:function(){return t},getActions:function(){return e},getActionViewItem:function(e){
var t=i._keybindingFor(e);if(t)return new o.ActionViewItem(e,e,{label:!0,keybinding:t.getLabel(),isMenu:!0});var n=e;return"function"==typeof n.getActionViewItem?n.getActionViewItem():new o.ActionViewItem(e,e,{icon:!0,label:!0,isMenu:!0})},getKeyBinding:function(e){return i._keybindingFor(e)},onHide:function(e){i._contextMenuIsBeingShownCount--,i._editor.focus(),i._editor.updateOptions({hover:r})}})}},e.prototype._keybindingFor=function(e){return this._keybindingService.lookupKeybinding(e.id)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._contextMenuIsBeingShownCount>0&&this._contextViewService.hideContextView(),this._toDispose.dispose()},e.ID="editor.contrib.contextmenu",e=d([c(1,p.IContextMenuService),c(2,p.IContextViewService),c(3,h.IContextKeyService),c(4,f.IKeybindingService),c(5,u.IMenuService)],e)}();t.ContextMenuController=g;var m=function(e){function t(){return e.call(this,{id:"editor.action.showContextMenu",label:i.localize(0,null),alias:"Show Editor Context Menu",
precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.textInputFocus,primary:1092,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){g.get(t).showContextMenu()},t}(a.EditorAction);a.registerEditorContribution(g),a.registerEditorAction(m)}),define(t[490],i([1,0,329,2,11,21]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(e){this.selections=e}return e.prototype.equals=function(e){var t=this.selections.length;if(t!==e.selections.length)return!1;for(var i=0;i<t;i++)if(!this.selections[i].equalsSelection(e.selections[i]))return!1;return!0},e}(),l=function(e){function t(t){var i=e.call(this)||this;return i._editor=t,i._isCursorUndo=!1,i._undoStack=[],i._prevState=i._readState(),i._register(t.onDidChangeModel(function(e){i._undoStack=[],i._prevState=null})),i._register(t.onDidChangeModelContent(function(e){i._undoStack=[],i._prevState=null})),i._register(t.onDidChangeCursorSelection(function(e){
!i._isCursorUndo&&i._prevState&&(i._undoStack.push(i._prevState),i._undoStack.length>50&&i._undoStack.shift()),i._prevState=i._readState()})),i}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype._readState=function(){return this._editor.hasModel()?new a(this._editor.getSelections()):null},t.prototype.getId=function(){return t.ID},t.prototype.cursorUndo=function(){if(this._editor.hasModel())for(var e=new a(this._editor.getSelections());this._undoStack.length>0;){var t=this._undoStack.pop();if(!t.equals(e))return this._isCursorUndo=!0,this._editor.setSelections(t.selections),this._editor.revealRangeInCenterIfOutsideViewport(t.selections[0],0),void(this._isCursorUndo=!1)}},t.ID="editor.contrib.cursorUndoController",t}(n.Disposable);t.CursorUndoController=l;var u=function(e){function t(){return e.call(this,{id:"cursorUndo",label:i.localize(0,null),alias:"Soft Undo",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:2099,weight:100}})||this}return r(t,e),
t.prototype.run=function(e,t,i){l.get(t).cursorUndo()},t}(o.EditorAction);t.CursorUndo=u,o.registerEditorContribution(l),o.registerEditorAction(u)}),define(t[491],i([1,0,2,18,11,13,3,20,249,30,551]),function(e,t,i,n,o,s,a,l,u,d){"use strict";function c(e){return n.isMacintosh?e.altKey:e.ctrlKey}Object.defineProperty(t,"__esModule",{value:!0});var h=function(e){function t(t){var i=e.call(this)||this;return i._editor=t,i._register(i._editor.onMouseDown(function(e){return i._onEditorMouseDown(e)})),i._register(i._editor.onMouseUp(function(e){return i._onEditorMouseUp(e)})),i._register(i._editor.onMouseDrag(function(e){return i._onEditorMouseDrag(e)})),i._register(i._editor.onMouseDrop(function(e){return i._onEditorMouseDrop(e)})),i._register(i._editor.onKeyDown(function(e){return i.onEditorKeyDown(e)})),i._register(i._editor.onKeyUp(function(e){return i.onEditorKeyUp(e)})),i._register(i._editor.onDidBlurEditorWidget(function(){return i.onEditorBlur()})),i._dndDecorationIds=[],i._mouseDown=!1,
i._modifierPressed=!1,i._dragSelection=null,i}return r(t,e),t.prototype.onEditorBlur=function(){this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1,this._modifierPressed=!1},t.prototype.onEditorKeyDown=function(e){this._editor.getConfiguration().dragAndDrop&&(c(e)&&(this._modifierPressed=!0),this._mouseDown&&c(e)&&this._editor.updateOptions({mouseStyle:"copy"}))},t.prototype.onEditorKeyUp=function(e){this._editor.getConfiguration().dragAndDrop&&(c(e)&&(this._modifierPressed=!1),this._mouseDown&&e.keyCode===t.TRIGGER_KEY_VALUE&&this._editor.updateOptions({mouseStyle:"default"}))},t.prototype._onEditorMouseDown=function(e){this._mouseDown=!0},t.prototype._onEditorMouseUp=function(e){this._mouseDown=!1,this._editor.updateOptions({mouseStyle:"text"})},t.prototype._onEditorMouseDrag=function(e){var t=e.target;if(null===this._dragSelection){var i=(this._editor.getSelections()||[]).filter(function(e){return t.position&&e.containsPosition(t.position)});if(1!==i.length)return;this._dragSelection=i[0]}
c(e.event)?this._editor.updateOptions({mouseStyle:"copy"}):this._editor.updateOptions({mouseStyle:"default"}),t.position&&(this._dragSelection.containsPosition(t.position)?this._removeDecoration():this.showAt(t.position))},t.prototype._onEditorMouseDrop=function(e){if(e.target&&(this._hitContent(e.target)||this._hitMargin(e.target))&&e.target.position){var i=new s.Position(e.target.position.lineNumber,e.target.position.column);if(null===this._dragSelection){var n=null;if(e.event.shiftKey){var o=this._editor.getSelection();if(o){var r=o.selectionStartLineNumber,a=o.selectionStartColumn;n=[new l.Selection(r,a,i.lineNumber,i.column)]}}else n=(this._editor.getSelections()||[]).map(function(e){return e.containsPosition(i)?new l.Selection(i.lineNumber,i.column,i.lineNumber,i.column):e});this._editor.setSelections(n||[],"mouse")
}else(!this._dragSelection.containsPosition(i)||(c(e.event)||this._modifierPressed)&&(this._dragSelection.getEndPosition().equals(i)||this._dragSelection.getStartPosition().equals(i)))&&(this._editor.pushUndoStop(),this._editor.executeCommand(t.ID,new u.DragAndDropCommand(this._dragSelection,i,c(e.event)||this._modifierPressed)),this._editor.pushUndoStop())}this._editor.updateOptions({mouseStyle:"text"}),this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1},t.prototype.showAt=function(e){var i=[{range:new a.Range(e.lineNumber,e.column,e.lineNumber,e.column),options:t._DECORATION_OPTIONS}];this._dndDecorationIds=this._editor.deltaDecorations(this._dndDecorationIds,i),this._editor.revealPosition(e,1)},t.prototype._removeDecoration=function(){this._dndDecorationIds=this._editor.deltaDecorations(this._dndDecorationIds,[])},t.prototype._hitContent=function(e){return 6===e.type||7===e.type},t.prototype._hitMargin=function(e){return 2===e.type||3===e.type||4===e.type},t.prototype.getId=function(){
return t.ID},t.prototype.dispose=function(){this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1,this._modifierPressed=!1,e.prototype.dispose.call(this)},t.ID="editor.contrib.dragAndDrop",t.TRIGGER_KEY_VALUE=n.isMacintosh?6:5,t._DECORATION_OPTIONS=d.ModelDecorationOptions.register({className:"dnd-target"}),t}(i.Disposable);t.DragAndDropController=h,o.registerEditorContribution(h)}),define(t[492],i([1,0,332,23,5,15,38,2,11,254,410,21,255,40,411,17,175,257,10,14,540]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S){"use strict";function w(e){if(!n.isUndefined(e)){if(!n.isObject(e))return!1;var t=e;if(!n.isUndefined(t.levels)&&!n.isNumber(t.levels))return!1;if(!n.isUndefined(t.direction)&&!n.isString(t.direction))return!1;if(!(n.isUndefined(t.selectionLines)||n.isArray(t.selectionLines)&&t.selectionLines.every(n.isNumber)))return!1}return!0}Object.defineProperty(t,"__esModule",{value:!0});var E=new S.RawContextKey("foldingEnabled",!1);t.ID="editor.contrib.folding";var L=function(e){
function i(t,i){var n=e.call(this)||this;return n.contextKeyService=i,n.localToDispose=n._register(new l.DisposableStore),n.editor=t,n._isEnabled=n.editor.getConfiguration().contribInfo.folding,n._autoHideFoldingControls="mouseover"===n.editor.getConfiguration().contribInfo.showFoldingControls,n._useFoldingProviders="indentation"!==n.editor.getConfiguration().contribInfo.foldingStrategy,n.foldingModel=null,n.hiddenRangeModel=null,n.rangeProvider=null,n.foldingRegionPromise=null,n.foldingStateMemento=null,n.foldingModelPromise=null,n.updateScheduler=null,n.cursorChangedScheduler=null,n.mouseDownInfo=null,n.foldingDecorationProvider=new p.FoldingDecorationProvider(t),n.foldingDecorationProvider.autoHideFoldingControls=n._autoHideFoldingControls,n.foldingEnabled=E.bindTo(n.contextKeyService),n.foldingEnabled.set(n._isEnabled),n._register(n.editor.onDidChangeModel(function(){return n.onModelChanged()})),n._register(n.editor.onDidChangeConfiguration(function(e){if(e.contribInfo){var t=n._isEnabled
;n._isEnabled=n.editor.getConfiguration().contribInfo.folding,n.foldingEnabled.set(n._isEnabled),t!==n._isEnabled&&n.onModelChanged();var i=n._autoHideFoldingControls;n._autoHideFoldingControls="mouseover"===n.editor.getConfiguration().contribInfo.showFoldingControls,i!==n._autoHideFoldingControls&&(n.foldingDecorationProvider.autoHideFoldingControls=n._autoHideFoldingControls,n.onModelContentChanged());var o=n._useFoldingProviders;n._useFoldingProviders="indentation"!==n.editor.getConfiguration().contribInfo.foldingStrategy,o!==n._useFoldingProviders&&n.onFoldingStrategyChanged()}})),n.onModelChanged(),n}return r(i,e),i.get=function(e){return e.getContribution(t.ID)},i.prototype.getId=function(){return t.ID},i.prototype.saveViewState=function(){var e=this.editor.getModel();if(!e||!this._isEnabled||e.isTooLargeForTokenization())return{};if(this.foldingModel){var t=this.foldingModel.isInitialized?this.foldingModel.getMemento():this.hiddenRangeModel.getMemento(),i=this.rangeProvider?this.rangeProvider.id:void 0
;return{collapsedRegions:t,lineCount:e.getLineCount(),provider:i}}},i.prototype.restoreViewState=function(e){var t=this.editor.getModel();if(t&&this._isEnabled&&!t.isTooLargeForTokenization()&&this.hiddenRangeModel&&e&&e.collapsedRegions&&e.lineCount===t.getLineCount()){e.provider!==y.ID_SYNTAX_PROVIDER&&e.provider!==b.ID_INIT_PROVIDER||(this.foldingStateMemento=e);var i=e.collapsedRegions;if(this.hiddenRangeModel.applyMemento(i)){var n=this.getFoldingModel();n&&n.then(function(e){e&&e.applyMemento(i)}).then(void 0,C.onUnexpectedError)}}},i.prototype.onModelChanged=function(){var e=this;this.localToDispose.clear();var t=this.editor.getModel();this._isEnabled&&t&&!t.isTooLargeForTokenization()&&(this.foldingModel=new h.FoldingModel(t,this.foldingDecorationProvider),this.localToDispose.add(this.foldingModel),this.hiddenRangeModel=new g.HiddenRangeModel(this.foldingModel),this.localToDispose.add(this.hiddenRangeModel),this.localToDispose.add(this.hiddenRangeModel.onDidChange(function(t){
return e.onHiddenRangesChanges(t)})),this.updateScheduler=new s.Delayer(200),this.cursorChangedScheduler=new s.RunOnceScheduler(function(){return e.revealCursor()},200),this.localToDispose.add(this.cursorChangedScheduler),this.localToDispose.add(_.FoldingRangeProviderRegistry.onDidChange(function(){return e.onFoldingStrategyChanged()})),this.localToDispose.add(this.editor.onDidChangeModelLanguageConfiguration(function(){return e.onFoldingStrategyChanged()})),this.localToDispose.add(this.editor.onDidChangeModelContent(function(){return e.onModelContentChanged()})),this.localToDispose.add(this.editor.onDidChangeCursorPosition(function(){return e.onCursorPositionChanged()})),this.localToDispose.add(this.editor.onMouseDown(function(t){return e.onEditorMouseDown(t)})),this.localToDispose.add(this.editor.onMouseUp(function(t){return e.onEditorMouseUp(t)})),this.localToDispose.add({dispose:function(){e.foldingRegionPromise&&(e.foldingRegionPromise.cancel(),e.foldingRegionPromise=null),
e.updateScheduler&&e.updateScheduler.cancel(),e.updateScheduler=null,e.foldingModel=null,e.foldingModelPromise=null,e.hiddenRangeModel=null,e.cursorChangedScheduler=null,e.foldingStateMemento=null,e.rangeProvider&&e.rangeProvider.dispose(),e.rangeProvider=null}}),this.onModelContentChanged())},i.prototype.onFoldingStrategyChanged=function(){this.rangeProvider&&this.rangeProvider.dispose(),this.rangeProvider=null,this.onModelContentChanged()},i.prototype.getRangeProvider=function(e){var t=this;if(this.rangeProvider)return this.rangeProvider;if(this.rangeProvider=new v.IndentRangeProvider(e),this._useFoldingProviders&&this.foldingModel){var i=_.FoldingRangeProviderRegistry.ordered(this.foldingModel.textModel);if(0===i.length&&this.foldingStateMemento&&this.foldingStateMemento.collapsedRegions){return this.rangeProvider=new b.InitializingRangeProvider(e,this.foldingStateMemento.collapsedRegions,function(){t.foldingStateMemento=null,t.onFoldingStrategyChanged()},3e4)}
i.length>0&&(this.rangeProvider=new y.SyntaxRangeProvider(e,i))}return this.foldingStateMemento=null,this.rangeProvider},i.prototype.getFoldingModel=function(){return this.foldingModelPromise},i.prototype.onModelContentChanged=function(){var e=this;this.updateScheduler&&(this.foldingRegionPromise&&(this.foldingRegionPromise.cancel(),this.foldingRegionPromise=null),this.foldingModelPromise=this.updateScheduler.trigger(function(){var t=e.foldingModel;if(!t)return null;var i=e.foldingRegionPromise=s.createCancelablePromise(function(i){return e.getRangeProvider(t.textModel).compute(i)});return i.then(function(n){if(n&&i===e.foldingRegionPromise){var o=e.editor.getSelections(),r=o?o.map(function(e){return e.startLineNumber}):[];t.update(n,r)}return t})}).then(void 0,function(e){return C.onUnexpectedError(e),null}))},i.prototype.onHiddenRangesChanges=function(e){if(this.hiddenRangeModel&&e.length){var t=this.editor.getSelections();t&&this.hiddenRangeModel.adjustSelections(t)&&this.editor.setSelections(t)}
this.editor.setHiddenAreas(e)},i.prototype.onCursorPositionChanged=function(){this.hiddenRangeModel&&this.hiddenRangeModel.hasRanges()&&this.cursorChangedScheduler.schedule()},i.prototype.revealCursor=function(){var e=this,t=this.getFoldingModel();t&&t.then(function(t){if(t){var i=e.editor.getSelections();if(i&&i.length>0){for(var n=[],o=function(i){var o=i.selectionStartLineNumber;e.hiddenRangeModel&&e.hiddenRangeModel.isHidden(o)&&n.push.apply(n,t.getAllRegionsAtLine(o,function(e){return e.isCollapsed&&o>e.startLineNumber}))},r=0,s=i;r<s.length;r++){o(s[r])}n.length&&(t.toggleCollapseState(n),e.reveal(i[0].getPosition()))}}}).then(void 0,C.onUnexpectedError)},i.prototype.onEditorMouseDown=function(e){if(this.mouseDownInfo=null,this.hiddenRangeModel&&e.target&&e.target.range&&(e.event.leftButton||e.event.middleButton)){var t=e.target.range,i=!1;switch(e.target.type){case 4:var n=e.target.detail,o=e.target.element.offsetLeft;if(n.offsetX-o<5)return;i=!0;break;case 7:if(this.hiddenRangeModel.hasRanges()){
if(!e.target.detail.isAfterLines)break}return;case 6:if(this.hiddenRangeModel.hasRanges()){var r=this.editor.getModel();if(r&&t.startColumn===r.getLineMaxColumn(t.startLineNumber))break}return;default:return}this.mouseDownInfo={lineNumber:t.startLineNumber,iconClicked:i}}},i.prototype.onEditorMouseUp=function(e){var t=this,i=this.getFoldingModel();if(i&&this.mouseDownInfo&&e.target){var n=this.mouseDownInfo.lineNumber,o=this.mouseDownInfo.iconClicked,r=e.target.range;if(r&&r.startLineNumber===n){if(o){if(4!==e.target.type)return}else{var s=this.editor.getModel();if(!s||r.startColumn!==s.getLineMaxColumn(n))return}i.then(function(i){if(i){var r=i.getRegionAtLine(n);if(r&&r.startLineNumber===n){var s=r.isCollapsed;if(o||s){var a=[r];(e.event.middleButton||e.event.shiftKey)&&a.push.apply(a,i.getRegionsInside(r,function(e){return e.isCollapsed===s})),i.toggleCollapseState(a),t.reveal({lineNumber:n,column:1})}}}}).then(void 0,C.onUnexpectedError)}}},i.prototype.reveal=function(e){
this.editor.revealPositionInCenterIfOutsideViewport(e,0)},i=d([c(1,S.IContextKeyService)],i)}(l.Disposable);t.FoldingController=L;var x=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var n=this,o=L.get(t);if(o){var r=o.getFoldingModel();return r?(this.reportTelemetry(e,t),r.then(function(e){if(e){n.invoke(o,e,t,i);var r=t.getSelection();r&&o.reveal(r.getStartPosition())}})):void 0}},t.prototype.getSelectedLines=function(e){var t=e.getSelections();return t?t.map(function(e){return e.startLineNumber}):[]},t.prototype.getLineNumbers=function(e,t){return e&&e.selectionLines?e.selectionLines.map(function(e){return e+1}):this.getSelectedLines(t)},t.prototype.run=function(e,t){},t}(u.EditorAction),D=function(e){function t(){return e.call(this,{id:"editor.unfold",label:i.localize(0,null),alias:"Unfold",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:3161,mac:{primary:2649},weight:100},description:{
description:"Unfold the content in the editor",args:[{name:"Unfold editor argument",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t* 'levels': Number of levels to unfold. If not set, defaults to 1.\n\t\t\t\t\t\t* 'direction': If 'up', unfold given number of levels up otherwise unfolds down.\n\t\t\t\t\t\t* 'selectionLines': The start lines (0-based) of the editor selections to apply the unfold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t",constraint:w,schema:{type:"object",properties:{levels:{type:"number",default:1},direction:{type:"string",enum:["up","down"],default:"down"},selectionLines:{type:"array",items:{type:"number"}}}}}]}})||this}return r(t,e),t.prototype.invoke=function(e,t,i,n){var o=n&&n.levels||1,r=this.getLineNumbers(n,i);n&&"up"===n.direction?h.setCollapseStateLevelsUp(t,!1,o,r):h.setCollapseStateLevelsDown(t,!1,o,r)},t}(x),I=function(e){function t(){return e.call(this,{id:"editor.unfoldRecursively",
label:i.localize(1,null),alias:"Unfold Recursively",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2137),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i,n){h.setCollapseStateLevelsDown(t,!1,Number.MAX_VALUE,this.getSelectedLines(i))},t}(x),N=function(e){function t(){return e.call(this,{id:"editor.fold",label:i.localize(2,null),alias:"Fold",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:3159,mac:{primary:2647},weight:100},description:{description:"Fold the content in the editor",args:[{name:"Fold editor argument",
description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t\t* 'levels': Number of levels to fold. Defaults to 1.\n\t\t\t\t\t\t\t* 'direction': If 'up', folds given number of levels up otherwise folds down.\n\t\t\t\t\t\t\t* 'selectionLines': The start lines (0-based) of the editor selections to apply the fold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t",constraint:w,schema:{type:"object",properties:{levels:{type:"number",default:1},direction:{type:"string",enum:["up","down"],default:"down"},selectionLines:{type:"array",items:{type:"number"}}}}}]}})||this}return r(t,e),t.prototype.invoke=function(e,t,i,n){var o=n&&n.levels||1,r=this.getLineNumbers(n,i);n&&"up"===n.direction?h.setCollapseStateLevelsUp(t,!0,o,r):h.setCollapseStateLevelsDown(t,!0,o,r)},t}(x),M=function(e){function t(){return e.call(this,{id:"editor.foldRecursively",label:i.localize(3,null),alias:"Fold Recursively",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,
primary:a.KeyChord(2089,2135),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){var n=this.getSelectedLines(i);h.setCollapseStateLevelsDown(t,!0,Number.MAX_VALUE,n)},t}(x),k=function(e){function t(){return e.call(this,{id:"editor.foldAllBlockComments",label:i.localize(4,null),alias:"Fold All Block Comments",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2133),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){if(t.regions.hasTypes())h.setCollapseStateForType(t,_.FoldingRangeKind.Comment.value,!0);else{var n=i.getModel();if(!n)return;var r=m.LanguageConfigurationRegistry.getComments(n.getLanguageIdentifier().id);if(r&&r.blockCommentStartToken){var s=new RegExp("^\\s*"+o.escapeRegExpCharacters(r.blockCommentStartToken));h.setCollapseStateForMatchingLines(t,s,!0)}}},t}(x),T=function(e){function t(){return e.call(this,{id:"editor.foldAllMarkerRegions",label:i.localize(5,null),alias:"Fold All Regions",precondition:E,kbOpts:{
kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2077),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){if(t.regions.hasTypes())h.setCollapseStateForType(t,_.FoldingRangeKind.Region.value,!0);else{var n=i.getModel();if(!n)return;var o=m.LanguageConfigurationRegistry.getFoldingRules(n.getLanguageIdentifier().id);if(o&&o.markers&&o.markers.start){var r=new RegExp(o.markers.start);h.setCollapseStateForMatchingLines(t,r,!0)}}},t}(x),R=function(e){function t(){return e.call(this,{id:"editor.unfoldAllMarkerRegions",label:i.localize(6,null),alias:"Unfold All Regions",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2078),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){if(t.regions.hasTypes())h.setCollapseStateForType(t,_.FoldingRangeKind.Region.value,!1);else{var n=i.getModel();if(!n)return;var o=m.LanguageConfigurationRegistry.getFoldingRules(n.getLanguageIdentifier().id);if(o&&o.markers&&o.markers.start){
var r=new RegExp(o.markers.start);h.setCollapseStateForMatchingLines(t,r,!1)}}},t}(x),O=function(e){function t(){return e.call(this,{id:"editor.foldAll",label:i.localize(7,null),alias:"Fold All",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2069),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){h.setCollapseStateLevelsDown(t,!0)},t}(x),P=function(e){function t(){return e.call(this,{id:"editor.unfoldAll",label:i.localize(8,null),alias:"Unfold All",precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2088),weight:100}})||this}return r(t,e),t.prototype.invoke=function(e,t,i){h.setCollapseStateLevelsDown(t,!1)},t}(x),A=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.getFoldingLevel=function(){return parseInt(this.id.substr(t.ID_PREFIX.length))},t.prototype.invoke=function(e,t,i){h.setCollapseStateAtLevel(t,this.getFoldingLevel(),!0,this.getSelectedLines(i))},
t.ID_PREFIX="editor.foldLevel",t.ID=function(e){return t.ID_PREFIX+e},t}(x);u.registerEditorContribution(L),u.registerEditorAction(D),u.registerEditorAction(I),u.registerEditorAction(N),u.registerEditorAction(M),u.registerEditorAction(O),u.registerEditorAction(P),u.registerEditorAction(k),u.registerEditorAction(T),u.registerEditorAction(R);for(var F=1;F<=7;F++)u.registerInstantiatedEditorAction(new A({id:A.ID(F),label:i.localize(9,null,F),alias:"Fold Level "+F,precondition:E,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:a.KeyChord(2089,2048|21+F),weight:100}}))}),define(t[493],i([1,0,333,11,112]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(){return e.call(this,{id:"editor.action.fontZoomIn",label:i.localize(0,null),alias:"Editor Font Zoom In",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){o.EditorZoom.setZoomLevel(o.EditorZoom.getZoomLevel()+1)},t}(n.EditorAction),a=function(e){function t(){
return e.call(this,{id:"editor.action.fontZoomOut",label:i.localize(1,null),alias:"Editor Font Zoom Out",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){o.EditorZoom.setZoomLevel(o.EditorZoom.getZoomLevel()-1)},t}(n.EditorAction),l=function(e){function t(){return e.call(this,{id:"editor.action.fontZoomReset",label:i.localize(2,null),alias:"Editor Font Zoom Reset",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){o.EditorZoom.setZoomLevel(0)},t}(n.EditorAction);n.registerEditorAction(s),n.registerEditorAction(a),n.registerEditorAction(l)}),define(t[494],i([1,0,43,19,26,10,24,61,101,11,13,3,20,17,60,42,176,334,371,12,75]),function(e,t,i,n,o,r,s,u,d,c,h,p,f,g,m,v,_,y,b,C,S){"use strict";function w(e){if((e=e.filter(function(e){return e.range})).length){for(var t=e[0].range,n=1;n<e.length;n++)t=p.Range.plusRange(t,e[n].range);var o=t.startLineNumber,r=t.endLineNumber
;o===r?1===e.length?i.alert(y.localize(0,null,o)):i.alert(y.localize(1,null,e.length,o)):1===e.length?i.alert(y.localize(2,null,o,r)):i.alert(y.localize(3,null,e.length,o,r))}}function E(e){for(var t=[],i=new Set,n=0,o=g.DocumentFormattingEditProviderRegistry.ordered(e);n<o.length;n++){l=o[n];t.push(l),l.extensionId&&i.add(b.ExtensionIdentifier.toKey(l.extensionId))}for(var r=function(e){if(e.extensionId){if(i.has(b.ExtensionIdentifier.toKey(e.extensionId)))return"continue";i.add(b.ExtensionIdentifier.toKey(e.extensionId))}t.push({displayName:e.displayName,extensionId:e.extensionId,provideDocumentFormattingEdits:function(t,i,n){return e.provideDocumentRangeFormattingEdits(t,t.getFullModelRange(),i,n)}})},s=0,a=g.DocumentRangeFormattingEditProviderRegistry.ordered(e);s<a.length;s++){var l;r(l=a[s])}return t}function L(e,t,i,n,o){return a(this,void 0,void 0,function(){var r,s,a,c,h,g,v;return l(this,function(l){switch(l.label){case 0:r=e.get(m.IEditorWorkerService),d.isCodeEditor(i)?(s=i.getModel(),
a=new u.EditorStateCancellationTokenSource(i,5,o)):(s=i,a=new u.TextModelCancellationTokenSource(i,o)),l.label=1;case 1:return l.trys.push([1,,4,5]),[4,t.provideDocumentRangeFormattingEdits(s,n,s.getFormattingOptions(),a.token)];case 2:return h=l.sent(),[4,r.computeMoreMinimalEdits(s.uri,h)];case 3:return c=l.sent(),a.token.isCancellationRequested?[2,!0]:[3,5];case 4:return a.dispose(),[7];case 5:return c&&0!==c.length?(d.isCodeEditor(i)?(_.FormattingEdit.execute(i,c),w(c),i.pushUndoStop(),i.focus(),i.revealPositionInCenterIfOutsideViewport(i.getPosition(),1)):(g=c[0].range,v=new f.Selection(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn),s.pushEditOperations([v],c.map(function(e){return{text:e.text,range:p.Range.lift(e.range),forceMoveMarkers:!0}}),function(e){for(var t=0,i=e;t<i.length;t++){var n=i[t].range;if(p.Range.areIntersectingOrTouching(n,v))return[new f.Selection(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn)]}return null})),[2,!0]):[2,!1]}})})}function x(e,t,i,n,o){
return a(this,void 0,void 0,function(){var r,s,a,c,h,g,v;return l(this,function(l){switch(l.label){case 0:r=e.get(m.IEditorWorkerService),d.isCodeEditor(i)?(s=i.getModel(),a=new u.EditorStateCancellationTokenSource(i,5,o)):(s=i,a=new u.TextModelCancellationTokenSource(i,o)),l.label=1;case 1:return l.trys.push([1,,4,5]),[4,t.provideDocumentFormattingEdits(s,s.getFormattingOptions(),a.token)];case 2:return h=l.sent(),[4,r.computeMoreMinimalEdits(s.uri,h)];case 3:return c=l.sent(),a.token.isCancellationRequested?[2,!0]:[3,5];case 4:return a.dispose(),[7];case 5:return c&&0!==c.length?(d.isCodeEditor(i)?(_.FormattingEdit.execute(i,c),2!==n&&(w(c),i.pushUndoStop(),i.focus(),i.revealPositionInCenterIfOutsideViewport(i.getPosition(),1))):(g=c[0].range,v=new f.Selection(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn),s.pushEditOperations([v],c.map(function(e){return{text:e.text,range:p.Range.lift(e.range),forceMoveMarkers:!0}}),function(e){for(var t=0,i=e;t<i.length;t++){var n=i[t].range
;if(p.Range.areIntersectingOrTouching(n,v))return[new f.Selection(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn)]}return null})),[2,!0]):[2,!1]}})})}function D(e,t,i,o,s){return a(this,void 0,void 0,function(){var a,u,d,c,h;return l(this,function(l){switch(l.label){case 0:a=g.DocumentRangeFormattingEditProviderRegistry.ordered(t),u=0,d=a,l.label=1;case 1:return u<d.length?(c=d[u],[4,Promise.resolve(c.provideDocumentRangeFormattingEdits(t,i,o,s)).catch(r.onUnexpectedExternalError)]):[3,5];case 2:return h=l.sent(),n.isNonEmptyArray(h)?[4,e.computeMoreMinimalEdits(t.uri,h)]:[3,4];case 3:return[2,l.sent()];case 4:return u++,[3,1];case 5:return[2,void 0]}})})}function I(e,t,i,o){return a(this,void 0,void 0,function(){var s,a,u,d,c;return l(this,function(l){switch(l.label){case 0:s=E(t),a=0,u=s,l.label=1;case 1:return a<u.length?(d=u[a],[4,Promise.resolve(d.provideDocumentFormattingEdits(t,i,o)).catch(r.onUnexpectedExternalError)]):[3,5];case 2:return c=l.sent(),
n.isNonEmptyArray(c)?[4,e.computeMoreMinimalEdits(t.uri,c)]:[3,4];case 3:return[2,l.sent()];case 4:return a++,[3,1];case 5:return[2,void 0]}})})}function N(e,t,i,n,s){var a=g.OnTypeFormattingEditProviderRegistry.ordered(t);return 0===a.length?Promise.resolve(void 0):a[0].autoFormatTriggerCharacters.indexOf(n)<0?Promise.resolve(void 0):Promise.resolve(a[0].provideOnTypeFormattingEdits(t,i,n,s,o.CancellationToken.None)).catch(r.onUnexpectedExternalError).then(function(i){return e.computeMoreMinimalEdits(t.uri,i)})}Object.defineProperty(t,"__esModule",{value:!0}),t.alertFormattingEdits=w,t.getRealAndSyntheticDocumentFormattersOrdered=E;var M=function(){function e(){}return e.select=function(t,i,n){return a(this,void 0,void 0,function(){var o;return l(this,function(r){switch(r.label){case 0:return 0===t.length?[2,void 0]:(o=e._selectors.iterator().next().value)?[4,o(t,i,n)]:[3,2];case 1:return[2,r.sent()];case 2:return[2,t[0]]}})})},e._selectors=new S.LinkedList,e}();t.FormattingConflicts=M,
t.formatDocumentRangeWithSelectedProvider=function(e,t,i,n,o){return a(this,void 0,void 0,function(){var r,s,a,u;return l(this,function(l){switch(l.label){case 0:return r=e.get(C.IInstantiationService),s=d.isCodeEditor(t)?t.getModel():t,a=g.DocumentRangeFormattingEditProviderRegistry.ordered(s),[4,M.select(a,s,n)];case 1:return(u=l.sent())?[4,r.invokeFunction(L,u,t,i,o)]:[3,3];case 2:l.sent(),l.label=3;case 3:return[2]}})})},t.formatDocumentRangeWithProvider=L,t.formatDocumentWithSelectedProvider=function(e,t,i,n){return a(this,void 0,void 0,function(){var o,r,s,a;return l(this,function(l){switch(l.label){case 0:return o=e.get(C.IInstantiationService),r=d.isCodeEditor(t)?t.getModel():t,s=E(r),[4,M.select(s,r,i)];case 1:return(a=l.sent())?[4,o.invokeFunction(x,a,t,i,n)]:[3,3];case 2:l.sent(),l.label=3;case 3:return[2]}})})},t.formatDocumentWithProvider=x,t.getDocumentRangeFormattingEditsUntilResult=D,t.getDocumentFormattingEditsUntilResult=I,t.getOnTypeFormattingEdits=N,
c.registerLanguageCommand("_executeFormatRangeProvider",function(e,t){var i=t.resource,n=t.range,a=t.options;if(!(i instanceof s.URI&&p.Range.isIRange(n)))throw r.illegalArgument();var l=e.get(v.IModelService).getModel(i);if(!l)throw r.illegalArgument("resource");return D(e.get(m.IEditorWorkerService),l,p.Range.lift(n),a,o.CancellationToken.None)}),c.registerLanguageCommand("_executeFormatDocumentProvider",function(e,t){var i=t.resource,n=t.options;if(!(i instanceof s.URI))throw r.illegalArgument("resource");var a=e.get(v.IModelService).getModel(i);if(!a)throw r.illegalArgument("resource");return I(e.get(m.IEditorWorkerService),a,n,o.CancellationToken.None)}),c.registerLanguageCommand("_executeFormatOnTypeProvider",function(e,t){var i=t.resource,n=t.position,o=t.ch,a=t.options;if(!(i instanceof s.URI&&h.Position.isIPosition(n)&&"string"==typeof o))throw r.illegalArgument();var l=e.get(v.IModelService).getModel(i);if(!l)throw r.illegalArgument("resource")
;return N(e.get(m.IEditorWorkerService),l,h.Position.lift(n),o,a)})}),define(t[495],i([1,0,19,26,38,2,11,31,80,3,21,17,60,494,176,335,32,14,12,10]),function(e,t,i,n,o,s,u,h,p,f,g,m,v,_,y,b,C,S,w,E){"use strict";var L=this;Object.defineProperty(t,"__esModule",{value:!0});var x=function(){function e(e,t){var i=this;this._workerService=t,this._callOnDispose=new s.DisposableStore,this._callOnModel=new s.DisposableStore,this._editor=e,this._callOnDispose.add(e.onDidChangeConfiguration(function(){return i._update()})),this._callOnDispose.add(e.onDidChangeModel(function(){return i._update()})),this._callOnDispose.add(e.onDidChangeModelLanguage(function(){return i._update()})),this._callOnDispose.add(m.OnTypeFormattingEditProviderRegistry.onDidChange(this._update,this))}return e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._callOnDispose.dispose(),this._callOnModel.dispose()},e.prototype._update=function(){var e=this;if(this._callOnModel.clear(),
this._editor.getConfiguration().contribInfo.formatOnType&&this._editor.hasModel()){var t=this._editor.getModel(),i=m.OnTypeFormattingEditProviderRegistry.ordered(t)[0];if(i&&i.autoFormatTriggerCharacters){for(var n=new p.CharacterSet,o=0,r=i.autoFormatTriggerCharacters;o<r.length;o++){var s=r[o];n.add(s.charCodeAt(0))}this._callOnModel.add(this._editor.onDidType(function(t){var i=t.charCodeAt(t.length-1);n.has(i)&&e._trigger(String.fromCharCode(i))}))}}},e.prototype._trigger=function(e){var t=this;if(this._editor.hasModel()&&!(this._editor.getSelections().length>1)){var n=this._editor.getModel(),o=this._editor.getPosition(),r=!1,s=this._editor.onDidChangeModelContent(function(e){if(e.isFlush)return r=!0,void s.dispose();for(var t=0,i=e.changes.length;t<i;t++){if(e.changes[t].range.endLineNumber<=o.lineNumber)return r=!0,void s.dispose()}});_.getOnTypeFormattingEdits(this._workerService,n,o,e,n.getFormattingOptions()).then(function(e){s.dispose(),r||i.isNonEmptyArray(e)&&(y.FormattingEdit.execute(t._editor,e),
_.alertFormattingEdits(e))},function(e){throw s.dispose(),e})}},e.ID="editor.contrib.autoFormat",e=d([c(1,v.IEditorWorkerService)],e)}(),D=function(){function e(e,t){var i=this;this.editor=e,this._instantiationService=t,this._callOnDispose=new s.DisposableStore,this._callOnModel=new s.DisposableStore,this._callOnDispose.add(e.onDidChangeConfiguration(function(){return i._update()})),this._callOnDispose.add(e.onDidChangeModel(function(){return i._update()})),this._callOnDispose.add(e.onDidChangeModelLanguage(function(){return i._update()})),this._callOnDispose.add(m.DocumentRangeFormattingEditProviderRegistry.onDidChange(this._update,this))}return e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._callOnDispose.dispose(),this._callOnModel.dispose()},e.prototype._update=function(){var e=this;this._callOnModel.clear(),
this.editor.getConfiguration().contribInfo.formatOnPaste&&this.editor.hasModel()&&m.DocumentRangeFormattingEditProviderRegistry.has(this.editor.getModel())&&this._callOnModel.add(this.editor.onDidPaste(function(t){return e._trigger(t)}))},e.prototype._trigger=function(e){this.editor.hasModel()&&(this.editor.getSelections().length>1||this._instantiationService.invokeFunction(_.formatDocumentRangeWithSelectedProvider,this.editor,e,2,n.CancellationToken.None).catch(E.onUnexpectedError))},e.ID="editor.contrib.formatOnPaste",e=d([c(1,w.IInstantiationService)],e)}(),I=function(e){function t(){return e.call(this,{id:"editor.action.formatDocument",label:b.localize(0,null),alias:"Format Document",precondition:S.ContextKeyExpr.and(g.EditorContextKeys.writable,g.EditorContextKeys.hasDocumentFormattingProvider),kbOpts:{kbExpr:S.ContextKeyExpr.and(g.EditorContextKeys.editorTextFocus,g.EditorContextKeys.hasDocumentFormattingProvider),primary:1572,linux:{primary:3111},weight:100},menuOpts:{
when:g.EditorContextKeys.hasDocumentFormattingProvider,group:"1_modification",order:1.3}})||this}return r(t,e),t.prototype.run=function(e,t){return a(this,void 0,void 0,function(){var i;return l(this,function(o){switch(o.label){case 0:return t.hasModel()?(i=e.get(w.IInstantiationService),[4,i.invokeFunction(_.formatDocumentWithSelectedProvider,t,1,n.CancellationToken.None)]):[3,2];case 1:o.sent(),o.label=2;case 2:return[2]}})})},t}(u.EditorAction),N=function(e){function t(){return e.call(this,{id:"editor.action.formatSelection",label:b.localize(1,null),alias:"Format Selection",precondition:S.ContextKeyExpr.and(g.EditorContextKeys.writable,g.EditorContextKeys.hasDocumentSelectionFormattingProvider),kbOpts:{kbExpr:S.ContextKeyExpr.and(g.EditorContextKeys.editorTextFocus,g.EditorContextKeys.hasDocumentSelectionFormattingProvider),primary:o.KeyChord(2089,2084),weight:100},menuOpts:{when:S.ContextKeyExpr.and(g.EditorContextKeys.hasDocumentSelectionFormattingProvider,g.EditorContextKeys.hasNonEmptySelection),
group:"1_modification",order:1.31}})||this}return r(t,e),t.prototype.run=function(e,t){return a(this,void 0,void 0,function(){var i,o,r;return l(this,function(s){switch(s.label){case 0:return t.hasModel()?(i=e.get(w.IInstantiationService),o=t.getModel(),(r=t.getSelection()).isEmpty()&&(r=new f.Range(r.startLineNumber,1,r.startLineNumber,o.getLineMaxColumn(r.startLineNumber))),[4,i.invokeFunction(_.formatDocumentRangeWithSelectedProvider,t,r,1,n.CancellationToken.None)]):[2];case 1:return s.sent(),[2]}})})},t}(u.EditorAction);u.registerEditorContribution(x),u.registerEditorContribution(D),u.registerEditorAction(I),u.registerEditorAction(N),C.CommandsRegistry.registerCommand("editor.action.format",function(e){return a(L,void 0,void 0,function(){var t,i;return l(this,function(n){switch(n.label){case 0:return(t=e.get(h.ICodeEditorService).getFocusedCodeEditor())&&t.hasModel()?(i=e.get(C.ICommandService),t.getSelection().isEmpty()?[4,i.executeCommand("editor.action.formatDocument")]:[3,2]):[2];case 1:
return n.sent(),[3,4];case 2:return[4,i.executeCommand("editor.action.formatSelection")];case 3:n.sent(),n.label=4;case 4:return[2]}})})})}),define(t[210],i([1,0,19,26,10,11,17]),function(e,t,i,n,o,r,s){"use strict";function a(e,t,n,r){var s=n.ordered(e).map(function(i){return Promise.resolve(r(i,e,t)).then(void 0,function(e){o.onUnexpectedExternalError(e)})});return Promise.all(s).then(i.flatten).then(i.coalesce)}function l(e,t,i){return a(e,t,s.DefinitionProviderRegistry,function(e,t,n){return e.provideDefinition(t,n,i)})}function u(e,t,i){return a(e,t,s.DeclarationProviderRegistry,function(e,t,n){return e.provideDeclaration(t,n,i)})}function d(e,t,i){return a(e,t,s.ImplementationProviderRegistry,function(e,t,n){return e.provideImplementation(t,n,i)})}function c(e,t,i){return a(e,t,s.TypeDefinitionProviderRegistry,function(e,t,n){return e.provideTypeDefinition(t,n,i)})}Object.defineProperty(t,"__esModule",{value:!0}),t.getDefinitionsAtPosition=l,t.getDeclarationsAtPosition=u,
t.getImplementationsAtPosition=d,t.getTypeDefinitionsAtPosition=c,r.registerDefaultLanguageCommand("_executeDefinitionProvider",function(e,t){return l(e,t,n.CancellationToken.None)}),r.registerDefaultLanguageCommand("_executeDeclarationProvider",function(e,t){return u(e,t,n.CancellationToken.None)}),r.registerDefaultLanguageCommand("_executeImplementationProvider",function(e,t){return d(e,t,n.CancellationToken.None)}),r.registerDefaultLanguageCommand("_executeTypeDefinitionProvider",function(e,t){return c(e,t,n.CancellationToken.None)})}),define(t[497],i([1,0,14,12,73,84,11,31,3,2,4,338,33,34]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ctxHasSymbols=new i.RawContextKey("hasSymbols",!1),t.ISymbolNavigationService=n.createDecorator("ISymbolNavigationService");var v=function(){function e(e,i,n,o){this._editorService=i,this._notificationService=n,this._keybindingService=o,this._currentModel=void 0,this._currentIdx=-1,this._ignoreEditorChange=!1,
this._ctxHasSymbols=t.ctxHasSymbols.bindTo(e)}return e.prototype.reset=function(){this._ctxHasSymbols.reset(),h.dispose(this._currentState),h.dispose(this._currentMessage),this._currentModel=void 0,this._currentIdx=-1},e.prototype.put=function(e){var t=this,i=e.parent.parent;if(i.references.length<=1)this.reset();else{this._currentModel=i,this._currentIdx=i.references.indexOf(e),this._ctxHasSymbols.set(!0),this._showMessage();var n=new _(this._editorService),o=n.onDidChange(function(e){if(!t._ignoreEditorChange){var n=t._editorService.getActiveCodeEditor();if(n){var o=n.getModel(),r=n.getPosition();if(o&&r){for(var s=!1,a=!1,l=0,d=i.references;l<d.length;l++){var c=d[l];if(c.uri.toString()===o.uri.toString())s=!0,a=a||u.Range.containsPosition(c.range,r);else if(s)break}s&&a||t.reset()}}}});this._currentState=h.combinedDisposable(n,o)}},e.prototype.revealNext=function(e){var t=this;if(!this._currentModel)return Promise.resolve();this._currentIdx+=1,this._currentIdx%=this._currentModel.references.length
;var i=this._currentModel.references[this._currentIdx];return this._showMessage(),this._ignoreEditorChange=!0,this._editorService.openCodeEditor({resource:i.uri,options:{selection:u.Range.collapseToStart(i.range),revealInCenterIfOutsideViewport:!0}},e).finally(function(){t._ignoreEditorChange=!1})},e.prototype._showMessage=function(){h.dispose(this._currentMessage);var e=this._keybindingService.lookupKeybinding("editor.gotoNextSymbolFromResult"),t=e?f.localize(0,null,this._currentIdx+1,this._currentModel.references.length,e.getLabel()):f.localize(1,null,this._currentIdx+1,this._currentModel.references.length);this._currentMessage=this._notificationService.status(t)},e=d([c(0,i.IContextKeyService),c(1,l.ICodeEditorService),c(2,m.INotificationService),c(3,g.IKeybindingService)],e)}();o.registerSingleton(t.ISymbolNavigationService,v,!0),a.registerEditorCommand(new(function(e){function n(){return e.call(this,{id:"editor.gotoNextSymbolFromResult",
precondition:i.ContextKeyExpr.and(t.ctxHasSymbols,i.ContextKeyExpr.equals("config.editor.gotoLocation.multiple","goto")),kbOpts:{weight:100,primary:70}})||this}return r(n,e),n.prototype.runEditorCommand=function(e,i){return e.get(t.ISymbolNavigationService).revealNext(i)},n}(a.EditorCommand))),s.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"editor.gotoNextSymbolFromResult.cancel",weight:100,when:t.ctxHasSymbols,primary:9,handler:function(e){e.get(t.ISymbolNavigationService).reset()}});var _=function(){function e(e){this._listener=new Map,this._disposables=new h.DisposableStore,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._disposables.add(e.onCodeEditorRemove(this._onDidRemoveEditor,this)),this._disposables.add(e.onCodeEditorAdd(this._onDidAddEditor,this)),e.listCodeEditors().forEach(this._onDidAddEditor,this)}return e.prototype.dispose=function(){this._disposables.dispose(),this._onDidChange.dispose(),this._listener.forEach(h.dispose)},
e.prototype._onDidAddEditor=function(e){var t=this;this._listener.set(e,h.combinedDisposable(e.onDidChangeCursorPosition(function(i){return t._onDidChange.fire({editor:e})}),e.onDidChangeModelContent(function(i){return t._onDidChange.fire({editor:e})})))},e.prototype._onDidRemoveEditor=function(e){h.dispose(this._listener.get(e)),this._listener.delete(e)},e=d([c(0,l.ICodeEditorService)],e)}()}),define(t[498],i([1,0,19,26,10,11,17]),function(e,t,i,n,o,r,s){"use strict";function a(e,t,n){var r=s.HoverProviderRegistry.ordered(e).map(function(i){return Promise.resolve(i.provideHover(e,t,n)).then(function(e){return e&&function(e){var t=void 0!==e.range,i=void 0!==e.contents&&e.contents&&e.contents.length>0;return t&&i}(e)?e:void 0},function(e){o.onUnexpectedExternalError(e)})});return Promise.all(r).then(i.coalesce)}Object.defineProperty(t,"__esModule",{value:!0}),t.getHover=a,r.registerDefaultLanguageCommand("_executeHoverProvider",function(e,t){return a(e,t,n.CancellationToken.None)})}),
define(t[499],i([1,0,344,38,120,11,81,505,146,53,13,3,20,21,264,412,265]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var _=function(e){function t(t,i){var n=e.call(this,i)||this;return n.down=t,n}return r(t,e),t.prototype.run=function(e,t){for(var i=[],n=0,o=t.getSelections()||[];n<o.length;n++){var r=o[n];i.push(new g.CopyLinesCommand(r,this.down))}t.pushUndoStop(),t.executeCommands(this.id,i),t.pushUndoStop()},t}(s.EditorAction),y=function(e){function t(){return e.call(this,!1,{id:"editor.action.copyLinesUpAction",label:i.localize(0,null),alias:"Copy Line Up",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:1552,linux:{primary:3600},weight:100},menubarOpts:{menuId:22,group:"2_line",title:i.localize(1,null),order:1}})||this}return r(t,e),t}(_),b=function(e){function t(){return e.call(this,!0,{id:"editor.action.copyLinesDownAction",label:i.localize(2,null),alias:"Copy Line Down",
precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:1554,linux:{primary:3602},weight:100},menubarOpts:{menuId:22,group:"2_line",title:i.localize(3,null),order:2}})||this}return r(t,e),t}(_),C=function(e){function t(t,i){var n=e.call(this,i)||this;return n.down=t,n}return r(t,e),t.prototype.run=function(e,t){for(var i=[],n=t.getSelections()||[],o=t.getConfiguration().autoIndent,r=0,s=n;r<s.length;r++){var a=s[r];i.push(new m.MoveLinesCommand(a,this.down,o))}t.pushUndoStop(),t.executeCommands(this.id,i),t.pushUndoStop()},t}(s.EditorAction),S=function(e){function t(){return e.call(this,!1,{id:"editor.action.moveLinesUpAction",label:i.localize(4,null),alias:"Move Line Up",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:528,linux:{primary:528},weight:100},menubarOpts:{menuId:22,group:"2_line",title:i.localize(5,null),order:3}})||this}return r(t,e),t}(C),w=function(e){function t(){return e.call(this,!0,{
id:"editor.action.moveLinesDownAction",label:i.localize(6,null),alias:"Move Line Down",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:530,linux:{primary:530},weight:100},menubarOpts:{menuId:22,group:"2_line",title:i.localize(7,null),order:4}})||this}return r(t,e),t}(C),E=function(e){function t(t,i){var n=e.call(this,i)||this;return n.descending=t,n}return r(t,e),t.prototype.run=function(e,t){for(var i=t.getSelections()||[],n=0,o=i;n<o.length;n++){var r=o[n];if(!v.SortLinesCommand.canRun(t.getModel(),r,this.descending))return}for(var s=[],a=0,l=i.length;a<l;a++)s[a]=new v.SortLinesCommand(i[a],this.descending);t.pushUndoStop(),t.executeCommands(this.id,s),t.pushUndoStop()},t}(s.EditorAction);t.AbstractSortLinesAction=E;var L=function(e){function t(){return e.call(this,!1,{id:"editor.action.sortLinesAscending",label:i.localize(8,null),alias:"Sort Lines Ascending",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t}(E)
;t.SortLinesAscendingAction=L;var x=function(e){function t(){return e.call(this,!0,{id:"editor.action.sortLinesDescending",label:i.localize(9,null),alias:"Sort Lines Descending",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t}(E);t.SortLinesDescendingAction=x;var D=function(e){function t(){return e.call(this,{id:t.ID,label:i.localize(10,null),alias:"Trim Trailing Whitespace",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:n.KeyChord(2089,2102),weight:100}})||this}return r(t,e),t.prototype.run=function(e,t,i){var n=[];"auto-save"===i.reason&&(n=(t.getSelections()||[]).map(function(e){return new c.Position(e.positionLineNumber,e.positionColumn)}));var o=t.getSelection();if(null!==o){var r=new l.TrimTrailingWhitespaceCommand(o,n);t.pushUndoStop(),t.executeCommands(this.id,[r]),t.pushUndoStop()}},t.ID="editor.action.trimTrailingWhitespace",t}(s.EditorAction);t.TrimTrailingWhitespaceAction=D;var I=function(e){function t(){return e.call(this,{
id:"editor.action.deleteLines",label:i.localize(11,null),alias:"Delete Line",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.textInputFocus,primary:3113,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){var i=this._getLinesToRemove(t),n=t.getModel();if(1!==n.getLineCount()||1!==n.getLineMaxColumn(1)){for(var o=0,r=[],s=[],a=0,l=i.length;a<l;a++){var u=i[a],c=u.startLineNumber,h=u.endLineNumber,f=1,g=n.getLineMaxColumn(h);h<n.getLineCount()?(h+=1,g=1):c>1&&(c-=1,f=n.getLineMaxColumn(c)),r.push(d.EditOperation.replace(new p.Selection(c,f,h,g),"")),s.push(new p.Selection(c-o,u.positionColumn,c-o,u.positionColumn)),o+=u.endLineNumber-u.startLineNumber+1}t.pushUndoStop(),t.executeEdits(this.id,r,s),t.pushUndoStop()}}},t.prototype._getLinesToRemove=function(e){var t=e.getSelections().map(function(e){var t=e.endLineNumber;return e.startLineNumber<e.endLineNumber&&1===e.endColumn&&(t-=1),{startLineNumber:e.startLineNumber,
selectionStartColumn:e.selectionStartColumn,endLineNumber:t,positionColumn:e.positionColumn}});t.sort(function(e,t){return e.startLineNumber===t.startLineNumber?e.endLineNumber-t.endLineNumber:e.startLineNumber-t.startLineNumber});for(var i=[],n=t[0],o=1;o<t.length;o++)n.endLineNumber+1>=t[o].startLineNumber?n.endLineNumber=t[o].endLineNumber:(i.push(n),n=t[o]);return i.push(n),i},t}(s.EditorAction);t.DeleteLinesAction=I;var N=function(e){function t(){return e.call(this,{id:"editor.action.indentLines",label:i.localize(12,null),alias:"Indent Line",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:2137,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=t._getCursors();i&&(t.pushUndoStop(),t.executeCommands(this.id,u.TypeOperations.indent(i.context.config,t.getModel(),t.getSelections())),t.pushUndoStop())},t}(s.EditorAction);t.IndentLinesAction=N;var M=function(e){function t(){return e.call(this,{id:"editor.action.outdentLines",
label:i.localize(13,null),alias:"Outdent Line",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:2135,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){o.CoreEditingCommands.Outdent.runEditorCommand(e,t,null)},t}(s.EditorAction),k=function(e){function t(){return e.call(this,{id:"editor.action.insertLineBefore",label:i.localize(14,null),alias:"Insert Line Above",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:3075,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=t._getCursors();i&&(t.pushUndoStop(),t.executeCommands(this.id,u.TypeOperations.lineInsertBefore(i.context.config,t.getModel(),t.getSelections())))},t}(s.EditorAction);t.InsertLineBeforeAction=k;var T=function(e){function t(){return e.call(this,{id:"editor.action.insertLineAfter",label:i.localize(15,null),alias:"Insert Line Below",precondition:f.EditorContextKeys.writable,kbOpts:{
kbExpr:f.EditorContextKeys.editorTextFocus,primary:2051,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=t._getCursors();i&&(t.pushUndoStop(),t.executeCommands(this.id,u.TypeOperations.lineInsertAfter(i.context.config,t.getModel(),t.getSelections())))},t}(s.EditorAction);t.InsertLineAfterAction=T;var R=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){for(var i=t.getSelection(),n=this._getRangesToDelete(t),o=[],r=0,s=n.length-1;r<s;r++){var a=n[r],l=n[r+1];null===h.Range.intersectRanges(a,l)?o.push(a):n[r+1]=h.Range.plusRange(a,l)}o.push(n[n.length-1]);var u=this._getEndCursorState(i,o),c=o.map(function(e){return d.EditOperation.replace(e,"")});t.pushUndoStop(),t.executeEdits(this.id,c,u),t.pushUndoStop()}},t}(s.EditorAction);t.AbstractDeleteAllToBoundaryAction=R;var O=function(e){function t(){return e.call(this,{id:"deleteAllLeft",label:i.localize(16,null),alias:"Delete All Left",
precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.textInputFocus,primary:0,mac:{primary:2049},weight:100}})||this}return r(t,e),t.prototype._getEndCursorState=function(e,t){var i=null,n=[],o=0;return t.forEach(function(t){var r;if(1===t.endColumn&&o>0){var s=t.startLineNumber-o;r=new p.Selection(s,t.startColumn,s,t.startColumn)}else r=new p.Selection(t.startLineNumber,t.startColumn,t.startLineNumber,t.startColumn);o+=t.endLineNumber-t.startLineNumber,t.intersectRanges(e)?i=r:n.push(r)}),i&&n.unshift(i),n},t.prototype._getRangesToDelete=function(e){var t=e.getSelections();if(null===t)return[];var i=t,n=e.getModel();return null===n?[]:(i.sort(h.Range.compareRangesUsingStarts),i=i.map(function(e){if(e.isEmpty()){if(1===e.startColumn){var t=Math.max(1,e.startLineNumber-1),i=1===e.startLineNumber?1:n.getLineContent(t).length+1;return new h.Range(t,i,e.startLineNumber,1)}return new h.Range(e.startLineNumber,1,e.startLineNumber,e.startColumn)}
return new h.Range(e.startLineNumber,1,e.endLineNumber,e.endColumn)}))},t}(R);t.DeleteAllLeftAction=O;var P=function(e){function t(){return e.call(this,{id:"deleteAllRight",label:i.localize(17,null),alias:"Delete All Right",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.textInputFocus,primary:0,mac:{primary:297,secondary:[2068]},weight:100}})||this}return r(t,e),t.prototype._getEndCursorState=function(e,t){for(var i=null,n=[],o=0,r=t.length;o<r;o++){var s=t[o],a=new p.Selection(s.startLineNumber-0,s.startColumn,s.startLineNumber-0,s.startColumn);s.intersectRanges(e)?i=a:n.push(a)}return i&&n.unshift(i),n},t.prototype._getRangesToDelete=function(e){var t=e.getModel();if(null===t)return[];var i=e.getSelections();if(null===i)return[];var n=i.map(function(e){if(e.isEmpty()){var i=t.getLineMaxColumn(e.startLineNumber);return e.startColumn===i?new h.Range(e.startLineNumber,e.startColumn,e.startLineNumber+1,1):new h.Range(e.startLineNumber,e.startColumn,e.startLineNumber,i)}return e})
;return n.sort(h.Range.compareRangesUsingStarts),n},t}(R);t.DeleteAllRightAction=P;var A=function(e){function t(){return e.call(this,{id:"editor.action.joinLines",label:i.localize(18,null),alias:"Join Lines",precondition:f.EditorContextKeys.writable,kbOpts:{kbExpr:f.EditorContextKeys.editorTextFocus,primary:0,mac:{primary:296},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=t.getSelections();if(null!==i){var n=t.getSelection();if(null!==n){i.sort(h.Range.compareRangesUsingStarts);var o=[],r=i.reduce(function(e,t){return e.isEmpty()?e.endLineNumber===t.startLineNumber?(n.equalsSelection(e)&&(n=t),t):t.startLineNumber>e.endLineNumber+1?(o.push(e),t):new p.Selection(e.startLineNumber,e.startColumn,t.endLineNumber,t.endColumn):t.startLineNumber>e.endLineNumber?(o.push(e),t):new p.Selection(e.startLineNumber,e.startColumn,t.endLineNumber,t.endColumn)});o.push(r);var s=t.getModel();if(null!==s){for(var a=[],l=[],u=n,c=0,f=0,g=o.length;f<g;f++){
var m=o[f],v=m.startLineNumber,_=0,y=void 0,b=void 0,C=s.getLineContent(m.endLineNumber).length-m.endColumn;if(m.isEmpty()||m.startLineNumber===m.endLineNumber){var S=m.getStartPosition();S.lineNumber<s.getLineCount()?(y=v+1,b=s.getLineMaxColumn(y)):(y=S.lineNumber,b=s.getLineMaxColumn(S.lineNumber))}else y=m.endLineNumber,b=s.getLineMaxColumn(y);for(var w=s.getLineContent(v),E=v+1;E<=y;E++){var L=s.getLineContent(E),x=s.getLineFirstNonWhitespaceColumn(E);if(x>=1){var D=!0;""===w&&(D=!1),!D||" "!==w.charAt(w.length-1)&&"\t"!==w.charAt(w.length-1)||(D=!1,w=w.replace(/[\s\uFEFF\xA0]+$/g," "));var I=L.substr(x-1);w+=(D?" ":"")+I,_=D?I.length+1:I.length}else _=0}var N=new h.Range(v,1,y,b);if(!N.isEmpty()){var M=void 0;m.isEmpty()?(a.push(d.EditOperation.replace(N,w)),M=new p.Selection(N.startLineNumber-c,w.length-_+1,v-c,w.length-_+1)):m.startLineNumber===m.endLineNumber?(a.push(d.EditOperation.replace(N,w)),
M=new p.Selection(m.startLineNumber-c,m.startColumn,m.endLineNumber-c,m.endColumn)):(a.push(d.EditOperation.replace(N,w)),M=new p.Selection(m.startLineNumber-c,m.startColumn,m.startLineNumber-c,w.length-C)),null!==h.Range.intersectRanges(N,n)?u=M:l.push(M)}c+=N.endLineNumber-N.startLineNumber}l.unshift(u),t.pushUndoStop(),t.executeEdits(this.id,a,l),t.pushUndoStop()}}}},t}(s.EditorAction);t.JoinLinesAction=A;var F=function(e){function t(){return e.call(this,{id:"editor.action.transpose",label:i.localize(19,null),alias:"Transpose characters around the cursor",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t.prototype.run=function(e,t){var i=t.getSelections();if(null!==i){var n=t.getModel();if(null!==n){for(var o=[],r=0,s=i.length;r<s;r++){var l=i[r];if(l.isEmpty()){var u=l.getStartPosition(),d=n.getLineMaxColumn(u.lineNumber);if(u.column>=d){if(u.lineNumber===n.getLineCount())continue
;var c=new h.Range(u.lineNumber,Math.max(1,u.column-1),u.lineNumber+1,1),f=n.getValueInRange(c).split("").reverse().join("");o.push(new a.ReplaceCommand(new p.Selection(u.lineNumber,Math.max(1,u.column-1),u.lineNumber+1,1),f))}else{var c=new h.Range(u.lineNumber,Math.max(1,u.column-1),u.lineNumber,u.column+1),f=n.getValueInRange(c).split("").reverse().join("");o.push(new a.ReplaceCommandThatPreservesSelection(c,f,new p.Selection(u.lineNumber,u.column+1,u.lineNumber,u.column+1)))}}}t.pushUndoStop(),t.executeCommands(this.id,o),t.pushUndoStop()}}},t}(s.EditorAction);t.TransposeAction=F;var W=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.run=function(e,t){var i=t.getSelections();if(null!==i){var n=t.getModel();if(null!==n){for(var o=t.getConfiguration().wordSeparators,r=[],s=0,l=i.length;s<l;s++){var u=i[s];if(u.isEmpty()){var d=u.getStartPosition(),c=n.getWordAtPosition(d);if(!c)continue
;var f=new h.Range(d.lineNumber,c.startColumn,d.lineNumber,c.endColumn),g=n.getValueInRange(f);r.push(new a.ReplaceCommandThatPreservesSelection(f,this._modifyText(g,o),new p.Selection(d.lineNumber,d.column,d.lineNumber,d.column)))}else{g=n.getValueInRange(u);r.push(new a.ReplaceCommandThatPreservesSelection(u,this._modifyText(g,o),u))}}t.pushUndoStop(),t.executeCommands(this.id,r),t.pushUndoStop()}}},t}(s.EditorAction);t.AbstractCaseAction=W;var V=function(e){function t(){return e.call(this,{id:"editor.action.transformToUppercase",label:i.localize(20,null),alias:"Transform to Uppercase",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t.prototype._modifyText=function(e,t){return e.toLocaleUpperCase()},t}(W);t.UpperCaseAction=V;var B=function(e){function t(){return e.call(this,{id:"editor.action.transformToLowercase",label:i.localize(21,null),alias:"Transform to Lowercase",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t.prototype._modifyText=function(e,t){
return e.toLocaleLowerCase()},t}(W);t.LowerCaseAction=B;var H=function(e){function t(){return e.call(this,{id:"editor.action.transformToTitlecase",label:i.localize(22,null),alias:"Transform to Title Case",precondition:f.EditorContextKeys.writable})||this}return r(t,e),t.prototype._modifyText=function(e,t){for(var i=("\r\n\t "+t).split(""),n="",o=!0,r=0;r<e.length;r++){var s=e[r];i.indexOf(s)>=0?(o=!0,n+=s):o?(o=!1,n+=s.toLocaleUpperCase()):n+=s.toLocaleLowerCase()}return n},t}(W);t.TitleCaseAction=H,s.registerEditorAction(y),s.registerEditorAction(b),s.registerEditorAction(S),s.registerEditorAction(w),s.registerEditorAction(L),s.registerEditorAction(x),s.registerEditorAction(D),s.registerEditorAction(I),s.registerEditorAction(N),s.registerEditorAction(M),s.registerEditorAction(k),s.registerEditorAction(T),s.registerEditorAction(O),s.registerEditorAction(P),s.registerEditorAction(A),s.registerEditorAction(F),s.registerEditorAction(V),s.registerEditorAction(B),s.registerEditorAction(H)}),
define(t[151],i([1,0,15,10,11,17,14,26]),function(e,t,i,n,o,r,s,u){"use strict";function d(e,t,o,s){var a=r.SignatureHelpProviderRegistry.ordered(e);return i.first(a.map(function(i){return function(){return Promise.resolve(i.provideSignatureHelp(e,t,s,o)).catch(function(e){return n.onUnexpectedExternalError(e)})}}))}var c=this;Object.defineProperty(t,"__esModule",{value:!0}),t.Context={Visible:new s.RawContextKey("parameterHintsVisible",!1),MultipleSignatures:new s.RawContextKey("parameterHintsMultipleSignatures",!1)},t.provideSignatureHelp=d,o.registerDefaultLanguageCommand("_executeSignatureHelpProvider",function(e,t,i){return a(c,void 0,void 0,function(){var n;return l(this,function(o){switch(o.label){case 0:return[4,d(e,t,{triggerKind:r.SignatureHelpTriggerKind.Invoke,isRetrigger:!1,triggerCharacter:i.triggerCharacter},u.CancellationToken.None)];case 1:return(n=o.sent())?(setTimeout(function(){return n.dispose()},0),[2,n.value]):[2,void 0]}})})})}),
define(t[501],i([1,0,15,10,4,2,80,17,151]),function(e,t,i,n,o,a,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c;!function(e){e.Default=new(function(){return function(){this.type=0}}());var t=function(){return function(e){this.request=e,this.type=2}}();e.Pending=t;var i=function(){return function(e){this.hints=e,this.type=1}}();e.Active=i}(c||(c={}));var h=function(e){function t(n,r){void 0===r&&(r=t.DEFAULT_DELAY);var s=e.call(this)||this;return s._onChangedHints=s._register(new o.Emitter),s.onChangedHints=s._onChangedHints.event,s.triggerOnType=!1,s._state=c.Default,s._lastSignatureHelpResult=s._register(new a.MutableDisposable),s.triggerChars=new l.CharacterSet,s.retriggerChars=new l.CharacterSet,s.triggerId=0,s.editor=n,s.throttledDelayer=new i.Delayer(r),s._register(s.editor.onDidChangeConfiguration(function(){return s.onEditorConfigurationChange()})),s._register(s.editor.onDidChangeModel(function(e){return s.onModelChanged()})),
s._register(s.editor.onDidChangeModelLanguage(function(e){return s.onModelChanged()})),s._register(s.editor.onDidChangeCursorSelection(function(e){return s.onCursorChange(e)})),s._register(s.editor.onDidChangeModelContent(function(e){return s.onModelContentChange()})),s._register(u.SignatureHelpProviderRegistry.onDidChange(s.onModelChanged,s)),s._register(s.editor.onDidType(function(e){return s.onDidType(e)})),s.onEditorConfigurationChange(),s.onModelChanged(),s}return r(t,e),Object.defineProperty(t.prototype,"state",{get:function(){return this._state},set:function(e){2===this._state.type&&this._state.request.cancel(),this._state=e},enumerable:!0,configurable:!0}),t.prototype.cancel=function(e){void 0===e&&(e=!1),this.state=c.Default,this.throttledDelayer.cancel(),e||this._onChangedHints.fire(void 0)},t.prototype.trigger=function(e,t){var i=this,o=this.editor.getModel();if(o&&u.SignatureHelpProviderRegistry.has(o)){var r=++this.triggerId;this.throttledDelayer.trigger(function(){return i.doTrigger({
triggerKind:e.triggerKind,triggerCharacter:e.triggerCharacter,isRetrigger:1===i.state.type||2===i.state.type,activeSignatureHelp:1===i.state.type?i.state.hints:void 0},r)},t).then(void 0,n.onUnexpectedError)}},t.prototype.next=function(){if(1===this.state.type){var e=this.state.hints.signatures.length,t=this.state.hints.activeSignature,i=t%e==e-1,n=this.editor.getConfiguration().contribInfo.parameterHints.cycle;!(e<2||i)||n?this.updateActiveSignature(i&&n?0:t+1):this.cancel()}},t.prototype.previous=function(){if(1===this.state.type){var e=this.state.hints.signatures.length,t=this.state.hints.activeSignature,i=0===t,n=this.editor.getConfiguration().contribInfo.parameterHints.cycle;!(e<2||i)||n?this.updateActiveSignature(i&&n?e-1:t-1):this.cancel()}},t.prototype.updateActiveSignature=function(e){1===this.state.type&&(this.state=new c.Active(s({},this.state.hints,{activeSignature:e})),this._onChangedHints.fire(this.state.hints))},t.prototype.doTrigger=function(e,t){var o=this;if(this.cancel(!0),
!this.editor.hasModel())return Promise.resolve(!1);var r=this.editor.getModel(),s=this.editor.getPosition();return this.state=new c.Pending(i.createCancelablePromise(function(t){return d.provideSignatureHelp(r,s,e,t)})),this.state.request.then(function(e){return t!==o.triggerId?(e&&e.dispose(),!1):e&&e.value.signatures&&0!==e.value.signatures.length?(o.state=new c.Active(e.value),o._lastSignatureHelpResult.value=e,o._onChangedHints.fire(o.state.hints),!0):(e&&e.dispose(),o._lastSignatureHelpResult.clear(),o.cancel(),!1)}).catch(function(e){return t===o.triggerId&&(o.state=c.Default),n.onUnexpectedError(e),!1})},Object.defineProperty(t.prototype,"isTriggered",{get:function(){return 1===this.state.type||2===this.state.type||this.throttledDelayer.isTriggered()},enumerable:!0,configurable:!0}),t.prototype.onModelChanged=function(){this.cancel(),this.triggerChars=new l.CharacterSet,this.retriggerChars=new l.CharacterSet;var e=this.editor.getModel()
;if(e)for(var t=0,i=u.SignatureHelpProviderRegistry.ordered(e);t<i.length;t++){for(var n=i[t],o=0,r=n.signatureHelpTriggerCharacters||[];o<r.length;o++){d=r[o];this.triggerChars.add(d.charCodeAt(0)),this.retriggerChars.add(d.charCodeAt(0))}for(var s=0,a=n.signatureHelpRetriggerCharacters||[];s<a.length;s++){var d=a[s];this.retriggerChars.add(d.charCodeAt(0))}}},t.prototype.onDidType=function(e){if(this.triggerOnType){var t=e.length-1,i=e.charCodeAt(t);(this.triggerChars.has(i)||this.isTriggered&&this.retriggerChars.has(i))&&this.trigger({triggerKind:u.SignatureHelpTriggerKind.TriggerCharacter,triggerCharacter:e.charAt(t)})}},t.prototype.onCursorChange=function(e){"mouse"===e.source?this.cancel():this.isTriggered&&this.trigger({triggerKind:u.SignatureHelpTriggerKind.ContentChange})},t.prototype.onModelContentChange=function(){this.isTriggered&&this.trigger({triggerKind:u.SignatureHelpTriggerKind.ContentChange})},t.prototype.onEditorConfigurationChange=function(){
this.triggerOnType=this.editor.getConfiguration().contribInfo.parameterHints.enabled,this.triggerOnType||this.cancel()},t.prototype.dispose=function(){this.cancel(!0),e.prototype.dispose.call(this)},t.DEFAULT_DELAY=120,t}(a.Disposable);t.ParameterHintsModel=h}),define(t[502],i([1,0,10,24,3,11,42,26,76,409,95]),function(e,t,i,n,o,r,s,u,d,c,h){"use strict";function p(e,t,i){return a(this,void 0,void 0,function(){var n,o,r,s,a,u;return l(this,function(l){switch(l.label){case 0:return[4,c.OutlineModel.create(e,i)];case 1:for(n=l.sent(),o=[],r=0,s=h.values(n.children);r<s.length;r++)(a=s[r])instanceof c.OutlineElement?o.push(a.symbol):o.push.apply(o,h.values(a.children).map(function(e){return e.symbol}));return u=[],i.isCancellationRequested?[2,u]:(t?g(u,o,""):u=o,[2,u.sort(f)])}})})}function f(e,t){return o.Range.compareRangesUsingStarts(e.range,t.range)}function g(e,t,i){for(var n=0,o=t;n<o.length;n++){var r=o[n];e.push({kind:r.kind,tags:r.tags,name:r.name,detail:r.detail,containerName:r.containerName||i,
range:r.range,selectionRange:r.selectionRange,children:void 0}),r.children&&g(e,r.children,r.name)}}Object.defineProperty(t,"__esModule",{value:!0}),t.getDocumentSymbols=p,r.registerLanguageCommand("_executeDocumentSymbolProvider",function(e,t){var o=t.resource;if(!(o instanceof n.URI))throw i.illegalArgument("resource");var r=e.get(s.IModelService).getModel(o);return r?p(r,!1,u.CancellationToken.None):e.get(d.ITextModelService).createModelReference(o).then(function(e){return new Promise(function(t,i){try{t(p(e.object.textEditorModel,!1,u.CancellationToken.None))}catch(e){i(e)}}).finally(function(){e.dispose()})})})}),define(t[503],i([1,0,19,26,11,13,3,20,21,17,359,2,267,180,32,10]),function(e,t,i,n,o,s,u,d,c,h,p,f,g,m,v,_){"use strict";function y(e,t,n){var o=h.SelectionRangeRegistry.all(e);1===o.length&&o.unshift(new m.BracketSelectionRangeProvider);for(var r=[],a=[],l=0,d=o;l<d.length;l++){var c=d[l];r.push(Promise.resolve(c.provideSelectionRanges(e,t,n)).then(function(e){
if(i.isNonEmptyArray(e)&&e.length===t.length)for(var n=0;n<t.length;n++){a[n]||(a[n]=[]);for(var o=0,r=e[n];o<r.length;o++){var s=r[o];u.Range.isIRange(s.range)&&u.Range.containsPosition(s.range,t[n])&&a[n].push(u.Range.lift(s.range))}}},_.onUnexpectedExternalError))}return Promise.all(r).then(function(){return a.map(function(t){if(0===t.length)return[];t.sort(function(e,t){return s.Position.isBefore(e.getStartPosition(),t.getStartPosition())?1:s.Position.isBefore(t.getStartPosition(),e.getStartPosition())?-1:s.Position.isBefore(e.getEndPosition(),t.getEndPosition())?-1:s.Position.isBefore(t.getEndPosition(),e.getEndPosition())?1:0});for(var i,n=[],o=0,r=t;o<r.length;o++){var a=r[o];(!i||u.Range.containsRange(a,i)&&!u.Range.equalsRange(a,i))&&(n.push(a),i=a)}for(var l=[n[0]],d=1;d<n.length;d++){var c=n[d-1],h=n[d];if(h.startLineNumber!==c.startLineNumber||h.endLineNumber!==c.endLineNumber){
var p=new u.Range(c.startLineNumber,e.getLineFirstNonWhitespaceColumn(c.startLineNumber),c.endLineNumber,e.getLineLastNonWhitespaceColumn(c.endLineNumber));p.containsRange(c)&&!p.equalsRange(c)&&h.containsRange(p)&&!h.equalsRange(p)&&l.push(p);var f=new u.Range(c.startLineNumber,1,c.endLineNumber,e.getLineMaxColumn(c.endLineNumber));f.containsRange(c)&&!f.equalsRange(p)&&h.containsRange(f)&&!h.equalsRange(f)&&l.push(f)}l.push(h)}return l})})}Object.defineProperty(t,"__esModule",{value:!0});var b=function(){function e(e,t){this.index=e,this.ranges=t}return e.prototype.mov=function(t){var i=this.index+(t?1:-1);if(i<0||i>=this.ranges.length)return this;var n=new e(i,this.ranges);return n.ranges[i].equalsRange(this.ranges[this.index])?n.mov(t):n},e}(),C=function(){function e(e){this._ignoreSelection=!1,this._editor=e}return e.get=function(t){return t.getContribution(e._id)},e.prototype.dispose=function(){f.dispose(this._selectionListener)},e.prototype.getId=function(){return e._id},e.prototype.run=function(e){
var t=this;if(this._editor.hasModel()){var o=this._editor.getSelections(),r=this._editor.getModel();if(h.SelectionRangeRegistry.has(r)){var s=Promise.resolve(void 0);return this._state||(s=y(r,o.map(function(e){return e.getPosition()}),n.CancellationToken.None).then(function(e){if(i.isNonEmptyArray(e)&&e.length===o.length&&t._editor.hasModel()&&i.equals(t._editor.getSelections(),o,function(e,t){return e.equalsSelection(t)})){for(var n=function(t){e[t]=e[t].filter(function(e){return e.containsPosition(o[t].getStartPosition())&&e.containsPosition(o[t].getEndPosition())}),e[t].unshift(o[t])},r=0;r<e.length;r++)n(r);t._state=e.map(function(e){return new b(0,e)}),f.dispose(t._selectionListener),t._selectionListener=t._editor.onDidChangeCursorPosition(function(){t._ignoreSelection||(f.dispose(t._selectionListener),t._state=void 0)})}})),s.then(function(){if(t._state){t._state=t._state.map(function(t){return t.mov(e)});var i=t._state.map(function(e){
return d.Selection.fromPositions(e.ranges[e.index].getStartPosition(),e.ranges[e.index].getEndPosition())});t._ignoreSelection=!0;try{t._editor.setSelections(i)}finally{t._ignoreSelection=!1}}})}}},e._id="editor.contrib.smartSelectController",e}(),S=function(e){function t(t,i){var n=e.call(this,i)||this;return n._forward=t,n}return r(t,e),t.prototype.run=function(e,t){return a(this,void 0,void 0,function(){var e;return l(this,function(i){switch(i.label){case 0:return(e=C.get(t))?[4,e.run(this._forward)]:[3,2];case 1:i.sent(),i.label=2;case 2:return[2]}})})},t}(o.EditorAction),w=function(e){function t(){return e.call(this,!0,{id:"editor.action.smartSelect.expand",label:p.localize(0,null),alias:"Expand Selection",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:1553,mac:{primary:3345},weight:100},menubarOpts:{menuId:22,group:"1_basic",title:p.localize(1,null),order:2}})||this}return r(t,e),t}(S)
;v.CommandsRegistry.registerCommandAlias("editor.action.smartSelect.grow","editor.action.smartSelect.expand");var E=function(e){function t(){return e.call(this,!1,{id:"editor.action.smartSelect.shrink",label:p.localize(2,null),alias:"Shrink Selection",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:1551,mac:{primary:3343},weight:100},menubarOpts:{menuId:22,group:"1_basic",title:p.localize(3,null),order:3}})||this}return r(t,e),t}(S);o.registerEditorContribution(C),o.registerEditorAction(w),o.registerEditorAction(E),h.SelectionRangeRegistry.register("*",new g.WordSelectionRangeProvider),t.provideSelectionRanges=y,o.registerDefaultLanguageCommand("_executeSelectionRangeProvider",function(e,t,i){return y(e,i.positions,n.CancellationToken.None)})}),define(t[93],i([1,0,15,29,10,11,17,14,26,3,64,2]),function(e,t,i,n,o,r,s,u,d,c,h,p){"use strict";function f(e,t,n,r,a){void 0===n&&(n=y.default),void 0===r&&(r={triggerKind:0}),void 0===a&&(a=d.CancellationToken.None)
;var l=e.getWordUntilPosition(t),u=new c.Range(t.lineNumber,l.startColumn,t.lineNumber,l.endColumn);t=t.clone();var h=s.CompletionProviderRegistry.orderedGroups(e);!n.kindFilter.has(25)&&b&&h.unshift([b]);var f=[],g=new p.DisposableStore,v=!1,C=h.map(function(i){return function(){return Promise.all(i.map(function(i){if(!(n.providerFilter.size>0)||n.providerFilter.has(i))return Promise.resolve(i.provideCompletionItems(e,t,r,a)).then(function(o){var r=f.length;if(o){for(var s=0,a=o.suggestions||[];s<a.length;s++){var l=a[s];n.kindFilter.has(l.kind)||(l.range||(l.range=u),f.push(new _(t,l,o,i,e)))}p.isDisposable(o)&&g.add(o)}r!==f.length&&i!==b&&(v=!0)},o.onUnexpectedExternalError)}))}});return i.first(C,function(){return v||a.isCancellationRequested}).then(function(){return a.isCancellationRequested?(g.dispose(),Promise.reject(o.canceled())):f.sort(m(n.snippetSortOrder))})}function g(e,t){if(e.sortTextLow&&t.sortTextLow){if(e.sortTextLow<t.sortTextLow)return-1;if(e.sortTextLow>t.sortTextLow)return 1}
return e.completion.label<t.completion.label?-1:e.completion.label>t.completion.label?1:e.completion.kind-t.completion.kind}function m(e){return C.get(e)}var v=this;Object.defineProperty(t,"__esModule",{value:!0}),t.Context={Visible:new u.RawContextKey("suggestWidgetVisible",!1),MultipleSuggestions:new u.RawContextKey("suggestWidgetMultipleSuggestions",!1),MakesTextEdit:new u.RawContextKey("suggestionMakesTextEdit",!0),AcceptSuggestionsOnEnter:new u.RawContextKey("acceptSuggestionOnEnter",!0)};var _=function(){return function(e,t,i,r,s){this.position=e,this.completion=t,this.container=i,this.provider=r,this.score=h.FuzzyScore.Default,this.distance=0,this.labelLow=t.label.toLowerCase(),this.sortTextLow=t.sortText&&t.sortText.toLowerCase(),this.filterTextLow=t.filterText&&t.filterText.toLowerCase();var a=r.resolveCompletionItem;if("function"!=typeof a)this.resolve=function(){return Promise.resolve()};else{var l;this.resolve=function(i){if(!l){var u=!1;l=Promise.resolve(a.call(r,s,e,t,i)).then(function(e){
n.assign(t,e),u=!0},function(e){o.isPromiseCanceledError(e)&&(l=void 0)}),i.onCancellationRequested(function(){u||(l=void 0)})}return l}}}}();t.CompletionItem=_;var y=function(){function e(e,t,i){void 0===e&&(e=2),void 0===t&&(t=new Set),void 0===i&&(i=new Set),this.snippetSortOrder=e,this.kindFilter=t,this.providerFilter=i}return e.default=new e,e}();t.CompletionOptions=y;var b;t.getSnippetSuggestSupport=function(){return b},t.provideSuggestionItems=f;var C=new Map;C.set(0,function(e,t){if(e.completion.kind!==t.completion.kind){if(25===e.completion.kind)return-1;if(25===t.completion.kind)return 1}return g(e,t)}),C.set(2,function(e,t){if(e.completion.kind!==t.completion.kind){if(25===e.completion.kind)return 1;if(25===t.completion.kind)return-1}return g(e,t)}),C.set(1,g),t.getSuggestionComparator=m,r.registerDefaultLanguageCommand("_executeCompletionItemProvider",function(e,t,i){return a(v,void 0,void 0,function(){var n,o,r,s,a,u,c,h;return l(this,function(l){switch(l.label){case 0:return n={incomplete:!1,
suggestions:[]},o=new p.DisposableStore,r=[],s=i.maxItemsToResolve||0,[4,f(e,t)];case 1:for(a=l.sent(),u=0,c=a;u<c.length;u++)h=c[u],r.length<s&&r.push(h.resolve(d.CancellationToken.None)),n.incomplete=n.incomplete||h.container.incomplete,n.suggestions.push(h.completion),p.isDisposable(h.container)&&o.add(h.container);l.label=2;case 2:return l.trys.push([2,,4,5]),[4,Promise.all(r)];case 3:return l.sent(),[2,n];case 4:return setTimeout(function(){return o.dispose()},100),[7];case 5:return[2]}})})});var S=new(function(){function e(){this.onlyOnceSuggestions=[]}return e.prototype.provideCompletionItems=function(){var e={suggestions:this.onlyOnceSuggestions.slice(0)};return this.onlyOnceSuggestions.length=0,e},e}());s.CompletionProviderRegistry.register("*",S),t.showSimpleSuggestions=function(e,t){setTimeout(function(){var i;(i=S.onlyOnceSuggestions).push.apply(i,t),e.getContribution("editor.contrib.suggestController").triggerSuggest((new Set).add(S))},0)}}),
define(t[212],i([1,0,363,43,11,150]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(){return e.call(this,{id:t.ID,label:i.localize(0,null),alias:"Toggle Tab Key Moves Focus",precondition:void 0,kbOpts:{kbExpr:null,primary:2091,mac:{primary:1323},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var o=!s.TabFocus.getTabFocusMode();s.TabFocus.setTabFocusMode(o),o?n.alert(i.localize(1,null)):n.alert(i.localize(2,null))},t.ID="editor.action.toggleTabFocusMode",t}(o.EditorAction);t.ToggleTabFocusModeAction=a,o.registerEditorAction(a)}),define(t[506],i([1,0,364,11,127]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(){return e.call(this,{id:"editor.action.forceRetokenize",label:i.localize(0,null),alias:"Developer: Force Retokenize",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){var i=t.getModel();i.resetTokenization()
;var n=new o.StopWatch(!0);i.forceTokenization(i.getLineCount()),n.stop(),console.log("tokenization took "+n.elapsed())}},t}(n.EditorAction);n.registerEditorAction(s)}),define(t[213],i([1,0,11,81,36,145,86,13,3,20,21,66,14,47]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(e){function t(t){var i=e.call(this,t)||this;return i._inSelectionMode=t.inSelectionMode,i._wordNavigationType=t.wordNavigationType,i}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var n=this;if(t.hasModel()){var r=t.getConfiguration(),s=a.getMapForWordSeparators(r.wordSeparators),u=t.getModel(),d=t.getSelections().map(function(e){var t=new l.Position(e.positionLineNumber,e.positionColumn),i=n._move(s,u,t,n._wordNavigationType);return n._moveTo(e,i,n._inSelectionMode)});if(t._getCursors().setStates("moveWordCommand",0,d.map(function(e){return o.CursorState.fromModelSelection(e)})),1===d.length){var c=new l.Position(d[0].positionLineNumber,d[0].positionColumn)
;t.revealPosition(c,0)}}},t.prototype._moveTo=function(e,t,i){return i?new d.Selection(e.selectionStartLineNumber,e.selectionStartColumn,t.lineNumber,t.column):new d.Selection(t.lineNumber,t.column,t.lineNumber,t.column)},t}(i.EditorCommand);t.MoveWordCommand=g;var m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._move=function(e,t,i,n){return s.WordOperations.moveWordLeft(e,t,i,n)},t}(g);t.WordLeftCommand=m;var v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._move=function(e,t,i,n){return s.WordOperations.moveWordRight(e,t,i,n)},t}(g);t.WordRightCommand=v;var _=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:0,id:"cursorWordStartLeft",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:2063,mac:{primary:527},weight:100}})||this}return r(t,e),t}(m);t.CursorWordStartLeft=_;var y=function(e){function t(){return e.call(this,{inSelectionMode:!1,
wordNavigationType:2,id:"cursorWordEndLeft",precondition:void 0})||this}return r(t,e),t}(m);t.CursorWordEndLeft=y;var b=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:1,id:"cursorWordLeft",precondition:void 0})||this}return r(t,e),t}(m);t.CursorWordLeft=b;var C=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordStartLeftSelect",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:3087,mac:{primary:1551},weight:100}})||this}return r(t,e),t}(m);t.CursorWordStartLeftSelect=C;var S=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordEndLeftSelect",precondition:void 0})||this}return r(t,e),t}(m);t.CursorWordEndLeftSelect=S;var w=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:1,id:"cursorWordLeftSelect",precondition:void 0})||this}return r(t,e),t}(m);t.CursorWordLeftSelect=w;var E=function(e){function t(){return e.call(this,{
inSelectionMode:!1,wordNavigationType:3,id:"cursorWordAccessibilityLeft",precondition:void 0,kbOpts:{kbExpr:p.ContextKeyExpr.and(c.EditorContextKeys.textInputFocus,h.CONTEXT_ACCESSIBILITY_MODE_ENABLED),primary:2063,mac:{primary:527},weight:101}})||this}return r(t,e),t.prototype._move=function(t,i,n,o){return e.prototype._move.call(this,a.getMapForWordSeparators(f.EDITOR_DEFAULTS.wordSeparators),i,n,o)},t}(m);t.CursorWordAccessibilityLeft=E;var L=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:3,id:"cursorWordAccessibilityLeftSelect",precondition:void 0,kbOpts:{kbExpr:p.ContextKeyExpr.and(c.EditorContextKeys.textInputFocus,h.CONTEXT_ACCESSIBILITY_MODE_ENABLED),primary:3087,mac:{primary:1551},weight:101}})||this}return r(t,e),t.prototype._move=function(t,i,n,o){return e.prototype._move.call(this,a.getMapForWordSeparators(f.EDITOR_DEFAULTS.wordSeparators),i,n,o)},t}(m);t.CursorWordAccessibilityLeftSelect=L;var x=function(e){function t(){return e.call(this,{inSelectionMode:!1,
wordNavigationType:0,id:"cursorWordStartRight",precondition:void 0})||this}return r(t,e),t}(v);t.CursorWordStartRight=x;var D=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordEndRight",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:2065,mac:{primary:529},weight:100}})||this}return r(t,e),t}(v);t.CursorWordEndRight=D;var I=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordRight",precondition:void 0})||this}return r(t,e),t}(v);t.CursorWordRight=I;var N=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordStartRightSelect",precondition:void 0})||this}return r(t,e),t}(v);t.CursorWordStartRightSelect=N;var M=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordEndRightSelect",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:3089,mac:{primary:1553},weight:100}})||this}
return r(t,e),t}(v);t.CursorWordEndRightSelect=M;var k=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordRightSelect",precondition:void 0})||this}return r(t,e),t}(v);t.CursorWordRightSelect=k;var T=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:3,id:"cursorWordAccessibilityRight",precondition:void 0,kbOpts:{kbExpr:p.ContextKeyExpr.and(c.EditorContextKeys.textInputFocus,h.CONTEXT_ACCESSIBILITY_MODE_ENABLED),primary:2065,mac:{primary:529},weight:101}})||this}return r(t,e),t.prototype._move=function(t,i,n,o){return e.prototype._move.call(this,a.getMapForWordSeparators(f.EDITOR_DEFAULTS.wordSeparators),i,n,o)},t}(v);t.CursorWordAccessibilityRight=T;var R=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:3,id:"cursorWordAccessibilityRightSelect",precondition:void 0,kbOpts:{kbExpr:p.ContextKeyExpr.and(c.EditorContextKeys.textInputFocus,h.CONTEXT_ACCESSIBILITY_MODE_ENABLED),primary:3089,mac:{
primary:1553},weight:101}})||this}return r(t,e),t.prototype._move=function(t,i,n,o){return e.prototype._move.call(this,a.getMapForWordSeparators(f.EDITOR_DEFAULTS.wordSeparators),i,n,o)},t}(v);t.CursorWordAccessibilityRightSelect=R;var O=function(e){function t(t){var i=e.call(this,t)||this;return i._whitespaceHeuristics=t.whitespaceHeuristics,i._wordNavigationType=t.wordNavigationType,i}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var o=this;if(t.hasModel()){var r=t.getConfiguration(),s=a.getMapForWordSeparators(r.wordSeparators),l=t.getModel(),u=t.getSelections().map(function(e){var t=o._delete(s,l,e,o._whitespaceHeuristics,o._wordNavigationType);return new n.ReplaceCommand(t,"")});t.pushUndoStop(),t.executeCommands(this.id,u),t.pushUndoStop()}},t}(i.EditorCommand);t.DeleteWordCommand=O;var P=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._delete=function(e,t,i,n,o){var r=s.WordOperations.deleteWordLeft(e,t,i,n,o);return r||new u.Range(1,1,1,1)
},t}(O);t.DeleteWordLeftCommand=P;var A=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._delete=function(e,t,i,n,o){var r=s.WordOperations.deleteWordRight(e,t,i,n,o);if(r)return r;var a=t.getLineCount(),l=t.getLineMaxColumn(a);return new u.Range(a,l,a,l)},t}(O);t.DeleteWordRightCommand=A;var F=function(e){function t(){return e.call(this,{whitespaceHeuristics:!1,wordNavigationType:0,id:"deleteWordStartLeft",precondition:c.EditorContextKeys.writable})||this}return r(t,e),t}(P);t.DeleteWordStartLeft=F;var W=function(e){function t(){return e.call(this,{whitespaceHeuristics:!1,wordNavigationType:2,id:"deleteWordEndLeft",precondition:c.EditorContextKeys.writable})||this}return r(t,e),t}(P);t.DeleteWordEndLeft=W;var V=function(e){function t(){return e.call(this,{whitespaceHeuristics:!0,wordNavigationType:0,id:"deleteWordLeft",precondition:c.EditorContextKeys.writable,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:2049,mac:{primary:513},weight:100}})||this}
return r(t,e),t}(P);t.DeleteWordLeft=V;var B=function(e){function t(){return e.call(this,{whitespaceHeuristics:!1,wordNavigationType:0,id:"deleteWordStartRight",precondition:c.EditorContextKeys.writable})||this}return r(t,e),t}(A);t.DeleteWordStartRight=B;var H=function(e){function t(){return e.call(this,{whitespaceHeuristics:!1,wordNavigationType:2,id:"deleteWordEndRight",precondition:c.EditorContextKeys.writable})||this}return r(t,e),t}(A);t.DeleteWordEndRight=H;var z=function(e){function t(){return e.call(this,{whitespaceHeuristics:!0,wordNavigationType:2,id:"deleteWordRight",precondition:c.EditorContextKeys.writable,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:2068,mac:{primary:532},weight:100}})||this}return r(t,e),t}(A);t.DeleteWordRight=z,i.registerEditorCommand(new _),i.registerEditorCommand(new y),i.registerEditorCommand(new b),i.registerEditorCommand(new C),i.registerEditorCommand(new S),i.registerEditorCommand(new w),i.registerEditorCommand(new x),i.registerEditorCommand(new D),
i.registerEditorCommand(new I),i.registerEditorCommand(new N),i.registerEditorCommand(new M),i.registerEditorCommand(new k),i.registerEditorCommand(new E),i.registerEditorCommand(new L),i.registerEditorCommand(new T),i.registerEditorCommand(new R),i.registerEditorCommand(new F),i.registerEditorCommand(new W),i.registerEditorCommand(new V),i.registerEditorCommand(new B),i.registerEditorCommand(new H),i.registerEditorCommand(new z)}),define(t[508],i([1,0,11,145,3,21,213,32]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(e){function t(){return e.call(this,{whitespaceHeuristics:!0,wordNavigationType:0,id:"deleteWordPartLeft",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:769},weight:100}})||this}return r(t,e),t.prototype._delete=function(e,t,i,r,s){var a=n.WordPartOperations.deleteWordPartLeft(e,t,i,r);return a||new o.Range(1,1,1,1)},t}(a.DeleteWordCommand);t.DeleteWordPartLeft=u
;var d=function(e){function t(){return e.call(this,{whitespaceHeuristics:!0,wordNavigationType:2,id:"deleteWordPartRight",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:788},weight:100}})||this}return r(t,e),t.prototype._delete=function(e,t,i,r,s){var a=n.WordPartOperations.deleteWordPartRight(e,t,i,r);if(a)return a;var l=t.getLineCount(),u=t.getLineMaxColumn(l);return new o.Range(l,u,l,u)},t}(a.DeleteWordCommand);t.DeleteWordPartRight=d;var c=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._move=function(e,t,i,o){return n.WordPartOperations.moveWordPartLeft(e,t,i)},t}(a.MoveWordCommand);t.WordPartLeftCommand=c;var h=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:0,id:"cursorWordPartLeft",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:783},weight:100}})||this}return r(t,e),t}(c);t.CursorWordPartLeft=h,
l.CommandsRegistry.registerCommandAlias("cursorWordPartStartLeft","cursorWordPartLeft");var p=function(e){function t(){return e.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordPartLeftSelect",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1807},weight:100}})||this}return r(t,e),t}(c);t.CursorWordPartLeftSelect=p,l.CommandsRegistry.registerCommandAlias("cursorWordPartStartLeftSelect","cursorWordPartLeftSelect");var f=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._move=function(e,t,i,o){return n.WordPartOperations.moveWordPartRight(e,t,i)},t}(a.MoveWordCommand);t.WordPartRightCommand=f;var g=function(e){function t(){return e.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordPartRight",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:785},weight:100}})||this}return r(t,e),t}(f);t.CursorWordPartRight=g;var m=function(e){function t(){
return e.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordPartRightSelect",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1809},weight:100}})||this}return r(t,e),t}(f);t.CursorWordPartRightSelect=m,i.registerEditorCommand(new u),i.registerEditorCommand(new d),i.registerEditorCommand(new h),i.registerEditorCommand(new p),i.registerEditorCommand(new g),i.registerEditorCommand(new m)}),define(t[509],i([1,0,28,8,2,11,261]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var n=e.call(this)||this;return n.editor=t,n.widget=null,i.isIPad&&(n._register(t.onDidChangeConfiguration(function(){return n.update()})),n.update()),n}return r(t,e),t.prototype.update=function(){var e=!this.editor.getConfiguration().readOnly;!this.widget&&e?this.widget=new l(this.editor):this.widget&&!e&&(this.widget.dispose(),this.widget=null)},t.prototype.getId=function(){return t.ID},t.prototype.dispose=function(){
e.prototype.dispose.call(this),this.widget&&(this.widget.dispose(),this.widget=null)},t.ID="editor.contrib.iPadShowKeyboard",t}(o.Disposable);t.IPadShowKeyboard=a;var l=function(e){function t(t){var i=e.call(this)||this;return i.editor=t,i._domNode=document.createElement("textarea"),i._domNode.className="iPadShowKeyboard",i._register(n.addDisposableListener(i._domNode,"touchstart",function(e){i.editor.focus()})),i._register(n.addDisposableListener(i._domNode,"focus",function(e){i.editor.focus()})),i.editor.addOverlayWidget(i),i}return r(t,e),t.prototype.dispose=function(){this.editor.removeOverlayWidget(this),e.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return{preference:1}},t.ID="editor.contrib.ShowKeyboardWidget",t}(o.Disposable);s.registerEditorContribution(a)}),define(t[510],i([1,0,11,91,56]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var s=function(e){function t(){var t=e.call(this,{id:"editor.action.toggleHighContrast",label:o.ToggleHighContrastNLS.toggleHighContrast,alias:"Toggle High Contrast Theme",precondition:void 0})||this;return t._originalThemeName=null,t}return r(t,e),t.prototype.run=function(e,t){var i=e.get(n.IStandaloneThemeService);this._originalThemeName?(i.setTheme(this._originalThemeName),this._originalThemeName=null):(this._originalThemeName=i.getTheme().themeName,i.setTheme("hc-black"))},t}(i.EditorAction);i.registerEditorAction(s)}),define(t[22],i([1,0,46,25,4,370,202,15]),function(e,t,i,n,o,r,s,a){"use strict";function l(e,t,i,n,o){return f.registerColor(e,t,i,n,o)}function u(e,t){return function(i){var n=p(e,i);if(n)return n.darken(t)}}function d(e,t){return function(i){var n=p(e,i);if(n)return n.lighten(t)}}function c(e,t){return function(i){var n=p(e,i);if(n)return n.transparent(t)}}function h(e,t,i,o){return function(r){var s=p(e,r);if(s){var a=p(t,r)
;return a?s.isDarkerThan(a)?n.Color.getLighterColor(s,a,i).transparent(o):n.Color.getDarkerColor(s,a,i).transparent(o):s.transparent(i*o)}}}function p(e,t){if(null!==e)return"string"==typeof e?"#"===e[0]?n.Color.fromHex(e):t.getColor(e):e instanceof n.Color?e:"function"==typeof e?e(t):void 0}Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions={ColorContribution:"base.contributions.colors"};var f=new(function(){function e(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.colorSchema={type:"object",properties:{}},this.colorReferenceSchema={type:"string",enum:[],enumDescriptions:[]},this.colorsById={}}return e.prototype.registerColor=function(e,t,i,n,o){void 0===n&&(n=!1);var r={id:e,description:i,defaults:t,needsTransparency:n,deprecationMessage:o};this.colorsById[e]=r;var s={type:"string",description:i,format:"color-hex",default:"#ff0000"};return o&&(s.deprecationMessage=o),this.colorSchema.properties[e]=s,this.colorReferenceSchema.enum.push(e),
this.colorReferenceSchema.enumDescriptions.push(i),this._onDidChangeSchema.fire(),e},e.prototype.resolveDefaultColor=function(e,t){var i=this.colorsById[e];if(i&&i.defaults){return p(i.defaults[t.type],t)}},e.prototype.getColorSchema=function(){return this.colorSchema},e.prototype.toString=function(){var e=this;return Object.keys(this.colorsById).sort(function(e,t){var i=-1===e.indexOf(".")?0:1,n=-1===t.indexOf(".")?0:1;return i!==n?i-n:e.localeCompare(t)}).map(function(t){return"- `"+t+"`: "+e.colorsById[t].description}).join("\n")},e}());i.Registry.add(t.Extensions.ColorContribution,f),t.registerColor=l,t.foreground=l("foreground",{dark:"#CCCCCC",light:"#616161",hc:"#FFFFFF"},r.localize(0,null)),t.errorForeground=l("errorForeground",{dark:"#F48771",light:"#A1260D",hc:"#F48771"},r.localize(1,null)),t.focusBorder=l("focusBorder",{dark:n.Color.fromHex("#0E639C").transparent(.8),light:n.Color.fromHex("#007ACC").transparent(.4),hc:"#F38518"},r.localize(2,null)),t.contrastBorder=l("contrastBorder",{light:null,
dark:null,hc:"#6FC3DF"},r.localize(3,null)),t.activeContrastBorder=l("contrastActiveBorder",{light:null,dark:null,hc:t.focusBorder},r.localize(4,null)),t.textLinkForeground=l("textLink.foreground",{light:"#006AB1",dark:"#3794FF",hc:"#3794FF"},r.localize(5,null)),t.textCodeBlockBackground=l("textCodeBlock.background",{light:"#dcdcdc66",dark:"#0a0a0a66",hc:n.Color.black},r.localize(6,null)),t.widgetShadow=l("widget.shadow",{dark:"#000000",light:"#A8A8A8",hc:null},r.localize(7,null)),t.inputBackground=l("input.background",{dark:"#3C3C3C",light:n.Color.white,hc:n.Color.black},r.localize(8,null)),t.inputForeground=l("input.foreground",{dark:t.foreground,light:t.foreground,hc:t.foreground},r.localize(9,null)),t.inputBorder=l("input.border",{dark:null,light:null,hc:t.contrastBorder},r.localize(10,null)),t.inputActiveOptionBorder=l("inputOption.activeBorder",{dark:"#007ACC00",light:"#007ACC00",hc:t.contrastBorder},r.localize(11,null)),t.inputActiveOptionBackground=l("inputOption.activeBackground",{
dark:c(t.focusBorder,.5),light:c(t.focusBorder,.3),hc:null},r.localize(12,null)),t.inputValidationInfoBackground=l("inputValidation.infoBackground",{dark:"#063B49",light:"#D6ECF2",hc:n.Color.black},r.localize(13,null)),t.inputValidationInfoForeground=l("inputValidation.infoForeground",{dark:null,light:null,hc:null},r.localize(14,null)),t.inputValidationInfoBorder=l("inputValidation.infoBorder",{dark:"#007acc",light:"#007acc",hc:t.contrastBorder},r.localize(15,null)),t.inputValidationWarningBackground=l("inputValidation.warningBackground",{dark:"#352A05",light:"#F6F5D2",hc:n.Color.black},r.localize(16,null)),t.inputValidationWarningForeground=l("inputValidation.warningForeground",{dark:null,light:null,hc:null},r.localize(17,null)),t.inputValidationWarningBorder=l("inputValidation.warningBorder",{dark:"#B89500",light:"#B89500",hc:t.contrastBorder},r.localize(18,null)),t.inputValidationErrorBackground=l("inputValidation.errorBackground",{dark:"#5A1D1D",light:"#F2DEDE",hc:n.Color.black},r.localize(19,null)),
t.inputValidationErrorForeground=l("inputValidation.errorForeground",{dark:null,light:null,hc:null},r.localize(20,null)),t.inputValidationErrorBorder=l("inputValidation.errorBorder",{dark:"#BE1100",light:"#BE1100",hc:t.contrastBorder},r.localize(21,null)),t.selectBackground=l("dropdown.background",{dark:"#3C3C3C",light:n.Color.white,hc:n.Color.black},r.localize(22,null)),t.selectForeground=l("dropdown.foreground",{dark:"#F0F0F0",light:null,hc:n.Color.white},r.localize(23,null)),t.listFocusBackground=l("list.focusBackground",{dark:"#062F4A",light:"#D6EBFF",hc:null},r.localize(24,null)),t.listFocusForeground=l("list.focusForeground",{dark:null,light:null,hc:null},r.localize(25,null)),t.listActiveSelectionBackground=l("list.activeSelectionBackground",{dark:"#094771",light:"#0074E8",hc:null},r.localize(26,null)),t.listActiveSelectionForeground=l("list.activeSelectionForeground",{dark:n.Color.white,light:n.Color.white,hc:null},r.localize(27,null)),
t.listInactiveSelectionBackground=l("list.inactiveSelectionBackground",{dark:"#37373D",light:"#E4E6F1",hc:null},r.localize(28,null)),t.listInactiveSelectionForeground=l("list.inactiveSelectionForeground",{dark:null,light:null,hc:null},r.localize(29,null)),t.listInactiveFocusBackground=l("list.inactiveFocusBackground",{dark:null,light:null,hc:null},r.localize(30,null)),t.listHoverBackground=l("list.hoverBackground",{dark:"#2A2D2E",light:"#F0F0F0",hc:null},r.localize(31,null)),t.listHoverForeground=l("list.hoverForeground",{dark:null,light:null,hc:null},r.localize(32,null)),t.listDropBackground=l("list.dropBackground",{dark:t.listFocusBackground,light:t.listFocusBackground,hc:null},r.localize(33,null)),t.listHighlightForeground=l("list.highlightForeground",{dark:"#0097fb",light:"#0066BF",hc:t.focusBorder},r.localize(34,null)),t.listFilterWidgetBackground=l("listFilterWidget.background",{light:"#efc1ad",dark:"#653723",hc:n.Color.black},r.localize(35,null)),t.listFilterWidgetOutline=l("listFilterWidget.outline",{
dark:n.Color.transparent,light:n.Color.transparent,hc:"#f38518"},r.localize(36,null)),t.listFilterWidgetNoMatchesOutline=l("listFilterWidget.noMatchesOutline",{dark:"#BE1100",light:"#BE1100",hc:t.contrastBorder},r.localize(37,null)),t.treeIndentGuidesStroke=l("tree.indentGuidesStroke",{dark:"#585858",light:"#a9a9a9",hc:"#a9a9a9"},r.localize(38,null)),t.pickerGroupForeground=l("pickerGroup.foreground",{dark:"#3794FF",light:"#0066BF",hc:n.Color.white},r.localize(39,null)),t.pickerGroupBorder=l("pickerGroup.border",{dark:"#3F3F46",light:"#CCCEDB",hc:n.Color.white},r.localize(40,null)),t.badgeBackground=l("badge.background",{dark:"#4D4D4D",light:"#C4C4C4",hc:n.Color.black},r.localize(41,null)),t.badgeForeground=l("badge.foreground",{dark:n.Color.white,light:"#333",hc:n.Color.white},r.localize(42,null)),t.scrollbarShadow=l("scrollbar.shadow",{dark:"#000000",light:"#DDDDDD",hc:null},r.localize(43,null)),t.scrollbarSliderBackground=l("scrollbarSlider.background",{dark:n.Color.fromHex("#797979").transparent(.4),
light:n.Color.fromHex("#646464").transparent(.4),hc:c(t.contrastBorder,.6)},r.localize(44,null)),t.scrollbarSliderHoverBackground=l("scrollbarSlider.hoverBackground",{dark:n.Color.fromHex("#646464").transparent(.7),light:n.Color.fromHex("#646464").transparent(.7),hc:c(t.contrastBorder,.8)},r.localize(45,null)),t.scrollbarSliderActiveBackground=l("scrollbarSlider.activeBackground",{dark:n.Color.fromHex("#BFBFBF").transparent(.4),light:n.Color.fromHex("#000000").transparent(.6),hc:t.contrastBorder},r.localize(46,null)),t.progressBarBackground=l("progressBar.background",{dark:n.Color.fromHex("#0E70C0"),light:n.Color.fromHex("#0E70C0"),hc:t.contrastBorder},r.localize(47,null)),t.menuBorder=l("menu.border",{dark:null,light:null,hc:t.contrastBorder},r.localize(48,null)),t.menuForeground=l("menu.foreground",{dark:t.selectForeground,light:t.foreground,hc:t.selectForeground},r.localize(49,null)),t.menuBackground=l("menu.background",{dark:t.selectBackground,light:t.selectBackground,hc:t.selectBackground
},r.localize(50,null)),t.menuSelectionForeground=l("menu.selectionForeground",{dark:t.listActiveSelectionForeground,light:t.listActiveSelectionForeground,hc:t.listActiveSelectionForeground},r.localize(51,null)),t.menuSelectionBackground=l("menu.selectionBackground",{dark:t.listActiveSelectionBackground,light:t.listActiveSelectionBackground,hc:t.listActiveSelectionBackground},r.localize(52,null)),t.menuSelectionBorder=l("menu.selectionBorder",{dark:null,light:null,hc:t.activeContrastBorder},r.localize(53,null)),t.menuSeparatorBackground=l("menu.separatorBackground",{dark:"#BBBBBB",light:"#888888",hc:t.contrastBorder},r.localize(54,null)),t.editorErrorForeground=l("editorError.foreground",{dark:"#F48771",light:"#E51400",hc:null},r.localize(55,null)),t.editorErrorBorder=l("editorError.border",{dark:null,light:null,hc:n.Color.fromHex("#E47777").transparent(.8)},r.localize(56,null)),t.editorWarningForeground=l("editorWarning.foreground",{dark:"#CCA700",light:"#E9A700",hc:null},r.localize(57,null)),
t.editorWarningBorder=l("editorWarning.border",{dark:null,light:null,hc:n.Color.fromHex("#FFCC00").transparent(.8)},r.localize(58,null)),t.editorInfoForeground=l("editorInfo.foreground",{dark:"#75BEFF",light:"#75BEFF",hc:null},r.localize(59,null)),t.editorInfoBorder=l("editorInfo.border",{dark:null,light:null,hc:n.Color.fromHex("#75BEFF").transparent(.8)},r.localize(60,null)),t.editorHintForeground=l("editorHint.foreground",{dark:n.Color.fromHex("#eeeeee").transparent(.7),light:"#6c6c6c",hc:null},r.localize(61,null)),t.editorHintBorder=l("editorHint.border",{dark:null,light:null,hc:n.Color.fromHex("#eeeeee").transparent(.8)},r.localize(62,null)),t.editorBackground=l("editor.background",{light:"#fffffe",dark:"#1E1E1E",hc:n.Color.black},r.localize(63,null)),t.editorForeground=l("editor.foreground",{light:"#333333",dark:"#BBBBBB",hc:n.Color.white},r.localize(64,null)),t.editorWidgetBackground=l("editorWidget.background",{dark:"#252526",light:"#F3F3F3",hc:"#0C141F"},r.localize(65,null)),
t.editorWidgetForeground=l("editorWidget.foreground",{dark:t.foreground,light:t.foreground,hc:t.foreground},r.localize(66,null)),t.editorWidgetBorder=l("editorWidget.border",{dark:"#454545",light:"#C8C8C8",hc:t.contrastBorder},r.localize(67,null)),t.editorWidgetResizeBorder=l("editorWidget.resizeBorder",{light:null,dark:null,hc:null},r.localize(68,null)),t.editorSelectionBackground=l("editor.selectionBackground",{light:"#ADD6FF",dark:"#264F78",hc:"#f3f518"},r.localize(69,null)),t.editorSelectionForeground=l("editor.selectionForeground",{light:null,dark:null,hc:"#000000"},r.localize(70,null)),t.editorInactiveSelection=l("editor.inactiveSelectionBackground",{light:c(t.editorSelectionBackground,.5),dark:c(t.editorSelectionBackground,.5),hc:c(t.editorSelectionBackground,.5)},r.localize(71,null),!0),t.editorSelectionHighlight=l("editor.selectionHighlightBackground",{light:h(t.editorSelectionBackground,t.editorBackground,.3,.6),dark:h(t.editorSelectionBackground,t.editorBackground,.3,.6),hc:null
},r.localize(72,null),!0),t.editorSelectionHighlightBorder=l("editor.selectionHighlightBorder",{light:null,dark:null,hc:t.activeContrastBorder},r.localize(73,null)),t.editorFindMatch=l("editor.findMatchBackground",{light:"#A8AC94",dark:"#515C6A",hc:null},r.localize(74,null)),t.editorFindMatchHighlight=l("editor.findMatchHighlightBackground",{light:"#EA5C0055",dark:"#EA5C0055",hc:null},r.localize(75,null),!0),t.editorFindRangeHighlight=l("editor.findRangeHighlightBackground",{dark:"#3a3d4166",light:"#b4b4b44d",hc:null},r.localize(76,null),!0),t.editorFindMatchBorder=l("editor.findMatchBorder",{light:null,dark:null,hc:t.activeContrastBorder},r.localize(77,null)),t.editorFindMatchHighlightBorder=l("editor.findMatchHighlightBorder",{light:null,dark:null,hc:t.activeContrastBorder},r.localize(78,null)),t.editorFindRangeHighlightBorder=l("editor.findRangeHighlightBorder",{dark:null,light:null,hc:c(t.activeContrastBorder,.4)},r.localize(79,null),!0),t.editorHoverHighlight=l("editor.hoverHighlightBackground",{
light:"#ADD6FF26",dark:"#264f7840",hc:"#ADD6FF26"},r.localize(80,null),!0),t.editorHoverBackground=l("editorHoverWidget.background",{light:t.editorWidgetBackground,dark:t.editorWidgetBackground,hc:t.editorWidgetBackground},r.localize(81,null)),t.editorHoverBorder=l("editorHoverWidget.border",{light:t.editorWidgetBorder,dark:t.editorWidgetBorder,hc:t.editorWidgetBorder},r.localize(82,null)),t.editorHoverStatusBarBackground=l("editorHoverWidget.statusBarBackground",{dark:d(t.editorHoverBackground,.2),light:u(t.editorHoverBackground,.05),hc:t.editorWidgetBackground},r.localize(83,null)),t.editorActiveLinkForeground=l("editorLink.activeForeground",{dark:"#4E94CE",light:n.Color.blue,hc:n.Color.cyan},r.localize(84,null)),t.defaultInsertColor=new n.Color(new n.RGBA(155,185,85,.2)),t.defaultRemoveColor=new n.Color(new n.RGBA(255,0,0,.2)),t.diffInserted=l("diffEditor.insertedTextBackground",{dark:t.defaultInsertColor,light:t.defaultInsertColor,hc:null},r.localize(85,null),!0),
t.diffRemoved=l("diffEditor.removedTextBackground",{dark:t.defaultRemoveColor,light:t.defaultRemoveColor,hc:null},r.localize(86,null),!0),t.diffInsertedOutline=l("diffEditor.insertedTextBorder",{dark:null,light:null,hc:"#33ff2eff"},r.localize(87,null)),t.diffRemovedOutline=l("diffEditor.removedTextBorder",{dark:null,light:null,hc:"#FF008F"},r.localize(88,null)),t.diffBorder=l("diffEditor.border",{dark:null,light:null,hc:t.contrastBorder},r.localize(89,null)),t.snippetTabstopHighlightBackground=l("editor.snippetTabstopHighlightBackground",{dark:new n.Color(new n.RGBA(124,124,124,.3)),light:new n.Color(new n.RGBA(10,50,100,.2)),hc:new n.Color(new n.RGBA(124,124,124,.3))},r.localize(90,null)),t.snippetTabstopHighlightBorder=l("editor.snippetTabstopHighlightBorder",{dark:null,light:null,hc:null},r.localize(91,null)),t.snippetFinalTabstopHighlightBackground=l("editor.snippetFinalTabstopHighlightBackground",{dark:null,light:null,hc:null},r.localize(92,null)),
t.snippetFinalTabstopHighlightBorder=l("editor.snippetFinalTabstopHighlightBorder",{dark:"#525252",light:new n.Color(new n.RGBA(10,50,100,.5)),hc:"#525252"},r.localize(93,null)),t.overviewRulerFindMatchForeground=l("editorOverviewRuler.findMatchForeground",{dark:"#d186167e",light:"#d186167e",hc:"#AB5A00"},r.localize(94,null),!0),t.overviewRulerSelectionHighlightForeground=l("editorOverviewRuler.selectionHighlightForeground",{dark:"#A0A0A0CC",light:"#A0A0A0CC",hc:"#A0A0A0CC"},r.localize(95,null),!0),t.minimapFindMatch=l("minimap.findMatchHighlight",{light:"#d18616",dark:"#d18616",hc:"#AB5A00"},r.localize(96,null),!0),t.darken=u,t.lighten=d,t.transparent=c,t.oneOf=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return function(t){for(var i=0,n=e;i<n.length;i++){var o=p(n[i],t);if(o)return o}}},t.workbenchColorsSchemaId="vscode://schemas/workbench-colors";var g=i.Registry.as(s.Extensions.JSONContribution);g.registerSchema(t.workbenchColorsSchemaId,f.getColorSchema())
;var m=new a.RunOnceScheduler(function(){return g.notifySchemaChanged(t.workbenchColorsSchemaId)},200);f.onDidChangeSchema(function(){m.isScheduled()||m.schedule()})}),define(t[512],i([1,0,2,13,3,358,14,22,373]),function(e,t,i,n,o,r,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_RENAME_INPUT_VISIBLE=new s.RawContextKey("renameInputVisible",!1);var l=function(){function e(e,n,o){var r=this;this.themeService=n,this._disposables=new i.DisposableStore,this.allowEditorOverflow=!0,this._currentAcceptInput=null,this._currentCancelInput=null,this._visibleContextKey=t.CONTEXT_RENAME_INPUT_VISIBLE.bindTo(o),this._editor=e,this._editor.addContentWidget(this),this._disposables.add(e.onDidChangeConfiguration(function(e){e.fontInfo&&r.updateFont()})),this._disposables.add(n.onThemeChange(function(e){return r.onThemeChange(e)}))}return e.prototype.onThemeChange=function(e){this.updateStyles(e)},e.prototype.dispose=function(){this._disposables.dispose(),this._editor.removeContentWidget(this)},
e.prototype.getId=function(){return"__renameInputWidget"},e.prototype.getDomNode=function(){return this._domNode||(this._inputField=document.createElement("input"),this._inputField.className="rename-input",this._inputField.type="text",this._inputField.setAttribute("aria-label",r.localize(0,null)),this._domNode=document.createElement("div"),this._domNode.style.height=this._editor.getConfiguration().lineHeight+"px",this._domNode.className="monaco-editor rename-box",this._domNode.appendChild(this._inputField),this.updateFont(),this.updateStyles(this.themeService.getTheme())),this._domNode},e.prototype.updateStyles=function(e){if(this._inputField){var t=e.getColor(a.inputBackground),i=e.getColor(a.inputForeground),n=e.getColor(a.widgetShadow),o=e.getColor(a.inputBorder);this._inputField.style.backgroundColor=t?t.toString():null,this._inputField.style.color=i?i.toString():null,this._inputField.style.borderWidth=o?"1px":"0px",this._inputField.style.borderStyle=o?"solid":"none",
this._inputField.style.borderColor=o?o.toString():"none",this._domNode.style.boxShadow=n?" 0 2px 8px "+n:null}},e.prototype.updateFont=function(){if(this._inputField){var e=this._editor.getConfiguration().fontInfo;this._inputField.style.fontFamily=e.fontFamily,this._inputField.style.fontWeight=e.fontWeight,this._inputField.style.fontSize=e.fontSize+"px"}},e.prototype.getPosition=function(){return this._visible?{position:this._position,preference:[2,1]}:null},e.prototype.acceptInput=function(){this._currentAcceptInput&&this._currentAcceptInput()},e.prototype.cancelInput=function(e){this._currentCancelInput&&this._currentCancelInput(e)},e.prototype.getInput=function(e,t,r,s){var a=this;this._position=new n.Position(e.startLineNumber,e.startColumn),this._inputField.value=t,this._inputField.setAttribute("selectionStart",r.toString()),this._inputField.setAttribute("selectionEnd",s.toString()),this._inputField.size=Math.max(1.1*(e.endColumn-e.startColumn),20);var l=new i.DisposableStore,u=function(){l.dispose(),
a._hide()};return new Promise(function(i){a._currentCancelInput=function(e){return a._currentAcceptInput=null,a._currentCancelInput=null,i(e),!0},a._currentAcceptInput=function(){0!==a._inputField.value.trim().length&&a._inputField.value!==t?(a._currentAcceptInput=null,a._currentCancelInput=null,i(a._inputField.value)):a.cancelInput(!0)};l.add(a._editor.onDidChangeCursorSelection(function(){var t=a._editor.getPosition();t&&o.Range.containsPosition(e,t)||a.cancelInput(!0)})),l.add(a._editor.onDidBlurEditorWidget(function(){return a.cancelInput(!1)})),a._show()}).then(function(e){return u(),e},function(e){return u(),Promise.reject(e)})},e.prototype._show=function(){var e=this;this._editor.revealLineInCenterIfOutsideViewport(this._position.lineNumber,0),this._visible=!0,this._visibleContextKey.set(!0),this._editor.layoutContentWidget(this),setTimeout(function(){e._inputField.focus(),
e._inputField.setSelectionRange(parseInt(e._inputField.getAttribute("selectionStart")),parseInt(e._inputField.getAttribute("selectionEnd")))},100)},e.prototype._hide=function(){this._visible=!1,this._visibleContextKey.reset(),this._editor.layoutContentWidget(this)},e}();t.RenameInputField=l}),define(t[90],i([1,0,22,29]),function(e,t,i,n){"use strict";function o(e,t){var i=Object.create(null);for(var n in t){var o=t[n];"string"==typeof o?i[n]=e.getColor(o):"function"==typeof o&&(i[n]=o(e))}return i}function r(e,t,i){function n(n){var r=o(e.getTheme(),t);"function"==typeof i?i(r):i.style(r)}return n(e.getTheme()),e.onThemeChange(n)}Object.defineProperty(t,"__esModule",{value:!0}),t.computeStyles=o,t.attachStyler=r,t.attachBadgeStyler=function(e,t,n){return r(t,{badgeBackground:n&&n.badgeBackground||i.badgeBackground,badgeForeground:n&&n.badgeForeground||i.badgeForeground,badgeBorder:i.contrastBorder},e)},t.attachQuickOpenStyler=function(e,t,n){return r(t,{foreground:n&&n.foreground||i.foreground,
background:n&&n.background||i.editorBackground,borderColor:n&&n.borderColor||i.contrastBorder,widgetShadow:n&&n.widgetShadow||i.widgetShadow,progressBarBackground:n&&n.progressBarBackground||i.progressBarBackground,pickerGroupForeground:n&&n.pickerGroupForeground||i.pickerGroupForeground,pickerGroupBorder:n&&n.pickerGroupBorder||i.pickerGroupBorder,inputBackground:n&&n.inputBackground||i.inputBackground,inputForeground:n&&n.inputForeground||i.inputForeground,inputBorder:n&&n.inputBorder||i.inputBorder,inputValidationInfoBorder:n&&n.inputValidationInfoBorder||i.inputValidationInfoBorder,inputValidationInfoBackground:n&&n.inputValidationInfoBackground||i.inputValidationInfoBackground,inputValidationInfoForeground:n&&n.inputValidationInfoForeground||i.inputValidationInfoForeground,inputValidationWarningBorder:n&&n.inputValidationWarningBorder||i.inputValidationWarningBorder,inputValidationWarningBackground:n&&n.inputValidationWarningBackground||i.inputValidationWarningBackground,
inputValidationWarningForeground:n&&n.inputValidationWarningForeground||i.inputValidationWarningForeground,inputValidationErrorBorder:n&&n.inputValidationErrorBorder||i.inputValidationErrorBorder,inputValidationErrorBackground:n&&n.inputValidationErrorBackground||i.inputValidationErrorBackground,inputValidationErrorForeground:n&&n.inputValidationErrorForeground||i.inputValidationErrorForeground,listFocusBackground:n&&n.listFocusBackground||i.listFocusBackground,listFocusForeground:n&&n.listFocusForeground||i.listFocusForeground,listActiveSelectionBackground:n&&n.listActiveSelectionBackground||i.darken(i.listActiveSelectionBackground,.1),listActiveSelectionForeground:n&&n.listActiveSelectionForeground||i.listActiveSelectionForeground,listFocusAndSelectionBackground:n&&n.listFocusAndSelectionBackground||i.listActiveSelectionBackground,listFocusAndSelectionForeground:n&&n.listFocusAndSelectionForeground||i.listActiveSelectionForeground,
listInactiveSelectionBackground:n&&n.listInactiveSelectionBackground||i.listInactiveSelectionBackground,listInactiveSelectionForeground:n&&n.listInactiveSelectionForeground||i.listInactiveSelectionForeground,listInactiveFocusBackground:n&&n.listInactiveFocusBackground||i.listInactiveFocusBackground,listHoverBackground:n&&n.listHoverBackground||i.listHoverBackground,listHoverForeground:n&&n.listHoverForeground||i.listHoverForeground,listDropBackground:n&&n.listDropBackground||i.listDropBackground,listFocusOutline:n&&n.listFocusOutline||i.activeContrastBorder,listSelectionOutline:n&&n.listSelectionOutline||i.activeContrastBorder,listHoverOutline:n&&n.listHoverOutline||i.activeContrastBorder},e)},t.attachListStyler=function(e,i,o){return r(i,n.mixin(o||Object.create(null),t.defaultListStyles,!1),e)},t.defaultListStyles={listFocusBackground:i.listFocusBackground,listFocusForeground:i.listFocusForeground,listActiveSelectionBackground:i.darken(i.listActiveSelectionBackground,.1),
listActiveSelectionForeground:i.listActiveSelectionForeground,listFocusAndSelectionBackground:i.listActiveSelectionBackground,listFocusAndSelectionForeground:i.listActiveSelectionForeground,listInactiveSelectionBackground:i.listInactiveSelectionBackground,listInactiveSelectionForeground:i.listInactiveSelectionForeground,listInactiveFocusBackground:i.listInactiveFocusBackground,listHoverBackground:i.listHoverBackground,listHoverForeground:i.listHoverForeground,listDropBackground:i.listDropBackground,listFocusOutline:i.activeContrastBorder,listSelectionOutline:i.activeContrastBorder,listHoverOutline:i.activeContrastBorder,listFilterWidgetBackground:i.listFilterWidgetBackground,listFilterWidgetOutline:i.listFilterWidgetOutline,listFilterWidgetNoMatchesOutline:i.listFilterWidgetNoMatchesOutline,listMatchesShadow:i.widgetShadow,treeIndentGuidesStroke:i.treeIndentGuidesStroke},t.defaultMenuStyles={shadowColor:i.widgetShadow,borderColor:i.menuBorder,foregroundColor:i.menuForeground,backgroundColor:i.menuBackground,
selectionForegroundColor:i.menuSelectionForeground,selectionBackgroundColor:i.menuSelectionBackground,selectionBorderColor:i.menuSelectionBorder,separatorColor:i.menuSeparatorBackground},t.attachMenuStyler=function(e,i,n){return r(i,s({},t.defaultMenuStyles,n),e)}}),define(t[514],i([1,0,8,305,22,90]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(){function e(e,t,i,n,o,r){this.codeEditor=e,this.themeService=r,this.create(t,i,n,o)}return e.prototype.create=function(e,t,i,s){this.domNode=document.createElement("div"),this.quickOpenWidget=new n.QuickOpenWidget(this.domNode,{onOk:e,onCancel:t,onType:i},{inputPlaceHolder:void 0,inputAriaLabel:s.inputAriaLabel,keyboardSupport:!0}),this.styler=r.attachQuickOpenStyler(this.quickOpenWidget,this.themeService,{pickerGroupForeground:o.foreground}),this.quickOpenWidget.create(),this.codeEditor.addOverlayWidget(this)},e.prototype.setInput=function(e,t){this.quickOpenWidget.setInput(e,t)},e.prototype.getId=function(){
return e.ID},e.prototype.getDomNode=function(){return this.domNode},e.prototype.destroy=function(){this.codeEditor.removeOverlayWidget(this),this.quickOpenWidget.dispose(),this.styler.dispose()},e.prototype.show=function(e){this.visible=!0;var t=this.codeEditor.getLayoutInfo();t&&this.quickOpenWidget.layout(new i.Dimension(t.width,t.height)),this.quickOpenWidget.show(e),this.codeEditor.layoutOverlayWidget(this)},e.prototype.getPosition=function(){return this.visible?{preference:2}:null},e.ID="editor.contrib.quickOpenEditorWidget",e}();t.QuickOpenEditorWidget=s}),define(t[515],i([1,0,58,2,291,8,90,52,44,401]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t,i,n,o){this.contextViewService=e,this.telemetryService=t,this.notificationService=i,this.keybindingService=n,this.themeService=o,this.options={blockMouse:!0}}return e.prototype.configure=function(e){this.options=e},e.prototype.showContextMenu=function(e){var t=this,u=e.getActions()
;if(u.length){this.focusToReturn=document.activeElement;var d;this.contextViewService.showContextView({getAnchor:function(){return e.getAnchor()},canRelayout:!1,anchorAlignment:e.anchorAlignment,render:function(c){var h=e.getMenuClassName?e.getMenuClassName():"";h&&(c.className+=" "+h),t.options.blockMouse&&(t.block=c.appendChild(r.$(".context-view-block")));var p=new n.DisposableStore,f=e.actionRunner||new i.ActionRunner;return f.onDidBeforeRun(t.onActionRun,t,p),f.onDidRun(t.onDidActionRun,t,p),d=new o.Menu(c,u,{actionViewItemProvider:e.getActionViewItem,context:e.getActionsContext?e.getActionsContext():null,actionRunner:f,getKeyBinding:e.getKeyBinding?e.getKeyBinding:function(e){return t.keybindingService.lookupKeybinding(e.id)}}),p.add(s.attachMenuStyler(d,t.themeService)),d.onDidCancel(function(){return t.contextViewService.hideContextView(!0)},null,p),d.onDidBlur(function(){return t.contextViewService.hideContextView(!0)},null,p),a.domEvent(window,r.EventType.BLUR)(function(){
t.contextViewService.hideContextView(!0)},null,p),a.domEvent(window,r.EventType.MOUSE_DOWN)(function(e){if(!e.defaultPrevented){var i=new l.StandardMouseEvent(e),n=i.target;if(!i.rightButton){for(;n;){if(n===c)return;n=n.parentElement}t.contextViewService.hideContextView(!0)}}},null,p),n.combinedDisposable(p,d)},focus:function(){d&&d.focus(!!e.autoSelectFirstItem)},onHide:function(i){e.onHide&&e.onHide(!!i),t.block&&(r.removeNode(t.block),t.block=null),t.focusToReturn&&t.focusToReturn.focus()}})}},e.prototype.onActionRun=function(e){this.telemetryService&&this.telemetryService.publicLog2("workbenchActionExecuted",{id:e.action.id,from:"contextMenu"}),this.contextViewService.hideContextView(!1),this.focusToReturn&&this.focusToReturn.focus()},e.prototype.onDidActionRun=function(e){e.error&&this.notificationService&&this.notificationService.error(e.error)},e}();t.ContextMenuHandler=u}),define(t[16],i([1,0,12,2,46,4]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.IThemeService=i.createDecorator("themeService"),t.themeColorFromId=function(e){return{id:e}},t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc",t.getThemeTypeSelector=function(e){switch(e){case t.DARK:return"vs-dark";case t.HIGH_CONTRAST:return"hc-black";default:return"vs"}},t.Extensions={ThemingContribution:"base.contributions.theming"};var s=new(function(){function e(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}return e.prototype.onThemeChange=function(e){var t=this;return this.themingParticipants.push(e),this.onThemingParticipantAddedEmitter.fire(e),n.toDisposable(function(){var i=t.themingParticipants.indexOf(e);t.themingParticipants.splice(i,1)})},e.prototype.getThemingParticipants=function(){return this.themingParticipants},e}());o.Registry.add(t.Extensions.ThemingContribution,s),t.registerThemingParticipant=function(e){return s.onThemeChange(e)}}),define(t[517],i([1,0,8,2,5,24,235,72,49,16]),function(e,t,i,n,o,s,a,l,u,h){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var p=function(e){function t(t,n){void 0===n&&(n=i.createStyleSheet());var o=e.call(this)||this;return o._decorationOptionProviders=new Map,o._styleSheet=n,o._themeService=t,o}return r(t,e),t.prototype.registerDecorationType=function(e,t,i){var n=this._decorationOptionProviders.get(e);if(!n){var o={styleSheet:this._styleSheet,key:e,parentTypeKey:i,options:t||Object.create(null)};n=i?new f(this._themeService,o):new g(this._themeService,o),this._decorationOptionProviders.set(e,n)}n.refCount++},t.prototype.removeDecorationType=function(e){var t=this._decorationOptionProviders.get(e);t&&(t.refCount--,t.refCount<=0&&(this._decorationOptionProviders.delete(e),t.dispose(),this.listCodeEditors().forEach(function(t){return t.removeDecorations(e)})))},t.prototype.resolveDecorationOptions=function(e,t){var i=this._decorationOptionProviders.get(e);if(!i)throw new Error("Unknown decoration type key: "+e);return i.getOptions(this,t)},t=d([c(0,h.IThemeService)],t)
}(a.AbstractCodeEditorService);t.CodeEditorServiceImpl=p;var f=function(){function e(e,t){this._parentTypeKey=t.parentTypeKey,this.refCount=0,this._beforeContentRules=new v(3,t,e),this._afterContentRules=new v(4,t,e)}return e.prototype.getOptions=function(e,t){var i=e.resolveDecorationOptions(this._parentTypeKey,!0);return this._beforeContentRules&&(i.beforeContentClassName=this._beforeContentRules.className),this._afterContentRules&&(i.afterContentClassName=this._afterContentRules.className),i},e.prototype.dispose=function(){this._beforeContentRules&&(this._beforeContentRules.dispose(),this._beforeContentRules=null),this._afterContentRules&&(this._afterContentRules.dispose(),this._afterContentRules=null)},e}(),g=function(){function e(e,t){var i=this;this._disposables=new n.DisposableStore,this.refCount=0;var o=function(n){var o=new v(n,t,e);if(i._disposables.add(o),o.hasContent)return o.className};this.className=o(0);var r=function(n){var o=new v(n,t,e);return i._disposables.add(o),o.hasContent?{
className:o.className,hasLetterSpacing:o.hasLetterSpacing}:null}(1);r&&(this.inlineClassName=r.className,this.inlineClassNameAffectsLetterSpacing=r.hasLetterSpacing),this.beforeContentClassName=o(3),this.afterContentClassName=o(4),this.glyphMarginClassName=o(2);var s=t.options;this.isWholeLine=Boolean(s.isWholeLine),this.stickiness=s.rangeBehavior;var a=s.light&&s.light.overviewRulerColor||s.overviewRulerColor,l=s.dark&&s.dark.overviewRulerColor||s.overviewRulerColor;void 0===a&&void 0===l||(this.overviewRuler={color:a||l,darkColor:l||a,position:s.overviewRulerLane||u.OverviewRulerLane.Center})}return e.prototype.getOptions=function(e,t){return t?{inlineClassName:this.inlineClassName,beforeContentClassName:this.beforeContentClassName,afterContentClassName:this.afterContentClassName,className:this.className,glyphMarginClassName:this.glyphMarginClassName,isWholeLine:this.isWholeLine,overviewRuler:this.overviewRuler,stickiness:this.stickiness}:this},e.prototype.dispose=function(){this._disposables.dispose()},e
}(),m={color:"color:{0} !important;",opacity:"opacity:{0};",backgroundColor:"background-color:{0};",outline:"outline:{0};",outlineColor:"outline-color:{0};",outlineStyle:"outline-style:{0};",outlineWidth:"outline-width:{0};",border:"border:{0};",borderColor:"border-color:{0};",borderRadius:"border-radius:{0};",borderSpacing:"border-spacing:{0};",borderStyle:"border-style:{0};",borderWidth:"border-width:{0};",fontStyle:"font-style:{0};",fontWeight:"font-weight:{0};",textDecoration:"text-decoration:{0};",cursor:"cursor:{0};",letterSpacing:"letter-spacing:{0};",gutterIconPath:"background:{0} center center no-repeat;",gutterIconSize:"background-size:{0};",contentText:"content:'{0}';",contentIconPath:"content:{0};",margin:"margin:{0};",width:"width:{0};",height:"height:{0};"},v=function(){function e(e,t,i){var n=this;this._theme=i.getTheme(),this._ruleType=e,this._providerArgs=t,this._usesThemeColors=!1,this._hasContent=!1,this._hasLetterSpacing=!1;var o=_.getClassName(this._providerArgs.key,e)
;this._providerArgs.parentTypeKey&&(o=o+" "+_.getClassName(this._providerArgs.parentTypeKey,e)),this._className=o,this._unThemedSelector=_.getSelector(this._providerArgs.key,this._providerArgs.parentTypeKey,e),this._buildCSS(),this._usesThemeColors?this._themeListener=i.onThemeChange(function(e){n._theme=i.getTheme(),n._removeCSS(),n._buildCSS()}):this._themeListener=null}return e.prototype.dispose=function(){this._hasContent&&(this._removeCSS(),this._hasContent=!1),this._themeListener&&(this._themeListener.dispose(),this._themeListener=null)},Object.defineProperty(e.prototype,"hasContent",{get:function(){return this._hasContent},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasLetterSpacing",{get:function(){return this._hasLetterSpacing},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"className",{get:function(){return this._className},enumerable:!0,configurable:!0}),e.prototype._buildCSS=function(){var e,t,i,n=this._providerArgs.options;switch(this._ruleType){case 0:
e=this.getCSSTextForModelDecorationClassName(n),t=this.getCSSTextForModelDecorationClassName(n.light),i=this.getCSSTextForModelDecorationClassName(n.dark);break;case 1:e=this.getCSSTextForModelDecorationInlineClassName(n),t=this.getCSSTextForModelDecorationInlineClassName(n.light),i=this.getCSSTextForModelDecorationInlineClassName(n.dark);break;case 2:e=this.getCSSTextForModelDecorationGlyphMarginClassName(n),t=this.getCSSTextForModelDecorationGlyphMarginClassName(n.light),i=this.getCSSTextForModelDecorationGlyphMarginClassName(n.dark);break;case 3:e=this.getCSSTextForModelDecorationContentClassName(n.before),t=this.getCSSTextForModelDecorationContentClassName(n.light&&n.light.before),i=this.getCSSTextForModelDecorationContentClassName(n.dark&&n.dark.before);break;case 4:e=this.getCSSTextForModelDecorationContentClassName(n.after),t=this.getCSSTextForModelDecorationContentClassName(n.light&&n.light.after),i=this.getCSSTextForModelDecorationContentClassName(n.dark&&n.dark.after);break;default:
throw new Error("Unknown rule type: "+this._ruleType)}var o=this._providerArgs.styleSheet.sheet,r=!1;e.length>0&&(o.insertRule(this._unThemedSelector+" {"+e+"}",0),r=!0),t.length>0&&(o.insertRule(".vs"+this._unThemedSelector+" {"+t+"}",0),r=!0),i.length>0&&(o.insertRule(".vs-dark"+this._unThemedSelector+", .hc-black"+this._unThemedSelector+" {"+i+"}",0),r=!0),this._hasContent=r},e.prototype._removeCSS=function(){i.removeCSSRulesContainingSelector(this._unThemedSelector,this._providerArgs.styleSheet)},e.prototype.getCSSTextForModelDecorationClassName=function(e){if(!e)return"";var t=[];return this.collectCSSText(e,["backgroundColor"],t),this.collectCSSText(e,["outline","outlineColor","outlineStyle","outlineWidth"],t),this.collectBorderSettingsCSSText(e,t),t.join("")},e.prototype.getCSSTextForModelDecorationInlineClassName=function(e){if(!e)return"";var t=[];return this.collectCSSText(e,["fontStyle","fontWeight","textDecoration","cursor","color","opacity","letterSpacing"],t),
e.letterSpacing&&(this._hasLetterSpacing=!0),t.join("")},e.prototype.getCSSTextForModelDecorationContentClassName=function(e){if(!e)return"";var t=[];if(void 0!==e){if(this.collectBorderSettingsCSSText(e,t),void 0!==e.contentIconPath&&t.push(o.format(m.contentIconPath,i.asCSSUrl(s.URI.revive(e.contentIconPath)))),"string"==typeof e.contentText){var n=e.contentText.match(/^.*$/m)[0].replace(/['\\]/g,"\\$&");t.push(o.format(m.contentText,n))}this.collectCSSText(e,["fontStyle","fontWeight","textDecoration","color","opacity","backgroundColor","margin"],t),this.collectCSSText(e,["width","height"],t)&&t.push("display:inline-block;")}return t.join("")},e.prototype.getCSSTextForModelDecorationGlyphMarginClassName=function(e){if(!e)return"";var t=[];return void 0!==e.gutterIconPath&&(t.push(o.format(m.gutterIconPath,i.asCSSUrl(s.URI.revive(e.gutterIconPath)))),void 0!==e.gutterIconSize&&t.push(o.format(m.gutterIconSize,e.gutterIconSize))),t.join("")},e.prototype.collectBorderSettingsCSSText=function(e,t){
return!!this.collectCSSText(e,["border","borderColor","borderRadius","borderSpacing","borderStyle","borderWidth"],t)&&(t.push(o.format("box-sizing: border-box;")),!0)},e.prototype.collectCSSText=function(e,t,i){for(var n=i.length,r=0,s=t;r<s.length;r++){var a=s[r],l=this.resolveValue(e[a]);"string"==typeof l&&i.push(o.format(m[a],l))}return i.length!==n},e.prototype.resolveValue=function(e){if(l.isThemeColor(e)){this._usesThemeColors=!0;var t=this._theme.getColor(e.id);return t?t.toString():"transparent"}return e},e}(),_=function(){function e(){}return e.getClassName=function(e,t){return"ced-"+e+"-"+t},e.getSelector=function(e,t,i){var n=".monaco-editor ."+this.getClassName(e,i);return t&&(n=n+"."+this.getClassName(t,i)),3===i?n+="::before":4===i&&(n+="::after"),n},e}()}),define(t[518],i([1,0,8,27,51,35,16]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t,r,l,u){
var d=e.call(this,t)||this,c=d._context.configuration.editor.viewInfo.scrollbar,h={listenOnDomNode:l.domNode,className:"editor-scrollable "+a.getThemeTypeSelector(t.theme.type),useShadows:!1,lazyRender:!0,vertical:c.vertical,horizontal:c.horizontal,verticalHasArrows:c.verticalHasArrows,horizontalHasArrows:c.horizontalHasArrows,verticalScrollbarSize:c.verticalScrollbarSize,verticalSliderSize:c.verticalSliderSize,horizontalScrollbarSize:c.horizontalScrollbarSize,horizontalSliderSize:c.horizontalSliderSize,handleMouseWheel:c.handleMouseWheel,arrowSize:c.arrowSize,mouseWheelScrollSensitivity:c.mouseWheelScrollSensitivity,fastScrollSensitivity:c.fastScrollSensitivity};d.scrollbar=d._register(new o.SmoothScrollableElement(r.domNode,h,d._context.viewLayout.scrollable)),s.PartFingerprints.write(d.scrollbar.getDomNode(),5),d.scrollbarDomNode=n.createFastDomNode(d.scrollbar.getDomNode()),d.scrollbarDomNode.setPosition("absolute"),d._setLayout();var p=function(e,t,i){var n={};if(t){var o=e.scrollTop
;o&&(n.scrollTop=d._context.viewLayout.getCurrentScrollTop()+o,e.scrollTop=0)}if(i){var r=e.scrollLeft;r&&(n.scrollLeft=d._context.viewLayout.getCurrentScrollLeft()+r,e.scrollLeft=0)}d._context.viewLayout.setScrollPositionNow(n)};return d._register(i.addDisposableListener(l.domNode,"scroll",function(e){return p(l.domNode,!0,!0)})),d._register(i.addDisposableListener(r.domNode,"scroll",function(e){return p(r.domNode,!0,!1)})),d._register(i.addDisposableListener(u.domNode,"scroll",function(e){return p(u.domNode,!0,!1)})),d._register(i.addDisposableListener(d.scrollbarDomNode.domNode,"scroll",function(e){return p(d.scrollbarDomNode.domNode,!0,!1)})),d}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype._setLayout=function(){var e=this._context.configuration.editor.layoutInfo;this.scrollbarDomNode.setLeft(e.contentLeft)
;"right"===this._context.configuration.editor.viewInfo.minimap.side?this.scrollbarDomNode.setWidth(e.contentWidth+e.minimapWidth):this.scrollbarDomNode.setWidth(e.contentWidth),this.scrollbarDomNode.setHeight(e.contentHeight)},t.prototype.getOverviewRulerLayoutInfo=function(){return this.scrollbar.getOverviewRulerLayoutInfo()},t.prototype.getDomNode=function(){return this.scrollbarDomNode},t.prototype.delegateVerticalScrollbarMouseDown=function(e){this.scrollbar.delegateVerticalScrollbarMouseDown(e)},t.prototype.onConfigurationChanged=function(e){if(e.viewInfo){var t=this._context.configuration.editor,i={handleMouseWheel:t.viewInfo.scrollbar.handleMouseWheel,mouseWheelScrollSensitivity:t.viewInfo.scrollbar.mouseWheelScrollSensitivity,fastScrollSensitivity:t.viewInfo.scrollbar.fastScrollSensitivity};this.scrollbar.updateOptions(i)}return e.layoutInfo&&this._setLayout(),!0},t.prototype.onScrollChanged=function(e){return!0},t.prototype.onThemeChanged=function(e){
return this.scrollbar.updateClassName("editor-scrollable "+a.getThemeTypeSelector(this._context.theme.type)),!0},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){this.scrollbar.renderNow()},t}(s.ViewPart);t.EditorScrollbar=l}),define(t[216],i([1,0,28,27,18,519,88,138,94,16]),function(e,t,i,n,o,s,a,l,u,d){"use strict";function c(e,t,i,n,o){return new b(e,t,i,n,o)}function h(e,t,i,n,o){return new y(e,t,i,n,o)}Object.defineProperty(t,"__esModule",{value:!0});var p=!!o.isNative||!(o.isLinux||i.isFirefox||i.isSafari),f=i.isEdgeOrIE,g=function(){function e(e,t){this._domNode=e,this._clientRectDeltaLeft=0,this._clientRectDeltaLeftRead=!1,this.endNode=t}return Object.defineProperty(e.prototype,"clientRectDeltaLeft",{get:function(){return this._clientRectDeltaLeftRead||(this._clientRectDeltaLeftRead=!0,this._clientRectDeltaLeft=this._domNode.getBoundingClientRect().left),this._clientRectDeltaLeft},enumerable:!0,configurable:!0}),e}();t.DomReadingContext=g;var m=function(){function e(e,t){
this.themeType=t,this.renderWhitespace=e.editor.viewInfo.renderWhitespace,this.renderControlCharacters=e.editor.viewInfo.renderControlCharacters,this.spaceWidth=e.editor.fontInfo.spaceWidth,this.useMonospaceOptimizations=e.editor.fontInfo.isMonospace&&!e.editor.viewInfo.disableMonospaceOptimizations,this.canUseHalfwidthRightwardsArrow=e.editor.fontInfo.canUseHalfwidthRightwardsArrow,this.lineHeight=e.editor.lineHeight,this.stopRenderingLineAfter=e.editor.viewInfo.stopRenderingLineAfter,this.fontLigatures=e.editor.viewInfo.fontLigatures}return e.prototype.equals=function(e){return this.themeType===e.themeType&&this.renderWhitespace===e.renderWhitespace&&this.renderControlCharacters===e.renderControlCharacters&&this.spaceWidth===e.spaceWidth&&this.useMonospaceOptimizations===e.useMonospaceOptimizations&&this.canUseHalfwidthRightwardsArrow===e.canUseHalfwidthRightwardsArrow&&this.lineHeight===e.lineHeight&&this.stopRenderingLineAfter===e.stopRenderingLineAfter&&this.fontLigatures===e.fontLigatures},e}()
;t.ViewLineOptions=m;var v=function(){function e(e){this._options=e,this._isMaybeInvalid=!0,this._renderedViewLine=null}return e.prototype.getDomNode=function(){return this._renderedViewLine&&this._renderedViewLine.domNode?this._renderedViewLine.domNode.domNode:null},e.prototype.setDomNode=function(e){if(!this._renderedViewLine)throw new Error("I have no rendered view line to set the dom node to...");this._renderedViewLine.domNode=n.createFastDomNode(e)},e.prototype.onContentChanged=function(){this._isMaybeInvalid=!0},e.prototype.onTokensChanged=function(){this._isMaybeInvalid=!0},e.prototype.onDecorationsChanged=function(){this._isMaybeInvalid=!0},e.prototype.onOptionsChanged=function(e){this._isMaybeInvalid=!0,this._options=e},e.prototype.onSelectionChanged=function(){return!(!f&&this._options.themeType!==d.HIGH_CONTRAST&&"selection"!==this._options.renderWhitespace)&&(this._isMaybeInvalid=!0,!0)},e.prototype.renderLine=function(t,i,n,o){if(!1===this._isMaybeInvalid)return!1;this._isMaybeInvalid=!1
;var r=n.getViewLineRenderingData(t),s=this._options,a=l.LineDecoration.filter(r.inlineDecorations,t,r.minColumn,r.maxColumn),c=null;if(f||s.themeType===d.HIGH_CONTRAST||"selection"===this._options.renderWhitespace)for(var h=0,g=n.selections;h<g.length;h++){var m=g[h];if(!(m.endLineNumber<t||m.startLineNumber>t)){var v=m.startLineNumber===t?m.startColumn:r.minColumn,y=m.endLineNumber===t?m.endColumn:r.maxColumn;v<y&&("selection"!==this._options.renderWhitespace?a.push(new l.LineDecoration(v,y,"inline-selected-text",0)):(c||(c=[]),c.push(new u.LineRange(v-1,y-1))))}}var b=new u.RenderLineInput(s.useMonospaceOptimizations,s.canUseHalfwidthRightwardsArrow,r.content,r.continuesWithWrappedLine,r.isBasicASCII,r.containsRTL,r.minColumn-1,r.tokens,a,r.tabSize,s.spaceWidth,s.stopRenderingLineAfter,s.renderWhitespace,s.renderControlCharacters,s.fontLigatures,c);if(this._renderedViewLine&&this._renderedViewLine.input.equals(b))return!1;o.appendASCIIString('<div style="top:'),o.appendASCIIString(String(i)),
o.appendASCIIString("px;height:"),o.appendASCIIString(String(this._options.lineHeight)),o.appendASCIIString('px;" class="'),o.appendASCIIString(e.CLASS_NAME),o.appendASCIIString('">');var S=u.renderViewLine(b,o);o.appendASCIIString("</div>");var w=null;return p&&r.isBasicASCII&&s.useMonospaceOptimizations&&0===S.containsForeignElements&&r.content.length<300&&b.lineTokens.getCount()<100&&(w=new _(this._renderedViewLine?this._renderedViewLine.domNode:null,b,S.characterMapping)),w||(w=C(this._renderedViewLine?this._renderedViewLine.domNode:null,b,S.characterMapping,S.containsRTL,S.containsForeignElements)),this._renderedViewLine=w,!0},e.prototype.layoutLine=function(e,t){this._renderedViewLine&&this._renderedViewLine.domNode&&(this._renderedViewLine.domNode.setTop(t),this._renderedViewLine.domNode.setHeight(this._options.lineHeight))},e.prototype.getWidth=function(){return this._renderedViewLine?this._renderedViewLine.getWidth():0},e.prototype.getWidthIsFast=function(){
return!this._renderedViewLine||this._renderedViewLine.getWidthIsFast()},e.prototype.getVisibleRangesForRange=function(e,t,i){if(!this._renderedViewLine)return null;e|=0,t|=0,e=Math.min(this._renderedViewLine.input.lineContent.length+1,Math.max(1,e)),t=Math.min(this._renderedViewLine.input.lineContent.length+1,Math.max(1,t));var n=0|this._renderedViewLine.input.stopRenderingLineAfter;return-1!==n&&e>n&&t>n?null:(-1!==n&&e>n&&(e=n),-1!==n&&t>n&&(t=n),this._renderedViewLine.getVisibleRangesForRange(e,t,i))},e.prototype.getColumnOfNodeOffset=function(e,t,i){return this._renderedViewLine?this._renderedViewLine.getColumnOfNodeOffset(e,t,i):1},e.CLASS_NAME="view-line",e}();t.ViewLine=v;var _=function(){function e(e,t,i){this.domNode=e,this.input=t,this._characterMapping=i,this._charWidth=t.spaceWidth}return e.prototype.getWidth=function(){return this._getCharPosition(this._characterMapping.length)},e.prototype.getWidthIsFast=function(){return!0},e.prototype.getVisibleRangesForRange=function(e,t,i){
var n=this._getCharPosition(e),o=this._getCharPosition(t);return[new a.HorizontalRange(n,o-n)]},e.prototype._getCharPosition=function(e){var t=this._characterMapping.getAbsoluteOffsets();return 0===t.length?0:Math.round(this._charWidth*t[e-1])},e.prototype.getColumnOfNodeOffset=function(e,t,i){for(var n=t.textContent.length,o=-1;t;)t=t.previousSibling,o++;return this._characterMapping.partDataToCharOffset(o,n,i)+1},e}(),y=function(){function e(e,t,i,n,o){if(this.domNode=e,this.input=t,this._characterMapping=i,this._isWhitespaceOnly=/^\s*$/.test(t.lineContent),this._containsForeignElements=o,this._cachedWidth=-1,this._pixelOffsetCache=null,!n||0===this._characterMapping.length){this._pixelOffsetCache=new Int32Array(Math.max(2,this._characterMapping.length+1));for(var r=0,s=this._characterMapping.length;r<=s;r++)this._pixelOffsetCache[r]=-1}}return e.prototype._getReadingTarget=function(){return this.domNode.domNode.firstChild},e.prototype.getWidth=function(){
return-1===this._cachedWidth&&(this._cachedWidth=this._getReadingTarget().offsetWidth),this._cachedWidth},e.prototype.getWidthIsFast=function(){return-1!==this._cachedWidth},e.prototype.getVisibleRangesForRange=function(e,t,i){if(null!==this._pixelOffsetCache){var n=this._readPixelOffset(e,i);if(-1===n)return null;var o=this._readPixelOffset(t,i);return-1===o?null:[new a.HorizontalRange(n,o-n)]}return this._readVisibleRangesForRange(e,t,i)},e.prototype._readVisibleRangesForRange=function(e,t,i){if(e===t){var n=this._readPixelOffset(e,i);return-1===n?null:[new a.HorizontalRange(n,0)]}return this._readRawVisibleRangesForRange(e,t,i)},e.prototype._readPixelOffset=function(e,t){if(0===this._characterMapping.length){if(0===this._containsForeignElements)return 0;if(2===this._containsForeignElements)return 0;if(1===this._containsForeignElements)return this.getWidth()}if(null!==this._pixelOffsetCache){var i=this._pixelOffsetCache[e];if(-1!==i)return i;var n=this._actualReadPixelOffset(e,t)
;return this._pixelOffsetCache[e]=n,n}return this._actualReadPixelOffset(e,t)},e.prototype._actualReadPixelOffset=function(e,t){if(0===this._characterMapping.length){var i=s.RangeUtil.readHorizontalRanges(this._getReadingTarget(),0,0,0,0,t.clientRectDeltaLeft,t.endNode);return i&&0!==i.length?i[0].left:-1}if(e===this._characterMapping.length&&this._isWhitespaceOnly&&0===this._containsForeignElements)return this.getWidth();var n=this._characterMapping.charOffsetToPartData(e-1),o=u.CharacterMapping.getPartIndex(n),r=u.CharacterMapping.getCharIndex(n),a=s.RangeUtil.readHorizontalRanges(this._getReadingTarget(),o,r,o,r,t.clientRectDeltaLeft,t.endNode);return a&&0!==a.length?a[0].left:-1},e.prototype._readRawVisibleRangesForRange=function(e,t,i){if(1===e&&t===this._characterMapping.length)return[new a.HorizontalRange(0,this.getWidth())]
;var n=this._characterMapping.charOffsetToPartData(e-1),o=u.CharacterMapping.getPartIndex(n),r=u.CharacterMapping.getCharIndex(n),l=this._characterMapping.charOffsetToPartData(t-1),d=u.CharacterMapping.getPartIndex(l),c=u.CharacterMapping.getCharIndex(l);return s.RangeUtil.readHorizontalRanges(this._getReadingTarget(),o,r,d,c,i.clientRectDeltaLeft,i.endNode)},e.prototype.getColumnOfNodeOffset=function(e,t,i){for(var n=t.textContent.length,o=-1;t;)t=t.previousSibling,o++;return this._characterMapping.partDataToCharOffset(o,n,i)+1},e}(),b=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._readVisibleRangesForRange=function(t,i,n){var o=e.prototype._readVisibleRangesForRange.call(this,t,i,n);if(!o||0===o.length||t===i||1===t&&i===this._characterMapping.length)return o;if(!this.input.containsRTL){var r=this._readPixelOffset(i,n);if(-1!==r){var s=o[o.length-1];s.left<r&&(s.width=r-s.left)}}return o},t}(y),C=i.isWebKit?c:h}),
define(t[217],i([1,0,28,162,35,216,13,3,36]),function(e,t,i,n,o,s,a,l,u){"use strict";function d(e){return{isAfterLines:!1,horizontalDistanceToText:e}}Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(e,t,i,n,o,r){void 0===i&&(i=0),void 0===n&&(n=null),void 0===o&&(o=null),void 0===r&&(r=null),this.element=e,this.type=t,this.mouseColumn=i,this.position=n,!o&&n&&(o=new l.Range(n.lineNumber,n.column,n.lineNumber,n.column)),this.range=o,this.detail=r}return e._typeToString=function(e){return 1===e?"TEXTAREA":2===e?"GUTTER_GLYPH_MARGIN":3===e?"GUTTER_LINE_NUMBERS":4===e?"GUTTER_LINE_DECORATIONS":5===e?"GUTTER_VIEW_ZONE":6===e?"CONTENT_TEXT":7===e?"CONTENT_EMPTY":8===e?"CONTENT_VIEW_ZONE":9===e?"CONTENT_WIDGET":10===e?"OVERVIEW_RULER":11===e?"SCROLLBAR":12===e?"OVERLAY_WIDGET":"UNKNOWN"},e.toString=function(e){return this._typeToString(e.type)+": "+e.position+" - "+e.range+" - "+e.detail},e.prototype.toString=function(){return e.toString(this)},e}();t.MouseTarget=c;var h=function(){
function e(){}return e.isTextArea=function(e){return 2===e.length&&3===e[0]&&6===e[1]},e.isChildOfViewLines=function(e){return e.length>=4&&3===e[0]&&7===e[3]},e.isStrictChildOfViewLines=function(e){return e.length>4&&3===e[0]&&7===e[3]},e.isChildOfScrollableElement=function(e){return e.length>=2&&3===e[0]&&5===e[1]},e.isChildOfMinimap=function(e){return e.length>=2&&3===e[0]&&8===e[1]},e.isChildOfContentWidgets=function(e){return e.length>=4&&3===e[0]&&1===e[3]},e.isChildOfOverflowingContentWidgets=function(e){return e.length>=1&&2===e[0]},e.isChildOfOverlayWidgets=function(e){return e.length>=2&&3===e[0]&&4===e[1]},e}(),p=function(){function e(e,t,i){this.model=e.model,this.layoutInfo=e.configuration.editor.layoutInfo,this.viewDomNode=t.viewDomNode,this.lineHeight=e.configuration.editor.lineHeight,this.typicalHalfwidthCharacterWidth=e.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,this.lastViewCursorsRenderData=i,this._context=e,this._viewHelper=t}return e.prototype.getZoneAtCoord=function(t){
return e.getZoneAtCoord(this._context,t)},e.getZoneAtCoord=function(e,t){var i=e.viewLayout.getWhitespaceAtVerticalOffset(t);if(i){var n=i.verticalOffset+i.height/2,o=e.model.getLineCount(),r=null,s=void 0,l=null;return i.afterLineNumber!==o&&(l=new a.Position(i.afterLineNumber+1,1)),i.afterLineNumber>0&&(r=new a.Position(i.afterLineNumber,e.model.getLineMaxColumn(i.afterLineNumber))),s=null===l?r:null===r?l:t<n?r:l,{viewZoneId:i.id,afterLineNumber:i.afterLineNumber,positionBefore:r,positionAfter:l,position:s}}return null},e.prototype.getFullLineRangeAtCoord=function(e){if(this._context.viewLayout.isAfterLines(e)){var t=this._context.model.getLineCount(),i=this._context.model.getLineMaxColumn(t);return{range:new l.Range(t,i,t,i),isAfterLines:!0}}var n=this._context.viewLayout.getLineNumberAtVerticalOffset(e),o=this._context.model.getLineMaxColumn(n);return{range:new l.Range(n,1,n,o),isAfterLines:!1}},e.prototype.getLineNumberAtVerticalOffset=function(e){
return this._context.viewLayout.getLineNumberAtVerticalOffset(e)},e.prototype.isAfterLines=function(e){return this._context.viewLayout.isAfterLines(e)},e.prototype.getVerticalOffsetForLineNumber=function(e){return this._context.viewLayout.getVerticalOffsetForLineNumber(e)},e.prototype.findAttribute=function(t,i){return e._findAttribute(t,i,this._viewHelper.viewDomNode)},e._findAttribute=function(e,t,i){for(;e&&e!==document.body;){if(e.hasAttribute&&e.hasAttribute(t))return e.getAttribute(t);if(e===i)return null;e=e.parentNode}return null},e.prototype.getLineWidth=function(e){return this._viewHelper.getLineWidth(e)},e.prototype.visibleRangeForPosition2=function(e,t){return this._viewHelper.visibleRangeForPosition2(e,t)},e.prototype.getPositionFromDOMInfo=function(e,t){return this._viewHelper.getPositionFromDOMInfo(e,t)},e.prototype.getCurrentScrollTop=function(){return this._context.viewLayout.getCurrentScrollTop()},e.prototype.getCurrentScrollLeft=function(){
return this._context.viewLayout.getCurrentScrollLeft()},e}();t.HitTestContext=p;var f=function(e){function t(t,i,n,r){var s=e.call(this,t,i,n)||this;return s._ctx=t,r?(s.target=r,s.targetPath=o.PartFingerprints.collect(r,t.viewDomNode)):(s.target=null,s.targetPath=new Uint8Array(0)),s}return r(t,e),t.prototype.toString=function(){return"pos("+this.pos.x+","+this.pos.y+"), editorPos("+this.editorPos.x+","+this.editorPos.y+"), mouseVerticalOffset: "+this.mouseVerticalOffset+", mouseContentHorizontalOffset: "+this.mouseContentHorizontalOffset+"\n\ttarget: "+(this.target?this.target.outerHTML:null)},t.prototype.fulfill=function(e,t,i,n){void 0===t&&(t=null),void 0===i&&(i=null),void 0===n&&(n=null);var o=this.mouseColumn;return t&&t.column<this._ctx.model.getLineMaxColumn(t.lineNumber)&&(o=u.CursorColumns.visibleColumnFromColumn(this._ctx.model.getLineContent(t.lineNumber),t.column,this._ctx.model.getOptions().tabSize)+1),new c(this.target,e,o,t,i,n)},t.prototype.withTarget=function(e){
return new t(this._ctx,this.editorPos,this.pos,e)},t}(function(){return function(e,t,i){this.editorPos=t,this.pos=i,this.mouseVerticalOffset=Math.max(0,e.getCurrentScrollTop()+i.y-t.y),this.mouseContentHorizontalOffset=e.getCurrentScrollLeft()+i.x-t.x-e.layoutInfo.contentLeft,this.isInMarginArea=i.x-t.x<e.layoutInfo.contentLeft&&i.x-t.x>=e.layoutInfo.glyphMarginLeft,this.isInContentArea=!this.isInMarginArea,this.mouseColumn=Math.max(0,m._getMouseColumn(this.mouseContentHorizontalOffset,e.typicalHalfwidthCharacterWidth))}}()),g={isAfterLines:!0},m=function(){function e(e,t){this._context=e,this._viewHelper=t}return e.prototype.mouseTargetIsWidget=function(e){var t=e.target,i=o.PartFingerprints.collect(t,this._viewHelper.viewDomNode);return!(!h.isChildOfContentWidgets(i)&&!h.isChildOfOverflowingContentWidgets(i))||!!h.isChildOfOverlayWidgets(i)},e.prototype.createMouseTarget=function(t,i,n,o){var r=new p(this._context,this._viewHelper,t),s=new f(r,i,n,o);try{return e._createMouseTarget(r,s,!1)}catch(e){
return s.fulfill(0)}},e._createMouseTarget=function(t,i,n){if(null===i.target){if(n)return i.fulfill(0);var o=e._doHitTest(t,i);return o.position?e.createMouseTargetFromHitTestPosition(t,i,o.position.lineNumber,o.position.column):this._createMouseTarget(t,i.withTarget(o.hitTarget),!0)}var r=i,s=null;return s=s||e._hitTestContentWidget(t,r),s=s||e._hitTestOverlayWidget(t,r),s=s||e._hitTestMinimap(t,r),s=s||e._hitTestScrollbarSlider(t,r),s=s||e._hitTestViewZone(t,r),s=s||e._hitTestMargin(t,r),s=s||e._hitTestViewCursor(t,r),s=s||e._hitTestTextArea(t,r),s=s||e._hitTestViewLines(t,r,n),(s=s||e._hitTestScrollbar(t,r))||i.fulfill(0)},e._hitTestContentWidget=function(e,t){if(h.isChildOfContentWidgets(t.targetPath)||h.isChildOfOverflowingContentWidgets(t.targetPath)){var i=e.findAttribute(t.target,"widgetId");return i?t.fulfill(9,null,null,i):t.fulfill(0)}return null},e._hitTestOverlayWidget=function(e,t){if(h.isChildOfOverlayWidgets(t.targetPath)){var i=e.findAttribute(t.target,"widgetId")
;return i?t.fulfill(12,null,null,i):t.fulfill(0)}return null},e._hitTestViewCursor=function(e,t){if(t.target)for(var i=0,n=o=e.lastViewCursorsRenderData;i<n.length;i++){u=n[i];if(t.target===u.domNode)return t.fulfill(6,u.position)}if(t.isInContentArea)for(var o=e.lastViewCursorsRenderData,r=t.mouseContentHorizontalOffset,s=t.mouseVerticalOffset,a=0,l=o;a<l.length;a++){var u;if(!(r<(u=l[a]).contentLeft)&&!(r>u.contentLeft+u.width)){var d=e.getVerticalOffsetForLineNumber(u.position.lineNumber);if(d<=s&&s<=d+u.height)return t.fulfill(6,u.position)}}return null},e._hitTestViewZone=function(e,t){var i=e.getZoneAtCoord(t.mouseVerticalOffset);if(i){var n=t.isInContentArea?8:5;return t.fulfill(n,i.position,null,i)}return null},e._hitTestTextArea=function(e,t){return h.isTextArea(t.targetPath)?t.fulfill(1):null},e._hitTestMargin=function(e,t){if(t.isInMarginArea){var i=e.getFullLineRangeAtCoord(t.mouseVerticalOffset),n=i.range.getStartPosition(),o=Math.abs(t.pos.x-t.editorPos.x),r={isAfterLines:i.isAfterLines,
glyphMarginLeft:e.layoutInfo.glyphMarginLeft,glyphMarginWidth:e.layoutInfo.glyphMarginWidth,lineNumbersWidth:e.layoutInfo.lineNumbersWidth,offsetX:o};return(o-=e.layoutInfo.glyphMarginLeft)<=e.layoutInfo.glyphMarginWidth?t.fulfill(2,n,i.range,r):(o-=e.layoutInfo.glyphMarginWidth)<=e.layoutInfo.lineNumbersWidth?t.fulfill(3,n,i.range,r):(o-=e.layoutInfo.lineNumbersWidth,t.fulfill(4,n,i.range,r))}return null},e._hitTestViewLines=function(t,i,n){if(!h.isChildOfViewLines(i.targetPath))return null;if(t.isAfterLines(i.mouseVerticalOffset)){var o=t.model.getLineCount(),r=t.model.getLineMaxColumn(o);return i.fulfill(7,new a.Position(o,r),void 0,g)}if(n){if(h.isStrictChildOfViewLines(i.targetPath)){var s=t.getLineNumberAtVerticalOffset(i.mouseVerticalOffset);if(0===t.model.getLineLength(s)){var l=t.getLineWidth(s),u=d(i.mouseContentHorizontalOffset-l);return i.fulfill(7,new a.Position(s,1),void 0,u)}}return i.fulfill(0)}var c=e._doHitTest(t,i)
;return c.position?e.createMouseTargetFromHitTestPosition(t,i,c.position.lineNumber,c.position.column):this._createMouseTarget(t,i.withTarget(c.hitTarget),!0)},e._hitTestMinimap=function(e,t){if(h.isChildOfMinimap(t.targetPath)){var i=e.getLineNumberAtVerticalOffset(t.mouseVerticalOffset),n=e.model.getLineMaxColumn(i);return t.fulfill(11,new a.Position(i,n))}return null},e._hitTestScrollbarSlider=function(e,t){if(h.isChildOfScrollableElement(t.targetPath)&&t.target&&1===t.target.nodeType){var i=t.target.className;if(i&&/\b(slider|scrollbar)\b/.test(i)){var n=e.getLineNumberAtVerticalOffset(t.mouseVerticalOffset),o=e.model.getLineMaxColumn(n);return t.fulfill(11,new a.Position(n,o))}}return null},e._hitTestScrollbar=function(e,t){if(h.isChildOfScrollableElement(t.targetPath)){var i=e.getLineNumberAtVerticalOffset(t.mouseVerticalOffset),n=e.model.getLineMaxColumn(i);return t.fulfill(11,new a.Position(i,n))}return null},e.prototype.getMouseColumn=function(t,i){
var n=this._context.configuration.editor.layoutInfo,o=this._context.viewLayout.getCurrentScrollLeft()+i.x-t.x-n.contentLeft;return e._getMouseColumn(o,this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth)},e._getMouseColumn=function(e,t){if(e<0)return 1;return Math.round(e/t)+1},e.createMouseTargetFromHitTestPosition=function(e,t,n,o){var r=new a.Position(n,o),s=e.getLineWidth(n);if(t.mouseContentHorizontalOffset>s){if(i.isEdge&&1===r.column){var u=d(t.mouseContentHorizontalOffset-s);return t.fulfill(7,new a.Position(n,e.model.getLineMaxColumn(n)),void 0,u)}var c=d(t.mouseContentHorizontalOffset-s);return t.fulfill(7,r,void 0,c)}var h=e.visibleRangeForPosition2(n,o);if(!h)return t.fulfill(0,r);var p=h.left;if(t.mouseContentHorizontalOffset===p)return t.fulfill(6,r);var f=[];if(f.push({offset:h.left,column:o}),o>1){var g=e.visibleRangeForPosition2(n,o-1);g&&f.push({offset:g.left,column:o-1})}if(o<e.model.getLineMaxColumn(n)){var m=e.visibleRangeForPosition2(n,o+1);m&&f.push({
offset:m.left,column:o+1})}f.sort(function(e,t){return e.offset-t.offset});for(var v=1;v<f.length;v++){var _=f[v-1],y=f[v];if(_.offset<=t.mouseContentHorizontalOffset&&t.mouseContentHorizontalOffset<=y.offset){var b=new l.Range(n,_.column,n,y.column);return t.fulfill(6,r,b)}}return t.fulfill(6,r)},e._doHitTestWithCaretRangeFromPoint=function(e,t){var i=e.getLineNumberAtVerticalOffset(t.mouseVerticalOffset),o=e.getVerticalOffsetForLineNumber(i)+Math.floor(e.lineHeight/2),r=t.pos.y+(o-t.mouseVerticalOffset);r<=t.editorPos.y&&(r=t.editorPos.y+1),r>=t.editorPos.y+e.layoutInfo.height&&(r=t.editorPos.y+e.layoutInfo.height-1);var s=new n.PageCoordinates(t.pos.x,r),a=this._actualDoHitTestWithCaretRangeFromPoint(e,s.toClientCoordinates());return a.position?a:this._actualDoHitTestWithCaretRangeFromPoint(e,t.pos.toClientCoordinates())},e._actualDoHitTestWithCaretRangeFromPoint=function(e,t){var i=document.caretRangeFromPoint(t.clientX,t.clientY);if(!i||!i.startContainer)return{position:null,hitTarget:null}
;var n=i.startContainer,o=null;if(n.nodeType===n.TEXT_NODE){var r=(l=(a=n.parentNode)?a.parentNode:null)?l.parentNode:null;if((r&&r.nodeType===r.ELEMENT_NODE?r.className:null)===s.ViewLine.CLASS_NAME){return{position:u=e.getPositionFromDOMInfo(a,i.startOffset),hitTarget:null}}o=n.parentNode}else if(n.nodeType===n.ELEMENT_NODE){var a=n.parentNode,l=a?a.parentNode:null;if((l&&l.nodeType===l.ELEMENT_NODE?l.className:null)===s.ViewLine.CLASS_NAME){var u=e.getPositionFromDOMInfo(n,n.textContent.length);return{position:u,hitTarget:null}}o=n}return{position:null,hitTarget:o}},e._doHitTestWithCaretPositionFromPoint=function(e,t){var i=document.caretPositionFromPoint(t.clientX,t.clientY);if(i.offsetNode.nodeType===i.offsetNode.TEXT_NODE){var n=i.offsetNode.parentNode,o=n?n.parentNode:null,r=o?o.parentNode:null;if((r&&r.nodeType===r.ELEMENT_NODE?r.className:null)===s.ViewLine.CLASS_NAME){return{position:e.getPositionFromDOMInfo(i.offsetNode.parentNode,i.offset),hitTarget:null}}return{position:null,
hitTarget:i.offsetNode.parentNode}}return{position:null,hitTarget:i.offsetNode}},e._doHitTestWithMoveToPoint=function(e,t){var i=null,n=null,o=document.body.createTextRange();try{o.moveToPoint(t.clientX,t.clientY)}catch(e){return{position:null,hitTarget:null}}o.collapse(!0);var r=o?o.parentElement():null,a=r?r.parentNode:null,l=a?a.parentNode:null;if((l&&l.nodeType===l.ELEMENT_NODE?l.className:"")===s.ViewLine.CLASS_NAME){var u=o.duplicate();u.moveToElementText(r),u.setEndPoint("EndToStart",o),i=e.getPositionFromDOMInfo(r,u.text.length),u.moveToElementText(e.viewDomNode)}else n=r;return o.moveToElementText(e.viewDomNode),{position:i,hitTarget:n}},e._doHitTest=function(e,t){return document.caretRangeFromPoint?this._doHitTestWithCaretRangeFromPoint(e,t):document.caretPositionFromPoint?this._doHitTestWithCaretPositionFromPoint(e,t.pos.toClientCoordinates()):document.body.createTextRange?this._doHitTestWithMoveToPoint(e,t.pos.toClientCoordinates()):{position:null,hitTarget:null}},e}();t.MouseTargetFactory=m}),
define(t[521],i([1,0,28,8,44,15,2,18,217,162,112,13,20,85]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f){"use strict";function g(e){return function(t,i){var n=!1;return e&&(n=e.mouseTargetIsWidget(i)),n||i.preventDefault(),i}}Object.defineProperty(t,"__esModule",{value:!0});var m=function(e){function t(r,a,l){var h=e.call(this)||this;h._isFocused=!1,h._context=r,h.viewController=a,h.viewHelper=l,h.mouseTargetFactory=new u.MouseTargetFactory(h._context,l),h._mouseDownOperation=h._register(new v(h._context,h.viewController,h.viewHelper,function(e,t){return h._createMouseTarget(e,t)},function(e){return h._getMouseColumn(e)})),h._asyncFocus=h._register(new s.RunOnceScheduler(function(){return h.viewHelper.focusTextArea()},0)),h.lastMouseLeaveTime=-1;var p=new d.EditorMouseEventFactory(h.viewHelper.viewDomNode);h._register(p.onContextMenu(h.viewHelper.viewDomNode,function(e){return h._onContextMenu(e,!0)})),h._register(p.onMouseMoveThrottled(h.viewHelper.viewDomNode,function(e){return h._onMouseMove(e)
},g(h.mouseTargetFactory),t.MOUSE_MOVE_MINIMUM_TIME)),h._register(p.onMouseUp(h.viewHelper.viewDomNode,function(e){return h._onMouseUp(e)})),h._register(p.onMouseLeave(h.viewHelper.viewDomNode,function(e){return h._onMouseLeave(e)})),h._register(p.onMouseDown(h.viewHelper.viewDomNode,function(e){return h._onMouseDown(e)}));return h._register(n.addDisposableListener(h.viewHelper.viewDomNode,i.isEdgeOrIE?"mousewheel":"wheel",function(e){if(h.viewController.emitMouseWheel(e),h._context.configuration.editor.viewInfo.mouseWheelZoom){var t=new o.StandardWheelEvent(e);if(t.browserEvent.ctrlKey||t.browserEvent.metaKey){var i=c.EditorZoom.getZoomLevel(),n=t.deltaY>0?1:-1;c.EditorZoom.setZoomLevel(i+n),t.preventDefault(),t.stopPropagation()}}},!0)),h._context.addEventHandler(h),h}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),e.prototype.dispose.call(this)},t.prototype.onCursorStateChanged=function(e){return this._mouseDownOperation.onCursorStateChanged(e),!1},
t.prototype.onFocusChanged=function(e){return this._isFocused=e.isFocused,!1},t.prototype.onScrollChanged=function(e){return this._mouseDownOperation.onScrollChanged(),!1},t.prototype.getTargetAtClientPoint=function(e,t){var i=new d.ClientCoordinates(e,t).toPageCoordinates(),n=d.createEditorPagePosition(this.viewHelper.viewDomNode);if(i.y<n.y||i.y>n.y+n.height||i.x<n.x||i.x>n.x+n.width)return null;var o=this.viewHelper.getLastViewCursorsRenderData();return this.mouseTargetFactory.createMouseTarget(o,n,i,null)},t.prototype._createMouseTarget=function(e,t){var i=this.viewHelper.getLastViewCursorsRenderData();return this.mouseTargetFactory.createMouseTarget(i,e.editorPos,e.pos,t?e.target:null)},t.prototype._getMouseColumn=function(e){return this.mouseTargetFactory.getMouseColumn(e.editorPos,e.pos)},t.prototype._onContextMenu=function(e,t){this.viewController.emitContextMenu({event:e,target:this._createMouseTarget(e,t)})},t.prototype._onMouseMove=function(e){if(!this._mouseDownOperation.isActive()){
e.timestamp<this.lastMouseLeaveTime||this.viewController.emitMouseMove({event:e,target:this._createMouseTarget(e,!0)})}},t.prototype._onMouseLeave=function(e){this.lastMouseLeaveTime=(new Date).getTime(),this.viewController.emitMouseLeave({event:e,target:null})},t.prototype._onMouseUp=function(e){this.viewController.emitMouseUp({event:e,target:this._createMouseTarget(e,!0)})},t.prototype._onMouseDown=function(e){var t=this,n=this._createMouseTarget(e,!0),o=6===n.type||7===n.type,r=2===n.type||3===n.type||4===n.type,s=3===n.type,a=this._context.configuration.editor.viewInfo.selectOnLineNumbers,u=8===n.type||5===n.type,d=9===n.type,c=e.leftButton||e.middleButton;l.isMacintosh&&e.leftButton&&e.ctrlKey&&(c=!1);var h=function(){i.isIE&&!t._isFocused?t._asyncFocus.schedule():(e.preventDefault(),t.viewHelper.focusTextArea())};if(c&&(o||s&&a))h(),this._mouseDownOperation.start(n.type,e);else if(r)e.preventDefault();else if(u){var p=n.detail;this.viewHelper.shouldSuppressMouseDownOnViewZone(p.viewZoneId)&&(h(),
this._mouseDownOperation.start(n.type,e),e.preventDefault())}else d&&this.viewHelper.shouldSuppressMouseDownOnWidget(n.detail)&&(h(),e.preventDefault());this.viewController.emitMouseDown({event:e,target:n})},t.MOUSE_MOVE_MINIMUM_TIME=100,t}(f.ViewEventHandler);t.MouseHandler=m;var v=function(e){function t(t,i,n,o,r){var a=e.call(this)||this;return a._context=t,a._viewController=i,a._viewHelper=n,a._createMouseTarget=o,a._getMouseColumn=r,a._mouseMoveMonitor=a._register(new d.GlobalEditorMouseMoveMonitor(a._viewHelper.viewDomNode)),a._onScrollTimeout=a._register(new s.TimeoutTimer),a._mouseState=new _,a._currentSelection=new p.Selection(1,1,1,1),a._isActive=!1,a._lastMouseEvent=null,a}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.isActive=function(){return this._isActive},t.prototype._onMouseDownThenMove=function(e){this._lastMouseEvent=e,this._mouseState.setModifiers(e);var t=this._findMousePosition(e,!0)
;t&&(this._mouseState.isDragAndDrop?this._viewController.emitMouseDrag({event:e,target:t}):this._dispatchMouse(t,!0))},t.prototype.start=function(e,t){var i=this;this._lastMouseEvent=t,this._mouseState.setStartedOnLineNumbers(3===e),this._mouseState.setStartButtons(t),this._mouseState.setModifiers(t);var n=this._findMousePosition(t,!0);if(n&&n.position){if(this._mouseState.trySetCount(t.detail,n.position),t.detail=this._mouseState.count,!this._context.configuration.editor.readOnly&&this._context.configuration.editor.dragAndDrop&&!this._mouseState.altKey&&t.detail<2&&!this._isActive&&!this._currentSelection.isEmpty()&&6===n.type&&n.position&&this._currentSelection.containsPosition(n.position))return this._mouseState.isDragAndDrop=!0,this._isActive=!0,void this._mouseMoveMonitor.startMonitoring(g(null),function(e){return i._onMouseDownThenMove(e)},function(){var e=i._findMousePosition(i._lastMouseEvent,!0);i._viewController.emitMouseDrop({event:i._lastMouseEvent,
target:e?i._createMouseTarget(i._lastMouseEvent,!0):null}),i._stop()});this._mouseState.isDragAndDrop=!1,this._dispatchMouse(n,t.shiftKey),this._isActive||(this._isActive=!0,this._mouseMoveMonitor.startMonitoring(g(null),function(e){return i._onMouseDownThenMove(e)},function(){return i._stop()}))}},t.prototype._stop=function(){this._isActive=!1,this._onScrollTimeout.cancel()},t.prototype.onScrollChanged=function(){var e=this;this._isActive&&this._onScrollTimeout.setIfNotSet(function(){if(e._lastMouseEvent){var t=e._findMousePosition(e._lastMouseEvent,!1);t&&(e._mouseState.isDragAndDrop||e._dispatchMouse(t,!0))}},10)},t.prototype.onCursorStateChanged=function(e){this._currentSelection=e.selections[0]},t.prototype._getPositionOutsideEditor=function(e){var t=e.editorPos,i=this._context.model,n=this._context.viewLayout,o=this._getMouseColumn(e);if(e.posy<t.y){s=Math.max(n.getCurrentScrollTop()-(t.y-e.posy),0);if(a=u.HitTestContext.getZoneAtCoord(this._context,s)){
if(l=this._helpPositionJumpOverViewZone(a))return new u.MouseTarget(null,13,o,l)}var r=n.getLineNumberAtVerticalOffset(s);return new u.MouseTarget(null,13,o,new h.Position(r,1))}if(e.posy>t.y+t.height){var s=n.getCurrentScrollTop()+(e.posy-t.y),a=u.HitTestContext.getZoneAtCoord(this._context,s);if(a){var l=this._helpPositionJumpOverViewZone(a);if(l)return new u.MouseTarget(null,13,o,l)}var d=n.getLineNumberAtVerticalOffset(s);return new u.MouseTarget(null,13,o,new h.Position(d,i.getLineMaxColumn(d)))}var c=n.getLineNumberAtVerticalOffset(n.getCurrentScrollTop()+(e.posy-t.y));return e.posx<t.x?new u.MouseTarget(null,13,o,new h.Position(c,1)):e.posx>t.x+t.width?new u.MouseTarget(null,13,o,new h.Position(c,i.getLineMaxColumn(c))):null},t.prototype._findMousePosition=function(e,t){var i=this._getPositionOutsideEditor(e);if(i)return i;var n=this._createMouseTarget(e,t);if(!n.position)return null;if(8===n.type||5===n.type){var o=this._helpPositionJumpOverViewZone(n.detail)
;if(o)return new u.MouseTarget(n.element,n.type,n.mouseColumn,o,null,n.detail)}return n},t.prototype._helpPositionJumpOverViewZone=function(e){var t=new h.Position(this._currentSelection.selectionStartLineNumber,this._currentSelection.selectionStartColumn),i=e.positionBefore,n=e.positionAfter;return i&&n?i.isBefore(t)?i:n:null},t.prototype._dispatchMouse=function(e,t){e.position&&this._viewController.dispatchMouse({position:e.position,mouseColumn:e.mouseColumn,startedOnLineNumbers:this._mouseState.startedOnLineNumbers,inSelectionMode:t,mouseDownCount:this._mouseState.count,altKey:this._mouseState.altKey,ctrlKey:this._mouseState.ctrlKey,metaKey:this._mouseState.metaKey,shiftKey:this._mouseState.shiftKey,leftButton:this._mouseState.leftButton,middleButton:this._mouseState.middleButton})},t}(a.Disposable),_=function(){function e(){this._altKey=!1,this._ctrlKey=!1,this._metaKey=!1,this._shiftKey=!1,this._leftButton=!1,this._middleButton=!1,this._startedOnLineNumbers=!1,this._lastMouseDownPosition=null,
this._lastMouseDownPositionEqualCount=0,this._lastMouseDownCount=0,this._lastSetMouseDownCountTime=0,this.isDragAndDrop=!1}return Object.defineProperty(e.prototype,"altKey",{get:function(){return this._altKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"ctrlKey",{get:function(){return this._ctrlKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"metaKey",{get:function(){return this._metaKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"shiftKey",{get:function(){return this._shiftKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"leftButton",{get:function(){return this._leftButton},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"middleButton",{get:function(){return this._middleButton},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"startedOnLineNumbers",{get:function(){return this._startedOnLineNumbers},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"count",{
get:function(){return this._lastMouseDownCount},enumerable:!0,configurable:!0}),e.prototype.setModifiers=function(e){this._altKey=e.altKey,this._ctrlKey=e.ctrlKey,this._metaKey=e.metaKey,this._shiftKey=e.shiftKey},e.prototype.setStartButtons=function(e){this._leftButton=e.leftButton,this._middleButton=e.middleButton},e.prototype.setStartedOnLineNumbers=function(e){this._startedOnLineNumbers=e},e.prototype.trySetCount=function(t,i){var n=(new Date).getTime();n-this._lastSetMouseDownCountTime>e.CLEAR_MOUSE_DOWN_COUNT_TIME&&(t=1),this._lastSetMouseDownCountTime=n,t>this._lastMouseDownCount+1&&(t=this._lastMouseDownCount+1),this._lastMouseDownPosition&&this._lastMouseDownPosition.equals(i)?this._lastMouseDownPositionEqualCount++:this._lastMouseDownPositionEqualCount=1,this._lastMouseDownPosition=i,this._lastMouseDownCount=Math.min(t,this._lastMouseDownPositionEqualCount)},e.CLEAR_MOUSE_DOWN_COUNT_TIME=400,e}()}),define(t[522],i([1,0,8,79,2,521,162]),function(e,t,i,n,o,s,a){"use strict";function l(e,t){var i={
translationY:t.translationY,translationX:t.translationX};return e&&(i.translationY+=e.translationY,i.translationX+=e.translationX),i}Object.defineProperty(t,"__esModule",{value:!0});var u=function(e){function t(t,n,o){var r=e.call(this,t,n,o)||this;return r.viewHelper.linesContentDomNode.style.msTouchAction="none",r.viewHelper.linesContentDomNode.style.msContentZooming="none",r._installGestureHandlerTimeout=window.setTimeout(function(){if(r._installGestureHandlerTimeout=-1,window.MSGesture){var e=new MSGesture,t=new MSGesture;e.target=r.viewHelper.linesContentDomNode,t.target=r.viewHelper.linesContentDomNode,r.viewHelper.linesContentDomNode.addEventListener("MSPointerDown",function(i){var n=i.pointerType;n!==(i.MSPOINTER_TYPE_MOUSE||"mouse")?n===(i.MSPOINTER_TYPE_TOUCH||"touch")?(r._lastPointerType="touch",e.addPointer(i.pointerId)):(r._lastPointerType="pen",t.addPointer(i.pointerId)):r._lastPointerType="mouse"}),
r._register(i.addDisposableThrottledListener(r.viewHelper.linesContentDomNode,"MSGestureChange",function(e){return r._onGestureChange(e)},l)),r._register(i.addDisposableListener(r.viewHelper.linesContentDomNode,"MSGestureTap",function(e){return r._onCaptureGestureTap(e)},!0))}},100),r._lastPointerType="mouse",r}return r(t,e),t.prototype._onMouseDown=function(t){"mouse"===this._lastPointerType&&e.prototype._onMouseDown.call(this,t)},t.prototype._onCaptureGestureTap=function(e){var t=this,i=new a.EditorMouseEvent(e,this.viewHelper.viewDomNode),n=this._createMouseTarget(i,!1);n.position&&this.viewController.moveTo(n.position),i.browserEvent.fromElement?(i.preventDefault(),this.viewHelper.focusTextArea()):setTimeout(function(){t.viewHelper.focusTextArea()})},t.prototype._onGestureChange=function(e){this._context.viewLayout.deltaScrollNow(-e.translationX,-e.translationY)},t.prototype.dispose=function(){window.clearTimeout(this._installGestureHandlerTimeout),e.prototype.dispose.call(this)},t
}(s.MouseHandler),d=function(e){function t(t,n,o){var r=e.call(this,t,n,o)||this;return r.viewHelper.linesContentDomNode.style.touchAction="none",r._installGestureHandlerTimeout=window.setTimeout(function(){if(r._installGestureHandlerTimeout=-1,window.MSGesture){var e=new MSGesture,t=new MSGesture;e.target=r.viewHelper.linesContentDomNode,t.target=r.viewHelper.linesContentDomNode,r.viewHelper.linesContentDomNode.addEventListener("pointerdown",function(i){var n=i.pointerType;"mouse"!==n?"touch"===n?(r._lastPointerType="touch",e.addPointer(i.pointerId)):(r._lastPointerType="pen",t.addPointer(i.pointerId)):r._lastPointerType="mouse"}),r._register(i.addDisposableThrottledListener(r.viewHelper.linesContentDomNode,"MSGestureChange",function(e){return r._onGestureChange(e)},l)),r._register(i.addDisposableListener(r.viewHelper.linesContentDomNode,"MSGestureTap",function(e){return r._onCaptureGestureTap(e)},!0))}},100),r._lastPointerType="mouse",r}return r(t,e),t.prototype._onMouseDown=function(t){
"mouse"===this._lastPointerType&&e.prototype._onMouseDown.call(this,t)},t.prototype._onCaptureGestureTap=function(e){var t=this,i=new a.EditorMouseEvent(e,this.viewHelper.viewDomNode),n=this._createMouseTarget(i,!1);n.position&&this.viewController.moveTo(n.position),i.browserEvent.fromElement?(i.preventDefault(),this.viewHelper.focusTextArea()):setTimeout(function(){t.viewHelper.focusTextArea()})},t.prototype._onGestureChange=function(e){this._context.viewLayout.deltaScrollNow(-e.translationX,-e.translationY)},t.prototype.dispose=function(){window.clearTimeout(this._installGestureHandlerTimeout),e.prototype.dispose.call(this)},t}(s.MouseHandler),c=function(e){function t(t,o,r){var s=e.call(this,t,o,r)||this;return n.Gesture.addTarget(s.viewHelper.linesContentDomNode),s._register(i.addDisposableListener(s.viewHelper.linesContentDomNode,n.EventType.Tap,function(e){return s.onTap(e)})),s._register(i.addDisposableListener(s.viewHelper.linesContentDomNode,n.EventType.Change,function(e){return s.onChange(e)})),
s._register(i.addDisposableListener(s.viewHelper.linesContentDomNode,n.EventType.Contextmenu,function(e){return s._onContextMenu(new a.EditorMouseEvent(e,s.viewHelper.viewDomNode),!1)})),s}return r(t,e),t.prototype.onTap=function(e){e.preventDefault(),this.viewHelper.focusTextArea();var t=this._createMouseTarget(new a.EditorMouseEvent(e,this.viewHelper.viewDomNode),!1);t.position&&this.viewController.moveTo(t.position)},t.prototype.onChange=function(e){this._context.viewLayout.deltaScrollNow(-e.translationX,-e.translationY)},t}(s.MouseHandler),h=function(e){function t(t,i,n){var o=e.call(this)||this;return window.navigator.msPointerEnabled?o.handler=o._register(new u(t,i,n)):window.TouchEvent?o.handler=o._register(new c(t,i,n)):window.navigator.pointerEnabled||window.PointerEvent?o.handler=o._register(new d(t,i,n)):o.handler=o._register(new s.MouseHandler(t,i,n)),o}return r(t,e),t.prototype.getTargetAtClientPoint=function(e,t){return this.handler.getTargetAtClientPoint(e,t)},t}(o.Disposable)
;t.PointerHandler=h}),define(t[523],i([1,0,2,217]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var o=function(e){function t(t){var i=e.call(this)||this;return i.onDidScroll=null,i.onDidGainFocus=null,i.onDidLoseFocus=null,i.onKeyDown=null,i.onKeyUp=null,i.onContextMenu=null,i.onMouseMove=null,i.onMouseLeave=null,i.onMouseUp=null,i.onMouseDown=null,i.onMouseDrag=null,i.onMouseDrop=null,i.onMouseWheel=null,i._viewModel=t,i}return r(t,e),t.prototype.emitScrollChanged=function(e){this.onDidScroll&&this.onDidScroll(e)},t.prototype.emitViewFocusGained=function(){this.onDidGainFocus&&this.onDidGainFocus(void 0)},t.prototype.emitViewFocusLost=function(){this.onDidLoseFocus&&this.onDidLoseFocus(void 0)},t.prototype.emitKeyDown=function(e){this.onKeyDown&&this.onKeyDown(e)},t.prototype.emitKeyUp=function(e){this.onKeyUp&&this.onKeyUp(e)},t.prototype.emitContextMenu=function(e){this.onContextMenu&&this.onContextMenu(this._convertViewToModelMouseEvent(e))},
t.prototype.emitMouseMove=function(e){this.onMouseMove&&this.onMouseMove(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseLeave=function(e){this.onMouseLeave&&this.onMouseLeave(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseUp=function(e){this.onMouseUp&&this.onMouseUp(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseDown=function(e){this.onMouseDown&&this.onMouseDown(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseDrag=function(e){this.onMouseDrag&&this.onMouseDrag(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseDrop=function(e){this.onMouseDrop&&this.onMouseDrop(this._convertViewToModelMouseEvent(e))},t.prototype.emitMouseWheel=function(e){this.onMouseWheel&&this.onMouseWheel(e)},t.prototype._convertViewToModelMouseEvent=function(e){return e.target?{event:e.event,target:this._convertViewToModelMouseTarget(e.target)}:e},t.prototype._convertViewToModelMouseTarget=function(e){
return new s(e.element,e.type,e.mouseColumn,e.position?this._convertViewToModelPosition(e.position):null,e.range?this._convertViewToModelRange(e.range):null,e.detail)},t.prototype._convertViewToModelPosition=function(e){return this._viewModel.coordinatesConverter.convertViewPositionToModelPosition(e)},t.prototype._convertViewToModelRange=function(e){return this._viewModel.coordinatesConverter.convertViewRangeToModelRange(e)},t}(i.Disposable);t.ViewOutgoingEvents=o;var s=function(){function e(e,t,i,n,o,r){this.element=e,this.type=t,this.mouseColumn=i,this.position=n,this.range=o,this.detail=r}return e.prototype.toString=function(){return n.MouseTarget.toString(this)},e}()}),define(t[524],i([1,0,15,65,155,35,216,13,3,88,303]),function(e,t,i,n,o,s,a,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(){this._currentVisibleRange=new u.Range(1,1,1,1)}return e.prototype.getCurrentVisibleRange=function(){return this._currentVisibleRange},
e.prototype.setCurrentVisibleRange=function(e){this._currentVisibleRange=e},e}(),h=function(){return function(e,t,i,n,o,r){this.lineNumber=e,this.startColumn=t,this.endColumn=i,this.startScrollTop=n,this.stopScrollTop=o,this.scrollType=r}}(),p=function(e){function t(t,r){var l=e.call(this,t)||this;l._linesContent=r,l._textRangeRestingSpot=document.createElement("div"),l._visibleLines=new o.VisibleLinesCollection(l),l.domNode=l._visibleLines.domNode;var u=l._context.configuration;return l._lineHeight=u.editor.lineHeight,l._typicalHalfwidthCharacterWidth=u.editor.fontInfo.typicalHalfwidthCharacterWidth,l._isViewportWrapping=u.editor.wrappingInfo.isViewportWrapping,l._revealHorizontalRightPadding=u.editor.viewInfo.revealHorizontalRightPadding,l._scrollOff=u.editor.viewInfo.cursorSurroundingLines,l._canUseLayerHinting=u.editor.canUseLayerHinting,l._viewLineOptions=new a.ViewLineOptions(u,l._context.theme.type),s.PartFingerprints.write(l.domNode,7),l.domNode.setClassName("view-lines"),
n.Configuration.applyFontInfo(l.domNode,u.editor.fontInfo),l._maxLineWidth=0,l._asyncUpdateLineWidths=new i.RunOnceScheduler(function(){l._updateLineWidthsSlow()},200),l._lastRenderedData=new c,l._horizontalRevealRequest=null,l}return r(t,e),t.prototype.dispose=function(){this._asyncUpdateLineWidths.dispose(),e.prototype.dispose.call(this)},t.prototype.getDomNode=function(){return this.domNode},t.prototype.createVisibleLine=function(){return new a.ViewLine(this._viewLineOptions)},t.prototype.onConfigurationChanged=function(e){this._visibleLines.onConfigurationChanged(e),e.wrappingInfo&&(this._maxLineWidth=0);var t=this._context.configuration;return e.lineHeight&&(this._lineHeight=t.editor.lineHeight),e.fontInfo&&(this._typicalHalfwidthCharacterWidth=t.editor.fontInfo.typicalHalfwidthCharacterWidth),e.wrappingInfo&&(this._isViewportWrapping=t.editor.wrappingInfo.isViewportWrapping),e.viewInfo&&(this._revealHorizontalRightPadding=t.editor.viewInfo.revealHorizontalRightPadding,
this._scrollOff=t.editor.viewInfo.cursorSurroundingLines),e.canUseLayerHinting&&(this._canUseLayerHinting=t.editor.canUseLayerHinting),e.fontInfo&&n.Configuration.applyFontInfo(this.domNode,t.editor.fontInfo),this._onOptionsMaybeChanged(),e.layoutInfo&&(this._maxLineWidth=0),!0},t.prototype._onOptionsMaybeChanged=function(){var e=this._context.configuration,t=new a.ViewLineOptions(e,this._context.theme.type);if(!this._viewLineOptions.equals(t)){this._viewLineOptions=t;for(var i=this._visibleLines.getStartLineNumber(),n=this._visibleLines.getEndLineNumber(),o=i;o<=n;o++){this._visibleLines.getVisibleLine(o).onOptionsChanged(this._viewLineOptions)}return!0}return!1},t.prototype.onCursorStateChanged=function(e){for(var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber(),n=!1,o=t;o<=i;o++)n=this._visibleLines.getVisibleLine(o).onSelectionChanged()||n;return n},t.prototype.onDecorationsChanged=function(e){
for(var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber(),n=t;n<=i;n++)this._visibleLines.getVisibleLine(n).onDecorationsChanged();return!0},t.prototype.onFlushed=function(e){var t=this._visibleLines.onFlushed(e);return this._maxLineWidth=0,t},t.prototype.onLinesChanged=function(e){return this._visibleLines.onLinesChanged(e)},t.prototype.onLinesDeleted=function(e){return this._visibleLines.onLinesDeleted(e)},t.prototype.onLinesInserted=function(e){return this._visibleLines.onLinesInserted(e)},t.prototype.onRevealRangeRequest=function(e){var t=this._computeScrollTopToRevealRange(this._context.viewLayout.getFutureViewport(),e.range,e.verticalType),i=this._context.viewLayout.validateScrollPosition({scrollTop:t});e.revealHorizontal?e.range.startLineNumber!==e.range.endLineNumber?i={scrollTop:i.scrollTop,scrollLeft:0
}:this._horizontalRevealRequest=new h(e.range.startLineNumber,e.range.startColumn,e.range.endColumn,this._context.viewLayout.getCurrentScrollTop(),i.scrollTop,e.scrollType):this._horizontalRevealRequest=null;var n=Math.abs(this._context.viewLayout.getCurrentScrollTop()-i.scrollTop);return 0===e.scrollType&&n>this._lineHeight?this._context.viewLayout.setScrollPositionSmooth(i):this._context.viewLayout.setScrollPositionNow(i),!0},t.prototype.onScrollChanged=function(e){if(this._horizontalRevealRequest&&e.scrollLeftChanged&&(this._horizontalRevealRequest=null),this._horizontalRevealRequest&&e.scrollTopChanged){var t=Math.min(this._horizontalRevealRequest.startScrollTop,this._horizontalRevealRequest.stopScrollTop),i=Math.max(this._horizontalRevealRequest.startScrollTop,this._horizontalRevealRequest.stopScrollTop);(e.scrollTop<t||e.scrollTop>i)&&(this._horizontalRevealRequest=null)}return this.domNode.setWidth(e.scrollWidth),this._visibleLines.onScrollChanged(e)||!0},t.prototype.onTokensChanged=function(e){
return this._visibleLines.onTokensChanged(e)},t.prototype.onZonesChanged=function(e){return this._context.viewLayout.onMaxLineWidthChanged(this._maxLineWidth),this._visibleLines.onZonesChanged(e)},t.prototype.onThemeChanged=function(e){return this._onOptionsMaybeChanged()},t.prototype.getPositionFromDOMInfo=function(e,t){var i=this._getViewLineDomNode(e);if(null===i)return null;var n=this._getLineNumberFor(i);if(-1===n)return null;if(n<1||n>this._context.model.getLineCount())return null;if(1===this._context.model.getLineMaxColumn(n))return new l.Position(n,1);var o=this._visibleLines.getStartLineNumber(),r=this._visibleLines.getEndLineNumber();if(n<o||n>r)return null;var s=this._visibleLines.getVisibleLine(n).getColumnOfNodeOffset(n,e,t),a=this._context.model.getLineMinColumn(n);return s<a&&(s=a),new l.Position(n,s)},t.prototype._getViewLineDomNode=function(e){for(;e&&1===e.nodeType;){if(e.className===a.ViewLine.CLASS_NAME)return e;e=e.parentElement}return null},t.prototype._getLineNumberFor=function(e){
for(var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber(),n=t;n<=i;n++){if(e===this._visibleLines.getVisibleLine(n).getDomNode())return n}return-1},t.prototype.getLineWidth=function(e){var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber();return e<t||e>i?-1:this._visibleLines.getVisibleLine(e).getWidth()},t.prototype.linesVisibleRangesForRange=function(e,t){if(this.shouldRender())return null;var i=e.endLineNumber,n=u.Range.intersectRanges(e,this._lastRenderedData.getCurrentVisibleRange());if(!n)return null;var o=[],r=0,s=new a.DomReadingContext(this.domNode.domNode,this._textRangeRestingSpot),c=0;t&&(c=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new l.Position(n.startLineNumber,1)).lineNumber);for(var h=this._visibleLines.getStartLineNumber(),p=this._visibleLines.getEndLineNumber(),f=n.startLineNumber;f<=n.endLineNumber;f++)if(!(f<h||f>p)){
var g=f===n.startLineNumber?n.startColumn:1,m=f===n.endLineNumber?n.endColumn:this._context.model.getLineMaxColumn(f),v=this._visibleLines.getVisibleLine(f).getVisibleRangesForRange(g,m,s);if(v&&0!==v.length){if(t&&f<i){c!==(c=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new l.Position(f+1,1)).lineNumber)&&(v[v.length-1].width+=this._typicalHalfwidthCharacterWidth)}o[r++]=new d.LineVisibleRanges(f,v)}}return 0===r?null:o},t.prototype.visibleRangesForRange2=function(e){if(this.shouldRender())return null;var t=u.Range.intersectRanges(e,this._lastRenderedData.getCurrentVisibleRange());if(!t)return null;for(var i=[],n=new a.DomReadingContext(this.domNode.domNode,this._textRangeRestingSpot),o=this._visibleLines.getStartLineNumber(),r=this._visibleLines.getEndLineNumber(),s=t.startLineNumber;s<=t.endLineNumber;s++)if(!(s<o||s>r)){
var l=s===t.startLineNumber?t.startColumn:1,d=s===t.endLineNumber?t.endColumn:this._context.model.getLineMaxColumn(s),c=this._visibleLines.getVisibleLine(s).getVisibleRangesForRange(l,d,n);c&&0!==c.length&&(i=i.concat(c))}return 0===i.length?null:i},t.prototype.visibleRangeForPosition=function(e){var t=this.visibleRangesForRange2(new u.Range(e.lineNumber,e.column,e.lineNumber,e.column));return t?t[0]:null},t.prototype.updateLineWidths=function(){this._updateLineWidths(!1)},t.prototype._updateLineWidthsFast=function(){return this._updateLineWidths(!0)},t.prototype._updateLineWidthsSlow=function(){this._updateLineWidths(!1)},t.prototype._updateLineWidths=function(e){for(var t=this._visibleLines.getStartLineNumber(),i=this._visibleLines.getEndLineNumber(),n=1,o=!0,r=t;r<=i;r++){var s=this._visibleLines.getVisibleLine(r);!e||s.getWidthIsFast()?n=Math.max(n,s.getWidth()):o=!1}return o&&1===t&&i===this._context.model.getLineCount()&&(this._maxLineWidth=0),this._ensureMaxLineWidth(n),o},
t.prototype.prepareRender=function(){throw new Error("Not supported")},t.prototype.render=function(){throw new Error("Not supported")},t.prototype.renderText=function(e){if(this._visibleLines.renderLines(e),this._lastRenderedData.setCurrentVisibleRange(e.visibleRange),this.domNode.setWidth(this._context.viewLayout.getScrollWidth()),this.domNode.setHeight(Math.min(this._context.viewLayout.getScrollHeight(),1e6)),this._horizontalRevealRequest){var t=this._horizontalRevealRequest.lineNumber,i=this._horizontalRevealRequest.startColumn,n=this._horizontalRevealRequest.endColumn,o=this._horizontalRevealRequest.scrollType;if(e.startLineNumber<=t&&t<=e.endLineNumber){this._horizontalRevealRequest=null,this.onDidRender();var r=this._computeScrollLeftToRevealRange(t,i,n);this._isViewportWrapping||this._ensureMaxLineWidth(r.maxHorizontalOffset),0===o?this._context.viewLayout.setScrollPositionSmooth({scrollLeft:r.scrollLeft}):this._context.viewLayout.setScrollPositionNow({scrollLeft:r.scrollLeft})}}
this._updateLineWidthsFast()||this._asyncUpdateLineWidths.schedule(),this._linesContent.setLayerHinting(this._canUseLayerHinting);var s=this._context.viewLayout.getCurrentScrollTop()-e.bigNumbersDelta;this._linesContent.setTop(-s),this._linesContent.setLeft(-this._context.viewLayout.getCurrentScrollLeft())},t.prototype._ensureMaxLineWidth=function(e){var t=Math.ceil(e);this._maxLineWidth<t&&(this._maxLineWidth=t,this._context.viewLayout.onMaxLineWidthChanged(this._maxLineWidth))},t.prototype._computeScrollTopToRevealRange=function(e,t,i){var n,o,r=e.top,s=e.height,a=r+s;n=this._context.viewLayout.getVerticalOffsetForLineNumber(t.startLineNumber),o=this._context.viewLayout.getVerticalOffsetForLineNumber(t.endLineNumber)+this._lineHeight;var l=Math.min(s/this._lineHeight/2,this._scrollOff);n-=l*this._lineHeight,o+=Math.max(0,l-1)*this._lineHeight,0!==i&&4!==i||(o+=this._lineHeight);var u;if(1===i||2===i)if(2===i&&r<=n&&o<=a)u=r;else{var d=(n+o)/2;u=Math.max(0,d-s/2)
}else u=this._computeMinimumScrolling(r,a,n,o,3===i,4===i);return u},t.prototype._computeScrollLeftToRevealRange=function(e,i,n){var o=0,r=this._context.viewLayout.getCurrentViewport(),s=r.left,a=s+r.width,l=this.visibleRangesForRange2(new u.Range(e,i,e,n)),d=Number.MAX_VALUE,c=0;if(!l)return{scrollLeft:s,maxHorizontalOffset:o};for(var h=0,p=l;h<p.length;h++){var f=p[h];f.left<d&&(d=f.left),f.left+f.width>c&&(c=f.left+f.width)}o=c,d=Math.max(0,d-t.HORIZONTAL_EXTRA_PX),c+=this._revealHorizontalRightPadding;return{scrollLeft:this._computeMinimumScrolling(s,a,d,c),maxHorizontalOffset:o}},t.prototype._computeMinimumScrolling=function(e,t,i,n,o,r){o=!!o,r=!!r;var s=(t|=0)-(e|=0);return(n|=0)-(i|=0)<s?o?i:r?Math.max(0,n-s):i<e?i:n>t?Math.max(0,n-s):e:i},t.HORIZONTAL_EXTRA_PX=30,t}(s.ViewPart);t.ViewLines=p}),define(t[525],i([1,0,8,27,82,18,5,155,35,3,139,405,77,22,16,289]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g){"use strict";function m(e){return 2===e?4:4===e?6:1===e?2:3}function v(e){return 2===e?2:4===e?2:1}
Object.defineProperty(t,"__esModule",{value:!0});var _=140,y=function(){function e(e){var t=e.editor.pixelRatio,i=e.editor.layoutInfo,n=e.editor.viewInfo,o=e.editor.fontInfo;this.renderMinimap=0|i.renderMinimap,this.scrollBeyondLastLine=n.scrollBeyondLastLine,this.showSlider=n.minimap.showSlider,this.pixelRatio=t,this.typicalHalfwidthCharacterWidth=o.typicalHalfwidthCharacterWidth,this.lineHeight=e.editor.lineHeight,this.minimapLeft=i.minimapLeft,this.minimapWidth=i.minimapWidth,this.minimapHeight=i.height,this.canvasInnerWidth=Math.max(1,Math.floor(t*this.minimapWidth)),this.canvasInnerHeight=Math.max(1,Math.floor(t*this.minimapHeight)),this.canvasOuterWidth=this.canvasInnerWidth/t,this.canvasOuterHeight=this.canvasInnerHeight/t}return e.prototype.equals=function(e){
return this.renderMinimap===e.renderMinimap&&this.scrollBeyondLastLine===e.scrollBeyondLastLine&&this.showSlider===e.showSlider&&this.pixelRatio===e.pixelRatio&&this.typicalHalfwidthCharacterWidth===e.typicalHalfwidthCharacterWidth&&this.lineHeight===e.lineHeight&&this.minimapLeft===e.minimapLeft&&this.minimapWidth===e.minimapWidth&&this.minimapHeight===e.minimapHeight&&this.canvasInnerWidth===e.canvasInnerWidth&&this.canvasInnerHeight===e.canvasInnerHeight&&this.canvasOuterWidth===e.canvasOuterWidth&&this.canvasOuterHeight===e.canvasOuterHeight},e}(),b=function(){function e(e,t,i,n,o,r,s){this.scrollTop=e,this.scrollHeight=t,this._computedSliderRatio=i,this.sliderTop=n,this.sliderHeight=o,this.startLineNumber=r,this.endLineNumber=s}return e.prototype.getDesiredScrollTopFromDelta=function(e){var t=this.sliderTop+e;return Math.round(t/this._computedSliderRatio)},e.create=function(t,i,n,o,r,s,a,l,u){var d,c=t.pixelRatio,h=m(t.renderMinimap),p=Math.floor(t.canvasInnerHeight/h),f=t.lineHeight;if(r&&n!==s){
var g=n-i+1;d=Math.floor(g*h/c)}else{C=o/f;d=Math.floor(C*h/c)}var v;v=t.scrollBeyondLastLine?(s-1)*h/c:Math.max(0,s*h/c-d);var _=(v=Math.min(t.minimapHeight-d,v))/(l-o),y=a*_,b=0;if(t.scrollBeyondLastLine){var C;b=C=o/f}if(p>=s+b){return new e(a,l,_,y,d,S=1,w=s)}var S=Math.max(1,Math.floor(i-y*c/h));u&&u.scrollHeight===l&&(u.scrollTop>a&&(S=Math.min(S,u.startLineNumber)),u.scrollTop<a&&(S=Math.max(S,u.startLineNumber)));var w=Math.min(s,S+p-1);return new e(a,l,_,y,d,S,w)},e}(),C=function(){function e(e){this.dy=e}return e.prototype.onContentChanged=function(){this.dy=-1},e.prototype.onTokensChanged=function(){this.dy=-1},e.INVALID=new e(-1),e}(),S=function(){function e(e,t,i){this.renderedLayout=e,this._imageData=t,this._renderedLines=new l.RenderedLinesCollection(function(){return C.INVALID}),this._renderedLines._set(e.startLineNumber,i)}return e.prototype.linesEquals=function(e){if(!this.scrollEquals(e))return!1;for(var t=this._renderedLines._get().lines,i=0,n=t.length;i<n;i++)if(-1===t[i].dy)return!1
;return!0},e.prototype.scrollEquals=function(e){return this.renderedLayout.startLineNumber===e.startLineNumber&&this.renderedLayout.endLineNumber===e.endLineNumber},e.prototype._get=function(){var e=this._renderedLines._get();return{imageData:this._imageData,rendLineNumberStart:e.rendLineNumberStart,lines:e.lines}},e.prototype.onLinesChanged=function(e){return this._renderedLines.onLinesChanged(e.fromLineNumber,e.toLineNumber)},e.prototype.onLinesDeleted=function(e){this._renderedLines.onLinesDeleted(e.fromLineNumber,e.toLineNumber)},e.prototype.onLinesInserted=function(e){this._renderedLines.onLinesInserted(e.fromLineNumber,e.toLineNumber)},e.prototype.onTokensChanged=function(e){return this._renderedLines.onTokensChanged(e.ranges)},e}(),w=function(){function e(t,i,n,o){this._backgroundFillData=e._createBackgroundFillData(i,n,o),this._buffers=[t.createImageData(i,n),t.createImageData(i,n)],this._lastUsedBuffer=0}return e.prototype.getBuffer=function(){this._lastUsedBuffer=1-this._lastUsedBuffer
;var e=this._buffers[this._lastUsedBuffer];return e.data.set(this._backgroundFillData),e},e._createBackgroundFillData=function(e,t,i){for(var n=i.r,o=i.g,r=i.b,s=new Uint8ClampedArray(e*t*4),a=0,l=0;l<t;l++)for(var u=0;u<e;u++)s[a]=n,s[a+1]=o,s[a+2]=r,s[a+3]=255,a+=4;return s},e}(),E=function(e){function t(t){var r=e.call(this,t)||this;return r._renderDecorations=!1,r._options=new y(r._context.configuration),r._lastRenderData=null,r._buffers=null,r._domNode=n.createFastDomNode(document.createElement("div")),u.PartFingerprints.write(r._domNode,8),r._domNode.setClassName(r._getMinimapDomNodeClassName()),r._domNode.setPosition("absolute"),r._domNode.setAttribute("role","presentation"),r._domNode.setAttribute("aria-hidden","true"),r._shadow=n.createFastDomNode(document.createElement("div")),r._shadow.setClassName("minimap-shadow-hidden"),r._domNode.appendChild(r._shadow),r._canvas=n.createFastDomNode(document.createElement("canvas")),r._canvas.setPosition("absolute"),r._canvas.setLeft(0),
r._domNode.appendChild(r._canvas),r._decorationsCanvas=n.createFastDomNode(document.createElement("canvas")),r._decorationsCanvas.setPosition("absolute"),r._decorationsCanvas.setClassName("minimap-decorations-layer"),r._decorationsCanvas.setLeft(0),r._domNode.appendChild(r._decorationsCanvas),r._slider=n.createFastDomNode(document.createElement("div")),r._slider.setPosition("absolute"),r._slider.setClassName("minimap-slider"),r._slider.setLayerHinting(!0),r._domNode.appendChild(r._slider),r._sliderHorizontal=n.createFastDomNode(document.createElement("div")),r._sliderHorizontal.setPosition("absolute"),r._sliderHorizontal.setClassName("minimap-slider-horizontal"),r._slider.appendChild(r._sliderHorizontal),r._tokensColorTracker=c.MinimapTokensColorTracker.getInstance(),r._applyLayout(),r._mouseDownListener=i.addStandardDisposableListener(r._domNode.domNode,"mousedown",function(e){e.preventDefault();var t=r._options.renderMinimap;if(0!==t&&r._lastRenderData){
var i=m(t),n=r._options.pixelRatio*e.browserEvent.offsetY,o=Math.floor(n/i)+r._lastRenderData.renderedLayout.startLineNumber;o=Math.min(o,r._context.model.getLineCount()),r._context.privateViewEventBus.emit(new p.ViewRevealRangeRequestEvent(new d.Range(o,1,o,1),1,!1,0))}}),r._sliderMouseMoveMonitor=new o.GlobalMouseMoveMonitor,r._sliderMouseDownListener=i.addStandardDisposableListener(r._slider.domNode,"mousedown",function(e){if(e.preventDefault(),e.stopPropagation(),e.leftButton&&r._lastRenderData){var t=e.posy,i=e.posx,n=r._lastRenderData.renderedLayout;r._slider.toggleClassName("active",!0),r._sliderMouseMoveMonitor.startMonitoring(o.standardMouseMoveMerger,function(e){var o=Math.abs(e.posx-i);if(s.isWindows&&o>_)r._context.viewLayout.setScrollPositionNow({scrollTop:n.scrollTop});else{var a=e.posy-t;r._context.viewLayout.setScrollPositionNow({scrollTop:n.getDesiredScrollTopFromDelta(a)})}},function(){r._slider.toggleClassName("active",!1)})}}),r}return r(t,e),t.prototype.dispose=function(){
this._mouseDownListener.dispose(),this._sliderMouseMoveMonitor.dispose(),this._sliderMouseDownListener.dispose(),e.prototype.dispose.call(this)},t.prototype._getMinimapDomNodeClassName=function(){return"always"===this._options.showSlider?"minimap slider-always":"minimap slider-mouseover"},t.prototype.getDomNode=function(){return this._domNode},t.prototype._applyLayout=function(){this._domNode.setLeft(this._options.minimapLeft),this._domNode.setWidth(this._options.minimapWidth),this._domNode.setHeight(this._options.minimapHeight),this._shadow.setHeight(this._options.minimapHeight),this._canvas.setWidth(this._options.canvasOuterWidth),this._canvas.setHeight(this._options.canvasOuterHeight),this._canvas.domNode.width=this._options.canvasInnerWidth,this._canvas.domNode.height=this._options.canvasInnerHeight,this._decorationsCanvas.setWidth(this._options.canvasOuterWidth),this._decorationsCanvas.setHeight(this._options.canvasOuterHeight),this._decorationsCanvas.domNode.width=this._options.canvasInnerWidth,
this._decorationsCanvas.domNode.height=this._options.canvasInnerHeight,this._slider.setWidth(this._options.minimapWidth)},t.prototype._getBuffer=function(){return this._buffers||(this._buffers=new w(this._canvas.domNode.getContext("2d"),this._options.canvasInnerWidth,this._options.canvasInnerHeight,this._tokensColorTracker.getColor(2))),this._buffers.getBuffer()},t.prototype._onOptionsMaybeChanged=function(){var e=new y(this._context.configuration);return!this._options.equals(e)&&(this._options=e,this._lastRenderData=null,this._buffers=null,this._applyLayout(),this._domNode.setClassName(this._getMinimapDomNodeClassName()),!0)},t.prototype.onConfigurationChanged=function(e){return this._onOptionsMaybeChanged()},t.prototype.onFlushed=function(e){return this._lastRenderData=null,!0},t.prototype.onLinesChanged=function(e){return!!this._lastRenderData&&this._lastRenderData.onLinesChanged(e)},t.prototype.onLinesDeleted=function(e){return this._lastRenderData&&this._lastRenderData.onLinesDeleted(e),!0},
t.prototype.onLinesInserted=function(e){return this._lastRenderData&&this._lastRenderData.onLinesInserted(e),!0},t.prototype.onScrollChanged=function(e){return this._renderDecorations=!0,!0},t.prototype.onTokensChanged=function(e){return!!this._lastRenderData&&this._lastRenderData.onTokensChanged(e)},t.prototype.onTokensColorsChanged=function(e){return this._lastRenderData=null,this._buffers=null,!0},t.prototype.onZonesChanged=function(e){return this._lastRenderData=null,!0},t.prototype.onDecorationsChanged=function(e){return this._renderDecorations=!0,!0},t.prototype.onThemeChanged=function(e){return this._context.model.invalidateMinimapColorCache(),this._renderDecorations=!!this._lastDecorations,!!this._lastDecorations},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){if(0===this._options.renderMinimap)return this._shadow.setClassName("minimap-shadow-hidden"),this._sliderHorizontal.setWidth(0),void this._sliderHorizontal.setHeight(0)
;e.scrollLeft+e.viewportWidth>=e.scrollWidth?this._shadow.setClassName("minimap-shadow-hidden"):this._shadow.setClassName("minimap-shadow-visible");var t=b.create(this._options,e.visibleRange.startLineNumber,e.visibleRange.endLineNumber,e.viewportHeight,e.viewportData.whitespaceViewportData.length>0,this._context.model.getLineCount(),e.scrollTop,e.scrollHeight,this._lastRenderData?this._lastRenderData.renderedLayout:null);this._slider.setTop(t.sliderTop),this._slider.setHeight(t.sliderHeight);var i=e.scrollLeft/this._options.typicalHalfwidthCharacterWidth,n=Math.min(this._options.minimapWidth,Math.round(i*v(this._options.renderMinimap)/this._options.pixelRatio));this._sliderHorizontal.setLeft(n),this._sliderHorizontal.setWidth(this._options.minimapWidth-n),this._sliderHorizontal.setTop(0),this._sliderHorizontal.setHeight(t.sliderHeight),this.renderDecorations(t),this._lastRenderData=this.renderLines(t)},t.prototype.renderDecorations=function(e){if(this._renderDecorations){this._renderDecorations=!1
;var t=this._context.model.getDecorationsInViewport(new d.Range(e.startLineNumber,1,e.endLineNumber,this._context.model.getLineMaxColumn(e.endLineNumber))),i=this._options,n=i.renderMinimap,o=i.canvasInnerWidth,r=i.canvasInnerHeight,s=m(n),a=v(n),l=this._context.model.getOptions().tabSize,u=this._decorationsCanvas.domNode.getContext("2d");u.clearRect(0,0,o,r);for(var c=new Map,h=0;h<t.length;h++){var p=t[h];if(p.options.minimap)for(var f=p.range.startLineNumber;f<=p.range.endLineNumber;f++)this.renderDecorationOnLine(u,c,p,e,f,s,s,l,a)}this._lastDecorations=t}},t.prototype.renderDecorationOnLine=function(e,t,i,n,o,r,s,l,u){var d=(o-n.startLineNumber)*s,c=t.get(o),h=!c;if(!c){var p=this._context.model.getLineContent(o);c=[0];for(var f=1;f<p.length+1;f++){var g=p.charCodeAt(f-1),m=9===g?l*u:a.isFullWidthCharacter(g)?2*u:u;c[f]=c[f-1]+m}t.set(o,c)}var v=i.range,_=v.startColumn,y=v.endColumn,b=v.startLineNumber,C=v.endLineNumber,S=b===o?c[_-1]:0,w=C>o?c.length-1:y-1;if(w>0){var E=c[w]-S||2
;this.renderDecoration(e,i.options.minimap,S,d,E,r)}h&&this.renderLineHighlight(e,i.options.minimap,d,r)},t.prototype.renderLineHighlight=function(e,t,i,n){var o=t.getColor(this._context.theme);e.fillStyle=o&&o.transparent(.5).toString()||"",e.fillRect(0,i,e.canvas.width,n)},t.prototype.renderDecoration=function(e,t,i,n,o,r){var s=t.getColor(this._context.theme);e.fillStyle=s&&s.toString()||"",e.fillRect(i,n,o,r)},t.prototype.renderLines=function(e){var i=this._options.renderMinimap,n=e.startLineNumber,o=e.endLineNumber,r=m(i);if(this._lastRenderData&&this._lastRenderData.linesEquals(e)){var s=this._lastRenderData._get();return new S(e,s.imageData,s.lines)}
for(var a=this._getBuffer(),l=t._renderUntouchedLines(a,n,o,r,this._lastRenderData),u=l[0],d=l[1],c=l[2],p=this._context.model.getMinimapLinesRenderingData(n,o,c),f=p.tabSize,g=this._tokensColorTracker.getColor(2),v=this._tokensColorTracker.backgroundIsLight(),_=0,y=[],b=0,w=o-n+1;b<w;b++)c[b]&&t._renderLine(a,g,v,i,this._tokensColorTracker,h.getOrCreateMinimapCharRenderer(),_,f,p.data[b]),y[b]=new C(_),_+=r;var E=-1===u?0:u,L=(-1===d?a.height:d)-E;return this._canvas.domNode.getContext("2d").putImageData(a,0,0,0,E,a.width,L),new S(e,a,y)},t._renderUntouchedLines=function(e,t,i,n,o){var r=[];if(!o){for(var s=0,a=i-t+1;s<a;s++)r[s]=!0;return[-1,-1,r]}for(var l=o._get(),u=l.imageData.data,d=l.rendLineNumberStart,c=l.lines,h=c.length,p=e.width,f=e.data,g=(i-t+1)*n*p*4,m=-1,v=-1,_=-1,y=-1,b=-1,C=-1,S=0,w=t;w<=i;w++){var E=w-t,L=w-d,x=L>=0&&L<h?c[L].dy:-1;if(-1!==x){var D=x*p*4,I=(x+n)*p*4,N=S*p*4,M=(S+n)*p*4;y===D&&C===N?(y=I,C=M):(-1!==_&&(f.set(u.subarray(_,y),b),-1===m&&0===_&&_===b&&(m=y),
-1===v&&y===g&&_===b&&(v=_)),_=D,y=I,b=N,C=M),r[E]=!1,S+=n}else r[E]=!0,S+=n}-1!==_&&(f.set(u.subarray(_,y),b),-1===m&&0===_&&_===b&&(m=y),-1===v&&y===g&&_===b&&(v=_));return[-1===m?-1:m/(4*p),-1===v?-1:v/(4*p),r]},t._renderLine=function(e,t,i,n,o,r,s,l,u){for(var d=u.content,c=u.tokens,h=v(n),p=e.width-h,f=0,g=0,m=0,_=0,y=c.getCount();_<y;_++)for(var b=c.getEndOffset(_),C=c.getForeground(_),S=o.getColor(C);g<b;g++){if(f>p)return;var w=d.charCodeAt(g);if(9===w){var E=l-(g+m)%l;m+=E-1,f+=E*h}else if(32===w)f+=h;else for(var L=a.isFullWidthCharacter(w)?2:1,x=0;x<L;x++)if(2===n?r.x2RenderChar(e,f,s,w,S,t,i):1===n?r.x1RenderChar(e,f,s,w,S,t,i):4===n?r.x2BlockRenderChar(e,f,s,S,t,i):r.x1BlockRenderChar(e,f,s,S,t,i),(f+=h)>p)return}},t}(u.ViewPart);t.Minimap=E,g.registerThemingParticipant(function(e,t){var i=e.getColor(f.scrollbarSliderBackground);if(i){var n=i.transparent(.5);t.addRule(".monaco-editor .minimap-slider, .monaco-editor .minimap-slider .minimap-slider-horizontal { background: "+n+"; }")}
var o=e.getColor(f.scrollbarSliderHoverBackground);if(o){var r=o.transparent(.5);t.addRule(".monaco-editor .minimap-slider:hover, .monaco-editor .minimap-slider:hover .minimap-slider-horizontal { background: "+r+"; }")}var s=e.getColor(f.scrollbarSliderActiveBackground);if(s){var a=s.transparent(.5);t.addRule(".monaco-editor .minimap-slider.active, .monaco-editor .minimap-slider.active .minimap-slider-horizontal { background: "+a+"; }")}var l=e.getColor(f.scrollbarShadow);l&&t.addRule(".monaco-editor .minimap-shadow-visible { box-shadow: "+l+" -6px 0 6px -6px inset; }")})}),define(t[526],i([1,0,27,35,22,16,276]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var n=e.call(this,t)||this;return n._scrollTop=0,n._width=0,n._updateWidth(),n._shouldShow=!1,n._useShadows=n._context.configuration.editor.viewInfo.scrollbar.useShadows,n._domNode=i.createFastDomNode(document.createElement("div")),n._domNode.setAttribute("role","presentation"),
n._domNode.setAttribute("aria-hidden","true"),n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype._updateShouldShow=function(){var e=this._useShadows&&this._scrollTop>0;return this._shouldShow!==e&&(this._shouldShow=e,!0)},t.prototype.getDomNode=function(){return this._domNode},t.prototype._updateWidth=function(){var e=this._context.configuration.editor.layoutInfo,t=0;return t=0===e.renderMinimap||e.minimapWidth>0&&0===e.minimapLeft?e.width:e.width-e.minimapWidth-e.verticalScrollbarWidth,this._width!==t&&(this._width=t,!0)},t.prototype.onConfigurationChanged=function(e){var t=!1;return e.viewInfo&&(this._useShadows=this._context.configuration.editor.viewInfo.scrollbar.useShadows),e.layoutInfo&&(t=this._updateWidth()),this._updateShouldShow()||t},t.prototype.onScrollChanged=function(e){return this._scrollTop=e.scrollTop,this._updateShouldShow()},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){this._domNode.setWidth(this._width),
this._domNode.setClassName(this._shouldShow?"scroll-decoration":"")},t}(n.ViewPart);t.ScrollDecorationViewPart=a,s.registerThemingParticipant(function(e,t){var i=e.getColor(o.scrollbarShadow);i&&t.addRule(".monaco-editor .scroll-decoration { box-shadow: "+i+" 0 6px 6px -6px inset; }")})}),define(t[527],i([1,0,28,71,22,16,275]),function(e,t,i,n,o,s){"use strict";function a(e){return new d(e)}function l(e){return new c(e.lineNumber,e.ranges.map(a))}function u(e){return e<0?-e:e}Object.defineProperty(t,"__esModule",{value:!0});var d=function(){return function(e){this.left=e.left,this.width=e.width,this.startStyle=null,this.endStyle=null}}(),c=function(){return function(e,t){this.lineNumber=e,this.ranges=t}}(),h=i.isEdgeOrIE,p=function(e){function t(t){var i=e.call(this)||this;return i._previousFrameVisibleRangesWithStyle=[],i._context=t,i._lineHeight=i._context.configuration.editor.lineHeight,i._roundedSelection=i._context.configuration.editor.viewInfo.roundedSelection,
i._typicalHalfwidthCharacterWidth=i._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,i._selections=[],i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.viewInfo&&(this._roundedSelection=this._context.configuration.editor.viewInfo.roundedSelection),e.fontInfo&&(this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),!0},t.prototype.onCursorStateChanged=function(e){return this._selections=e.selections.slice(0),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},
t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype._visibleRangesHaveGaps=function(e){for(var t=0,i=e.length;t<i;t++){if(e[t].ranges.length>1)return!0}return!1},t.prototype._enrichVisibleRangesWithStyle=function(e,t,i){var n=this._typicalHalfwidthCharacterWidth/4,o=null,r=null;if(i&&i.length>0&&t.length>0){var s=t[0].lineNumber;if(s===e.startLineNumber)for(l=0;!o&&l<i.length;l++)i[l].lineNumber===s&&(o=i[l].ranges[0]);var a=t[t.length-1].lineNumber;if(a===e.endLineNumber)for(l=i.length-1;!r&&l>=0;l--)i[l].lineNumber===a&&(r=i[l].ranges[0]);o&&!o.startStyle&&(o=null),r&&!r.startStyle&&(r=null)}for(var l=0,d=t.length;l<d;l++){var c=t[l].ranges[0],h=c.left,p=c.left+c.width,f={top:0,bottom:0},g={top:0,bottom:0};if(l>0){var m=t[l-1].ranges[0].left,v=t[l-1].ranges[0].left+t[l-1].ranges[0].width;u(h-m)<n?f.top=2:h>m&&(f.top=1),u(p-v)<n?g.top=2:m<p&&p<v&&(g.top=1)}else o&&(f.top=o.startStyle.top,g.top=o.endStyle.top);if(l+1<d){
var _=t[l+1].ranges[0].left,y=t[l+1].ranges[0].left+t[l+1].ranges[0].width;u(h-_)<n?f.bottom=2:_<h&&h<y&&(f.bottom=1),u(p-y)<n?g.bottom=2:p<y&&(g.bottom=1)}else r&&(f.bottom=r.startStyle.bottom,g.bottom=r.endStyle.bottom);c.startStyle=f,c.endStyle=g}},t.prototype._getVisibleRangesWithStyle=function(e,t,i){var n=(t.linesVisibleRangesForRange(e,!0)||[]).map(l),o=this._visibleRangesHaveGaps(n);return h||o||!this._roundedSelection||this._enrichVisibleRangesWithStyle(t.visibleRange,n,i),n},t.prototype._createSelectionPiece=function(e,t,i,n,o){return'<div class="cslr '+i+'" style="top:'+e.toString()+"px;left:"+n.toString()+"px;width:"+o.toString()+"px;height:"+t+'px;"></div>'},t.prototype._actualRenderOneSelection=function(e,i,n,o){for(var r=o.length>0&&o[0].ranges[0].startStyle,s=this._lineHeight.toString(),a=(this._lineHeight-1).toString(),l=o.length>0?o[0].lineNumber:0,u=o.length>0?o[o.length-1].lineNumber:0,d=0,c=o.length;d<c;d++){
for(var h=o[d],p=h.lineNumber,f=p-i,g=n&&(p===u||p===l)?a:s,m=n&&p===l?1:0,v="",_=0,y=h.ranges.length;_<y;_++){var b=h.ranges[_];if(r){var C=b.startStyle,S=b.endStyle;if(1===C.top||1===C.bottom){v+=this._createSelectionPiece(m,g,t.SELECTION_CLASS_NAME,b.left-t.ROUNDED_PIECE_WIDTH,t.ROUNDED_PIECE_WIDTH);var w=t.EDITOR_BACKGROUND_CLASS_NAME;1===C.top&&(w+=" "+t.SELECTION_TOP_RIGHT),1===C.bottom&&(w+=" "+t.SELECTION_BOTTOM_RIGHT),v+=this._createSelectionPiece(m,g,w,b.left-t.ROUNDED_PIECE_WIDTH,t.ROUNDED_PIECE_WIDTH)}if(1===S.top||1===S.bottom){v+=this._createSelectionPiece(m,g,t.SELECTION_CLASS_NAME,b.left+b.width,t.ROUNDED_PIECE_WIDTH);var E=t.EDITOR_BACKGROUND_CLASS_NAME;1===S.top&&(E+=" "+t.SELECTION_TOP_LEFT),1===S.bottom&&(E+=" "+t.SELECTION_BOTTOM_LEFT),v+=this._createSelectionPiece(m,g,E,b.left+b.width,t.ROUNDED_PIECE_WIDTH)}}var L=t.SELECTION_CLASS_NAME;if(r){var C=b.startStyle,S=b.endStyle;0===C.top&&(L+=" "+t.SELECTION_TOP_LEFT),0===C.bottom&&(L+=" "+t.SELECTION_BOTTOM_LEFT),
0===S.top&&(L+=" "+t.SELECTION_TOP_RIGHT),0===S.bottom&&(L+=" "+t.SELECTION_BOTTOM_RIGHT)}v+=this._createSelectionPiece(m,g,L,b.left,b.width)}e[f]+=v}},t.prototype.prepareRender=function(e){for(var t=[],i=e.visibleRange.startLineNumber,n=e.visibleRange.endLineNumber,o=i;o<=n;o++){t[o-i]=""}for(var r=[],s=0,a=this._selections.length;s<a;s++){var l=this._selections[s];if(l.isEmpty())r[s]=null;else{var u=this._getVisibleRangesWithStyle(l,e,this._previousFrameVisibleRangesWithStyle[s]);r[s]=u,this._actualRenderOneSelection(t,i,this._selections.length>1,u)}}this._previousFrameVisibleRangesWithStyle=r,this._renderResult=t},t.prototype.render=function(e,t){if(!this._renderResult)return"";var i=t-e;return i<0||i>=this._renderResult.length?"":this._renderResult[i]},t.SELECTION_CLASS_NAME="selected-text",t.SELECTION_TOP_LEFT="top-left-radius",t.SELECTION_BOTTOM_LEFT="bottom-left-radius",t.SELECTION_TOP_RIGHT="top-right-radius",t.SELECTION_BOTTOM_RIGHT="bottom-right-radius",
t.EDITOR_BACKGROUND_CLASS_NAME="monaco-editor-background",t.ROUNDED_PIECE_WIDTH=10,t}(n.DynamicViewOverlay);t.SelectionsOverlay=p,s.registerThemingParticipant(function(e,t){var i=e.getColor(o.editorSelectionBackground);i&&t.addRule(".monaco-editor .focused .selected-text { background-color: "+i+"; }");var n=e.getColor(o.editorInactiveSelection);n&&t.addRule(".monaco-editor .selected-text { background-color: "+n+"; }");var r=e.getColor(o.editorSelectionForeground);r&&t.addRule(".monaco-editor .view-line span.inline-selected-text { color: "+r+"; }")})}),define(t[37],i([1,0,320,25,22,16]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.editorLineHighlight=o.registerColor("editor.lineHighlightBackground",{dark:null,light:null,hc:null},i.localize(0,null)),t.editorLineHighlightBorder=o.registerColor("editor.lineHighlightBorder",{dark:"#282828",light:"#eeeeee",hc:"#f38518"},i.localize(1,null)),t.editorRangeHighlight=o.registerColor("editor.rangeHighlightBackground",{
dark:"#ffffff0b",light:"#fdff0033",hc:null},i.localize(2,null),!0),t.editorRangeHighlightBorder=o.registerColor("editor.rangeHighlightBorder",{dark:null,light:null,hc:o.activeContrastBorder},i.localize(3,null),!0),t.editorCursorForeground=o.registerColor("editorCursor.foreground",{dark:"#AEAFAD",light:n.Color.black,hc:n.Color.white},i.localize(4,null)),t.editorCursorBackground=o.registerColor("editorCursor.background",null,i.localize(5,null)),t.editorWhitespaces=o.registerColor("editorWhitespace.foreground",{dark:"#e3e4e229",light:"#33333333",hc:"#e3e4e229"},i.localize(6,null)),t.editorIndentGuides=o.registerColor("editorIndentGuide.background",{dark:t.editorWhitespaces,light:t.editorWhitespaces,hc:t.editorWhitespaces},i.localize(7,null)),t.editorActiveIndentGuides=o.registerColor("editorIndentGuide.activeBackground",{dark:t.editorWhitespaces,light:t.editorWhitespaces,hc:t.editorWhitespaces},i.localize(8,null)),t.editorLineNumbers=o.registerColor("editorLineNumber.foreground",{dark:"#858585",light:"#237893",
hc:n.Color.white},i.localize(9,null));var s=o.registerColor("editorActiveLineNumber.foreground",{dark:"#c6c6c6",light:"#0B216F",hc:o.activeContrastBorder},i.localize(10,null),!1,i.localize(11,null));t.editorActiveLineNumber=o.registerColor("editorLineNumber.activeForeground",{dark:s,light:s,hc:s},i.localize(12,null)),t.editorRuler=o.registerColor("editorRuler.foreground",{dark:"#5A5A5A",light:n.Color.lightgrey,hc:n.Color.white},i.localize(13,null)),t.editorCodeLensForeground=o.registerColor("editorCodeLens.foreground",{dark:"#999999",light:"#999999",hc:"#999999"},i.localize(14,null)),t.editorBracketMatchBackground=o.registerColor("editorBracketMatch.background",{dark:"#0064001a",light:"#0064001a",hc:"#0064001a"},i.localize(15,null)),t.editorBracketMatchBorder=o.registerColor("editorBracketMatch.border",{dark:"#888",light:"#B9B9B9",hc:o.contrastBorder},i.localize(16,null)),t.editorOverviewRulerBorder=o.registerColor("editorOverviewRuler.border",{dark:"#7f7f7f4d",light:"#7f7f7f4d",hc:"#7f7f7f4d"
},i.localize(17,null)),t.editorGutter=o.registerColor("editorGutter.background",{dark:o.editorBackground,light:o.editorBackground,hc:o.editorBackground},i.localize(18,null)),t.editorUnnecessaryCodeBorder=o.registerColor("editorUnnecessaryCode.border",{dark:null,light:null,hc:n.Color.fromHex("#fff").transparent(.8)},i.localize(19,null)),t.editorUnnecessaryCodeOpacity=o.registerColor("editorUnnecessaryCode.opacity",{dark:n.Color.fromHex("#000a"),light:n.Color.fromHex("#0007"),hc:null},i.localize(20,null)),t.overviewRulerError=o.registerColor("editorOverviewRuler.errorForeground",{dark:new n.Color(new n.RGBA(255,18,18,.7)),light:new n.Color(new n.RGBA(255,18,18,.7)),hc:new n.Color(new n.RGBA(255,50,50,1))},i.localize(21,null)),t.overviewRulerWarning=o.registerColor("editorOverviewRuler.warningForeground",{dark:o.editorWarningForeground,light:o.editorWarningForeground,hc:o.editorWarningBorder},i.localize(22,null)),t.overviewRulerInfo=o.registerColor("editorOverviewRuler.infoForeground",{
dark:o.editorInfoForeground,light:o.editorInfoForeground,hc:o.editorInfoBorder},i.localize(23,null)),r.registerThemingParticipant(function(e,i){var n=e.getColor(o.editorBackground);n&&i.addRule(".monaco-editor, .monaco-editor-background, .monaco-editor .inputarea.ime-input { background-color: "+n+"; }");var r=e.getColor(o.editorForeground);r&&i.addRule(".monaco-editor, .monaco-editor .inputarea.ime-input { color: "+r+"; }");var s=e.getColor(t.editorGutter);s&&i.addRule(".monaco-editor .margin { background-color: "+s+"; }");var a=e.getColor(t.editorRangeHighlight);a&&i.addRule(".monaco-editor .rangeHighlight { background-color: "+a+"; }");var l=e.getColor(t.editorRangeHighlightBorder);l&&i.addRule(".monaco-editor .rangeHighlight { border: 1px "+("hc"===e.type?"dotted":"solid")+" "+l+"; }");var u=e.getColor(t.editorWhitespaces);u&&i.addRule(".vs-whitespace { color: "+u+" !important; }")})}),define(t[529],i([1,0,71,37,16,376]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;var s=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._lineHeight=i._context.configuration.editor.lineHeight,i._renderLineHighlight=i._context.configuration.editor.viewInfo.renderLineHighlight,i._selectionIsEmpty=!0,i._primaryCursorLineNumber=1,i._scrollWidth=0,i._contentWidth=i._context.configuration.editor.layoutInfo.contentWidth,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.viewInfo&&(this._renderLineHighlight=this._context.configuration.editor.viewInfo.renderLineHighlight),e.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth),!0},t.prototype.onCursorStateChanged=function(e){var t=!1,i=e.selections[0].positionLineNumber;this._primaryCursorLineNumber!==i&&(this._primaryCursorLineNumber=i,t=!0)
;var n=e.selections[0].isEmpty();return this._selectionIsEmpty!==n?(this._selectionIsEmpty=n,!0):t},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollWidthChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype.prepareRender=function(e){this._scrollWidth=e.scrollWidth},t.prototype.render=function(e,t){if(t===this._primaryCursorLineNumber){if(this._shouldShowCurrentLine()){return'<div class="'+("current-line"+(this._willRenderMarginCurrentLine()?" current-line-both":""))+'" style="width:'+String(Math.max(this._scrollWidth,this._contentWidth))+"px; height:"+String(this._lineHeight)+'px;"></div>'}return""}return""},t.prototype._shouldShowCurrentLine=function(){return("line"===this._renderLineHighlight||"all"===this._renderLineHighlight)&&this._selectionIsEmpty},t.prototype._willRenderMarginCurrentLine=function(){
return"gutter"===this._renderLineHighlight||"all"===this._renderLineHighlight},t}(i.DynamicViewOverlay);t.CurrentLineHighlightOverlay=s,o.registerThemingParticipant(function(e,t){var i=e.getColor(n.editorLineHighlight);if(i&&t.addRule(".monaco-editor .view-overlays .current-line { background-color: "+i+"; }"),!i||i.isTransparent()||e.defines(n.editorLineHighlightBorder)){var o=e.getColor(n.editorLineHighlightBorder);o&&(t.addRule(".monaco-editor .view-overlays .current-line { border: 2px solid "+o+"; }"),"hc"===e.type&&t.addRule(".monaco-editor .view-overlays .current-line { border-width: 1px; }"))}})}),define(t[530],i([1,0,71,37,16,374]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._lineHeight=i._context.configuration.editor.lineHeight,i._renderLineHighlight=i._context.configuration.editor.viewInfo.renderLineHighlight,i._selectionIsEmpty=!0,i._primaryCursorLineNumber=1,
i._contentLeft=i._context.configuration.editor.layoutInfo.contentLeft,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){this._context.removeEventHandler(this),e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.viewInfo&&(this._renderLineHighlight=this._context.configuration.editor.viewInfo.renderLineHighlight),e.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft),!0},t.prototype.onCursorStateChanged=function(e){var t=!1,i=e.selections[0].positionLineNumber;this._primaryCursorLineNumber!==i&&(this._primaryCursorLineNumber=i,t=!0);var n=e.selections[0].isEmpty();return this._selectionIsEmpty!==n?(this._selectionIsEmpty=n,!0):t},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onZonesChanged=function(e){return!0},
t.prototype.prepareRender=function(e){},t.prototype.render=function(e,t){if(t===this._primaryCursorLineNumber){var i="current-line";if(this._shouldShowCurrentLine()){i="current-line current-line-margin"+(this._willRenderContentCurrentLine()?" current-line-margin-both":"")}return'<div class="'+i+'" style="width:'+String(this._contentLeft)+"px; height:"+String(this._lineHeight)+'px;"></div>'}return""},t.prototype._shouldShowCurrentLine=function(){return"gutter"===this._renderLineHighlight||"all"===this._renderLineHighlight},t.prototype._willRenderContentCurrentLine=function(){return("line"===this._renderLineHighlight||"all"===this._renderLineHighlight)&&this._selectionIsEmpty},t}(i.DynamicViewOverlay);t.CurrentLineMarginHighlightOverlay=s,o.registerThemingParticipant(function(e,t){var i=e.getColor(n.editorLineHighlight);if(i)t.addRule(".monaco-editor .margin-view-overlays .current-line-margin { background-color: "+i+"; border: none; }");else{var o=e.getColor(n.editorLineHighlightBorder)
;o&&t.addRule(".monaco-editor .margin-view-overlays .current-line-margin { border: 2px solid "+o+"; }"),"hc"===e.type&&t.addRule(".monaco-editor .margin-view-overlays .current-line-margin { border-width: 1px; }")}})}),define(t[531],i([1,0,71,13,37,16,315]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var i=e.call(this)||this;i._context=t,i._primaryLineNumber=0,i._lineHeight=i._context.configuration.editor.lineHeight,i._spaceWidth=i._context.configuration.editor.fontInfo.spaceWidth,i._enabled=i._context.configuration.editor.viewInfo.renderIndentGuides,i._activeIndentEnabled=i._context.configuration.editor.viewInfo.highlightActiveIndentGuide;var n=i._context.configuration.editor.wrappingInfo.wrappingColumn;return i._maxIndentLeft=-1===n?-1:n*i._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype.dispose=function(){
this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){if(e.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),e.fontInfo&&(this._spaceWidth=this._context.configuration.editor.fontInfo.spaceWidth),e.viewInfo&&(this._enabled=this._context.configuration.editor.viewInfo.renderIndentGuides,this._activeIndentEnabled=this._context.configuration.editor.viewInfo.highlightActiveIndentGuide),e.wrappingInfo||e.fontInfo){var t=this._context.configuration.editor.wrappingInfo.wrappingColumn;this._maxIndentLeft=-1===t?-1:t*this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth}return!0},t.prototype.onCursorStateChanged=function(e){var t=e.selections[0],i=t.isEmpty()?t.positionLineNumber:0;return this._primaryLineNumber!==i&&(this._primaryLineNumber=i,!0)},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){
return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype.onLanguageConfigurationChanged=function(e){return!0},t.prototype.prepareRender=function(e){if(this._enabled){var t=e.visibleRange.startLineNumber,i=e.visibleRange.endLineNumber,o=this._context.model.getOptions().indentSize*this._spaceWidth,r=e.scrollWidth,s=this._lineHeight,a=this._context.model.getLinesIndentGuides(t,i),l=0,u=0,d=0;if(this._activeIndentEnabled&&this._primaryLineNumber){var c=this._context.model.getActiveIndentGuide(this._primaryLineNumber,t,i);l=c.startLineNumber,u=c.endLineNumber,d=c.indent}for(var h=[],p=t;p<=i;p++){for(var f=l<=p&&p<=u,g=p-t,m=a[g],v="",_=e.visibleRangeForPosition(new n.Position(p,1)),y=_?_.left:0,b=1;b<=m;b++){if(v+='<div class="'+(f&&b===d?"cigra":"cigr")+'" style="left:'+y+"px;height:"+s+"px;width:"+o+'px"></div>',
(y+=o)>r||this._maxIndentLeft>0&&y>this._maxIndentLeft)break}h[g]=v}this._renderResult=h}else this._renderResult=null},t.prototype.render=function(e,t){if(!this._renderResult)return"";var i=t-e;return i<0||i>=this._renderResult.length?"":this._renderResult[i]},t}(i.DynamicViewOverlay);t.IndentGuidesOverlay=a,s.registerThemingParticipant(function(e,t){var i=e.getColor(o.editorIndentGuides);i&&t.addRule(".monaco-editor .lines-content .cigr { box-shadow: 1px 0 0 0 "+i+" inset; }");var n=e.getColor(o.editorActiveIndentGuides)||i;n&&t.addRule(".monaco-editor .lines-content .cigra { box-shadow: 1px 0 0 0 "+n+" inset; }")})}),define(t[218],i([1,0,18,71,13,37,16,314]),function(e,t,i,n,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t){var i=e.call(this)||this;return i._context=t,i._readConfig(),i._lastCursorModelPosition=new o.Position(1,1),i._renderResult=null,i._context.addEventHandler(i),i}return r(t,e),t.prototype._readConfig=function(){
var e=this._context.configuration.editor;this._lineHeight=e.lineHeight,this._renderLineNumbers=e.viewInfo.renderLineNumbers,this._renderCustomLineNumbers=e.viewInfo.renderCustomLineNumbers,this._renderFinalNewline=e.viewInfo.renderFinalNewline,this._lineNumbersLeft=e.layoutInfo.lineNumbersLeft,this._lineNumbersWidth=e.layoutInfo.lineNumbersWidth},t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){return this._readConfig(),!0},t.prototype.onCursorStateChanged=function(e){var t=e.selections[0].getPosition();return this._lastCursorModelPosition=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(t),2===this._renderLineNumbers||3===this._renderLineNumbers},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},
t.prototype.onScrollChanged=function(e){return e.scrollTopChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype._getLineRenderLineNumber=function(e){var t=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new o.Position(e,1));if(1!==t.column)return"";var i=t.lineNumber;if(!this._renderFinalNewline){var n=this._context.model.getLineCount(),r=this._context.model.getLineContent(i);if(i===n&&""===r)return""}if(this._renderCustomLineNumbers)return this._renderCustomLineNumbers(i);if(2===this._renderLineNumbers){var s=Math.abs(this._lastCursorModelPosition.lineNumber-i);return 0===s?'<span class="relative-current-line-number">'+i+"</span>":String(s)}return 3===this._renderLineNumbers?this._lastCursorModelPosition.lineNumber===i?String(i):i%10==0?String(i):"":String(i)},t.prototype.prepareRender=function(e){if(0!==this._renderLineNumbers){
for(var n=i.isLinux?this._lineHeight%2==0?" lh-even":" lh-odd":"",o=e.visibleRange.startLineNumber,r=e.visibleRange.endLineNumber,s='<div class="'+t.CLASS_NAME+n+'" style="left:'+this._lineNumbersLeft.toString()+"px;width:"+this._lineNumbersWidth.toString()+'px;">',a=[],l=o;l<=r;l++){var u=l-o,d=this._getLineRenderLineNumber(l);a[u]=d?s+d+"</div>":""}this._renderResult=a}else this._renderResult=null},t.prototype.render=function(e,t){if(!this._renderResult)return"";var i=t-e;return i<0||i>=this._renderResult.length?"":this._renderResult[i]},t.CLASS_NAME="line-numbers",t}(n.DynamicViewOverlay);t.LineNumbersOverlay=l,a.registerThemingParticipant(function(e,t){var i=e.getColor(s.editorLineNumbers);i&&t.addRule(".monaco-editor .line-numbers { color: "+i+"; }");var n=e.getColor(s.editorActiveLineNumber);n&&t.addRule(".monaco-editor .current-line ~ .line-numbers { color: "+n+"; }")})}),define(t[533],i([1,0,28,27,18,5,65,167,197,35,218,173,86,13,3,20,77,377]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v){"use strict"
;function _(e,t){var n=document.createElement("canvas").getContext("2d");n.font=function(e){return function(e,t,i,n,o){return e+" normal "+t+" "+i+"px / "+n+"px "+o}("normal",e.fontWeight,e.fontSize,e.lineHeight,e.fontFamily)}(t);var o=n.measureText(e);return i.isFirefox?o.width+2:o.width}Object.defineProperty(t,"__esModule",{value:!0});var y=function(){function e(e,t,i){this.top=e,this.left=t,this.width=i}return e.prototype.setWidth=function(t){return new e(this.top,this.left,t)},e}(),b=i.isEdgeOrIE||i.isFirefox,C=function(){function e(){this._lastState=null}return e.prototype.set=function(e){this._lastState=e},e.prototype.get=function(e){return this._lastState&&this._lastState.lastCopiedValue===e?this._lastState:(this._lastState=null,null)},e.INSTANCE=new e,e}(),S=function(e){function t(t,r,s){var a=e.call(this,t)||this;a._primaryCursorVisibleRange=null,a._viewController=r,a._viewHelper=s;var c=a._context.configuration.editor;a._accessibilitySupport=c.accessibilitySupport,
a._contentLeft=c.layoutInfo.contentLeft,a._contentWidth=c.layoutInfo.contentWidth,a._contentHeight=c.layoutInfo.contentHeight,a._scrollLeft=0,a._scrollTop=0,a._fontInfo=c.fontInfo,a._lineHeight=c.lineHeight,a._emptySelectionClipboard=c.emptySelectionClipboard,a._copyWithSyntaxHighlighting=c.copyWithSyntaxHighlighting,a._visibleTextArea=null,a._selections=[new m.Selection(1,1,1,1)],a.textArea=n.createFastDomNode(document.createElement("textarea")),d.PartFingerprints.write(a.textArea,6),a.textArea.setClassName("inputarea"),a.textArea.setAttribute("wrap","off"),a.textArea.setAttribute("autocorrect","off"),a.textArea.setAttribute("autocapitalize","off"),a.textArea.setAttribute("autocomplete","off"),a.textArea.setAttribute("spellcheck","false"),a.textArea.setAttribute("aria-label",c.viewInfo.ariaLabel),a.textArea.setAttribute("role","textbox"),a.textArea.setAttribute("aria-multiline","true"),a.textArea.setAttribute("aria-haspopup","false"),a.textArea.setAttribute("aria-autocomplete","both"),
a.textAreaCover=n.createFastDomNode(document.createElement("div")),a.textAreaCover.setPosition("absolute");var h={getLineCount:function(){return a._context.model.getLineCount()},getLineMaxColumn:function(e){return a._context.model.getLineMaxColumn(e)},getValueInRange:function(e,t){return a._context.model.getValueInRange(e,t)}},p={getPlainTextToCopy:function(){var e=a._context.model.getPlainTextToCopy(a._selections,a._emptySelectionClipboard,o.isWindows),t=a._context.model.getEOL(),n=a._emptySelectionClipboard&&1===a._selections.length&&a._selections[0].isEmpty(),r=Array.isArray(e)?e:null,s=Array.isArray(e)?e.join(t):e,l=null;if(n||r){l={lastCopiedValue:i.isFirefox?s.replace(/\r\n/g,"\n"):s,isFromEmptySelection:a._emptySelectionClipboard&&1===a._selections.length&&a._selections[0].isEmpty(),multicursorText:r}}return C.INSTANCE.set(l),s},getHTMLToCopy:function(){
return a._copyWithSyntaxHighlighting||l.CopyOptions.forceCopyWithSyntaxHighlighting?a._context.model.getHTMLToCopy(a._selections,a._emptySelectionClipboard):null},getScreenReaderContent:function(e){if(i.isIPad)return u.TextAreaState.EMPTY;if(1===a._accessibilitySupport){if(o.isMacintosh){var t=a._selections[0];if(t.isEmpty()){var n=t.getStartPosition(),r=a._getWordBeforePosition(n);if(0===r.length&&(r=a._getCharacterBeforePosition(n)),r.length>0)return new u.TextAreaState(r,r.length,r.length,n,n)}}return u.TextAreaState.EMPTY}return u.PagedScreenReaderStrategy.fromEditorSelection(e,h,a._selections[0],0===a._accessibilitySupport)},deduceModelPosition:function(e,t,i){return a._context.model.deduceModelPositionRelativeToViewPosition(e,t,i)}};return a._textAreaInput=a._register(new l.TextAreaInput(p,a.textArea)),a._register(a._textAreaInput.onKeyDown(function(e){a._viewController.emitKeyDown(e)})),a._register(a._textAreaInput.onKeyUp(function(e){a._viewController.emitKeyUp(e)})),
a._register(a._textAreaInput.onPaste(function(e){var t=C.INSTANCE.get(e.text),i=!1,n=null;t&&(i=a._emptySelectionClipboard&&t.isFromEmptySelection,n=t.multicursorText),a._viewController.paste("keyboard",e.text,i,n)})),a._register(a._textAreaInput.onCut(function(){a._viewController.cut("keyboard")})),a._register(a._textAreaInput.onType(function(e){e.replaceCharCnt?a._viewController.replacePreviousChar("keyboard",e.text,e.replaceCharCnt):a._viewController.type("keyboard",e.text)})),a._register(a._textAreaInput.onSelectionChangeRequest(function(e){a._viewController.setSelection("keyboard",e)})),a._register(a._textAreaInput.onCompositionStart(function(){var e=a._selections[0].startLineNumber,t=a._selections[0].startColumn;a._context.privateViewEventBus.emit(new v.ViewRevealRangeRequestEvent(new g.Range(e,t,e,t),0,!0,1));var i=a._viewHelper.visibleRangeForPositionRelativeToEditor(e,t);i&&(a._visibleTextArea=new y(a._context.viewLayout.getVerticalOffsetForLineNumber(e),i.left,b?0:1),a._render()),
a.textArea.setClassName("inputarea ime-input"),a._viewController.compositionStart("keyboard")})),a._register(a._textAreaInput.onCompositionUpdate(function(e){i.isEdgeOrIE?a._visibleTextArea=a._visibleTextArea.setWidth(0):a._visibleTextArea=a._visibleTextArea.setWidth(_(e.data,a._fontInfo)),a._render()})),a._register(a._textAreaInput.onCompositionEnd(function(){a._visibleTextArea=null,a._render(),a.textArea.setClassName("inputarea"),a._viewController.compositionEnd("keyboard")})),a._register(a._textAreaInput.onFocus(function(){a._context.privateViewEventBus.emit(new v.ViewFocusChangedEvent(!0))})),a._register(a._textAreaInput.onBlur(function(){a._context.privateViewEventBus.emit(new v.ViewFocusChangedEvent(!1))})),a}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype._getWordBeforePosition=function(e){for(var t=this._context.model.getLineContent(e.lineNumber),i=p.getMapForWordSeparators(this._context.configuration.editor.wordSeparators),n=e.column,o=0;n>1;){
var r=t.charCodeAt(n-2);if(0!==i.get(r)||o>50)return t.substring(n-1,e.column-1);o++,n--}return t.substring(0,e.column-1)},t.prototype._getCharacterBeforePosition=function(e){if(e.column>1){var t=this._context.model.getLineContent(e.lineNumber).charAt(e.column-2);if(!s.isHighSurrogate(t.charCodeAt(0)))return t}return""},t.prototype.onConfigurationChanged=function(e){var t=this._context.configuration.editor;return e.fontInfo&&(this._fontInfo=t.fontInfo),e.viewInfo&&this.textArea.setAttribute("aria-label",t.viewInfo.ariaLabel),e.layoutInfo&&(this._contentLeft=t.layoutInfo.contentLeft,this._contentWidth=t.layoutInfo.contentWidth,this._contentHeight=t.layoutInfo.contentHeight),e.lineHeight&&(this._lineHeight=t.lineHeight),e.accessibilitySupport&&(this._accessibilitySupport=t.accessibilitySupport,this._textAreaInput.writeScreenReaderContent("strategy changed")),e.emptySelectionClipboard&&(this._emptySelectionClipboard=t.emptySelectionClipboard),
e.copyWithSyntaxHighlighting&&(this._copyWithSyntaxHighlighting=t.copyWithSyntaxHighlighting),!0},t.prototype.onCursorStateChanged=function(e){return this._selections=e.selections.slice(0),this._textAreaInput.writeScreenReaderContent("selection changed"),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return this._scrollLeft=e.scrollLeft,this._scrollTop=e.scrollTop,!0},t.prototype.onZonesChanged=function(e){return!0},t.prototype.isFocused=function(){return this._textAreaInput.isFocused()},t.prototype.focusTextArea=function(){this._textAreaInput.focusTextArea()},t.prototype.prepareRender=function(e){var t=new f.Position(this._selections[0].positionLineNumber,this._selections[0].positionColumn);this._primaryCursorVisibleRange=e.visibleRangeForPosition(t)},
t.prototype.render=function(e){this._textAreaInput.writeScreenReaderContent("render"),this._render()},t.prototype._render=function(){if(this._visibleTextArea)this._renderInsideEditor(this._visibleTextArea.top-this._scrollTop,this._contentLeft+this._visibleTextArea.left-this._scrollLeft,this._visibleTextArea.width,this._lineHeight,!0);else if(this._primaryCursorVisibleRange){var e=this._contentLeft+this._primaryCursorVisibleRange.left-this._scrollLeft;if(e<this._contentLeft||e>this._contentLeft+this._contentWidth)this._renderAtTopLeft();else{var t=this._context.viewLayout.getVerticalOffsetForLineNumber(this._selections[0].positionLineNumber)-this._scrollTop;t<0||t>this._contentHeight?this._renderAtTopLeft():this._renderInsideEditor(t,e,b?0:1,b?0:1,!1)}}else this._renderAtTopLeft()},t.prototype._renderInsideEditor=function(e,t,i,n,o){var r=this.textArea,s=this.textAreaCover;o?a.Configuration.applyFontInfo(r,this._fontInfo):(r.setFontSize(1),r.setLineHeight(this._fontInfo.lineHeight)),r.setTop(e),r.setLeft(t),
r.setWidth(i),r.setHeight(n),s.setTop(0),s.setLeft(0),s.setWidth(0),s.setHeight(0)},t.prototype._renderAtTopLeft=function(){var e=this.textArea,t=this.textAreaCover;if(a.Configuration.applyFontInfo(e,this._fontInfo),e.setTop(0),e.setLeft(0),t.setTop(0),t.setLeft(0),b)return e.setWidth(0),e.setHeight(0),t.setWidth(0),void t.setHeight(0);e.setWidth(1),e.setHeight(1),t.setWidth(1),t.setHeight(1),this._context.configuration.editor.viewInfo.glyphMargin?t.setClassName("monaco-editor-background textAreaCover "+h.Margin.OUTER_CLASS_NAME):0!==this._context.configuration.editor.viewInfo.renderLineNumbers?t.setClassName("monaco-editor-background textAreaCover "+c.LineNumbersOverlay.CLASS_NAME):t.setClassName("monaco-editor-background textAreaCover")},t}(d.ViewPart);t.TextAreaHandler=S}),define(t[534],i([1,0,27,25,35,13,17,37]),function(e,t,i,n,o,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t){this.lineHeight=e.editor.lineHeight,this.pixelRatio=e.editor.pixelRatio,
this.overviewRulerLanes=e.editor.viewInfo.overviewRulerLanes,this.renderBorder=e.editor.viewInfo.overviewRulerBorder;var i=t.getColor(l.editorOverviewRulerBorder);this.borderColor=i?i.toString():null,this.hideCursor=e.editor.viewInfo.hideCursorInOverviewRuler;var o=t.getColor(l.editorCursorForeground);this.cursorColor=o?o.transparent(.7).toString():null,this.themeType=t.type;var r=e.editor.viewInfo.minimap.enabled,s=e.editor.viewInfo.minimap.side,u=r?a.TokenizationRegistry.getDefaultBackground():null;this.backgroundColor=null===u||"left"===s?null:n.Color.Format.CSS.formatHex(u);var d=e.editor.layoutInfo.overviewRuler;this.top=d.top,this.right=d.right,this.domWidth=d.width,this.domHeight=d.height,this.canvasWidth=this.domWidth*this.pixelRatio|0,this.canvasHeight=this.domHeight*this.pixelRatio|0;var c=this._initLanes(1,this.canvasWidth,this.overviewRulerLanes),h=c[0],p=c[1];this.x=h,this.w=p}return e.prototype._initLanes=function(e,t,i){var n=t-e;if(i>=3){
var o=n-(s=Math.floor(n/3))-(a=Math.floor(n/3)),r=(l=e)+s;return[[0,l,r,l,u=l+s+o,l,r,l],[0,s,o,s+o,a,s+o+a,o+a,s+o+a]]}if(2===i){var s=Math.floor(n/2),a=n-s,l=e,u=l+s;return[[0,l,l,l,u,l,l,l],[0,s,s,s,a,s+a,s+a,s+a]]}var d=e,c=n;return[[0,d,d,d,d,d,d,d],[0,c,c,c,c,c,c,c]]},e.prototype.equals=function(e){return this.lineHeight===e.lineHeight&&this.pixelRatio===e.pixelRatio&&this.overviewRulerLanes===e.overviewRulerLanes&&this.renderBorder===e.renderBorder&&this.borderColor===e.borderColor&&this.hideCursor===e.hideCursor&&this.cursorColor===e.cursorColor&&this.themeType===e.themeType&&this.backgroundColor===e.backgroundColor&&this.top===e.top&&this.right===e.right&&this.domWidth===e.domWidth&&this.domHeight===e.domHeight&&this.canvasWidth===e.canvasWidth&&this.canvasHeight===e.canvasHeight},e}(),d=function(e){function t(t){var n=e.call(this,t)||this;return n._domNode=i.createFastDomNode(document.createElement("canvas")),n._domNode.setClassName("decorationsOverviewRuler"),n._domNode.setPosition("absolute"),
n._domNode.setLayerHinting(!0),n._domNode.setAttribute("aria-hidden","true"),n._updateSettings(!1),n._tokensColorTrackerListener=a.TokenizationRegistry.onDidChange(function(e){e.changedColorMap&&n._updateSettings(!0)}),n._cursorPositions=[],n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._tokensColorTrackerListener.dispose()},t.prototype._updateSettings=function(e){var t=new u(this._context.configuration,this._context.theme);return(!this._settings||!this._settings.equals(t))&&(this._settings=t,this._domNode.setTop(this._settings.top),this._domNode.setRight(this._settings.right),this._domNode.setWidth(this._settings.domWidth),this._domNode.setHeight(this._settings.domHeight),this._domNode.domNode.width=this._settings.canvasWidth,this._domNode.domNode.height=this._settings.canvasHeight,e&&this._render(),!0)},t.prototype.onConfigurationChanged=function(e){return this._updateSettings(!1)},t.prototype.onCursorStateChanged=function(e){this._cursorPositions=[]
;for(var t=0,i=e.selections.length;t<i;t++)this._cursorPositions[t]=e.selections[t].getPosition();return this._cursorPositions.sort(s.Position.compare),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onScrollChanged=function(e){return e.scrollHeightChanged},t.prototype.onZonesChanged=function(e){return!0},t.prototype.onThemeChanged=function(e){return this._context.model.invalidateOverviewRulerColorCache(),this._updateSettings(!1)},t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.prepareRender=function(e){},t.prototype.render=function(e){this._render()},t.prototype._render=function(){var e=this._settings.canvasWidth,t=this._settings.canvasHeight,i=this._settings.lineHeight,n=this._context.viewLayout,o=t/this._context.viewLayout.getScrollHeight(),r=this._context.model.getAllOverviewRulerDecorations(this._context.theme),s=6*this._settings.pixelRatio|0,a=s/2|0,l=this._domNode.domNode.getContext("2d")
;null===this._settings.backgroundColor?l.clearRect(0,0,e,t):(l.fillStyle=this._settings.backgroundColor,l.fillRect(0,0,e,t));var u=this._settings.x,d=this._settings.w,c=Object.keys(r);c.sort();for(var h=0,p=c.length;h<p;h++){var f=c[h],g=r[f];l.fillStyle=f;for(var m=0,v=0,_=0,y=0,b=g.length;y<b;y++){var C=g[3*y],S=g[3*y+1],w=g[3*y+2],E=n.getVerticalOffsetForLineNumber(S)*o|0;if((k=(n.getVerticalOffsetForLineNumber(w)+i)*o|0)-E<s){(M=(E+k)/2|0)<a?M=a:M+a>t&&(M=t-a),E=M-a,k=M+a}E>_+1||C!==m?(0!==y&&l.fillRect(u[m],v,d[m],_-v),m=C,v=E,_=k):k>_&&(_=k)}l.fillRect(u[m],v,d[m],_-v)}if(!this._settings.hideCursor&&this._settings.cursorColor){var L=2*this._settings.pixelRatio|0,x=L/2|0,D=this._settings.x[7],I=this._settings.w[7];l.fillStyle=this._settings.cursorColor;for(var v=-100,_=-100,y=0,b=this._cursorPositions.length;y<b;y++){var N=this._cursorPositions[y],M=n.getVerticalOffsetForLineNumber(N.lineNumber)*o|0;M<x?M=x:M+x>t&&(M=t-x);var k=(E=M-x)+L;E>_+1?(0!==y&&l.fillRect(D,v,I,_-v),v=E,_=k):k>_&&(_=k)}
l.fillRect(D,v,I,_-v)}this._settings.renderBorder&&this._settings.borderColor&&this._settings.overviewRulerLanes>0&&(l.beginPath(),l.lineWidth=1,l.strokeStyle=this._settings.borderColor,l.moveTo(0,0),l.lineTo(0,t),l.stroke(),l.moveTo(0,0),l.lineTo(e,0),l.stroke())},t}(o.ViewPart);t.DecorationsOverviewRuler=d}),define(t[535],i([1,0,27,35,37,16,278]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(e){function t(t){var n=e.call(this,t)||this;return n.domNode=i.createFastDomNode(document.createElement("div")),n.domNode.setAttribute("role","presentation"),n.domNode.setAttribute("aria-hidden","true"),n.domNode.setClassName("view-rulers"),n._renderedRulers=[],n._rulers=n._context.configuration.editor.viewInfo.rulers,n._typicalHalfwidthCharacterWidth=n._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(e){
return!!(e.viewInfo||e.layoutInfo||e.fontInfo)&&(this._rulers=this._context.configuration.editor.viewInfo.rulers,this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,!0)},t.prototype.onScrollChanged=function(e){return e.scrollHeightChanged},t.prototype.prepareRender=function(e){},t.prototype._ensureRulersCount=function(){var e=this._renderedRulers.length,t=this._rulers.length;if(e!==t)if(e<t)for(var n=this._context.model.getOptions().tabSize,o=t-e;o>0;){(s=i.createFastDomNode(document.createElement("div"))).setClassName("view-ruler"),s.setWidth(n),this.domNode.appendChild(s),this._renderedRulers.push(s),o--}else for(var r=e-t;r>0;){var s=this._renderedRulers.pop();this.domNode.removeChild(s),r--}},t.prototype.render=function(e){this._ensureRulersCount();for(var t=0,i=this._rulers.length;t<i;t++){var n=this._renderedRulers[t];n.setHeight(Math.min(e.scrollHeight,1e6)),n.setLeft(this._rulers[t]*this._typicalHalfwidthCharacterWidth)}},t}(n.ViewPart)
;t.Rulers=a,s.registerThemingParticipant(function(e,t){var i=e.getColor(o.editorRuler);i&&t.addRule(".monaco-editor .view-ruler { box-shadow: 1px 0 0 0 "+i+" inset; }")})}),define(t[536],i([1,0,27,15,35,460,47,37,16,274]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(t){var o=e.call(this,t)||this;return o._readOnly=o._context.configuration.editor.readOnly,o._cursorBlinking=o._context.configuration.editor.viewInfo.cursorBlinking,o._cursorStyle=o._context.configuration.editor.viewInfo.cursorStyle,o._cursorSmoothCaretAnimation=o._context.configuration.editor.viewInfo.cursorSmoothCaretAnimation,o._selectionIsEmpty=!0,o._isVisible=!1,o._primaryCursor=new s.ViewCursor(o._context),o._secondaryCursors=[],o._renderData=[],o._domNode=i.createFastDomNode(document.createElement("div")),o._domNode.setAttribute("role","presentation"),o._domNode.setAttribute("aria-hidden","true"),o._updateDomClassName(),
o._domNode.appendChild(o._primaryCursor.getDomNode()),o._startCursorBlinkAnimation=new n.TimeoutTimer,o._cursorFlatBlinkInterval=new n.IntervalTimer,o._blinkingEnabled=!1,o._editorHasFocus=!1,o._updateBlinking(),o}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._startCursorBlinkAnimation.dispose(),this._cursorFlatBlinkInterval.dispose()},t.prototype.getDomNode=function(){return this._domNode},t.prototype.onConfigurationChanged=function(e){e.readOnly&&(this._readOnly=this._context.configuration.editor.readOnly),e.viewInfo&&(this._cursorBlinking=this._context.configuration.editor.viewInfo.cursorBlinking,this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle,this._cursorSmoothCaretAnimation=this._context.configuration.editor.viewInfo.cursorSmoothCaretAnimation),this._primaryCursor.onConfigurationChanged(e),this._updateBlinking(),e.viewInfo&&this._updateDomClassName()
;for(var t=0,i=this._secondaryCursors.length;t<i;t++)this._secondaryCursors[t].onConfigurationChanged(e);return!0},t.prototype._onCursorPositionChanged=function(e,t){if(this._primaryCursor.onCursorPositionChanged(e),this._updateBlinking(),this._secondaryCursors.length<t.length)for(var i=t.length-this._secondaryCursors.length,n=0;n<i;n++){var o=new s.ViewCursor(this._context);this._domNode.domNode.insertBefore(o.getDomNode().domNode,this._primaryCursor.getDomNode().domNode.nextSibling),this._secondaryCursors.push(o)}else if(this._secondaryCursors.length>t.length)for(var r=this._secondaryCursors.length-t.length,n=0;n<r;n++)this._domNode.removeChild(this._secondaryCursors[0].getDomNode()),this._secondaryCursors.splice(0,1);for(n=0;n<t.length;n++)this._secondaryCursors[n].onCursorPositionChanged(t[n])},t.prototype.onCursorStateChanged=function(e){for(var t=[],i=0,n=e.selections.length;i<n;i++)t[i]=e.selections[i].getPosition();this._onCursorPositionChanged(t[0],t.slice(1));var o=e.selections[0].isEmpty()
;return this._selectionIsEmpty!==o&&(this._selectionIsEmpty=o,this._updateDomClassName()),!0},t.prototype.onDecorationsChanged=function(e){return!0},t.prototype.onFlushed=function(e){return!0},t.prototype.onFocusChanged=function(e){return this._editorHasFocus=e.isFocused,this._updateBlinking(),!1},t.prototype.onLinesChanged=function(e){return!0},t.prototype.onLinesDeleted=function(e){return!0},t.prototype.onLinesInserted=function(e){return!0},t.prototype.onScrollChanged=function(e){return!0},t.prototype.onTokensChanged=function(e){var t=function(t){for(var i=0,n=e.ranges.length;i<n;i++)if(e.ranges[i].fromLineNumber<=t.lineNumber&&t.lineNumber<=e.ranges[i].toLineNumber)return!0;return!1};if(t(this._primaryCursor.getPosition()))return!0;for(var i=0,n=this._secondaryCursors;i<n.length;i++){if(t(n[i].getPosition()))return!0}return!1},t.prototype.onZonesChanged=function(e){return!0},t.prototype._getCursorBlinking=function(){return this._editorHasFocus?this._readOnly?5:this._cursorBlinking:0},
t.prototype._updateBlinking=function(){var e=this;this._startCursorBlinkAnimation.cancel(),this._cursorFlatBlinkInterval.cancel();var i=this._getCursorBlinking(),n=0===i,o=5===i;n?this._hide():this._show(),this._blinkingEnabled=!1,this._updateDomClassName(),n||o||(1===i?this._cursorFlatBlinkInterval.cancelAndSet(function(){e._isVisible?e._hide():e._show()},t.BLINK_INTERVAL):this._startCursorBlinkAnimation.setIfNotSet(function(){e._blinkingEnabled=!0,e._updateDomClassName()},t.BLINK_INTERVAL))},t.prototype._updateDomClassName=function(){this._domNode.setClassName(this._getClassName())},t.prototype._getClassName=function(){var e="cursors-layer";switch(this._selectionIsEmpty||(e+=" has-selection"),this._cursorStyle){case a.TextEditorCursorStyle.Line:e+=" cursor-line-style";break;case a.TextEditorCursorStyle.Block:e+=" cursor-block-style";break;case a.TextEditorCursorStyle.Underline:e+=" cursor-underline-style";break;case a.TextEditorCursorStyle.LineThin:e+=" cursor-line-thin-style";break
;case a.TextEditorCursorStyle.BlockOutline:e+=" cursor-block-outline-style";break;case a.TextEditorCursorStyle.UnderlineThin:e+=" cursor-underline-thin-style";break;default:e+=" cursor-line-style"}if(this._blinkingEnabled)switch(this._getCursorBlinking()){case 1:e+=" cursor-blink";break;case 2:e+=" cursor-smooth";break;case 3:e+=" cursor-phase";break;case 4:e+=" cursor-expand";break;case 5:e+=" cursor-solid";break;default:e+=" cursor-solid"}else e+=" cursor-solid";return this._cursorSmoothCaretAnimation&&(e+=" cursor-smooth-caret-animation"),e},t.prototype._show=function(){this._primaryCursor.show();for(var e=0,t=this._secondaryCursors.length;e<t;e++)this._secondaryCursors[e].show();this._isVisible=!0},t.prototype._hide=function(){this._primaryCursor.hide();for(var e=0,t=this._secondaryCursors.length;e<t;e++)this._secondaryCursors[e].hide();this._isVisible=!1},t.prototype.prepareRender=function(e){this._primaryCursor.prepareRender(e)
;for(var t=0,i=this._secondaryCursors.length;t<i;t++)this._secondaryCursors[t].prepareRender(e)},t.prototype.render=function(e){var t=[],i=0,n=this._primaryCursor.render(e);n&&(t[i++]=n);for(var o=0,r=this._secondaryCursors.length;o<r;o++){var s=this._secondaryCursors[o].render(e);s&&(t[i++]=s)}this._renderData=t},t.prototype.getLastRenderData=function(){return this._renderData},t.BLINK_INTERVAL=500,t}(o.ViewPart);t.ViewCursors=d,u.registerThemingParticipant(function(e,t){var i=e.getColor(l.editorCursorForeground);if(i){var n=e.getColor(l.editorCursorBackground);n||(n=i.opposite()),t.addRule(".monaco-editor .cursor { background-color: "+i+"; border-color: "+i+"; color: "+n+"; }"),"hc"===e.type&&t.addRule(".monaco-editor .cursors-layer.has-selection .cursor { border-left: 1px solid "+n+"; border-right: 1px solid "+n+"; }")}})}),
define(t[537],i([1,0,8,27,10,522,533,478,459,35,231,529,530,232,518,132,531,218,524,234,173,236,525,237,534,238,535,526,527,536,239,13,88,520,532,77,554,85,16]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M,k,T,R,O,P,A,F,W,V){"use strict";function B(e){try{return e()}catch(e){o.onUnexpectedError(e)}}Object.defineProperty(t,"__esModule",{value:!0});var H=function(){throw new Error("Invalid change accessor")},z=function(e){function t(t,i,o,r,x,T){var R=e.call(this)||this;R._cursor=x,R._renderAnimationFrame=null,R.outgoingEvents=T;var F=new l.ViewController(i,r,R.outgoingEvents,t);R.eventDispatcher=new P.ViewEventDispatcher(function(e){return R._renderOnce(e)}),R.eventDispatcher.addEventHandler(R),R._context=new O.ViewContext(i,o.getTheme(),r,R.eventDispatcher),R._register(o.onThemeChange(function(e){R._context.theme=e,R.eventDispatcher.emit(new A.ViewThemeChangedEvent),R.render(!0,!1)})),R.viewParts=[],R._textAreaHandler=new a.TextAreaHandler(R._context,F,R.createTextAreaHandlerHelper()),
R.viewParts.push(R._textAreaHandler),R.linesContent=n.createFastDomNode(document.createElement("div")),R.linesContent.setClassName("lines-content monaco-editor-background"),R.linesContent.setPosition("absolute"),R.domNode=n.createFastDomNode(document.createElement("div")),R.domNode.setClassName(R.getEditorClassName()),R.overflowGuardContainer=n.createFastDomNode(document.createElement("div")),d.PartFingerprints.write(R.overflowGuardContainer,3),R.overflowGuardContainer.setClassName("overflow-guard"),R._scrollbar=new g.EditorScrollbar(R._context,R.linesContent,R.domNode,R.overflowGuardContainer),R.viewParts.push(R._scrollbar),R.viewLines=new y.ViewLines(R._context,R.linesContent),R.viewZones=new k.ViewZones(R._context),R.viewParts.push(R.viewZones);var W=new L.DecorationsOverviewRuler(R._context);R.viewParts.push(W);var V=new I.ScrollDecorationViewPart(R._context);R.viewParts.push(V);var B=new u.ContentViewOverlays(R._context);R.viewParts.push(B),
B.addDynamicOverlay(new h.CurrentLineHighlightOverlay(R._context)),B.addDynamicOverlay(new N.SelectionsOverlay(R._context)),B.addDynamicOverlay(new v.IndentGuidesOverlay(R._context)),B.addDynamicOverlay(new f.DecorationsOverlay(R._context));var H=new u.MarginViewOverlays(R._context);R.viewParts.push(H),H.addDynamicOverlay(new p.CurrentLineMarginHighlightOverlay(R._context)),H.addDynamicOverlay(new m.GlyphMarginOverlay(R._context)),H.addDynamicOverlay(new S.MarginViewLineDecorationsOverlay(R._context)),H.addDynamicOverlay(new b.LinesDecorationsOverlay(R._context)),H.addDynamicOverlay(new _.LineNumbersOverlay(R._context));var z=new C.Margin(R._context);z.getDomNode().appendChild(R.viewZones.marginDomNode),z.getDomNode().appendChild(H.getDomNode()),R.viewParts.push(z),R.contentWidgets=new c.ViewContentWidgets(R._context,R.domNode),R.viewParts.push(R.contentWidgets),R.viewCursors=new M.ViewCursors(R._context),R.viewParts.push(R.viewCursors),R.overlayWidgets=new E.ViewOverlayWidgets(R._context),
R.viewParts.push(R.overlayWidgets);var K=new D.Rulers(R._context);R.viewParts.push(K);var U=new w.Minimap(R._context);if(R.viewParts.push(U),W){var j=R._scrollbar.getOverviewRulerLayoutInfo();j.parent.insertBefore(W.getDomNode(),j.insertBefore)}return R.linesContent.appendChild(B.getDomNode()),R.linesContent.appendChild(K.domNode),R.linesContent.appendChild(R.viewZones.domNode),R.linesContent.appendChild(R.viewLines.getDomNode()),R.linesContent.appendChild(R.contentWidgets.domNode),R.linesContent.appendChild(R.viewCursors.getDomNode()),R.overflowGuardContainer.appendChild(z.getDomNode()),R.overflowGuardContainer.appendChild(R._scrollbar.getDomNode()),R.overflowGuardContainer.appendChild(V.getDomNode()),R.overflowGuardContainer.appendChild(R._textAreaHandler.textArea),R.overflowGuardContainer.appendChild(R._textAreaHandler.textAreaCover),R.overflowGuardContainer.appendChild(R.overlayWidgets.getDomNode()),R.overflowGuardContainer.appendChild(U.getDomNode()),R.domNode.appendChild(R.overflowGuardContainer),
R.domNode.appendChild(R.contentWidgets.overflowingContentWidgetsDomNode),R._setLayout(),R.pointerHandler=R._register(new s.PointerHandler(R._context,F,R.createPointerHandlerHelper())),R._register(r.addEventListener(function(e){R.eventDispatcher.emitMany(e)})),R._register(R._cursor.addEventListener(function(e){R.eventDispatcher.emitMany(e)})),R}return r(t,e),t.prototype._flushAccumulatedAndRenderNow=function(){this._renderNow()},t.prototype.createPointerHandlerHelper=function(){var e=this;return{viewDomNode:this.domNode.domNode,linesContentDomNode:this.linesContent.domNode,focusTextArea:function(){e.focus()},getLastViewCursorsRenderData:function(){return e.viewCursors.getLastRenderData()||[]},shouldSuppressMouseDownOnViewZone:function(t){return e.viewZones.shouldSuppressMouseDownOnViewZone(t)},shouldSuppressMouseDownOnWidget:function(t){return e.contentWidgets.shouldSuppressMouseDownOnWidget(t)},getPositionFromDOMInfo:function(t,i){return e._flushAccumulatedAndRenderNow(),
e.viewLines.getPositionFromDOMInfo(t,i)},visibleRangeForPosition2:function(t,i){return e._flushAccumulatedAndRenderNow(),e.viewLines.visibleRangeForPosition(new T.Position(t,i))},getLineWidth:function(t){return e._flushAccumulatedAndRenderNow(),e.viewLines.getLineWidth(t)}}},t.prototype.createTextAreaHandlerHelper=function(){var e=this;return{visibleRangeForPositionRelativeToEditor:function(t,i){return e._flushAccumulatedAndRenderNow(),e.viewLines.visibleRangeForPosition(new T.Position(t,i))}}},t.prototype._setLayout=function(){var e=this._context.configuration.editor.layoutInfo;this.domNode.setWidth(e.width),this.domNode.setHeight(e.height),this.overflowGuardContainer.setWidth(e.width),this.overflowGuardContainer.setHeight(e.height),this.linesContent.setWidth(1e6),this.linesContent.setHeight(1e6)},t.prototype.getEditorClassName=function(){var e=this._textAreaHandler.isFocused()?" focused":"";return this._context.configuration.editor.editorClassName+" "+V.getThemeTypeSelector(this._context.theme.type)+e},
t.prototype.onConfigurationChanged=function(e){return e.editorClassName&&this.domNode.setClassName(this.getEditorClassName()),e.layoutInfo&&this._setLayout(),!1},t.prototype.onFocusChanged=function(e){return this.domNode.setClassName(this.getEditorClassName()),this._context.model.setHasFocus(e.isFocused),e.isFocused?this.outgoingEvents.emitViewFocusGained():this.outgoingEvents.emitViewFocusLost(),!1},t.prototype.onScrollChanged=function(e){return this.outgoingEvents.emitScrollChanged(e),!1},t.prototype.onThemeChanged=function(e){return this.domNode.setClassName(this.getEditorClassName()),!1},t.prototype.dispose=function(){null!==this._renderAnimationFrame&&(this._renderAnimationFrame.dispose(),this._renderAnimationFrame=null),this.eventDispatcher.removeEventHandler(this),this.outgoingEvents.dispose(),this.viewLines.dispose();for(var t=0,i=this.viewParts.length;t<i;t++)this.viewParts[t].dispose();this.viewParts=[],e.prototype.dispose.call(this)},t.prototype._renderOnce=function(e){var t=B(e)
;return this._scheduleRender(),t},t.prototype._scheduleRender=function(){null===this._renderAnimationFrame&&(this._renderAnimationFrame=i.runAtThisOrScheduleAtNextAnimationFrame(this._onRenderScheduled.bind(this),100))},t.prototype._onRenderScheduled=function(){this._renderAnimationFrame=null,this._flushAccumulatedAndRenderNow()},t.prototype._renderNow=function(){var e=this;B(function(){return e._actualRender()})},t.prototype._getViewPartsToRender=function(){for(var e=[],t=0,i=0,n=this.viewParts.length;i<n;i++){var o=this.viewParts[i];o.shouldRender()&&(e[t++]=o)}return e},t.prototype._actualRender=function(){if(i.isInDOM(this.domNode.domNode)){var e=this._getViewPartsToRender();if(this.viewLines.shouldRender()||0!==e.length){var t=this._context.viewLayout.getLinesViewportData();this._context.model.setViewport(t.startLineNumber,t.endLineNumber,t.centeredLineNumber);var n=new F.ViewportData(this._cursor.getViewSelections(),t,this._context.viewLayout.getWhitespaceViewportData(),this._context.model)
;this.contentWidgets.shouldRender()&&this.contentWidgets.onBeforeRender(n),this.viewLines.shouldRender()&&(this.viewLines.renderText(n),this.viewLines.onDidRender(),e=this._getViewPartsToRender());for(var o=new R.RenderingContext(this._context.viewLayout,n,this.viewLines),r=0,s=e.length;r<s;r++){(a=e[r]).prepareRender(o)}for(var r=0,s=e.length;r<s;r++){var a=e[r];a.render(o),a.onDidRender()}}}},t.prototype.delegateVerticalScrollbarMouseDown=function(e){this._scrollbar.delegateVerticalScrollbarMouseDown(e)},t.prototype.restoreState=function(e){this._context.viewLayout.setScrollPositionNow({scrollTop:e.scrollTop}),this._context.model.tokenizeViewport(),this._renderNow(),this.viewLines.updateLineWidths(),this._context.viewLayout.setScrollPositionNow({scrollLeft:e.scrollLeft})},t.prototype.getOffsetForColumn=function(e,t){var i=this._context.model.validateModelPosition({lineNumber:e,column:t}),n=this._context.model.coordinatesConverter.convertModelPositionToViewPosition(i);this._flushAccumulatedAndRenderNow()
;var o=this.viewLines.visibleRangeForPosition(new T.Position(n.lineNumber,n.column));return o?o.left:-1},t.prototype.getTargetAtClientPoint=function(e,t){return this.pointerHandler.getTargetAtClientPoint(e,t)},t.prototype.createOverviewRuler=function(e){return new x.OverviewRuler(this._context,e)},t.prototype.change=function(e){var t=this,i=!1;return this._renderOnce(function(){var n={addZone:function(e){return i=!0,t.viewZones.addZone(e)},removeZone:function(e){e&&(i=t.viewZones.removeZone(e)||i)},layoutZone:function(e){e&&(i=t.viewZones.layoutZone(e)||i)}};!function(e,t){try{e(t)}catch(e){o.onUnexpectedError(e)}}(e,n),n.addZone=H,n.removeZone=H,n.layoutZone=H,i&&(t._context.viewLayout.onHeightMaybeChanged(),t._context.privateViewEventBus.emit(new A.ViewZonesChangedEvent))}),i},t.prototype.render=function(e,t){if(t){this.viewLines.forceShouldRender();for(var i=0,n=this.viewParts.length;i<n;i++){this.viewParts[i].forceShouldRender()}}e?this._flushAccumulatedAndRenderNow():this._scheduleRender()},
t.prototype.focus=function(){this._textAreaHandler.focusTextArea()},t.prototype.isFocused=function(){return this._textAreaHandler.isFocused()},t.prototype.addContentWidget=function(e){this.contentWidgets.addWidget(e.widget),this.layoutContentWidget(e),this._scheduleRender()},t.prototype.layoutContentWidget=function(e){var t=e.position?e.position.position:null,i=e.position?e.position.range||null:null,n=e.position?e.position.preference:null;this.contentWidgets.setWidgetPosition(e.widget,t,i,n),this._scheduleRender()},t.prototype.removeContentWidget=function(e){this.contentWidgets.removeWidget(e.widget),this._scheduleRender()},t.prototype.addOverlayWidget=function(e){this.overlayWidgets.addWidget(e.widget),this.layoutOverlayWidget(e),this._scheduleRender()},t.prototype.layoutOverlayWidget=function(e){var t=e.position?e.position.preference:null;this.overlayWidgets.setWidgetPosition(e.widget,t)&&this._scheduleRender()},t.prototype.removeOverlayWidget=function(e){this.overlayWidgets.removeWidget(e.widget),
this._scheduleRender()},t}(W.ViewEventHandler);t.View=z}),define(t[98],i([1,0,307,8,10,4,2,50,65,11,31,537,523,400,36,13,3,20,168,72,21,17,37,22,408,32,14,12,104,34,16,66,23,244,240]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M,k,T,R,O,P){"use strict";function A(e){return j+encodeURIComponent(e.toString())+q}Object.defineProperty(t,"__esModule",{value:!0});var F=0,W="showUnused",V=function(){function e(e,t,i,n,o,r){this.model=e,this.viewModel=t,this.cursor=i,this.view=n,this.hasRealView=o,this.listenersToRemove=r}return e.prototype.dispose=function(){a.dispose(this.listenersToRemove),this.model.onBeforeDetached(),this.hasRealView&&this.view.dispose(),this.cursor.dispose(),this.viewModel.dispose()},e}(),B=function(e){function t(t,i,n,r,a,l,u,d,c,p){var f=e.call(this)||this;f._onDidDispose=f._register(new s.Emitter),f.onDidDispose=f._onDidDispose.event,f._onDidChangeModelContent=f._register(new s.Emitter),f.onDidChangeModelContent=f._onDidChangeModelContent.event,
f._onDidChangeModelLanguage=f._register(new s.Emitter),f.onDidChangeModelLanguage=f._onDidChangeModelLanguage.event,f._onDidChangeModelLanguageConfiguration=f._register(new s.Emitter),f.onDidChangeModelLanguageConfiguration=f._onDidChangeModelLanguageConfiguration.event,f._onDidChangeModelOptions=f._register(new s.Emitter),f.onDidChangeModelOptions=f._onDidChangeModelOptions.event,f._onDidChangeModelDecorations=f._register(new s.Emitter),f.onDidChangeModelDecorations=f._onDidChangeModelDecorations.event,f._onDidChangeConfiguration=f._register(new s.Emitter),f.onDidChangeConfiguration=f._onDidChangeConfiguration.event,f._onDidChangeModel=f._register(new s.Emitter),f.onDidChangeModel=f._onDidChangeModel.event,f._onDidChangeCursorPosition=f._register(new s.Emitter),f.onDidChangeCursorPosition=f._onDidChangeCursorPosition.event,f._onDidChangeCursorSelection=f._register(new s.Emitter),f.onDidChangeCursorSelection=f._onDidChangeCursorSelection.event,f._onDidAttemptReadOnlyEdit=f._register(new s.Emitter),
f.onDidAttemptReadOnlyEdit=f._onDidAttemptReadOnlyEdit.event,f._onDidLayoutChange=f._register(new s.Emitter),f.onDidLayoutChange=f._onDidLayoutChange.event,f._editorTextFocus=f._register(new H),f.onDidFocusEditorText=f._editorTextFocus.onDidChangeToTrue,f.onDidBlurEditorText=f._editorTextFocus.onDidChangeToFalse,f._editorWidgetFocus=f._register(new H),f.onDidFocusEditorWidget=f._editorWidgetFocus.onDidChangeToTrue,f.onDidBlurEditorWidget=f._editorWidgetFocus.onDidChangeToFalse,f._onWillType=f._register(new s.Emitter),f.onWillType=f._onWillType.event,f._onDidType=f._register(new s.Emitter),f.onDidType=f._onDidType.event,f._onCompositionStart=f._register(new s.Emitter),f.onCompositionStart=f._onCompositionStart.event,f._onCompositionEnd=f._register(new s.Emitter),f.onCompositionEnd=f._onCompositionEnd.event,f._onDidPaste=f._register(new s.Emitter),f.onDidPaste=f._onDidPaste.event,f._onMouseUp=f._register(new s.Emitter),f.onMouseUp=f._onMouseUp.event,f._onMouseDown=f._register(new s.Emitter),
f.onMouseDown=f._onMouseDown.event,f._onMouseDrag=f._register(new s.Emitter),f.onMouseDrag=f._onMouseDrag.event,f._onMouseDrop=f._register(new s.Emitter),f.onMouseDrop=f._onMouseDrop.event,f._onContextMenu=f._register(new s.Emitter),f.onContextMenu=f._onContextMenu.event,f._onMouseMove=f._register(new s.Emitter),f.onMouseMove=f._onMouseMove.event,f._onMouseLeave=f._register(new s.Emitter),f.onMouseLeave=f._onMouseLeave.event,f._onMouseWheel=f._register(new s.Emitter),f.onMouseWheel=f._onMouseWheel.event,f._onKeyUp=f._register(new s.Emitter),f.onKeyUp=f._onKeyUp.event,f._onKeyDown=f._register(new s.Emitter),f.onKeyDown=f._onKeyDown.event,f._onDidScrollChange=f._register(new s.Emitter),f.onDidScrollChange=f._onDidScrollChange.event,f._onDidChangeViewZones=f._register(new s.Emitter),f.onDidChangeViewZones=f._onDidChangeViewZones.event,f._domElement=t,f._id=++F,f._decorationTypeKeysToIds={},f._decorationTypeSubtypes={},f.isSimpleWidget=n.isSimpleWidget||!1,f._telemetryData=n.telemetryData,i=i||{},
f._configuration=f._register(f._createConfiguration(i,p)),f._register(f._configuration.onDidChange(function(e){f._onDidChangeConfiguration.fire(e),e.layoutInfo&&f._onDidLayoutChange.fire(f._configuration.editor.layoutInfo),f._configuration.editor.showUnused?f._domElement.classList.add(W):f._domElement.classList.remove(W)})),f._contextKeyService=f._register(u.createScoped(f._domElement)),f._notificationService=c,f._codeEditorService=a,f._commandService=l,f._themeService=d,f._register(new z(f,f._contextKeyService)),f._register(new K(f,f._contextKeyService)),f._instantiationService=r.createChild(new k.ServiceCollection([N.IContextKeyService,f._contextKeyService])),f._modelData=null,f._contributions={},f._actions={},f._focusTracker=new U(t),f._focusTracker.onChange(function(){f._editorWidgetFocus.setValue(f._focusTracker.hasFocus())}),f._contentWidgets={},f._overlayWidgets={};for(var g,m=0,v=(g=Array.isArray(n.contributions)?n.contributions:h.EditorExtensionsRegistry.getEditorContributions()).length;m<v;m++){
var _=g[m];try{var y=f._instantiationService.createInstance(_,f);f._contributions[y.getId()]=y}catch(e){o.onUnexpectedError(e)}}return h.EditorExtensionsRegistry.getEditorActions().forEach(function(e){var t=new C.InternalEditorAction(e.id,e.label,e.alias,P.withNullAsUndefined(e.precondition),function(){return f._instantiationService.invokeFunction(function(t){return Promise.resolve(e.runEditorCommand(t,f,null))})},f._contextKeyService);f._actions[t.id]=t}),f._codeEditorService.addCodeEditor(f),f}return r(t,e),t.prototype._createConfiguration=function(e,t){return new u.Configuration(this.isSimpleWidget,e,this._domElement,t)},t.prototype.getId=function(){return this.getEditorType()+":"+this._id},t.prototype.getEditorType=function(){return S.EditorType.ICodeEditor},t.prototype.dispose=function(){this._codeEditorService.removeCodeEditor(this),this._focusTracker.dispose();for(var t=Object.keys(this._contributions),i=0,n=t.length;i<n;i++){var o=t[i];this._contributions[o].dispose()}this._removeDecorationTypes(),
this._postDetachModelCleanup(this._detachModel()),this._onDidDispose.fire(),e.prototype.dispose.call(this)},t.prototype.invokeWithinContext=function(e){return this._instantiationService.invokeFunction(e)},t.prototype.updateOptions=function(e){this._configuration.updateOptions(e)},t.prototype.getConfiguration=function(){return this._configuration.editor},t.prototype.getRawConfiguration=function(){return this._configuration.getRawOptions()},t.prototype.getValue=function(e){if(void 0===e&&(e=null),!this._modelData)return"";var t=!(!e||!e.preserveBOM),i=0;return e&&e.lineEnding&&"\n"===e.lineEnding?i=1:e&&e.lineEnding&&"\r\n"===e.lineEnding&&(i=2),this._modelData.model.getValue(i,t)},t.prototype.setValue=function(e){this._modelData&&this._modelData.model.setValue(e)},t.prototype.getModel=function(){return this._modelData?this._modelData.model:null},t.prototype.setModel=function(e){void 0===e&&(e=null);var t=e;if(!(null===this._modelData&&null===t||this._modelData&&this._modelData.model===t)){
var i=this._detachModel();this._attachModel(t);var n={oldModelUrl:i?i.uri:null,newModelUrl:t?t.uri:null};this._removeDecorationTypes(),this._onDidChangeModel.fire(n),this._postDetachModelCleanup(i)}},t.prototype._removeDecorationTypes=function(){if(this._decorationTypeKeysToIds={},this._decorationTypeSubtypes){for(var e in this._decorationTypeSubtypes){var t=this._decorationTypeSubtypes[e];for(var i in t)this._removeDecorationType(e+"-"+i)}this._decorationTypeSubtypes={}}},t.prototype.getVisibleRanges=function(){return this._modelData?this._modelData.viewModel.getVisibleRanges():[]},t.prototype.getWhitespaces=function(){return this._modelData?this._modelData.viewModel.viewLayout.getWhitespaces():[]},t._getVerticalOffsetForPosition=function(e,t,i){var n=e.model.validatePosition({lineNumber:t,column:i}),o=e.viewModel.coordinatesConverter.convertModelPositionToViewPosition(n);return e.viewModel.viewLayout.getVerticalOffsetForLineNumber(o.lineNumber)},t.prototype.getTopForLineNumber=function(e){
return this._modelData?t._getVerticalOffsetForPosition(this._modelData,e,1):-1},t.prototype.getTopForPosition=function(e,i){return this._modelData?t._getVerticalOffsetForPosition(this._modelData,e,i):-1},t.prototype.setHiddenAreas=function(e){this._modelData&&this._modelData.viewModel.setHiddenAreas(e.map(function(e){return y.Range.lift(e)}))},t.prototype.getVisibleColumnFromPosition=function(e){if(!this._modelData)return e.column;var t=this._modelData.model.validatePosition(e),i=this._modelData.model.getOptions().tabSize;return v.CursorColumns.visibleColumnFromColumn(this._modelData.model.getLineContent(t.lineNumber),t.column,i)+1},t.prototype.getPosition=function(){return this._modelData?this._modelData.cursor.getPosition():null},t.prototype.setPosition=function(e){if(this._modelData){if(!_.Position.isIPosition(e))throw new Error("Invalid arguments");this._modelData.cursor.setSelections("api",[{selectionStartLineNumber:e.lineNumber,selectionStartColumn:e.column,positionLineNumber:e.lineNumber,
positionColumn:e.column}])}},t.prototype._sendRevealRange=function(e,t,i,n){if(this._modelData){if(!y.Range.isIRange(e))throw new Error("Invalid arguments");var o=this._modelData.model.validateRange(e),r=this._modelData.viewModel.coordinatesConverter.convertModelRangeToViewRange(o);this._modelData.cursor.emitCursorRevealRange(r,t,i,n)}},t.prototype.revealLine=function(e,t){void 0===t&&(t=0),this._revealLine(e,0,t)},t.prototype.revealLineInCenter=function(e,t){void 0===t&&(t=0),this._revealLine(e,1,t)},t.prototype.revealLineInCenterIfOutsideViewport=function(e,t){void 0===t&&(t=0),this._revealLine(e,2,t)},t.prototype._revealLine=function(e,t,i){if("number"!=typeof e)throw new Error("Invalid arguments");this._sendRevealRange(new y.Range(e,1,e,1),t,!1,i)},t.prototype.revealPosition=function(e,t){void 0===t&&(t=0),this._revealPosition(e,0,!0,t)},t.prototype.revealPositionInCenter=function(e,t){void 0===t&&(t=0),this._revealPosition(e,1,!0,t)},t.prototype.revealPositionInCenterIfOutsideViewport=function(e,t){
void 0===t&&(t=0),this._revealPosition(e,2,!0,t)},t.prototype._revealPosition=function(e,t,i,n){if(!_.Position.isIPosition(e))throw new Error("Invalid arguments");this._sendRevealRange(new y.Range(e.lineNumber,e.column,e.lineNumber,e.column),t,i,n)},t.prototype.getSelection=function(){return this._modelData?this._modelData.cursor.getSelection():null},t.prototype.getSelections=function(){return this._modelData?this._modelData.cursor.getSelections():null},t.prototype.setSelection=function(e){var t=b.Selection.isISelection(e),i=y.Range.isIRange(e);if(!t&&!i)throw new Error("Invalid arguments");if(t)this._setSelectionImpl(e);else if(i){var n={selectionStartLineNumber:e.startLineNumber,selectionStartColumn:e.startColumn,positionLineNumber:e.endLineNumber,positionColumn:e.endColumn};this._setSelectionImpl(n)}},t.prototype._setSelectionImpl=function(e){if(this._modelData){var t=new b.Selection(e.selectionStartLineNumber,e.selectionStartColumn,e.positionLineNumber,e.positionColumn)
;this._modelData.cursor.setSelections("api",[t])}},t.prototype.revealLines=function(e,t,i){void 0===i&&(i=0),this._revealLines(e,t,0,i)},t.prototype.revealLinesInCenter=function(e,t,i){void 0===i&&(i=0),this._revealLines(e,t,1,i)},t.prototype.revealLinesInCenterIfOutsideViewport=function(e,t,i){void 0===i&&(i=0),this._revealLines(e,t,2,i)},t.prototype._revealLines=function(e,t,i,n){if("number"!=typeof e||"number"!=typeof t)throw new Error("Invalid arguments");this._sendRevealRange(new y.Range(e,1,t,1),i,!1,n)},t.prototype.revealRange=function(e,t,i,n){void 0===t&&(t=0),void 0===i&&(i=!1),void 0===n&&(n=!0),this._revealRange(e,i?1:0,n,t)},t.prototype.revealRangeInCenter=function(e,t){void 0===t&&(t=0),this._revealRange(e,1,!0,t)},t.prototype.revealRangeInCenterIfOutsideViewport=function(e,t){void 0===t&&(t=0),this._revealRange(e,2,!0,t)},t.prototype.revealRangeAtTop=function(e,t){void 0===t&&(t=0),this._revealRange(e,3,!0,t)},t.prototype._revealRange=function(e,t,i,n){
if(!y.Range.isIRange(e))throw new Error("Invalid arguments");this._sendRevealRange(y.Range.lift(e),t,i,n)},t.prototype.setSelections=function(e,t){if(void 0===t&&(t="api"),this._modelData){if(!e||0===e.length)throw new Error("Invalid arguments");for(var i=0,n=e.length;i<n;i++)if(!b.Selection.isISelection(e[i]))throw new Error("Invalid arguments");this._modelData.cursor.setSelections(t,e)}},t.prototype.getScrollWidth=function(){return this._modelData?this._modelData.viewModel.viewLayout.getScrollWidth():-1},t.prototype.getScrollLeft=function(){return this._modelData?this._modelData.viewModel.viewLayout.getCurrentScrollLeft():-1},t.prototype.getScrollHeight=function(){return this._modelData?this._modelData.viewModel.viewLayout.getScrollHeight():-1},t.prototype.getScrollTop=function(){return this._modelData?this._modelData.viewModel.viewLayout.getCurrentScrollTop():-1},t.prototype.setScrollLeft=function(e){if(this._modelData){if("number"!=typeof e)throw new Error("Invalid arguments")
;this._modelData.viewModel.viewLayout.setScrollPositionNow({scrollLeft:e})}},t.prototype.setScrollTop=function(e){if(this._modelData){if("number"!=typeof e)throw new Error("Invalid arguments");this._modelData.viewModel.viewLayout.setScrollPositionNow({scrollTop:e})}},t.prototype.setScrollPosition=function(e){this._modelData&&this._modelData.viewModel.viewLayout.setScrollPositionNow(e)},t.prototype.saveViewState=function(){if(!this._modelData)return null;for(var e={},t=0,i=Object.keys(this._contributions);t<i.length;t++){var n=i[t],o=this._contributions[n];"function"==typeof o.saveViewState&&(e[n]=o.saveViewState())}return{cursorState:this._modelData.cursor.saveState(),viewState:this._modelData.viewModel.saveState(),contributionsState:e}},t.prototype.restoreViewState=function(e){if(this._modelData&&this._modelData.hasRealView){var t=e;if(t&&t.cursorState&&t.viewState){var i=t.cursorState;Array.isArray(i)?this._modelData.cursor.restoreState(i):this._modelData.cursor.restoreState([i])
;for(var n=t.contributionsState||{},o=Object.keys(this._contributions),r=0,s=o.length;r<s;r++){var a=o[r],l=this._contributions[a];"function"==typeof l.restoreViewState&&l.restoreViewState(n[a])}var u=this._modelData.viewModel.reduceRestoreState(t.viewState);this._modelData.view.restoreState(u)}}},t.prototype.getContribution=function(e){return this._contributions[e]||null},t.prototype.getActions=function(){for(var e=[],t=Object.keys(this._actions),i=0,n=t.length;i<n;i++){var o=t[i];e.push(this._actions[o])}return e},t.prototype.getSupportedActions=function(){var e=this.getActions();return e=e.filter(function(e){return e.isSupported()})},t.prototype.getAction=function(e){return this._actions[e]||null},t.prototype.trigger=function(e,t,i){if(i=i||{},t===S.Handler.Type){if(!this._modelData||"string"!=typeof i.text||0===i.text.length)return;return"keyboard"===e&&this._onWillType.fire(i.text),this._modelData.cursor.trigger(e,t,i),void("keyboard"===e&&this._onDidType.fire(i.text))}if(t!==S.Handler.Paste){
t===S.Handler.CompositionStart&&this._onCompositionStart.fire(),t===S.Handler.CompositionEnd&&this._onCompositionEnd.fire();var n=this.getAction(t);n?Promise.resolve(n.run()).then(void 0,o.onUnexpectedError):this._modelData&&(this._triggerEditorCommand(e,t,i)||this._modelData.cursor.trigger(e,t,i))}else{if(!this._modelData||"string"!=typeof i.text||0===i.text.length)return;var r=this._modelData.cursor.getSelection().getStartPosition();this._modelData.cursor.trigger(e,t,i);var s=this._modelData.cursor.getSelection().getStartPosition();"keyboard"===e&&this._onDidPaste.fire(new y.Range(r.lineNumber,r.column,s.lineNumber,s.column))}},t.prototype._triggerEditorCommand=function(e,t,i){var n=this,r=h.EditorExtensionsRegistry.getEditorCommand(t);return!!r&&(i=i||{},i.source=e,this._instantiationService.invokeFunction(function(e){Promise.resolve(r.runEditorCommand(e,n,i)).then(void 0,o.onUnexpectedError)}),!0)},t.prototype._getCursors=function(){return this._modelData?this._modelData.cursor:null},
t.prototype.pushUndoStop=function(){return!!this._modelData&&(!this._configuration.editor.readOnly&&(this._modelData.model.pushStackElement(),!0))},t.prototype.executeEdits=function(e,t,i){if(!this._modelData)return!1;if(this._configuration.editor.readOnly)return!1;var n;return n=i?Array.isArray(i)?function(){return i}:i:function(){return null},this._modelData.cursor.executeEdits(e,t,n),!0},t.prototype.executeCommand=function(e,t){this._modelData&&this._modelData.cursor.trigger(e,S.Handler.ExecuteCommand,t)},t.prototype.executeCommands=function(e,t){this._modelData&&this._modelData.cursor.trigger(e,S.Handler.ExecuteCommands,t)},t.prototype.changeDecorations=function(e){return this._modelData?this._modelData.model.changeDecorations(e,this._id):null},t.prototype.getLineDecorations=function(e){return this._modelData?this._modelData.model.getLineDecorations(e,this._id,this._configuration.editor.readOnly):null},t.prototype.deltaDecorations=function(e,t){
return this._modelData?0===e.length&&0===t.length?e:this._modelData.model.deltaDecorations(e,t,this._id):[]},t.prototype.removeDecorations=function(e){var t=this._decorationTypeKeysToIds[e];t&&this.deltaDecorations(t,[]),this._decorationTypeKeysToIds.hasOwnProperty(e)&&delete this._decorationTypeKeysToIds[e],this._decorationTypeSubtypes.hasOwnProperty(e)&&delete this._decorationTypeSubtypes[e]},t.prototype.getLayoutInfo=function(){return this._configuration.editor.layoutInfo},t.prototype.createOverviewRuler=function(e){return this._modelData&&this._modelData.hasRealView?this._modelData.view.createOverviewRuler(e):null},t.prototype.getDomNode=function(){return this._modelData&&this._modelData.hasRealView?this._modelData.view.domNode.domNode:null},t.prototype.delegateVerticalScrollbarMouseDown=function(e){this._modelData&&this._modelData.hasRealView&&this._modelData.view.delegateVerticalScrollbarMouseDown(e)},t.prototype.layout=function(e){this._configuration.observeReferenceElement(e),this.render()},
t.prototype.focus=function(){this._modelData&&this._modelData.hasRealView&&this._modelData.view.focus()},t.prototype.hasTextFocus=function(){return!(!this._modelData||!this._modelData.hasRealView)&&this._modelData.view.isFocused()},t.prototype.hasWidgetFocus=function(){return this._focusTracker&&this._focusTracker.hasFocus()},t.prototype.addContentWidget=function(e){var t={widget:e,position:e.getPosition()};this._contentWidgets.hasOwnProperty(e.getId())&&console.warn("Overwriting a content widget with the same id."),this._contentWidgets[e.getId()]=t,this._modelData&&this._modelData.hasRealView&&this._modelData.view.addContentWidget(t)},t.prototype.layoutContentWidget=function(e){var t=e.getId();if(this._contentWidgets.hasOwnProperty(t)){var i=this._contentWidgets[t];i.position=e.getPosition(),this._modelData&&this._modelData.hasRealView&&this._modelData.view.layoutContentWidget(i)}},t.prototype.removeContentWidget=function(e){var t=e.getId();if(this._contentWidgets.hasOwnProperty(t)){
var i=this._contentWidgets[t];delete this._contentWidgets[t],this._modelData&&this._modelData.hasRealView&&this._modelData.view.removeContentWidget(i)}},t.prototype.addOverlayWidget=function(e){var t={widget:e,position:e.getPosition()};this._overlayWidgets.hasOwnProperty(e.getId())&&console.warn("Overwriting an overlay widget with the same id."),this._overlayWidgets[e.getId()]=t,this._modelData&&this._modelData.hasRealView&&this._modelData.view.addOverlayWidget(t)},t.prototype.layoutOverlayWidget=function(e){var t=e.getId();if(this._overlayWidgets.hasOwnProperty(t)){var i=this._overlayWidgets[t];i.position=e.getPosition(),this._modelData&&this._modelData.hasRealView&&this._modelData.view.layoutOverlayWidget(i)}},t.prototype.removeOverlayWidget=function(e){var t=e.getId();if(this._overlayWidgets.hasOwnProperty(t)){var i=this._overlayWidgets[t];delete this._overlayWidgets[t],this._modelData&&this._modelData.hasRealView&&this._modelData.view.removeOverlayWidget(i)}},t.prototype.changeViewZones=function(e){
if(this._modelData&&this._modelData.hasRealView){this._modelData.view.change(e)&&this._onDidChangeViewZones.fire()}},t.prototype.getTargetAtClientPoint=function(e,t){return this._modelData&&this._modelData.hasRealView?this._modelData.view.getTargetAtClientPoint(e,t):null},t.prototype.getScrolledVisiblePosition=function(e){if(!this._modelData||!this._modelData.hasRealView)return null;var i=this._modelData.model.validatePosition(e),n=this._configuration.editor.layoutInfo;return{top:t._getVerticalOffsetForPosition(this._modelData,i.lineNumber,i.column)-this.getScrollTop(),left:this._modelData.view.getOffsetForColumn(i.lineNumber,i.column)+n.glyphMarginWidth+n.lineNumbersWidth+n.decorationsWidth-this.getScrollLeft(),height:this._configuration.editor.lineHeight}},t.prototype.getOffsetForColumn=function(e,t){return this._modelData&&this._modelData.hasRealView?this._modelData.view.getOffsetForColumn(e,t):-1},t.prototype.render=function(e){void 0===e&&(e=!1),
this._modelData&&this._modelData.hasRealView&&this._modelData.view.render(!0,e)},t.prototype.applyFontInfo=function(e){u.Configuration.applyFontInfoSlow(e,this._configuration.editor.fontInfo)},t.prototype._attachModel=function(e){var t=this;if(e){var o=[];this._domElement.setAttribute("data-mode-id",e.getLanguageIdentifier().language),this._configuration.setIsDominatedByLongLines(e.isDominatedByLongLines()),this._configuration.setMaxLineNumber(e.getLineCount()),e.onBeforeAttached();var r=new D.ViewModel(this._id,this._configuration,e,function(e){return n.scheduleAtNextAnimationFrame(e)});o.push(e.onDidChangeDecorations(function(e){return t._onDidChangeModelDecorations.fire(e)})),o.push(e.onDidChangeLanguage(function(i){t._domElement.setAttribute("data-mode-id",e.getLanguageIdentifier().language),t._onDidChangeModelLanguage.fire(i)})),o.push(e.onDidChangeLanguageConfiguration(function(e){return t._onDidChangeModelLanguageConfiguration.fire(e)})),o.push(e.onDidChangeContent(function(e){
return t._onDidChangeModelContent.fire(e)})),o.push(e.onDidChangeOptions(function(e){return t._onDidChangeModelOptions.fire(e)})),o.push(e.onWillDispose(function(){return t.setModel(null)}));var s=new m.Cursor(this._configuration,e,r);o.push(s.onDidReachMaxCursorCount(function(){t._notificationService.warn(i.localize(0,null,m.Cursor.MAX_CURSOR_COUNT))})),o.push(s.onDidAttemptReadOnlyEdit(function(){t._onDidAttemptReadOnlyEdit.fire(void 0)})),o.push(s.onDidChange(function(e){for(var i=[],n=0,o=e.selections.length;n<o;n++)i[n]=e.selections[n].getPosition();var r={position:i[0],secondaryPositions:i.slice(1),reason:e.reason,source:e.source};t._onDidChangeCursorPosition.fire(r);var s={selection:e.selections[0],secondarySelections:e.selections.slice(1),source:e.source,reason:e.reason};t._onDidChangeCursorSelection.fire(s)}));var a=this._createView(r,s),l=a[0],u=a[1];if(u){this._domElement.appendChild(l.domNode.domNode);for(var d=Object.keys(this._contentWidgets),c=0,h=d.length;c<h;c++){p=d[c]
;l.addContentWidget(this._contentWidgets[p])}for(var c=0,h=(d=Object.keys(this._overlayWidgets)).length;c<h;c++){var p=d[c];l.addOverlayWidget(this._overlayWidgets[p])}l.render(!1,!0),l.domNode.domNode.setAttribute("data-uri",e.uri.toString())}this._modelData=new V(e,r,s,l,u,o)}else this._modelData=null},t.prototype._createView=function(e,t){var i,n=this;i=this.isSimpleWidget?{executeEditorCommand:function(e,i){e.runCoreEditorCommand(t,i)},paste:function(e,t,i,o){n.trigger(e,S.Handler.Paste,{text:t,pasteOnNewLine:i,multicursorText:o})},type:function(e,t){n.trigger(e,S.Handler.Type,{text:t})},replacePreviousChar:function(e,t,i){n.trigger(e,S.Handler.ReplacePreviousChar,{text:t,replaceCharCnt:i})},compositionStart:function(e){n.trigger(e,S.Handler.CompositionStart,void 0)},compositionEnd:function(e){n.trigger(e,S.Handler.CompositionEnd,void 0)},cut:function(e){n.trigger(e,S.Handler.Cut,void 0)}}:{executeEditorCommand:function(e,i){e.runCoreEditorCommand(t,i)},paste:function(e,t,i,o){
n._commandService.executeCommand(S.Handler.Paste,{text:t,pasteOnNewLine:i,multicursorText:o})},type:function(e,t){n._commandService.executeCommand(S.Handler.Type,{text:t})},replacePreviousChar:function(e,t,i){n._commandService.executeCommand(S.Handler.ReplacePreviousChar,{text:t,replaceCharCnt:i})},compositionStart:function(e){n._commandService.executeCommand(S.Handler.CompositionStart,{})},compositionEnd:function(e){n._commandService.executeCommand(S.Handler.CompositionEnd,{})},cut:function(e){n._commandService.executeCommand(S.Handler.Cut,{})}};var o=new g.ViewOutgoingEvents(e);o.onDidGainFocus=function(){n._editorTextFocus.setValue(!0),n._editorWidgetFocus.setValue(!0)},o.onDidScroll=function(e){return n._onDidScrollChange.fire(e)},o.onDidLoseFocus=function(){return n._editorTextFocus.setValue(!1)},o.onContextMenu=function(e){return n._onContextMenu.fire(e)},o.onMouseDown=function(e){return n._onMouseDown.fire(e)},o.onMouseUp=function(e){return n._onMouseUp.fire(e)},o.onMouseDrag=function(e){
return n._onMouseDrag.fire(e)},o.onMouseDrop=function(e){return n._onMouseDrop.fire(e)},o.onKeyUp=function(e){return n._onKeyUp.fire(e)},o.onMouseMove=function(e){return n._onMouseMove.fire(e)},o.onMouseLeave=function(e){return n._onMouseLeave.fire(e)},o.onMouseWheel=function(e){return n._onMouseWheel.fire(e)},o.onKeyDown=function(e){return n._onKeyDown.fire(e)};return[new f.View(i,this._configuration,this._themeService,e,t,o),!0]},t.prototype._postDetachModelCleanup=function(e){e&&e.removeAllDecorationsWithOwnerId(this._id)},t.prototype._detachModel=function(){if(!this._modelData)return null;var e=this._modelData.model,t=this._modelData.hasRealView?this._modelData.view.domNode.domNode:null;return this._modelData.dispose(),this._modelData=null,this._domElement.removeAttribute("data-mode-id"),t&&this._domElement.removeChild(t),e},t.prototype._removeDecorationType=function(e){this._codeEditorService.removeDecorationType(e)},t.prototype.hasModel=function(){return null!==this._modelData},
t=d([c(3,M.IInstantiationService),c(4,p.ICodeEditorService),c(5,I.ICommandService),c(6,N.IContextKeyService),c(7,R.IThemeService),c(8,T.INotificationService),c(9,O.IAccessibilityService)],t)}(a.Disposable);t.CodeEditorWidget=B;var H=function(e){function t(){var t=e.call(this)||this;return t._onDidChangeToTrue=t._register(new s.Emitter),t.onDidChangeToTrue=t._onDidChangeToTrue.event,t._onDidChangeToFalse=t._register(new s.Emitter),t.onDidChangeToFalse=t._onDidChangeToFalse.event,t._value=0,t}return r(t,e),t.prototype.setValue=function(e){var t=e?2:1;this._value!==t&&(this._value=t,2===this._value?this._onDidChangeToTrue.fire():1===this._value&&this._onDidChangeToFalse.fire())},t}(a.Disposable);t.BooleanEventEmitter=H;var z=function(e){function t(t,i){var n=e.call(this)||this;return n._editor=t,i.createKey("editorId",t.getId()),n._editorFocus=w.EditorContextKeys.focus.bindTo(i),n._textInputFocus=w.EditorContextKeys.textInputFocus.bindTo(i),n._editorTextFocus=w.EditorContextKeys.editorTextFocus.bindTo(i),
n._editorTabMovesFocus=w.EditorContextKeys.tabMovesFocus.bindTo(i),n._editorReadonly=w.EditorContextKeys.readOnly.bindTo(i),n._hasMultipleSelections=w.EditorContextKeys.hasMultipleSelections.bindTo(i),n._hasNonEmptySelection=w.EditorContextKeys.hasNonEmptySelection.bindTo(i),n._canUndo=w.EditorContextKeys.canUndo.bindTo(i),n._canRedo=w.EditorContextKeys.canRedo.bindTo(i),n._register(n._editor.onDidChangeConfiguration(function(){return n._updateFromConfig()})),n._register(n._editor.onDidChangeCursorSelection(function(){return n._updateFromSelection()})),n._register(n._editor.onDidFocusEditorWidget(function(){return n._updateFromFocus()})),n._register(n._editor.onDidBlurEditorWidget(function(){return n._updateFromFocus()})),n._register(n._editor.onDidFocusEditorText(function(){return n._updateFromFocus()})),n._register(n._editor.onDidBlurEditorText(function(){return n._updateFromFocus()})),n._register(n._editor.onDidChangeModel(function(){return n._updateFromModel()})),
n._register(n._editor.onDidChangeConfiguration(function(){return n._updateFromModel()})),n._updateFromConfig(),n._updateFromSelection(),n._updateFromFocus(),n._updateFromModel(),n}return r(t,e),t.prototype._updateFromConfig=function(){var e=this._editor.getConfiguration();this._editorTabMovesFocus.set(e.tabFocusMode),this._editorReadonly.set(e.readOnly)},t.prototype._updateFromSelection=function(){var e=this._editor.getSelections();e?(this._hasMultipleSelections.set(e.length>1),this._hasNonEmptySelection.set(e.some(function(e){return!e.isEmpty()}))):(this._hasMultipleSelections.reset(),this._hasNonEmptySelection.reset())},t.prototype._updateFromFocus=function(){this._editorFocus.set(this._editor.hasWidgetFocus()&&!this._editor.isSimpleWidget),this._editorTextFocus.set(this._editor.hasTextFocus()&&!this._editor.isSimpleWidget),this._textInputFocus.set(this._editor.hasTextFocus())},t.prototype._updateFromModel=function(){var e=this._editor.getModel();this._canUndo.set(Boolean(e&&e.canUndo())),
this._canRedo.set(Boolean(e&&e.canRedo()))},t}(a.Disposable),K=function(e){function t(t,i){var n=e.call(this)||this;n._editor=t,n._contextKeyService=i,n._langId=w.EditorContextKeys.languageId.bindTo(i),n._hasCompletionItemProvider=w.EditorContextKeys.hasCompletionItemProvider.bindTo(i),n._hasCodeActionsProvider=w.EditorContextKeys.hasCodeActionsProvider.bindTo(i),n._hasCodeLensProvider=w.EditorContextKeys.hasCodeLensProvider.bindTo(i),n._hasDefinitionProvider=w.EditorContextKeys.hasDefinitionProvider.bindTo(i),n._hasDeclarationProvider=w.EditorContextKeys.hasDeclarationProvider.bindTo(i),n._hasImplementationProvider=w.EditorContextKeys.hasImplementationProvider.bindTo(i),n._hasTypeDefinitionProvider=w.EditorContextKeys.hasTypeDefinitionProvider.bindTo(i),n._hasHoverProvider=w.EditorContextKeys.hasHoverProvider.bindTo(i),n._hasDocumentHighlightProvider=w.EditorContextKeys.hasDocumentHighlightProvider.bindTo(i),n._hasDocumentSymbolProvider=w.EditorContextKeys.hasDocumentSymbolProvider.bindTo(i),
n._hasReferenceProvider=w.EditorContextKeys.hasReferenceProvider.bindTo(i),n._hasRenameProvider=w.EditorContextKeys.hasRenameProvider.bindTo(i),n._hasSignatureHelpProvider=w.EditorContextKeys.hasSignatureHelpProvider.bindTo(i),n._hasDocumentFormattingProvider=w.EditorContextKeys.hasDocumentFormattingProvider.bindTo(i),n._hasDocumentSelectionFormattingProvider=w.EditorContextKeys.hasDocumentSelectionFormattingProvider.bindTo(i),n._hasMultipleDocumentFormattingProvider=w.EditorContextKeys.hasMultipleDocumentFormattingProvider.bindTo(i),n._hasMultipleDocumentSelectionFormattingProvider=w.EditorContextKeys.hasMultipleDocumentSelectionFormattingProvider.bindTo(i),n._isInWalkThrough=w.EditorContextKeys.isInEmbeddedEditor.bindTo(i);var o=function(){return n._update()};return n._register(t.onDidChangeModel(o)),n._register(t.onDidChangeModelLanguage(o)),n._register(E.CompletionProviderRegistry.onDidChange(o)),n._register(E.CodeActionProviderRegistry.onDidChange(o)),
n._register(E.CodeLensProviderRegistry.onDidChange(o)),n._register(E.DefinitionProviderRegistry.onDidChange(o)),n._register(E.DeclarationProviderRegistry.onDidChange(o)),n._register(E.ImplementationProviderRegistry.onDidChange(o)),n._register(E.TypeDefinitionProviderRegistry.onDidChange(o)),n._register(E.HoverProviderRegistry.onDidChange(o)),n._register(E.DocumentHighlightProviderRegistry.onDidChange(o)),n._register(E.DocumentSymbolProviderRegistry.onDidChange(o)),n._register(E.ReferenceProviderRegistry.onDidChange(o)),n._register(E.RenameProviderRegistry.onDidChange(o)),n._register(E.DocumentFormattingEditProviderRegistry.onDidChange(o)),n._register(E.DocumentRangeFormattingEditProviderRegistry.onDidChange(o)),n._register(E.SignatureHelpProviderRegistry.onDidChange(o)),o(),n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.reset=function(){var e=this;this._contextKeyService.bufferChangeEvents(function(){e._langId.reset(),e._hasCompletionItemProvider.reset(),
e._hasCodeActionsProvider.reset(),e._hasCodeLensProvider.reset(),e._hasDefinitionProvider.reset(),e._hasDeclarationProvider.reset(),e._hasImplementationProvider.reset(),e._hasTypeDefinitionProvider.reset(),e._hasHoverProvider.reset(),e._hasDocumentHighlightProvider.reset(),e._hasDocumentSymbolProvider.reset(),e._hasReferenceProvider.reset(),e._hasRenameProvider.reset(),e._hasDocumentFormattingProvider.reset(),e._hasDocumentSelectionFormattingProvider.reset(),e._hasSignatureHelpProvider.reset(),e._isInWalkThrough.reset()})},t.prototype._update=function(){var e=this,t=this._editor.getModel();t?this._contextKeyService.bufferChangeEvents(function(){e._langId.set(t.getLanguageIdentifier().language),e._hasCompletionItemProvider.set(E.CompletionProviderRegistry.has(t)),e._hasCodeActionsProvider.set(E.CodeActionProviderRegistry.has(t)),e._hasCodeLensProvider.set(E.CodeLensProviderRegistry.has(t)),e._hasDefinitionProvider.set(E.DefinitionProviderRegistry.has(t)),
e._hasDeclarationProvider.set(E.DeclarationProviderRegistry.has(t)),e._hasImplementationProvider.set(E.ImplementationProviderRegistry.has(t)),e._hasTypeDefinitionProvider.set(E.TypeDefinitionProviderRegistry.has(t)),e._hasHoverProvider.set(E.HoverProviderRegistry.has(t)),e._hasDocumentHighlightProvider.set(E.DocumentHighlightProviderRegistry.has(t)),e._hasDocumentSymbolProvider.set(E.DocumentSymbolProviderRegistry.has(t)),e._hasReferenceProvider.set(E.ReferenceProviderRegistry.has(t)),e._hasRenameProvider.set(E.RenameProviderRegistry.has(t)),e._hasSignatureHelpProvider.set(E.SignatureHelpProviderRegistry.has(t)),e._hasDocumentFormattingProvider.set(E.DocumentFormattingEditProviderRegistry.has(t)||E.DocumentRangeFormattingEditProviderRegistry.has(t)),e._hasDocumentSelectionFormattingProvider.set(E.DocumentRangeFormattingEditProviderRegistry.has(t)),e._hasMultipleDocumentFormattingProvider.set(E.DocumentFormattingEditProviderRegistry.all(t).length+E.DocumentRangeFormattingEditProviderRegistry.all(t).length>1),
e._hasMultipleDocumentSelectionFormattingProvider.set(E.DocumentRangeFormattingEditProviderRegistry.all(t).length>1),e._isInWalkThrough.set(t.uri.scheme===l.Schemas.walkThroughSnippet)}):this.reset()},t}(a.Disposable);t.EditorModeContext=K;var U=function(e){function t(t){var i=e.call(this)||this;return i._onChange=i._register(new s.Emitter),i.onChange=i._onChange.event,i._hasFocus=!1,i._domFocusTracker=i._register(n.trackFocus(t)),i._register(i._domFocusTracker.onDidFocus(function(){i._hasFocus=!0,i._onChange.fire(void 0)})),i._register(i._domFocusTracker.onDidBlur(function(){i._hasFocus=!1,i._onChange.fire(void 0)})),i}return r(t,e),t.prototype.hasFocus=function(){return this._hasFocus},t
}(a.Disposable),j=encodeURIComponent("<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 6 3' enable-background='new 0 0 6 3' height='3' width='6'><g fill='"),q=encodeURIComponent("'><polygon points='5.5,0 2.5,3 1.1,3 4.1,0'/><polygon points='4,0 6,2 6,0.6 5.4,0'/><polygon points='0,2 1,3 2.4,3 0,0.6'/></g></svg>"),G=encodeURIComponent('<svg xmlns="http://www.w3.org/2000/svg" height="3" width="12"><g fill="'),Z=encodeURIComponent('"><circle cx="1" cy="1" r="1"/><circle cx="5" cy="1" r="1"/><circle cx="9" cy="1" r="1"/></g></svg>');R.registerThemingParticipant(function(e,t){var i=e.getColor(x.editorErrorBorder);i&&t.addRule(".monaco-editor .squiggly-error { border-bottom: 4px double "+i+"; }");var n=e.getColor(x.editorErrorForeground);n&&t.addRule('.monaco-editor .squiggly-error { background: url("data:image/svg+xml,'+A(n)+'") repeat-x bottom left; }');var o=e.getColor(x.editorWarningBorder);o&&t.addRule(".monaco-editor .squiggly-warning { border-bottom: 4px double "+o+"; }")
;var r=e.getColor(x.editorWarningForeground);r&&t.addRule('.monaco-editor .squiggly-warning { background: url("data:image/svg+xml,'+A(r)+'") repeat-x bottom left; }');var s=e.getColor(x.editorInfoBorder);s&&t.addRule(".monaco-editor .squiggly-info { border-bottom: 4px double "+s+"; }");var a=e.getColor(x.editorInfoForeground);a&&t.addRule('.monaco-editor .squiggly-info { background: url("data:image/svg+xml,'+A(a)+'") repeat-x bottom left; }');var l=e.getColor(x.editorHintBorder);l&&t.addRule(".monaco-editor .squiggly-hint { border-bottom: 2px dotted "+l+"; }");var u=e.getColor(x.editorHintForeground);u&&t.addRule('.monaco-editor .squiggly-hint { background: url("data:image/svg+xml,'+function(e){return G+encodeURIComponent(e.toString())+Z}(u)+'") no-repeat bottom left; }');var d=e.getColor(L.editorUnnecessaryCodeOpacity);d&&t.addRule("."+W+" .monaco-editor .squiggly-inline-unnecessary { opacity: "+d.rgba.a+"; }");var c=e.getColor(L.editorUnnecessaryCodeBorder)
;c&&t.addRule("."+W+" .monaco-editor .squiggly-unnecessary { border-bottom: 2px dashed "+c+"; }");var h=e.getColor(x.editorForeground)||"inherit";t.addRule(".monaco-editor .squiggly-inline-deprecated { text-decoration: line-through; text-decoration-color: "+h+"}")})}),define(t[539],i([1,0,309,8,27,74,51,58,2,65,11,31,87,13,37,94,67,14,22,16,253]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b){"use strict";function C(e){for(var t=e.get(h.ICodeEditorService).listDiffEditors(),i=0,n=t.length;i<n;i++){var o=t[i];if(o.hasWidgetFocus())return o}return null}Object.defineProperty(t,"__esModule",{value:!0});var S=function(){function e(e,t,i,n){this.originalLineStart=e,this.originalLineEnd=t,this.modifiedLineStart=i,this.modifiedLineEnd=n}return e.prototype.getType=function(){return 0===this.originalLineStart?1:0===this.modifiedLineStart?2:0},e}(),w=function(){return function(e){this.entries=e}}(),E=function(e){function t(t){var r=e.call(this)||this;return r._width=0,r._diffEditor=t,r._isVisible=!1,
r.shadow=o.createFastDomNode(document.createElement("div")),r.shadow.setClassName("diff-review-shadow"),r.actionBarContainer=o.createFastDomNode(document.createElement("div")),r.actionBarContainer.setClassName("diff-review-actions"),r._actionBar=r._register(new s.ActionBar(r.actionBarContainer.domNode)),r._actionBar.push(new l.Action("diffreview.close",i.localize(0,null),"close-diff-review",!0,function(){return r.hide(),Promise.resolve(null)}),{label:!1,icon:!0}),r.domNode=o.createFastDomNode(document.createElement("div")),r.domNode.setClassName("diff-review monaco-editor-background"),r._content=o.createFastDomNode(document.createElement("div")),r._content.setClassName("diff-review-content"),r.scrollbar=r._register(new a.DomScrollableElement(r._content.domNode,{})),r.domNode.domNode.appendChild(r.scrollbar.getDomNode()),r._register(t.onDidUpdateDiff(function(){r._isVisible&&(r._diffs=r._compute(),r._render())})),r._register(t.getModifiedEditor().onDidChangeCursorPosition(function(){r._isVisible&&r._render()
})),r._register(t.getOriginalEditor().onDidFocusEditorWidget(function(){r._isVisible&&r.hide()})),r._register(t.getModifiedEditor().onDidFocusEditorWidget(function(){r._isVisible&&r.hide()})),r._register(n.addStandardDisposableListener(r.domNode.domNode,"click",function(e){e.preventDefault();var t=n.findParentWithClass(e.target,"diff-review-row");t&&r._goToRow(t)})),r._register(n.addStandardDisposableListener(r.domNode.domNode,"keydown",function(e){(e.equals(18)||e.equals(2066)||e.equals(530))&&(e.preventDefault(),r._goToRow(r._getNextRow())),(e.equals(16)||e.equals(2064)||e.equals(528))&&(e.preventDefault(),r._goToRow(r._getPrevRow())),(e.equals(9)||e.equals(2057)||e.equals(521)||e.equals(1033))&&(e.preventDefault(),r.hide()),(e.equals(10)||e.equals(3))&&(e.preventDefault(),r.accept())})),r._diffs=[],r._currentDiff=null,r}return r(t,e),t.prototype.prev=function(){var e=0;if(this._isVisible||(this._diffs=this._compute()),this._isVisible){
for(var t=-1,i=0,n=this._diffs.length;i<n;i++)if(this._diffs[i]===this._currentDiff){t=i;break}e=this._diffs.length+t-1}else e=this._findDiffIndex(this._diffEditor.getPosition());0!==this._diffs.length&&(e%=this._diffs.length,this._diffEditor.setPosition(new f.Position(this._diffs[e].entries[0].modifiedLineStart,1)),this._isVisible=!0,this._diffEditor.doLayout(),this._render(),this._goToRow(this._getNextRow()))},t.prototype.next=function(){var e=0;if(this._isVisible||(this._diffs=this._compute()),this._isVisible){for(var t=-1,i=0,n=this._diffs.length;i<n;i++)if(this._diffs[i]===this._currentDiff){t=i;break}e=t+1}else e=this._findDiffIndex(this._diffEditor.getPosition());0!==this._diffs.length&&(e%=this._diffs.length,this._diffEditor.setPosition(new f.Position(this._diffs[e].entries[0].modifiedLineStart,1)),this._isVisible=!0,this._diffEditor.doLayout(),this._render(),this._goToRow(this._getNextRow()))},t.prototype.accept=function(){var e=-1,t=this._getCurrentFocusedRow();if(t){
var i=parseInt(t.getAttribute("data-line"),10);isNaN(i)||(e=i)}this.hide(),-1!==e&&(this._diffEditor.setPosition(new f.Position(e,1)),this._diffEditor.revealPosition(new f.Position(e,1),1))},t.prototype.hide=function(){this._isVisible=!1,this._diffEditor.focus(),this._diffEditor.doLayout(),this._render()},t.prototype._getPrevRow=function(){var e=this._getCurrentFocusedRow();return e?e.previousElementSibling?e.previousElementSibling:e:this._getFirstRow()},t.prototype._getNextRow=function(){var e=this._getCurrentFocusedRow();return e?e.nextElementSibling?e.nextElementSibling:e:this._getFirstRow()},t.prototype._getFirstRow=function(){return this.domNode.domNode.querySelector(".diff-review-row")},t.prototype._getCurrentFocusedRow=function(){var e=document.activeElement;return e&&/diff-review-row/.test(e.className)?e:null},t.prototype._goToRow=function(e){var t=this._getCurrentFocusedRow();e.tabIndex=0,e.focus(),t&&t!==e&&(t.tabIndex=-1),this.scrollbar.scanDomNode()},t.prototype.isVisible=function(){
return this._isVisible},t.prototype.layout=function(e,t,i){this._width=t,this.shadow.setTop(e-6),this.shadow.setWidth(t),this.shadow.setHeight(this._isVisible?6:0),this.domNode.setTop(e),this.domNode.setWidth(t),this.domNode.setHeight(i),this._content.setHeight(i),this._content.setWidth(t),this._isVisible?(this.actionBarContainer.setAttribute("aria-hidden","false"),this.actionBarContainer.setDisplay("block")):(this.actionBarContainer.setAttribute("aria-hidden","true"),this.actionBarContainer.setDisplay("none"))},t.prototype._compute=function(){var e=this._diffEditor.getLineChanges();if(!e||0===e.length)return[];var i=this._diffEditor.getOriginalEditor().getModel(),n=this._diffEditor.getModifiedEditor().getModel();return i&&n?t._mergeAdjacent(e,i.getLineCount(),n.getLineCount()):[]},t._mergeAdjacent=function(e,t,i){if(!e||0===e.length)return[];for(var n=[],o=0,r=0,s=e.length;r<s;r++){
var a=e[r],l=a.originalStartLineNumber,u=a.originalEndLineNumber,d=a.modifiedStartLineNumber,c=a.modifiedEndLineNumber,h=[],p=0,f=0===u?l:l-1,g=0===c?d:d-1,m=1,v=1;if(r>0){var _=e[r-1];m=0===_.originalEndLineNumber?_.originalStartLineNumber+1:_.originalEndLineNumber+1,v=0===_.modifiedEndLineNumber?_.modifiedStartLineNumber+1:_.modifiedEndLineNumber+1}var y=f-3+1,b=g-3+1;if(y<m){y+=M=m-y,b+=M}if(b<v){y+=M=v-b,b+=M}h[p++]=new S(y,f,b,g),0!==u&&(h[p++]=new S(l,u,0,0)),0!==c&&(h[p++]=new S(0,0,d,c));var C=0===u?l+1:u+1,E=0===c?d+1:c+1,L=t,x=i;if(r+1<s){var D=e[r+1];L=0===D.originalEndLineNumber?D.originalStartLineNumber:D.originalStartLineNumber-1,x=0===D.modifiedEndLineNumber?D.modifiedStartLineNumber:D.modifiedStartLineNumber-1}var I=C+3-1,N=E+3-1;if(I>L){I+=M=L-I,N+=M}if(N>x){var M=x-N;I+=M,N+=M}h[p++]=new S(C,I,E,N),n[o++]=new w(h)}for(var k=n[0].entries,T=[],R=0,r=1,s=n.length;r<s;r++){var O=n[r].entries,P=k[k.length-1],A=O[0]
;0===P.getType()&&0===A.getType()&&A.originalLineStart<=P.originalLineEnd?(k[k.length-1]=new S(P.originalLineStart,A.originalLineEnd,P.modifiedLineStart,A.modifiedLineEnd),k=k.concat(O.slice(1))):(T[R++]=new w(k),k=O)}return T[R++]=new w(k),T},t.prototype._findDiffIndex=function(e){for(var t=e.lineNumber,i=0,n=this._diffs.length;i<n;i++){var o=this._diffs[i].entries;if(t<=o[o.length-1].modifiedLineEnd)return i}return 0},t.prototype._render=function(){var e=this._diffEditor.getOriginalEditor().getConfiguration(),o=this._diffEditor.getModifiedEditor().getConfiguration(),r=this._diffEditor.getOriginalEditor().getModel(),s=this._diffEditor.getModifiedEditor().getModel(),a=r.getOptions(),l=s.getOptions();if(!this._isVisible||!r||!s)return n.clearNode(this._content.domNode),this._currentDiff=null,void this.scrollbar.scanDomNode();var u=this._findDiffIndex(this._diffEditor.getPosition());if(this._diffs[u]!==this._currentDiff){this._currentDiff=this._diffs[u]
;var c=this._diffs[u].entries,h=document.createElement("div");h.className="diff-review-table",h.setAttribute("role","list"),d.Configuration.applyFontInfoSlow(h,o.fontInfo);for(var p=0,f=0,g=0,m=0,v=0,_=c.length;v<_;v++){var y=(k=c[v]).originalLineStart,b=k.originalLineEnd,C=k.modifiedLineStart,S=k.modifiedLineEnd;0!==y&&(0===p||y<p)&&(p=y),0!==b&&(0===f||b>f)&&(f=b),0!==C&&(0===g||C<g)&&(g=C),0!==S&&(0===m||S>m)&&(m=S)}var w=document.createElement("div");w.className="diff-review-row";var E=document.createElement("div");E.className="diff-review-cell diff-review-summary";var L=f-p+1,x=m-g+1;E.appendChild(document.createTextNode(u+1+"/"+this._diffs.length+": @@ -"+p+","+L+" +"+g+","+x+" @@")),w.setAttribute("data-line",String(g));var D=function(e){return 0===e?i.localize(1,null):1===e?i.localize(2,null):i.localize(3,null,e)},I=D(L),N=D(x);w.setAttribute("aria-label",i.localize(4,null,u+1,this._diffs.length,p,I,g,N)),w.appendChild(E),w.setAttribute("role","listitem"),h.appendChild(w)
;for(var M=g,v=0,_=c.length;v<_;v++){var k=c[v];t._renderSection(h,k,M,this._width,e,r,a,o,s,l),0!==k.modifiedLineStart&&(M=k.modifiedLineEnd)}n.clearNode(this._content.domNode),this._content.domNode.appendChild(h),this.scrollbar.scanDomNode()}},t._renderSection=function(e,t,n,o,r,s,a,l,u,d){var c=t.getType(),h="diff-review-row",p="",f="diff-review-spacer";switch(c){case 1:h="diff-review-row line-insert",p=" char-insert",f="diff-review-spacer insert-sign";break;case 2:h="diff-review-row line-delete",p=" char-delete",f="diff-review-spacer delete-sign"}for(var g=t.originalLineStart,m=t.originalLineEnd,v=t.modifiedLineStart,_=t.modifiedLineEnd,y=Math.max(_-v,m-g),b=r.layoutInfo.glyphMarginWidth+r.layoutInfo.lineNumbersWidth,C=10+l.layoutInfo.glyphMarginWidth+l.layoutInfo.lineNumbersWidth,S=0;S<=y;S++){var w=0===g?0:g+S,E=0===v?0:v+S,L=document.createElement("div");L.style.minWidth=o+"px",L.className=h,L.setAttribute("role","listitem"),0!==E&&(n=E),L.setAttribute("data-line",String(n))
;var x=document.createElement("div");x.className="diff-review-cell",L.appendChild(x);var D=document.createElement("span");D.style.width=b+"px",D.style.minWidth=b+"px",D.className="diff-review-line-number"+p,0!==w?D.appendChild(document.createTextNode(String(w))):D.innerHTML="&nbsp;",x.appendChild(D);var I=document.createElement("span");I.style.width=C+"px",I.style.minWidth=C+"px",I.style.paddingRight="10px",I.className="diff-review-line-number"+p,0!==E?I.appendChild(document.createTextNode(String(E))):I.innerHTML="&nbsp;",x.appendChild(I);var N=document.createElement("span");N.className=f,N.innerHTML="&nbsp;&nbsp;",x.appendChild(N);var M=void 0;0!==E?(x.insertAdjacentHTML("beforeend",this._renderLine(u,l,d.tabSize,E)),M=u.getLineContent(E)):(x.insertAdjacentHTML("beforeend",this._renderLine(s,r,a.tabSize,w)),M=s.getLineContent(w)),0===M.length&&(M=i.localize(5,null));var k="";switch(c){case 0:k=i.localize(6,null,w,E,M);break;case 1:k=i.localize(7,null,E,M);break;case 2:k=i.localize(8,null,w,M)}
L.setAttribute("aria-label",k),e.appendChild(L)}},t._renderLine=function(e,t,i,n){var o=e.getLineContent(n),r=new Uint32Array(2);r[0]=o.length,r[1]=16793600;var s=new p.LineTokens(r,o),a=v.ViewLineRenderingData.isBasicASCII(o,e.mightContainNonBasicASCII()),l=v.ViewLineRenderingData.containsRTL(o,a,e.mightContainRTL());return m.renderViewLine2(new m.RenderLineInput(t.fontInfo.isMonospace&&!t.viewInfo.disableMonospaceOptimizations,t.fontInfo.canUseHalfwidthRightwardsArrow,o,!1,a,l,0,s,[],i,t.fontInfo.spaceWidth,t.viewInfo.stopRenderingLineAfter,t.viewInfo.renderWhitespace,t.viewInfo.renderControlCharacters,t.viewInfo.fontLigatures,null)).html},t}(u.Disposable);t.DiffReview=E,b.registerThemingParticipant(function(e,t){var i=e.getColor(g.editorLineNumbers);i&&t.addRule(".monaco-diff-editor .diff-review-line-number { color: "+i+"; }");var n=e.getColor(y.scrollbarShadow);n&&t.addRule(".monaco-diff-editor .diff-review-shadow { box-shadow: "+n+" 0 -6px 6px -6px inset; }")});var L=function(e){function t(){
return e.call(this,{id:"editor.action.diffReview.next",label:i.localize(9,null),alias:"Go to Next Difference",precondition:_.ContextKeyExpr.has("isInDiffEditor"),kbOpts:{kbExpr:null,primary:65,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=C(e);i&&i.diffReviewNext()},t}(c.EditorAction),x=function(e){function t(){return e.call(this,{id:"editor.action.diffReview.prev",label:i.localize(10,null),alias:"Go to Previous Difference",precondition:_.ContextKeyExpr.has("isInDiffEditor"),kbOpts:{kbExpr:null,primary:1089,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=C(e);i&&i.diffReviewPrev()},t}(c.EditorAction);c.registerEditorAction(L),c.registerEditorAction(x)}),define(t[219],i([1,0,308,8,27,100,15,4,2,29,65,61,31,98,539,47,3,156,72,30,60,171,138,94,67,14,12,104,34,22,16,54,311,268]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M,k,T,R,O,P){"use strict";function A(e,t,i,n,o){return{range:new y.Range(e,t,i,n),options:o}}function F(e){
return e.modifiedEndLineNumber>0}function W(e){return e.originalEndLineNumber>0}Object.defineProperty(t,"__esModule",{value:!0});var V=function(){function e(e,t){this._contextMenuService=e,this._clipboardService=t,this._zones=[],this.inlineDiffMargins=[],this._zonesMap={},this._decorations=[]}return e.prototype.getForeignViewZones=function(e){var t=this;return e.filter(function(e){return!t._zonesMap[String(e.id)]})},e.prototype.clean=function(e){var t=this;this._zones.length>0&&e.changeViewZones(function(e){for(var i=0,n=t._zones.length;i<n;i++)e.removeZone(t._zones[i])}),this._zones=[],this._zonesMap={},this._decorations=e.deltaDecorations(this._decorations,[])},e.prototype.apply=function(e,t,i,n){var o=this,r=n?f.StableEditorScrollState.capture(e):null;e.changeViewZones(function(t){for(var n=0,r=o._zones.length;n<r;n++)t.removeZone(o._zones[n]);for(var n=0,s=o.inlineDiffMargins.length;n<s;n++)o.inlineDiffMargins[n].dispose();o._zones=[],o._zonesMap={},o.inlineDiffMargins=[]
;for(var n=0,a=i.zones.length;n<a;n++){var l=i.zones[n];l.suppressMouseDown=!1;var u=t.addZone(l);o._zones.push(u),o._zonesMap[String(u)]=!0,i.zones[n].diff&&l.marginDomNode&&o._clipboardService&&o.inlineDiffMargins.push(new P.InlineDiffMargin(u,l.marginDomNode,e,i.zones[n].diff,o._contextMenuService,o._clipboardService))}}),r&&r.restore(e),this._decorations=e.deltaDecorations(this._decorations,i.decorations),t&&t.setZones(i.overviewZones)},e}(),B=0,H=function(e){function t(i,r,s,u,d,c,h,p,f,g){var m=e.call(this)||this;m._onDidDispose=m._register(new l.Emitter),m.onDidDispose=m._onDidDispose.event,m._onDidUpdateDiff=m._register(new l.Emitter),m.onDidUpdateDiff=m._onDidUpdateDiff.event,m._lastOriginalWarning=null,m._lastModifiedWarning=null,m._editorWorkerService=u,m._codeEditorService=h,m._contextKeyService=m._register(d.createScoped(i)),m._contextKeyService.createKey("isInDiffEditor",!0),m._themeService=p,m._notificationService=f,m.id=++B,m._domElement=i,r=r||{},m._renderSideBySide=!0,
void 0!==r.renderSideBySide&&(m._renderSideBySide=r.renderSideBySide),m._ignoreTrimWhitespace=!0,void 0!==r.ignoreTrimWhitespace&&(m._ignoreTrimWhitespace=r.ignoreTrimWhitespace),m._renderIndicators=!0,void 0!==r.renderIndicators&&(m._renderIndicators=r.renderIndicators),m._originalIsEditable=!1,void 0!==r.originalEditable&&(m._originalIsEditable=Boolean(r.originalEditable)),m._updateDecorationsRunner=m._register(new a.RunOnceScheduler(function(){return m._updateDecorations()},0)),m._containerDomElement=document.createElement("div"),m._containerDomElement.className=t._getClassName(m._themeService.getTheme(),m._renderSideBySide),m._containerDomElement.style.position="relative",m._containerDomElement.style.height="100%",m._domElement.appendChild(m._containerDomElement),m._overviewViewportDomElement=o.createFastDomNode(document.createElement("div")),m._overviewViewportDomElement.setClassName("diffViewport"),m._overviewViewportDomElement.setPosition("absolute"),m._overviewDomElement=document.createElement("div"),
m._overviewDomElement.className="diffOverview",m._overviewDomElement.style.position="absolute",m._overviewDomElement.appendChild(m._overviewViewportDomElement.domNode),m._register(n.addStandardDisposableListener(m._overviewDomElement,"mousedown",function(e){m.modifiedEditor.delegateVerticalScrollbarMouseDown(e)})),m._containerDomElement.appendChild(m._overviewDomElement),m._originalDomNode=document.createElement("div"),m._originalDomNode.className="editor original",m._originalDomNode.style.position="absolute",m._originalDomNode.style.height="100%",m._containerDomElement.appendChild(m._originalDomNode),m._modifiedDomNode=document.createElement("div"),m._modifiedDomNode.className="editor modified",m._modifiedDomNode.style.position="absolute",m._modifiedDomNode.style.height="100%",m._containerDomElement.appendChild(m._modifiedDomNode),m._beginUpdateDecorationsTimeout=-1,m._currentlyChangingViewZones=!1,m._diffComputationToken=0,m._originalEditorState=new V(g,s),m._modifiedEditorState=new V(g,s),m._isVisible=!0,
m._isHandlingScrollEvent=!1,m._width=0,m._height=0,m._reviewHeight=0,m._diffComputationResult=null;var _=m._contextKeyService.createScoped();_.createKey("isInDiffLeftEditor",!0);var y=new M.ServiceCollection;y.set(I.IContextKeyService,_);var b=c.createChild(y),C=m._contextKeyService.createScoped();C.createKey("isInDiffRightEditor",!0);var S=new M.ServiceCollection;S.set(I.IContextKeyService,C);var w=c.createChild(S);return m.originalEditor=m._createLeftHandSideEditor(r,b),m.modifiedEditor=m._createRightHandSideEditor(r,w),m._originalOverviewRuler=null,m._modifiedOverviewRuler=null,m._reviewPane=new v.DiffReview(m),m._containerDomElement.appendChild(m._reviewPane.domNode.domNode),m._containerDomElement.appendChild(m._reviewPane.shadow.domNode),m._containerDomElement.appendChild(m._reviewPane.actionBarContainer.domNode),r.automaticLayout?(m._measureDomElementToken=new a.IntervalTimer,m._measureDomElementToken.cancelAndSet(function(){return m._measureDomElement(!1)},100)):m._measureDomElementToken=null,
m._enableSplitViewResizing=!0,void 0!==r.enableSplitViewResizing&&(m._enableSplitViewResizing=r.enableSplitViewResizing),m._renderSideBySide?m._setStrategy(new q(m._createDataSource(),m._enableSplitViewResizing)):m._setStrategy(new Z(m._createDataSource(),m._enableSplitViewResizing)),m._register(p.onThemeChange(function(e){m._strategy&&m._strategy.applyColors(e)&&m._updateDecorationsRunner.schedule(),m._containerDomElement.className=t._getClassName(m._themeService.getTheme(),m._renderSideBySide)})),m._codeEditorService.addDiffEditor(m),m}return r(t,e),t.prototype.hasWidgetFocus=function(){return n.isAncestor(document.activeElement,this._domElement)},t.prototype.diffReviewNext=function(){this._reviewPane.next()},t.prototype.diffReviewPrev=function(){this._reviewPane.prev()},t._getClassName=function(e,t){var i="monaco-diff-editor monaco-editor-background ";return t&&(i+="side-by-side "),i+=R.getThemeTypeSelector(e.type)},t.prototype._recreateOverviewRulers=function(){
this._originalOverviewRuler&&(this._overviewDomElement.removeChild(this._originalOverviewRuler.getDomNode()),this._originalOverviewRuler.dispose()),this.originalEditor.hasModel()&&(this._originalOverviewRuler=this.originalEditor.createOverviewRuler("original diffOverviewRuler"),this._overviewDomElement.appendChild(this._originalOverviewRuler.getDomNode())),this._modifiedOverviewRuler&&(this._overviewDomElement.removeChild(this._modifiedOverviewRuler.getDomNode()),this._modifiedOverviewRuler.dispose()),this.modifiedEditor.hasModel()&&(this._modifiedOverviewRuler=this.modifiedEditor.createOverviewRuler("modified diffOverviewRuler"),this._overviewDomElement.appendChild(this._modifiedOverviewRuler.getDomNode())),this._layoutOverviewRulers()},t.prototype._createLeftHandSideEditor=function(e,t){var i=this,n=this._createInnerEditor(t,this._originalDomNode,this._adjustOptionsForLeftHandSide(e,this._originalIsEditable));return this._register(n.onDidScrollChange(function(e){
i._isHandlingScrollEvent||(e.scrollTopChanged||e.scrollLeftChanged||e.scrollHeightChanged)&&(i._isHandlingScrollEvent=!0,i.modifiedEditor.setScrollPosition({scrollLeft:e.scrollLeft,scrollTop:e.scrollTop}),i._isHandlingScrollEvent=!1,i._layoutOverviewViewport())})),this._register(n.onDidChangeViewZones(function(){i._onViewZonesChanged()})),this._register(n.onDidChangeModelContent(function(){i._isVisible&&i._beginUpdateDecorationsSoon()})),n},t.prototype._createRightHandSideEditor=function(e,t){var i=this,n=this._createInnerEditor(t,this._modifiedDomNode,this._adjustOptionsForRightHandSide(e));return this._register(n.onDidScrollChange(function(e){i._isHandlingScrollEvent||(e.scrollTopChanged||e.scrollLeftChanged||e.scrollHeightChanged)&&(i._isHandlingScrollEvent=!0,i.originalEditor.setScrollPosition({scrollLeft:e.scrollLeft,scrollTop:e.scrollTop}),i._isHandlingScrollEvent=!1,i._layoutOverviewViewport())})),this._register(n.onDidChangeViewZones(function(){i._onViewZonesChanged()})),
this._register(n.onDidChangeConfiguration(function(e){e.fontInfo&&n.getModel()&&i._onViewZonesChanged()})),this._register(n.onDidChangeModelContent(function(){i._isVisible&&i._beginUpdateDecorationsSoon()})),n},t.prototype._createInnerEditor=function(e,t,i){return e.createInstance(m.CodeEditorWidget,t,i,{})},t.prototype.dispose=function(){this._codeEditorService.removeDiffEditor(this),-1!==this._beginUpdateDecorationsTimeout&&(window.clearTimeout(this._beginUpdateDecorationsTimeout),this._beginUpdateDecorationsTimeout=-1),this._measureDomElementToken&&this._measureDomElementToken.dispose(),this._cleanViewZonesAndDecorations(),this._originalOverviewRuler&&(this._overviewDomElement.removeChild(this._originalOverviewRuler.getDomNode()),this._originalOverviewRuler.dispose()),this._modifiedOverviewRuler&&(this._overviewDomElement.removeChild(this._modifiedOverviewRuler.getDomNode()),this._modifiedOverviewRuler.dispose()),this._overviewDomElement.removeChild(this._overviewViewportDomElement.domNode),
this._containerDomElement.removeChild(this._overviewDomElement),this._containerDomElement.removeChild(this._originalDomNode),this.originalEditor.dispose(),this._containerDomElement.removeChild(this._modifiedDomNode),this.modifiedEditor.dispose(),this._strategy.dispose(),this._containerDomElement.removeChild(this._reviewPane.domNode.domNode),this._containerDomElement.removeChild(this._reviewPane.shadow.domNode),this._containerDomElement.removeChild(this._reviewPane.actionBarContainer.domNode),this._reviewPane.dispose(),this._domElement.removeChild(this._containerDomElement),this._onDidDispose.fire(),e.prototype.dispose.call(this)},t.prototype.getId=function(){return this.getEditorType()+":"+this.id},t.prototype.getEditorType=function(){return C.EditorType.IDiffEditor},t.prototype.getLineChanges=function(){return this._diffComputationResult?this._diffComputationResult.changes:null},t.prototype.getOriginalEditor=function(){return this.originalEditor},t.prototype.getModifiedEditor=function(){
return this.modifiedEditor},t.prototype.updateOptions=function(e){var i=!1;void 0!==e.renderSideBySide&&this._renderSideBySide!==e.renderSideBySide&&(this._renderSideBySide=e.renderSideBySide,i=!0);var n=!1;void 0!==e.ignoreTrimWhitespace&&this._ignoreTrimWhitespace!==e.ignoreTrimWhitespace&&(this._ignoreTrimWhitespace=e.ignoreTrimWhitespace,n=!0),void 0!==e.renderIndicators&&this._renderIndicators!==e.renderIndicators&&(this._renderIndicators=e.renderIndicators,n=!0),n&&this._beginUpdateDecorations(),void 0!==e.originalEditable&&(this._originalIsEditable=Boolean(e.originalEditable)),this.modifiedEditor.updateOptions(this._adjustOptionsForRightHandSide(e)),this.originalEditor.updateOptions(this._adjustOptionsForLeftHandSide(e,this._originalIsEditable)),void 0!==e.enableSplitViewResizing&&(this._enableSplitViewResizing=e.enableSplitViewResizing),this._strategy.setEnableSplitViewResizing(this._enableSplitViewResizing),
i&&(this._renderSideBySide?this._setStrategy(new q(this._createDataSource(),this._enableSplitViewResizing)):this._setStrategy(new Z(this._createDataSource(),this._enableSplitViewResizing)),this._containerDomElement.className=t._getClassName(this._themeService.getTheme(),this._renderSideBySide))},t.prototype.getModel=function(){return{original:this.originalEditor.getModel(),modified:this.modifiedEditor.getModel()}},t.prototype.setModel=function(e){if(e&&(!e.original||!e.modified))throw new Error(e.original?"DiffEditorWidget.setModel: Modified model is null":"DiffEditorWidget.setModel: Original model is null");this._cleanViewZonesAndDecorations(),this.originalEditor.setModel(e?e.original:null),this.modifiedEditor.setModel(e?e.modified:null),this._updateDecorationsRunner.cancel(),e&&(this.originalEditor.setScrollTop(0),this.modifiedEditor.setScrollTop(0)),this._diffComputationResult=null,this._diffComputationToken++,e?(this._recreateOverviewRulers(),
this._beginUpdateDecorations()):this._diffComputationResult=null,this._layoutOverviewViewport()},t.prototype.getDomNode=function(){return this._domElement},t.prototype.getVisibleColumnFromPosition=function(e){return this.modifiedEditor.getVisibleColumnFromPosition(e)},t.prototype.getPosition=function(){return this.modifiedEditor.getPosition()},t.prototype.setPosition=function(e){this.modifiedEditor.setPosition(e)},t.prototype.revealLine=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealLine(e,t)},t.prototype.revealLineInCenter=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealLineInCenter(e,t)},t.prototype.revealLineInCenterIfOutsideViewport=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealLineInCenterIfOutsideViewport(e,t)},t.prototype.revealPosition=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealPosition(e,t)},t.prototype.revealPositionInCenter=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealPositionInCenter(e,t)},
t.prototype.revealPositionInCenterIfOutsideViewport=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealPositionInCenterIfOutsideViewport(e,t)},t.prototype.getSelection=function(){return this.modifiedEditor.getSelection()},t.prototype.getSelections=function(){return this.modifiedEditor.getSelections()},t.prototype.setSelection=function(e){this.modifiedEditor.setSelection(e)},t.prototype.setSelections=function(e){this.modifiedEditor.setSelections(e)},t.prototype.revealLines=function(e,t,i){void 0===i&&(i=0),this.modifiedEditor.revealLines(e,t,i)},t.prototype.revealLinesInCenter=function(e,t,i){void 0===i&&(i=0),this.modifiedEditor.revealLinesInCenter(e,t,i)},t.prototype.revealLinesInCenterIfOutsideViewport=function(e,t,i){void 0===i&&(i=0),this.modifiedEditor.revealLinesInCenterIfOutsideViewport(e,t,i)},t.prototype.revealRange=function(e,t,i,n){void 0===t&&(t=0),void 0===i&&(i=!1),void 0===n&&(n=!0),this.modifiedEditor.revealRange(e,t,i,n)},t.prototype.revealRangeInCenter=function(e,t){void 0===t&&(t=0),
this.modifiedEditor.revealRangeInCenter(e,t)},t.prototype.revealRangeInCenterIfOutsideViewport=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealRangeInCenterIfOutsideViewport(e,t)},t.prototype.revealRangeAtTop=function(e,t){void 0===t&&(t=0),this.modifiedEditor.revealRangeAtTop(e,t)},t.prototype.getSupportedActions=function(){return this.modifiedEditor.getSupportedActions()},t.prototype.saveViewState=function(){return{original:this.originalEditor.saveViewState(),modified:this.modifiedEditor.saveViewState()}},t.prototype.restoreViewState=function(e){if(e.original&&e.modified){var t=e;this.originalEditor.restoreViewState(t.original),this.modifiedEditor.restoreViewState(t.modified)}},t.prototype.layout=function(e){this._measureDomElement(!1,e)},t.prototype.focus=function(){this.modifiedEditor.focus()},t.prototype.hasTextFocus=function(){return this.originalEditor.hasTextFocus()||this.modifiedEditor.hasTextFocus()},t.prototype.trigger=function(e,t,i){this.modifiedEditor.trigger(e,t,i)},
t.prototype.changeDecorations=function(e){return this.modifiedEditor.changeDecorations(e)},t.prototype._measureDomElement=function(e,t){if((t=t||{width:this._containerDomElement.clientWidth,height:this._containerDomElement.clientHeight}).width<=0)return this._width=0,this._height=0,void(this._reviewHeight=0);(e||t.width!==this._width||t.height!==this._height)&&(this._width=t.width,this._height=t.height,this._reviewHeight=this._reviewPane.isVisible()?this._height:0,this._doLayout())},t.prototype._layoutOverviewRulers=function(){if(this._originalOverviewRuler&&this._modifiedOverviewRuler){var e=t.ENTIRE_DIFF_OVERVIEW_WIDTH-2*t.ONE_OVERVIEW_WIDTH;this.modifiedEditor.getLayoutInfo()&&(this._originalOverviewRuler.setLayout({top:0,width:t.ONE_OVERVIEW_WIDTH,right:e+t.ONE_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}),this._modifiedOverviewRuler.setLayout({top:0,right:0,width:t.ONE_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}))}},t.prototype._onViewZonesChanged=function(){
this._currentlyChangingViewZones||this._updateDecorationsRunner.schedule()},t.prototype._beginUpdateDecorationsSoon=function(){var e=this;-1!==this._beginUpdateDecorationsTimeout&&(window.clearTimeout(this._beginUpdateDecorationsTimeout),this._beginUpdateDecorationsTimeout=-1),this._beginUpdateDecorationsTimeout=window.setTimeout(function(){return e._beginUpdateDecorations()},t.UPDATE_DIFF_DECORATIONS_DELAY)},t._equals=function(e,t){return!e&&!t||!(!e||!t)&&e.toString()===t.toString()},t.prototype._beginUpdateDecorations=function(){var e=this;this._beginUpdateDecorationsTimeout=-1;var n=this.originalEditor.getModel(),o=this.modifiedEditor.getModel();if(n&&o){this._diffComputationToken++;var r=this._diffComputationToken;this._editorWorkerService.canComputeDiff(n.uri,o.uri)?this._editorWorkerService.computeDiff(n.uri,o.uri,this._ignoreTrimWhitespace).then(function(t){r===e._diffComputationToken&&n===e.originalEditor.getModel()&&o===e.modifiedEditor.getModel()&&(e._diffComputationResult=t,
e._updateDecorationsRunner.schedule(),e._onDidUpdateDiff.fire())},function(t){r===e._diffComputationToken&&n===e.originalEditor.getModel()&&o===e.modifiedEditor.getModel()&&(e._diffComputationResult=null,e._updateDecorationsRunner.schedule())}):t._equals(n.uri,this._lastOriginalWarning)&&t._equals(o.uri,this._lastModifiedWarning)||(this._lastOriginalWarning=n.uri,this._lastModifiedWarning=o.uri,this._notificationService.warn(i.localize(0,null)))}},t.prototype._cleanViewZonesAndDecorations=function(){this._originalEditorState.clean(this.originalEditor),this._modifiedEditorState.clean(this.modifiedEditor)},t.prototype._updateDecorations=function(){if(this.originalEditor.getModel()&&this.modifiedEditor.getModel()&&this._originalOverviewRuler&&this._modifiedOverviewRuler){
var e=this._diffComputationResult?this._diffComputationResult.changes:[],t=this._originalEditorState.getForeignViewZones(this.originalEditor.getWhitespaces()),i=this._modifiedEditorState.getForeignViewZones(this.modifiedEditor.getWhitespaces()),n=this._strategy.getEditorsDiffDecorations(e,this._ignoreTrimWhitespace,this._renderIndicators,t,i,this.originalEditor,this.modifiedEditor);try{this._currentlyChangingViewZones=!0,this._originalEditorState.apply(this.originalEditor,this._originalOverviewRuler,n.original,!1),this._modifiedEditorState.apply(this.modifiedEditor,this._modifiedOverviewRuler,n.modified,!0)}finally{this._currentlyChangingViewZones=!1}}},t.prototype._adjustOptionsForSubEditor=function(e){var t=h.deepClone(e||{});return t.inDiffEditor=!0,t.wordWrap="off",t.wordWrapMinified=!1,t.automaticLayout=!1,t.scrollbar=t.scrollbar||{},t.scrollbar.vertical="visible",t.folding=!1,t.codeLens=!1,t.fixedOverflowWidgets=!0,t.minimap||(t.minimap={}),t.minimap.enabled=!1,t},
t.prototype._adjustOptionsForLeftHandSide=function(e,t){var i=this._adjustOptionsForSubEditor(e);return i.readOnly=!t,i.overviewRulerLanes=1,i.extraEditorClassName="original-in-monaco-diff-editor",i},t.prototype._adjustOptionsForRightHandSide=function(e){var i=this._adjustOptionsForSubEditor(e);return i.revealHorizontalRightPadding=_.EDITOR_DEFAULTS.viewInfo.revealHorizontalRightPadding+t.ENTIRE_DIFF_OVERVIEW_WIDTH,i.scrollbar.verticalHasArrows=!1,i.extraEditorClassName="modified-in-monaco-diff-editor",i},t.prototype.doLayout=function(){this._measureDomElement(!0)},t.prototype._doLayout=function(){var e=this._strategy.layout();this._originalDomNode.style.width=e+"px",this._originalDomNode.style.left="0px",this._modifiedDomNode.style.width=this._width-e+"px",this._modifiedDomNode.style.left=e+"px",this._overviewDomElement.style.top="0px",this._overviewDomElement.style.height=this._height-this._reviewHeight+"px",this._overviewDomElement.style.width=t.ENTIRE_DIFF_OVERVIEW_WIDTH+"px",
this._overviewDomElement.style.left=this._width-t.ENTIRE_DIFF_OVERVIEW_WIDTH+"px",this._overviewViewportDomElement.setWidth(t.ENTIRE_DIFF_OVERVIEW_WIDTH),this._overviewViewportDomElement.setHeight(30),this.originalEditor.layout({width:e,height:this._height-this._reviewHeight}),this.modifiedEditor.layout({width:this._width-e-t.ENTIRE_DIFF_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}),(this._originalOverviewRuler||this._modifiedOverviewRuler)&&this._layoutOverviewRulers(),this._reviewPane.layout(this._height-this._reviewHeight,this._width,this._reviewHeight),this._layoutOverviewViewport()},t.prototype._layoutOverviewViewport=function(){var e=this._computeOverviewViewport();e?(this._overviewViewportDomElement.setTop(e.top),this._overviewViewportDomElement.setHeight(e.height)):(this._overviewViewportDomElement.setTop(0),this._overviewViewportDomElement.setHeight(0))},t.prototype._computeOverviewViewport=function(){var e=this.modifiedEditor.getLayoutInfo();if(!e)return null
;var t=this.modifiedEditor.getScrollTop(),i=this.modifiedEditor.getScrollHeight(),n=Math.max(0,e.contentHeight),o=Math.max(0,n-0),r=i>0?o/i:0;return{height:Math.max(0,Math.floor(e.contentHeight*r)),top:Math.floor(t*r)}},t.prototype._createDataSource=function(){var e=this;return{getWidth:function(){return e._width},getHeight:function(){return e._height-e._reviewHeight},getContainerDomNode:function(){return e._containerDomElement},relayoutEditors:function(){e._doLayout()},getOriginalEditor:function(){return e.originalEditor},getModifiedEditor:function(){return e.modifiedEditor}}},t.prototype._setStrategy=function(e){this._strategy&&this._strategy.dispose(),this._strategy=e,e.applyColors(this._themeService.getTheme()),this._diffComputationResult&&this._updateDecorations(),this._measureDomElement(!0)},t.prototype._getLineChangeAtOrBeforeLineNumber=function(e,t){var i=this._diffComputationResult?this._diffComputationResult.changes:[];if(0===i.length||e<t(i[0]))return null;for(var n=0,o=i.length-1;n<o;){
var r=Math.floor((n+o)/2),s=t(i[r]),a=r+1<=o?t(i[r+1]):Number.MAX_VALUE;e<s?o=r-1:e>=a?n=r+1:(n=r,o=r)}return i[n]},t.prototype._getEquivalentLineForOriginalLineNumber=function(e){var t=this._getLineChangeAtOrBeforeLineNumber(e,function(e){return e.originalStartLineNumber});if(!t)return e;var i=t.originalStartLineNumber+(t.originalEndLineNumber>0?-1:0),n=t.modifiedStartLineNumber+(t.modifiedEndLineNumber>0?-1:0),o=t.originalEndLineNumber>0?t.originalEndLineNumber-t.originalStartLineNumber+1:0,r=t.modifiedEndLineNumber>0?t.modifiedEndLineNumber-t.modifiedStartLineNumber+1:0,s=e-i;return s<=o?n+Math.min(s,r):n+r-o+s},t.prototype._getEquivalentLineForModifiedLineNumber=function(e){var t=this._getLineChangeAtOrBeforeLineNumber(e,function(e){return e.modifiedStartLineNumber});if(!t)return e
;var i=t.originalStartLineNumber+(t.originalEndLineNumber>0?-1:0),n=t.modifiedStartLineNumber+(t.modifiedEndLineNumber>0?-1:0),o=t.originalEndLineNumber>0?t.originalEndLineNumber-t.originalStartLineNumber+1:0,r=t.modifiedEndLineNumber>0?t.modifiedEndLineNumber-t.modifiedStartLineNumber+1:0,s=e-n;return s<=r?i+Math.min(s,o):i+o-r+s},t.prototype.getDiffLineInformationForOriginal=function(e){return this._diffComputationResult?{equivalentLineNumber:this._getEquivalentLineForOriginalLineNumber(e)}:null},t.prototype.getDiffLineInformationForModified=function(e){return this._diffComputationResult?{equivalentLineNumber:this._getEquivalentLineForModifiedLineNumber(e)}:null},t.ONE_OVERVIEW_WIDTH=15,t.ENTIRE_DIFF_OVERVIEW_WIDTH=30,t.UPDATE_DIFF_DECORATIONS_DELAY=200,t=d([c(3,w.IEditorWorkerService),c(4,I.IContextKeyService),c(5,N.IInstantiationService),c(6,g.ICodeEditorService),c(7,R.IThemeService),c(8,k.INotificationService),c(9,O.IContextMenuService)],t)}(u.Disposable);t.DiffEditorWidget=H;var z=function(e){
function t(t){var i=e.call(this)||this;return i._dataSource=t,i._insertColor=null,i._removeColor=null,i}return r(t,e),t.prototype.applyColors=function(e){var t=(e.getColor(T.diffInserted)||T.defaultInsertColor).transparent(2),i=(e.getColor(T.diffRemoved)||T.defaultRemoveColor).transparent(2),n=!t.equals(this._insertColor)||!i.equals(this._removeColor);return this._insertColor=t,this._removeColor=i,n},t.prototype.getEditorsDiffDecorations=function(e,t,i,n,o,r,s){o=o.sort(function(e,t){return e.afterLineNumber-t.afterLineNumber}),n=n.sort(function(e,t){return e.afterLineNumber-t.afterLineNumber});var a=this._getViewZones(e,n,o,r,s,i),l=this._getOriginalEditorDecorations(e,t,i,r,s),u=this._getModifiedEditorDecorations(e,t,i,r,s);return{original:{decorations:l.decorations,overviewZones:l.overviewZones,zones:a.original},modified:{decorations:u.decorations,overviewZones:u.overviewZones,zones:a.modified}}},t}(u.Disposable),K=function(){function e(e){this._source=e,this._index=-1,this.current=null,this.advance()}
return e.prototype.advance=function(){this._index++,this._index<this._source.length?this.current=this._source[this._index]:this.current=null},e}(),U=function(){function e(e,t,i){this.lineChanges=e,this.originalForeignVZ=t,this.modifiedForeignVZ=i}return e.prototype.getViewZones=function(){for(var t={original:[],modified:[]},i=0,n=0,o=0,r=0,s=0,a=0,l=function(e,t){return e.afterLineNumber-t.afterLineNumber},u=function(e,t){if(null===t.domNode&&e.length>0){var i=e[e.length-1];if(i.afterLineNumber===t.afterLineNumber&&null===i.domNode)return void(i.heightInLines+=t.heightInLines)}e.push(t)},d=new K(this.modifiedForeignVZ),c=new K(this.originalForeignVZ),h=0,p=this.lineChanges.length;h<=p;h++){var f=h<p?this.lineChanges[h]:null;null!==f?(o=f.originalStartLineNumber+(f.originalEndLineNumber>0?-1:0),r=f.modifiedStartLineNumber+(f.modifiedEndLineNumber>0?-1:0),n=f.originalEndLineNumber>0?f.originalEndLineNumber-f.originalStartLineNumber+1:0,
i=f.modifiedEndLineNumber>0?f.modifiedEndLineNumber-f.modifiedStartLineNumber+1:0,s=Math.max(f.originalStartLineNumber,f.originalEndLineNumber),a=Math.max(f.modifiedStartLineNumber,f.modifiedEndLineNumber)):(s=o+=1e7+n,a=r+=1e7+i);for(var g=[],m=[];d.current&&d.current.afterLineNumber<=a;){_=void 0;_=d.current.afterLineNumber<=r?o-r+d.current.afterLineNumber:s;var v=null;f&&f.modifiedStartLineNumber<=d.current.afterLineNumber&&d.current.afterLineNumber<=f.modifiedEndLineNumber&&(v=this._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion()),g.push({afterLineNumber:_,heightInLines:d.current.heightInLines,domNode:null,marginDomNode:v}),d.advance()}for(;c.current&&c.current.afterLineNumber<=s;){var _=void 0;_=c.current.afterLineNumber<=o?r-o+c.current.afterLineNumber:a,m.push({afterLineNumber:_,heightInLines:c.current.heightInLines,domNode:null}),c.advance()}if(null!==f&&F(f)){(y=this._produceOriginalFromDiff(f,n,i))&&g.push(y)}if(null!==f&&W(f)){var y=this._produceModifiedFromDiff(f,n,i)
;y&&m.push(y)}var b=0,C=0;for(g=g.sort(l),m=m.sort(l);b<g.length&&C<m.length;){var S=g[b],w=m[C],E=S.afterLineNumber-o,L=w.afterLineNumber-r;E<L?(u(t.original,S),b++):L<E?(u(t.modified,w),C++):S.shouldNotShrink?(u(t.original,S),b++):w.shouldNotShrink?(u(t.modified,w),C++):S.heightInLines>=w.heightInLines?(S.heightInLines-=w.heightInLines,C++):(w.heightInLines-=S.heightInLines,b++)}for(;b<g.length;)u(t.original,g[b]),b++;for(;C<m.length;)u(t.modified,m[C]),C++}return{original:e._ensureDomNodes(t.original),modified:e._ensureDomNodes(t.modified)}},e._ensureDomNodes=function(e){return e.map(function(e){return e.domNode||(e.domNode=function(){var e=document.createElement("div");return e.className="diagonal-fill",e}()),e})},e}(),j={charDelete:S.ModelDecorationOptions.register({className:"char-delete"}),charDeleteWholeLine:S.ModelDecorationOptions.register({className:"char-delete",isWholeLine:!0}),charInsert:S.ModelDecorationOptions.register({className:"char-insert"}),
charInsertWholeLine:S.ModelDecorationOptions.register({className:"char-insert",isWholeLine:!0}),lineInsert:S.ModelDecorationOptions.register({className:"line-insert",marginClassName:"line-insert",isWholeLine:!0}),lineInsertWithSign:S.ModelDecorationOptions.register({className:"line-insert",linesDecorationsClassName:"insert-sign",marginClassName:"line-insert",isWholeLine:!0}),lineDelete:S.ModelDecorationOptions.register({className:"line-delete",marginClassName:"line-delete",isWholeLine:!0}),lineDeleteWithSign:S.ModelDecorationOptions.register({className:"line-delete",linesDecorationsClassName:"delete-sign",marginClassName:"line-delete",isWholeLine:!0}),lineDeleteMargin:S.ModelDecorationOptions.register({marginClassName:"line-delete"})},q=function(e){function t(t,i){var n=e.call(this,t)||this;return n._disableSash=!1===i,n._sashRatio=null,n._sashPosition=null,n._startSashPosition=null,n._sash=n._register(new s.Sash(n._dataSource.getContainerDomNode(),n)),n._disableSash&&(n._sash.state=0),
n._sash.onDidStart(function(){return n.onSashDragStart()}),n._sash.onDidChange(function(e){return n.onSashDrag(e)}),n._sash.onDidEnd(function(){return n.onSashDragEnd()}),n._sash.onDidReset(function(){return n.onSashReset()}),n}return r(t,e),t.prototype.setEnableSplitViewResizing=function(e){var t=!1===e;this._disableSash!==t&&(this._disableSash=t,this._sash.state=this._disableSash?0:3)},t.prototype.layout=function(e){void 0===e&&(e=this._sashRatio);var i=this._dataSource.getWidth()-H.ENTIRE_DIFF_OVERVIEW_WIDTH,n=Math.floor((e||.5)*i),o=Math.floor(.5*i);return n=this._disableSash?o:n||o,i>2*t.MINIMUM_EDITOR_WIDTH?(n<t.MINIMUM_EDITOR_WIDTH&&(n=t.MINIMUM_EDITOR_WIDTH),n>i-t.MINIMUM_EDITOR_WIDTH&&(n=i-t.MINIMUM_EDITOR_WIDTH)):n=o,this._sashPosition!==n&&(this._sashPosition=n,this._sash.layout()),this._sashPosition},t.prototype.onSashDragStart=function(){this._startSashPosition=this._sashPosition},t.prototype.onSashDrag=function(e){
var t=this._dataSource.getWidth()-H.ENTIRE_DIFF_OVERVIEW_WIDTH,i=this.layout((this._startSashPosition+(e.currentX-e.startX))/t);this._sashRatio=i/t,this._dataSource.relayoutEditors()},t.prototype.onSashDragEnd=function(){this._sash.layout()},t.prototype.onSashReset=function(){this._sashRatio=.5,this._dataSource.relayoutEditors(),this._sash.layout()},t.prototype.getVerticalSashTop=function(e){return 0},t.prototype.getVerticalSashLeft=function(e){return this._sashPosition},t.prototype.getVerticalSashHeight=function(e){return this._dataSource.getHeight()},t.prototype._getViewZones=function(e,t,i,n,o){return new G(e,t,i).getViewZones()},t.prototype._getOriginalEditorDecorations=function(e,t,i,n,o){for(var r=String(this._removeColor),s={decorations:[],overviewZones:[]},a=n.getModel(),l=0,u=e.length;l<u;l++){var d=e[l];if(W(d)&&(s.decorations.push({range:new y.Range(d.originalStartLineNumber,1,d.originalEndLineNumber,Number.MAX_VALUE),options:i?j.lineDeleteWithSign:j.lineDelete}),
F(d)&&d.charChanges||s.decorations.push(A(d.originalStartLineNumber,1,d.originalEndLineNumber,Number.MAX_VALUE,j.charDeleteWholeLine)),s.overviewZones.push(new E.OverviewRulerZone(d.originalStartLineNumber,d.originalEndLineNumber,r)),d.charChanges))for(var c=0,h=d.charChanges.length;c<h;c++){var p=d.charChanges[c];if(W(p))if(t)for(var f=p.originalStartLineNumber;f<=p.originalEndLineNumber;f++){var g=void 0,m=void 0;g=f===p.originalStartLineNumber?p.originalStartColumn:a.getLineFirstNonWhitespaceColumn(f),m=f===p.originalEndLineNumber?p.originalEndColumn:a.getLineLastNonWhitespaceColumn(f),s.decorations.push(A(f,g,f,m,j.charDelete))}else s.decorations.push(A(p.originalStartLineNumber,p.originalStartColumn,p.originalEndLineNumber,p.originalEndColumn,j.charDelete))}}return s},t.prototype._getModifiedEditorDecorations=function(e,t,i,n,o){for(var r=String(this._insertColor),s={decorations:[],overviewZones:[]},a=o.getModel(),l=0,u=e.length;l<u;l++){var d=e[l];if(F(d)&&(s.decorations.push({
range:new y.Range(d.modifiedStartLineNumber,1,d.modifiedEndLineNumber,Number.MAX_VALUE),options:i?j.lineInsertWithSign:j.lineInsert}),W(d)&&d.charChanges||s.decorations.push(A(d.modifiedStartLineNumber,1,d.modifiedEndLineNumber,Number.MAX_VALUE,j.charInsertWholeLine)),s.overviewZones.push(new E.OverviewRulerZone(d.modifiedStartLineNumber,d.modifiedEndLineNumber,r)),d.charChanges))for(var c=0,h=d.charChanges.length;c<h;c++){var p=d.charChanges[c];if(F(p))if(t)for(var f=p.modifiedStartLineNumber;f<=p.modifiedEndLineNumber;f++){var g=void 0,m=void 0;g=f===p.modifiedStartLineNumber?p.modifiedStartColumn:a.getLineFirstNonWhitespaceColumn(f),m=f===p.modifiedEndLineNumber?p.modifiedEndColumn:a.getLineLastNonWhitespaceColumn(f),s.decorations.push(A(f,g,f,m,j.charInsert))}else s.decorations.push(A(p.modifiedStartLineNumber,p.modifiedStartColumn,p.modifiedEndLineNumber,p.modifiedEndColumn,j.charInsert))}}return s},t.MINIMUM_EDITOR_WIDTH=100,t}(z),G=function(e){function t(t,i,n){return e.call(this,t,i,n)||this}
return r(t,e),t.prototype._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion=function(){return null},t.prototype._produceOriginalFromDiff=function(e,t,i){return i>t?{afterLineNumber:Math.max(e.originalStartLineNumber,e.originalEndLineNumber),heightInLines:i-t,domNode:null}:null},t.prototype._produceModifiedFromDiff=function(e,t,i){return t>i?{afterLineNumber:Math.max(e.modifiedStartLineNumber,e.modifiedEndLineNumber),heightInLines:t-i,domNode:null}:null},t}(U),Z=function(e){function t(t,i){var n=e.call(this,t)||this;return n.decorationsLeft=t.getOriginalEditor().getLayoutInfo().decorationsLeft,n._register(t.getOriginalEditor().onDidLayoutChange(function(e){n.decorationsLeft!==e.decorationsLeft&&(n.decorationsLeft=e.decorationsLeft,t.relayoutEditors())})),n}return r(t,e),t.prototype.setEnableSplitViewResizing=function(e){},t.prototype._getViewZones=function(e,t,i,n,o,r){return new Y(e,t,i,n,o,r).getViewZones()},t.prototype._getOriginalEditorDecorations=function(e,t,i,n,o){
for(var r=String(this._removeColor),s={decorations:[],overviewZones:[]},a=0,l=e.length;a<l;a++){var u=e[a];W(u)&&(s.decorations.push({range:new y.Range(u.originalStartLineNumber,1,u.originalEndLineNumber,Number.MAX_VALUE),options:j.lineDeleteMargin}),s.overviewZones.push(new E.OverviewRulerZone(u.originalStartLineNumber,u.originalEndLineNumber,r)))}return s},t.prototype._getModifiedEditorDecorations=function(e,t,i,n,o){for(var r=String(this._insertColor),s={decorations:[],overviewZones:[]},a=o.getModel(),l=0,u=e.length;l<u;l++){var d=e[l];if(F(d))if(s.decorations.push({range:new y.Range(d.modifiedStartLineNumber,1,d.modifiedEndLineNumber,Number.MAX_VALUE),options:i?j.lineInsertWithSign:j.lineInsert}),s.overviewZones.push(new E.OverviewRulerZone(d.modifiedStartLineNumber,d.modifiedEndLineNumber,r)),d.charChanges)for(var c=0,h=d.charChanges.length;c<h;c++){var p=d.charChanges[c];if(F(p))if(t)for(var f=p.modifiedStartLineNumber;f<=p.modifiedEndLineNumber;f++){var g=void 0,m=void 0
;g=f===p.modifiedStartLineNumber?p.modifiedStartColumn:a.getLineFirstNonWhitespaceColumn(f),m=f===p.modifiedEndLineNumber?p.modifiedEndColumn:a.getLineLastNonWhitespaceColumn(f),s.decorations.push(A(f,g,f,m,j.charInsert))}else s.decorations.push(A(p.modifiedStartLineNumber,p.modifiedStartColumn,p.modifiedEndLineNumber,p.modifiedEndColumn,j.charInsert))}else s.decorations.push(A(d.modifiedStartLineNumber,1,d.modifiedEndLineNumber,Number.MAX_VALUE,j.charInsertWholeLine))}return s},t.prototype.layout=function(){return Math.max(5,this.decorationsLeft)},t}(z),Y=function(e){function t(t,i,n,o,r,s){var a=e.call(this,t,i,n)||this;return a.originalModel=o.getModel(),a.modifiedEditorConfiguration=r.getConfiguration(),a.modifiedEditorTabSize=r.getModel().getOptions().tabSize,a.renderIndicators=s,a}return r(t,e),t.prototype._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion=function(){var e=document.createElement("div");return e.className="inline-added-margin-view-zone",e},
t.prototype._produceOriginalFromDiff=function(e,t,i){var n=document.createElement("div");return n.className="inline-added-margin-view-zone",{afterLineNumber:Math.max(e.originalStartLineNumber,e.originalEndLineNumber),heightInLines:i,domNode:document.createElement("div"),marginDomNode:n}},t.prototype._produceModifiedFromDiff=function(e,t,i){var n=[];if(e.charChanges)for(var o=0,r=e.charChanges.length;o<r;o++){var s=e.charChanges[o];W(s)&&n.push(new D.InlineDecoration(new y.Range(s.originalStartLineNumber,s.originalStartColumn,s.originalEndLineNumber,s.originalEndColumn),"char-delete",0))}
for(var a=b.createStringBuilder(1e4),l=[],u=this.modifiedEditorConfiguration.layoutInfo.decorationsWidth,d=this.modifiedEditorConfiguration.lineHeight,c=this.modifiedEditorConfiguration.fontInfo.typicalHalfwidthCharacterWidth,h=0,f=[],g=e.originalStartLineNumber;g<=e.originalEndLineNumber;g++)if(h=Math.max(h,this._renderOriginalLine(g-e.originalStartLineNumber,this.originalModel,this.modifiedEditorConfiguration,this.modifiedEditorTabSize,g,n,a)),f.push(this.originalModel.getLineContent(g)),this.renderIndicators){var m=g-e.originalStartLineNumber;l=l.concat(['<div class="delete-sign" style="position:absolute;top:'+m*d+"px;width:"+u+"px;height:"+d+'px;right:0;"></div>'])}h+=this.modifiedEditorConfiguration.viewInfo.scrollBeyondLastColumn;var v=document.createElement("div");v.className="view-lines line-delete",v.innerHTML=a.build(),p.Configuration.applyFontInfoSlow(v,this.modifiedEditorConfiguration.fontInfo);var _=document.createElement("div");return _.className="inline-deleted-margin-view-zone",
_.innerHTML=l.join(""),p.Configuration.applyFontInfoSlow(_,this.modifiedEditorConfiguration.fontInfo),{shouldNotShrink:!0,afterLineNumber:0===e.modifiedEndLineNumber?e.modifiedStartLineNumber:e.modifiedStartLineNumber-1,heightInLines:t,minWidthInPx:h*c,domNode:v,marginDomNode:_,diff:{originalStartLineNumber:e.originalStartLineNumber,originalEndLineNumber:e.originalEndLineNumber,modifiedStartLineNumber:e.modifiedStartLineNumber,modifiedEndLineNumber:e.modifiedEndLineNumber,originalContent:f}}},t.prototype._renderOriginalLine=function(e,t,i,n,o,r,s){var a=t.getLineTokens(o),l=a.getLineContent(),u=L.LineDecoration.filter(r,o,1,l.length+1);s.appendASCIIString('<div class="view-line'),0===r.length&&s.appendASCIIString(" char-delete"),s.appendASCIIString('" style="top:'),s.appendASCIIString(String(e*i.lineHeight)),s.appendASCIIString('px;width:1000000px;">')
;var d=D.ViewLineRenderingData.isBasicASCII(l,t.mightContainNonBasicASCII()),c=D.ViewLineRenderingData.containsRTL(l,d,t.mightContainRTL()),h=x.renderViewLine(new x.RenderLineInput(i.fontInfo.isMonospace&&!i.viewInfo.disableMonospaceOptimizations,i.fontInfo.canUseHalfwidthRightwardsArrow,l,!1,d,c,0,a,u,n,i.fontInfo.spaceWidth,i.viewInfo.stopRenderingLineAfter,i.viewInfo.renderWhitespace,i.viewInfo.renderControlCharacters,i.viewInfo.fontLigatures,null),s);s.appendASCIIString("</div>");var p=h.characterMapping.getAbsoluteOffsets();return p.length>0?p[p.length-1]:0},t}(U);R.registerThemingParticipant(function(e,t){var i=e.getColor(T.diffInserted);i&&(t.addRule(".monaco-editor .line-insert, .monaco-editor .char-insert { background-color: "+i+"; }"),t.addRule(".monaco-diff-editor .line-insert, .monaco-diff-editor .char-insert { background-color: "+i+"; }"),t.addRule(".monaco-editor .inline-added-margin-view-zone { background-color: "+i+"; }"));var n=e.getColor(T.diffRemoved)
;n&&(t.addRule(".monaco-editor .line-delete, .monaco-editor .char-delete { background-color: "+n+"; }"),t.addRule(".monaco-diff-editor .line-delete, .monaco-diff-editor .char-delete { background-color: "+n+"; }"),t.addRule(".monaco-editor .inline-deleted-margin-view-zone { background-color: "+n+"; }"));var o=e.getColor(T.diffInsertedOutline);o&&t.addRule(".monaco-editor .line-insert, .monaco-editor .char-insert { border: 1px "+("hc"===e.type?"dashed":"solid")+" "+o+"; }");var r=e.getColor(T.diffRemovedOutline);r&&t.addRule(".monaco-editor .line-delete, .monaco-editor .char-delete { border: 1px "+("hc"===e.type?"dashed":"solid")+" "+r+"; }");var s=e.getColor(T.scrollbarShadow);s&&t.addRule(".monaco-diff-editor.side-by-side .editor.modified { box-shadow: -6px 0 5px -5px "+s+"; }");var a=e.getColor(T.diffBorder);a&&t.addRule(".monaco-diff-editor.side-by-side .editor.modified { border-left: 1px solid "+a+"; }")})}),define(t[153],i([1,0,29,31,98,32,14,12,34,16,66]),function(e,t,i,n,o,s,a,l,u,h,p){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var f=function(e){function t(t,i,n,o,r,s,a,l,u,d){var c=e.call(this,t,n.getRawConfiguration(),{},o,r,s,a,l,u,d)||this;return c._parentEditor=n,c._overwriteOptions=i,e.prototype.updateOptions.call(c,c._overwriteOptions),c._register(n.onDidChangeConfiguration(function(e){return c._onParentConfigurationChanged(e)})),c}return r(t,e),t.prototype.getParentEditor=function(){return this._parentEditor},t.prototype._onParentConfigurationChanged=function(t){e.prototype.updateOptions.call(this,this._parentEditor.getRawConfiguration()),e.prototype.updateOptions.call(this,this._overwriteOptions)},t.prototype.updateOptions=function(t){i.mixin(this._overwriteOptions,t,!0),e.prototype.updateOptions.call(this,this._overwriteOptions)},t=d([c(3,l.IInstantiationService),c(4,n.ICodeEditorService),c(5,s.ICommandService),c(6,a.IContextKeyService),c(7,h.IThemeService),c(8,u.INotificationService),c(9,p.IAccessibilityService)],t)}(o.CodeEditorWidget);t.EmbeddedCodeEditorWidget=f}),
define(t[542],i([1,0,69,2,49,16,37,42,3,41,50,4,23]),function(e,t,i,n,o,s,a,l,u,h,p,f,g){"use strict";function m(e){return e.toString()}Object.defineProperty(t,"__esModule",{value:!0});var v=function(e){function t(t){var i=e.call(this)||this;return i.model=t,i._markersData=new Map,i._register(n.toDisposable(function(){i.model.deltaDecorations(h.keys(i._markersData),[]),i._markersData.clear()})),i}return r(t,e),t.prototype.update=function(e,t){for(var i=this.model.deltaDecorations(h.keys(this._markersData),t),n=0;n<i.length;n++)this._markersData.set(i[n],e[n])},t.prototype.getMarker=function(e){return this._markersData.get(e.id)},t}(n.Disposable),_=function(e){function t(t,i){var n=e.call(this)||this;return n._markerService=i,n._onDidChangeMarker=n._register(new f.Emitter),n._markerDecorations=new Map,t.getModels().forEach(function(e){return n._onModelAdded(e)}),n._register(t.onModelAdded(n._onModelAdded,n)),n._register(t.onModelRemoved(n._onModelRemoved,n)),
n._register(n._markerService.onMarkerChanged(n._handleMarkerChange,n)),n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._markerDecorations.forEach(function(e){return e.dispose()}),this._markerDecorations.clear()},t.prototype.getMarker=function(e,t){var i=this._markerDecorations.get(m(e.uri));return i?g.withUndefinedAsNull(i.getMarker(t)):null},t.prototype._handleMarkerChange=function(e){var t=this;e.forEach(function(e){var i=t._markerDecorations.get(m(e));i&&t._updateDecorations(i)})},t.prototype._onModelAdded=function(e){var t=new v(e);this._markerDecorations.set(m(e.uri),t),this._updateDecorations(t)},t.prototype._onModelRemoved=function(e){var t=this,i=this._markerDecorations.get(m(e.uri));i&&(i.dispose(),this._markerDecorations.delete(m(e.uri))),e.uri.scheme!==p.Schemas.inMemory&&e.uri.scheme!==p.Schemas.internal&&e.uri.scheme!==p.Schemas.vscode||this._markerService&&this._markerService.read({resource:e.uri}).map(function(e){return e.owner}).forEach(function(i){
return t._markerService.remove(i,[e.uri])})},t.prototype._updateDecorations=function(e){var t=this,i=this._markerService.read({resource:e.model.uri,take:500}),n=i.map(function(i){return{range:t._createDecorationRange(e.model,i),options:t._createDecorationOption(i)}});e.update(i,n),this._onDidChangeMarker.fire(e.model)},t.prototype._createDecorationRange=function(e,t){var n=u.Range.lift(t);if(t.severity===i.MarkerSeverity.Hint&&(t.tags&&-1!==t.tags.indexOf(1)||(n=n.setEndPosition(n.startLineNumber,n.startColumn+2))),(n=e.validateRange(n)).isEmpty()){var o=e.getWordAtPosition(n.getStartPosition());if(o)n=new u.Range(n.startLineNumber,o.startColumn,n.endLineNumber,o.endColumn);else{var r=e.getLineLastNonWhitespaceColumn(n.startLineNumber)||e.getLineMaxColumn(n.startLineNumber);1===r||(n=n.endColumn>=r?new u.Range(n.startLineNumber,r-1,n.endLineNumber,r):new u.Range(n.startLineNumber,n.startColumn,n.endLineNumber,n.endColumn+1))}
}else if(t.endColumn===Number.MAX_VALUE&&1===t.startColumn&&n.startLineNumber===n.endLineNumber){var s=e.getLineFirstNonWhitespaceColumn(t.startLineNumber);s<n.endColumn&&(n=new u.Range(n.startLineNumber,s,n.endLineNumber,n.endColumn),t.startColumn=s)}return n},t.prototype._createDecorationOption=function(e){var t,n,r=void 0,l=void 0;switch(e.severity){case i.MarkerSeverity.Hint:t=e.tags&&e.tags.indexOf(1)>=0?"squiggly-unnecessary":"squiggly-hint",n=0;break;case i.MarkerSeverity.Warning:t="squiggly-warning",r=s.themeColorFromId(a.overviewRulerWarning),n=20;break;case i.MarkerSeverity.Info:t="squiggly-info",r=s.themeColorFromId(a.overviewRulerInfo),n=10;break;case i.MarkerSeverity.Error:default:t="squiggly-error",r=s.themeColorFromId(a.overviewRulerError),n=30}return e.tags&&(-1!==e.tags.indexOf(1)&&(l="squiggly-inline-unnecessary"),-1!==e.tags.indexOf(2)&&(l="squiggly-inline-deprecated")),{stickiness:1,className:t,showIfCollapsed:!0,overviewRuler:{color:r,position:o.OverviewRulerLane.Right},zIndex:n,
inlineClassName:l}},t=d([c(0,l.IModelService),c(1,i.IMarkerService)],t)}(n.Disposable);t.MarkerDecorationsService=_}),define(t[543],i([1,0,321,15,2,11,13,20,21,49,30,37,22,16,59,233]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var m=p.registerColor("editorOverviewRuler.bracketMatchForeground",{dark:"#A0A0A0",light:"#A0A0A0",hc:"#A0A0A0"},i.localize(0,null)),v=function(e){function t(){return e.call(this,{id:"editor.action.jumpToBracket",label:i.localize(1,null),alias:"Go to Bracket",precondition:void 0,kbOpts:{kbExpr:u.EditorContextKeys.editorTextFocus,primary:3160,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=b.get(t);i&&i.jumpToBracket()},t}(s.EditorAction),_=function(e){function t(){return e.call(this,{id:"editor.action.selectToBracket",label:i.localize(2,null),alias:"Select to Bracket",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){var i=b.get(t);i&&i.selectToBracket()},t
}(s.EditorAction),y=function(){return function(e,t){this.position=e,this.brackets=t}}(),b=function(e){function t(t){var i=e.call(this)||this;return i._editor=t,i._lastBracketsData=[],i._lastVersionId=0,i._decorations=[],i._updateBracketsSoon=i._register(new n.RunOnceScheduler(function(){return i._updateBrackets()},50)),i._matchBrackets=i._editor.getConfiguration().contribInfo.matchBrackets,i._updateBracketsSoon.schedule(),i._register(t.onDidChangeCursorPosition(function(e){i._matchBrackets&&i._updateBracketsSoon.schedule()})),i._register(t.onDidChangeModelContent(function(e){i._updateBracketsSoon.schedule()})),i._register(t.onDidChangeModel(function(e){i._lastBracketsData=[],i._decorations=[],i._updateBracketsSoon.schedule()})),i._register(t.onDidChangeModelLanguageConfiguration(function(e){i._lastBracketsData=[],i._updateBracketsSoon.schedule()})),i._register(t.onDidChangeConfiguration(function(e){i._matchBrackets=i._editor.getConfiguration().contribInfo.matchBrackets,
!i._matchBrackets&&i._decorations.length>0&&(i._decorations=i._editor.deltaDecorations(i._decorations,[])),i._updateBracketsSoon.schedule()})),i}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.jumpToBracket=function(){if(this._editor.hasModel()){var e=this._editor.getModel(),t=this._editor.getSelections().map(function(t){var i=t.getStartPosition(),n=e.matchBracket(i),o=null;if(n)n[0].containsPosition(i)?o=n[1].getStartPosition():n[1].containsPosition(i)&&(o=n[0].getStartPosition());else{var r=e.findNextBracket(i);r&&r.range&&(o=r.range.getStartPosition())}return o?new l.Selection(o.lineNumber,o.column,o.lineNumber,o.column):new l.Selection(i.lineNumber,i.column,i.lineNumber,i.column)});this._editor.setSelections(t),this._editor.revealRange(t[0])}},t.prototype.selectToBracket=function(){if(this._editor.hasModel()){var e=this._editor.getModel(),t=[];this._editor.getSelections().forEach(function(i){
var n=i.getStartPosition(),o=e.matchBracket(n),r=null,s=null;if(!o){var a=e.findNextBracket(n);a&&a.range&&(o=e.matchBracket(a.range.getStartPosition()))}o&&(o[0].startLineNumber===o[1].startLineNumber?(r=o[1].startColumn<o[0].startColumn?o[1].getStartPosition():o[0].getStartPosition(),s=o[1].startColumn<o[0].startColumn?o[0].getEndPosition():o[1].getEndPosition()):(r=o[1].startLineNumber<o[0].startLineNumber?o[1].getStartPosition():o[0].getStartPosition(),s=o[1].startLineNumber<o[0].startLineNumber?o[0].getEndPosition():o[1].getEndPosition())),r&&s&&t.push(new l.Selection(r.lineNumber,r.column,s.lineNumber,s.column))}),t.length>0&&(this._editor.setSelections(t),this._editor.revealRange(t[0]))}},t.prototype._updateBrackets=function(){if(this._matchBrackets){this._recomputeBrackets();for(var e=[],i=0,n=0,o=this._lastBracketsData.length;n<o;n++){var r=this._lastBracketsData[n].brackets;r&&(e[i++]={range:r[0],options:t._DECORATION_OPTIONS},e[i++]={range:r[1],options:t._DECORATION_OPTIONS})}
this._decorations=this._editor.deltaDecorations(this._decorations,e)}},t.prototype._recomputeBrackets=function(){if(!this._editor.hasModel())return this._lastBracketsData=[],void(this._lastVersionId=0);var e=this._editor.getModel(),t=e.getVersionId(),i=[];this._lastVersionId===t&&(i=this._lastBracketsData);for(var n=this._editor.getSelections(),o=[],r=0,s=0,l=n.length;s<l;s++){var u=n[s];u.isEmpty()&&(o[r++]=u.getStartPosition())}o.length>1&&o.sort(a.Position.compare);for(var d=[],c=0,h=0,p=i.length,s=0,l=o.length;s<l;s++){for(var f=o[s];h<p&&i[h].position.isBefore(f);)h++;if(h<p&&i[h].position.equals(f))d[c++]=i[h];else{var g=e.matchBracket(f);d[c++]=new y(f,g)}}this._lastBracketsData=d,this._lastVersionId=t},t.ID="editor.contrib.bracketMatchingController",t._DECORATION_OPTIONS=c.ModelDecorationOptions.register({stickiness:1,className:"bracket-match",overviewRuler:{color:f.themeColorFromId(m),position:d.OverviewRulerLane.Center}}),t}(o.Disposable);t.BracketMatchingController=b,
s.registerEditorContribution(b),s.registerEditorAction(_),s.registerEditorAction(v),f.registerThemingParticipant(function(e,t){var i=e.getColor(h.editorBracketMatchBackground);i&&t.addRule(".monaco-editor .bracket-match { background-color: "+i+"; }");var n=e.getColor(h.editorBracketMatchBorder);n&&t.addRule(".monaco-editor .bracket-match { border: 1px solid "+n+"; }")}),g.MenuRegistry.appendMenuItem(16,{group:"5_infile_nav",command:{id:"editor.action.jumpToBracket",title:i.localize(3,null)},order:2})}),define(t[544],i([1,0,8,19,5,3,30,37,22,16,591]),function(e,t,i,n,o,r,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(){function e(e,t){this.afterLineNumber=e,this._onHeight=t,this.heightInLines=1,this.suppressMouseDown=!0,this.domNode=document.createElement("div")}return e.prototype.onComputedHeight=function(e){void 0===this._lastHeight?this._lastHeight=e:this._lastHeight!==e&&(this._lastHeight=e,this._onHeight())},e}(),c=function(){function e(t,n,o){
this.allowEditorOverflow=!1,this.suppressMouseDown=!0,this._commands=new Map,this._id="codeLensWidget"+ ++e._idPool,this._editor=t,this.setSymbolRange(n),this._domNode=document.createElement("span"),this._domNode.innerHTML="&nbsp;",i.addClass(this._domNode,"codelens-decoration"),this.updateHeight(),this.withCommands(o.map(function(e){return e.symbol}),!1)}return e.prototype.updateHeight=function(){var e=this._editor.getConfiguration(),t=e.fontInfo,i=e.lineHeight;this._domNode.style.height=Math.round(1.1*i)+"px",this._domNode.style.lineHeight=i+"px",this._domNode.style.fontSize=Math.round(.9*t.fontSize)+"px",this._domNode.style.paddingRight=Math.round(.45*t.fontSize)+"px",this._domNode.innerHTML="&nbsp;"},e.prototype.withCommands=function(e,t){this._commands.clear();var r=n.coalesce(e);if(n.isFalsyOrEmpty(r))this._domNode.innerHTML="<span>no commands</span>";else{for(var s=[],a=0;a<r.length;a++){var l=r[a].command;if(l){var u=o.escape(l.title),d=void 0;l.id?(d="<a id="+a+">"+u+"</a>",
this._commands.set(String(a),l)):d="<span>"+u+"</span>",s.push(d)}}var c=""===this._domNode.innerHTML||"&nbsp;"===this._domNode.innerHTML;this._domNode.innerHTML=s.join("<span>&nbsp;|&nbsp;</span>"),this._editor.layoutContentWidget(this),c&&t&&i.addClass(this._domNode,"fadein")}},e.prototype.getCommand=function(e){return e.parentElement===this._domNode?this._commands.get(e.id):void 0},e.prototype.getId=function(){return this._id},e.prototype.getDomNode=function(){return this._domNode},e.prototype.setSymbolRange=function(e){if(this._editor.hasModel()){var t=e.startLineNumber,i=this._editor.getModel().getLineFirstNonWhitespaceColumn(t);this._widgetPosition={position:{lineNumber:t,column:i},preference:[1]}}},e.prototype.getPosition=function(){return this._widgetPosition||null},e.prototype.isVisible=function(){return this._domNode.hasAttribute("monaco-visible-content-widget")},e._idPool=0,e}(),h=function(){function e(){this._removeDecorations=[],this._addDecorations=[],this._addDecorationsCallbacks=[]}
return e.prototype.addDecoration=function(e,t){this._addDecorations.push(e),this._addDecorationsCallbacks.push(t)},e.prototype.removeDecoration=function(e){this._removeDecorations.push(e)},e.prototype.commit=function(e){for(var t=e.deltaDecorations(this._removeDecorations,this._addDecorations),i=0,n=t.length;i<n;i++)this._addDecorationsCallbacks[i](t[i])},e}();t.CodeLensHelper=h;var p=function(){function e(e,t,i,n,o){var a=this;this._editor=t,this._data=e,this._decorationIds=new Array(this._data.length);var l;this._data.forEach(function(e,t){i.addDecoration({range:e.symbol.range,options:s.ModelDecorationOptions.EMPTY},function(e){return a._decorationIds[t]=e}),l=l?r.Range.plusRange(l,e.symbol.range):r.Range.lift(e.symbol.range)}),l&&(this._contentWidget=new c(t,l,this._data),this._viewZone=new d(l.startLineNumber-1,o),this._viewZoneId=n.addZone(this._viewZone),this._editor.addContentWidget(this._contentWidget))}return e.prototype.dispose=function(e,t){
for(;this._decorationIds.length;)e.removeDecoration(this._decorationIds.pop());t&&t.removeZone(this._viewZoneId),this._editor.removeContentWidget(this._contentWidget)},e.prototype.isValid=function(){var e=this;if(!this._editor.hasModel())return!1;var t=this._editor.getModel();return this._decorationIds.some(function(i,n){var o=t.getDecorationRange(i),s=e._data[n].symbol;return!(!o||r.Range.isEmpty(s.range)!==o.isEmpty())})},e.prototype.updateCodeLensSymbols=function(e,t){for(var i=this;this._decorationIds.length;)t.removeDecoration(this._decorationIds.pop());this._data=e,this._decorationIds=new Array(this._data.length),this._data.forEach(function(e,n){t.addDecoration({range:e.symbol.range,options:s.ModelDecorationOptions.EMPTY},function(e){return i._decorationIds[n]=e})})},e.prototype.computeIfNecessary=function(e){if(!this._contentWidget.isVisible())return null;for(var t=0;t<this._decorationIds.length;t++){var i=e.getDecorationRange(this._decorationIds[t]);i&&(this._data[t].symbol.range=i)}return this._data
},e.prototype.updateCommands=function(e){this._contentWidget.withCommands(e,!0);for(var t=0;t<this._data.length;t++){var i=e[t];if(i){var n=this._data[t].symbol;n.command=i.command||n.command}}},e.prototype.updateHeight=function(){this._contentWidget.updateHeight()},e.prototype.getCommand=function(e){return this._contentWidget.getCommand(e)},e.prototype.getLineNumber=function(){if(this._editor.hasModel()){var e=this._editor.getModel().getDecorationRange(this._decorationIds[0]);if(e)return e.startLineNumber}return-1},e.prototype.update=function(e){if(this.isValid()&&this._editor.hasModel()){var t=this._editor.getModel().getDecorationRange(this._decorationIds[0]);t&&(this._viewZone.afterLineNumber=t.startLineNumber-1,e.layoutZone(this._viewZoneId),this._contentWidget.setSymbolRange(t),this._editor.layoutContentWidget(this._contentWidget))}},e}();t.CodeLensWidget=p,u.registerThemingParticipant(function(e,t){var i=e.getColor(a.editorCodeLensForeground)
;i&&t.addRule(".monaco-editor .codelens-decoration { color: "+i+"; }");var n=e.getColor(l.editorActiveLinkForeground);n&&t.addRule(".monaco-editor .codelens-decoration > a:hover { color: "+n+" !important; }")})}),define(t[545],i([1,0,15,10,2,61,11,17,207,544,32,34,485]),function(e,t,i,n,o,r,s,a,l,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var g=function(){function e(e,t,i,n){var r=this;this._editor=e,this._commandService=t,this._notificationService=i,this._codeLensCache=n,this._globalToDispose=new o.DisposableStore,this._localToDispose=new o.DisposableStore,this._lenses=[],this._oldCodeLensModels=new o.DisposableStore,this._modelChangeCounter=0,this._isEnabled=this._editor.getConfiguration().contribInfo.codeLens,this._globalToDispose.add(this._editor.onDidChangeModel(function(){return r._onModelChange()})),this._globalToDispose.add(this._editor.onDidChangeModelLanguage(function(){return r._onModelChange()})),
this._globalToDispose.add(this._editor.onDidChangeConfiguration(function(){var e=r._isEnabled;r._isEnabled=r._editor.getConfiguration().contribInfo.codeLens,e!==r._isEnabled&&r._onModelChange()})),this._globalToDispose.add(a.CodeLensProviderRegistry.onDidChange(this._onModelChange,this)),this._onModelChange()}return e.prototype.dispose=function(){this._localDispose(),this._globalToDispose.dispose(),this._oldCodeLensModels.dispose(),o.dispose(this._currentCodeLensModel)},e.prototype._localDispose=function(){this._currentFindCodeLensSymbolsPromise&&(this._currentFindCodeLensSymbolsPromise.cancel(),this._currentFindCodeLensSymbolsPromise=void 0,this._modelChangeCounter++),this._currentResolveCodeLensSymbolsPromise&&(this._currentResolveCodeLensSymbolsPromise.cancel(),this._currentResolveCodeLensSymbolsPromise=void 0),this._localToDispose.clear(),this._oldCodeLensModels.clear(),o.dispose(this._currentCodeLensModel)},e.prototype.getId=function(){return e.ID},e.prototype._onModelChange=function(){var e=this
;this._localDispose();var t=this._editor.getModel();if(t&&this._isEnabled){var s=this._codeLensCache.get(t);if(s&&this._renderCodeLensSymbols(s),a.CodeLensProviderRegistry.has(t)){for(var d=0,c=a.CodeLensProviderRegistry.all(t);d<c.length;d++){var h=c[d];if("function"==typeof h.onDidChange){var p=h.onDidChange(function(){return g.schedule()});this._localToDispose.add(p)}}var f=this._detectVisibleLenses=new i.RunOnceScheduler(function(){return e._onViewportChanged()},250),g=new i.RunOnceScheduler(function(){var o=++e._modelChangeCounter;e._currentFindCodeLensSymbolsPromise&&e._currentFindCodeLensSymbolsPromise.cancel(),e._currentFindCodeLensSymbolsPromise=i.createCancelablePromise(function(e){return l.getCodeLensData(t,e)}),e._currentFindCodeLensSymbolsPromise.then(function(i){o===e._modelChangeCounter&&(e._currentCodeLensModel&&e._oldCodeLensModels.add(e._currentCodeLensModel),e._currentCodeLensModel=i,e._codeLensCache.put(t,i),e._renderCodeLensSymbols(i),f.schedule())},n.onUnexpectedError)},250)
;this._localToDispose.add(g),this._localToDispose.add(f),this._localToDispose.add(this._editor.onDidChangeModelContent(function(){e._editor.changeDecorations(function(t){e._editor.changeViewZones(function(i){var n=[],o=-1;e._lenses.forEach(function(e){e.isValid()&&o!==e.getLineNumber()?(e.update(i),o=e.getLineNumber()):n.push(e)});var r=new u.CodeLensHelper;n.forEach(function(t){t.dispose(r,i),e._lenses.splice(e._lenses.indexOf(t),1)}),r.commit(t)})}),f.schedule(),g.schedule()})),this._localToDispose.add(this._editor.onDidScrollChange(function(t){t.scrollTopChanged&&e._lenses.length>0&&f.schedule()})),this._localToDispose.add(this._editor.onDidLayoutChange(function(){f.schedule()})),this._localToDispose.add(o.toDisposable(function(){if(e._editor.getModel()){var t=r.StableEditorScrollState.capture(e._editor);e._editor.changeDecorations(function(t){e._editor.changeViewZones(function(i){e._disposeAllLenses(t,i)})}),t.restore(e._editor)}else e._disposeAllLenses(void 0,void 0)})),
this._localToDispose.add(this._editor.onDidChangeConfiguration(function(t){if(t.fontInfo)for(var i=0,n=e._lenses;i<n.length;i++){n[i].updateHeight()}})),this._localToDispose.add(this._editor.onMouseUp(function(t){var i;if(9===t.target.type&&t.target.element&&"A"===t.target.element.tagName)for(var n=0,o=e._lenses;n<o.length;n++){var r=o[n].getCommand(t.target.element);if(r){(i=e._commandService).executeCommand.apply(i,[r.id].concat(r.arguments||[])).catch(function(t){return e._notificationService.error(t)});break}}})),g.schedule()}else s&&this._localToDispose.add(i.disposableTimeout(function(){var i=e._codeLensCache.get(t);s===i&&(e._codeLensCache.delete(t),e._onModelChange())},3e4))}},e.prototype._disposeAllLenses=function(e,t){var i=new u.CodeLensHelper;this._lenses.forEach(function(e){return e.dispose(i,t)}),e&&i.commit(e),this._lenses=[]},e.prototype._renderCodeLensSymbols=function(e){var t=this;if(this._editor.hasModel()){
for(var i,n=this._editor.getModel().getLineCount(),o=[],s=0,a=e.lenses;s<a.length;s++){var l=a[s],d=l.symbol.range.startLineNumber;d<1||d>n||(i&&i[i.length-1].symbol.range.startLineNumber===d?i.push(l):(i=[l],o.push(i)))}var c=r.StableEditorScrollState.capture(this._editor);this._editor.changeDecorations(function(e){t._editor.changeViewZones(function(i){for(var n=new u.CodeLensHelper,r=0,s=0;s<o.length&&r<t._lenses.length;){var a=o[s][0].symbol.range.startLineNumber,l=t._lenses[r].getLineNumber();l<a?(t._lenses[r].dispose(n,i),t._lenses.splice(r,1)):l===a?(t._lenses[r].updateCodeLensSymbols(o[s],n),s++,r++):(t._lenses.splice(r,0,new u.CodeLensWidget(o[s],t._editor,n,i,function(){return t._detectVisibleLenses&&t._detectVisibleLenses.schedule()})),r++,s++)}for(;r<t._lenses.length;)t._lenses[r].dispose(n,i),t._lenses.splice(r,1);for(;s<o.length;)t._lenses.push(new u.CodeLensWidget(o[s],t._editor,n,i,function(){return t._detectVisibleLenses&&t._detectVisibleLenses.schedule()})),s++;n.commit(e)})}),
c.restore(this._editor)}},e.prototype._onViewportChanged=function(){var e=this;this._currentResolveCodeLensSymbolsPromise&&(this._currentResolveCodeLensSymbolsPromise.cancel(),this._currentResolveCodeLensSymbolsPromise=void 0);var t=this._editor.getModel();if(t){var o=[],r=[];this._lenses.forEach(function(e){var i=e.computeIfNecessary(t);i&&(o.push(i),r.push(e))}),0!==o.length&&(this._currentResolveCodeLensSymbolsPromise=i.createCancelablePromise(function(e){var i=o.map(function(i,o){var s=new Array(i.length),a=i.map(function(i,o){return i.symbol.command||"function"!=typeof i.provider.resolveCodeLens?(s[o]=i.symbol,Promise.resolve(void 0)):Promise.resolve(i.provider.resolveCodeLens(t,i.symbol,e)).then(function(e){s[o]=e},n.onUnexpectedExternalError)});return Promise.all(a).then(function(){e.isCancellationRequested||r[o].updateCommands(s)})});return Promise.all(i)}),this._currentResolveCodeLensSymbolsPromise.then(function(){e._oldCodeLensModels.clear(),e._currentResolveCodeLensSymbolsPromise=void 0
},function(t){n.onUnexpectedError(t),e._currentResolveCodeLensSymbolsPromise=void 0}))}},e.ID="css.editor.codeLens",e=d([c(1,h.ICommandService),c(2,p.INotificationService),c(3,f.ICodeLensCache)],e)}();t.CodeLensContribution=g,s.registerEditorContribution(g)}),define(t[546],i([1,0,28,8,82,45,25,4,2,22,16,578]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h=n.$,p=function(e){function t(t,i,o){var r=e.call(this)||this;r.model=i,r.domNode=h(".colorpicker-header"),n.append(t,r.domNode),r.pickedColorNode=n.append(r.domNode,h(".picked-color"));var s=n.append(r.domNode,h(".original-color"));return s.style.backgroundColor=a.Color.Format.CSS.format(r.model.originalColor),r.backgroundColor=o.getTheme().getColor(d.editorHoverBackground)||a.Color.white,r._register(c.registerThemingParticipant(function(e,t){r.backgroundColor=e.getColor(d.editorHoverBackground)||a.Color.white})),r._register(n.addDisposableListener(r.pickedColorNode,n.EventType.CLICK,function(){
return r.model.selectNextColorPresentation()})),r._register(n.addDisposableListener(s,n.EventType.CLICK,function(){r.model.color=r.model.originalColor,r.model.flushColor()})),r._register(i.onDidChangeColor(r.onDidChangeColor,r)),r._register(i.onDidChangePresentation(r.onDidChangePresentation,r)),r.pickedColorNode.style.backgroundColor=a.Color.Format.CSS.format(i.color),n.toggleClass(r.pickedColorNode,"light",i.color.rgba.a<.5?r.backgroundColor.isLighter():i.color.isLighter()),r}return r(t,e),t.prototype.onDidChangeColor=function(e){this.pickedColorNode.style.backgroundColor=a.Color.Format.CSS.format(e),n.toggleClass(this.pickedColorNode,"light",e.rgba.a<.5?this.backgroundColor.isLighter():e.isLighter()),this.onDidChangePresentation()},t.prototype.onDidChangePresentation=function(){this.pickedColorNode.textContent=this.model.presentation?this.model.presentation.label:""},t}(u.Disposable);t.ColorPickerHeader=p;var f=function(e){function t(t,i,o){var r=e.call(this)||this;return r.model=i,r.pixelRatio=o,
r.domNode=h(".colorpicker-body"),n.append(t,r.domNode),r.saturationBox=new g(r.domNode,r.model,r.pixelRatio),r._register(r.saturationBox),r._register(r.saturationBox.onDidChange(r.onDidSaturationValueChange,r)),r._register(r.saturationBox.onColorFlushed(r.flushColor,r)),r.opacityStrip=new v(r.domNode,r.model),r._register(r.opacityStrip),r._register(r.opacityStrip.onDidChange(r.onDidOpacityChange,r)),r._register(r.opacityStrip.onColorFlushed(r.flushColor,r)),r.hueStrip=new _(r.domNode,r.model),r._register(r.hueStrip),r._register(r.hueStrip.onDidChange(r.onDidHueChange,r)),r._register(r.hueStrip.onColorFlushed(r.flushColor,r)),r}return r(t,e),t.prototype.flushColor=function(){this.model.flushColor()},t.prototype.onDidSaturationValueChange=function(e){var t=e.s,i=e.v,n=this.model.color.hsva;this.model.color=new a.Color(new a.HSVA(n.h,t,i,n.a))},t.prototype.onDidOpacityChange=function(e){var t=this.model.color.hsva;this.model.color=new a.Color(new a.HSVA(t.h,t.s,t.v,e))},t.prototype.onDidHueChange=function(e){
var t=this.model.color.hsva,i=360*(1-e);this.model.color=new a.Color(new a.HSVA(360===i?0:i,t.s,t.v,t.a))},t.prototype.layout=function(){this.saturationBox.layout(),this.opacityStrip.layout(),this.hueStrip.layout()},t}(u.Disposable);t.ColorPickerBody=f;var g=function(e){function t(t,i,o){var r=e.call(this)||this;return r.model=i,r.pixelRatio=o,r._onDidChange=new l.Emitter,r.onDidChange=r._onDidChange.event,r._onColorFlushed=new l.Emitter,r.onColorFlushed=r._onColorFlushed.event,r.domNode=h(".saturation-wrap"),n.append(t,r.domNode),r.canvas=document.createElement("canvas"),r.canvas.className="saturation-box",n.append(r.domNode,r.canvas),r.selection=h(".saturation-selection"),n.append(r.domNode,r.selection),r.layout(),r._register(n.addDisposableListener(r.domNode,n.EventType.MOUSE_DOWN,function(e){return r.onMouseDown(e)})),r._register(r.model.onDidChangeColor(r.onDidChangeColor,r)),r.monitor=null,r}return r(t,e),t.prototype.onMouseDown=function(e){var t=this
;this.monitor=this._register(new o.GlobalMouseMoveMonitor);var i=n.getDomNodePagePosition(this.domNode);e.target!==this.selection&&this.onDidChangePosition(e.offsetX,e.offsetY),this.monitor.startMonitoring(o.standardMouseMoveMerger,function(e){return t.onDidChangePosition(e.posx-i.left,e.posy-i.top)},function(){return null});var r=n.addDisposableListener(document,n.EventType.MOUSE_UP,function(){t._onColorFlushed.fire(),r.dispose(),t.monitor&&(t.monitor.stopMonitoring(!0),t.monitor=null)},!0)},t.prototype.onDidChangePosition=function(e,t){var i=Math.max(0,Math.min(1,e/this.width)),n=Math.max(0,Math.min(1,1-t/this.height));this.paintSelection(i,n),this._onDidChange.fire({s:i,v:n})},t.prototype.layout=function(){this.width=this.domNode.offsetWidth,this.height=this.domNode.offsetHeight,this.canvas.width=this.width*this.pixelRatio,this.canvas.height=this.height*this.pixelRatio,this.paint();var e=this.model.color.hsva;this.paintSelection(e.s,e.v)},t.prototype.paint=function(){
var e=this.model.color.hsva,t=new a.Color(new a.HSVA(e.h,1,1,1)),i=this.canvas.getContext("2d"),n=i.createLinearGradient(0,0,this.canvas.width,0);n.addColorStop(0,"rgba(255, 255, 255, 1)"),n.addColorStop(.5,"rgba(255, 255, 255, 0.5)"),n.addColorStop(1,"rgba(255, 255, 255, 0)");var o=i.createLinearGradient(0,0,0,this.canvas.height);o.addColorStop(0,"rgba(0, 0, 0, 0)"),o.addColorStop(1,"rgba(0, 0, 0, 1)"),i.rect(0,0,this.canvas.width,this.canvas.height),i.fillStyle=a.Color.Format.CSS.format(t),i.fill(),i.fillStyle=n,i.fill(),i.fillStyle=o,i.fill()},t.prototype.paintSelection=function(e,t){this.selection.style.left=e*this.width+"px",this.selection.style.top=this.height-t*this.height+"px"},t.prototype.onDidChangeColor=function(){this.monitor&&this.monitor.isMonitoring()||this.paint()},t}(u.Disposable),m=function(e){function t(t,i){var o=e.call(this)||this;return o.model=i,o._onDidChange=new l.Emitter,o.onDidChange=o._onDidChange.event,o._onColorFlushed=new l.Emitter,o.onColorFlushed=o._onColorFlushed.event,
o.domNode=n.append(t,h(".strip")),o.overlay=n.append(o.domNode,h(".overlay")),o.slider=n.append(o.domNode,h(".slider")),o.slider.style.top="0px",o._register(n.addDisposableListener(o.domNode,n.EventType.MOUSE_DOWN,function(e){return o.onMouseDown(e)})),o.layout(),o}return r(t,e),t.prototype.layout=function(){this.height=this.domNode.offsetHeight-this.slider.offsetHeight;var e=this.getValue(this.model.color);this.updateSliderPosition(e)},t.prototype.onMouseDown=function(e){var t=this,i=this._register(new o.GlobalMouseMoveMonitor),r=n.getDomNodePagePosition(this.domNode);n.addClass(this.domNode,"grabbing"),e.target!==this.slider&&this.onDidChangeTop(e.offsetY),i.startMonitoring(o.standardMouseMoveMerger,function(e){return t.onDidChangeTop(e.posy-r.top)},function(){return null});var s=n.addDisposableListener(document,n.EventType.MOUSE_UP,function(){t._onColorFlushed.fire(),s.dispose(),i.stopMonitoring(!0),n.removeClass(t.domNode,"grabbing")},!0)},t.prototype.onDidChangeTop=function(e){
var t=Math.max(0,Math.min(1,1-e/this.height));this.updateSliderPosition(t),this._onDidChange.fire(t)},t.prototype.updateSliderPosition=function(e){this.slider.style.top=(1-e)*this.height+"px"},t}(u.Disposable),v=function(e){function t(t,i){var o=e.call(this,t,i)||this;return n.addClass(o.domNode,"opacity-strip"),o._register(i.onDidChangeColor(o.onDidChangeColor,o)),o.onDidChangeColor(o.model.color),o}return r(t,e),t.prototype.onDidChangeColor=function(e){var t=e.rgba,i=t.r,n=t.g,o=t.b,r=new a.Color(new a.RGBA(i,n,o,1)),s=new a.Color(new a.RGBA(i,n,o,0));this.overlay.style.background="linear-gradient(to bottom, "+r+" 0%, "+s+" 100%)"},t.prototype.getValue=function(e){return e.hsva.a},t}(m),_=function(e){function t(t,i){var o=e.call(this,t,i)||this;return n.addClass(o.domNode,"hue-strip"),o}return r(t,e),t.prototype.getValue=function(e){return 1-e.hsva.h/360},t}(m),y=function(e){function t(t,n,o,r){var s=e.call(this)||this;s.model=n,s.pixelRatio=o,s._register(i.onDidChangeZoomLevel(function(){return s.layout()
}));var a=h(".colorpicker-widget");t.appendChild(a);var l=new p(a,s.model,r);return s.body=new f(a,s.model,s.pixelRatio),s._register(l),s._register(s.body),s}return r(t,e),t.prototype.layout=function(){this.body.layout()},t}(s.Widget);t.ColorPickerWidget=y}),define(t[547],i([1,0,3,49,30,22,16]),function(e,t,i,n,o,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){function e(e){this._editor=e,this._decorations=[],this._overviewRulerApproximateDecorations=[],this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null,this._startPosition=this._editor.getPosition()}return e.prototype.dispose=function(){this._editor.deltaDecorations(this._allDecorations(),[]),this._decorations=[],this._overviewRulerApproximateDecorations=[],this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null},e.prototype.reset=function(){this._decorations=[],this._overviewRulerApproximateDecorations=[],
this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null},e.prototype.getCount=function(){return this._decorations.length},e.prototype.getFindScope=function(){return this._findScopeDecorationId?this._editor.getModel().getDecorationRange(this._findScopeDecorationId):null},e.prototype.getStartPosition=function(){return this._startPosition},e.prototype.setStartPosition=function(e){this._startPosition=e,this.setCurrentFindMatch(null)},e.prototype._getDecorationIndex=function(e){var t=this._decorations.indexOf(e);return t>=0?t+1:1},e.prototype.getCurrentMatchesPosition=function(t){for(var i=0,n=this._editor.getModel().getDecorationsInRange(t);i<n.length;i++){var o=n[i],r=o.options;if(r===e._FIND_MATCH_DECORATION||r===e._CURRENT_FIND_MATCH_DECORATION)return this._getDecorationIndex(o.id)}return 1},e.prototype.setCurrentFindMatch=function(t){var n=this,o=null,r=0;if(t)for(var s=0,a=this._decorations.length;s<a;s++){
var l=this._editor.getModel().getDecorationRange(this._decorations[s]);if(t.equalsRange(l)){o=this._decorations[s],r=s+1;break}}return null===this._highlightedDecorationId&&null===o||this._editor.changeDecorations(function(t){if(null!==n._highlightedDecorationId&&(t.changeDecorationOptions(n._highlightedDecorationId,e._FIND_MATCH_DECORATION),n._highlightedDecorationId=null),null!==o&&(n._highlightedDecorationId=o,t.changeDecorationOptions(n._highlightedDecorationId,e._CURRENT_FIND_MATCH_DECORATION)),null!==n._rangeHighlightDecorationId&&(t.removeDecoration(n._rangeHighlightDecorationId),n._rangeHighlightDecorationId=null),null!==o){var r=n._editor.getModel().getDecorationRange(o);if(r.startLineNumber!==r.endLineNumber&&1===r.endColumn){var s=r.endLineNumber-1,a=n._editor.getModel().getLineMaxColumn(s);r=new i.Range(r.startLineNumber,r.startColumn,s,a)}n._rangeHighlightDecorationId=t.addDecoration(r,e._RANGE_HIGHLIGHT_DECORATION)}}),r},e.prototype.set=function(t,n){var o=this
;this._editor.changeDecorations(function(r){var s=e._FIND_MATCH_DECORATION,a=[];if(t.length>1e3){s=e._FIND_MATCH_NO_OVERVIEW_DECORATION;for(var l=o._editor.getModel().getLineCount(),u=o._editor.getLayoutInfo().height/l,d=Math.max(2,Math.ceil(3/u)),c=t[0].range.startLineNumber,h=t[0].range.endLineNumber,p=1,f=t.length;p<f;p++){var g=t[p].range;h+d>=g.startLineNumber?g.endLineNumber>h&&(h=g.endLineNumber):(a.push({range:new i.Range(c,1,h,1),options:e._FIND_MATCH_ONLY_OVERVIEW_DECORATION}),c=g.startLineNumber,h=g.endLineNumber)}a.push({range:new i.Range(c,1,h,1),options:e._FIND_MATCH_ONLY_OVERVIEW_DECORATION})}for(var m=new Array(t.length),p=0,f=t.length;p<f;p++)m[p]={range:t[p].range,options:s};o._decorations=r.deltaDecorations(o._decorations,m),o._overviewRulerApproximateDecorations=r.deltaDecorations(o._overviewRulerApproximateDecorations,a),o._rangeHighlightDecorationId&&(r.removeDecoration(o._rangeHighlightDecorationId),o._rangeHighlightDecorationId=null),
o._findScopeDecorationId&&(r.removeDecoration(o._findScopeDecorationId),o._findScopeDecorationId=null),n&&(o._findScopeDecorationId=r.addDecoration(n,e._FIND_SCOPE_DECORATION))})},e.prototype.matchBeforePosition=function(e){if(0===this._decorations.length)return null;for(var t=this._decorations.length-1;t>=0;t--){var i=this._decorations[t],n=this._editor.getModel().getDecorationRange(i);if(n&&!(n.endLineNumber>e.lineNumber)){if(n.endLineNumber<e.lineNumber)return n;if(!(n.endColumn>e.column))return n}}return this._editor.getModel().getDecorationRange(this._decorations[this._decorations.length-1])},e.prototype.matchAfterPosition=function(e){if(0===this._decorations.length)return null;for(var t=0,i=this._decorations.length;t<i;t++){var n=this._decorations[t],o=this._editor.getModel().getDecorationRange(n);if(o&&!(o.startLineNumber<e.lineNumber)){if(o.startLineNumber>e.lineNumber)return o;if(!(o.startColumn<e.column))return o}}return this._editor.getModel().getDecorationRange(this._decorations[0])},
e.prototype._allDecorations=function(){var e=[];return e=e.concat(this._decorations),e=e.concat(this._overviewRulerApproximateDecorations),this._findScopeDecorationId&&e.push(this._findScopeDecorationId),this._rangeHighlightDecorationId&&e.push(this._rangeHighlightDecorationId),e},e._CURRENT_FIND_MATCH_DECORATION=o.ModelDecorationOptions.register({stickiness:1,zIndex:13,className:"currentFindMatch",showIfCollapsed:!0,overviewRuler:{color:s.themeColorFromId(r.overviewRulerFindMatchForeground),position:n.OverviewRulerLane.Center},minimap:{color:s.themeColorFromId(r.minimapFindMatch),position:n.MinimapPosition.Inline}}),e._FIND_MATCH_DECORATION=o.ModelDecorationOptions.register({stickiness:1,className:"findMatch",showIfCollapsed:!0,overviewRuler:{color:s.themeColorFromId(r.overviewRulerFindMatchForeground),position:n.OverviewRulerLane.Center},minimap:{color:s.themeColorFromId(r.minimapFindMatch),position:n.MinimapPosition.Inline}}),e._FIND_MATCH_NO_OVERVIEW_DECORATION=o.ModelDecorationOptions.register({
stickiness:1,className:"findMatch",showIfCollapsed:!0}),e._FIND_MATCH_ONLY_OVERVIEW_DECORATION=o.ModelDecorationOptions.register({stickiness:1,overviewRuler:{color:s.themeColorFromId(r.overviewRulerFindMatchForeground),position:n.OverviewRulerLane.Center}}),e._RANGE_HIGHLIGHT_DECORATION=o.ModelDecorationOptions.register({stickiness:1,className:"rangeHighlight",isWholeLine:!0}),e._FIND_SCOPE_DECORATION=o.ModelDecorationOptions.register({className:"findScope",isWholeLine:!0}),e}();t.FindDecorations=a}),define(t[137],i([1,0,15,2,81,13,3,20,147,547,251,252,14]),function(e,t,i,n,o,r,s,a,l,u,d,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_FIND_WIDGET_VISIBLE=new h.RawContextKey("findWidgetVisible",!1),t.CONTEXT_FIND_INPUT_FOCUSED=new h.RawContextKey("findInputFocussed",!1),t.CONTEXT_REPLACE_INPUT_FOCUSED=new h.RawContextKey("replaceInputFocussed",!1),t.ToggleCaseSensitiveKeybinding={primary:545,mac:{primary:2593}},t.ToggleWholeWordKeybinding={primary:565,mac:{primary:2613}},
t.ToggleRegexKeybinding={primary:560,mac:{primary:2608}},t.ToggleSearchScopeKeybinding={primary:554,mac:{primary:2602}},t.FIND_IDS={StartFindAction:"actions.find",StartFindWithSelection:"actions.findWithSelection",NextMatchFindAction:"editor.action.nextMatchFindAction",PreviousMatchFindAction:"editor.action.previousMatchFindAction",NextSelectionMatchFindAction:"editor.action.nextSelectionMatchFindAction",PreviousSelectionMatchFindAction:"editor.action.previousSelectionMatchFindAction",StartFindReplaceAction:"editor.action.startFindReplaceAction",CloseFindWidgetCommand:"closeFindWidget",ToggleCaseSensitiveCommand:"toggleFindCaseSensitive",ToggleWholeWordCommand:"toggleFindWholeWord",ToggleRegexCommand:"toggleFindRegex",ToggleSearchScopeCommand:"toggleFindInSelection",TogglePreserveCaseCommand:"togglePreserveCase",ReplaceOneAction:"editor.action.replaceOne",ReplaceAllAction:"editor.action.replaceAll",SelectAllMatchesAction:"editor.action.selectAllMatches"},t.MATCHES_LIMIT=19999;var p=function(){function e(e,t){
var o=this;this._toDispose=new n.DisposableStore,this._editor=e,this._state=t,this._isDisposed=!1,this._startSearchingTimer=new i.TimeoutTimer,this._decorations=new u.FindDecorations(e),this._toDispose.add(this._decorations),this._updateDecorationsScheduler=new i.RunOnceScheduler(function(){return o.research(!1)},100),this._toDispose.add(this._updateDecorationsScheduler),this._toDispose.add(this._editor.onDidChangeCursorPosition(function(e){3!==e.reason&&5!==e.reason&&6!==e.reason||o._decorations.setStartPosition(o._editor.getPosition())})),this._ignoreModelContentChanged=!1,this._toDispose.add(this._editor.onDidChangeModelContent(function(e){o._ignoreModelContentChanged||(e.isFlush&&o._decorations.reset(),o._decorations.setStartPosition(o._editor.getPosition()),o._updateDecorationsScheduler.schedule())})),this._toDispose.add(this._state.onFindReplaceStateChange(function(e){return o._onStateChanged(e)})),this.research(!1,this._state.searchScope)}return e.prototype.dispose=function(){this._isDisposed=!0,
n.dispose(this._startSearchingTimer),this._toDispose.dispose()},e.prototype._onStateChanged=function(e){var t=this;if(!this._isDisposed&&this._editor.hasModel()&&(e.searchString||e.isReplaceRevealed||e.isRegex||e.wholeWord||e.matchCase||e.searchScope)){this._editor.getModel().isTooLargeForSyncing()?(this._startSearchingTimer.cancel(),this._startSearchingTimer.setIfNotSet(function(){e.searchScope?t.research(e.moveCursor,t._state.searchScope):t.research(e.moveCursor)},240)):e.searchScope?this.research(e.moveCursor,this._state.searchScope):this.research(e.moveCursor)}},e._getSearchRange=function(e,t){return t||e.getFullModelRange()},e.prototype.research=function(e,i){var n=null;null!==(n=void 0!==i?i:this._decorations.getFindScope())&&n.startLineNumber!==n.endLineNumber&&(n=1===n.endColumn?new s.Range(n.startLineNumber,1,n.endLineNumber-1,this._editor.getModel().getLineMaxColumn(n.endLineNumber-1)):new s.Range(n.startLineNumber,1,n.endLineNumber,this._editor.getModel().getLineMaxColumn(n.endLineNumber)))
;var o=this._findMatches(n,!1,t.MATCHES_LIMIT);this._decorations.set(o,n),this._state.changeMatchInfo(this._decorations.getCurrentMatchesPosition(this._editor.getSelection()),this._decorations.getCount(),void 0),e&&this._moveToNextMatch(this._decorations.getStartPosition())},e.prototype._hasMatches=function(){return this._state.matchesCount>0},e.prototype._cannotFind=function(){if(!this._hasMatches()){var e=this._decorations.getFindScope();return e&&this._editor.revealRangeInCenterIfOutsideViewport(e,0),!0}return!1},e.prototype._setCurrentFindMatch=function(e){var t=this._decorations.setCurrentFindMatch(e);this._state.changeMatchInfo(t,this._decorations.getCount(),e),this._editor.setSelection(e),this._editor.revealRangeInCenterIfOutsideViewport(e,0)},e.prototype._prevSearchPosition=function(e){var t=this._state.isRegex&&(this._state.searchString.indexOf("^")>=0||this._state.searchString.indexOf("$")>=0),i=e.lineNumber,n=e.column,o=this._editor.getModel();return t||1===n?(1===i?i=o.getLineCount():i--,
n=o.getLineMaxColumn(i)):n--,new r.Position(i,n)},e.prototype._moveToPrevMatch=function(i,n){if(void 0===n&&(n=!1),this._decorations.getCount()<t.MATCHES_LIMIT){var o=this._decorations.matchBeforePosition(i);return o&&o.isEmpty()&&o.getStartPosition().equals(i)&&(i=this._prevSearchPosition(i),o=this._decorations.matchBeforePosition(i)),void(o&&this._setCurrentFindMatch(o))}if(!this._cannotFind()){var s=this._decorations.getFindScope(),a=e._getSearchRange(this._editor.getModel(),s);a.getEndPosition().isBefore(i)&&(i=a.getEndPosition()),i.isBefore(a.getStartPosition())&&(i=a.getEndPosition());var l=i.lineNumber,u=i.column,d=this._editor.getModel(),c=new r.Position(l,u),h=d.findPreviousMatch(this._state.searchString,c,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);if(h&&h.range.isEmpty()&&h.range.getStartPosition().equals(c)&&(c=this._prevSearchPosition(c),
h=d.findPreviousMatch(this._state.searchString,c,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1)),h)return n||a.containsRange(h.range)?void this._setCurrentFindMatch(h.range):this._moveToPrevMatch(h.range.getStartPosition(),!0)}},e.prototype.moveToPrevMatch=function(){this._moveToPrevMatch(this._editor.getSelection().getStartPosition())},e.prototype._nextSearchPosition=function(e){var t=this._state.isRegex&&(this._state.searchString.indexOf("^")>=0||this._state.searchString.indexOf("$")>=0),i=e.lineNumber,n=e.column,o=this._editor.getModel();return t||n===o.getLineMaxColumn(i)?(i===o.getLineCount()?i=1:i++,n=1):n++,new r.Position(i,n)},e.prototype._moveToNextMatch=function(e){if(this._decorations.getCount()<t.MATCHES_LIMIT){var i=this._decorations.matchAfterPosition(e);return i&&i.isEmpty()&&i.getStartPosition().equals(e)&&(e=this._nextSearchPosition(e),i=this._decorations.matchAfterPosition(e)),void(i&&this._setCurrentFindMatch(i))}
var n=this._getNextMatch(e,!1,!0);n&&this._setCurrentFindMatch(n.range)},e.prototype._getNextMatch=function(t,i,n,o){if(void 0===o&&(o=!1),this._cannotFind())return null;var s=this._decorations.getFindScope(),a=e._getSearchRange(this._editor.getModel(),s);a.getEndPosition().isBefore(t)&&(t=a.getStartPosition()),t.isBefore(a.getStartPosition())&&(t=a.getStartPosition());var l=t.lineNumber,u=t.column,d=this._editor.getModel(),c=new r.Position(l,u),h=d.findNextMatch(this._state.searchString,c,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,i);return n&&h&&h.range.isEmpty()&&h.range.getStartPosition().equals(c)&&(c=this._nextSearchPosition(c),h=d.findNextMatch(this._state.searchString,c,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,i)),h?o||a.containsRange(h.range)?h:this._getNextMatch(h.range.getEndPosition(),i,n,!0):null},e.prototype.moveToNextMatch=function(){
this._moveToNextMatch(this._editor.getSelection().getEndPosition())},e.prototype._getReplacePattern=function(){return this._state.isRegex?c.parseReplaceString(this._state.replaceString):c.ReplacePattern.fromStaticValue(this._state.replaceString)},e.prototype.replace=function(){if(this._hasMatches()){var e=this._getReplacePattern(),t=this._editor.getSelection(),i=this._getNextMatch(t.getStartPosition(),!0,!1);if(i)if(t.equalsRange(i.range)){var n=e.buildReplaceString(i.matches,this._state.preserveCase),s=new o.ReplaceCommand(t,n);this._executeEditorCommand("replace",s),this._decorations.setStartPosition(new r.Position(t.startLineNumber,t.startColumn+n.length)),this.research(!0)}else this._decorations.setStartPosition(this._editor.getPosition()),this._setCurrentFindMatch(i.range)}},e.prototype._findMatches=function(t,i,n){var o=e._getSearchRange(this._editor.getModel(),t)
;return this._editor.getModel().findMatches(this._state.searchString,o,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,i,n)},e.prototype.replaceAll=function(){if(this._hasMatches()){var e=this._decorations.getFindScope();null===e&&this._state.matchesCount>=t.MATCHES_LIMIT?this._largeReplaceAll():this._regularReplaceAll(e),this.research(!1)}},e.prototype._largeReplaceAll=function(){var e=new l.SearchParams(this._state.searchString,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null).parseSearchRequest();if(e){var t=e.regex;if(!t.multiline){var i="m";t.ignoreCase&&(i+="i"),t.global&&(i+="g"),t=new RegExp(t.source,i)}var n,r=this._editor.getModel(),s=r.getValue(1),a=r.getFullModelRange(),u=this._getReplacePattern(),d=this._state.preserveCase;n=u.hasReplacementPatterns||d?s.replace(t,function(){return u.buildReplaceString(arguments,d)}):s.replace(t,u.buildReplaceString(null,d))
;var c=new o.ReplaceCommandThatPreservesSelection(a,n,this._editor.getSelection());this._executeEditorCommand("replaceAll",c)}},e.prototype._regularReplaceAll=function(e){for(var t=this._getReplacePattern(),i=this._findMatches(e,t.hasReplacementPatterns||this._state.preserveCase,1073741824),n=[],o=0,r=i.length;o<r;o++)n[o]=t.buildReplaceString(i[o].matches,this._state.preserveCase);var s=new d.ReplaceAllCommand(this._editor.getSelection(),i.map(function(e){return e.range}),n);this._executeEditorCommand("replaceAll",s)},e.prototype.selectAllMatches=function(){if(this._hasMatches()){for(var e=this._decorations.getFindScope(),t=this._findMatches(e,!1,1073741824).map(function(e){return new a.Selection(e.range.startLineNumber,e.range.startColumn,e.range.endLineNumber,e.range.endColumn)}),i=this._editor.getSelection(),n=0,o=t.length;n<o;n++){if(t[n].equalsRange(i)){t=[i].concat(t.slice(0,n)).concat(t.slice(n+1));break}}this._editor.setSelections(t)}},e.prototype._executeEditorCommand=function(e,t){try{
this._ignoreModelContentChanged=!0,this._editor.pushUndoStop(),this._editor.executeCommand(e,t),this._editor.pushUndoStop()}finally{this._ignoreModelContentChanged=!1}},e}();t.FindModelBoundToEditorModel=p}),define(t[549],i([1,0,8,182,45,15,137,22,16]),function(e,t,i,n,o,s,a,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var d=function(e){function t(t,o,r,u){var d=e.call(this)||this;d._hideSoon=d._register(new s.RunOnceScheduler(function(){return d._hide()},2e3)),d._isVisible=!1,d._editor=t,d._state=o,d._keybindingService=r,d._domNode=document.createElement("div"),d._domNode.className="findOptionsWidget",d._domNode.style.display="none",d._domNode.style.top="10px",d._domNode.setAttribute("role","presentation"),d._domNode.setAttribute("aria-hidden","true");var c=u.getTheme().getColor(l.inputActiveOptionBorder),h=u.getTheme().getColor(l.inputActiveOptionBackground);return d.caseSensitive=d._register(new n.CaseSensitiveCheckbox({
appendTitle:d._keybindingLabelFor(a.FIND_IDS.ToggleCaseSensitiveCommand),isChecked:d._state.matchCase,inputActiveOptionBorder:c,inputActiveOptionBackground:h})),d._domNode.appendChild(d.caseSensitive.domNode),d._register(d.caseSensitive.onChange(function(){d._state.change({matchCase:d.caseSensitive.checked},!1)})),d.wholeWords=d._register(new n.WholeWordsCheckbox({appendTitle:d._keybindingLabelFor(a.FIND_IDS.ToggleWholeWordCommand),isChecked:d._state.wholeWord,inputActiveOptionBorder:c,inputActiveOptionBackground:h})),d._domNode.appendChild(d.wholeWords.domNode),d._register(d.wholeWords.onChange(function(){d._state.change({wholeWord:d.wholeWords.checked},!1)})),d.regex=d._register(new n.RegexCheckbox({appendTitle:d._keybindingLabelFor(a.FIND_IDS.ToggleRegexCommand),isChecked:d._state.isRegex,inputActiveOptionBorder:c,inputActiveOptionBackground:h})),d._domNode.appendChild(d.regex.domNode),d._register(d.regex.onChange(function(){d._state.change({isRegex:d.regex.checked},!1)})),d._editor.addOverlayWidget(d),
d._register(d._state.onFindReplaceStateChange(function(e){var t=!1;e.isRegex&&(d.regex.checked=d._state.isRegex,t=!0),e.wholeWord&&(d.wholeWords.checked=d._state.wholeWord,t=!0),e.matchCase&&(d.caseSensitive.checked=d._state.matchCase,t=!0),!d._state.isRevealed&&t&&d._revealTemporarily()})),d._register(i.addDisposableNonBubblingMouseOutListener(d._domNode,function(e){return d._onMouseOut()})),d._register(i.addDisposableListener(d._domNode,"mouseover",function(e){return d._onMouseOver()})),d._applyTheme(u.getTheme()),d._register(u.onThemeChange(d._applyTheme.bind(d))),d}return r(t,e),t.prototype._keybindingLabelFor=function(e){var t=this._keybindingService.lookupKeybinding(e);return t?" ("+t.getLabel()+")":""},t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),e.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return{preference:0}},t.prototype.highlightFindOptions=function(){
this._revealTemporarily()},t.prototype._revealTemporarily=function(){this._show(),this._hideSoon.schedule()},t.prototype._onMouseOut=function(){this._hideSoon.schedule()},t.prototype._onMouseOver=function(){this._hideSoon.cancel()},t.prototype._show=function(){this._isVisible||(this._isVisible=!0,this._domNode.style.display="block")},t.prototype._hide=function(){this._isVisible&&(this._isVisible=!1,this._domNode.style.display="none")},t.prototype._applyTheme=function(e){var t={inputActiveOptionBorder:e.getColor(l.inputActiveOptionBorder),inputActiveOptionBackground:e.getColor(l.inputActiveOptionBackground)};this.caseSensitive.style(t),this.wholeWords.style(t),this.regex.style(t)},t.ID="editor.contrib.findOptionsWidget",t}(o.Widget);t.FindOptionsWidget=d,u.registerThemingParticipant(function(e,t){var i=e.getColor(l.editorWidgetBackground);i&&t.addRule(".monaco-editor .findOptionsWidget { background-color: "+i+"; }");var n=e.getColor(l.widgetShadow)
;n&&t.addRule(".monaco-editor .findOptionsWidget { box-shadow: 0 2px 8px "+n+"; }");var o=e.getColor(l.contrastBorder);o&&t.addRule(".monaco-editor .findOptionsWidget { border: 2px solid "+o+"; }")})}),define(t[550],i([1,0,331,8,43,100,45,15,10,2,18,5,3,137,22,16,470,548]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v){"use strict";function _(e,t,i){var n=!!t.match(/\n/);i&&n&&i.selectionStart>0&&e.stopPropagation()}function y(e,t,i){var n=!!t.match(/\n/);i&&n&&i.selectionEnd<i.value.length&&e.stopPropagation()}Object.defineProperty(t,"__esModule",{value:!0});var b=i.localize(0,null),C=i.localize(1,null),S=i.localize(2,null),w=i.localize(3,null),E=i.localize(4,null),L=i.localize(5,null),x=i.localize(6,null),D=i.localize(7,null),I=i.localize(8,null),N=i.localize(9,null),M=i.localize(10,null),k=i.localize(11,null,f.MATCHES_LIMIT),T=i.localize(12,null),R=i.localize(13,null),O=69,P=17+(O+3+1)+92+2,A=33,F="ctrlEnterReplaceAll.windows.donotask",W=c.isMacintosh?256:2048,V=function(){return function(e){
this.afterLineNumber=e,this.heightInPx=A,this.suppressMouseDown=!1,this.domNode=document.createElement("div"),this.domNode.className="dock-find-viewzone"}}();t.FindWidgetViewZone=V;var B=function(e){function t(t,i,o,r,s,a,u,c,h){var p=e.call(this)||this;return p._codeEditor=t,p._controller=i,p._state=o,p._contextViewProvider=r,p._keybindingService=s,p._contextKeyService=a,p._storageService=c,p._notificationService=h,p._ctrlEnterReplaceAllWarningPrompted=!!c.getBoolean(F,0),p._isVisible=!1,p._isReplaceVisible=!1,p._ignoreChangeEvent=!1,p._updateHistoryDelayer=new l.Delayer(500),p._register(d.toDisposable(function(){return p._updateHistoryDelayer.cancel()})),p._register(p._state.onFindReplaceStateChange(function(e){return p._onStateChanged(e)})),p._buildDomNode(),p._updateButtons(),p._tryUpdateWidgetWidth(),p._findInput.inputBox.layout(),p._register(p._codeEditor.onDidChangeConfiguration(function(e){if(e.readOnly&&(p._codeEditor.getConfiguration().readOnly&&p._state.change({isReplaceRevealed:!1},!1),
p._updateButtons()),e.layoutInfo&&p._tryUpdateWidgetWidth(),e.accessibilitySupport&&p.updateAccessibilitySupport(),e.contribInfo){var t=p._codeEditor.getConfiguration().contribInfo.find.addExtraSpaceOnTop;t&&!p._viewZone&&(p._viewZone=new V(0),p._showViewZone()),!t&&p._viewZone&&p._removeViewZone()}})),p.updateAccessibilitySupport(),p._register(p._codeEditor.onDidChangeCursorSelection(function(){p._isVisible&&p._updateToggleSelectionFindButton()})),p._register(p._codeEditor.onDidFocusEditorWidget(function(){if(p._isVisible){var e=p._controller.getGlobalBufferTerm();e&&e!==p._state.searchString&&(p._state.change({searchString:e},!0),p._findInput.select())}})),p._findInputFocused=f.CONTEXT_FIND_INPUT_FOCUSED.bindTo(a),p._findFocusTracker=p._register(n.trackFocus(p._findInput.inputBox.inputElement)),p._register(p._findFocusTracker.onDidFocus(function(){p._findInputFocused.set(!0),p._updateSearchScope()})),p._register(p._findFocusTracker.onDidBlur(function(){p._findInputFocused.set(!1)})),
p._replaceInputFocused=f.CONTEXT_REPLACE_INPUT_FOCUSED.bindTo(a),p._replaceFocusTracker=p._register(n.trackFocus(p._replaceInput.inputBox.inputElement)),p._register(p._replaceFocusTracker.onDidFocus(function(){p._replaceInputFocused.set(!0),p._updateSearchScope()})),p._register(p._replaceFocusTracker.onDidBlur(function(){p._replaceInputFocused.set(!1)})),p._codeEditor.addOverlayWidget(p),p._codeEditor.getConfiguration().contribInfo.find.addExtraSpaceOnTop&&(p._viewZone=new V(0)),p._applyTheme(u.getTheme()),p._register(u.onThemeChange(p._applyTheme.bind(p))),p._register(p._codeEditor.onDidChangeModel(function(){p._isVisible&&(p._viewZoneId=void 0)})),p._register(p._codeEditor.onDidScrollChange(function(e){e.scrollTopChanged?p._layoutViewZone():setTimeout(function(){p._layoutViewZone()},0)})),p}return r(t,e),t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return this._isVisible?{preference:0}:null},
t.prototype._onStateChanged=function(e){if(e.searchString){this._state.searchString.indexOf("\n")>=0?n.addClass(this._domNode,"multipleline"):n.removeClass(this._domNode,"multipleline");try{this._ignoreChangeEvent=!0,this._findInput.setValue(this._state.searchString)}finally{this._ignoreChangeEvent=!1}this._updateButtons()}if(e.replaceString&&(this._replaceInput.inputBox.value=this._state.replaceString),e.isRevealed&&(this._state.isRevealed?this._reveal():this._hide(!0)),e.isReplaceRevealed&&(this._state.isReplaceRevealed?this._codeEditor.getConfiguration().readOnly||this._isReplaceVisible||(this._isReplaceVisible=!0,this._replaceInput.width=n.getTotalWidth(this._findInput.domNode),this._updateButtons(),this._replaceInput.inputBox.layout()):this._isReplaceVisible&&(this._isReplaceVisible=!1,this._updateButtons())),(e.isRevealed||e.isReplaceRevealed)&&(this._state.isRevealed||this._state.isReplaceRevealed)&&this._tryUpdateHeight()&&this._showViewZone(),e.isRegex&&this._findInput.setRegex(this._state.isRegex),
e.wholeWord&&this._findInput.setWholeWords(this._state.wholeWord),e.matchCase&&this._findInput.setCaseSensitive(this._state.matchCase),e.searchScope&&(this._state.searchScope?this._toggleSelectionFind.checked=!0:this._toggleSelectionFind.checked=!1,this._updateToggleSelectionFindButton()),e.searchString||e.matchesCount||e.matchesPosition){var t=this._state.searchString.length>0&&0===this._state.matchesCount;n.toggleClass(this._domNode,"no-results",t),this._updateMatchesCount(),this._updateButtons()}(e.searchString||e.currentMatch)&&this._layoutViewZone(),e.updateHistory&&this._delayedUpdateHistory()},t.prototype._delayedUpdateHistory=function(){this._updateHistoryDelayer.trigger(this._updateHistory.bind(this))},t.prototype._updateHistory=function(){this._state.searchString&&this._findInput.inputBox.addToHistory(),this._state.replaceString&&this._replaceInput.inputBox.addToHistory()},t.prototype._updateMatchesCount=function(){this._matchesCount.style.minWidth=O+"px",
this._state.matchesCount>=f.MATCHES_LIMIT?this._matchesCount.title=k:this._matchesCount.title="",this._matchesCount.firstChild&&this._matchesCount.removeChild(this._matchesCount.firstChild);var e;if(this._state.matchesCount>0){var t=String(this._state.matchesCount);this._state.matchesCount>=f.MATCHES_LIMIT&&(t+="+");var i=String(this._state.matchesPosition);"0"===i&&(i="?"),e=h.format(T,i,t)}else e=R;this._matchesCount.appendChild(document.createTextNode(e)),o.alert(this._getAriaLabel(e,this._state.currentMatch,this._state.searchString),!0),O=Math.max(O,this._matchesCount.clientWidth)},t.prototype._getAriaLabel=function(e,t,n){return e===R?""===n?i.localize(14,null,e):i.localize(15,null,e,n):t?i.localize(16,null,e,n,t.startLineNumber+":"+t.startColumn):i.localize(17,null,e,n)},t.prototype._updateToggleSelectionFindButton=function(){var e=this._codeEditor.getSelection(),t=!!e&&(e.startLineNumber!==e.endLineNumber||e.startColumn!==e.endColumn),i=this._toggleSelectionFind.checked
;this._toggleSelectionFind.setEnabled(this._isVisible&&(i||t))},t.prototype._updateButtons=function(){this._findInput.setEnabled(this._isVisible),this._replaceInput.setEnabled(this._isVisible&&this._isReplaceVisible),this._updateToggleSelectionFindButton(),this._closeBtn.setEnabled(this._isVisible);var e=this._state.searchString.length>0,t=!!this._state.matchesCount;this._prevBtn.setEnabled(this._isVisible&&e&&t),this._nextBtn.setEnabled(this._isVisible&&e&&t),this._replaceBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&e),this._replaceAllBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&e),n.toggleClass(this._domNode,"replaceToggled",this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("collapse",!this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("expand",this._isReplaceVisible),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible);var i=!this._codeEditor.getConfiguration().readOnly;this._toggleReplaceBtn.setEnabled(this._isVisible&&i)},t.prototype._reveal=function(){
var e=this;if(!this._isVisible){this._isVisible=!0;var t=this._codeEditor.getSelection();!!t&&(t.startLineNumber!==t.endLineNumber||t.startColumn!==t.endColumn)&&this._codeEditor.getConfiguration().contribInfo.find.autoFindInSelection?this._toggleSelectionFind.checked=!0:this._toggleSelectionFind.checked=!1,this._tryUpdateWidgetWidth(),this._updateButtons(),setTimeout(function(){n.addClass(e._domNode,"visible"),e._domNode.setAttribute("aria-hidden","false")},0),setTimeout(function(){e._findInput.validate()},200),this._codeEditor.layoutOverlayWidget(this);var i=!0;if(this._codeEditor.getConfiguration().contribInfo.find.seedSearchStringFromSelection&&t){var o=this._codeEditor.getDomNode();if(o){var r=n.getDomNodePagePosition(o),s=this._codeEditor.getScrolledVisiblePosition(t.getStartPosition()),a=r.left+(s?s.left:0),l=s?s.top:0;if(this._viewZone&&l<this._viewZone.heightInPx){t.endLineNumber>t.startLineNumber&&(i=!1);var u=n.getTopLeftOffset(this._domNode).left;a>u&&(i=!1)
;var d=this._codeEditor.getScrolledVisiblePosition(t.getEndPosition());r.left+(d?d.left:0)>u&&(i=!1)}}}this._showViewZone(i)}},t.prototype._hide=function(e){this._isVisible&&(this._isVisible=!1,this._updateButtons(),n.removeClass(this._domNode,"visible"),this._domNode.setAttribute("aria-hidden","true"),this._findInput.clearMessage(),e&&this._codeEditor.focus(),this._codeEditor.layoutOverlayWidget(this),this._removeViewZone())},t.prototype._layoutViewZone=function(){var e=this;if(this._codeEditor.getConfiguration().contribInfo.find.addExtraSpaceOnTop){if(this._isVisible){var t=this._viewZone;void 0===this._viewZoneId&&t&&this._codeEditor.changeViewZones(function(i){t.heightInPx=e._getHeight(),e._viewZoneId=i.addZone(t),e._codeEditor.setScrollTop(e._codeEditor.getScrollTop()+t.heightInPx)})}}else this._removeViewZone()},t.prototype._showViewZone=function(e){var t=this;if(void 0===e&&(e=!0),this._isVisible){if(this._codeEditor.getConfiguration().contribInfo.find.addExtraSpaceOnTop){
void 0===this._viewZone&&(this._viewZone=new V(0));var i=this._viewZone;this._codeEditor.changeViewZones(function(n){if(void 0!==t._viewZoneId){var o=t._getHeight();if(o===i.heightInPx)return;r=o-i.heightInPx;return i.heightInPx=o,n.layoutZone(t._viewZoneId),void(e&&t._codeEditor.setScrollTop(t._codeEditor.getScrollTop()+r))}var r=t._getHeight();i.heightInPx=r,t._viewZoneId=n.addZone(i),e&&t._codeEditor.setScrollTop(t._codeEditor.getScrollTop()+r)})}}},t.prototype._removeViewZone=function(){var e=this;this._codeEditor.changeViewZones(function(t){void 0!==e._viewZoneId&&(t.removeZone(e._viewZoneId),e._viewZoneId=void 0,e._viewZone&&(e._codeEditor.setScrollTop(e._codeEditor.getScrollTop()-e._viewZone.heightInPx),e._viewZone=void 0))})},t.prototype._applyTheme=function(e){var t={inputActiveOptionBorder:e.getColor(g.inputActiveOptionBorder),inputActiveOptionBackground:e.getColor(g.inputActiveOptionBackground),inputBackground:e.getColor(g.inputBackground),inputForeground:e.getColor(g.inputForeground),
inputBorder:e.getColor(g.inputBorder),inputValidationInfoBackground:e.getColor(g.inputValidationInfoBackground),inputValidationInfoForeground:e.getColor(g.inputValidationInfoForeground),inputValidationInfoBorder:e.getColor(g.inputValidationInfoBorder),inputValidationWarningBackground:e.getColor(g.inputValidationWarningBackground),inputValidationWarningForeground:e.getColor(g.inputValidationWarningForeground),inputValidationWarningBorder:e.getColor(g.inputValidationWarningBorder),inputValidationErrorBackground:e.getColor(g.inputValidationErrorBackground),inputValidationErrorForeground:e.getColor(g.inputValidationErrorForeground),inputValidationErrorBorder:e.getColor(g.inputValidationErrorBorder)};this._findInput.style(t),this._replaceInput.style(t)},t.prototype._tryUpdateWidgetWidth=function(){if(this._isVisible){if(this._codeEditor.getConfiguration().layoutInfo.contentWidth<=0)n.addClass(this._domNode,"hiddenEditor");else{n.hasClass(this._domNode,"hiddenEditor")&&n.removeClass(this._domNode,"hiddenEditor")
;var e=this._codeEditor.getConfiguration().layoutInfo.width,t=this._codeEditor.getConfiguration().layoutInfo.minimapWidth,i=!1,o=!1,r=!1;if(this._resized){if(n.getTotalWidth(this._domNode)>419)return this._domNode.style.maxWidth=e-28-t-15+"px",void(this._replaceInput.width=n.getTotalWidth(this._findInput.domNode))}if(447+t>=e&&(o=!0),447+t-O>=e&&(r=!0),447+t-O>=e+50&&(i=!0),n.toggleClass(this._domNode,"collapsed-find-widget",i),n.toggleClass(this._domNode,"narrow-find-widget",r),n.toggleClass(this._domNode,"reduced-find-widget",o),r||i||(this._domNode.style.maxWidth=e-28-t-15+"px"),this._resized){this._findInput.inputBox.layout();var s=this._findInput.inputBox.width;s>0&&(this._replaceInput.width=s)}}}},t.prototype._getHeight=function(){var e=0;return e+=4,e+=this._findInput.inputBox.height+2,this._isReplaceVisible&&(e+=4,e+=this._replaceInput.inputBox.height+2),e+=4},t.prototype._tryUpdateHeight=function(){var e=this._getHeight()
;return(null===this._cachedHeight||this._cachedHeight!==e)&&(this._cachedHeight=e,this._domNode.style.height=e+"px",!0)},t.prototype.focusFindInput=function(){this._findInput.select(),this._findInput.focus()},t.prototype.focusReplaceInput=function(){this._replaceInput.select(),this._replaceInput.focus()},t.prototype.highlightFindOptions=function(){this._findInput.highlightFindOptions()},t.prototype._updateSearchScope=function(){if(this._codeEditor.hasModel()&&this._toggleSelectionFind.checked){var e=this._codeEditor.getSelection();1===e.endColumn&&e.endLineNumber>e.startLineNumber&&(e=e.setEndPosition(e.endLineNumber-1,this._codeEditor.getModel().getLineMaxColumn(e.endLineNumber-1)));var t=this._state.currentMatch;e.startLineNumber!==e.endLineNumber&&(p.Range.equalsRange(e,t)||this._state.change({searchScope:e},!0))}},t.prototype._onFindInputMouseDown=function(e){e.middleButton&&e.stopPropagation()},t.prototype._onFindInputKeyDown=function(e){if(e.equals(3|W)){
var t=this._findInput.inputBox.inputElement,i=t.selectionStart,n=t.selectionEnd,o=t.value;if(null!==i&&null!==n){var r=o.substr(0,i)+"\n"+o.substr(n);return this._findInput.inputBox.value=r,t.setSelectionRange(i+1,i+1),this._findInput.inputBox.layout(),void e.preventDefault()}}return e.equals(2)?(this._isReplaceVisible?this._replaceInput.focus():this._findInput.focusOnCaseSensitive(),void e.preventDefault()):e.equals(2066)?(this._codeEditor.focus(),void e.preventDefault()):e.equals(16)?_(e,this._findInput.getValue(),this._findInput.domNode.querySelector("textarea")):e.equals(18)?y(e,this._findInput.getValue(),this._findInput.domNode.querySelector("textarea")):void 0},t.prototype._onReplaceInputKeyDown=function(e){if(e.equals(3|W)){c.isWindows&&c.isNative&&!this._ctrlEnterReplaceAllWarningPrompted&&(this._notificationService.info(i.localize(18,null)),this._ctrlEnterReplaceAllWarningPrompted=!0,this._storageService.store(F,!0,0))
;var t=this._replaceInput.inputBox.inputElement,n=t.selectionStart,o=t.selectionEnd,r=t.value;if(null!==n&&null!==o){var s=r.substr(0,n)+"\n"+r.substr(o);return this._replaceInput.inputBox.value=s,t.setSelectionRange(n+1,n+1),this._replaceInput.inputBox.layout(),void e.preventDefault()}}return e.equals(2)?(this._findInput.focusOnCaseSensitive(),void e.preventDefault()):e.equals(1026)?(this._findInput.focus(),void e.preventDefault()):e.equals(2066)?(this._codeEditor.focus(),void e.preventDefault()):e.equals(16)?_(e,this._replaceInput.inputBox.value,this._replaceInput.inputBox.element.querySelector("textarea")):e.equals(18)?y(e,this._replaceInput.inputBox.value,this._replaceInput.inputBox.element.querySelector("textarea")):void 0},t.prototype.getHorizontalSashTop=function(e){return 0},t.prototype.getHorizontalSashLeft=function(e){return 0},t.prototype.getHorizontalSashWidth=function(e){return 500},t.prototype._keybindingLabelFor=function(e){var t=this._keybindingService.lookupKeybinding(e)
;return t?" ("+t.getLabel()+")":""},t.prototype._buildDomNode=function(){var e=this;this._findInput=this._register(new v.ContextScopedFindInput(null,this._contextViewProvider,{width:221,label:b,placeholder:C,appendCaseSensitiveLabel:this._keybindingLabelFor(f.FIND_IDS.ToggleCaseSensitiveCommand),appendWholeWordsLabel:this._keybindingLabelFor(f.FIND_IDS.ToggleWholeWordCommand),appendRegexLabel:this._keybindingLabelFor(f.FIND_IDS.ToggleRegexCommand),validation:function(t){if(0===t.length||!e._findInput.getRegex())return null;try{return new RegExp(t),null}catch(e){return{content:e.message}}},flexibleHeight:!0,flexibleWidth:!0,flexibleMaxHeight:118},this._contextKeyService,!0)),this._findInput.setRegex(!!this._state.isRegex),this._findInput.setCaseSensitive(!!this._state.matchCase),this._findInput.setWholeWords(!!this._state.wholeWord),this._register(this._findInput.onKeyDown(function(t){return e._onFindInputKeyDown(t)})),this._register(this._findInput.inputBox.onDidChange(function(){
e._ignoreChangeEvent||e._state.change({searchString:e._findInput.getValue()},!0)})),this._register(this._findInput.onDidOptionChange(function(){e._state.change({isRegex:e._findInput.getRegex(),wholeWord:e._findInput.getWholeWords(),matchCase:e._findInput.getCaseSensitive()},!0)})),this._register(this._findInput.onCaseSensitiveKeyDown(function(t){t.equals(1026)&&e._isReplaceVisible&&(e._replaceInput.focus(),t.preventDefault())})),this._register(this._findInput.onRegexKeyDown(function(t){t.equals(2)&&e._isReplaceVisible&&(e._replaceInput.focusOnPreserve(),t.preventDefault())})),this._register(this._findInput.inputBox.onDidHeightChange(function(t){e._tryUpdateHeight()&&e._showViewZone()})),c.isLinux&&this._register(this._findInput.onMouseDown(function(t){return e._onFindInputMouseDown(t)})),this._matchesCount=document.createElement("div"),this._matchesCount.className="matchesCount",this._updateMatchesCount(),this._prevBtn=this._register(new z({label:S+this._keybindingLabelFor(f.FIND_IDS.PreviousMatchFindAction),
className:"previous",onTrigger:function(){e._codeEditor.getAction(f.FIND_IDS.PreviousMatchFindAction).run().then(void 0,u.onUnexpectedError)}})),this._nextBtn=this._register(new z({label:w+this._keybindingLabelFor(f.FIND_IDS.NextMatchFindAction),className:"next",onTrigger:function(){e._codeEditor.getAction(f.FIND_IDS.NextMatchFindAction).run().then(void 0,u.onUnexpectedError)}}));var t=document.createElement("div");t.className="find-part",t.appendChild(this._findInput.domNode);var i=document.createElement("div");i.className="find-actions",t.appendChild(i),i.appendChild(this._matchesCount),i.appendChild(this._prevBtn.domNode),i.appendChild(this._nextBtn.domNode),this._toggleSelectionFind=this._register(new H({parent:i,title:E+this._keybindingLabelFor(f.FIND_IDS.ToggleSearchScopeCommand),onChange:function(){if(e._toggleSelectionFind.checked){if(e._codeEditor.hasModel()){var t=e._codeEditor.getSelection()
;1===t.endColumn&&t.endLineNumber>t.startLineNumber&&(t=t.setEndPosition(t.endLineNumber-1,e._codeEditor.getModel().getLineMaxColumn(t.endLineNumber-1))),t.isEmpty()||e._state.change({searchScope:t},!0)}}else e._state.change({searchScope:null},!0)}})),this._closeBtn=this._register(new z({label:L+this._keybindingLabelFor(f.FIND_IDS.CloseFindWidgetCommand),className:"close-fw",onTrigger:function(){e._state.change({isRevealed:!1,searchScope:null},!1)},onKeyDown:function(t){t.equals(2)&&e._isReplaceVisible&&(e._replaceBtn.isEnabled()?e._replaceBtn.focus():e._codeEditor.focus(),t.preventDefault())}})),i.appendChild(this._closeBtn.domNode),this._replaceInput=this._register(new v.ContextScopedReplaceInput(null,void 0,{label:x,placeholder:D,history:[],flexibleHeight:!0,flexibleWidth:!0,flexibleMaxHeight:118},this._contextKeyService,!0)),this._replaceInput.setPreserveCase(!!this._state.preserveCase),this._register(this._replaceInput.onKeyDown(function(t){return e._onReplaceInputKeyDown(t)})),
this._register(this._replaceInput.inputBox.onDidChange(function(){e._state.change({replaceString:e._replaceInput.inputBox.value},!1)})),this._register(this._replaceInput.inputBox.onDidHeightChange(function(t){e._isReplaceVisible&&e._tryUpdateHeight()&&e._showViewZone()})),this._register(this._replaceInput.onDidOptionChange(function(){e._state.change({preserveCase:e._replaceInput.getPreserveCase()},!0)})),this._register(this._replaceInput.onPreserveCaseKeyDown(function(t){t.equals(2)&&(e._prevBtn.isEnabled()?e._prevBtn.focus():e._nextBtn.isEnabled()?e._nextBtn.focus():e._toggleSelectionFind.isEnabled()?e._toggleSelectionFind.focus():e._closeBtn.isEnabled()&&e._closeBtn.focus(),t.preventDefault())})),this._replaceBtn=this._register(new z({label:I+this._keybindingLabelFor(f.FIND_IDS.ReplaceOneAction),className:"replace",onTrigger:function(){e._controller.replace()},onKeyDown:function(t){t.equals(1026)&&(e._closeBtn.focus(),t.preventDefault())}})),this._replaceAllBtn=this._register(new z({
label:N+this._keybindingLabelFor(f.FIND_IDS.ReplaceAllAction),className:"replace-all",onTrigger:function(){e._controller.replaceAll()}}));var o=document.createElement("div");o.className="replace-part",o.appendChild(this._replaceInput.domNode);var r=document.createElement("div");r.className="replace-actions",o.appendChild(r),r.appendChild(this._replaceBtn.domNode),r.appendChild(this._replaceAllBtn.domNode),this._toggleReplaceBtn=this._register(new z({label:M,className:"toggle left",onTrigger:function(){e._state.change({isReplaceRevealed:!e._isReplaceVisible},!1),e._isReplaceVisible&&(e._replaceInput.width=n.getTotalWidth(e._findInput.domNode),e._replaceInput.inputBox.layout()),e._showViewZone()}})),this._toggleReplaceBtn.toggleClass("expand",this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("collapse",!this._isReplaceVisible),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible),this._domNode=document.createElement("div"),this._domNode.className="editor-widget find-widget",
this._domNode.setAttribute("aria-hidden","true"),this._domNode.style.width="419px",this._domNode.appendChild(this._toggleReplaceBtn.domNode),this._domNode.appendChild(t),this._domNode.appendChild(o),this._resizeSash=new s.Sash(this._domNode,this,{orientation:0}),this._resized=!1;var a=419;this._register(this._resizeSash.onDidStart(function(){a=n.getTotalWidth(e._domNode)})),this._register(this._resizeSash.onDidChange(function(t){e._resized=!0;var i=a+t.startX-t.currentX;if(!(i<419)){var o=i-P;i>(parseFloat(n.getComputedStyle(e._domNode).maxWidth)||0)||(e._domNode.style.width=i+"px",e._findInput.inputBox.width=o,e._isReplaceVisible&&(e._replaceInput.width=n.getTotalWidth(e._findInput.domNode)),e._findInput.inputBox.layout(),e._tryUpdateHeight())}})),this._register(this._resizeSash.onDidReset(function(){var t=n.getTotalWidth(e._domNode);if(!(t<419)){var i=419;e._resized&&419!==t||(i=e._codeEditor.getConfiguration().layoutInfo.width-28-e._codeEditor.getConfiguration().layoutInfo.minimapWidth-15,e._resized=!0)
;var o=i-P;e._domNode.style.width=i+"px",e._findInput.inputBox.width=o,e._isReplaceVisible&&(e._replaceInput.width=n.getTotalWidth(e._findInput.domNode)),e._findInput.inputBox.layout()}}))},t.prototype.updateAccessibilitySupport=function(){var e=this._codeEditor.getConfiguration().accessibilitySupport;this._findInput.setFocusInputOnOptionClick(2!==e)},t.ID="editor.contrib.findWidget",t}(a.Widget);t.FindWidget=B;var H=function(e){function t(i){var n=e.call(this)||this;return n._opts=i,n._domNode=document.createElement("div"),n._domNode.className="monaco-checkbox",n._domNode.title=n._opts.title,n._domNode.tabIndex=0,n._checkbox=document.createElement("input"),n._checkbox.type="checkbox",n._checkbox.className="checkbox",n._checkbox.id="checkbox-"+t._COUNTER++,n._checkbox.tabIndex=-1,n._label=document.createElement("label"),n._label.className="label",n._label.htmlFor=n._checkbox.id,n._label.tabIndex=-1,n._domNode.appendChild(n._checkbox),n._domNode.appendChild(n._label),n._opts.parent.appendChild(n._domNode),
n.onchange(n._checkbox,function(){n._opts.onChange()}),n}return r(t,e),Object.defineProperty(t.prototype,"domNode",{get:function(){return this._domNode},enumerable:!0,configurable:!0}),t.prototype.isEnabled=function(){return this._domNode.tabIndex>=0},Object.defineProperty(t.prototype,"checked",{get:function(){return this._checkbox.checked},set:function(e){this._checkbox.checked=e},enumerable:!0,configurable:!0}),t.prototype.focus=function(){this._domNode.focus()},t.prototype.enable=function(){this._checkbox.removeAttribute("disabled")},t.prototype.disable=function(){this._checkbox.disabled=!0},t.prototype.setEnabled=function(e){e?(this.enable(),this.domNode.tabIndex=0):(this.disable(),this.domNode.tabIndex=-1)},t._COUNTER=0,t}(a.Widget),z=function(e){function t(t){var i=e.call(this)||this;return i._opts=t,i._domNode=document.createElement("div"),i._domNode.title=i._opts.label,i._domNode.tabIndex=0,i._domNode.className="button "+i._opts.className,i._domNode.setAttribute("role","button"),
i._domNode.setAttribute("aria-label",i._opts.label),i.onclick(i._domNode,function(e){i._opts.onTrigger(),e.preventDefault()}),i.onkeydown(i._domNode,function(e){if(e.equals(10)||e.equals(3))return i._opts.onTrigger(),void e.preventDefault();i._opts.onKeyDown&&i._opts.onKeyDown(e)}),i}return r(t,e),Object.defineProperty(t.prototype,"domNode",{get:function(){return this._domNode},enumerable:!0,configurable:!0}),t.prototype.isEnabled=function(){return this._domNode.tabIndex>=0},t.prototype.focus=function(){this._domNode.focus()},t.prototype.setEnabled=function(e){n.toggleClass(this._domNode,"disabled",!e),this._domNode.setAttribute("aria-disabled",String(!e)),this._domNode.tabIndex=e?0:-1},t.prototype.setExpanded=function(e){this._domNode.setAttribute("aria-expanded",String(!!e))},t.prototype.toggleClass=function(e,t){n.toggleClass(this._domNode,e,t)},t}(a.Widget);t.SimpleButton=z,m.registerThemingParticipant(function(e,t){var i=function(e,i){i&&t.addRule(".monaco-editor "+e+" { background-color: "+i+"; }")}
;i(".findMatch",e.getColor(g.editorFindMatchHighlight)),i(".currentFindMatch",e.getColor(g.editorFindMatch)),i(".findScope",e.getColor(g.editorFindRangeHighlight));i(".find-widget",e.getColor(g.editorWidgetBackground));var n=e.getColor(g.widgetShadow);n&&t.addRule(".monaco-editor .find-widget { box-shadow: 0 2px 8px "+n+"; }");var o=e.getColor(g.editorFindMatchHighlightBorder);o&&t.addRule(".monaco-editor .findMatch { border: 1px "+("hc"===e.type?"dotted":"solid")+" "+o+"; box-sizing: border-box; }");var r=e.getColor(g.editorFindMatchBorder);r&&t.addRule(".monaco-editor .currentFindMatch { border: 2px solid "+r+"; padding: 1px; box-sizing: border-box; }");var s=e.getColor(g.editorFindRangeHighlightBorder);s&&t.addRule(".monaco-editor .findScope { border: 1px "+("hc"===e.type?"dashed":"solid")+" "+s+"; }");var a=e.getColor(g.contrastBorder);a&&t.addRule(".monaco-editor .find-widget { border: 2px solid "+a+"; }");var l=e.getColor(g.editorWidgetForeground)
;l&&t.addRule(".monaco-editor .find-widget { color: "+l+"; }");var u=e.getColor(g.errorForeground);u&&t.addRule(".monaco-editor .find-widget.no-results .matchesCount { color: "+u+"; }");var d=e.getColor(g.editorWidgetResizeBorder);if(d)t.addRule(".monaco-editor .find-widget .monaco-sash { background-color: "+d+"; width: 3px !important; margin-left: -4px;}");else{var c=e.getColor(g.editorWidgetBorder);c&&t.addRule(".monaco-editor .find-widget .monaco-sash { background-color: "+c+"; width: 3px !important; margin-left: -4px;}")}var h=e.getColor(g.inputActiveOptionBorder);h&&t.addRule(".monaco-editor .find-widget .monaco-checkbox .checkbox:checked + .label { border: 1px solid "+h.toString()+"; }");var p=e.getColor(g.inputActiveOptionBackground);p&&t.addRule(".monaco-editor .find-widget .monaco-checkbox .checkbox:checked + .label { background-color: "+p.toString()+"; }");var f=e.getColor(g.focusBorder)
;f&&t.addRule(".monaco-workbench .monaco-editor .find-widget .monaco-inputbox.synthetic-focus { outline-color: "+f+"; }")})}),define(t[221],i([1,0,330,15,2,5,11,21,137,549,250,550,134,14,54,12,33,68,16,34]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S){"use strict";function w(e){if(!e.hasModel())return null;var t=e.getSelection();if(t.startLineNumber===t.endLineNumber)if(t.isEmpty()){var i=e.getModel().getWordAtPosition(t.getStartPosition());if(i)return i.word}else if(e.getModel().getValueLengthInRange(t)<E)return e.getModel().getValueInRange(t);return null}Object.defineProperty(t,"__esModule",{value:!0});var E=524288;t.getSelectionSearchString=w;var L=function(e){function t(t,i,o,r){var s=e.call(this)||this;return s._editor=t,s._findWidgetVisible=u.CONTEXT_FIND_WIDGET_VISIBLE.bindTo(i),s._contextKeyService=i,s._storageService=o,s._clipboardService=r,s._updateHistoryDelayer=new n.Delayer(500),s._state=s._register(new p.FindReplaceState),s.loadQueryState(),
s._register(s._state.onFindReplaceStateChange(function(e){return s._onStateChanged(e)})),s._model=null,s._register(s._editor.onDidChangeModel(function(){var e=s._editor.getModel()&&s._state.isRevealed;s.disposeModel(),s._state.change({searchScope:null,matchCase:s._storageService.getBoolean("editor.matchCase",1,!1),wholeWord:s._storageService.getBoolean("editor.wholeWord",1,!1),isRegex:s._storageService.getBoolean("editor.isRegex",1,!1),preserveCase:s._storageService.getBoolean("editor.preserveCase",1,!1)},!1),e&&s._start({forceRevealReplace:!1,seedSearchStringFromSelection:!1,seedSearchStringFromGlobalClipboard:!1,shouldFocus:0,shouldAnimate:!1,updateSearchScope:!1})})),s}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.dispose=function(){this.disposeModel(),e.prototype.dispose.call(this)},t.prototype.disposeModel=function(){this._model&&(this._model.dispose(),this._model=null)},t.prototype.getId=function(){return t.ID},t.prototype._onStateChanged=function(e){this.saveQueryState(e),
e.isRevealed&&(this._state.isRevealed?this._findWidgetVisible.set(!0):(this._findWidgetVisible.reset(),this.disposeModel())),e.searchString&&this.setGlobalBufferTerm(this._state.searchString)},t.prototype.saveQueryState=function(e){e.isRegex&&this._storageService.store("editor.isRegex",this._state.actualIsRegex,1),e.wholeWord&&this._storageService.store("editor.wholeWord",this._state.actualWholeWord,1),e.matchCase&&this._storageService.store("editor.matchCase",this._state.actualMatchCase,1),e.preserveCase&&this._storageService.store("editor.preserveCase",this._state.actualPreserveCase,1)},t.prototype.loadQueryState=function(){this._state.change({matchCase:this._storageService.getBoolean("editor.matchCase",1,this._state.matchCase),wholeWord:this._storageService.getBoolean("editor.wholeWord",1,this._state.wholeWord),isRegex:this._storageService.getBoolean("editor.isRegex",1,this._state.isRegex),preserveCase:this._storageService.getBoolean("editor.preserveCase",1,this._state.preserveCase)},!1)},
t.prototype.isFindInputFocused=function(){return!!u.CONTEXT_FIND_INPUT_FOCUSED.getValue(this._contextKeyService)},t.prototype.getState=function(){return this._state},t.prototype.closeFindWidget=function(){this._state.change({isRevealed:!1,searchScope:null},!1),this._editor.focus()},t.prototype.toggleCaseSensitive=function(){this._state.change({matchCase:!this._state.matchCase},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleWholeWords=function(){this._state.change({wholeWord:!this._state.wholeWord},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleRegex=function(){this._state.change({isRegex:!this._state.isRegex},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleSearchScope=function(){if(this._state.searchScope)this._state.change({searchScope:null},!0);else if(this._editor.hasModel()){var e=this._editor.getSelection()
;1===e.endColumn&&e.endLineNumber>e.startLineNumber&&(e=e.setEndPosition(e.endLineNumber-1,this._editor.getModel().getLineMaxColumn(e.endLineNumber-1))),e.isEmpty()||this._state.change({searchScope:e},!0)}},t.prototype.setSearchString=function(e){this._state.isRegex&&(e=s.escapeRegExpCharacters(e)),this._state.change({searchString:e},!1)},t.prototype.highlightFindOptions=function(){},t.prototype._start=function(e){if(this.disposeModel(),this._editor.hasModel()){var t={isRevealed:!0};if(e.seedSearchStringFromSelection){(i=w(this._editor))&&(this._state.isRegex?t.searchString=s.escapeRegExpCharacters(i):t.searchString=i)}if(!t.searchString&&e.seedSearchStringFromGlobalClipboard){var i=this.getGlobalBufferTerm();i&&(t.searchString=i)}if(e.forceRevealReplace?t.isReplaceRevealed=!0:this._findWidgetVisible.get()||(t.isReplaceRevealed=!1),e.updateSearchScope){var n=this._editor.getSelection();n.isEmpty()||(t.searchScope=n)}this._state.change(t,!1),
this._model||(this._model=new u.FindModelBoundToEditorModel(this._editor,this._state))}},t.prototype.start=function(e){this._start(e)},t.prototype.moveToNextMatch=function(){return!!this._model&&(this._model.moveToNextMatch(),!0)},t.prototype.moveToPrevMatch=function(){return!!this._model&&(this._model.moveToPrevMatch(),!0)},t.prototype.replace=function(){return!!this._model&&(this._model.replace(),!0)},t.prototype.replaceAll=function(){return!!this._model&&(this._model.replaceAll(),!0)},t.prototype.selectAllMatches=function(){return!!this._model&&(this._model.selectAllMatches(),this._editor.focus(),!0)},t.prototype.getGlobalBufferTerm=function(){return this._editor.getConfiguration().contribInfo.find.globalFindClipboard&&this._clipboardService&&this._editor.hasModel()&&!this._editor.getModel().isTooLargeForSyncing()?this._clipboardService.readFindText():""},t.prototype.setGlobalBufferTerm=function(e){
this._editor.getConfiguration().contribInfo.find.globalFindClipboard&&this._clipboardService&&this._editor.hasModel()&&!this._editor.getModel().isTooLargeForSyncing()&&this._clipboardService.writeFindText(e)},t.ID="editor.contrib.findController",t=d([c(1,m.IContextKeyService),c(2,b.IStorageService),c(3,g.IClipboardService)],t)}(o.Disposable);t.CommonFindController=L;var x=function(e){function t(t,i,n,o,r,s,a,l){var u=e.call(this,t,n,a,l)||this;return u._contextViewService=i,u._keybindingService=o,u._themeService=r,u._notificationService=s,u._widget=null,u._findOptionsWidget=null,u}return r(t,e),t.prototype._start=function(t){this._widget||this._createFindWidget(),!this._widget.getPosition()&&this._editor.getConfiguration().contribInfo.find.autoFindInSelection&&(t.updateSearchScope=!0),e.prototype._start.call(this,t),2===t.shouldFocus?this._widget.focusReplaceInput():1===t.shouldFocus&&this._widget.focusFindInput()},t.prototype.highlightFindOptions=function(){this._widget||this._createFindWidget(),
this._state.isRevealed?this._widget.highlightFindOptions():this._findOptionsWidget.highlightFindOptions()},t.prototype._createFindWidget=function(){this._widget=this._register(new f.FindWidget(this._editor,this,this._state,this._contextViewService,this._keybindingService,this._contextKeyService,this._themeService,this._storageService,this._notificationService)),this._findOptionsWidget=this._register(new h.FindOptionsWidget(this._editor,this._state,this._keybindingService,this._themeService))},t=d([c(1,v.IContextViewService),c(2,m.IContextKeyService),c(3,y.IKeybindingService),c(4,C.IThemeService),c(5,S.INotificationService),c(6,b.IStorageService),c(7,_.optional(g.IClipboardService))],t)}(L);t.FindController=x;var D=function(e){function t(){return e.call(this,{id:u.FIND_IDS.StartFindAction,label:i.localize(0,null),alias:"Find",precondition:void 0,kbOpts:{kbExpr:null,primary:2084,weight:100},menubarOpts:{menuId:14,group:"3_find",title:i.localize(1,null),order:1}})||this}return r(t,e),
t.prototype.run=function(e,t){var i=L.get(t);i&&i.start({forceRevealReplace:!1,seedSearchStringFromSelection:t.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:t.getConfiguration().contribInfo.find.globalFindClipboard,shouldFocus:1,shouldAnimate:!0,updateSearchScope:!1})},t}(a.EditorAction);t.StartFindAction=D;var I=function(e){function t(){return e.call(this,{id:u.FIND_IDS.StartFindWithSelection,label:i.localize(2,null),alias:"Find With Selection",precondition:void 0,kbOpts:{kbExpr:null,primary:0,mac:{primary:2083},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=L.get(t);i&&(i.start({forceRevealReplace:!1,seedSearchStringFromSelection:!0,seedSearchStringFromGlobalClipboard:!1,shouldFocus:1,shouldAnimate:!0,updateSearchScope:!1}),i.setGlobalBufferTerm(i.getState().searchString))},t}(a.EditorAction);t.StartFindWithSelectionAction=I;var N=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),
t.prototype.run=function(e,t){var i=L.get(t);i&&!this._run(i)&&(i.start({forceRevealReplace:!1,seedSearchStringFromSelection:0===i.getState().searchString.length&&t.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:!0,shouldFocus:0,shouldAnimate:!0,updateSearchScope:!1}),this._run(i))},t}(a.EditorAction);t.MatchFindAction=N;var M=function(e){function t(){return e.call(this,{id:u.FIND_IDS.NextMatchFindAction,label:i.localize(3,null),alias:"Find Next",precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.focus,primary:61,mac:{primary:2085,secondary:[61]},weight:100}})||this}return r(t,e),t.prototype._run=function(e){return e.moveToNextMatch()},t}(N);t.NextMatchFindAction=M;var k=function(e){function t(){return e.call(this,{id:u.FIND_IDS.NextMatchFindAction,label:i.localize(4,null),alias:"Find Next",precondition:void 0,kbOpts:{kbExpr:m.ContextKeyExpr.and(l.EditorContextKeys.focus,u.CONTEXT_FIND_INPUT_FOCUSED),primary:3,weight:100}})||this}return r(t,e),
t.prototype._run=function(e){return e.moveToNextMatch()},t}(N);t.NextMatchFindAction2=k;var T=function(e){function t(){return e.call(this,{id:u.FIND_IDS.PreviousMatchFindAction,label:i.localize(5,null),alias:"Find Previous",precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.focus,primary:1085,mac:{primary:3109,secondary:[1085]},weight:100}})||this}return r(t,e),t.prototype._run=function(e){return e.moveToPrevMatch()},t}(N);t.PreviousMatchFindAction=T;var R=function(e){function t(){return e.call(this,{id:u.FIND_IDS.PreviousMatchFindAction,label:i.localize(6,null),alias:"Find Previous",precondition:void 0,kbOpts:{kbExpr:m.ContextKeyExpr.and(l.EditorContextKeys.focus,u.CONTEXT_FIND_INPUT_FOCUSED),primary:1027,weight:100}})||this}return r(t,e),t.prototype._run=function(e){return e.moveToPrevMatch()},t}(N);t.PreviousMatchFindAction2=R;var O=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.run=function(e,t){var i=L.get(t);if(i){var n=w(t);n&&i.setSearchString(n),
this._run(i)||(i.start({forceRevealReplace:!1,seedSearchStringFromSelection:t.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:!1,shouldFocus:0,shouldAnimate:!0,updateSearchScope:!1}),this._run(i))}},t}(a.EditorAction);t.SelectionMatchFindAction=O;var P=function(e){function t(){return e.call(this,{id:u.FIND_IDS.NextSelectionMatchFindAction,label:i.localize(7,null),alias:"Find Next Selection",precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.focus,primary:2109,weight:100}})||this}return r(t,e),t.prototype._run=function(e){return e.moveToNextMatch()},t}(O);t.NextSelectionMatchFindAction=P;var A=function(e){function t(){return e.call(this,{id:u.FIND_IDS.PreviousSelectionMatchFindAction,label:i.localize(8,null),alias:"Find Previous Selection",precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.focus,primary:3133,weight:100}})||this}return r(t,e),t.prototype._run=function(e){return e.moveToPrevMatch()},t}(O);t.PreviousSelectionMatchFindAction=A
;var F=function(e){function t(){return e.call(this,{id:u.FIND_IDS.StartFindReplaceAction,label:i.localize(9,null),alias:"Replace",precondition:void 0,kbOpts:{kbExpr:null,primary:2086,mac:{primary:2596},weight:100},menubarOpts:{menuId:14,group:"3_find",title:i.localize(10,null),order:2}})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()&&!t.getConfiguration().readOnly){var i=L.get(t),n=t.getSelection(),o=i.isFindInputFocused(),r=!n.isEmpty()&&n.startLineNumber===n.endLineNumber&&t.getConfiguration().contribInfo.find.seedSearchStringFromSelection&&!o,s=o||r?2:1;i&&i.start({forceRevealReplace:!0,seedSearchStringFromSelection:r,seedSearchStringFromGlobalClipboard:t.getConfiguration().contribInfo.find.seedSearchStringFromSelection,shouldFocus:s,shouldAnimate:!0,updateSearchScope:!1})}},t}(a.EditorAction);t.StartFindReplaceAction=F,a.registerEditorContribution(x),a.registerEditorAction(D),a.registerEditorAction(I),a.registerEditorAction(M),a.registerEditorAction(k),a.registerEditorAction(T),
a.registerEditorAction(R),a.registerEditorAction(P),a.registerEditorAction(A),a.registerEditorAction(F);var W=a.EditorCommand.bindToContribution(L.get);a.registerEditorCommand(new W({id:u.FIND_IDS.CloseFindWidgetCommand,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.closeFindWidget()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:9,secondary:[1033]}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ToggleCaseSensitiveCommand,precondition:void 0,handler:function(e){return e.toggleCaseSensitive()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:u.ToggleCaseSensitiveKeybinding.primary,mac:u.ToggleCaseSensitiveKeybinding.mac,win:u.ToggleCaseSensitiveKeybinding.win,linux:u.ToggleCaseSensitiveKeybinding.linux}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ToggleWholeWordCommand,precondition:void 0,handler:function(e){return e.toggleWholeWords()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:u.ToggleWholeWordKeybinding.primary,
mac:u.ToggleWholeWordKeybinding.mac,win:u.ToggleWholeWordKeybinding.win,linux:u.ToggleWholeWordKeybinding.linux}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ToggleRegexCommand,precondition:void 0,handler:function(e){return e.toggleRegex()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:u.ToggleRegexKeybinding.primary,mac:u.ToggleRegexKeybinding.mac,win:u.ToggleRegexKeybinding.win,linux:u.ToggleRegexKeybinding.linux}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ToggleSearchScopeCommand,precondition:void 0,handler:function(e){return e.toggleSearchScope()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:u.ToggleSearchScopeKeybinding.primary,mac:u.ToggleSearchScopeKeybinding.mac,win:u.ToggleSearchScopeKeybinding.win,linux:u.ToggleSearchScopeKeybinding.linux}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ReplaceOneAction,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.replace()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:3094}})),
a.registerEditorCommand(new W({id:u.FIND_IDS.ReplaceOneAction,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.replace()},kbOpts:{weight:105,kbExpr:m.ContextKeyExpr.and(l.EditorContextKeys.focus,u.CONTEXT_REPLACE_INPUT_FOCUSED),primary:3}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ReplaceAllAction,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.replaceAll()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:2563}})),a.registerEditorCommand(new W({id:u.FIND_IDS.ReplaceAllAction,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.replaceAll()},kbOpts:{weight:105,kbExpr:m.ContextKeyExpr.and(l.EditorContextKeys.focus,u.CONTEXT_REPLACE_INPUT_FOCUSED),primary:void 0,mac:{primary:2051}}})),a.registerEditorCommand(new W({id:u.FIND_IDS.SelectAllMatchesAction,precondition:u.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(e){return e.selectAllMatches()},kbOpts:{weight:105,kbExpr:l.EditorContextKeys.focus,primary:515}}))}),
define(t[552],i([1,0,343,3,20,21,11,60,262,61,16,37,30,15,10]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var _=function(){function e(e,t){this.decorationIds=[],this.editor=e,this.editorWorkerService=t}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.dispose=function(){},e.prototype.getId=function(){return e.ID},e.prototype.run=function(t,i){var r=this;this.currentRequest&&this.currentRequest.cancel();var s=this.editor.getSelection(),a=this.editor.getModel();if(a&&s){var l=s;if(l.startLineNumber===l.endLineNumber){var d=new h.EditorState(this.editor,5),c=a.uri;return this.editorWorkerService.canNavigateValueSet(c)?(this.currentRequest=m.createCancelablePromise(function(e){return r.editorWorkerService.navigateValueSet(c,l,i)}),this.currentRequest.then(function(i){if(i&&i.range&&i.value&&d.validate(r.editor)){var s=n.Range.lift(i.range),a=i.range,c=i.value.length-(l.endColumn-l.startColumn);a={startLineNumber:a.startLineNumber,
startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.startColumn+i.value.length},c>1&&(l=new o.Selection(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn+c-1));var h=new u.InPlaceReplaceCommand(s,l,i.value);r.editor.pushUndoStop(),r.editor.executeCommand(t,h),r.editor.pushUndoStop(),r.decorationIds=r.editor.deltaDecorations(r.decorationIds,[{range:a,options:e.DECORATION}]),r.decorationRemover&&r.decorationRemover.cancel(),r.decorationRemover=m.timeout(350),r.decorationRemover.then(function(){return r.decorationIds=r.editor.deltaDecorations(r.decorationIds,[])}).catch(v.onUnexpectedError)}}).catch(v.onUnexpectedError)):Promise.resolve(void 0)}}},e.ID="editor.contrib.inPlaceReplaceController",e.DECORATION=g.ModelDecorationOptions.register({className:"valueSetReplacement"}),e=d([c(1,l.IEditorWorkerService)],e)}(),y=function(e){function t(){return e.call(this,{id:"editor.action.inPlaceReplace.up",label:i.localize(0,null),alias:"Replace with Previous Value",
precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:3154,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=_.get(t);return i?i.run(this.id,!0):Promise.resolve(void 0)},t}(a.EditorAction),b=function(e){function t(){return e.call(this,{id:"editor.action.inPlaceReplace.down",label:i.localize(1,null),alias:"Replace with Next Value",precondition:s.EditorContextKeys.writable,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:3156,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=_.get(t);return i?i.run(this.id,!1):Promise.resolve(void 0)},t}(a.EditorAction);a.registerEditorContribution(_),a.registerEditorAction(y),a.registerEditorAction(b),p.registerThemingParticipant(function(e,t){var i=e.getColor(f.editorBracketMatchBorder);i&&t.addRule(".monaco-editor.vs .valueSetReplacement { outline: solid 2px "+i+"; }")})}),
define(t[553],i([1,0,345,15,26,10,78,2,18,11,30,17,177,420,34,55,22,16,482]),function(e,t,i,n,o,u,h,p,f,g,m,v,_,y,b,C,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var E={general:m.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link"}),active:m.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active"})},L=function(){function e(e,t){this.link=e,this.decorationId=t}return e.decoration=function(t,i){return{range:t.range,options:e._getOptions(t,i,!1)}},e._getOptions=function(e,t,n){var o=s({},n?E.active:E.general);return o.hoverMessage=function(e,t){var n=e.url&&/^command:/i.test(e.url.toString()),o=e.tooltip?e.tooltip:n?i.localize(0,null):i.localize(1,null),r=t?f.isMacintosh?i.localize(2,null):i.localize(3,null):f.isMacintosh?i.localize(4,null):i.localize(5,null);if(e.url){var s=(new h.MarkdownString).appendMarkdown("["+o+"]("+e.url.toString()+") ("+r+")");return s.isTrusted=!0,s}
return(new h.MarkdownString).appendText(o+" ("+r+")")}(e,t),o},e.prototype.activate=function(t,i){t.changeDecorationOptions(this.decorationId,e._getOptions(this.link,i,!0))},e.prototype.deactivate=function(t,i){t.changeDecorationOptions(this.decorationId,e._getOptions(this.link,i,!1))},e}(),x=function(){function e(e,t,i){var o=this;this.listenersToRemove=new p.DisposableStore,this.editor=e,this.openerService=t,this.notificationService=i;var r=new _.ClickLinkGesture(e);this.listenersToRemove.add(r),this.listenersToRemove.add(r.onMouseMoveOrRelevantKeyDown(function(e){var t=e[0],i=e[1];o._onEditorMouseMove(t,i)})),this.listenersToRemove.add(r.onExecute(function(e){o.onEditorMouseUp(e)})),this.listenersToRemove.add(r.onCancel(function(e){o.cleanUpActiveLinkDecoration()})),this.enabled=e.getConfiguration().contribInfo.links,this.listenersToRemove.add(e.onDidChangeConfiguration(function(t){var i=e.getConfiguration().contribInfo.links;o.enabled!==i&&(o.enabled=i,o.updateDecorations([]),o.stop(),o.beginCompute())
})),this.listenersToRemove.add(e.onDidChangeModelContent(function(e){return o.onChange()})),this.listenersToRemove.add(e.onDidChangeModel(function(e){return o.onModelChanged()})),this.listenersToRemove.add(e.onDidChangeModelLanguage(function(e){return o.onModelModeChanged()})),this.listenersToRemove.add(v.LinkProviderRegistry.onDidChange(function(e){return o.onModelModeChanged()})),this.timeout=new n.TimeoutTimer,this.computePromise=null,this.activeLinksList=null,this.currentOccurrences={},this.activeLinkDecorationId=null,this.beginCompute()}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.onModelChanged=function(){this.currentOccurrences={},this.activeLinkDecorationId=null,this.stop(),this.beginCompute()},e.prototype.onModelModeChanged=function(){this.stop(),this.beginCompute()},e.prototype.onChange=function(){var t=this;this.timeout.setIfNotSet(function(){return t.beginCompute()},e.RECOMPUTE_TIME)},e.prototype.beginCompute=function(){
return a(this,void 0,void 0,function(){var e,t,i;return l(this,function(o){switch(o.label){case 0:if(!this.editor.hasModel()||!this.enabled)return[2];if(e=this.editor.getModel(),!v.LinkProviderRegistry.has(e))return[2];this.activeLinksList&&(this.activeLinksList.dispose(),this.activeLinksList=null),this.computePromise=n.createCancelablePromise(function(t){return y.getLinks(e,t)}),o.label=1;case 1:return o.trys.push([1,3,4,5]),t=this,[4,this.computePromise];case 2:return t.activeLinksList=o.sent(),this.updateDecorations(this.activeLinksList.links),[3,5];case 3:return i=o.sent(),u.onUnexpectedError(i),[3,5];case 4:return this.computePromise=null,[7];case 5:return[2]}})})},e.prototype.updateDecorations=function(e){for(var t="altKey"===this.editor.getConfiguration().multiCursorModifier,i=[],n=Object.keys(this.currentOccurrences),o=0,r=n.length;o<r;o++){var s=n[o],a=this.currentOccurrences[s];i.push(a.decorationId)}var l=[];if(e)for(var u=0,d=e;u<d.length;u++){var c=d[u];l.push(L.decoration(c,t))}
var h=this.editor.deltaDecorations(i,l);this.currentOccurrences={},this.activeLinkDecorationId=null;for(var o=0,r=h.length;o<r;o++){a=new L(e[o],h[o]);this.currentOccurrences[a.decorationId]=a}},e.prototype._onEditorMouseMove=function(e,t){var i=this,n="altKey"===this.editor.getConfiguration().multiCursorModifier;if(this.isEnabled(e,t)){this.cleanUpActiveLinkDecoration();var o=this.getLinkOccurrence(e.target.position);o&&this.editor.changeDecorations(function(e){o.activate(e,n),i.activeLinkDecorationId=o.decorationId})}else this.cleanUpActiveLinkDecoration()},e.prototype.cleanUpActiveLinkDecoration=function(){var e="altKey"===this.editor.getConfiguration().multiCursorModifier;if(this.activeLinkDecorationId){var t=this.currentOccurrences[this.activeLinkDecorationId];t&&this.editor.changeDecorations(function(i){t.deactivate(i,e)}),this.activeLinkDecorationId=null}},e.prototype.onEditorMouseUp=function(e){if(this.isEnabled(e)){var t=this.getLinkOccurrence(e.target.position)
;t&&this.openLinkOccurrence(t,e.hasSideBySideModifier)}},e.prototype.openLinkOccurrence=function(e,t){var n=this;if(this.openerService){var r=e.link;r.resolve(o.CancellationToken.None).then(function(e){return n.openerService.open(e,{openToSide:t})},function(e){var t=e instanceof Error?e.message:e;"invalid"===t?n.notificationService.warn(i.localize(6,null,r.url.toString())):"missing"===t?n.notificationService.warn(i.localize(7,null)):u.onUnexpectedError(e)})}},e.prototype.getLinkOccurrence=function(e){if(!this.editor.hasModel()||!e)return null;for(var t=0,i=this.editor.getModel().getDecorationsInRange({startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column},0,!0);t<i.length;t++){var n=i[t],o=this.currentOccurrences[n.id];if(o)return o}return null},e.prototype.isEnabled=function(e,t){return Boolean(6===e.target.type&&(e.hasTriggerModifier||t&&t.keyCodeIsTriggerKey))},e.prototype.stop=function(){this.timeout.cancel(),this.activeLinksList&&this.activeLinksList.dispose(),
this.computePromise&&(this.computePromise.cancel(),this.computePromise=null)},e.prototype.dispose=function(){this.listenersToRemove.dispose(),this.stop(),this.timeout.dispose()},e.ID="editor.linkDetector",e.RECOMPUTE_TIME=1e3,e=d([c(1,C.IOpenerService),c(2,b.INotificationService)],e)}(),D=function(e){function t(){return e.call(this,{id:"editor.action.openLink",label:i.localize(8,null),alias:"Open Link",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){var i=x.get(t);if(i&&t.hasModel())for(var n=0,o=t.getSelections();n<o.length;n++){var r=o[n],s=i.getLinkOccurrence(r.getEndPosition());s&&i.openLinkOccurrence(s,!1)}},t}(g.EditorAction);g.registerEditorContribution(x),g.registerEditorAction(D),w.registerThemingParticipant(function(e,t){var i=e.getColor(S.editorActiveLinkForeground);i&&t.addRule(".monaco-editor .detected-link-active { color: "+i+" !important; }")})}),define(t[107],i([1,0,346,15,2,43,3,11,14,16,22,453]),function(e,t,i,n,o,s,a,l,u,h,p){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var f=function(e){function t(i,n){var r=e.call(this)||this;return r.closeTimeout=3e3,r._messageWidget=r._register(new o.MutableDisposable),r._messageListeners=r._register(new o.DisposableStore),r._editor=i,r._visible=t.MESSAGE_VISIBLE.bindTo(n),r._register(r._editor.onDidAttemptReadOnlyEdit(function(){return r._onDidAttemptReadOnlyEdit()})),r}return r(t,e),t.get=function(e){return e.getContribution(t._id)},t.prototype.getId=function(){return t._id},t.prototype.dispose=function(){e.prototype.dispose.call(this),this._visible.reset()},t.prototype.showMessage=function(e,t){var i=this;s.alert(e),this._visible.set(!0),this._messageWidget.clear(),this._messageListeners.clear(),this._messageWidget.value=new m(this._editor,t,e),this._messageListeners.add(this._editor.onDidBlurEditorText(function(){return i.closeMessage()})),this._messageListeners.add(this._editor.onDidChangeCursorPosition(function(){return i.closeMessage()})),
this._messageListeners.add(this._editor.onDidDispose(function(){return i.closeMessage()})),this._messageListeners.add(this._editor.onDidChangeModel(function(){return i.closeMessage()})),this._messageListeners.add(new n.TimeoutTimer(function(){return i.closeMessage()},this.closeTimeout));var o;this._messageListeners.add(this._editor.onMouseMove(function(e){e.target.position&&(o?o.containsPosition(e.target.position)||i.closeMessage():o=new a.Range(t.lineNumber-3,1,e.target.position.lineNumber+3,1))}))},t.prototype.closeMessage=function(){this._visible.reset(),this._messageListeners.clear(),this._messageWidget.value&&this._messageListeners.add(m.fadeOut(this._messageWidget.value))},t.prototype._onDidAttemptReadOnlyEdit=function(){this._editor.hasModel()&&this.showMessage(i.localize(0,null),this._editor.getPosition())},t._id="editor.contrib.messageController",t.MESSAGE_VISIBLE=new u.RawContextKey("messageVisible",!1),t=d([c(1,u.IContextKeyService)],t)}(o.Disposable);t.MessageController=f
;var g=l.EditorCommand.bindToContribution(f.get);l.registerEditorCommand(new g({id:"leaveEditorMessage",precondition:f.MESSAGE_VISIBLE,handler:function(e){return e.closeMessage()},kbOpts:{weight:130,primary:9}}));var m=function(){function e(e,t,i){var n=t.lineNumber,o=t.column;this.allowEditorOverflow=!0,this.suppressMouseDown=!1,this._editor=e,this._editor.revealLinesInCenterIfOutsideViewport(n,n,0),this._position={lineNumber:n,column:o-1},this._domNode=document.createElement("div"),this._domNode.classList.add("monaco-editor-overlaymessage");var r=document.createElement("div");r.classList.add("message"),r.textContent=i,this._domNode.appendChild(r);var s=document.createElement("div");s.classList.add("anchor"),this._domNode.appendChild(s),this._editor.addContentWidget(this),this._domNode.classList.add("fadeIn")}return e.fadeOut=function(e){var t,i=function(){e.dispose(),clearTimeout(t),e.getDomNode().removeEventListener("animationend",i)};return t=setTimeout(i,110),
e.getDomNode().addEventListener("animationend",i),e.getDomNode().classList.add("fadeOut"),{dispose:i}},e.prototype.dispose=function(){this._editor.removeContentWidget(this)},e.prototype.getId=function(){return"messageoverlay"},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return{position:this._position,preference:[1]}},e}();l.registerEditorContribution(f),h.registerThemingParticipant(function(e,t){var i=e.getColor(p.inputValidationInfoBorder);if(i){var n=e.type===h.HIGH_CONTRAST?2:1;t.addRule(".monaco-editor .monaco-editor-overlaymessage .anchor { border-top-color: "+i+"; }"),t.addRule(".monaco-editor .monaco-editor-overlaymessage .message { border: "+n+"px solid "+i+"; }")}var o=e.getColor(p.inputValidationInfoBackground);o&&t.addRule(".monaco-editor .monaco-editor-overlaymessage .message { background-color: "+o+"; }");var r=e.getColor(p.inputValidationInfoForeground);r&&t.addRule(".monaco-editor .monaco-editor-overlaymessage .message { color: "+r+"; }")})}),
define(t[555],i([1,0,10,2,107,54,33,245,435]),function(e,t,i,n,o,s,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var f=function(e){function t(t,i,o,r,s){var u=e.call(this)||this;return u._editor=t,u.delegate=o,u._activeCodeActions=u._register(new n.MutableDisposable),u._codeActionWidget=u._register(new h.CodeActionWidget(u._editor,r,{onSelectCodeAction:function(e){return a(u,void 0,void 0,function(){return l(this,function(t){return this.delegate.applyCodeAction(e,!0),[2]})})}})),u._lightBulbWidget=u._register(new p.LightBulbWidget(u._editor,i,s)),u._register(u._lightBulbWidget.onClick(u._handleLightBulbSelect,u)),u}return r(t,e),t.prototype.update=function(e){return a(this,void 0,void 0,function(){var t,n;return l(this,function(r){switch(r.label){case 0:if(1!==e.type)return this._lightBulbWidget.hide(),[2];r.label=1;case 1:return r.trys.push([1,3,,4]),[4,e.actions];case 2:return t=r.sent(),[3,4];case 3:return n=r.sent(),i.onUnexpectedError(n),[2];case 4:
if(this._lightBulbWidget.update(t,e.position),!t.actions.length&&e.trigger.context)return o.MessageController.get(this._editor).showMessage(e.trigger.context.notAvailableMessage,e.trigger.context.position),this._activeCodeActions.value=t,[2];if("manual"!==e.trigger.type)return[3,10];if(!e.trigger.filter||!e.trigger.filter.kind)return[3,9];if(!(t.actions.length>0))return[3,9];if(1!==e.trigger.autoApply&&(0!==e.trigger.autoApply||1!==t.actions.length))return[3,9];r.label=5;case 5:return r.trys.push([5,,7,8]),[4,this.delegate.applyCodeAction(t.actions[0],!1)];case 6:return r.sent(),[3,8];case 7:return t.dispose(),[7];case 8:return[2];case 9:return this._activeCodeActions.value=t,this._codeActionWidget.show(t,e.position),[3,11];case 10:this._codeActionWidget.isVisible?t.dispose():this._activeCodeActions.value=t,r.label=11;case 11:return[2]}})})},t.prototype.showCodeActionList=function(e,t){return a(this,void 0,void 0,function(){return l(this,function(i){return this._codeActionWidget.show(e,t),[2]})})},
t.prototype._handleLightBulbSelect=function(e){this._codeActionWidget.show(e.actions,e)},t=d([c(3,s.IContextMenuService),c(4,u.IKeybindingService)],t)}(n.Disposable);t.CodeActionUi=f}),define(t[223],i([1,0,2,5,11,163,21,555,107,325,32,14,54,33,69,110,483,130]),function(e,t,i,n,o,s,u,h,p,f,g,m,v,_,y,b,C,S){"use strict";function w(e){return m.ContextKeyExpr.regex(C.SUPPORTED_CODE_ACTIONS.keys()[0],new RegExp("(\\s|^)"+n.escapeRegExpCharacters(e.value)+"\\b"))}function E(e,t,i,n){return a(this,void 0,void 0,function(){return l(this,function(o){switch(o.label){case 0:return e.edit?[4,t.apply(e.edit,{editor:n})]:[3,2];case 1:o.sent(),o.label=2;case 2:return e.command?[4,i.executeCommand.apply(i,[e.command.id].concat(e.command.arguments||[]))]:[3,4];case 3:o.sent(),o.label=4;case 4:return[2]}})})}function L(e,t,i,n){if(e.hasModel()){var o=x.get(e);o&&o.manualTriggerAtCurrentPosition(t,i,n)}}Object.defineProperty(t,"__esModule",{value:!0});var x=function(e){function t(t,i,n,o,r,s,u,d){var c=e.call(this)||this
;return c._commandService=u,c._bulkEditService=d,c._editor=t,c._model=c._register(new C.CodeActionModel(c._editor,i,n,o)),c._register(c._model.onDidChangeState(function(e){return c.update(e)})),c._ui=c._register(new h.CodeActionUi(t,D.Id,{applyCodeAction:function(e,t){return a(c,void 0,void 0,function(){return l(this,function(i){switch(i.label){case 0:return i.trys.push([0,,2,3]),[4,this._applyCodeAction(e)];case 1:return i.sent(),[3,3];case 2:return t&&this._trigger({type:"auto",filter:{}}),[7];case 3:return[2]}})})}},r,s)),c}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.update=function(e){this._ui.update(e)},t.prototype.showCodeActions=function(e,t){return this._ui.showCodeActionList(e,t)},t.prototype.getId=function(){return t.ID},t.prototype.manualTriggerAtCurrentPosition=function(e,t,i){if(this._editor.hasModel()){p.MessageController.get(this._editor).closeMessage();var n=this._editor.getPosition();this._trigger({type:"manual",filter:t,autoApply:i,context:{
notAvailableMessage:e,position:n}})}},t.prototype._trigger=function(e){return this._model.trigger(e)},t.prototype._applyCodeAction=function(e){return E(e,this._bulkEditService,this._commandService,this._editor)},t.ID="editor.contrib.quickFixController",t=d([c(1,y.IMarkerService),c(2,m.IContextKeyService),c(3,b.IEditorProgressService),c(4,v.IContextMenuService),c(5,_.IKeybindingService),c(6,g.ICommandService),c(7,s.IBulkEditService)],t)}(i.Disposable);t.QuickFixController=x,t.applyCodeAction=E;var D=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(0,null),alias:"Quick Fix...",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,u.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:u.EditorContextKeys.editorTextFocus,primary:2132,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){return L(t,f.localize(1,null),void 0,void 0)},t.Id="editor.action.quickFix",t}(o.EditorAction);t.QuickFixAction=D;var I=function(){function e(e,t,i){this.kind=e,this.apply=t,
this.preferred=i}return e.fromUser=function(t,i){return t&&"object"==typeof t?new e(e.getKindFromUser(t,i.kind),e.getApplyFromUser(t,i.apply),e.getPreferredUser(t)):new e(i.kind,i.apply,!1)},e.getApplyFromUser=function(e,t){switch("string"==typeof e.apply?e.apply.toLowerCase():""){case"first":return 1;case"never":return 2;case"ifsingle":return 0;default:return t}},e.getKindFromUser=function(e,t){return"string"==typeof e.kind?new S.CodeActionKind(e.kind):t},e.getPreferredUser=function(e){return"boolean"==typeof e.preferred&&e.preferred},e}(),N=function(e){function t(){return e.call(this,{id:t.Id,precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,u.EditorContextKeys.hasCodeActionsProvider),description:{description:"Trigger a code action",args:[{name:"args",schema:{type:"object",required:["kind"],properties:{kind:{type:"string"},apply:{type:"string",default:"ifSingle",enum:["first","ifSingle","never"]}}}}]}})||this}return r(t,e),t.prototype.runEditorCommand=function(e,t,i){var n=I.fromUser(i,{
kind:S.CodeActionKind.Empty,apply:0});return L(t,f.localize(2,null),{kind:n.kind,includeSourceActions:!0,onlyIncludePreferredActions:n.preferred},n.apply)},t.Id="editor.action.codeAction",t}(o.EditorCommand);t.CodeActionCommand=N;var M=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(3,null),alias:"Refactor...",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,u.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:u.EditorContextKeys.editorTextFocus,primary:3120,mac:{primary:1328},weight:100},menuOpts:{group:"1_modification",order:2,when:m.ContextKeyExpr.and(u.EditorContextKeys.writable,w(S.CodeActionKind.Refactor))},description:{description:"Refactor...",args:[{name:"args",schema:{type:"object",properties:{kind:{type:"string"},apply:{type:"string",default:"never",enum:["first","ifSingle","never"]}}}}]}})||this}return r(t,e),t.prototype.run=function(e,t,i){var n=I.fromUser(i,{kind:S.CodeActionKind.Refactor,apply:2});return L(t,f.localize(4,null),{
kind:S.CodeActionKind.Refactor.contains(n.kind)?n.kind:S.CodeActionKind.Empty,onlyIncludePreferredActions:n.preferred},n.apply)},t.Id="editor.action.refactor",t}(o.EditorAction);t.RefactorAction=M;var k=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(5,null),alias:"Source Action...",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,u.EditorContextKeys.hasCodeActionsProvider),menuOpts:{group:"1_modification",order:2.1,when:m.ContextKeyExpr.and(u.EditorContextKeys.writable,w(S.CodeActionKind.Source))},description:{description:"Source Action...",args:[{name:"args",schema:{type:"object",properties:{kind:{type:"string"},apply:{type:"string",default:"never",enum:["first","ifSingle","never"]}}}}]}})||this}return r(t,e),t.prototype.run=function(e,t,i){var n=I.fromUser(i,{kind:S.CodeActionKind.Source,apply:2});return L(t,f.localize(6,null),{kind:S.CodeActionKind.Source.contains(n.kind)?n.kind:S.CodeActionKind.Empty,includeSourceActions:!0,onlyIncludePreferredActions:n.preferred
},n.apply)},t.Id="editor.action.sourceAction",t}(o.EditorAction);t.SourceAction=k;var T=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(7,null),alias:"Organize Imports",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,w(S.CodeActionKind.SourceOrganizeImports)),kbOpts:{kbExpr:u.EditorContextKeys.editorTextFocus,primary:1581,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){return L(t,f.localize(8,null),{kind:S.CodeActionKind.SourceOrganizeImports,includeSourceActions:!0},0)},t.Id="editor.action.organizeImports",t}(o.EditorAction);t.OrganizeImportsAction=T;var R=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(9,null),alias:"Fix All",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,w(S.CodeActionKind.SourceFixAll))})||this}return r(t,e),t.prototype.run=function(e,t){return L(t,f.localize(10,null),{kind:S.CodeActionKind.SourceFixAll,includeSourceActions:!0},0)},t.Id="editor.action.fixAll",t}(o.EditorAction);t.FixAllAction=R
;var O=function(e){function t(){return e.call(this,{id:t.Id,label:f.localize(11,null),alias:"Auto Fix...",precondition:m.ContextKeyExpr.and(u.EditorContextKeys.writable,w(S.CodeActionKind.QuickFix)),kbOpts:{kbExpr:u.EditorContextKeys.editorTextFocus,primary:1620,mac:{primary:2644},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){return L(t,f.localize(12,null),{kind:S.CodeActionKind.QuickFix,onlyIncludePreferredActions:!0},0)},t.Id="editor.action.autoFix",t}(o.EditorAction);t.AutoFixAction=O}),define(t[557],i([1,0,11,223]),function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),i.registerEditorContribution(n.QuickFixController),i.registerEditorAction(n.QuickFixAction),i.registerEditorAction(n.RefactorAction),i.registerEditorAction(n.SourceAction),i.registerEditorAction(n.OrganizeImportsAction),i.registerEditorAction(n.AutoFixAction),i.registerEditorAction(n.FixAllAction),i.registerEditorCommand(new n.CodeActionCommand)}),
define(t[558],i([1,0,347,15,38,2,11,192,3,20,21,49,30,17,221,22,16]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v){"use strict";function _(e,t,i){for(var n=y(e,t[0],!i),o=1,r=t.length;o<r;o++){var s=t[o];if(s.isEmpty())return!1;if(n!==y(e,s,!i))return!1}return!0}function y(e,t,i){var n=e.getValueInRange(t);return i?n.toLowerCase():n}Object.defineProperty(t,"__esModule",{value:!0});var b=function(e){function t(){return e.call(this,{id:"editor.action.insertCursorAbove",label:i.localize(0,null),alias:"Add Cursor Above",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:2576,linux:{primary:1552,secondary:[3088]},weight:100},menubarOpts:{menuId:22,group:"3_multi",title:i.localize(1,null),order:2}})||this}return r(t,e),t.prototype.run=function(e,t,i){if(t.hasModel()){var n=i&&!0===i.logicalLine,o=t._getCursors(),r=o.context;r.config.readOnly||(r.model.pushStackElement(),o.setStates(i.source,3,l.CursorMoveCommands.addCursorUp(r,o.getAll(),n)),o.reveal(!0,1,0))}},t}(a.EditorAction)
;t.InsertCursorAbove=b;var C=function(e){function t(){return e.call(this,{id:"editor.action.insertCursorBelow",label:i.localize(2,null),alias:"Add Cursor Below",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:2578,linux:{primary:1554,secondary:[3090]},weight:100},menubarOpts:{menuId:22,group:"3_multi",title:i.localize(3,null),order:3}})||this}return r(t,e),t.prototype.run=function(e,t,i){if(t.hasModel()){var n=i&&!0===i.logicalLine,o=t._getCursors(),r=o.context;r.config.readOnly||(r.model.pushStackElement(),o.setStates(i.source,3,l.CursorMoveCommands.addCursorDown(r,o.getAll(),n)),o.reveal(!0,2,0))}},t}(a.EditorAction);t.InsertCursorBelow=C;var S=function(e){function t(){return e.call(this,{id:"editor.action.insertCursorAtEndOfEachLineSelected",label:i.localize(4,null),alias:"Add Cursors to Line Ends",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:1575,weight:100},menubarOpts:{menuId:22,group:"3_multi",title:i.localize(5,null),order:4}})||this}
return r(t,e),t.prototype.getCursorsForSelection=function(e,t,i){if(!e.isEmpty()){for(var n=e.startLineNumber;n<e.endLineNumber;n++){var o=t.getLineMaxColumn(n);i.push(new d.Selection(n,o,n,o))}e.endColumn>1&&i.push(new d.Selection(e.endLineNumber,e.endColumn,e.endLineNumber,e.endColumn))}},t.prototype.run=function(e,t){var i=this;if(t.hasModel()){var n=t.getModel(),o=[];t.getSelections().forEach(function(e){return i.getCursorsForSelection(e,n,o)}),o.length>0&&t.setSelections(o)}},t}(a.EditorAction),w=function(e){function t(){return e.call(this,{id:"editor.action.addCursorsToBottom",label:i.localize(6,null),alias:"Add Cursors To Bottom",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){for(var i=t.getSelections(),n=t.getModel().getLineCount(),o=[],r=i[0].startLineNumber;r<=n;r++)o.push(new d.Selection(r,i[0].startColumn,r,i[0].endColumn));o.length>0&&t.setSelections(o)}},t}(a.EditorAction),E=function(e){function t(){return e.call(this,{id:"editor.action.addCursorsToTop",
label:i.localize(7,null),alias:"Add Cursors To Top",precondition:void 0})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){for(var i=t.getSelections(),n=[],o=i[0].startLineNumber;o>=1;o--)n.push(new d.Selection(o,i[0].startColumn,o,i[0].endColumn));n.length>0&&t.setSelections(n)}},t}(a.EditorAction),L=function(){return function(e,t,i){this.selections=e,this.revealRange=t,this.revealScrollType=i}}();t.MultiCursorSessionResult=L;var x=function(){function e(e,t,i,n,o,r,s){this._editor=e,this.findController=t,this.isDisconnectedFromFindController=i,this.searchText=n,this.wholeWord=o,this.matchCase=r,this.currentMatch=s}return e.create=function(t,i){if(!t.hasModel())return null;var n=i.getState();if(!t.hasTextFocus()&&n.isRevealed&&n.searchString.length>0)return new e(t,i,!1,n.searchString,n.wholeWord,n.matchCase,null);var o,r,s=!1,a=t.getSelections();1===a.length&&a[0].isEmpty()?(s=!0,o=!0,r=!0):(o=n.wholeWord,r=n.matchCase);var l,u=t.getSelection(),c=null;if(u.isEmpty()){
var h=t.getModel().getWordAtPosition(u.getStartPosition());if(!h)return null;l=h.word,c=new d.Selection(u.startLineNumber,h.startColumn,u.startLineNumber,h.endColumn)}else l=t.getModel().getValueInRange(u).replace(/\r\n/g,"\n");return new e(t,i,s,l,o,r,c)},e.prototype.addSelectionToNextFindMatch=function(){if(!this._editor.hasModel())return null;var e=this._getNextMatch();if(!e)return null;var t=this._editor.getSelections();return new L(t.concat(e),e,0)},e.prototype.moveSelectionToNextFindMatch=function(){if(!this._editor.hasModel())return null;var e=this._getNextMatch();if(!e)return null;var t=this._editor.getSelections();return new L(t.slice(0,t.length-1).concat(e),e,0)},e.prototype._getNextMatch=function(){if(!this._editor.hasModel())return null;if(this.currentMatch){var e=this.currentMatch;return this.currentMatch=null,e}this.findController.highlightFindOptions()
;var t=this._editor.getSelections(),i=t[t.length-1],n=this._editor.getModel().findNextMatch(this.searchText,i.getEndPosition(),!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);return n?new d.Selection(n.range.startLineNumber,n.range.startColumn,n.range.endLineNumber,n.range.endColumn):null},e.prototype.addSelectionToPreviousFindMatch=function(){if(!this._editor.hasModel())return null;var e=this._getPreviousMatch();if(!e)return null;var t=this._editor.getSelections();return new L(t.concat(e),e,0)},e.prototype.moveSelectionToPreviousFindMatch=function(){if(!this._editor.hasModel())return null;var e=this._getPreviousMatch();if(!e)return null;var t=this._editor.getSelections();return new L(t.slice(0,t.length-1).concat(e),e,0)},e.prototype._getPreviousMatch=function(){if(!this._editor.hasModel())return null;if(this.currentMatch){var e=this.currentMatch;return this.currentMatch=null,e}this.findController.highlightFindOptions()
;var t=this._editor.getSelections(),i=t[t.length-1],n=this._editor.getModel().findPreviousMatch(this.searchText,i.getStartPosition(),!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);return n?new d.Selection(n.range.startLineNumber,n.range.startColumn,n.range.endLineNumber,n.range.endColumn):null},e.prototype.selectAll=function(){return this._editor.hasModel()?(this.findController.highlightFindOptions(),this._editor.getModel().findMatches(this.searchText,!0,!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1,1073741824)):[]},e}();t.MultiCursorSession=x;var D=function(e){function t(t){var i=e.call(this)||this;return i._sessionDispose=i._register(new s.DisposableStore),i._editor=t,i._ignoreSelectionChange=!1,i._session=null,i}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.dispose=function(){this._endSession(),e.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},
t.prototype._beginSessionIfNeeded=function(e){var t=this;if(!this._session){var i=x.create(this._editor,e);if(!i)return;this._session=i;var n={searchString:this._session.searchText};this._session.isDisconnectedFromFindController&&(n.wholeWordOverride=1,n.matchCaseOverride=1,n.isRegexOverride=2),e.getState().change(n,!1),this._sessionDispose.add(this._editor.onDidChangeCursorSelection(function(e){t._ignoreSelectionChange||t._endSession()})),this._sessionDispose.add(this._editor.onDidBlurEditorText(function(){t._endSession()})),this._sessionDispose.add(e.getState().onFindReplaceStateChange(function(e){(e.matchCase||e.wholeWord)&&t._endSession()}))}},t.prototype._endSession=function(){if(this._sessionDispose.clear(),this._session&&this._session.isDisconnectedFromFindController){var e={wholeWordOverride:0,matchCaseOverride:0,isRegexOverride:0};this._session.findController.getState().change(e,!1)}this._session=null},t.prototype._setSelections=function(e){this._ignoreSelectionChange=!0,
this._editor.setSelections(e),this._ignoreSelectionChange=!1},t.prototype._expandEmptyToWord=function(e,t){if(!t.isEmpty())return t;var i=e.getWordAtPosition(t.getStartPosition());return i?new d.Selection(t.startLineNumber,i.startColumn,t.startLineNumber,i.endColumn):t},t.prototype._applySessionResult=function(e){e&&(this._setSelections(e.selections),e.revealRange&&this._editor.revealRangeInCenterIfOutsideViewport(e.revealRange,e.revealScrollType))},t.prototype.getSession=function(e){return this._session},t.prototype.addSelectionToNextFindMatch=function(e){if(this._editor.hasModel()){if(!this._session){var t=this._editor.getSelections();if(t.length>1){var i=e.getState().matchCase;if(!_(this._editor.getModel(),t,i)){for(var n=this._editor.getModel(),o=[],r=0,s=t.length;r<s;r++)o[r]=this._expandEmptyToWord(n,t[r]);return void this._editor.setSelections(o)}}}this._beginSessionIfNeeded(e),this._session&&this._applySessionResult(this._session.addSelectionToNextFindMatch())}},
t.prototype.addSelectionToPreviousFindMatch=function(e){this._beginSessionIfNeeded(e),this._session&&this._applySessionResult(this._session.addSelectionToPreviousFindMatch())},t.prototype.moveSelectionToNextFindMatch=function(e){this._beginSessionIfNeeded(e),this._session&&this._applySessionResult(this._session.moveSelectionToNextFindMatch())},t.prototype.moveSelectionToPreviousFindMatch=function(e){this._beginSessionIfNeeded(e),this._session&&this._applySessionResult(this._session.moveSelectionToPreviousFindMatch())},t.prototype.selectAll=function(e){if(this._editor.hasModel()){var t=null,i=e.getState();if(i.isRevealed&&i.searchString.length>0&&i.isRegex)t=this._editor.getModel().findMatches(i.searchString,!0,i.isRegex,i.matchCase,i.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1,1073741824);else{if(this._beginSessionIfNeeded(e),!this._session)return;t=this._session.selectAll()}if(t.length>0){for(var n=this._editor.getSelection(),o=0,r=t.length;o<r;o++){var s=t[o]
;if(s.range.intersectRanges(n)){t[o]=t[0],t[0]=s;break}}this._setSelections(t.map(function(e){return new d.Selection(e.range.startLineNumber,e.range.startColumn,e.range.endLineNumber,e.range.endColumn)}))}}},t.ID="editor.contrib.multiCursorController",t}(s.Disposable);t.MultiCursorSelectionController=D;var I=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.run=function(e,t){var i=D.get(t);if(i){var n=g.CommonFindController.get(t);n&&this._run(i,n)}},t}(a.EditorAction);t.MultiCursorSelectionControllerAction=I;var N=function(e){function t(){return e.call(this,{id:"editor.action.addSelectionToNextFindMatch",label:i.localize(8,null),alias:"Add Selection To Next Find Match",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.focus,primary:2082,weight:100},menubarOpts:{menuId:22,group:"3_multi",title:i.localize(9,null),order:5}})||this}return r(t,e),t.prototype._run=function(e,t){e.addSelectionToNextFindMatch(t)},t}(I);t.AddSelectionToNextFindMatchAction=N
;var M=function(e){function t(){return e.call(this,{id:"editor.action.addSelectionToPreviousFindMatch",label:i.localize(10,null),alias:"Add Selection To Previous Find Match",precondition:void 0,menubarOpts:{menuId:22,group:"3_multi",title:i.localize(11,null),order:6}})||this}return r(t,e),t.prototype._run=function(e,t){e.addSelectionToPreviousFindMatch(t)},t}(I);t.AddSelectionToPreviousFindMatchAction=M;var k=function(e){function t(){return e.call(this,{id:"editor.action.moveSelectionToNextFindMatch",label:i.localize(12,null),alias:"Move Last Selection To Next Find Match",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.focus,primary:o.KeyChord(2089,2082),weight:100}})||this}return r(t,e),t.prototype._run=function(e,t){e.moveSelectionToNextFindMatch(t)},t}(I);t.MoveSelectionToNextFindMatchAction=k;var T=function(e){function t(){return e.call(this,{id:"editor.action.moveSelectionToPreviousFindMatch",label:i.localize(13,null),alias:"Move Last Selection To Previous Find Match",precondition:void 0})||this}
return r(t,e),t.prototype._run=function(e,t){e.moveSelectionToPreviousFindMatch(t)},t}(I);t.MoveSelectionToPreviousFindMatchAction=T;var R=function(e){function t(){return e.call(this,{id:"editor.action.selectHighlights",label:i.localize(14,null),alias:"Select All Occurrences of Find Match",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.focus,primary:3114,weight:100},menubarOpts:{menuId:22,group:"3_multi",title:i.localize(15,null),order:7}})||this}return r(t,e),t.prototype._run=function(e,t){e.selectAll(t)},t}(I);t.SelectHighlightsAction=R;var O=function(e){function t(){return e.call(this,{id:"editor.action.changeAll",label:i.localize(16,null),alias:"Change All Occurrences",precondition:c.EditorContextKeys.writable,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:2108,weight:100},menuOpts:{group:"1_modification",order:1.2}})||this}return r(t,e),t.prototype._run=function(e,t){e.selectAll(t)},t}(I);t.CompatChangeAll=O;var P=function(){function e(e,t,i){this.searchText=e,this.matchCase=t,
this.wordSeparators=i}return e.softEquals=function(e,t){return!e&&!t||!(!e||!t)&&(e.searchText===t.searchText&&e.matchCase===t.matchCase&&e.wordSeparators===t.wordSeparators)},e}(),A=function(e){function t(t){var i=e.call(this)||this;return i.editor=t,i._isEnabled=t.getConfiguration().contribInfo.selectionHighlight,i.decorations=[],i.updateSoon=i._register(new n.RunOnceScheduler(function(){return i._update()},300)),i.state=null,i._register(t.onDidChangeConfiguration(function(e){i._isEnabled=t.getConfiguration().contribInfo.selectionHighlight})),i._register(t.onDidChangeCursorSelection(function(e){i._isEnabled&&(e.selection.isEmpty()?3===e.reason?(i.state&&i._setState(null),i.updateSoon.schedule()):i._setState(null):i._update())})),i._register(t.onDidChangeModel(function(e){i._setState(null)})),i._register(g.CommonFindController.get(t).getState().onFindReplaceStateChange(function(e){i._update()})),i}return r(t,e),t.prototype.getId=function(){return t.ID},t.prototype._update=function(){
this._setState(t._createState(this._isEnabled,this.editor))},t._createState=function(e,t){if(!e)return null;if(!t.hasModel())return null;var i=t.getSelection();if(i.startLineNumber!==i.endLineNumber)return null;var n=D.get(t);if(!n)return null;var o=g.CommonFindController.get(t);if(!o)return null;var r=n.getSession(o);if(!r){var s=t.getSelections();if(s.length>1){var a=o.getState().matchCase;if(!_(t.getModel(),s,a))return null}r=x.create(t,o)}if(!r)return null;if(r.currentMatch)return null;if(/^[ \t]+$/.test(r.searchText))return null;if(r.searchText.length>200)return null;var l=o.getState(),u=l.matchCase;if(l.isRevealed){var d=l.searchString;u||(d=d.toLowerCase());var c=r.searchText;if(u||(c=c.toLowerCase()),d===c&&r.matchCase===l.matchCase&&r.wholeWord===l.wholeWord&&!l.isRegex)return null}return new P(r.searchText,r.matchCase,r.wholeWord?t.getConfiguration().wordSeparators:null)},t.prototype._setState=function(e){if(P.softEquals(this.state,e))this.state=e;else if(this.state=e,this.state){
if(this.editor.hasModel()){var i=this.editor.getModel();if(!i.isTooLargeForTokenization()){var n=f.DocumentHighlightProviderRegistry.has(i),o=i.findMatches(this.state.searchText,!0,!1,this.state.matchCase,this.state.wordSeparators,!1).map(function(e){return e.range});o.sort(u.Range.compareRangesUsingStarts);var r=this.editor.getSelections();r.sort(u.Range.compareRangesUsingStarts);for(var s=[],a=0,l=0,d=o.length,c=r.length;a<d;){var h=o[a];if(l>=c)s.push(h),a++;else{var p=u.Range.compareRangesUsingStarts(h,r[l]);p<0?(!r[l].isEmpty()&&u.Range.areIntersecting(h,r[l])||s.push(h),a++):p>0?l++:(a++,l++)}}var g=s.map(function(e){return{range:e,options:n?t._SELECTION_HIGHLIGHT:t._SELECTION_HIGHLIGHT_OVERVIEW}});this.decorations=this.editor.deltaDecorations(this.decorations,g)}}}else this.decorations=this.editor.deltaDecorations(this.decorations,[])},t.prototype.dispose=function(){this._setState(null),e.prototype.dispose.call(this)},t.ID="editor.contrib.selectionHighlighter",
t._SELECTION_HIGHLIGHT_OVERVIEW=p.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight",overviewRuler:{color:v.themeColorFromId(m.overviewRulerSelectionHighlightForeground),position:h.OverviewRulerLane.Center}}),t._SELECTION_HIGHLIGHT=p.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight"}),t}(s.Disposable);t.SelectionHighlighter=A,a.registerEditorContribution(D),a.registerEditorContribution(A),a.registerEditorAction(b),a.registerEditorAction(C),a.registerEditorAction(S),a.registerEditorAction(N),a.registerEditorAction(M),a.registerEditorAction(k),a.registerEditorAction(T),a.registerEditorAction(R),a.registerEditorAction(O),a.registerEditorAction(w),a.registerEditorAction(E)}),define(t[559],i([1,0,8,52,43,51,4,2,70,111,151,349,14,55,22,16,501,436]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var b=i.$,C=function(e){function t(t,i,n,o){var r=e.call(this)||this;return r.editor=t,
r.renderDisposeables=r._register(new l.DisposableStore),r.model=r._register(new l.MutableDisposable),r.allowEditorOverflow=!0,r.markdownRenderer=r._register(new h.MarkdownRenderer(t,o,n)),r.model.value=new y.ParameterHintsModel(t),r.keyVisible=p.Context.Visible.bindTo(i),r.keyMultipleSignatures=p.Context.MultipleSignatures.bindTo(i),r.visible=!1,r._register(r.model.value.onChangedHints(function(e){e?(r.show(),r.render(e)):r.hide()})),r}return r(t,e),t.prototype.createParamaterHintDOMNodes=function(){var e=this;this.element=b(".editor-widget.parameter-hints-widget");var t=i.append(this.element,b(".wrapper"));t.tabIndex=-1;var o=i.append(t,b(".buttons")),r=i.append(o,b(".button.previous")),l=i.append(o,b(".button.next")),u=n.stop(n.domEvent(r,"click"));this._register(u(this.previous,this));var d=n.stop(n.domEvent(l,"click"));this._register(d(this.next,this)),this.overloads=i.append(t,b(".overloads"));var c=b(".body");this.scrollbar=new s.DomScrollableElement(c,{}),this._register(this.scrollbar),
t.appendChild(this.scrollbar.getDomNode()),this.signature=i.append(c,b(".signature")),this.docs=i.append(c,b(".docs")),this.editor.addContentWidget(this),this.hide(),this.element.style.userSelect="text",this._register(this.editor.onDidChangeCursorSelection(function(t){e.visible&&e.editor.layoutContentWidget(e)}));var h=function(){var t=e.editor.getConfiguration().fontInfo;e.element.style.fontSize=t.fontSize+"px"};h(),this._register(a.Event.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter(function(e){return e.fontInfo}).on(h,null)),this._register(this.editor.onDidLayoutChange(function(t){return e.updateMaxHeight()})),this.updateMaxHeight()},t.prototype.show=function(){var e=this;this.model&&!this.visible&&(this.element||this.createParamaterHintDOMNodes(),this.keyVisible.set(!0),this.visible=!0,setTimeout(function(){return i.addClass(e.element,"visible")},100),this.editor.layoutContentWidget(this))},t.prototype.hide=function(){
this.model&&this.visible&&(this.element||this.createParamaterHintDOMNodes(),this.keyVisible.reset(),this.visible=!1,this.announcedLabel=null,i.removeClass(this.element,"visible"),this.editor.layoutContentWidget(this))},t.prototype.getPosition=function(){return this.visible?{position:this.editor.getPosition(),preference:[1,2]}:null},t.prototype.render=function(e){var t=e.signatures.length>1;i.toggleClass(this.element,"multiple",t),this.keyMultipleSignatures.set(t),this.signature.innerHTML="",this.docs.innerHTML="";var n=e.signatures[e.activeSignature];if(n){var r=i.append(this.signature,b(".code")),s=n.parameters.length>0,a=this.editor.getConfiguration().fontInfo;if(r.style.fontSize=a.fontSize+"px",r.style.fontFamily=a.fontFamily,s)this.renderParameters(r,n,e.activeParameter);else{i.append(r,b("span")).textContent=n.label}this.renderDisposeables.clear();var l=n.parameters[e.activeParameter];if(l&&l.documentation){var u=b("span.documentation")
;if("string"==typeof l.documentation)u.textContent=l.documentation;else{d=this.markdownRenderer.render(l.documentation);i.addClass(d.element,"markdown-docs"),this.renderDisposeables.add(d),u.appendChild(d.element)}i.append(this.docs,b("p",{},u))}if(void 0===n.documentation);else if("string"==typeof n.documentation)i.append(this.docs,b("p",{},n.documentation));else{var d=this.markdownRenderer.render(n.documentation);i.addClass(d.element,"markdown-docs"),this.renderDisposeables.add(d),i.append(this.docs,d.element)}var c=!1;l&&"string"==typeof l.documentation&&l.documentation.length>0&&(c=!0),l&&"object"==typeof l.documentation&&l.documentation.value.length>0&&(c=!0),"string"==typeof n.documentation&&n.documentation.length>0&&(c=!0),"object"==typeof n.documentation&&n.documentation.value.length>0&&(c=!0),i.toggleClass(this.signature,"has-docs",c),i.toggleClass(this.docs,"empty",!c);var h=String(e.activeSignature+1);if(e.signatures.length<10&&(h+="/"+e.signatures.length),this.overloads.textContent=h,l){
var p=this.getParameterLabel(n,e.activeParameter);this.announcedLabel!==p&&(o.alert(f.localize(0,null,p)),this.announcedLabel=p)}this.editor.layoutContentWidget(this),this.scrollbar.scanDomNode()}},t.prototype.renderParameters=function(e,t,n){var o=this.getParameterLabelOffsets(t,n),r=o[0],s=o[1],a=document.createElement("span");a.textContent=t.label.substring(0,r);var l=document.createElement("span");l.textContent=t.label.substring(r,s),l.className="parameter active";var u=document.createElement("span");u.textContent=t.label.substring(s),i.append(e,a,l,u)},t.prototype.getParameterLabel=function(e,t){var i=e.parameters[t];return"string"==typeof i.label?i.label:e.label.substring(i.label[0],i.label[1])},t.prototype.getParameterLabelOffsets=function(e,t){var i=e.parameters[t];if(i){if(Array.isArray(i.label))return i.label;var n=e.label.lastIndexOf(i.label);return n>=0?[n,n+i.label.length]:[0,0]}return[0,0]},t.prototype.next=function(){this.model.value&&(this.editor.focus(),this.model.value.next())},
t.prototype.previous=function(){this.model.value&&(this.editor.focus(),this.model.value.previous())},t.prototype.cancel=function(){this.model.value&&this.model.value.cancel()},t.prototype.getDomNode=function(){return this.element},t.prototype.getId=function(){return t.ID},t.prototype.trigger=function(e){this.model.value&&this.model.value.trigger(e,0)},t.prototype.updateMaxHeight=function(){var e=Math.max(this.editor.getLayoutInfo().height/4,250);this.element.style.maxHeight=e+"px"},t.ID="editor.widget.parameterHintsWidget",t=d([c(1,g.IContextKeyService),c(2,m.IOpenerService),c(3,u.IModeService)],t)}(l.Disposable);t.ParameterHintsWidget=C,_.registerThemingParticipant(function(e,t){var i=e.getColor(v.editorHoverBorder);if(i){var n=e.type===_.HIGH_CONTRAST?2:1;t.addRule(".monaco-editor .parameter-hints-widget { border: "+n+"px solid "+i+"; }"),t.addRule(".monaco-editor .parameter-hints-widget.multiple .body { border-left: 1px solid "+i.transparent(.5)+"; }"),
t.addRule(".monaco-editor .parameter-hints-widget .signature.has-docs { border-bottom: 1px solid "+i.transparent(.5)+"; }")}var o=e.getColor(v.editorHoverBackground);o&&t.addRule(".monaco-editor .parameter-hints-widget { background-color: "+o+"; }");var r=e.getColor(v.textLinkForeground);r&&t.addRule(".monaco-editor .parameter-hints-widget a { color: "+r+"; }");var s=e.getColor(v.textCodeBlockBackground);s&&t.addRule(".monaco-editor .parameter-hints-widget code { background-color: "+s+"; }")})}),define(t[560],i([1,0,348,2,12,21,14,11,559,151,17]),function(e,t,i,n,o,s,a,l,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var f=function(e){function t(t,i){var n=e.call(this)||this;return n.editor=t,n.widget=n._register(i.createInstance(u.ParameterHintsWidget,n.editor)),n}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.cancel=function(){this.widget.cancel()},t.prototype.previous=function(){this.widget.previous()},
t.prototype.next=function(){this.widget.next()},t.prototype.trigger=function(e){this.widget.trigger(e)},t.ID="editor.controller.parameterHints",t=d([c(1,o.IInstantiationService)],t)}(n.Disposable),g=function(e){function t(){return e.call(this,{id:"editor.action.triggerParameterHints",label:i.localize(0,null),alias:"Trigger Parameter Hints",precondition:s.EditorContextKeys.hasSignatureHelpProvider,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:3082,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=f.get(t);i&&i.trigger({triggerKind:p.SignatureHelpTriggerKind.Invoke})},t}(l.EditorAction);t.TriggerParameterHintsAction=g,l.registerEditorContribution(f),l.registerEditorAction(g);var m=l.EditorCommand.bindToContribution(f.get);l.registerEditorCommand(new m({id:"closeParameterHints",precondition:h.Context.Visible,handler:function(e){return e.cancel()},kbOpts:{weight:175,kbExpr:s.EditorContextKeys.focus,primary:9,secondary:[1033]}})),l.registerEditorCommand(new m({
id:"showPrevParameterHint",precondition:a.ContextKeyExpr.and(h.Context.Visible,h.Context.MultipleSignatures),handler:function(e){return e.previous()},kbOpts:{weight:175,kbExpr:s.EditorContextKeys.focus,primary:16,secondary:[528],mac:{primary:16,secondary:[528,302]}}})),l.registerEditorCommand(new m({id:"showNextParameterHint",precondition:a.ContextKeyExpr.and(h.Context.Visible,h.Context.MultipleSignatures),handler:function(e){return e.next()},kbOpts:{weight:175,kbExpr:s.EditorContextKeys.focus,primary:18,secondary:[530],mac:{primary:18,secondary:[530,300]}}}))}),define(t[96],i([1,0,8,74,58,25,4,29,5,31,153,413,350,14,12,73,421]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPeekViewService=g.createDecorator("IPeekViewService"),m.registerSingleton(t.IPeekViewService,function(){function e(){this._widgets=new Map}return e.prototype.addExclusiveWidget=function(e,t){var i=this,n=this._widgets.get(e);n&&(n.listener.dispose(),n.widget.dispose())
;this._widgets.set(e,{widget:t,listener:t.onDidClose(function(){var n=i._widgets.get(e);n&&n.widget===t&&(n.listener.dispose(),i._widgets.delete(e))})})},e}());!function(e){e.inPeekEditor=new f.RawContextKey("inReferenceSearchEditor",!0),e.notInPeekEditor=e.inPeekEditor.toNegated()}(t.PeekContext||(t.PeekContext={})),t.getOuterEditor=function(e){var t=e.get(d.ICodeEditorService).getFocusedCodeEditor();return t instanceof c.EmbeddedCodeEditorWidget?t.getParentEditor():t};var v={headerBackgroundColor:s.Color.white,primaryHeadingColor:s.Color.fromHex("#333333"),secondaryHeadingColor:s.Color.fromHex("#6c6c6cb3")},_=function(e){function t(t,i){void 0===i&&(i={});var n=e.call(this,t,i)||this;return n._onDidClose=new a.Emitter,l.mixin(n.options,v,!1),n}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this),this._onDidClose.fire(this)},Object.defineProperty(t.prototype,"onDidClose",{get:function(){return this._onDidClose.event},enumerable:!0,configurable:!0}),t.prototype.style=function(t){
var i=this.options;t.headerBackgroundColor&&(i.headerBackgroundColor=t.headerBackgroundColor),t.primaryHeadingColor&&(i.primaryHeadingColor=t.primaryHeadingColor),t.secondaryHeadingColor&&(i.secondaryHeadingColor=t.secondaryHeadingColor),e.prototype.style.call(this,t)},t.prototype._applyStyles=function(){e.prototype._applyStyles.call(this);var t=this.options;this._headElement&&t.headerBackgroundColor&&(this._headElement.style.backgroundColor=t.headerBackgroundColor.toString()),this._primaryHeading&&t.primaryHeadingColor&&(this._primaryHeading.style.color=t.primaryHeadingColor.toString()),this._secondaryHeading&&t.secondaryHeadingColor&&(this._secondaryHeading.style.color=t.secondaryHeadingColor.toString()),this._bodyElement&&t.frameColor&&(this._bodyElement.style.borderColor=t.frameColor.toString())},t.prototype._fillContainer=function(e){this.setCssClass("peekview-widget"),this._headElement=i.$(".head"),this._bodyElement=i.$(".body"),this._fillHead(this._headElement),this._fillBody(this._bodyElement),
e.appendChild(this._headElement),e.appendChild(this._bodyElement)},t.prototype._fillHead=function(e){var t=this,r=i.$(".peekview-title");i.append(this._headElement,r),i.addStandardDisposableListener(r,"click",function(e){return t._onTitleClick(e)}),this._fillTitleIcon(r),this._primaryHeading=i.$("span.filename"),this._secondaryHeading=i.$("span.dirname"),this._metaHeading=i.$("span.meta"),i.append(r,this._primaryHeading,this._secondaryHeading,this._metaHeading);var s=i.$(".peekview-actions");i.append(this._headElement,s);var a=this._getActionBarOptions();this._actionbarWidget=new n.ActionBar(s,a),this._disposables.add(this._actionbarWidget),this._actionbarWidget.push(new o.Action("peekview.close",p.localize(0,null),"close-peekview-action",!0,function(){return t.dispose(),Promise.resolve()}),{label:!1,icon:!0})},t.prototype._fillTitleIcon=function(e){},t.prototype._getActionBarOptions=function(){return{}},t.prototype._onTitleClick=function(e){},t.prototype.setTitle=function(e,t){
this._primaryHeading&&this._secondaryHeading&&(this._primaryHeading.innerHTML=u.escape(e),this._primaryHeading.setAttribute("aria-label",e),t?this._secondaryHeading.innerHTML=u.escape(t):i.clearNode(this._secondaryHeading))},t.prototype.setMetaTitle=function(e){this._metaHeading&&(e?this._metaHeading.innerHTML=u.escape(e):i.clearNode(this._metaHeading))},t.prototype._doLayout=function(e,t){if(!this._isShowing&&e<0)this.dispose();else{var i=Math.ceil(1.2*this.editor.getConfiguration().lineHeight),n=e-(i+2);this._doLayoutHead(i,t),this._doLayoutBody(n,t)}},t.prototype._doLayoutHead=function(e,t){this._headElement&&(this._headElement.style.height=e+"px",this._headElement.style.lineHeight=this._headElement.style.height)},t.prototype._doLayoutBody=function(e,t){this._bodyElement&&(this._bodyElement.style.height=e+"px")},t}(h.ZoneWidget);t.PeekViewWidget=_}),define(t[562],i([1,0,97,76,135,422,102,16,90,8,355,203,48,2,12,33,64,157]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var C=function(){function e(e){this._resolverService=e}return e.prototype.hasChildren=function(e){return e instanceof i.ReferencesModel||e instanceof i.FileReferences&&!e.failure},e.prototype.getChildren=function(e){if(e instanceof i.ReferencesModel)return e.groups;if(e instanceof i.FileReferences)return e.resolve(this._resolverService).then(function(e){return e.children});throw new Error("bad tree")},e=d([c(0,n.ITextModelService)],e)}();t.DataSource=C;var S=function(){function e(){}return e.prototype.getHeight=function(){return 23},e.prototype.getTemplateId=function(e){return e instanceof i.FileReferences?x.id:I.id},e}();t.Delegate=S;var w=function(){function e(e){this._keybindingService=e}return e.prototype.getKeyboardNavigationLabel=function(e){if(e instanceof i.OneReference){var t=e.parent.preview,n=t&&t.preview(e.range);if(n)return n.value}return g.basename(e.uri)},e.prototype.mightProducePrintableCharacter=function(e){
return this._keybindingService.mightProducePrintableCharacter(e)},e=d([c(0,_.IKeybindingService)],e)}();t.StringRepresentationProvider=w;var E=function(){function e(){}return e.prototype.getId=function(e){return e.id},e}();t.IdentityProvider=E;var L=function(e){function t(t,i,n){var r=e.call(this)||this;r._uriLabel=i;var a=document.createElement("div");return h.addClass(a,"reference-file"),r.file=r._register(new o.IconLabel(a,{supportHighlights:!0})),r.badge=new s.CountBadge(h.append(a,h.$(".count"))),r._register(u.attachBadgeStyler(r.badge,n)),t.appendChild(a),r}return r(t,e),t.prototype.set=function(e,t){var i=g.dirname(e.uri);this.file.setLabel(f.getBaseLabel(e.uri),this._uriLabel.getUriLabel(i,{relative:!0}),{title:this._uriLabel.getUriLabel(e.uri),matches:t});var n=e.children.length;this.badge.setCount(n),e.failure?this.badge.setTitleFormat(p.localize(0,null)):n>1?this.badge.setTitleFormat(p.localize(1,null,n)):this.badge.setTitleFormat(p.localize(2,null,n))},
t=d([c(1,a.ILabelService),c(2,l.IThemeService)],t)}(m.Disposable),x=function(){function e(t){this._instantiationService=t,this.templateId=e.id}return e.prototype.renderTemplate=function(e){return this._instantiationService.createInstance(L,e)},e.prototype.renderElement=function(e,t,i){i.set(e.element,y.createMatches(e.filterData))},e.prototype.disposeTemplate=function(e){e.dispose()},e.id="FileReferencesRenderer",e=d([c(0,v.IInstantiationService)],e)}();t.FileReferencesRenderer=x;var D=function(){function e(e){this.label=new b.HighlightedLabel(e,!1)}return e.prototype.set=function(e,t){var i=e.parent.preview,n=i&&i.preview(e.range);if(n){var o=n.value,r=n.highlight;t&&!y.FuzzyScore.isDefault(t)?(h.toggleClass(this.label.element,"referenceMatch",!1),this.label.set(o,y.createMatches(t))):(h.toggleClass(this.label.element,"referenceMatch",!0),this.label.set(o,[r]))}else this.label.set(g.basename(e.uri)+":"+(e.range.startLineNumber+1)+":"+(e.range.startColumn+1))},e}(),I=function(){function e(){
this.templateId=e.id}return e.prototype.renderTemplate=function(e){return new D(e)},e.prototype.renderElement=function(e,t,i){i.set(e.element,e.filterData)},e.prototype.disposeTemplate=function(){},e.id="OneReferenceRenderer",e}();t.OneReferenceRenderer=I;var N=function(){function e(){}return e.prototype.getAriaLabel=function(e){return e instanceof i.FileReferences?e.getAriaMessage():e instanceof i.OneReference?e.getAriaMessage():null},e}();t.AriaProvider=N}),define(t[563],i([1,0,357,10,14,110,11,21,512,16,17,13,43,3,107,61,34,163,24,31,26,2,15]),function(e,t,i,n,o,s,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D){"use strict";function I(e,t,i){return a(this,void 0,void 0,function(){return l(this,function(n){return[2,new N(e,t).provideRenameEdits(i,0,[],L.CancellationToken.None)]})})}Object.defineProperty(t,"__esModule",{value:!0});var N=function(){function e(e,t){this.model=e,this.position=t,this._providers=g.RenameProviderRegistry.ordered(e)}return e.prototype.hasProvider=function(){return this._providers.length>0},
e.prototype.resolveRenameLocation=function(e){return a(this,void 0,void 0,function(){var t,i,n;return l(this,function(o){switch(o.label){case 0:return(t=this._providers[0])?t.resolveRenameLocation?[4,t.resolveRenameLocation(this.model,this.position,e)]:[3,2]:[2,void 0];case 1:i=o.sent(),o.label=2;case 2:return!i&&(n=this.model.getWordAtPosition(this.position))?[2,{range:new _.Range(this.position.lineNumber,n.startColumn,this.position.lineNumber,n.endColumn),text:n.word}]:[2,i]}})})},e.prototype.provideRenameEdits=function(e,t,n,o){return a(this,void 0,void 0,function(){var r,s;return l(this,function(a){switch(a.label){case 0:return(r=this._providers[t])?[4,r.provideRenameEdits(this.model,this.position,e,o)]:[2,{edits:[],rejectReason:n.join("\n")}];case 1:return(s=a.sent())?s.rejectReason?[2,this.provideRenameEdits(e,t+1,n.concat(s.rejectReason),o)]:[2,s]:[2,this.provideRenameEdits(e,t+1,n.concat(i.localize(0,null)),o)]}})})},e}();t.rename=I;var M=function(e){function t(t,i,n,o,r,s){var a=e.call(this)||this
;return a.editor=t,a._notificationService=i,a._bulkEditService=n,a._progressService=o,a._contextKeyService=r,a._themeService=s,a._renameOperationIdPool=1,a._register(a.editor.onDidChangeModel(function(){return a.onModelChanged()})),a._register(a.editor.onDidChangeModelLanguage(function(){return a.onModelChanged()})),a._register(a.editor.onDidChangeCursorSelection(function(){return a.onModelChanged()})),a}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},Object.defineProperty(t.prototype,"renameInputField",{get:function(){return this._renameInputField||(this._renameInputField=this._register(new p.RenameInputField(this.editor,this._themeService,this._contextKeyService))),this._renameInputField},enumerable:!0,configurable:!0}),t.prototype.getId=function(){return t.ID},t.prototype.run=function(){return a(this,void 0,void 0,function(){var e,t=this;return l(this,function(i){return this._activeRename&&this._activeRename.operation.cancel(),e=this._renameOperationIdPool++,this._activeRename={id:e,
operation:D.createCancelablePromise(function(i){return t.doRename(i,e)})},[2,this._activeRename.operation]})})},t.prototype.doRename=function(e,t){return a(this,void 0,void 0,function(){var n,o,r,s,a,u,d,c,h=this;return l(this,function(l){switch(l.label){case 0:if(!this.editor.hasModel())return[2,void 0];if(n=this.editor.getPosition(),!(o=new N(this.editor.getModel(),n)).hasProvider())return[2,void 0];l.label=1;case 1:return l.trys.push([1,3,,4]),s=o.resolveRenameLocation(e),this._progressService.showWhile(s,250),[4,s];case 2:return r=l.sent(),[3,4];case 3:return a=l.sent(),y.MessageController.get(this.editor).showMessage(a||i.localize(1,null),n),[2,void 0];case 4:return r?r.rejectReason?(y.MessageController.get(this.editor).showMessage(r.rejectReason,n),[2,void 0]):this._activeRename&&this._activeRename.id===t?(u=this.editor.getSelection(),d=0,c=r.text.length,_.Range.isEmpty(u)||_.Range.spansMultipleLines(u)||!_.Range.containsRange(r.range,u)||(d=Math.max(0,u.startColumn-r.range.startColumn),
c=Math.min(r.range.endColumn,u.endColumn)-r.range.startColumn),[2,this.renameInputField.getInput(r.range,r.text,d,c).then(function(t){if("boolean"!=typeof t){h.editor.focus();var n=new b.EditorState(h.editor,15),s=Promise.resolve(o.provideRenameEdits(t,0,[],e).then(function(e){if(h.editor.hasModel()){if(!e.rejectReason)return h._bulkEditService.apply(e,{editor:h.editor}).then(function(e){e.ariaSummary&&v.alert(i.localize(2,null,r.text,t,e.ariaSummary))});n.validate(h.editor)?y.MessageController.get(h.editor).showMessage(e.rejectReason,h.editor.getPosition()):h._notificationService.info(e.rejectReason)}},function(e){return h._notificationService.error(i.localize(3,null)),Promise.reject(e)}));return h._progressService.showWhile(s,250),s}t&&h.editor.focus()})]):[2,void 0]:[2,void 0]}})})},t.prototype.acceptRenameInput=function(){this._renameInputField&&this._renameInputField.acceptInput()},t.prototype.cancelRenameInput=function(){this._renameInputField&&this._renameInputField.cancelInput(!0)},
t.prototype.onModelChanged=function(){this._activeRename&&(this._activeRename.operation.cancel(),this._activeRename=void 0)},t.ID="editor.contrib.renameController",t=d([c(1,C.INotificationService),c(2,S.IBulkEditService),c(3,s.IEditorProgressService),c(4,o.IContextKeyService),c(5,f.IThemeService)],t)}(x.Disposable),k=function(e){function t(){return e.call(this,{id:"editor.action.rename",label:i.localize(4,null),alias:"Rename Symbol",precondition:o.ContextKeyExpr.and(h.EditorContextKeys.writable,h.EditorContextKeys.hasRenameProvider),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:60,weight:100},menuOpts:{group:"1_modification",order:1.1}})||this}return r(t,e),t.prototype.runCommand=function(t,i){var o=this,r=t.get(E.ICodeEditorService),s=Array.isArray(i)&&i||[void 0,void 0],a=s[0],l=s[1];return w.URI.isUri(a)&&m.Position.isIPosition(l)?r.openCodeEditor({resource:a},r.getActiveCodeEditor()).then(function(e){e&&(e.setPosition(l),e.invokeWithinContext(function(t){return o.reportTelemetry(t,e),
o.run(t,e)}))},n.onUnexpectedError):e.prototype.runCommand.call(this,t,i)},t.prototype.run=function(e,t){var i=M.get(t);return i?i.run():Promise.resolve()},t}(u.EditorAction);t.RenameAction=k,u.registerEditorContribution(M),u.registerEditorAction(k);var T=u.EditorCommand.bindToContribution(M.get);u.registerEditorCommand(new T({id:"acceptRenameInput",precondition:p.CONTEXT_RENAME_INPUT_VISIBLE,handler:function(e){return e.acceptRenameInput()},kbOpts:{weight:199,kbExpr:h.EditorContextKeys.focus,primary:3}})),u.registerEditorCommand(new T({id:"cancelRenameInput",precondition:p.CONTEXT_RENAME_INPUT_VISIBLE,handler:function(e){return e.cancelRenameInput()},kbOpts:{weight:199,kbExpr:h.EditorContextKeys.focus,primary:9,secondary:[1033]}})),u.registerDefaultLanguageCommand("_executeDocumentRenameProvider",function(e,t,i){var o=i.newName;if("string"!=typeof o)throw n.illegalArgument("newName");return I(e,t,o)})}),
define(t[564],i([1,0,362,64,5,4,10,2,8,122,51,33,14,93,43,103,90,16,22,68,111,70,55,15,17,135,454,42,24,12,185,78,19,298]),function(e,t,i,n,o,r,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M,k,T,R,O,P,A,F){"use strict";function W(e){if(!e)return!1;var t=e.completion;return!!t.documentation||t.detail&&t.detail!==t.label}Object.defineProperty(t,"__esModule",{value:!0});t.editorSuggestWidgetBackground=w.registerColor("editorSuggestWidget.background",{dark:w.editorWidgetBackground,light:w.editorWidgetBackground,hc:w.editorWidgetBackground},i.localize(0,null)),t.editorSuggestWidgetBorder=w.registerColor("editorSuggestWidget.border",{dark:w.editorWidgetBorder,light:w.editorWidgetBorder,hc:w.editorWidgetBorder},i.localize(1,null)),t.editorSuggestWidgetForeground=w.registerColor("editorSuggestWidget.foreground",{dark:w.editorForeground,light:w.editorForeground,hc:w.editorForeground},i.localize(2,null)),t.editorSuggestWidgetSelectedBackground=w.registerColor("editorSuggestWidget.selectedBackground",{
dark:w.listFocusBackground,light:w.listFocusBackground,hc:w.listFocusBackground},i.localize(3,null)),t.editorSuggestWidgetHighlightForeground=w.registerColor("editorSuggestWidget.highlightForeground",{dark:w.listHighlightForeground,light:w.listHighlightForeground,hc:w.listHighlightForeground},i.localize(4,null));var V=/^(#([\da-f]{3}){1,2}|(rgb|hsl)a\(\s*(\d{1,3}%?\s*,\s*){3}(1|0?\.\d+)\)|(rgb|hsl)\(\s*\d{1,3}%?(\s*,\s*\d{1,3}%?){2}\s*\))$/i,B=function(){function e(e,t,i,n,o,r){this.widget=e,this.editor=t,this.triggerKeybindingLabel=i,this._modelService=n,this._modeService=o,this._themeService=r}return Object.defineProperty(e.prototype,"templateId",{get:function(){return"suggestion"},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(e){var t=this,n=Object.create(null);n.disposables=new h.DisposableStore,n.root=e,p.addClass(n.root,"show-file-icons"),n.icon=p.append(e,p.$(".icon")),n.colorspan=p.append(n.icon,p.$("span.colorspan"));var o=p.append(e,p.$(".contents")),s=p.append(o,p.$(".main"))
;n.iconLabel=new M.IconLabel(s,{supportHighlights:!0,supportOcticons:!0}),n.disposables.add(n.iconLabel),n.typeLabel=p.append(s,p.$("span.type-label")),n.readMore=p.append(s,p.$("span.readMore")),n.readMore.title=i.localize(5,null,this.triggerKeybindingLabel);var a=function(){var e=t.editor.getConfiguration(),i=e.fontInfo.fontFamily,o=e.contribInfo.suggestFontSize||e.fontInfo.fontSize,r=e.contribInfo.suggestLineHeight||e.fontInfo.lineHeight,a=e.fontInfo.fontWeight,l=o+"px",u=r+"px";n.root.style.fontSize=l,n.root.style.fontWeight=a,s.style.fontFamily=i,s.style.lineHeight=u,n.icon.style.height=u,n.icon.style.width=u,n.readMore.style.height=u,n.readMore.style.width=u};return a(),n.disposables.add(r.Event.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter(function(e){return e.fontInfo||e.contribInfo}).on(a,null)),n},e.prototype.renderElement=function(e,t,i){var o=this,r=i,s=e.completion;r.icon.className="icon "+N.completionKindToCssClass(s.kind),r.colorspan.style.backgroundColor="";var a={
labelEscapeNewLines:!0,matches:n.createMatches(e.score)},l=[];19===s.kind&&function(e,t){return e.completion.label.match(V)?(t[0]=e.completion.label,!0):!("string"!=typeof e.completion.documentation||!e.completion.documentation.match(V)||(t[0]=e.completion.documentation,0))}(e,l)?(r.icon.className="icon customcolor",r.colorspan.style.backgroundColor=l[0]):20===s.kind&&this._themeService.getIconTheme().hasFileIcons?(r.icon.className="icon hide",a.extraClasses=F.flatten([k.getIconClasses(this._modelService,this._modeService,R.URI.from({scheme:"fake",path:s.label}),P.FileKind.FILE),k.getIconClasses(this._modelService,this._modeService,R.URI.from({scheme:"fake",path:s.detail}),P.FileKind.FILE)])):23===s.kind&&this._themeService.getIconTheme().hasFolderIcons?(r.icon.className="icon hide",a.extraClasses=F.flatten([k.getIconClasses(this._modelService,this._modeService,R.URI.from({scheme:"fake",path:s.label}),P.FileKind.FOLDER),k.getIconClasses(this._modelService,this._modeService,R.URI.from({scheme:"fake",
path:s.detail}),P.FileKind.FOLDER)])):(r.icon.className="icon hide",a.extraClasses=["suggest-icon "+N.completionKindToCssClass(s.kind)]),s.tags&&s.tags.indexOf(1)>=0&&(a.extraClasses=(a.extraClasses||[]).concat(["deprecated"]),a.matches=[]),r.iconLabel.setLabel(s.label,void 0,a),r.typeLabel.textContent=(s.detail||"").replace(/\n.*$/m,""),W(e)?(p.show(r.readMore),r.readMore.onmousedown=function(e){e.stopPropagation(),e.preventDefault()},r.readMore.onclick=function(e){e.stopPropagation(),e.preventDefault(),o.widget.toggleDetails()}):(p.hide(r.readMore),r.readMore.onmousedown=null,r.readMore.onclick=null)},e.prototype.disposeTemplate=function(e){e.disposables.dispose()},e=d([c(3,T.IModelService),c(4,x.IModeService),c(5,S.IThemeService)],e)}(),H=function(){function e(e,t,n,o,s){var a=this;this.widget=t,this.editor=n,this.markdownRenderer=o,this.triggerKeybindingLabel=s,this.borderWidth=1,this.disposables=new h.DisposableStore,this.el=p.append(e,p.$(".details")),this.disposables.add(h.toDisposable(function(){
return e.removeChild(a.el)})),this.body=p.$(".body"),this.scrollbar=new g.DomScrollableElement(this.body,{}),p.append(this.el,this.scrollbar.getDomNode()),this.disposables.add(this.scrollbar),this.header=p.append(this.body,p.$(".header")),this.close=p.append(this.header,p.$("span.close")),this.close.title=i.localize(6,null,this.triggerKeybindingLabel),this.type=p.append(this.header,p.$("p.type")),this.docs=p.append(this.body,p.$("p.docs")),this.ariaLabel=null,this.configureFont(),r.Event.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter(function(e){return e.fontInfo}).on(this.configureFont,this,this.disposables),o.onDidRenderCodeBlock(function(){return a.scrollbar.scanDomNode()},this,this.disposables)}return Object.defineProperty(e.prototype,"element",{get:function(){return this.el},enumerable:!0,configurable:!0}),e.prototype.renderLoading=function(){this.type.textContent=i.localize(7,null),this.docs.textContent=""},e.prototype.renderItem=function(e,t){var i=this
;this.renderDisposeable=h.dispose(this.renderDisposeable);var n=e.completion,r=n.documentation,s=n.detail;if(t){var a="";a+="score: "+e.score[0]+(e.word?", compared '"+(e.completion.filterText&&e.completion.filterText+" (filterText)"||e.completion.label)+"' with '"+e.word+"'":" (no prefix)")+"\n",a+="distance: "+e.distance+", see localityBonus-setting\n",a+="index: "+e.idx+", based on "+(e.completion.sortText&&'sortText: "'+e.completion.sortText+'"'||"label")+"\n",r=(new A.MarkdownString).appendCodeblock("empty",a),s="Provider: "+e.provider._debugDisplayName}if(!t&&!W(e))return this.type.textContent="",this.docs.textContent="",p.addClass(this.el,"no-docs"),void(this.ariaLabel=null);if(p.removeClass(this.el,"no-docs"),"string"==typeof r)p.removeClass(this.docs,"markdown-docs"),this.docs.textContent=r;else{p.addClass(this.docs,"markdown-docs"),this.docs.innerHTML="";var l=this.markdownRenderer.render(r);this.renderDisposeable=l,this.docs.appendChild(l.element)}s?(this.type.innerText=s,
p.show(this.type)):(this.type.innerText="",p.hide(this.type)),this.el.style.height=this.header.offsetHeight+this.docs.offsetHeight+2*this.borderWidth+"px",this.close.onmousedown=function(e){e.preventDefault(),e.stopPropagation()},this.close.onclick=function(e){e.preventDefault(),e.stopPropagation(),i.widget.toggleDetails()},this.body.scrollTop=0,this.scrollbar.scanDomNode(),this.ariaLabel=o.format("{0}{1}",s||"",r?"string"==typeof r?r:r.value:"")},e.prototype.getAriaLabel=function(){return this.ariaLabel},e.prototype.scrollDown=function(e){void 0===e&&(e=8),this.body.scrollTop+=e},e.prototype.scrollUp=function(e){void 0===e&&(e=8),this.body.scrollTop-=e},e.prototype.scrollTop=function(){this.body.scrollTop=0},e.prototype.scrollBottom=function(){this.body.scrollTop=this.body.scrollHeight},e.prototype.pageDown=function(){this.scrollDown(80)},e.prototype.pageUp=function(){this.scrollUp(80)},e.prototype.setBorderWidth=function(e){this.borderWidth=e},e.prototype.configureFont=function(){
var e=this.editor.getConfiguration(),t=e.fontInfo.fontFamily,i=e.contribInfo.suggestFontSize||e.fontInfo.fontSize,n=e.contribInfo.suggestLineHeight||e.fontInfo.lineHeight,o=e.fontInfo.fontWeight,r=i+"px",s=n+"px";this.el.style.fontSize=r,this.el.style.fontWeight=o,this.type.style.fontFamily=t,this.close.style.height=s,this.close.style.width=s},e.prototype.dispose=function(){this.disposables.dispose(),this.renderDisposeable=h.dispose(this.renderDisposeable)},e}(),z=function(){function e(e,i,n,o,s,a,l,u,d){var c=this;this.editor=e,this.telemetryService=i,this.allowEditorOverflow=!0,this.suppressMouseDown=!0,this.state=null,this.isAuto=!1,this.loadingTimeout=h.Disposable.None,this.currentSuggestionDetails=null,this.ignoreFocusEvents=!1,this.completionModel=null,this.showTimeout=new I.TimeoutTimer,this.toDispose=new h.DisposableStore,this.onDidSelectEmitter=new r.Emitter,this.onDidFocusEmitter=new r.Emitter,this.onDidHideEmitter=new r.Emitter,this.onDidShowEmitter=new r.Emitter,
this.onDidSelect=this.onDidSelectEmitter.event,this.onDidFocus=this.onDidFocusEmitter.event,this.onDidHide=this.onDidHideEmitter.event,this.onDidShow=this.onDidShowEmitter.event,this.maxWidgetWidth=660,this.listWidth=330,this.firstFocusInCurrentList=!1,this.preferDocPositionTop=!1,this.docsPositionPreviousWidgetY=null,this.explainMode=!1,this._lastAriaAlertLabel=null;var g=a.lookupKeybinding("editor.action.triggerSuggest"),m=g?" ("+g.getLabel()+")":"",v=this.toDispose.add(new L.MarkdownRenderer(e,l,u));this.isAuto=!1,this.focusedItem=null,this.storageService=s,this.element=p.$(".editor-widget.suggest-widget"),this.toDispose.add(p.addDisposableListener(this.element,"click",function(e){e.target===c.element&&c.hideWidget()})),this.messageElement=p.append(this.element,p.$(".message")),this.listElement=p.append(this.element,p.$(".tree")),this.details=d.createInstance(H,this.element,this,this.editor,v,m);var y=function(){
return p.toggleClass(c.element,"no-icons",!c.editor.getConfiguration().contribInfo.suggest.showIcons)};y();var b=d.createInstance(B,this,this.editor,m);this.list=new f.List(this.listElement,this,[b],{useShadows:!1,openController:{shouldOpen:function(){return!1}},mouseSupport:!1}),this.toDispose.add(C.attachListStyler(this.list,o,{listInactiveFocusBackground:t.editorSuggestWidgetSelectedBackground,listInactiveFocusOutline:w.activeContrastBorder})),this.toDispose.add(o.onThemeChange(function(e){return c.onThemeChange(e)})),this.toDispose.add(e.onDidLayoutChange(function(){return c.onEditorLayoutChange()})),this.toDispose.add(this.list.onMouseDown(function(e){return c.onListMouseDown(e)})),this.toDispose.add(this.list.onSelectionChange(function(e){return c.onListSelection(e)})),this.toDispose.add(this.list.onFocusChange(function(e){return c.onListFocus(e)})),this.toDispose.add(this.editor.onDidChangeCursorSelection(function(){return c.onCursorSelectionChanged()})),
this.toDispose.add(this.editor.onDidChangeConfiguration(function(e){return e.contribInfo&&y()})),this.suggestWidgetVisible=_.Context.Visible.bindTo(n),this.suggestWidgetMultipleSuggestions=_.Context.MultipleSuggestions.bindTo(n),this.editor.addContentWidget(this),this.setState(0),this.onThemeChange(o.getTheme())}return e.prototype.onCursorSelectionChanged=function(){0!==this.state&&this.editor.layoutContentWidget(this)},e.prototype.onEditorLayoutChange=function(){3!==this.state&&5!==this.state||!this.expandDocsSettingFromStorage()||this.expandSideOrBelow()},e.prototype.onListMouseDown=function(e){void 0!==e.element&&void 0!==e.index&&(e.browserEvent.preventDefault(),e.browserEvent.stopPropagation(),this.select(e.element,e.index))},e.prototype.onListSelection=function(e){e.elements.length&&this.select(e.elements[0],e.indexes[0])},e.prototype.select=function(e,t){var i=this.completionModel;i&&(this.onDidSelectEmitter.fire({item:e,index:t,model:i}),this.editor.focus())},
e.prototype._getSuggestionAriaAlertLabel=function(e){return this.expandDocsSettingFromStorage()?i.localize(10,null,e.completion.label,this.details.getAriaLabel()):e.completion.label},e.prototype._ariaAlert=function(e){this._lastAriaAlertLabel!==e&&(this._lastAriaAlertLabel=e,this._lastAriaAlertLabel&&y.alert(this._lastAriaAlertLabel,!0))},e.prototype.onThemeChange=function(e){var i=e.getColor(t.editorSuggestWidgetBackground);i&&(this.listElement.style.backgroundColor=i.toString(),this.details.element.style.backgroundColor=i.toString(),this.messageElement.style.backgroundColor=i.toString());var n=e.getColor(t.editorSuggestWidgetBorder);n&&(this.listElement.style.borderColor=n.toString(),this.details.element.style.borderColor=n.toString(),this.messageElement.style.borderColor=n.toString(),this.detailsBorderColor=n.toString());var o=e.getColor(w.focusBorder);o&&(this.detailsFocusBorderColor=o.toString()),this.details.setBorderWidth("hc"===e.type?2:1)},e.prototype.onListFocus=function(e){var t=this
;if(!this.ignoreFocusEvents){if(!e.elements.length)return this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null,this.focusedItem=null),void this._ariaAlert(null);if(this.completionModel){var i=e.elements[0],n=e.indexes[0];this.firstFocusInCurrentList=!this.focusedItem,i!==this.focusedItem&&(this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null),this.focusedItem=i,this.list.reveal(n),this.currentSuggestionDetails=I.createCancelablePromise(function(e){return a(t,void 0,void 0,function(){var t,n,o=this;return l(this,function(r){switch(r.label){case 0:return t=I.disposableTimeout(function(){return o.showDetails(!0)},250),e.onCancellationRequested(function(){return t.dispose()}),[4,i.resolve(e)];case 1:return n=r.sent(),t.dispose(),[2,n]}})})}),this.currentSuggestionDetails.then(function(){n>=t.list.length||i!==t.list.element(n)||(t.ignoreFocusEvents=!0,t.list.splice(n,1,[i]),t.list.setFocus([n]),
t.ignoreFocusEvents=!1,t.expandDocsSettingFromStorage()?t.showDetails(!1):p.removeClass(t.element,"docs-side"),t._ariaAlert(t._getSuggestionAriaAlertLabel(i)))}).catch(u.onUnexpectedError)),this.onDidFocusEmitter.fire({item:i,index:n,model:this.completionModel})}}},e.prototype.setState=function(t){if(this.element){var i=this.state!==t;switch(this.state=t,p.toggleClass(this.element,"frozen",4===t),t){case 0:p.hide(this.messageElement,this.details.element,this.listElement),this.hide(),this.listHeight=0,i&&this.list.splice(0,this.list.length),this.focusedItem=null;break;case 1:this.messageElement.textContent=e.LOADING_MESSAGE,p.hide(this.listElement,this.details.element),p.show(this.messageElement),p.removeClass(this.element,"docs-side"),this.show(),this.focusedItem=null;break;case 2:this.messageElement.textContent=e.NO_SUGGESTIONS_MESSAGE,p.hide(this.listElement,this.details.element),p.show(this.messageElement),p.removeClass(this.element,"docs-side"),this.show(),this.focusedItem=null;break;case 3:case 4:
p.hide(this.messageElement),p.show(this.listElement),this.show();break;case 5:p.hide(this.messageElement),p.show(this.details.element,this.listElement),this.show(),this._ariaAlert(this.details.getAriaLabel())}}},e.prototype.showTriggered=function(e,t){var i=this;0===this.state&&(this.isAuto=!!e,this.isAuto||(this.loadingTimeout=I.disposableTimeout(function(){return i.setState(1)},t)))},e.prototype.showSuggestions=function(e,t,i,n){if(this.preferDocPositionTop=!1,this.docsPositionPreviousWidgetY=null,this.loadingTimeout.dispose(),this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null),this.completionModel!==e&&(this.completionModel=e),i&&2!==this.state&&0!==this.state)this.setState(4);else{var o=this.completionModel.items.length,r=0===o;if(this.suggestWidgetMultipleSuggestions.set(o>1),r)n?this.setState(0):this.setState(2),this.completionModel=null;else{if(3!==this.state){var a=this.completionModel.stats;a.wasAutomaticallyTriggered=!!n,
this.telemetryService.publicLog("suggestWidget",s({},a))}this.focusedItem=null,this.list.splice(0,this.list.length,this.completionModel.items),i?this.setState(4):this.setState(3),this.list.reveal(t,0),this.list.setFocus([t]),this.detailsBorderColor&&(this.details.element.style.borderColor=this.detailsBorderColor)}}},e.prototype.selectNextPage=function(){switch(this.state){case 0:return!1;case 5:return this.details.pageDown(),!0;case 1:return!this.isAuto;default:return this.list.focusNextPage(),!0}},e.prototype.selectNext=function(){switch(this.state){case 0:return!1;case 1:return!this.isAuto;default:return this.list.focusNext(1,!0),!0}},e.prototype.selectLast=function(){switch(this.state){case 0:return!1;case 5:return this.details.scrollBottom(),!0;case 1:return!this.isAuto;default:return this.list.focusLast(),!0}},e.prototype.selectPreviousPage=function(){switch(this.state){case 0:return!1;case 5:return this.details.pageUp(),!0;case 1:return!this.isAuto;default:return this.list.focusPreviousPage(),!0}},
e.prototype.selectPrevious=function(){switch(this.state){case 0:return!1;case 1:return!this.isAuto;default:return this.list.focusPrevious(1,!0),!1}},e.prototype.selectFirst=function(){switch(this.state){case 0:return!1;case 5:return this.details.scrollTop(),!0;case 1:return!this.isAuto;default:return this.list.focusFirst(),!0}},e.prototype.getFocusedItem=function(){if(0!==this.state&&2!==this.state&&1!==this.state&&this.completionModel)return{item:this.list.getFocusedElements()[0],index:this.list.getFocus()[0],model:this.completionModel}},e.prototype.toggleDetailsFocus=function(){5===this.state?(this.setState(3),this.detailsBorderColor&&(this.details.element.style.borderColor=this.detailsBorderColor)):3===this.state&&this.expandDocsSettingFromStorage()&&(this.setState(5),this.detailsFocusBorderColor&&(this.details.element.style.borderColor=this.detailsFocusBorderColor)),this.telemetryService.publicLog2("suggestWidget:toggleDetailsFocus")},e.prototype.toggleDetails=function(){
if(W(this.list.getFocusedElements()[0]))if(this.expandDocsSettingFromStorage())this.updateExpandDocsSetting(!1),p.hide(this.details.element),p.removeClass(this.element,"docs-side"),p.removeClass(this.element,"docs-below"),this.editor.layoutContentWidget(this),this.telemetryService.publicLog2("suggestWidget:collapseDetails");else{if(3!==this.state&&5!==this.state&&4!==this.state)return;this.updateExpandDocsSetting(!0),this.showDetails(!1),this._ariaAlert(this.details.getAriaLabel()),this.telemetryService.publicLog2("suggestWidget:expandDetails")}},e.prototype.showDetails=function(e){this.expandSideOrBelow(),p.show(this.details.element),this.details.element.style.maxHeight=this.maxWidgetHeight+"px",e?this.details.renderLoading():this.details.renderItem(this.list.getFocusedElements()[0],this.explainMode),this.listElement.style.marginTop="0px",this.editor.layoutContentWidget(this),this.adjustDocsPosition(),this.editor.focus()},e.prototype.toggleExplainMode=function(){
this.list.getFocusedElements()[0]&&this.expandDocsSettingFromStorage()&&(this.explainMode=!this.explainMode,this.showDetails(!1))},e.prototype.show=function(){var e=this,t=this.updateListHeight();t!==this.listHeight&&(this.editor.layoutContentWidget(this),this.listHeight=t),this.suggestWidgetVisible.set(!0),this.showTimeout.cancelAndSet(function(){p.addClass(e.element,"visible"),e.onDidShowEmitter.fire(e)},100)},e.prototype.hide=function(){this.suggestWidgetVisible.reset(),this.suggestWidgetMultipleSuggestions.reset(),p.removeClass(this.element,"visible")},e.prototype.hideWidget=function(){this.loadingTimeout.dispose(),this.setState(0),this.onDidHideEmitter.fire(this)},e.prototype.getPosition=function(){if(0===this.state)return null;var e=[2,1];return this.preferDocPositionTop&&(e=[1]),{position:this.editor.getPosition(),preference:e}},e.prototype.getDomNode=function(){return this.element},e.prototype.getId=function(){return e.ID},e.prototype.updateListHeight=function(){var e=0
;if(2===this.state||1===this.state)e=this.unfocusedHeight;else{var t=this.list.contentHeight/this.unfocusedHeight,i=this.editor.getConfiguration().contribInfo.suggest.maxVisibleSuggestions;e=Math.min(t,i)*this.unfocusedHeight}return this.element.style.lineHeight=this.unfocusedHeight+"px",this.listElement.style.height=e+"px",this.list.layout(e),e},e.prototype.adjustDocsPosition=function(){if(this.editor.hasModel()){var e=this.editor.getConfiguration().fontInfo.lineHeight,t=this.editor.getScrolledVisiblePosition(this.editor.getPosition()),i=p.getDomNodePagePosition(this.editor.getDomNode()),n=i.left+t.left,o=i.top+t.top+t.height,r=p.getDomNodePagePosition(this.element),s=r.left,a=r.top;if(this.docsPositionPreviousWidgetY&&this.docsPositionPreviousWidgetY<a&&!this.preferDocPositionTop)return this.preferDocPositionTop=!0,void this.adjustDocsPosition();this.docsPositionPreviousWidgetY=a,s<n-this.listWidth?p.addClass(this.element,"list-right"):p.removeClass(this.element,"list-right"),
p.hasClass(this.element,"docs-side")&&o-e>a&&this.details.element.offsetHeight>this.listElement.offsetHeight&&(this.listElement.style.marginTop=this.details.element.offsetHeight-this.listElement.offsetHeight+"px")}},e.prototype.expandSideOrBelow=function(){if(!W(this.focusedItem)&&this.firstFocusInCurrentList)return p.removeClass(this.element,"docs-side"),void p.removeClass(this.element,"docs-below");var e=this.element.style.maxWidth.match(/(\d+)px/);!e||Number(e[1])<this.maxWidgetWidth?(p.addClass(this.element,"docs-below"),p.removeClass(this.element,"docs-side")):W(this.focusedItem)&&(p.addClass(this.element,"docs-side"),p.removeClass(this.element,"docs-below"))},Object.defineProperty(e.prototype,"maxWidgetHeight",{get:function(){return this.unfocusedHeight*this.editor.getConfiguration().contribInfo.suggest.maxVisibleSuggestions},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"unfocusedHeight",{get:function(){var e=this.editor.getConfiguration()
;return e.contribInfo.suggestLineHeight||e.fontInfo.lineHeight},enumerable:!0,configurable:!0}),e.prototype.getHeight=function(e){return this.unfocusedHeight},e.prototype.getTemplateId=function(e){return"suggestion"},e.prototype.expandDocsSettingFromStorage=function(){return this.storageService.getBoolean("expandSuggestionDocs",0,!1)},e.prototype.updateExpandDocsSetting=function(e){this.storageService.store("expandSuggestionDocs",e,0)},e.prototype.dispose=function(){this.details.dispose(),this.list.dispose(),this.toDispose.dispose(),this.loadingTimeout.dispose(),this.showTimeout.dispose()},e.ID="editor.widget.suggestWidget",e.LOADING_MESSAGE=i.localize(8,null),e.NO_SUGGESTIONS_MESSAGE=i.localize(9,null),e=d([c(1,b.ITelemetryService),c(2,v.IContextKeyService),c(3,S.IThemeService),c(4,E.IStorageService),c(5,m.IKeybindingService),c(6,x.IModeService),c(7,D.IOpenerService),c(8,O.IInstantiationService)],e)}();t.SuggestWidget=z,S.registerThemingParticipant(function(e,i){
var n=e.getColor(t.editorSuggestWidgetHighlightForeground);n&&i.addRule(".monaco-editor .suggest-widget .monaco-list .monaco-list-row .monaco-highlighted-label .highlight { color: "+n+"; }");var o=e.getColor(t.editorSuggestWidgetForeground);o&&i.addRule(".monaco-editor .suggest-widget { color: "+o+"; }");var r=e.getColor(w.textLinkForeground);r&&i.addRule(".monaco-editor .suggest-widget a { color: "+r+"; }");var s=e.getColor(w.textCodeBlockBackground);s&&i.addRule(".monaco-editor .suggest-widget code { background-color: "+s+"; }")})}),define(t[565],i([1,0,365,19,15,26,10,2,11,3,21,49,30,17,14,22,16]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y){"use strict";function b(e,t,i){var r=m.DocumentHighlightProviderRegistry.ordered(e);return o.first(r.map(function(n){return function(){return Promise.resolve(n.provideDocumentHighlights(e,t,i)).then(void 0,a.onUnexpectedExternalError)}}),n.isNonEmptyArray)}Object.defineProperty(t,"__esModule",{value:!0}),
t.editorWordHighlight=_.registerColor("editor.wordHighlightBackground",{dark:"#575757B8",light:"#57575740",hc:null},i.localize(0,null),!0),t.editorWordHighlightStrong=_.registerColor("editor.wordHighlightStrongBackground",{dark:"#004972B8",light:"#0e639c40",hc:null},i.localize(1,null),!0),t.editorWordHighlightBorder=_.registerColor("editor.wordHighlightBorder",{light:null,dark:null,hc:_.activeContrastBorder},i.localize(2,null)),t.editorWordHighlightStrongBorder=_.registerColor("editor.wordHighlightStrongBorder",{light:null,dark:null,hc:_.activeContrastBorder},i.localize(3,null)),t.overviewRulerWordHighlightForeground=_.registerColor("editorOverviewRuler.wordHighlightForeground",{dark:"#A0A0A0CC",light:"#A0A0A0CC",hc:"#A0A0A0CC"},i.localize(4,null),!0),t.overviewRulerWordHighlightStrongForeground=_.registerColor("editorOverviewRuler.wordHighlightStrongForeground",{dark:"#C0A0C0CC",light:"#C0A0C0CC",hc:"#C0A0C0CC"},i.localize(5,null),!0),t.ctxHasWordHighlights=new v.RawContextKey("hasWordHighlights",!1),
t.getOccurrencesAtPosition=b;var C=function(){function e(e,t,i){var n=this;this._wordRange=this._getCurrentWordRange(e,t),this.result=o.createCancelablePromise(function(o){return n._compute(e,t,i,o)})}return e.prototype._getCurrentWordRange=function(e,t){var i=e.getWordAtPosition(t.getPosition());return i?new h.Range(t.startLineNumber,i.startColumn,t.startLineNumber,i.endColumn):null},e.prototype.isValid=function(e,t,i){for(var n=t.startLineNumber,o=t.startColumn,r=t.endColumn,s=this._getCurrentWordRange(e,t),a=Boolean(this._wordRange&&this._wordRange.equalsRange(s)),l=0,u=i.length;!a&&l<u;l++){var d=e.getDecorationRange(i[l]);d&&d.startLineNumber===n&&d.startColumn<=o&&d.endColumn>=r&&(a=!0)}return a},e.prototype.cancel=function(){this.result.cancel()},e}(),S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._compute=function(e,t,i,n){return b(e,t.getPosition(),n).then(function(e){return e||[]})},t}(C),w=function(e){function t(t,i,n){
var o=e.call(this,t,i,n)||this;return o._selectionIsEmpty=i.isEmpty(),o}return r(t,e),t.prototype._compute=function(e,t,i,n){return o.timeout(250,n).then(function(){if(!t.isEmpty())return[];var n=e.getWordAtPosition(t.getPosition());if(!n)return[];return e.findMatches(n.word,!0,!1,!0,i,!1).map(function(e){return{range:e.range,kind:m.DocumentHighlightKind.Text}})})},t.prototype.isValid=function(t,i,n){var o=i.isEmpty();return this._selectionIsEmpty===o&&e.prototype.isValid.call(this,t,i,n)},t}(C);u.registerDefaultLanguageCommand("_executeDocumentHighlights",function(e,t){return b(e,t,s.CancellationToken.None)});var E=function(){function e(e,i){var n=this;this.toUnhook=new l.DisposableStore,this.workerRequestTokenId=0,this.workerRequestCompleted=!1,this.workerRequestValue=[],this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1,this.editor=e,this._hasWordHighlights=t.ctxHasWordHighlights.bindTo(i),this._ignorePositionChangeEvent=!1,
this.occurrencesHighlight=this.editor.getConfiguration().contribInfo.occurrencesHighlight,this.model=this.editor.getModel(),this.toUnhook.add(e.onDidChangeCursorPosition(function(e){n._ignorePositionChangeEvent||n.occurrencesHighlight&&n._onPositionChanged(e)})),this.toUnhook.add(e.onDidChangeModelContent(function(e){n._stopAll()})),this.toUnhook.add(e.onDidChangeConfiguration(function(e){var t=n.editor.getConfiguration().contribInfo.occurrencesHighlight;n.occurrencesHighlight!==t&&(n.occurrencesHighlight=t,n._stopAll())})),this._decorationIds=[],this.workerRequestTokenId=0,this.workerRequest=null,this.workerRequestCompleted=!1,this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1}return e.prototype.hasDecorations=function(){return this._decorationIds.length>0},e.prototype.restore=function(){this.occurrencesHighlight&&this._run()},e.prototype._getSortedHighlights=function(){var e=this;return n.coalesce(this._decorationIds.map(function(t){return e.model.getDecorationRange(t)
}).sort(h.Range.compareRangesUsingStarts))},e.prototype.moveNext=function(){var e=this,t=this._getSortedHighlights(),i=t[(n.firstIndex(t,function(t){return t.containsPosition(e.editor.getPosition())})+1)%t.length];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(i.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(i)}finally{this._ignorePositionChangeEvent=!1}},e.prototype.moveBack=function(){var e=this,t=this._getSortedHighlights(),i=t[(n.firstIndex(t,function(t){return t.containsPosition(e.editor.getPosition())})-1+t.length)%t.length];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(i.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(i)}finally{this._ignorePositionChangeEvent=!1}},e.prototype._removeDecorations=function(){this._decorationIds.length>0&&(this._decorationIds=this.editor.deltaDecorations(this._decorationIds,[]),this._hasWordHighlights.set(!1))},e.prototype._stopAll=function(){this._removeDecorations(),
-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1),null!==this.workerRequest&&(this.workerRequest.cancel(),this.workerRequest=null),this.workerRequestCompleted||(this.workerRequestTokenId++,this.workerRequestCompleted=!0)},e.prototype._onPositionChanged=function(e){this.occurrencesHighlight&&3===e.reason?this._run():this._stopAll()},e.prototype._run=function(){var e=this,t=this.editor.getSelection();if(t.startLineNumber===t.endLineNumber){var i=t.startLineNumber,n=t.startColumn,o=t.endColumn,r=this.model.getWordAtPosition({lineNumber:i,column:n});if(!r||r.startColumn>n||r.endColumn<o)this._stopAll();else{var s=this.workerRequest&&this.workerRequest.isValid(this.model,t,this._decorationIds);if(this.lastCursorPositionChangeTime=(new Date).getTime(),s)this.workerRequestCompleted&&-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1,this._beginRenderDecorations());else{this._stopAll()
;var l=++this.workerRequestTokenId;this.workerRequestCompleted=!1,this.workerRequest=function(e,t,i){return m.DocumentHighlightProviderRegistry.has(e)?new S(e,t,i):new w(e,t,i)}(this.model,this.editor.getSelection(),this.editor.getConfiguration().wordSeparators),this.workerRequest.result.then(function(t){l===e.workerRequestTokenId&&(e.workerRequestCompleted=!0,e.workerRequestValue=t||[],e._beginRenderDecorations())},a.onUnexpectedError)}}}else this._stopAll()},e.prototype._beginRenderDecorations=function(){var e=this,t=(new Date).getTime(),i=this.lastCursorPositionChangeTime+250;t>=i?(this.renderDecorationsTimer=-1,this.renderDecorations()):this.renderDecorationsTimer=setTimeout(function(){e.renderDecorations()},i-t)},e.prototype.renderDecorations=function(){this.renderDecorationsTimer=-1;for(var t=[],i=0,n=this.workerRequestValue.length;i<n;i++){var o=this.workerRequestValue[i];t.push({range:o.range,options:e._getDecorationOptions(o.kind)})}
this._decorationIds=this.editor.deltaDecorations(this._decorationIds,t),this._hasWordHighlights.set(this.hasDecorations())},e._getDecorationOptions=function(e){return e===m.DocumentHighlightKind.Write?this._WRITE_OPTIONS:e===m.DocumentHighlightKind.Text?this._TEXT_OPTIONS:this._REGULAR_OPTIONS},e.prototype.dispose=function(){this._stopAll(),this.toUnhook.dispose()},e._WRITE_OPTIONS=g.ModelDecorationOptions.register({stickiness:1,className:"wordHighlightStrong",overviewRuler:{color:y.themeColorFromId(t.overviewRulerWordHighlightStrongForeground),position:f.OverviewRulerLane.Center}}),e._TEXT_OPTIONS=g.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight",overviewRuler:{color:y.themeColorFromId(_.overviewRulerSelectionHighlightForeground),position:f.OverviewRulerLane.Center}}),e._REGULAR_OPTIONS=g.ModelDecorationOptions.register({stickiness:1,className:"wordHighlight",overviewRuler:{color:y.themeColorFromId(t.overviewRulerWordHighlightForeground),position:f.OverviewRulerLane.Center}}),e
}(),L=function(e){function t(t,i){var n=e.call(this)||this;n.wordHighligher=null;var o=function(){t.hasModel()&&(n.wordHighligher=new E(t,i))};return n._register(t.onDidChangeModel(function(e){n.wordHighligher&&(n.wordHighligher.dispose(),n.wordHighligher=null),o()})),o(),n}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.saveViewState=function(){return!(!this.wordHighligher||!this.wordHighligher.hasDecorations())},t.prototype.moveNext=function(){this.wordHighligher&&this.wordHighligher.moveNext()},t.prototype.moveBack=function(){this.wordHighligher&&this.wordHighligher.moveBack()},t.prototype.restoreViewState=function(e){this.wordHighligher&&e&&this.wordHighligher.restore()},t.prototype.dispose=function(){this.wordHighligher&&(this.wordHighligher.dispose(),this.wordHighligher=null),e.prototype.dispose.call(this)},t.ID="editor.contrib.wordHighlighter",t=d([c(1,v.IContextKeyService)],t)}(l.Disposable),x=function(e){function t(t,i){
var n=e.call(this,i)||this;return n._isNext=t,n}return r(t,e),t.prototype.run=function(e,t){var i=L.get(t);i&&(this._isNext?i.moveNext():i.moveBack())},t}(u.EditorAction),D=function(e){function n(){return e.call(this,!0,{id:"editor.action.wordHighlight.next",label:i.localize(6,null),alias:"Go to Next Symbol Highlight",precondition:t.ctxHasWordHighlights,kbOpts:{kbExpr:p.EditorContextKeys.editorTextFocus,primary:65,weight:100}})||this}return r(n,e),n}(x),I=function(e){function n(){return e.call(this,!1,{id:"editor.action.wordHighlight.prev",label:i.localize(7,null),alias:"Go to Previous Symbol Highlight",precondition:t.ctxHasWordHighlights,kbOpts:{kbExpr:p.EditorContextKeys.editorTextFocus,primary:1089,weight:100}})||this}return r(n,e),n}(x),N=function(e){function n(){return e.call(this,{id:"editor.action.wordHighlight.trigger",label:i.localize(8,null),alias:"Trigger Symbol Highlight",precondition:t.ctxHasWordHighlights.toNegated(),kbOpts:{kbExpr:p.EditorContextKeys.editorTextFocus,primary:0,weight:100}
})||this}return r(n,e),n.prototype.run=function(e,t,i){var n=L.get(t);n&&n.restoreViewState(!0)},n}(u.EditorAction);u.registerEditorContribution(L),u.registerEditorAction(D),u.registerEditorAction(I),u.registerEditorAction(N),y.registerThemingParticipant(function(e,i){var n=e.getColor(_.editorSelectionHighlight);n&&(i.addRule(".monaco-editor .focused .selectionHighlight { background-color: "+n+"; }"),i.addRule(".monaco-editor .selectionHighlight { background-color: "+n.transparent(.5)+"; }"));var o=e.getColor(t.editorWordHighlight);o&&i.addRule(".monaco-editor .wordHighlight { background-color: "+o+"; }");var r=e.getColor(t.editorWordHighlightStrong);r&&i.addRule(".monaco-editor .wordHighlightStrong { background-color: "+r+"; }");var s=e.getColor(_.editorSelectionHighlightBorder);s&&i.addRule(".monaco-editor .selectionHighlight { border: 1px "+("hc"===e.type?"dotted":"solid")+" "+s+"; box-sizing: border-box; }");var a=e.getColor(t.editorWordHighlightBorder)
;a&&i.addRule(".monaco-editor .wordHighlight { border: 1px "+("hc"===e.type?"dashed":"solid")+" "+a+"; box-sizing: border-box; }");var l=e.getColor(t.editorWordHighlightStrongBorder);l&&i.addRule(".monaco-editor .wordHighlightStrong { border: 1px "+("hc"===e.type?"dashed":"solid")+" "+l+"; box-sizing: border-box; }")})}),define(t[566],i([1,0,28,8,27,116,43,45,2,18,5,24,11,21,212,14,12,33,55,22,16,56,266]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var L=new _.RawContextKey("accessibilityHelpWidgetVisible",!1),x=function(e){function t(t,i){var n=e.call(this)||this;return n._editor=t,n._widget=n._register(i.createInstance(D,n._editor)),n}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.show=function(){this._widget.show()},t.prototype.hide=function(){this._widget.hide()},t.ID="editor.contrib.accessibilityHelpController",t=d([c(1,y.IInstantiationService)],t)
}(u.Disposable),D=function(e){function t(t,i,r,s){var l=e.call(this)||this;return l._contextKeyService=i,l._keybindingService=r,l._openerService=s,l._editor=t,l._isVisibleKey=L.bindTo(l._contextKeyService),l._domNode=o.createFastDomNode(document.createElement("div")),l._domNode.setClassName("accessibilityHelpWidget"),l._domNode.setDisplay("none"),l._domNode.setAttribute("role","dialog"),l._domNode.setAttribute("aria-hidden","true"),l._contentDomNode=o.createFastDomNode(document.createElement("div")),l._contentDomNode.setAttribute("role","document"),l._domNode.appendChild(l._contentDomNode),l._isVisible=!1,l._register(l._editor.onDidLayoutChange(function(){l._isVisible&&l._layout()})),l._register(n.addStandardDisposableListener(l._contentDomNode.domNode,"keydown",function(e){if(l._isVisible&&(e.equals(2083)&&(a.alert(E.AccessibilityHelpNLS.emergencyConfOn),l._editor.updateOptions({accessibilitySupport:"on"}),n.clearNode(l._contentDomNode.domNode),l._buildContent(),l._contentDomNode.domNode.focus(),
e.preventDefault(),e.stopPropagation()),e.equals(2086))){a.alert(E.AccessibilityHelpNLS.openingDocs);var t=l._editor.getRawConfiguration().accessibilityHelpUrl;void 0===t&&(t="https://go.microsoft.com/fwlink/?linkid=852450"),l._openerService.open(f.URI.parse(t)),e.preventDefault(),e.stopPropagation()}})),l.onblur(l._contentDomNode.domNode,function(){l.hide()}),l._editor.addOverlayWidget(l),l}return r(t,e),t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),e.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.getPosition=function(){return{preference:null}},t.prototype.show=function(){this._isVisible||(this._isVisible=!0,this._isVisibleKey.set(!0),this._layout(),this._domNode.setDisplay("block"),this._domNode.setAttribute("aria-hidden","false"),this._contentDomNode.domNode.tabIndex=0,this._buildContent(),this._contentDomNode.domNode.focus())},t.prototype._descriptionForCommand=function(e,t,i){
var n=this._keybindingService.lookupKeybinding(e);return n?p.format(t,n.getAriaLabel()):p.format(i,e)},t.prototype._buildContent=function(){var e=this._editor.getConfiguration(),t=this._editor.getSelections(),i=0;if(t){var n=this._editor.getModel();n&&t.forEach(function(e){i+=n.getValueLengthInRange(e)})}var o=function(e,t){return e&&0!==e.length?1===e.length?t?p.format(E.AccessibilityHelpNLS.singleSelectionRange,e[0].positionLineNumber,e[0].positionColumn,t):p.format(E.AccessibilityHelpNLS.singleSelection,e[0].positionLineNumber,e[0].positionColumn):t?p.format(E.AccessibilityHelpNLS.multiSelectionRange,e.length,t):e.length>0?p.format(E.AccessibilityHelpNLS.multiSelection,e.length):"":E.AccessibilityHelpNLS.noSelection}(t,i);e.wrappingInfo.inDiffEditor?e.readOnly?o+=E.AccessibilityHelpNLS.readonlyDiffEditor:o+=E.AccessibilityHelpNLS.editableDiffEditor:e.readOnly?o+=E.AccessibilityHelpNLS.readonlyEditor:o+=E.AccessibilityHelpNLS.editableEditor
;var r=h.isMacintosh?E.AccessibilityHelpNLS.changeConfigToOnMac:E.AccessibilityHelpNLS.changeConfigToOnWinLinux;switch(e.accessibilitySupport){case 0:o+="\n\n - "+r;break;case 2:o+="\n\n - "+E.AccessibilityHelpNLS.auto_on;break;case 1:o+="\n\n - "+E.AccessibilityHelpNLS.auto_off,o+=" "+r}e.tabFocusMode?o+="\n\n - "+this._descriptionForCommand(v.ToggleTabFocusModeAction.ID,E.AccessibilityHelpNLS.tabFocusModeOnMsg,E.AccessibilityHelpNLS.tabFocusModeOnMsgNoKb):o+="\n\n - "+this._descriptionForCommand(v.ToggleTabFocusModeAction.ID,E.AccessibilityHelpNLS.tabFocusModeOffMsg,E.AccessibilityHelpNLS.tabFocusModeOffMsgNoKb);o+="\n\n - "+(h.isMacintosh?E.AccessibilityHelpNLS.openDocMac:E.AccessibilityHelpNLS.openDocWinLinux),o+="\n\n"+E.AccessibilityHelpNLS.outroMsg,this._contentDomNode.domNode.appendChild(s.renderFormattedText(o)),this._contentDomNode.domNode.setAttribute("aria-label",o)},t.prototype.hide=function(){this._isVisible&&(this._isVisible=!1,this._isVisibleKey.reset(),this._domNode.setDisplay("none"),
this._domNode.setAttribute("aria-hidden","true"),this._contentDomNode.domNode.tabIndex=-1,n.clearNode(this._contentDomNode.domNode),this._editor.focus())},t.prototype._layout=function(){var e=this._editor.getLayoutInfo(),i=Math.max(5,Math.min(t.WIDTH,e.width-40)),n=Math.max(5,Math.min(t.HEIGHT,e.height-40));this._domNode.setWidth(i),this._domNode.setHeight(n);var o=Math.round((e.height-n)/2);this._domNode.setTop(o);var r=Math.round((e.width-i)/2);this._domNode.setLeft(r)},t.ID="editor.contrib.accessibilityHelpWidget",t.WIDTH=500,t.HEIGHT=300,t=d([c(1,_.IContextKeyService),c(2,b.IKeybindingService),c(3,C.IOpenerService)],t)}(l.Widget),I=function(e){function t(){return e.call(this,{id:"editor.action.showAccessibilityHelp",label:E.AccessibilityHelpNLS.showAccessibilityHelpAction,alias:"Show Accessibility Help",precondition:void 0,kbOpts:{kbExpr:m.EditorContextKeys.focus,primary:i.isIE?2107:571,weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=x.get(t);i&&i.show()},t}(g.EditorAction)
;g.registerEditorContribution(x),g.registerEditorAction(I);var N=g.EditorCommand.bindToContribution(x.get);g.registerEditorCommand(new N({id:"closeAccessibilityHelp",precondition:L,handler:function(e){return e.hide()},kbOpts:{weight:200,kbExpr:m.EditorContextKeys.focus,primary:9,secondary:[1033]}})),w.registerThemingParticipant(function(e,t){var i=e.getColor(S.editorWidgetBackground);i&&t.addRule(".monaco-editor .accessibilityHelpWidget { background-color: "+i+"; }");var n=e.getColor(S.editorWidgetForeground);n&&t.addRule(".monaco-editor .accessibilityHelpWidget { color: "+n+"; }");var o=e.getColor(S.widgetShadow);o&&t.addRule(".monaco-editor .accessibilityHelpWidget { box-shadow: 0 2px 8px "+o+"; }");var r=e.getColor(S.contrastBorder);r&&t.addRule(".monaco-editor .accessibilityHelpWidget { border: 2px solid "+r+"; }")})}),define(t[567],i([1,0,25,2,5,11,17,63,70,91,22,16,56,260]),function(e,t,i,n,o,s,a,l,u,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var m=function(e){
function t(t,i,n){var o=e.call(this)||this;return o._editor=t,o._modeService=n,o._widget=null,o._register(o._editor.onDidChangeModel(function(e){return o.stop()})),o._register(o._editor.onDidChangeModelLanguage(function(e){return o.stop()})),o._register(a.TokenizationRegistry.onDidChange(function(e){return o.stop()})),o}return r(t,e),t.get=function(e){return e.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.dispose=function(){this.stop(),e.prototype.dispose.call(this)},t.prototype.launch=function(){this._widget||this._editor.hasModel()&&(this._widget=new _(this._editor,this._modeService))},t.prototype.stop=function(){this._widget&&(this._widget.dispose(),this._widget=null)},t.ID="editor.contrib.inspectTokens",t=d([c(1,h.IStandaloneThemeService),c(2,u.IModeService)],t)}(n.Disposable),v=function(e){function t(){return e.call(this,{id:"editor.action.inspectTokens",label:g.InspectTokensNLS.inspectTokensAction,alias:"Developer: Inspect Tokens",precondition:void 0})||this}return r(t,e),
t.prototype.run=function(e,t){var i=m.get(t);i&&i.launch()},t}(s.EditorAction),_=function(e){function t(t,i){var n=e.call(this)||this;return n.allowEditorOverflow=!0,n._editor=t,n._modeService=i,n._model=n._editor.getModel(),n._domNode=document.createElement("div"),n._domNode.className="tokens-inspect-widget",n._tokenizationSupport=function(e){var t=a.TokenizationRegistry.get(e.language);return t||{getInitialState:function(){return l.NULL_STATE},tokenize:function(t,i,n){return l.nullTokenize(e.language,t,i,n)},tokenize2:function(t,i,n){return l.nullTokenize2(e.id,t,i,n)}}}(n._model.getLanguageIdentifier()),n._compute(n._editor.getPosition()),n._register(n._editor.onDidChangeCursorPosition(function(e){return n._compute(n._editor.getPosition())})),n._editor.addContentWidget(n),n}return r(t,e),t.prototype.dispose=function(){this._editor.removeContentWidget(this),e.prototype.dispose.call(this)},t.prototype.getId=function(){return t._ID},t.prototype._compute=function(e){
for(var t=this._getTokensAtLine(e.lineNumber),n=0,r=t.tokens1.length-1;r>=0;r--){var s=t.tokens1[r];if(e.column-1>=s.offset){n=r;break}}for(var a=0,r=t.tokens2.length>>>1;r>=0;r--)if(e.column-1>=t.tokens2[r<<1]){a=r;break}var l="",u=this._model.getLineContent(e.lineNumber),d="";if(n<t.tokens1.length){var c=t.tokens1[n].offset,h=n+1<t.tokens1.length?t.tokens1[n+1].offset:u.length;d=u.substring(c,h)}l+='<h2 class="tm-token">'+function(e){for(var t="",i=0,n=e.length;i<n;i++){var o=e.charCodeAt(i);switch(o){case 9:t+="&rarr;";break;case 32:t+="&middot;";break;case 60:t+="&lt;";break;case 62:t+="&gt;";break;case 38:t+="&amp;";break;default:t+=String.fromCharCode(o)}}return t}(d)+'<span class="tm-token-length">('+d.length+" "+(1===d.length?"char":"chars")+")</span></h2>",l+='<hr class="tokens-inspect-separator" style="clear:both"/>';var p=this._decodeMetadata(t.tokens2[1+(a<<1)]);l+='<table class="tm-metadata-table"><tbody>',
l+='<tr><td class="tm-metadata-key">language</td><td class="tm-metadata-value">'+o.escape(p.languageIdentifier.language)+"</td>",l+='<tr><td class="tm-metadata-key">token type</td><td class="tm-metadata-value">'+this._tokenTypeToString(p.tokenType)+"</td>",l+='<tr><td class="tm-metadata-key">font style</td><td class="tm-metadata-value">'+this._fontStyleToString(p.fontStyle)+"</td>",l+='<tr><td class="tm-metadata-key">foreground</td><td class="tm-metadata-value">'+i.Color.Format.CSS.formatHex(p.foreground)+"</td>",l+='<tr><td class="tm-metadata-key">background</td><td class="tm-metadata-value">'+i.Color.Format.CSS.formatHex(p.background)+"</td>",l+="</tbody></table>",l+='<hr class="tokens-inspect-separator"/>',n<t.tokens1.length&&(l+='<span class="tm-token-type">'+o.escape(t.tokens1[n].type)+"</span>"),this._domNode.innerHTML=l,this._editor.layoutContentWidget(this)},t.prototype._decodeMetadata=function(e){
var t=a.TokenizationRegistry.getColorMap(),i=a.TokenMetadata.getLanguageId(e),n=a.TokenMetadata.getTokenType(e),o=a.TokenMetadata.getFontStyle(e),r=a.TokenMetadata.getForeground(e),s=a.TokenMetadata.getBackground(e);return{languageIdentifier:this._modeService.getLanguageIdentifier(i),tokenType:n,fontStyle:o,foreground:t[r],background:t[s]}},t.prototype._tokenTypeToString=function(e){switch(e){case 0:return"Other";case 1:return"Comment";case 2:return"String";case 4:return"RegEx"}return"??"},t.prototype._fontStyleToString=function(e){var t="";return 1&e&&(t+="italic "),2&e&&(t+="bold "),4&e&&(t+="underline "),0===t.length&&(t="---"),t},t.prototype._getTokensAtLine=function(e){var t=this._getStateBeforeLine(e),i=this._tokenizationSupport.tokenize(this._model.getLineContent(e),t,0),n=this._tokenizationSupport.tokenize2(this._model.getLineContent(e),t,0);return{startState:t,tokens1:i.tokens,tokens2:n.tokens,endState:i.endState}},t.prototype._getStateBeforeLine=function(e){
for(var t=this._tokenizationSupport.getInitialState(),i=1;i<e;i++){t=this._tokenizationSupport.tokenize(this._model.getLineContent(i),t,0).endState}return t},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return{position:this._editor.getPosition(),preference:[2,1]}},t._ID="editor.contrib.inspectTokensWidget",t}(n.Disposable);s.registerEditorContribution(m),s.registerEditorAction(v),f.registerThemingParticipant(function(e,t){var i=e.getColor(p.editorHoverBorder);if(i){var n=e.type===f.HIGH_CONTRAST?2:1;t.addRule(".monaco-editor .tokens-inspect-widget { border: "+n+"px solid "+i+"; }"),t.addRule(".monaco-editor .tokens-inspect-widget .tokens-inspect-separator { background-color: "+i+"; }")}var o=e.getColor(p.editorHoverBackground);o&&t.addRule(".monaco-editor .tokens-inspect-widget { background-color: "+o+"; }")})}),define(t[142],i([1,0,11,30,514,16,259]),function(e,t,i,n,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a=function(){
function e(e,t){this.themeService=t,this.widget=null,this.rangeHighlightDecorationId=null,this.lastKnownEditorSelection=null,this.editor=e}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.widget&&(this.widget.destroy(),this.widget=null)},e.prototype.run=function(e){var t=this;this.widget&&(this.widget.destroy(),this.widget=null);var i=function(e){t.clearDecorations(),e&&t.lastKnownEditorSelection&&(t.editor.setSelection(t.lastKnownEditorSelection),t.editor.revealRangeInCenterIfOutsideViewport(t.lastKnownEditorSelection,0)),t.lastKnownEditorSelection=null,document.activeElement!==document.body&&e||t.editor.focus()};this.widget=new o.QuickOpenEditorWidget(this.editor,function(){return i(!1)},function(){return i(!0)},function(i){t.widget.setInput(e.getModel(i),e.getAutoFocus(i))},{inputAriaLabel:e.inputAriaLabel},this.themeService),this.lastKnownEditorSelection||(this.lastKnownEditorSelection=this.editor.getSelection()),
this.widget.show("")},e.prototype.decorateLine=function(t,i){var n=[];this.rangeHighlightDecorationId&&(n.push(this.rangeHighlightDecorationId),this.rangeHighlightDecorationId=null);var o=[{range:t,options:e._RANGE_HIGHLIGHT_DECORATION}],r=i.deltaDecorations(n,o);this.rangeHighlightDecorationId=r[0]},e.prototype.clearDecorations=function(){this.rangeHighlightDecorationId&&(this.editor.deltaDecorations([this.rangeHighlightDecorationId],[]),this.rangeHighlightDecorationId=null)},e.ID="editor.controller.quickOpenController",e._RANGE_HIGHLIGHT_DECORATION=n.ModelDecorationOptions.register({className:"rangeHighlight",isWholeLine:!0}),e=d([c(1,s.IThemeService)],e)}();t.QuickOpenController=a;var l=function(e){function t(t,i){var n=e.call(this,i)||this;return n._inputAriaLabel=t,n}return r(t,e),t.prototype.getController=function(e){return a.get(e)},t.prototype._show=function(e,t){e.run({inputAriaLabel:this._inputAriaLabel,getModel:function(e){return t.getModel(e)},getAutoFocus:function(e){return t.getAutoFocus(e)}})},
t}(i.EditorAction);t.BaseEditorQuickOpenAction=l,i.registerEditorContribution(a)}),define(t[569],i([1,0,5,119,101,11,13,3,21,142,56,258]),function(e,t,i,n,o,s,a,l,u,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var h=function(e){function t(t,i,n){var o=e.call(this)||this;return o.editor=i,o.decorator=n,o.parseResult=o.parseInput(t),o}return r(t,e),t.prototype.parseInput=function(e){var t,n=e.split(",").map(function(e){return parseInt(e,10)}).filter(function(e){return!isNaN(e)});t=0===n.length?new a.Position(-1,-1):1===n.length?new a.Position(n[0],1):new a.Position(n[0],n[1]);var r;if(o.isCodeEditor(this.editor))r=this.editor.getModel();else{var s=this.editor.getModel();r=s?s.modified:null}var l,u=!!r&&r.validatePosition(t).equals(t)
;return l=u?t.column&&t.column>1?i.format(c.GoToLineNLS.gotoLineLabelValidLineAndColumn,t.lineNumber,t.column):i.format(c.GoToLineNLS.gotoLineLabelValidLine,t.lineNumber):t.lineNumber<1||t.lineNumber>(r?r.getLineCount():0)?i.format(c.GoToLineNLS.gotoLineLabelEmptyWithLineLimit,r?r.getLineCount():0):i.format(c.GoToLineNLS.gotoLineLabelEmptyWithLineAndColumnLimit,r?r.getLineMaxColumn(t.lineNumber):0),{position:t,isValid:u,label:l}},t.prototype.getLabel=function(){return this.parseResult.label},t.prototype.getAriaLabel=function(){var e=this.editor.getPosition(),t=e?e.lineNumber:0;return i.format(c.GoToLineNLS.gotoLineAriaLabel,t,this.parseResult.label)},t.prototype.run=function(e,t){return 1===e?this.runOpen():this.runPreview()},t.prototype.runOpen=function(){if(!this.parseResult.isValid)return!1;var e=this.toSelection();return this.editor.setSelection(e),this.editor.revealRangeInCenter(e,0),this.editor.focus(),!0},t.prototype.runPreview=function(){
if(!this.parseResult.isValid)return this.decorator.clearDecorations(),!1;var e=this.toSelection();return this.editor.revealRangeInCenter(e,0),this.decorator.decorateLine(e,this.editor),!1},t.prototype.toSelection=function(){return new l.Range(this.parseResult.position.lineNumber,this.parseResult.position.column,this.parseResult.position.lineNumber,this.parseResult.position.column)},t}(n.QuickOpenEntry);t.GotoLineEntry=h;var p=function(e){function t(){return e.call(this,c.GoToLineNLS.gotoLineActionInput,{id:"editor.action.gotoLine",label:c.GoToLineNLS.gotoLineActionLabel,alias:"Go to Line...",precondition:void 0,kbOpts:{kbExpr:u.EditorContextKeys.focus,primary:2085,mac:{primary:293},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=this;this._show(this.getController(t),{getModel:function(e){return new n.QuickOpenModel([new h(e,t,i.getController(t))])},getAutoFocus:function(e){return{autoFocusFirstEntry:e.length>0}}})},t}(d.BaseEditorQuickOpenAction);t.GotoLineAction=p,
s.registerEditorAction(p)}),define(t[570],i([1,0,5,28,10,64,119,11,21,142,33,56]),function(e,t,i,n,o,s,a,l,u,d,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(e){function t(t,i,n,o,r){var s=e.call(this)||this;return s.key=t,s.keyAriaLabel=i,s.setHighlights(n),s.action=o,s.editor=r,s}return r(t,e),t.prototype.getLabel=function(){return this.action.label},t.prototype.getAriaLabel=function(){return this.keyAriaLabel?i.format(h.QuickCommandNLS.ariaLabelEntryWithKey,this.getLabel(),this.keyAriaLabel):i.format(h.QuickCommandNLS.ariaLabelEntry,this.getLabel())},t.prototype.getGroupLabel=function(){return this.key},t.prototype.run=function(e,t){var i=this;return 1===e&&(setTimeout(function(){i.editor.focus();try{(i.action.run()||Promise.resolve()).then(void 0,o.onUnexpectedError)}catch(e){o.onUnexpectedError(e)}},50),!0)},t}(a.QuickOpenEntryGroup);t.EditorActionCommandEntry=p;var f=function(e){function t(){return e.call(this,h.QuickCommandNLS.quickCommandActionInput,{
id:"editor.action.quickCommand",label:h.QuickCommandNLS.quickCommandActionLabel,alias:"Command Palette",precondition:void 0,kbOpts:{kbExpr:u.EditorContextKeys.focus,primary:n.isIE?571:59,weight:100},menuOpts:{group:"z_commands",order:1}})||this}return r(t,e),t.prototype.run=function(e,t){var i=this,n=e.get(c.IKeybindingService);this._show(this.getController(t),{getModel:function(e){return new a.QuickOpenModel(i._editorActionsToEntries(n,t,e))},getAutoFocus:function(e){return{autoFocusFirstEntry:!0,autoFocusPrefixMatch:e}}})},t.prototype._sort=function(e,t){var i=(e.getLabel()||"").toLowerCase(),n=(t.getLabel()||"").toLowerCase();return i.localeCompare(n)},t.prototype._editorActionsToEntries=function(e,t,i){for(var n=[],o=0,r=t.getSupportedActions();o<r.length;o++){var a=r[o],l=e.lookupKeybinding(a.id);if(a.label){var u=s.matchesFuzzy(i,a.label);u&&n.push(new p(l?l.getLabel()||"":"",l?l.getAriaLabel()||"":"",u,a,t))}}return n=n.sort(this._sort)},t}(d.BaseEditorQuickOpenAction);t.QuickCommandAction=f,
l.registerEditorAction(f)}),define(t[571],i([1,0,26,64,5,119,11,3,21,17,502,142,56,247]),function(e,t,i,n,o,s,a,l,u,d,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var f=function(e){function t(t,i,n,o,r,s,a){var l=e.call(this)||this;return l.name=t,l.type=i,l.description=n,l.range=o,l.setHighlights(r),l.editor=s,l.decorator=a,l}return r(t,e),t.prototype.getLabel=function(){return this.name},t.prototype.getAriaLabel=function(){return o.format(p.QuickOutlineNLS.entryAriaLabel,this.name)},t.prototype.getIcon=function(){return this.type},t.prototype.getDescription=function(){return this.description},t.prototype.getType=function(){return this.type},t.prototype.getRange=function(){return this.range},t.prototype.run=function(e,t){return 1===e?this.runOpen(t):this.runPreview()},t.prototype.runOpen=function(e){var t=this.toSelection();return this.editor.setSelection(t),this.editor.revealRangeInCenter(t,0),this.editor.focus(),!0},t.prototype.runPreview=function(){var e=this.toSelection()
;return this.editor.revealRangeInCenter(e,0),this.decorator.decorateLine(this.range,this.editor),!1},t.prototype.toSelection=function(){return new l.Range(this.range.startLineNumber,this.range.startColumn||1,this.range.startLineNumber,this.range.startColumn||1)},t}(s.QuickOpenEntryGroup);t.SymbolEntry=f;var g=function(e){function t(){return e.call(this,p.QuickOutlineNLS.quickOutlineActionInput,{id:"editor.action.quickOutline",label:p.QuickOutlineNLS.quickOutlineActionLabel,alias:"Go to Symbol...",precondition:u.EditorContextKeys.hasDocumentSymbolProvider,kbOpts:{kbExpr:u.EditorContextKeys.focus,primary:3117,weight:100},menuOpts:{group:"navigation",order:3}})||this}return r(t,e),t.prototype.run=function(e,t){var n=this;if(t.hasModel()){var o=t.getModel();if(d.DocumentSymbolProviderRegistry.has(o))return c.getDocumentSymbols(o,!0,i.CancellationToken.None).then(function(e){0!==e.length&&n._run(t,e)})}},t.prototype._run=function(e,t){var i=this;this._show(this.getController(e),{getModel:function(n){
return new s.QuickOpenModel(i.toQuickOpenEntries(e,t,n))},getAutoFocus:function(e){return 0===e.indexOf(":")&&(e=e.substr(":".length)),{autoFocusPrefixMatch:e,autoFocusFirstEntry:!!e}}})},t.prototype.symbolEntry=function(e,t,i,n,o,r,s){return new f(e,t,i,l.Range.lift(n),o,r,s)},t.prototype.toQuickOpenEntries=function(e,t,i){var r=this.getController(e),s=[],a=i;0===i.indexOf(":")&&(a=a.substr(":".length));for(var l=0,u=t;l<u.length;l++){var c=u[l],h=o.trim(c.name),f=n.matchesFuzzy(a,h);if(f){var g=void 0;c.containerName&&(g=c.containerName),s.push(this.symbolEntry(h,d.symbolKindToCssClass(c.kind),g,c.range,f,e,r))}}if(i&&(s=0===i.indexOf(":")?s.sort(this.sortScoped.bind(this,i.toLowerCase())):s.sort(this.sortNormal.bind(this,i.toLowerCase()))),s.length>0&&0===i.indexOf(":")){for(var m=null,v=null,_=0,y=0;y<s.length;y++){var b=s[y];m!==b.getType()?(v&&v.setGroupLabel(this.typeToLabel(m||"",_)),m=b.getType(),v=b,_=1,b.setShowBorder(y>0)):_++}v&&v.setGroupLabel(this.typeToLabel(m||"",_))
}else s.length>0&&s[0].setGroupLabel(o.format(p.QuickOutlineNLS._symbols_,s.length));return s},t.prototype.typeToLabel=function(e,t){switch(e){case"module":return o.format(p.QuickOutlineNLS._modules_,t);case"class":return o.format(p.QuickOutlineNLS._class_,t);case"interface":return o.format(p.QuickOutlineNLS._interface_,t);case"method":return o.format(p.QuickOutlineNLS._method_,t);case"function":return o.format(p.QuickOutlineNLS._function_,t);case"property":return o.format(p.QuickOutlineNLS._property_,t);case"variable":return o.format(p.QuickOutlineNLS._variable_,t);case"var":return o.format(p.QuickOutlineNLS._variable2_,t);case"constructor":return o.format(p.QuickOutlineNLS._constructor_,t);case"call":return o.format(p.QuickOutlineNLS._call_,t)}return e},t.prototype.sortNormal=function(e,t,i){var n=t.getLabel().toLowerCase(),o=i.getLabel().toLowerCase(),r=n.localeCompare(o);if(0!==r)return r;var s=t.getRange(),a=i.getRange();return s.startLineNumber-a.startLineNumber},t.prototype.sortScoped=function(e,t,i){
e=e.substr(":".length);var n=t.getType(),o=i.getType(),r=n.localeCompare(o);if(0!==r)return r;if(e){var s=t.getLabel().toLowerCase(),a=i.getLabel().toLowerCase(),l=s.localeCompare(a);if(0!==l)return l}var u=t.getRange(),d=i.getRange();return u.startLineNumber-d.startLineNumber},t}(h.BaseEditorQuickOpenAction);t.QuickOutlineAction=g,a.registerEditorAction(g)}),define(t[572],i([1,0,8,50,517]),function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.getActiveCodeEditor=function(){return null},t.prototype.openCodeEditor=function(e,t,i){return t?Promise.resolve(this.doOpenEditor(t,e)):Promise.resolve(null)},t.prototype.doOpenEditor=function(e,t){if(!this.findModel(e,t.resource)){if(t.resource){var o=t.resource.scheme;if(o===n.Schemas.http||o===n.Schemas.https)return i.windowOpenNoOpener(t.resource.toString()),e}return null}var r=t.options?t.options.selection:null
;if(r)if("number"==typeof r.endLineNumber&&"number"==typeof r.endColumn)e.setSelection(r),e.revealRangeInCenter(r,1);else{var s={lineNumber:r.startLineNumber,column:r.startColumn};e.setPosition(s),e.revealPositionInCenter(s,1)}return e},t.prototype.findModel=function(e,t){var i=e.getModel();return i&&i.uri.toString()!==t.toString()?null:i},t}(o.CodeEditorServiceImpl);t.StandaloneCodeEditorServiceImpl=s}),define(t[573],i([1,0,37,22]),function(e,t,i,n){"use strict";var o,r,s;Object.defineProperty(t,"__esModule",{value:!0}),t.vs={base:"vs",inherit:!1,rules:[{token:"",foreground:"000000",background:"fffffe"},{token:"invalid",foreground:"cd3131"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"001188"},{token:"variable.predefined",foreground:"4864AA"},{token:"constant",foreground:"dd0000"},{token:"comment",foreground:"008000"},{token:"number",foreground:"09885A"},{token:"number.hex",foreground:"3030c0"},{token:"regexp",foreground:"800000"},{token:"annotation",
foreground:"808080"},{token:"type",foreground:"008080"},{token:"delimiter",foreground:"000000"},{token:"delimiter.html",foreground:"383838"},{token:"delimiter.xml",foreground:"0000FF"},{token:"tag",foreground:"800000"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta.scss",foreground:"800000"},{token:"metatag",foreground:"e00000"},{token:"metatag.content.html",foreground:"FF0000"},{token:"metatag.html",foreground:"808080"},{token:"metatag.xml",foreground:"808080"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"863B00"},{token:"string.key.json",foreground:"A31515"},{token:"string.value.json",foreground:"0451A5"},{token:"attribute.name",foreground:"FF0000"},{token:"attribute.value",foreground:"0451A5"},{token:"attribute.value.number",foreground:"09885A"},{token:"attribute.value.unit",foreground:"09885A"},{token:"attribute.value.html",foreground:"0000FF"},{token:"attribute.value.xml",foreground:"0000FF"},{token:"string",foreground:"A31515"},{
token:"string.html",foreground:"0000FF"},{token:"string.sql",foreground:"FF0000"},{token:"string.yaml",foreground:"0451A5"},{token:"keyword",foreground:"0000FF"},{token:"keyword.json",foreground:"0451A5"},{token:"keyword.flow",foreground:"AF00DB"},{token:"keyword.flow.scss",foreground:"0000FF"},{token:"operator.scss",foreground:"666666"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"666666"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(o={},o[n.editorBackground]="#FFFFFE",o[n.editorForeground]="#000000",o[n.editorInactiveSelection]="#E5EBF1",o[i.editorIndentGuides]="#D3D3D3",o[i.editorActiveIndentGuides]="#939393",o[n.editorSelectionHighlight]="#ADD6FF4D",o)},t.vs_dark={base:"vs-dark",inherit:!1,rules:[{token:"",foreground:"D4D4D4",background:"1E1E1E"},{token:"invalid",foreground:"f44747"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"74B0DF"},{token:"variable.predefined",foreground:"4864AA"},{
token:"variable.parameter",foreground:"9CDCFE"},{token:"constant",foreground:"569CD6"},{token:"comment",foreground:"608B4E"},{token:"number",foreground:"B5CEA8"},{token:"number.hex",foreground:"5BB498"},{token:"regexp",foreground:"B46695"},{token:"annotation",foreground:"cc6666"},{token:"type",foreground:"3DC9B0"},{token:"delimiter",foreground:"DCDCDC"},{token:"delimiter.html",foreground:"808080"},{token:"delimiter.xml",foreground:"808080"},{token:"tag",foreground:"569CD6"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta.scss",foreground:"A79873"},{token:"meta.tag",foreground:"CE9178"},{token:"metatag",foreground:"DD6A6F"},{token:"metatag.content.html",foreground:"9CDCFE"},{token:"metatag.html",foreground:"569CD6"},{token:"metatag.xml",foreground:"569CD6"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"9CDCFE"},{token:"string.key.json",foreground:"9CDCFE"},{token:"string.value.json",foreground:"CE9178"},{token:"attribute.name",
foreground:"9CDCFE"},{token:"attribute.value",foreground:"CE9178"},{token:"attribute.value.number.css",foreground:"B5CEA8"},{token:"attribute.value.unit.css",foreground:"B5CEA8"},{token:"attribute.value.hex.css",foreground:"D4D4D4"},{token:"string",foreground:"CE9178"},{token:"string.sql",foreground:"FF0000"},{token:"keyword",foreground:"569CD6"},{token:"keyword.flow",foreground:"C586C0"},{token:"keyword.json",foreground:"CE9178"},{token:"keyword.flow.scss",foreground:"569CD6"},{token:"operator.scss",foreground:"909090"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"909090"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(r={},r[n.editorBackground]="#1E1E1E",r[n.editorForeground]="#D4D4D4",r[n.editorInactiveSelection]="#3A3D41",r[i.editorIndentGuides]="#404040",r[i.editorActiveIndentGuides]="#707070",r[n.editorSelectionHighlight]="#ADD6FF26",r)},t.hc_black={base:"hc-black",inherit:!1,rules:[{token:"",foreground:"FFFFFF",background:"000000"},{token:"invalid",
foreground:"f44747"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"1AEBFF"},{token:"variable.parameter",foreground:"9CDCFE"},{token:"constant",foreground:"569CD6"},{token:"comment",foreground:"608B4E"},{token:"number",foreground:"FFFFFF"},{token:"regexp",foreground:"C0C0C0"},{token:"annotation",foreground:"569CD6"},{token:"type",foreground:"3DC9B0"},{token:"delimiter",foreground:"FFFF00"},{token:"delimiter.html",foreground:"FFFF00"},{token:"tag",foreground:"569CD6"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta",foreground:"D4D4D4"},{token:"meta.tag",foreground:"CE9178"},{token:"metatag",foreground:"569CD6"},{token:"metatag.content.html",foreground:"1AEBFF"},{token:"metatag.html",foreground:"569CD6"},{token:"metatag.xml",foreground:"569CD6"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"9CDCFE"},{token:"string.key",foreground:"9CDCFE"},{token:"string.value",foreground:"CE9178"},{
token:"attribute.name",foreground:"569CD6"},{token:"attribute.value",foreground:"3FF23F"},{token:"string",foreground:"CE9178"},{token:"string.sql",foreground:"FF0000"},{token:"keyword",foreground:"569CD6"},{token:"keyword.flow",foreground:"C586C0"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"909090"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(s={},s[n.editorBackground]="#000000",s[n.editorForeground]="#FFFFFF",s[i.editorIndentGuides]="#FFFFFF",s[i.editorActiveIndentGuides]="#FFFFFF",s)}}),define(t[574],i([1,0,8,25,4,17,487,573,46,22,16]),function(e,t,i,n,o,r,s,a,l,u,d){"use strict";function c(e){return e===f||e===g||e===m}function h(e){switch(e){case f:return a.vs;case g:return a.vs_dark;case m:return a.hc_black}}function p(e){var t=h(e);return new y(e,t)}Object.defineProperty(t,"__esModule",{value:!0});var f="vs",g="vs-dark",m="hc-black",v=l.Registry.as(u.Extensions.ColorContribution),_=l.Registry.as(d.Extensions.ThemingContribution),y=function(){function e(e,t){
this.themeData=t;var i=t.base;e.length>0?(this.id=i+" "+e,this.themeName=e):(this.id=i,this.themeName=i),this.colors=null,this.defaultColors=Object.create(null),this._tokenTheme=null}return Object.defineProperty(e.prototype,"base",{get:function(){return this.themeData.base},enumerable:!0,configurable:!0}),e.prototype.notifyBaseUpdated=function(){this.themeData.inherit&&(this.colors=null,this._tokenTheme=null)},e.prototype.getColors=function(){if(!this.colors){var e=new Map;for(var t in this.themeData.colors)e.set(t,n.Color.fromHex(this.themeData.colors[t]));if(this.themeData.inherit){var i=h(this.themeData.base);for(var t in i.colors)e.has(t)||e.set(t,n.Color.fromHex(i.colors[t]))}this.colors=e}return this.colors},e.prototype.getColor=function(e,t){var i=this.getColors().get(e);return i||(!1!==t?this.getDefault(e):void 0)},e.prototype.getDefault=function(e){var t=this.defaultColors[e];return t||(t=v.resolveDefaultColor(e,this),this.defaultColors[e]=t,t)},e.prototype.defines=function(e){
return Object.prototype.hasOwnProperty.call(this.getColors(),e)},Object.defineProperty(e.prototype,"type",{get:function(){switch(this.base){case f:return"light";case m:return"hc";default:return"dark"}},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"tokenTheme",{get:function(){if(!this._tokenTheme){var e=[],t=[];if(this.themeData.inherit){var i=h(this.themeData.base);e=i.rules,i.encodedTokensColors&&(t=i.encodedTokensColors)}e=e.concat(this.themeData.rules),this.themeData.encodedTokensColors&&(t=this.themeData.encodedTokensColors),this._tokenTheme=s.TokenTheme.createFromRawTokenTheme(e,t)}return this._tokenTheme},enumerable:!0,configurable:!0}),e}(),b=function(){function e(){this.environment=Object.create(null),this._onThemeChange=new o.Emitter,this._onIconThemeChange=new o.Emitter,this._knownThemes=new Map,this._knownThemes.set(f,p(f)),this._knownThemes.set(g,p(g)),this._knownThemes.set(m,p(m)),this._styleElement=i.createStyleSheet(),this._styleElement.className="monaco-colors",
this.setTheme(f)}return Object.defineProperty(e.prototype,"onThemeChange",{get:function(){return this._onThemeChange.event},enumerable:!0,configurable:!0}),e.prototype.defineTheme=function(e,t){if(!/^[a-z0-9\-]+$/i.test(e))throw new Error("Illegal theme name!");if(!c(t.base)&&!c(e))throw new Error("Illegal theme base!");this._knownThemes.set(e,new y(e,t)),c(e)&&this._knownThemes.forEach(function(t){t.base===e&&t.notifyBaseUpdated()}),this._theme&&this._theme.themeName===e&&this.setTheme(e)},e.prototype.getTheme=function(){return this._theme},e.prototype.setTheme=function(e){var t,i=this;if(t=this._knownThemes.has(e)?this._knownThemes.get(e):this._knownThemes.get(f),this._theme===t)return t.id;this._theme=t;var n=[],o={},a={addRule:function(e){o[e]||(n.push(e),o[e]=!0)}};_.getThemingParticipants().forEach(function(e){return e(t,a,i.environment)});var l=t.tokenTheme.getColorMap();return a.addRule(s.generateTokensCSSForColorMap(l)),this._styleElement.innerHTML=n.join("\n"),r.TokenizationRegistry.setColorMap(l),
this._onThemeChange.fire(t),t.id},e.prototype.getIconTheme=function(){return{hasFileIcons:!1,hasFolderIcons:!1,hidesExplorerArrows:!1}},e}();t.StandaloneThemeServiceImpl=b}),define(t[575],i([1,0,515,54,103,4,34,16,33,2]),function(e,t,i,n,o,s,a,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(e){function t(t,n,o,r,a){var l=e.call(this)||this;return l._onDidContextMenu=l._register(new s.Emitter),l.contextMenuHandler=new i.ContextMenuHandler(o,t,n,r,a),l}return r(t,e),t.prototype.configure=function(e){this.contextMenuHandler.configure(e)},t.prototype.showContextMenu=function(e){this.contextMenuHandler.showContextMenu(e),this._onDidContextMenu.fire()},t=d([c(0,o.ITelemetryService),c(1,a.INotificationService),c(2,n.IContextViewService),c(3,u.IKeybindingService),c(4,l.IThemeService)],t)}(h.Disposable);t.ContextMenuService=p}),define(t[131],i([1,0,8,122,2,368,39,89,14,12,33,46,90,16,183,296,294,66]),function(e,t,i,n,o,a,l,u,h,p,f,g,m,v,_,y,b,C){"use strict";function S(e){
return"alt"===e.getValue(t.multiSelectModifierSettingKey)}function w(e){return"doubleClick"!==e.getValue(t.openModeSettingKey)}function E(e,r,a,u,d,c,h){t.WorkbenchListSupportsKeyboardNavigation.bindTo(a),t.didBindWorkbenchListAutomaticKeyboardNavigation||(t.WorkbenchListAutomaticKeyboardNavigation.bindTo(a),t.didBindWorkbenchListAutomaticKeyboardNavigation=!0);var p=function(){var e=a.getContextKeyValue(t.WorkbenchListAutomaticKeyboardNavigationKey);return e&&(e=d.getValue(t.automaticKeyboardNavigationSettingKey)),e},f=2===h.getAccessibilitySupport()?"simple":d.getValue(t.keyboardNavigationSettingKey),g=void 0!==r.horizontalScrolling?r.horizontalScrolling:function(e){return l.getMigratedSettingValue(e,t.horizontalScrollingKey,"workbench.tree.horizontalScrolling")}(d),v=w(d),_=function(e,t,i){var n=new o.DisposableStore,r=s({},e);if(!1!==e.multipleSelectionSupport&&!e.multipleSelectionController){var a=new k(t);r.multipleSelectionController=a,n.add(a)}var l=new T(t,e.openController);if(r.openController=l,
n.add(l),e.keyboardNavigationLabelProvider){var u=e.keyboardNavigationLabelProvider;r.keyboardNavigationLabelProvider={getKeyboardNavigationLabel:function(e){return u.getKeyboardNavigationLabel(e)},mightProducePrintableCharacter:function(e){return i.mightProducePrintableCharacter(e)}}}return[r,n]}(r,d,c),y=_[0],b=_[1],C=r.additionalScrollHeight;return{getAutomaticKeyboardNavigation:p,disposable:b,options:s({keyboardSupport:!1,styleController:new n.DefaultStyleController((I||(I=i.createStyleSheet()),I))},m.computeStyles(u.getTheme(),m.defaultListStyles),y,{indent:d.getValue(N),renderIndentGuides:d.getValue(M),automaticKeyboardNavigation:p(),simpleKeyboardNavigation:"simple"===f,filterOnType:"filter"===f,horizontalScrolling:g,openOnSingleClick:v,keyboardNavigationEventFilter:function(e,t){var i=!1;return function(n){if(i)return i=!1,!1;var o=t.softDispatch(n,e);return o&&o.enterChord?(i=!0,!1):(i=!1,!0)}}(e,c),additionalScrollHeight:C})}}var L;Object.defineProperty(t,"__esModule",{value:!0}),
t.IListService=p.createDecorator("listService");var x=function(){function e(e){this.lists=[],this._lastFocusedWidget=void 0}return Object.defineProperty(e.prototype,"lastFocusedList",{get:function(){return this._lastFocusedWidget},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t){var i=this;if(this.lists.some(function(t){return t.widget===e}))throw new Error("Cannot register the same widget multiple times");var n={widget:e,extraContextKeys:t};return this.lists.push(n),e.getHTMLElement()===document.activeElement&&(this._lastFocusedWidget=e),o.combinedDisposable(e.onDidFocus(function(){return i._lastFocusedWidget=e}),o.toDisposable(function(){return i.lists.splice(i.lists.indexOf(n),1)}),e.onDidDispose(function(){i.lists=i.lists.filter(function(e){return e!==n}),i._lastFocusedWidget===e&&(i._lastFocusedWidget=void 0)}))},e=d([c(0,h.IContextKeyService)],e)}();t.ListService=x;var D=new h.RawContextKey("listFocus",!0)
;t.WorkbenchListSupportsMultiSelectContextKey=new h.RawContextKey("listSupportsMultiselect",!0),t.WorkbenchListHasSelectionOrFocus=new h.RawContextKey("listHasSelectionOrFocus",!1),t.WorkbenchListDoubleSelection=new h.RawContextKey("listDoubleSelection",!1),t.WorkbenchListMultiSelection=new h.RawContextKey("listMultiSelection",!1),t.WorkbenchListSupportsKeyboardNavigation=new h.RawContextKey("listSupportsKeyboardNavigation",!0),t.WorkbenchListAutomaticKeyboardNavigationKey="listAutomaticKeyboardNavigation",t.WorkbenchListAutomaticKeyboardNavigation=new h.RawContextKey(t.WorkbenchListAutomaticKeyboardNavigationKey,!0),t.didBindWorkbenchListAutomaticKeyboardNavigation=!1,t.multiSelectModifierSettingKey="workbench.list.multiSelectModifier",t.openModeSettingKey="workbench.list.openMode",t.horizontalScrollingKey="workbench.list.horizontalScrolling",t.keyboardNavigationSettingKey="workbench.list.keyboardNavigation",t.automaticKeyboardNavigationSettingKey="workbench.list.automaticKeyboardNavigation"
;var I,N="workbench.tree.indent",M="workbench.tree.renderIndentGuides",k=function(e){function i(t){var i=e.call(this)||this;return i.configurationService=t,i.useAltAsMultipleSelectionModifier=S(t),i.registerListeners(),i}return r(i,e),i.prototype.registerListeners=function(){var e=this;this._register(this.configurationService.onDidChangeConfiguration(function(i){i.affectsConfiguration(t.multiSelectModifierSettingKey)&&(e.useAltAsMultipleSelectionModifier=S(e.configurationService))}))},i.prototype.isSelectionSingleChangeEvent=function(e){return this.useAltAsMultipleSelectionModifier?e.browserEvent.altKey:n.isSelectionSingleChangeEvent(e)},i.prototype.isSelectionRangeChangeEvent=function(e){return n.isSelectionRangeChangeEvent(e)},i}(o.Disposable),T=function(e){function i(t,i){var n=e.call(this)||this;return n.configurationService=t,n.existingOpenController=i,n.openOnSingleClick=w(t),n.registerListeners(),n}return r(i,e),i.prototype.registerListeners=function(){var e=this
;this._register(this.configurationService.onDidChangeConfiguration(function(i){i.affectsConfiguration(t.openModeSettingKey)&&(e.openOnSingleClick=w(e.configurationService))}))},i.prototype.shouldOpen=function(e){if(e instanceof MouseEvent){var t=0===e.button,i=2===e.detail;return!(t&&!this.openOnSingleClick&&!i)&&(!(!t&&1!==e.button)&&(!this.existingOpenController||this.existingOpenController.shouldOpen(e)))}return!this.existingOpenController||this.existingOpenController.shouldOpen(e)},i}(o.Disposable),R=function(e){function i(t,i,n,o,r,s,a,l,u,d){var c=this,h=E(t,o,r,a,l,u,d),p=h.options,f=h.getAutomaticKeyboardNavigation,g=h.disposable;return(c=e.call(this,t,i,n,p)||this).disposables.push(g),c.internals=new A(c,p,f,r,s,a,l,d),c.disposables.push(c.internals),c}return r(i,e),i=d([c(4,h.IContextKeyService),c(5,t.IListService),c(6,v.IThemeService),c(7,l.IConfigurationService),c(8,f.IKeybindingService),c(9,C.IAccessibilityService)],i)}(_.ObjectTree);t.WorkbenchObjectTree=R;var O=function(e){
function i(t,i,n,o,r,s,a,l,u,d,c){var h=this,p=E(t,r,s,l,u,d,c),f=p.options,g=p.getAutomaticKeyboardNavigation,m=p.disposable;return(h=e.call(this,t,i,n,o,f)||this).disposables.push(m),h.internals=new A(h,f,g,s,a,l,u,c),h.disposables.push(h.internals),h}return r(i,e),i=d([c(5,h.IContextKeyService),c(6,t.IListService),c(7,v.IThemeService),c(8,l.IConfigurationService),c(9,f.IKeybindingService),c(10,C.IAccessibilityService)],i)}(b.DataTree);t.WorkbenchDataTree=O;var P=function(e){function i(t,i,n,o,r,s,a,l,u,d,c){var h=this,p=E(t,r,s,l,u,d,c),f=p.options,g=p.getAutomaticKeyboardNavigation,m=p.disposable;return(h=e.call(this,t,i,n,o,f)||this).disposables.push(m),h.internals=new A(h,f,g,s,a,l,u,c),h.disposables.push(h.internals),h}return r(i,e),Object.defineProperty(i.prototype,"contextKeyService",{get:function(){return this.internals.contextKeyService},enumerable:!0,configurable:!0}),
i=d([c(5,h.IContextKeyService),c(6,t.IListService),c(7,v.IThemeService),c(8,l.IConfigurationService),c(9,f.IKeybindingService),c(10,C.IAccessibilityService)],i)}(y.AsyncDataTree);t.WorkbenchAsyncDataTree=P;var A=function(){function e(e,i,n,o,r,s,a,l){var u=this;this.disposables=[],this.contextKeyService=function(e,t){var i=e.createScoped(t.getHTMLElement());return D.bindTo(i),i}(o,e);t.WorkbenchListSupportsMultiSelectContextKey.bindTo(this.contextKeyService).set(!(!1===i.multipleSelectionSupport)),this.hasSelectionOrFocus=t.WorkbenchListHasSelectionOrFocus.bindTo(this.contextKeyService),this.hasDoubleSelection=t.WorkbenchListDoubleSelection.bindTo(this.contextKeyService),this.hasMultiSelection=t.WorkbenchListMultiSelection.bindTo(this.contextKeyService),this._useAltAsMultipleSelectionModifier=S(a);var d=new Set;d.add(t.WorkbenchListAutomaticKeyboardNavigationKey);var c=function(){var i=2===l.getAccessibilitySupport()?"simple":a.getValue(t.keyboardNavigationSettingKey);e.updateOptions({
simpleKeyboardNavigation:"simple"===i,filterOnType:"filter"===i})};this.disposables.push(this.contextKeyService,r.register(e),m.attachListStyler(e,s),e.onDidChangeSelection(function(){var t=e.getSelection(),i=e.getFocus();u.hasSelectionOrFocus.set(t.length>0||i.length>0),u.hasMultiSelection.set(t.length>1),u.hasDoubleSelection.set(2===t.length)}),e.onDidChangeFocus(function(){var t=e.getSelection(),i=e.getFocus();u.hasSelectionOrFocus.set(t.length>0||i.length>0)}),a.onDidChangeConfiguration(function(i){if(i.affectsConfiguration(t.openModeSettingKey)&&e.updateOptions({openOnSingleClick:w(a)}),i.affectsConfiguration(t.multiSelectModifierSettingKey)&&(u._useAltAsMultipleSelectionModifier=S(a)),i.affectsConfiguration(N)){var o=a.getValue(N);e.updateOptions({indent:o})}if(i.affectsConfiguration(M)){var r=a.getValue(M);e.updateOptions({renderIndentGuides:r})}i.affectsConfiguration(t.keyboardNavigationSettingKey)&&c(),i.affectsConfiguration(t.automaticKeyboardNavigationSettingKey)&&e.updateOptions({
automaticKeyboardNavigation:n()})}),this.contextKeyService.onDidChangeContext(function(t){t.affectsSome(d)&&e.updateOptions({automaticKeyboardNavigation:n()})}),l.onDidChangeAccessibilitySupport(function(){return c()}))}return e.prototype.dispose=function(){this.disposables=o.dispose(this.disposables)},e=d([c(3,h.IContextKeyService),c(4,t.IListService),c(5,v.IThemeService),c(6,l.IConfigurationService),c(7,C.IAccessibilityService)],e)}();g.Registry.as(u.Extensions.Configuration).registerConfiguration({id:"workbench",order:7,title:a.localize(0,null),type:"object",properties:(L={},L[t.multiSelectModifierSettingKey]={type:"string",enum:["ctrlCmd","alt"],enumDescriptions:[a.localize(1,null),a.localize(2,null)],default:"ctrlCmd",description:a.localize(3,null)},L[t.openModeSettingKey]={type:"string",enum:["singleClick","doubleClick"],default:"singleClick",description:a.localize(4,null)},L[t.horizontalScrollingKey]={type:"boolean",default:!1,description:a.localize(5,null)},L["workbench.tree.horizontalScrolling"]={
type:"boolean",default:!1,description:a.localize(6,null),deprecationMessage:a.localize(7,null,t.horizontalScrollingKey)},L[N]={type:"number",default:8,minimum:0,maximum:40,description:a.localize(8,null)},L[M]={type:"string",enum:["none","onHover","always"],default:"onHover",description:a.localize(9,null)},L[t.keyboardNavigationSettingKey]={type:"string",enum:["simple","highlight","filter"],enumDescriptions:[a.localize(10,null),a.localize(11,null),a.localize(12,null)],default:"highlight",description:a.localize(13,null)},L[t.automaticKeyboardNavigationSettingKey]={type:"boolean",default:!0,markdownDescription:a.localize(14,null)},L)})}),define(t[118],i([1,0,8,25,4,2,50,48,153,3,30,76,562,356,14,12,102,131,22,16,96,97,384,397]),function(e,t,i,n,o,s,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var I=function(){function e(e,t){var i=this;this._editor=e,this._model=t,this._decorations=new Map,this._decorationIgnoreSet=new Set,
this._callOnDispose=new s.DisposableStore,this._callOnModelChange=new s.DisposableStore,this._callOnDispose.add(this._editor.onDidChangeModel(function(){return i._onModelChanged()})),this._onModelChanged()}return e.prototype.dispose=function(){this._callOnModelChange.dispose(),this._callOnDispose.dispose(),this.removeDecorations()},e.prototype._onModelChanged=function(){this._callOnModelChange.clear();var e=this._editor.getModel();if(e)for(var t=0,i=this._model.groups;t<i.length;t++){var n=i[t];if(n.uri.toString()===e.uri.toString())return void this._addDecorations(n)}},e.prototype._addDecorations=function(t){var i=this;if(this._editor.hasModel()){this._callOnModelChange.add(this._editor.getModel().onDidChangeDecorations(function(e){return i._onDecorationChanged()}));for(var n=[],o=[],r=0,s=t.children.length;r<s;r++){var a=t.children[r];this._decorationIgnoreSet.has(a.id)||(n.push({range:a.range,options:e.DecorationOptions}),o.push(r))}
for(var l=this._editor.deltaDecorations([],n),r=0;r<l.length;r++)this._decorations.set(l[r],t.children[o[r]])}},e.prototype._onDecorationChanged=function(){var e=this,t=[],i=this._editor.getModel();if(i){this._decorations.forEach(function(n,o){var r=i.getDecorationRange(o);if(r){var s=!1;if(!f.Range.equalsRange(r,n.range)){if(f.Range.spansMultipleLines(r))s=!0;else{n.range.endColumn-n.range.startColumn!==r.endColumn-r.startColumn&&(s=!0)}s?(e._decorationIgnoreSet.add(n.id),t.push(o)):n.range=r}}});for(var n=0,o=t.length;n<o;n++)this._decorations.delete(t[n]);this._editor.deltaDecorations(t,[])}},e.prototype.removeDecorations=function(){var e=[];this._decorations.forEach(function(t,i){e.push(i)}),this._editor.deltaDecorations(e,[]),this._decorations.clear()},e.DecorationOptions=g.ModelDecorationOptions.register({stickiness:1,className:"reference-decoration"}),e}(),N=function(){function e(){this.ratio=.7,this.heightInLines=18}return e.fromJSON=function(e){var t,i;try{var n=JSON.parse(e);t=n.ratio,
i=n.heightInLines}catch(e){}return{ratio:t||.7,heightInLines:i||18}},e}();t.LayoutData=N,t.ctxReferenceWidgetSearchTreeFocused=new y.RawContextKey("referenceSearchTreeFocused",!0);var M=function(e){function y(t,i,n,r,a,l,u,d){var c=e.call(this,t,{showFrame:!1,showArrow:!0,isResizeable:!0,isAccessible:!0})||this;return c._defaultTreeKeyboardSupport=i,c.layoutData=n,c._textModelResolverService=a,c._instantiationService=l,c._peekViewService=u,c._uriLabel=d,c._disposeOnNewModel=new s.DisposableStore,c._callOnDispose=new s.DisposableStore,c._onDidSelectReference=new o.Emitter,c._dim={height:0,width:0},c._applyTheme(r.getTheme()),c._callOnDispose.add(r.onThemeChange(c._applyTheme.bind(c))),c._peekViewService.addExclusiveWidget(t,c),c.create(),c}return r(y,e),y.prototype.dispose=function(){this.setModel(void 0),this._callOnDispose.dispose(),this._disposeOnNewModel.dispose(),s.dispose(this._preview),s.dispose(this._previewNotAvailableMessage),s.dispose(this._tree),s.dispose(this._previewModelReference),
this._splitView.dispose(),e.prototype.dispose.call(this)},y.prototype._applyTheme=function(e){var i=e.getColor(t.peekViewBorder)||n.Color.transparent;this.style({arrowColor:i,frameColor:i,headerBackgroundColor:e.getColor(t.peekViewTitleBackground)||n.Color.transparent,primaryHeadingColor:e.getColor(t.peekViewTitleForeground),secondaryHeadingColor:e.getColor(t.peekViewTitleInfoForeground)})},Object.defineProperty(y.prototype,"onDidSelectReference",{get:function(){return this._onDidSelectReference.event},enumerable:!0,configurable:!0}),y.prototype.show=function(t){this.editor.revealRangeInCenterIfOutsideViewport(t,0),e.prototype.show.call(this,t,this.layoutData.heightInLines||18)},y.prototype.focus=function(){this._tree.domFocus()},y.prototype._onTitleClick=function(e){this._preview&&this._preview.getModel()&&this._onDidSelectReference.fire({element:this._getFocusedReference(),kind:e.ctrlKey||e.metaKey||e.altKey?"side":"open",source:"title"})},y.prototype._fillBody=function(e){var n=this
;this.setCssClass("reference-zone-widget"),this._messageContainer=i.append(e,i.$("div.messages")),i.hide(this._messageContainer),this._splitView=new D.SplitView(e,{orientation:1}),this._previewContainer=i.append(e,i.$("div.preview.inline"));this._preview=this._instantiationService.createInstance(p.EmbeddedCodeEditorWidget,this._previewContainer,{scrollBeyondLastLine:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,fixedOverflowWidgets:!0,minimap:{enabled:!1}},this.editor),i.hide(this._previewContainer),this._previewNotAvailableMessage=g.TextModel.createFromString(_.localize(0,null)),this._treeContainer=i.append(e,i.$("div.ref-tree.inline"));var r={ariaLabel:_.localize(1,null),keyboardSupport:this._defaultTreeKeyboardSupport,accessibilityProvider:new v.AriaProvider,keyboardNavigationLabelProvider:this._instantiationService.createInstance(v.StringRepresentationProvider),identityProvider:new v.IdentityProvider}
;this._tree=this._instantiationService.createInstance(S.WorkbenchAsyncDataTree,this._treeContainer,new v.Delegate,[this._instantiationService.createInstance(v.FileReferencesRenderer),this._instantiationService.createInstance(v.OneReferenceRenderer)],this._instantiationService.createInstance(v.DataSource),r),t.ctxReferenceWidgetSearchTreeFocused.bindTo(this._tree.contextKeyService),this._splitView.addView({onDidChange:o.Event.None,element:this._previewContainer,minimumSize:200,maximumSize:Number.MAX_VALUE,layout:function(e){n._preview.layout({height:n._dim.height,width:e})}},D.Sizing.Distribute),this._splitView.addView({onDidChange:o.Event.None,element:this._treeContainer,minimumSize:100,maximumSize:Number.MAX_VALUE,layout:function(e){n._treeContainer.style.height=n._dim.height+"px",n._treeContainer.style.width=e+"px",n._tree.layout(n._dim.height,e)}},D.Sizing.Distribute),this._disposables.add(this._splitView.onDidSashChange(function(){n._dim.width&&(n.layoutData.ratio=n._splitView.getViewSize(0)/n._dim.width)
},void 0));var s=function(e,t){e instanceof x.OneReference&&("show"===t&&n._revealReference(e,!1),n._onDidSelectReference.fire({element:e,kind:t,source:"tree"}))};this._tree.onDidChangeFocus(function(e){s(e.elements[0],"show")}),this._tree.onDidChangeSelection(function(e){var t=!1;e.browserEvent instanceof KeyboardEvent&&(t=!0),t?s(e.elements[0],"goto"):s(e.elements[0],"show")}),this._tree.onDidOpen(function(e){var t=e.browserEvent instanceof MouseEvent&&(e.browserEvent.ctrlKey||e.browserEvent.metaKey||e.browserEvent.altKey),i=!e.browserEvent||e.browserEvent instanceof MouseEvent&&2===e.browserEvent.detail;t?s(e.elements[0],"side"):i?s(e.elements[0],"goto"):s(e.elements[0],"show")}),i.hide(this._treeContainer)},y.prototype._onWidth=function(e){this._dim&&this._doLayoutBody(this._dim.height,e)},y.prototype._doLayoutBody=function(t,i){e.prototype._doLayoutBody.call(this,t,i),this._dim={height:t,width:i},this.layoutData.heightInLines=this._viewZone?this._viewZone.heightInLines:this.layoutData.heightInLines,
this._splitView.layout(i),this._splitView.resizeView(0,i*this.layoutData.ratio)},y.prototype.setSelection=function(e){var t=this;return this._revealReference(e,!0).then(function(){t._model&&(t._tree.setSelection([e]),t._tree.setFocus([e]))})},y.prototype.setModel=function(e){return this._disposeOnNewModel.clear(),this._model=e,this._model?this._onNewModel():Promise.resolve()},y.prototype._onNewModel=function(){var e=this;return this._model?this._model.empty?(this.setTitle(""),this._messageContainer.innerHTML=_.localize(2,null),i.show(this._messageContainer),Promise.resolve(void 0)):(i.hide(this._messageContainer),this._decorationsManager=new I(this._preview,this._model),this._disposeOnNewModel.add(this._decorationsManager),this._disposeOnNewModel.add(this._model.onDidChangeReferenceRange(function(t){return e._tree.rerender(t)})),this._disposeOnNewModel.add(this._preview.onMouseDown(function(t){var i=t.event,n=t.target;if(2===i.detail){var o=e._getFocusedReference();o&&e._onDidSelectReference.fire({element:{
uri:o.uri,range:n.range},kind:i.ctrlKey||i.metaKey||i.altKey?"side":"open",source:"editor"})}})),i.addClass(this.container,"results-loaded"),i.show(this._treeContainer),i.show(this._previewContainer),this._splitView.layout(this._dim.width),this.focus(),this._tree.setInput(1===this._model.groups.length?this._model.groups[0]:this._model)):Promise.resolve(void 0)},y.prototype._getFocusedReference=function(){var e=this._tree.getFocus()[0];return e instanceof x.OneReference?e:e instanceof x.FileReferences&&e.children.length>0?e.children[0]:void 0},y.prototype._revealReference=function(e,t){return a(this,void 0,void 0,function(){var i,n,o,r,a;return l(this,function(l){switch(l.label){case 0:return this._revealedReference===e?[2]:(this._revealedReference=e,e.uri.scheme!==u.Schemas.inMemory?this.setTitle(h.basenameOrAuthority(e.uri),this._uriLabel.getUriLabel(h.dirname(e.uri))):this.setTitle(_.localize(3,null)),i=this._textModelResolverService.createModelReference(e.uri),
this._tree.getInput()!==e.parent?[3,1]:(this._tree.reveal(e),[3,3]));case 1:return t&&this._tree.reveal(e.parent),[4,this._tree.expand(e.parent)];case 2:l.sent(),this._tree.reveal(e),l.label=3;case 3:return[4,i];case 4:return n=l.sent(),this._model?(s.dispose(this._previewModelReference),(o=n.object)?(r=this._preview.getModel()===o.textEditorModel?0:1,a=f.Range.lift(e.range).collapseToStart(),this._previewModelReference=n,this._preview.setModel(o.textEditorModel),this._preview.setSelection(a),this._preview.revealRangeInCenter(a,r)):(this._preview.setModel(this._previewNotAvailableMessage),n.dispose()),[2]):(n.dispose(),[2])}})})},y=d([c(3,E.IThemeService),c(4,m.ITextModelService),c(5,b.IInstantiationService),c(6,L.IPeekViewService),c(7,C.ILabelService)],y)}(L.PeekViewWidget);t.ReferenceWidget=M,t.peekViewTitleBackground=w.registerColor("peekViewTitle.background",{dark:"#1E1E1E",light:"#FFFFFF",hc:"#0C141F"},_.localize(4,null)),t.peekViewTitleForeground=w.registerColor("peekViewTitleLabel.foreground",{
dark:"#FFFFFF",light:"#333333",hc:"#FFFFFF"},_.localize(5,null)),t.peekViewTitleInfoForeground=w.registerColor("peekViewTitleDescription.foreground",{dark:"#ccccccb3",light:"#6c6c6cb3",hc:"#FFFFFF99"},_.localize(6,null)),t.peekViewBorder=w.registerColor("peekView.border",{dark:"#007acc",light:"#007acc",hc:w.contrastBorder},_.localize(7,null)),t.peekViewResultsBackground=w.registerColor("peekViewResult.background",{dark:"#252526",light:"#F3F3F3",hc:n.Color.black},_.localize(8,null)),t.peekViewResultsMatchForeground=w.registerColor("peekViewResult.lineForeground",{dark:"#bbbbbb",light:"#646465",hc:n.Color.white},_.localize(9,null)),t.peekViewResultsFileForeground=w.registerColor("peekViewResult.fileForeground",{dark:n.Color.white,light:"#1E1E1E",hc:n.Color.white},_.localize(10,null)),t.peekViewResultsSelectionBackground=w.registerColor("peekViewResult.selectionBackground",{dark:"#3399ff33",light:"#3399ff33",hc:null},_.localize(11,null)),
t.peekViewResultsSelectionForeground=w.registerColor("peekViewResult.selectionForeground",{dark:n.Color.white,light:"#6C6C6C",hc:n.Color.white},_.localize(12,null)),t.peekViewEditorBackground=w.registerColor("peekViewEditor.background",{dark:"#001F33",light:"#F2F8FC",hc:n.Color.black},_.localize(13,null)),t.peekViewEditorGutterBackground=w.registerColor("peekViewEditorGutter.background",{dark:t.peekViewEditorBackground,light:t.peekViewEditorBackground,hc:t.peekViewEditorBackground},_.localize(14,null)),t.peekViewResultsMatchHighlight=w.registerColor("peekViewResult.matchHighlightBackground",{dark:"#ea5c004d",light:"#ea5c004d",hc:null},_.localize(15,null)),t.peekViewEditorMatchHighlight=w.registerColor("peekViewEditor.matchHighlightBackground",{dark:"#ff8f0099",light:"#f5d802de",hc:null},_.localize(16,null)),t.peekViewEditorMatchHighlightBorder=w.registerColor("peekViewEditor.matchHighlightBorder",{dark:null,light:null,hc:w.activeContrastBorder},_.localize(17,null)),E.registerThemingParticipant(function(e,i){
var n=e.getColor(t.peekViewResultsMatchHighlight);n&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree .referenceMatch .highlight { background-color: "+n+"; }");var o=e.getColor(t.peekViewEditorMatchHighlight);o&&i.addRule(".monaco-editor .reference-zone-widget .preview .reference-decoration { background-color: "+o+"; }");var r=e.getColor(t.peekViewEditorMatchHighlightBorder);r&&i.addRule(".monaco-editor .reference-zone-widget .preview .reference-decoration { border: 2px solid "+r+"; box-sizing: border-box; }");var s=e.getColor(w.activeContrastBorder);s&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree .referenceMatch .highlight { border: 1px dotted "+s+"; box-sizing: border-box; }");var a=e.getColor(t.peekViewResultsBackground);a&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree { background-color: "+a+"; }");var l=e.getColor(t.peekViewResultsMatchForeground);l&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree { color: "+l+"; }")
;var u=e.getColor(t.peekViewResultsFileForeground);u&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree .reference-file { color: "+u+"; }");var d=e.getColor(t.peekViewResultsSelectionBackground);d&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree .monaco-list:focus .monaco-list-rows > .monaco-list-row.selected:not(.highlighted) { background-color: "+d+"; }");var c=e.getColor(t.peekViewResultsSelectionForeground);c&&i.addRule(".monaco-editor .reference-zone-widget .ref-tree .monaco-list:focus .monaco-list-rows > .monaco-list-row.selected:not(.highlighted) { color: "+c+" !important; }");var h=e.getColor(t.peekViewEditorBackground);h&&i.addRule(".monaco-editor .reference-zone-widget .preview .monaco-editor .monaco-editor-background,.monaco-editor .reference-zone-widget .preview .monaco-editor .inputarea.ime-input {\tbackground-color: "+h+";}");var p=e.getColor(t.peekViewEditorGutterBackground)
;p&&i.addRule(".monaco-editor .reference-zone-widget .preview .monaco-editor .margin {\tbackground-color: "+p+";}")})}),define(t[148],i([1,0,352,10,2,31,12,14,39,68,118,3,13,34]),function(e,t,i,n,o,r,s,u,h,p,f,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ctxReferenceSearchVisible=new u.RawContextKey("referenceSearchVisible",!1);var _=function(){function e(e,i,n,r,s,a,l,u){this._defaultTreeKeyboardSupport=e,this._editorService=r,this._notificationService=s,this._instantiationService=a,this._storageService=l,this._configurationService=u,this._disposables=new o.DisposableStore,this._requestIdPool=0,this._ignoreModelChangeEvent=!1,this._editor=i,this._referenceSearchVisible=t.ctxReferenceSearchVisible.bindTo(n)}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._referenceSearchVisible.reset(),o.dispose(this._disposables),this._widget&&(o.dispose(this._widget),this._widget=void 0),
this._model&&(o.dispose(this._model),this._model=void 0)},e.prototype.toggleWidget=function(e,t,n){var o,r=this;if(this._widget&&(o=this._widget.position),this.closeWidget(),!o||!e.containsPosition(o)){this._referenceSearchVisible.set(!0),this._disposables.add(this._editor.onDidChangeModelLanguage(function(){r.closeWidget()})),this._disposables.add(this._editor.onDidChangeModel(function(){r._ignoreModelChangeEvent||r.closeWidget()}));var s=f.LayoutData.fromJSON(this._storageService.get("peekViewLayout",0,"{}"));this._widget=this._instantiationService.createInstance(f.ReferenceWidget,this._editor,this._defaultTreeKeyboardSupport,s),this._widget.setTitle(i.localize(0,null)),this._widget.show(e),this._disposables.add(this._widget.onDidClose(function(){t.cancel(),r._widget&&(r._storageService.store("peekViewLayout",JSON.stringify(r._widget.layoutData),0),r._widget=void 0),r.closeWidget()})),this._disposables.add(this._widget.onDidSelectReference(function(e){var t=e.element,i=e.kind;switch(i){case"open":
if("editor"===e.source&&r._configurationService.getValue("editor.stablePeek"))break;case"side":t&&r.openReference(t,"side"===i);break;case"goto":t&&(n.onGoto?n.onGoto(t):r._gotoReference(t))}}));var a=++this._requestIdPool;t.then(function(t){if(a===r._requestIdPool&&r._widget)return r._model&&r._model.dispose(),r._model=t,r._widget.setModel(r._model).then(function(){if(r._widget&&r._model&&r._editor.hasModel()){r._widget.setMetaTitle(n.getMetaTitle(r._model));var t=r._editor.getModel().uri,i=new m.Position(e.startLineNumber,e.startColumn),o=r._model.nearestReference(t,i);if(o)return r._widget.setSelection(o)}})},function(e){r._notificationService.error(e)})}},e.prototype.goToNextOrPreviousReference=function(e){return a(this,void 0,void 0,function(){var t,i,n,o;return l(this,function(r){switch(r.label){case 0:return this._editor.hasModel()&&this._model&&this._widget&&((t=this._widget.position)&&(i=this._model.nearestReference(this._editor.getModel().uri,t)))?(n=this._model.nextOrPreviousReference(i,e),
o=this._editor.hasTextFocus(),[4,this._widget.setSelection(n)]):[2];case 1:return r.sent(),[4,this._gotoReference(n)];case 2:return r.sent(),o&&this._editor.focus(),[2]}})})},e.prototype.closeWidget=function(){this._widget&&(o.dispose(this._widget),this._widget=void 0),this._referenceSearchVisible.reset(),this._disposables.clear(),this._model&&(o.dispose(this._model),this._model=void 0),this._editor.focus(),this._requestIdPool+=1},e.prototype._gotoReference=function(e){var t=this;this._widget&&this._widget.hide(),this._ignoreModelChangeEvent=!0;var i=g.Range.lift(e.range).collapseToStart();return this._editorService.openCodeEditor({resource:e.uri,options:{selection:i}},this._editor).then(function(e){t._ignoreModelChangeEvent=!1,e&&e===t._editor?t._widget&&(t._widget.show(i),t._widget.focus()):t.closeWidget()},function(e){t._ignoreModelChangeEvent=!1,n.onUnexpectedError(e)})},e.prototype.openReference=function(e,t){t||this.closeWidget();var i=e.uri,n=e.range;this._editorService.openCodeEditor({resource:i,
options:{selection:n}},this._editor,t)},e.ID="editor.contrib.referencesController",e=d([c(2,u.IContextKeyService),c(3,r.ICodeEditorService),c(4,v.INotificationService),c(5,s.IInstantiationService),c(6,p.IStorageService),c(7,h.IConfigurationService)],e)}();t.ReferencesController=_}),define(t[226],i([1,0,43,15,38,18,11,31,3,21,17,107,96,148,97,336,59,14,34,110,210,32,61,497]),function(e,t,i,n,o,s,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var D=function(){return function(e,t,i,n){void 0===e&&(e=!1),void 0===t&&(t=!1),void 0===i&&(i=!0),void 0===n&&(n=!0),this.openToSide=e,this.openInPeek=t,this.filterCurrent=i,this.showMessage=n}}();t.DefinitionActionConfig=D;var I=function(e){function t(t,i){var n=e.call(this,i)||this;return n._configuration=t,n}return r(t,e),t.prototype.run=function(e,t){var i=this;if(!t.hasModel())return Promise.resolve(void 0)
;var o=e.get(C.INotificationService),r=e.get(d.ICodeEditorService),s=e.get(S.IEditorProgressService),u=e.get(x.ISymbolNavigationService),h=t.getModel(),p=t.getPosition(),g=new L.EditorStateCancellationTokenSource(t,5),m=n.raceCancellation(this._getTargetLocationForPosition(h,p,g.token),g.token).then(function(e){return a(i,void 0,void 0,function(){var i,n,o,s,a,d,g,m;return l(this,function(l){if(!e||h.isDisposed())return[2];for(i=-1,n=[],o=0,s=e;o<s.length;o++)(a=s[o])&&a.range&&(d=n.push(a),this._configuration.filterCurrent&&a.uri.toString()===h.uri.toString()&&c.Range.containsPosition(a.range,p)&&-1===i&&(i=d-1));return 0!==n.length?1===n.length&&-1!==i?(m=n[0],[2,this._openReference(t,r,m,!1).then(function(){})]):[2,this._onResult(r,u,t,new v.ReferencesModel(n))]:(this._configuration.showMessage&&(g=h.getWordAtPosition(p),f.MessageController.get(t).showMessage(this._getNoResultFoundMessage(g),p)),[2])})})},function(e){o.error(e)}).finally(function(){g.dispose()});return s.showWhile(m,250),m},
t.prototype._getTargetLocationForPosition=function(e,t,i){return w.getDefinitionsAtPosition(e,t,i)},t.prototype._getNoResultFoundMessage=function(e){return e&&e.word?_.localize(0,null,e.word):_.localize(1,null)},t.prototype._getMetaTitle=function(e){return e.references.length>1?_.localize(2,null,e.references.length):""},t.prototype._onResult=function(e,t,n,o){return a(this,void 0,void 0,function(){var r,s,a,u;return l(this,function(l){switch(l.label){case 0:return r=o.getAriaMessage(),i.alert(r),s=n.getConfiguration().contribInfo.gotoLocation,this._configuration.openInPeek||"peek"===s.multiple&&o.references.length>1?(this._openInPeek(e,n,o),[3,3]):[3,1];case 1:return n.hasModel()?(a=o.firstReference())?[4,this._openReference(n,e,a,this._configuration.openToSide)]:[2]:[3,3];case 2:(u=l.sent())&&o.references.length>1&&"gotoAndPeek"===s.multiple?this._openInPeek(e,u,o):o.dispose(),"goto"===s.multiple&&t.put(a),l.label=3;case 3:return[2]}})})},t.prototype._openReference=function(e,t,i,n){var o=void 0
;return p.isLocationLink(i)&&(o=i.targetSelectionRange),o||(o=i.range),t.openCodeEditor({resource:i.uri,options:{selection:c.Range.collapseToStart(o),revealInCenterIfOutsideViewport:!0}},e,n)},t.prototype._openInPeek=function(e,t,i){var o=this,r=m.ReferencesController.get(t);r&&t.hasModel()?r.toggleWidget(t.getSelection(),n.createCancelablePromise(function(e){return Promise.resolve(i)}),{getMetaTitle:function(e){return o._getMetaTitle(e)},onGoto:function(i){return r.closeWidget(),o._openReference(t,e,i,!1)}}):i.dispose()},t}(u.EditorAction);t.DefinitionAction=I;var N=s.isWeb?2118:70,M=function(e){function t(){var i=e.call(this,new D,{id:t.id,label:_.localize(3,null),alias:"Go to Definition",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasDefinitionProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:N,weight:100},menuOpts:{group:"navigation",order:1.1}})||this
;return E.CommandsRegistry.registerCommandAlias("editor.action.goToDeclaration",t.id),i}return r(t,e),t.id="editor.action.revealDefinition",t}(I);t.GoToDefinitionAction=M;var k=function(e){function t(){var i=e.call(this,new D(!0),{id:t.id,label:_.localize(4,null),alias:"Open Definition to the Side",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasDefinitionProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:o.KeyChord(2089,N),weight:100}})||this;return E.CommandsRegistry.registerCommandAlias("editor.action.openDeclarationToTheSide",t.id),i}return r(t,e),t.id="editor.action.revealDefinitionAside",t}(I);t.OpenDefinitionToSideAction=k;var T=function(e){function t(){var i=e.call(this,new D(void 0,!0,!1),{id:t.id,label:_.localize(5,null),alias:"Peek Definition",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasDefinitionProvider,g.PeekContext.notInPeekEditor,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{
kbExpr:h.EditorContextKeys.editorTextFocus,primary:582,linux:{primary:3140},weight:100},menuOpts:{group:"navigation",order:1.2}})||this;return E.CommandsRegistry.registerCommandAlias("editor.action.previewDeclaration",t.id),i}return r(t,e),t.id="editor.action.peekDefinition",t}(I);t.PeekDefinitionAction=T;var R=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._getTargetLocationForPosition=function(e,t,i){return w.getDeclarationsAtPosition(e,t,i)},t.prototype._getNoResultFoundMessage=function(e){return e&&e.word?_.localize(6,null,e.word):_.localize(7,null)},t.prototype._getMetaTitle=function(e){return e.references.length>1?_.localize(8,null,e.references.length):""},t}(I);t.DeclarationAction=R;var O=function(e){function t(){return e.call(this,new D,{id:t.id,label:_.localize(9,null),alias:"Go to Declaration",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasDeclarationProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),menuOpts:{group:"navigation",
order:1.3}})||this}return r(t,e),t.prototype._getNoResultFoundMessage=function(e){return e&&e.word?_.localize(10,null,e.word):_.localize(11,null)},t.prototype._getMetaTitle=function(e){return e.references.length>1?_.localize(12,null,e.references.length):""},t.id="editor.action.revealDeclaration",t}(R);t.GoToDeclarationAction=O;var P=function(e){function t(){return e.call(this,new D(void 0,!0,!1),{id:"editor.action.peekDeclaration",label:_.localize(13,null),alias:"Peek Declaration",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasDeclarationProvider,g.PeekContext.notInPeekEditor,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),menuOpts:{group:"navigation",order:1.31}})||this}return r(t,e),t}(R);t.PeekDeclarationAction=P;var A=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._getTargetLocationForPosition=function(e,t,i){return w.getImplementationsAtPosition(e,t,i)},t.prototype._getNoResultFoundMessage=function(e){
return e&&e.word?_.localize(14,null,e.word):_.localize(15,null)},t.prototype._getMetaTitle=function(e){return e.references.length>1?_.localize(16,null,e.references.length):""},t}(I);t.ImplementationAction=A;var F=function(e){function t(){return e.call(this,new D,{id:t.ID,label:_.localize(17,null),alias:"Go to Implementation",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasImplementationProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:2118,weight:100}})||this}return r(t,e),t.ID="editor.action.goToImplementation",t}(A);t.GoToImplementationAction=F;var W=function(e){function t(){return e.call(this,new D(!1,!0,!1),{id:t.ID,label:_.localize(18,null),alias:"Peek Implementation",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasImplementationProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:3142,weight:100}})||this}return r(t,e),
t.ID="editor.action.peekImplementation",t}(A);t.PeekImplementationAction=W;var V=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype._getTargetLocationForPosition=function(e,t,i){return w.getTypeDefinitionsAtPosition(e,t,i)},t.prototype._getNoResultFoundMessage=function(e){return e&&e.word?_.localize(19,null,e.word):_.localize(20,null)},t.prototype._getMetaTitle=function(e){return e.references.length>1?_.localize(21,null,e.references.length):""},t}(I);t.TypeDefinitionAction=V;var B=function(e){function t(){return e.call(this,new D,{id:t.ID,label:_.localize(22,null),alias:"Go to Type Definition",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasTypeDefinitionProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:0,weight:100},menuOpts:{group:"navigation",order:1.4}})||this}return r(t,e),t.ID="editor.action.goToTypeDefinition",t}(V);t.GoToTypeDefinitionAction=B;var H=function(e){function t(){
return e.call(this,new D(!1,!0,!1),{id:t.ID,label:_.localize(23,null),alias:"Peek Type Definition",precondition:b.ContextKeyExpr.and(h.EditorContextKeys.hasTypeDefinitionProvider,h.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:0,weight:100}})||this}return r(t,e),t.ID="editor.action.peekTypeDefinition",t}(V);t.PeekTypeDefinitionAction=H,u.registerEditorAction(M),u.registerEditorAction(k),u.registerEditorAction(T),u.registerEditorAction(O),u.registerEditorAction(P),u.registerEditorAction(F),u.registerEditorAction(W),u.registerEditorAction(B),u.registerEditorAction(H),y.MenuRegistry.appendMenuItem(16,{group:"4_symbol_nav",command:{id:"editor.action.goToDeclaration",title:_.localize(24,null)},order:2}),y.MenuRegistry.appendMenuItem(16,{group:"4_symbol_nav",command:{id:"editor.action.goToTypeDefinition",title:_.localize(25,null)},order:3}),y.MenuRegistry.appendMenuItem(16,{group:"4_symbol_nav",command:{id:"editor.action.goToImplementation",
title:_.localize(26,null)},order:4})}),define(t[580],i([1,0,337,15,10,78,70,3,17,11,210,2,76,16,22,61,226,177,13,23,172]),function(e,t,i,n,o,r,s,a,l,u,h,p,f,g,m,v,_,y,b,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var S=function(){function e(e,t,i){var n=this;this.textModelResolverService=t,this.modeService=i,this.toUnhook=new p.DisposableStore,this.decorations=[],this.currentWordUnderMouse=null,this.previousPromise=null,this.editor=e;var r=new y.ClickLinkGesture(e);this.toUnhook.add(r),this.toUnhook.add(r.onMouseMoveOrRelevantKeyDown(function(e){var t=e[0],i=e[1];n.startFindDefinition(t,C.withNullAsUndefined(i))})),this.toUnhook.add(r.onExecute(function(e){n.isEnabled(e)&&n.gotoDefinition(e.target,e.hasSideBySideModifier).then(function(){n.removeDecorations()},function(e){n.removeDecorations(),o.onUnexpectedError(e)})})),this.toUnhook.add(r.onCancel(function(){n.removeDecorations(),n.currentWordUnderMouse=null}))}return e.prototype.startFindDefinition=function(e,t){var s=this
;if(!(9===e.target.type&&this.decorations.length>0)){if(!this.editor.hasModel()||!this.isEnabled(e,t))return this.currentWordUnderMouse=null,void this.removeDecorations();var l=e.target.position?this.editor.getModel().getWordAtPosition(e.target.position):null;if(!l)return this.currentWordUnderMouse=null,void this.removeDecorations();var u=e.target.position;if(!this.currentWordUnderMouse||this.currentWordUnderMouse.startColumn!==l.startColumn||this.currentWordUnderMouse.endColumn!==l.endColumn||this.currentWordUnderMouse.word!==l.word){this.currentWordUnderMouse=l;var d=new v.EditorState(this.editor,15);this.previousPromise&&(this.previousPromise.cancel(),this.previousPromise=null),this.previousPromise=n.createCancelablePromise(function(t){return s.findDefinition(e.target,t)}),this.previousPromise.then(function(e){
if(e&&e.length&&d.validate(s.editor))if(e.length>1)s.addDecoration(new a.Range(u.lineNumber,l.startColumn,u.lineNumber,l.endColumn),(new r.MarkdownString).appendText(i.localize(0,null,e.length)));else{var t=e[0];if(!t.uri)return;s.textModelResolverService.createModelReference(t.uri).then(function(e){if(e.object&&e.object.textEditorModel){var i=e.object.textEditorModel,n=t.range.startLineNumber;if(n<1||n>i.getLineCount())e.dispose();else{var o,d=s.getPreviewValue(i,n,t);o=t.originSelectionRange?a.Range.lift(t.originSelectionRange):new a.Range(u.lineNumber,l.startColumn,u.lineNumber,l.endColumn);var c=s.modeService.getModeIdByFilepathOrFirstLine(i.uri);s.addDecoration(o,(new r.MarkdownString).appendCodeblock(c||"",d)),e.dispose()}}else e.dispose()})}else s.removeDecorations()}).then(void 0,o.onUnexpectedError)}}},e.prototype.getPreviewValue=function(t,i,n){var o=n.targetSelectionRange?n.range:this.getPreviewRangeBasedOnBrackets(t,i)
;o.endLineNumber-o.startLineNumber>=e.MAX_SOURCE_PREVIEW_LINES&&(o=this.getPreviewRangeBasedOnIndentation(t,i));return this.stripIndentationFromPreviewRange(t,i,o)},e.prototype.stripIndentationFromPreviewRange=function(e,t,i){for(var n=e.getLineFirstNonWhitespaceColumn(t),o=t+1;o<i.endLineNumber;o++){var r=e.getLineFirstNonWhitespaceColumn(o);n=Math.min(n,r)}return e.getValueInRange(i).replace(new RegExp("^\\s{"+(n-1)+"}","gm"),"").trim()},e.prototype.getPreviewRangeBasedOnIndentation=function(t,i){for(var n=t.getLineFirstNonWhitespaceColumn(i),o=Math.min(t.getLineCount(),i+e.MAX_SOURCE_PREVIEW_LINES),r=i+1;r<o;r++){if(n===t.getLineFirstNonWhitespaceColumn(r))break}return new a.Range(i,1,r+1,1)},e.prototype.getPreviewRangeBasedOnBrackets=function(t,i){for(var n=Math.min(t.getLineCount(),i+e.MAX_SOURCE_PREVIEW_LINES),o=[],r=!0,s=t.findNextBracket(new b.Position(i,1));null!==s;){if(0===o.length)o.push(s);else{var l=o[o.length-1];if(l.open===s.open&&l.isOpen&&!s.isOpen?o.pop():o.push(s),0===o.length){
if(!r)return new a.Range(i,1,s.range.endLineNumber+1,1);r=!1}}var u=t.getLineMaxColumn(i),d=s.range.endLineNumber,c=s.range.endColumn;if(u===s.range.endColumn&&(d++,c=1),d>n)return new a.Range(i,1,n+1,1);s=t.findNextBracket(new b.Position(d,c))}return new a.Range(i,1,n+1,1)},e.prototype.addDecoration=function(e,t){var i={range:e,options:{inlineClassName:"goto-definition-link",hoverMessage:t}};this.decorations=this.editor.deltaDecorations(this.decorations,[i])},e.prototype.removeDecorations=function(){this.decorations.length>0&&(this.decorations=this.editor.deltaDecorations(this.decorations,[]))},e.prototype.isEnabled=function(e,t){return this.editor.hasModel()&&e.isNoneOrSingleMouseDown&&6===e.target.type&&(e.hasTriggerModifier||!!t&&t.keyCodeIsTriggerKey)&&l.DefinitionProviderRegistry.has(this.editor.getModel())},e.prototype.findDefinition=function(e,t){var i=this.editor.getModel();return i?h.getDefinitionsAtPosition(i,e.position,t):Promise.resolve(null)},e.prototype.gotoDefinition=function(e,t){var i=this
;this.editor.setPosition(e.position);var n=new _.DefinitionAction(new _.DefinitionActionConfig(t,!1,!0,!1),{alias:"",label:"",id:"",precondition:void 0});return this.editor.invokeWithinContext(function(e){return n.run(e,i.editor)})},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.toUnhook.dispose()},e.ID="editor.contrib.gotodefinitionwithmouse",e.MAX_SOURCE_PREVIEW_LINES=8,e=d([c(1,f.ITextModelService),c(2,s.IModeService)],e)}();u.registerEditorContribution(S),g.registerThemingParticipant(function(e,t){var i=e.getColor(m.editorActiveLinkForeground);i&&t.addRule(".monaco-editor .goto-definition-link { color: "+i+" !important; }")})}),define(t[581],i([1,0,351,14,84,13,11,17,3,96,148,97,15,10,21,153,101,131,118,32,24,31,26,19]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x){"use strict";function D(e,t){I(e,function(e){return e.closeWidget()})}function I(e,t){var i=h.getOuterEditor(e);if(i){var n=p.ReferencesController.get(i);n&&t(n)}}function N(e,t,i){
var n=l.ReferenceProviderRegistry.ordered(e).map(function(n){return Promise.resolve(n.provideReferences(e,t,{includeDeclaration:!0},i)).then(function(e){if(Array.isArray(e))return e},function(e){m.onUnexpectedExternalError(e)})});return Promise.all(n).then(function(e){return x.flatten(x.coalesce(e))})}Object.defineProperty(t,"__esModule",{value:!0}),t.defaultReferenceSearchOptions={getMetaTitle:function(e){return e.references.length>1?i.localize(0,null,e.references.length):""}};var M=function(){function e(e,t){e instanceof _.EmbeddedCodeEditorWidget&&h.PeekContext.inPeekEditor.bindTo(t)}return e.prototype.dispose=function(){},e.prototype.getId=function(){return e.ID},e.ID="editor.contrib.referenceController",e=d([c(1,n.IContextKeyService)],e)}();t.ReferenceController=M;var k=function(e){function o(){return e.call(this,{id:"editor.action.referenceSearch.trigger",label:i.localize(1,null),alias:"Peek References",
precondition:n.ContextKeyExpr.and(v.EditorContextKeys.hasReferenceProvider,h.PeekContext.notInPeekEditor,v.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:v.EditorContextKeys.editorTextFocus,primary:1094,weight:100},menuOpts:{group:"navigation",order:1.5}})||this}return r(o,e),o.prototype.run=function(e,i){var n=p.ReferencesController.get(i);if(n&&i.hasModel()){var o=i.getSelection(),r=i.getModel(),s=g.createCancelablePromise(function(e){return N(r,o.getStartPosition(),e).then(function(e){return new f.ReferencesModel(e)})});n.toggleWidget(o,s,t.defaultReferenceSearchOptions)}},o}(a.EditorAction);t.ReferenceAction=k,a.registerEditorContribution(M),a.registerEditorAction(k);S.CommandsRegistry.registerCommand({id:"editor.action.findReferences",handler:function(e,i,n){if(!(i instanceof w.URI))throw new Error("illegal argument, uri");if(!n)throw new Error("illegal argument, position");var o=e.get(E.ICodeEditorService);return o.openCodeEditor({resource:i},o.getFocusedCodeEditor()).then(function(e){
if(y.isCodeEditor(e)&&e.hasModel()){var i=p.ReferencesController.get(e);if(i){var o=g.createCancelablePromise(function(t){return N(e.getModel(),s.Position.lift(n),t).then(function(e){return new f.ReferencesModel(e)})}),r=new u.Range(n.lineNumber,n.column,n.lineNumber,n.column);return Promise.resolve(i.toggleWidget(r,o,t.defaultReferenceSearchOptions))}}})}}),S.CommandsRegistry.registerCommand({id:"editor.action.showReferences",handler:function(e,i,n,o){if(!(i instanceof w.URI))throw new Error("illegal argument, uri expected");if(!o)throw new Error("missing references");var r=e.get(E.ICodeEditorService);return r.openCodeEditor({resource:i},r.getFocusedCodeEditor()).then(function(e){if(y.isCodeEditor(e)){var i=p.ReferencesController.get(e);if(i)return i.toggleWidget(new u.Range(n.lineNumber,n.column,n.lineNumber,n.column),g.createCancelablePromise(function(e){return Promise.resolve(new f.ReferencesModel(o))}),t.defaultReferenceSearchOptions)}})},description:{
description:"Show references at a position in a file",args:[{name:"uri",description:"The text document in which to show references",constraint:w.URI},{name:"position",description:"The position at which to show",constraint:s.Position.isIPosition},{name:"locations",description:"An array of locations.",constraint:Array}]}}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToNextReference",weight:250,primary:62,when:p.ctxReferenceSearchVisible,handler:function(e){I(e,function(e){e.goToNextOrPreviousReference(!0)})}}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToNextReferenceFromEmbeddedEditor",weight:150,primary:62,when:h.PeekContext.inPeekEditor,handler:function(e){I(e,function(e){e.goToNextOrPreviousReference(!0)})}}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToPreviousReference",weight:250,primary:1086,when:p.ctxReferenceSearchVisible,handler:function(e){I(e,function(e){e.goToNextOrPreviousReference(!1)})}}),
o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToPreviousReferenceFromEmbeddedEditor",weight:150,primary:1086,when:h.PeekContext.inPeekEditor,handler:function(e){I(e,function(e){e.goToNextOrPreviousReference(!1)})}}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"closeReferenceSearch",weight:250,primary:9,secondary:[1033],when:n.ContextKeyExpr.and(p.ctxReferenceSearchVisible,n.ContextKeyExpr.not("config.editor.stablePeek")),handler:D}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"closeReferenceSearchEditor",weight:-1,primary:9,secondary:[1033],when:n.ContextKeyExpr.and(h.PeekContext.inPeekEditor,n.ContextKeyExpr.not("config.editor.stablePeek")),handler:D}),o.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"openReferenceToSide",weight:100,primary:2051,mac:{primary:259},when:n.ContextKeyExpr.and(p.ctxReferenceSearchVisible,C.ctxReferenceWidgetSearchTreeFocused),handler:function(e,t){var i=e.get(b.IListService),n=i.lastFocusedList&&i.lastFocusedList.getFocus()
;n instanceof f.OneReference&&I(e,function(e){return e.openReference(n,!0)})}}),t.provideReferences=N,a.registerDefaultLanguageCommand("_executeReferenceProvider",function(e,t){return N(e,t,L.CancellationToken.None)})}),define(t[582],i([1,0,11,31,148,39,14,12,34,68]),function(e,t,i,n,o,s,a,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(e){function t(t,i,n,o,r,s,a){return e.call(this,!0,t,i,n,o,r,s,a)||this}return r(t,e),t=d([c(1,a.IContextKeyService),c(2,n.ICodeEditorService),c(3,u.INotificationService),c(4,l.IInstantiationService),c(5,h.IStorageService),c(6,s.IConfigurationService)],t)}(o.ReferencesController);t.StandaloneReferencesController=p,i.registerEditorContribution(p)}),define(t[583],i([1,0,109,16,25]),function(e,t,i,n,o){"use strict";function r(e,t){return"."+s.className(e).split(" ").join(".")+' { background: url("data:image/svg+xml,'+s.getSVGData(e,t)+'") center center no-repeat; height: 16px; width: 16px; }'}Object.defineProperty(t,"__esModule",{value:!0})
;var s,a=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M8.58318 2.02842C9.96435 2.16331 11.2561 2.77279 12.2383 3.75307C13.3643 4.87923 13.9978 6.40584 14 7.99829C14.0004 9.38617 13.5196 10.7313 12.6396 11.8045C11.7595 12.8778 10.5345 13.6127 9.17333 13.8841C7.81215 14.1556 6.39895 13.9467 5.1745 13.2931C3.95005 12.6394 2.99008 11.5815 2.45814 10.2995C1.92619 9.0175 1.85517 7.59072 2.25717 6.26222C2.65917 4.93373 3.50933 3.7857 4.66282 3.0137C5.8163 2.24171 7.20177 1.89351 8.58318 2.02842ZM8.68038 1.03316C10.292 1.19055 11.7993 1.90184 12.9453 3.04585C14.2587 4.35938 14.9976 6.14013 15 7.99764C15.0005 9.61695 14.4396 11.1864 13.4129 12.4385C12.3861 13.6907 10.9569 14.5482 9.36889 14.8648C7.78084 15.1815 6.13211 14.9378 4.70359 14.1752C3.27506 13.4127 2.1551 12.1784 1.53449 10.6828C0.913887 9.18708 0.831027 7.52251 1.30003 5.97259C1.76903 4.42268 2.76089 3.08331 4.10662 2.18265C5.45236 1.28199 7.06873 0.875761 8.68038 1.03316ZM5.52498 5L8.00004 7.47506L10.4751 5L11.1822 5.70711L8.70714 8.18217L11.1818 10.6569L10.4747 11.364L8.00004 8.88927L5.52535 11.364L4.81824 10.6569L7.29293 8.18217L4.81787 5.70711L5.52498 5Z" fill="'),l=encodeURIComponent('"/></svg>'),u=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M8.58318 2.02842C9.96435 2.16331 11.2561 2.77279 12.2383 3.75307C13.3643 4.87923 13.9978 6.40584 14 7.99829C14.0004 9.38617 13.5196 10.7313 12.6396 11.8045C11.7595 12.8778 10.5345 13.6127 9.17333 13.8841C7.81215 14.1556 6.39895 13.9467 5.1745 13.2931C3.95005 12.6394 2.99008 11.5815 2.45814 10.2995C1.92619 9.0175 1.85517 7.59072 2.25717 6.26222C2.65917 4.93373 3.50933 3.7857 4.66282 3.0137C5.8163 2.24171 7.20177 1.89351 8.58318 2.02842ZM8.68038 1.03316C10.292 1.19055 11.7993 1.90184 12.9453 3.04585C14.2587 4.35938 14.9976 6.14013 15 7.99764C15.0005 9.61695 14.4396 11.1864 13.4129 12.4385C12.3861 13.6907 10.9569 14.5482 9.36889 14.8648C7.78084 15.1815 6.13211 14.9378 4.70359 14.1752C3.27506 13.4127 2.1551 12.1784 1.53449 10.6828C0.913887 9.18708 0.831027 7.52251 1.30003 5.97259C1.76903 4.42268 2.76089 3.08331 4.10662 2.18265C5.45236 1.28199 7.06873 0.875761 8.68038 1.03316ZM5.52498 5L8.00004 7.47506L10.4751 5L11.1822 5.70711L8.70714 8.18217L11.1818 10.6569L10.4747 11.364L8.00004 8.88927L5.52535 11.364L4.81824 10.6569L7.29293 8.18217L4.81787 5.70711L5.52498 5Z" fill="'),d=encodeURIComponent('"/></svg>'),c=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M14.12 13.9725L15 12.5L9.37927 2H7.61924L1.9985 12.5L2.87852 13.9725H14.12ZM2.87852 12.9725L8.49925 2.47249L14.12 12.9725H2.87852ZM7.98952 6H8.98802V10H7.98952V6ZM7.98952 11H8.98802V12H7.98952V11Z" fill="'),h=encodeURIComponent('"/></svg>'),p=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M14.12 13.9725L15 12.5L9.37927 2H7.61924L1.9985 12.5L2.87852 13.9725H14.12ZM2.87852 12.9725L8.49925 2.47249L14.12 12.9725H2.87852ZM7.98952 6H8.98802V10H7.98952V6ZM7.98952 11H8.98802V12H7.98952V11Z" fill="'),f=encodeURIComponent('"/></svg>'),g=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M3 7.5C3 4.46243 5.46243 2 8.5 2C11.5376 2 14 4.46243 14 7.5C14 10.5376 11.5376 13 8.5 13C5.46243 13 3 10.5376 3 7.5ZM2 7.5C2 3.91015 4.91015 1 8.5 1C12.0899 1 15 3.91015 15 7.5C15 11.0899 12.0899 14 8.5 14C4.91015 14 2 11.0899 2 7.5ZM8 4V5H9V4H8ZM8 6L8 10H9L9 6H8Z" fill="'),m=encodeURIComponent('"/></svg>'),v=encodeURIComponent('<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M3 7.5C3 4.46243 5.46243 2 8.5 2C11.5376 2 14 4.46243 14 7.5C14 10.5376 11.5376 13 8.5 13C5.46243 13 3 10.5376 3 7.5ZM2 7.5C2 3.91015 4.91015 1 8.5 1C12.0899 1 15 3.91015 15 7.5C15 11.0899 12.0899 14 8.5 14C4.91015 14 2 11.0899 2 7.5ZM8 4V5H9V4H8ZM8 6L8 10H9L9 6H8Z" fill="'),_=encodeURIComponent('"/></svg>')
;!function(e){e.getSVGData=function(e,t){switch(e){case i.default.Ignore:var r=t.type===n.LIGHT?o.Color.fromHex("#75BEFF"):o.Color.fromHex("#007ACC");return t.type===n.LIGHT?g+encodeURIComponent(r.toString())+m:v+encodeURIComponent(r.toString())+_;case i.default.Info:var s=t.type===n.LIGHT?o.Color.fromHex("#007ACC"):o.Color.fromHex("#75BEFF");return t.type===n.LIGHT?g+encodeURIComponent(s.toString())+m:v+encodeURIComponent(s.toString())+_;case i.default.Warning:var y=t.type===n.LIGHT?o.Color.fromHex("#DDB100"):o.Color.fromHex("#fc0");return t.type===n.LIGHT?c+encodeURIComponent(y.toString())+h:p+encodeURIComponent(y.toString())+f;case i.default.Error:var b=t.type===n.LIGHT?o.Color.fromHex("#A1260D"):o.Color.fromHex("#F48771");return t.type===n.LIGHT?a+encodeURIComponent(b.toString())+l:u+encodeURIComponent(b.toString())+d}return""},e.className=function(e){switch(e){case i.default.Ignore:return"severity-icon severity-ignore";case i.default.Info:return"severity-icon severity-info";case i.default.Warning:
return"severity-icon severity-warning";case i.default.Error:return"severity-icon severity-error"}return""}}(s=t.SeverityIcon||(t.SeverityIcon={})),n.registerThemingParticipant(function(e,t){t.addRule(r(i.default.Error,e)),t.addRule(r(i.default.Warning,e)),t.addRule(r(i.default.Info,e)),t.addRule(r(i.default.Ignore,e))})}),define(t[584],i([1,0,340,8,2,69,3,22,16,25,51,203,19,4,96,48,118,583,504]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var y=function(){function e(e,t,i){var o=this;this._lines=0,this._longestLineLength=0,this._relatedDiagnostics=new WeakMap,this._disposables=[],this._editor=t;var r=document.createElement("div");r.className="descriptioncontainer",r.setAttribute("aria-live","assertive"),r.setAttribute("role","alert"),this._messageBlock=document.createElement("div"),n.addClass(this._messageBlock,"message"),r.appendChild(this._messageBlock),this._relatedBlock=document.createElement("div"),r.appendChild(this._relatedBlock),
this._disposables.push(n.addStandardDisposableListener(this._relatedBlock,"click",function(e){e.preventDefault();var t=o._relatedDiagnostics.get(e.target);t&&i(t)})),this._scrollable=new c.ScrollableElement(r,{horizontal:1,vertical:1,useShadows:!1,horizontalScrollbarSize:3,verticalScrollbarSize:3}),e.appendChild(this._scrollable.getDomNode()),this._disposables.push(this._scrollable.onScroll(function(e){r.style.left="-"+e.scrollLeft+"px",r.style.top="-"+e.scrollTop+"px"})),this._disposables.push(this._scrollable)}return e.prototype.dispose=function(){o.dispose(this._disposables)},e.prototype.update=function(e){var t=e.source,i=e.message,o=e.relatedInformation,r=e.code,s=i.split(/\r\n|\r|\n/g);this._lines=s.length,this._longestLineLength=0;for(var a=0,l=s;a<l.length;a++){f=l[a];this._longestLineLength=Math.max(f.length,this._longestLineLength)}n.clearNode(this._messageBlock),this._editor.applyFontInfo(this._messageBlock);for(var u=this._messageBlock,d=0,c=s;d<c.length;d++){var f=c[d]
;(u=document.createElement("div")).innerText=f,""===f&&(u.style.height=this._messageBlock.style.lineHeight),this._messageBlock.appendChild(u)}if(t||r){var g=document.createElement("span");if(n.addClass(g,"details"),u.appendChild(g),t){var m=document.createElement("span");m.innerText=t,n.addClass(m,"source"),g.appendChild(m)}if(r){var v=document.createElement("span");v.innerText="("+r+")",n.addClass(v,"code"),g.appendChild(v)}}if(n.clearNode(this._relatedBlock),this._editor.applyFontInfo(this._relatedBlock),p.isNonEmptyArray(o)){var _=this._relatedBlock.appendChild(document.createElement("div"));_.style.paddingTop=Math.floor(.66*this._editor.getConfiguration().lineHeight)+"px",this._lines+=1;for(var y=0,b=o;y<b.length;y++){var C=b[y],S=document.createElement("div"),w=document.createElement("a");n.addClass(w,"filename"),w.innerHTML=h.getBaseLabel(C.resource)+"("+C.startLineNumber+", "+C.startColumn+"): ",w.title=h.getPathLabel(C.resource,void 0),this._relatedDiagnostics.set(w,C)
;var E=document.createElement("span");E.innerText=C.message,S.appendChild(w),S.appendChild(E),this._lines+=1,_.appendChild(S)}}var L=this._editor.getConfiguration().fontInfo,x=Math.ceil(L.typicalFullwidthCharacterWidth*this._longestLineLength*.75),D=L.lineHeight*this._lines;this._scrollable.setScrollDimensions({scrollWidth:x,scrollHeight:D})},e.prototype.layout=function(e,t){this._scrollable.getDomNode().style.height=e+"px",this._scrollable.getDomNode().style.width=t+"px",this._scrollable.setScrollDimensions({width:t,height:e})},e.prototype.getHeightInLines=function(){return Math.min(17,this._lines)},e}(),b=function(e){function l(t,i,n){var r=e.call(this,t,{showArrow:!0,showFrame:!0,isAccessible:!0})||this;return r.actions=i,r._themeService=n,r._callOnDispose=new o.DisposableStore,r._onDidSelectRelatedInformation=new f.Emitter,r.onDidSelectRelatedInformation=r._onDidSelectRelatedInformation.event,r._severity=s.MarkerSeverity.Warning,r._backgroundColor=d.Color.white,r._applyTheme(n.getTheme()),
r._callOnDispose.add(n.onThemeChange(r._applyTheme.bind(r))),r.create(),r}return r(l,e),l.prototype._applyTheme=function(e){this._backgroundColor=e.getColor(t.editorMarkerNavigationBackground);var i=t.editorMarkerNavigationError;this._severity===s.MarkerSeverity.Warning?i=t.editorMarkerNavigationWarning:this._severity===s.MarkerSeverity.Info&&(i=t.editorMarkerNavigationInfo);var n=e.getColor(i);this.style({arrowColor:n,frameColor:n,headerBackgroundColor:this._backgroundColor,primaryHeadingColor:e.getColor(v.peekViewTitleForeground),secondaryHeadingColor:e.getColor(v.peekViewTitleInfoForeground)})},l.prototype._applyStyles=function(){this._parentContainer&&(this._parentContainer.style.backgroundColor=this._backgroundColor?this._backgroundColor.toString():""),e.prototype._applyStyles.call(this)},l.prototype.dispose=function(){this._callOnDispose.dispose(),e.prototype.dispose.call(this)},l.prototype._fillHead=function(t){e.prototype._fillHead.call(this,t),this._actionbarWidget.push(this.actions,{label:!1,icon:!0
})},l.prototype._fillTitleIcon=function(e){this._icon=n.append(e,n.$(""))},l.prototype._getActionBarOptions=function(){return{orientation:1}},l.prototype._fillBody=function(e){var t=this;this._parentContainer=e,n.addClass(e,"marker-widget"),this._parentContainer.tabIndex=0,this._parentContainer.setAttribute("role","tooltip"),this._container=document.createElement("div"),e.appendChild(this._container),this._message=new y(this._container,this.editor,function(e){return t._onDidSelectRelatedInformation.fire(e)}),this._disposables.add(this._message)},l.prototype.show=function(e,t){throw new Error("call showAtMarker")},l.prototype.showAtMarker=function(t,n,o){this._container.classList.remove("stale"),this._message.update(t),this._severity=t.severity,this._applyTheme(this._themeService.getTheme());var r=a.Range.lift(t),l=this.editor.getPosition(),u=l&&r.containsPosition(l)?l:r.getStartPosition();e.prototype.show.call(this,u,this.computeRequiredHeight());var d=this.editor.getModel();if(d){
var c=o>1?i.localize(0,null,n,o):i.localize(1,null,n,o);this.setTitle(m.basename(d.uri),c)}this._icon.className=_.SeverityIcon.className(s.MarkerSeverity.toSeverity(this._severity)),this.editor.revealPositionInCenter(u,0)},l.prototype.updateMarker=function(e){this._container.classList.remove("stale"),this._message.update(e)},l.prototype.showStale=function(){this._container.classList.add("stale"),this._relayout()},l.prototype._doLayoutBody=function(t,i){e.prototype._doLayoutBody.call(this,t,i),this._heightInPixel=t,this._message.layout(t,i),this._container.style.height=t+"px"},l.prototype._onWidth=function(e){this._message.layout(this._heightInPixel,e)},l.prototype._relayout=function(){e.prototype._relayout.call(this,this.computeRequiredHeight())},l.prototype.computeRequiredHeight=function(){return 3+this._message.getHeightInLines()},l}(g.PeekViewWidget);t.MarkerNavigationWidget=b
;var C=l.oneOf(l.editorErrorForeground,l.editorErrorBorder),S=l.oneOf(l.editorWarningForeground,l.editorWarningBorder),w=l.oneOf(l.editorInfoForeground,l.editorInfoBorder);t.editorMarkerNavigationError=l.registerColor("editorMarkerNavigationError.background",{dark:C,light:C,hc:C},i.localize(2,null)),t.editorMarkerNavigationWarning=l.registerColor("editorMarkerNavigationWarning.background",{dark:S,light:S,hc:S},i.localize(3,null)),t.editorMarkerNavigationInfo=l.registerColor("editorMarkerNavigationInfo.background",{dark:w,light:w,hc:w},i.localize(4,null)),t.editorMarkerNavigationBackground=l.registerColor("editorMarkerNavigation.background",{dark:"#2D2D30",light:d.Color.white,hc:"#0C141F"},i.localize(5,null)),u.registerThemingParticipant(function(e,t){var i=e.getColor(l.textLinkForeground);i&&t.addRule(".monaco-editor .marker-widget a { color: "+i+"; }")})}),define(t[227],i([1,0,339,4,2,14,69,3,11,16,21,584,5,19,31,10,59,58,33]),function(e,t,i,n,o,s,u,h,p,f,g,m,v,_,y,b,C,S,w){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var E=function(){function e(e,t){var i=this;this._toUnbind=new o.DisposableStore,this._editor=e,this._markers=[],this._nextIdx=-1,this._ignoreSelectionChange=!1,this._onCurrentMarkerChanged=new n.Emitter,this._onMarkerSetChanged=new n.Emitter,this.setMarkers(t),this._toUnbind.add(this._editor.onDidDispose(function(){return i.dispose()})),this._toUnbind.add(this._editor.onDidChangeCursorPosition(function(){i._ignoreSelectionChange||i.currentMarker&&i._editor.getPosition()&&h.Range.containsPosition(i.currentMarker,i._editor.getPosition())||(i._nextIdx=-1)}))}return Object.defineProperty(e.prototype,"onCurrentMarkerChanged",{get:function(){return this._onCurrentMarkerChanged.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMarkerSetChanged",{get:function(){return this._onMarkerSetChanged.event},enumerable:!0,configurable:!0}),e.prototype.setMarkers=function(e){var t=this._nextIdx>=0?this._markers[this._nextIdx]:void 0
;this._markers=e||[],this._markers.sort(x.compareMarker),this._nextIdx=t?Math.max(-1,_.binarySearch(this._markers,t,x.compareMarker)):-1,this._onMarkerSetChanged.fire(this)},e.prototype.withoutWatchingEditorPosition=function(e){this._ignoreSelectionChange=!0;try{e()}finally{this._ignoreSelectionChange=!1}},e.prototype._initIdx=function(e){for(var t=!1,i=this._editor.getPosition(),n=0;n<this._markers.length;n++){var o=h.Range.lift(this._markers[n]);if(o.isEmpty()&&this._editor.getModel()){var r=this._editor.getModel().getWordAtPosition(o.getStartPosition());r&&(o=new h.Range(o.startLineNumber,r.startColumn,o.startLineNumber,r.endColumn))}if(i&&(o.containsPosition(i)||i.isBeforeOrEqual(o.getStartPosition()))){this._nextIdx=n,t=!0;break}}t||(this._nextIdx=e?0:this._markers.length-1),this._nextIdx<0&&(this._nextIdx=this._markers.length-1)},Object.defineProperty(e.prototype,"currentMarker",{get:function(){return this.canNavigate()?this._markers[this._nextIdx]:void 0},set:function(e){var t=this._nextIdx
;this._nextIdx=-1,e&&(this._nextIdx=this.indexOf(e)),this._nextIdx!==t&&this._onCurrentMarkerChanged.fire(e)},enumerable:!0,configurable:!0}),e.prototype.move=function(e,t){if(!this.canNavigate())return this._onCurrentMarkerChanged.fire(void 0),!t;var i=this._nextIdx,n=!1;if(-1===this._nextIdx?this._initIdx(e):e?t||this._nextIdx+1<this._markers.length?this._nextIdx=(this._nextIdx+1)%this._markers.length:n=!0:e||(t||this._nextIdx>0?this._nextIdx=(this._nextIdx-1+this._markers.length)%this._markers.length:n=!0),i!==this._nextIdx){var o=this._markers[this._nextIdx];this._onCurrentMarkerChanged.fire(o)}return n},e.prototype.canNavigate=function(){return this._markers.length>0},e.prototype.findMarkerAtPosition=function(e){for(var t=0,i=this._markers;t<i.length;t++){var n=i[t];if(h.Range.containsPosition(n,e))return n}},Object.defineProperty(e.prototype,"total",{get:function(){return this._markers.length},enumerable:!0,configurable:!0}),e.prototype.indexOf=function(e){return 1+this._markers.indexOf(e)},
e.prototype.dispose=function(){this._toUnbind.dispose()},e}(),L=function(){function e(e,t,i,n,r,s){this._markerService=t,this._contextKeyService=i,this._themeService=n,this._editorService=r,this._keybindingService=s,this._model=null,this._widget=null,this._disposeOnClose=new o.DisposableStore,this._editor=e,this._widgetVisible=k.bindTo(this._contextKeyService)}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._cleanUp(),this._disposeOnClose.dispose()},e.prototype._cleanUp=function(){this._widgetVisible.reset(),this._disposeOnClose.clear(),this._widget=null,this._model=null},e.prototype.getOrCreateModel=function(){var e=this;if(this._model)return this._model;var t=this._getMarkers();this._model=new E(this._editor,t),this._markerService.onMarkerChanged(this._onMarkerChanged,this,this._disposeOnClose)
;var i=this._keybindingService.lookupKeybinding(I.ID),n=this._keybindingService.lookupKeybinding(D.ID),o=[new S.Action(I.ID,I.LABEL+(i?" ("+i.getLabel()+")":""),"show-previous-problem chevron-up",this._model.canNavigate(),function(){return a(e,void 0,void 0,function(){return l(this,function(e){return this._model&&this._model.move(!1,!0),[2]})})}),new S.Action(D.ID,D.LABEL+(n?" ("+n.getLabel()+")":""),"show-next-problem chevron-down",this._model.canNavigate(),function(){return a(e,void 0,void 0,function(){return l(this,function(e){return this._model&&this._model.move(!0,!0),[2]})})})];this._widget=new m.MarkerNavigationWidget(this._editor,o,this._themeService),this._widgetVisible.set(!0),this._widget.onDidClose(function(){return e._cleanUp()},this,this._disposeOnClose),this._disposeOnClose.add(this._model),this._disposeOnClose.add(this._widget);for(var r=0,s=o;r<s.length;r++){var u=s[r];this._disposeOnClose.add(u)}return this._disposeOnClose.add(this._widget.onDidSelectRelatedInformation(function(t){
e._editorService.openCodeEditor({resource:t.resource,options:{pinned:!0,revealIfOpened:!0,selection:h.Range.lift(t).collapseToStart()}},e._editor).then(void 0,b.onUnexpectedError),e.closeMarkersNavigation(!1)})),this._disposeOnClose.add(this._editor.onDidChangeModel(function(){return e._cleanUp()})),this._disposeOnClose.add(this._model.onCurrentMarkerChanged(function(t){t&&e._model?e._model.withoutWatchingEditorPosition(function(){e._widget&&e._model&&e._widget.showAtMarker(t,e._model.indexOf(t),e._model.total)}):e._cleanUp()})),this._disposeOnClose.add(this._model.onMarkerSetChanged(function(){if(e._widget&&e._widget.position&&e._model){var t=e._model.findMarkerAtPosition(e._widget.position);t?e._widget.updateMarker(t):e._widget.showStale()}})),this._model},e.prototype.closeMarkersNavigation=function(e){void 0===e&&(e=!0),this._cleanUp(),e&&this._editor.focus()},e.prototype.show=function(e){this.getOrCreateModel().currentMarker=e},e.prototype._onMarkerChanged=function(e){var t=this._editor.getModel()
;t&&this._model&&e.some(function(e){return t.uri.toString()===e.toString()})&&this._model.setMarkers(this._getMarkers())},e.prototype._getMarkers=function(){var e=this._editor.getModel();return e?this._markerService.read({resource:e.uri,severities:u.MarkerSeverity.Error|u.MarkerSeverity.Warning|u.MarkerSeverity.Info}):[]},e.ID="editor.contrib.markerController",e=d([c(1,u.IMarkerService),c(2,s.IContextKeyService),c(3,f.IThemeService),c(4,y.ICodeEditorService),c(5,w.IKeybindingService)],e)}();t.MarkerController=L;var x=function(e){function t(t,i,n){var o=e.call(this,n)||this;return o._isNext=t,o._multiFile=i,o}return r(t,e),t.prototype.run=function(e,i){var n=this,o=e.get(u.IMarkerService),r=e.get(y.ICodeEditorService),s=L.get(i);if(!s)return Promise.resolve(void 0);var a=s.getOrCreateModel();if(!a.move(this._isNext,!this._multiFile)||!this._multiFile)return Promise.resolve(void 0);var l=o.read({severities:u.MarkerSeverity.Error|u.MarkerSeverity.Warning|u.MarkerSeverity.Info}).sort(t.compareMarker)
;if(0===l.length)return Promise.resolve(void 0);var d=i.getModel();if(!d)return Promise.resolve(void 0);var c=a.currentMarker||{resource:d.uri,severity:u.MarkerSeverity.Error,startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1},h=_.binarySearch(l,c,t.compareMarker);h<0?(h=~h,h%=l.length):h=this._isNext?(h+1)%l.length:(h+l.length-1)%l.length;var p=l[h];return p.resource.toString()===d.uri.toString()?(a.move(this._isNext,!0),Promise.resolve(void 0)):(s.closeMarkersNavigation(),r.openCodeEditor({resource:p.resource,options:{pinned:!1,revealIfOpened:!0,revealInCenterIfOutsideViewport:!0,selection:p}},i).then(function(e){if(e)return e.getAction(n.id).run()}))},t.compareMarker=function(e,t){var i=v.compare(e.resource.toString(),t.resource.toString());return 0===i&&(i=u.MarkerSeverity.compare(e.severity,t.severity)),0===i&&(i=h.Range.compareRangesUsingStarts(e,t)),i},t}(p.EditorAction),D=function(e){function t(){return e.call(this,!0,!1,{id:t.ID,label:t.LABEL,
alias:"Go to Next Problem (Error, Warning, Info)",precondition:g.EditorContextKeys.writable,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:578,weight:100}})||this}return r(t,e),t.ID="editor.action.marker.next",t.LABEL=i.localize(0,null),t}(x);t.NextMarkerAction=D;var I=function(e){function t(){return e.call(this,!1,!1,{id:t.ID,label:t.LABEL,alias:"Go to Previous Problem (Error, Warning, Info)",precondition:g.EditorContextKeys.writable,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:1602,weight:100}})||this}return r(t,e),t.ID="editor.action.marker.prev",t.LABEL=i.localize(1,null),t}(x),N=function(e){function t(){return e.call(this,!0,!0,{id:"editor.action.marker.nextInFiles",label:i.localize(2,null),alias:"Go to Next Problem in Files (Error, Warning, Info)",precondition:g.EditorContextKeys.writable,kbOpts:{kbExpr:g.EditorContextKeys.focus,primary:66,weight:100}})||this}return r(t,e),t}(x),M=function(e){function t(){return e.call(this,!1,!0,{id:"editor.action.marker.prevInFiles",
label:i.localize(3,null),alias:"Go to Previous Problem in Files (Error, Warning, Info)",precondition:g.EditorContextKeys.writable,kbOpts:{kbExpr:g.EditorContextKeys.focus,primary:1090,weight:100}})||this}return r(t,e),t}(x);p.registerEditorContribution(L),p.registerEditorAction(D),p.registerEditorAction(I),p.registerEditorAction(N),p.registerEditorAction(M);var k=new s.RawContextKey("markersNavigationVisible",!1),T=p.EditorCommand.bindToContribution(L.get);p.registerEditorCommand(new T({id:"closeMarkersNavigation",precondition:k,handler:function(e){return e.closeMarkersNavigation()},kbOpts:{weight:150,kbExpr:g.EditorContextKeys.focus,primary:9,secondary:[1033]}})),C.MenuRegistry.appendMenuItem(16,{group:"6_problem_nav",command:{id:"editor.action.marker.nextInFiles",title:i.localize(4,null)},order:1}),C.MenuRegistry.appendMenuItem(16,{group:"6_problem_nav",command:{id:"editor.action.marker.prevInFiles",title:i.localize(5,null)},order:2})}),
define(t[586],i([1,0,342,8,26,25,78,2,13,3,30,17,208,209,246,546,498,178,179,111,19,69,48,10,55,227,15,206,223,130]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var k=n.$,T=function(){return function(e,t,i){this.range=e,this.color=t,this.provider=i}}(),R=function(){return function(e,t){this.range=e,this.marker=t}}(),O=function(){function e(e,t){this._markerDecorationsService=t,this._editor=e,this._result=[]}return e.prototype.setRange=function(e){this._range=e,this._result=[]},e.prototype.clearResult=function(){this._result=[]},e.prototype.computeAsync=function(e){if(!this._editor.hasModel()||!this._range)return Promise.resolve([]);var t=this._editor.getModel();return h.HoverProviderRegistry.has(t)?v.getHover(t,new u.Position(this._range.startLineNumber,this._range.startColumn),e):Promise.resolve([])},e.prototype.computeSync=function(){var e=this;if(!this._editor.hasModel()||!this._range)return[]
;var t=this._editor.getModel(),i=this._range.startLineNumber;if(i>this._editor.getModel().getLineCount())return[];var n=f.ColorDetector.get(this._editor),o=t.getLineMaxColumn(i),r=this._editor.getLineDecorations(i),s=!1,l=this._range,u=r.map(function(r){var u=r.range.startLineNumber===i?r.range.startColumn:1,c=r.range.endLineNumber===i?r.range.endColumn:o;if(u>l.startColumn||l.endColumn>c)return null;var h=new d.Range(l.startLineNumber,u,l.startLineNumber,c),p=e._markerDecorationsService.getMarker(t,r);if(p)return new R(h,p);var f=n.getColorData(r.range.getStartPosition());if(!s&&f){s=!0;var g=f.colorInfo,m=g.color,v=g.range;return new T(v,m,f.provider)}if(a.isEmptyMarkdownString(r.options.hoverMessage))return null;return{contents:r.options.hoverMessage?C.asArray(r.options.hoverMessage):[],range:h}});return C.coalesce(u)},e.prototype.onResult=function(e,t){this._result=t?e.concat(this._result.sort(function(e,t){return e instanceof T?-1:t instanceof T?1:0})):this._result.concat(e)},
e.prototype.getResult=function(){return this._result.slice(0)},e.prototype.getResultWithLoadingMessage=function(){return this._result.slice(0).concat([this._getLoadingMessage()])},e.prototype._getLoadingMessage=function(){return{range:this._range,contents:[(new a.MarkdownString).appendText(i.localize(0,null))]}},e}(),P=function(e){function t(i,o,r,s,a,u){void 0===u&&(u=L.NullOpenerService);var d=e.call(this,t.ID,i)||this;return d._themeService=r,d._keybindingService=s,d._modeService=a,d._openerService=u,d.renderDisposable=d._register(new l.MutableDisposable),d._messages=[],d._lastRange=null,d._computer=new O(d._editor,o),d._highlightDecorations=[],d._isChangingDecorations=!1,d._shouldFocus=!1,d._colorPicker=null,d._hoverOperation=new _.HoverOperation(d._computer,function(e){return d._withResult(e,!0)},null,function(e){return d._withResult(e,!1)},d._editor.getConfiguration().contribInfo.hover.delay),d._register(n.addStandardDisposableListener(d.getDomNode(),n.EventType.FOCUS,function(){
d._colorPicker&&n.addClass(d.getDomNode(),"colorpicker-hover")})),d._register(n.addStandardDisposableListener(d.getDomNode(),n.EventType.BLUR,function(){n.removeClass(d.getDomNode(),"colorpicker-hover")})),d._register(i.onDidChangeConfiguration(function(e){d._hoverOperation.setHoverTime(d._editor.getConfiguration().contribInfo.hover.delay)})),d}return r(t,e),t.prototype.dispose=function(){this._hoverOperation.cancel(),e.prototype.dispose.call(this)},t.prototype.onModelDecorationsChanged=function(){this._isChangingDecorations||this.isVisible&&(this._hoverOperation.cancel(),this._computer.clearResult(),this._colorPicker||this._hoverOperation.start(0))},t.prototype.startShowingAt=function(e,t,i){if(!this._lastRange||!this._lastRange.equalsRange(e)){if(this._hoverOperation.cancel(),this.isVisible)if(this._showAtPosition&&this._showAtPosition.lineNumber===e.startLineNumber){for(var n=[],o=0,r=this._messages.length;o<r;o++){var s=this._messages[o],l=s.range
;l&&l.startColumn<=e.startColumn&&l.endColumn>=e.endColumn&&n.push(s)}if(n.length>0){if(function(e,t){if(!e&&t||e&&!t||e.length!==t.length)return!1;for(var i=0;i<e.length;i++){var n=e[i],o=t[i];if(n instanceof R&&o instanceof R)return S.IMarkerData.makeKey(n.marker)===S.IMarkerData.makeKey(o.marker);if(n instanceof T||o instanceof T)return!1;if(n instanceof R||o instanceof R)return!1;if(!a.markedStringsEquals(n.contents,o.contents))return!1}return!0}(n,this._messages))return;this._renderMessages(e,n)}else this.hide()}else this.hide();this._lastRange=e,this._computer.setRange(e),this._shouldFocus=i,this._hoverOperation.start(t)}},t.prototype.hide=function(){this._lastRange=null,this._hoverOperation.cancel(),e.prototype.hide.call(this),this._isChangingDecorations=!0,this._highlightDecorations=this._editor.deltaDecorations(this._highlightDecorations,[]),this._isChangingDecorations=!1,this.renderDisposable.clear(),this._colorPicker=null},t.prototype.isColorPickerVisible=function(){return!!this._colorPicker},
t.prototype._withResult=function(e,t){this._messages=e,this._lastRange&&this._messages.length>0?this._renderMessages(this._lastRange,this._messages):t&&this.hide()},t.prototype._renderMessages=function(e,i){var r=this;this.renderDisposable.dispose(),this._colorPicker=null;var c=Number.MAX_VALUE,h=i[0].range?d.Range.lift(i[0].range):null,f=document.createDocumentFragment(),v=!0,_=!1,y=new l.DisposableStore,C=[];if(i.forEach(function(e){if(e.range)if(c=Math.min(c,e.range.startColumn),h=h?d.Range.plusRange(h,e.range):d.Range.lift(e.range),e instanceof T){_=!0;var t=e.color,i=t.red,u=t.green,S=t.blue,w=t.alpha,E=new s.RGBA(255*i,255*u,255*S,w),L=new s.Color(E);if(!r._editor.hasModel())return;var x=r._editor.getModel(),D=new d.Range(e.range.startLineNumber,e.range.startColumn,e.range.endLineNumber,e.range.endColumn),I={range:e.range,color:e.color},N=new g.ColorPickerModel(L,[],0),M=new m.ColorPickerWidget(f,N,r._editor.getConfiguration().pixelRatio,r._themeService)
;p.getColorPresentations(x,I,e.provider,o.CancellationToken.None).then(function(t){if(N.colorPresentations=t||[],r._editor.hasModel()){var i=r._editor.getModel().getValueInRange(e.range);N.guessColorPresentation(L,i);var n=function(){var e,t;N.presentation.textEdit?(e=[N.presentation.textEdit],t=(t=new d.Range(N.presentation.textEdit.range.startLineNumber,N.presentation.textEdit.range.startColumn,N.presentation.textEdit.range.endLineNumber,N.presentation.textEdit.range.endColumn)).setEndPosition(t.endLineNumber,t.startColumn+N.presentation.textEdit.text.length)):(e=[{identifier:null,range:D,text:N.presentation.label,forceMoveMarkers:!1}],t=D.setEndPosition(D.endLineNumber,D.startColumn+N.presentation.label.length)),r._editor.pushUndoStop(),r._editor.executeEdits("colorpicker",e),N.presentation.additionalTextEdits&&(e=N.presentation.additionalTextEdits.slice(),r._editor.executeEdits("colorpicker",e),r.hide()),r._editor.pushUndoStop(),D=t},s=function(t){return p.getColorPresentations(x,{range:D,color:{
red:t.rgba.r/255,green:t.rgba.g/255,blue:t.rgba.b/255,alpha:t.rgba.a}},e.provider,o.CancellationToken.None).then(function(e){N.colorPresentations=e||[]})},a=N.onColorFlushed(function(e){s(e).then(n)}),u=N.onDidChangeColor(s);r._colorPicker=M,r.showAt(D.getStartPosition(),D,r._shouldFocus),r.updateContents(f),r._colorPicker.layout(),r.renderDisposable.value=l.combinedDisposable(a,u,M,y)}})}else e instanceof R?(C.push(e),v=!1):e.contents.filter(function(e){return!a.isEmptyMarkdownString(e)}).forEach(function(e){var t=k("div.hover-row.markdown-hover"),i=n.append(t,k("div.hover-contents")),o=y.add(new b.MarkdownRenderer(r._editor,r._modeService,r._openerService));y.add(o.onDidRenderCodeBlock(function(){i.className="hover-contents code-hover-contents",r.onContentsChange()}));var s=y.add(o.render(e));i.appendChild(s.element),f.appendChild(t),v=!1})}),C.length){C.forEach(function(e){return f.appendChild(r.renderMarkerHover(e))});var w=1===C.length?C[0]:C.sort(function(e,t){
return S.MarkerSeverity.compare(e.marker.severity,t.marker.severity)})[0];f.appendChild(this.renderMarkerStatusbar(w))}_||v||(this.showAt(new u.Position(e.startLineNumber,c),h,this._shouldFocus),this.updateContents(f)),this._isChangingDecorations=!0,this._highlightDecorations=this._editor.deltaDecorations(this._highlightDecorations,h?[{range:h,options:t._DECORATION_OPTIONS}]:[]),this._isChangingDecorations=!1},t.prototype.renderMarkerHover=function(e){var t=this,i=k("div.hover-row"),o=n.append(i,k("div.marker.hover-contents")),r=e.marker,s=r.source,a=r.message,l=r.code,u=r.relatedInformation;this._editor.applyFontInfo(o);var d=n.append(o,k("span"));if(d.style.whiteSpace="pre-wrap",d.innerText=a,s||l){var c=n.append(o,k("span"));c.style.opacity="0.6",c.style.paddingLeft="6px",c.innerText=s&&l?s+"("+l+")":s||"("+l+")"}if(C.isNonEmptyArray(u))for(var h=function(e,i,r,s){var a=n.append(o,k("div"));a.style.marginTop="8px";var l=n.append(a,k("a"));l.innerText=w.basename(i)+"("+r+", "+s+"): ",
l.style.cursor="pointer",l.onclick=function(e){e.stopPropagation(),e.preventDefault(),t._openerService&&t._openerService.open(i.with({fragment:r+","+s})).catch(E.onUnexpectedError)};var u=n.append(a,k("span"));u.innerText=e,p._editor.applyFontInfo(u)},p=this,f=0,g=u;f<g.length;f++){var m=g[f];h(m.message,m.resource,m.startLineNumber,m.startColumn)}return i},t.prototype.renderMarkerStatusbar=function(e){var t=this,o=k("div.hover-row.status-bar"),r=new l.DisposableStore,s=n.append(o,k("div.actions"));e.marker.severity!==S.MarkerSeverity.Error&&e.marker.severity!==S.MarkerSeverity.Warning&&e.marker.severity!==S.MarkerSeverity.Info||r.add(this.renderAction(s,{label:i.localize(1,null),commandId:x.NextMarkerAction.ID,run:function(){t.hide(),x.MarkerController.get(t._editor).show(e.marker),t._editor.focus()}}));var a=n.append(s,k("div"));a.style.opacity="0",a.style.transition="opacity 0.2s",setTimeout(function(){return a.style.opacity="1"},200),a.textContent=i.localize(2,null),r.add(l.toDisposable(function(){
return a.remove()}));var u=this.getCodeActions(e.marker);return r.add(l.toDisposable(function(){return u.cancel()})),u.then(function(e){if(a.style.transition="",a.style.opacity="1",!e.actions.length)return e.dispose(),void(a.textContent=i.localize(3,null));a.remove();var o=!1;r.add(l.toDisposable(function(){o||e.dispose()})),r.add(t.renderAction(s,{label:i.localize(4,null),commandId:N.QuickFixAction.Id,run:function(i){o=!0;var r=N.QuickFixController.get(t._editor),s=n.getDomNodePagePosition(i);r.showCodeActions(e,{x:s.left+6,y:s.top+s.height+6})}}))}),this.renderDisposable.value=r,o},t.prototype.getCodeActions=function(e){var t=this;return D.createCancelablePromise(function(i){return I.getCodeActions(t._editor.getModel(),new d.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn),{type:"manual",filter:{kind:M.CodeActionKind.QuickFix}},i)})},t.prototype.renderAction=function(e,t){var i=n.append(e,k("div.action-container")),o=n.append(i,k("a.action"))
;t.iconClass&&n.append(o,k("span.icon."+t.iconClass));var r=n.append(o,k("span"));r.textContent=t.label;var s=this._keybindingService.lookupKeybinding(t.commandId);return s&&(r.title=t.label+" ("+s.getLabel()+")"),n.addDisposableListener(i,n.EventType.CLICK,function(e){e.stopPropagation(),e.preventDefault(),t.run(i)})},t.ID="editor.contrib.modesContentHoverWidget",t._DECORATION_OPTIONS=c.ModelDecorationOptions.register({className:"hoverHighlight"}),t}(y.ContentHoverWidget);t.ModesContentHoverWidget=P}),define(t[587],i([1,0,341,38,2,11,3,21,70,586,450,55,22,16,187,33,486]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var y=function(){function e(e,t,i,n,r,s){var a=this;this._editor=e,this._openerService=t,this._modeService=i,this._markerDecorationsService=n,this._keybindingService=r,this._themeService=s,this._toUnhook=new o.DisposableStore,this._isMouseDown=!1,this._hoverClicked=!1,this._contentWidget=null,this._glyphWidget=null,this._hookEvents(),
this._didChangeConfigurationHandler=this._editor.onDidChangeConfiguration(function(e){e.contribInfo&&(a._hideWidgets(),a._unhookEvents(),a._hookEvents())})}return Object.defineProperty(e.prototype,"contentWidget",{get:function(){return this._contentWidget||this._createHoverWidgets(),this._contentWidget},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"glyphWidget",{get:function(){return this._glyphWidget||this._createHoverWidgets(),this._glyphWidget},enumerable:!0,configurable:!0}),e.get=function(t){return t.getContribution(e.ID)},e.prototype._hookEvents=function(){var e=this,t=function(){return e._hideWidgets()},i=this._editor.getConfiguration().contribInfo.hover;this._isHoverEnabled=i.enabled,this._isHoverSticky=i.sticky,this._isHoverEnabled?(this._toUnhook.add(this._editor.onMouseDown(function(t){return e._onEditorMouseDown(t)})),this._toUnhook.add(this._editor.onMouseUp(function(t){return e._onEditorMouseUp(t)})),this._toUnhook.add(this._editor.onMouseMove(function(t){
return e._onEditorMouseMove(t)})),this._toUnhook.add(this._editor.onKeyDown(function(t){return e._onKeyDown(t)})),this._toUnhook.add(this._editor.onDidChangeModelDecorations(function(){return e._onModelDecorationsChanged()}))):this._toUnhook.add(this._editor.onMouseMove(t)),this._toUnhook.add(this._editor.onMouseLeave(t)),this._toUnhook.add(this._editor.onDidChangeModel(t)),this._toUnhook.add(this._editor.onDidScrollChange(function(t){return e._onEditorScrollChanged(t)}))},e.prototype._unhookEvents=function(){this._toUnhook.clear()},e.prototype._onModelDecorationsChanged=function(){this.contentWidget.onModelDecorationsChanged(),this.glyphWidget.onModelDecorationsChanged()},e.prototype._onEditorScrollChanged=function(e){(e.scrollTopChanged||e.scrollLeftChanged)&&this._hideWidgets()},e.prototype._onEditorMouseDown=function(e){this._isMouseDown=!0;var t=e.target.type
;9!==t||e.target.detail!==h.ModesContentHoverWidget.ID?12===t&&e.target.detail===p.ModesGlyphHoverWidget.ID||(12!==t&&e.target.detail!==p.ModesGlyphHoverWidget.ID&&(this._hoverClicked=!1),this._hideWidgets()):this._hoverClicked=!0},e.prototype._onEditorMouseUp=function(e){this._isMouseDown=!1},e.prototype._onEditorMouseMove=function(e){var t=e.target.type;if(!(this._isMouseDown&&this._hoverClicked&&this.contentWidget.isColorPickerVisible()||this._isHoverSticky&&9===t&&e.target.detail===h.ModesContentHoverWidget.ID||this._isHoverSticky&&12===t&&e.target.detail===p.ModesGlyphHoverWidget.ID)){if(7===t){var i=this._editor.getConfiguration().fontInfo.typicalHalfwidthCharacterWidth/2,n=e.target.detail;n&&!n.isAfterLines&&"number"==typeof n.horizontalDistanceToText&&n.horizontalDistanceToText<i&&(t=6)}6===t?(this.glyphWidget.hide(),this._isHoverEnabled&&e.target.range&&this.contentWidget.startShowingAt(e.target.range,0,!1)):2===t?(this.contentWidget.hide(),
this._isHoverEnabled&&e.target.position&&this.glyphWidget.startShowingAt(e.target.position.lineNumber)):this._hideWidgets()}},e.prototype._onKeyDown=function(e){5!==e.keyCode&&6!==e.keyCode&&57!==e.keyCode&&4!==e.keyCode&&this._hideWidgets()},e.prototype._hideWidgets=function(){!this._glyphWidget||!this._contentWidget||this._isMouseDown&&this._hoverClicked&&this._contentWidget.isColorPickerVisible()||(this._glyphWidget.hide(),this._contentWidget.hide())},e.prototype._createHoverWidgets=function(){this._contentWidget=new h.ModesContentHoverWidget(this._editor,this._markerDecorationsService,this._themeService,this._keybindingService,this._modeService,this._openerService),this._glyphWidget=new p.ModesGlyphHoverWidget(this._editor,this._modeService,this._openerService)},e.prototype.showContentHover=function(e,t,i){this.contentWidget.startShowingAt(e,t,i)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._unhookEvents(),this._toUnhook.dispose(),
this._didChangeConfigurationHandler.dispose(),this._glyphWidget&&this._glyphWidget.dispose(),this._contentWidget&&this._contentWidget.dispose()},e.ID="editor.contrib.hover",e=d([c(1,f.IOpenerService),c(2,u.IModeService),c(3,v.IMarkerDecorationsService),c(4,_.IKeybindingService),c(5,m.IThemeService)],e)}();t.ModesHoverController=y;var b=function(e){function t(){return e.call(this,{id:"editor.action.showHover",label:i.localize(0,null),alias:"Show Hover",precondition:void 0,kbOpts:{kbExpr:l.EditorContextKeys.editorTextFocus,primary:n.KeyChord(2089,2087),weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){if(t.hasModel()){var i=y.get(t);if(i){var n=t.getPosition(),o=new a.Range(n.lineNumber,n.column,n.lineNumber,n.column),r=2===t.getConfiguration().accessibilitySupport;i.showContentHover(o,1,r)}}},t}(s.EditorAction);s.registerEditorContribution(y),s.registerEditorAction(b),m.registerThemingParticipant(function(e,t){var i=e.getColor(g.editorHoverHighlight)
;i&&t.addRule(".monaco-editor .hoverHighlight { background-color: "+i+"; }");var n=e.getColor(g.editorHoverBackground);n&&t.addRule(".monaco-editor .monaco-editor-hover { background-color: "+n+"; }");var o=e.getColor(g.editorHoverBorder);o&&(t.addRule(".monaco-editor .monaco-editor-hover { border: 1px solid "+o+"; }"),t.addRule(".monaco-editor .monaco-editor-hover .hover-row:not(:first-child):not(:empty) { border-top: 1px solid "+o.transparent(.5)+"; }"),t.addRule(".monaco-editor .monaco-editor-hover hr { border-top: 1px solid "+o.transparent(.5)+"; }"),t.addRule(".monaco-editor .monaco-editor-hover hr { border-bottom: 0px solid "+o.transparent(.5)+"; }"));var r=e.getColor(g.textLinkForeground);r&&t.addRule(".monaco-editor .monaco-editor-hover a { color: "+r+"; }");var s=e.getColor(g.editorHoverStatusBarBackground);s&&t.addRule(".monaco-editor .monaco-editor-hover .hover-row .actions { background-color: "+s+"; }");var a=e.getColor(g.textCodeBlockBackground)
;a&&t.addRule(".monaco-editor .monaco-editor-hover code { background-color: "+a+"; }")})}),define(t[126],i([1,0,24,48,12,41]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IWorkspaceContextService=o.createDecorator("contextService");!function(e){e.isIWorkspace=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&Array.isArray(e.folders)}}(t.IWorkspace||(t.IWorkspace={}));!function(e){e.isIWorkspaceFolder=function(e){return e&&"object"==typeof e&&i.URI.isUri(e.uri)&&"string"==typeof e.name&&"function"==typeof e.toResource}}(t.IWorkspaceFolder||(t.IWorkspaceFolder={}));var s=function(){function e(e,t,i){void 0===t&&(t=[]),void 0===i&&(i=null),this._id=e,this._configuration=i,this._foldersMap=r.TernarySearchTree.forPaths(),this.folders=t}return Object.defineProperty(e.prototype,"folders",{get:function(){return this._folders},set:function(e){this._folders=e,this.updateFoldersMap()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"id",{
get:function(){return this._id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"configuration",{get:function(){return this._configuration},set:function(e){this._configuration=e},enumerable:!0,configurable:!0}),e.prototype.getFolder=function(e){return e?this._foldersMap.findSubstr(e.with({scheme:e.scheme,authority:e.authority,path:e.path}).toString())||null:null},e.prototype.updateFoldersMap=function(){this._foldersMap=r.TernarySearchTree.forPaths();for(var e=0,t=this.folders;e<t.length;e++){var i=t[e];this._foldersMap.set(i.uri.toString(),i)}},e.prototype.toJSON=function(){return{id:this.id,folders:this.folders,configuration:this.configuration}},e}();t.Workspace=s;var a=function(){function e(e,t){this.raw=t,this.uri=e.uri,this.index=e.index,this.name=e.name}return e.prototype.toResource=function(e){return n.joinPath(this.uri,e)},e.prototype.toJSON=function(){return{uri:this.uri,name:this.name,index:this.index}},e}();t.WorkspaceFolder=a}),
define(t[113],i([1,0,5,8,57,4,38,2,18,109,24,101,150,53,13,3,17,32,39,467,432,198,84,437,438,34,126,56]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M){"use strict";function k(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof p.URI)}Object.defineProperty(t,"__esModule",{value:!0});var T=function(){function e(e){this.model=e,this._onDispose=new s.Emitter}return Object.defineProperty(e.prototype,"textEditorModel",{get:function(){return this.model},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._onDispose.fire()},e}();t.SimpleModel=T;var R=function(){function e(){}return e.prototype.setEditor=function(e){this.editor=e},e.prototype.createModelReference=function(e){var t=this,i=null;return this.editor&&(i=function(e,t,i){return f.isCodeEditor(e)?t(e):i(e)}(this.editor,function(i){return t.findModel(i,e)},function(i){
return t.findModel(i.getOriginalEditor(),e)||t.findModel(i.getModifiedEditor(),e)})),i?Promise.resolve(new l.ImmortalReference(new T(i))):Promise.reject(new Error("Model not found"))},e.prototype.findModel=function(e,t){var i=e.getModel();return i&&i.uri.toString()!==t.toString()?null:i},e}();t.SimpleEditorModelResolverService=R;var O=function(){function e(){}return e.prototype.showWhile=function(e,t){return Promise.resolve(void 0)},e}();t.SimpleEditorProgressService=O;var P=function(){return function(){}}();t.SimpleDialogService=P;var A=function(){function e(){}return e.prototype.info=function(e){return this.notify({severity:h.default.Info,message:e})},e.prototype.warn=function(e){return this.notify({severity:h.default.Warning,message:e})},e.prototype.error=function(e){return this.notify({severity:h.default.Error,message:e})},e.prototype.notify=function(t){switch(t.severity){case h.default.Error:console.error(t.message);break;case h.default.Warning:console.warn(t.message);break;default:console.log(t.message)
}return e.NO_OP},e.prototype.status=function(e,t){return l.Disposable.None},e.NO_OP=new I.NoOpNotification,e}();t.SimpleNotificationService=A;var F=function(){function e(e){this._onWillExecuteCommand=new s.Emitter,this._onDidExecuteCommand=new s.Emitter,this._instantiationService=e,this._dynamicCommands=Object.create(null)}return e.prototype.addCommand=function(e){var t=this,i=e.id;return this._dynamicCommands[i]=e,l.toDisposable(function(){delete t._dynamicCommands[i]})},e.prototype.executeCommand=function(e){for(var t=[],i=1;i<arguments.length;i++)t[i-1]=arguments[i];var n=b.CommandsRegistry.getCommand(e)||this._dynamicCommands[e];if(!n)return Promise.reject(new Error("command '"+e+"' not found"));try{this._onWillExecuteCommand.fire({commandId:e,args:t});var o=this._instantiationService.invokeFunction.apply(this._instantiationService,[n.handler].concat(t));return this._onDidExecuteCommand.fire({commandId:e,args:t}),Promise.resolve(o)}catch(e){return Promise.reject(e)}},e}();t.StandaloneCommandService=F
;var W=function(e){function t(t,i,r,s,a){var l=e.call(this,t,i,r,s)||this;return l._cachedResolver=null,l._dynamicKeybindings=[],l._register(n.addDisposableListener(a,n.EventType.KEY_DOWN,function(e){var t=new o.StandardKeyboardEvent(e);l._dispatch(t,t.target)&&t.preventDefault()})),l}return r(t,e),t.prototype.addDynamicKeybinding=function(e,t,i,n){var o=this,r=a.createKeybinding(t,u.OS);if(!r)throw new Error("Invalid keybinding");var s=new l.DisposableStore;this._dynamicKeybindings.push({keybinding:r,command:e,when:n,weight1:1e3,weight2:0}),s.add(l.toDisposable(function(){for(var t=0;t<o._dynamicKeybindings.length;t++){if(o._dynamicKeybindings[t].command===e)return o._dynamicKeybindings.splice(t,1),void o.updateResolver({source:1})}}));var d=this._commandService;if(!(d instanceof F))throw new Error("Unknown command service!");return s.add(d.addCommand({id:e,handler:i})),this.updateResolver({source:1}),s},t.prototype.updateResolver=function(e){this._cachedResolver=null,this._onDidUpdateKeybindings.fire(e)},
t.prototype._getResolver=function(){if(!this._cachedResolver){var e=this._toNormalizedKeybindingItems(L.KeybindingsRegistry.getDefaultKeybindings(),!0),t=this._toNormalizedKeybindingItems(this._dynamicKeybindings,!1);this._cachedResolver=new E.KeybindingResolver(e,t)}return this._cachedResolver},t.prototype._documentHasFocus=function(){return document.hasFocus()},t.prototype._toNormalizedKeybindingItems=function(e,t){for(var i=[],n=0,o=0,r=e;o<r.length;o++){var s=r[o],a=s.when||void 0,l=s.keybinding;if(l)for(var u=0,d=this.resolveKeybinding(l);u<d.length;u++){var c=d[u];i[n++]=new x.ResolvedKeybindingItem(c,s.command,s.commandArgs,a,t)}else i[n++]=new x.ResolvedKeybindingItem(void 0,s.command,s.commandArgs,a,t)}return i},t.prototype.resolveKeybinding=function(e){return[new D.USLayoutResolvedKeybinding(e,u.OS)]},t.prototype.resolveKeyboardEvent=function(e){var t=new a.SimpleKeybinding(e.ctrlKey,e.shiftKey,e.altKey,e.metaKey,e.keyCode).toChord();return new D.USLayoutResolvedKeybinding(t,u.OS)},t
}(w.AbstractKeybindingService);t.StandaloneKeybindingService=W;var V=function(){function e(){this._onDidChangeConfiguration=new s.Emitter,this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel)}return e.prototype.configuration=function(){return this._configuration},e.prototype.getValue=function(e,t){var i="string"==typeof e?e:void 0,n=k(e)?e:k(t)?t:{};return this.configuration().getValue(i,n,void 0)},e.prototype.updateValue=function(e,t,i,n){return this.configuration().updateValue(e,t),Promise.resolve()},e.prototype.inspect=function(e,t){return void 0===t&&(t={}),this.configuration().inspect(e,t,void 0)},e}();t.SimpleConfigurationService=V;var B=function(){function e(e){var t=this;this.configurationService=e,this._onDidChangeConfiguration=new s.Emitter,this.configurationService.onDidChangeConfiguration(function(e){t._onDidChangeConfiguration.fire(e)})}return e.prototype.getValue=function(e,t,i){
var n=(v.Position.isIPosition(t)?t:null)?"string"==typeof i?i:void 0:"string"==typeof t?t:void 0;return void 0===n?this.configurationService.getValue():this.configurationService.getValue(n)},e}();t.SimpleResourceConfigurationService=B;var H=function(){function e(e){this.configurationService=e}return e.prototype.getEOL=function(e){var t=this.configurationService.getValue("files");return t&&t.eol&&"auto"!==t.eol?t.eol:u.isLinux||u.isMacintosh?"\n":"\r\n"},e=d([c(0,C.IConfigurationService)],e)}();t.SimpleResourcePropertiesService=H;var z=function(){function e(){this._serviceBrand=void 0}return e.prototype.publicLog=function(e,t){return Promise.resolve(void 0)},e.prototype.publicLog2=function(e,t){return this.publicLog(e,t)},e}();t.StandaloneTelemetryService=z;var K=function(){function e(){var t=p.URI.from({scheme:e.SCHEME,authority:"model",path:"/"});this.workspace={id:"4064f6ec-cb38-4ad0-af64-ee6467e63c82",folders:[new N.WorkspaceFolder({uri:t,name:"",index:0})]}}return e.prototype.getWorkspace=function(){
return this.workspace},e.prototype.getWorkspaceFolder=function(t){return t&&t.scheme===e.SCHEME?this.workspace.folders[0]:null},e.SCHEME="inmemory",e}();t.SimpleWorkspaceContextService=K,t.applyConfigurationValues=function(e,t,i){t&&e instanceof V&&Object.keys(t).forEach(function(n){g.isEditorConfigurationKey(n)&&e.updateValue("editor."+n,t[n]),i&&g.isDiffEditorConfigurationKey(n)&&e.updateValue("diffEditor."+n,t[n])})};var U=function(){function e(e){this._modelService=e}return e.prototype.apply=function(e,t){var n=new Map;if(e.edits)for(var o=0,r=e.edits;o<r.length;o++){var s=r[o];if(!y.isResourceTextEdit(s))return Promise.reject(new Error("bad edit - only text edits are supported"));var a=this._modelService.getModel(s.resource);if(!a)return Promise.reject(new Error("bad edit - model not found"));var l=n.get(a);l||(l=[]),n.set(a,l.concat(s.edits))}var u=0,d=0;return n.forEach(function(e,t){t.applyEdits(e.map(function(e){return m.EditOperation.replaceMove(_.Range.lift(e.range),e.text)})),d+=1,u+=e.length}),
Promise.resolve({selection:void 0,ariaSummary:i.format(M.SimpleServicesNLS.bulkEditServiceSummary,u,d)})},e}();t.SimpleBulkEditService=U;var j=function(){function e(){}return e.prototype.getUriLabel=function(e,t){return"file"===e.scheme?e.fsPath:e.path},e}();t.SimpleUriLabelService=j;var q=function(){function e(e){this._container=e,this.onLayout=s.Event.None}return Object.defineProperty(e.prototype,"container",{get:function(){return this._container},enumerable:!0,configurable:!0}),e}();t.SimpleLayoutService=q}),define(t[590],i([1,0,28,43,2,31,98,219,168,60,113,91,59,32,39,14,54,12,33,34,16,66,56,134]),function(e,t,i,n,o,s,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var D=0,I=!1,N=function(e){function t(t,o,r,s,a,l,u,d,c,h){var f=this;return o=o||{},o.ariaLabel=o.ariaLabel||L.StandaloneCodeEditorNLS.editorViewAccessibleLabel,
o.ariaLabel=o.ariaLabel+";"+(i.isIE?L.StandaloneCodeEditorNLS.accessibilityHelpMessageIE:L.StandaloneCodeEditorNLS.accessibilityHelpMessage),f=e.call(this,t,o,{},r,s,a,l,d,c,h)||this,u instanceof p.StandaloneKeybindingService?f._standaloneKeybindingService=u:f._standaloneKeybindingService=null,I||(I=!0,n.setARIAContainer(document.body)),f}return r(t,e),t.prototype.addCommand=function(e,t,i){if(!this._standaloneKeybindingService)return console.warn("Cannot add command because the editor is configured with an unrecognized KeybindingService"),null;var n="DYNAMIC_"+ ++D,o=_.ContextKeyExpr.deserialize(i);return this._standaloneKeybindingService.addDynamicKeybinding(n,e,t,o),n},t.prototype.createContextKey=function(e,t){return this._contextKeyService.createKey(e,t)},t.prototype.addAction=function(e){var t=this;if("string"!=typeof e.id||"string"!=typeof e.label||"function"!=typeof e.run)throw new Error("Invalid action descriptor, `id`, `label` and `run` are required properties!")
;if(!this._standaloneKeybindingService)return console.warn("Cannot add keybinding because the editor is configured with an unrecognized KeybindingService"),o.Disposable.None;var i=e.id,n=e.label,r=_.ContextKeyExpr.and(_.ContextKeyExpr.equals("editorId",this.getId()),_.ContextKeyExpr.deserialize(e.precondition)),s=e.keybindings,a=_.ContextKeyExpr.and(r,_.ContextKeyExpr.deserialize(e.keybindingContext)),l=e.contextMenuGroupId||null,d=e.contextMenuOrder||0,c=function(){return Promise.resolve(e.run(t))},h=new o.DisposableStore,p=this.getId()+":"+i;if(h.add(m.CommandsRegistry.registerCommand(p,c)),l){var f={command:{id:p,title:n},when:r,group:l,order:d};h.add(g.MenuRegistry.appendMenuItem(7,f))}if(Array.isArray(s))for(var v=0,y=s;v<y.length;v++){var b=y[v];h.add(this._standaloneKeybindingService.addDynamicKeybinding(p,b,c,a))}var C=new u.InternalEditorAction(p,n,n,r,c,this._contextKeyService);return this._actions[i]=C,h.add(o.toDisposable(function(){delete t._actions[i]})),h},
t=d([c(2,b.IInstantiationService),c(3,s.ICodeEditorService),c(4,m.ICommandService),c(5,_.IContextKeyService),c(6,C.IKeybindingService),c(7,w.IThemeService),c(8,S.INotificationService),c(9,E.IAccessibilityService)],t)}(a.CodeEditorWidget);t.StandaloneCodeEditor=N;var M=function(e){function t(t,i,n,o,r,s,a,l,u,d,c,h,f){var g=this;p.applyConfigurationValues(h,i,!1),"string"==typeof(i=i||{}).theme&&d.setTheme(i.theme);var m=i.model;delete i.model,(g=e.call(this,t,i,o,r,s,a,l,d,c,f)||this)._contextViewService=u,g._configurationService=h,g._register(n);var v;if(void 0===m?(v=self.monaco.editor.createModel(i.value||"",i.language||"text/plain"),g._ownsModel=!0):(v=m,g._ownsModel=!1),g._attachModel(v),v){var _={oldModelUrl:null,newModelUrl:v.uri};g._onDidChangeModel.fire(_)}return g}return r(t,e),t.prototype.dispose=function(){e.prototype.dispose.call(this)},t.prototype.updateOptions=function(t){p.applyConfigurationValues(this._configurationService,t,!1),e.prototype.updateOptions.call(this,t)},
t.prototype._attachModel=function(t){e.prototype._attachModel.call(this,t),this._modelData&&this._contextViewService.setContainer(this._modelData.view.domNode.domNode)},t.prototype._postDetachModelCleanup=function(t){e.prototype._postDetachModelCleanup.call(this,t),t&&this._ownsModel&&(t.dispose(),this._ownsModel=!1)},t=d([c(3,b.IInstantiationService),c(4,s.ICodeEditorService),c(5,m.ICommandService),c(6,_.IContextKeyService),c(7,C.IKeybindingService),c(8,y.IContextViewService),c(9,f.IStandaloneThemeService),c(10,S.INotificationService),c(11,v.IConfigurationService),c(12,E.IAccessibilityService)],t)}(N);t.StandaloneEditor=M;var k=function(e){function t(t,i,n,o,r,s,a,l,u,d,c,h,f,g){var m=this;return p.applyConfigurationValues(h,i,!0),"string"==typeof(i=i||{}).theme&&(i.theme=d.setTheme(i.theme)),m=e.call(this,t,i,g,l,r,o,u,d,c,f)||this,m._contextViewService=a,m._configurationService=h,m._register(n),m._contextViewService.setContainer(m._containerDomElement),m}return r(t,e),t.prototype.dispose=function(){
e.prototype.dispose.call(this)},t.prototype.updateOptions=function(t){p.applyConfigurationValues(this._configurationService,t,!0),e.prototype.updateOptions.call(this,t)},t.prototype._createInnerEditor=function(e,t,i){return e.createInstance(N,t,i)},t.prototype.getOriginalEditor=function(){return e.prototype.getOriginalEditor.call(this)},t.prototype.getModifiedEditor=function(){return e.prototype.getModifiedEditor.call(this)},t.prototype.addCommand=function(e,t,i){return this.getModifiedEditor().addCommand(e,t,i)},t.prototype.createContextKey=function(e,t){return this.getModifiedEditor().createContextKey(e,t)},t.prototype.addAction=function(e){return this.getModifiedEditor().addAction(e)},t=d([c(3,b.IInstantiationService),c(4,_.IContextKeyService),c(5,C.IKeybindingService),c(6,y.IContextViewService),c(7,h.IEditorWorkerService),c(8,s.ICodeEditorService),c(9,f.IStandaloneThemeService),c(10,S.INotificationService),c(11,v.IConfigurationService),c(12,y.IContextMenuService),c(13,b.optional(x.IClipboardService))],t)
}(l.DiffEditorWidget);t.StandaloneDiffEditor=k}),define(t[228],i([1,0,2,163,31,60,200,70,462,42,464,140,113,572,574,91,59,32,39,468,14,575,54,441,429,12,431,104,33,102,131,114,446,69,34,110,68,103,16,126,427,187,542,66,466,199,73]),function(e,t,i,n,o,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M,k,T,R,O,P,A,F,W,V,B,H,z,K,U,j,q,G){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var Z;!function(e){function t(e,t){var i=new n(e,t);return r.push(i),i}var i=new I.ServiceCollection,n=function(){function e(e,t){this._serviceId=e,this._factory=t,this._value=null}return Object.defineProperty(e.prototype,"id",{get:function(){return this._serviceId},enumerable:!0,configurable:!0}),e.prototype.get=function(e){if(!this._value){if(e&&(this._value=e[this._serviceId.toString()]),this._value||(this._value=this._factory(e)),!this._value)throw new Error("Service "+this._serviceId+" is missing!");i.set(this._serviceId,this._value)}return this._value},e}();e.LazyStaticService=n;var r=[];e.init=function(e){
for(var t=new I.ServiceCollection,i=0,n=G.getSingletonServiceDescriptors();i<n.length;i++){var o=n[i],s=o[0],a=o[1];t.set(s,a)}for(var l in e)e.hasOwnProperty(l)&&t.set(x.createDecorator(l),e[l]);r.forEach(function(i){return t.set(i.id,i.get(e))});var u=new D.InstantiationService(t,!0);return t.set(x.IInstantiationService,u),[t,u]},e.instantiationService=t(x.IInstantiationService,function(){return new D.InstantiationService(i,!0)});var v=new p.SimpleConfigurationService;e.configurationService=t(y.IConfigurationService,function(){return v}),e.resourceConfigurationService=t(h.ITextResourceConfigurationService,function(){return new p.SimpleResourceConfigurationService(v)}),e.resourcePropertiesService=t(h.ITextResourcePropertiesService,function(){return new p.SimpleResourcePropertiesService(v)}),e.contextService=t(B.IWorkspaceContextService,function(){return new p.SimpleWorkspaceContextService}),e.labelService=t(M.ILabelService,function(){return new p.SimpleUriLabelService}),
e.telemetryService=t(W.ITelemetryService,function(){return new p.StandaloneTelemetryService}),e.dialogService=t(L.IDialogService,function(){return new p.SimpleDialogService}),e.notificationService=t(P.INotificationService,function(){return new p.SimpleNotificationService}),e.markerService=t(O.IMarkerService,function(){return new R.MarkerService}),e.modeService=t(l.IModeService,function(e){return new u.ModeServiceImpl}),e.modelService=t(d.IModelService,function(t){return new c.ModelServiceImpl(e.configurationService.get(t),e.resourcePropertiesService.get(t))}),e.markerDecorationsService=t(z.IMarkerDecorationsService,function(t){return new K.MarkerDecorationsService(e.modelService.get(t),e.markerService.get(t))}),e.standaloneThemeService=t(m.IStandaloneThemeService,function(){return new g.StandaloneThemeServiceImpl}),e.codeEditorService=t(o.ICodeEditorService,function(t){return new f.StandaloneCodeEditorServiceImpl(e.standaloneThemeService.get(t))}),e.editorProgressService=t(A.IEditorProgressService,function(){
return new p.SimpleEditorProgressService}),e.storageService=t(F.IStorageService,function(){return new F.InMemoryStorageService}),e.logService=t(T.ILogService,function(){return new T.NullLogService}),e.editorWorkerService=t(s.IEditorWorkerService,function(t){return new a.EditorWorkerServiceImpl(e.modelService.get(t),e.resourceConfigurationService.get(t),e.logService.get(t))})}(Z=t.StaticServices||(t.StaticServices={}));var Y=function(e){function t(t,i){var o=e.call(this)||this,r=Z.init(i),s=r[0],a=r[1];o._serviceCollection=s,o._instantiationService=a;var l=o.get(y.IConfigurationService),u=o.get(P.INotificationService),c=o.get(W.ITelemetryService),h=o.get(V.IThemeService),f=function(e,t){var n=null;return i&&(n=i[e.toString()]),n||(n=t()),o._serviceCollection.set(e,n),n},g=f(C.IContextKeyService,function(){return o._register(new b.ContextKeyService(l))});f(U.IAccessibilityService,function(){return new j.BrowserAccessibilityService(g,l)}),f(k.IListService,function(){return new k.ListService(g)})
;var m=f(_.ICommandService,function(){return new p.StandaloneCommandService(o._instantiationService)}),L=f(N.IKeybindingService,function(){return o._register(new p.StandaloneKeybindingService(g,m,c,u,t))}),x=f(q.ILayoutService,function(){return new p.SimpleLayoutService(t)}),D=f(w.IContextViewService,function(){return o._register(new E.ContextViewService(x))});return f(w.IContextMenuService,function(){var e=new S.ContextMenuService(c,u,D,L,h);return e.configure({blockMouse:!1}),o._register(e)}),f(v.IMenuService,function(){return new H.MenuService(m)}),f(n.IBulkEditService,function(){return new p.SimpleBulkEditService(Z.modelService.get(d.IModelService))}),o}return r(t,e),t.prototype.get=function(e){var t=this._serviceCollection.get(e);if(!t)throw new Error("Missing service "+e);return t},t.prototype.set=function(e,t){this._serviceCollection.set(e,t)},t.prototype.has=function(e){return this._serviceCollection.has(e)},t}(i.Disposable);t.DynamicStandaloneServices=Y}),
define(t[592],i([1,0,31,419,166,47,117,72,49,17,63,60,76,444,141,415,113,590,228,91,32,39,14,54,12,33,34,55,66,65,516]),function(e,t,i,n,o,r,s,a,l,u,d,c,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N){"use strict";function M(e,t,o){var r=new _.DynamicStandaloneServices(e,t),s=null;r.has(h.ITextModelService)||(s=new m.SimpleEditorModelResolverService,r.set(h.ITextModelService,s)),r.has(D.IOpenerService)||r.set(D.IOpenerService,new n.OpenerService(r.get(i.ICodeEditorService),r.get(b.ICommandService)));var a=o(r);return s&&s.setEditor(a),a}function k(e,t,n){return M(e,n||{},function(n){return new v.StandaloneEditor(e,t,n,n.get(E.IInstantiationService),n.get(i.ICodeEditorService),n.get(b.ICommandService),n.get(S.IContextKeyService),n.get(L.IKeybindingService),n.get(w.IContextViewService),n.get(y.IStandaloneThemeService),n.get(x.INotificationService),n.get(C.IConfigurationService),n.get(I.IAccessibilityService))})}function T(e){return _.StaticServices.codeEditorService.get().onCodeEditorAdd(function(t){e(t)})}
function R(e,t,n){return M(e,n||{},function(n){return new v.StandaloneDiffEditor(e,t,n,n.get(E.IInstantiationService),n.get(S.IContextKeyService),n.get(L.IKeybindingService),n.get(w.IContextViewService),n.get(c.IEditorWorkerService),n.get(i.ICodeEditorService),n.get(y.IStandaloneThemeService),n.get(x.INotificationService),n.get(C.IConfigurationService),n.get(w.IContextMenuService),null)})}function O(e,t){return new o.DiffNavigator(e,t)}function P(e,t,i){return _.StaticServices.modelService.get().createModel(e,t,i)}function A(e,t,i){if(e=e||"",!t){var n=e.indexOf("\n"),o=e;return-1!==n&&(o=e.substring(0,n)),P(e,_.StaticServices.modeService.get().createByFilepathOrFirstLine(i||null,o),i)}return P(e,_.StaticServices.modeService.get().create(t),i)}function F(e,t){_.StaticServices.modelService.get().setMode(e,_.StaticServices.modeService.get().create(t))}function W(e,t,i){e&&_.StaticServices.markerService.get().changeOne(t,e.uri,i)}function V(e){return _.StaticServices.markerService.get().read(e)}function B(e){
return _.StaticServices.modelService.get().getModel(e)}function H(){return _.StaticServices.modelService.get().getModels()}function z(e){return _.StaticServices.modelService.get().onModelAdded(e)}function K(e){return _.StaticServices.modelService.get().onModelRemoved(e)}function U(e){return _.StaticServices.modelService.get().onModelModeChanged(function(t){e({model:t.model,oldLanguage:t.oldModeId})})}function j(e){return p.createWebWorker(_.StaticServices.modelService.get(),e)}function q(e,t){return g.Colorizer.colorizeElement(_.StaticServices.standaloneThemeService.get(),_.StaticServices.modeService.get(),e,t)}function G(e,t,i){return g.Colorizer.colorize(_.StaticServices.modeService.get(),e,t,i)}function Z(e,t,i){return void 0===i&&(i=4),g.Colorizer.colorizeModelLine(e,t,i)}function Y(e,t){_.StaticServices.modeService.get().triggerMode(t);for(var i=function(e){var t=u.TokenizationRegistry.get(e);return t||{getInitialState:function(){return d.NULL_STATE},tokenize:function(t,i,n){
return d.nullTokenize(e,t,i,n)}}}(t),n=e.split(/\r\n|\r|\n/),o=[],r=i.getInitialState(),s=0,a=n.length;s<a;s++){var l=n[s],c=i.tokenize(l,r,0);o[s]=c.tokens,r=c.endState}return o}function X(e,t){_.StaticServices.standaloneThemeService.get().defineTheme(e,t)}function $(e){_.StaticServices.standaloneThemeService.get().setTheme(e)}function Q(){N.clearAllFontInfos()}Object.defineProperty(t,"__esModule",{value:!0}),t.create=k,t.onDidCreateEditor=T,t.createDiffEditor=R,t.createDiffNavigator=O,t.createModel=A,t.setModelLanguage=F,t.setModelMarkers=W,t.getModelMarkers=V,t.getModel=B,t.getModels=H,t.onDidCreateModel=z,t.onWillDisposeModel=K,t.onDidChangeModelLanguage=U,t.createWebWorker=j,t.colorizeElement=q,t.colorize=G,t.colorizeModelLine=Z,t.tokenize=Y,t.defineTheme=X,t.setTheme=$,t.remeasureFonts=Q,t.createMonacoEditorAPI=function(){return{create:k,onDidCreateEditor:T,createDiffEditor:R,createDiffNavigator:O,createModel:A,setModelLanguage:F,setModelMarkers:W,getModelMarkers:V,getModels:H,getModel:B,
onDidCreateModel:z,onWillDisposeModel:K,onDidChangeModelLanguage:U,createWebWorker:j,colorizeElement:q,colorize:G,colorizeModelLine:Z,tokenize:Y,defineTheme:X,setTheme:$,remeasureFonts:Q,ScrollbarVisibility:f.ScrollbarVisibility,WrappingIndent:f.WrappingIndent,OverviewRulerLane:f.OverviewRulerLane,MinimapPosition:f.MinimapPosition,EndOfLinePreference:f.EndOfLinePreference,DefaultEndOfLine:f.DefaultEndOfLine,EndOfLineSequence:f.EndOfLineSequence,TrackedRangeStickiness:f.TrackedRangeStickiness,CursorChangeReason:f.CursorChangeReason,MouseTargetType:f.MouseTargetType,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorCursorBlinkingStyle:f.TextEditorCursorBlinkingStyle,ContentWidgetPositionPreference:f.ContentWidgetPositionPreference,OverlayWidgetPositionPreference:f.OverlayWidgetPositionPreference,RenderMinimap:f.RenderMinimap,ScrollType:f.ScrollType,RenderLineNumbersType:f.RenderLineNumbersType,InternalEditorOptions:r.InternalEditorOptions,BareFontInfo:s.BareFontInfo,FontInfo:s.FontInfo,
TextModelResolvedOptions:l.TextModelResolvedOptions,FindMatch:l.FindMatch,EditorType:a.EditorType}}}),define(t[593],i([1,0,3,106,17,40,108,141,228,272,195]),function(e,t,i,n,o,r,s,a,l,u,d){"use strict";function c(e){s.ModesRegistry.registerLanguage(e)}function h(){var e=[];return e=e.concat(s.ModesRegistry.getLanguages())}function p(e){var t=l.StaticServices.modeService.get().getLanguageIdentifier(e);return t?t.id:0}function f(e,t){var i=l.StaticServices.modeService.get().onDidCreateMode(function(n){n.getId()===e&&(i.dispose(),t())});return i}function g(e,t){var i=l.StaticServices.modeService.get().getLanguageIdentifier(e);if(!i)throw new Error("Cannot set configuration for unknown language "+e);return r.LanguageConfigurationRegistry.register(i,t)}function m(e){return e&&"function"==typeof e.then}function v(e,t){var i=l.StaticServices.modeService.get().getLanguageIdentifier(e);if(!i)throw new Error("Cannot set tokens provider for unknown language "+e);var n=function(e){return function(e){
return"tokenizeEncoded"in e}(e)?new V(e):new B(l.StaticServices.standaloneThemeService.get(),i,e)};return m(t)?o.TokenizationRegistry.registerPromise(e,t.then(function(e){return n(e)})):o.TokenizationRegistry.register(e,n(t))}function _(e,t){var i=function(t){return d.createTokenizationSupport(l.StaticServices.modeService.get(),l.StaticServices.standaloneThemeService.get(),e,u.compile(e,t))};return m(t)?o.TokenizationRegistry.registerPromise(e,t.then(function(e){return i(e)})):o.TokenizationRegistry.register(e,i(t))}function y(e,t){return o.ReferenceProviderRegistry.register(e,t)}function b(e,t){return o.RenameProviderRegistry.register(e,t)}function C(e,t){return o.SignatureHelpProviderRegistry.register(e,t)}function S(e,t){return o.HoverProviderRegistry.register(e,{provideHover:function(e,n,o){var r=e.getWordAtPosition(n);return Promise.resolve(t.provideHover(e,n,o)).then(function(e){if(e)return!e.range&&r&&(e.range=new i.Range(n.lineNumber,r.startColumn,n.lineNumber,r.endColumn)),
e.range||(e.range=new i.Range(n.lineNumber,n.column,n.lineNumber,n.column)),e})}})}function w(e,t){return o.DocumentSymbolProviderRegistry.register(e,t)}function E(e,t){return o.DocumentHighlightProviderRegistry.register(e,t)}function L(e,t){return o.DefinitionProviderRegistry.register(e,t)}function x(e,t){return o.ImplementationProviderRegistry.register(e,t)}function D(e,t){return o.TypeDefinitionProviderRegistry.register(e,t)}function I(e,t){return o.CodeLensProviderRegistry.register(e,t)}function N(e,t){return o.CodeActionProviderRegistry.register(e,{provideCodeActions:function(e,n,o,r){var s=l.StaticServices.markerService.get().read({resource:e.uri}).filter(function(e){return i.Range.areIntersectingOrTouching(e,n)});return t.provideCodeActions(e,n,{markers:s,only:o.only},r)}})}function M(e,t){return o.DocumentFormattingEditProviderRegistry.register(e,t)}function k(e,t){return o.DocumentRangeFormattingEditProviderRegistry.register(e,t)}function T(e,t){
return o.OnTypeFormattingEditProviderRegistry.register(e,t)}function R(e,t){return o.LinkProviderRegistry.register(e,t)}function O(e,t){return o.CompletionProviderRegistry.register(e,t)}function P(e,t){return o.ColorProviderRegistry.register(e,t)}function A(e,t){return o.FoldingRangeProviderRegistry.register(e,t)}function F(e,t){return o.DeclarationProviderRegistry.register(e,t)}function W(e,t){return o.SelectionRangeRegistry.register(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.register=c,t.getLanguages=h,t.getEncodedLanguageId=p,t.onLanguage=f,t.setLanguageConfiguration=g;var V=function(){function e(e){this._actual=e}return e.prototype.getInitialState=function(){return this._actual.getInitialState()},e.prototype.tokenize=function(e,t,i){throw new Error("Not supported!")},e.prototype.tokenize2=function(e,t){var i=this._actual.tokenizeEncoded(e,t);return new n.TokenizationResult2(i.tokens,i.endState)},e}();t.EncodedTokenizationSupport2Adapter=V;var B=function(){function e(e,t,i){
this._standaloneThemeService=e,this._languageIdentifier=t,this._actual=i}return e.prototype.getInitialState=function(){return this._actual.getInitialState()},e.prototype._toClassicTokens=function(e,t,i){for(var o=[],r=0,s=0,a=e.length;s<a;s++){var l=e[s],u=l.startIndex;0===s?u=0:u<r&&(u=r),o[s]=new n.Token(u+i,l.scopes,t),r=u}return o},e.prototype.tokenize=function(e,t,i){var o,r=this._actual.tokenize(e,t),s=this._toClassicTokens(r.tokens,this._languageIdentifier.language,i);return o=r.endState.equals(t)?t:r.endState,new n.TokenizationResult(s,o)},e.prototype._toBinaryTokens=function(e,t){for(var i=this._languageIdentifier.id,n=this._standaloneThemeService.getTheme().tokenTheme,o=[],r=0,s=0,a=0,l=e.length;a<l;a++){var u=e[a],d=n.match(i,u.scopes);if(!(r>0&&o[r-1]===d)){var c=u.startIndex;0===a?c=0:c<s&&(c=s),o[r++]=c+t,o[r++]=d,s=c}}for(var h=new Uint32Array(r),a=0;a<r;a++)h[a]=o[a];return h},e.prototype.tokenize2=function(e,t,i){var o,r=this._actual.tokenize(e,t),s=this._toBinaryTokens(r.tokens,i)
;return o=r.endState.equals(t)?t:r.endState,new n.TokenizationResult2(s,o)},e}();t.TokenizationSupport2Adapter=B,t.setTokensProvider=v,t.setMonarchTokensProvider=_,t.registerReferenceProvider=y,t.registerRenameProvider=b,t.registerSignatureHelpProvider=C,t.registerHoverProvider=S,t.registerDocumentSymbolProvider=w,t.registerDocumentHighlightProvider=E,t.registerDefinitionProvider=L,t.registerImplementationProvider=x,t.registerTypeDefinitionProvider=D,t.registerCodeLensProvider=I,t.registerCodeActionProvider=N,t.registerDocumentFormattingEditProvider=M,t.registerDocumentRangeFormattingEditProvider=k,t.registerOnTypeFormattingEditProvider=T,t.registerLinkProvider=R,t.registerCompletionItemProvider=O,t.registerColorProvider=P,t.registerFoldingRangeProvider=A,t.registerDeclarationProvider=F,t.registerSelectionRangeProvider=W,t.createMonacoLanguagesAPI=function(){return{register:c,getLanguages:h,onLanguage:f,getEncodedLanguageId:p,setLanguageConfiguration:g,setTokensProvider:v,setMonarchTokensProvider:_,
registerReferenceProvider:y,registerRenameProvider:b,registerCompletionItemProvider:O,registerSignatureHelpProvider:C,registerHoverProvider:S,registerDocumentSymbolProvider:w,registerDocumentHighlightProvider:E,registerDefinitionProvider:L,registerImplementationProvider:x,registerTypeDefinitionProvider:D,registerCodeLensProvider:I,registerCodeActionProvider:N,registerDocumentFormattingEditProvider:M,registerDocumentRangeFormattingEditProvider:k,registerOnTypeFormattingEditProvider:T,registerLinkProvider:R,registerColorProvider:P,registerFoldingRangeProvider:A,registerDeclarationProvider:F,registerSelectionRangeProvider:W,DocumentHighlightKind:a.DocumentHighlightKind,CompletionItemKind:a.CompletionItemKind,CompletionItemTag:a.CompletionItemTag,CompletionItemInsertTextRule:a.CompletionItemInsertTextRule,SymbolKind:a.SymbolKind,SymbolTag:a.SymbolTag,IndentAction:a.IndentAction,CompletionTriggerKind:a.CompletionTriggerKind,SignatureHelpTriggerKind:a.SignatureHelpTriggerKind,FoldingRangeKind:o.FoldingRangeKind}}
}),define(t[594],i([1,0,47,170,592,593]),function(e,t,i,n,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=self;i.EDITOR_DEFAULTS.wrappingIndent=0,i.EDITOR_DEFAULTS.viewInfo.glyphMargin=!1,i.EDITOR_DEFAULTS.autoIndent=!1;var a=n.createMonacoBaseAPI();a.editor=o.createMonacoEditorAPI(),a.languages=r.createMonacoLanguagesAPI(),t.CancellationTokenSource=a.CancellationTokenSource,t.Emitter=a.Emitter,t.KeyCode=a.KeyCode,t.KeyMod=a.KeyMod,t.Position=a.Position,t.Range=a.Range,t.Selection=a.Selection,t.SelectionDirection=a.SelectionDirection,t.MarkerSeverity=a.MarkerSeverity,t.MarkerTag=a.MarkerTag,t.Uri=a.Uri,t.Token=a.Token,t.editor=a.editor,t.languages=a.languages,s.monaco=a,void 0!==s.require&&"function"==typeof s.require.config&&s.require.config({ignoreDuplicateModules:["vscode-languageserver-types","vscode-languageserver-types/main","vscode-nls","vscode-nls/vscode-nls","jsonc-parser","jsonc-parser/main","vscode-uri","vscode-uri/index","vs/basic-languages/typescript/typescript"]})}),
define(t[595],i([1,0,24]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WORKSPACE_EXTENSION="code-workspace",t.isSingleFolderWorkspaceIdentifier=function(e){return e instanceof i.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0}}),define(t[596],i([1,0,360,83,48,128,40,5,595]),function(e,t,i,n,o,r,s,a,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e){this._delegates=e}return e.prototype.resolve=function(e){for(var t=0,i=this._delegates;t<i.length;t++){var n=i[t].resolve(e);if(void 0!==n)return n}},e}();t.CompositeSnippetVariableResolver=u;var d=function(){function e(e,t){this._model=e,this._selection=t}return e.prototype.resolve=function(e){var t=e.name;if("SELECTION"===t||"TM_SELECTED_TEXT"===t){var i=this._model.getValueInRange(this._selection)||void 0;if(i&&this._selection.startLineNumber!==this._selection.endLineNumber&&e.snippet){
var n=this._model.getLineContent(this._selection.startLineNumber),o=a.getLeadingWhitespace(n,0,this._selection.startColumn-1),s=o;e.snippet.walk(function(t){return t!==e&&(t instanceof r.Text&&(s=a.getLeadingWhitespace(t.value.split(/\r\n|\r|\n/).pop())),!0)});var l=a.commonPrefixLength(s,o);i=i.replace(/(\r\n|\r|\n)(.*)/g,function(e,t,i){return""+t+s.substr(l)+i})}return i}if("TM_CURRENT_LINE"===t)return this._model.getLineContent(this._selection.positionLineNumber);if("TM_CURRENT_WORD"===t){var u=this._model.getWordAtPosition({lineNumber:this._selection.positionLineNumber,column:this._selection.positionColumn});return u&&u.word||void 0}return"TM_LINE_INDEX"===t?String(this._selection.positionLineNumber-1):"TM_LINE_NUMBER"===t?String(this._selection.positionLineNumber):void 0},e}();t.SelectionBasedVariableResolver=d;var c=function(){function e(e,t){this._labelService=e,this._model=t}return e.prototype.resolve=function(e){var t=e.name;if("TM_FILENAME"===t)return n.basename(this._model.uri.fsPath)
;if("TM_FILENAME_BASE"===t){var i=n.basename(this._model.uri.fsPath),r=i.lastIndexOf(".");return r<=0?i:i.slice(0,r)}return"TM_DIRECTORY"===t&&this._labelService?"."===n.dirname(this._model.uri.fsPath)?"":this._labelService.getUriLabel(o.dirname(this._model.uri)):"TM_FILEPATH"===t&&this._labelService?this._labelService.getUriLabel(this._model.uri):void 0},e}();t.ModelBasedVariableResolver=c;var h=function(){function e(e,t,i){this._clipboardText=e,this._selectionIdx=t,this._selectionCount=i}return e.prototype.resolve=function(e){if("CLIPBOARD"===e.name&&this._clipboardText){var t=this._clipboardText.split(/\r\n|\n|\r/).filter(function(e){return!a.isFalsyOrWhitespace(e)});return t.length===this._selectionCount?t[this._selectionIdx]:this._clipboardText}},e}();t.ClipboardBasedVariableResolver=h;var p=function(){function e(e){this._model=e}return e.prototype.resolve=function(e){var t=e.name,i=this._model.getLanguageIdentifier(),n=s.LanguageConfigurationRegistry.getComments(i.id)
;if(n)return"LINE_COMMENT"===t?n.lineCommentToken||void 0:"BLOCK_COMMENT_START"===t?n.blockCommentStartToken||void 0:"BLOCK_COMMENT_END"===t?n.blockCommentEndToken||void 0:void 0},e}();t.CommentBasedVariableResolver=p;var f=function(){function e(){}return e.prototype.resolve=function(t){var i=t.name
;return"CURRENT_YEAR"===i?String((new Date).getFullYear()):"CURRENT_YEAR_SHORT"===i?String((new Date).getFullYear()).slice(-2):"CURRENT_MONTH"===i?a.pad((new Date).getMonth().valueOf()+1,2):"CURRENT_DATE"===i?a.pad((new Date).getDate().valueOf(),2):"CURRENT_HOUR"===i?a.pad((new Date).getHours().valueOf(),2):"CURRENT_MINUTE"===i?a.pad((new Date).getMinutes().valueOf(),2):"CURRENT_SECOND"===i?a.pad((new Date).getSeconds().valueOf(),2):"CURRENT_DAY_NAME"===i?e.dayNames[(new Date).getDay()]:"CURRENT_DAY_NAME_SHORT"===i?e.dayNamesShort[(new Date).getDay()]:"CURRENT_MONTH_NAME"===i?e.monthNames[(new Date).getMonth()]:"CURRENT_MONTH_NAME_SHORT"===i?e.monthNamesShort[(new Date).getMonth()]:"CURRENT_SECONDS_UNIX"===i?String(Math.floor(Date.now()/1e3)):void 0},e.dayNames=[i.localize(0,null),i.localize(1,null),i.localize(2,null),i.localize(3,null),i.localize(4,null),i.localize(5,null),i.localize(6,null)],
e.dayNamesShort=[i.localize(7,null),i.localize(8,null),i.localize(9,null),i.localize(10,null),i.localize(11,null),i.localize(12,null),i.localize(13,null)],e.monthNames=[i.localize(14,null),i.localize(15,null),i.localize(16,null),i.localize(17,null),i.localize(18,null),i.localize(19,null),i.localize(20,null),i.localize(21,null),i.localize(22,null),i.localize(23,null),i.localize(24,null),i.localize(25,null)],e.monthNamesShort=[i.localize(26,null),i.localize(27,null),i.localize(28,null),i.localize(29,null),i.localize(30,null),i.localize(31,null),i.localize(32,null),i.localize(33,null),i.localize(34,null),i.localize(35,null),i.localize(36,null),i.localize(37,null)],e}();t.TimeBasedVariableResolver=f;var g=function(){function e(e){this._workspaceService=e}return e.prototype.resolve=function(e){if("WORKSPACE_NAME"===e.name&&this._workspaceService){var t=l.toWorkspaceIdentifier(this._workspaceService.getWorkspace());if(t){if(l.isSingleFolderWorkspaceIdentifier(t))return n.basename(t.path)
;var i=n.basename(t.configPath.path);return a.endsWith(i,l.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-l.WORKSPACE_EXTENSION.length-1)),i}}},e}();t.WorkspaceBasedVariableResolver=g}),define(t[597],i([1,0,19,2,5,53,3,20,30,134,126,12,128,596,16,22,102,372]),function(e,t,i,n,o,r,s,a,l,u,d,c,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),f.registerThemingParticipant(function(e,t){function i(t){var i=e.getColor(t);return i?i.toString():"transparent"}t.addRule(".monaco-editor .snippet-placeholder { background-color: "+i(g.snippetTabstopHighlightBackground)+"; outline-color: "+i(g.snippetTabstopHighlightBorder)+"; }"),t.addRule(".monaco-editor .finish-snippet-placeholder { background-color: "+i(g.snippetFinalTabstopHighlightBackground)+"; outline-color: "+i(g.snippetFinalTabstopHighlightBorder)+"; }")});var v=function(){function e(e,t,n){this._nestingLevel=1,this._editor=e,this._snippet=t,this._offset=n,this._placeholderGroups=i.groupBy(t.placeholders,h.Placeholder.compareByIndex),
this._placeholderGroupsIdx=-1}return e.prototype.dispose=function(){if(this._placeholderDecorations){var e=[];this._placeholderDecorations.forEach(function(t){return e.push(t)}),this._editor.deltaDecorations(e,[])}this._placeholderGroups.length=0},e.prototype._initDecorations=function(){var t=this;if(!this._placeholderDecorations){this._placeholderDecorations=new Map;var i=this._editor.getModel();this._editor.changeDecorations(function(n){for(var o=0,r=t._snippet.placeholders;o<r.length;o++){var a=r[o],l=t._snippet.offset(a),u=t._snippet.fullLen(a),d=s.Range.fromPositions(i.getPositionAt(t._offset+l),i.getPositionAt(t._offset+l+u)),c=a.isFinalTabstop?e._decor.inactiveFinal:e._decor.inactive,h=n.addDecoration(d,c);t._placeholderDecorations.set(a,h)}})}},e.prototype.move=function(t){var i=this;if(!this._editor.hasModel())return[];if(this._initDecorations(),this._placeholderGroupsIdx>=0){for(var n=[],o=0,s=this._placeholderGroups[this._placeholderGroupsIdx];o<s.length;o++){var l=s[o];if(l.transform){
var u=this._placeholderDecorations.get(l),d=this._editor.getModel().getDecorationRange(u),c=this._editor.getModel().getValueInRange(d);n.push(r.EditOperation.replaceMove(d,l.transform.resolve(c)))}}n.length>0&&this._editor.executeEdits("snippet.placeholderTransform",n)}var h=!1;!0===t&&this._placeholderGroupsIdx<this._placeholderGroups.length-1?(this._placeholderGroupsIdx+=1,h=!0):!1===t&&this._placeholderGroupsIdx>0&&(this._placeholderGroupsIdx-=1,h=!0);var p=this._editor.getModel().changeDecorations(function(t){for(var n=new Set,o=[],r=0,s=i._placeholderGroups[i._placeholderGroupsIdx];r<s.length;r++){var l=s[r],u=i._placeholderDecorations.get(l),d=i._editor.getModel().getDecorationRange(u);o.push(new a.Selection(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn)),h=h&&i._hasPlaceholderBeenCollapsed(l),t.changeDecorationOptions(u,l.isFinalTabstop?e._decor.activeFinal:e._decor.active),n.add(l);for(var c=0,p=i._snippet.enclosingPlaceholders(l);c<p.length;c++){
var f=p[c],g=i._placeholderDecorations.get(f);t.changeDecorationOptions(g,f.isFinalTabstop?e._decor.activeFinal:e._decor.active),n.add(f)}}return i._placeholderDecorations.forEach(function(i,o){n.has(o)||t.changeDecorationOptions(i,o.isFinalTabstop?e._decor.inactiveFinal:e._decor.inactive)}),o});return h?this.move(t):p},e.prototype._hasPlaceholderBeenCollapsed=function(e){for(var t=e;t;){if(t instanceof h.Placeholder){var i=this._placeholderDecorations.get(t);if(this._editor.getModel().getDecorationRange(i).isEmpty()&&t.toString().length>0)return!0}t=t.parent}return!1},Object.defineProperty(e.prototype,"isAtFirstPlaceholder",{get:function(){return this._placeholderGroupsIdx<=0||0===this._placeholderGroups.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isAtLastPlaceholder",{get:function(){return this._placeholderGroupsIdx===this._placeholderGroups.length-1},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasPlaceholder",{get:function(){
return this._snippet.placeholders.length>0},enumerable:!0,configurable:!0}),e.prototype.computePossibleSelections=function(){for(var e=new Map,t=0,i=this._placeholderGroups;t<i.length;t++)for(var n=void 0,o=0,r=i[t];o<r.length;o++){var s=r[o];if(s.isFinalTabstop)break;n||(n=[],e.set(s.index,n));var a=this._placeholderDecorations.get(s),l=this._editor.getModel().getDecorationRange(a);if(!l){e.delete(s.index);break}n.push(l)}return e},Object.defineProperty(e.prototype,"choice",{get:function(){return this._placeholderGroups[this._placeholderGroupsIdx][0].choice},enumerable:!0,configurable:!0}),e.prototype.merge=function(t){var n=this,o=this._editor.getModel();this._nestingLevel*=10,this._editor.changeDecorations(function(r){for(var a=0,l=n._placeholderGroups[n._placeholderGroupsIdx];a<l.length;a++){var u=l[a],d=t.shift();console.assert(!d._placeholderDecorations);for(var c=d._snippet.placeholderInfo.last.index,p=0,f=d._snippet.placeholderInfo.all;p<f.length;p++){var g=f[p]
;g.isFinalTabstop?g.index=u.index+(c+1)/n._nestingLevel:g.index=u.index+g.index/n._nestingLevel}n._snippet.replace(u,d._snippet.children);var m=n._placeholderDecorations.get(u);r.removeDecoration(m),n._placeholderDecorations.delete(u);for(var v=0,_=d._snippet.placeholders;v<_.length;v++){var y=_[v],b=d._snippet.offset(y),C=d._snippet.fullLen(y),S=s.Range.fromPositions(o.getPositionAt(d._offset+b),o.getPositionAt(d._offset+b+C)),w=r.addDecoration(S,e._decor.inactive);n._placeholderDecorations.set(y,w)}}n._placeholderGroups=i.groupBy(n._snippet.placeholders,h.Placeholder.compareByIndex)})},e._decor={active:l.ModelDecorationOptions.register({stickiness:0,className:"snippet-placeholder"}),inactive:l.ModelDecorationOptions.register({stickiness:1,className:"snippet-placeholder"}),activeFinal:l.ModelDecorationOptions.register({stickiness:1,className:"finish-snippet-placeholder"}),inactiveFinal:l.ModelDecorationOptions.register({stickiness:1,className:"finish-snippet-placeholder"})},e}();t.OneSnippet=v;var _={
overwriteBefore:0,overwriteAfter:0,adjustWhitespace:!0,clipboardText:void 0},y=function(){function e(e,t,i){void 0===i&&(i=_),this._templateMerges=[],this._snippets=[],this._editor=e,this._template=t,this._options=i}return e.adjustWhitespace=function(e,t,i){var n=e.getLineContent(t.lineNumber),r=o.getLeadingWhitespace(n,0,t.column-1);i.walk(function(t){if(t instanceof h.Text&&!(t.parent instanceof h.Choice)){for(var i=t.value.split(/\r\n|\r|\n/),n=1;n<i.length;n++){var s=o.getLeadingWhitespace(i[n]);i[n]=e.normalizeIndentation(r+s)+i[n].substr(s.length)}var a=i.join(e.getEOL());a!==t.value&&t.parent.replace(t,[new h.Text(a)])}return!0})},e.adjustSelection=function(e,t,i,n){if(0!==i||0!==n){var o=t.positionLineNumber,r=t.positionColumn,s=r-i,l=r+n,u=e.validateRange({startLineNumber:o,startColumn:s,endLineNumber:o,endColumn:l});t=a.Selection.createWithDirection(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn,t.getDirection())}return t},e.createEditsAndSnippets=function(t,i,n,o,a,l,f){var g=[],_=[]
;if(!t.hasModel())return{edits:g,snippets:_};var y=t.getModel(),b=t.invokeWithinContext(function(e){return e.get(d.IWorkspaceContextService,c.optional)}),C=t.invokeWithinContext(function(e){return new p.ModelBasedVariableResolver(e.get(m.ILabelService,c.optional),y)}),S=t.invokeWithinContext(function(e){return e.get(u.IClipboardService,c.optional)});f=f||S&&S.readTextSync();for(var w=0,E=y.getValueInRange(e.adjustSelection(y,t.getSelection(),n,0)),L=y.getValueInRange(e.adjustSelection(y,t.getSelection(),0,o)),x=y.getLineFirstNonWhitespaceColumn(t.getSelection().positionLineNumber),D=t.getSelections().map(function(e,t){return{selection:e,idx:t}}).sort(function(e,t){return s.Range.compareRangesUsingStarts(e.selection,t.selection)}),I=0,N=D;I<N.length;I++){var M=N[I],k=M.selection,T=M.idx,R=e.adjustSelection(y,k,n,0),O=e.adjustSelection(y,k,0,o);E!==y.getValueInRange(R)&&(R=k),L!==y.getValueInRange(O)&&(O=k)
;var P=k.setStartPosition(R.startLineNumber,R.startColumn).setEndPosition(O.endLineNumber,O.endColumn),A=(new h.SnippetParser).parse(i,!0,a),F=P.getStartPosition();(l||T>0&&x!==y.getLineFirstNonWhitespaceColumn(k.positionLineNumber))&&e.adjustWhitespace(y,F,A),A.resolveVariables(new p.CompositeSnippetVariableResolver([C,new p.ClipboardBasedVariableResolver(f,T,D.length),new p.SelectionBasedVariableResolver(y,k),new p.CommentBasedVariableResolver(y),new p.TimeBasedVariableResolver,new p.WorkspaceBasedVariableResolver(b)]));var W=y.getOffsetAt(F)+w;w+=A.toString().length-y.getValueLengthInRange(P),g[T]=r.EditOperation.replace(P,A.toString()),_[T]=new v(t,A,W)}return{edits:g,snippets:_}},e.prototype.dispose=function(){n.dispose(this._snippets)},e.prototype._logInfo=function(){return'template="'+this._template+'", merged_templates="'+this._templateMerges.join(" -> ")+'"'},e.prototype.insert=function(){var t=this;if(this._editor.hasModel()){
var i=e.createEditsAndSnippets(this._editor,this._template,this._options.overwriteBefore,this._options.overwriteAfter,!1,this._options.adjustWhitespace,this._options.clipboardText),n=i.edits,o=i.snippets;this._snippets=o,this._editor.executeEdits("snippet",n,function(e){return t._snippets[0].hasPlaceholder?t._move(!0):e.map(function(e){return a.Selection.fromPositions(e.range.getEndPosition())})}),this._editor.revealRange(this._editor.getSelections()[0])}},e.prototype.merge=function(t,i){var n=this;if(void 0===i&&(i=_),this._editor.hasModel()){this._templateMerges.push([this._snippets[0]._nestingLevel,this._snippets[0]._placeholderGroupsIdx,t]);var o=e.createEditsAndSnippets(this._editor,t,i.overwriteBefore,i.overwriteAfter,!0,i.adjustWhitespace,i.clipboardText),r=o.edits,s=o.snippets;this._editor.executeEdits("snippet",r,function(e){for(var t=0,i=n._snippets;t<i.length;t++){i[t].merge(s)}return console.assert(0===s.length),n._snippets[0].hasPlaceholder?n._move(void 0):e.map(function(e){
return a.Selection.fromPositions(e.range.getEndPosition())})})}},e.prototype.next=function(){var e=this._move(!0);this._editor.setSelections(e),this._editor.revealPositionInCenterIfOutsideViewport(e[0].getPosition())},e.prototype.prev=function(){var e=this._move(!1);this._editor.setSelections(e),this._editor.revealPositionInCenterIfOutsideViewport(e[0].getPosition())},e.prototype._move=function(e){for(var t=[],i=0,n=this._snippets;i<n.length;i++){var o=n[i].move(e);t.push.apply(t,o)}return t},Object.defineProperty(e.prototype,"isAtFirstPlaceholder",{get:function(){return this._snippets[0].isAtFirstPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isAtLastPlaceholder",{get:function(){return this._snippets[0].isAtLastPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasPlaceholder",{get:function(){return this._snippets[0].hasPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"choice",{get:function(){
return this._snippets[0].choice},enumerable:!0,configurable:!0}),e.prototype.isSelectionWithinPlaceholders=function(){if(!this.hasPlaceholder)return!1;var e=this._editor.getSelections();if(e.length<this._snippets.length)return!1;for(var t=new Map,i=function(i){var n=i.computePossibleSelections();if(0===t.size&&n.forEach(function(i,n){i.sort(s.Range.compareRangesUsingStarts);for(var o=0,r=e;o<r.length;o++){var a=r[o];if(i[0].containsRange(a)){t.set(n,[]);break}}}),0===t.size)return{value:!1};t.forEach(function(e,t){e.push.apply(e,n.get(t))})},n=0,o=this._snippets;n<o.length;n++){var r=i(o[n]);if("object"==typeof r)return r.value}return e.sort(s.Range.compareRangesUsingStarts),t.forEach(function(i,n){if(i.length===e.length){i.sort(s.Range.compareRangesUsingStarts);for(var o=0;o<i.length;o++)if(!i[o].containsRange(e[o]))return void t.delete(n)}else t.delete(n)}),t.size>0},e}();t.SnippetSession=y}),define(t[161],i([1,0,2,5,11,3,20,21,93,14,114,597]),function(e,t,i,n,o,r,a,l,u,h,p,f){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var g={overwriteBefore:0,overwriteAfter:0,undoStopBefore:!0,undoStopAfter:!0,adjustWhitespace:!0,clipboardText:void 0},m=function(){function e(t,n,o){this._editor=t,this._logService=n,this._snippetListener=new i.DisposableStore,this._modelVersionId=-1,this._inSnippet=e.InSnippetMode.bindTo(o),this._hasNextTabstop=e.HasNextTabstop.bindTo(o),this._hasPrevTabstop=e.HasPrevTabstop.bindTo(o)}return e.get=function(e){return e.getContribution("snippetController2")},e.prototype.dispose=function(){this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),i.dispose(this._session),this._snippetListener.dispose()},e.prototype.getId=function(){return"snippetController2"},e.prototype.insert=function(e,t){try{this._doInsert(e,void 0===t?g:s({},g,t))}catch(t){this.cancel(),this._logService.error(t),this._logService.error("snippet_error"),this._logService.error("insert_template=",e),
this._logService.error("existing_template=",this._session?this._session._logInfo():"<no_session>")}},e.prototype._doInsert=function(e,t){var i=this;this._editor.hasModel()&&(this._snippetListener.clear(),t.undoStopBefore&&this._editor.getModel().pushStackElement(),this._session?this._session.merge(e,t):(this._modelVersionId=this._editor.getModel().getAlternativeVersionId(),this._session=new f.SnippetSession(this._editor,e,t),this._session.insert()),t.undoStopAfter&&this._editor.getModel().pushStackElement(),this._updateState(),this._snippetListener.add(this._editor.onDidChangeModelContent(function(e){return e.isFlush&&i.cancel()})),this._snippetListener.add(this._editor.onDidChangeModel(function(){return i.cancel()})),this._snippetListener.add(this._editor.onDidChangeCursorSelection(function(){return i._updateState()})))},e.prototype._updateState=function(){if(this._session&&this._editor.hasModel()){if(this._modelVersionId===this._editor.getModel().getAlternativeVersionId())return this.cancel()
;if(!this._session.hasPlaceholder)return this.cancel();if(this._session.isAtLastPlaceholder||!this._session.isSelectionWithinPlaceholders())return this.cancel();this._inSnippet.set(!0),this._hasPrevTabstop.set(!this._session.isAtFirstPlaceholder),this._hasNextTabstop.set(!this._session.isAtLastPlaceholder),this._handleChoice()}},e.prototype._handleChoice=function(){var e=this;if(this._session&&this._editor.hasModel()){var t=this._session.choice;if(t){if(this._currentChoice!==t){this._currentChoice=t,this._editor.setSelections(this._editor.getSelections().map(function(e){return a.Selection.fromPositions(e.getStartPosition())}));var i=t.options[0];u.showSimpleSuggestions(this._editor,t.options.map(function(t,o){return{kind:13,label:t.value,insertText:t.value,sortText:n.repeat("a",o+1),range:r.Range.fromPositions(e._editor.getPosition(),e._editor.getPosition().delta(0,i.value.length))}}))}}else this._currentChoice=void 0}else this._currentChoice=void 0},e.prototype.finish=function(){
for(;this._inSnippet.get();)this.next()},e.prototype.cancel=function(e){void 0===e&&(e=!1),this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),this._snippetListener.clear(),i.dispose(this._session),this._session=void 0,this._modelVersionId=-1,e&&this._editor.setSelections([this._editor.getSelection()])},e.prototype.prev=function(){this._session&&this._session.prev(),this._updateState()},e.prototype.next=function(){this._session&&this._session.next(),this._updateState()},e.prototype.isInSnippet=function(){return Boolean(this._inSnippet.get())},e.InSnippetMode=new h.RawContextKey("inSnippetMode",!1),e.HasNextTabstop=new h.RawContextKey("hasNextTabstop",!1),e.HasPrevTabstop=new h.RawContextKey("hasPrevTabstop",!1),e=d([c(1,p.ILogService),c(2,h.IContextKeyService)],e)}();t.SnippetController2=m,o.registerEditorContribution(m);var v=o.EditorCommand.bindToContribution(m.get);o.registerEditorCommand(new v({id:"jumpToNextSnippetPlaceholder",
precondition:h.ContextKeyExpr.and(m.InSnippetMode,m.HasNextTabstop),handler:function(e){return e.next()},kbOpts:{weight:130,kbExpr:l.EditorContextKeys.editorTextFocus,primary:2}})),o.registerEditorCommand(new v({id:"jumpToPrevSnippetPlaceholder",precondition:h.ContextKeyExpr.and(m.InSnippetMode,m.HasPrevTabstop),handler:function(e){return e.prev()},kbOpts:{weight:130,kbExpr:l.EditorContextKeys.editorTextFocus,primary:1026}})),o.registerEditorCommand(new v({id:"leaveSnippet",precondition:m.InSnippetMode,handler:function(e){return e.cancel(!0)},kbOpts:{weight:130,kbExpr:l.EditorContextKeys.editorTextFocus,primary:9,secondary:[1033]}})),o.registerEditorCommand(new v({id:"acceptSnippet",precondition:m.InSnippetMode,handler:function(e){return e.finish()}}))}),define(t[474],i([1,0,19,15,10,4,2,20,17,316,93,161,26,270]),function(e,t,i,n,o,r,s,a,l,u,d,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var f=function(){function e(e,t,i,n){
this.leadingLineContent=e.getLineContent(t.lineNumber).substr(0,t.column-1),this.leadingWord=e.getWordUntilPosition(t),this.lineNumber=t.lineNumber,this.column=t.column,this.auto=i,this.shy=n}return e.shouldAutoTrigger=function(e){if(!e.hasModel())return!1;var t=e.getModel(),i=e.getPosition();t.tokenizeIfCheap(i.lineNumber);var n=t.getWordAtPosition(i);return!!n&&(n.endColumn===i.column&&!!isNaN(Number(n.word)))},e}();t.LineContext=f;var g=function(){function e(e,t){var i=this;this._editor=e,this._editorWorker=t,this._toDispose=new s.DisposableStore,this._quickSuggestDelay=10,this._triggerQuickSuggest=new n.TimeoutTimer,this._state=0,this._completionDisposables=new s.DisposableStore,this._onDidCancel=new r.Emitter,this._onDidTrigger=new r.Emitter,this._onDidSuggest=new r.Emitter,this.onDidCancel=this._onDidCancel.event,this.onDidTrigger=this._onDidTrigger.event,this.onDidSuggest=this._onDidSuggest.event,this._currentSelection=this._editor.getSelection()||new a.Selection(1,1,1,1),
this._toDispose.add(this._editor.onDidChangeModel(function(){i._updateTriggerCharacters(),i.cancel()})),this._toDispose.add(this._editor.onDidChangeModelLanguage(function(){i._updateTriggerCharacters(),i.cancel()})),this._toDispose.add(this._editor.onDidChangeConfiguration(function(){i._updateTriggerCharacters(),i._updateQuickSuggest()})),this._toDispose.add(l.CompletionProviderRegistry.onDidChange(function(){i._updateTriggerCharacters(),i._updateActiveSuggestSession()})),this._toDispose.add(this._editor.onDidChangeCursorSelection(function(e){i._onCursorChange(e)}));var o=!1;this._toDispose.add(this._editor.onCompositionStart(function(){o=!0})),this._toDispose.add(this._editor.onCompositionEnd(function(){o=!1,i._refilterCompletionItems()})),this._toDispose.add(this._editor.onDidChangeModelContent(function(){o||i._refilterCompletionItems()})),this._updateTriggerCharacters(),this._updateQuickSuggest()}return e.prototype.dispose=function(){s.dispose(this._triggerCharacterListener),
s.dispose([this._onDidCancel,this._onDidSuggest,this._onDidTrigger,this._triggerQuickSuggest]),this._toDispose.dispose(),this._completionDisposables.dispose(),this.cancel()},e.prototype._updateQuickSuggest=function(){this._quickSuggestDelay=this._editor.getConfiguration().contribInfo.quickSuggestionsDelay,(isNaN(this._quickSuggestDelay)||!this._quickSuggestDelay&&0!==this._quickSuggestDelay||this._quickSuggestDelay<0)&&(this._quickSuggestDelay=10)},e.prototype._updateTriggerCharacters=function(){var e=this;if(s.dispose(this._triggerCharacterListener),!this._editor.getConfiguration().readOnly&&this._editor.hasModel()&&this._editor.getConfiguration().contribInfo.suggestOnTriggerCharacters){for(var t=Object.create(null),i=0,n=l.CompletionProviderRegistry.all(this._editor.getModel());i<n.length;i++)for(var o=n[i],r=0,a=o.triggerCharacters||[];r<a.length;r++){var u=a[r],c=t[u];c||(c=t[u]=new Set).add(d.getSnippetSuggestSupport()),c.add(o)}this._triggerCharacterListener=this._editor.onDidType(function(i){
var n=i.charAt(i.length-1),o=t[n];if(o){var r=e._completionModel?e._completionModel.adopt(o):void 0;e.trigger({auto:!0,shy:!1,triggerCharacter:n},Boolean(e._completionModel),o,r)}})}},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),e.prototype.cancel=function(e){void 0===e&&(e=!1),0!==this._state&&(this._triggerQuickSuggest.cancel(),this._requestToken&&(this._requestToken.cancel(),this._requestToken=void 0),this._state=0,this._completionModel=void 0,this._context=void 0,this._onDidCancel.fire({retrigger:e}))},e.prototype.clear=function(){this._completionDisposables.clear()},e.prototype._updateActiveSuggestSession=function(){0!==this._state&&(this._editor.hasModel()&&l.CompletionProviderRegistry.has(this._editor.getModel())?this.trigger({auto:2===this._state,shy:!1},!0):this.cancel())},e.prototype._onCursorChange=function(e){var t=this;if(this._editor.hasModel()){var i=this._editor.getModel(),n=this._currentSelection
;if(this._currentSelection=this._editor.getSelection(),!e.selection.isEmpty()||0!==e.reason||"keyboard"!==e.source&&"deleteLeft"!==e.source)0!==this._state&&this.cancel();else if(l.CompletionProviderRegistry.has(i)&&0===this._state){if(!1===this._editor.getConfiguration().contribInfo.quickSuggestions)return;if(!n.containsRange(this._currentSelection)&&!n.getEndPosition().isBeforeOrEqual(this._currentSelection.getPosition()))return;if(this._editor.getConfiguration().contribInfo.suggest.snippetsPreventQuickSuggestions&&c.SnippetController2.get(this._editor).isInSnippet())return;this.cancel(),this._triggerQuickSuggest.cancelAndSet(function(){if(0===t._state&&f.shouldAutoTrigger(t._editor)&&t._editor.hasModel()){var e=t._editor.getModel(),i=t._editor.getPosition(),n=t._editor.getConfiguration().contribInfo.quickSuggestions;if(!1!==n){if(!0===n);else{e.tokenizeIfCheap(i.lineNumber);var o=e.getLineTokens(i.lineNumber),r=o.getStandardTokenType(o.findTokenIndexAtOffset(Math.max(i.column-1-1,0)))
;if(!(n.other&&0===r||n.comments&&1===r||n.strings&&2===r))return}t.trigger({auto:!0,shy:!1})}}},this._quickSuggestDelay)}}},e.prototype._refilterCompletionItems=function(){var e=this;Promise.resolve().then(function(){if(0!==e._state&&e._editor.hasModel()){var t=e._editor.getModel(),i=e._editor.getPosition(),n=new f(t,i,2===e._state,!1);e._onNewContext(n)}})},e.prototype.trigger=function(e,t,n,r){var a=this;if(void 0===t&&(t=!1),this._editor.hasModel()){var c=this._editor.getModel(),g=e.auto,m=new f(c,this._editor.getPosition(),g,e.shy);this.cancel(t),this._state=g?2:1,this._onDidTrigger.fire({auto:g,shy:e.shy,position:this._editor.getPosition()}),this._context=m;var v;v=e.triggerCharacter?{triggerKind:1,triggerCharacter:e.triggerCharacter}:n&&n.size>0?{triggerKind:2}:{triggerKind:0},this._requestToken=new h.CancellationTokenSource;var _=this._editor.getConfiguration().contribInfo,y=new Set,b=1;switch(_.suggest.snippets){case"top":b=0;break;case"bottom":b=2;break;case"none":y.add(25)}
for(var C in _.suggest.filteredTypes){var S=l.completionKindFromString(C,!0);void 0!==S&&!1===_.suggest.filteredTypes[C]&&y.add(S)}var w=p.WordDistance.create(this._editorWorker,this._editor),E=d.provideSuggestionItems(c,this._editor.getPosition(),new d.CompletionOptions(b,y,n),v,this._requestToken.token);Promise.all([E,w]).then(function(t){var n=t[0],o=t[1];if(s.dispose(a._requestToken),0!==a._state&&a._editor.hasModel()){var l=a._editor.getModel();if(i.isNonEmptyArray(r)){var c=d.getSuggestionComparator(b);n=n.concat(r).sort(c)}var h=new f(l,a._editor.getPosition(),g,e.shy);a._completionModel=new u.CompletionModel(n,a._context.column,{leadingLineContent:h.leadingLineContent,characterCountDelta:h.column-a._context.column},o,a._editor.getConfiguration().contribInfo.suggest);for(var p=0,m=n;p<m.length;p++){var v=m[p];s.isDisposable(v.container)&&a._completionDisposables.add(v.container)}a._onNewContext(h)}}).catch(o.onUnexpectedError)}},e.prototype._onNewContext=function(e){
if(this._context)if(e.lineNumber===this._context.lineNumber){if(e.leadingWord.startColumn<this._context.leadingWord.startColumn)this.cancel();else if(e.column<this._context.column)e.leadingWord.word?this.trigger({auto:this._context.auto,shy:!1},!0):this.cancel();else if(this._completionModel)if(e.column>this._context.column&&this._completionModel.incomplete.size>0&&0!==e.leadingWord.word.length){var t=this._completionModel.incomplete,i=this._completionModel.adopt(t);this.trigger({auto:2===this._state,shy:!1},!0,t,i)}else{var n=this._completionModel.lineContext,o=!1;if(this._completionModel.lineContext={leadingLineContent:e.leadingLineContent,characterCountDelta:e.column-this._context.column},0===this._completionModel.items.length){if(f.shouldAutoTrigger(this._editor)&&this._context.leadingWord.endColumn<e.leadingWord.startColumn)return void this.trigger({auto:this._context.auto,shy:!1},!0);if(this._context.auto)return void this.cancel();if(this._completionModel.lineContext=n,
(o=this._completionModel.items.length>0)&&0===e.leadingWord.word.length)return void this.cancel()}this._onDidSuggest.fire({completionModel:this._completionModel,auto:this._context.auto,shy:this._context.shy,isFrozen:o})}}else this.cancel()},e}();t.SuggestModel=g}),define(t[473],i([1,0,43,19,10,2,11,53,3,21,161,128,472,361,32,14,12,93,423,474,564,424,4,60,15,23,269]),function(e,t,i,n,o,a,l,u,h,p,f,g,m,v,_,y,b,C,S,w,E,L,x,D,I,N,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var k=!1,T=function(){function e(e,t){this._model=e,this._position=t;if(e.getLineMaxColumn(t.lineNumber)!==t.column){var i=e.getOffsetAt(t),n=e.getPositionAt(i+1);this._marker=e.deltaDecorations([],[{range:h.Range.fromPositions(t,n),options:{stickiness:1}}])}}return e.prototype.dispose=function(){this._marker&&!this._model.isDisposed()&&this._model.deltaDecorations(this._marker,[])},e.prototype.delta=function(e){if(this._model.isDisposed()||this._position.lineNumber!==e.lineNumber)return 0;if(this._marker){
var t=this._model.getDecorationRange(this._marker[0]);return this._model.getOffsetAt(t.getStartPosition())-this._model.getOffsetAt(e)}return this._model.getLineMaxColumn(e.lineNumber)-e.column},e}(),R=function(){function e(e,t,i,n,o,r){var s=this;this._editor=e,this._memoryService=i,this._commandService=n,this._contextKeyService=o,this._instantiationService=r,this._lineSuffix=new a.MutableDisposable,this._toDispose=new a.DisposableStore,this._model=new w.SuggestModel(this._editor,t),this._widget=new I.IdleValue(function(){var e=s._instantiationService.createInstance(E.SuggestWidget,s._editor);s._toDispose.add(e),s._toDispose.add(e.onDidSelect(function(e){return s._insertSuggestion(e,!1,!0)},s));var t=new M.CommitCharacterController(s._editor,e,function(e){return s._insertSuggestion(e,!1,!0)});s._toDispose.add(t),s._toDispose.add(s._model.onDidSuggest(function(e){0===e.completionModel.items.length&&t.reset()}));var i=C.Context.MakesTextEdit.bindTo(s._contextKeyService)
;return s._toDispose.add(e.onDidFocus(function(e){var t=e.item,n=s._editor.getPosition(),o=t.completion.range.startColumn,r=n.column,a=!0;if(!("smart"!==s._editor.getConfiguration().contribInfo.acceptSuggestionOnEnter||2!==s._model.state||t.completion.command||t.completion.additionalTextEdits||4&t.completion.insertTextRules||r-o!==t.completion.insertText.length)){a=s._editor.getModel().getValueInRange({startLineNumber:n.lineNumber,startColumn:o,endLineNumber:n.lineNumber,endColumn:r})!==t.completion.insertText}i.set(a)})),s._toDispose.add(a.toDisposable(function(){return i.reset()})),e}),this._alternatives=new I.IdleValue(function(){return s._toDispose.add(new S.SuggestAlternatives(s._editor,s._contextKeyService))}),this._toDispose.add(r.createInstance(L.WordContextKey,e)),this._toDispose.add(this._model.onDidTrigger(function(e){s._widget.getValue().showTriggered(e.auto,e.shy?250:50),s._lineSuffix.value=new T(s._editor.getModel(),e.position)})),this._toDispose.add(this._model.onDidSuggest(function(e){
if(!e.shy){var t=s._memoryService.select(s._editor.getModel(),s._editor.getPosition(),e.completionModel.items);s._widget.getValue().showSuggestions(e.completionModel,t,e.isFrozen,e.auto)}})),this._toDispose.add(this._model.onDidCancel(function(e){e.retrigger||s._widget.getValue().hideWidget()})),this._toDispose.add(this._editor.onDidBlurEditorWidget(function(){k||(s._model.cancel(),s._model.clear())}));var l=C.Context.AcceptSuggestionsOnEnter.bindTo(o),u=function(){var e=s._editor.getConfiguration().contribInfo.acceptSuggestionOnEnter;l.set("on"===e||"smart"===e)};this._toDispose.add(this._editor.onDidChangeConfiguration(function(){return u()})),u()}return e.get=function(t){return t.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._alternatives.dispose(),this._toDispose.dispose(),this._widget.dispose(),this._model.dispose(),this._lineSuffix.dispose()},e.prototype._insertSuggestion=function(e,t,i){var n,r=this
;if(!e||!e.item)return this._alternatives.getValue().reset(),this._model.cancel(),void this._model.clear();if(this._editor.hasModel()){var s=this._editor.getModel(),a=s.getAlternativeVersionId(),l=e.item,d=l.completion,c=l.position,p=this._editor.getPosition().column-c.column;i&&this._editor.pushUndoStop(),Array.isArray(d.additionalTextEdits)&&this._editor.executeEdits("suggestController.additionalTextEdits",d.additionalTextEdits.map(function(e){return u.EditOperation.replace(h.Range.lift(e.range),e.text)})),this._memoryService.memorize(s,this._editor.getPosition(),e.item);var m=d.insertText;4&d.insertTextRules||(m=g.SnippetParser.escape(m));var v=c.column-d.range.startColumn,_=d.range.endColumn-c.column,y=this._lineSuffix.value?this._lineSuffix.value.delta(this._editor.getPosition()):0;f.SnippetController2.get(this._editor).insert(m,{overwriteBefore:v+p,overwriteAfter:_+y,undoStopBefore:!1,undoStopAfter:!1,adjustWhitespace:!(1&d.insertTextRules)}),i&&this._editor.pushUndoStop(),
d.command?d.command.id===O.id?this._model.trigger({auto:!0,shy:!1},!0):((n=this._commandService).executeCommand.apply(n,[d.command.id].concat(d.command.arguments?d.command.arguments.slice():[])).catch(o.onUnexpectedError).finally(function(){return r._model.clear()}),this._model.cancel()):(this._model.cancel(),this._model.clear()),t&&this._alternatives.getValue().set(e,function(e){for(;s.canUndo();){a!==s.getAlternativeVersionId()&&s.undo(),r._insertSuggestion(e,!1,!1);break}}),this._alertCompletionItem(e.item)}},e.prototype._alertCompletionItem=function(e){var t=e.completion;if(n.isNonEmptyArray(t.additionalTextEdits)){var o=v.localize(0,null,t.label,t.additionalTextEdits.length);i.alert(o)}},e.prototype.triggerSuggest=function(e){this._editor.hasModel()&&(this._model.trigger({auto:!1,shy:!1},!1,e),this._editor.revealLine(this._editor.getPosition().lineNumber,0),this._editor.focus())},e.prototype.triggerSuggestAndAcceptBest=function(e){var t=this;if(this._editor.hasModel()){
var i=this._editor.getPosition(),n=function(){i.equals(t._editor.getPosition())&&t._commandService.executeCommand(e.fallback)};x.Event.once(this._model.onDidTrigger)(function(e){var i=[];x.Event.any(t._model.onDidTrigger,t._model.onDidCancel)(function(){a.dispose(i),n()},void 0,i),t._model.onDidSuggest(function(e){var o=e.completionModel;if(a.dispose(i),0!==o.items.length){var r=t._memoryService.select(t._editor.getModel(),t._editor.getPosition(),o.items),s=o.items[r];!function(e){if(4&e.completion.insertTextRules||e.completion.additionalTextEdits)return!0;var i=t._editor.getPosition(),n=e.completion.range.startColumn,o=i.column;if(o-n!==e.completion.insertText.length)return!0;return t._editor.getModel().getValueInRange({startLineNumber:i.lineNumber,startColumn:n,endLineNumber:i.lineNumber,endColumn:o})!==e.completion.insertText}(s)?n():(t._editor.pushUndoStop(),t._insertSuggestion({index:r,item:s,model:o},!0,!1))}else n()},void 0,i)}),this._model.trigger({auto:!1,shy:!0}),
this._editor.revealLine(i.lineNumber,0),this._editor.focus()}},e.prototype.acceptSelectedSuggestion=function(e){var t=this._widget.getValue().getFocusedItem();this._insertSuggestion(t,!!e,!0)},e.prototype.acceptNextSuggestion=function(){this._alternatives.getValue().next()},e.prototype.acceptPrevSuggestion=function(){this._alternatives.getValue().prev()},e.prototype.cancelSuggestWidget=function(){this._model.cancel(),this._model.clear(),this._widget.getValue().hideWidget()},e.prototype.selectNextSuggestion=function(){this._widget.getValue().selectNext()},e.prototype.selectNextPageSuggestion=function(){this._widget.getValue().selectNextPage()},e.prototype.selectLastSuggestion=function(){this._widget.getValue().selectLast()},e.prototype.selectPrevSuggestion=function(){this._widget.getValue().selectPrevious()},e.prototype.selectPrevPageSuggestion=function(){this._widget.getValue().selectPreviousPage()},e.prototype.selectFirstSuggestion=function(){this._widget.getValue().selectFirst()},
e.prototype.toggleSuggestionDetails=function(){this._widget.getValue().toggleDetails()},e.prototype.toggleExplainMode=function(){this._widget.getValue().toggleExplainMode()},e.prototype.toggleSuggestionFocus=function(){this._widget.getValue().toggleDetailsFocus()},e.ID="editor.contrib.suggestController",e=d([c(1,D.IEditorWorkerService),c(2,m.ISuggestMemoryService),c(3,_.ICommandService),c(4,y.IContextKeyService),c(5,b.IInstantiationService)],e)}();t.SuggestController=R;var O=function(e){function t(){return e.call(this,{id:t.id,label:v.localize(1,null),alias:"Trigger Suggest",precondition:y.ContextKeyExpr.and(p.EditorContextKeys.writable,p.EditorContextKeys.hasCompletionItemProvider),kbOpts:{kbExpr:p.EditorContextKeys.textInputFocus,primary:2058,mac:{primary:266},weight:100}})||this}return r(t,e),t.prototype.run=function(e,t){var i=R.get(t);i&&i.triggerSuggest()},t.id="editor.action.triggerSuggest",t}(l.EditorAction);t.TriggerSuggestAction=O,l.registerEditorContribution(R),l.registerEditorAction(O)
;var P=l.EditorCommand.bindToContribution(R.get);l.registerEditorCommand(new P({id:"acceptSelectedSuggestion",precondition:C.Context.Visible,handler:function(e){return e.acceptSelectedSuggestion(!0)},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:2}})),l.registerEditorCommand(new P({id:"acceptSelectedSuggestionOnEnter",precondition:C.Context.Visible,handler:function(e){return e.acceptSelectedSuggestion(!1)},kbOpts:{weight:190,kbExpr:y.ContextKeyExpr.and(p.EditorContextKeys.textInputFocus,C.Context.AcceptSuggestionsOnEnter,C.Context.MakesTextEdit),primary:3}})),l.registerEditorCommand(new P({id:"hideSuggestWidget",precondition:C.Context.Visible,handler:function(e){return e.cancelSuggestWidget()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})),l.registerEditorCommand(new P({id:"selectNextSuggestion",precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectNextSuggestion()},kbOpts:{
weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:18,secondary:[2066],mac:{primary:18,secondary:[2066,300]}}})),l.registerEditorCommand(new P({id:"selectNextPageSuggestion",precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectNextPageSuggestion()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:12,secondary:[2060]}})),l.registerEditorCommand(new P({id:"selectLastSuggestion",precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectLastSuggestion()}})),l.registerEditorCommand(new P({id:"selectPrevSuggestion",precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectPrevSuggestion()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:16,secondary:[2064],mac:{primary:16,secondary:[2064,302]}}})),l.registerEditorCommand(new P({id:"selectPrevPageSuggestion",
precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectPrevPageSuggestion()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:11,secondary:[2059]}})),l.registerEditorCommand(new P({id:"selectFirstSuggestion",precondition:y.ContextKeyExpr.and(C.Context.Visible,C.Context.MultipleSuggestions),handler:function(e){return e.selectFirstSuggestion()}})),l.registerEditorCommand(new P({id:"toggleSuggestionDetails",precondition:C.Context.Visible,handler:function(e){return e.toggleSuggestionDetails()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:2058,mac:{primary:266}}})),l.registerEditorCommand(new P({id:"toggleExplainMode",precondition:C.Context.Visible,handler:function(e){return e.toggleExplainMode()},kbOpts:{weight:100,primary:2133}})),l.registerEditorCommand(new P({id:"toggleSuggestionFocus",precondition:C.Context.Visible,handler:function(e){return e.toggleSuggestionFocus()},kbOpts:{weight:190,
kbExpr:p.EditorContextKeys.textInputFocus,primary:2570,mac:{primary:778}}})),l.registerEditorCommand(new P({id:"insertBestCompletion",precondition:y.ContextKeyExpr.and(y.ContextKeyExpr.equals("config.editor.tabCompletion","on"),L.WordContextKey.AtEnd,C.Context.Visible.toNegated(),S.SuggestAlternatives.OtherSuggestions.toNegated(),f.SnippetController2.InSnippetMode.toNegated()),handler:function(e,t){e.triggerSuggestAndAcceptBest(N.isObject(t)?s({fallback:"tab"},t):{fallback:"tab"})},kbOpts:{weight:190,primary:2}})),l.registerEditorCommand(new P({id:"insertNextSuggestion",precondition:y.ContextKeyExpr.and(y.ContextKeyExpr.equals("config.editor.tabCompletion","on"),S.SuggestAlternatives.OtherSuggestions,C.Context.Visible.toNegated(),f.SnippetController2.InSnippetMode.toNegated()),handler:function(e){return e.acceptNextSuggestion()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:2}})),l.registerEditorCommand(new P({id:"insertPrevSuggestion",
precondition:y.ContextKeyExpr.and(y.ContextKeyExpr.equals("config.editor.tabCompletion","on"),S.SuggestAlternatives.OtherSuggestions,C.Context.Visible.toNegated(),f.SnippetController2.InSnippetMode.toNegated()),handler:function(e){return e.acceptPrevSuggestion()},kbOpts:{weight:190,kbExpr:p.EditorContextKeys.textInputFocus,primary:1026}}))}),define(t[507],i([1,0,120,98,219,166,543,479,480,481,557,545,209,488,489,490,491,221,492,493,495,226,580,227,587,552,499,553,558,560,581,563,503,161,473,506,212,565,213,508,56]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(t[602],i([1,0,594,507,566,509,567,569,570,571,582,510]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){for(var i in e)t.hasOwnProperty(i)||(t[i]=e[i])}(i)})}).call(this);

/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-typescript version: 3.5.1(3596f46e41922104181cda3ed981f5a25246882e)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-typescript/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/lib/typescriptServicesMetadata",["require","exports"],function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.typescriptVersion="3.5.1"}),define("vs/language/typescript/monaco.contribution",["require","exports","./lib/typescriptServicesMetadata","vs/editor/editor.api"],function(i,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n,o,r,s,a,c,u,p,d,g,l=monaco.Emitter,h=function(){function e(e,t){this._onDidChange=new l,this._onDidExtraLibsChange=new l,this._extraLibs=Object.create(null),this._workerMaxIdleTime=12e4,this.setCompilerOptions(e),this.setDiagnosticsOptions(t),this._onDidExtraLibsChangeTimeout=-1}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidExtraLibsChange",{get:function(){return this._onDidExtraLibsChange.event},enumerable:!0,configurable:!0}),e.prototype.getExtraLibs=function(){return this._extraLibs},e.prototype.addExtraLib=function(e,t){var i=this;if(void 0===t&&(t="ts:extralib-"+Math.random().toString(36).substring(2,15)),this._extraLibs[t]&&this._extraLibs[t].content===e)return{dispose:function(){}};var n=1;return this._extraLibs[t]&&(n=this._extraLibs[t].version+1),this._extraLibs[t]={content:e,version:n},this._fireOnDidExtraLibsChangeSoon(),{dispose:function(){var e=i._extraLibs[t];e&&e.version===n&&(delete i._extraLibs[t],i._fireOnDidExtraLibsChangeSoon())}}},e.prototype._fireOnDidExtraLibsChangeSoon=function(){var e=this;-1===this._onDidExtraLibsChangeTimeout&&(this._onDidExtraLibsChangeTimeout=setTimeout(function(){e._onDidExtraLibsChangeTimeout=-1,e._onDidExtraLibsChange.fire(void 0)},0))},e.prototype.getCompilerOptions=function(){return this._compilerOptions},e.prototype.setCompilerOptions=function(e){this._compilerOptions=e||Object.create(null),this._onDidChange.fire(void 0)},e.prototype.getDiagnosticsOptions=function(){return this._diagnosticsOptions},e.prototype.setDiagnosticsOptions=function(e){this._diagnosticsOptions=e||Object.create(null),this._onDidChange.fire(void 0)},e.prototype.setMaximumWorkerIdleTime=function(e){this._workerMaxIdleTime=e},e.prototype.getWorkerMaxIdleTime=function(){return this._workerMaxIdleTime},e.prototype.setEagerModelSync=function(e){this._eagerModelSync=e},e.prototype.getEagerModelSync=function(){return this._eagerModelSync},e}();e.LanguageServiceDefaultsImpl=h,(o=n||(n={}))[o.None=0]="None",o[o.CommonJS=1]="CommonJS",o[o.AMD=2]="AMD",o[o.UMD=3]="UMD",o[o.System=4]="System",o[o.ES2015=5]="ES2015",o[o.ESNext=99]="ESNext",(s=r||(r={}))[s.None=0]="None",s[s.Preserve=1]="Preserve",s[s.React=2]="React",s[s.ReactNative=3]="ReactNative",(c=a||(a={}))[c.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",c[c.LineFeed=1]="LineFeed",(p=u||(u={}))[p.ES3=0]="ES3",p[p.ES5=1]="ES5",p[p.ES2015=2]="ES2015",p[p.ES2016=3]="ES2016",p[p.ES2017=4]="ES2017",p[p.ES2018=5]="ES2018",p[p.ES2019=6]="ES2019",p[p.ES2020=7]="ES2020",p[p.ESNext=99]="ESNext",p[p.JSON=100]="JSON",p[p.Latest=99]="Latest",(g=d||(d={}))[g.Classic=1]="Classic",g[g.NodeJs=2]="NodeJs";var S=new h({allowNonTsExtensions:!0,target:u.Latest},{noSemanticValidation:!1,noSyntaxValidation:!1}),f=new h({allowNonTsExtensions:!0,allowJs:!0,target:u.Latest},{noSemanticValidation:!0,noSyntaxValidation:!1});function E(){return b().then(function(e){return e.getTypeScriptWorker()})}function x(){return b().then(function(e){return e.getJavaScriptWorker()})}function b(){return new Promise(function(e,t){i(["./tsMode"],e,t)})}monaco.languages.typescript={ModuleKind:n,JsxEmit:r,NewLineKind:a,ScriptTarget:u,ModuleResolutionKind:d,typescriptVersion:t.typescriptVersion,typescriptDefaults:S,javascriptDefaults:f,getTypeScriptWorker:E,getJavaScriptWorker:x},monaco.languages.onLanguage("typescript",function(){return b().then(function(e){return e.setupTypeScript(S)})}),monaco.languages.onLanguage("javascript",function(){return b().then(function(e){return e.setupJavaScript(f)})})});
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-css version: 2.5.1(aeab3841236554bc23f03a8a47bfb68fbe719447)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-css/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/css/monaco.contribution",["require","exports","vs/editor/editor.api"],function(o,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=monaco.Emitter,n=function(){function e(e,n){this._onDidChange=new t,this._languageId=e,this.setDiagnosticsOptions(n)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"diagnosticsOptions",{get:function(){return this._diagnosticsOptions},enumerable:!0,configurable:!0}),e.prototype.setDiagnosticsOptions=function(e){this._diagnosticsOptions=e||Object.create(null),this._onDidChange.fire(this)},e}(),i={validate:!0,lint:{compatibleVendorPrefixes:"ignore",vendorPrefix:"warning",duplicateProperties:"warning",emptyRules:"warning",importStatement:"ignore",boxModel:"ignore",universalSelector:"ignore",zeroUnits:"ignore",fontFaceProperties:"warning",hexColorLength:"error",argumentsInColorFunction:"error",unknownProperties:"warning",ieHack:"ignore",unknownVendorSpecificProperties:"ignore",propertyIgnoredDueToDisplay:"warning",important:"ignore",float:"ignore",idSelector:"ignore"}},r=new(e.LanguageServiceDefaultsImpl=n)("css",i),s=new n("scss",i),a=new n("less",i);function u(){return new Promise(function(e,n){o(["./cssMode"],e,n)})}monaco.languages.css={cssDefaults:r,lessDefaults:a,scssDefaults:s},monaco.languages.onLanguage("less",function(){u().then(function(e){return e.setupMode(a)})}),monaco.languages.onLanguage("scss",function(){u().then(function(e){return e.setupMode(s)})}),monaco.languages.onLanguage("css",function(){u().then(function(e){return e.setupMode(r)})})});
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-json version: 2.7.0(f3afc1b721188b32506d5b8a924561e3ec7534e3)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-json/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/json/monaco.contribution",["require","exports","vs/editor/editor.api"],(function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var t=monaco.Emitter,o=function(){function e(e,n,o){this._onDidChange=new t,this._languageId=e,this.setDiagnosticsOptions(n),this.setModeConfiguration(o)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"modeConfiguration",{get:function(){return this._modeConfiguration},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"diagnosticsOptions",{get:function(){return this._diagnosticsOptions},enumerable:!0,configurable:!0}),e.prototype.setDiagnosticsOptions=function(e){this._diagnosticsOptions=e||Object.create(null),this._onDidChange.fire(this)},e.prototype.setModeConfiguration=function(e){this._modeConfiguration=e||Object.create(null),this._onDidChange.fire(this)},e}();n.LanguageServiceDefaultsImpl=o;var i=new o("json",{validate:!0,allowComments:!0,schemas:[],enableSchemaRequest:!1},{documentFormattingEdits:!0,documentRangeFormattingEdits:!0,completionItems:!0,hovers:!0,documentSymbols:!0,tokens:!0,colors:!0,foldingRanges:!0,diagnostics:!0});monaco.languages.json={jsonDefaults:i},monaco.languages.register({id:"json",extensions:[".json",".bowerrc",".jshintrc",".jscsrc",".eslintrc",".babelrc",".har"],aliases:["JSON","json"],mimetypes:["application/json"]}),monaco.languages.onLanguage("json",(function(){new Promise((function(n,t){e(["./jsonMode"],n,t)})).then((function(e){return e.setupMode(i)}))}))}));
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-html version: 2.5.3(a819bbcf4554af1b8509c1ba5708fffed644f702)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-html/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/html/monaco.contribution",["require","exports","vs/editor/editor.api"],function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var o=monaco.Emitter,n=function(){function e(e,n){this._onDidChange=new o,this._languageId=e,this.setOptions(n)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"options",{get:function(){return this._options},enumerable:!0,configurable:!0}),e.prototype.setOptions=function(e){this._options=e||Object.create(null),this._onDidChange.fire(this)},e}(),a={tabSize:4,insertSpaces:!1,wrapLineLength:120,unformatted:'default": "a, abbr, acronym, b, bdo, big, br, button, cite, code, dfn, em, i, img, input, kbd, label, map, object, q, samp, select, small, span, strong, sub, sup, textarea, tt, var',contentUnformatted:"pre",indentInnerHtml:!1,preserveNewLines:!0,maxPreserveNewLines:null,indentHandlebars:!1,endWithNewline:!1,extraLiners:"head, body, /html",wrapAttributes:"auto"},r={format:a,suggest:{html5:!0}},i={format:a,suggest:{html5:!0,razor:!0}},u="html",s="handlebars",l="razor",g=new(e.LanguageServiceDefaultsImpl=n)(u,{format:a,suggest:{html5:!0,angular1:!0,ionic:!0}}),c=new n(s,r),f=new n(l,i);function m(){return new Promise(function(e,n){t(["./htmlMode"],e,n)})}monaco.languages.html={htmlDefaults:g,razorDefaults:f,handlebarDefaults:c},monaco.languages.onLanguage(u,function(){m().then(function(e){return e.setupMode(g)})}),monaco.languages.onLanguage(s,function(){m().then(function(e){return e.setupMode(c)})}),monaco.languages.onLanguage(l,function(){m().then(function(e){return e.setupMode(f)})})});
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-languages version: 1.8.0(0ed9a6c3e90a24375fab54f7205fb76ce992f117)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-languages/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/basic-languages/_.contribution",["require","exports","vs/editor/editor.api"],function(e,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var t="undefined"==typeof monaco?self.monaco:monaco,n={};var s={};function r(e){return s[e]||(s[e]=function(i){return(0,n[i].loader)().then(function(e){t.languages.setMonarchTokensProvider(i,e.language),t.languages.setLanguageConfiguration(i,e.conf)})}(e)),s[e]}i.loadLanguage=r,i.registerLanguage=function(e){var i=e.id;n[i]=e,t.languages.register(e),t.languages.onLanguage(i,function(){r(i)})}}),define("vs/basic-languages/abap/abap.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"abap",extensions:[".abap"],aliases:["abap","ABAP"],loader:function(){return new Promise(function(e,i){t(["./abap"],e,i)})}})}),define("vs/basic-languages/bat/bat.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"bat",extensions:[".bat",".cmd"],aliases:["Batch","bat"],loader:function(){return new Promise(function(e,i){t(["./bat"],e,i)})}})}),define("vs/basic-languages/coffee/coffee.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"coffeescript",extensions:[".coffee"],aliases:["CoffeeScript","coffeescript","coffee"],mimetypes:["text/x-coffeescript","text/coffeescript"],loader:function(){return new Promise(function(e,i){t(["./coffee"],e,i)})}})}),define("vs/basic-languages/cpp/cpp.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"c",extensions:[".c",".h"],aliases:["C","c"],loader:function(){return new Promise(function(e,i){t(["./cpp"],e,i)})}}),i.registerLanguage({id:"cpp",extensions:[".cpp",".cc",".cxx",".hpp",".hh",".hxx"],aliases:["C++","Cpp","cpp"],loader:function(){return new Promise(function(e,i){t(["./cpp"],e,i)})}})}),define("vs/basic-languages/csharp/csharp.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"csharp",extensions:[".cs",".csx",".cake"],aliases:["C#","csharp"],loader:function(){return new Promise(function(e,i){t(["./csharp"],e,i)})}})}),define("vs/basic-languages/csp/csp.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"csp",extensions:[],aliases:["CSP","csp"],loader:function(){return new Promise(function(e,i){t(["./csp"],e,i)})}})}),define("vs/basic-languages/css/css.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"css",extensions:[".css"],aliases:["CSS","css"],mimetypes:["text/css"],loader:function(){return new Promise(function(e,i){t(["./css"],e,i)})}})}),define("vs/basic-languages/dockerfile/dockerfile.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"dockerfile",extensions:[".dockerfile"],filenames:["Dockerfile"],aliases:["Dockerfile"],loader:function(){return new Promise(function(e,i){t(["./dockerfile"],e,i)})}})}),define("vs/basic-languages/fsharp/fsharp.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"fsharp",extensions:[".fs",".fsi",".ml",".mli",".fsx",".fsscript"],aliases:["F#","FSharp","fsharp"],loader:function(){return new Promise(function(e,i){t(["./fsharp"],e,i)})}})}),define("vs/basic-languages/go/go.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"go",extensions:[".go"],aliases:["Go"],loader:function(){return new Promise(function(e,i){t(["./go"],e,i)})}})}),define("vs/basic-languages/handlebars/handlebars.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"handlebars",extensions:[".handlebars",".hbs"],aliases:["Handlebars","handlebars"],mimetypes:["text/x-handlebars-template"],loader:function(){return new Promise(function(e,i){t(["./handlebars"],e,i)})}})}),define("vs/basic-languages/html/html.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"html",extensions:[".html",".htm",".shtml",".xhtml",".mdoc",".jsp",".asp",".aspx",".jshtm"],aliases:["HTML","htm","html","xhtml"],mimetypes:["text/html","text/x-jshtm","text/template","text/ng-template"],loader:function(){return new Promise(function(e,i){t(["./html"],e,i)})}})}),define("vs/basic-languages/ini/ini.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"ini",extensions:[".ini",".properties",".gitconfig"],filenames:["config",".gitattributes",".gitconfig",".editorconfig"],aliases:["Ini","ini"],loader:function(){return new Promise(function(e,i){t(["./ini"],e,i)})}})}),define("vs/basic-languages/java/java.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"java",extensions:[".java",".jav"],aliases:["Java","java"],mimetypes:["text/x-java-source","text/x-java"],loader:function(){return new Promise(function(e,i){t(["./java"],e,i)})}})}),define("vs/basic-languages/javascript/javascript.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"javascript",extensions:[".js",".es6",".jsx"],firstLine:"^#!.*\\bnode",filenames:["jakefile"],aliases:["JavaScript","javascript","js"],mimetypes:["text/javascript"],loader:function(){return new Promise(function(e,i){t(["./javascript"],e,i)})}})}),define("vs/basic-languages/kotlin/kotlin.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"kotlin",extensions:[".kt"],aliases:["Kotlin","kotlin"],mimetypes:["text/x-kotlin-source","text/x-kotlin"],loader:function(){return new Promise(function(e,i){t(["./kotlin"],e,i)})}})}),define("vs/basic-languages/less/less.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"less",extensions:[".less"],aliases:["Less","less"],mimetypes:["text/x-less","text/less"],loader:function(){return new Promise(function(e,i){t(["./less"],e,i)})}})}),define("vs/basic-languages/lua/lua.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"lua",extensions:[".lua"],aliases:["Lua","lua"],loader:function(){return new Promise(function(e,i){t(["./lua"],e,i)})}})}),define("vs/basic-languages/markdown/markdown.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"markdown",extensions:[".md",".markdown",".mdown",".mkdn",".mkd",".mdwn",".mdtxt",".mdtext"],aliases:["Markdown","markdown"],loader:function(){return new Promise(function(e,i){t(["./markdown"],e,i)})}})}),define("vs/basic-languages/mips/mips.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"mips",extensions:[".s"],aliases:["MIPS","MIPS-V"],mimetypes:["text/x-mips","text/mips","text/plaintext"],loader:function(){return new Promise(function(e,i){t(["./mips"],e,i)})}})}),define("vs/basic-languages/msdax/msdax.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"msdax",extensions:[".dax",".msdax"],aliases:["DAX","MSDAX"],loader:function(){return new Promise(function(e,i){t(["./msdax"],e,i)})}})}),define("vs/basic-languages/mysql/mysql.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"mysql",extensions:[],aliases:["MySQL","mysql"],loader:function(){return new Promise(function(e,i){t(["./mysql"],e,i)})}})}),define("vs/basic-languages/objective-c/objective-c.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"objective-c",extensions:[".m"],aliases:["Objective-C"],loader:function(){return new Promise(function(e,i){t(["./objective-c"],e,i)})}})}),define("vs/basic-languages/pascal/pascal.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"pascal",extensions:[".pas",".p",".pp"],aliases:["Pascal","pas"],mimetypes:["text/x-pascal-source","text/x-pascal"],loader:function(){return new Promise(function(e,i){t(["./pascal"],e,i)})}})}),define("vs/basic-languages/pascaligo/pascaligo.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"pascaligo",extensions:[".ligo"],aliases:["Pascaligo","ligo"],loader:function(){return new Promise(function(e,i){t(["./pascaligo"],e,i)})}})}),define("vs/basic-languages/pgsql/pgsql.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"pgsql",extensions:[],aliases:["PostgreSQL","postgres","pg","postgre"],loader:function(){return new Promise(function(e,i){t(["./pgsql"],e,i)})}})}),define("vs/basic-languages/php/php.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"php",extensions:[".php",".php4",".php5",".phtml",".ctp"],aliases:["PHP","php"],mimetypes:["application/x-php"],loader:function(){return new Promise(function(e,i){t(["./php"],e,i)})}})}),define("vs/basic-languages/postiats/postiats.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"postiats",extensions:[".dats",".sats",".hats"],aliases:["ATS","ATS/Postiats"],loader:function(){return new Promise(function(e,i){t(["./postiats"],e,i)})}})}),define("vs/basic-languages/powerquery/powerquery.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"powerquery",extensions:[".pq",".pqm"],aliases:["PQ","M","Power Query","Power Query M"],loader:function(){return new Promise(function(e,i){t(["./powerquery"],e,i)})}})}),define("vs/basic-languages/powershell/powershell.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"powershell",extensions:[".ps1",".psm1",".psd1"],aliases:["PowerShell","powershell","ps","ps1"],loader:function(){return new Promise(function(e,i){t(["./powershell"],e,i)})}})}),define("vs/basic-languages/pug/pug.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"pug",extensions:[".jade",".pug"],aliases:["Pug","Jade","jade"],loader:function(){return new Promise(function(e,i){t(["./pug"],e,i)})}})}),define("vs/basic-languages/python/python.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"python",extensions:[".py",".rpy",".pyw",".cpy",".gyp",".gypi"],aliases:["Python","py"],firstLine:"^#!/.*\\bpython[0-9.-]*\\b",loader:function(){return new Promise(function(e,i){t(["./python"],e,i)})}})}),define("vs/basic-languages/r/r.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"r",extensions:[".r",".rhistory",".rprofile",".rt"],aliases:["R","r"],loader:function(){return new Promise(function(e,i){t(["./r"],e,i)})}})}),define("vs/basic-languages/razor/razor.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"razor",extensions:[".cshtml"],aliases:["Razor","razor"],mimetypes:["text/x-cshtml"],loader:function(){return new Promise(function(e,i){t(["./razor"],e,i)})}})}),define("vs/basic-languages/redis/redis.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"redis",extensions:[".redis"],aliases:["redis"],loader:function(){return new Promise(function(e,i){t(["./redis"],e,i)})}})}),define("vs/basic-languages/redshift/redshift.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"redshift",extensions:[],aliases:["Redshift","redshift"],loader:function(){return new Promise(function(e,i){t(["./redshift"],e,i)})}})}),define("vs/basic-languages/ruby/ruby.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"ruby",extensions:[".rb",".rbx",".rjs",".gemspec",".pp"],filenames:["rakefile"],aliases:["Ruby","rb"],loader:function(){return new Promise(function(e,i){t(["./ruby"],e,i)})}})}),define("vs/basic-languages/rust/rust.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"rust",extensions:[".rs",".rlib"],aliases:["Rust","rust"],loader:function(){return new Promise(function(e,i){t(["./rust"],e,i)})}})}),define("vs/basic-languages/sb/sb.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"sb",extensions:[".sb"],aliases:["Small Basic","sb"],loader:function(){return new Promise(function(e,i){t(["./sb"],e,i)})}})}),define("vs/basic-languages/scss/scss.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"scss",extensions:[".scss"],aliases:["Sass","sass","scss"],mimetypes:["text/x-scss","text/scss"],loader:function(){return new Promise(function(e,i){t(["./scss"],e,i)})}})}),define("vs/basic-languages/sophia/sophia.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"aes",extensions:[".aes"],aliases:["aes","sophia","Sophia"],loader:function(){return new Promise(function(e,i){t(["./sophia"],e,i)})}})}),define("vs/basic-languages/solidity/solidity.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"sol",extensions:[".sol"],aliases:["sol","solidity","Solidity"],loader:function(){return new Promise(function(e,i){t(["./solidity"],e,i)})}})}),define("vs/basic-languages/sql/sql.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"sql",extensions:[".sql"],aliases:["SQL"],loader:function(){return new Promise(function(e,i){t(["./sql"],e,i)})}})}),define("vs/basic-languages/st/st.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"st",extensions:[".st",".iecst",".iecplc",".lc3lib"],aliases:["StructuredText","scl","stl"],loader:function(){return new Promise(function(e,i){t(["./st"],e,i)})}})}),define("vs/basic-languages/swift/swift.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"swift",aliases:["Swift","swift"],extensions:[".swift"],mimetypes:["text/swift"],loader:function(){return new Promise(function(e,i){t(["./swift"],e,i)})}})}),define("vs/basic-languages/tcl/tcl.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"tcl",extensions:[".tcl"],aliases:["tcl","Tcl","tcltk","TclTk","tcl/tk","Tcl/Tk"],loader:function(){return new Promise(function(e,i){t(["./tcl"],e,i)})}})}),define("vs/basic-languages/twig/twig.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"twig",extensions:[".twig"],aliases:["Twig","twig"],mimetypes:["text/x-twig"],loader:function(){return new Promise(function(e,i){t(["./twig"],e,i)})}})}),define("vs/basic-languages/typescript/typescript.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"typescript",extensions:[".ts",".tsx"],aliases:["TypeScript","ts","typescript"],mimetypes:["text/typescript"],loader:function(){return new Promise(function(e,i){t(["./typescript"],e,i)})}})}),define("vs/basic-languages/vb/vb.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"vb",extensions:[".vb"],aliases:["Visual Basic","vb"],loader:function(){return new Promise(function(e,i){t(["./vb"],e,i)})}})}),define("vs/basic-languages/xml/xml.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"xml",extensions:[".xml",".dtd",".ascx",".csproj",".config",".wxi",".wxl",".wxs",".xaml",".svg",".svgz",".opf",".xsl"],firstLine:"(\\<\\?xml.*)|(\\<svg)|(\\<\\!doctype\\s+svg)",aliases:["XML","xml"],mimetypes:["text/xml","application/xml","application/xaml+xml","application/xml-dtd"],loader:function(){return new Promise(function(e,i){t(["./xml"],e,i)})}})}),define("vs/basic-languages/yaml/yaml.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"yaml",extensions:[".yaml",".yml"],aliases:["YAML","yaml","YML","yml"],mimetypes:["application/x-yaml"],loader:function(){return new Promise(function(e,i){t(["./yaml"],e,i)})}})}),define("vs/basic-languages/scheme/scheme.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"scheme",extensions:[".scm",".ss",".sch",".rkt"],aliases:["scheme","Scheme"],loader:function(){return new Promise(function(e,i){t(["./scheme"],e,i)})}})}),define("vs/basic-languages/clojure/clojure.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"clojure",extensions:[".clj",".cljs",".cljc",".edn"],aliases:["clojure","Clojure"],loader:function(){return new Promise(function(e,i){t(["./clojure"],e,i)})}})}),define("vs/basic-languages/shell/shell.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"shell",extensions:[".sh",".bash"],aliases:["Shell","sh"],loader:function(){return new Promise(function(e,i){t(["./shell"],e,i)})}})}),define("vs/basic-languages/perl/perl.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"perl",extensions:[".pl"],aliases:["Perl","pl"],loader:function(){return new Promise(function(e,i){t(["./perl"],e,i)})}})}),define("vs/basic-languages/azcli/azcli.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"azcli",extensions:[".azcli"],aliases:["Azure CLI","azcli"],loader:function(){return new Promise(function(e,i){t(["./azcli"],e,i)})}})}),define("vs/basic-languages/apex/apex.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"apex",extensions:[".cls"],aliases:["Apex","apex"],mimetypes:["text/x-apex-source","text/x-apex"],loader:function(){return new Promise(function(e,i){t(["./apex"],e,i)})}})}),define("vs/basic-languages/graphql/graphql.contribution",["require","exports","../_.contribution"],function(t,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i.registerLanguage({id:"graphql",extensions:[".graphql",".gql"],aliases:["GraphQL","graphql","gql"],mimetypes:["application/graphql"],loader:function(){return new Promise(function(e,i){t(["./graphql"],e,i)})}})}),define("vs/basic-languages/monaco.contribution",["require","exports","./abap/abap.contribution","./bat/bat.contribution","./coffee/coffee.contribution","./cpp/cpp.contribution","./csharp/csharp.contribution","./csp/csp.contribution","./css/css.contribution","./dockerfile/dockerfile.contribution","./fsharp/fsharp.contribution","./go/go.contribution","./handlebars/handlebars.contribution","./html/html.contribution","./ini/ini.contribution","./java/java.contribution","./javascript/javascript.contribution","./kotlin/kotlin.contribution","./less/less.contribution","./lua/lua.contribution","./markdown/markdown.contribution","./mips/mips.contribution","./msdax/msdax.contribution","./mysql/mysql.contribution","./objective-c/objective-c.contribution","./pascal/pascal.contribution","./pascaligo/pascaligo.contribution","./pgsql/pgsql.contribution","./php/php.contribution","./postiats/postiats.contribution","./powerquery/powerquery.contribution","./powershell/powershell.contribution","./pug/pug.contribution","./python/python.contribution","./r/r.contribution","./razor/razor.contribution","./redis/redis.contribution","./redshift/redshift.contribution","./ruby/ruby.contribution","./rust/rust.contribution","./sb/sb.contribution","./scss/scss.contribution","./sophia/sophia.contribution","./solidity/solidity.contribution","./sql/sql.contribution","./st/st.contribution","./swift/swift.contribution","./tcl/tcl.contribution","./twig/twig.contribution","./typescript/typescript.contribution","./vb/vb.contribution","./xml/xml.contribution","./yaml/yaml.contribution","./scheme/scheme.contribution","./clojure/clojure.contribution","./shell/shell.contribution","./perl/perl.contribution","./azcli/azcli.contribution","./apex/apex.contribution","./graphql/graphql.contribution","vs/editor/editor.api"],function(e,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0})});
define("vs/editor/editor.main", ["vs/editor/edcore.main","vs/language/typescript/monaco.contribution","vs/language/css/monaco.contribution","vs/language/json/monaco.contribution","vs/language/html/monaco.contribution","vs/basic-languages/monaco.contribution"], function(api) { return api; });
//# sourceMappingURL=../../../min-maps/vs/editor/editor.main.js.map